# Les fichiers extraits doivents tre nomms de la faon suivante :
#
#	BRIO_type_YYYYMMDD_YYYYMMDD.txt
#
#	o :
#	BRIO est le nom d'un BRIO, en majusucules, tel qu'il figure dans la liste ci-dessous
#	type  vaut "damndes " ou "refus"
#	et suivent les dates de dbut et de fin de l'extraction :
#	YYYY codage de l'anne toujours en 4 chiffres, p.ex. 2004
#	MM	codage du mois en 2 chiffres p.ex 10 pour octobre, 01 pour janvier
#	DD	codage du jour en deux chiffre : de 01  31
#	Exemple : pour une extraction des demandes faites au brio Aroval
#	entre le premier janvier 2004 et le 30 juin 2004
#
#	AROVAL_demandes_20040101_20040630.txt
#

##############
#
#	rglages
#
##############

# Chargement des routines de nettoyage des donnes et de cacul des indicateurs

	source ("/opt/brioche-web/briochecvs/brioche_r/nettoyage.R")
        source ("/opt/brioche-web/briochecvs/brioche_r/calcul.R")

# Liste des BRIO :

	brios <- c("ARCOS", "ARC", "ASCOR", "AROVAL", "RENOVA", "SANTE-BROYE", "CHABLAIS")

# Seuil du taux de rponse pour le calcul des indicateurs
# En porportion entre 0 et 1 : p. ex 0.9 quivaut  90% (seuil fix par l'IUMSP).

	seuil <- 0.9

# Prsentation dtaille (TRUE) ou simplifie (FALSE) ?
# La prsentation simplifie est celle demande par les usagers des BRIO.

	bavard <- FALSE

# Rpertoire contenant les extractions (ne pas oublier la barre oblique finale)

	repertoire.extractions <- "/opt/brioche-web/briochecvs/extractions_r/"


############################
#
#	calcul des indicateurs
#
############################


# La boucle passe en revue les six brios possibles
# et cherche si une extraction a t effectue, dans quel cas
# les donnes sont charges, et la routine de calcul lance.

	for (i in 1:length(brios))	{
		brio <- brios[i]
print (brio)
		# Chercher le fichier des demandes...

		pattern <- paste ("^", brio, "_demandes_[0-9]{8}_[0-9]{8}\.txt$", sep="")	 
		fichier.demandes <- list.files (path=repertoire.extractions, pattern=pattern)

		# ... et des refus

		pattern <- paste ("^", brio, "_refus_[0-9]{8}_[0-9]{8}\.txt$", sep="")	 
		fichier.refus <- list.files (path=repertoire.extractions, pattern=pattern)

		# Les fichiers ont-ils t trouvs pour ce BRIO?

		if (length(fichier.demandes)>0 && length(fichier.refus)>0)	{

		# Information sur la priode d'analyse  partir du nom de fichier extrait

			info.date <- strsplit(fichier.demandes, split="_|\.txt", extended = TRUE)
		
		# Formattage de la date

			HTMLDate <- function (x)	{
				nom.mois <- c("janvier", "f&eacute;vrier", "mars", "avril", "mai", "juin", "juillet", "ao&ucirc;t", "septembre", "octobre", "novembre", "d&eacute;cembre")
				annee <- substring (x, first=1, last=4)
				mois <-  substring (x, first=5, last=6)
				jour <-  substring (x, first=7, last=8)
				if (substring(jour,1,1)=="0") jour <- substring(jour,2,2)
				htmlDate <- paste (jour, nom.mois[as.integer(mois )], annee )
				htmlDate
			}
			brio <- info.date[[1]][1]
			debut.periode <- HTMLDate (info.date[[1]][3])
			fin.periode <- HTMLDate (info.date[[1]][4])

		# Rpertopire accueillant la page d'analyse (ne pas oublier la barre oblique finale)
		# En cas de variation avec le nom du brio, voici un exemple :
		# repertoire.analyses <- paste ("/chemin/d/acces/", brio, "/sous/repertoires/", sep="")

			repertoire.analyses <- paste ("/opt/brioche-web/briochecvs/", brio, "/html_r/", sep="")

		# Nom du fichier d'analyses

			fichier.analyse <- paste (
				repertoire.analyses,
				brio,
				"_",
				info.date[[1]][3],
				"_",
				info.date[[1]][4],
				".html",
				sep=""
			)
print (fichier.analyse)
		# lecture et prparation des donnes

			demandes <- read.table (
				file=paste(repertoire.extractions,fichier.demandes,sep=""),
				header=TRUE,
				sep="\t",
				quote="\""
			)
			demandes <- nettoyage.demandes (demandes)
		
			refus <- read.table (
				file=paste (repertoire.extractions,fichier.refus,sep=""),
				header=TRUE,
				sep="\t",
				quote=""
			)
			refus <- nettoyage.refus (refus)

		# Calcul des indicateurs

			html.rapport (
				brio=brio,
				demandes=demandes,
				refus=refus,
				bavard=bavard,
				seuil=seuil,
				file=fichier.analyse,
				date.debut=debut.periode,
				date.fin=fin.periode
			)
		}
	}

warnings()

# Quitter R

	quit (save="no", status=0)
