#####################################################
#
# prparation des donnes (nettoyage et lablisation)
#
#####################################################


######################
#
# Fichier des demandes
#
######################


nettoyage.demandes <- function (demandes)
{
# noms des variables en minuscules

	names (demandes) <- tolower (names(demandes))

# Transformation des caractres accentus

	html.accents <- function (text)	{
		text <- gsub (pattern="<", replacement="&lt;", text, extended=FALSE, perl=FALSE)
		text <- gsub (pattern=">", replacement="&gt;", text, extended=FALSE, perl=FALSE)
		text <- gsub (pattern="", replacement="&agrave;", text, extended=FALSE, perl=FALSE)
		text <- gsub (pattern="", replacement="&acirc;", text, extended=FALSE, perl=FALSE)
		text <- gsub (pattern="", replacement="&eacute;", text, extended=FALSE, perl=FALSE)
		text <- gsub (pattern="", replacement="&egrave;", text, extended=FALSE, perl=FALSE)
		text <- gsub (pattern="", replacement="&ecirc;", text, extended=FALSE, perl=FALSE)
		text <- gsub (pattern="", replacement="&icirc;", text, extended=FALSE, perl=FALSE)
		text <- gsub (pattern="", replacement="&ocirc;", text, extended=FALSE, perl=FALSE)
		text <- gsub (pattern="", replacement="&ugrave;", text, extended=FALSE, perl=FALSE)
		text <- gsub (pattern="", replacement="&ucirc;", text, extended=FALSE, perl=FALSE)
		text <- gsub (pattern="", replacement="&ccedil;", text, extended=FALSE, perl=FALSE)
		text
	}
#	
# labels
#
	label.autonomie <- c ("Autonome", "Surveillance/stimulation", "Exige de l'aide", "D&eacute;pendant")
	label.demandes<- c("Absence", "Pr&eacute;sence")

#
# A Caractristiques individuelles
#

# 1
	demandes$idusager <- as.character(demandes$idusager)
# 2
	demandes$iddemand<- as.character (demandes$iddemand)
# 3
	demandes$age[demandes$age==99] <- NA
	demandes$age <- factor (demandes$age, levels=1:4, labels=c("&lt;65", " 65-74", "75-84", "&gt;=85"), ordered=TRUE)
# 4
	demandes$sexe[demandes$sexe==99] <- NA
	demandes$sexe <- factor (demandes$sexe, levels=c(1,2), labels=c("Homme", "Femme"))
# 5
	demandes$region[demandes$region==99] <- NA
	# attention ! dcalage de +1 lors de la catgorisation !!!
	demandes$region <- factor (demandes$region, levels=0:53, labels=c(
		"Hors canton",
		"District de Lausanne - ville de Pully",
		"District de Lausanne - ville de Lausanne",
		"District de Lausanne - ville de Prilly",	
		"District de Lausanne - ville de Renens",	
		"District de Lausanne - Est",
		"District de Lausanne - Ouest",
		"District d'Oron - Ouest",
		"District d'Oron - Est",
		"District d'Echallens - Sud",
		"District d'Echallens - Nord",
		"District de Morges - ville de Morges",	
		"District de Morges - ville d'Ecublens",
		"District de Morges - Ouest",
		"District de Morges - Centre, Centre-Ouest",
		"District de Morges - Est",
		"District d'Aubonne - Sud + commune d'Allaman",
		"District d'Aubonne - Nord",
		"District du Lavaux - Ouest",
		"District du Lavaux - Centre",	
		"District du Lavaux - Est",
		"District de Vevey-Ouest",
		"District de Vevey - ville de Vevey",
		"District de Vevey - ville de la Tour de Peilz",
		"District de Vevey-Est",
		"District de Vevey - ville de Montreux",
		"District de Rolle - Nord-Est",
		"District de Rolle - Sud-Ouest",
		"District de Nyon - ville de Gland",
		"District de Nyon - Est, Nord-Est",
		"District de Nyon - ville de Nyon",
		"District de Nyon - Centre",
		"District de Nyon - Ouest, Sud-Ouest",
		"District de Cossonay - Sud-Est",	
		"District de Cossonay - Sud-Ouest",	
		"District de Cossonay - Nord",
		"District d'Orbe - Est",
		"District d'Orbe - Ouest",
		"District de la Vall&eacute;e",
		"District d'Echallens",
		"District d'Yverdon - Est",
		"District d'Yverdon - Ville d'Yverdon",
		"District d'Yverdon - Ouest",
		"District de Grandson",
		"District de Grandson",
		"District de Moudon - Sud",
		"District de Moudon - Nord",
		"District de Payerne - Sud",
		"District de Payerne - Nord",
		"District d'Avenches",
		"District d'Aigle - Sud, Sud-Est",
		"District d'Aigle - Centre",
		"District d'Aigle - Nord, Nord-Ouest",
		"District du Pays-d'Enhaut"
	))
# 6
	demandes$sitsoc[demandes$sitsoc==99] <- NA
	demandes$sitsoc <- factor(demandes$sitsoc, levels=c(1,2,3,4, 5), labels=c("Vit seul sans l'aide de proches", "Vit seul avec l'aide de proches", "Vit en m&eacute;nage", "Vit en institution de soins", "Autre"))
# 7 
	demandes$cms <- factor (demandes$cms, levels=1:3, labels=c("CMS", "Autre prestataire", "Aucune aide re&ccedil;ue"))
# 8.1 
	demandes$probleme1 <- factor(demandes$probleme1, levels=0:1, labels=label.demandes)
# 8.2 
	demandes$probleme2 <- factor(demandes$probleme2, levels=0:1, labels=label.demandes)
# 8.3 
	demandes$probleme3 <- factor(demandes$probleme3, levels=0:1, labels=label.demandes)
# 8.4 
	demandes$probleme4 <- factor(demandes$probleme4, levels=0:1, labels=label.demandes)
# 8.5 
	demandes$probleme5 <- factor(demandes$probleme5, levels=0:1, labels=label.demandes)
# 8.6 
	demandes$probleme6 <- factor(demandes$probleme6, levels=0:1, labels=label.demandes)
# 8.7 
	demandes$probleme7 <- factor(demandes$probleme7, levels=0:1, labels=label.demandes)
# 8.8 
	demandes$probleme8 <- factor(demandes$probleme8, levels=0:1, labels=label.demandes)
# 8.9 
	demandes$probleme9 <- factor(demandes$probleme9, levels=0:1, labels=label.demandes)
# 8.10 
	demandes$probleme10 <- factor(demandes$probleme10, levels=0:1, labels=label.demandes)
# 8.11 
	demandes$probleme11 <- factor(demandes$probleme11, levels=0:1, labels=label.demandes)
# 8.12 
	demandes$probleme12 <- factor(demandes$probleme12, levels=0:1, labels=label.demandes)
# 8.13
	demandes$autreprobl[demandes$autreprobl==""] <- as.character(NA)
	demandes$autreprobl <- factor(demandes$autreprobl)
	levels (demandes$autreprobl) <- html.accents(levels (demandes$autreprobl))
# 9
	demandes$dmst[demandes$dmst==99] <- NA
	demandes$dmst <- factor (demandes$dmst, levels=1:2, labels=c("Oui", "Non"), ordered=TRUE)
# 10
	demandes$manger[demandes$manger==99] <- NA
	demandes$manger <- factor (demandes$manger, levels=1:4, labels=label.autonomie, ordered=TRUE)
# 11
	demandes$laver[demandes$laver==99] <- NA
	demandes$laver <- factor (demandes$laver, levels=1:4, labels=label.autonomie, ordered=TRUE)
# 12
	demandes$habiller[demandes$habiller==99] <- NA
	demandes$habiller <- factor (demandes$habiller, levels=1:4, labels=label.autonomie, ordered=TRUE)
# 13
	demandes$deshab[demandes$deshab==99] <- NA
	demandes$deshab <- factor (demandes$deshab, levels=1:4, labels=label.autonomie, ordered=TRUE)
# 14
	demandes$entpers[demandes$entpers==99] <- NA
	demandes$entpers <- factor (demandes$entpers, levels=1:4, labels=label.autonomie, ordered=TRUE)
# 15
	demandes$contves[demandes$contves==99] <- NA
	demandes$contves <- factor (demandes$contves, levels=1:4, labels=label.autonomie, ordered=TRUE)
# 16
	demandes$contana[demandes$contana==99] <- NA
	demandes$contana <- factor (demandes$contana, levels=1:4, labels=label.autonomie, ordered=TRUE)
# 17
	demandes$toilet[demandes$toilet==99] <- NA
	demandes$toilet <- factor (demandes$toilet, levels=1:4, labels=label.autonomie, ordered=TRUE)
# 18
	demandes$memoire[demandes$memoire==99] <- NA
	demandes$memoire <- factor (demandes$memoire, levels=1:4, labels=label.autonomie, ordered=TRUE)
# 19
	demandes$orientat[demandes$orientat==99] <- NA
	demandes$orientat<- factor (demandes$orientat, levels=1:4, labels=label.autonomie, ordered=TRUE)
# 20
	demandes$jugement[demandes$jugement==99] <- NA
	demandes$jugement <- factor (demandes$jugement, levels=1:4, labels=label.autonomie, ordered=TRUE)
# 21
	demandes$soccuper[demandes$soccuper==99] <- NA
	demandes$soccuper <- factor (demandes$soccuper, levels=1:4, labels=label.autonomie, ordered=TRUE)

#
# B Premire prise de contact
#

# 23
	demandes$debutpec[demandes$debutpec==99] <- NA
	demandes$debutpec <- factor (demandes$debutpec, levels=1:4, labels=c("Le plus rapidement possible", "D&egrave;s maintenant mais sans urgence", "Dans une semaine &agrave; un mois maximum", "Dans plus d'un mois"), ordered=TRUE)
# 24
	demandes$provient[demandes$provient==99] <- NA
	demandes$provient <- factor (demandes$provient, levels=1:10, labels=c("Lit A", "Lit B", "Lit C long s&eacute;jour", "Lit C long s&eacute;jour provisoire", "Lit C court s&eacute;jour", "Lit A ou B reclass&eacute; en C", "Etablissement non m&eacute;dicalis&eacute;", "Domicile avec UAT", "Domicile sans UAT", "S&eacute;jour d'observation"))
# 25
	demandes$origine[demandes$origine==99] <- NA
	# ne pas tenir compte des nouvelles catgories introduites par O. B.
	demandes$origine[demandes$origine==14|demandes$origine==15] <- 7
#	demandes$origine <- factor (demandes$origine, levels=1:15, labels=c("CMS", "Autre prestataire de maintien &agrave; domicile", "EMS g&eacute;riatrique", "EMS psychog&eacute;riatrique", "EMS psychiatrique", "CTR", "Services placeurs des h&ocirc;pitaux", "M&eacute;decin traitant", "Autre BRIO", "Usager/entourage", "Autre", "CTR hors r&eacute;seau", "H&ocirc;pital A hors r&eacute;seau", "Autre h&ocirc;pital A", "H&ocirc;pital psychiatrique (A)"))
	demandes$origine <- factor (demandes$origine, levels=1:13, labels=c(
		"CMS",
		"Autre prestataire de maintien &agrave; domicile",
		"EMS g&eacute;riatrique",
		"EMS psychog&eacute;riatrique",
		"EMS psychiatrique",
		"CTR",
		"Services placeurs des h&ocirc;pitaux",
		"M&eacute;decin traitant",
		"Autre BRIO",
		"Usager/entourage",
		"Autre",
		"CTR hors r&eacute;seau",
		"H&ocirc;pital A hors r&eacute;seau"
	))
# 26
	# BUG dans brioche :
	demandes$pecdem[is.na(demandes$pecdem)] <- 1
	
	demandes$pecdem[demandes$pecdem==99] <- NA
	demandes$pecdem <- factor (demandes$pecdem, levels=0:9, labels=c("Orientation d&eacute;j&agrave; arr&ecirc;t&eacute;e", "Lit C : court s&eacute;jour", "Lit C : long s&eacute;jour", "Lit C : s&eacute;jour d'observation", "Etablissement non m&eacute;dicalis&eacute;", "Domicile avec UAT", "Domicile sans UAT", "Toutes options ouvertes", "CTR", "Autre"))
# 27
	demandes$typedom[demandes$typedom==99] <- NA
	demandes$typedom <- factor (demandes$typedom, levels=1:3, labels=c("Domicile banal", "Logement adapt&eacute;", "Appartement prot&eacute;g&eacute;"))
# 28
	demandes$natpec[demandes$natpec==99] <- NA
	demandes$natpec<- factor (demandes$natpec, levels=1:3, labels=c("G&eacute;riatrie", "Psychiatrie", "Psychog&eacute;riatrie"))

#
# C Procdure d'demandes$orientation
#

# 29
	demandes$rencontr[demandes$rencontr==99] <- NA
	demandes$rencontr <- factor (demandes$rencontr, levels=1:3, labels=c("Oui, &eacute;valuation de premi&egrave;re ligne", "Non, &eacute;valuation de 2&egrave;me 	ligne", "Aucune implication"))

#
# D Aboutissement de la demande
#

# 34
	demandes$decorient[demandes$decorient==99] <- NA
	demandes$decorient <- factor (demandes$decorient, levels=1:7, labels=c("Domicile priv&eacute;", "Logement adapt&eacute;", "Logement prot&eacute;g&eacute;", "Etablissement non m&eacute;dicalis&eacute;", "EMS g&eacute;riatrique", "EMS psychog&eacute;riatrique", "EMS psychiatrique "))
# 35
	demandes$orguat[demandes$orguat==99] <- NA
	demandes$orguat <- factor (demandes$orguat, levels=0:2, labels=c("Non", "Oui, g&eacute;riatrique", "Oui, psychog&eacute;riatrique"))
# 36
	demandes$emsres[demandes$emsres==99] <- NA
	demandes$emsres <- factor (demandes$emsres, levels=0:1, labels=c("Hors r&eacute;seau", "Dans le r&eacute;seau"))
# 41	
	demandes$dateabou <- as.character(demandes$dateabou)
	demandes$dateabou[demandes$dateabou==""] <- "99"
	demandes$dateabou <- factor (demandes$dateabou)
	demandes$dateabou[as.character(demandes$dateabou)=="99"] <- NA
# 39
	demandes$motifaba[demandes$motifaba==99] <- NA
	demandes$motifaba <- factor (demandes$motifaba, levels=1:3, labels=c("d&eacute;saccord de l'usager et/ou entourage", "solution trouv&eacute;e par un autre BRIO", "solution trouv&eacute;e par l'usager et/ou entourage"))
# 40
	demandes$formulat[demandes$formulat==99] <- NA
	demandes$formulat<- factor (demandes$formulat, levels=1:2, labels=c("Changement de l'&eacute;tat de sant&eacute; de l'usager", "Changement structurel du soutien &agrave; domicile"))
# 42
	demandes$demabout[demandes$demabout==-99999] <- NA

# 37
	demandes$aboutiss[demandes$aboutiss==99] <- NA
	# correction temporaire pour le bug dans Brioche 2 :
	demandes$aboutiss[is.na(demandes$dateabou)&is.na(demandes$aboutiss)] <- 11
	demandes$aboutiss <- factor (demandes$aboutiss, levels=1:11, labels=c("Domicile (y. c. appartements prot&eacute;g&eacute;s ou adapt&eacute;s)", "Court s&eacute;jour", "Long s&eacute;jour", "Poursuite du long s&eacute;jour dans le m&ecirc;me &eacute;tablissement", "S&eacute;jour d'observation", "Hospitalisation en lit A", "Hopitalisation en lit B", "D&eacute;c&egrave;s", "Abandon de la demande", "Nouvelle demande", "En cours"))

# labliser les variables

	attr(demandes$idusager, "description") <- "Num&eacute;ro r&eacute;f&eacute;rentiel de l'usager (un par usager)"
	attr(demandes$iddemand, "description") <- "Num&eacute;ro chronologique de la demande (un par demande )"
	attr(demandes$age, "description") <- "Age de l'usager"
	attr(demandes$sexe, "description") <- "Sexe de l'usager"
	attr(demandes$region, "description") <- "R&eacute;gion de r&eacute;sidence de l'usager"
	attr(demandes$sitsoc, "description") <- "Situation sociale de l'usager"
	attr(demandes$cms, "description") <- "Aide d'un CMS ou d'un autre prestataire de maintien &agrave; domicile au moment de la demande"
	attr(demandes$probleme1, "description") <- "Anxi&eacute;t&eacute; &frasl; d&eacute;pression &frasl; sentiment d'ins&eacute;curit&eacute;"
	attr(demandes$probleme2, "description") <- "Risques de fugue &frasl; troubles du comportement"
	attr(demandes$probleme3, "description") <- "R&eacute;sistance multiple aux  antibiotiques"
	attr(demandes$probleme4, "description") <- "Chutes (au cours des 3 derniers mois)"
	attr(demandes$probleme5, "description") <- "Solitude"
	attr(demandes$probleme6, "description") <- "D&eacute;pendance (alcool, substances)"
	attr(demandes$probleme7, "description") <- "Alimentation par perfusion"
	attr(demandes$probleme8, "description") <- "Domicile inad&eacute;quat"
	attr(demandes$probleme9, "description") <- "Absence &frasl; indisponibilit&eacute; du r&eacute;seau primaire"
	attr(demandes$probleme10, "description") <- "Epuisement du r&eacute;seau primaire"
	attr(demandes$probleme11, "description") <- "Probl&egrave;mes respiratoires"
	attr(demandes$probleme12, "description") <- "L'usager refuse l'aide du CMS"
	attr(demandes$autreprobl, "description") <- "Autre... &agrave; pr&eacute;ciser"
	attr(demandes$dmst, "description") <- "Transmission d'un DMST"
	attr(demandes$manger, "description") <- "Degr&eacute; d'autonomie de l'usager pour se nourrir"
	attr(demandes$laver, "description") <- "Degr&eacute; d'autonomie de l'usager pour se demandes$laver"
	attr(demandes$habiller, "description") <- "Degr&eacute; d'autonomie de l'usager pour s'demandes$habiller"
	attr(demandes$deshab, "description") <- "Degr&eacute; d'autonomie de l'usager pour se d&eacute;sdemandes$habiller"
	attr(demandes$entpers, "description") <- "Degr&eacute; d'autonomie de l'usager pour entretenir sa personne"
	attr(demandes$contves, "description") <- "Degr&eacute; d'autonomie de l'usager pour la continence v&eacute;sicale"
	attr(demandes$contana, "description") <- "Degr&eacute; d'autonomie de l'usager pour la continence anale"
	attr(demandes$toilet, "description") <- "Degr&eacute; d'autonomie de l'usager pour utiliser les demandes$toilettes"
	attr(demandes$memoire, "description") <- "Degr&eacute; d'autonomie de l'usager pour la m&eacute;moire"
	attr(demandes$memoire, "description") <- "Degr&eacute; d'autonomie de l'usager pour l'orientation (temps, espace)"
	attr(demandes$jugement, "description") <- "Degr&eacute; d'autonomie de l'usager pour le demandes$jugement et la compr&eacute;hension"
	attr(demandes$soccuper, "description") <- "Degr&eacute; d'autonomie de l'usager pour g&eacute;rer son temps libre, s'occuper"
	attr(demandes$datedem, "description") <- "Date de la demande en semaines"
	attr(demandes$debutpec, "description") <- "D&eacute;but de prise en charge d&eacute;sir&eacute;e..."
	attr(demandes$provient, "description") <- "Provenance de l'usager"
	attr(demandes$origine, "description") <- "Origine de la demande"
	attr(demandes$pecdem, "description") <- "Prise en charge d&eacute;sir&eacute;e"
	attr(demandes$typedom, "description") <- "Type de domicile demand&eacute;"
	attr(demandes$natpec, "description") <- "Nature de la prise en charge demand&eacute;e"
	attr(demandes$rencontr, "description") <- "Rencontre avec l'usager"
	attr(demandes$decorient, "description") <- "D&eacute;cision d'orientation"
	attr(demandes$orguat, "description") <- "D&eacute;cision d'demandes$orientation"
	attr(demandes$emsres, "description") <- "Localisation de l'EMS"
	attr(demandes$aboutiss, "description") <- "Aboutissement de la demande"
	attr(demandes$formulat, "description") <- "Motif de la formulation d'une nouvelle demande"
	attr(demandes$demabout, "description") <- "Dur&eacute;e en jours entre la date de la demande et la date d'aboutissement"
	attr(demandes$motifaba, "description") <- "Motif d'abandon de la demande"
	attr(demandes$formulat, "description") <- "Motif de la formulation d'une nouvelle demande"
	attr(demandes$demabout, "description") <- "Dur&eacute;e en jours entre la date de la demande et la date d'aboutissement"

	demandes
}



nettoyage.refus <- function (refus)
{
	# noms des variables
	names (refus) <- c ("iddemand", "typerefus", "motifrefus")

	if (nrow(refus) > 0)	{
		refus$iddemand <- as.character (refus$iddemand)
		refus$iddemand <- gsub (x=refus$iddemand, pattern="\\\"", replacement="", extended=FALSE, perl=FALSE)

		levels(refus$typerefus) <- gsub (x=levels(refus$typerefus), pattern="\\\"", replacement="", extended=FALSE, perl=FALSE)
	}
	refus$typerefus <- as.character(refus$typerefus)
	refus$typerefus <- as.character(refus$typerefus)
	refus$typerefus <- as.integer (refus$typerefus)
	refus$typerefus <- factor (refus$typerefus, levels=1:2, labels=c("CMS", "EMS"))
	attr (refus$typerefus, "description") <- "Institution qui refuse"

	attr (refus$motifrefus, "description") <- "Motif du refus"

	refus
}
