-- PATCH pour la base de donnes de briochecvs dbrio
-- Pour appliquer ce patch tapper la ligne suivante : 
-- mysql -u dbrio -p dbrio < 2_3-3_2.sql
-- Version v2_3 => v3_2 Regroupement des patches elca_ et ob_ correspondant
--

-- Ajout du champ AVS pour l'usager

ALTER TABLE `usagers` ADD `avs` VARCHAR( 14 ) AFTER `sexe` ;

-- Ajout d'une table PROVENANCE -- version dj corrige conformment au patch_ob_1_2.sql
DROP TABLE IF EXISTS `provenance`;
CREATE TABLE `provenance` (
  `idprovenance` smallint(6) NOT NULL default '0',
  `ordre` smallint(6) NOT NULL default '0',
  `provenance_text` char(25) default NULL,
  `tst` timestamp(14) NOT NULL,
  PRIMARY KEY  (`idprovenance`)
) TYPE=MyISAM;

--
-- Dumping data for table `provenance`
--


INSERT INTO `provenance` VALUES (1,1,'Hpital (A)',20050101202016),
                                (2,2,'CTR (B)',20050101202016),
                                (8,3,'Lit A ou B reclass',20050101202253),
                                (3,4,'Long sjour (C)',20050101202303),
                                (5,5,'Long sjour provisoire',20050101202413),
                                (6,6,'Sjour d\'observation',20050101202016),
                                (7,7,'Court sjour (C)',20050101202016),
                                (9,8,'Etabl. non mdicalis',20050101202417),
                                (4,9,'Domicile',20050101202348);






-- pour les courts sejours

ALTER TABLE `calendrier` ADD `urgent` TINYINT( 1 ) DEFAULT '0' NOT NULL AFTER `nolit` ;
ALTER TABLE `calendrier` ADD `commentaire` TEXT AFTER `urgent` ;


-- ajout champ dans demandeor
ALTER TABLE `demandeor` ADD `dmttrans` SMALLINT( 6 ) DEFAULT '0' NOT NULL AFTER `doctrans` ;
ALTER TABLE `demandeor` ADD `supplement_ch_indiv` SMALLINT( 6 ) DEFAULT '0' NOT NULL AFTER `dmttrans` ;
ALTER TABLE `demandeor` ADD `mobilite` TINYINT( 4 ) DEFAULT '0' NOT NULL AFTER `refuscms` ;

-- ajout des mmes champs dans la table avaliderdem
ALTER TABLE `avaliderdem` ADD `dmttrans` SMALLINT( 6 ) DEFAULT '0' NOT NULL AFTER `doctrans` ;
ALTER TABLE `avaliderdem` ADD `supplement_ch_indiv` SMALLINT( 6 ) DEFAULT '0' NOT NULL AFTER `dmttrans` ;
ALTER TABLE `avaliderdem` ADD `mobilite` TINYINT( 4 ) DEFAULT '0' NOT NULL AFTER `refuscms` ;


-- ajout pour hopital A, B

ALTER TABLE `etablissements` ADD `type_hopital` CHAR( 1 ) ;
ALTER TABLE `issue` ADD `noet` INT( 11 ) ;

--- issue -> service placeur de la demande

ALTER TABLE `dossiers` ADD `issue_etabl` INT( 11 ) ;

-- ajout d'une dropdown pour les courts sejours dans la page Issue.

ALTER TABLE `issue` ADD `type_court_sejour` SMALLINT( 6 ) ;

-- aijout d'un champ dans la demande

ALTER TABLE `demandeor` ADD `litjusqua` DATE AFTER `litdepuis` ;

-- ajout d'une colonne issue dans le rsum pour l'usager

DROP TABLE IF EXISTS `issueoptions`;
CREATE TABLE `issueoptions` (
  `idissue` smallint(6) NOT NULL default '0',
  `issue_text` char(60) default NULL,
  `tst` timestamp(14) NOT NULL,
  PRIMARY KEY  (`idissue`)
) TYPE=MyISAM;

#
# Dumping data for table `issueoptions`
#


INSERT INTO `issueoptions` VALUES (1, 'Domicile', 20041208113640);
INSERT INTO `issueoptions` VALUES (4, 'Dcs avant orientation', 20041208113739);
INSERT INTO `issueoptions` VALUES (5, 'Demande d\'orientation retire', 20041208113801);
INSERT INTO `issueoptions` VALUES (2, 'Court sjour', 20041208113821);
INSERT INTO `issueoptions` VALUES (6, 'Sjour d\'observation', 20041208113844);
INSERT INTO `issueoptions` VALUES (3, 'Placement long sjour', 20041208113854);
INSERT INTO `issueoptions` VALUES (9, 'Hpital A', 20041208113927);
INSERT INTO `issueoptions` VALUES (10, 'Hpital B', 20041208113937);
INSERT INTO `issueoptions` VALUES (7, 'Nouvelle demande', 20041208114000);
INSERT INTO `issueoptions` VALUES (8, 'Long sj. mme tabl.', 20041208114027);
    
    
-- Ajout d'un choix pour le sexe lorsqu'on n'attribue pas de dossier

ALTER TABLE `calendrier` ADD `sexe` CHAR( 1 ) AFTER `commentaire` ;

#Ajout d'un champ "ordre"  typesejour

alter table typesejour add ordre smallint not null;
alter table typesejour change ttypesej ttypesej char(25);
DELETE FROM typesejour;
INSERT INTO typesejour VALUES (1,'Long sj. (C)',20050107225615,1);
INSERT INTO typesejour VALUES (2,'Sj. d\'observation (C)',20050107225617,2);
INSERT INTO typesejour VALUES (3,'Court sj. non urgent (C)',20050107230326,3);
INSERT INTO typesejour VALUES (4,'Polyvalent',20050107225433,0);
INSERT INTO typesejour VALUES (5,'Court sj. planifi (C)',20050107230332,5);
INSERT INTO typesejour VALUES (6,'Et. non mdicalis (D)',20050107225632,6);
INSERT INTO typesejour VALUES (7,'CTR (B)',20050107225634,7);
INSERT INTO typesejour VALUES (8,'Domicile',20050107225637,8);
INSERT INTO typesejour VALUES (9,'Domicile + UAT',20050107225640,9);
INSERT INTO typesejour VALUES (10,'Logement adapt',20050107225644,10);
INSERT INTO typesejour VALUES (11,'Appart. protg',20050107225646,11);
INSERT INTO typesejour VALUES (12,'Tt. opt. ouvertes',20050107225649,12);
INSERT INTO typesejour VALUES (13,'Or. dj arrte',20050107225651,13);
INSERT INTO typesejour VALUES (14,'Court sj. urgent (C)',20050107225657,4);

# Ajout du champ litjusqua  la table avaliderdem (pour qu'elle reste calque sur demandeor)
ALTER TABLE avaliderdem add litjusqua date after litdepuis;


# Modification du numro de version stock dans la base de donnes.

UPDATE version SET valeur = 3 WHERE cle = "versionG";
UPDATE version SET valeur = 2 WHERE cle = "versionP";

