<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Agrgation de plusieurs bases de donnes
* @package accessoires
*/
/**
* Agrgation de plusieurs bases de donnes
* Appele par un script en ligne de commande, cette classe permet de fusionner plusieurs bases de donnes
* de production, par exemple pour extraire des statistiques agrges. Ralis
* pour le rseau NORD-BROYE. 
* Ne pas utiliser pour gnrer une base de production mais uniquement  des fins 
* statistiques : les fusions d'usagers, d'tablissements, 
* etc. sont ralises " la hussarde".
* @package accessoires
* @author ob
*/ 
class agregation {
  /**
  * le tableau des bases de donnes sources
  * tableau associatif fournissant, pour chaque index, un tableau associatifs avec les valeurs :
  * <pre>
  * 'bd' = la base de donnes d'une instance  fusionner
  * 'user' = un nom d'utilisateur mysql autoris
  * 'pw' = le mot de passe correspondant
  * 'offsetUsagers' = un nombre ajout au numro d'usager, pour viter les doublons
  * 'offsetDossiers' = idem pour les numros de dossiers
  * 'offsetEtablissement' = idem pour les numros d'tablissements
  * 'offsetLits' = idem pour les numros de lits
  * 'offsetUtilisateurs' = idem pour les numros d'utilisateurs
  * </pre>
  * les numros d'offset doivent tre suprieurs au dernier numro atteint par la basse prcdente dans
  * l'ordre des fusions
  * @var array
  */
  var $sources;
  
  /**
  * le tableau associatif des paramtres de la base de donnes destination :
  * <pre>
  * 'bd' = la base de donne de destination
  * 'user' = un nom d'utilisateur autoris
  * 'pw' = un mot de passe autoris
  * 'offsetBrios' = le nombre  ajouter au numro du premier des tablissements "BRIOs" cr par agrgation
  * doit tre suprieur au numro d'tablissement le plus lev (offset compris) de la dernire base agrge
  * </pre>
  * @var array
  */
  var $destination;
  
  /**
  * le tableau des BRIOs  crer fournissant, pour chaque index, un tableau associatif avec les valeurs :
  * <pre>
  * 'numero' = le numro d'ordre, ajout au paramtre 'offsetBrios' pour dterminer le numro d'tablissement
  * 'nom' = le nom du BRIO cr
  * 'preg' = l'expression rgulire permettant d'identifier le BRIO correspondant dans les bases de donnes sources
  * </pre>
  * @var array
  */
  var $brios;
  
  /**
  * un lien mysql par instance source, chaque index du tableau correspond  une ressource
  * @var array
  */
  var $links;
  
  /**
  * le lien mysql pour la base destination
  * @var resource
  */
  var $linkd;

  /**
  * @param array sources cf. variable de classe
  * @param array destination cf. variable de classe
  * @param array brios cf. variable de classe
  */
  function agregation($sources, $destination, $brios){
    $this->sources = $sources;
    $this->destination = $destination;
    $this->brios = $brios;
    $cpt = count($this->sources);
    for ($i = 0; $i < $cpt; $i++){
      $this->links[$i] = mysql_pconnect("localhost", $this->sources[$i]['user'], $this->sources[$i]['pw']);
      mysql_select_db($this->sources[$i]['bd'], $this->links[$i]);
      print (mysql_error() ? mysql_error() . "\n" : "");
      
    }
    $this->linkd = mysql_pconnect("localhost", $this->destination['user'], $this->destination['pw']);
    mysql_select_db($this->destination['bd'], $this->linkd);
    print (mysql_error() ? mysql_error() . "\n" : "");
    
  }
  
  /**
  * squence des mthodes invoques
  */
  function execute(){
    $this->creeDest();
    $this->copie();
    $this->remplitParametres();
    $this->updateOffset();
    $this->remplitTables();
    $this->detruitProv();
    $this->doublonsUsagers();
    $this->doublonsBrios();
  }

  /**
  * rcupration du schma des bases de donnes, dans la premire base source
  * renvoie un tableau d'instructions sql permettant de reconstituer le schma des tables
  * @return array
  */
  function getSchema(){
    $result = mysql_list_tables($this->sources[0]['bd'], $this->links[0]);
    $schema = array();
    while($ligne = mysql_fetch_row($result)){
      if (! preg_match("/^_/", $ligne[0])){
      //if (! preg_match("/^_prov/", $ligne[0])){
        $schema[] = "DROP TABLE IF EXISTS $ligne[0];";
        $requete2 = "SHOW CREATE TABLE $ligne[0];";
        $result2 = mysql_query($requete2, $this->links[0]);
        print mysql_error();
        $ligne2 = mysql_fetch_row($result2);
        $schema[] = $ligne2[1] . ";";
      }
    }
  
    return $schema; 
  }

  /**
  * cration du schma de la base destination
  */
  function creeDest(){
    $schema = $this->getSchema();
    $cpt = count($schema);
    for ($i = 0; $i < $cpt; $i++){
      $requete = $schema[$i];
      $result = mysql_query($requete);
      print mysql_error();
    }
  }
  
    
  /**
  * cre, dans la base destination, des tables provisoires contenant les donnes des
  * bases  fusionner
  */
  function copie(){
    $cpt = count($this->sources);
    for ($i = 0; $i < $cpt; $i++){
      $result = mysql_list_tables($this->sources[$i]['bd'], $this->links[$i]);
      while ($ligne = mysql_fetch_row($result)){
        if (! preg_match("/^_/", $ligne[0])) {
        //if (! preg_match("/^_prov/", $ligne[0])) {
          $nomt = $ligne[0];
          $nomprov = "._prov_" . $i . "_" . $nomt;
          $requete2 = "DROP TABLE IF EXISTS $nomprov";
          $result2 = mysql_query($requete2, $this->linkd);
          $requete2 = "CREATE TABLE " . $this->destination['bd'] . $nomprov .
                      " SELECT * FROM " . $this->sources[$i]['bd'] . ".$nomt";
          $result2 = mysql_query($requete2, $this->linkd);
          print mysql_error();             
        }
      }
    }
  
  }

  /**
  * remplissage des tables paramtres de la base de destination (une seule fois)
  */  
  function remplitParametres(){
    $param = $this->getTabParam();
    foreach ($param as $table){
      $requete = "INSERT INTO $table SELECT * FROM _prov_0_$table";
      $result = mysql_query($requete, $this->linkd);
    }
  }
  
  /** 
  * renvoie le tableau des tables "paramtres", c'est--dire contenant des enregistrements
  * communs  toutes les instances, et qu'il ne faut par consquent pas fusionner
  */
  function getTabParam(){
    $param[] = "adressesinterbrio";
    $param[] = "groupesetab";
    $param[] = "issueoptions";
    $param[] = "listeaides";
    $param[] = "listeprofils";
    $param[] = "missions";
    $param[] = "nopostaux";
    $param[] = "provenance";
    $param[] = "sexelit";
    $param[] = "typesejour";
    $param[] = "version";
    $param[] = "optionssoin";
    $param[] = "quittances";
    $param[] = "typeaidedom";
    $param[] = "typedebutpec";
    $param[] = "typepath";
    $param[] = "typesitsociale";
    return $param;
  }
  
  /**
  * modification des identifiants de certains champs des tables provisoires en fonction des offsets
  * fournis
  */
  function updateOffset(){
    $cpt = count($this->sources);
    for ($i = 0; $i < $cpt; $i++){
      //Usagers
      $requete = "UPDATE _prov_" . $i . "_usagers SET nous = nous + " . $this->sources[$i]['offsetUsagers'];
      $result = mysql_query($requete, $this->linkd);
      //Dossiers et sous-tables
      $requete = "UPDATE _prov_" . $i . "_dossiers SET nodoss =  nodoss + " .
                  $this->sources[$i]['offsetDossiers'] . ", nous = nous + " .
                  $this->sources[$i]['offsetUsagers'];
      $result = mysql_query($requete, $this->linkd);
      $tabs[0][0] = "demandeor";
      $tabs[0][1] = "nodoss";
      $tabs[0][2] = "nodemor";
      $tabs[1][0] = "decision";
      $tabs[1][1] = "nodoss";
      $tabs[1][2] = "nodec";
      $tabs[2][0] = "issue";
      $tabs[2][1] = "nodoss";
      $tabs[2][2] = "noissue";
      $tabs[3][0] = "profilopars";
      $tabs[3][1] = "nodoss";
      $tabs[3][2] = "noprof";
      $tabs[4][0] = "notes";
      $tabs[4][1] = "nodossier";
      $tabs[4][2] = "";
      $tabs[5][0] = "attributionlit";
      $tabs[5][1] = "nodoss";
      $tabs[5][2] = "idplac";
      $tabs[6][0] = "grille";
      $tabs[6][1] = "nodoss";
      $tabs[6][2] = "nogrille";
      $tabs[7][0] = "calendrier";
      $tabs[7][1] = "nodoss";
      $tabs[7][2] = "noev";
      $tabs[8][0] = "choixems";
      $tabs[8][1] = "nodoss";
      $tabs[8][2] = "nochoix";
      $tabs[9][0] = "signetsdossiers";
      $tabs[9][1] = "nodoss";
      $tabs[9][2] = "id";
      $cpt2 = count($tabs);
      for ($j = 0; $j < $cpt2; $j++){
        $requete = "UPDATE _prov_" . $i ."_" . $tabs[$j][0] . " SET " . $tabs[$j][1] . " = " . 
                   $tabs[$j][1] . " + " . $this->sources[$i]['offsetDossiers'] . 
                   ($tabs[$j][2] ? ", " . $tabs[$j][2] . " = " . $tabs[$j][2] . " + " .
                   $this->sources[$i]['offsetDossiers'] : "");
        $result = mysql_query($requete, $this->linkd);
        print mysql_error();            
      } 
      // Etablissements
      $requete = "UPDATE _prov_" . $i . "_etablissements SET noet = noet + " . $this->sources[$i]['offsetEtablissements'];
      $result = mysql_query($requete, $this->linkd);
      print mysql_error();
      $requete = "UPDATE _prov_" . $i . "_annoncelit SET etabl = etabl + " . $this->sources[$i]['offsetEtablissements'];
      $result = mysql_query($requete, $this->linkd);
      print mysql_error();
      $requete = "UPDATE _prov_" . $i . "_calendrier SET etablissement = etablissement + " . $this->sources[$i]['offsetEtablissements']; 
      $result = mysql_query($requete, $this->linkd);
      print mysql_error();
      $requete = "UPDATE _prov_" . $i . "_choixems SET noems = noems + " . $this->sources[$i]['offsetEtablissements']; 
      $result = mysql_query($requete, $this->linkd);
      print mysql_error();
      $requete = "UPDATE _prov_" . $i . "_demandeor SET servplac = servplac + " . $this->sources[$i]['offsetEtablissements']; 
      $result = mysql_query($requete, $this->linkd);
      print mysql_error();
      $requete = "UPDATE _prov_" . $i . "_etablautorises SET etabl = etabl + " . $this->sources[$i]['offsetEtablissements'] . 
                 ", id = id + " . $this->sources[$i]['offsetEtablissements']; 
      $result = mysql_query($requete, $this->linkd);
      print mysql_error();
      $requete = "UPDATE _prov_" . $i . "_issue SET noet = noet + " . $this->sources[$i]['offsetEtablissements']; 
      $result = mysql_query($requete, $this->linkd);
      print mysql_error();
      $requete = "UPDATE _prov_" . $i . "_litscourtsejour SET etabl = etabl + " . $this->sources[$i]['offsetEtablissements'] .
                 ", id = id + " . $this->sources[$i]['offsetEtablissements']; 
      $result = mysql_query($requete, $this->linkd);
      print mysql_error();
      
      // Lits
      $requete = "UPDATE _prov_" . $i . "_annoncelit SET nolit = nolit + " . $this->sources[$i]['offsetLits'];
      $result = mysql_query($requete, $this->linkd);
      print mysql_error();
      $requete = "UPDATE _prov_" . $i . "_attributionlit SET nolit = nolit + " . $this->sources[$i]['offsetLits'] .
                 ", idplac = idplac + " . $this->sources[$i]['offsetLits'];
      $result = mysql_query($requete, $this->linkd);
      print mysql_error();
      $requete = "UPDATE _prov_" . $i . "_calendrier SET nolit = nolit + " . $this->sources[$i]['offsetLits'] .
                 ", noev = noev + " . $this->sources[$i]['offsetLits'];
      $result = mysql_query($requete, $this->linkd);
      print mysql_error();
      
      // Utilisateurs
      $requete = "UPDATE _prov_" . $i . "_initialesidut SET no = no + " . $this->sources[$i]['offsetUtilisateurs'] .
                 ", idut = idut + " . $this->sources[$i]['offsetUtilisateurs'];  
      $result = mysql_query($requete, $this->linkd);
      print mysql_error();
      // Signets
      $requete = "UPDATE _prov_" . $i . "_signets SET id = id + " . $this->sources[$i]['offsetUtilisateurs'];
      $result = mysql_query($requete, $this->linkd);
      print mysql_error();
    }
  }

  /**
  * agrgation des tables non "paramtres"
  */
  function remplitTables(){
    $param = $this->getTabParam();
    $result = mysql_list_tables($this->sources[0]['bd'], $this->links[0]);
    $cpt = count($this->sources);
    while ($ligne = mysql_fetch_row($result)){
      if ((! in_array($ligne[0], $param)) && (! preg_match("/^_/", $ligne[0]))) {
      //if ((! in_array($ligne[0], $param)) && (! preg_match("/^_prov/", $ligne[0]))) {
        for ($i = 0; $i < $cpt; $i++){
          $requete2 = "INSERT IGNORE INTO " . $ligne[0] . " SELECT * FROM _prov_" . $i . "_" . $ligne[0];
          $result2 = mysql_query($requete2, $this->linkd);
          print mysql_error();
        }
      }
    }
    // Correction des noms propres tout en majuscules.
    $requete = "UPDATE usagers set nom = concat(upper(left(nom, 1)), lower(substring(nom from 2))) " .
               "where hex(substring(nom, 2, 1)) = hex(upper(substring(nom, 2, 1)))";
    $result = mysql_query($requete, $this->linkd);
  }
  
  
  /**
  * suppression des tables provisoires
  */
  function detruitProv(){
    $result = mysql_list_tables($this->destination['bd'], $this->linkd);
    while ($ligne = mysql_fetch_row($result)){
      if(preg_match("/^_/", $ligne[0])){
        $requete2 = "DROP TABLE " . $ligne[0];
        $result2 = mysql_query($requete2);
        print mysql_error();
      }
    }
  }
  
  /**
  * recherche des doublons prsums dans la table "usagers", puis fusion
  */
  function doublonsUsagers(){
    $requete = "ALTER TABLE usagers ADD INDEX datenaiss(datenaiss)";
    $result = mysql_query($requete, $this->linkd); 
    $requete = "select usagers.nous, usagers_1.nous from usagers left join usagers as usagers_1 " .
               "on usagers.datenaiss = usagers_1.datenaiss where usagers.nous > usagers_1.nous " .
               "and usagers.sexe = usagers_1.sexe and LEFT(usagers.nom, 3) = left(usagers_1.nom, 3) " .
               "and left(usagers.prenom,3) = left(usagers_1.prenom, 3) limit 1";
    $i = 0;
    print "FUSIONS :\n";
    do {
      $result = mysql_query($requete, $this->linkd);             
      $ligne = mysql_fetch_row($result);
      if ($ligne[0] && $ligne[1]){
        print $i . " : " . $ligne[0] . " - " . $ligne[1] . "\n";
        $this->fusionneUsagers($ligne[0], $ligne[1]);   
        $i++;
      }   
    } while($ligne[0]);     
    print $i . " usagers fusionns\n";
    
    //$requete = "ALTER TABLE usagers DROP INDEX datenaiss";
    //$result = mysql_query($requete);
  }

  /**
  * fusion " la hussarde des doublons identifis
  */
  function fusionneUsagers($prem, $sec){
    $requete = "SELECT nous FROM usagers WHERE nous IN($prem, $sec) ORDER BY tst";
    $result = mysql_query($requete, $this->linkd);
    $ligne = mysql_fetch_row($result);
    $secondaire = $ligne[0];
    $ligne = mysql_fetch_row($result);
    $primaire = $ligne[0];
    if ($primaire == $secondaire){
      print "ERREUR DE FUSION";
      return;
    }
    $requete = "UPDATE dossiers SET nous = $primaire WHERE nous = $secondaire";
    $result = mysql_query($requete, $this->linkd);
    print mysql_error();
    $requete = "DELETE FROM usagers WHERE nous = $secondaire";
    $result = mysql_query($requete);
    print mysql_error();
  }

  /**
  * fusion des doublons des tablissements "BRIOs"
  */
  function doublonsBrios(){
    $cpt = count($this->brios);
    //Cration des nouveaux enregistrements BRIOs
    for ($i = 0; $i < $cpt; $i++){
      $requete = "INSERT INTO etablissements SET noet = " . ($this->destination['offsetBrios'] + $this->brios[$i]['numero']) .
                 ", nomet = \"" . $this->brios[$i]['nom'] . "\", litsc = -1, servplac = -1, litsd = -1" .
                 ", autbrio = -1, groupet = 9" . ($this->brios[$i]['idsulid'] == -1 ? ", idsulid = \"-1\"" : ""); 
      $result = mysql_query($requete, $this->linkd);
      print mysql_error();
    }
    // Remplacement des anciens BRIOs par les nouveaux
    $requete = "SELECT * from etablissements WHERE autbrio = -1 or idsulid = \"-1\"";
    $result = mysql_query($requete, $this->linkd);
    while ($ligne = mysql_fetch_object($result)) {
      for ($i = 0; $i < $cpt; $i++){
        if (preg_match("/" . $this->brios[$i]['preg']. "/i", $ligne->nomet) && $ligne->noet < $this->destination['offsetBrios']){
          $ancnum = $ligne->noet;
          $nouvnum = $this->destination['offsetBrios'] + $this->brios[$i]['numero'];
          $requete2 = "UPDATE demandeor SET servplac = $nouvnum WHERE servplac = $ancnum";
          $result2 = mysql_query($requete2, $this->linkd);
          print mysql_error();
          $requete2 = "UPDATE choixems SET noems = $nouvnum WHERE noems = $ancnum";
          $result2 = mysql_query($requete2, $this->linkd);
          print mysql_error();
          $requete2 = "DELETE FROM etablissements WHERE noet = $ancnum";
          $result2 = mysql_query($requete2, $this->linkd);
          print mysql_error();
        }  
      }
    }
  }
}




?>