<?php

class makeReports {

    var $dataManager;
    
    function __construct() {
        
        $this->dataManager = new dataManager();
    }
    
    function makeFiles() {
        
        $end = date("Y");
        $start = $end - 1;
        $periodArray = array();
        $dirPath = CREATION_DIR."period";

        if (!is_dir($dirPath)) mkdir($dirPath,0777,true);
        // Calculate Periods
        for ($y = $start; $y <= $end; $y++) {
            // Years
            $periodArray[$y]["YEAR"]["START"] = strtotime("$y-01-01");
            $periodArray[$y]["YEAR"]["END"] = strtotime("$y-12-31");
            // Semestres
            $periodArray[$y]["SEM1"]["START"] = strtotime("$y-01-01");
            $periodArray[$y]["SEM1"]["END"] = strtotime("$y-06-30");
            $periodArray[$y]["SEM2"]["START"] = strtotime("$y-07-01");
            $periodArray[$y]["SEM2"]["END"] = strtotime("$y-12-31");
            // Trimestres
            $periodArray[$y]["TRI1"]["START"] = strtotime("$y-01-01");
            $periodArray[$y]["TRI1"]["END"] = strtotime("$y-03-31");
            $periodArray[$y]["TRI2"]["START"] = strtotime("$y-04-01");
            $periodArray[$y]["TRI2"]["END"] = strtotime("$y-06-30");
            $periodArray[$y]["TRI3"]["START"] = strtotime("$y-07-01");
            $periodArray[$y]["TRI3"]["END"] = strtotime("$y-09-30");
            $periodArray[$y]["TRI4"]["START"] = strtotime("$y-10-01");
            $periodArray[$y]["TRI4"]["END"] = strtotime("$y-12-31");
            // Months
            for ($m = 1; $m <= 12; $m++) {
                if (strtotime("$y-$m-01") > time()) break;
                $periodArray[$y]["MON".$m]["START"] = strtotime("$y-$m-01");
                $periodArray[$y]["MON".$m]["END"] = strtotime("$y-$m-".cal_days_in_month(CAL_GREGORIAN,$m,$y));
            }
        }
        // Period
        
        foreach ($periodArray as $y => $period) {
            // Prepare folders
            $dirName = $y;
            if (is_dir($dirPath."/".$dirName)) {
                print $dirname . "\n";
                $rmdir = scandir($dirPath."/".$dirName);
                foreach ($rmdir as $rm) {
                    if ($rm != "." && $rm != "..")
                        unlink($dirPath."/".$dirName."/".$rm);
                }
            } else mkdir($dirPath."/".$dirName,0777);
            // Create files
            foreach ($period as $k => $per) {
                $from = $per["START"];
                $to = $per["END"];
                $type = $k;
                $fileName = date("Ymd", $from) . "_" . date("Ymd", $to);
                $fullFileName = $dirPath."/".$dirName."/agreg_".$type."_".$fileName.".html";
                print "Fichier $fileName ...\n";
                $fileContent = $this->makeFile(date("Y-m-d", $from), date("Y-m-d", $to), "period");
                file_put_contents($fullFileName,$fileContent);
            }
        }
        
        print "Fin de la cration des tableaux par priode...\n";
        // Instant
        
        for ($i=-75;$i<=-1;$i++) {
          $aujourdhui = getdate();
          $timestamp = mktime(0,0,0,$aujourdhui['mon'],$aujourdhui['mday'] + $i,$aujourdhui['year']);
          //$timestamp = time();
          $date = date("Y-m-d",$timestamp);
          print "$date \n";
          $dirName = date("M_Y", $timestamp);
          $fileName = date("Ymd", $timestamp);
          $dirPath = CREATION_DIR."instant";
          $fullFileName = $dirPath."/".$dirName."/agreg_".$fileName.".html";
          $fileContent = $this->makeFile($date);
          if (!is_dir($dirPath)) {
            mkdir($dirPath."/".$dirName,0777,true);
          } else {
            if (!is_dir($dirPath."/".$dirName)) mkdir($dirPath."/".$dirName,0777);
            else 
                if (is_file($fullFileName)) unlink($fullFileName);
          }
          file_put_contents($fullFileName,$fileContent);
        }
        
        print "Fin de la cration des tableaux par instant...\n";
        // Copy stylesheet and imgs
        copy("css.css", CREATION_DIR."css.css");
        copy("plus.gif", CREATION_DIR."plus.gif");
        copy("moins.gif", CREATION_DIR."moins.gif");
 
        // Create index.html page
        $indexContent = $this->makeIndex();
        file_put_contents(CREATION_DIR."index.html",$indexContent);
        
        return true;
    }
    
    function makeFile($from, $to = null, $type = "instant") {
        $data = $this->dataManager->initializeDataArray();
        $data['LC'] = $this->dataManager->getLC($from, $to, $type, null);
        $data['LC_DLS'] = $this->dataManager->getLC($from, $to, $type, "dls");
        $data['LC_DSP'] = $this->dataManager->getLC($from, $to, $type, "dsp");
        $data['LC_DCS'] = $this->dataManager->getLC($from, $to, $type, "dcs");
        
        //if ($type = "period"){
        //  $data['LC_DPL'] = $this->dataManager->getLC($from, $to, $type, "dpl");
        //}
        $data['DECU'] = $this->dataManager->getDE($from, $to, $type, $urgence = true, null);
        $data['DECU_SO'] = $this->dataManager->getDE($from, $to, $type, true, "so");
        $data['DECU_CS'] = $this->dataManager->getDE($from, $to, $type, true, "cs");
        $data['DECU_PL'] = $this->dataManager->getDE($from, $to, $type, true, "pl");
        $data['DECU_LB'] = $this->dataManager->getDE($from, $to, $type, true, "lb");
        $data['DECU_RD'] = $this->dataManager->getDE($from, $to, $type, true, "rd");
        $data['DECU_NS'] = $this->dataManager->getDE($from, $to, $type, true, "ns");
        
        $data['DECNU'] = $this->dataManager->getDE($from, $to, $type, $urgence = false, null);
        $data['DECNU_SO'] = $this->dataManager->getDE($from, $to, $type, false, "so");
        $data['DECNU_CS'] = $this->dataManager->getDE($from, $to, $type, false, "cs");
        $data['DECNU_PL'] = $this->dataManager->getDE($from, $to, $type, false, "pl");
        $data['DECNU_LB'] = $this->dataManager->getDE($from, $to, $type, false, "lb");
        $data['DECNU_RD'] = $this->dataManager->getDE($from, $to, $type, false, "rd");
        $data['DECNU_NS'] = $this->dataManager->getDE($from, $to, $type, false, "ns");
        if ($type == "period"){
          $data['LCA'] = $this->dataManager->getLCA($from, $to, $type, null);
          $data['LCA_DLS'] = $this->dataManager->getLCA($from, $to, $type, "dls");
          $data['LCA_DSO'] = $this->dataManager->getLCA($from, $to, $type, "dso");
          $data['LCA_DCS'] = $this->dataManager->getLCA($from, $to, $type, "dcs"); 
          $data['LCA_DPL'] = $this->dataManager->getLCA($from, $to, $type, "dpl");
        //$data['LCA_NS'] = $this->dataManager->getLCA($from, $to, $type, "ns");
        }

        $data = $this->dataManager->calcPercent($data);

        return $this->makeHTML($data, $from, $to, $type);

    }
    
    function makeIndex() {
        
        $html = "";
        
        $arbo = array();
                
        $months = scandir(CREATION_DIR."instant");
        foreach ($months as $month) {
            if ($month == '.' || $month == '..') continue;
            if (is_dir(CREATION_DIR."instant/".$month)) {
                $scans = scandir(CREATION_DIR."instant/".$month);
                $year = substr($month,4,4);
                $month = substr($month,0,3);
                foreach ($scans as $scan) {
                    if ($scan == '.' || $scan == '..') continue;
                    $name = explode("_", $scan);
                    $name = str_replace(".html", "", $name[1]);
                    $arbo[$year]["instant"][$month][$name] = $scan;
                }
            }
        }
        
        $html .= "<h2>Rapports extraits des donnes agrges<hr/></h2>";
        $html .= "<ul><h2 id='id_main'>";
        
        $years = scandir(CREATION_DIR."period");
        krsort($years);
        foreach ($years as $year) {
            if ($year == '.' || $year == '..') continue;
            if (is_dir(CREATION_DIR."period/".$year)) {
                $html .= "<a href='#id_$year'>$year</a>&nbsp;&nbsp;&nbsp;";
                $scans = scandir(CREATION_DIR."period/".$year);
                foreach ($scans as $scan) {
                    if ($scan == '.' || $scan == '..') continue;
                    $name = explode("_", $scan);
                    $name = $name[2];
                    $bigName = "";
                    if (strstr($scan,"MON")) $bigName = "MON";
                    if (strstr($scan,"TRI")) $bigName = "TRI";
                    if (strstr($scan,"SEM")) $bigName = "SEM";
                    if (strstr($scan,"YEAR")) $bigName = "YEAR";
                    $arbo[$year]["period"][$bigName][$name] = $scan;
                }
            }
        }
        
        $html .= "<hr/></h2></ul>";
        
        $monthArray = array("Jan" => "Janvier", "Feb" => "Fvrier", "Mar" => "Mars", "Apr" => "Avril", 
                            "May" => "Mai", "Jun" => "Juin", "Jul" => "Juillet", "Aug" => "Aot", 
                            "Sep" => "Septembre", "Oct" => "Octobre", "Nov" => "Novembre", "Dec" => "Dcembre");
        
        krsort($arbo);
        foreach ($arbo as $year => $leafs) {
            
            $html .= "<ul><h2 id='id_$year' class='indexTitle'>$year&nbsp;&nbsp;&nbsp;";
            $html .= "<a style='text-decoration:none;color:white;' href='#id_main'>&uarr;</a></h2>"; 
            $html .= "<li><h3>Priode</h3>";
            $html .= "<table cellpadding=3 width=880>";
            $html .= "<tr><td width=250 class='indexHeader'>Anne</td>";
            $html .= "<td width=250 class='indexHeader'>Semestre</td>";
            $html .= "<td width=250 class='indexHeader'>Trimestre</td>";
            $html .= "<td width=20>";
            $html .= "<img height=20 id='imgPer1Plus_$year' src='plus.gif' style='cursor:pointer;display:none;' ";
            $html .= "onclick=\"document.getElementById('tr1Per_$year').style.display='';";
            $html .= "document.getElementById('imgPer1Minus_$year').style.display='';this.style.display='none';return false;\"></img>";
            $html .= "<img height=20 id='imgPer1Minus_$year' src='moins.gif' style='cursor:pointer;' ";
            $html .= "onclick=\"document.getElementById('tr1Per_$year').style.display='none';";
            $html .= "document.getElementById('imgPer1Plus_$year').style.display='';this.style.display='none';return false;\"></img>";            
            $html .= "</td></tr>";
            $yearFile = $leafs["period"]["YEAR"][$year."0101"];
            $html .= "<tr id='tr1Per_$year'><td class='indexContent'><a href='period/$year/$yearFile'>$yearFile</a></td>";
            $html .= "<td class='indexContent'>";
            foreach ($leafs["period"]["SEM"] as $sem) {
                $html .= "<a href='period/$year/$sem'>$sem</a><br/>";
            }
            $html .= "</td><td class='indexContent'>";
            foreach ($leafs["period"]["TRI"] as $tri) {
                $html .= "<a href='period/$year/$tri'>$tri</a><br/>";
            }
            $html .= "</td><td>&nbsp;</td></tr>";
            $html .= "<tr><td class='indexHeader' colspan='3'>Mois</td>";
            $html .= "<td width=20>";
            $html .= "<img height=20 id='imgPer2Plus_$year' src='plus.gif' style='cursor:pointer;display:none;' ";
            $html .= "onclick=\"document.getElementById('tr2Per_$year').style.display='';";
            $html .= "document.getElementById('imgPer2Minus_$year').style.display='';this.style.display='none';return false;\"></img>";
            $html .= "<img height=20 id='imgPer2Minus_$year' src='moins.gif' style='cursor:pointer;' ";
            $html .= "onclick=\"document.getElementById('tr2Per_$year').style.display='none';";
            $html .= "document.getElementById('imgPer2Plus_$year').style.display='';this.style.display='none';return false;\"></img>";
            $html .= "</td></tr>";
            $cpt = 0;
            ksort($leafs["period"]["MON"]);
            $html .= "<tr id='tr2Per_$year'><td class='indexContent' valign='top'>";
            foreach ($leafs["period"]["MON"] as $mon) {
                $cpt ++;
                $html .= "<a href='period/$year/$mon'>$mon</a>";
                if (fmod($cpt,4) == 0 && $cpt < 10) $html .= "</td><td class='indexContent' valign='top'>";
                else $html .= "<br/>";
            }
            $html .= "</td><td>&nbsp;</td></tr>";
            $html .= "</table><br/>";
            
            $html .= "</li>";
            $html .= "<li><h3>Instantan</h3>";
            $html .= "<table cellpadding=3 width=880>";
            foreach ($monthArray as $monthKey => $monthName) {
                $html .= "<tr><td colspan='4' class='indexHeader'>$monthName</td>";
                $html .= "<td width=20 align='right'>";
                if (isset($leafs["instant"][$monthKey])) {
                    $html .= "<img height=20 id='imgPlus_$monthKey' src='plus.gif' style='cursor:pointer;' ";
                    $html .= "onclick=\"document.getElementById('tr_$monthKey').style.display='';";
                    $html .= "document.getElementById('imgMinus_$monthKey').style.display='';this.style.display='none';return false;\"></img>";
                    $html .= "<img height=20 id='imgMinus_$monthKey' src='moins.gif' style='cursor:pointer;display:none;' ";
                    $html .= "onclick=\"document.getElementById('tr_$monthKey').style.display='none';";
                    $html .= "document.getElementById('imgPlus_$monthKey').style.display='';this.style.display='none';return false;\"></img>";                    
                } else $html .= "&nbsp;";
                $html .= "</td></tr>";
                $cpt = 0;
                if (isset($leafs["instant"][$monthKey])) {
                    ksort($leafs["instant"][$monthKey]);
                    $html .= "<tr id='tr_$monthKey' style='display:none;'><td width=200 class='indexContent' valign='top'>";
                    foreach ($leafs["instant"][$monthKey] as $file) {
                        $cpt ++;
                        $html .= "<a href='instant/".$monthKey."_$year/$file'>$file</a>";
                        if (fmod($cpt,8) == 0 && $cpt < 30) $html .= "</td><td width=200 class='indexContent' valign='top'>";
                        else $html .= "<br/>";
                    }
                    $cpt = 4 - ceil(($cpt+1)/8);
                    for ($i = 0; $i < $cpt; $i ++) $html .= "</td><td width=200 class='indexContent'>&nbsp;";
                    $html .= "</td><td>&nbsp;</td></tr>";
                }
            }
            $html .= "</table><br/>";
            
            $html .= "</li>";
            $html .= "</ul>";
        }
               
        $css = "<link rel='stylesheet' type='text/css' href='css.css'/>";
        $html = "<html><head>$css</head><body>$html</body></html>";
        
        return $html;
    }
    
    function makeHTML($data, $from, $to = null, $type = "instant") {
        $html = "";
       
        $html .= "<table border=0 cellspacing=0 cellpadding=6>";
                
        switch ($type) {
            case "period" :
                $title = "La situation du ".date("d.m.Y",strtotime($from))." au ".date("d.m.y",strtotime($to));
            break;
            case "instant" :
                $title = "La situation au ".date("d.m.Y",strtotime($from));
            break;
            default : 
                $title = "";
            break;
        }
                
        $year = date("Y",strtotime($from));
        $html .= "<tr><td colspan='10'><h2>".$title."</h2></td>";
        $html .= "<td><a href='../../index.html#id_$year'>Retour</a></td></tr>"; 
        
        $html .= "<tr>";
        $html .= "<td height=40>&nbsp;</td>";
        $html .= "<td align='center' style='border-right:1px black solid' colspan='2' width=150 class='stdHeader'><b>OUEST</b></td>";
        $html .= "<td align='center' style='border-right:1px black solid' colspan='2' width=150 class='stdHeader'><b>CENTRE</b></td>";
        $html .= "<td align='center' style='border-right:1px black solid' colspan='2' width=150 class='stdHeader'><b>NORD</b></td>";
        $html .= "<td align='center' style='border-right:1px black solid' colspan='2' width=150 class='stdHeader'><b>EST</b></td>";
        $html .= "<td align='center' colspan='2' width=150 class='cantonHeader'><b>CANTON</b></td>";
        $html .= "</tr>";
                
        $tables = array();
        
        if ($type == "period") {
            $txt = "Nombre de lits C annoncs";
        } else {
            $txt = "Nombre de lits C disponibles";
        }
        $tables[$txt]["values"] = $data["LC"];
        $subtables = array();
        $subtables["Dont longs sjours"]["values"] = $data["LC_DLS"];
        $subtables["Dont sjours polyvalents"]["values"] = $data["LC_DSP"];
        $subtables["Dont courts sjours"]["values"] = $data["LC_DCS"];
        //if ($type == "period") {
        //    $subtables["Dont courts sjours conventionns (planning)"]["values"] = $data["LC_DPL"];
        //}
        $tables[$txt]["subtables"] = $subtables;
        $recu_encours = ($type == "period" ? "reues" : "en cours");
        $tables["Nombre de demandes $recu_encours priorit 1"]["values"] = $data["DECU"];
        $subtables = array();
        $subtables["Dont demandes de long sjour (y.c. observation)"]["values"] = $data["DECU_SO"];
        $subtables["Dont demandes de court sjour (urgent / non-urgent)"]["values"] = $data["DECU_CS"];
        $subtables["Dont demandes de court sjour conventionns (planning)"]["values"] = $data["DECU_PL"];
        $subtables["Dont demandes de lit B"]["values"] = $data["DECU_LB"];
        $subtables["Dont demandes de retour  domicile"]["values"] = $data["DECU_RD"];
        $subtables["Dont autres demandes ou type non-spcifi"]["values"] = $data["DECU_NS"];
        $tables["Nombre de demandes $recu_encours priorit 1"]["subtables"] = $subtables;
        
        $tables["Nombre de demandes $recu_encours non prioritaires"]["values"] = $data["DECNU"];
        $subtables = array();
        $subtables["Dont demandes de long sjour (y.c. observation)"]["values"] = $data["DECNU_SO"];
        $subtables["Dont demandes de court sjour (urgent / non-urgent)"]["values"] = $data["DECNU_CS"];
        $subtables["Dont demandes de court sjour conventionns (planning)"]["values"] = $data["DECNU_PL"];
        $subtables["Dont demandes de lit B"]["values"] = $data["DECNU_LB"];
        $subtables["Dont demandes de retour  domicile"]["values"] = $data["DECNU_RD"];
        $subtables["Dont autres demandes ou type non-spcifi"]["values"] = $data["DECNU_NS"];
        $tables["Nombre de demandes $recu_encours non prioritaires"]["subtables"] = $subtables;
        
        if ($type == "period") {
            $tables["Nombre de lits C attribus"]["values"] = $data["LCA"];
            $subtables = array(); 
            $subtables["Dont longs sjours"]["values"] = $data["LCA_DLS"];
            $subtables["Dont sjours d'observation"]["values"] = $data["LCA_DSO"];
            $subtables["Dont courts sjours"]["values"] = $data["LCA_DCS"];
            
            //$subtables["Dont sjour non spcifi"]["values"] = $data["LCA_NS"];
            $tables["Nombre de lits C attribus"]["subtables"] = $subtables;
            $tables["Courts sjours conventionns (planning)"]["values"] = $data["LCA_DPL"];
            $tables["Courts sjours conventionns (planning)"]["subtables"] = array();
        }
        
        foreach ($tables as $k => $table) {
            
            $k = "<b>".$k."</b>";
            $align = "left";
            $html .= $this->makeLine($k, $table["values"], 'left');
            
            $cpt = 0;
            foreach ($table["subtables"] as $subk => $subtables) {
                $subk = "<i>".$subk."</i>";
                $align = "right";
                $html .= $this->makeLine($subk, $subtables["values"], $cpt, 'right');
                $cpt ++;
            }
        }
        
        $html .= "</table>";
        
        $css = "<link rel='stylesheet' type='text/css' href='../../css.css'/>";
        $html = "<html><head>$css</head><body>$html</body></html>";
        
        return $html;
    }
    
    function makeLine($name, $values, $l = 0, $align = 'left') {
        
        $html  = "";
        
        if ($align == "left") {
            $class = "titleLine";
            $cantonClass = "cantonTitleLine";
        } else {
            if (fmod($l,2) == 0) {
                $class = "altern1";
                $cantonClass = "cantonTitleLineAltern1";
            } else {
                $class = "altern2";
                $cantonClass = "cantonTitleLineAltern2";
            }
        }
        
        $html .= "<tr><td class='$class' align='$align'>".$name."</td>";
        $html .= "<td align='right' class='$class'>".$values["OUEST"][0]."</td>";
        $html .= "<td align='right' style='border-right:1px black solid' class='$class'>".number_format($values["OUEST"][1],2,".",null)."%</td>";
        $html .= "<td align='right' class='$class'>".$values["CENTRE"][0]."</td>";
        $html .= "<td align='right' style='border-right:1px black solid' class='$class'>".number_format($values["CENTRE"][1],2,".",null)."%</td>";
        $html .= "<td align='right' class='$class'>".$values["NORD"][0]."</td>";
        $html .= "<td align='right' style='border-right:1px black solid' class='$class'>".number_format($values["NORD"][1],2,".",null)."%</td>";
        $html .= "<td align='right' class='$class'>".$values["EST"][0]."</td>";
        $html .= "<td align='right' style='border-right:1px black solid' class='$class'>".number_format($values["EST"][1],2,".",null)."%</td>";
        $html .= "<td align='right' class='$cantonClass'>".$values["CANTON"][0]."</td>";
        $html .= "<td align='right' class='$cantonClass'>".number_format($values["CANTON"][1],2,".",null)."%</td>";
        $html .= "</tr>";    
        
        return $html;
    }
}

?>