<?php
/**
* Sauvegarde sur ficher pdf du planning des courts sjours
* @package accessoires
* @author cjd jdu
*/
/**
*/ 
require("entete.phtml");

$ini = new briocheIni();

require_once("$ini->classDir/fpdf/fpdf.php");
require_once("$ini->classDir/phpmailer/class.phpmailer.php");

$linkBrioche = mysql_pconnect($ini->briocheHote, $ini->briocheUser, $ini->briochePw);
$result = mysql_select_db($ini->briocheBd, $linkBrioche);

/**
* Sauvegarde sur fichier pdf du planning des courts sjours
* Un fichier pdf est cr (bibliothque fpdf) et est envoy par courriel  une ou plusieurs adresses
* Ce fichier peut tre appel directement dans une crontab
* @package accessoires
* @author cjd jdu
*/
class PDF extends FPDF
{

  /**
  * Construction de l'en-tte
  */
  function Header() {
    global $ini;
  	$brio = $ini->nomBrio;
  	$this->SetFont('Arial','IB',10);
  	$today = getdate();
  	foreach ($today as $key => $day) if (strlen($day) == 1) $today[$key] = "0" . $day;
    $now = $today['mday']." / ".$today['mon']." / ".$today['year']." - ".$today['hours']." : ".$today['minutes']." : ".$today['seconds'];
  	$this->Cell(100,5,$brio,0,0);
  	$this->Cell(0,5,$now,0,1,"R");
  }

  /**
  * Construction du pied de Page
  */
  function Footer() {

  	$this->SetY(-15);
    $this->SetFont('Arial','I',10);
    $this->Cell(0,5,'Page '.$this->PageNo() . " / {nb}",0,0,'C');
  }
}

class backupEMSpdf {

    var $_pdf;
    var $_ini;
    var $_ems;
    
    function __construct($ems = null) {
        
        $this->_pdf = new PDF();
        $this->_ini = new briocheIni();
        if (is_null($ems)) $this->_ems = $this->getEMS();
        else $this->_ems[] = $ems;
    }
    
    /**
    * construit le fichier pdf
    */
    function build() {

        $this->_pdf->AliasNbPages();
        $this->_pdf->SetFont('Arial','',10);
        $this->_pdf->SetFillColor(255,255,255);
        
        $this->_pdf->AddPage('landscape');
        $this->addLegend();
        
        $EMSs = $this->_ems;
        foreach ($EMSs as $EMS) {
            for ($d=0;$d<12;$d++) { 
                $m = date("m")+$d;
                $day = getdate(mktime(0, 0, 0, $m, 1, date("Y")));
                $this->_pdf->AddPage('landscape');
                $this->_pdf->Cell(50,5,$EMS['name'],1,1,'center');
                $this->_pdf->Cell(0,5,'',0,1);
                $this->getCalendar($EMS['id'],$day);
            }
        }
    }
    
    /**
    * renvoie un tableau des EMS pratiquant le court sjour planning contenant, pour chaque entre, 
    * un tableau associatif dont les cls sont 'id' (numro de l'tablissement)
    * et 'name' (nom de d'tablissement
    * @return array
    */
    function getEMS() {
    
      $query = "SELECT noet, nomet, emails_pdf FROM etablissements WHERE courplan = -1";
      $result = mysql_query($query);
      $i = 0;
      $EMS = array();
      while ($EMSs = mysql_fetch_assoc($result)) {
    	  	$EMS[$i]['id'] = $EMSs['noet'];
    	  	$EMS[$i]['name'] = $EMSs['nomet'];
    	  	$EMS[$i]['emails_pdf'] = $EMSs['emails_pdf'];
    	  	$i++;
      }
      return $EMS;
    }
    
    /**
    * renvoie la liste des chambres et des lits d'un EMS
    * pour chaque entre du tableau, un tableau associatif dont les cls sont 'chambre' (numro de chambre), 'lit'
    * (numro de lit), 'descr' (description associe)
    * @param int EMS le numro d'tablissement
    * @return array
    */
    function getRoomsAndBeds($EMS) {
      
      $query = "SELECT chambre, lit, debut, fin, descr FROM litscourtsejour WHERE etabl = $EMS";
      $result = mysql_query($query);
      $i = 0;
      while ($chlits = mysql_fetch_assoc($result)) {
        $chlit[$i]['chambre'] = $chlits['chambre'];
    	$chlit[$i]['lit'] = $chlits['lit'];
    	$chlit[$i]['descr'] = $chlits['descr'];
    	$chlit[$i]['debut'] = $chlits['debut'];
    	$chlit[$i]['fin'] = $chlits['fin'];
    	$i++;
      }
      return $chlit;
    }
    
    /**
    * construction du titre
    * @param array day une date au format revoy par la fonction getdate()
    */
    function getHeader($day) {
      
      $mois = array('Janvier','Fvrier','Mars','Avril','Mai','Juin','Juillet','Aot','Septembre','Octobre','Novembre','Dcembre');
      
      $this_month = $day['mon'];
      $this_year = $day['year'];
      $num_days = cal_days_in_month(CAL_GREGORIAN,$this_month,$this_year);
      
      $this->_pdf->Cell(60,5);
      $this->_pdf->Cell(20,5,$mois[$this_month-1] . " " . $this_year,"L",1);
      $this->_pdf->Cell(30,5);
      $this->_pdf->Cell(10,5,"Ch.",0,0);
      $this->_pdf->Cell(20,5,"Lit",0,0);
        
      for ($i=1;$i<=$num_days;$i++) {
      	$day = getdate(mktime(0,0,0,$this_month,$i,$this_year));
      	$w_day = $day['wday'];
      	if ($w_day == 0) $this->_pdf->SetFillColor(230,230,230);
      	else $this->_pdf->SetFillColor(255,255,255);
      	$this->_pdf->Cell(6,5,$i,"LR",0,'',1);
      }
    }
    
    /**
    * renvoie l'occupation pour un lit dtermin
    * @return array le tableau des sjours associs  ce lit
    */
    function getOccupation($EMS,$chambre,$lit) {
    
      $query = "SELECT calendrier.noev, calendrier.nodoss, calendrier.debut, calendrier.fin, usagers.sexe, calendrier.sortie_confirmee, calendrier.horsStats, calendrier.datedecision, calendrier.urgent, usagers.nom, usagers.prenom FROM calendrier, dossiers, usagers WHERE calendrier.nodoss = dossiers.nodoss AND dossiers.nous = usagers.nous AND calendrier.etablissement = $EMS AND calendrier.chambre = $chambre AND calendrier.lit = $lit AND calendrier.actif = 1";
      $result = mysql_query($query);
        
      $i = 0;
      $occup = array();
      while ($occups = mysql_fetch_assoc($result)) {
      	$occup[$i]['noev'] = $occups['noev'];
        $occup[$i]['nodoss'] = $occups['nodoss'];
    	$occup[$i]['nom'] = $occups['nom'] . " " . $occups['prenom'];
    	$occup[$i]['debut'] = $occups['debut'];
    	$occup[$i]['fin'] = $occups['fin'];
    	$occup[$i]['sexe'] = $occups['sexe'];
    	$occup[$i]['sortie_confirmee'] = $occups['sortie_confirmee'];
    	$occup[$i]['urgent'] = $occups['urgent'];
    	$occup[$i]['type'] = 'occ';
    	$occup[$i]['hors_stats'] = $occups['horsStats'];
    	$occup[$i]['datedecision'] = $occups['datedecision'];	 
    	$i++;
      }
      return $occup;
    }
    
    /**
    * renvoie un tableau des sjours bloqus (non attribus  un dossier particulier) pour un lit donn
    * @return array
    */
    function getReservation($EMS,$chambre,$lit) {
    
      $query = "SELECT calendrier.noev, calendrier.nodoss, calendrier.debut, calendrier.fin, calendrier.sexe, calendrier.sortie_confirmee, calendrier.urgent, calendrier.horsStats, calendrier.datedecision FROM calendrier WHERE calendrier.nodoss = -999 AND calendrier.etablissement = $EMS AND calendrier.chambre = $chambre AND calendrier.lit = $lit AND calendrier.actif = 1";
      $result = mysql_query($query);
        
      $i = 0;
      $reserv = array();
      while ($reservs = mysql_fetch_assoc($result)) {
      	$reserv[$i]['noev'] = $reservs['noev'];
        $reserv[$i]['nodoss'] = $reservs['nodoss'];
    	$reserv[$i]['nom'] = '';
    	$reserv[$i]['debut'] = $reservs['debut'];
    	$reserv[$i]['fin'] = $reservs['fin'];
    	$reserv[$i]['sexe'] = $reservs['sexe'];
    	$reserv[$i]['sortie_confirmee'] = $reservs['sortie_confirmee'];
    	$reserv[$i]['urgent'] = $reservs['urgent'];
    	$reserv[$i]['type'] = 'res';
    	$reserv[$i]['hors_stats'] = $reservs['horsStats'];
    	$reserv[$i]['datedecision'] = $reservs['datedecision'];
    	$i++;
      }
      return $reserv;
    }
    
    /**
    * un jour donn se trouve  l'intrieur d'une priode ?
    * @param string debut (format amricain) le dbut de la priode
    * @param string fin (format amricain) la fin de la priode
    * @param string jour le jour  tester
    * @return boolean
    */
    function dayInPeriod($debut,$fin,$jour) {
    
    	$d = explode('-',$debut);
    	$dt = mktime(0,0,0,$d[1],$d[2],$d[0]);
    	
    	$f = explode('-',$fin);
    	$ft = mktime(0,0,0,$f[1],$f[2],$f[0]);
    	
    	$j = explode('-',$jour);
    	$jt = mktime(0,0,0,$j[1],$j[2],$j[0]);
    	
    	if ($jt >= $dt && $jt < $ft) return true; else return false;	
    }
    
    /**
    * Y a-t-il un changement de lit en cours de sjour ?
    * @param int item le numro d'vnement correspondant au sjour test
    * @param int nodoss le numro de dossier
    * @param string debut | fin le test se fait-il sur le dbut ou la fin du sjour considr ?
    * @return boolean
    */
    function change_cs($item,$nodoss,$quand = "fin") {
      	
      if ($quand == 'fin') {	
      	$autre_cs = "SELECT * FROM calendrier WHERE nodoss = $nodoss AND actif = 1 AND csprec = $item";
      	$autre_cs = mysql_query($autre_cs);
        if (mysql_num_rows($autre_cs)) return true;
      }
      if ($quand == 'debut') {
      	$autre_cs = "SELECT csprec FROM calendrier WHERE noev = $item AND actif = 1";
        $autre_cs = mysql_query($autre_cs);
        $csprec = mysql_fetch_assoc($autre_cs);
        if ($csprec['csprec']) return true; 
      }
      return false;
    }
    
    /**
    * construction d'une ligne du planning pour un mois et un lit
    * @param int ems le numro d'tablissement
    * @param int chambre le numro de la chambre
    * @param int lit le numro du lit
    * @param array day une date (format getdate())
    */
    function getCalendarInfo($EMS,$chambre,$lit,$day,$debut,$fin) {
          
      $this_month = $day['mon'];
      $this_year = $day['year'];
      $num_days = cal_days_in_month(CAL_GREGORIAN,$this_month,$this_year);
    
      $occupation = $this->getOccupation($EMS,$chambre,$lit);
      $reservation = $this->getReservation($EMS,$chambre,$lit);
     
      $full_array = array_merge($occupation,$reservation);
         
      $dernier = 0;
      
      if ($debut != '' && $this->dayInPeriod("$this_year-$this_month-1", "$this_year-$this_month-$num_days", $debut)) {
        $date_debut = explode('-',$debut);
    	$date_debut = mktime(0,0,0,$date_debut[1],$date_debut[2],$date_debut[0]);
    	$debut_mois = mktime(0,0,0,$this_month,1,$this_year);
    	$start_day = date('d',$date_debut) - date('d',$debut_mois) + 1;
        $this->_pdf->Cell(6*($start_day-1),5,'',"LT");
      } else $start_day = 1;
      
      if ($fin != '' && $this->dayInPeriod("$this_year-$this_month-1", "$this_year-$this_month-$num_days", $fin)) {
        $date_fin = explode('-',$fin);
    	$date_fin = mktime(0,0,0,$date_fin[1],$date_fin[2],$date_fin[0]);
    	$fin_mois = mktime(0,0,0,$this_month,$num_days,$this_year);
    	$end_days = date('d',$fin_mois) - date('d',$date_fin);
    	$num_days = date('d',$date_fin);
      }
    
      for ($i=$start_day;$i<=$num_days;$i++) {  // for each day
      	
      	$size = 1;
      	$color = array(255,255,255);
      	$end_text = '';
      	$start_text = '';
      	$text = '';
      	$occ = false;
      	$faux_dernier = 0;
      	
      	$hach = false;
      	$drawVerticalPattern = false;
        if (isset($full_array[0])) {
          foreach ($full_array as $key => $cs) {
          	while ($this->dayInPeriod($cs['debut'],$cs['fin'],"$this_year-$this_month-$i")) {
          	  if ($cs['debut'] == date("Y-m-d",mktime(0,0,0,$this_month,$i,$this_year))) $faux_dernier = 1;
          	  if ($cs['type'] == 'occ') {
          	  	if ($cs['urgent'] == 1) {
          	  	  if ($cs['sexe'] == 'F') {
          	  	    $color = array(255,181,181);
          	  	  } elseif ($cs['sexe'] == 'M') {
          	  	  	$color = array(178,178,255);
          	  	  }	
          	  	} else {
          	  	  if ($cs['sexe'] == 'F') {
          	  	  	$color = array(230,113,086);
          	  	  } elseif ($cs['sexe'] == 'M') {
          	  	  	$color = array(093,134,215);
          	  	  }
          	  	}
          	  } elseif ($cs['type'] == 'res') {
          	  	if ($cs['urgent'] == 1) {
          	  	  if ($cs['sexe'] == 'F') {
          	  	  	$color = array(255,173,249);
          	  	  } elseif ($cs['sexe'] == 'M') {
          	  	  	$color = array(183,255,253);
          	  	  } else {
          	  	  	$color = array(170,255,170);
          	  	  }
          	  	} else {
          	  	  if ($cs['sexe'] == 'F') {
          	  	  	$color = array(255,179,141);
          	  	  } elseif ($cs['sexe'] == 'M') {
          	  	  	$color = array(102,255,204);
          	  	  } else {
          	  	  	$color = array(165,224,000);
          	  	  }
          	  	}
          	  }
          	  if ($cs['sortie_confirmee'] == 1) $end_text = "]"; else $end_text = "?";
          	  if ($this->change_cs($cs['noev'],$cs['nodoss'],'debut')) $text = "< ";
          	  if ($this->change_cs($cs['noev'],$cs['nodoss'],'fin')) $end_text = ">";
          	  $size++;
          	  $i++;
          	  $occ = true;
              $hach = $cs['hors_stats'];
	          	if ($cs['datedecision'] != '') {
	          	  $dateStartOfCurrentMonth = mktime(0, 0, 0, $this_month , 0, $this_year);
	          	  $dateEndOfCurrentMonth = mktime(0, 0, 0, $this_month + 1, 0, $this_year) - 43200;
	          	  $dateDecision = strtotime($cs['datedecision']);
	    	      $datePeriodBegins = strtotime($cs['debut']);
	    	      $drawVerticalPattern = $dateDecision < $dateEndOfCurrentMonth;
	          	  $verticalPatternStartAtDay = $dateStartOfCurrentMonth > $dateDecision ? 0 : date('d', $dateDecision) - date('d', $datePeriodBegins);
	          	} else {
	          		$drawVerticalPattern = false;
	          	}
          	}
          	
          	
          	if ($occ) {
          	  $start_text = "[";
          	  if ($cs['nodoss'] == -999) $text = '?';
              else $text .= $cs['nodoss'] . ' - ' . $cs['nom'];
          	  $size--;
          	  break;
          	}
          }
        }
        
        $this->_pdf->SetFillColor($color[0],$color[1],$color[2]);
        
        if ($dernier == 1) {
          if ($faux_dernier == 1) $this->_pdf->Cell(3,5,'',"LT",0,'',0);
          else $this->_pdf->Cell(3,5,$start_text,"LT",0,'',1);
          $dernier = 0;
        }
        
        if ($i > $num_days)
        	$size = $size - ($i - $num_days);
    
        if ($size > 0) {
          $x_start = $this->_pdf->GetX();
          $y_start = $this->_pdf->GetY();
          $this->_pdf->Cell(6*($size),5,$text,"LT",0,'',1);
          if ($hach) {
            for ($step = 0; $step < $size; $step++) {
              $x = $x_start + $step * 6;
              $y = $y_start;
              $this->_pdf->Image($this->_ini->classDir."/fpdf/img/hach.png",$x,$y,6,5);
            }
          }
          if ($drawVerticalPattern) {
            for ($step = $verticalPatternStartAtDay; $step < $size; $step++) {
              $x = $x_start + 6 * $step;
              $y = $y_start;
              $this->_pdf->Image($this->_ini->classDir."/fpdf/img/hachvert.png",$x,$y,6,5);
            }
          }
        }
        
        if ($i > $num_days) $this->_pdf->Cell(6,5,">>","LT",0,'',1);
        
        if ($occ && $i <= $num_days) {
          $this->_pdf->Cell(3,5,$end_text,"LT",0,'',1);    
          $dernier = 1;
        }
      }
      
      if (isset($end_days)) {
        $this->_pdf->Cell(6*$end_days,5,"","LT");
      }
    }
    
    /**
    * construction du planning pour un tablissement et un mois
    * @param int ems le numro d'tablissement
    * @param array day une date (format getdate())
    */
    function getCalendar($EMS,$day) {
      
      $chlits = $this->getRoomsAndBeds($EMS);
      $chambre_old = '';
      
      $this->getHeader($day);
      $this->_pdf->Ln();
    	    
      foreach ($chlits as $chlit) {
      	
      	if ($chambre_old != $chlit['chambre']) $border = 'T'; else $border = '';
      	$chambre_old = $chlit['chambre'];
      	
      	$this->_pdf->SetDrawColor(0,0,0);
        $this->_pdf->SetFont('Arial','B',10);
        $this->_pdf->Cell(30,5);
      	$this->_pdf->Cell(10,5,$chlit['chambre'],$border,0);
      	$this->_pdf->SetFont('Arial','',10);
      	$this->_pdf->Cell(10,5,$chlit['lit'],$border,0);
      	$this->_pdf->Cell(10,5,$chlit['descr'],$border,0);
      	  	
      	$this->getCalendarInfo($EMS,$chlit['chambre'],$chlit['lit'],$day,$chlit['debut'],$chlit['fin']);
      	$this->_pdf->ln();
      }
    }
    
    /**
    * construction de la lgende
    */
    function addLegend() {
      
      $this->_pdf->SetFont('Arial','',40);
      $this->_pdf->SetFillColor(255,255,255);
      $this->_pdf->Cell(0,40,'Sauvegarde du Planning des Courts Sjour',0,1);
      
      $this->_pdf->SetFont('Arial','',30);
      $this->_pdf->Cell(0,10,'Lgende :','B',1);
    	
      $this->_pdf->Cell(0,10,'','',1);
      $this->_pdf->SetFont('Arial','',10);
      
      $this->legend(255,181,181,'Urgent : femme');
      $this->legend(230,113,086,'Non urgent : femme');
      $this->legend(255,255,255,'Date de sortie confirme',']');
      $this->_pdf->ln();$this->_pdf->ln();
      $this->legend(178,178,255,'Urgent : homme');
      $this->legend(093,134,215,'Non urgent : homme');
      $this->legend(255,255,255,'Date de sortie non confirme','?');
      $this->_pdf->ln();$this->_pdf->ln();
      $this->legend(255,173,249,'Urgent : bloqu pour une femme');
      $this->legend(255,179,141,'Non urgent : bloqu pour une femme');
      $this->legend(255,255,255,'Le court sjour se poursuit','>>');
      $this->_pdf->ln();$this->_pdf->ln();
      $this->legend(183,255,253,'Urgent : bloqu pour une homme');
      $this->legend(102,255,204,'Non urgent : bloqu pour une homme');
      $this->legend(255,255,255,'Changement en cours de sjour (fin)','>');
      $this->_pdf->ln();$this->_pdf->ln();
      $this->legend(170,255,170,'Urgent : bloqu');
      $this->legend(165,224,000,'Non urgent : bloqu');
      $this->legend(255,255,255,'Changement en cours de sjour (dbut)','<');
      $this->_pdf->ln();$this->_pdf->ln();
      $this->legend(255,255,255,'Sjour hors statistiques','',$this->_ini->classDir."/fpdf/img/hach.jpg");
      $this->legend(255,255,255,'Court sjour transform en long sjour','',$this->_ini->classDir."/fpdf/img/hachvert.jpg");
      $this->_pdf->ln();$this->_pdf->ln();
      $this->_pdf->SetFont('Arial','B',10);
      $this->_pdf->Cell(0,6,"Plages de temps blanches :",0,1);
      $this->_pdf->SetFont('Arial','',10);
      $this->_pdf->Cell(0,6,"indique les priodes pour lesquelles un lit est indisponible, aucun sjour ne peut y tre attribu.",0,1);
      $this->_pdf->Cell(0,6,"Le lit disparat du planning les mois o il n'est pas disponible.",0,1);
    
      $this->_pdf->SetFont('Arial','',10);
      $this->_pdf->SetFillColor(255,255,255);
    }
    
    /**
    * construction d'un item de la lgende
    */
    function legend($R,$G,$B,$text1, $text2 = '', $image = '') {
      
      $this->_pdf->SetFillColor($R,$G,$B);
      
      $this->_pdf->Cell(70,8,$text1,0,0);
      
      if ($image != '') {
        $this->_pdf->Image($image,$this->_pdf->GetX(),$this->_pdf->GetY(),8,8);
        $this->_pdf->Cell(8,8);
      } else {
        $this->_pdf->Cell(8,8,$text2,0,0,'',1);
      }
      $this->_pdf->Cell(10,8);
    }
    
}

class pdfMail {

	/**
	 * @var PHPMailer
	 */    
	var $_mail;
    var $_ini;
    
    function __construct() {
        
        $this->_ini = new briocheIni();
        $this->_mail = new PHPMailer();
        $this->_mail->SetLanguage("fr");
        $this->_mail->From = $this->_ini->adresseAdministrateur;
        $this->_mail->FromName = "Brioche-Web " . $this->_ini->nomBrio;
        $this->_mail->WordWrap = 50;
        $this->_mail->IsHTML(true);
        
        if ($this->_ini->typeMailer == 'smtp') {
            $this->_mail->IsSMTP();
            if (!$this->_ini->hoteMailer) {
                print "Veuillez complter le paramtre hoteMailer dans briocheIni.inc.\n";
                exit;
            }
            $this->_mail->Host = $this->_ini->hoteMailer;
            $this->_mail->SMTPAuth = false;
            
        } elseif ($this->_ini->typeMailer == 'sendmail') {
            
            $this->_mail->IsSendmail();
            $this->_mail->Sendmail = "/usr/sbin/sendmail -t";
            
        } else {
            
            print "Le paramtre typeMailer n'est pas correctement configur dans briocheIni.inc.\n";
        }
    }
    
    function setContent($subject, $body) {
     
        $this->_mail->Subject = $subject;
        $this->_mail->Body    = $body;
        $this->_mail->AltBody = strip_tags($body);
    }
    
    function setAttachment($filename) {
        
        $this->_mail->ClearAttachments();
        $this->_mail->AddAttachment($filename);
    }
    
    function setAdresses($emails) {
        
        $this->_mail->ClearAddresses();
        $emails = explode(";",$emails);

        foreach ($emails as $email) {
          $this->_mail->AddAddress($email);  
        }
    }
    
    function send() {
     
        if(!$this->_mail->Send()) {
            echo "Message could not be sent.\n";
            echo "Mailer Error: " . $this->_mail->ErrorInfo . "\n";
            exit;
        }
        
        echo "Message has been sent.\n";   
    }
}

function removeChars($string) {

    $a = ". '??"; 
    $b = "___aaaaaaaceeeeiiiidnoooooouuuuybsaaaaaaaceeeeiiiidnoooooouuuyybyrr"; 
    $string = strtr($string, $a, $b); 
    $string = strtoupper($string);    
    return $string;
}

$now = date("Y_m_d_H_i_s");
$filebase = $ini->repSauvegarde . "/";
$pdfs = array();

$backup = new backupEMSpdf();
$backup->build();
$pdfs[0]['pdf'] = $backup->_pdf;
$pdfs[0]['emails'] = $ini->planningEmails;
$pdfs[0]['filename'] = $filebase . "backup_" . $ini->nomBrio . "_" . $now . ".pdf";
$pdfs[0]['content'] = array('subject' => "Planning Lits - PDF", 'body' => "Planning Lits - <b>PDF</b>");

foreach ($backup->_ems as $ems) {
    if ($ems['emails_pdf'] != '') {
        $backup = new backupEMSpdf($ems);
        $backup->build();
        $ems_name = removeChars($ems['name']);
        $filename = $filebase . "Brioche-Web_Courts_sejours_" . $ems_name . "_" . $now . ".pdf";
        $pdfs[] = array('pdf' => $backup->_pdf, 'emails' => $ems['emails_pdf'], 'filename' => $filename,
                        'content' => array('subject' => "Brioche-Web, " . $ems['name'] . " : planning des courts sjours prvus au " . date("d-m-Y"), 
                                           'body' => "Vous trouverez ci-joint,  titre informatif, le planning des courts sjours prvus pour " . $ems['name'] . "  la date du " . date("d-m-Y") . ".<br/><br/>En cas d'interruption de la rception quotidienne de ces e-mails, merci de le signaler au BRIO (auprs de la personne responsable de l'application Brioche web).<br/><br/>Brioche-Web " . $ini->nomBrio));
    }
}
$encoding = ini_get("mbstring.internal_encoding");
if ($encoding != "ISO-8859-1") ini_set("mbstring.internal_encoding", "ISO-8859-1");

$mail = new pdfMail();
foreach ($pdfs as $pdf) {
    $pdf['pdf']->Output($pdf['filename']); 
    $mail->setContent($pdf['content']['subject'], $pdf['content']['body']);
    $mail->setAdresses($pdf['emails']);
    $mail->setAttachment($pdf['filename']);
    $mail->send();
}

ini_set("mbstring.internal_encoding", $encoding);

?>
