<?php
  // $Id: annonceLit.inc,v 1.1.1.1 2010-10-11 22:25:53 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Annonce de lit
* @package formulaires
*/
/**
* Annonce de lit de BriocheWeb
* Formulaire permettant d'annoncer un lit, aussi bien par les collaborateurs BRIOS que par les tablissements
* @package formulaires
* @author ob tnh
*/
class annonceLit extends cadronglet {
   /**
   * l'objet ensTableBrioche contenant les donnes de l'annonce
   * @var object ensTableBrioche
   */
   var $rs;
   /**
   * le numro de l'annonce
   * @var int
   */
   var $item;
   /**
   * un objet options, encapsulant les options transmises
   * @var object optionsBrioche
   */
   var $options;
   /**
   * un objet options, encapsulant les options  transmettre
   * @var object futuroptions
   */
   var $futuroptions;
   /**
   * la valeur principale du champ "action" du formulaire
   */
   var $action;
  
   
   /**
   * @param string largeur la largeur du formulaire (pixel ou %)
   * @param string grise la couleur correspondant au "gris"
   * @param string actif cf variable de classe action
   * @param string fondpage la couleur de fond de la page web
   * @param string sessionid l'identifiant de session
   * @param int item cf. variable de classe
   * @param string options la chaine de caractres correspondant  l'objet $this->option
   * @param array recup le tableau des champs de formulaire posts, pour rcupration si pas de lecture dans la bd
   * @param int ditem un numro de dossier -- permet de se souvenir d'un numro de dossier lors du passage entre 
   * le dtail de l'annonce et la liste des lits dans le contexte de l'attribution d'un lit
   */
   function annonceLit($largeur, $grise, $actif, $fondpage, $sessionid, $item = 0, $options = 0, $recup=0, $ditem=0){
     global $fdosbrioche;
     global $imagesdir;
     
     $ini = new briocheIni();
     $autspec[0] = $ini->autSpec[0];
     if (! $this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid, $autspec)) return;
      
     $this->action = $actif;
     $future_action = $this->action + 100;
     $this->options = new optionsBrioche($options);
     $this->futuroptions = new optionsBrioche($options);
     $this->item = $item;
     $this->rs = new ensTableBrioche("annoncelit", "nolit = $this->item", "*", "", $this->idsession, 0, 0, false, $autspec);
     // Vrification des droits
     $annEms = false;
     // Pas d'autorisation principale (autReq) mais autorisation spcifique => demande par web
     if((! $this->verifAut($ini->autReq, $this->autorisations)) && $this->verifAut($ini->autSpec[0], $this->autorisations)){
       $annEms = true;
     }
     if ($annEms || $this->action == 5002){ //dans le cas d'une annonce par EMS ou de la validation, on travaille sur table accessoire
       $this->rs->setTable("avalider");
     }  

     // L'utilisateur a-t-il le droit d'diter les annonces de lits
     $edition_autorisee = $this->verifAut($ini->autSpec[3], $this->autorisations) || $this->verifAut($ini->autSpec[0], $this->autorisations);
     // flag pour indiquer si on doit rendre ditable les champs du formulaire
     $non_editable = false;
     if ($this->options->getOption("EDITABLE") == 0 || !$edition_autorisee) {
       // si on vient de la consultation des lits et si la sauvegarde s'est bien passe ou si on n'a pas le droit d'dition,
       // les champs sont dsactivs
       $non_editable = true;
     }
     //Nouvel item
     if ($this->item == -999){
       $this->item = $this->rs->creeNouveau("nolit");
     }
     //Validation annonces EMS
     if ($this->action == 5002){
       $this->rs->setWhere("1");
       $this->item = $this->rs->getPremier("nolit"); 
       $this->rs->setWhere("nolit = $this->item");
     }
     //Vrification de l'item demand
     if (! $this->rs->checkItem($this->item, "nolit")){
       if ($this->action == 5001) {
         $al = new Alerte("Lit N $this->item inexistant !");
         $al->imprime();
       }
       if ($this->action == 5002){
         $opt = new optionsBrioche();
         $opt->setOption("VAL_DEM", 9);
         $optc = $opt->getChaine();
         $al = new Alerte("Toutes les annonces ont t valides ! ");
         $al->imprime();
         print "<SCRIPT LANGUAGE=\"JavaScript\">document.location='$fdosbrioche?action=0&sessionid=$this->idsession" .
               "&options=$optc';</SCRIPT>";
         $vx = new verrouAn($this->idsession, "annonces");
         $vx->rouvre();
       }
     }
    
    
    //cette annonce
    $ann = $this->rs->getTableau($recup);
    
    $annoncelit = "";
    if (isset($ann[0])){
      $annoncelit = $ann[0];
    }
    
    // Dessin des onglets

    $tabbande = array("", "", "", "N " . $this->item, "");
    $this->addOnglet("Annonce de lit", $tabbande, "#FDDB00", $this->action, 120, "");
    $this->colmateOnglets();

    //ajout du contenu spcifique
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fdosbrioche, "post");
    $of->addLigne(0.5);
    $c = new TPanel(3);
    $x = new Label("Etablissement :&nbsp;");
    $c->addChamp($x);
    $labellise = false;
    if ($annEms){ //Annonce de lit par EMS
      $non_editable = false; //Une annonce par EMS est toujours ditable
      $ems = new EnsTableBrioche("etablautorises", "etablautorises.idut = $this->nout and etablautorises.priv = \"ems\"", 
                                 "etablissements.nomet, etablissements.noet, etablissements.psychoger, ".
                                 "etablissements.ger, etablissements.psy, etablissements.litsd, etablissements.actif",
                                 "etablissements.actif, " .
                                 "etablissements.groupepriorite, etablissements.nomet", 
                                 $this->idsession, "etablissements", "etablautorises.etabl = etablissements.noet", false, $autspec);
      $tabems = $ems->getTableau();
      if (!isset($etablissement)) {
        $etablissement = $tabems[0]->noet;
      }
      if (! $etablissement) {
        $al = new Alerte("Aucun tablissement ne vous a t attribu... Vous ne pourrez donc pas annoncer de lit." .
                         "Veuillez prendre contact avec l\'administrateur");
        $al->imprime();                 
      }
      $labellise = true;    
    }
    else {
      $where = ($this->options->getOption("ANN_LIT") == 1 ? " AND actif = -1" : "");
      $ems = new EnsTableBrioche("etablissements", "(litsc = -1 or litsd = -1) and autbrio = 0" . $where, 
                                 "nomet, noet, psychoger, ger, psy, litsd, actif", "actif, groupepriorite, nomet",
                                 $this->idsession);
      if (!isset($etablissement)) {
        $etablissement = $annoncelit->etabl;
      }
    }

    $tabems = $ems->getTableau();
    
    // mise  jour du formulaire selon l'tablissement choisi
    $this->futuroptions = new optionsBrioche($this->options->getChaine());
    $this->futuroptions->setOption("PASSE", 1);
    $onchange = "document.forms.donnees.options.value='" . $this->futuroptions->getChaine() . "';" .
                "document.forms.donnees.action.value=5003;document.forms.donnees.submit();";
    $x = new ListOptTableEtabl("annoncelit[etabl]", $etablissement, $ems, false, 0, "d2",
                               $onchange, $labellise || $non_editable);
    $x->addDefaut("---", "");
    $x->addOptionsEtablissements("nomet", "noet");
    $c->addChamp($x);
    $of->addChamp($c);
    $c = new TPanel(3, 1, "RIGHT", "MIDDLE");
    $x = new ChampTexte("annoncelit[litdepuis]", $annoncelit->litdepuis, "Libre depuis :&nbsp;",
                        15, 15, false, "text", "d2", "controleDate('annoncelit[litdepuis]', '" .
                        $annoncelit->litdepuis . "', 365, 365, 'annoncelit[litdepuis]', 'annoncelit[courtau]')", "", $non_editable, true);
    $c->addChamp($x);
    $c->addChamp(new Espace(2));
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    $acb = new AutoCheckBox();
    $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "", "Statut du lit :");
    if ($annoncelit->stlit == 5) {
      $x = new Label("<FONT COLOR=\"red\">Court sjour Planning</FONT>");
      $c->addChamp($x);
      $x = new Bouton("annoncelit[stlit]", 5, "HIDDEN");
      $c->addChamp($x);
    }
    else {
      $x = new GrBoutonRadio("annoncelit[stlit]", $annoncelit->stlit, "", "", $non_editable);
      $x->addRadio("Long sjour", 1);
      $x->addRadio("Court sjour", 3);
      $c->addChamp($x);
      $acb->addCase($x);
      $x = new ChampTexte("annoncelit[courtau]", $annoncelit->courtau, "Libre jusqu'au :&nbsp;", 15, 15, false,
                           "text", "d2", "controleDate('annoncelit[courtau]', '" . $annoncelit->courtau .
                           "', '365', '365', 'annoncelit[litdepuis]', 'annoncelit[courtau]')",
                           "", $non_editable, true);
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new GrBoutonRadio("annoncelit[stlit]", $annoncelit->stlit, "", "", $non_editable);
      $x->addRadio("Polyvalent", 4);
      $c->addChamp($x);
      $acb->addCase($x);
    }
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "", "Mission :");
    $x = new GrBoutonRadio("annoncelit[mission]", $annoncelit->mission, "", "", $non_editable);

    // n'afficher que les options correspondant aux missions de l'tablissement choisi par l'utilisateur
    $etabl_choisi = array();
    foreach ($tabems as $etabl) {
      if ($etabl->noet == $etablissement) {
        $etabl_choisi['psychoger']  = ($etabl->psychoger == -1 ? true : false);
        $etabl_choisi['ger']  = ($etabl->ger == -1 ? true : false);
        $etabl_choisi['psy']  = ($etabl->psy == -1 ? true : false);
        $etabl_choisi['litsd']  = ($etabl->litsd == -1 ? true : false);
        break;
      }
    }
    if (isset($etabl_choisi['psychoger']) && $etabl_choisi['psychoger']) {
      $x->addRadio("Psychogr.", 1);
    }
    if (isset($etabl_choisi['ger']) && $etabl_choisi['ger']) {
      $x->addRadio("Griatrie", 2);
    }
    if (isset($etabl_choisi['psy']) && $etabl_choisi['psy']) {
      $x->addRadio("Psychiatrie", 3);
    }
    if (isset($etabl_choisi['litsd']) && $etabl_choisi['litsd']) {
      $x->addRadio("Lit D", 4);
    }
    $x->addRadio("Autre", 5);
    $c->addChamp($x);
    $acb->addCase($x);
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "", "Pour :");
    $x = new GrBoutonRadio("annoncelit[sexlit]", $annoncelit->sexlit, "", "", $non_editable);
    $x->addRadio("Homme", 1);
    $x->addRadio("Femme", 2);
    $x->addRadio("Lit polyvalent", 3);
    $c->addChamp($x);
    $acb->addCase($x);
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    $c = new TpanelCadre(6, 1, "LEFT", "MIDDLE", "", "Chambre  :");
    $x = new GrBoutonRadio("annoncelit[chambre]", $annoncelit->chambre, "", "", $non_editable);
    $x->addRadio("1 lit", 1);
    $x->addRadio("2 lits", 2);
    $x->addRadio("3 lits et plus", 3);
    $c->addChamp($x);
    $acb->addCase($x);
    $c->addChamp($acb);
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    $c = new TPanel(6, 1);
    $x = new TextArea("annoncelit[compl]", $annoncelit->compl, "Indications complmentaires :", 100, 2, "virtual", $non_editable);
    $c->addChamp($x);
    $c->addChamp(new Espace(2));
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    $c = new TPanel(3);
    $x = new ChampTexte("annoncelit[datann]", $annoncelit->datann, "Date de l'annonce :&nbsp;", 15, 15, false,
                        "text", "d2", "controleDate('annoncelit[datann]', '" . $annoncelit->datann . "', 365, 365,'','', true)", "", $non_editable, true);
    $c->addChamp($x);
    $of->addChamp($c);
    $c = new TPanel(3, 1, "RIGHT", "MIDDLE");
    $x = new ChampTexte("annoncelit[nomann]", $annoncelit->nomann, "Annonceur :&nbsp;", 30, 50, false, "text", "d2", "", "", $non_editable);
    $c->addChamp($x);
    $c->addChamp(new Espace(2));
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    $c = new TPanel(6, 1, "RIGHT", "MIDDLE");
    $x = new Bouton("action", $future_action, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("options", $this->options->getChaine(), "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("item", $this->item, "HIDDEN");
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $futuroptions = new optionsBrioche($this->options->getChaine());
    //Dtermine l'action effectue par le bouton "lister lit" en fonction du contexte
    switch ($futuroptions->getOption("MASQ_RES")) {
    case 0:
    case 1:
      $act = 4001;
      break;
    case 2:
      $act = 4002;
      break;
    case 3:
      $act = "4003&item=$ditem";
      break;
    }
    if ($this->action != 5002 && $edition_autorisee){ //Il ne s'agit pas de la validation d'une demande Web et l'dition est autorise
      $this->futuroptions = new optionsBrioche($this->options->getchaine());
      if ($non_editable) {
        $this->futuroptions->setOption("EDITABLE", 1);
        $bouton_label = "Editer";      	
        $future_action = $future_action - 100;
      } else { 
        $this->futuroptions->setOption("EDITABLE", 0);
        if ($annEms){ // annonce web
          $bouton_label = "Envoyer au Brio";  
        }  
        else { // Annonce normale
          $bouton_label = "Sauver";      
        }
      }
      $x = new Bouton("Envoyer", $bouton_label, "SUBMIT", "document.donnees.options.value = \"" .
                      $this->futuroptions->getChaine() . "\";document.donnees.action.value=".$future_action.";", "bok");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));      
    }
    if ($this->action != 5002 && !$non_editable && $this->options->getOption("ANN_LIT") == 0) {
      // si l'annonce est ditable et si elle a dj t inscrite, on affiche ces boutons qui permettent d'enlever une annonce
      $x = new Bouton("Dtruire annonce", "Dtruire annonce", "BUTTON", "supprimeCond(\"" .
                      "$fdosbrioche?action=5099&sessionid=$this->idsession&item=$this->item&options=" . $this->options->getChaine() . "\", " .
                      "\"Utilisez cette fonction si un lit a t annonc par erreur... " .
                      "Voulez-vous rellement dtruire cette annonce (aucune possibilit de rcupration) ?\")" );
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new Bouton("Retirer annonce", "Retirer annonce", "BUTTON", "supprimeCond(\"" .
                      "$fdosbrioche?action=5098&sessionid=$this->idsession&item=$this->item&options=" . $this->options->getChaine() . "\", " .
                      "\"Utilisez cette fonction si une annonce de lit faite  bon escient est retire par le dtenteur du lit..." .
                      "Voulez-vous rellement retirer cette annonce ?\")" );
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
    }

    if ($this->action == 5002){ // Validation des demandes web
      $futopt = new optionsBrioche();
      $futopt->setOption("ANN_LIT", 4);
      $valeurOpt = $futopt->getChaine();
      $js = "document.forms.donnees.options.value = \"$valeurOpt\";document.forms.donnees.submit()";
      $x = new Bouton("Rejeter", "Rejeter", "BUTTON", "$js");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $futopt->setOption("ANN_LIT", 3);
      $valeurOpt = $futopt->getChaine();
      $js = "document.forms.donnees.options.value = \"$valeurOpt\";document.forms.donnees.submit()";
      $x = new Bouton("Accepter", "Accepter", "BUTTON", "$js");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      
    } 
    else { // Demandes  
      if ((! $annEms) &&  (! $this->options->getOption("EDITABLE")) && (! $this->options->getOption("CONS_LITS"))) {
        $this->futuroptions->setOption("ANN_LIT", 0);
        $x = new Bouton("Retour liste", "Lister lits", "BUTTON",
                        "window.location=\"$fdosbrioche?action=$act&sessionid=$this->idsession&options=" .
                        $this->futuroptions->getchaine() . "\"");
        $c->addChamp($x);
        $c->addChamp(new Espace(3));
      }
      if ($annEms){
        $label_bouton = "Fermer sans envoyer";
        $js = "window.close();";
      }
      else {
        $label_bouton = "Fermer";
        if (! $non_editable){
          $js = "if(!qModif()){window.close();}";
        }
        else {
          $js = "window.close();";
        }
      }  
      $x = new Bouton("Fermer", $label_bouton, "BUTTON", $js);
      $c->addChamp($x);
    }
    $c->addChamp(new Espace(3));
    $of->addChamp($c);
    $of->addLigne(0.5);
    $this->addContenu($of->getContenu());
  }




}


?>
