<?php
  // $Id: annuaire.inc,v 1.4 2017/07/06 22:19:44 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Annuaire
* @package herms
*/
/**
* Annuaire
* Annuaire du module Herms, contenant les fonctions de base de l'annuaire du module Herms, ainsi que des fonctions lies
* au premier projet Herms (document mdical de transmission).
* @package herms
* @author ob
*/
class annuaire extends cadropt{
  /**
  * l'identifiant de session
  * @var string
  */
  var $idsession;
  
  /**
  * l'action principale
  * @var int
  */
  var $action;
  
  /**
  * action secondaire (listes d'abonns)
  * @var int
  */
  var $action2;
  
  /**
  * action secondaire (liste SVM - pas utilise actuellement)
  * @var int
  */
  var $action3;
  
  /**
  * erreur de session
  * @var int
  */
  var $n_erreur = 0;
  
  /**
  * le contenu HTML du champ
  * @var string
  */
  var $vitrine;
  
  /**
  * faut-il inclure les listes de mdecins ?
  * @var boolean
  */
  var $medecins;
  
  /**
  * la session utilise par cet objet
  * @var object session
  */
  var $session;
  

  /**
  * @param string no cf. variable de classe idsession
  * @param int act cf. variable de classe action
  * @param int act2 cf. variable de classe action2
  * @param int act3 cf. variable de classe action3
  * @param boolean med cf. variable de classe medecin
  */
  function __construct($no, $act="", $act2="", $act3="", $med = true){
    parent::__construct("#009966",90, false);
    $this->idsession = $no;
    $this->action = $act;
    $this->action2 = $act2;
    $this->action3 = $act3;
    $this->session = new sessionAn($this->idsession,0,0);
    $this->medecins = $med;
    if (!$this->verifSess($this->session)){
      return;
    }
  }

  
  /**
  * vrification d'une session, et de l'autorisation "gestAnn"
  * @param object ss la session  vrifier
  * @return int 0 (erreur de session) ou 1 (session OK)
  */
  function verifSess($ss){
    if($ss->n_erreur){
      $this->n_erreur = $ss->n_erreur;
      return 0;
    }
    if(! preg_match("/gestAnn/", $ss->autorisations)){
      $this->n_erreur = 1001;
      return 0;
    }
    else return 1;
  }

  /**
  * construction de l'affichage dans le menu principal de Herms
  */
  function faitVitrine(){
    global $fichier;
    if ($this->n_erreur) return;
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c= new TLabel("Edition annuaire");
    $c->setColSpan("2");
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(1, 1, "", "", "50%");
    $x = new TLabel("&nbsp;");
    $c->addChamp($x);
    $form->addChamp($c);
    $c = new TPanel(1, 1, "CENTER", "", "60%");
    $x = new Bouton("Editer", "Editer", "SUBMIT");
    $c->addChamp($x);
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $form->addChamp($c);
    $this->vitrine = $this->entete;
    $this->vitrine .= $form->getContenu();
    $this->vitrine .= $this->pied;
  }
  
  /**
  * construction du formulaire principal de l'annuaire
  */
  function faitFormulaire(){
    global $fichier;
    if ($this->n_erreur) return;
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c = new TLabel("Annuaire - Fonctions disponibles", true);
    $c->setColspan("6");
    $c->setAlign("CENTER");
    $form->addChamp($c);
    if ($this->medecins){
      $form->addLigne();
      $c = new TPanel(6,1);
      $x = new Label("<A HREF=\"$fichier?action=$this->action2&sessionid=$this->idsession\">" .
                     "Liste r&eacute;gionale des m&eacute;decins</A>");
      $c->addChamp($x);
      $form->addChamp($c);
      $form->addLigne();
      $c = new TPanel(6,1);
      $x = new Label("<A HREF=\"$fichier?action=$this->action3&sessionid=$this->idsession\">Liste SVM</A>");
      $c->addChamp($x);
      $form->addChamp($c);
    }
    $form->addLigne();
    $c = new TPanel(6,1);
    $x = new Label("<A HREF=\"$fichier?action=$this->action2&crit=1&sessionid=$this->idsession\">Liste abonns collectifs</A>");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6,1);
    $x = new Label("<A HREF=\"$fichier?action=$this->action2&crit=2&sessionid=$this->idsession\">Liste autres abonns</A>");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6,1, "RIGHT");

    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("Retour", "Retour", "SUBMIT");

    $c->addChamp($x);
    $form->addChamp($c);
    $this->vitrine = $this->entete . $form->getContenu() . $this->pied;
  }

  /**
  * affichage de listes d'abonns
  * @param int crit : 1 pour abonns collectifs 2 pour autres abonns (0 pour mdecins)
  */
  function listeMed($crit=0){
    global $fichier, $champs;
    if ($this->n_erreur) return;
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c = new TLabel("Annuaire - Liste des abonn&eacute;s", true);
    $c->setColSpan("6");
    $c->setAlign("CENTER");
    $form->addChamp($c);

    $form->addLigne();
    $c = new TPanel(6, 1);
    $x = new Label("<A HREF=\"$fichier?action=$this->action2&crit=$crit&sessionid=$this->idsession\">Ajout nouvel item</A>");
    $c->addChamp($x);
    $form->addChamp($c);

    $items = $this->session->getItMeds($crit);
    if (is_array($items)){
      while (list ($cle, $valeur) = each ($items)){
        $form->addLigne();
        $c = new TPanel(4,1);
        $x = new Label ("<FONT" . ($valeur[4] < 0 ? " COLOR=\"red\"" : "")  . ">" .
                        ($valeur[1] ? "$valeur[1] $valeur[0], $valeur[2]" : "$valeur[5]") . "</FONT>");
        $c->addChamp($x);
        $form->addChamp($c);
        $c = new TPanel(1, 1);
        $x = new Label ("<A HREF=\"$fichier?action=$this->action2&crit=$crit&item=$valeur[3]&sessionid=$this->idsession\">" .
                       ($valeur[4] < 0 ? "VALIDER" : "Editer") . "</A>");
        $c->addChamp($x);
        $form->addChamp($c);
        $c = new TPanel(1, 1);
        $x = new Label ("<A HREF=\"$fichier?action=$this->action3&crit=$crit&item=$valeur[3]" . 
                        "&sessionid=$this->idsession\">Supprimer</A>");
        $c->addChamp($x);
        $form->addChamp($c);
      }
    }
    $form->addLigne();
    $c = new TPanel(6, 1, "RIGHT");
    $x = new Bouton("Retour", "Retour", "SUBMIT");
    $c->addChamp($x);
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("crit", "$crit", "HIDDEN");
    $c->addChamp($x);
    $form->addChamp($c);
    $this->vitrine = $this->entete . $form->getContenu() . $this->pied;
  }
  
  /**
  * mode dition-ajout d'une entre
  * @param int crit cf. fonction listeMed
  */
  function nouveauMed($crit=0){
    global $fichier, $champs, $item;
    if (empty($champs)) {
      for ($i = 0; $i < 11; $i++){
        $champs[] = "";
      }
    }
    if ($this->n_erreur) return;
        
    for ($i = 0; $i<count($champs); $i++){
      if (isset($champs[$i])) {
        $champs[$i] = $this->session->deguille($champs[$i]);
      }
      else {
        //$champs[$i] = "";
      }
    }
    
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c = new TPanel(6,1,"CENTER");
    $x = new Label(($item ? "Modification d'un item" : "Ajout d'un item"), true);
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();

    if ($crit == 1){ //abonn collectif
      $c = new TPanel(6,1);
      $x = new ChampTexte("champs[10]", $champs[10], "Nom", 50, 50);
      $c->addChamp($x);
      $form->addChamp($c);
    }
    else { // abonn individuel
      $c = new TPanel(3,1);
      $x = new ChampTexte("champs[0]",$champs[0], "Nom", 30, 30);
      $c->addChamp($x);
      $form->addChamp($c);
      $c = new TPanel(3,1);
      $x = new ChampTexte("champs[1]", $champs[1], "Pr&eacute;nom", 30, 30);
      $c->addChamp($x);
      $form->addChamp($c);
    }
    $form->addLigne();
    $c = new TPanel(6, 1);
    $x = new ChampTexte("champs[2]", $champs[2], ($crit == 0 ? "Spcialit" : "Remarque"), 50, 50);
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6,1);
    $x = new ChampTexte("champs[3]", $champs[3], "Rue et N", 70, 70);
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(3,1);
    $x = new ChampTexte("champs[4]", $champs[4], "NPA", 5, 7);
    $c->addChamp($x);
    $form->addChamp($c);
    $c = new TPanel(3,1);
    $x = new ChampTexte("champs[5]", $champs[5], "Localit&eacute;", 30, 30);
    $c->addChamp($x);
    $form->addChamp($c);

    $form->addLigne();
    $c = new TPanel(3,1);
    $x = new ChampTexte("champs[6]", $champs[6], "T&eacute;l&eacute;phone", 20, 20);
    $c->addChamp($x);
    $form->addChamp($c);
    $c = new TPanel(3,1);
    $x = new ChampTexte("champs[7]", $champs[7], "Fax", 20, 20);
    $c->addChamp($x);
    $form->addChamp($c);

    $form->addLigne();
    $c = new TPanel(3,1);
    $x = new ChampTexte("champs[8]", $champs[8], "E-mail", 25, 50);
    $c->addChamp($x);
    $form->addChamp($c);
    $c = new TPanel(3,1);
    if ($crit == 0){
      if (! isset($champs[9])) $champs[9] = 0;
      $x = new CheckBox("champs[9]", "oui", "Membre AMESLO", ($champs[9]=="oui" ? true : false));
    }
    else {
      $x = new Espace(2);
    }
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6,1, "RIGHT");
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("item", "$item", "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("crit", "$crit", "HIDDEN");
    $c->addChamp($x);

    $x = new Bouton("Enregistrer", "Abandonner", "SUBMIT");
    $c->addChamp($x);
    $x = new Espace(3);
    $c->addChamp($x);
    $x = new Bouton("Enregistrer", "Enregistrer", "SUBMIT");
    $c->addChamp($x);
    $form->addChamp($c);
    $this->vitrine = $this->entete . $form->getContenu() . $this->pied;
    
  }

  /**
  * vrification des donnes saisies dans le formulaire
  * @param crit cf. fonction listeMed
  * @return boolean les donnes entres sont-elles compltes
  */
  function verifMed($crit=0){
    global $champs, $item;
    $ret = true;
    if ($crit == 1){
      if (! $champs[10]){
        $this->n_erreur = 1116;
        return false;
      }
    }
    else {
      if ((! $champs[0]) OR (!$champs[1])){
        $this->n_erreur = 1112;
        return false;
      }
    }
    if ((! $champs[4]) OR (! $champs[5])){
      $this->n_erreur = 1113;
      $ret = false;
    }
    return $ret;
  }

  /**
  * enregistrement formulaire
  */
  function addMed($crit=0){
    if ($this->n_erreur) return;
    $this->session->addMed($crit);
  }

  /**
  * destruction d'une entre
  */
  function detrMed($item){
    if ($this->n_erreur) return;
    $this->session->detrMed($item);
  }

  /**
  * lecture d'un enregistrement
  * @return array les champs de l'enregistrement
  */
  function recupMed(){
    if ($this->n_erreur) return;
    return $this->session->recupMed();
  }

  /**
  * Affichage de la liste des membres de la SVM (Herms - dmt)
  */
  function listeSVM() {
    global $fichier, $champs, $choix, $off;
    if ($this->n_erreur) return;
    if (! isset($champs[0])) $champs[0] = "";
    if ($choix) {
      $champs[0]="";
    }
    else {
      $champs[1]="";
    }
    $offset=$off;
    $items = $this->session->getItSVM($offset, $choix, $champs);
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c = new TLabel("Annuaire - Liste des membres de la SVM", true);
    $c->setColSpan("6");
    $c->setAlign("CENTER");
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6,1,"CENTER");
    $x = new Label (
                    "Rponses " . ($offset*100+1) . " - " .
                    (($offset+1)*100 < $this->session->compte ? ($offset+1)*100 : $this->session->compte) .
                    " de " . $this->session->compte .
                    "... &lt; " .
                    ($offset  ? "<A HREF=\"$fichier?action=$this->action&sessionid=$this->idsession&off=" .
                    ($offset-1) . "&choix=$choix&champs[0]=$champs[0]&champs[1]=$champs[1]" .
                    "\">Prcdente</A>" : "Prcdente").
                    " | Page | " .
                    (($offset+1)*100 < $this->session->compte ? 
                    "<A HREF=\"$fichier?action=$this->action&sessionid=$this->idsession&off=" .
                    ($offset+1) . "&choix=$choix&champs[0]=$champs[0]&champs[1]=$champs[1]" .
                    "\"> Suivante</A>" : "Suivante"). " &gt;"
                    );
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6, 1);
    $x = new Radio("choix", "0", "Recherche par nom", ($choix ? false : true));
    $c->addChamp($x);
    $x = new ChampTexte("champs[0]", $champs[0], "commenant par :", 6, 5);
    $c->addChamp($x);
    $x = new Espace(5);
    $c->addChamp($x);
    $x = new Radio("choix", "1", "Recherche par NPA", ($choix ? true : false));
    $c->addChamp($x);
    $x = new ChampTexte("champs[1]", $champs[1], "depuis :", 5, 4);
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6,1);
    $x = new Bouton("OK", "Excuter", "SUBMIT");
    $c->addChamp($x);
    $x = new Espace(5);
    $c->addChamp($x);
    $x = new Bouton("OK", "Retour", "SUBMIT");
    $c->addChamp($x);
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(2,1);
    $x = new Label ("Nom et adresse", true);
    $c->addChamp($x);
    $form->addChamp($c);
    $c = new TPanel(1,1);
    $x = new Label ("Tl.", true);
    $c->addChamp($x);
    $form->addChamp($c);
    $c = new TPanel(1,1);
    $x = new Label ("Fax.", true);
    $c->addChamp($x);
    $form->addChamp($c);
    $c = new TPanel(1,1);
    $x = new Label ("E-mail", true);
    $c->addChamp($x);
    $form->addChamp($c);
    if ($items){
      while (list ($cle, $valeur) = each ($items)){
        $form->addLigne();
        $c = new TPanel(2,1);
        $tabspec = $this->session->getSpec($valeur[8]);
        if (! $tabspec) $tabspec[0] = "";
        $x = new Label ("<B>$valeur[1]</B> $valeur[9] " .
                       ($valeur[8] ? "<BR><I> $tabspec[0] (FMH $valeur[8])</I>" : "") .
                       "<BR>" . ($valeur[2] ? "$valeur[2], " : "") . "$valeur[3] $valeur[4]");
        $c->addChamp($x);
        $form->addChamp($c);
        $c = new TPanel(1,1);
        $x = new Label ("$valeur[5]");
        $c->addChamp($x);
        $form->addChamp($c);
        $c = new TPanel(1,1);
        $x = new Label ("$valeur[6]");
        $c->addChamp($x);
        $form->addChamp($c);
        $c = new TPanel(1, 1);
        $x = new Label (($valeur[7] ? "<A HREF=\"mailto:$valeur[7]\">$valeur[7]</A>" : ""));
        $c->addChamp($x);
        $form->addChamp($c);
        $c = new TPanel(1, 1);
        $x = new Label ((! $valeur[10] ? "<A HREF=\"$fichier?action=$this->action2&item=$valeur[0]&off=$offset" .
                        "&choix=$choix&champs[0]=$champs[0]&champs[1]=$champs[1]&sessionid=$this->idsession\">" .
                        "Importer</A>" : "Importer"));
        $c->addChamp($x);
        $form->addChamp($c);
      }
    }
    else {
      $form->addLigne();
      $c = new TPanel(6,1);
      $x = new Label("Votre requte ne renvoie aucun rsultat...");
      $c->addChamp($x);
      $form->addChamp($c);
    }
    $this->vitrine = $this->entete . $form->getContenu() . $this->pied;
  }

  /**
  * importation d'un membre de la SVM dans la liste rgionale des mdecins (hermes - dmt)
  * @param int item le numro de l'enregistrement
  */
  function importe($item){
    #Importation d'un mdecin SVM dans la liste rgionale
    $valeurs = $this->session->getMedSVM($item);
    $this->session->remplitAbo($valeurs);
  }

  /**
  * affichage du contenu HTML de l'objet
  */
  function imprime(){
    if ($this->n_erreur) return;
    print $this->vitrine;
  }

}

 ?>
