<?php
  // $Id: briocheObs.inc,v 1.1.1.1 2010-10-11 22:25:44 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Encadr du menu principal donnant accs  toutes les fonctions de BriocheWeb - observatoire
* @package formulaires
*/
/**
* Encadr du menu principal donnant accs  toutes les fonctions de BriocheWeb
* A intgrer dans la page d'accueil. Donne accs  l'arborescence des menus de BriocheWeb
* A l'heure actuelle, un menu principal, un sous-menu "Listes et tats" et un sous-menu
* "Statistiques BRIO"
* @package formulaires
* @author ob
*/
class briocheObs extends cadroptBrioche{
  /**
  * l'identifiant de session
  * @var string
  */
  var $idsession;
  
  /**
  * => listes et tats
  * @var int
  */
  var $action;
  
  /**
  * l'action prcdente (servant au bouton retour)
  * @var int
  */
  var $precedente_action;
  
  /**
  * @param string sessionid cf. variable de classe idsession
  * @param int act... cf les variables de classe action...
  * @param int precedente_action cf. variable de classe
  */
  function briocheObs($sessionid, $precedente_action = 0, $act  ){
    //Autorisation spciale:
    $ini = new briocheIni();
    $autspec = array();
    $autspec[0] = $ini->autSpec[0];
    $autspec[1] = $ini->autSpec[1];
    if(!$this->cadroptBrioche("#009966",90 , 1, $sessionid, $autspec)) return;
    $this->idsession = $sessionid;
    $this->action = $act;
    $this->precedente_action = $precedente_action;
  }

  
  /**
  * construction de l'affichage dans le menu principal de Brioche-obs
  */
  function faitVitrine(){
    global $fichier;
    global $fdossbrioche;
    global $fCourSej;
    if ($this->n_erreur) return;
    $form = new TabForm();
    $form->setTabParam("100%");
    $form->setFormParam("donnees", "", "");
    $ini = new briocheIni();
    $opt = new optionsBrioche();
    $opt->setOption("CONS_LITS", 1);
    //Consultation lits
    $c = new TPanel(2, 1);
    $x = new Lien("Tableaux de bords lits et demandes", false, false, false, "",
                   "$fichier?tempus=" . time() . 
                   "&action=$this->action&sessionid=$this->idsession&options=" .
                    $opt->getChaine());
    $c->addChamp($x);
    $x = new Bouton("largeurecran", 0, "HIDDEN");
    $c->addChamp($x);
    $form->addChamp($c);
    
    /*
    $c = new TPanel(1, 3, "RIGHT");
    $x = new Aide("C0002");
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $form->addChamp($c);
    $form->addLigne();
    // Annonce de lits pour EMS
    if ($this->verifAut($ini->autSpec[0], $this->autorisations)){
      $opt = new optionsBrioche();
      $opt->setOption("EDITABLE", 1); 
      $opt->setOption("ANN_LIT", 1);
      $c = new TPanel (2, 1);
      $x = new Lien("Annonce de lit (EMS)", false, false, false, "",
                    "javascript:ouvreBrioche('$fdossbrioche?action=$this->action8" .
                    "&sessionid=$this->idsession&options=" . $opt->getChaine() .
                    "&item=-999')");
      $c->addChamp($x);
      $form->addChamp($c);
      $form->addLigne();
    }
    
    if ($this->verifAut($ini->autSpec[1], $this->autorisations)){
      //Demande d'orientation pour service placeur
      $opt = new optionsBrioche();
      $opt->setOption("MODE", 4);
      $opt->setOption("NOUV_US", 1);
      $opt->setOption("NOUV_DOSS", 1);
      $c = new TPanel(2, 1);
      $x = new Lien("Demande d'orientation (Service placeur)", false, false, false, "",
                    "javascript:ouvreBrioche('$fdossbrioche?action=$this->action18" .
                    "&sessionid=$this->idsession&options=" . $opt->getChaine() .
                    "&item=-999')");
      $c->addChamp($x);
      $form->addChamp($c);
      $form->addLigne();
      //Suivi des demandes pour services placeurs
      $c = new TPanel(2, 1);
      $x = new Lien("Suivi des demandes (Service placeur)", false, false, false, "",
                    "$fichier?tempus=" . time() .
                    "&action=$this->action16&sessionid=$this->idsession");
      $c->addChamp($x);
      $form->addChamp($c);
      $form->addLigne();              

      //Statistiques par services placeurs (seuls les services placeurs en ont besoin :
      //Les utilisateurs BRIO autoriss accdent par le menu Statistiques BRIO
      if ($this->verifAut($ini->autSpec[1], $this->autorisations)){
      $c = new TPanel(2, 1);
      $act = $this->action17 + 0.2;
      $x = new Lien("Statistiques (Service placeur)", false, false, false, "",
                  "$fichier?tempus=" . time() .
                  "&action=$act&sessionid=$this->idsession");
      $c->addChamp($x);
      $form->addChamp($c);
      $form->addLigne();   
      }          
    }
     
    if ($this->verifAut($ini->autSpec[0], $this->autorisations)){
      //Prinscriptions pour EMS
      $c = new TPanel(2, 1);
      $x = new Lien("Prinscriptions et placements (EMS)", false, false, false, "", 
                    "$fichier?tempus=" . time() .
                    "&action=$this->action14&sessionid=$this->idsession");
      $c->addChamp($x);
      $form->addChamp($c);
      $form->addLigne();
    }

    //Statistiques pour EMS (seuls les EMS en ont besoin : les utilisateurs BRIO
    //autoriss accdent par le menu Statistique BRIO
    if ($this->verifAut($ini->autSpec[0], $this->autorisations) ){
      $c = new TPanel(2, 1);
      $act = $this->action11 + 0.2;
      $x = new Lien("Statistiques (EMS)", false, false, false, "", 
                    "$fichier?tempus=" . time() . 
                    "&action=$act&sessionid=$this->idsession");
      $c->addChamp($x);
      $form->addChamp($c);
      $form->addLigne();
    }

    //Rcapitulatif courts sjour pour EMS (pour les utilisateurs BRIO, cf. menu Statistiques
    if ($this->verifAut($ini->autSpec[2], $this->autorisations)){
      $c = new TPanel(2, 1);
      $act = ($this->action21 * 10);
      $x = new Lien("Statistique des courts sjours planning : liste nominative (EMS)", false, false, false, "",
                    "$fichier?tempus=" . time() .
                    "&action=$act&sessionid=$this->idsession");
      $c->addChamp($x);
      $form->addChamp($c);
      $form->addLigne();              
    
      $c = new TPanel(2, 1);
      $act = ($this->action23 * 10);
      $x = new Lien("Statistique des courts sjours planning : indicateurs (EMS)", false, false, false, "",
                    "$fichier?tempus=" . time() .
                    "&action=$act&sessionid=$this->idsession");
      $c->addChamp($x);
      $form->addChamp($c);
      $form->addLigne();              
    
    
    
    }
    
    if ($this->verifAut($ini->autReq, $this->autorisations)) {
      //Dossier brioche
      $opt = new optionsBrioche();
      $opt->setOption("VAL_DEM", 9);
      $c = new TPanel(2, 1);
      $x = new Lien("Dossiers Brioche", false, false, false, "",
                      "javascript:ouvreBrioche('$fdossbrioche?action=$this->action2" .
                      "&sessionid=$this->idsession&options=" . $opt->getChaine() . "')");
      $c->addChamp($x);
      $form->addChamp($c);
      $form->addLigne();
      //Recherche par critres
      $c = new TPanel(2, 1);
      $x = new Lien("Recherche par critres", false, false, false, "",
                    "$fichier?tempus=" . time() . "&action=$this->action13" .
                    "&sessionid=$this->idsession&donnees[suspens]=-1");
      $c->addChamp($x);
      $form->addChamp($c);
      $form->addLigne();

      //Statistiques BRIO : Rservs aux utiliateurs BRIO qui ont
      // l'autorisation supplmentaire statR
      if ($this->verifAut($ini->autSuppl[2], $this->autorisations)){
        $c = new TPanel(2, 1);
        $x = new Lien("Statistiques BRIO", false, false, false, "",
                      "$fichier?action=$this->action12&sessionid=$this->idsession");
        $c->addChamp($x);
        $form->addChamp($c);
        $form->addLigne();
      }
      
      //Listes et tats
      $c = new TLabel("<A HREF=\"$fichier?action=$this->action&sessionid=$this->idsession\">Brioche - Listes et &eacute;tats</A>");
      $c->setColSpan("2");
      $form->addChamp($c);
      $form->addLigne();

    }
    //Courts sjours planifis (accs en criture pour le BRIO
    if ($this->verifAut($ini->autSuppl[1], $this->autorisations)){
      $c = new TLabel("<A HREF=\"javascript:void(0)\" onClick=\"ouvrePlanning('$fCourSej?action=1&sessionid=$this->idsession')\">" .
                      "Brioche - Planning courts sjours</A>");
      $c->setColSpan("2");
      $form->addChamp($c);
      $form->addLigne();
    }
    
    //Courts sjours planifis (accs en lecture seule pour un EMS)
    if ($this->verifAut($ini->autSpec[2], $this->autorisations)){
      $c = new TLabel("<A HREF=\"javascript:void(0)\" onClick=\"ouvrePlanning('$fCourSej?action=1&sessionid=$this->idsession')\">" .
                      "Planning courts sjours (EMS)");
      $c->setColSpan("2");
      $form->addChamp($c);
      $form->addLigne();
    }
    
    if ($this->verifAut($ini->autSuppl[0], $this->autorisations)){
      //Privilges des utilisateurs
      $c = new TLabel("<A HREF=\"$fichier?action=$this->action7&sessionid=$this->idsession\">Brioche - Privilges des utilisateurs</A>");
      $c->setColSpan("2");
      $form->addChamp($c);
      $form->addLigne();
      //Divers administration
      $c = new TPanel(2, 1);
      $x = new Lien("Brioche - Divers administration", false, false, false, "", "$fichier?action=$this->action15&sessionid=$this->idsession");
      $c->addChamp($x);
      $form->addChamp($c);
      $form->addLigne();
    }
    */
    $this->vitrine = $form->getContenu();
    
    $this->LitContenu($this->vitrine);
   
  }
  
  /**
  * sous-menu listes et tats
  */
  /*
  function faitFormulaire(){
    global $fichier;
    if ($this->n_erreur) return;
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c = new TLabel("Brioche - Listes et tats", true);
    $c->setColspan("6");
    $c->setAlign("CENTER");
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6,1);
    $x = new Lien("Dossiers en suspens", false, false, false, "",
                  "$fichier?tempus=" . time() . 
                  "&action=$this->action2&sessionid=$this->idsession");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6, 1);
    $x = new Lien("Distribution des dossiers", false, false, false, "", 
                  "$fichier?tempus=" . time() .
                  "&action=$this->action3&sessionid=$this->idsession");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6, 1);
    $x = new Lien("CTR : listes d'inscrits", false, false, false, "",
                  "$fichier?tempus=" . time() .
                  "&action=$this->action20&sessionid=$this->idsession");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6, 1);
    $x = new Lien("EMS : listes d'inscrits", false, false, false, "",
                  "$fichier?tempus=" . time() .
                  "&action=$this->action4&sessionid=$this->idsession");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6, 1);
    $x = new Lien("Services placeurs", false, false, false, "", 
                  "$fichier?tempus=" . time() . 
                  "&action=$this->action5&sessionid=$this->idsession");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6, 1);
    $x = new Lien("Sjours d'observation", false, false, false, "", 
                   "$fichier?tempus=" . time() .
                   "&action=$this->action6&sessionid=$this->idsession");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6,1, "RIGHT");
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("Retour", "Retour", "SUBMIT");

    $c->addChamp($x);
    $form->addChamp($c);
    $this->vitrine = $form->getContenu();
    $this->LitContenu($this->vitrine);
  }
  */
  /**
  * sous-menu statistiques
  */
  /*
  function faitMenuStat(){
    global $fichier;
    if ($this->n_erreur) return;
    $ini = new briocheIni();
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c = new TLabel("Brioche - Statistiques BRIO", true);
    $c->setColspan("6");
    $c->setAlign("CENTER");
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6, 1);
    $x = new Lien("Indicateurs SSP 2002", false, false, false, "",
                  "$fichier?action=$this->action3&sessionid=$this->idsession");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6, 1);
    $x = new Lien("Statistiques par EMS", false, false, false, "",
                  "$fichier?action=$this->action2&sessionid=$this->idsession&precedente_action=$this->precedente_action");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6, 1);
    $x = new Lien("Statistiques par service placeur", false, false, false, "",
                  "$fichier?action=$this->action4&sessionid=$this->idsession&precedente_action=$this->precedente_action");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();              
    
    // Rcapitulatif courts sjours planning pour Utilisateur BRIO avec autorisation courts sjours
    if ($this->verifAut($ini->autSuppl[1], $this->autorisations)) {
      $c = new TPanel(6, 1);
      $x = new Lien("Statistique des courts sjours planning : liste nominative", false, false, false, "", 
                    "$fichier?action=$this->action21&sessionid=$this->idsession&precedente_action=" . 
                    "$this->precedente_action");
      $c->addChamp($x);
      $form->addChamp($c);
      $form->addLigne();

      $c = new TPanel(6, 1);
      $x = new Lien("Statistique des courts sjours planning : indicateurs", false, false, false, "", 
                    "$fichier?action=$this->action23&sessionid=$this->idsession&precedente_action=" . 
                    "$this->precedente_action");
      $c->addChamp($x);
      $form->addChamp($c);
      $form->addLigne();     
    }
    // Extraction fichiers de donnes pour IUMSP (devrait tre obsolte avec l'intgration des routines R)
    // On la garde avec une option spcifique pour les tests
    if ($this->verifAut($ini->autSuppl[3], $this->autorisations)){
      $c = new TPanel(6, 1);
      $x = new Lien("Extraction IUMSP", false, false, false, "", 
                    "$fichier?action=$this->action5&sessionid=$this->idsession");
      $c->addChamp($x);
      $form->addChamp($c);              
      $form->addLigne();
    }
    // Consultation rapports d'analyse de l'IUMSP
    
    $c = new TPanel(6, 1);
    $x = new Lien("Indicateurs IUMSP", false, false, false, "", 
                  "$fichier?action=$this->action19&sessionid=$this->idsession");
    $c->addChamp($x);
    $form->addChamp($c);              
    $form->addLigne();
    
    // Tableau de bord "Lits et demandes"
    if (isset($ini->autSuppl[6]) && $this->verifAut($ini->autSuppl[6], $this->autorisations)) {
      $c = new TPanel(6, 1);
      $x = new Lien("Tableau de bord \"Lits et demandes\"", false, false, false, "",
                    "$fichier?action=$this->action22&sessionid=$this->idsession");
      $c->addChamp($x);   
      $form->addChamp($c);
      $form->addLigne();
    }
    $c = new TPanel(6, 1, "RIGHT");
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
   
    $x = new Bouton("Retour", "Retour", "SUBMIT");
    $c->addChamp($x);
    $form->addChamp($c);
    $this->vitrine = $form->getContenu();
    $this->LitContenu($this->vitrine);
    
               
    
  }
 */
}

?>
