<?php
/**
* Changement adresse lectronique
* @package formulaires
*/
/**
* Changement adresse lectronique
* Permet  l'utilisateur de fournir et de modifier son adresse lectronique
* @package formulaires
* @author ob
*/
class cEmail extends cadropt{
  /**
  * l'identifiant de session
  * @var string
  */
  var $idsession;
  
  /**
  * l'action du formulaire
  * @var int
  */
  var $action;
  
  /**
  * l'erreur de session
  * @var int
  */
  var $n_erreur = 0;
  
  /**
  * le contenu HTML du formulaire
  * @var string
  */
  var $vitrine;
  
  /**
  * message  afficher au-dessus du formulaire
  * @var string
  */
  var $message;
  
  /**
  * legende du formulaire
  * @var string
  */
  var $legende;
  
  /**
  * l'objet session utilis
  * @var object
  */
  var $session;
  
  /**
  * numro d'erreur (en cas d'erreur dans l'adresse lectronique)
  * @var int
  */
  var $ad_erreur;
  
  /**
  * permet de passer un paramtre  l'action suivante (utile pour Herms - dmt)
  * @var string
  */
  var $suite;

  /**
  * @param string no cf. variable de classe idsession
  * @param int act cf. variable de classe action
  * @param suite cf. variable de classe suite
  */
  function __construct($no, $act, $suite = ""){
    
    //$this->cadropt("#009966",90);
    parent::__construct("#009966",90);
    $this->idsession = $no;
    $this->action = $act;
    $this->suite = $suite;
    $this->session = new sessionPH($this->idsession);

    if (!$this->verifSess($this->session)){
      return;
    }

  }
 
  
   /**
  * vrification d'une session, et de l'autorisation "cEmail"
  * @param object ss la session  vrifier
  * @return int 0 (erreur de session) ou 1 (session OK)
  */
  function verifSess($ss){

    if($ss->n_erreur){
      $this->n_erreur = $ss->n_erreur;
      return 0;
    }

    if(! preg_match("/cEmail/", $ss->autorisations)){
      $this->n_erreur = 1001;
      return 0;
    }
    else return 1;
  }
  
  /**
  * construction de l'affichage dans le menu principal
  */
  function faitVitrine(){
    global $fichier;
    if ($this->n_erreur) return;
    if(! $this->session->email){
      parent::__construct("orange");
      $this->message = "Vous n'avez pas fourni d'adresse &eacute;lectronique. Il ne  vous est donc pas " .
                       "possible de recevoir les messages de confirmation.";
      $this->legende = "Fournir une adresse";
    }
    else{
      //$this->cadropt("#009966");
      parent::__construct("#009966");
      $this->message = "Les messages vous sont envoy&eacute;s &agrave; l'adresse suivante : <B>  " . $this->session->email . "</B>";
      $this->legende = "Changer l'adresse";
    }
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c = new TLabel("$this->message");
    $c->setColSpan(2);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(1, 1, "", "", "50%");
    $x = new Label("&nbsp;");
    $c->addChamp($x);
    $form->addChamp($c);
    $c = new TPanel(1,1, "CENTER", "", "60%");
    $x = new Bouton("bchEmail", "$this->legende", "SUBMIT");
    $c->addChamp($x);
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $form->addChamp($c);
    $this->vitrine = $this->entete;
    $this->vitrine .= $form->getContenu();
    $this->vitrine .= $this->pied;
  }

  /**
  * construction du formulaire pour changement adresse
  */
  function faitFormulaire(){
    global $fichier;
    if ($this->n_erreur) return;
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c = new TLabel("Veuillez entrer deux fois votre adresse &eacute;lectronique. " .
                    "Les deux entr&eacute;es doivent &ecirc;tre identiques. Laissez en blanc si vous " .
                    "d&eacute;sirez effacer votre adresse");
    $c->setColSpan(2);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TChampTexte("email1", "", "", 50, 50);
    $c->setColSpan(2);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TChampTexte("email2", "", "", 50, 50);
    $c->setColSpan(2);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(2, 1, "RIGHT");
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("badr", "Abandonner", "SUBMIT");
    $c->addChamp($x);
    $x = new Espace(2);
    $c->addChamp($x);
    $x = new Bouton("badr", "Valider", "SUBMIT");
    $c->addChamp($x);
    if ($this->suite == "pref") {
      $x = new Bouton("suite", "pref", "HIDDEN");
      $c->addChamp($x);
    }
    $form->addChamp($c);
    $this->vitrine = $this->entete;
    $this->vitrine .= $form->getContenu();
    $this->vitrine .= $this->pied;
  }
  
  /**
  * vrification des donnes saisies dans le formulaire
  */
  function validation(){
    $ex = new extrVar();
    $ex->extrait("email1");
    $ex->extrait("email2");
    $ex->extrait("badr");
    global $email1, $email2, $badr;
    if ($this->n_erreur) return;
    if ($badr == "Abandonner"){
      return;
    }
    if($email1 != $email2){
      $this->ad_erreur = 1002;
      return;
    }
    if( (! $email1) AND $this->session->preference == "@"){
      $this->ad_erreur = 1102;
      return;
    }
    $this->session->changeEmail($email1);
  }

  /**
  * affichage du contenu HTML de l'objet
  */
  function imprime(){
    print $this->vitrine;
  }
}

 ?>
