<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Gestion des comptes utilisateurs
* @package herms
*/
/**
* Gestion des comptes utilisateurs
* Administration des comptes utilisateurs, des groupes, des autorisations dans Herms
* @package herms
* @author ob
*/
class cUt extends cadropt{
  /**
  * l'identifiant de session
  * @var string
  */
  var $idsession;
  
  /**
  * l'action principale (affichage du formulaire depuis le menu et retour au menu)
  * @var int
  */
  var $action;
  
  /**
  * gestion des comptes et des groupes
  * @var int
  */
  var $action2;
  
  /**
  * gestion des autorisations, et suppressions diverses
  * @var int
  */
  var $action3;
  
  /**
  * autorisations par groupe, ajout nouveau compte
  * @var int
  */
  var $action4;
  
  /**
  * numro d'une erreur de session
  * @var int
  */
  var $n_erreur = 0;
  
  /**
  * numro d'une erreur de saisie
  * @var int
  */
  var $ad_erreur = 0;
  
  /**
  * le contenu HTML du formulaire
  * @var int
  */
  var $vitrine;
  
  /**
  * l'objet session utilis
  * @var object
  */
  var $session;


  /**
  * @param string no cf. variable de classe idsession
  * @param int act... cf. variables de session action...
  */
  function __construct($no, $act="", $act2="", $act3="", $act4=""){
    parent::__construct("#009966",90, false);
    $this->idsession = $no;
    $this->action = $act;
    $this->action2 = $act2;
    $this->action3 = $act3;
    $this->action4 = $act4;
    $this->session = new sessionCUt($this->idsession,0,0);
    if (!$this->verifSess($this->session)){
      return;
    }

  }


  /**
  * vrification d'une session, et de l'autorisation "suHermes"
  * @param object ss la session  vrifier
  * @return int 0 (erreur de session) ou 1 (session OK)
  */
  function verifSess($ss){

    if($ss->n_erreur){
      $this->n_erreur = $ss->n_erreur;
      return 0;
    }

    if(! preg_match("/suHermes/", $ss->autorisations)){
      $this->n_erreur = 1001;
      return 0;
    }

    else return 1;
  }

  /**
  * construction de l'affichage dans le menu principal de Herms
  */
  function faitVitrine(){
    global $fichier;
    if ($this->n_erreur) return;
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c= new TLabel("Comptes utilisateurs");
    $c->setColSpan("2");
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(1, 1, "", "", "50%");
    $x = new TLabel("&nbsp;");
    $c->addChamp($x);
    $form->addChamp($c);
    $c = new TPanel(1, 1, "CENTER", "", "60%");
    $x = new Bouton("Gerer", "G&eacute;rer", "SUBMIT");
    $c->addChamp($x);
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $form->addChamp($c);
    $this->vitrine = $this->entete;
    $this->vitrine .= $form->getContenu();
    $this->vitrine .= $this->pied;
  }
  
  /**
  * construction du formulaire principal de la gestion utilisateurs
  */
  function faitFormulaire(){
    global $fichier;
    if ($this->n_erreur) return;
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c = new TLabel("Comptes utilisateurs - Fonctions disponibles", true);
    $c->setColspan("6");
    $c->setAlign("CENTER");
    $form->addChamp($c);

    $form->addLigne();
    $c= new TPanel(6,1);
    $x = new Label("<A HREF=\"$fichier?action=$this->action2&sessionid=$this->idsession\">Comptes par abonn</A>");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c= new TPanel(6,1);
    $x = new Label("<A HREF=\"$fichier?action=$this->action3&sessionid=$this->idsession\">Liste des autorisations</A>");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c= new TPanel(6,1);
    $x = new Label("<A HREF=\"$fichier?action=$this->action4&sessionid=$this->idsession\">Autorisations par groupe</A>");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6,1, "RIGHT");

    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("Retour", "Retour", "SUBMIT");

    $c->addChamp($x);
    $form->addChamp($c);
    $this->vitrine = $this->entete . $form->getContenu() . $this->pied;
  }

  /**
  * affichage de la liste des utilisateurs
  */
  function listeAbo(){
    global $fichier, $champs;
    if ($this->n_erreur) return;
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c = new TPanel(6, 1, "RIGHT");
    $x = new Bouton("Retour", "Retour", "SUBMIT");
    $c->addChamp($x);
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TLabel("Comptes utilisateurs", true);
    $c->setColSpan("6");
    $c->setAlign("CENTER");
    $form->addChamp($c);
    $items = $this->session->getAboSuppr();
    if (count($items) && is_array($items)){
      $form->addLigne();
      $c = new TLabel("Il n'y a plus d'entre abonns pour les utilisateurs suivants :", true, true);
      $c->setColSpan("6");
      $form->addChamp($c);
      while (list ($cle, $valeur) = each($items)){
        $form->addLigne();
        $c = new TPanel(3,1);
        $x = new Label ($valeur[1]);
        $c->addChamp($x);
        $form->addChamp($c);
        $c = new TPanel(3,1);
        $x = new Label ("<A HREF=\"$fichier?action=$this->action3&item=$valeur[0]&orph=1&sessionid=$this->idsession\">Supprimer</A>");
        $c->addChamp($x);
        $form->addChamp($c);
      }
      $form->addLigne();
      $c = new TLabel("Comptes utilisateurs enregistrs :", true, true);
      $c->setColSpan("6");
      $form->addChamp($c);
    }
    $items = $this->session->getItAbos();

    while (list ($cle, $valeur) = each ($items)){
      $form->addLigne();
      $c = new TPanel(1,1);
      $x = new Label ($valeur[4]." - ");
      $c->addChamp($x);
      $x = new Label ((! $valeur[2] ? "$valeur[1]" : "$valeur[2] $valeur[3]"));
      $c->addChamp($x);
      $form->addChamp($c);
      $c = new TPanel(1,1);
      $x = new Label ($valeur[6]);
      $c->addChamp($x);
      $form->addChamp($c);
      $c = new TPanel(1,1);
      $x = new Label ($this->session->groupeUt($valeur[4]));
      $c->addChamp($x);
      $form->addChamp($c);
      $c = new TPanel(1, 1);
      $x = new Label (($valeur[4] ? "Cr&eacute;er" : 
                                    "<A HREF=\"$fichier?action=$this->action2&item=$valeur[0]" .
                                    "&sessionid=$this->idsession\">Cr&eacute;er</A>"));
      $c->addChamp($x);
      $form->addChamp($c);
      $c = new TPanel(1, 1);
      $x = new Label (($valeur[4] ? "<A HREF=\"$fichier?action=$this->action2&item=$valeur[0]" .
                                    "&sessionid=$this->idsession\">Editer</A>" : "Editer"));
      $c->addChamp($x);
      $form->addChamp($c);
      $c = new TPanel(1, 1);
      $x = new Label (($valeur[4] ? "<A HREF=\"$fichier?action=$this->action3&item=$valeur[0]" .
                                    "&sessionid=$this->idsession\">Supprimer</A>" : "Supprimer"));
      $c->addChamp($x);
      $form->addChamp($c);
    }

    $form->addLigne();
    $c = new TPanel(6, 1, "RIGHT");
    $x = new Bouton("Retour", "Retour", "SUBMIT");
    $c->addChamp($x);
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $form->addChamp($c);
    $this->vitrine = $this->entete . $form->getContenu() . $this->pied;
  }
  /**
  * Ajout ou dition d'un compte
  */
  function nouveauCompte(){
    global $fichier, $champs, $item;
    if ($this->n_erreur) return;
    for ($i = 0; $i < 10; $i++){
      if (! isset($champs[$i])) {
        $champs[$i] = "";
      }
    }
    if (! $champs[7]){
       $champs[7] = "RIEN";
    }
    for ($i = 0; $i<count($champs); $i++){
      $champs[$i] = $this->session->deguille($champs[$i]);
    }
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action4", "POST");
    $c = new TPanel(6,1,"CENTER");
    $x = new Label(($champs[5] ? "Modification d'un compte" : "Ajout d'un compte"), true);
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6,1);
    $x = new Label("<B>Abonn&eacute; :</B> $champs[0] &nbsp;&nbsp;&nbsp;<B>Nom :</B> $champs[1]" . ($champs[2] ? ", $champs[2]" : ""));
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    if ($champs[3]=="oui"){
      $c = new TPanel(6,1);
      $x = new Label("<B>M&eacute;decin</B> &nbsp;&nbsp;&nbsp;-&nbsp;&nbsp;&nbsp; <B>Membre de l'AMESLO :</B> $champs[6]");
      $c->addChamp($x);
      $form->addChamp($c);
      $form->addLigne();
    }
    if ($champs[5]){
      $c = new TPanel(6,1);
      $x = new Label("<B>Compte utilisateur :</B> $champs[5]");
      $c->addChamp($x);
      $form->addChamp($c);
      $form->addLigne();
    }
    $c = new TPanel(6,1);
    $x = new Label("Groupe :", true);
    $c->addChamp($x);
    $x = new Espace(5);
    $c->addChamp($x);
    $x = new ListOpt("champs[7]", $champs[7]);
    $groupes = $this->session->recupGroupe();
    for ($i = 0; $i < count($groupes); $i++){
      $x->addOption($groupes[$i][1], $groupes[$i][0]);
    }
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();

    $c = new TPanel(6, 1);
    $x = new ChampTexte("champs[8]", $champs[8], "<B>Nom d'utilisateur :</B>", 20, 20);
    $c->addChamp($x);
    $x = new Espace(3);
    $c->addChamp($x);
    $x = new ChampTexte("champs[9]", $champs[9], "<B>Fax :</B>", 20, 20);
    $c->addChamp($x);
    $x = new Espace(3);
    $c->addChamp($x);
    $x = new ChampTexte("champs[10]", $champs[10], "<B>E-mail :</B>", 25, 25);
    $c->addChamp($x); 
    $form->addChamp($c);
    $form->addLigne();

    $c = new TPanel(6, 1);
    $x = new ChampTexte("champs[2]", "", "<B>Mot de passe :</B>", 20, 20, false, "password");
    $c->addChamp($x);
    $x = new Espace(5);
    $c->addChamp($x);
    $x = new Label(($champs[5] ? "Laissez en blanc pour ne pas modifier" : "Le mot de passe sera stock sous forme encrypte"));
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6,1, "RIGHT");
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("champs[5]", "$champs[5]", "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("item", "$item", "HIDDEN");
    $c->addChamp($x);

    $x = new Bouton("Enregistrer", "Abandonner", "SUBMIT");
    $c->addChamp($x);
    $x = new Espace(3);
    $c->addChamp($x);
    $x = new Bouton("Enregistrer", "Enregistrer", "SUBMIT");
    $c->addChamp($x);
    $form->addChamp($c);
    $this->vitrine = $this->entete . $form->getContenu() . $this->pied;
  }

  /**
  * validation des donnes saisies
  */
  function valCompte() {
    global $champs;
    if ($this->n_erreur) return;
    if (! $this->session->contrCaract($champs[8])) { //caractres illgaux dans le nom d'utilisateur
      $this->n_erreur = 1114;
      return;
    }
    if (strlen($champs[8]) < 5 OR strlen($champs[8]) > 20) { //Nom d'utilisateur trop court ou trop long
      $this->n_erreur = 1115;
      return;
    }
    if (! $this->session->contrCaract($champs[2])) { //caractres illgaux dans le mot de passe
      $this->n_erreur = 1004;
      $champs[2] = "";
      return;
    }
    if ($champs[2] AND (strlen($champs[2]) < 5 OR strlen($champs[2]) > 20)) { //Mdp trop court ou trop long
      $this->n_erreur = 1003;
      $champs[2] = "";
      return;
    }
    if ($this->enrCompte()){
      $co = new cadropt("Orange", 50);
      $co->LitContenu("<TR><TD><H3>Le compte a &eacute;t&eacute; enregistr&eacute;</H3></TD></TR>");
      $co->imprime();
    }
    else {
      $co = new cadropt("red", 50);
      $co->LitContenu("<TR><TD><H3>Erreur inattendue lors de l'enregistrement !!!</H3></TD></TR>");
      $co->imprime();
    }
  }

  /**
  * lecture de la liste des comptes
  * @return array la liste des comptes
  */
  function recupCompte(){
    if ($this->n_erreur) return;
    return $this->session->recupCompte();
  }

  /**
  * enregistrement d'un compte
  * @return boolean
  */
  function enrCompte(){
    if ($this->n_erreur) return;
    return $this->session->enrCompte();
  }

  /**
  * destrutcion d'un compte
  */
  function detrCompte($item){
    if ($this->n_erreur) return;
    if (! $this->session->detrCompte($item)){
      $co = new cadropt("red", 50);
      $co->LitContenu("<TR><TD><H3>Erreur inattendue lors de la suppression !!!</H3></TD></TR>");
      $co->imprime();
    }
  }

  /**
  * affichage de la liste des autorisations
  */
  function listeAut(){
    global $fichier, $champs;
    if ($this->n_erreur) return;
    if (strlen($champs[0]) > 0){
      $rep = $this->session->addAut();
      if (! $rep){
        $this->ad_erreur = 1117;
      }
      else {
        $champs[0] = "";
        $champs[1] = "";
      }
    }

    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c = new TLabel("Autorisations - Liste des fonctions<BR><BR>", true);
    $c->setColSpan("6");
    $c->setAlign("CENTER");
    $form->addChamp($c);
    $auts = $this->session->recupAut();
    $form->addLigne();
    $c = new TPanel(5, 1);
    $x = new ChampTexte("champs[0]", $champs[0], "<B>Nouvel item :</B> Libell&eacute;", 17, 15);
    $c->addChamp($x);
    $x = new Espace(3);
    $c->addChamp($x);
    $x = new ChampTexte("champs[1]", $champs[1], "Descriptif", 35, 30);
    $c->addChamp($x);
    $form->addChamp($c);
    $c = new TPanel(1,1, "RIGHT");
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("Ajouter", "Ajouter", "SUBMIT");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TLabel("<BR><BR><B>Items existants :</B>");
    $c->setColSpan(6);
    $form->addChamp($c);
    while (list ($cle, $valeur) = each ($auts)){
      $form->addLigne();
      $c = new TPanel(3,1);
      $x = new Label("$valeur[1] ($valeur[0])");
      $c->addChamp($x);
      $form->addChamp($c);
      $c = new TPanel(3,1);
      $x = new Label("<A HREF=\"$fichier?action=$this->action2&item=$valeur[0]&sessionid=$this->idsession\">Supprimer</A>");
      $c->addChamp($x);
      $form->addChamp($c);
    }
    $form->addLigne();
    $c = new TPanel(6, 1, "RIGHT");
    $x = new Bouton("Ajouter", "Retour", "SUBMIT");
    $c->addChamp($x);
    $form->addChamp($c);
    $this->vitrine = $this->entete . $form->getContenu() . $this->pied;
  }

  /**
  * destruction d'une autorisation
  */
  function detrAut(){
    if ($this->n_erreur) return;
    $this->session->detrAut();
  }

  /**
  * affichage de la liste des groupes
  */
  function listeGroupes(){
  #Liste des groupes d'utilisateurs
    global $fichier, $champs;
    if ($this->n_erreur) return;
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c = new TLabel("Groupes d'utilisateurs - Gestion des autorisations", true);
    $c->setColSpan("6");
    $c->setAlign("CENTER");
    $form->addChamp($c);
    $form->addLigne();
    $c = new TLabel("<A HREF=\"$fichier?action=$this->action2&sessionid=$this->idsession\">Ajouter groupe</A>");
    $c->setColSpan(6);
    $form->addChamp($c);
    $items = $this->session->recupGroupe();
    while (list ($cle, $valeur) = each ($items)){
      $form->addLigne();
      $c = new TPanel(4, 1);
      $x = new Label("<B>$valeur[0]</B> - $valeur[1] <I>($valeur[2])</I>");
      $c->addChamp($x);
      $form->addChamp($c);
      $c = new TPanel(1, 1);
      $x = new Label("<A HREF=\"$fichier?action=$this->action2&item=$valeur[3]&sessionid=$this->idsession\">Editer</A>");
      $c->addChamp($x);
      $form->addChamp($c);
      $c = new TPanel(1, 1);
      $x = new Label("<A HREF=\"$fichier?action=$this->action3&item=$valeur[3]&sessionid=$this->idsession\">Supprimer</A>");
      $c->addChamp($x);
      $form->addChamp($c);
    }
    $form->addLigne();
    $c = new TPanel(6, 1, "RIGHT");
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("Retour", "Retour", "SUBMIT");
    $c->addChamp($x);
    $form->addChamp($c);

    $this->vitrine = $this->entete;
    $this->vitrine .= $form->getContenu();
    $this->vitrine .= $this->pied;
  }

  /**
  * ajout ou dition d'un groupe
  */
  function nouvGroupe(){
  #Ajout-dition d'un groupe
    global $fichier, $champs, $item, $opts;
    if ($this->n_erreur) return;
    if (empty($champs)) {
      $champs[0] = "";
      $champs[1] = "";
    }
    for ($i = 0; $i<count($champs); $i++){
      $champs[$i] = $this->session->deguille($champs[$i]);
    }
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c = new TLabel("Groupe - Gestion des autorisations", true);
    $c->setColSpan("6");
    $c->setAlign("CENTER");
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6, 1);
    $x = new ChampTexte("champs[0]", $champs[0], "Abr&eacute;viation&nbsp;:<BR><I>Majuscules uniquement</I>", 12, 10);
    $c->addChamp($x);
    $x = new Espace(5);
    $c->addChamp($x);
    $x = new ChampTexte("champs[1]", $champs[1], "Libell&eacute;&nbsp;:", 22, 20);
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TLabel("Choix des autorisations :");
    $c->setAlign("RIGHT");
    $form->addChamp($c);
    $c = new TPanel(5, 1);
    $groupes = $this->session->recupAut();
    $x = new ListOpt("opts[]", $opts, true, 5);
    $x->addOption("--- Aucune ---", "");
    while (list ($cle, $valeur) = each ($groupes)){
      $x->addOption("$valeur[1] ($valeur[0])", $valeur[0]);
    }
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TLabel("Fonctions autoris&eacute;es&nbsp;: <FONT COLOR=\"red\">" .
                    (is_array($opts) ? implode(",", $opts) : "") . "</FONT>");
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(6, 1, "RIGHT");
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("item", $item, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("Valider", "Retour", "SUBMIT");
    $c->addChamp($x);
    $x = new Espace(2);
    $c->addChamp($x);
    $x = new Bouton("Valider", "Valider", "SUBMIT");
    $c->addChamp($x);
    $form->addChamp($c);
    $this->vitrine = $this->entete;
    $this->vitrine .= $form->getContenu();
    $this->vitrine .= $this->pied;
  }

  /**
  * lecture des champs d'un groupe
  * @return array
  */
  function recupMGroupe($item){
    return $this->session->recupMGroupe($item);
  }
  
  /**
  * lecture des autorisations d'un groupe
  * @return string
  */
  function recupMOpt($item){
    return $this->session->recupMOpt($item);
  }

  /**
  * vrification des donnes lors de la cration-modification d'un groupe
  */
  function verifGroupe(){
    global $champs, $opts, $item;
    $champs[0] = preg_replace("/[^A-Z]/", "", $champs[0]);
    if (! $champs[0] OR ! $champs[1]){
      $this->ad_erreur = 1118;
      return;
    }
    if ($this->session->addGroupe()){
      $co = new cadropt("orange", 70);
      $co->LitContenu("<TR><TD><H3>Op&eacute;ration r&eacute;ussie&nbsp;!</H3></TD></TR><TR><TD><P>");
      $co->imprime();
    }
    else {
      $this->ad_erreur = 1119;
    }
  }
  
  /**
  * suppression d'un groupe
  */
  function detrGroupe($item){
    $this->session->detrGroupe($item);
  }
  
  /**
  * affichage du formulaire
  */
  function imprime(){
    if ($this->n_erreur) return;
    print $this->vitrine;
  }
}

?>
