<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Contenant de 3e niveau permettant de raccrocher les contenants graphiques de 2e niveau aux sessions et aux donnes
* @package donnes
*/
/**
* Contenant de 3e niveau permettant de raccrocher les contenants graphiques de 2e niveau aux sessions et aux donnes
* Cet objet hrite de connexionBrioche, et donc d'une session. Il permet de grer l'affichage du contenu graphique
* en tenant compte de la validit de la session et des autorisations
* <pre>
* Exemple :
* class monForm extends cadreSimple {
*   function monForm($largeur, $fondpage, $idsession) {
*     if (! $this->cadreSimple($largeur, $fondpage, $idsession) return false;
*     $of = new TabForm();
*     ... ajout de contenants  $of ...
*     $this->addContenu($of->getContenu);
*   }
* }
* </pre>
* @package donnes
* @author ob
*/
class cadreSimple extends connexionBrioche {
  /**
  * largeur (pixels ou %)
  * @var string
  */
  var $largeur;
  
  /**
  * le contenu HTML de l'objet (corps central)
  * @var string
  */
  var $contenu;
  
  /**
  * l'en-tte de l'objet (HTML)
  * @var string
  */
  var $entete;
  
  /**
  * le pied de l'objet (HTML)
  * @var string
  */
  var $pied;
  
  /**
  * le contenu HTML total
  * @var string
  */
  var $sortie;
    
  /**
  * variable non utilise (ne concerne que cadronglet !)
  * @var string
  */
  var $fondpage;


  /**
  * @param string largeur, cf. variable de classe
  * @param string fondpage, cf. variable de classe (pas utilise)
  * @param string sessionid, cf. variable de classe
  * @param array autspec, les autorisations spcifiques permettant l'accs, indpendamment de l'autorisation principale
  * @return boolean la session est-elle OK ?
  */
  function __construct($largeur, $fondpage, $sessionid, $autspec=0){
    if (! parent::__construct($sessionid, $autspec)) return false;
    
    if (preg_match("/%/", $largeur)) { // Conversion si nc. de largeur en valeur absolue
      $largeur = preg_replace("/%/", "", $largeur) * $this->largeurecran / 100;
    }
    if (! $largeur) $largeur = 800;
    $this->largeur = $largeur;
    $this->fondpage = $fondpage;
    $this->pied = "\n<CENTER>\n<TABLE WIDTH=\"90%\"><TR><TD><IMG SRC=\"images/brioche100a.gif\" " .
                  "align=\"LEFT\"></TR></TABLE></CENTER>";
    return true;
  }

  /**
  * ajout d'un contenu graphique (HTML)
  * fonction utilise pour passer  l'objet cadre un contenant de deuxime niveau comme OngForm
  */
  function addContenu($cont){
    $this->contenu .= "$cont";
  }
  
  /**
  * permet de n'afficher que le contenu central lors, par exemple, de l'envoi d'une feuille Excel
  */
  function effaceEntete(){
    $this->entete = "";
    $this->pied = "";
  }
  
  /**
  * affiche le contenu HTML ( condition que la session soit OK)
  */
  function imprime(){
    if ($this->n_erreur){
      $b = new erreurB($this->n_erreur);
      //print "ERREUR $this->n_erreur";
    }
    else {
      $this->sortie = $this->entete . $this->contenu . $this->pied;
      print $this->sortie;
    }
  }
}
?>
