<?php
  // $Id: cadronglet.inc,v 1.2 2017/07/06 22:19:44 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

/**
* Cadre grant les onglets
* @package donnes
*/
/**
* Cadre grant les onglets
* S'utilise comme cadreSimple, mais permet en plus d'ajouter des onglets au haut du formulaire
* @package donnes
* @author ob
*/
class cadronglet extends cadreSimple {
  /**
  * couleur grise
  * @var string
  */
  var $grise;
  
  /**
  * la largeur totale des onglets
  * @var int
  */
  var $largonglets;
  
  /**
  * l'onglet actif (correspond en principe  une action)
  * @var int
  */
  var $actif;
  
  /**
  * le contenu de la bande (sous l'onglet)
  * @var array
  */
  var $bande;
  
  /**
  * la couleur de la bande
  * @var string
  */
  var $coulbande;

  /**
  * @param string largeur, la largeur totale  passer au parent
  * @param string grise, la couleur du gris
  * @param string fondpage, la couleur de fond  passer au parent (mais cela ne sert  rien !)
  * @param string sessionid, l'identifiant de session  passer au parent
  * @param array $autspec, les autorisations spcifiques  passer au parent
  * @return boolean, la session est-elle OK ?
  */
  function __construct($largeur, $grise, $actif, $fondpage, $sessionid, $autspec=0){
    if (! parent::__construct($largeur, $fondpage, $sessionid, $autspec)) return false;
    $this->grise = $grise;
    $this->actif = $actif;
    $this->entete = "<CENTER><TABLE WIDTH=\"$this->largeur\" BORDER=0 CELLSPACING=0 CELLPADDING=0 " .
                    "BGCOLOR=\"$this->grise\"><TR>\n";
    $this->pied = "";
    $this->pied = "</TR></TABLE>\n" . 
      "<TABLE WIDTH=\"$this->largeur\" align=\"CENTER\">" .
      //"<TR><TD><IMG SRC=\"images/brioche100a.gif\" " .
      //"align=\"LEFT\"></TR>" .
      "</TABLE></CENTER><BR><BR>";
    return true;
  }


  /**
  * ajout d'un onglet
  * @param string texte le texte de l'onglet
  * @param string textebande le texte  inscrire dans la bande d'en dessous
  * @param string couleur la couleur de l'onglet
  * @param string numero le numro de l'onglet (sera compar avec actif pour dterminer quel onglet afficher)
  * @param int largeur la largeur de cet onglet
  * @param string href le lien html  associer  l'onglet
  */
  function addOnglet($texte, $textebande, $couleur, $numero, $largeur, $href){
    if ($numero != $this->actif){
      $couleur = $this->grise;
      $coultxt = "black";
    }
    else {
      $href = "";
      $coultxt = "white";
      $this->bande = $textebande;
      $this->coulbande = $couleur;
    }
    $this->entete .= "<TD BGCOLOR=\"$couleur\" WIDTH=\"$largeur\"><CENTER><FONT COLOR =\"$coultxt\">" .
                     ($href ? "<A HREF=\"$href\">$texte</A>" : "<B>$texte</B>") . "</FONT></CENTER></TD>".
                     "<TD WIDTH=1 BGCOLOR=\"#808080\"><IMG WIDTH=1 HEIGHT=1 ALT=\"\"></TD>".
                     "<TD WIDTH=1 BGCOLOR=\"#ffffff\"><IMG WIDTH=1 HEIGHT=1 ALT=\"\"></TD>\n";
    $this->largonglets += $largeur;
  }

  /**
  * fonction  excuter aprs l'insertion du dernier onglet. Dessine le "vide"  droite.
  */
  function colmateOnglets(){
    $this->entete .= "<TD BGCOLOR=\"$this->fondpage\">&nbsp;</TD>" .
      "</TR></TABLE><TABLE WIDTH=\"$this->largeur\" BORDER=0 CELLPADDING=5 CELLSPACING=0>" . //Ce border pour la bande de l'onglet
      "<TR><TD WIDTH=\"40%\" BGCOLOR=\"$this->coulbande\"><FONT COLOR=\"white\"><B>" . $this->bande[0] . "&nbsp;&nbsp;" .
      $this->bande[1] . "</B></FONT></TD>" .
      "<TD  WIDTH=\"40%\" BGCOLOR=\"$this->coulbande\"><FONT COLOR=\"white\"><B>" . $this->bande[2]  .
      $this->bande[4] . "</B></FONT></TD>" .
      "<TD  ALIGN = RIGHT WIDTH=\"20%\" BGCOLOR=\"$this->coulbande\"><FONT COLOR=\"white\"><B>"  .
      $this->bande[3] . "</B></FONT></TD>" .
      "</TR></TABLE>\n";
  }
  
  /* Fonction plus ncessaire. Heureusement : elle n'avait rien  faire ici !
  #fonction pratique pour les listes et tats
  function get_nomEtabl($noet) {
	  
      if ($noet == '' || $noet == '--') $noet = 0;		
	  $query = "SELECT nomet FROM etablissements WHERE noet = $noet";
	  $result = mysql_query($query);
	  $nom = mysql_fetch_assoc($result);
	  return $nom['nomet'];
	}
  */
}
?>
