<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Calendrier
* @package donnes
*/
/**
* Calendrier
* Encapsule la table "calendrier" de la base dbrio et mule des fonctions de type mcal
* Remplace la bibliothque mcal (dcidemment trop bugge) pour grer les vnements utiliss
* pour le planning
* @package donnes
* @author ob
*/
class calendrier extends connexionBrioche {
  /**
  * l'objet ensTableBrioche accdant  la table "calendrier"
  * @var object ensTableBrioche
  */
  var $table;
  /**
  * l'objet updateTableBrioche pour crire dans la table "calendrier"
  * @var object updateTableBrioche
  */
  var $ut;
  
  /**
  * @param string sessionid l'identifiant de session,  passer  l'objet parent
  * @param array autspec les autorisations spcifiques,  passer  l'objet parent
  */
  function calendrier($sessionid, $autspec){
    if (! $this->connexionBrioche($sessionid, $autspec)) return;
    $this->table = new ensTableBrioche("calendrier", "1", "*", "debut", $sessionid, 0, 0, false, $autspec);
    $this->ut = new updateTableBrioche("calendrier", "", "", "noev", $this->idsession, "", $this->autspec);
  }
  
  /**
  * obtention du tableau des vnements compris dans une priode donne
  * @param int andeb l'anne du dbut
  * @param int moisdeb le mois du dbut
  * @param int jourdeb le quantime du dbut
  * @param int anfin l'anne de la fin
  * @param int moisfin le mois de la fin
  * @param int jourfin le quantime de la fin
  * @return array le tableau des vnements
  */
  function listEvents($andeb, $moisdeb, $jourdeb, $anfin, $moisfin, $jourfin){
    $where = "debut > \"$andeb-$moisdeb-$jourdeb\" AND fin < \"$anfin-$moisfin-$jourfin\" AND actif > 0";
    $this->table->setWhere($where);
    $tblev = $this->table->getTableau();
    return $tblev;
  }
  
  /**
  * obtention d'un vnement d'aprs son identifiant
  * @param int titre l'idendifiant de l'vnement
  * @return object ev l'objet dont les proprits sont les champs de l'vnement
  */
  function fetchEvent($titre){
    $where = "noev = $titre";
    $this->table->setWhere($where);
    $tblev = $this->table->getTableau();
    if (count($tblev)) {
      return $tblev[0];
    }
    else {
      return false;
    } 
  }
  
  /**
  * cration d'un nouvel vnement
  * @return object ev l'vnement cr
  */
  function eventInit(){
    $noev = $this->table->creeNouveau("noev");
    $tabchamps['actif'] = 1;
    $this->ut->setItem($noev);
    $this->ut->setTabChamps($tabchamps);
    $this->ut->update();
    $ev = $this->fetchEvent($noev);
    return $ev;
  }
  
  /**
  * mise  jour des champs d'un vnement
  * @param int id l'idientifiant de l'vnement
  * @param array tabchamps un tableau associatif dont les cls sont les noms des champs et les valeurs la valeur correspondante
  * @return boolean mise  jour OK ?
  */
  function setChamps($id, $tabchamps){
    $this->ut->setItem($id);
    $this->ut->setTabChamps($tabchamps);
    return $this->ut->update();
  }
  
  /**
  * suppression d'un vnement
  * @param int id l'identifiant de l'vnement
  * @return boolean la suppression s'est-elle faite ?
  */
  function deleteEvent($id){
    $this->ut->setItem($id);
    $tabchamps['actif'] = "NULL";
    $this->ut->setTabChamps($tabchamps);
    return $this->ut->update();
  }
    
  /**
  * recherche des vnements  fusionner (fragments de sjours remis dans le mme lit)
  * @return object le premier couple d'vnements  fusionner (la fonction est a appeler de manire itrative en fusionnant
  * chaque fois le premier couple jusqu' plus soif).
  */
  function getAFusionner(){
    
    $query = "SELECT count(*) as count, group_concat(noev,'___',debut,'___',fin) as concat
          FROM calendrier WHERE actif = 1 AND nodoss != -999 AND tst > 19700102000000
          GROUP BY nodoss, etablissement, chambre, lit HAVING count = 2";
    $query = mysql_query($query);
    
    $cpt = 0;
    while ($result = mysql_fetch_object($query)) {
      list($prems,$deuz) = explode(",",$result->concat);
      $prems = explode("___",$prems);
      $deuz = explode("___",$deuz);
      if ($prems[1] == $deuz[2] || $prems[2] == $deuz[1]) {
        $returnObject = new stdClass();
        $returnObject->noev = $prems[0];
        $returnObject->noev1 = $deuz[0];
        $cpt++; break;
      }       
    }

    if ($cpt) return $returnObject;
    else return false;
    
    /*$et = new ensTableBrioche("calendrier",
                              "calendrier.actif = 1 and calendrier1.actif = 1 and calendrier.noev > calendrier1.noev " .
                              "and (calendrier.fin = calendrier1.debut or calendrier.debut = calendrier1.fin) " .
                              "and calendrier.chambre = calendrier1.chambre and calendrier.lit = calendrier1.lit " .
                              "and calendrier.etablissement = calendrier1.etablissement",
                              "calendrier.noev, calendrier1.noev as noev1",
                              "calendrier.noev",
                              $this->idsession,
                              "calendrier as calendrier1",
                              "calendrier.nodoss = calendrier1.nodoss AND calendrier.nodoss != -999");
    $tet = $et->getTableau();
    
    $cpt = count($tet);
    if ($cpt) return $tet[0];
    return false;*/                      
  }
  
  /**
  * suppression de la mention "court sjour prcdent" lorsque celui-ci a t supprim
  */
  function nettoieEnchainements(){
    $et = new ensTableBrioche("calendrier",
                              "calendrier.csprec is not null " .
                              "AND calendrier.actif = 1 AND calendrier1.actif IS NULL",
                              "calendrier.noev",
                              0,
                              $this->idsession,
                              "calendrier as calendrier1",
                              "calendrier.csprec = calendrier1.noev");
    $tet = $et->getTableau();
    $cpt = count($tet);                          
    for ($i = 0; $i < $cpt; $i++){
      $this->ut->setItem($tet[$i]->noev);
      $tabchamps['csprec'] = "NULL";
      $this->ut->setTabChamps($tabchamps);
      $this->ut->update();
    }
  }
}
