<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Changement de mot de passe
* @package formulaires
*/
/**
* Changement de mot de passe
* Permet  l'utilisateur de modifier son mot de passe de connexion
* Accessible depuis le menu principal de Herms et de Brioche
* @package formulaires
* @author ob
*/
class chMdp extends cadropt{
  /**
  * l'identifiant de session
  * @var string
  */
  var $idsession;
  
  /**
  * l'action associe au formulaire
  * @var action
  */
  var $action;
  
  /**
  * le numro d'une erreur de session
  * @var int
  */
  var $n_erreur = 0;
  
  /**
  * le contenu HTML
  * @var string
  */
  var $vitrine;
  
  /**
  * l'objet session associ
  * @var object
  */
  var $session;
  
  /**
  * numro d'une erreur de saisie
  * @var int
  */
  var $ad_erreur;

  /**
  * @param string no cf. variable de classe idsession
  * @param int act cf. variable de classe action
  */
  function __construct($no, $act){
    parent::__construct("#009966",90);
    $this->idsession = $no;
    $this->action = $act;
    $this->session = new Session($this->idsession);
    if (!$this->verifSess($this->session)){
      return;
    }
  }
  
  /**
  * vrification de la session associe et de l'autorisation chMdp
  * @param object session la session invoque
  * @return boolean la session est-elle OK ?
  */
  function verifSess($ss){
    if($ss->n_erreur){
      $this->n_erreur = $ss->n_erreur;
      return 0;
    }
    if(! preg_match("/chMdp/", $ss->autorisations)){
      $this->n_erreur = 1001;
      return 0;
    }
    else return 1;
  }
    
  /**
  * construction de l'affichage dans le menu principal
  */
  function faitVitrine(){
    global $fichier;
    if ($this->n_erreur) return;
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c = new TLabel("Prenez l'habitude de changer votre mot de passe de temps &agrave; autre&nbsp;!");
    $c->setColSpan(2);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(1, 1, "", "", "50%");
    $x = new Label("&nbsp;");
    $c->addChamp($x);
    $form->addChamp($c);
    $c = new TPanel(1,1, "CENTER", "", "60%");
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("bchmdp", "Changer le mot de passe", "SUBMIT");
    $c->addChamp($x);
    $form->addChamp($c);

    $this->vitrine = $this->entete;
    $this->vitrine .= $form->getContenu();
    $this->vitrine .= $this->pied;
  }

  /**
  * construction du formulaire permettant de changer le mot de passe
  */
  function faitFormulaire(){
    global $fichier;
    if ($this->n_erreur) return;
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c = new TPanel(1, 1, "RIGHT", "", "50%");
    $x = new Label("Entrez ici votre mot de passe <FONT COLOR=\"red\">actuel</FONT> :");
    $c->addChamp($x);
    $form->addChamp($c);
    $c = new TChampTexte("mdpact", "", "", 20, 20, "", "PASSWORD");
    $form->addChamp($c);
    $form->addLigne();
    $c = new TLabel("Entrez une premi&egrave;re fois votre <FONT COLOR=red>nouveau</FONT> mot de passe :");
    $c->setAlign("RIGHT");
    $form->addChamp($c);
    $c = new TChampTexte("mdpnouv1", "", "", 20, 20, "", "PASSWORD");
    $form->addChamp($c);
    $form->addLigne();
    $c = new TLabel("Entrez une seconde fois votre <FONT COLOR=red>nouveau</FONT> mot de passe :");
    $c->setAlign("RIGHT");
    $form->addChamp($c);
    $c = new TChampTexte("mdpnouv2", "", "", 20, 20, "", "PASSWORD");
    $form->addChamp($c);
    $form->addLigne();
    $c = new TLabel("Les mots de passe doivent compter entre 5 et 20 caract&egrave;res. " .
                    "Ils ne peuvent contenir que des lettres (non accentu&eacute;es) majuscules " .
                    "ou minuscules ainsi que des chiffres. Les espaces, tirets et autres " .
                    "caract&egrave;res sp&eacute;ciaux sont exclus. Attention ! Les lettres " .
                    "majuscules et minuscules n'ont pas la m&ecirc;me valeur : Si votre mot de " .
                    "passe est <I>BONJOUR</I>, <I>bonjour</I> sera refus&eacute;.");
    $c->setColSpan(2);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(2, 1, "RIGHT");
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("bmdp", "Abandonner", "SUBMIT");
    $c->addChamp($x);
    $x = new Espace(2);
    $c->addChamp($x);
    $x = new Bouton("bmdp", "Valider", "SUBMIT");
    $c->addChamp($x);
    $form->addChamp($c);
    $this->vitrine = $this->entete;
    $this->vitrine .= $form->getContenu();
    $this->vitrine .= $this->pied;
  }
  
  /**
  * vrification des donnes saisies dans le formulaire
  */
  function validation(){
    $ex = new extrVar();
    $ex->extrait("mdpact");
    $ex->extrait("mdpnouv1");
    $ex->extrait("mdpnouv2");
    $ex->extrait("bmdp");
    global $mdpact, $mdpnouv1, $mdpnouv2, $bmdp;;
    if ($this->n_erreur) return;
    if ($bmdp == "Abandonner"){
      return;
    }
    if (! $this->session->contrMdp($mdpact)) return;
    if (strlen($mdpnouv1) < 5 OR strlen($mdpnouv1) > 20){
      $this->ad_erreur = 1003;
      return;
    }
    if (! $this->session->contrCaract($mdpnouv1)){
      $this->ad_erreur = 1004;
      return;
    }
    if ($mdpnouv1 != $mdpnouv2){
      $this->ad_erreur = 1005;
      return;
    }
    $this->session->nouvMdp($mdpnouv1);
    parent::__construct("orange", 50);
    $this->vitrine = $this->entete;
    $this->vitrine .= "<TR><TD><H3>Votre nouveau mot de passe est valable imm&eacute;diatement&nbsp;!</H3></TD></TR>";
    $this->vitrine .= $this->pied;

  }

  /**
  * affichage du contenu HTML de l'objet
  */
  function imprime(){
    print $this->vitrine;
  }
}

?>
