<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Dfinition des chambres et des lits dans le planning des courts sjours
* @package formulaires
*/
/**
* Dfinition des chambres et des lits dans le planning des courts sjours
* Permet, pour les tablissement disposant d'un planning, de dfinir les chambres et les lits grs
* @package formulaires
* @author ob jdu
*/
class chambresLits extends cadreSimple {
  /**
  * @param string largeur la largeur du cadre
  * @param string fondpage la couleur de fond
  * @param int action l'action du formulaire
  * @param string sessionid l'identifiant de session
  * @param array recup un tableau de valeurs permettant, si la saisie n'est pas valide,
  * de shunter la base de donnes
  * @param int action2 (suppression d'un lit)
  */
  function chambresLits($largeur, $fondpage, $action, $sessionid, $recup=0, $action2=0, $item=-1){
    global $fCourSej;
    if(! $this->cadreSimple($largeur, $fondpage, $sessionid)) return;
    $tf = new TabForm();
    $tf->setTabParam($largeur, 0, 3, 0, $fondpage);
    $tf->setFormParam("donnees", $fCourSej, "post");
    $chlits = new EnsTableBrioche("litscourtsejour", 1, "*, if(litscourtsejour.horsStats=0,'non','oui') as horsStats", 
                                  "etabl, chambre, lit", $this->idsession,
                                  "etablissements", "litscourtsejour.etabl = etablissements.noet");
    $litscourtsejour = $chlits->getTableau($recup);
    if (is_array($litscourtsejour) && isset($litscourtsejour[0])){
      if ($item > 0) {
        $litscourtsejour = new EnsTableBrioche("litscourtsejour", "id = $item", "*", "etabl, chambre, lit", $this->idsession,
                                               "etablissements", "litscourtsejour.etabl = etablissements.noet");
        $litscourtsejour = $litscourtsejour->getTableau($recup);
      }
      $litscourtsejour = $litscourtsejour[0];
    }
    $etablissements = new EnsTableBrioche("etablissements", "courplan = -1", "noet, nomet, actif",
                                          "actif,groupepriorite,nomet", $this->idsession);
    $c = new TPanel(6, 1);
    $x = new Label("<H3>Chambres et lits</H3>");
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TPanelTableau(8, 1, $chlits, "#ffffff", "litscourtsejour", "id", "nomet");
    $x = new Label("", false, false, false, "chambre");
    $c->addColChamp("Ch.", $x);
    $x = new Label("", false, false, false, "lit");
    $c->addColChamp("Lit", $x);
    $x = new Label("", false, false, false, "descr");
    $c->addColChamp("Desc.", $x);
    $x = new Label("", false, false, false, "debut");
    $c->addColChamp("Du", $x);
    $x = new Label("", false, false, false, "fin");
    $c->addColChamp("Au", $x);
    $x = new Label("", false, false, false, "horsStats");
    $c->addColChamp("Hors stat.", $x);
    $x = new Lien("", false, false, false, "id",
                  "javascript:supprimeCond('$fCourSej?action=$action2&item=&sessionid=$this->idsession', " .
                  "'Voulez-vous vraiment supprimer ce lit ?')", "images/croixtr.gif");
    $c->addColChamp("Effacer", $x, false, true, false, false, "CENTER");
    $x = new Lien("", false, false, false, "id",
                  "javascript:lienCond('$fCourSej?action=2&item=&sessionid=$this->idsession')", "images/edit.gif");
    $c->addColChamp("Slectionner", $x, false, true, false, false, "CENTER");
    $c->addTitres(true);
    $tf->addChamp($c);
    $c = new TPanel(1, 1, "RIGHT", "TOP");
    $x = new Label("<BR><BR><BR><BR>Etablissement&nbsp;:&nbsp;&nbsp;");
    $c->addChamp($x);
    $x = new ListOptTableEtabl("litscourtsejour[etabl]", $litscourtsejour->etabl, $etablissements, false, 0, "d2");
    $x->addDefaut("---", "");
    $x->addOptionsEtablissements("nomet", "noet");
    $c->addChamp($x);

    $x = new Label("<BR><BR>");
    $c->addChamp($x);
    
    $x = new ChampTexte("litscourtsejour[chambre]", $litscourtsejour->chambre, "Ch.&nbsp;:", 4, 4, false, "TEXT", "d2");
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $x = new ChampTexte("litscourtsejour[lit]", $litscourtsejour->lit, "Lit&nbsp;:", 4, 4, false, "TEXT", "d2");
    $c->addChamp($x);
    $x = new Label("<BR><BR>");
    $c->addChamp($x);
    
    $x = new ChampTexte("litscourtsejour[descr]",$litscourtsejour->descr,"Description :", 4, 4,false,"TEXT","d2");
    $c->addChamp($x);
    $x = new Label("<BR><BR>");
    $c->addChamp($x);
    
    $x = new ChampTexte("litscourtsejour[debut]", $litscourtsejour->debut, "Lit disponible du&nbsp;:&nbsp;", 15, 15, false, "text", "d2",
                                "controleDate('litscourtsejour[debut]', '', 365, 365,'litscourtsejour[debut]','litscourtsejour[fin]')", "", false, true);
    $c->addChamp($x);
    $x = new Label("<BR><BR>");
    $c->addChamp($x);
    $x = new ChampTexte("litscourtsejour[fin]", $litscourtsejour->fin, "jusqu'au&nbsp;:&nbsp;", 15, 15, false, "text", "d2",
                                "controleDate('litscourtsejour[fin]', '', 365, 365,'litscourtsejour[debut]','litscourtsejour[fin]')", "", false, true);
    $c->addChamp($x);
    $x = new Label("<BR><BR>");
    $c->addChamp($x);
    
    $x = new CheckBox("litscourtsejour[horsStats]", "-1", "Hors statistiques", $litscourtsejour->horsStats, false, "", "avant");
    $c->addChamp($x);
    $x = new Label("<BR><BR>");
    $c->addChamp($x);
    
    $x = new Bouton("Modifier", "Modifier lit", "SUBMIT");
    $c->addChamp($x);
    $x = new Label("<BR><BR>");
    $c->addChamp($x);
    $x = new Bouton("Ajouter", "Ajouter lit", "SUBMIT");
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("action", $action, "HIDDEN");
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $x = new Bouton("Fermer", "Fermer", "BUTTON", "window.opener.document.forms.donnees.submit();window.close()");
    $c->addChamp($x);
    $x = new Label("<BR><BR><p align=justify style='padding:5px;'>
    <b>1) Chambre et lit :</b> seuls des chiffres sont possibles <br/><br/>
    <b>2) Description :</b> permet d'afficher sur le planning, en regard de chaque lit, un sigle de 4 lettres et/ou chiffres.
    A utiliser pour dfinir les caractristiques particulires d'un lit (p.ex. barrires architecturales) <br/><br/>
    <b>3) Lit disponible du / au :</b> la dfinition d'une priode de disponibilit du lit empche d'attribuer des sjours 
    hors de cette priode.
    A utiliser lorsqu'un nouveau lit est cr, supprim, ou qu'il a une dure d'existence limite : 
    graphiquement, le lit devient \"blanc\" hors de ces priodes ou disparat du planning les mois o il n'est pas disponible.
    Les journes ralises sur la priode de disponibilit sont nanmoins comptes dans les statistiques, 
    ainsi que les journes possible mais pour la seule priode dfinie par des dates. <br/><br/>
    <b>4) Hors statistiques :</b> exclut d'une manire gnrale un lit du calcul de nombre de journes possibles. 
    Les sjours qui s'y droulent sont nanmoins compts dans le calcul des journes ralises.
    A utiliser par exemple pour les lits \"tampon\" ou \"presse-papier\".</p>");
    $c->addChamp($x);
    $tf->addChamp($c);
    $this->addContenu($tf->getContenu());
  }
}



?>