<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Gestion du NPA et de la localit
* @package accessoires
*/
/**
* Gestion du NPA et de la localit
* Peut tre utilis  cheval sur 2 champs de formulaire quelconques
* en conjonction avec la fonction javascript controleNPA();
* Seule contrainte : il doit exister une table "localites" rpertoriant les 
* couples NPA - localit, et son schma doit correspondre  celui dfini pour briocheWeb
* @package accessoires
* @author ob
*/
class checkNPA extends cadronglet{
  /** le NPA
  * @var int
  */
  var $item;
  
  /**
  * la localit
  * @var string
  */
  var $issue;
  
  /**
  * nom du champ NPA
  * @var string
  */
  var $lcs;
  
  /**
  * nom du champ localit
  * @var string
  */
  var $litem;
  
  /**
  * nom du formulaire contenant les champs NPA et localit
  * @var string
  */
  var $ditem;
        
  /**
  * options 1 : contrle du NPA, 2 : contrle localit, 3 : contrle existence du couple enregistr
  * 4 : faut-il enregistrer un nouveau couple ? 5 : enregistrement d'un nouveau couple
  * @var int
  */      
  var $options;
  
  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param int action l'action principale
  * @param string fondpage la couleur du fond de page
  * @param int options cf. variable de classe
  * @param string sessionid l'identifiant de session
  * @param int item cf. variable de classe
  * @param string issue cf. variable de classe
  * @param string lcs cf. variable de classe
  * @param string litem cf. variable de classe
  * @param string ditem cf. variable de classe
  */
  function __construct($largeur, $grise, $action, $fondpage, 
                    $options, $sessionid, $item = "", $issue = "", $lcs = "", $litem = "", $ditem = ""){
    $ini = new briocheIni();
    $autspec = false;
    if (isset($ini->autSpec[1])) $autspec[0] = $ini->autSpec[1];
    
    if (! parent::__construct($largeur, $grise, $action, $fondpage, $sessionid, $autspec)) return;
    
    $this->options = $options;
    
    $this->item = $item;
    $this->litem = $litem;
    $this->ditem = $ditem;
    $this->lcs = $lcs;
    $this->issue = $issue;
  }  
  
  /**
  * affichage du contenu du formulaire
  */
  function affiche(){
    global $fdosbrioche;
    global $imagesdir;
    $tabbande = array("", "", "", "", "");
    switch ($this->options){
    case 1: // Contrle du NPA
      $et = new ensTableBrioche("localites", "nopost=$this->item",
                                "localite, " . 
                                "replace(localite, \"\'\", \"\\\'\") as qloc", 
                                "localite", $this->idsession, 0, 0, false, $this->autspec);
      $cpt = $et->compte();
      switch ($cpt) { 
      case 0:
        print "<SCRIPT Language=\"JavaScript\">" .
              "window.opener.document.forms['$this->ditem'].elements['$this->litem'].focus();" .
              "</SCRIPT>";
        $fe = new fermeFenetre(0, 1);
        break;
      case 1:
        $tet = $et->getTableau();
        $localite = $tet[0]->localite;
        print "<SCRIPT Language=\"JavaScript\">" .
              "changeChampOpener('$this->litem', '$localite', '$this->ditem');" .
              "window.opener.document.forms['$this->ditem'].elements['$this->litem'].focus();" .
              "</SCRIPT>";
        $fe = new fermeFenetre(0,1);
        break;
      default :
        $this->addOnglet("Recherche de la localit...", $tabbande, "orange", $this->actif, 150, "");
        $this->colmateOnglets();
        $of = new OngForm();
        $of->setTabParam($this->largeur, $this->coulbande, 6);
        $of->setFormParam("donnees", $fdosbrioche, "post");
        $c = new TPanelTableau(6, 1, $et, $this->grise, "donnees", "qloc");
        $x = new Label("", false, false, false, "localite");
        $c->addColChamp("Loc.", $x);
        $x = new BoutonImage("", "$imagesdir/vu.gif", 12, 12,
                         "javascript:changeChampOpener('$this->litem', '', '$this->ditem');" .
                         "window.opener.document.forms['$this->ditem'].elements['$this->litem'].focus();" .
                         "window.close();",
                         "qloc");
        $c->addColChamp("", $x, false, true);
        
        $of->addChamp($c);
        $of->addLigne(0.5);
        $this->addContenu($of->getContenu());
        $this->imprime();
        break;
      }
      break;
    case 2: // Contrle de la localit
      $et = new ensTableBrioche("localites", "localite=\"$this->issue\"",
                                "nopost", "nopost", $this->idsession, 0, 0, false, $this->autspec);
      $cpt = $et->compte();
      switch ($cpt) { 
      case 0:
        $fe = new fermeFenetre(0, 1);
        break;
      case 1:
        $tet = $et->getTableau();
        $nopost = $tet[0]->nopost;
        print "<SCRIPT Language=\"JavaScript\">" .
              "changeChampOpener('$this->lcs', '$nopost', '$this->ditem');" .
              "</SCRIPT>";
        $fe = new fermeFenetre(0,1);
        break;
      default :
        $this->addOnglet("Recherche du numro postal...", $tabbande, "orange", $this->actif, 150, "");
        $this->colmateOnglets();
        $of = new OngForm();
        $of->setTabParam($this->largeur, $this->coulbande, 6);
        $of->setFormParam("donnees", $fdosbrioche, "post");
        $c = new TPanelTableau(6, 1, $et, $this->grise, "donnees", "nopost");
        $x = new Label("", false, false, false, "nopost");
        $c->addColChamp("Nopost", $x);
        $x = new BoutonImage("", "$imagesdir/vu.gif", 12, 12,
                         "javascript:changeChampOpener('$this->lcs', , '$this->ditem');window.close();",
                         "nopost");
        $c->addColChamp("", $x, false, true);
        
        $of->addChamp($c);
        $this->addContenu($of->getContenu());
        $this->imprime();
        break;
      }
      break;
    case 3 : // Contrle prsence lors de l'enregistrement des coordonnes
      if ((! $this->item) || (! $this->issue)) return;
      $et = new ensTableBrioche("localites", "nopost = $this->item AND localite = \"$this->issue\"", 
                                "*", 0, $this->idsession);
      if (! $et->compte()){
        print "<SCRIPT Language=\"JavaScript\">" .
              "window.open('$fdosbrioche?action=$this->actif&sessionid=$this->idsession&item=$this->item&issue=$this->issue" .
              "&options=4', '$this->issue', " .
              "'scrollbars=yes,resizable=no,menubar=no,locationbar=no,height=150,width=350,screenX=150,screenY=100')" .
              "</SCRIPT>";
      }                          
      break;
    case 4 : // Bote de dialogue "Faut-il enregistrer la nouvelle paire ?"
      $this->addOnglet("Nouvelle paire...", $tabbande, "orange", $this->actif, 100, "");
      $this->colmateOnglets();
      $of = new OngForm();
      $of->setTabParam($this->largeur, $this->coulbande, 6);
      $of->setFormParam("donnees", $fdosbrioche, "post");
      $c = new TPanel(6, 1);
      $x = new Label("La paire <B>\"$this->item " . stripslashes($this->issue) . 
                     "\"</B> ne figure pas dans la base de donnes. " .
                     "Dsirez-vous l'enregistrer ?");
      $c->addChamp($x);
      $x = new Bouton("action", $this->actif, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("item", $this->item, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("issue", $this->issue, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("options", 5, "HIDDEN");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne(0.5);
      $c = new TPanel(6, 1, "RIGHT");
      $x = new Bouton("Oui", "Oui", "SUBMIT", "", "bok");
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      $x = new Bouton("Non", "Non", "BUTTON", "window.close();", "ban");
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $this->addContenu($of->getContenu());
      $this->imprime();
      break;
    case 5 :  // Enregistrement nouvelle paire
      $tabchamps['nopost'] = $this->item;
      $tabchamps['localite'] = stripslashes($this->issue);
      $ut = new updateTableBrioche("localites", $tabchamps, "", "", $this->idsession);
      $ut->ajouteEnr();
      $fe = new fermeFenetre(0, 1); 
      break;  
    }
  }
  
}







?>
