<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

/**
* Client soap pour se connectant au serveur central pour rcuprer des documents
* @package accessoires
*/
/**
* Client soap se connectant au serveur central pour rcuprer des documents
* ncessite la bibliothque nusoap
* @package accessoires
* @author ob
*/ 
class clientManege extends connexionBrioche {
  /**
  * le client invoqu
  * @var object soapclient
  */
  var $client;
  
  /**
  * l'identifiant de la session distante (sur le serveur soap Mange)
  * @var string
  */
  var $sessiondist;
  
  /**
  * @param string sessionid l'identifiant de la session locale
  */
  function clientManege($sessionid) {
    if (! $this->connexionBrioche($sessionid)) return;
    $ini = new briocheIni();
    $this->client = new soapclient_bis($ini->manegeURL);
    $this->sessiondist = $this->client->call('getSession', array($ini->manegeUtil,
                                       $ini->manegePw));
    //echo '<pre>' . htmlspecialchars($this->client->request, ENT_QUOTES) . '</pre>';
    //print $this->client->response;
    //print $this->sessiondist . "a";
  }  
    
    
  /**
  * envoi d'une demande d'orientation
  * @param int l'identifiant de l'envoi (champ nochoix de la table choixEMS)
  */
  function envoieDemande($nochoix){
    //Donnes  envoyer
    $ech = new ensTableBrioche("choixems", "1", "nochoix", 0, $this->idsession);
    $nodoss = $ech->lookUp("nodoss", "nochoix = $nochoix");
    $noet = $ech->lookUp("noems", "nochoix = $nochoix");
    $join[] = "dossiers";
    $on[] = "demandeor.nodoss = dossiers.nodoss";
    $join[] = "usagers";
    $on[] = "dossiers.nous = usagers.nous";
    $et = new ensTableBrioche("demandeor", "demandeor.nodoss = $nodoss", "demandeor.*, usagers.*", 0, $this->idsession,
                              $join, $on);
    $tet = $et->getTableau();
    $tab = $tet[0];
    //Adresse du BRIO destinataire
    $ead = new ensTableBrioche("etablissements", "noet = $noet", "adresseib", 0, $this->idsession);
    $tead = $ead->getTableau();
    $adresse = $tead[0]->adresseib;
    $response = $this->client->call('envoieDemande', array($this->sessiondist, $tab, $adresse));
    //print '<pre>' . htmlspecialchars($this->client->response, ENT_QUOTES) . '</pre>';
    //print_r($response);
    if($response > 0){
      //Suivi local
      $ensuivi = new ensTableBrioche("suivisenvoisib",
                                     "nochoix = $nochoix",
                                     "id", 0, $this->idsession);
      if ($ensuivi->compte()){
        $tensuivi = $ensuivi->getTableau();
        $nid = $tensuivi[0]->id;                               
      }
      else {
        $nid = $ensuivi->creeNouveau("id");                               
      }                               
      $tabchamps['adressedest'] = $adresse;
      $tabchamps['nochoix'] = $nochoix;
      $tabchamps['quittance'] = 0;
      $ut = new updateTableBrioche("suivisenvoisib", $tabchamps, $nid, "id", $this->idsession);
      $ut->update();
      $texte = "Votre demande a t transmise !";
    }
    else {
      $texte = "Problme de transmission... Veuillez ressayer plus tard.";
    }
    $al = new Alerte($texte);
    $al->imprime(); 
  }
  
  /**
  * va chercher les demandes interBRIOs en attente sur le serveur soap (Mange)
  */
  function getDemandes(){
    //Rcupration des demandes sur serveur Mange
    $response = $this->client->call('getDemandes', $this->sessiondist);
    if (! is_array($response)){
      print "<FONT COLOR=\"#ffffff\">ATTENTION : La rcupration des demandes interBRIOs " .
            "n'est pas possible actuellement. Si le problme persiste, veuillez " .
            "prendre contact avec votre administrateur.</FONT><BR><BR>";
      return;
    }
    $cpt = count($response);
    $ete = new ensTableBrioche("etablissements", "1", "noet", 0, $this->idsession);
    $ut = new updateTableBrioche("avaliderdem", "", "", "", $this->idsession);
    //Ecriture des demandes en local dans avaliderdem
    for ($i = 0; $i < $cpt; $i++){
      $tabchamps = $response[$i];
      $expediteur = $ete->lookUp("noet", "adresseib = \"" . $tabchamps['brioorigine'] . "\"");
      $nodemor = $tabchamps['nodemor'];
      $tabchamps['nomanege'] = $tabchamps['nodemor'];
      unset($tabchamps['nodemor']);
      unset($tabchamps['tst']);
      unset($tabchamps['dmd5']);
      $tabchamps['servplac'] = $expediteur; 
      $ut->setTabChamps($tabchamps);
      if ($ut->ajouteEnr($tabchamps)){
        //Mise  jour de la quittance sur le serveur Mange
        $response2 = $this->client->call('setQuittance', array($this->sessiondist, $nodemor, 2));
      }
    }
    $this->getQuittances();
  }
  
  /**
  * va chercher sur le serveur distant les quittances pour les demandes envoyes et les met  jour en local
  */
  function getQuittances(){
    $et = new ensTableBrioche("suivisenvoisib",
                              "quittance < 10 and suivisenvoisib.nochoix is not null and choixems.nodoss is not null",
                              "nodoss, adressedest",
                              0, $this->idsession, "choixems", "suivisenvoisib.nochoix = choixems.nochoix");
    if (! $et->compte()) return;
    $tab = $et->getTableau();                          
    $response = $this->client->call('getQuittances', array($this->sessiondist, $tab));
    //echo '<pre>' . htmlspecialchars($this->client->request, ENT_QUOTES) . '</pre>';
    //print '<pre>' . htmlspecialchars($this->client->response, ENT_QUOTES) . '</pre>';
    $cpt = count($response);
    //print_r($response);
    $ut = new updateTableBrioche("suivisenvoisib", "", "", "", $this->idsession);
    $ets = new ensTableBrioche("choixems", "1", "nochoix", 0, $this->idsession);
    $ete = new ensTableBrioche("etablissements", "1", "noet", 0, $this->idsession);
    for ($i = 0; $i < $cpt; $i++){
      $noet = $ete->lookUp("noet", "adresseib = \"" . $response[$i]['adressedest'] . "\"");
      if ($noet == '') $noet = 0;
      $nochoix = $ets->lookUp("nochoix", "nodoss = " . $response[$i]['nodoss'] . " AND noems = $noet");
      $ut->updateSpec("quittance", $response[$i]['quittance'],
                      "nochoix = $nochoix");
    }
  }
  
  /**
  * mise  jour d'une quittance distante lors de la validation ou du rejet d'une demande interBRIOs
  * @param int nomanege identifiant fourni par le serveur au moment du tlchargement et consign dans le champ
  * nomanege des tables avaliderdem et demandeor
  * @param int valeur la valeur que doit prendre la quittance (98 pour rejet, 99 pour acceptation)
  * @param int nodoss le numro de dossier (local)
  * @param int nous le numro d'usager (local)
  * @return boolean quittance du serveur (OK ou non)
  */
  function setQuittance($nomanege, $valeur, $nodoss = 0, $nous = 0){
    $response = $this->client->call('setQuittance', array($this->sessiondist, $nomanege, $valeur, $nodoss, $nous));
    //echo '<pre>' . htmlspecialchars($this->client->request, ENT_QUOTES) . '</pre>';
    //print '<pre>' . htmlspecialchars($this->client->response, ENT_QUOTES) . '</pre>';
    $this->getQuittances();
    return $response;
  }
  
  /**
  * mise  jour du rpertoire d'adresses interBRIOs ( faire appeler par un script quotidien)
  * se connecte au serveur et charge la liste des BRIOs rpertoris avec leur adresse qu'elle substitue
  *  l'ancienne liste
  * @return boolean mise  jour OK ?
  */
  function majAdressesInterBrio(){ 
    $response = $this->client->call('getAdressesInterBrio', $this->sessiondist); 
    //echo '<pre>' . htmlspecialchars($this->client->request, ENT_QUOTES) . '</pre>';
    //print $this->client->response;
    if ((! is_array($response)) || (! count($response))) {
       return false;
    }
    $cpt = count($response);
    $ut = new updateTableBrioche("adressesinterbrio", $tabchamps, 0, 0, $this->idsession);
    $ut->lock('w');
    $ut->detruitTout();   
    for ($i = 0; $i < $cpt; $i++){
      $tabchamps = $response[$i];
      $ut->setTabChamps($tabchamps);
      $ut->ajouteEnr();
    }   
    $ut->unlock();   
    // Suppression de la table "Etablissements" des adresses ventuellement primes;
    $ets = new ensTableBrioche("etablissements",
                               "etablissements.adresseIB IS NOT NULL AND adressesinterbrio.adresse IS NULL",
                               "noet", 0, 
                               $this->idsession, "adressesinterbrio",
                               "etablissements.adresseIB = adressesinterbrio.adresse");
    $tets = $ets->getTableau();
    $cpt = count($tets);
    if($cpt) {
      $chaine = "(";
      for ($i = 0; $i < $cpt; $i++){
        $chaine .= $tets[$i]->noet;
        if ($i < $cpt-1){
          $chaine .= ",";
        }
      }            
      $chaine .= ")";
      $uts = new updateTableBrioche("etablissements", "", "", "", $this->idsession);
      $uts->updateSpec("adresseIB", "NULL", "noet in $chaine", true);
    }
    
    
    return true;
    /*
    if ($client->fault) {
      echo "FAULT: <p>Code: {" .$this->client->faultcode . "}<br />";
      echo "String: {" . $this->client->faultstring . "}";
    } else {
      print_r($response);
    }
    */
  }
}





?>
