<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Connexion  la base d'aide
* @package donnes
*/
/**
* Connexion  la base d'aide
* Permet  l'utilisateur de se connecter  la base d'aide (pas de session)
* Traitement du contenu en fonction de l'affichage
* @package donnes
* @author ob
*/
class connexionAide {
  /**
  * le lien  la base de donnes
  * @var resource
  */
  var $linkAide;
  
  /**
  * l'identifiant dfinissant le chapitre ou la rubrique  afficher
  * @var string
  */
  var $id;
  
  /**
  * le type d'affichage (C: chapitre - R: rubrique - V: vedette). 1er caractre de l'identifiant
  * @var string
  */
  var $typeAff;
  
  /**
  * le numro  afficher (chapitre ou rubrique).  partir du second caractre de l'identifiant
  * @var int
  */
  var $numeroAff;

  /**
  * @param string id cf. variable de classe
  */
  function connexionAide($id){
    $ini = new briocheIni();
    $this->id = $id;
    $this->typeAff = substr($this->id, 0, 1);
    $this->numeroAff = substr($this->id, 1); 
    $this->linkAide = mysqli_connect($ini->aideHote, $ini->aideUser, $ini->aidePw, $ini->aideBd);
    print mysqli_error($this->linkAide);	
  }
  
  /**
  * renvoie le type d'affichage
  * @return string le type d'affichage
  */
  function getTypeAff(){
    return $this->typeAff;
  }	
  
  /**
  * renvoie le numro  afficher
  * @return int le numro  afficher
  */
  function getNumeroAff(){
    return $this->numeroAff; 	
  }	

  /**
  * dans le cas d'un affichage par chapitre, renvoie le titre du chapitre
  * @return string titre du chapitre
  */
  function getTitreChap(){
    if ($this->typeAff == "C"){
      $requete = "SELECT titchap FROM chapitres WHERE id = $this->numeroAff"; 	
      $result = mysqli_query($this->linkAide, $requete);
      $ligne = mysqli_fetch_row($result);
      return $ligne[0];
    }
    else {
      return false;	  
    }
  }
  
  /**
  * dans le cas d'un affichage par chapitres ou par vedette, retourne le nombre de rubriques
  * @return int nombre de rubriques
  */
  function getNbRub(){
    if ($this->typeAff == "C" || $this->typeAff == "V"){
      $requete = "SELECT COUNT(id) FROM rubriques WHERE chap = $this->numeroAff";
      $result = mysqli_query($this->linkAide, $requete);
      print mysqli_error($this->linkAide);
      $ligne = mysqli_fetch_row($result);
      return $ligne[0];
    }
    else {
      return false;
    }
  }
  
  /**
  * tableau des titres de rubrique
  * @return array les titres
  */
  function getTitRub(){
    if($this->typeAff == "C" || $this->typeAff == "V"){
      $requete = "SELECT titrub FROM rubriques WHERE chap = $this->numeroAff ORDER BY ordrub";
      $result = mysqli_query($this->linkAide, $requete);
      $tab = array();
      while($ligne = mysqli_fetch_row($result)){
        $tab[] = $ligne[0];
      }
      return $tab;	
    }
  }
  
  /**
  * tableau des textes de rubrique
  * @return array les textes
  */
  function getTextRub(){
    if($this->typeAff == "C" || $this->typeAff == "V"){
      $requete = "SELECT textrub FROM rubriques WHERE chap = $this->numeroAff ORDER BY ordrub";
      $result = mysqli_query($this->linkAide, $requete);
      $tab = array();
      while($ligne = mysqli_fetch_row($result)){
        $texte = $ligne[0];
        $texte = preg_replace("/<p>/", "<p class=\"texte\">", $texte);
        $texte = $this->extraitParam($texte);
        $tab[] = $texte;
      }
      return $tab;		
    } 		
  }	
  
  /**
  * insertion de paramtres du fichier briocheIni.inc dfinis par (param)  l'intrieur du texte
  * de l'aide
  * @return string le texte modifi
  */
  function extraitParam($texte){
    $texte = preg_replace_callback("/\(([^\)]*)\)/i", 
                                   create_function(
                                     '$matches',
                                     '
                                      $nomparam = substr($matches[0], 2, -2);             
                                      $ini = new briocheIni();
                                      if ($nomparam == "admin"){
                                        return $ini->adresseAdministrateur;
                                      }
                                      if ($nomparam == "adbrio"){
                                        return $ini->adresseBrio;
                                      }
                                     '
                                   )                  
                                   , $texte);
    return $texte;	
  }	

}


?>