<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Connexion aux donnes de Brioche
* @package donnes
* @author ob
*/
/**
* Connexion aux donnes de Brioche
* Connexion  la base de donnes de l'application, avec gestion des sessions, des autorisations
* et prtraitement et la conversion de certaines donnes. Permet en particulier de grer la conversion
* entre un format d'affichage "francophone" des dates (j.m.a) et le format "amricain" (yyyy-m-d) de la base de donnes.
* Tout objet permettant d'accder  la base de donnes devrait hriter de connexionBrioche
* @package donnes
* @author ob
*/
class connexionBrioche extends sessionDBrioche {
  /**
  * le lien  la base de donnes
  * @var resource
  */
  var $linkBrioche;
  
  /**
  * le nomb de la base de donnes
  * @var string
  */
  var $bdBrioche;
  
  /**
  * @param string sessionid l'identifiant de session
  * @param array autspec les autorisations spcifiques
  * @return boolean la session est-elle OK ?
  */
  function __construct($sessionid, $autspec = 0){
    $ini = new BriocheIni();
    $hini = new HermesIni();
    $debog = $ini->debogage;
    if (! parent::__construct($sessionid, $autspec)){
      if (! $debog){
        $b = new erreurB($this->n_erreur);
      }
      else {
        print "Erreur Connexion : $this->n_erreur";
      }
      return false;
    }
    $this->bdBrioche = $ini->briocheBd;
    $this->linkBrioche = mysqli_connect($ini->briocheHote, $ini->briocheUser, $ini->briochePw, $this->bdBrioche);
    if (! $this->link){
      #chec de la connexion
      $this->erreur = mysqli_error($this->linkBrioche);
      $this->n_erreur = 1120;
      return false;
    }
    //$result = mysql_select_db($this->bdBrioche, $this->linkBrioche);
    //print mysql_error();
    //if (!$result) {
    //  $this->erreur = mysql_error();
    //  $this->n_erreur = 1120;
    //  return false;
    //}
    return true;
  }
    
  /**
  * initiales de l'utilisateur courant
  * @return string initiales
  */
  function getInit(){  
    $requete = "SELECT init FROM initialesidut WHERE idut = $this->nout";
    $result = mysqli_query($this->linkBrioche, $requete);
    $ligne = mysqli_fetch_row($result);
    $init = false;
    if (isset($ligne[0])){
      $init = $ligne[0];
    }
    return $init;
  }
  
  /**
  * conversion d'une date au format francophone en un timestamp unix
  * @param string dateFr la date  convertif
  * @return float le timestamp
  */
  function dateFr2tst($dateFr){
    $tab = explode(".", $dateFr);
    return mktime(0, 0, 0, $tab[1], $tab[0], $tab[2]);
  }
  //Mme emploi que la prcdente, qui est  utiliser prfrentiellement
  //Conversion d'une date au format jj.mm.aaaa en tst (obsolte);
  function dateFrToTst($dte){
    return mktime(0, 0, 0, substr($dte, 3, 2), substr($dte, 0, 2), substr($dte, 6, 4));
  }
  
  /**
  * conversion d'un timestamp unix en une date francophone
  * @param float tst le timestamp  convertir
  * @return string la date convertie
  */
  function tst2DateFr($tst){
    return date("d.m.Y", $tst);
  }
  
  /**
  * conversion d'une date aammjj en une date francophone
  * @param string date6
  * @return string la date convertie
  */
  function date62DateFr($date6){
    return substr($date6, 4, 2) . "." . substr($date6, 2, 2) . "." . substr($date6, 0, 2);  
  }
  
  /**
  * conversion d'une date du format amricain au format francophone
  * @param string dateAm
  * @return string la date convertie
  */
  function getDateFr($dateAm){
    //print $dateAm . "<br>";
    $tab = explode(" ", $dateAm); //Explosion de l'ventuel datetime
    $tab = explode("-", $tab[0]); //Explosion de la date
    if(!isset($tab[0]) || !isset($tab[1]) || !isset($tab[2])) return "";
    if(! $tab[0] || ! $tab[1] || ! $tab[2]) return "";
    
    //print "$tab[2].$tab[1].$tab[0]" . "<br>---<br>";
    return "$tab[2].$tab[1].$tab[0]";

  }

  /**
  * conversion d'une date du format francophone au format amricain, ventuellement mise entre guillemets
  * @param string dateFr la date  convertir
  * @param boolean guillemets faut-il mettre la date entre guillemets ?
  * @return string la date convertie
  */ 
  function getDateAm($dateFr, $guillemets=1){
    if ($dateFr == "") return "NULL";
    $tab = explode(".", $dateFr);
    if ($guillemets == 1) {
      return "\"$tab[2]-$tab[1]-$tab[0]\"";
    }
    else {
      return "$tab[2]-$tab[1]-$tab[0]";
    }
  }
  
  /**
  * la date du jour au format francophone
  * @return string la date formate
  */
  function aujourdhui(){
    return date("d.m.Y");
  }

  /**
  * le premier janvier de l'anne en cours au format francophone
  * @return string la date formate
  */
  function nouvelan(){
    return date("d.m.Y", mktime(0,0,0,1,1,date("Y")));
  }

  /**
  * la date du jour au format amricain
  * @return string la date formate
  */
  function today(){
    return date("Y-m-d");
  }
  
  /**
  * renvoie une date loigne de + delta jours d'aujourd'hui
  * @param int delta l'intervalle  ajouter (ou retrancher si ngatif)
  * @return string la nouvelle date au format francophone
  */
  function plusJours($delta){
    return date("d.m.Y", mktime(0, 0, 0, date("m"), date("d") + $delta, date("Y")));
  }
  
  /**
  * le premier jour du mois pass
  * @return string la nouvelle date au format francophone
  */
  function premierMoisPasse(){
    return date("d.m.Y", mktime(0,0,0,date("m")-1, 1, date("Y")));
  }	
  
  /**
  * le dernier jour du mois pass
  * @return string la nouvelle date au format francophone
  */
  function dernierMoisPasse(){
    return date("d.m.Y", mktime(0,0,0,date("m"), 0, date("Y")));
  }	
  
  
  /**
  * renvoie une date correspondant  une date de dpart + une priode en jours
  * @param string depart la date de dpart (format francophone ou amricain)
  * @param int periode la priode en jours(positive ou ngative)
  * @return string la nouvelle date au mme format que le paramtre depart
  */
  function periodeJours($depart, $periode){
    if (preg_match("/\./", $depart)){
      $langue = "fr";
      $depart = connexionBrioche::getDateAm($depart, false);
    }
    $departtime = strtotime($depart);
    $offset = $periode * 24 * 3600;
    $departtime = $departtime + $offset;
    if ($langue == "fr"){
      return date("d.m.Y", $departtime);
    }
    else {
      return date("Y-m-d", $departtime);
    }
  }

  /**
  * Prtraitement des champs texte (remplacement de certains caractres pouvant faire problme pour l'affichage HTML)
  * @param string txt le texte d'origine
  * @return string le texte modifi
  */
  function metEnFormeSel($txt){
    $txt = preg_replace("/</", "&lt;", $txt);
    $txt = preg_replace("/>/", "&gt;", $txt);
    return $txt;
  }

  /**
  * conversion d'un tableau de paramtres rsultant du post d'un formulaire en
  * un objet contenant une proprit par champ de la table concerne
  * Cette mthode est appele par les objets ensTableBrioche et enrBrioche lorsqu'il s'agit
  * de shunter les donnes de la base durant la vrification et la correction des donnes
  * saisies dans un formulaire
  * @param array tabrec le tableau  transformer
  * @param string le nom de la table correspondante
  * @return object objet dont les proprits correspondent aux champs de la table
  */
  function faitRecup($tabrec, $table){
    //$lf = mysql_list_fields($this->bdBrioche, $table);
    //$nf = mysql_num_fields($lf);
    $req = "SELECT * FROM $table LIMIT 1";
    $result = mysqli_query($this->linkBrioche, $req);
    while ($fld = mysqli_fetch_field($result)){
       $nom = $fld->name;
       if (! isset($recup)) $recup = new stdClass();
       $recup->$nom = "";
    }
    while (list($cle, $val) = each ($tabrec)){
      $val = stripslashes($val);
      $val = preg_replace("/\"/", "&quot;", $val);
      $recup->$cle = $val;
    }
    return $recup;
  }

  
  /**
  * prtraitement des donnes lors de l'criture une table
  * mthode utilise par l'objet updateTableBrioche
  * @param string cle le nom du champ
  * @param string valeur la valeur  mettre en forme
  * @param array types un tableau associatif dont les cls sont les noms des champs et
  * les valeurs les types de donnes correspondants
  * @param array tailles idem, mais pour les tailles des champs correspondants
  * ces deux derniers paramtres sont obtenus par les mthodes getTypes() et getTailles()
  * de updateTableBrioche
  * @return string le contenu du paramtre "valeur" mis en forme 
  */
  function metEnFormeUpd($cle, $valeur, $types, $tailles){
    if($types[$cle] == 254 OR $types[$cle] == 252 OR $types[$cle] == 253) { //char (254) ou blob (252) ou varchar(253)
      if($types[$cle] == 254){
        if (strlen($valeur) > $tailles[$cle]){
          $valeur = substr($valeur, 0, $tailles[$cle]);
          $al = new Alerte("Trop de donnes dans un champ texte. Votre entre a t tronque !");
          $al->imprime();
        }
      }
      $valeur = preg_replace("/\"/", "&quot;", $valeur); //Suppression des guillemets, qui troublent l'affichage web
      if (strlen($valeur) == 0) {
        $valeur = "NULL";
      }
      else {  	
        $valeur = "\"$valeur\"";
      }
    }
    if ($types[$cle] == 10){ // date (10)
      $valeur = $this->getDateAm($valeur);
    }
    if ($types[$cle] == 12 || $types[$cle] == 7){ // datetime (12) timestamp (7)
      $valeur = "\"$valeur\"";
    }
    if ($types[$cle] == 3 || $types[$cle] == 2 || $types[$cle] == 1){ // integer (
      if (strlen($valeur) == 0) $valeur = "NULL";
    }
    $valeur = preg_replace("/&lt;/", "<", $valeur);
    $valeur = preg_replace("/&gt;/", ">", $valeur);
    return $valeur;
  }
  
  
  /**
  * renvoie un document HTML contentant une table  partir d'un tableau de valeurs
  * @param array tab le tableau  transformer
  * @return string le document html
  */
  function getHtml($tab){
    $html = "<HTML><BODY><TABLE>";
    foreach ($tab as $ligne) {
      $html .= "<TR>";
      foreach ($ligne as $cellule) {
          $html .= "<TD WIDTH=100>";
	  $html .= $cellule;
          $html .= "</TD>";
        }
      $html .= "</TR>";
    }
    $html .= "</TABLE></BODY></HTML>";
    return $html;
  }
   
  
  /**
  * renvoie une valeur en pourcents sur la base d'un numrateur et d'un dnominateur, en
  * rglant les problmes de division par zro
  * @param float num le numrateur
  * @param float den le dnominateur
  * @param int arrondit le nombre de chiffres aprs la virgule
  * @param mixed divparzero la valeur renvoye lorsque le dnominateur est nul
  * @return float la valeur en pourcents
  */
  function pourcent($num, $den, $arrondit = 0, $divparzero = ""){
    if (! $den) return $divparzero;
    $pc = round($num / $den * 100, $arrondit);
    return $pc;
  }
  
}

?>
