<?php
// $Id: criteresB.inc,v 1.1.1.1 2010-10-11 22:25:50 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Recherche par critres
* @package formulaires
*/
/**
* Recherche par critres
* En combinant divers critres, l'utilisateur peut slectionner des sous-ensembles de dossiers et en afficher
* la liste
* @package formulaires
* @author ob tnh cjd jdu
*/
class criteresB extends cadronglet{

  /**
  * @param string largeur la largeur (en pixel ou en pourcents)
  * @param string grise la couleur grise
  * @param int actif l'action du formulaire
  * @param string fondpage le fond de la page
  * @param string sessionid l'identifiant de session
  * @param array donnees le tableau des donnes postes
  */
  function criteresB($largeur, $grise, $actif, $fondpage, $sessionid, $donnees) {
    global $fichier;
    $ini = new briocheIni();
    if (! $this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid)) return;
    //Valeurs par dfaut
    if (! isset($donnees['sexe'])) $donnees['sexe'] = "";
    if (! isset($donnees['issue'])) $donnees['issue'][] = 0;
    if (! isset($donnees['mission'])) $donnees['mission'] = 0;
    if (! isset($donnees['priorite'])) $donnees['priorite'] = 0;
    if (! isset($donnees['servplac'])) $donnees['servplac'][] = 0;
    if (! isset($donnees['provenance'])) $donnees['provenance'][] = 0;
    if (! isset($donnees['long'])) $donnees['long'] = 0;
    if (! isset($donnees['observation'])) $donnees['observation'] = 0;
    if (! isset($donnees['court_urgent'])) $donnees['court_urgent'] = 0;
    if (! isset($donnees['court_non_urgent'])) $donnees['court_non_urgent'] = 0;
    if (! isset($donnees['sejobs'])) $donnees['sejobs'] = 0;
    if (! isset($donnees['suspens'])) $donnees['suspens'] = 0;
    if (! isset($donnees['utilisateur'])) $donnees['utilisateur'] = "";
    if (! isset($donnees['ems'])) $donnees['ems'][] = 0;
    if (! isset($donnees['refus'])) $donnees['refus'] = 0;
    if (! isset($donnees['signet'])) $donnees['signet'] = 0;
    if (! isset($donnees['debut'])) $donnees['debut'] = "";
    if (! isset($donnees['fin'])) $donnees['fin'] = "";
    if (! isset($donnees['issue_debut'])) $donnees['issue_debut'] = "";
    if (! isset($donnees['issue_fin'])) $donnees['issue_fin'] = "";
    if (! isset($donnees['emspl'])) $donnees['emspl'] = 0;
    if (! isset($donnees['page'])) $donnees['page'] = 0;
    if (! isset($donnees['tri'])) $donnees['tri'] = 1;
    for ($i = 1; $i < 15; $i++){
      if (! isset($donnees['pec'.$i])) $donnees['pec'.$i] = 0;
    }
    
    //AJOUT CJD requte mission
    for ($i = 1; $i < 5; $i++){
      if (! isset($donnees['id'.$i])) $donnees['id'.$i] = 0;
    }
    //AJOUT CJD requte priorit
    for ($i = 0; $i < 4; $i++){
      if (! isset($donnees['pri'.$i])) $donnees['pri'.$i] = 0;
    }
    //Clause order d'aprs donnees[tri]
    switch($donnees['tri']){
    case 2:
      $order = "usagers.nom";
      break;
    case 3:
      $order = "demandeor.datedem";
      break;
    case 4:
      $order = "issue.dateissue";    
      break;
    default:
      $order = "dossiers.nodoss";
    }
    
    //Requte principale
    if ($donnees['ems'][0]) {
      $join[] = "dossiers";
      $on[] = "choixems.nodoss = dossiers.nodoss";
    }
    $join[] = "usagers";
    $on[] = "dossiers.nous = usagers.nous";
    $join[] = "demandeor";
    $on[] = "dossiers.nodoss = demandeor.nodoss";
    $join[] = "typesejour";
    $on[] = "demandeor.typesej = typesejour.idts";
    $join[] = "missions";
    $on[] = "demandeor.typepath = missions.nomission";
    $join[] = "etablissements";
    $on[] = "demandeor.servplac = etablissements.noet";
    $join[] = "issue";
    $on[] = "dossiers.nodoss = issue.nodoss";
    $join[] = "signetsdossiers";
    $on[] = "dossiers.nodoss = signetsdossiers.nodoss";
    $join[] = "signets";
    $on[] = "signetsdossiers.idsignet = signets.id";
    $join[] = "attributionlit";
    $on[] = "dossiers.nodoss = attributionlit.nodoss";
    $join[] = "annoncelit";
    $on[] = "attributionlit.nolit = annoncelit.nolit";    
    $join [] = "issueoptions";
    $on [] = "issue.issue = issueoptions.idissue";
    $req = new EnsTableCompact(($donnees['ems'][0] ? "choixems" : "dossiers"), "1",
                               "dossiers.nodoss, " .
                               "CONCAT(usagers.nom, \" \", usagers.prenom) AS usager," .
                               "usagers.sexe AS sexe, " .
                               "demandeor.datedem, " .
                               "typesejour.ttypesej AS typesej, " .
                               "missions.txtmission AS tmission, " .
                               "etablissements.nomet AS servplac, " .
                               "CONCAT(demandeor.referent, \" \", demandeor.medecinautre) AS referent, " .
                               "dossiers.priorite, " .
                               "IF(dossiers.dateclo IS NULL, \"Oui\", \"Non\") AS suspens, " .
                               "IF(dossiers.sejobs = -1, \"Oui\", \"Non\") AS sejobs, " .
                               "dossiers.suivpar, " .
                               /*"issue.issue,*/ "issue.dateissue, issueoptions.issue_text, " .
                               "signets.nomsignet, demandeor.litdepuis",
                               $order, $this->idsession, $join, $on, true,
                               "nodoss", "<BR>");
        
    //Clause where
    if ($donnees['debut'] && ! $donnees['fin']) $donnees['fin'] = $donnees['debut'];
    if ($donnees['fin'] && ! $donnees['debut']) $donnees['debut'] = $donnees['fin'];
    if ($donnees['issue_debut'] && ! $donnees['issue_fin']) $donnees['issue_fin'] = $donnees['issue_debut'];
    if ($donnees['issue_fin'] && ! $donnees['issue_debut']) $donnees['issue_debut'] = $donnees['issue_fin'];
    $where = "" .
    
    "(dossiers.statut IS NULL OR dossiers.statut NOT IN (99, 100)) AND " .
    ($donnees['debut'] ? "demandeor.datedem BETWEEN " . $this->getDateAm($donnees['debut']) . " AND " .
                         $this->getDateAm($donnees['fin']) . " AND " : "1 AND ").
    ($donnees['issue_debut'] ? "issue.dateissue BETWEEN " . $this->getDateAm($donnees['issue_debut']) . " AND " .
                         $this->getDateAm($donnees['issue_fin']) . " AND " : "1 AND ").
    ($donnees['sexe'] ? "sexe = \"" . $donnees['sexe'] . "\" AND " : "1 AND ").
    ($donnees['mission'] ? "demandeor.typepath = " . $donnees['mission'] . " AND " : "1 AND ").
    ($donnees['suspens'] ? "dossiers.dateclo IS NULL AND " : "1 AND ").      
    ($donnees['priorite'] ? "dossiers.priorite = " . $donnees['priorite'] . " AND " : "1 AND ").
    ($donnees['sejobs'] ? "dossiers.sejobs = -1 AND " : "1 AND ").
    ($donnees['utilisateur'] ? "dossiers.suivpar = \"" . $donnees['utilisateur'] . "\" AND " : "1 AND ").
    ($donnees['signet'] ? "signets.id = " . $donnees['signet'] . " AND " : "1 AND ").
    ($donnees['emspl'] ? "annoncelit.etabl = " . $donnees['emspl'] . " AND " : "1 AND ").
    ($donnees['refus'] == 1 ? "choixems.refus + choixems.refpro = 0 AND " : "1 AND ").
    ($donnees['refus'] == 3 ? "choixems.refus + choixems.refpro <> 0 AND " : "1 AND ").
    "1";   
    
    
    //PROVENANCE -> RECUP DES DONNEES
    $value = ($donnees['ems'][0]);
    if ($value != 0){
          if  (count($donnees['ems'])){
        $where .= " AND choixems.noems in (". join(", ", $donnees['ems']) .")";      
      }
    }
    
    
    //PROVENANCE -> RECUP DES DONNEES
    $value = ($donnees['provenance'][0]);
    if ($value != 0){
          if  (count($donnees['provenance'])){
        $where .= " AND demandeor.provenance in (". join(", ", $donnees['provenance']) .")";      
      }
    }

    
    //SERVICE PLACEUR -> RECUP DES DONNEES
    $value = ($donnees['servplac'][0]);
    if ($value != 0){
       if  (count($donnees['servplac'])){
        $where .= " AND demandeor.servplac in (". join(", ", $donnees['servplac']) .")";      
      }
    }
    
    
    //ISSUE -> RECUP DES DONNEES
    $value = ($donnees['issue'][0]);
    if ($value != 0){
       if  (count($donnees['issue'])){
        $where .= " AND issue.issue in (". join(", ", $donnees['issue']) .")";      
      }
    }
   
    // Prise en charge dsire (cases  cocher optionnelles)
    $epec = new EnsTableBrioche("typesejour", "ordre <> 0", "*", "ABS(ordre)", $this->idsession);
    $epect = $epec->getTableau();
    $cepect = count($epect);
    $sej_demandes = array();
    for ($i = 1; $i <= $cepect+1; $i ++){
      if ($donnees['pec' . $i]) $sej_demandes[] = $i;
    }
    if  (count($sej_demandes)){
      $where .= " AND demandeor.typesej in (". join(", ", $sej_demandes) .")";      
    }
//    $where = eregi_replace(" AND 1", "", $where);
//    $req->setWhere($where);
    
    // Ajout CJD , prise en charge dsire (cases  cocher optionnelles)
    $missions = array();
    for ($i = 1; $i < 5; $i ++){
      if ($donnees['id' . $i]) $missions[] = $i;
    }   
    if  (count($missions)){
      $where .= " AND demandeor.typepath in (". join(", ", $missions) .")";      
    }
//    $where = eregi_replace(" AND 1", "", $where);
//    $req->setWhere($where);
    
    // Ajout CJD , priorit
    $priorites = array();
    for ($i = 0; $i < 4; $i ++){
      if ($donnees['pri' . $i]) $priorites[] = $i;
    }   
    if  (count($priorites)){
      $where .= " AND dossiers.priorite in (". join(", ", $priorites) .")";      
    }
    $where = eregi_replace(" AND 1", "", $where);
        
    $req->setWhere($where);
    
    //Nombre total d'enregistrement retourns (indpendamment de la pagination)
    $nbtotal = $req->compteTotal();
        
    //Contenu page
    //Interface de recherche    
    if ($actif == 17) {
      //Pagination
      $pag = new Pagination($req, "dossiers", "donnees", "donnees[page]", 100, $donnees['page']);
      $tabbande = array("Recherche par critres", "", "", "", "");
      $this->addOnglet("Chercher", $tabbande, "#8b8378", $this->actif, 80, "");
      $this->colmateOnglets();
      $of = new OngForm();
      $of->setTabParam($this->largeur, $this->coulbande, 12);
      $of->setFormParam("donnees", $fichier, "post");
      $acb = new AutoCheckBox();
      $of->addLigne();
      $c = new TPanel(10, 1, "RIGHT");
      $x = new Bouton("Slectionner", "Slectionner", "BUTTON",
                      "document.forms.donnees.action.value=17;" .
                      "changeChamp(\"donnees[page]\", 1, \"donnees\");document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      // Visualisation chane SQL de la requte
      $sql = $req->getSql();
      $sql2 = eregi_replace("\"", "\\\"", $sql) . ";";
      $x = new Bouton("SQL", "Voir SQL", "BUTTON", "ff=ouvreFenetre(\"\", \"Requte\", \"width=550,height=250\", true);" .
                      "ff.document.write(\"<html><body bgcolor=#988663><form><textarea rows=10 cols=60>" . $sql2 .
                      "</textarea><p><input type=\\\"button\\\" value=\\\"Fermer\\\" onClick=\\\"window.close()\\\">" .
                      "</form></body></html>\");"
                     );
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      if ($nbtotal > $ini->maxExcel){
        $actionbouton = "alert(\"Vous ne pouvez obtenir une feuille de calcul comportant plus de " .
                        $ini->maxExcel . " enregistrements... Veuillez " .
                        "affiner vos critres de recherche !\");";
      }
      else {
        $actionbouton = "document.forms.donnees.action.value=18;document.forms.donnees.submit();";
      }
      $x = new Bouton("Obtenir", "Obtenir feuille de calcul", "BUTTON",
                      $actionbouton);
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new Bouton("Retour", "Retour", "BUTTON", "document.forms.donnees.action.value=1;document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $of->addChamp($c);
      $c = new TPanel(2, 1);
      $x = new Aide("C0004");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne(0.5);
      //Date de la demande
      $c = new TPanelCadre(12, 1, "LEFT", "MIDDLE", "", "Date de la demande&nbsp;:");
      $x = new ChampTexte("donnees[debut]", $donnees['debut'], "Entre le ", 15, 15, false,
                          "TEXT", "d2", "controleDate('donnees[debut]', '', '', '')","",false,true);
      $c->addChamp($x);                    
      $c->addChamp(new Espace(3));
      $x = new ChampTexte("donnees[fin]", $donnees['fin'], "et le ", 15, 15, false,
                          "TEXT", "d2", "controleDate('donnees[fin]', '', '', '')","",false,true);
      $c->addChamp($x);                    
      $of->addChamp($c);
      $of->addLigne();
      //Sexe usager
      $c = new TPanelCadre(3, 1, "LEFT", "MIDDLE", "", "Sexe&nbsp;:");
      $x = new GrBoutonRadio("donnees[sexe]", $donnees['sexe'], "", "donnees");
      $x->addRadio("Fm.", "F");
      $x->addRadio("Masc.", "M");
      $c->addChamp($x);
      $acb->addCase($x);
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("action", $this->actif, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("donnees[page]", $donnees['page'], "HIDDEN");
      $c->addChamp($x);  
      $of->addChamp($c);

      //Mission (new -> rajout champ texte  l'lment mission)      
              
      $ep = new EnsTableBrioche("missions", 1, "*", "nomission", $this->idsession);
      $ept = $ep->getTableau();
      $c = new TPanelCadre(9, 1, "LEFT", "MIDDLE", "", "Mission demande&nbsp;:");
      $cpt = count($ept);
      for ($i = 0; $i < $cpt; $i++){
        $mission = "id"  . $ept[$i]->nomission;
        $label = $ept[$i]->txtmission;
        $br = false;
        if($i == 4) $br = true;
        $x = new Autocase("donnees[$mission]", $donnees[$mission], $label, $br) ;
        $c->addChamp($x);
        $acb->addCase($x);
      }
      $of->addChamp($c);

      $of->addLigne();
      $of->addLigne(0.3);
  
      //Priorit - transformation en checkboxes
      $c = new TPanelCadre(3, 1, "LEFT", "MIDDLE", "", "Priorit&nbsp;:");
      for ($i = 0; $i < 4; $i++){
        $priorite = "pri" . $i;
        $label = $i;
        $br = false;
        if($i == 3) $br = true;
        $x = new Autocase("donnees[$priorite]", $donnees[$priorite], $label, $br) ;
        $c->addChamp($x);
        $acb->addCase($x);
      }
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne(0.3);  

      //Service placeur (new->multiple select list)
      $ts = new EnsTableBrioche("etablissements", "servplac = -1", "noet, nomet, actif",
                                "actif, groupepriorite, nomet", $this->idsession);
      $c = new TPanel(3, 1, "LEFT", "MIDDLE");
      $x = new Label("Service placeur&nbsp;:", false, false, true);
      $c->addChamp($x);
      $field_id = 1;
      $x = new ListOptTableEtabl("donnees[servplac][]", $donnees['servplac'], $ts, true, 5, "d2", "", false, false, 1);
      $x->addDefaut("---", 0);
      $x->addOptionsEtablissements("nomet", "noet");
      $c->addChamp($x);
      $of->addChamp($c);    
           
      // Boutons service placeur tous/aucun/actif/inactif
      $Tous_js = "toto = document.getElementById(1);";
      $Aucun_js = "toto = document.getElementById(1);";
      $Actifs_js = "toto = document.getElementById(1);";
      $Inactifs_js = "toto = document.getElementById(1);";
      $etabliste = $x->tab;
      foreach ($etabliste as $key => $etabl) {
        $key++;
        $Tous_js .= "
        toto.options[$key].selected = true;
       ";
        $Aucun_js .= "
        toto.options[$key].selected = false;
       ";
        if ($etabl->actif == -1) {
           $Actifs_js .= "
         toto.options[$key].selected = true;
         ";
           $Inactifs_js .= "
         toto.options[$key].selected = false;
         ";
        } else {
          $Actifs_js .= "
         toto.options[$key].selected = false;
         ";
          $Inactifs_js .= "
         toto.options[$key].selected = true;
         ";
        }
      }
      $Tous_js .= "toto.options[0].selected = false;";
      $Aucun_js .= "toto.options[0].selected = false;";
      $Actifs_js .= "toto.options[0].selected = false;";
      $Inactifs_js .= "toto.options[0].selected = false;";
            
      $c = new TPanel(2,1,"MIDDLE");      
      $x = new Bouton("Tous","Tous","BUTTON",$Tous_js);
      $c->addChamp($x);  
      $x = new Espace(3);
      $c->addChamp($x);
      $x = new Bouton("Aucun","Aucun","BUTTON",$Aucun_js);
      $c->addChamp($x); 
      $x = new TLabel("<BR><BR>");    
      $c->addChamp($x);    
      $x = new Bouton("Actifs","Actifs","BUTTON",$Actifs_js);
      $c->addChamp($x); 
      $x = new Espace(3);
      $c->addChamp($x);  
      $x = new Bouton("Inactifs","Inactifs","BUTTON",$Inactifs_js);
      $c->addChamp($x);  
      $of->addChamp($c);
      
      //Provenance new
      $tp = new EnsTableBrioche("provenance", "1", "*", "ordre", $this->idsession);
      $c = new TPanel(5, 1, "RIGHT");
      $x = new Label("Situation de l'usager au moment de la demande (provenance)&nbsp;:", false, false, true);
      $c->addChamp($x);
      $x = new ListOptTable("donnees[provenance][]", $donnees['provenance'], $tp, true, 5, "d2");
      $x->addDefaut("---", 0);
      $x->addOptions("provenance_text", "idprovenance");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne(0.3);
      
      //Prise en charge dsire
      $c = new TPanelCadre(12, 1, "LEFT", "MIDDLE", "", "Prise en charge dsire&nbsp;:");
      for ($i = 0; $i < $cepect; $i++){
        $nom = "pec"  . $epect[$i]->idts;
        $label = $epect[$i]->ttypesej;
        $br = false;
        if($i == 5) $br = true;
        $x = new Autocase("donnees[$nom]", $donnees[$nom], $label, $br) ;
        $c->addChamp($x);
        $acb->addCase($x);
      }
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne(0.3);
      
      //Sjour d'observation
      $c = new TPanelCadre(5, 1, "LEFT", "MIDDLE", "", "Limiter  :");
      $x = new AutoCase("donnees[sejobs]", $donnees['sejobs'], "Sjours d'observation");
      $c->addChamp($x);
      $acb->addCase($x);
      
      //Dossiers en suspens
      $x = new AutoCase("donnees[suspens]", $donnees['suspens'], "Dossiers en suspens");
      $c->addChamp($x);
      $acb->addCase($x);
      $of->addChamp($c);
      
      //Dossiers suivis par
      $c = new TPanel(3, 1);
      $x = new Label("Dossiers suivis par&nbsp;:", false, false, true);
      $c->addChamp($x);
      $ut = new ensTableBrioche("utilisateurs", "1", "init, nomut", "nomut", $this->idsession);
      $x = new ListOptTable("donnees[utilisateur]", $donnees['utilisateur'], $ut, false, 0, "d2");
      $x->addDefaut("---", "");
      $x->addOptions("nomut", "init");
      $c->addChamp($x);
      $of->addChamp($c);
      
      //Signets
      $c = new TPanel(3,1);
      $sig = new ensTableBrioche("signets", "1", "id, nomsignet", "nomsignet", $this->idsession);
      $x = new Label("Signet&nbsp;:", false, false, true);
      $c->addChamp($x);
      $x = new ListOptTable("donnees[signet]", $donnees['signet'], $sig, false, 0, "d2");
      $x->addDefaut("---", "");
      $x->addOptions("nomsignet", "id");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne(0.3);
      
      //Inscriptions dans EMS backup
      $c = new TPanelCadre(12, 1, "LEFT", "MIDDLE", "", "Inscriptions dans un EMS&nbsp;:");
      $ems = new ensTableBrioche("etablissements", "litsc + litsd <> 0", "noet, nomet, actif",
                                 "actif, groupepriorite, nomet", $this->idsession);
      $x = new ListOptTableEtabl("donnees[ems][]", $donnees['ems'], $ems, true, 5, "d2");
      $x->addDefaut("---", 0);
      $x->addOptionsEtablissements("nomet", "noet");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));      
      $x = new GrBoutonRadio("donnees[refus]", $donnees['refus'], "", "donnees");
      $x->addRadio("Sans refus", 1);
      $x->addRadio("Avec refus", 2);
      $x->addRadio("Seulement refus", 3);
      $c->addChamp($x);
      $acb->addCase($x);
      $c->addChamp($acb);
      $of->addChamp($c);
      $of->addLigne(0.3);
      $of->addLigne();

       //Issue NEW!!
      $c = new TPanel(3, 1, "LEFT", "MIDDLE");
      $x = new Label("Issue&nbsp;:", false, false, true);
      $c->addChamp($x);
      $eti = new ensTableBrioche("issueoptions", "1", "*", "ordre", $this->idsession);
      $x = new ListOptTable("donnees[issue][]", $donnees['issue'], $eti, true, 5, "d2");
      $x->addDefaut("---", 0);
      $x->addOptions("issue_text", "idissue");
      $c->addChamp($x);
      $of->addChamp($c);      
      
      // Placement dans un EMS
      $c = new TPanelCadre(9, 1, "LEFT", "MIDDLE", "", "Placement dans un EMS&nbsp;:");
      $ems = new ensTableBrioche("etablissements",
                                 "(litsc = -1 OR litsd = -1) AND autbrio = 0",
                                 "noet, nomet, actif", "actif, groupepriorite, nomet", $this->idsession);
      $x = new ListOptTableEtabl("donnees[emspl]", $donnees['emspl'], $ems, false, 0, "d2");
      $x->addDefaut("---", 0);
      $x->addOptionsEtablissements("nomet", "noet");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne(0.5);


      // date de l'issue
      $c = new TPanelCadre(12, 1, "LEFT", "MIDDLE", "", "Date de l'issue&nbsp;:");
      $x = new ChampTexte("donnees[issue_debut]", $donnees['issue_debut'], "Entre le ", 15, 15, false,
                          "TEXT", "d2", "controleDate('donnees[issue_debut]', '', '', '')","",false,true);
      $c->addChamp($x);                    
      $c->addChamp(new Espace(3));
      $x = new ChampTexte("donnees[issue_fin]", $donnees['issue_fin'], "et le ", 15, 15, false,
                          "TEXT", "d2", "controleDate('donnees[issue_fin]', '', '', '')","",false,true);
      $c->addChamp($x);                    
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne(0.5);
      
      // Double des boutons //////////////////////////////
      $c = new TPanel(10, 1, "RIGHT");
      $x = new Bouton("Slectionner", "Slectionner", "BUTTON",
                      "document.forms.donnees.action.value=17;" .
                      "changeChamp(\"donnees[page]\", 1, \"donnees\");document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      // Visualisation chane SQL de la requte
      $sql = $req->getSql();
      $sql2 = eregi_replace("\"", "\\\"", $sql) . ";";
      $x = new Bouton("SQL", "Voir SQL", "BUTTON", "ff=ouvreFenetre(\"\", \"Requte\", \"width=550,height=250\", true);" .
                      "ff.document.write(\"<html><body bgcolor=#988663><form><textarea rows=10 cols=60>" . $sql2 .
                      "</textarea><p><input type=\\\"button\\\" value=\\\"Fermer\\\" onClick=\\\"window.close()\\\">" .
                      "</form></body></html>\");"
                     );
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      if ($nbtotal > $ini->maxExcel){
        $actionbouton = "alert(\"Vous ne pouvez obtenir une feuille de calcul comportant plus de " .
                        $ini->maxExcel . " enregistrements... Veuillez " .
                        "affiner vos critres de recherche !\");";
      }
      else {
        $actionbouton = "document.forms.donnees.action.value=18;document.forms.donnees.submit();";
      }
      $x = new Bouton("Obtenir", "Obtenir feuille de calcul", "BUTTON",
                      $actionbouton);
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new Bouton("Retour", "Retour", "BUTTON", "document.forms.donnees.action.value=1;document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $of->addChamp($c);
      $of->addLigne(0.5);
      //////////////////////////////////////////////////
      
      // tri
      $c = new TPanelCadre(12, 1, "LEFT", "MIDDLE", "", "Trier par&nbsp;:");
      $x = new GrBoutonRadio("donnees[tri]", $donnees['tri'], "", "donnees");
      $x->addRadio("numro de dossier", 1);
      $x->addRadio("nom d'usager", 2);
      $x->addRadio("date de la demande", 3);
      $x->addRadio("date de l'issue", 4);
      $c->addChamp($x);
      $acb->addCase($x);
      
      $of->addChamp($c);
      $of->addLigne(0.5);
      //Affichage des rsultats
      $of->addLigne();
      //print $req->getSql();
      $c = new TPanel(12, 1);
      
      $c->addChamp($pag);
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne();
      $c = new TPanelTableau(12, 1, $req, $this->grise, "dossiers", "nodoss");
      $opt = new optionsBrioche();
      $opt->setOption("MODE", 2);
      $opt->setOption("FORCE_DOSS", 1);
      $opt->setOption("LARG_FIX", 1);
      $largfen = 830;
      $x = new Lien("", false, false, false, "nodoss", "javascript:ouvreBrioche('brioche.php?action=1" .
                     "&sessionid=$this->idsession&item=&options=" . $opt->getChaine() .
                     "', " . $largfen . ")");
      $c->addColChamp("Doss.", $x, false, true);
      $x = new Label("", false, false, false, "usager");
      $c->addColChamp("Usager", $x);
      $x = new Label("", false, false, false, "datedem");
      $c->addColChamp("Date dem.", $x);
      $x = new Label("", false, false, false, "sexe");
      $c->addColChamp("Sexe", $x);
      $x = new Label("", false, false, false, "typesej");
      $c->addColChamp("Sj.", $x);
      $x = new Label("", false, false, false, "tmission");
      $c->addColChamp("Mission", $x);
      $x = new Label("", false, false, false, "servplac");
      $c->addColChamp("Serv. plac.", $x);
      $x = new Label("", false, false, false, "referent");
      $c->addColChamp("Rf.", $x);
      $x = new Label("", false, false, false, "suivpar");
      $c->addColChamp("suiv.", $x);
      $x = new Label("", false, false, false, "priorite");
      $c->addColChamp("Pri.", $x);
      $x = new Label("", false, false, false, "litdepuis");
      $c->addColChamp("Dbut souhait", $x);
      $x = new Label("", false, false, false, "suspens");
      $c->addColChamp("Susp.", $x);
      $x = new Label("", false, false, false, "sejobs");
      $c->addColChamp("Obs.", $x);
      $x = new Label("", false, false, false, "issue_text");
      //$c->addColChamp("Issue", $x, false, false, "textIssue", $this);
      $c->addColChamp("Issue", $x);
      $x = new Label("", false, false, false, "dateissue");
      $c->addColChamp("Date issue", $x);
      $x = new Label("", false, false, false, "nomsignet");
      $c->addColChamp("Sig.", $x);
      $c->addTitres(true);
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne(0.5);
      $c = new TPanel(12, 1);
      $c->addChamp($pag);
      $of->addChamp($c);
      $of->addLigne();
      $this->addContenu($of->getContenu());
    }
    elseif ($actif == 18){
      $tab = $req->getTableauBidim();
            
      $cpt = count($tab);
      /*
      for ($i = 1; $i < $cpt; $i++){
        $tab[$i][12] = $this->textIssue($tab[$i][12]);
      }
      */
      $html = $req->getHtml($tab, $cpt, 14);
      $this->effaceEntete();
      header('Content-disposition: inline; filename=stats.xls');
      header('Content-type: application/vnd.ms-excel');
      print $html;
    }
  }
   
}
?>
