<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Corps du DMT
* @package dmt
*/
/**
* Corps du DMT
* Formulaire reproduisant le document-mdical de transmission. L'utilisateur
* doit avoir une autorisation "dmt".
* @package dmt
* @author ob
*/
class dmt extends cadropt{
  /**
  * l'identifiant de session
  * @var string
  */
  var $idsession;
  
  /**
  * l'action associe au formulaire
  * @var int
  */
  var $action;
  
  /**
  * le numro d'une erreur de session
  * @var int
  */
  var $n_erreur = 0;
  
  /**
  * le contenu HTML de l'objet
  * @var string
  */
  var $vitrine;
  
  /**
  * un message  afficher au-dessus du formulaire
  * @var string
  */
  var $message;
     
  /**
  * la session associe
  * @var object
  */
  var $session;
  
  /**
  * le numro de transaction identifiant un envoi donn
  * @var string
  */
  var $noTrans;
  
  /**
  * une erreur de saisie
  * @var int
  */
  var $ad_erreur;
  
  /**
  * l'action servant  effacer un destinataire pralablement slectionn
  * @var int
  */
  var $actefface;

  /**
  * @param string no cf. variable de classe idsession
  * @param int act cf. variable de classe action
  * @param string nt Numro de transaction (pass  la session avant d'tre rcupr comme variable de classe noTrans)
  */ 
  function dmt($no, $act, $nt = 0, $actefface=0){
    $this->cadropt("#009966",90, false);
    $this->idsession = $no;
    $this->action = $act;
    $this->actefface = $actefface;
    $this->session = new sessionDmt($this->idsession,0,0,"dmt", $nt);
    $this->noTrans = $this->session->noTrans;
    if (!$this->verifSess($this->session)){
      return;
    }
  }
  
  /**
  * vrification de la session associe
  * @param object ss la session  vrifier
  * @return boolean la session est-elle OK ?
  */
  function verifSess($ss){
    if($ss->n_erreur){
      $this->n_erreur = $ss->n_erreur;
      return 0;
    }
    if(! ereg("dmt", $ss->autorisations)){
      $this->n_erreur = 1001;
      return 0;
    }
    else return 1;
  }

  /**
  * construction de l'affichage dans le menu principal de l'application
  */ 
  function faitVitrine(){
    global $fichier;
    if ($this->n_erreur) return;
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "dmt.php3", "POST");
    $c= new TLabel("Document mdical de transmission");
    $c->setColSpan("2");
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(1, 1, "", "", "50%");
    $c->addChamp(new TLabel("&nbsp;"));
    $form->addChamp($c);
    $c = new TPanel(1, 1, "CENTER", "", "60%");
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("Rdiger", "Rdiger", "SUBMIT");
    $c->addChamp($x);
    $form->addChamp($c);
    $this->vitrine = $this->entete;
    $this->vitrine .= $form->getContenu();
    $this->vitrine .= $this->pied;
  }

  /**
  * construction de l'affichage de la liste des destinataires potentiels
  */
  function faitListeUt(){
    global $fichier;
    if ($this->n_erreur) return;
    $this->vitrine = $this->entete;
    $tableau = $this->session->getListus();
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("", "$fichier?action=$this->action", "POST");
    $c = new TLabel("Choix des destinataires", true);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TLabel("Recherche alphab&eacute;tique");
    $form->addChamp($c);
    $form->addLigne();
    $c = new TPanel(1,1);
    $x = new ChampTexte("champs[0]", "", "D&eacute;but du nom :", "6", "6");
    $c->addChamp($x);
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("noTrans", "$this->noTrans", "HIDDEN");
    $c->addChamp($x);
    $c->addChamp(new Espace(5));
    $x = new Bouton("Chercher", "Chercher", "SUBMIT");
    $c->addChamp($x);
    $form->addChamp($c);
    $form->addLigne();
    $c = new TLabel("S&eacute;lectionnez le ou les destinataires");
    $form->addChamp($c);
    $form->addLigne();
    $liste = "";
    for ($i=0; $i < count($tableau); $i++){
      $liste .= $tableau[$i] . "<BR>";
    }
    $c = new TLabel("$liste");
    $form->addChamp($c);
    $this->vitrine .= $form->getContenu();
    $this->vitrine .= $this->pied;
  }

  
  /**
  * construction de l'affichage de la liste des destinataires slectionns
  */
  function faitListeDest($dest, $op){
    global $fichier, $redige;
    if ($this->n_erreur) return;
    if($op AND $dest){
      $this->session->ajouteTicket($dest);
    }
    $tableau = $this->session->getListDest();
    #Ajout d'un javascript dfinissant un tableau avec les noms des utilisateurs
    #qui sera repris par la fonction d'impression du dmt
    $script  = "\r\n<SCRIPT LANGUAGE=\"JavaScript\">\r\n" .
              "<!--\r\n";
    $nbel = count($tableau);
    $script .= "dests = new Array($nbel);\r\n";
    for ($i = 0; $i < $nbel; $i++){
      $script .= "dests[$i] = \"" . $tableau[$i][0] . "\";\r\n";
    }
    $script .= "//-->\r\n" .
               "</SCRIPT>";
    $this->vitrine = $script;
    $this->vitrine .= $this->entete;
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("destchoisis", "$fichier?action=$this->action", "POST");
    $c = new TLabel("Destinataires choisis :", true);
    $form->addChamp($c);
    $form->addLigne();
    $maxit = 0;
    $liste = "";
    if (! $tableau){
      $c = new TLabel("Choisissez les destinataires de ce document en cliquant sur " .
                      "leur nom dans le tableau de gauche", false);
      $form->addChamp($c);
    }
    else {
      $maxit = (count($tableau) == 6 ? 5 : count($tableau));

      for ($i=0; $i<$maxit; $i++){

        $liste .= $tableau[$i][0] .
                "&nbsp;&nbsp;<A HREF=\"$fichier?action=$this->actefface&" .
                "sessionid=$this->idsession&noTrans=$this->noTrans" .
                "&noticket=" .$tableau[$i][1] . "&redige=$redige\">Effacer</A><BR>";
      }
      if (isset ($tableau[5][0])){
          $liste .= "<BR><B>Le choix est limit&eacute; &agrave; cinq destinataires au maximum !</B>";
      }
      $c = new TLabel("$liste");
      $form->addChamp($c);

    }
    $form->addLigne();
    $c = new TPanel(1,1, "RIGHT");
    for ($i=0; $i<5; $i++){
      $x = new Bouton("Ticket$i", ($i >= $maxit ? "0" : $tableau[$i][1]) , "HIDDEN");
      $c->addChamp($x);
    }
    $x = new Bouton("Quitter", "Quitter", "BUTTON", "quitte(\"$this->idsession\")");
    $c->addChamp($x);
    $c->addChamp(new Espace(5));
    if ($this->session->compteTickets() AND $redige != 1){


      $x = new Bouton("Rediger", "R&eacute;diger", "BUTTON",
                      "redige(\"$fichier\", \"$this->idsession\", \"$this->noTrans\")");
      $c->addChamp($x);
      $c->addChamp(new Espace(5));
    }
    $form->addChamp($c);

    $this->vitrine .= $form->getContenu();
    $this->vitrine .= $this->pied;
  }

  /**
  * construction de l'affichage du corps du document
  */
  function faitDocument(){
  if ($this->n_erreur) return;
  $this->cadropt("#800080",95, false);
  $this->vitrine = $this->entete;
  $tf = new TabForm();
  $tf->setTabParam();
  $tf->setFormParam("dmt", "", "");
  $c = new TLabel("&nbsp;&nbsp;");
  $tf->addChamp($c);
  $c = new TLabel("&nbsp;&nbsp;");
  $tf->addChamp($c);
  $c = new TLabel("&nbsp;&nbsp;");
  $tf->addChamp($c);
  $c = new TLabel("&nbsp;&nbsp;");
  $tf->addChamp($c);
  $c = new TLabel("&nbsp;&nbsp;");
  $tf->addChamp($c);
  $c = new TLabel("&nbsp;&nbsp;");
  $tf->addChamp($c);
  $c = new TLabel("&nbsp;&nbsp;");
  $tf->addChamp($c);
  $c = new TLabel("&nbsp;&nbsp;");
  $tf->addChamp($c);
  $c = new TLabel("&nbsp;&nbsp;");
  $tf->addChamp($c);
  $c = new TLabel("&nbsp;&nbsp;");
  $tf->addChamp($c);
  $c = new TLabel("&nbsp;&nbsp;");
  $tf->addChamp($c);
  $c = new TLabel("&nbsp;&nbsp;");
  $tf->addChamp($c);
  $tf->addLigne();
  $c = new TLabel ("AROVAL - DOCUMENT MEDICAL DE TRANSMISSION - Confidentiel", true, false, true);
  $c->setColSpan("12");
  $c->setAlign("CENTER");

  $tf->addChamp($c);
  $tf->addLigne();

  $c = new TLabel ("Concerne patient(e)", true, false, true);
  $c->setColSpan("12");
  $c->setAlign("LEFT");

  $tf->addChamp($c);
  $tf->addLigne();
  $c = new TPanel("12", "1");
  $x = new ChampTexte("patient", "", "Nom, prnom :", "40", "50", false);
  $c->addChamp($x);
  $tf->addChamp($c);
  $tf->addLigne();

  $c = new TChampTexte("domc", "", "rsidant  :", "30", "70", true);
  $c->setColSpan("7");
  $tf->addChamp($c);

  $c = new TChampTexte("daten", "", "n(e) le :", "12", "12", true);
  $c->setColSpan("5");
  $tf->addChamp($c);
  $tf->addLigne();

  $c = new TPanel("12", "1");
  $x = new Radio("cons", "", "A consult en urgence le", false, false);
  $c->addChamp($x);
  $x = new ChampTexte("datecons", "", "", "12", "12");
  $c->addChamp($x);
  $tf->addChamp($c);

  $tf->addLigne();
  $c = new TPanel("12", "1");
  $x = new Radio("cons", "", "A sjourn du", false, false);
  $c->addChamp($x);
  $x = new ChampTexte("datedeb", "", "", "12", "12");
  $c->addChamp($x);
  $x = new Espace(8);
  $c->addChamp($x);
  $x = new ChampTexte("datefin", "", "au", "12", "12");
  $c->addChamp($x);
  $tf->addChamp($c);

  $tf->addLigne();
  $c = new TPanel("12", "1", "LEFT", "TOP");
  $x = new Label("Dmarche", true, false, false);
  $c->addChamp($x);
  $tf->addChamp($c);
  $tf->addLigne();

  $c = new TPanel("4", "1", "LEFT", "TOP");
  $x = new Radio ("dem", "", "Demande d'admission", false, true);
  $c->addChamp($x);
  $x = new Radio ("dem", "", "Avis de transfert", false, true);
  $c->addChamp($x);
  $tf->addChamp($c);

  $c = new TPanel("3", "1");
  $x = new Radio ("et", "", "Hpital&nbsp;:", false, true);
  $c->addChamp($x);
  $x = new Radio ("et", "", "EMS&nbsp;:", false, true);
  $c->addChamp($x);
  $x = new Radio ("et", "", "CTR&nbsp;:", false, true);
  $c->addChamp($x);
  $tf->addChamp($c);

  $c = new TChampTexte("nomet", "", "Nom de l'&eacute;tablissement&nbsp;:", "15", "20", true);
  $c->setColspan("3");
  $tf->addChamp($c);

  $c = new TPanel("2", "1", "LEFT", "TOP");
  $x = new Radio ("sej", "Long sjour", "Long sjour", false, true);
  $c->addChamp($x);
  $x = new Radio ("sej", "Court sjour", "Court sjour", false, true);
  $c->addChamp($x);

  $tf->addChamp($c);

  $tf->addLigne();

  $c = new TPanel("5", "1");
  $x = new Radio("dem", "Annonce de retour  domicile", "Annonce de retour  domicile", false, false);
  $c->addChamp($x);


  $tf->addChamp($c);
  $c = new TPanel("7", "1");
  $x = new ChampTexte("datedem", "", "Date :", "12", "12", true);
  $c->addChamp($x);
  $tf->addChamp($c);


  $tf->addLigne();
  $c = new TTextArea("diag", "", "Diagnostic - Problme principal - Examens - Traitements", "60", "6");
  $c->setColSpan("12");
  $tf->addChamp($c);

  $tf->addLigne();
  $c = new TTextArea("aut", "", "Autres affections et problmes - traitements habituels", "60", "6");
  $c->setColSpan("12");
  $tf->addChamp($c);

  $tf->addLigne();
  $c = new TLabel ("Mdico-social", true, false, false);

  $c->setColSpan("12");
  $c->setRowSpan("1");
  $tf->addChamp($c);
  $tf->addLigne();

  $c = new TChampTexte("persref", "", "Personne de rfrence :", "25", "40", true);
  $c->setColSpan("6");
  $tf->addChamp($c);
  $c = new TChampTexte("telref", "", "Tl :", "20", "20", true);
  $c->setColSpan("6");
  $tf->addChamp($c);

  $tf->addLigne();
  $c = new TPanel("12","1");
  $x = New CheckBox("dms", "1", "Doc. md.-soc. joint", false, false);
  $c->addChamp($x);
  $tf->addChamp($c);
  $tf->addLigne();
  $c = new TPanel("12", "1");
  $x = new ChampTexte("prct", "", "Arrt de travail (%)", "5", "5", false);
  $c->addChamp($x);
  $x = new Espace(5);
  $c->addChamp($x);
  $x = new ChampTexte("ardu", "", "du", "12", "12", false);
  $c->addChamp($x);
  $x = new Espace(5);
  $c->addChamp($x);
  $x = new ChampTexte("arau", "", "au", "12", "12", false);
  $c->addChamp($x);
  $tf->addChamp($c);

  $tf->addLigne();
  $c = new TLabel("Document r&eacute;dig&eacute; par " . $this->session->nomplein .
                  " au titre de m&eacute;decin&nbsp;: ", false, false, false);
  $c->setColSpan("7");
  $tf->addChamp($c);
  $c = new TPanel("5", "1");
  $x = new Bouton("exp", $this->session->nomplein, "HIDDEN");
  $c->addChamp($x);
  $x = new Bouton("nodoc", $this->noTrans, "HIDDEN");
  $c->addChamp($x);
  $x = new Radio("medtt", "", "traitant", false, false);
  $c->addChamp($x);
  $c->addChamp(new Espace(5));
  $x = new Radio("medtt", "", "de garde", false, false);
  $c->addChamp($x);
  $c->addChamp(new Espace(5));
  $x = new Radio("medtt", "", "hospitalier", false, false);
  $c->addChamp($x);
  $tf->addChamp($c);

  $tf->addLigne();
  $c = new TPanel("12", "1", "RIGHT");
  $x = new Bouton("Envoi", "Crypter et envoyer", "Button", "Envoyer()");
  $c->addChamp($x);
  $x = new Espace(10);
  $c->addChamp($x);
  $x = new Bouton("Impression", "Impression...", "Button", "fenImpr()");
  $c->addChamp($x);
  $x = new Espace(10);
  $c->addChamp($x);
  $x = new Bouton("Abandon", "Effacer document", "Reset");
  $c->addChamp($x);
  $c->addChamp(new Espace(10));
  $x = new Bouton("Quitter", "Quitter", "Button", "quitte(\"$this->idsession\")");
  $c->addChamp($x);
  $tf->addChamp($c);
  $tf->addLigne();
  $c = new TLabel("Identification du document (tient lieu de signature) : " . $this->noTrans , false, false, false);
  $c->setColspan("12");
  $tf->addChamp($c);

  $this->vitrine .= $tf->getContenu();

  $this->vitrine .= $this->pied;
  
  }

  /**
  * affichage du contenu HTML de l'objet
  */
  function imprime(){
    if ($this->n_erreur) return;
    print $this->vitrine;
  }

}

 ?>
