<?php
  // $Id: dossierBrioche.inc,v 1.1.1.1 2010-10-11 22:25:45 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Dossier Brioche
* @package formulaires
*/
/**
* Dossier Brioche
* Formulaire principal du dossier Brioche, contenant le dessin des onglets, la barre de navigation ainsi que la page de garde (onglet de navigation).
* Les pages correspondant aux autres onglets font l'objet de classes particulires pageDossierBrioche...
* @package formulaires
* @author ob cjd jdu
*/
class dossierBrioche extends cadronglet {
  /**
  * l'enregistrement correspondant au dossier courant
  * @var object
  */
  var $rs;
   
  /**
  * le numro du dossier courant
  * @var int
  */
  var $item;
   
  /**
  * les options transmises
  * @var object
  */
  var $options;
   
  /**
  * les options  transmettre
  * @var object
  */
  var $futuroptions;
   
  /**
  * un tableau de variables correspondant aux champs du formulaire, pour criture dans la base, 
  * ou pour la shunter lors de la vrification des donnes saisies
  * lors de la vrification de celles-ci
  * @var array
  */
  var $recup;
   
  /**
  * l'enregistrement de la table "dossiers" correspondant  ce dossier
  * @var object
  */
  var $dossiers;
   
  /**
  * l'enregistrement de la table "usagers" correspondant  ce dossier
  * @var object
  */
  var $usagers;
   
  /**
  * un tableau associatif de variables transmis par le module "planning" et servant  prremplir certains champs 
  * de la demande d'orientation
  * @var array
  */
  var $lcs;
   
  /**
  * action supplmentaire (pour le contrle du numro postal dans la demande d'orientation "Service placeur"
  * @var int
  */
  var $action2;
   
  /**
  * numro d'tablissement, lorsque le mode d'affichage 5 est slectionn (filtrer par tablissement)
  * ou le numro de la demande  valider lors de validation de demandes lectroniques
  * @var int
  */
  var $noetabl; 
   
  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string gris la couleur du gris
  * @param string fondpage la couleur de fond de la page
  * @param sring sessionid l'identifiant de session
  * @param int item le numro du dossier
  * @param string options la chane de caractres correspondant aux options passes
  * @param array recup le tableau des variables postes par le formulaire
  * @param int noetabl le numro de l'tablissement (lorsqu'on affiche les dossiers prinscrits dans
  * un dossier donn (l'option MODE = 5)
  * @param int action2 cf. variable de classe
  * @param array donnees un tableau de paramtres facultatif,  passer indpendamment de la base de donnes
  */
  function dossierBrioche($largeur, $grise, $actif, $fondpage, $sessionid, $item = 0, $options = 0, $recup = 0,
                          $noetabl = 0, $lcs = 0, $action2 = 0, $donnees = 0){  
    global $fdosbrioche;
    global $imagesdir;
    //global $noetabl;
    $this->options = new optionsBrioche($options);
    $largeur_entete_onglet = 80;
    $this->action2 = $action2;
    if ($this->options->getOption("MODE") == 5) $this->noetabl = $noetabl;
    $autspec = array();
    $ini = new briocheIni();
    $autspec[0] = $ini->autSpec[1];
    if ( ! $this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid, $autspec)) return;
    //Faut-il actualiser ?
    if ($this->options->getOption("MAINTENANT") == 2){
      $this->options->setOption("MAINTENANT", 0);
      $ab = new archivageBrioche($this->idsession);
    }
    // Faut-il vrifier les annonces de lit et dles demandes d'orientations reues par Internet
    if ((! $actif) && $this->options->getOption("VAL_DEM") == 9) { 
      $this->options->setOption("VAL_DEM", 0);
      if($this->verifAut($ini->autSpec[3], $this->autorisations)) { //Annonces de lit
        $va = new ensTableBrioche("avalider", "1", "*", 0, $this->idsession);
        $cpt = $va->compte();
        if ($cpt){
          $vx = new verrouAn($this->idsession, "annonces");
          if ($vx->isOuvert()){
            $vx->ferme();
            $script = "document.location='$fdosbrioche?action=5002&sessionid=$this->idsession'";
            $co = new Confirm("Vous avez reu $cpt annonce" . ($cpt == 1 ? "" : "s") . 
                            " de lit. Dsirez-vous valider maintenant ?",
                            $script);
            $co->imprime();
          }  
        }
      }
      if ($this->verifAut($ini->autSuppl[4], $this->autorisations)) {
        
        $vx = new verrouAn($this->idsession, "demandes");
        if ($vx->isOuvert()){
          $vx->ferme();
          //Rcupration des demandes sur Mange
          if ($ini->interbrio && $ini->manegeReleverAuLogin) {
            $man = new clientManege($this->idsession);
            $man->getDemandes();
            
          }
          
          $vd = new ensTableBrioche("avaliderdem", "1", "*", 0, $this->idsession);
          $cpt = $vd->compte();
          if ($cpt){
            $futopt = new optionsBrioche();
            $futopt->setOption("MODE", 4);
            $script = "document.location='$fdosbrioche?action=21&sessionid=$this->idsession&options=" .
                      $futopt->getChaine() . "'";
            $co = new Confirm("Vous avez reu $cpt demande" . ($cpt == 1 ? "" : "s") .
                              " d\'orientation. Dsirez-vous valider maintenant ?",
                              $script);
            $co->imprime();                    
          }
          else {
            $vx->rouvre();
          }
        }
      }
      //Vrification que l'affichage des popups est autoris
      print  "<SCRIPT LANGUAGE=\"JavaScript\">" .
             "testPopup();" .
             "postTestPopup();" .
             "</SCRIPT>";
    }  
    
    $this->lcs = $lcs;
    $this->recup = $recup;
    $this->action = $actif;
    // Connexion aux donnes
    $nav = new ensNavBrioche($this->options->getOption("MODE"), $this->idsession, $autspec);
    // dfinition d'un sous-ensemble de dossiers en fonction des options
    $mode5 = false;
    if ($this->options->getOption("MODE") == 5){   //affichage des prinscriptions (MODE 5)
      $nav->setEtablissement($noetabl);
      $mode5 = true;
    }
    $this->item = ($item ? $item : $nav->getPrecedent(0));
    $nous = 0;
    $this->futuroptions = new optionsBrioche($this->options->getChaine());
    if ($this->item == -999){ // Pas encore de numro de dossier
      if ($this->actif == 20){ // Demande SP => table avaliderdem
        $this->rs = new ensTableBrioche("avaliderdem", "", "*", 0, $this->idsession, 0, 0, false,
                                        $autspec);
        $this->item = $this->rs->creeNouveau("nodemor");
        $nomplein = "";  
      }
      elseif ($this->actif == 21 || $this->actif == 121){ // Validation demande SP
        
        $this->rs = new enrBrioche(0, $this->idsession);
        $this->item = $this->rs->creeDepuisAval($noetabl);
        if (! $this->item){ // Il n'y a plus de dossiers  valider
          $al = new Alerte("Il n\'y a plus de demande  valider...");
          $al->imprime();
          $verrou = new verrouAn($this->idsession, "demandes");
          $verrou->rouvre();
          
          
          print "<SCRIPT LANGUAGE=\"JavaScript\">" .
                "window.location='$fdosbrioche?action=0&sessionid=$this->idsession';" .         
                "</SCRIPT>";
          return;
          
          //$fe = new fermeFenetre(0, 1);
        }
        $this->usagers = $this->rs->getEnr("usagers");
        $nomplein = $this->usagers->nom . " " . $this->usagers->prenom;
        $futopt = new optionsBrioche($this->options->getChaine());
        $futopt->setOption("BLOQUE_US", 1);
        $futopt->setOption("NOUV_US", 2);
        $futopt->setOption("PASSE", 5); // Pour rgler le comportement du bouton slectionner de la fiche d'usager
        
        
      }
      else { // Demande ordinaire
        $this->rs = new enrBrioche($this->item, $this->idsession);
        $this->item = $this->rs->creeNouveau();
        $nomplein = "";
      }    
      $nav = new ensNavBrioche(4, $this->idsession, $autspec);
    }
    else { // Dj un numro de dossier
      if ($this->actif == 20){ // Demande SP
        $this->rs = new ensTableBrioche("avaliderdem", "nodemor = $this->item", "*", 0, $this->idsession, 0, 0,
                                        false, $autspec);
        $demandeor = $this->rs->getTableau($this->recup);
        $demandeor = $demandeor[0];
        $nomplein = $demandeor->nom . " " . $demandeor->prenom;
      }
      elseif ($this->actif == 21 || $this->actif == 121){ // Validation demande SP
        $this->rs = new enrBrioche($this->item, $this->idsession);
        $this->usagers = $this->rs->getEnr("usagers");
        $nomplein = $this->usagers->nom . " " . $this->usagers->prenom;
        
        /*
        $cd = new checkDoublons(200, "#efefef", 6201, "#009966", 11, $this->idsession, $this->usagers->nous);
        
        if ($cd->doublons != -999){
          print "<SCRIPT LANGUAGE=\"JavaScript\">" .
                "ouvreFenetre(\"brioche.php?action=1102&sessionid=" . $this->idsession .
                "&item=" . $this->usagers->nous . "&options=" .  $futopt->getChaine() .
                "\", \"usager\"," .
                " \"scrollbars=yes,resizable=no,menubar=no,locationbar=no,height=500,width=800,screenX=50,screenY=50\")" .
                "</SCRIPT>"; 
        }
        */
      }
      else { // Dossier ordinaire
        
        $this->rs = new enrBrioche($this->item, $this->idsession);
        $this->usagers = $this->rs->getEnr("usagers");
        $nav->setUsager($this->usagers->nous);
        // Vrification que l'item demand se trouve dans le sous-ensemble dfini. 
        // Si non, modifier l'item ou modifer les options.
        if (! $nav->checkItem($this->item)){ // Dossier pas trouv dans le mode courant
          if ($this->options->getOption("FORCE_DOSS") == "1"){ // dossier forc donc changement de mode
            $this->options->setOption("MODE", 2);
            $nav = new ensNavBrioche($this->options->getOption("MODE"), $this->idsession);
            if (! $nav->checkItem($this->item)){
              $al = new Alerte("Dossier N $this->item inexistant !");
              $al->imprime();
              $this->item = $nav->getSuivant(0);
            }
          }
          else {
            $this->item = $nav->getSuivant(0); // Mode forc => dossier suivant
          }
        }
        $this->rs->setItem($this->item);
        if ($this->recup && isset($this->recup['nous'])) {
          $us = new EnsTableBrioche("usagers", "nous = " . $recup['nous'], "*", 0, $this->idsession);
          $tb = $us->getTableau();
          if (is_array($tb) && isset($tb[0])) {
            $this->usagers = $tb[0];
          }
        }
        else {
          $this->usagers = $this->rs->getEnr("usagers");
        }
        $this->dossiers = $this->rs->getEnr("dossiers");
        $nomplein = $this->usagers->nom . " " . $this->usagers->prenom;
        $nav->setUsager($this->usagers->nous);
        if ($this->options->getOption("MODE") != 4){
          $this->futuroptions->setOption("NOUV_DOSS", 0);
        }
        $this->futuroptions->setOption("ATTR_LIT", 0);
        /*
        if ($this->futuroptions->getOption("MODE") == 4){
          $this->futuroptions->setOption("MODE", 0);
          $this->futuroptions->setOption("FORCE_DOSS", 0);
        }
        */
        if (! $this->futuroptions->getOption("REPRISE_OPARS")){
          for ($i = 1; $i <= 4; $i++){
            $this->futuroptions->setOption("Q$i", 0);
            $this->options->setOption("Q$i", 0);
          }
        }
        $this->options->setOption("REPRISE_OPARS", 0);
        $this->futuroptions->setOption("REPRISE_OPARS", 0);
      }
    }
    // Dessin des onglets
    $this->futuroptions->setOption("SEUL_CS", 0);
    
    $titre = "";
    if ($this->usagers->sexe == "M") $titre = "M.";
    elseif ($this->usagers->sexe == "F") $titre = "Mme";
    $nomplein = $titre . " " . $nomplein;
    if ($this->usagers->inactif) $nomplein = "(".$nomplein.")";
        
    $usOptions = new optionsBrioche($this->options->getChaine());
    $usOptions->setOption("MODE", 9);
    $usOptions->setOption("BLOQUE_US", 0);
    $usOptions->setOption("NOUV_US", 1);
    
    $js = "javascript:ouvreFenetre('" . $fdosbrioche . "?action=1001&sessionid=" .
		    $this->idsession . "&item=".$this->usagers->nous."&options=" .  $usOptions->getChaine() .
		    "', 'Usager', 'dependent=yes,scrollbars=yes," .
		    "resizable=no,menubar=no,locationbar=no,height=550,width=850,screenX=50,screenY=50')";
		    
    $nomplein = new Lien("<u>".$nomplein."</u>",true,false,false,$nomplein,"",0,false,$js);
    $nomplein = $nomplein->getContenu();
		    
    $tabbande = array("Dossier courant :", $this->item, $nomplein, "N usager : " .
                      $this->usagers->nous, " - Ouvert le " . $this->dossiers->datouv);
    if ($this->options->getOption("NOUV_DOSS") == 0){ // Onglet demande seul si nouveau dossier
      $this->addOnglet("Navigation", $tabbande, "#8b8378", 0, $largeur_entete_onglet,
                       "javascript:lienCond('$fdosbrioche?action=0&sessionid=$this->idsession&item=$this->item" .
                       ($mode5 ? "&noetabl=" . $noetabl : "" ) . "&options=" . $this->futuroptions->getChaine() . "')");
    }
    if ($this->actif == 20){ // Demande SP
      $tabbande = array("Demande d'orientation", "Rf. $this->item", "", "", "", "");
      $this->addOnglet("Service placeur", $tabbande, "#4488cc", 20, 120, "");
    }
    elseif ($this->actif == 21 || $this->actif == 121) { // Validation demande SP  
      $tabbande = array("Demande d'orientation", "Dossier prov.  $this->item", $nomplein, "N usager : " .
                        $this->usagers->nous, "", "");
      $this->addOnglet("Validation", $tabbande, "#4488cc", $this->actif, 120,
                     "");
      
    }
    else { // Demande ordinaire
      $tabbande[0] = "Demande d'orientation - Dossier ";
      $do =  $this->rs->getEnr("demandeor");
      $class_vars = get_class_vars(get_class($do));
      if (is_array($class_vars) && in_array("notrans", $class_vars)) {
        if ($do->notrans){
          $tabbande[2] = $tabbande[2] . " - Rf. " . $do->notrans;
        }
      }      
      
      $this->addOnglet("<b>Demande</b>", $tabbande, "#5CF80F", 1, $largeur_entete_onglet,
                     "javascript:lienCond('$fdosbrioche?action=1&sessionid=$this->idsession&item=$this->item" .
                     ($mode5 ? "&noetabl=" . $noetabl : "" ) . "&options=" . $this->futuroptions->getChaine() . "')");
      
    }
    if ($this->options->getOption("NOUV_DOSS") == 0) {
    	
      $cptEMS_a = compteContenu($this->item,'choixems','nodoss',$this->idsession,"AND (litsC OR litsD OR autbrio)","etablissements","noems = noet");
      $cptEMS_b = compteContenu($this->item,'choixems','nodoss',$this->idsession,"AND (litsC OR litsD OR autbrio) AND (chus != 0 OR refus != 0 
      OR chpro != 0 OR refpro != 0)","etablissements","noems = noet");
      $cptEMS_c = compteContenu($this->item,'dossiers','nodoss',$this->idsession,"AND (priorite != 0)");
      $cptCTR_a = compteContenu($this->item,'choixems','nodoss',$this->idsession,"AND (type_hopital = 'B')","etablissements","noems = noet");
      $cptCTR_b = compteContenu($this->item,'choixems','nodoss',$this->idsession,"AND (type_hopital = 'B') AND (chus != 0 OR refus != 0 
      OR chpro != 0 OR refpro != 0)","etablissements","noems = noet");
      $cptOPARS = compteContenu($this->item,'profilopars','nodoss',$this->idsession,"AND (profil != 0 OR sitsoc != 0 OR NOT(ISNULL(datev)) OR NOT(ISNULL(faitepar)))");
      $cptGrille = compteContenu($this->item,'grille','nodoss',$this->idsession,
                   "AND (manger != 0 OR laver != 0 OR habiller != 0 OR deshab != 0 OR entpers != 0 OR contves != 0 
                    OR contana != 0 OR toilet != 0 OR memoire != 0 OR orientat != 0 OR jugement != 0 OR soccuper != 0 
                    OR parler != 0 OR voir != 0 OR moytransp != 0 OR telephone != 0 OR auxil != 0 OR escaliers != 0
                    OR medics != 0 OR preprepas != 0 OR lienssociaux != 0 OR gestad != 0 OR lessive != 0 OR courses != 0
                    OR entrlog != 0 OR entendre != 0 OR deplint != 0 OR deplext != 0 OR changpos != 0)");
      $cptDMST = compteContenu($this->item,'dmst','nodoss',$this->idsession, 
                    "AND (NOT(ISNULL(d_Dentree)) OR NOT(ISNULL(d_Desortie)) OR NOT(ISNULL(x_Numerodeclient)) OR NOT(ISNULL(x_Etatcivil)) 
                     OR NOT(ISNULL(x_Relconf)) OR NOT(ISNULL(x_Profess)) OR NOT(ISNULL(x_Npconjoint)) OR NOT(ISNULL(t_Telurg))
                     OR NOT(ISNULL(x_Medtrait)) OR NOT(ISNULL(x_Medhop)) OR NOT(ISNULL(x_Ass)) OR NOT(ISNULL(x_Numass))
                     OR NOT(ISNULL(x_Persrefadr)) OR NOT(ISNULL(x_Persrefnom)) OR NOT(ISNULL(t_Persreftel)) OR NOT(ISNULL(t_Persvivtel))
                     OR NOT(ISNULL(x_Persviv)) OR NOT(ISNULL(x_Persvivadr)) OR NOT(ISNULL(x_Cur)) OR NOT(ISNULL(x_Curadr))
                     OR NOT(ISNULL(t_Curtel)) OR NOT(ISNULL(a_Iti)) OR NOT(ISNULL(a_Resbes)) OR NOT(ISNULL(x_Transfavec))
                     OR NOT(ISNULL(x_Transportpar)) OR NOT(ISNULL(d_Transport)) OR NOT(ISNULL(A_Etatgeneral)) OR NOT(ISNULL(a_Motiftransfert))
                     OR NOT(ISNULL(a_Traitcours)) OR NOT(ISNULL(x_Med_Ord)) OR NOT(ISNULL(t_Med_Tel)) OR n_Transfavec != 0)");
                    
      $cptAttribution = compteContenu($this->item,'attributionlit','nodoss',$this->idsession,"AND (NOT(ISNULL(dateres)) OR NOT(ISNULL(dateplac)) OR 
      NOT(ISNULL(nolit)) OR typesej != 0 OR mission != 0)");
      $cptNotes = compteContenu($this->item,'notes','nodossier',$this->idsession,"AND NOT(ISNULL(textnotes))");
      $cptDecision = compteContenu($this->item,'decision','nodoss',$this->idsession,"AND (NOT(ISNULL(datedec)) OR orientation != 0 OR sejorient != 0 OR
      longprov != 0 OR csg != 0 OR csp != 0 OR ug != 0 OR up != 0 OR sb != 0 OR si != 0 OR erg != 0 OR aidmen != 0 OR lessrep != 0 OR repas != 0 OR 
      aidesoc != 0 OR telec != 0 OR transp != 0 OR NOT(ISNULL(autres)) OR accept != 0 OR interbrio != 0 OR motretrait != 0 OR motnouvdem != 0)");
      $cptIssue = compteContenu($this->item,'issue','nodoss',$this->idsession,"AND (NOT(ISNULL(dateissue)) OR issue != 0 OR NOT(ISNULL(noet)) OR 
      NOT(ISNULL(type_court_sejour)) OR NOT(ISNULL(issue2)))");
        
      if ($cptOPARS > 0) $texte = "<b>OPARS</b>"; else $texte = "OPARS";
      $tabbande[0] = "Evaluation OPARS - Dossier ";
      $this->addOnglet($texte, $tabbande, "#00e1ff", 2, $largeur_entete_onglet,
                       "javascript:lienCond('$fdosbrioche?action=2&sessionid=$this->idsession&item=$this->item" .
                       ($mode5 ? "&noetabl=" . $noetabl : "" ) . "&options=" . $this->futuroptions->getChaine() . "')");
                       
      if ($cptGrille > 0 || $cptDMST > 0) $texte = "<b>DMST</b>"; else $texte = "DMST";
      $tabbande[0] = "Grille dpendance (DMST) - Dossier ";
      $this->addOnglet($texte, $tabbande, "#122199", 8, $largeur_entete_onglet,
                       "javascript:lienCond('$fdosbrioche?action=8&sessionid=$this->idsession&item=$this->item" .
                       ($mode5 ? "&noetabl=" . $noetabl : "") . "&options=" . $this->futuroptions->getChaine() . "')");
      
      if ($cptCTR_b > 0) $texte = " ($cptCTR_b)"; else $texte = "";
      if ($cptCTR_a > 0) $texte = "<b>CTR $texte</b>"; else $texte = "CTR";
      $tabbande[0] = "CTR - Dossier ";
      $this->addOnglet($texte, $tabbande, "#FF9400", 9, $largeur_entete_onglet,
                       "javascript:lienCond('$fdosbrioche?action=9&sessionid=$this->idsession&item=$this->item" .
                       ($mode5 ? "&noetabl=" . $noetabl : "" ) . "&options=" . $this->futuroptions->getChaine() . "')");
      
      if ($cptEMS_b > 0) $texte = " ($cptEMS_b)"; else $texte = "";
      if ($cptEMS_a > 0 || $cptEMS_c > 0) $texte = "<b>EMS $texte</b>"; else $texte = "EMS";
      $tabbande[0] = "EMS - Dossier ";
      $this->addOnglet($texte, $tabbande, "#FF9490", 4, $largeur_entete_onglet,
                       "javascript:lienCond('$fdosbrioche?action=4&sessionid=$this->idsession&item=$this->item" .
                       ($mode5 ? "&noetabl=" . $noetabl : "" ) . "&options=" . $this->futuroptions->getChaine() . "')");
      
      if ($cptAttribution > 0) $texte = "<b>Attribution</b>"; else $texte = "Attribution";
      $tabbande[0] = "Attribution - Dossier ";
      $this->addOnglet($texte, $tabbande, "#5E9183", 5, $largeur_entete_onglet,
                       "javascript:lienCond('$fdosbrioche?action=5&sessionid=$this->idsession&item=$this->item" .
                       ($mode5 ? "&noetabl=" . $noetabl : "" ) . "&options=" . $this->futuroptions->getChaine() . "')");
                       
      if ($cptNotes > 0) $texte = "<b>Notes ($cptNotes)</b>"; else $texte = "Notes";
      $tabbande[0] = "Notes - Dossier ";
      $this->addOnglet($texte, $tabbande, "#E19C1A", 6, $largeur_entete_onglet,
                       "javascript:lienCond('$fdosbrioche?action=6&sessionid=$this->idsession&item=$this->item" .
                       ($mode5 ? "&noetabl=" . $noetabl : "" ) . "&options=" . $this->futuroptions->getChaine() . "')");
                       
      if ($cptDecision > 0) $texte = "<b>Dcision</b>"; else $texte = "Dcision";
      $tabbande[0] = "Dcision - Dossier ";
      $this->addOnglet($texte, $tabbande, "orange", 3, $largeur_entete_onglet,
                       "javascript:lienCond('$fdosbrioche?action=3&sessionid=$this->idsession&item=$this->item" .
                       ($mode5 ? "&noetabl=" . $noetabl : "" ) . "&options=" . $this->futuroptions->getChaine(). "')");
                       
      if ($cptIssue > 0) $texte = "<b>Issue</b>"; else $texte = "Issue";
      $tabbande[0] = "Issue - Dossier";
      $this->addOnglet($texte, $tabbande, "#0070E8", 7, $largeur_entete_onglet,
                       "javascript:lienCond('$fdosbrioche?action=7&sessionid=$this->idsession&item=$this->item" .
                       ($mode5 ? "&noetabl=" . $noetabl : "" ) . "&options=" . $this->futuroptions->getChaine() . "')");
    }
    $this->colmateOnglets();
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6, $this->largeurecran);
    $of->setFormParam("navigation", $fdosbrioche, "post");

    //Navigation
    if ($this->options->getOption("NOUV_DOSS") == 0){
      $premier = $nav->getSuivant(0);
      $suivant = $nav->getSuivant($this->item);
      $precedent = $nav->getPrecedent($this->item);
      $dernier = $nav->getPrecedent(0);
      $navOptions = new optionsBrioche($this->options->getChaine());
      $navOptions->setOption("SEUL_CS", 0);
      $navOptions->setOption("FORCE_DOSS", 0);
      $c = new TPanel(2, 1);
      $x = new Label("Ouvert par <B>" . $this->dossiers->ouvpar . "</B> - Suivi par <B>" . $this->dossiers->suivpar . "</B>");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(2,1);
      $x = new Label($nav->getLibelle($this->options->getOption("MODE")) . " : " . $nav->getNbDoss() . " au total", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(2,1,"RIGHT", "MIDDLE");
      $x = new BoutonImage("Premier", "$imagesdir/premier.gif", 16, 16,
                           "javascript:lienCond('$fdosbrioche?action=$this->action&sessionid=$this->idsession&item=$premier" .
                           ($mode5 ? "&noetabl=" . $noetabl : "" ) . "&options=" .$navOptions->getChaine() . "')");
      $c->addChamp($x);
      $x = new BoutonImage("Prcdent", "$imagesdir/precedent.gif", 16, 16,
                           "javascript:lienCond('$fdosbrioche?action=$this->action&sessionid=$this->idsession&item=$precedent" .
                           ($mode5 ? "&noetabl=" . $noetabl : "" ) . "&options=" . $navOptions->getChaine() . "')");
      $c->addChamp($x);
      $x = new ChampTexte("item", $this->item, "", 5, 6, false, "text", "d2");
      $c->addChamp($x);
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      if ($mode5){
        $x = new Bouton("noetabl", $noetabl, "HIDDEN");
        $c->addChamp($x);
      }
      $this->futuroptions->setOption("FORCE_DOSS", 1);
      $x = new Bouton("options", $this->futuroptions->getChaine(), "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("action", $this->actif, "HIDDEN");
      $c->addChamp($x);
      $x = new BoutonImage("OK", "$imagesdir/vu.gif", 18, 16, "javascript:envoieCondNav()");
      $c->addChamp($x);
      $this->futuroptions->setOption("FORCE_DOSS", 0);
      $x = new BoutonImage("Suivant", "$imagesdir/suivant.gif", 16, 16,
                           "javascript:lienCond('$fdosbrioche?action=$this->action&sessionid=$this->idsession&item=$suivant" .
                           ($mode5 ? "&noetabl=" . $noetabl : "" ) . "&options=" . $navOptions->getChaine() . "')");
      $c->addChamp($x);
      $x = new BoutonImage("Dernier", "$imagesdir/dernier.gif", 16, 16,
                           "javascript:lienCond('$fdosbrioche?action=$this->action&sessionid=$this->idsession&item=$dernier" .
                           ($mode5 ? "&noetabl=" . $noetabl : "" ) . "&options=" . $navOptions->getChaine() . "')");
      $c->addChamp($x);
      $of->addChamp($c);
      if ($this->dossiers->sejobs == -1){
        $dem = $this->rs->getEnr("demandeor");
        $et = new EnsTableBrioche("etablissements", 1, "*", 0, $this->idsession);
        $etsejobs = "";
        if ($dem->etsejobs){
          $etsejobs = $et->lookUp("nomet", "noet = " . $dem->etsejobs);
        }
        $of->addLigne();
        $c = new TLabel("<FONT COLOR=\"red\">Sjour d'observation&nbsp;: $etsejobs</FONT>");
        $c->setColspan(6);
        $of->addChamp($c);
      }
      // Bande de couleur
      $coulb = "red";
      if ($this->rs->isOuvert()){
        if ($this->rs->isOuvert(1)) {
          $coulb = "#40FF63";
        }
        else {
          $coulb = "orange"; 
        }
      }
      $of->addLigneVierge();
      $c = new TBandeCouleur(6, 6, $coulb);
      $of->addChamp($c);

    }
    
    $this->addContenu($of->getContenu());
    //ajout du contenu spcifique
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6, $this->largeurecran);
    $of->setFormParam("donnees", $fdosbrioche, "post");
    $of->addLigne();
    switch ($this->actif){
    //Onglet Navigation
    case 0:
      $c = new TLabel("Mode :");
      $c->setColspan(1);
      $of->addChamp($c);
      $this->futuroptions = new optionsBrioche($this->options->getChaine());
      $this->futuroptions->setOption("FORCE_DOSS", 0);
      if ($this->futuroptions->getOption("MODE") == 4){
        $this->futuroptions->setOption("MODE", 0);
      }
      $c = new GrTBoutonTexte($this->futuroptions->getOption("MODE"), 4, 700, 18, "#ACA294", $grise, 4);
      $this->futuroptions->setOption("MODE", 0);
      $c->addBouton($nav->getLibelle(0), "$fdosbrioche?action=0&sessionid=$this->idsession&item=$this->item&options=" .
                    $this->futuroptions->getChaine(), 0);
      $this->futuroptions->setOption("MODE", 1);
      $c->addBouton($nav->getLibelle(1), "$fdosbrioche?action=0&sessionid=$this->idsession&item=$this->item&options=" .
                    $this->futuroptions->getChaine(), 1);
      $this->futuroptions->setOption("MODE", 2);
      $c->addBouton($nav->getLibelle(2), "$fdosbrioche?action=0&sessionid=$this->idsession&item=$this->item&options=" .
                    $this->futuroptions->getChaine(), 2);
      $this->futuroptions->setOption("MODE", 3);
      $c->addBouton($nav->getLibelle(3), "$fdosbrioche?action=0&sessionid=$this->idsession&item=$this->item&options=" .
                    $this->futuroptions->getChaine(), 3);
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne();
      $c = new TPanel(1);
      $x = new Label("Afficher&nbsp;:");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new GrTBoutonTexte(-999, 4, 700, 18, "", $grise, 4);

      // Usagers
      $this->futuroptions = new optionsBrioche($this->options->getChaine());
      $this->futuroptions->setOption("BLOQUE_US", 0);
      $this->futuroptions->setOption("NOUV_US", 1);
      $this->futuroptions->setOption("MODE", 9);
      $c->addBouton("Usagers", "javascript:ouvreFenetre('" . $fdosbrioche . "?action=1001&sessionid=" .
		    $this->idsession . "&item=0&options=" .  $this->futuroptions->getChaine() .
		    "', 'Usager', 'dependent=yes,scrollbars=yes," .
		    "resizable=no,menubar=no,locationbar=no,height=550,width=850,screenX=50,screenY=50')", 1);
    
      $this->futuroptions->setOption("NOUV_US", 0);
      $c->addBouton("Etablissements", "javascript:ouvreFenetre('" . $fdosbrioche . "?action=3001&sessionid=" .
                    $this->idsession . "&item=0&options=" . $this->futuroptions->getChaine() .
                    "', 'Etablissements', 'dependent=yes,scrollbars=yes," .
                    "resizable=no,menubar=no,locationbar=no,height=600,width=800,screenX=50,screenY=50')", 1);
      $c->addBouton("Lits", "javascript:ouvreFenetre('" . $fdosbrioche . "?action=4001&sessionid=" . $this->idsession .
                    "&options=" .$this->futuroptions->getChaine() . 
                    "', 'Lits','dependent=yes,scrollbars=yes,resizable=no," .
                    "menubar=no,locationbar=no,height=800,width=780,screenX=50,screenY=50')" , 1);
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne();
      $c = new TPanel(1);
      $x = new Label("<FONT COLOR=\"green\">Saisir :</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $us = new enrUsBrioche($this->usagers->nous, $this->idsession);
      $do = $this->rs->getEnr("demandeor");
      $rouvre = false;
      $c = new GrTBoutonTexte(-999, 4, 700, 18, "", $grise, 4);
      $this->futuroptions = new optionsBrioche($this->options->getChaine());
      $this->futuroptions->setOption("BLOQUE_US", 0);
      $this->futuroptions->setOption("NOUV_US", 1);
      $this->futuroptions->setOption("NOUV_DOSS", 1);
      $this->futuroptions->setOption("MODE", 4);
      $c->addBouton("Demande d'orientation", "$fdosbrioche?action=1&sessionid=$this->idsession&item=-999&options=" .
                    $this->futuroptions->getChaine(), 1);

      // Annonces de lits
      if ($this->verifAut($ini->autSpec[3], $this->autorisations)){
        $this->futuroptions = new optionsBrioche($this->options->getChaine());
        $this->futuroptions->setOption("EDITABLE", 1);
        $this->futuroptions->setOption("ANN_LIT", 1);
                      $c->addBouton("Annonce de lit", "javascript:ouvreFenetre('" .$fdosbrioche .
                      "?action=5001&sessionid=$this->idsession&item=-999&options=" .
                      $this->futuroptions->getChaine() .
                      "', 'Lits','scrollbars=yes,resizable=no,menubar=no,locationbar=no," .
                      "height=500,width=780,screenX=50,screenY=50')", 1);
      }
      $this->futuroptions = new optionsBrioche($this->options->getChaine());
      $this->futuroptions->setOption("MAINTENANT", 2);
      $this->futuroptions->setOption("FORCE_DOSS", 1);
      $c->addBouton("Actualiser",
                    "$fdosbrioche?action=0&sessionid=$this->idsession&item=$this->item&options=" .
                    $this->futuroptions->getChaine(), 1);
      if ($this->rs->rouvrable()){
        $this->futuroptions = new optionsBrioche($this->options->getChaine());
        $this->futuroptions->setOption("MODE", 0);
        $this->futuroptions->setOption("FORCE_DOSS", 0);
        $c->addBouton("Rouvrir dossier N $this->item",
                      "$fdosbrioche?action=998&sessionid=$this->idsession&item=$this->item&options=" .
                      $this->futuroptions->getChaine(), 1);
      }
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Aide("C0009");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $of->addChamp($c);
      $of->addLigne();

      // Fermer
      $c = new TPanel(6, 1, "RIGHT");
      $x = new Bouton("Fermer", "Fermer", "BUTTON", "if(!qModif())window.close()");
      $c->addChamp($x);
      $c->addChamp(new Espace(2));
      $of->addChamp($c);
      $of->addLigne();      

      $ini = new briocheIni();
      if ($this->verifAut($ini->autSuppl[0], $this->autorisations)){
        $c = new TPanel(1);
        $x = new Label("<FONT COLOR=\"red\">Dtruire&nbsp;:</FONT>");
        $c->addChamp($x);
        $of->addChamp($c);
        $c = new GrTBoutonTexte(-999, 1, 175, 18, "", $grise, 1);
        $this->futuroptions = new optionsBrioche($this->options->getChaine());
        if ($this->futuroptions->getOption("MODE") == 3){
          $this->futuroptions->setOption("MODE", 2);
        }  
        $this->futuroptions->setOption("FORCE_DOSS", 0);
        $c->addBouton("Dossier N $this->item",
                      "javascript:supprimeCond('$fdosbrioche?action=999&sessionid=$this->idsession&item=$this->item&options=" .
                      $this->futuroptions->getChaine() . "')", 1);
        
        $of->addChamp($c);
        $of->addLigne();
        $of->addLigne();
      }
      break;
    //Les contenus des onglets volumineux se trouvent dans les enfants de pageDossierBrioche;
    //Onglet demande d'orientation
    case 1:
    case 20:
    case 21:
    case 121:  
      $this->sauvCookie();
      $page = new pageDossierBriocheDemande($this);
      $of->addPage($page);
      break;
    //onglet OPARS
    case 2:
      $this->sauvCookie();
      $page = new pageDossierBriocheOpars($this);
      $of->addPage($page);
      break;
    //Onglet dcision
    case 3:
      $this->sauvCookie();
      $page = new pageDossierBriocheDecision($this);
      $of->addPage($page);
      break;
    case 4:
      $this->sauvCookie();
      $page = new pageDossierBriocheEMS($this);
      $of->addPage($page);
      break;
    case 5:
      $this->sauvCookie();
      $page = new pageDossierBriocheAttrib($this);
      $of->addPage($page);
      break;
    case 6:
      $this->sauvCookie();
      $page = new pageDossierBriocheNotes($this);
      $of->addPage($page);
      break;
    case 7:
      $this->sauvCookie();
      $page = new pageDossierBriocheIssue($this, $donnees);
      $of->addPage($page);
      break;
    case 8:
      $this->sauvCookie();
      $page = new pageDossierBriocheGrille($this);
      $of->addPage($page);
      break;
    case 9:
      $this->sauvCookie();
      $page = new pageDossierBriocheCTR($this);
      $of->addPage($page);
      break;
    }
    $this->addContenu($of->getContenu());
    
    if ($this->actif == 0) {
      
      $of = new OngForm();
      $of->setTabParam($this->largeur, $this->coulbande, 6, $this->largeurecran);
      $of->setFormParam("recherche",$fdosbrioche,"POST");   
      
      $contenu = "<tr><td width=40% valign='top'><table width=100%>";
      // Recherche
      $contenu .= $this->rechercheRapide();
      $contenu .= "</table></td><td width=60% valign='top'><table width=100%>";
      // Reception DMST
      $contenu .= $this->receptionDMST();
      $contenu .= "</table><br><table width=100%>";
      // Raccourci dossiers
      $contenu .= $this->raccourciDossiers();
      $contenu .= "</table></td></tr>";
      $of->corps .= $contenu;
      $of->addLigne();
      $of->addLigne();
            
      $this->addContenu($of->getContenu());
    }    
    
    $tf = new TabForm();
    $tf->setTabParam("90%", 0, 3, 0, "#009966");
    $c = new TLabel("&nbsp;");
    $tf->addChamp($c);

    $this->addContenu($tf->getContenu());
  }
  
  function rechercheRapide() {
      
    global $fdosbrioche;
    global $imagesdir;
    global $ini;
    global $itemNom, $itemPrenom;
      
    $contenu = "";
    
    $c = new TPanel(3);
    $x = new Label("Recherche rapide :",true);
    $c->addChamp($x);
    
    $contenu .= $c->TGetContenu();
    $contenu .= "</tr><tr><td colspan='3'>&nbsp;</td></tr><tr>";
    
    $tmp = $this->options->getOption("MODE");  
    $this->options->setOption("MODE", 9);
    $this->options->setOption("BLOQUE_US", 0);
    $this->options->setOption("NOUV_US", 1);
    
    $js = "javascript:ouvreFenetre(\"$fdosbrioche?action=1001&sessionid=$this->idsession&item=\"+document.getElementById(\"itemUsager\").value+\"" .
            "&options=" .  $this->options->getChaine() .
		    "\", \"Usager\", \"dependent=yes,scrollbars=yes," .
		    "resizable=no,menubar=no,locationbar=no,height=550,width=850,screenX=50,screenY=50\")";
    $c = new TPanel(3,1,"");
    $x = new Label("&nbsp;Numro Usager&nbsp;&nbsp;");
    $c->addChamp($x);
    $x = new ChampTexte("itemUsager", "", "", 22, 10, false, "text", "d2");
    $c->addChamp($x);
    $x = new Bouton("Chercher","Chercher","BUTTON", $js);
    $c->addChamp($x);
    
    $contenu .= $c->TGetContenu();
    $contenu .= "</tr><tr>";
    
    $this->options->setOption("MODE", $tmp);
    $this->options->setOption("FORCE_DOSS",1);
    $this->options->setOption("NOUV_US", 0);
    
    $js = "javascript:document.location=\"$fdosbrioche?action=0&sessionid=$this->idsession&item=\"+document.getElementById(\"itemDossier\").value+\"" .
                               "&options=" . $this->options->getChaine() . "\"";
    $c = new TPanel(3,1,"");
    $x = new Label("&nbsp;Numro Dossier&nbsp;");
    $c->addChamp($x);
    $x = new ChampTexte("itemDossier", "", "", 22, 10, false, "text", "d2");
    $c->addChamp($x);
    $x = new Bouton("Chercher","Chercher","BUTTON", $js);
    $c->addChamp($x);
    
    $contenu .= $c->TGetContenu();
    $contenu .= "</tr><tr>";
      
    $js = "javascript:document.location=\"$fdosbrioche?action=0&sessionid=$this->idsession&item=$this->item" .
                               "&options=" . $this->options->getChaine() . 
                               "&itemNom=\"+document.getElementById(\"itemNom\").value+\"".
                               "&itemPrenom=\"+document.getElementById(\"itemPrenom\").value;return false;";
    $c = new TPanel(3,1);
    $x = new ChampTexte("itemNom", $itemNom, "&nbsp;Nom ", 10, 10, false, "text", "d2");
    $c->addChamp($x);
    $x = new Label("<script>document.getElementById('itemNom').focus();</script>");
    $c->addChamp($x);
    $x = new ChampTexte("itemPrenom", $itemPrenom, "Prnom", 10, 10, false, "text", "d2");
    $c->addChamp($x);
    $x = new Bouton("Chercher","Chercher","SUBMIT", $js);
    $c->addChamp($x);
    
    $contenu .= $c->TGetContenu();
    $contenu .= "</tr><tr>";

    if ($itemNom != '' || $itemPrenom != '') {
    
        $this->options->setOption("MODE", 9);
        $this->options->setOption("BLOQUE_US", 0);
        $this->options->setOption("NOUV_US", 1);
        
        $tab = new ensTableBrioche("usagers", "nom LIKE \"$itemNom%\" AND prenom LIKE \"$itemPrenom%\" AND usagers.tst > " . ($ini->tstorig + 11),
                                   "CONCAT(nom, \" \", prenom) AS nomplein, usagers.nous, " .
                                   "IF (usagers.inactif = 0, " .
                                   "CONCAT(nom, \" \", prenom, \" - \", DAYOFMONTH(datenaiss), \".\", MONTH(datenaiss), \".\", " .
                                   "YEAR(datenaiss), IF(count(dossiers.nodoss) > count(dossiers.dateclo), \" *\", \"\")), " .
                                   "CONCAT(\"(\", nom, \" \", prenom, \" - \", DAYOFMONTH(datenaiss), \".\", MONTH(datenaiss), \".\", " .
                                   "YEAR(datenaiss), IF(count(dossiers.nodoss) > count(dossiers.dateclo), \" *\", \"\"), \")\")) AS nomdate",
                                   "nomplein", $this->idsession, "dossiers", "usagers.nous = dossiers.nous",
                                   false, 0, "usagers.nous");
        $c = new TPanel(3);
        if ($tab->compte()){
            $js = "javascript:ouvreFenetre('$fdosbrioche?action=1001&sessionid=$this->idsession&item='+document.recherche.item.value+'" .
                              "&options=" .  $this->options->getChaine() .
                              "', 'Usager', 'dependent=yes,scrollbars=yes," .
                              "resizable=no,menubar=no,locationbar=no,height=550,width=850,screenX=50,screenY=50')";
            $x = new ListOptTable("item", -1, $tab, false, 10, "d2", "\" ondblclick=\"$js");
            $x->addOptions("nomdate", "nous");
            $c->addChamp($x);
            $c->addChamp(new Espace(2));
            $x = new BoutonImage("Slectionner", "$imagesdir/vu.gif", 18, 16, $js);
            $c->addChamp($x);
            
            $contenu .= $c->TGetContenu();
            $contenu .= "</tr><tr>";
        
            // indication sur la signification de l'astrisque dans la liste des usagers
            $c = new TPanel(3);
            $x = new Label("* = Usager ayant un dossier ouvert<br/>( ) = Usager inactif (dcs,etc...)");
            $c->addChamp($x);
            
            $contenu .= $c->TGetContenu();
            $contenu .= "</tr>";
        } else {
            $x = new Label("La recherche ne renvoie aucun rsultat...");
            $c->addChamp($x);
            
            $contenu .= $c->TGetContenu();
            $contenu .= "</tr>";
        }
    } 
        
    return $contenu;
  }
  
  function receptionDMST() {
    
    global $fdosbrioche, $ini;
      
    $contenu = "";
    
    $jsTraiter = "javascript:ouvreFenetre('$fdosbrioche?sessionid=$this->idsession&action=8000&itemDMST={ITEM}&item=".$this->item .
		    "&options=".$this->options->getChaine()."', 'ReceptionDMST', 'dependent=yes,scrollbars=yes," .
		    "resizable=yes,menubar=no,locationbar=no,height=550,width=850,screenX=50,screenY=50');return false;";
    
    $js = "javascript:ouvreFenetre('xml.php?sessionid=$this->idsession&item={ITEM}" .
		    "', 'XML', 'dependent=yes,scrollbars=yes," .
		    "resizable=yes,menubar=no,locationbar=no,height=550,width=850,screenX=50,screenY=50');return false;";
    
    $jsEffacer = "if (confirm('Etes vous certain de vouloir poursuivre ?')) {document.location='$fdosbrioche?action=0&sessionid=$this->idsession&item=$this->item" .
                               "&options=" . $this->options->getChaine() . 
                               "&itemXML={ITEM}';}return false;";
		    
    $this->options->setOption("MODE", 9);
    $this->options->setOption("BLOQUE_US", 0);
    $this->options->setOption("NOUV_US", 1);
    
	$jsUsager = "javascript:ouvreFenetre('$fdosbrioche?action=1001&sessionid=$this->idsession&item={ITEM}" .
            "&options=" .  $this->options->getChaine() . "', 'Usager', 'dependent=yes,scrollbars=yes," .
		    "resizable=no,menubar=no,locationbar=no,height=550,width=850,screenX=50,screenY=50');return false;";
                               	    
    if ($this->verifAut($ini->autSuppl[4], $this->autorisations)) $where = "";
    else $where = "AND type = 'DMST'";

		    
    $recep = new ensTableBrioche("recepdmst","etat = 'S' $where","*",0,$this->idsession);
    $recep = $recep->getTableau();
    $cpt = count($recep);
           
    $c = new TPanel(3);
    $x = new Label("Dossiers et DMST reus ($cpt) :",true);
    $c->addChamp($x);
    $contenu .= $c->TGetContenu();
    $contenu .= "</tr><tr>";
    
    $c = new TPanel(3);
    $x = new Label("<table width='99%'><tr style='background-color:#DDDDDD;'><td><b>Provenance</b></td><td colspan='2'><b>Type</b></td><td><b>Usager</b></td><td><b>Action</b></td></tr>");
    $c->addChamp($x);
    foreach ($recep as $k => $ligne) {
                       
        $thisJsTraiter = str_replace("{ITEM}",$ligne->id,$jsTraiter);
        $thisJS = str_replace("{ITEM}",$ligne->id,$js);
        $thisJsEffacer = str_replace("{ITEM}",$ligne->id,$jsEffacer);
        if (fmod($k,2) == 0) $bgC = "#EEEEEE";
        else $bgC = "#ffda91";
        $cligne = "<tr style='background-color:$bgC;'><td>".$ligne->partenaire."</td>";
        if ($ligne->type == "DMST+") $cligne .= "<td>Demande orient.</td>";
        else $cligne .= "<td>$ligne->type</td>";
        $cligne .= "<td>".$ligne->type_sejour."</td>";
        $cligne .= "<td>";
        if ($ligne->usager > 0) {
            $thisJsUsager = str_replace("{ITEM}",$ligne->usager,$jsUsager);
            $cligne .= "<a href='' onclick=\"$thisJsUsager\">";
        }
        $cligne .= $ligne->nom." ".$ligne->prenom." (".$ligne->d_naissance.")";
        if ($ligne->usager > 0) $cligne .= "</a>";
        $cligne .= "</td><td>";
        $cligne .= "<a href='' onclick=\"$thisJsTraiter\">Traiter</a> ";
        $cligne .= "<a href='' onclick=\"$thisJS\">Consulter</a> ";
        $cligne .= "<a href='' onclick=\"$thisJsEffacer\">Effacer</a></td></tr>";
        $x = new Label($cligne);
        $c->addChamp($x);
    }
    $x = new Label("</table>");
    $c->addChamp($x);
    $contenu .= $c->TGetContenu();
    $contenu .= "</tr>";
    
    return $contenu;
  }

  function raccourciDossiers() {
    
    global $fdosbrioche, $imagesdir, $ini;
      
    $contenu = "";

    if (isset($_COOKIE['racDossOuv'])) $cookieOuv = $_COOKIE['racDossOuv'];
    else $cookieOuv = 'none';
    if (isset($_COOKIE['racDossDer'])) $cookieDer = $_COOKIE['racDossDer'];
    else $cookieDer = 'none';
    if (isset($_COOKIE['racDossSouf'])) $cookieSouf = $_COOKIE['racDossSouf'];
    else $cookieSouf = 'none';
            
    $init = new ensTableBrioche("initialesidut","idut = " . $this->nout,"init",0,$this->idsession);
    $init = $init->getPremier("init");
    
    $dossOuv = new ensTableBrioche("dossiers","suivpar = '$init' AND dateclo IS NULL",
                                   "*","nom",$this->idsession,array("usagers", "demandeor", "typesejour"),
                                   array("dossiers.nous = usagers.nous", 
                                         "demandeor.nodoss = dossiers.nodoss",
                                         "typesejour.idts = demandeor.typesej"));
                                         
    $nbDoss = $dossOuv->compte();
    $c = new TPanel(3);
    if ($cookieOuv == 'none') $src = 'plus.gif'; else $src = 'moins.gif';
    $img = "<img style='cursor:pointer;' id='ouvImg' name='ouvImg' src='$imagesdir/$src' onclick=\"changeDisp('racDossOuv','ouvImg');\"></img>";
    $x = new Label("Mes dossiers ouverts selon initiales  Suivi par  ($nbDoss) ".$img,true);
    $c->addChamp($x);
    $contenu .= $c->TGetContenu();
    $contenu .= "</tr><tr><td><div id='racDossOuv' name='racDossOuv'><table width=100%>";
            
    $this->options->setOption("FORCE_DOSS",1);
    $this->options->setOption("NOUV_US", 0);
    $this->options->setOption("MODE", 0);
    $js = "javascript:document.location='$fdosbrioche?action=1&sessionid=$this->idsession&item=&options=" . $this->options->getChaine() . "';return false;";
        
    $c = new TPanelTableau(12, 1, $dossOuv, "#EEEEEE", "dossiers", "nodoss", "", "", "", 0, "#FFDA91", "#DDDDDD");
    $x = new Lien("", false, false, false, "nodoss","#",0,false,$js);
    $c->addColChamp("Dossier", $x, false, true, false, false, "\"\" width=50 ");
    $x = new Label("", false, false, false, "datedem");
    $c->addColChamp("Date demande", $x, false, false, false, false, "\"\" width=100 ");
    $x = new Label("", false, false, false, "nom");
    $c->addColChamp("Nom", $x);
    $x = new Label("", false, false, false, "prenom");
    $c->addColChamp("Prnom", $x, false, false, false, false, "\"\" width=150 ");
    $x = new Label("", false, false, false, "ttypesej");
    $c->addColChamp("Sjour", $x, false, false, false, false, "\"\" width=180 ");
    $c->addTitres(true);
    $contenu .= $c->TGetContenu();
    $contenu .= "</table></div></td></tr><tr>";    
    
    if (isset($_COOKIE["DOSSIERS_".$this->nout])) {
        $dossDer = $_COOKIE["DOSSIERS_".$this->nout];
        $dossDer = explode(";",$dossDer);
        $orQuery = "0=1 ";
        foreach ($dossDer as $dd) {
            if ($dd == "") continue;
            $orQuery .= "OR dossiers.nodoss = $dd ";
        }
    } else {
        $orQuery = "0=1";   
    }

    $dossDer = new ensTableBrioche("dossiers","$orQuery","*","nom, dossiers.nodoss",$this->idsession,array("usagers", "demandeor", "typesejour"),
                                   array("dossiers.nous = usagers.nous", 
                                         "demandeor.nodoss = dossiers.nodoss",
                                         "typesejour.idts = demandeor.typesej"));      
    $dossDerTab = $dossDer->getTableau();
    $nbDoss = $dossDer->compte();
    $c = new TPanel(3);
    if ($cookieDer == 'none') $src = 'plus.gif'; else $src = 'moins.gif';
    $img = "<img style='cursor:pointer;' id='derImg' name='derImg' src='$imagesdir/$src' onclick=\"changeDisp('racDossDer','derImg');\"></img>";
    $x = new Label("Mes derniers dossiers consults ($nbDoss) ".$img,true);
    $c->addChamp($x);
    $contenu .= $c->TGetContenu();
    $contenu .= "</tr><tr><td><div id='racDossDer' name='racDossDer'><table width=99%>";
    
    $cpt = 0;
    $contenu .= "<tr><td bgColor='#DDDDDD' width=50><b>Dossier</b></td>";
    $contenu .= "<td bgColor='#DDDDDD' width=100><b>Date de demande</b></td>";
    $contenu .= "<td bgColor='#DDDDDD'><b>Nom</b></td>";
    $contenu .= "<td bgColor='#DDDDDD' width=150><b>Prnom</b></td>";
    $contenu .= "<td bgColor='#DDDDDD' width=180><b>Sjour</b></td></tr>";
    $js = "javascript:document.location=\"$fdosbrioche?action=1&sessionid=$this->idsession&item={ITEM}&options=" . $this->options->getChaine() . "\"";
    foreach ($dossDerTab as $k => $ligne) {
        if (fmod($cpt,2)==0) $bgc = "#EEEEEE";
        else $bgc = "#FFDA91";
        $thisJS = str_replace("{ITEM}",$ligne->nodoss,$js);
        
        if ($ligne->dateclo != '') $style = "style='color:red;'";
        else $style = "";
        
        $contenu .= "<tr>";
        $contenu .= "<td bgColor='$bgc'><a href='$thisJS' $style>".$ligne->nodoss."</a></td>";
        $contenu .= "<td bgColor='$bgc' $style>".$ligne->datedem."</td>";
        $contenu .= "<td bgColor='$bgc' $style>".$ligne->nom."</td>";
        $contenu .= "<td bgColor='$bgc' $style>".$ligne->prenom."</td>";
        $contenu .= "<td bgColor='$bgc' $style>".$ligne->ttypesej."</td>";
        $contenu .= "</tr>";
        $cpt++;
    }
    
    $contenu .= "</table>";
    
    $contenu .= "<p>Note : parmi les dossiers consults, les dossiers archivs apparaissent en 
    rouge dans cette liste pour mieux les distinguer.<br/><br/></p>";
    
    $contenu .= "</div></td></tr><tr>";
    
    $delaiMax = $ini->delaiDossiersInactifs["BASSE"];
    $delaiMoy = $ini->delaiDossiersInactifs["MOYENNE"];
    $delaiMin = $ini->delaiDossiersInactifs["HAUTE"];
    $dossSouf = new ensTableBrioche("notes, dossiers",
                                    "((DATEDIFF(curdate(),dossiers.datouv) > $delaiMax AND dossiers.priorite = 3) OR ".
                                    "(DATEDIFF(curdate(),dossiers.datouv) > $delaiMoy AND dossiers.priorite = 2) OR ".
                                    "(DATEDIFF(curdate(),dossiers.datouv) > $delaiMin AND (dossiers.priorite = 1 OR dossiers.priorite = 0))) ".
                                    "AND dossiers.dateclo IS NULL AND dossiers.nodoss = notes.nodossier AND typesejour.idts <= 2 ",
                                    "if (MAX(notes.date_creation) IS NULL, DATEDIFF(curdate(),dossiers.datouv),DATEDIFF(curdate(),MAX(notes.date_creation))) as sleeptime, ".
                                    "if (dossiers.priorite = 1 OR dossiers.priorite = 0, 
                                        if (MAX(notes.date_creation) IS NULL, DATEDIFF(curdate(),dossiers.datouv)-$delaiMin,DATEDIFF(curdate(),MAX(notes.date_creation))-$delaiMin), 
                                        if (priorite = 2, 
                                            if (MAX(notes.date_creation) IS NULL, DATEDIFF(curdate(),dossiers.datouv)-$delaiMoy,DATEDIFF(curdate(),MAX(notes.date_creation))-$delaiMoy), 
                                            if (MAX(notes.date_creation) IS NULL, DATEDIFF(curdate(),dossiers.datouv)-$delaiMax,DATEDIFF(curdate(),MAX(notes.date_creation))-$delaiMax))) 
                                            as overdue, dossiers.nodoss, usagers.nom, usagers.prenom, dossiers.datouv, usagers.datenaiss, dossiers.priorite, typesejour.ttypesej, demandeor.datedem ",
                                    "overdue DESC, dossiers.priorite",$this->idsession,
                                    array("usagers", "demandeor", "typesejour"),
                                    array("dossiers.nous = usagers.nous", "demandeor.nodoss = dossiers.nodoss", "typesejour.idts = demandeor.typesej")
                                    ,false,0,"dossiers.nodoss");
    $dossSouf = $dossSouf->getTableau();
    $nbDoss = 0;
    foreach ($dossSouf as $k => $ligne) {
        $delai = array($delaiMin,$delaiMin,$delaiMoy,$delaiMax);
        $delai = $delai[$ligne->priorite];
        if ($ligne->sleeptime < $delai) unset($dossSouf[$k]);
        else $nbDoss++;
    }
    $c = new TPanel(3);
    if ($cookieSouf == 'none') $src = 'plus.gif'; else $src = 'moins.gif';
    $img = "<img style='cursor:pointer;' id='soufImg' name='soufImg' src='$imagesdir/$src' onclick=\"changeDisp('racDossSouf','soufImg');\"></img>";
    $x = new Label("Dossiers ouverts (long sjour et observation) sans notes rcentes ($nbDoss) ".$img,true);
    $c->addChamp($x);
    $contenu .= $c->TGetContenu();
    $contenu .= "</tr><tr><td>";
    $contenu .= "<div id='racDossSouf' name='racDossSouf'>";
    $contenu .= "<table width='99%'>";
    $contenu .= "<tr><td bgColor='#DDDDDD'><b>Dossier</b></td><td bgColor='#DDDDDD'><b>Date de demande</b></td><td bgColor='#DDDDDD'><b>Nom</b></td>";
    $contenu .= "<td bgColor='#DDDDDD'><b>Prnom</b></td><td bgColor='#DDDDDD'><b>Sjour</b></td>";
    $contenu .= "<td bgColor='#DDDDDD'><b>Dernires notes en jours </b></td>";
    $contenu .= "<td bgColor='#DDDDDD'><b>Priorit</b></td><td bgColor='#DDDDDD'><b>Dlai dpass en jours</b></td></tr>";

    $js = "javascript:document.location=\"$fdosbrioche?action=1&sessionid=$this->idsession&item={ITEM}&options=" . $this->options->getChaine() . "\"";
    $cpt = 0;
    foreach ($dossSouf as $k => $ligne) {
        if (fmod($cpt,2)==0) $bgc = "#EEEEEE";
        else $bgc = "#FFDA91";
        $priorite = array("-","1","2","3");
        $priorite = $priorite[$ligne->priorite];
        $delai = array($delaiMin,$delaiMin,$delaiMoy,$delaiMax);
        $delai = $delai[$ligne->priorite];
        if ($ligne->sleeptime < $delai) continue;
        else $cpt++;
        $thisJS = str_replace("{ITEM}",$ligne->nodoss,$js);
        $contenu .= "<tr>";
        $contenu .= "<td bgColor='$bgc'><a href='$thisJS'>".$ligne->nodoss."</a></td>";
        $contenu .= "<td bgColor='$bgc'>".$ligne->datedem."</td>";
        $contenu .= "<td bgColor='$bgc'>".$ligne->nom."</td>";
        $contenu .= "<td bgColor='$bgc'>".$ligne->prenom."</td>";
        $contenu .= "<td bgColor='$bgc' nowrap>".$ligne->ttypesej."</td>";
        $contenu .= "<td bgColor='$bgc' align='right'>".$ligne->sleeptime."</td>";
        $contenu .= "<td bgColor='$bgc' align='right'>".$priorite."</td>";
        $contenu .= "<td bgColor='$bgc' align='right'>".$ligne->overdue."</td>";
        $contenu .= "</tr>";
        if ($cpt > 9) break;
    }
    $contenu .= "</table>";
    
    $contenu .= "<p>
    Note : Cette liste prsente les dossiers actuellement ouverts de long sjour ou sjour d'observation. 
    Ils sont tris en fonction du nombre de jours couls depuis la cration ou modification de l'onglet Notes 
    par rapport  un dlai dpendant de la priorit (cf. onglet EMS), et qui est de $delaiMin jours pour les dossiers 
    de priorit 1, $delaiMoy jours pour la priorit 2 et $delaiMax jours pour la priorit 3. Cela facilite les contrles et 
    permet d'viter que des dossiers ne soient ignors ou oublis dans la Brioche.
    </p>";
    
    $contenu .= "</div>";
        
    $contenu .= "<br/></td></tr>";

    $time = date("r",time() + (SEC_PAR_JOUR * $ini->cookie_expiration));
    $contenu .= "
    <script>
            
    document.getElementById('racDossOuv').style.display='$cookieOuv';
    document.getElementById('racDossDer').style.display='$cookieDer';
    document.getElementById('racDossSouf').style.display='$cookieSouf';
    
    function sauvCookie(name, val) {
        document.cookie=name+'='+val+';expires=$time';
    }
        
    function changeDisp(type, imgType) {
        disp = document.getElementById(type).style.display;
        if (disp == 'none') {
            document.getElementById(type).style.display = 'block';
            document.getElementById(imgType).src='$imagesdir/moins.gif';
            sauvCookie(type,'block');
        } else {
            document.getElementById(type).style.display = 'none';
            document.getElementById(imgType).src='$imagesdir/plus.gif';
            sauvCookie(type,'none');
        }
    }
        
    </script>
    ";
    
    return $contenu;
  }
  
  function sauvCookie() {
    
    global $ini;
      
    if (isset($_COOKIE["DOSSIERS_".$this->nout])) {
      $cookieData = $_COOKIE["DOSSIERS_".$this->nout];
      $cookieDataArray = explode(";",$cookieData);
      unset($cookieDataArray[count($cookieDataArray)-1]);
      $exists = array();
      $cookieData = "";
      foreach ($cookieDataArray as $k => $cda) {
        if (in_array($cda, $exists)) continue;
        if ($cda == "" || $cda == $this->item) continue;
        if ($k > 10) break;
        $exists[] = $cda;
        $cookieData .= $cda .";";
      }   
    }
    else $cookieData = "";
    $cookieData .= $this->item . ";";
    $time = time() + (SEC_PAR_JOUR * $ini->cookie_expiration);
    setcookie("DOSSIERS_".$this->nout,$cookieData,$time);
  }
}

function compteContenu($nodoss, $table, $nomId, $session, $complet = "", $join = "", $on = "") {

  $res = new ensTableBrioche($table, "$nomId = $nodoss " . $complet, "*", 0, $session, $join, $on);
  $cpt = $res->compte();
  return $cpt; 
}

?>