<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Enregistrement Brioche
* @package donnes
* @author ob
*/
/**
* Enregistrement Brioche
* Permet d'accder aux tables composant le dossier Brioche et d'agir sur les donnes indpendamment
* de tout objet graphique
* @package donnes
* @author ob
*/
class enrBrioche extends connexionBrioche {
  /**
  * le numro du dossier
  * @var int
  */
  var $item;
  
  /**
  * le numro de l'usager correspondant
  * @var int
  */
  var $nous = -1;

  /**
  * @param int item cf. variable de classe
  * @param string sessionid l'identifiant de session
  * @param array autspec les autorisations spcifiques pour l'accs aux donnes
  * @return boolean la session est-elle OK ?
  */
  function enrBrioche($item, $sessionid, $autspec=0){
    if (! $this->connexionBrioche($sessionid, $autspec)) return false;
    $this->item = $item;
    return true;
  }

  /**
  * accs  un autre dossier
  * @param int le numro du dossier en question
  */
  function setItem($item){
    $this->enrBrioche($item, $this->idsession, $this->autspec);
  }    
  
  /**
  * renvoie le numro de l'usager pour qui ce dossier est ouvert
  * @return int le numro
  */
  function getNoUs(){
    $enr = $this->getEnr("dossiers");
    return $enr->nous;
  }
  
  /**
  * renvoie la liste des champs d'une table
  * @param string table le nom de la table
  * @return array un tableau contenant le nom des champs
  */
  function getChamps($table){
    $requete = "SELECT * FROM $table LIMIT 1";
    $result = mysql_query($requete);
    $cpt = mysql_num_fields($result);
    for ($i = 0; $i < $cpt; $i++){
      $flds = mysql_fetch_field($result, $i);
      $tab[] = $flds->name;
    }
    return $tab;
  }
  
  /**
  * accs  l'enregistrement d'une table particulire correspondant au dossier courant
  * @param string table le nom de la table
  * @param array recup un tableau de variables postes, dans le cas o il faut shunter la base de donnes
  * lorsqu'on contrle des donnes saisies
  * @return object un objet dont les proprits correspondent au champ de la table et prennent les valeurs 
  * correspondant au dossier courant
  */
  function getEnr($table, $recup=0, $noaval=0){
    if ($this->n_erreur) return;
    if ($recup){
      $ligne = $this->faitRecup($recup, $table);
    }
    else {
      switch($table) {
      case "usagers":
        $requete = "SELECT usagers.* FROM dossiers LEFT JOIN usagers ON usagers.nous = dossiers.nous " .
                   "WHERE dossiers.nodoss = $this->item";
        break;
      case "notes":
        $requete = "SELECT notes.* FROM notes WHERE notes.nodossier = $this->item";
        break;
      case "avaliderdem":
        $ini = new briocheIni();
        $requete = "SELECT avaliderdem.* FROM avaliderdem WHERE tst > $ini->tstorig " .
                   ($noaval ? " AND nodemor = $noaval " : "") .
                   "ORDER BY nodemor LIMIT 1";
        break;
      default:
        $requete = "SELECT * FROM $table WHERE nodoss = $this->item";
        break;
      }
                  
      $result = mysql_query($requete);
      
      if (! $result) return false;
      $ligne = mysql_fetch_object($result);
      //Conversion des champs date
      
      if ($ligne){
        for ($i = 0; $i < mysql_num_fields($result); $i++){
          $flds = mysql_fetch_field($result, $i);
          $fn = $flds->name;
          if ($flds->type == "date"){
            $ligne->$fn = $this->getDateFr($ligne->$fn);
          }
          $ligne->$fn = $this->metEnFormeSel($ligne->$fn);
        }
      }
    }
    return $ligne;
  }

  /**
  * renvoie les demandes interBRIOs qui ont t faites pour ce dossier
  * @return array un tableau associatif avec les cls :
  * nomet : le nom du BRIO destinataire
  * quittance : la quittance de rception par le BRIO destinataire
  * noet : le numro d'tablissement du BRIO destinataire
  * adresseib : l'adresse interBRIOs du BRIO destinataire
  * l'identifiant de l'enregistrement correspondant de la table choixems
  */
  function getDemandeInterBrio(){
    $ini = new briocheIni();
    $join[] = "etablissements";
    $on[] = "choixems.noems = etablissements.noet";
    $join[] = "suivisenvoisib";
    $on[] = "choixems.nochoix = suivisenvoisib.nochoix";
    $etinterbrios = new ensTableBrioche("choixems", "nodoss = " .
                                        $this->item . " and autbrio = -1",
                                        "etablissements.nomet, etablissements.noet, etablissements.adresseib, " . 
                                        "choixems.nochoix, suivisenvoisib.quittance",
                                        "choixems.nochoix", $this->idsession,
                                        $join,
                                        $on);
    
    $tet = $etinterbrios->getTableau();
    $cpt = count($tet);
    $tab = array();
    for ($i = 0; $i < $cpt; $i++){
      $tab[$i]['nomet'] = $tet[$i]->nomet; 
      $tab[$i]['quittance'] = $tet[$i]->quittance;
      $tab[$i]['noet'] = $tet[$i]->noet;
      $tab[$i]['adresseib'] = $tet[$i]->adresseib;
      $tab[$i]['nochoix'] = $tet[$i]->nochoix;
    }
    return $tab;  
  }
  
  /**
  * renvoie un tableau des signets du dossier courant
  * @return array le nom des signets
  */
  function getSignets(){
    $etsignets = new ensTableBrioche("signetsdossiers", "nodoss = " .
                                     $this->item, "*", "0", $this->idsession,
                                     "signets", "signetsdossiers.idsignet = signets.id");
    $tet = $etsignets->getTableau();
    $cpt = count($tet);
    $tab = array();
    for ($i = 0; $i < $cpt; $i++){
      $tab[$i] = $tet[$i]->nomsignet; 
    }
    return $tab;
  }
  
  /**
  * renvoie un tableau des notes du dossier courant
  * @return array le nom des signets
  */
  function getNotes(){
    $notes = new ensTableBrioche("notes","nodossier=".$this->item,"*","idnotes",$this->idsession);
    $notes = $notes->getTableau();
    return $notes;
  }
  
  /**
  * archivage d'un dossier lorsqu'un court sjour "planning" est retir
  * @return boolean l'archivage s'est-il bien pass ?
  */
  function clotSurRetraitCS(){
    $requete = "UPDATE demandeor SET typesej = 3 WHERE nodoss = $this->item";
    if (! $result = mysql_query($requete)) return false;
    $tabchamp['dateissue'] = $this->aujourdhui();
    $tabchamp['issue'] = 5; // demande retire
    $an = new updateTableBrioche("issue", $tabchamp, $this->item, "nodoss", $this->idsession);
    if(! $an->update()) return false;
    $tabchamps = array();
    $tabchamps['dateplac'] = "";
    $tabchamps['dateval'] = "";
    $tabchamps['dateres'] = "";
    $tabchamps['mission'] = 0;
    $tabchamps['typesej'] = 99;
    $an = new updateTableBrioche("attributionlit", $tabchamps, $this->item, "nodoss", $this->idsession);
    if (! $an->update()) return false;
    return true;
  }
  
  /**
  * est-il possible de rouvrir le dossier courant ?
  * @return boolean
  */
  function rouvrable(){
    $nous = $this->getNoUs();
    $us = new enrUsBrioche($nous, $this->idsession);
    if ($us->hasOuvert(1)){
      return false;
    }
    $do = $this->getEnr("demandeor");
    if ($do->typesej == 5) {
      return false;   
    }
    $dos = $this->getEnr("dossiers");
    if (! $dos->dateclo){
      return false;
    }
    return true;   
  }
  
  /**
  * rouvre le dossier courant
  * @return resource rsultat de la requte de mise  jour qui rouvre le dossier
  */
  function rouvre(){
    if (! $this->rouvrable()){
      return false;
    }
    $requete = "UPDATE dossiers SET dateclo = NULL WHERE nodoss = $this->item";
    return mysql_query($requete);  
  }
  
  /**
  * cration d'un nouveau dossier avec toutes les tables annexes, et renvoi de son numro
  * @param string fact une chane de caractre facultative, utile pour viter que le mme hchage ne soit
  * gnr si plusieurs dossiers sont ouverts  la file durant la mme seconde
  * @return int le numro du nouveau dossier
  */
  function creeNouveau($fact=""){
    if ($this->n_erreur) return;
    $dg = md5(time() . $this->idsession . $fact);
    //table dossiers;
    $requete = "INSERT INTO dossiers SET datouv = \"" . $this->today() . "\", nous = $this->nous, dmd5 = \"$dg\", tst = 0";
    $result = mysql_query($requete);
    $requete = "SELECT nodoss FROM dossiers WHERE dmd5 = \"$dg\"";
    $result = mysql_query($requete);
    $lignes = mysql_fetch_row($result);
    $nd = $lignes[0];
    //table demandeor
    $requete = "INSERT INTO demandeor SET nodoss = $nd";
    $result = mysql_query($requete);
    //table decision
    $requete = "INSERT INTO decision SET nodoss = $nd";
    $result = mysql_query($requete);
    //table Issue
    $requete = "INSERT INTO issue SET nodoss = $nd";
    $result = mysql_query($requete);
    //table profilopars
    $requete = "INSERT INTO profilopars SET nodoss = $nd";
    $result = mysql_query($requete);
    //table notes
//    $requete = "INSERT INTO notes SET nodossier = $nd";
//    $result = mysql_query($requete);
    //table attributionlit
    $requete = "INSERT INTO attributionlit SET nodoss = $nd";
    $result = mysql_query($requete);
    //table dmst
    $requete = "INSERT INTO dmst SET nodoss = $nd";
    $result = mysql_query($requete);
    //table grille
    $requete = "INSERT INTO grille SET nodoss = $nd";
    $result = mysql_query($requete);
    return $nd;
  }
  
  /**
  * cration d'un nouveau dossier provisoire lors de la validation d'une demande faite par le service placeur
  * ou d'une demande interBRIOs
  * @return int le numro du nouveau dossier
  */
  function creeDepuisAval($noaval){
    //Cration d'un nouveau dossier provisoire
    $ini = new briocheIni();
    $enr = $this->getEnr("avaliderdem", 0, $noaval);
    if (! $enr->nodemor){ // Il n'y a plus de demande  valider
      return false;
    }
    
    //Y a-t-il dj un dossier provisoire (feuilletages prcdents ?)
    //$etd = new ensTableBrioche(
    if ($enr->noprov){
       $this->item = $enr->noprov;
       return $enr->noprov;
    }
    $this->item = $this->creeNouveau();
    $eu = new ensTableBrioche("usagers", 1, "*", 0, $this->idsession);
    // Cration d'un usager provisoire
    $nous = $eu->creeNouveau("nous");
    unset($tabchamps);
    $tabchamps['nom'] = $enr->nom;
    $tabchamps['prenom'] = $enr->prenom;
    $tabchamps['datenaiss'] = $enr->datenaiss;
    $tabchamps['adresse'] = $enr->adresse;
    $tabchamps['npa'] = $enr->npa;
    $tabchamps['loc'] = $enr->loc;
    $tabchamps['sexe'] = $enr->sexe;
    $tabchamps['tst'] = number_format($ini->tstorig + 10,0,"",""); // afin que l'usager soit reconnu comme provisoire
    $utu = new updateTableBrioche("usagers", $tabchamps, $nous, "nous", $this->idsession);
    // Ecriture dans le dossier provisoire
    if (! $utu->update()) print "PROBLEME";
    unset($tabchamps);
    $tabchamps['datouv'] = $this->aujourdhui();
    $tabchamps['statut'] = 99;
    $tabchamps['ouvpar'] = $this->getInit();
    $tabchamps['nous'] = $nous;
    $utd = new updateTableBrioche("dossiers", $tabchamps, $this->item, "nodoss", $this->idsession);
    if (! $utd->update()) print "PROBLEME";
    //Ecriture du n de dossier provisoire dans la table avaliderdem (pour feuilletage)
    unset($tabchamps);
    $tabchamps['noprov'] = $this->item;
    $utd = new updateTableBrioche("avaliderdem", $tabchamps, $enr->nodemor, "nodemor", $this->idsession);
    if (! $utd->update()) print mysql_error();
    // Ecriture dans la demande d'orientation;
    // Rcupration des champs de la table
    $requete = "SHOW FIELDS FROM demandeor";
    $result = mysql_query($requete);
    unset($tabchamps);
    $tabchamps['notrans'] = $enr->nodemor;
    while ($ligne = mysql_fetch_row($result)){
      $ind = $ligne[0];
      if ($ind != "nodoss" && $ind != "nodemor" && $ind != "notrans"){ 
        $tabchamps[$ind] = $enr->$ind;
      }
    }
    $utdem = new updateTableBrioche("demandeor", $tabchamps, $this->item, "nodoss", $this->idsession);
    if (! $utdem->update()) print "PROBLEME";
    
    return $this->item;
  }
  
  /**
  * acceptation d'une demande service placeur ou interBRIOs
  * @return int -1 si la demande est accepte sans autre. Si un autre dossier doit tre archiv,
  * le numro du dossier en question. 0 si l'acceptation choue.
  */
  function accepte(){
    // Y a-t-il dj un dossier ouvert pour cet usager ? Si oui, fermeture d'icelui.
    $ini = new briocheIni();
    $nous = $this->getNoUs();
    $us = new enrUsBrioche($nous, $this->idsession);
    $douv = $us->hasOuvert(1);
    $retour = -1;
    $demande = $this->getEnr("demandeor");
    if ($douv && $demande->typesej != 3 && $demande->typesej != 14){ // Fermeture du dossier ouvert
      $archive = new enrBrioche($douv, $this->idsession);
      $retour = $archive->archive();
    }
    $requete = "UPDATE dossiers SET statut = NULL WHERE nodoss = $this->item";
    $quit = false;
    if (mysql_query($requete)){
      $quit = $this->detruitAval();
    }
    $requete = "UPDATE usagers SET tst = NOW() WHERE nous = $nous";
    $result = mysql_query($requete);
    if ($retour && $quit){
      //Envoi quittance pour demandes transmises par Internet
      if ($ini->interbrio){ //Demandes interBRIOs actives
        $usager = $this->getEnr("usagers");
        if ($demande->brioorigine) { // brioorigine dfini
          $man = new clientManege($this->idsession);
          $man->setQuittance($demande->nomanege, 99, $demande->nodoss, $usager->nous);
        }
      }
      return $retour;
    }
    else {
      return false;
    }  
  }
  
  /**
  * rejet d'une demande service placeur ou interBRIOs
  * @return resource le rsultat de la destruction de l'enregistrement de la table avaliderdem
  */
  function rejette(){
    $ini = new briocheIni();
    if ($this->detruit()){
      if($ini->interbrio){
        $demande = $this->getEnr("demandeor");
        if ($demande->brioorigine) {
          $man = new clientManege($this->idsession);
          $man->setQuittance($demande->nomanege, 98); 
        } 
      }
      return $this->detruitAval();
    }
    else return false;
  }  
  
  /**
  * archivage du dossier courant
  * @return int le numro du dossier (ou false si chec)
  */
  function archive(){
    $tabchamps['issue'] = 7;
    $tabchamps['dateissue'] = $this->aujourdhui();
    $ut = new updateTableBrioche("issue", $tabchamps, $this->item, "nodoss", $this->idsession);
    if (! $ut->update()) return false;
    unset($tabchamps);
    $tabchamps['dateclo'] = $this->aujourdhui();
    $ut = new updateTableBrioche("dossiers", $tabchamps, $this->item, "nodoss", $this->idsession);
    $retour = false;
    if ($ut->update()){
      $retour = $this->item;
      $ab = new archivageBrioche($this->idsession);
    }
    return $retour;
  }
  
  /**
  * destruction de l'enregistrement de avaliderdem lorsque la demande service placeur ou interBRIOs a t lue
  * @return resource le rsultat de la requte destruction
  */
  function detruitAval(){
    $dem = $this->getEnr("demandeor");
    $requete = "DELETE FROM avaliderdem WHERE nodemor = $dem->notrans";
    return mysql_query($requete);
  }
  
  
  /**
  * le dossier courant est-il ouvert ?
  * @param int saufCourt si le dossier concerne une demande de court sjour et que saufCourt n'est pas nul,
  * il n'est pas compt comme ouvert
  * @return boolean
  */
  
  function isOuvert($saufCourt = 0){
    if ($this->n_erreur) return;
    $plan = false;
    if ($saufCourt){ // Ce dossier est ouvert et il n'est pas un court sjour
      $requete = "SELECT dossiers.nodoss, demandeor.typesej " .
                 "FROM dossiers LEFT JOIN demandeor ON dossiers.nodoss = demandeor.nodoss " .
                 "WHERE dossiers.nodoss = $this->item AND dossiers.dateclo IS NULL " .
                 "AND (statut IS NULL OR statut NOT IN(99, 100))";
      $result = mysql_query($requete);
      $lignes = mysql_fetch_row($result);
      if ($lignes[1] == 5 || $lignes[1] == 3 || $lignes[1] == 14) {
        $plan = true;
      }
    }
    $requete = "SELECT dossiers.dateclo FROM dossiers WHERE dossiers.nodoss = $this->item " .
               "AND (statut IS NULL OR statut NOT IN(99, 100))";
    $result = mysql_query($requete);
    $lignes = mysql_fetch_row($result);
    if (mysql_num_rows($result) == 0) return false;
    if ($lignes[0] || $plan){
      return false;
    }
    else {
      return true;
    }
  }
  
  /**
  * Nombre de demandes  valider
  * @return int le nombre de demandes lectroniques  valider
  */
  function getNbAval(){
    $ini = new briocheIni();
    $requete = "SELECT count(*) FROM avaliderdem WHERE tst > $ini->tstorig";
    $result = mysql_query($requete);
    $ligne = mysql_fetch_row($result);
    return $ligne[0];
  }
  
  /**
  * Numro de la demande  valider suivante
  * @return int le numro
  */
  function getSuivantAval(){
    $ini = new briocheIni();
    $requete = "SELECT nodemor from avaliderdem where noprov = $this->item"; 
    $result = mysql_query($requete);
    $ligne = mysql_fetch_row($result);
    $nodem = $ligne[0];
    $requete = "SELECT nodemor from avaliderdem where nodemor > $nodem AND tst > $ini->tstorig ORDER BY nodemor";
    $result = mysql_query($requete);
    if ($ligne = mysql_fetch_row($result)) return $ligne[0];
    return -1;
  }
  
  /**
  * Numro de la demande  valider prcdente
  * @return int le numro
  */
  function getPrecedAval(){
    $ini = new briocheIni();
    $requete = "SELECT nodemor from avaliderdem where noprov = $this->item"; 
    $result = mysql_query($requete);
    $ligne = mysql_fetch_row($result);
    $nodem = $ligne[0];
    $requete = "SELECT nodemor from avaliderdem where nodemor < $nodem AND tst > $ini->tstorig ORDER BY nodemor DESC";
    $result = mysql_query($requete);
    if ($ligne = mysql_fetch_row($result)) return $ligne[0];
    return -1;
  }
  
  
  
  /**
  * destruction du dossier courant
  * @return resource le rsultat de la requte destruction
  */
  function detruit(){
    if ($this->n_erreur) return;
    $requete = "DELETE FROM dossiers WHERE dossiers.nodoss = $this->item";
    $result = mysql_query($requete);
    return $result; 
  }
  
  function creerResteDossier($nd) {
    $requetes = array();
    //table decision
    $requetes[] = "INSERT INTO decision SET nodoss = $nd";
    //table Issue
    $requetes[] = "INSERT INTO issue SET nodoss = $nd";
    //table profilopars
    $requetes[] = "INSERT INTO profilopars SET nodoss = $nd";
    //table attributionlit
    $requetes[] = "INSERT INTO attributionlit SET nodoss = $nd";
    foreach ($requetes as $requete) {
        $result = mysql_query($requete);
        if (!$result) return false;
    }
    return true;
  }

}

?>
