<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Enregistrement usager
* @package donnes
*/
/**
* Enregistrement usager
* Donne accs aux donnes d'un usager et contient quelques mthodes non graphiques
* @package donnes
* @author ob
*/
class enrUsBrioche extends connexionBrioche {
  /**
  * le numro d'usager
  * @var int
  */
  var $item;
  
  /**
  * @param int item cf. variable de classe
  * @param string sessionid l'identifiant de session
  * @param array autspec les autorisations spcifiques
  */
  function enrUsBrioche($item, $sessionid, $autspec = ""){
    if (! $this->connexionBrioche($sessionid, $autspec)) return;
    $this->item = $item;
  }
  
  /**
  * fusion du dossier courant avec un autre
  * @param object uss l'objet enrUsBrioche correspondan  l'usager  fusionner avec celui-ci
  * @param boolean alert Faut-il afficher les ventuels messages pour l'utilisateur ?
  * @return resource le rsultat de la requte destruction (dans updateTableBrioche)
  */
  function fusionne(&$uss, $alerte = false){
    //Vrification que les deux numros correspondent  des dossiers
    if (! $this->existe(true)) return false;
    if (! $uss->existe(true)) return false;
    if ($this->hasOuvert(true) && $uss->hasOuvert(true)){ // Les deux usagers ont un dossier ouvert
      if ($alerte){
        $al = new Alerte("Les deux usagers ont un dossier ouvert. Veuillez archiver l\'un de ces dossiers.");
        $al->imprime();
      }
      return false;
    }
    $ut = new updateTableBrioche("dossiers", "", "", "", $this->idsession);
    if (! $ut->updateSpec("nous", $this->item, "nous = $uss->item", true)) return false;
    $ut = new updateTableBrioche("recepdmst", "", "", "", $this->idsession);
    if (! $ut->updateSpec("usager", $this->item, "usager = $uss->item", true)) return false;
    $ut = new updateTableBrioche("usagers", "", $uss->item, "nous", $this->idsession);
    return ($ut->detruitEnr());
  }
  
  /**
  * destruction d'un usager
  * @return resource le rsultat de la requte destruction (dans updateTableBrioche)
  */
  function detruit(){
    $et = new ensTableBrioche("dossiers", "nous = $this->item", "*", 0, $this->idsession);
    print $et->getSQL();
    if ($et->compte()) return false;
    $ut = new updateTableBrioche("usagers", "", $this->item, "nous", $this->idsession);
    return $ut->detruitEnr();
  }
  
  /**
  * l'usager rpondant au numro courant existe-t-il ?
  * @param boolean alerte faut-il afficher les messages pour l'utilisateur ?
  * @return int 0 si l'usager n'existe pas et 1 si l'usager existe
  */
  function existe($alerte = false){
    $eb = new ensTableBrioche("usagers", "nous = $this->item", "*", 0, $this->idsession);
    $cpt = $eb->compte();
    if ($alerte && (! $cpt)){
      $al = new Alerte("L\'usager $this->item n\'existe pas !");
      $al->imprime();
    }
    return $cpt;
  }
  
  /**
  * existe-t-il des doublons potentiels pour l'usager courant ?
  * @return string la liste des numros d'usagers desdoublons potientiels spars par une virgule, ou -999 s'il n'y en a pas
  */
  function listeDoublons(){
    $ini = new briocheIni();
    $enr = $this->getEnr();
    $dbl = new EnsTableBrioche("usagers",
                               "nous != $enr->nous AND prenom LIKE \"" . substr($enr->prenom, 0, 3) . "%\" AND sexe = \"" .
                               $enr->sexe . "\" AND datenaiss = " .
                               $this->getDateAm($enr->datenaiss) . "AND tst > " . ($ini->tstorig + 11),
                               "nous", "nous", $this->idsession);
    $tdbl = $dbl->getTableau();
    $cpt = count($tdbl);
    if (! $cpt){
      return -999;                           
    }
    else {
      $chaine = "";
      for ($i = 0; $i < $cpt; $i++){
        $chaine .= $tdbl[$i]->nous . ", ";
      }
      return substr($chaine, 0, -2);
    }
  }
  
  /**
  * renvoie un objet dont les proprits correspondent aux champs de la table "usagers", et dont les valeurs sont
  * celles de l'usager courant
  * @return object
  */
  function getEnr(){
    $mus = new ensTableBrioche("usagers", "nous = $this->item", "*", 0, $this->idsession, "", "",
                               false, $this->autspec);
    $tmus = $mus->getTableau();
    if (! count($tmus)) return false;
    return $tmus[0];
  }
  
  /**
  * y a-t-il un dossier ouvert pour l'usager en question ?
  * @param boolean saufCourt faut-il ignorer les demandes de court-sjour ?
  * @return int le numro du dossier ouvert ou false s'il n'y en a pas
  */
  function hasOuvert($saufCourt){
    if ($this->n_erreur) return;
    $hasOuvert = false;
    $doss = new ensTableBrioche("dossiers", "nous = $this->item", "*", 0, $this->idsession);
    $cpte = $doss->compte();
    if ($cpte){
      $dossiers = $doss->getTableau();
      foreach($dossiers as $dossUs) {  //L'un de ces dossiers est-il ouvert et +/- non CS
        $du = new enrBrioche($dossUs->nodoss, $this->idsession);
        if ($du->isOuvert($saufCourt)) {
          $hasOuvert = $dossUs->nodoss;
        }
      }
    }
    return $hasOuvert;
  }
  
  /**
  * recherche dans d'ventuels dossiers prcdents le nom et le tl du rfrent de l'entourage
  * @return object un objet dont les proprits sont refent : le nom du rfrent de l'entourage
  * et telrefent : son numro de tlphone. La fonction renvoie false s'il n'y a pas de dossier
  * correspondant.
  */
  function getRefEnt(){
    $doss = new ensTableBrioche("dossiers",
                                "nous = $this->item AND demandeor.refent IS NOT NULL",
                                "refent, telrefent", "dossiers.datouv DESC",
                                $this->idsession, "demandeor",
                                "demandeor.nodoss = dossiers.nodoss");
    $tdoss = $doss->getTableau();
    if (! count($tdoss)) return false;
    $refobj = $tdoss[0];
    return $refobj;                             
  }
  
}
?>