<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Ensemble des donnes ncessaires  l'extraction IUMSP
* @package donnes
*/
/**
* Ensemble des donnes ncessaires  l'extrationc IUMSP
* Fournit toutes les mthodes ncessaires  l'extraction des fichiers qui seront analyss par
* les routines R en vue de produire les rapports statistiques de l'IUMSP. Cet objet peut tre appel
* soit manuellement par le formulaire "Extraction IUMSP" (extIUMSP), soit par le script scritpIumsp sur la
* base d'une tche planifie. 
* @package donnes
* @author ob
*/
class ensDataIUMSP extends connexionBrioche {
  /**
  * le dbut de la priode d'extraction (date au format "j.m.a")
  * @var string
  */
  var $deb;
  
  /**
  * la fin de la priode d'extration (date au format "j.m.a")
  * @var string
  */
  var $fin;
  /**
  * une chane de caractre garantissant la non rversibilit du hchage d'anonymisation
  * tait indispensable lorsque les fichiers extraits taient envoys  un tiers pour traitement statistique
  * @var string
  */
  var $mdp;
  
  /**
  * nombre d'erreurs de traitement
  * @var int
  */
  var $nberreurs;
  
  /**
  * le nombre d'enregistrement traits
  * @var int
  */
  var $cpt;
  
  /**
  * @param string deb cf. variable de classe
  * @param string fin cf. variable de classe
  * @param string mdp cf. variable de classe
  * @param string sessionid l'identifiant de session
  */
  function ensDataIUMSP ($deb, $fin, $mdp, $sessionid){
    if (! $this->connexionBrioche($sessionid)) return;
    $this->deb = $deb;
    $this->fin = $fin;
    $this->mdp = $mdp;
    $debAm = $this->getDateAm($this->deb);
    $finAm = $this->getDateAm($this->fin);
    //Donnes utiles
    $join[] = "demandeor";
    $join[] = "usagers";
    $join[] = "grille";
    $join[] = "decision";
    $join[] = "issue";
    $join[] = "etablissements";
    $join[] = "attributionlit";
    $join[] = "annoncelit";
    $on[] = "dossiers.nodoss = demandeor.nodoss";
    $on[] = "dossiers.nous = usagers.nous";
    $on[] = "dossiers.nodoss = grille.nodoss";
    $on[] = "dossiers.nodoss = decision.nodoss";
    $on[] = "dossiers.nodoss = issue.nodoss";
    $on[] = "demandeor.servplac = etablissements.noet";
    $on[] = "demandeor.nodoss = attributionlit.nodoss";
    $on[] = "attributionlit.nolit = annoncelit.nolit";
    $champs = "usagers.nous, dossiers.nodoss, usagers.datenaiss as datenaiss, usagers.sexe, " .
              "usagers.npa, demandeor.sitsoc, demandeor.aidepr, demandeor.cms, demandeor.anx, " .
              "demandeor.trcomp, demandeor.resmult, demandeor.chutes, demandeor.solitude, " .
              "demandeor.dependance, demandeor.perfusion, demandeor.dominadequat, " .
              "demandeor.absenceent, demandeor.epuisementent, demandeor.respiratoire, " .
              "demandeor.refuscms, demandeor.mobilite, demandeor.autreprobl, demandeor.doctrans, " .
              "grille.manger, grille.laver, grille.habiller, grille.deshab, grille.entpers, " .
              "grille.contves, grille.contana, grille.toilet, grille.memoire, grille.orientat, " .
              "grille.jugement, grille.soccuper, UNIX_TIMESTAMP(demandeor.datedem) AS datedem, " .
              "UNIX_TIMESTAMP(demandeor.litdepuis) AS litdepuis, demandeor.debutpec, " .
              "demandeor.provenance, demandeor.uat, demandeor.servplac, " .
              "demandeor.typesej, demandeor.typepath, decision.interbrio, decision.accept, " .
              "decision.orientation, decision.ug, decision.up, decision.longprov, issue.issue, " .
              "decision.motretrait, decision.motnouvdem, etablissements.groupet, ". 
              "UNIX_TIMESTAMP(attributionlit.dateplac) AS dateplac, " .
              "annoncelit.nolit, UNIX_TIMESTAMP(issue.dateissue) AS dateissue"; 
    $dut = new ensTableBrioche("dossiers", "demandeor.datedem BETWEEN $debAm AND $finAm",
                               $champs, 0, $this->idsession, $join, $on); 
    //Table provisoire
    $tp = new tableProv("IUM", $this->idsession);
    $tp->setChamp("idusager", "CHAR", 32);
    $tp->setChamp("iddemand", "CHAR", 32, "", "", "", false, true);
    $tp->setChamp("age", "SMALLINT");
    $tp->setChamp("sexe", "SMALLINT");
    $tp->setChamp("region", "SMALLINT");
    $tp->setChamp("sitsoc", "SMALLINT");
    $tp->setChamp("cms", "SMALLINT");
    $tp->setChamp("probleme1", "TINYINT");
    $tp->setChamp("probleme2", "TINYINT");
    $tp->setChamp("probleme3", "TINYINT");
    $tp->setChamp("probleme4", "TINYINT");
    $tp->setChamp("probleme5", "TINYINT");
    $tp->setChamp("probleme6", "TINYINT");
    $tp->setChamp("probleme7", "TINYINT");
    $tp->setChamp("probleme8", "TINYINT");
    $tp->setChamp("probleme9", "TINYINT");
    $tp->setChamp("probleme10", "TINYINT");
    $tp->setChamp("probleme11", "TINYINT");
    $tp->setChamp("probleme12", "TINYINT");
    $tp->setChamp("probleme13", "TINYINT");
    $tp->setChamp("autreprobl", "CHAR", 50);
    $tp->setChamp("dmst", "SMALLINT");
    $tp->setChamp("manger", "SMALLINT");
    $tp->setChamp("laver", "SMALLINT");
    $tp->setChamp("habiller", "SMALLINT");
    $tp->setChamp("deshab", "SMALLINT");
    $tp->setChamp("entpers", "SMALLINT");
    $tp->setChamp("contves", "SMALLINT");
    $tp->setChamp("contana", "SMALLINT");
    $tp->setChamp("toilet", "SMALLINT");
    $tp->setChamp("memoire", "SMALLINT");
    $tp->setChamp("orientat", "SMALLINT");
    $tp->setChamp("jugement", "SMALLINT");
    $tp->setChamp("soccuper", "SMALLINT");
    $tp->setChamp("datedem", "CHAR", 5);
    $tp->setChamp("debutpec", "SMALLINT");
    $tp->setChamp("provient", "SMALLINT");
    $tp->setChamp("origine", "SMALLINT");
    $tp->setChamp("pecdem", "SMALLINT");
    $tp->setChamp("typedom", "SMALLINT");
    $tp->setChamp("natpec", "SMALLINT");
    $tp->setChamp("rencontr", "SMALLINT");
    $tp->setChamp("decorient", "SMALLINT");
    $tp->setChamp("orguat", "SMALLINT");
    $tp->setChamp("emsres", "SMALLINT");
    $tp->setChamp("aboutiss", "SMALLINT");
    $tp->setChamp("lsprovis", "TINYINT");
    $tp->setChamp("motifaba", "SMALLINT");
    $tp->setChamp("formulat", "SMALLINT");
    $tp->setChamp("dateabou", "CHAR", 5);
    $tp->setChamp("demabout", "INT");
    $tp->setChamp("tst", "TIMESTAMP");
    $tp->create();
    
    //Remplissage de la table provisoire;
    $tabDut = $dut->getTableau();
    $cpt = count($tabDut);
    $this->cpt = $cpt;
    $erreur = 0;
    //Rcupration des groupes de numros postaux
    $np = new ensTableBrioche("nopostaux", 1, "nopost, groupe", "nopost", $this->idsession);
    $tnp = $np->getTableau();
    $cpnp = count($tnp);
    $groupe = array();
    for ($i = 0; $i < $cpnp; $i++){
      $ind = $tnp[$i]->nopost;
      $gr = $tnp[$i]->groupe;
      $groupe[$ind] = $gr;
    }	
    for ($i = 0; $i < $cpt; $i++){
      $tabchamps['idusager'] = md5($tabDut[$i]->nous . $this->mdp);
      $tabchamps['iddemand'] = md5($tabDut[$i]->nodoss . $this->mdp);
      $tabchamps['age'] = $this->calcAge($tabDut[$i]->datenaiss, $tabDut[$i]->datedem);
      $tabchamps['sexe'] = $this->calcSexe($tabDut[$i]->sexe);
      $npa = $tabDut[$i]->npa;
      $tabchamps['region'] = (isset($groupe[$npa]) ? $groupe[$npa] : 0);
      $tabchamps['sitsoc'] = $this->calcSitsoc($tabDut[$i]->sitsoc, $tabDut[$i]->aidepr);
      $tabchamps['cms'] = ($tabDut[$i]->cms ? $tabDut[$i]->cms : 99);
      $tabchamps['probleme1'] =  - $tabDut[$i]->anx;
      $tabchamps['probleme2'] =  - $tabDut[$i]->trcomp;
      $tabchamps['probleme3'] =  - $tabDut[$i]->resmult;
      $tabchamps['probleme4'] =  - $tabDut[$i]->chutes;
      $tabchamps['probleme5'] =  - $tabDut[$i]->solitude;
      $tabchamps['probleme6'] =  - $tabDut[$i]->dependance;
      $tabchamps['probleme7'] =  - $tabDut[$i]->perfusion;
      $tabchamps['probleme8'] =  - $tabDut[$i]->dominadequat;
      $tabchamps['probleme9'] =  - $tabDut[$i]->absenceent;
      $tabchamps['probleme10'] =  - $tabDut[$i]->epuisementent;
      $tabchamps['probleme11'] =  - $tabDut[$i]->respiratoire;
      $tabchamps['probleme12'] =  - $tabDut[$i]->refuscms;
      $tabchamps['probleme13'] =  - $tabDut[$i]->mobilite;
      $tabchamps['autreprobl'] = $tabDut[$i]->autreprobl;
      $tabchamps['dmst'] = ($tabDut[$i]->doctrans ? $tabDut[$i]->doctrans : 99);	
      $tabchamps['manger'] = $this->calcGrille($tabDut[$i]->manger);
      $tabchamps['laver'] = $this->calcGrille($tabDut[$i]->laver);
      $tabchamps['habiller'] = $this->calcGrille($tabDut[$i]->habiller);
      $tabchamps['deshab'] = $this->calcGrille($tabDut[$i]->deshab);
      $tabchamps['entpers'] = $this->calcGrille($tabDut[$i]->entpers);
      $tabchamps['contves'] = $this->calcGrille($tabDut[$i]->contves);
      $tabchamps['contana'] = $this->calcGrille($tabDut[$i]->contana);
      $tabchamps['toilet'] = $this->calcGrille($tabDut[$i]->toilet);
      $tabchamps['memoire'] = $this->calcGrille($tabDut[$i]->memoire);
      $tabchamps['orientat'] = $this->calcGrille($tabDut[$i]->orientat);
      $tabchamps['jugement'] = $this->calcGrille($tabDut[$i]->jugement);
      $tabchamps['soccuper'] = $this->calcGrille($tabDut[$i]->soccuper);
      $tabchamps['datedem'] = $this->calcAnSemaine($tabDut[$i]->datedem);
      $tabchamps['debutpec'] = $this->calcDebutPec($tabDut[$i]->litdepuis, $tabDut[$i]->datedem,
                               $tabDut[$i]->debutpec);	 
      $tabchamps['provient'] = $this->calcProvient($tabDut[$i]->provenance, $tabDut[$i]->uat);
      $tabchamps['origine'] = ($tabDut[$i]->groupet ? $tabDut[$i]->groupet : 99);
      $tabchamps['pecdem'] = $this->calcPecDem($tabDut[$i]->typesej);
      $tabchamps['typedom'] = $this->calcTypeDom($tabDut[$i]->typesej);
      $tabchamps['natpec'] = $this->calcNatPec($tabDut[$i]->typepath);
      $tabchamps['rencontr'] = ($tabDut[$i]->interbrio ? $tabDut[$i]->interbrio : 99);
      $tabchamps['decorient'] = $this->calcDecOrient($tabDut[$i]->orientation);
      $tabchamps['orguat'] = $this->calcOrgUat($tabDut[$i]->orientation, $tabDut[$i]->ug,
                             $tabDut[$i]->up);
      $tabchamps['emsres'] = $this->calcEMSRes($tabDut[$i]->issue, $tabDut[$i]->nolit);
      $tabchamps['aboutiss'] = $this->calcAboutiss($tabDut[$i]->issue);
      $tabchamps['lsprovis'] = $this->calcLsProvis($tabDut[$i]->issue, $tabDut[$i]->longprov);
      $tabchamps['motifaba'] = ($tabDut[$i]->motretrait ? $tabDut[$i]->motretrait : 99); 
      $tabchamps['formulat'] = ($tabDut[$i]->motnouvdem ? $tabDut[$i]->motnouvdem : 99);
      $datepert = ($tabDut[$i]->typesej == 5 ? $tabDut[$i]->dateplac : $tabDut[$i]->dateissue);
      $tabchamps['dateabou'] = $this->calcAnSemaine($datepert);
      $tabchamps['demabout'] = $this->calcDemabout($tabDut[$i]->datedem, $datepert);
      $nouv = new updateTableBrioche($tp->getNom(), $tabchamps, 0, 0, $this->idsession);
      if(! $nouv->ajouteEnr()) $erreur++;	
    }
    $this->nberreurs = $erreur;	
    // Extraction des refus
    // table provisoire
    $tpr = new tableProv("IUMR", $this->idsession); 
    $tpr->setChamp("iddemand", "CHAR", 32);
    $tpr->setChamp("typerefus", "SMALLINT");
    $tpr->setChamp("motifrefus", "CHAR", 50);
    $tpr->setChamp("tst", "TIMESTAMP");
    $tpr->create();
    // Extraction des refus de CMS
    $join = array();
    $on = array();
    $tabchamps = array();
    $join[] = "demandeor";
    $join[] = "decision";
    $on[] = "dossiers.nodoss = demandeor.nodoss";
    $on[] = "dossiers.nodoss = decision.nodoss";
    $champs = "dossiers.nodoss, decision.accept, decision.orientation";
    $dut = new ensTableBrioche("dossiers", "demandeor.datedem BETWEEN $debAm AND $finAm",
                               $champs, 0, $this->idsession, $join, $on);
    $tabDut = $dut->getTableau();
    $cpt = count($tabDut);
    for($i = 0; $i < $cpt; $i++){
      if($tabDut[$i]->orientation <= 3 && $tabDut[$i]->accept == 3){
        $tabchamps['iddemand'] = md5($tabDut[$i]->nodoss . $this->mdp);
        $tabchamps['typerefus'] = 1;
        $nouv = new updateTableBrioche($tpr->getNom(), $tabchamps, 0, 0, $this->idsession);
        $nouv->ajouteEnr();
      }		
    }
    // Extraction des refus d'EMS
    $join = "demandeor";
    $on = "choixems.nodoss = demandeor.nodoss";
    $champs = "demandeor.nodoss, choixems.motref";
    $dut = new ensTableBrioche("choixems", "(demandeor.datedem BETWEEN $debAm AND $finAm) AND refpro = -1",
                               $champs, 0, $this->idsession, $join, $on);
    $tabchamps = array();
    $tabDut = $dut->getTableau();
    $cpt = count($tabDut);
    for($i = 0; $i < $cpt; $i++){
      $tabchamps['iddemand'] = md5($tabDut[$i]->nodoss . $this->mdp);
      $tabchamps['typerefus'] = 2;
      $tabchamps['motifrefus'] = $tabDut[$i]->motref;
      $nouv = new updateTableBrioche($tpr->getNom(), $tabchamps, 0, 0, $this->idsession);
      $nouv->ajouteEnr();    
    }	
    	
  }

  //Fonctions de calculs des variables IUMSP
  /**
  * calcul de l'ge
  * @param string naiss la date de naissance (format jj.mm.aaaa)
  * - impossible de gnrer un timestamp unix pour une date < 1970
  * @param string naiss la date de demande (timestamp unix)
  * @return int
  * <pre>
  * age <= 64 ans : 1
  * age > 64 et <= 74 ans : 2
  * age > 74 et <= 84 ans : 3
  * age > 84 ans : 4
  * age non calculable : 99
  * </pre>
  */
  function calcAge($naiss, $dem){
    if(! $naiss || ! $dem) return 99;
    $age = date("Y", $dem) - substr($naiss, 6, 4);
    if ($age <= 64) return 1;
    elseif($age <= 74) return 2;
    elseif($age <= 84) return 3;
    else return 4;
  }	
  /**
  * calcul du sexe
  * @param string sexe ("M" ou "F")
  * @return int 
  * <pre>
  * masculin  : 1
  * fminin : 2
  * non calculable 99
  * </pre>
  */
  function calcSexe($sexe){
  	if(! $sexe) return 99;
  	if($sexe == "M") return 1;
  	else return 2;
  }	
  
  /**
  * calcul de la situation sociale
  * @param int sitsoc la valeur du champ sitsoc de la table demandeor
  * @param int aidepr la valeur ch champ aidepr de la table demandeor
  * @return int
  * <pre>
  * vit seul et sans aide : 1
  * vit seul avec aide de proches : 2
  * vit en mnage : 3
  * vit en institution de soins : 4
  * autre : 5
  * non calculable : 99
  * </pre>
  */
  function calcSitsoc($sitsoc, $aidepr){
    if(! $sitsoc) return 99;
    if($sitsoc == 1 && (! $aidepr)) return 1; //Seul sans aide
    elseif($sitsoc == 3 || ($sitsoc == 1 && $aidepr)) return 2; //Avec aide proches
    elseif($sitsoc == 2) return 3; //En mnage
    elseif($sitsoc == 4) return 4;  //En institution de soins
    elseif($sitsoc == 5) return 5;  //Autre
  }	
  
  /**
  * calcul d'une valeur de la grille d'autonomie
  * @param int la valeur d'un champ de la table grille
  * @return int la mme valeur ou 99 s'il est absent
  */
  function calcGrille($param){
    if (! $param) return 99;
    return $param;
  }	
  
  /**
  * calcul d'une paire an-semaine
  * @param int un timestamp unix
  * @return string une chane "aa-ss" o aa est l'anne  2 chiffres et ss est le numro de la semaine dans l'anne
  */
  function calcAnSemaine($tst){
    if (! $tst) return 99;
    $an = date("y", $tst);
    $sem = date("W", $tst);
    return "$an-$sem";	
  }	
  
  /**
  * calcul de la variable "dbut souhait pour la prise en charge" en combinant les valeurs
  * du champ "litdepuis", "datedem" et "debutec" de la table demandeor
  * @param int litdepuis date demande pour le dbut de la prise en charge (timestamp unix)
  * @return int si debutpec, correspondant aux boutons radio du cadre "Dbut souhait pour la prise en charge
  * de la demande d'orientaion, est fourni, le renvoie tel quel. Dans le cas contraire, tente de calculer un
  * quivalent en se basant sur la date de la demande et le champ "Depuis le" du mme cadre 
  * <pre>
  * le plus vite possible (0 - 2 j.) : 1
  * ds maintenant mais sans urgence (3 - 6 j.) : 2
  * dans 1 semaine  1 mois max. : 3
  * dans plus d'un mois : 4
  * non calculable : 99
  * </pre>
  */
  function calcDebutPec($litdepuis, $datedem, $debutpec){
    if((! $debutpec) && ((! $datedem) || (! $litdepuis))) return 99;
    if($litdepuis && $datedem && (! $debutpec)){
      $interv = ($litdepuis - $datedem)/(60 * 60 * 24);
      if($interv < 7) return 2;
      elseif($interv < 31) return 3;
      else return 4;
    }
    else {		
      return $debutpec;
    }
  }	
  
  /**
  * calcul de la provenance (situation de l'usager au moment de la demande)
  * @param int provenance la valeur du champ "provenance" de la table "demandeor"
  * @param int uat la valeur du champ "uat" de la table "demandeor" : 0 si pas d'UAT, -1 si UAT
  * @return int
  * <pre>
  * hpital A : 1
  * hpital B : 2
  * long sjour : 3
  * long sjour provisoire : 4
  * court sjour : 5
  * lit A ou B reclass : 6
  * tablissement non mdicalis : 7
  * domicile avec UAT : 8
  * domicile sans UAT : 9
  * non calculable : 99
  * </pre>
  */
  function calcProvient($provenance, $uat){
    if(! $provenance) return 99;
    if($provenance == 1) return 1;
    elseif($provenance == 2) return 2;
    elseif($provenance == 3) return 3;
    elseif($provenance == 4){
      if($uat == -1) return 8;
      else return 9;
    }	
    elseif($provenance == 5) return 4;
    elseif($provenance == 6) return 10;
    elseif($provenance == 7) return 5;
    elseif($provenance == 8) return 6;
    elseif($provenance == 9) return 7;
  }	
  
  /**
  * calcul de la prise en charge demande
  * @param int typesej la valeur du champ "typesej" de la table "demandeor" 
  * @return int
  * <pre>
  * court sjour : 1
  * long sjour : 2
  * sjour d'observation : 3
  * tablissement non mdicalis : 4
  * domicile avec UAT : 5
  * domicile sans UAT : 6
  * toutes options ouvertes : 7
  * CTR : 8
  * orientation dj arrte : 0
  * non calculable : 99
  * </pre>
  */
  function calcPecDem($typesej){
    if(! $typesej) return 99;
    if($typesej == 1) return 2; //Long
    elseif($typesej == 2) return 3; //Observation
    elseif($typesej == 3 || $typesej == 4 || $typesej == 5 || $typesej == 14) return 1; //Court
    elseif($typesej == 6) return 4; //Et non mdicalis
    elseif($typesej == 7) return 8; //CTR
    elseif($typesej == 8 || $typesej == 10 || $typesej == 11) return 6; //Domicile sans UAT
    elseif($typesej == 9) return 5; //Domicile avec UAT
    elseif($typesej == 12) return 7; //Toutes options ouvertes
    elseif($typesej == 13) return 0; //Dj arrte
  }	
  
  /**
  * calcul du type de domicile
  * @param int typesej la valeur du champ "typesej" de la table "demandeor"
  * @return int
  * <pre>
  * domicile (avec ou sans UAT) : 1
  * logement adapt : 2
  * appartement protg : 3
  * non calculable : 99
  * </pre>
  */
  function calcTypeDom($typesej){
    if($typesej == 8) return 1;
    elseif($typesej == 9) return 1;
    elseif($typesej == 10) return 2;
    elseif($typesej == 11) return 3;
    else return 99;
  }	
  
  /**
  * calcul de la nature de la prise en charge
  * @param int typepath la valeur du champ "typepath" de la table "demandeor"
  * @return int
  * <pre>
  * griatrie : 1 (ou autre)
  * psychiatrie : 2
  * psychogriatrie : 3
  * non calculable : 99
  * </pre>
  */
  function calcNatPec($typepath){
    if (! $typepath) return 99;
    if ($typepath == 1) return 3; //Psychogr.
    elseif ($typepath == 2 || $typepath == 4) return 1; //Griatrie
    elseif ($typepath == 3) return 2; //Psychiatrie
  }  	
  
  /**
  * calcul de la dcision d'orientation
  * @param int orientation la valeur du champ "orientation" de la table "decision"
  * @return int
  * <pre>
  * domicile priv : 1
  * logement adapt : 2
  * logement protg : 3
  * tablissement non mdicalis : 4
  * EMS griatrique : 5
  * EMS psychogriatrique : 6
  * EMS psychiatrique : 7
  * la dcision CTR, pas encore prsente lors de l'tude IUMSP, est assimile  un retour  domicile
  * non calculable : 99
  * </pre> 
  */
  function calcDecOrient($orientation){
    if(! $orientation) return 99;
    if($orientation == 1) return 1; //Domicile priv
    elseif($orientation == 2) return 2; //Logement adapt
    elseif($orientation == 3) return 3; //Logement protg
    elseif($orientation == 4) return 4;  //Et. non mdic.
    elseif($orientation == 5) return 5; //EMS griatrique
    elseif($orientation == 6) return 6; //EMS psychogr.
    elseif($orientation == 7) return 7; // EMS psychiatrique
    elseif($orientation == 8) return 1; // CTR : A moins d'une modification des critres de l'IUMSP, une orientation en CTR
                                        // annonce un retour  domicile
  }	
  
  /**
  * calcul de la dsition d'organiser une UAT
  * @param int orientation la valeur du champ "orientation" de la table "decision"
  * @param int ug la valeur du champ "ug" de la table "decision" (UAT griatrique : 0 ou -1)
  * @param int up la valeur du champ "up" de la table "decision" (UAT psychogriatrique : 0 ou -1)
  * @return int
  * <pre>
  * pas d'UAT : 0
  * UAT griatrique : 1
  * UAT psychogriatrique : 2
  * non calculable : 99
  * </pre>
  */
  function calcOrgUat($orientation, $ug, $up){
    if($orientation + $ug + $up == 0) return 99;
    if($ug == -1) return 1;
    elseif($up == -1) return 2;
    else return 0;
  }	

  /**
  * calcul de la variable "placement dans le rseau"
  * @param int issue la valeur du champ "issue" de la table "issue"
  * @param int nolit le numro du lit attribu
  * @return int
  * <pre>
  * placement hors rseau : 0
  * attribution d'un lit dans le rseau : 1
  * non calculable ou non pertinent : 99
  * </pre>
  */
  function calcEMSRes($issue, $nolit){
    if($issue == 2 || $issue == 3 || $issue == 6 || $issue == 11){
      if(! $nolit) return 0;
      else return 1;
    }
    else{
      return 99;	 
    }
  }
  
  /**
  * calcul de l'aboutissement
  * @param int issue la valeur du champ "issue" de la table "issue"
  * @return int
  * <pre>
  * domicile : 1
  * court sjour : 2
  * long sjour : 3
  * long sjour dans le mme tablissement (aprs sjour d'observation) : 4
  * sjour d'observation : 5
  * hpital A : 6
  * hpital B : 7
  * dcs : 8
  * retrait de la demande : 9
  * nouvelle demande : 10
  * non calculable : 99
  * </pre>
  */
  function calcAboutiss($issue){
    if(! $issue) return 99;
    if($issue == 1) return 1; // domicile
    elseif($issue == 2) return 2; //Court sjour
    elseif($issue == 3) return 3; //Long
    elseif($issue == 4) return 8; // Dcs
    elseif($issue == 5) return 9; // Retrait
    elseif($issue == 6) return 5; //Sjour d'observation
    elseif($issue == 7) return 10; //Nouvelle demande
    elseif($issue == 8) return 4; //Long sjour mme tablissement
    elseif($issue == 9) return 6; //Hp. A.
    elseif($issue == 10) return 7; //Hp. B.
    elseif($issue == 11) return 2; //Court sjour planing
  }	

  /**
  * calcul du caractre provisoire d'un long sjour
  * @param int issue la valeur du champ "issue" de la table "issue"
  * @param int longprov la valeur du champ "longprov" de la table "decision"
  * @return int
  * <pre>
  * long sj. provisioire : 1
  * pas de long sj. provisoire : 2
  * non calculable : 99
  * </pre>
  */
  function calcLsProvis($issue, $longprov){
    if ($issue == 3){
      if ($longprov == -1) return 1;
      else return 2;
    }
    else return 99;	
  }	

  /**
  * calcul de la dure entre la demande et son aboutissement
  * @param int datedem la date de la demande (timestamp unix)
  * @param int dateissue la date de l'issue (timestamp unix)
  * @return int le nombre de jours ou, si non calculable, -99999
  */
  function calcDemabout($datedem, $dateissue){
    if((! $datedem) || (! $dateissue)){
      return -99999;
    }	
    else{
      $duree = intval(($dateissue - $datedem)/(24*60*60));
      return $duree;
    }	
  }	
}
?>
