<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Ensemble de navigation des dossier Brioche
* @package donnes
* @author ob
*/
/**
* Ensemble de navigation des dossiers Brioche
* Permet de slectionner des sous-ensembles de dossiers selon divers critres et de naviguer entre
* eux. La barre de navigation du dossier Brioche s'appuie sur cet objet pour dfinir, pour chaque dossier
* affich, le premier dossier de l'ensemble, le dernier, le prcdent, le suivant et pour dterminer si le
* dossier demand fait partie du sous-ensemble courant
* @package donnes
* @author ob
*/
class ensNavBrioche extends connexionBrioche {
  /**
  * le mode de consultation des dossiers
  * <pre>
  * dossiers ouverts : 0
  * dossiers archivs : 1
  * tous les dossiers : 2
  * filtrer par usager : 3
  * nouveau dossier : 4
  * filtrer par tablissement prslectionn : 5
  * </pre>
  * @var int
  */
  
  var $mode;
  /**
  * le numro de l'usager (si mode 3)
  * @var int
  */
  var $usager;
  
  /**
  * le numro de l'tablissement (si mode 5)
  * @var int
  */
  var $etabl;
  
  /**
  * @param int mode cf. variable de classe
  * @param string sessionid l'identifiant de session
  * @param array autspec les autorisations spcifiques
  */
  function __construct($mode, $sessionid, $autspec=0){
    if (! parent::__construct($sessionid, $autspec)) return false;
    $this->mode = $mode;
  }

  /**
  * dfinition de l'usager (mode 3)
  * @param int usager le numro d'usager
  */
  function setUsager($usager){
    $this->usager = $usager;
  }

  /**
  * dfinition de l'tablissement (mode 5)
  * @param int etabl le numro d'tablissement
  */
  function setEtablissement($etabl){
    $this->etabl = $etabl;
  }

  /**
  * renvoie le dossier suivant compte tenu du mode
  * @param int item le numro du dossier courant
  * @return int le numro du dossier suivant
  */
  function getSuivant($item){
    if ($this->n_erreur) return;
    $requete = "SELECT dossiers.nodoss FROM " . $this->clausefrom() .
               " WHERE dossiers.nous > 0 AND dossiers.nodoss > $item AND " . $this->clausemode() .
               " ORDER BY dossiers.nodoss LIMIT 1";
    $result = mysql_query($requete);
    if (! mysql_num_rows($result)) return $item;
    $lignes = mysql_fetch_row($result);
    return $lignes[0];
  }

  /**
  * renvoie le dossier prcdent compte tenu du mode
  * @param int intem le numro du dossier courant
  * @return int le numro du dossier prcdent
  */
  function getPrecedent($item){
    if ($this->n_erreur) return;
    if (!$item) $item = 100000000000;
    $requete = "SELECT dossiers.nodoss FROM " . $this->clausefrom() . 
               " WHERE dossiers.nous > 0 AND dossiers.nodoss < $item AND " . $this->clausemode() .
               " ORDER BY dossiers.nodoss DESC LIMIT 1 ";
    $result = mysql_query($requete);
    if (! mysql_num_rows($result)) return $item;
    $lignes = mysql_fetch_row($result);
    return $lignes[0];

  }

  /**
  * rdige la clause FROM de la requte en fonction du mode
  * @return string la clause from
  */
  function clausefrom(){
    switch ($this->mode) {
    case 0:
    case 1:
    case 2:
    case 3:
    case 4:
      return "dossiers";
      break;
    case 5:
      return "dossiers LEFT JOIN choixems ON dossiers.nodoss = choixems.nodoss";
      break;
    }
  }

  
  /**
  * rdige la clause WHERE en fonction du mode
  * @return string la clause WHERE
  */
  function clausemode(){
    // Statut in (99, 100) => dossiers provisoires ouverts lors de la validation des demandes SP;
    switch ($this->mode) {
    case 0:
      return "dossiers.nous > 0 AND dossiers.dateclo IS NULL AND (statut IS NULL OR statut NOT IN (99, 100))";         
       //MODE 0 : dossiers en cours
      break;
    case 1:
      return "dossiers.nous > 0 AND dossiers.dateclo IS NOT NULL AND (statut IS NULL OR statut NOT IN (99, 100))";
      //MODE 1 : dossiers archivs
      break;
    case 2:
      return "dossiers.nous > 0 AND (statut IS NULL OR statut NOT IN (99, 100))";
      //MODE 2 : tous dossiers
      break;
    case 3:
      return "dossiers.nous = " . ($this->usager ? $this->usager : "0") .
             " AND (statut IS NULL OR statut NOT IN (99, 100))";
      //MODE 3 : filtrer par usagers
      break;
    case 4:
      return "dossiers.nous < 0 AND (statut IS NULL OR statut NOT IN (99, 100))";
      //MODE 4 : nouvelle demande
      break;
    case 5:
      return "dossiers.nous > 0 AND dossiers.dateclo IS NULL AND choixems.noems = $this->etabl " .
             "AND (statut IS NULL OR statut NOT IN (99, 100))";
      //MODE 5 : prinscriptions dans les tablissements
      break;
    }
  }

  /**
  * contrle que l'item demand appartient bien  l'ensemble de dossier compte tenu du mode
  * @param int item le numro de dossier demand
  * @param boolean le numro en question appartient-il  l'ensemble de dossiers correspondant au mode courant ?
  */  
  function checkItem($item){
    if ($this->n_erreur) return;
    $requete = "SELECT COUNT(dossiers.nodoss) FROM " . $this->clausefrom() . " WHERE dossiers.nodoss = '$item' AND " .
                $this->clausemode();
    $result = mysql_query($requete);
    $lignes = mysql_fetch_row($result);
    if ($lignes[0]){
      return true;
    }
    else {
      return false;
    }
  }

  /**
  * renvoie le nombre de dossiers appartenant  l'ensemble dtermin par le mode
  * @return int
  */
  function getNbDoss(){
    if ($this->n_erreur) return;
    $requete = "SELECT COUNT(dossiers.nodoss) FROM " . $this->clausefrom() .
               " WHERE dossiers.nous > 0 AND " . $this->clausemode();
    $result = mysql_query($requete);
    $lignes = mysql_fetch_row($result);
    return $lignes[0];
  }

  /**
  * revoie la dnomination correspondant aux numros de mode
  * @param int mode le numro d'un mode
  * @return string le libell correspondant
  */
  function getLibelle($mode){
    switch($mode){
    case 0:
      return "Dossiers ouverts";
      break;
    case 1:
      return "Dossiers archivs";
      break;
    case 2:
      return "Tous dossiers";
      break;
    case 3:
      return "Filtrer par usager";
      break;
    case 4:
      return "Nouvelle demande";
      break;
    case 5:
      return "Prinscriptions";
      break;
    }
  }

}

?>
