<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Ensemble de donnes pour l'extraction des indicateurs 2002
* @package donnes
*/
/**
* Ensemble de donnes pour l'extraction des indicateurs 2002
* Groupe les requtes de base de donnes ncessaires  l'extraction des indicateurs SSP 2002
* Cet ensemble d'indicateurs sont les premiers  avoir t demands par le SSP aux BRIOs.
* Mme s'ils ont t quelque peu actualiss, leur intrt est surtout historique.
* Cet objet disponibles les indicateurs pour affichage ou pour export dans une feuille de calcul
* @package donnes
* @author ob
*/
class ensStatMM2 extends connexionBrioche {
  /**
  * le dbut de la priode (date au format "francophone")
  * @var int
  */
  var $deb;
  
  /**
  * la fin de la priode (date au format "francophone")
  * @var int
  */
  var $fin;
  
  /**
  * nombre de demandes externes (formules par un partenaire externe)
  * @var int
  */
  var $nbDemExt;
  
  /**
  * nombre de sjours d'observations dbouchant ne dbouchant pas sur un placement dans le mme tablissement
  * @var int
  */
  var $nbSejObsChgtEt;
  
  /**
  * nombre total des demandes (nbDemExt + nbSejObsChgtEt). Par dfinition, les sjours d'observation 
  * aboutissant  un placement dans le mme tablissement ne gnrent pas une nouvelle demande
  * @var int
  */
  var $nbDemOr;
  
  /**
  * nombre des demandes externes de long sjour
  * @var int
  */
  var $nbDemExtLong;
  
  /** nombre de demandes de long sjour dans un autre tablissement depuis un sjour d'observation
  * @var int
  */
  var $nbSejObsChgtEtLong;
  
  /** nombre total des demandes de long sjour (nbDemExtLong + nbSejObsChgtEtLong)
  * @var int
  */
  var $nbDemOrLong;
  
  /**
  * nombre total des demandes de court sjour (nbDemExtCourt + nbSejObsChgtEtCourt)
  * @var int
  */
  var $nbDemOrCourt;
  
  /**
  * nombre des demandes externes de court sjour (ni urgent ni planning)
  * @var int
  */
  var $nbDemExtCourt;
  
  /**
  * nombre total des demandes de court sjour urgent (nbDemExtCourtU + nbSejObsChgtEtCourtU)
  * @var int
  */
  var $nbDemOrCourtU;
  
  /**
  * nombre de demandes externes de court sjour urgent
  * @var int
  */
  var $nbDemExtCourtU;
  
  /**
  * nombre des demandes de court sjour urgent depuis un sjour d'observation
  * @var int
  */
  var $nbSejObsChgtEtCourtU;
  
  /**
  * nombre total des demandes de court sjour "planning" (nbDemExtCourtP + nbSejObsChgtEtCourtP)
  * @var int
  */
  var $nbDemOrCourtP;
  
  /**
  * nombre des demandes externes de court sjour "planning"
  * @var int
  */
  var $nbDemExtCourtP;
  
  /**
  * nombre de demandes de court sjour "planning" depuis un sjour d'observation
  * @var int
  */
  var $nbSejObsChgtEtCourtP;
  
  /**
  * nombre des demandes de court sjour (ni urgents ni planning) depuis un sjour d'observation
  * @var int
  */
  var $nbSejObsChgtEtCourt;
  
  /**
  * nombre total de demandes de sjour d'observation (nbDemExtObs + nbSejObsChgtEtObs)
  * @var int
  */ 
  var $nbDemOrObs;
  
  /**
  * nombre de demandes externes de sjour d'observation
  * @var int
  */
  var $nbDemExtObs;
  
  /**
  * nombre de demandes externes de structures intermdiaires
  * @var int
  */
  var $nbDemExtInt;
  
  /**
  * nombre de demandes de structures intermdiaires depuis un sjour d'observation
  * @var int
  */
  var $nbDemSejObsInt;
  
  /**
  * nombre total des demandes de structures intermdiaires (appart. protgs et adapts) (nbDemExtInt + nbDemSejObsInt)
  * @var int
  */ 
  var $nbDemOrInt;
  
  /**
  * nombre total des demandes de retour  domicile (nbDemExtDom + nbSejObsDom)
  * @var int
  */
  var $nbDemOrDom;
  
  /**
  * nombre de demandes externes de retour  domicile
  * @var int
  */
  var $nbDemExtDom;
  
  /**
  * nombre de demandes de retour  domicile depuis un sjour d'observation
  * @var int
  */
  var $nbSejObsDom;
  
  /** 
  * nombre total de damandes de CTR (nbDemExtCtr + nbSejObsCtr)
  * @var int
  */
  var $nbDemOrCtr;
  
  /**
  * nombre de demandes externes de CTR
  * @var int
  */
  var $nbDemExtCtr;
  
  /**
  * nombre de demande de CTR depuis un sjour d'observation
  * @var int
  */
  var $nbSejObsCtr;
  
  /**
  * nombre de demandes de nouveau sjour d'observation depuis un sjour d'observation
  * @var int
  */
  var $nbSejObsChgtEtObs;
  
  /**
  * nombre total des demandes non spcifies (nbDemExtNS + nbSejObsChgtEtNS)
  * @var int
  */
  var $nbDemOrNS;
  
  /**
  * nombre de demandes externes non spcifies
  * @var int
  */
  var $nbDemExtNS;
  
  /**
  * nombre de demandes non spcifies depuis un sjour d'observation
  * @var int
  */
  var $nbSejObsChgtEtNS;
  
  /**
  * nombre d'annonces de lit
  * @var int
  */
  var $nbann;
  
  /**
  * nombre d'annonces de lit de long sjour
  * @var int
  */
  var $nbAnnL;
  
  /**
  * nombre d'annonces de lit de court sjour
  * @var int
  */
  var $nbAnnC;
  
  /**
  * nombre d'annonces de lits polyvalents
  * @var int
  */
  var $nbAnnPo;
  
  /**
  * nombre de lits de court sjour planning
  * @var int
  */
  var $nbAnnPl;
  
  /**
  * nombre de demandes externes dans lequel le BRIO est impliqu
  * @var int
  */
  var $nbDemExtImplBrio;
  
  /**
  * nombre de sjours d'observation ne dbouchant pas sur le placement dans le mme tablissement pour lequel le BRIO est impliqu
  * @var int
  */
  var $nbSejObsChgtEtImplBrio;
  
  /**
  * nombre de demandes externe avec OPARS et BRIO 1re ligne
  * @var int
  */
  var $nbDemExtOpars1;
  
  /**
  * nombre de suites de sjour d'observation avec OPARS et BRIO 1re ligne
  * @var int
  */
  var $nbSejObsChgtEtOpars1;
  
  /** 
  * nombre total de demandes avec OPARS et BRIO 1re ligne (nbDemExtOpars1 + nbSejObsChgtEtOpars1)
  * @var int
  */
  var $opars1;
  
  /**
  * nombre de demandes externes avec OPARS et BRIO 2e ligne
  * @var int
  */
  var $nbDemExtOpars2;
  
  /**
  * nombre de suites de sjour d'observation avec OPARS et BRIO 2e ligne
  * @var int
  */
  var $nbSejObsChgtEtOpars2;
  
  /**
  * nombre total des demandes avec OPARS et BRIO 2e ligne (nbDemExtOpars2 + nbSejObsChgtEtOpars2)
  * @var int
  */
  var $opars2;
  
  /**
  * nombre de demandes externes avec OPARS sans implication du BRIO
  * @var int
  */
  var $nbDemExtOpars0;
  
  /**
  * nombre de de suites de sjour d'observation avec OPARS sans implication du BRIO
  * @var int
  */
  var $nbSejObsChgtEtOpars0;
  
  /**
  * nombre total des demandes avec OPARS sans implication du BRIO (nbDemExtOpars0 + nbSejObsChgtEtOpars0)
  * @var int
  */
  var $opars0;
  
  /**
  * nombre de lits attribus
  * @var int
  */
  var $nbLitsAttr;
  
  /**
  * nombre de longs sjours attribus
  * @var int
  */
  var $briolongs;
  
  /**
  * nombre de cpirts skpir attribus
  * @var int
  */
  var $brioCourts;
  
  /** 
  * nombre de sjours d'observation attribus
  * @var int
  */
  var $brioObs;
  
  /**
  * nombre des refus d'EMS
  * @var int
  */
  var $nbRefus;
  
  /** 
  * nombre des refus de long sjour
  * @var int
  */
  var $nbRefusLong;
  
  /**
  * nombre des refus de court sjour
  * @var int
  */
  var $nbRefusCourt;
  
  /**
  * nombre des refus de sjours d'observation
  * @var int
  */
  var $nbRefusObs;
  
  /**
  * nombre d'autres prises en charge que l'hbergbement
  * @var int
  */
  var $nonHeberg;
  
  /**
  * nombre de retour  domicile avec UAT
  * @var int
  */
  var $domU;
  
  /**
  * nombre retour  domicile sans UAT
  * @var int
  */
  var $doms;
  
  /**
  * nombre de logements protgs ou adapts
  * @var int
  */
  var $lprot;
  
  /** 
  * nombre de sjours d'observation organiss
  * @var int
  */
  var $sejObs;
  
  /**
  * nombre de sjours d'observation organiss se terminant par un retour  domicile
  */
  var $sejObsd;

  /**
  * @param string deb cf. variable de classe
  * @param string fin cf. variable de classe
  * @param string sessionid cf. variable de classe
  */
  function ensStatMM2($deb, $fin, $sessionid){
    if (! $this->connexionBrioche($sessionid)) return;
    $this->deb = $deb;
    $this->fin = $fin;
    $debAm = $this->getDateAm($deb);
    $finAm = $this->getDateAm($fin);
    $join[] = "demandeor";
    $on[] = "dossiers.nodoss = demandeor.nodoss";
    $join[] = "issue";
    $on[] = "dossiers.nodoss = issue.nodoss";
    $join[] = "decision";
    $on[] = "dossiers.nodoss = decision.nodoss";
    $join[] = "profilopars";
    $on[] = "dossiers.nodoss = profilopars.nodoss";
    $join[] = "etablissements";
    $on[] = "demandeor.servplac = etablissements.noet";
    $join[] = "attributionlit";
    $on[] = "dossiers.nodoss = attributionlit.nodoss";
    $ensd = new ensTableBrioche("dossiers", "1",
                                "dossiers.nodoss",
                               //"demandeor.servplac, etablissements.idsulid, issue.issue, dossiers.sejobs, demandeor.datedem, " .
                               //"demandeor.typesej, decision.interbrio, profilopars.profil, attributionlit.nolit, " .
                               //"decision.UG, decision.UP, decision.orientation",
                               0, $this->idsession, $join, $on);
    $wheredate = "datedem BETWEEN $debAm AND $finAm";
    $whereetabl = "  AND (etablissements.idsulid IS NULL OR etablissements.idsulid <> \"-1\")";
    $wheresejobs = " AND (sejobs = -1 AND issue <> 8)";
    $where = $wheredate . $whereetabl ;
    $ensd->setWhere($where);
    $this->nbDemExt = $ensd->compte();
    $where = $wheredate . $wheresejobs;
    $ensd->setWhere($where);
    $this->nbSejObsChgtEt = $ensd->compte();

    $wherepart = " AND demandeor.typesej = 1";
    $where = $wheredate . $whereetabl . $wherepart;
    $ensd->setWhere($where);
    $this->nbDemExtLong = $ensd->compte();
    $where = $wheredate . $wheresejobs . $wherepart;
    $ensd->setWhere($where);
    $this->nbSejObsChgtEtLong = $ensd->compte();

    $wherepart = " AND demandeor.typesej IN (3)";
    $where = $wheredate . $whereetabl . $wherepart;
    $ensd->setWhere($where);
    $this->nbDemExtCourt = $ensd->compte();
    $where = $wheredate . $wheresejobs . $wherepart;
    $ensd->setWhere($where);
    $this->nbSejObsChgtEtCourt = $ensd->compte();

    $wherepart = " AND demandeor.typesej IN (5)";
    $where = $wheredate . $whereetabl . $wherepart;
    $ensd->setWhere($where);
    $this->nbDemExtCourtP = $ensd->compte();
    $where = $wheredate . $wheresejobs . $wherepart;
    $ensd->setWhere($where);
    $this->nbSejObsChgtEtCourtP = $ensd->compte();
    
    $wherepart = " AND demandeor.typesej IN (14)";
    $where = $wheredate . $whereetabl . $wherepart;
    $ensd->setWhere($where);
    $this->nbDemExtCourtU = $ensd->compte();
    $where = $wheredate . $wheresejobs . $wherepart;
    $ensd->setWhere($where);
    $this->nbSejObsChgtEtCourtU = $ensd->compte();
    
    $wherepart = " AND demandeor.typesej = 2";
    $where = $wheredate . $whereetabl . $wherepart;
    $ensd->setWhere($where);
    $this->nbDemExtObs = $ensd->compte();
    $where = $wheredate . $wheresejobs . $wherepart;
    $ensd->setWhere($where);
    $this->nbSejObsChgtEtObs = $ensd->compte();

    $wherepart = " AND demandeor.typesej IN (6, 10, 11)";
    $where = $wheredate . $whereetabl . $wherepart;
    $ensd->setWhere($where);
    $this->nbDemExtInt = $ensd->compte();
    $where = $wheredate . $wheresejobs . $wherepart;
    $ensd->setWhere($where);
    $this->nbSejObsInt = $ensd->compte();
    
    $wherepart = " AND demandeor.typesej IN (8, 9)";
    $where = $wheredate . $whereetabl . $wherepart;
    $ensd->setWhere($where);
    $this->nbDemExtDom = $ensd->compte();
    $where = $wheredate . $wheresejobs . $wherepart;
    $ensd->setWhere($where);
    $this->nbSejObsDom = $ensd->compte();
    
    $wherepart = " AND demandeor.typesej = 7";
    $where = $wheredate . $whereetabl . $wherepart;
    $ensd->setWhere($where);
    $this->nbDemExtCtr =$ensd->compte();
    $where = $wheredate . $wheresejobs . $wherepart;
    $ensd->setWhere($where);
    $this->nbSejObsCtr = $ensd->compte();
    
    $wherepart = " AND demandeor.typesej NOT IN (1, 2, 3, 5, 6, 7, 8, 9, 10, 11, 14)";
    $where = $wheredate . $whereetabl . $wherepart;
    $ensd->setWhere($where);
    $this->nbDemExtNS = $ensd->compte();
    $where = $wheredate . $wheresejobs . $wherepart;
    $ensd->setWhere($where);
    $this->nbSejObsChgtEtNS = $ensd->compte();

    $wherepart = " AND interbrio IN (1,2) AND profil is not null";
    $where = $wheredate . $whereetabl . $wherepart;
    $ensd->setWhere($where);
    $this->nbDemExtImplBrio = $ensd->compte();
    $where = $wheredate . $wheresejobs . $wherepart;
    $ensd->setWhere($where);
    $this->nbSejObsChgtEtImplBrio = $ensd->compte();

    $wherepart = " AND interbrio = 1 AND profil is not null";
    $where = $wheredate . $whereetabl . $wherepart;
    $ensd->setWhere($where);
    $this->nbDemExtOpars1 = $ensd->compte();
    $where = $wheredate . $wheresejobs . $wherepart;
    $ensd->setWhere($where);
    $this->nbSejObsChgtEtOpars1 = $ensd->compte();

    $wherepart = " AND interbrio = 2 AND profil is not null";
    $where = $wheredate . $whereetabl . $wherepart;
    $ensd->setWhere($where);
    $this->nbDemExtOpars2 = $ensd->compte();
    $where = $wheredate . $wheresejobs . $wherepart;
    $ensd->setWhere($where);
    $this->nbSejObsChgtEtOpars2 = $ensd->compte();
    $this->nbDemOr = $this->nbDemExt + $this->nbSejObsChgtEt;

    $wherepart = " AND interbrio NOT IN (1, 2) AND profil is not null";
    $where = $wheredate . $whereetabl . $wherepart;
    $ensd->setWhere($where);
    $this->nbDemExtOpars0 = $ensd->compte();
    $where = $wheredate . $wheresejobs . $wherepart;
    $ensd->setWhere($where);
    $this->nbSejObsChgtEtOpars0 = $ensd->compte();

    $this->nbDemOr = $this->nbDemExt + $this->nbSejObsChgtEt;
    $this->nbDemOrLong = $this->nbDemExtLong + $this->nbSejObsChgtEtLong;
    $this->nbDemOrCourt = $this->nbDemExtCourt + $this->nbSejObsChgtEtCourt;
    $this->nbDemOrCourtP = $this->nbDemExtCourtP + $this->nbSejObsChgtEtCourtP;
    $this->nbDemOrCourtU = $this->nbDemExtCourtU + $this->nbSejObsChgtEtCourtU;
   
    $this->nbDemOrObs = $this->nbDemExtObs + $this->nbSejObsChgtEtObs;
    $this->nbDemOrInt = $this->nbDemExtInt + $this->nbSejObsInt;
    $this->nbDemOrDom = $this->nbDemExtDom + $this->nbSejObsDom;
    $this->nbDemOrCtr = $this->nbDemExtCtr + $this->nbSejObsCtr;
    $this->nbDemOrNS = $this->nbDemExtNS + $this->nbSejObsChgtEtNS;
    $this->implBrio = $this->nbDemExtImplBrio + $this->nbSejObsChgtEtImplBrio;
    $this->opars1 = $this->nbDemExtOpars1 + $this->nbSejObsChgtEtOpars1;
    $this->opars2 = $this->nbDemExtOpars2 + $this->nbSejObsChgtEtOpars2;
    $this->opars0 = $this->nbDemExtOpars0 + $this->nbSejObsChgtEtOpars0;

    //Annonces
    $wheredate = "datann BETWEEN $debAm AND $finAm";
    $where = $wheredate;

    $ensa = new ensTableBrioche("annoncelit", "1", "*", 0, $this->idsession);
    $ensa->setWhere($where);
    $this->nbAnn = $ensa->compte();
    
    $wheretype = " AND stlit = 1";
    $ensa->setWhere($where . $wheretype);
    $this->nbAnnL = $ensa->compte();
    $wheretype = " AND stlit = 3";
    $ensa->setWhere($where . $wheretype);
    $this->nbAnnC = $ensa->compte();
    $wheretype = " AND stlit = 4";
    $ensa->setWhere($where . $wheretype);
    $this->nbAnnPo = $ensa->compte();
    $wheretype = " AND stlit = 5";
    $ensa->setWhere($where . $wheretype);
    $this->nbAnnPl = $ensa->compte();
    
    
    
    
    //Issue
    $wheredate = "dateissue BETWEEN $debAm AND $finAm";
    $wherepart = " AND issue IN (2, 3, 6) AND nolit IS NOT NULL";
    $where = $wheredate . $wherepart;
    $ensd->setWhere($where);
    $this->nbLitsAttr = $ensd->compte();
    $wherepart = " AND issue = 3 AND nolit IS NOT NULL";
    $where = $wheredate . $wherepart;
    $ensd->setWhere($where);
    $this->brioLongs = $ensd->compte();
    $wherepart = " AND issue = 2 AND nolit IS NOT NULL";
    $where = $wheredate . $wherepart;
    $ensd->setWhere($where);
    $this->brioCourts = $ensd->compte();
    $wherepart = " AND issue = 6 AND nolit IS NOT NULL";
    $where = $wheredate . $wherepart;
    $ensd->setWhere($where);
    $this->brioObs = $ensd->compte();
    $wherepart = " AND issue = 6 AND nolit IS NOT NULL";
    $where = $wheredate . $wherepart;
    $ensd->setWhere($where);
    $this->brioObs = $ensd->compte();
    $wherepart = " AND issue NOT IN (2, 3, 6, 7, 8)";
    $where = $wheredate . $wherepart;
    $ensd->setWhere($where);
    $this->nonHeberg = $ensd->compte();
    $wherepart = " AND issue NOT IN (3, 6, 7, 8) AND (UG = -1 OR UP = -1)";
    $where = $wheredate . $wherepart;
    $ensd->setWhere($where);
    $this->domU = $ensd->compte();
    $wherepart = " AND issue NOT IN (2, 3, 6, 7, 8) AND UG <> -1 AND UP <> -1";
    $where = $wheredate . $wherepart;
    $ensd->setWhere($where);
    $this->doms = $ensd->compte();
    $wherepart = " AND issue NOT IN (3, 6, 7, 8) AND orientation IN (2, 3)";
    $where = $wheredate . $wherepart;
    $ensd->setWhere($where);
    $this->lprot = $ensd->compte();
    $wherepart = " AND issue = 4";
    $where = $wheredate . $wherepart;
    $ensd->setWhere($where);
    $this->deces = $ensd->compte();
    $wherepart = " AND sejobs = -1";
    $where = $wheredate . $wherepart;
    $ensd->setWhere($where);
    $this->sejObs = $ensd->compte();
    $wherepart = " AND sejobs = -1 AND issue = 1";
    $where = $wheredate . $wherepart;
    $ensd->setWhere($where);
    $this->sejObsd = $ensd->compte();

    //Refus
    unset($join, $on);
    $join = "demandeor";
    $on = "choixems.nodoss = demandeor.nodoss";
    $ensr = new ensTableBrioche("choixems", "1", "*", 0, $this->idsession, $join, $on);
    $wheredate = "datedem BETWEEN $debAm AND $finAm";
    $wherepart = " AND refpro = -1";
    $where = $wheredate . $wherepart;
    $ensr->setWhere($where);
    $this->nbRefus = $ensr->compte();
    $wherepart = " AND refpro = -1 AND typesej NOT IN (2, 3, 4)";
    $where = $wheredate . $wherepart;
    $ensr->setWhere($where);
    $this->nbRefusLong = $ensr->compte();
    $wherepart = " AND refpro = -1 AND typesej IN (3, 4)";
    $where = $wheredate . $wherepart;
    $ensr->setWhere($where);
    $this->nbRefusCourt = $ensr->compte();
    $wherepart = " AND refpro = -1 AND typesej = 2";
    $where = $wheredate . $wherepart;
    $ensr->setWhere($where);
    $this->nbRefusObs = $ensr->compte();

  }
  
  /**
  * renvoie un tableau bidimensionnel qui peut servir de substrat  une feuille de calcul
  * @return array
  */
  function getTableau() {
    $tab[0][0] = "<H2>Indicateurs \"2002\"</H2>";
    $tab[1][0] = "Priode du $this->deb au $this->fin";
    $tab[2][0] = "1. Nombre de demandes enregistres par le BRIO :";
    $tab[2][2] = $this->nbDemOr;
    $tab[3][0] = "<I>a) dont demandes de long sjour</I>";
    $tab[3][1] = $this->nbDemOrLong;
    $tab[4][0] = "<I>b) dont demandes de court sjour non urgent</I>";
    $tab[4][1] = $this->nbDemOrCourt;
    $tab[5][0] = "<I>b) dont demandes de court sjour planning</I>";
    $tab[5][1] = $this->nbDemOrCourtP;
    $tab[6][0] = "<I>b) dont demandes de court sjour urgent</I>";
    $tab[6][1] = $this->nbDemOrCourtU;
    $tab[7][0] = "<I>c) dont demandes de sjours d'obs.</I>";
    $tab[7][1] = $this->nbDemOrObs;
    $tab[8][0] = "<I>d) dont demandes de structures intermdiaires</I>";
    $tab[8][1] = $this->nbDemOrInt;
    $tab[9][0] = "<I>e) dont demandes de retour  domicile</I>";
    $tab[9][1] = $this->nbDemOrDom;
    $tab[10][0] = "<I>f) dont demandes de CTR</I>";
    $tab[10][1] = $this->nbDemOrCtr;
    $tab[11][0] = "<I>g) dont sjour non spcifi</I>";
    $tab[11][1] = $this->nbDemOrNS;
    $tab[12][0] = "2. Nombre de lits C annoncs :";
    $tab[12][2] = $this->nbAnn;
    $tab[13][0] = "<I>a) dont lits annoncs pour long sjour</I>";
    $tab[13][1] = $this->nbAnnL;
    $tab[14][0] = "<I>a) dont lits annoncs pour court sjour</I>";
    $tab[14][1] = $this->nbAnnC;
    $tab[15][0] = "<I>a) dont lits annoncs pour sjour polyvalent</I>";
    $tab[15][1] = $this->nbAnnPo;
    $tab[16][0] = "<I>a) dont courts sjours planning</I>";
    $tab[16][1] = $this->nbAnnPl;
    
    
    $tab[17][0] = "3. BRIO impliqu :";
    $tab[17][2] = $this->implBrio;
    $tab[18][0] = "<I>a) Opars et premire ligne</I>";
    $tab[18][1] = $this->opars1;
    $tab[19][0] = "<I>b) Opars et seconde ligne</I>";
    $tab[19][1] = $this->opars2;
    $tab[20][0] = "Opars sans implication du BRIO";
    $tab[20][2] = $this->opars0;
    $tab[21][0] = "4. Nombre de placements raliss dans le rseau :";
    $tab[21][2] = $this->nbLitsAttr;
    $tab[22][0] = "<I>a) dont longs sjours</I>";
    $tab[22][1] = $this->brioLongs;
    $tab[23][0] = "<I>b) dont courts sjours</I>";
    $tab[23][1] = $this->brioCourts;
    $tab[24][0] = "<I>c) dont sjours d'observation</I>";
    $tab[24][1] = $this->brioObs;
    $tab[25][0] = "5. Refus des EMS :";
    $tab[25][2] = $this->nbRefus;
    $tab[26][0] = "<I>a) dont demandes de longs sjours</I>";
    $tab[26][1] = $this->nbRefusLong;
    $tab[27][0] = "<I>b) dont demandes de courts sjours</I>";
    $tab[27][1] = $this->nbRefusCourt;
    $tab[28][0] = "<I>c) dont demandes sj. observation</I>";
    $tab[28][1] = $this->nbRefusObs;
    $tab[29][0] = "6. Autres prises en charge que l'hbergement :";
    $tab[29][2] = $this->nonHeberg;
    $tab[30][0] = "<I>UAT</I>";
    $tab[30][1] = $this->domU;
    $tab[31][0] = "<I>domicile sans UAT</I>";
    $tab[31][1] = $this->doms;
    $tab[32][0] = "<I>logement protg ou adapt</I>";
    $tab[32][1] = $this->lprot;
    $tab[33][0] = "<I>dcs</I>";
    $tab[33][1] = $this->deces;
    $tab[34][0] = "7. Nombre de sjours d'observation :";
    $tab[34][2] = $this->sejObs;
    $tab[35][0] = "<I>dont achevs par retour  dom.</I>";
    $tab[35][1] = $this->sejObsd;

    $tab[36][3] = "Donnes extraites le " . date("d.m.Y") . " par $this->nomplein";
    return $tab;
  }

}
?>
