<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Ensemble de donnes pour l'extraction des statistiques par srevice placeur
* @package donnes
*/
/**
* Ensemble de donnes pour l'extraction des statistiques par service placeur
* Groupe les requtes de base de donnes ncessaires  l'extraction des statistiques par service placeur
* et rend disponibles les indicateurs pour affichage ou pour export dans une feuille de calcul
* @package donnes
* @author ob
*/
class ensStatSP extends connexionBrioche {
  /**
  * le numro de l'tablissement courant
  * @var int
  */
  var $ems;
  
  /**
  * le nom de l'tablissement courant
  * @var int
  */
  var $nomems;
  
  /**
  * le dbut de la priode (date au format "francophone")
  * @var string
  */
  var $deb;
  
  /**
  * la fin de la priode (date au format "francophone")
  * @var string
  */
  var $fin;
  
  /**
  * nombre de demandes faites au BRIO par l'tablissement
  * @var int
  */
  var $nbdem;
  
  /**
  * nombre total de demandes faites au BRIO (pour comparaison)
  * @var int
  */
  var $nbdemBrio;
  
  /**
  * nombre de demandes de long sjour faites par l'tablissement
  * @var int
  */
  var $nbdemLong;
  
  /**
  * nombre total de demandes de long sjour faites au BRIO (pour comparaison)
  * @var int
  */
  var $nbdemLongBrio;
  
  /** 
  * nombre de demandes de sjour d'observation faites par l'tablissement
  * @var int
  */
  var $nbdemObs;
  
  /**
  * nombre total de demandes de sjour d'observation faites au BRIO (pour comparaison)
  * @var int
  */
  var $nbdemObsBrio;
  
  /**
  * nombre de demandes de court sjour faites par l'tablissement
  * @var int
  */
  var $nbdemCour;
  
  /**
  * nombre total de demandes de court sjour faites au BRIO (pour comparaison)
  * @var int
  */
  var $nbdemCourBrio;
  
  /**
  * nombre total de demandes pour une autre prise en charge
  * @var int
  */
  var $nbdemAut;
  
  /** 
  * nombre total de demandes pour une autre prise en charge faites au BRIO (pour comparaison)
  * @var int
  */
  var $nbdemAutBrio;
  
  /**
  * nombre de lits C attribus dans le rseau suite aux demandes de l'tablissement
  * @var int
  */
  var $nbattr;
  
  /**
  * nombre total de lits C attribus dans le rseau par le BRIO (pour comparaison)
  * @var int
  */
  var $nbattrBrio;
  
  /**
  * nombre de lits de long sjour attribus dans le rseau suite aux demandes de l'tablissement
  * @var int
  */
  var $nbattrLong;
  
  /**
  * nombre total de lits de long sjour attribus dans le rsau par le BRIO (pour comparaison)
  * @var int
  */
  var $nbattrLongBrio;
  
  /**
  * nombre de sjours d'observation organiss suite aux demandes de l'tablissement
  * @var int
  */
  var $nbattrObs;
  
  /**
  * nombre total de sjour d'observation organiss par le BRIO (pour comparaison)
  * @var int
  */
  var $nbattrObsBrio;
  
  /**
  * nombre de lits de court sjour attribus dans le rseau suite aux demandes de l'tablissement
  * @var int
  */
  var $nbattrCour;
  
  /**
  * nombre total de lits de court sjour attribus dans le rseau suite aux demandes de l'tablissement
  * @var int
  */
  var $nbattrCourBrio;
  
  /**
  * nombre de placements organiss hors rseau suite aux demandes de l'tablissement
  * @var int
  */
  var $nbattrHors;
  
  /**
  * nombre total de placements hors rseau (pour comparaison)
  * @var int
  */ 
  var $nbattrHorsBrio;
  
  /**
  * nombre de longs sjours organiss hors rseau suite aux demandes de l'tablissement
  * @var int
  */
  var $nbattrLongHors;
  
  /**
  * nombre total de longs sjours hors rseau (pour comparaison)
  * @var int
  */
  var $nbattrLongHorsBrio;
  
  /**
  * nombre de sjours d'observation hors rseau suite aux demandes de l'tablissement
  * @var int
  */
  var $nbattrObsHors;
  
  /**
  * nombre total de sjours d'observation hors rseau (pour comparaison)
  * @var int
  */
  var $nbattrObsHorsBrio;
  
  /**
  * nombre de courts sjours organiss hors rseau suite aux demandes de l'tablissement
  * @var int
  */
  var $nbattrCourHors;
  
  /**
  * nombre total de courts sjours hors rseau (pour comparaison)
  * @var int
  */
  var $nbattrCourHorsBrio;
  
  /**
  * dlai moyen entre la date demande et la date d'issue pour l'tablissement
  * @var float
  */
  var $delai;
  
  /**
  * dlai mdian entre la date demande et la date d'issue pour l'tablissement
  * @var int
  */
  var $percent;
  
  /**
  * premier quartile du dlai entre la date demande et la date d'issue pour l'ensemble du BRIO
  * @var int
  */
  var $percent25Brio;
  
  /**
  * dlai mdian entre la date demande et la date d'issue pour l'ensemble du BRIO
  * @var int
  */
  var $percent50Brio;
  
  /**
  * troisime quartile du dlai entre la date demande et la date d'issue pour l'ensemble du BRIO
  * @var int
  */
  var $percent75Brio;
  
  /**
  * moyenne d'ge des usagers pour l'tablissement
  * @var float
  */
  var $moyenneDage;
  
  /**
  * moyenne d'ge globale (BRIO)
  * @var float
  */
  var $moyenneDageBrio;
  
  /**
  * nombre de demandes faites par l'tablissement pour des femmes
  * @var int
  */
  var $nbFemmes;
  
  /**
  * nombre global de demandes faites pour des femmes
  * @var int
  */
  var $nbFemmesBrio;
  
  /** 
  * nombre de demandes faites par l'tablissement pour des hommes
  * @var int
  */
  var $nbHommes;
  
  /**
  * nombre total de demandes faites pour des hommes
  * @var int
  */
  var $nbHommesBrio;
  
  /**
  * @param string deb cf. variable de classe
  * @param string fin cf. variable de classe
  * @param string sessionid l'identifiant de session
  * @param int ems cf. variable de classe
  * @param array autspec les autorisations spcifiques
  */
  function ensStatSP ($deb, $fin, $sessionid, $ems = "", $autspec = 0){
    $ini = new briocheIni();
    $autspec[0] = $ini->autSpec[1];
    if (! $this->connexionBrioche($sessionid, $autspec)) return;
    if (! $this->verifAut($ini->autReq, $this->autorisations)){
      $et = new ensTableBrioche("etablautorises", "idut = $this->nout", "noet, nomet", 0, $this->idsession,
                                "etablissements", "etablautorises.etabl = etablissements.noet", false, $autspec);
      if (! $et->compte()) {
        $al = new Alerte("Aucun tablissement ne vous a t attribu : veuillez vous adresser au responsable BRIO");
        $al->imprime();  
        return;
      }
      $ett = $et->getTableau();
      $this->ems = $ett[0]->noet;
      $this->nomems = $ett[0]->nomet;
    }
    else {
      $this->ems = $ems;
      $et = new ensTableBrioche("etablissements", "noet = $this->ems", "nomet", 0, $this->idsession);
      $ett = $et->getTableau();
      if (count($ett)) $this->nomems = $ett[0]->nomet;
    }
    $debAm = $this->getDateAm($deb);
    $finAm = $this->getDateAm($fin);
    $this->deb = $deb;
    $this->fin = $fin;
    $join = array();
    $on = array();
    $wherebrio = "datedem BETWEEN $debAm AND $finAm";
    $wheret = ($this->ems == -1 ? "" : " AND servplac = $this->ems");
    $dem = new ensTableBrioche("demandeor", "", "demandeor.nodoss", 0, $this->idsession,
                               $join, $on, false, $autspec);     
    //Demandes
    $dem->setWhere($wherebrio . $wheret);
    $this->nbdem = $dem->compte();
    $dem->setWhere($wherebrio);
    $this->nbdemBrio = $dem->compte();
    $wherespec = " AND typesej = 1";
    $dem->setWhere($wherebrio . $wheret . $wherespec);
    $this->nbdemLong = $dem->compte();
    $dem->setWhere($wherebrio . $wherespec);
    $this->nbdemLongBrio = $dem->compte();
    $wherespec = " AND typesej = 2";
    $dem->setWhere($wherebrio . $wheret . $wherespec);
    $this->nbdemObs = $dem->compte();
    $dem->setWhere($wherebrio . $wherespec);
    $this->nbdemObsBrio = $dem->compte();
    $wherespec = " AND (typesej = 3 OR typesej = 4)";
    $dem->setWhere($wherebrio . $wheret . $wherespec);
    $this->nbdemCour = $dem->compte();
    $dem->setWhere($wherebrio . $wherespec);
    $this->nbdemCourBrio = $dem->compte();
    $wherespec = " AND typesej NOT IN (1, 2, 3, 4)";
    $dem->setWhere($wherebrio . $wheret . $wherespec);
    $this->nbdemAut = $dem->compte();
    $dem->setWhere($wherebrio . $wherespec);
    $this->nbdemAutBrio = $dem->compte();
    //Lits attribus dans le rseau
    //$join = "attributionlit";    
    //$on = "demandeor.nodoss = attributionlit.nodoss";
    $join[] = "attributionlit";    
    $on[] = "demandeor.nodoss = attributionlit.nodoss";
    $join[] = "issue";
    $on[] = "demandeor.nodoss = issue.nodoss";
    $dem->setJoinOn($join, $on);
    $wherespec = " AND attributionlit.nolit IS NOT NULL";
    $dem->setWhere($wherebrio . $wheret . $wherespec);
    $this->nbattr = $dem->compte();
    $dem->setWhere($wherebrio . $wherespec);
    $this->nbattrBrio = $dem->compte();
    $wherespec = " AND attributionlit.nolit IS NOT NULL AND issue.issue IN(3, 8)";
    $dem->setWhere($wherebrio . $wheret . $wherespec);
    $this->nbattrLong = $dem->compte();
    $dem->setWhere($wherebrio . $wherespec);
    $this->nbattrLongBrio = $dem->compte();
    $wherespec = " AND attributionlit.nolit IS NOT NULL AND issue.issue = 6";
    $dem->setWhere($wherebrio . $wheret . $wherespec);
    $this->nbattrObs = $dem->compte();
    $dem->setWhere($wherebrio . $wherespec);
    $this->nbattrObsBrio = $dem->compte();
    $wherespec = " AND attributionlit.nolit IS NOT NULL AND " .
                 "issue.issue IN (2, 11)";
    $dem->setWhere($wherebrio . $wheret . $wherespec);
    $this->nbattrCour = $dem->compte();
    $dem->setWhere($wherebrio . $wherespec);
    $this->nbattrCourBrio = $dem->compte();
    //Lits attribus hors du rseau
    //$join = array();
    //$on = array();
    
    //$dem->setJoinOn($join, $on);
    $wherespec = " AND attributionlit.nolit IS NULL AND issue.issue IN (2, 3, 6, 8, 11)";
    $dem->setWhere($wherebrio . $wheret . $wherespec);
    $this->nbattrHors = $dem->compte();
    $dem->setWhere($wherebrio . $wherespec);
    $this->nbattrHorsBrio = $dem->compte();
    $wherespec = " AND attributionlit.nolit IS NULL AND issue.issue IN (3, 8)";
    $dem->setWhere($wherebrio . $wheret . $wherespec);
    $this->nbattrLongHors = $dem->compte();
    $dem->setWhere($wherebrio . $wherespec);
    $this->nbattrLongHorsBrio = $dem->compte();
    $wherespec = " AND attributionlit.nolit IS NULL AND issue.issue = 6";
    $dem->setWhere($wherebrio . $wheret . $wherespec);
    $this->nbattrObsHors = $dem->compte();
    $dem->setWhere($wherebrio . $wherespec);
    $this->nbattrObsHorsBrio = $dem->compte();
    $wherespec = " AND attributionlit.nolit IS NULL AND issue.issue IN (2, 11)";
    $dem->setWhere($wherebrio . $wheret . $wherespec);
    $this->nbattrCourHors = $dem->compte();
    $dem->setWhere($wherebrio . $wherespec);
    $this->nbattrCourHorsBrio = $dem->compte();
    
    //delai
    $wherespec = " AND dateissue IS NOT NULL";
    $dem->setWhere($wherebrio . $wheret . $wherespec);
    $delaiaboutissement = "TO_DAYS(issue.dateissue) - " .
                          "IF(demandeor.litdepuis, TO_DAYS(demandeor.litdepuis)," .
                          "TO_DAYS(demandeor.datedem))";
    $this->delai = $dem->moyenne($delaiaboutissement);
    $this->percent = $dem->percentile($delaiaboutissement, 50);
    $dem->setWhere($wherebrio . $wherespec);
    $this->percent25Brio = $dem->percentile($delaiaboutissement, 25);
    $this->percent50Brio = $dem->percentile($delaiaboutissement, 50);
    $this->percent75Brio = $dem->percentile($delaiaboutissement, 75);
    
    //usagers
    $join[] = "dossiers";
    $on[] = "demandeor.nodoss = dossiers.nodoss";
    $join[] = "usagers";
    $on[] = "dossiers.nous = usagers.nous";
    $dem = new ensTableBrioche("demandeor", "1", "usagers.datenaiss, usagers.sexe",
                               "0", $this->idsession, $join, $on, false, $autspec);
    $dem->setWhere($wherebrio . $wheret);
    $age = "YEAR(demandeor.datedem) - YEAR(usagers.datenaiss)";
    $this->moyenneDage = $dem->moyenne($age);
    $dem->setWhere($wherebrio);
    $this->moyenneDageBrio = $dem->moyenne($age);
    $wherespec = " AND usagers.sexe = \"F\"";
    $dem->setWhere($wherebrio . $wheret . $wherespec);                           
    $this->nbFemmes = $dem->compte();
    $dem->setWhere($wherebrio . $wherespec);
    $this->nbFemmesBrio = $dem->compte();
    $wherespec = " AND usagers.sexe = \"M\"";
    $dem->setWhere($wherebrio . $wheret . $wherespec);
    $this->nbHommes = $dem->compte();
    $dem->setWhere($wherebrio . $wherespec);
    $this->nbHommesBrio = $dem->compte();                            
    
  }

  /**
  * renvoie un tableau bidimensionnel qui peut servir de substrat  une feuille de calcul
  * @return array
  */
  function getTableau() {
    $tab[0][0] = "<H2>Etablissement : $this->nomems</H2>";
    $tab[1][0] = "Priode du $this->deb au $this->fin";
    $tab[2][0] = "Nombre de demandes faites au BRIO";
    $tab[2][2] = $this->nbdem;
    $tab[3][0] = "<I>dont demandes de long sjour</I>";
    $tab[3][1] = $this->nbdemLong;
    $tab[4][0] = "<I>dont demandes de sjour d'observation</I>";
    $tab[4][1] = $this->nbdemObs;
    $tab[5][0] = "<I>dont demandes de court sjour</I>";
    $tab[5][1] = $this->nbdemObs;
    $tab[6][0] = "Nombre de lits C attribus au sein du rseau";
    $tab[6][2] =  $this->nbattr;
    $tab[7][0] = "<I>dont longs sjours</I>";
    $tab[7][1] = $this->nbattrLong;
    $tab[8][0] = "<I>dont sjours d'observation</I>";
    $tab[8][1] = $this->nbattrObs;
    $tab[9][0] = "<I>dont courts sjours</I>";
    $tab[9][1] = $this->nbattrCour;
    $tab[10][0] = "Nombre de lits C attribus hors du rseau";
    $tab[10][2] =  $this->nbattrHors;
    $tab[11][0] = "<I>dont longs sjours</I>";
    $tab[11][1] = $this->nbattrLongHors;
    $tab[12][0] = "<I>dont sjours d'observation</I>";
    $tab[12][1] = $this->nbattrObsHors;
    $tab[13][0] = "<I>dont courts sjours</I>";
    $tab[13][1] = $this->nbattrCourHors;
    $tab[14][0] = "Dlai moyen d'aboutissement des demandes (jours)";
    $tab[14][2] = $this->delai;
    $tab[15][0] = "Dans la moiti des cas, dlai infrieur  (jours)";
    $tab[15][2] = $this->percent;
    $tab[16][0] = "Moyenne d'ge des usagers (ans)";
    $tab[16][2] = $this->moyenneDage;
    $tab[17][0] = "Rapport femmes/hommes";
    $tab[17][2] = ($this->nbHommes ? round($this->nbFemmes / $this->nbHommes, 2) : "infini");

    $tab[18][3] = "Donnes extraites le " . date("d.m.Y") . " par $this->nomplein";
    return $tab;
  }

  





}
?>
