<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Ensemble permettant d'accder  une table ou  une jointure en compactant certains groupes d'enregistrements
* @package donnes
*/
/**
* Ensemble permettant d'accder  une table ou  une jointure en compactant certains groupes d'enregistrements
* Cet objet fournit en gros les mmes fonctions que ensTableBrioche dont il hrite, mais il permet en plus de
* compacter en une ligne de tableau plusieurs enregistrements ayant des valeurs communes pour la plupart de leurs
* champs, en listant les valeurs des champs qui n'ont pas la mme valeur.
* @package donnes
* @author ob tnh cjd
*/

class ensTableCompact extends ensTableBrioche{
  /**
  * le nom du champ "cl" : les enregistrements dont la cl ont la mme valeur sont compacts en un seul
  * ce champ doit apparatre en premier dans la clause ORDER
  * @var string
  */
  var $cle;
  
  /**
  * le sparateur (texte)  ajouter entre les diverses valeurs qui sont compactes dans une seule ligne de tableau
  * par exemple ", ", ou "&lt;BR&gt;"
  * @var string
  */
  var $separateur;
  
  /**
  * le nombre de lignes renvoyes (en tenant compte des compactages : plusieurs enregistrements compacts comptent
  * pour une seule ligne
  * @var int
  */
  var $compte;
  
  /**
  * le tableau des valeurs de $cle correspondant aux enregistrements de l'ensemble
  * @var array
  */
  var $curseur;
  
  /**
  * la valeur de la clause limit propre au tableau compact (se basant sur les lignes du curseur et non sur le rsultat brut
  * de la requte)
  * @var int
  */
  var $limitcurseur;
  
  /**
  * la valeur de l'offset de la clause limit propre au tableau compact
  * @var int
  */
  var $offsetcurseur = 0;
  
  /**
  * tableau des champs  ne pas compacter (par exemple parce qu'on les utilisera comme titre de 
  * groupe dans un TPanelTableau ces champs doivent apparatre avant les champs susceptibles d'tre compacts
  * dans l'ordre des champs de la clause "CHAMPS"
  * @var array
  */
  var $no_compact;
  
  /**
  * @param string table le nom de la table principale
  * @param string where la clause where
  * @param string champs les champs slectionns (spars par une virgule)
  * @param string order les champs de la clause order (spars par une virgule). Le premier des champs
  * doit correspondre au champ "cle"
  * @param string sessionid l'identifiant de session
  * @param mixed join la clause join (string nom de table ou array de plusieurs noms de table)
  * @param mixed on la clause on (string quivalence de la clause ON ou array de plusieurs quivalences)
  * @param boolean distinct s'agit-il d'une requte SELECT DISTINCT ?
  * @param string cle cf. variable de classe
  * @param string separateur cf. variable de classe
  * @param array autspec le tableau des autorisations spcifiques
  * @param array no_compact cf. variable de classe
  */
  function ensTableCompact($table, $where="1", $champs="*", $order=0, $sessionid,
                           $join=0, $on=0, $distinct=false, $cle, $separateur, $autspec=0, $no_compact = array()){
    if (! $this->ensTableBrioche($table, $where, $champs, $order, $sessionid,
                                 $join, $on, $distinct, $autspec)) return;
    $this->cle = $cle;
    $this->separateur = $separateur;
    $this->compte = "RIEN";
    $this->no_compact = $no_compact;  
  }

  /**
  * renvoie un tableau compact (1 ligne par valeur du champ "cle")
  * comparable  ceux renvoys par ensTableBrioche : un objet par ligne.
  * @return array
  */
  function getTableau(){
    $requete = $this->getSql();
    // print $requete . "<BR><BR>";
    return $this->executeReq($requete);
  }

  /**
  * excution de la requte et constitution du tableau pour le passer  getTableau()
  * @param string req le champ sql de la requte
  * @return array le tableau d'objets correspondant
  */
  function executeReq($req){
    $tab = array();
    $result = mysql_query($req);
    $cle = $this->cle;
    $doublons = array();
    if ($result){
      $nf = mysql_num_fields($result);
      $j = 0;
      while ($ligne = mysql_fetch_array($result)){
        //Conversion des champs date
        for ($i = 0; $i < $nf; $i++){
          $flds = mysql_fetch_field($result, $i);
          $fn = $flds->name;
          if ($flds->type == "date"){
            $ligne[$fn] = $this->getDateFr($ligne[$fn]);
          }
          $ligne[$fn] = $this->metEnFormeSel($ligne[$fn]);
        }
        if (! $j){ // Premire ligne
          $tab[] = $ligne;
          for ($i = 0; $i < $nf; $i++){
              $flds = mysql_fetch_field($result, $i);
              $fn = $flds->name;
              $doublons[1][$fn][] = $ligne[$fn];
          }
          $j++;
        }
        else {
          if ($ligne[$cle] == $tab[$j-1][$cle]){ // 2 x le mme item => compactage
            for ($i = 0; $i < $nf; $i++){
              $flds = mysql_fetch_field($result, $i);
              $fn = $flds->name;
              
              if (!isset($doublons[$j]) || !isset($doublons[$j][$fn])) $doublons[$j][$fn] = array();
              
              if ($ligne[$fn] != $tab[$j-1][$fn] && !in_array($ligne[$fn], $doublons[$j][$fn])){
              	if (!in_array($fn , $this->no_compact)) {
                  $doublons[$j][$fn][] = $ligne[$fn];
                  $tab[$j-1][$fn] .= $this->separateur . $ligne[$fn];
              	} else {
                  $tab[] = $ligne;
                  $j++;
                }
              }	
            }	
          }	
          else {
            $tab[] = $ligne;
            $j++;
            for ($i = 0; $i < $nf; $i++){
              $flds = mysql_fetch_field($result, $i);
              $fn = $flds->name;
              $doublons[$j][$fn][] = $ligne[$fn];
            }
          }	
        }
      }
    }

    // transformation d'un array en un objet
    $cpt = count($tab);
    $tabobj = array();
    $this->compte = $cpt;
    for ($i = 0; $i < $cpt; $i++){
      $ligne = $tab[$i];

      // cration d'un nom unique pour ne pas avoir le mme objet tout le long (php 5)
      $nom_obj = "obj" . $i;
      while (list($cl, $val) = each ($ligne)) {
        ${$nom_obj}->$cl = $val;
      }
      // ici on ne stocke que l'adresse de l'objet
      $tabobj[] = ${$nom_obj};
    }
    
    return $tabobj;
  }
  
  /**
  * renvoie le nombre d'lments du tableau compact
  * ( excuter de prfrence aprs getTableau())
  * @return int
  */
  function compte(){
    if ($this->compte == "RIEN"){
      $tab = $this->getTableau();	
    }
    return $this->compte;
  }	
  
  /**
  * Gnre un curseur, c'est--dire le tableau des enregistrements concerns
  * Le curseur est stock dans $this->curseur et est utilis par les mthode setLimite() et setOffset()
  * dabs les cas o l'affichage d'un grand tableau ncessite une pagination
  */
  function setCurseur(){
    $stockechamps = $this->champs;
    $cle = $this->cle;
    $this->champs = $this->table . "." . $cle;
    //print "aaa $this->cle -- " . $this->getSql() . "bbb";
    $tab = $this->executeReq($this->getSql());
    $cpt = count($tab);
    //rsultion bug -> enlve erreur lorsque la "recherche par critres" retourne un tableau vide 
    $curseur = array();
    for ($i = 0; $i < $cpt; $i++){
      $curseur[] = $tab[$i]->$cle;
    }
    $this->curseur = $curseur;
    $this->champs = $stockechamps;
  }
  
  /**
  * renvoie le nombre d'enregistrements total (sans limit), en tenant compte du compactage
  * n'est utile que si la mthode setLimit() a t utilise prcdemment
  * @return int
  */
  function compteTotal(){
    if (! $this->curseur) $this->setCurseur();
    return count($this->curseur);
  }
  
  /**
  * mule la clause SQL limit, mais l'applique au curseur, et donc tient compte des compactages.
  * @param int limit la limite
  */
  function setLimit($limit){
    if (! $this->curseur) $this->setCurseur();
    $this->limitcurseur = $limit;
    $this->regleCurseur();
  }
  
  /**
  * mule la partie OFFSET de la clause SQL LIMIT, mais l'applique au curseur
  * @param int offset
  */
  function setOffset($offset){
    if (! $this->curseur) $this->setCurseur();
    $this->offsetcurseur = $offset;
    $this->regleCurseur();
  }
  
  /**
  * redfinit la clause WHERE de la requte en fonction des valeurs de LIMIT et d'OFFSET
  */
  function regleCurseur(){
    $tabl = array();
    $limitesup = $this->offsetcurseur + $this->limitcurseur;
    $total = $this->compteTotal();
    if ($limitesup >= $total) $limitesup = $total;
    for ($i = $this->offsetcurseur; $i < $limitesup; $i++){
      $tabl[] = $this->curseur[$i];
    } 
    $chaine = join(",", $tabl);
    $chaine = $this->table . "." . $this->cle . " IN($chaine)";
    $this->setWhere($chaine);
  }
  
  /**
  * renvoie un tableau bidimensionnel utilisable pour les feuilles de calcul
  * @param boolean masqueTech faut-il masquer les champs techniques (dont le nom commence par "_")
  * @return array
  */
  function getTableauBidim($masqueTech = false){
    $this->separateur = ", ";
    $requete = $this->getSql();
    $tab = array();
    $result = mysql_query($requete);
    if ($result){
      $nf = mysql_num_fields($result);
      $masque = array();
      for ($i = 0; $i < $nf; $i++){
        $fldd = mysql_fetch_field($result, $i);
        if ((! $masqueTech) || (! (substr($fldd->name, 0, 1) == "_"))) {
        //Les champs "techniques" dont le nom commence par _ peuvent tre masqus
          $types[] = $fldd->type;
          $noms[] = "<B>$fldd->name</B>";
        }
        else {
          $masque[] = $i; //On rcolte l'index des champs masqus
        }
        //$types[] = $fldd->type;
        //$noms[] = "<B>$fldd->name</B>";
        if ($fldd->name == $this->cle){
         $cle = $i;
       }	
      }
      $tab[] = $noms;
      $j = 1;
      while ($ligne = mysql_fetch_row($result)){
        //Ablation des champs techniques
        $cptc = count($masque);
        for ($k = $cptc-1 ; $k >= 0; $k --){
          $ligne1 = array_slice($ligne, 0, $masque[$k]);
          $ligne2 = array_slice($ligne, $masque[$k] + 1);
          $ligne = array_merge($ligne1, $ligne2);
        }
        //Conversion des champs date
        for ($i = 0; $i < $nf; $i++){
          if ($types[$i] == "date"){
            $ligne[$i] = $this->getDateFr($ligne[$i]);
          }
          $ligne[$i] = $this->metEnFormeSel($ligne[$i]);
        }
        if ($j == 1) { //Premire ligne (aprs noms de champs)
          $tab[] = $ligne;
          $j++;
        }
        else {
          if ($ligne[$cle] == $tab[$j-1][$cle]){ // 2 x le mme item => compactage
            for ($i = 0; $i < $nf; $i++){
              if ($ligne[$i] != $tab[$j-1][$i]){
              	if (!in_array($i,$this->no_compact)) {
                  $tab[$j-1][$i] .= $this->separateur . $ligne[$i];
              	} else {
                  $tab[] = $ligne;
                  $j++;
                }
              }	
            }	
          }	
          else {
            $tab[] = $ligne;
            $j++;
          }	
        }
      }
    }
    return $tab;
  }

  /**
  * contrle qu'un champ est utilis, pour dcider s'il faut ou non l'afficher dans un tableau
  * @param string champ le nom du champ
  * @return boolean le champ est-il utilis ?
  */
  function controleChamp($champ){
    $nouvwhere = $this->where . " AND $champ IS NOT NULL";
    $tt = new ensTableCompact($this->table, $nouvwhere, $this->champs, $this->order, 
                              $this->idsession, $this->join, $this->on, false,
                              $this->cle, $this->separateur);
    $ss = $tt->getTableau();
    if(count($ss)){
      return true;
    }
    else {
      return false;
    }  	  
    
  }	
}

?>
