<?php
  // $Id: etablissementBrioche.inc,v 1.1.1.1 2010-10-11 22:25:43 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Fiche d'tablissement du dossier Brioche
* @package formulaires
*/
/**
* Fiche d'tablissement du dossier Brioche
* Permet d'accder, en lecture seule ou en criture,  tous les champs de la table etablissements
* @package formulaires
* @author ob thn cjd jdu
*/
class etablissementBrioche extends cadronglet {
   /**
   * l'objet ensTableBrioche correspondant  l'enregistrement courant de la table etablissements
   * @var object ensTableBrioche
   */   
   var $rs;
   
   /**
   * le numro de l'tablissement courant
   * @var int
   */
   var $item;
   
   /**
   * un objet contenant les options passes
   * @var object optionsBrioche
   */
   var $options;
   
   /**
   * un objet contenant les options  passer
   * @var object optionsBrioche
   */
   var $futuroptions;
   
  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param string actif l'action principale du formulaire
  * @param string fondpage la couleur de fond de la page
  * @param string sessionid l'identifiant de session
  * @param int item cf. variable de classe
  * @param string options la chaine de caractres correspondant aux options passes
  * @param array recup le tableau de variables post par le formulaire
  */ 
  function etablissementBrioche($largeur, $grise, $actif, $fondpage, $sessionid, $item = 0,
                                $options = 0, $recup=0){
    global $fdosbrioche;
    global $imagesdir;
    if ( !$this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid)) return; //appel du constsructeur de l'objet parent (avec vrif)
    
    $this->options = new optionsBrioche($options);
    $this->futuroptions = new optionsBrioche($options);
    $this->item = $item;
    $nav = new ensTableBrioche("etablissements", 1, "noet", "noet", $this->idsession); // liste des numros d'usager, pour navigation
    $navalph = new ensTableBrioche("etablissements", 1, "noet, nomet, actif", "actif, groupepriorite, nomet",  $this->idsession);
    $premier = $nav->getSuivant(0, "noet");
    if ($this->item == 0) $this->item = $premier;
    if ($this->item == 0){
      $al = new Alerte("Aucun tablissement rpertori. Utilisez \"Nouveau\" pour en crer");
      $al->imprime();
    }
    if ($this->item == -999){
      $this->item = $nav->creeNouveau("noet");
    }
        
    //Vrification de l'item demand
    if ($this->item && ! $nav->checkItem($this->item, "noet")){
      $al = new Alerte("Etablissement N $this->item inexistant !");
      $al->imprime();
      $this->item = $nav->getSuivant(0, "noet");
    }
    $aujourdhui = $nav->aujourdhui();
    $suivant = $nav->getSuivant($this->item, "noet");
    $precedent = $nav->getPrecedent($this->item, "noet");
    $dernier = $nav->getPrecedent(0, "noet");
    //cet tablissement
    $etablissements = false;    
    $ndoss = false;
    if ($this->item){
      $this->rs = new ensTableBrioche("etablissements", "noet = $this->item", "*", 0, $this->idsession);
      $rec = $this->rs->getTableau($recup);
      // la variable $recup provoque, si elle n'est pas = 0, la rcupration des valeurs passes par le form. en shuntant la base de donnes
      if (isset($rec[0])){
           $etablissements = $rec[0];
      }
      //Les dossiers prinscrits dans cet etablissements
      $doss = new ensTableBrioche("choixems", "choixems.noems = $this->item and dossiers.dateclo is null", "*", 0,
                                  $this->idsession, "dossiers", "choixems.nodoss = dossiers.nodoss");
      $ndoss = $doss->compte();
      $dossiers = $doss->getTableau();
      if (isset($dossiers[0])){
        $premierdoss = $dossiers[0];
        $premierdoss = $premierdoss->nodoss;
      }
    } 
    
    // Vrification des droits
    // L'utilisateur a-t-il le droit d'diter les tablissements
    $ini = new briocheIni();
    $edition_autorisee = $this->verifAut($ini->autSpec[4], $this->autorisations);
    
    // flag pour indiquer si on doit rendre ditable les champs du formulaire
    $non_editable = false;
    // si on n'a pas le droit d'dition, ou si le mode "ditable" n'est pas demand, les champs sont dsactivs
    if ($this->options->getOption("EDITABLE") == 0 || !$edition_autorisee) {
      // si on n'est pas en train d'diter un nouvel tablissement et si on n'a pas le droit d'dition
      // les champs sont dsactivs
      $non_editable = true;
    }
    
    // Dessin des onglets
    $tabbande = array("", "", "", "N " . $this->item, "");
    $this->addOnglet("Etablissement", $tabbande, "#8b8378", 3001, 60,
                     "javascript:lienCond('$fdosbrioche?action=3001&sessionid=$this->idsession&item=$this->item&options=" .
                     $this->options->getChaine() . "')");
    $this->colmateOnglets();
    //Navigation
    if ($this->options->getOption("NOUV_ET") == 0 && $non_editable){  //On n'est pas limit  un seul tablissement
      $of = new OngForm();
      $of->setTabParam($this->largeur, $this->coulbande, 6);
      $of->setFormParam("navigation", $fdosbrioche, "post");
      $c = new TPanel(3, 1, "LEFT", "MIDDLE", "50%");
      $x = new ListOptTableEtabl("itemalpha", $this->item, $navalph, false, 0, "d2",
                            "lienCond('$fdosbrioche?action=$this->actif&sessionid=$this->idsession&item=' + " .
                            "document.forms.navigation.itemalpha.value + '&options=" . $this->options->getChaine() . "')");
      $x->addOptionsEtablissements("nomet", "noet");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(3,1,"RIGHT", "MIDDLE");
      $x = new Label("Navigation :&nbsp;");
      $c-> addChamp($x);
      $x = new BoutonImage("Premier", "$imagesdir/premier.gif", 16, 16,
                           "javascript:lienCond('$fdosbrioche?action=$this->actif&sessionid=$this->idsession&item=$premier&options=" .
                           $this->options->getChaine() . "')");
      $c->addChamp($x);
      $x = new BoutonImage("Prcdent", "$imagesdir/precedent.gif", 16, 16,
                           "javascript:lienCond('$fdosbrioche?action=$this->actif&sessionid=$this->idsession&item=$precedent&options=" .
                           $this->options->getChaine() . "')");
      $c->addChamp($x);
      $x = new ChampTexte("item", "$this->item", "", 5, 6, false, "text", "d2");
      $c->addChamp($x);
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      //$this->futuroptions->setOption("FORCE_DOSS", 1);
      $x = new Bouton("options", $this->futuroptions->getChaine(), "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("action", $this->actif, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("etablissements[idsulid]", $etablissements->idsulid, "HIDDEN");
      $c->addChamp($x);
      $x = new BoutonImage("OK", "$imagesdir/vu.gif", 18, 16, "javascript:envoieCondNav()");
      $c->addChamp($x);
      //$this->futuroptions->setOption("FORCE_DOSS", 0);
      $x = new BoutonImage("Suivant", "$imagesdir/suivant.gif", 16, 16,
                           "javascript:lienCond('$fdosbrioche?action=$this->actif&sessionid=$this->idsession&item=$suivant&options=" .
                           $this->futuroptions->getChaine() . "')");
      $c->addChamp($x);
      $x = new BoutonImage("Dernier", "$imagesdir/dernier.gif", 16, 16,
                           "javascript:lienCond('$fdosbrioche?action=$this->actif&sessionid=$this->idsession&item=$dernier&options=" .
                           $this->futuroptions->getChaine() . "')");
      $c->addChamp($x);
      $of->addChamp($c);
      $this->addContenu($of->getContenu());
    }

   
    //ajout du contenu spcifique
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fdosbrioche, "post");
    $of->addLigne(0.5);
    $c = new TPanel(5);
    $x = new ChampTexte("etablissements[nomet]", $etablissements->nomet, "Nom :&nbsp;", 50, 50, false, "text", "d2", "", "", $non_editable);
    $c->addChamp($x);
    $of->addChamp($c);
    $c = new TPanel(1, 1, "RIGHT");
    $x = new Aide("C18");
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    $c = new TPanel(6);
    $acb = new AutoCheckBox();
    $this->futuroptions = new optionsBrioche($this->options->getChaine());
    $this->futuroptions->setOption("PASSE", 1);
    
    // Nouveau champ "actif"
    
    $x = new AutoCase("etablissements[actif]",(isset($etablissements->actif) ? $etablissements->actif : -1),"Actif",true,"",$non_editable);
    $acb->addCase($x);
    $c->addChamp($x);
    
    $onchange = "document.forms.donnees.options.value='" . $this->futuroptions->getChaine() .
                "';document.forms.donnees.submit();";
    $x = new AutoCase("etablissements[litsc]", (isset($etablissements->litsc) ? $etablissements->litsc : ""), 
                      "Fournisseur de lits C", false, $onchange, $non_editable);
    $acb->addCase($x);
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $x = new Autocase("etablissements[litsd]", (isset($etablissements->litsd) ? $etablissements->litsd : ""), "Fournisseur de lits D", false,
                      $onchange, $non_editable);
    $acb->addCase($x);
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne();
    $c = new TPanel(6);
    $x = new Autocase("etablissements[servplac]", (isset($etablissements->servplac) ? $etablissements->servplac : ""), "Service placeur",
                      false, "", $non_editable);
    $acb->addCase($x);
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $x = new Autocase("etablissements[autbrio]", (isset($etablissements->autbrio) ? $etablissements->autbrio : ""), "Autre BRIO", false,
                      $onchange, $non_editable);
    $acb->addCase($x);
    $c->addChamp($x);
    $c->addChamp($acb);
    $of->addChamp($c);
    if ( ((isset($etablissements->litsc) && $etablissements->litsc) || (isset($etablissements->litsd) && $etablissements->litsd == -1)) 
        && (!isset($etablissements->autbrio) || isset($etablissements->autbrio) && ! $etablissements->autbrio) ){
      $of->addLigne(0.5);
      $of->addLigne();
      $c = new TPanel(3);
      $x = new Autocase("etablissements[ger]", (isset($etablissements->ger) ? $etablissements->ger : ""),
                        "Griatrie", false, "", $non_editable);
      $acb->addCase($x);
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new Autocase("etablissements[psychoger]", (isset($etablissements->psychoger) ? $etablissements->psychoger : ""),
                        "Psychogriatrie", false, "", $non_editable);
      $acb->addCase($x);
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new Autocase("etablissements[psy]", (isset($etablissements->psy) ? $etablissements->psy : ""),
                        "Psychiatrie", false, "", $non_editable);
      $acb->addCase($x);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(3, 1, "", "", "40%");
      $x = new ChampTexte("etablissements[nblitsc]", (isset($etablissements->nblitsc) ? $etablissements->nblitsc : ""),
                          "Nb. lits C :&nbsp;", 4, 4, false, "text", "d2", "", "", $non_editable);
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $x = new Autocase("etablissements[courts]", (isset($etablissements->courts) ? $etablissements->courts : ""), "Courts sjours",
                        false, "", $non_editable);
      $acb->addCase($x);
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new Autocase("etablissements[csu]", (isset($etablissements->csu) ? $etablissements->csu : ""),
                        "... urgents", false, "", $non_editable);
      $acb->addCase($x);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(3);
      $x = new ChampTexte("etablissements[nblitsd]", (isset($etablissements->nblitsd) ? $etablissements->nblitsd : ""), "Nb. lits D :&nbsp;",
                          4, 4, false, "text", "d2", "", "", $non_editable);
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $of->addChamp($c);
      $c = new TPanel(3);
      $x = new ChampTexte("etablissements[nbpluat]", (isset($etablissements->nbpluat) ? $etablissements->nbpluat : ""),
                          "Nb. places UAT :&nbsp;", 4, 4, false, "text", "d2", "", "", $non_editable);
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(6);
      $x = new Autocase("etablissements[courplan]", (isset($etablissements->courplan) ? $etablissements->courplan : ""),
                        "Courts sjours &nbsp;planning&nbsp;", false, "", $non_editable);
      $acb->addCase($x);
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      
      $c = new TPanel(6);
      $x = new ChampTexte("etablissements[emails_pdf]", (isset($etablissements->emails_pdf) ? $etablissements->emails_pdf : ""),
                          "Adresse(s) e-mail pour l'envoi du planning (veuillez sparer les emails par un ';') :<br/> ", 50, 200, false, "text", "d2", "", "", $non_editable);
      $c->addChamp($x);
      $of->addChamp($c);
    }
    $of->addLigne();
    $of->addLigne();
    
    $c = new TPanel(4);
    $x = new TextArea("etablissements[notes]",$etablissements->notes, 
                        "Notes",100,3,"virtual",$non_editable);
    $c->addChamp($x);    
    $of->addChamp($c);
    $of->addLigne();
    $of->addLigne();
    
    if (((isset($etablissements->litsc) && $etablissements->litsc) || (isset($etablissements->litsd) && $etablissements->litsd))) {
    	$c = new TPanel(2);
    	$x = new ChampTexte("etablissements[idsulid]",$etablissements->idsulid, 
    	                    "ID sulid",5,5,false,"INT","d2","","",$non_editable);
    	$c->addChamp($x);    
    	$of->addChamp($c);
    	$of->addLigne();
    }
    
    $c = new TPanel(2);
    $x = new ChampTexte("etablissements[groupepriorite]",$etablissements->groupepriorite, 
                        "Groupe de priorits",5,5,false,"INT","d2","","",$non_editable);
    $c->addChamp($x);
    $of->addChamp($c);
    
    $enr = new enrEtablBrioche($this->item, $this->idsession);
    
    if ($ini->interbrio && ($etablissements->autbrio || $enr->isMonBrio())) {
      $c = new TPanel(4);
      $x = new Label("Adresse interBrio :", true);
      $c->addChamp($x);
      $c->addChamp(new Espace(2));
      $tadr = new ensTableBrioche("adressesinterbrio", "1", 
                                  "adresse, CONCAT(adresse, \" (\", libelle, \")\") as descr",
                                  "adresse", $this->idsession);
                                  
      $x = new ListOptTable("etablissements[adresseib]",
                            (isset($etablissements->adresseib) ? $etablissements->adresseib : ""),
                            $tadr, false, 0, "d2", "", $non_editable || $enr->isMonBrio());
      $x->addDefaut("---", "");
      $x->addOptions("descr", "adresse");                                                  
      $c->addChamp($x);
      $of->addChamp($c);
      
    }
    $of->addLigne();
    $of->addLigne();
    
    $c = new TPanel(6);
    $x = new GrBoutonRadio("etablissements[type_hopital]", (isset($etablissements->type_hopital) ? $etablissements->type_hopital : ""),
                           "", "donnees", $non_editable);
    $x->addRadio("Hpital A", "A");
    $x->addRadio("Hpital B", "B");
    $x->addRadio("CMS", "Z");
    $c->addChamp($x);
    $acb->addCase($x);
    $of->addChamp($c);
    $of->addLigne();

    $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "","Groupes d'tablissements (df. IUMSP) :" );
    $tabgroupe = new ensTableBrioche("groupesetab", 1, "*", "nomgroupe", $this->idsession);
    $x = new ListOptTable("etablissements[groupet]", (isset($etablissements->groupet) ? $etablissements->groupet : ""),
                          $tabgroupe, false, 0, "d2", "", $non_editable);
    $x->addDefaut("---", "");
    $x->addOptions("nomgroupe", "nogroupe");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne();
    $of->addLigne();


    if ($this->options->getOption("NOUV_ET") == 0) {
      // s'il ne s'agit pas d'un nouvel tablissement  enregistrer
      $c = new TPanel(5);
      $x = new Label("Nombre de prinscriptions pour cet tablissement&nbsp;:&nbsp;<B>" . $ndoss . "</B>");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $this->futuroptions = new optionsBrioche($this->options->getChaine());
      $this->futuroptions->setOption("MODE", 5);
      if ($ndoss && ! $this->options->getOption("EDITABLE")) {
        $x = new Bouton("Afficher", "Afficher", "button", 
        "afficheCondDoss(\"$fdosbrioche?action=1&sessionid=$this->idsession&item=0&noetabl=$this->item&options=" . 
        $this->futuroptions->getChaine() . "\", false)");
        $c->addChamp($x);
      }
      $c->addChamp(new Espace(3));
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne();
    }

    $c = new TPanel(6, 1, "RIGHT");
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    
    $x = new Bouton("item", $this->item, "HIDDEN");
    $c->addChamp($x);

    $x = new Bouton("options", $this->options->getChaine(), "HIDDEN");
    $c->addChamp($x);
    
    if ($edition_autorisee) { // Affichage du bouton diter/sauver
      $bouton_label = "";
      $this->futuroptions = new optionsBrioche($this->options->getchaine());
      if ($this->options->getOption("EDITABLE") == 0) {
        $this->futuroptions->setOption("EDITABLE", 1);
        $bouton_label = "Modifier cet tablissement";
        $futureaction = $this->actif;
      } 
      else {
        $this->futuroptions->setOption("EDITABLE", 0);
        $bouton_label = "Sauver";
        $futureaction = $this->actif + 100;
      }
      $x = new Bouton("Envoyer", $bouton_label,
                      "BUTTON", "document.donnees.options.value = \"" . $this->futuroptions->getchaine() . "\";document.donnees.submit();",
                      "bok");
      $c->addChamp($x);
    }
    
    
    $x = new Bouton("action", $futureaction, "HIDDEN");
    $c->addChamp($x);
    $c->addChamp(new Espace(2));    
    $c->addChamp($acb);

    // Nouveau
    if ($this->options->getOption("NOUV_ET") == 0 && $edition_autorisee && $this->options->getOption("EDITABLE") == 0) {
      $this->futuroptions = new optionsBrioche($this->options->getChaine());
      $this->futuroptions->setOption("NOUV_ET", 1);
      $this->futuroptions->setOption("EDITABLE", 1);
      $x = new Bouton("Nouveau", "Crer un nouvel tablissement", "BUTTON",
                      "lienCond(\"$fdosbrioche?action=$this->actif&sessionid=$this->idsession&item=-999&options=" .
                      $this->futuroptions->getChaine() . "\")");
      $c->addChamp($x);
      $c->addChamp(new Espace(2));
    }

    // Fermer
    $x = new Bouton("Fermer", "Fermer", "BUTTON", "if(!qModif())window.close()");
    $c->addChamp($x);
    $c->addChamp(new Espace(2));

    $of->addChamp($c);
    $of->addLigne(0.5);
    $this->addContenu($of->getContenu());
  }
  
  /**
  * renvoie la mission d'un tablissement (fonction statique non lie  l'tablissement courant)
  * @param int noet le numro de l'tablissement
  * @param string idsession un identifiant de session
  * @return int
  * <pre>
  * psychogriatrie : 1
  * griatrie : 2
  * psychiatrie : 3
  * lit D : 4
  * autre : 5
  * </pre>
  */
  function mission($noet, $idsession){
    $et = new ensTableBrioche("etablissements", "noet = $noet", "ger, psychoger, psy, litsd", 0, $idsession);
    $tet = $et->getTableau();
    $etabl = $tet[0];
    if ($etabl->psychoger){
      return 1;
    }
    if ($etabl->ger) {
      return 2;
    }
    if ($etabl->psy) {
      return 3;
    }
    if ($etabl->litsd) {
      return 4;
    }
    return 5;
  }

  /**
  * renvoie le nombre de lits dans une chambre donne (fonction statique non lie  l'tablissement courant)
  * utile uniquemen pour le planning
  * @param int noet le numro de l'tablissement
  * @param int noch le numro de la chambre
  * @param string idsession l'identifiant de session
  * @return int
  */
  function nbLits($noet, $noch, $idsession){
    $et = new ensTableBrioche("litscourtsejour", "etabl = $noet AND chambre = $noch", "*", 0, $idsession);
    $nb = $et->compte();
    return $nb; 
  }
}


?>
