<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Formulaire d'extraction de fichiers de donnes brutes anonymises pour l'IUMSP
* @package formulaires
*/
/**
* Formulaire d'extraction de fichiers de donnes brutes anonymises pour l'IUMSP
* Ce formulaire n'est plus ncessaire depuis que les donnes sont extraites automatiquement
* et que les routines R d'analyses s'excutent directement sur le serveur.
* @package formulaires
* @author ob
*/
class extIUMSP extends cadronglet{
  /**
  * action secondaire (pour les actions d'extraction : l'action principale ($this->actif) provoque le retour au menu)
  * @var int
  */
  var $action2;
  
  /**
  * objet contenant les options passes
  * @var object optionsBrioche
  */
  var $options;
  
  /**
  * @param string largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param int actif l'action principale du formulaire (utilise pour revenir au menu)
  * @param string fondpage la couleur de fond de la page
  * @param string sessionid l'identifiant de session
  * @param array donnees les donnes postes
  * @param int action2 cf. variable de classe
  * @param string options la chane de caractres correspondant aux options passes
  */
  function extIUMSP($largeur, $grise, $actif, $fondpage, $sessionid, $donnees, $action2, $options){
    global $fichier;
    $this->action2 = $action2;
    $this->options = $options;
    if (! isset($donnees)){
      $donnees['fin'] = "";
      $donnees['deb'] = "";
      $donnees['mdp'] = "";
    }
    $ini = new briocheIni();
    
    if ($this->options < 2){
      if (! $this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid)) return;
      $tabbande = array("Donnes IUMSP", "", "", "", "");
      $this->addOnglet("Extraction", $tabbande, "#8b8378", $this->actif, 80, "");
      $this->colmateOnglets();
      if (! $donnees['deb']) $donnees['deb'] = $this->premierMoisPasse();
      if (! $donnees['fin']) $donnees['fin'] = $this->dernierMoisPasse();
    }
    else{
      if (! $this->connexionBrioche($sessionid)) return;
    }	
    if ($this->options == 0 && strlen($donnees['mdp']) > 7){
      $this->options = 1;
    }  	
    //Extraction des donnes
    if ($this->options == 1){
      $ium = new ensDataIUMSP($donnees['deb'], $donnees['fin'], $donnees['mdp'],
                              $this->idsession);	
    }	   
    if ($this->options >= 2){//Fichiers csv
      if ($this->options == 2){
        $tp = new tableProv("IUM", $this->idsession);
        $contenu = $tp->getCSV("iddemand");
        header('Content-disposition: attachment; filename=demandes.txt');
        header('Content-type: text/plain');
        print $contenu;
      }	
      if ($this->options == 3){
        $tp = new tableProv("IUMR", $this->idsession);
        $contenu = $tp->getCSV("iddemand");
        header('Content-disposition: attachment; filename=refus.txt');
        header('Content-type: text/plain');
        print $contenu;
      }	
    }  
    else {
      //Contenu
      $of = new OngForm();
      $of->setTabParam($this->largeur, $this->coulbande, 6);
      $of->setFormParam("donnees", $fichier, "post");
      $c = new Tpanel(6);
      $x = new Label("$this->nomplein");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      $c = new TPanel(5, 1);
      $x = new ChampTexte("donnees[deb]", $donnees['deb'], "Priode du : ", 12, 12, false, "TEXT",  "d2",
                          "controleDate('donnees[deb]', '', '')", "", $this->options, true);
      $c->addChamp($x);
      $c->addChamp(new Espace(4));
      $x = new ChampTexte("donnees[fin]", $donnees['fin'], "au : ", 12, 12, false, "TEXT",  "d2",
                          "controleDate('donnees[fin]', '', '')", "", $this->options, true);
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new Bouton("Retour", "Retour", "SUBMIT");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 2, "RIGHT");
      $x = new Aide("C0000");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne(0.5);
      $c = new TPanel(5, 1);
      $x = new ChampTexte("donnees[mdp]", $donnees['mdp'], "Mot de passe :", 30, 30, false,
                          "TEXT", "d2", "", "", $this->options);
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne(0.5);
      $c = new TPanel(6, 1);
      if ($this->options == 0){
        $x = new Label("<FONT COLOR=\"red\">Choisissez une chane d'au moins 8 caractres " .
                       "pour garantir l'anonymat des donnes transmises. Celle-ci ne doit EN " .
                       "AUCUN CAS tre communique avec les donnes.</FONT>", false, true);
      
      }
      else {
        $x = new Label("<FONT COLOR=\"orange\">Ce mot de passe permet d'tablir le lien entre les numros de dossier " .
                       " et d'usager de Brioche et les codes anonymes transmis  l'IUMSP. En n'en gardant ".
                       "aucune trace, vous garantissez l'anonymat des donnes.</FONT>");	 
      }  
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne(0.5);
      if ($this->options == 0){
        $c = new TPanel(1, 1);
        $x = new Bouton("Continuer", "Continuer", "BUTTON",
                        "document.forms.donnees.action.value=$this->action2;document.forms.donnees.submit()");
        $c->addChamp($x);
        $of->addChamp($c);
        $c = new TPanel(5, 1);
        $x = new Label("Attention ! Selon la longueur de la priode choisie, l'extraction des donnes peut durer " .
                       " plus de 30 secondes... Si vous ne parvenez pas  extraire des donnes pour une longue priode, " .
                       "veuillez prendre contact avec <A HREF=\"mailto:$ini->adresseAdministrateur\">l'administrateur</A>.");
        $c->addChamp($x);               
      }
      elseif ($this->options == 1) {
        $c = new TPanel(6, 1);
        $x = new Label("L'extraction est termine. Nombre de demandes traites : " .
                       " $ium->cpt. Nombre d'erreurs rencontres : $ium->nberreurs", false, true);
        $c->addChamp($x);
        $of->addChamp($c);
        $of->addLigne();
        $of->addLigne(0.5); 
        $c = new TPanel(6, 1);
        $x = new Label("Tlchargez le <A HREF=\"$fichier?action=$this->action2&sessionid=$this->idsession" .
                       "&options=2\">fichier principal</A> (demandes)", true);
        $c->addChamp($x);
        $of->addChamp($c);
        $of->addLigne();
        $c = new TPanel(6, 1);
        $x = new Label("Tlchargez le <A HREF=\"$fichier?action=$this->action2&sessionid=$this->idsession" .
                       "&options=3\">fichier accessoire</A> (refus)", true);
        $c->addChamp($x);               
        $of->addChamp($c);
        $of->addLigne();
        $c = new TPanel(6, 1);
        $x = new Label("Tlchargez le journal de l'extraction. <B>Attention ! ce fichier doit " . 
                       "tre conserv en lieu sr et ne doit en aucun cas tre transmis " .
                       " l'IUMSP&nbsp;!", true);
                       
        $c->addChamp($x);
        
        
      }
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("action", $this->actif, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("options", $this->options, "HIDDEN");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      $this->addContenu($of->getContenu());
    }
  }
  

}
?>
