<?php
////////////////////////////////
//
// Permet d'appliquer  FPDF des corrections
// propres  l'imprimante et  l'OS
//
////////////////////////////////

class FPDFCorr extends FPDF {
  var $bordx;
  var $bordy;
  var $fact;
  var $police;
  var $pere;
  var $delta;
  var $pente;
  
  function __construct($bordx = 0, $bordy = 0, $fact = 1, $police = 0, $delta, $pente){
    parent::__construct();
    $this->bordx = $bordx;
    $this->bordy = $bordy;
    $this->fact = $fact;
    $this->police = $police;
    $this->delta = $delta;
    $this->pente = $pente;
  }

  
  function carre($x, $y){
    $this->SetXY($x, $y);
    $this->SetFont('Arial', 'B', 16);
    $this->Cell(1, 1, '');
  }
  
  function aI($val){
    return $val * $this->fact;
  }

  function aX($val){
    return $this->aI($val - $this->bordx);
  }

  function aY($val){
    return $this->aI($val - $this->bordy);
  }

  function Rect($x, $y, $w, $h, $style = ''){
    //print "x : $x / " . $this->aX($x) . " - y $y / " . $this->aY($y) . " - h $h / " . $this->Ai($h) . " <BR>";
    parent::Rect($this->aX($x), $this->aY($y), $this->aI($w), $this->aI($h), $style);
  }

  function SetX($x){
    parent::SetX($this->delta + ($this->aX($x)) * $this->pente);
  }

  function SetY($y, $reset=true){
    parent::SetY($this->delta + ($this->aY($y) * $this->pente), $reset);
  }

  function SetXY($x, $y){
    parent::SetXY($this->delta + ($this->aX($x) * $this->pente), $this->delta + ($this->aY($y) * $this->pente));
  }

  function Cell($w, $h = 0, $txt = '', $border = 0, $ln = 0, $align = '',
                $fill = 0, $link = ''){
    parent::Cell($this->aI($w), $this->aI($h), $txt, $border, $ln, $align, $fill, $link);
  }

  function MultiCell($w, $h, $txt = '', $border = 0, $align = '', $fill = 0){
    parent::Cell($this->aI($w), $this->aI($h), $txt, $border, $align, $fill);
  }
  
  function Line($x1, $y1, $x2, $y2){
    parent::Line($this->aX($x1), $this->aY($y1), $this->aX($x2), $this->aY($y2));
  }

  function SetMargins($left, $top, $right = -1){
    parent::SetMargins($this->aX($left), $this->aY($top), $this->aX($right));
  }
}



?>
