<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Impression d'une demande d'orientation au format pdf
* @package accessoires
*/
/**
* Impression d'une demande d'orientation au format pdf
* Utilise la bibliothqe fpdf
* @package accessoires
* @author cjd jdu ob
*/
class impressionPDF extends enrBrioche {
  /**
  * le contenu pdf du fichier
  * @var string
  */ 
  var $pdf;
  
  /**
  * la taille par dfaut des caractres
  * @var int
  */
  var $text_size;
  
  /**
  * la police par dfaut
  * @var string
  */
  var $text_font;
  
  /**
  * la hauteur de la ligne
  * @var float
  */
  var $row_size;
  
  /**
  * la hauteur de la ligne
  * @var float
  */
  var $small_row_size;
  
  /**
  * la taille des titres
  * @var int
  */
  var $title_size;
  
  /**
  * hauteur des cellules "titre"
  * @var int
  */
  var $title_height;
  
  /**
  * la police pour les options slectionnes
  * @var string
  */
  var $select_font;
  
  /**
  * la couleur des options slectionnes
  * @var array
  */
  var $select_color;
  
  /**
  * le style des options slectionnes
  * @var string
  */
  var $select_style;
  
  /**
  * la taille des options slectionnnes
  * @var int
  */
  var $select_size;
  
  /**
  * le nom du brio
  * @var string
  */ 
  var $nom;
  
  /**
  * les paramtres de configuration
  * @var object briocheIni
  */
  var $ini;
  
  /**
  * l'enregistrement correspondant  la demande  imprimer
  * @var object
  */
  var $demandeor;
  
  /**
  * l'enregistrement correspondant au dmst  imprimer
  * @var object
  */
  var $dmst;
  
  /**
  * l'enregistrement correspondant  la grille  imprimer
  * @var object
  */
  var $grille; 
  
  /**
  * l'enregistrement correspondant aux intervenants  imprimer
  * @var object
  */
  var $intervenants;
  
  /**
  * l'enregistrement correspondant aux mdicaments  imprimer
  * @var object
  */
  var $medics; 
   
  /**
  * le type de document  imprimer (demande ou grille)
  * @var object
  */
  var $type; 
  
  /**
  * @param int item le numro de dossier
  * @param string sessionid l'identifiant de session
  */ 
  function impressionPDF($item, $sessionid, $type){
      
    $this->type = $type;
    switch ($this->type) {
      case 'demande':
        if (! $this->enrBrioche($item, $sessionid)) return false;
        $this->ini = new briocheIni();  
        $this->text_size = 9;
        $this->row_size = 4.5;
        $this->small_row_size = 3.6;
        $this->text_font = 'Arial';
        $this->title_size = 12;
        $this->title_height = 6;
        $this->select_font = 'Arial';
        $this->select_color = array(0,0,0);
        $this->select_style = 'BIU';
        $this->select_size = $this->text_size + 1;
        $this->nom = $this->ini->nomBrio;
        $this->demandeor = $this->getEnr("demandeor");
      break;
      case 'dmst':
        if (! $this->enrBrioche($item, $sessionid)) return false;
        $this->ini = new briocheIni();  
        $this->text_size = 9;
        $this->row_size = 4.5;
        $this->small_row_size = 3.6;
        $this->text_font = 'Arial';
        $this->title_size = 12;
        $this->title_height = 6;
        $this->select_font = 'Arial';
        $this->select_color = array(0,0,0);
        $this->select_style = 'BIU';
        $this->select_size = $this->text_size + 1;
        $this->nom = $this->ini->nomBrio;
        $dmst = new ensTableBrioche("dmst","iddmst = $item","*",0,$sessionid);
        $dmst = $dmst->getTableau();
        $this->dmst = $dmst[0];
        $grille = new ensTableBrioche("grille","nodoss = ".$this->dmst->nodoss,"*",0,$sessionid);
        $grille = $grille->getTableau();
        $this->grille = $grille[0];
        $intervs = new ensTableBrioche("dmstinterv","iddmst = $item","*",0,$sessionid);
        $this->intervenants = $intervs->getTableau();
        $medics = new ensTableBrioche("dmstmedics","iddmst = $item","*",0,$sessionid);
        $this->medics = $medics->getTableau();
        break;
      default: return false;
    }
  }  
  
  
  /**
  * gnration du pdf
  * les champs sont ajouts  la proprit pdf
  */
  function generatePDF(){
    $encoding = ini_get("mbstring.internal_encoding");
    if ($encoding != "ISO-8859-1") ini_set("mbstring.internal_encoding", "ISO-8859-1");
    
    switch ($this->type) {
      case 'demande':
        $this->pdf = new FPDF();
        $this->pdf->AddPage();
        $this->pdf->SetFont($this->text_font,'B',$this->title_size);
        $this->pdf->Cell(0,$this->title_height,$this->nom . " - Demande d'orientation",0,1);
        $this->pdf->SetFont($this->text_font,'',$this->text_size);
        $this->pdf->SetFillColor(255,255,255);
        $this->pdf_champ_usager();
        $this->pdf->Cell(0,3,'',0,1);
        $this->pdf_champ_ouvpar_suivpar();
        $this->pdf_champ_signet();   
        $this->pdf->Cell(0,1,'',0,1);
        $this->pdf_champ_demande_inter_brio();   
        $this->pdf_champ_service_placeur();            
        $this->pdf_champ_referent();
        $this->pdf_champ_prise_en_charge_desiree();
        $this->pdf_champ_nature_prise_en_charge();
        $this->pdf_champ_debut_prise_en_charge();
        $this->pdf_champ_provenance_usager();
        $this->pdf_champ_prov_anterieure_usager();
        $this->pdf_champ_situation_sociale();
        $this->pdf_champ_recoit_aide();
        $this->pdf_champ_recoit_service_maintien_domicile();
        $this->pdf_champ_assurances_sociales();
        $this->pdf_champ_problemes_particuliers();
        $this->pdf_champ_personne_de_reference_entourage();
        $nl = $this->pdf_champ_souhaits_usager_entourage();
        $this->pdf_champ_indications_complementaires($nl);
        $this->pdf->Cell(0,1,'',0,1);
        $this->pdf_champ_envoi_DMST();
        if ($this->ini->dmttrans) $this->pdf_champ_envoi_DMT();
        if ($this->ini->supplement_ch_indiv) $this->pdf_champ_supplement_chambre_individuelle();
        $this->pdf->Cell(0,6,'',0,1);
        $this->pdf_champ_date_demande();
        $this->pdf_champ_demandeur();
        $this->pdf->Output();
      break;
      case 'dmst':
        $this->pdf = new FPDF();
        $this->pdf->AddPage();
        $this->pdf->SetFont($this->text_font,'B',$this->title_size);
        $this->pdf->Cell(140,$this->title_height,"CANTON DE VAUD",0,1,"C");
        $this->pdf->Cell(140,$this->title_height,"DOCUMENT MEDICO-SOCIAL DE TRANSMISSION",0,1,"C");
        $this->pdf->SetFillColor(255,255,255);
        $this->pdf->SetFont($this->text_font,'',$this->text_size);
        $this->pdf->Cell(140,$this->row_size,"",0,1);
        $this->pdf_entete_dmst();
        $this->pdf_donnees_admin();
        $this->pdf_famille();
        $this->pdf_habitat();
        $this->pdf->AddPage();
        $this->pdf_tete_dmst(2);
        $this->pdf_contexte();
        $this->pdf_intervenants();
        $this->pdf_autonomie();
        $this->pdf->AddPage();
        $this->pdf_tete_dmst(3);
        $this->pdf_bilan();
        $this->pdf_prise_en_charge();
        $this->pdf_pied_dmst();
        $this->pdf->Output();
      break;
      default: return false;
    }
    ini_set("mbstring.internal_encoding", $encoding);
  }
  
  /**
  * champ cadre gnrique comprenant un label et une valeur
  * @param string name le nom du champ
  * @param string value la valeur
  * @param int name_length la longueur de l'tiquette nom
  * @param int value_length la longuer de la valeur
  * @param string name_align l'alignement de l'tiquette nom ('L' | 'C' | 'R')
  * @param string value_align l'alignement de la valeur 
  */ 
  function pdf_champ_cadre($name,$value,$name_length=50,$value_length=50,$name_align='',$value_align='') {
    
    $this->pdf->Cell($name_length,$this->row_size,$name. " : ",0,0,$name_align);
    $this->pdf->Cell($value_length,$this->row_size,$value,1,0,$value_align,1);
  }
  
  /** 
  * champ cadre gnrique pour un groupe de boutons radio
  * @param string nom le nom du champ
  * @param string valeur la valeur du champ
  * @param object ensTableBrioche table la table contenant les options  afficher
  * @param string champtexte le champ de la table contenant libells  afficher pour chaque option
  * @param string champvaleur le champ de la table contenant les valeurs correspondant aux options
  * @param int nbcolonnes le nombre de colonnes par ligne
  * @param mix largcolonne la largeur de toute les colonnes ou un tableau contenant les largeurs
  * de chaque colonne
  */
  function pdf_groupe_radio($nom, $valeur, &$table, $champtexte, $champvaleur, $nbcolonnes,
                            $largcolonne){
    $tableau = $table->getTableau();
    $nbradio = count($tableau);
    $nblignes = ceil($nbradio/$nbcolonnes);
    $this->pdf->Cell(0,$this->row_size, $nom,0,1);
    $this->pdf->Cell(0,1,'','LTR',1); // La partie sup du cadre
    $k = 0;
    for ($i = 0; $i < $nblignes; $i++){  
      $this->pdf->Cell(3,$this->row_size,'','L'); // Segment de la partie gauche du cadre     
      for ($j = 0; $j < $nbcolonnes; $j++){
        $checked = false;
        if ($tableau[$k]->$champvaleur == $valeur) $checked = true;
        $this->pdf_champ_radio($tableau[$k]->$champtexte, $checked,
                               is_array($largcolonne) ? $largcolonne[$k] : $largcolonne);
        $k++;
      }
      $this->pdf->Cell(0,$this->row_size,'','R',1); // Segment de la partie droite du cadre
    }  
    $this->pdf->Cell(0,1,'','LBR',1); // La partie inf du cadre
  }
  
  /**
  * bouton radio gnrique
  * @param string name le libell  afficher
  * @param boolean checked l'option est-elle slectionnes
  * @param string name_length la longuer du libell
  * @param string name_align l'alignement du libell
  */
  function pdf_champ_radio($name,$checked,$name_length=50,$name_align='') {
    $ini = &$this->ini;
    $actual_textcolor = $this->pdf->TextColor;
    if ($checked) {
      $img = "$ini->classDir/fpdf/img/radio_true.jpg";
      $this->pdf->SetTextColor($this->select_color[0],$this->select_color[1],$this->select_color[2]);
      $this->pdf->SetFont($this->select_font,$this->select_style,$this->select_size);
    }
    else $img = "$ini->classDir/fpdf/img/radio_false.jpg";
    $this->pdf->Image($img,$this->pdf->GetX()+1,$this->pdf->GetY()+0.5,3);
    $this->pdf->Cell(5,$this->row_size);
    $this->pdf->Cell($name_length,$this->row_size,$name,0,0,$name_align);
    $this->pdf->TextColor = $actual_textcolor;
    $this->pdf->SetFont($this->text_font,'',$this->text_size);
  }
  
  /**
  * case  cocher gnrique
  * @param string name le libell de la case
  * @param boolean checked la case est-elle coche
  * @param int name_length la longueur du libell
  * @param string name_aligne l'alignement du libell
  */  
  function pdf_champ_checkbox($name,$checked,$name_length=50,$name_align='',$decX=1,$decY=1) {
    $ini = &$this->ini;
    $actual_textcolor = $this->pdf->TextColor;
    if ($checked) {
      $img = "$ini->classDir/fpdf/img/checkbox_true.jpg";
      $this->pdf->SetTextColor($this->select_color[0],$this->select_color[1],$this->select_color[2]);
      $this->pdf->SetFont($this->select_font,$this->select_style,$this->select_size);
    }
    else $img = "$ini->classDir/fpdf/img/checkbox_false.jpg";
    $this->pdf->Image($img,$this->pdf->GetX()+$decX,$this->pdf->GetY()+$decY,3);
    $this->pdf->Cell(5,$this->row_size);
    $this->pdf->Cell($name_length,$this->row_size,$name,0,0,$name_align);
    $this->pdf->TextColor = $actual_textcolor;
    $this->pdf->SetFont($this->text_font,'',$this->text_size);
  }
  
  /**
  * cadre dossier ouvert par
  */ 
  function pdf_champ_ouvpar_suivpar() {
    $dossier = $this->getEnr("dossiers");
    $this->pdf->Cell(100,$this->row_size,'Dossier ouvert par : ' . $dossier->ouvpar);
    $this->pdf->Cell(100,$this->row_size,'suivi par : ' . $dossier->suivpar,0,1);
  }
  
  /**
  * cadre signet
  */ 
  function pdf_champ_signet() {
    $signets = $this->getSignets();
    $signet_str = '';
    $this->pdf->Cell(0,1,'','LTR',1);
    $this->pdf->Cell(3,$this->row_size,'','L');
    $this->pdf->Cell(20,$this->row_size,'Signet : ');
    $actual_textcolor = $this->pdf->TextColor;
    $actual_fontstyle = $this->pdf->FontStyle;
    $actual_fontsize = $this->pdf->FontSizePt;
    $this->pdf->SetTextColor(0,0,255);
    $this->pdf->SetFont($this->pdf->FontFamily,'I',10);
    if ($signets != ''){
      foreach ($signets as $signet) {
        $signet_str .= $signet . " - ";
      }
    }
    $this->pdf->Cell(0,$this->row_size,$signet_str);
    $this->pdf->Cell(0,$this->row_size,'','R',1);
    $this->pdf->Cell(0,1,'','LBR',1);
    $this->pdf->TextColor = $actual_textcolor;
    $this->pdf->SetFont($this->pdf->FontFamily,$actual_fontstyle,$actual_fontsize);
  }
  
  /**
  * cadre service placeur
  */
  function pdf_champ_service_placeur() {
    $etabl = new enrEtablBrioche($this->demandeor->servplac, $this->idsession);
    $this->pdf->Cell(0,1,'',0,1);
    $this->pdf_champ_cadre('Service placeur',
                           $etabl->getNom(), 40, 50);
    $this->pdf->Cell(10,$this->row_size);
    $this->pdf_champ_cadre('Prcision', $this->demandeor->medecinautre, 30 ,50);
    $this->pdf->ln();
  }
  
  /**
  * cadre rfrent
  */
  function pdf_champ_referent() {
    $this->pdf->Cell(0,1,'',0,1);
    $this->pdf_champ_cadre('Professionnel rfrent', $this->raguillePDF($this->demandeor->referent), 40, 50);
    $this->pdf->Cell(10,$this->row_size);
    $this->pdf_champ_cadre('Tl.', $this->raguillePDF($this->demandeor->telref) ,30 , 50);
    $this->pdf->ln();
  }
  
  /**
  * cadre prise en charge dsire
  */
  function pdf_champ_prise_en_charge_desiree() {
    $etpec = new ensTableBrioche("typesejour", "ordre > 0",
                                 "idts, ttypesej", "ordre", $this->idsession);
    $this->pdf_groupe_radio("Prise en charge dsire : ",
                             $this->demandeor->typesej,
                             $etpec, "ttypesej", "idts", 4, 42);  
  }
  
  /**
  * cadre nature de la prise en charge
  */
  function pdf_champ_nature_prise_en_charge() {
    $etpath = new ensTableBrioche("typepath", "ordre > 0", "*", "ordre", $this->idsession);
    $this->pdf_groupe_radio("Nature de la prise en charche (si placement ou UAT) : ",
                            $this->demandeor->typepath,
                            $etpath, "ttypepath", "idtp", 4, 30);  
    
    $this->pdf->setY($this->pdf->getY() - $this->row_size - ($this->row_size/5));
    $this->pdf->setX(140);
    $this->pdf->Cell(50, $this->row_size, $this->demandeor->autre, 1, 0, '', 1);
    $this->pdf->setY($this->pdf->getY() + ($this->row_size/5));
    $this->pdf->ln();
  }

  /**
  * cadre dbut dsir pour la prise en charge
  */
  function pdf_champ_debut_prise_en_charge() {
    $actual_fontstyle = $this->pdf->FontStyle;
    $actual_fontsize = $this->pdf->FontSizePt;
    $etdeb = new ensTableBrioche("typedebutpec", "ordre > 0", "*", "ordre", $this->idsession);
    $this->pdf_groupe_radio("Dbut souhait pour la prise en charge : ",
                            $this->demandeor->debutpec,
                            $etdeb, "ttypedebutpec", "iddp", 2, 80);
    
    $this->pdf->Cell(0,1,'','LR',1);
    $this->pdf->Cell(3,$this->row_size,'','L');
    $this->pdf_champ_cadre('Depuis le',$this->demandeor->litdepuis,20);
    $this->pdf->SetFont($this->pdf->FontFamily,'I',8);
    $this->pdf->Cell(0,$this->row_size,'Pour l\'tude IUMSP, il est recommand de cocher aussi ' .
                     'l\'une des options ci-dessus');
    $this->pdf->SetFont($this->pdf->FontFamily,$actual_fontstyle,$actual_fontsize);
    $this->pdf->Cell(0,$this->row_size,'','R',1);
    $this->pdf->Cell(1,1,'','L');
    $this->pdf->Cell(0,1,'','R',1);
    $this->pdf->Cell(3,$this->row_size,'','L');
    $this->pdf->SetFont($this->text_font,'',$this->text_size);
    $this->pdf_champ_cadre('Jusqu\'au',$this->demandeor->litjusqua,20);
    $this->pdf->SetFont($this->pdf->FontFamily,'I',8);
    $this->pdf->Cell(0,$this->row_size,'Pour les courts sjours');
    $this->pdf->SetFont($this->pdf->FontFamily,$actual_fontstyle,$actual_fontsize);
    $this->pdf->Cell(0,$this->row_size,'','R',1);
    $this->pdf->Cell(0,1,'','LBR',1);
  
  }
  
  /**
  * cadre donnes de l'usager
  */ 
  function pdf_champ_usager() {
    $usager = $this->getEnr("usagers");
    $nom = $usager->nom . ", " . $usager->prenom;
    $sexe = $usager->sexe; 
    $naissance = $usager->datenaiss; 
    $adresse = $usager->adresse . " - " . $usager->npa . " " . $usager->loc;
    $actual_fontstyle = $this->pdf->FontStyle;
    $actual_fontsize = $this->pdf->FontSizePt;
    $this->pdf->SetFont($this->pdf->FontFamily,'B',$this->title_size);    
    $this->pdf->Cell(0,1,'','LTR',1,'',1);
    $this->pdf->Cell(3,$this->title_height,'','L',0,'',1);
    $this->pdf->Cell(120,$this->title_height,'Nom : ' . $this->raguillePDF($nom),'',0,'',1);
    $this->pdf->Cell(0,$this->title_height,'Sexe : ' . $sexe,'',0,'',1);
    $this->pdf->Cell(0,$this->title_height,'','R',1,'',1);
    $this->pdf->Cell(3,$this->title_height,'','L',0,'',1);
    $this->pdf->Cell(0,$this->title_height,'Date de naissance : ' . $naissance,'',0,'',1);
    $this->pdf->Cell(0,$this->title_height,'','R',1,'',1);
    $this->pdf->Cell(3,$this->title_height,'','L',0,'',1);
    $this->pdf->Cell(120,$this->title_height,'Adresse : ' . $this->raguillePDF($adresse),'',0,'',1);
    $this->pdf->Cell(0,$this->title_height,'Dossier n ' . $this->item,'',0,'',1);
    $this->pdf->Cell(0,$this->title_height,'','R',1,'',1);
    $this->pdf->Cell(0,1,'','LBR',1,'',1);
    $this->pdf->SetFont($this->pdf->FontFamily,$actual_fontstyle,$actual_fontsize);
  }
  
  /**
  * cadre provenance usager
  */
  function pdf_champ_provenance_usager() {
    $etprov =  new ensTableBrioche("provenance", "ordre > 0", "*", "ordre", $this->idsession);
    $this->pdf->SetFont($this->text_font,'',$this->text_size);
    $this->pdf_groupe_radio("Provenance (situation de l'usager au moment de la demande) :",
                            $this->demandeor->provenance,
                            $etprov, "provenance_text", "idprovenance", 3, 60);    
  }

  /**
  * cadre provenance antrieure
  */
  function pdf_champ_prov_anterieure_usager() {
    $etprov =  new ensTableBrioche("provenance", "ordre > 0", "*", "ordre", $this->idsession);
    $this->pdf_groupe_radio("Provenance antrieure (situation de l'usager avant la demande, si diffrente) : ",
                            $this->demandeor->prov_anterieure,
                            $etprov, "provenance_text", "idprovenance", 3, 60);   
  }
  
  /**
  * cadre situation sociale
  */
  function pdf_champ_situation_sociale() {
    $colonnes = array(25, 25, 40, 60, 30);
    $etsit = new ensTableBrioche("typesitsociale", "ordre > 0", "*", "ordre", $this->idsession);
    $this->pdf_groupe_radio("Situation sociale : ", $this->demandeor->sitsoc,
                            $etsit, "ttypesitsociale", "idss", 5, $colonnes);
  }
  
  /**
  * cadre reoit aide
  */
  function pdf_champ_recoit_aide() {
    $this->pdf->Cell(0,$this->row_size,'Reoit dj l\'aide : ',0,1);
    $this->pdf->Cell(0,1,'','LTR',1);
    $this->pdf->Cell(3,$this->row_size,'','L');
    $this->pdf_champ_checkbox('De proches',$this->demandeor->aidepr,30);
    $this->pdf_champ_checkbox('D\'une UAT',$this->demandeor->uat,30);
    $this->pdf->Cell(0,$this->row_size,'','R',1);
    $this->pdf->Cell(0,1,'','LBR',1); 
  }
  
  /** 
  * cadre aide d'un service de maintien  domicile
  */
  function pdf_champ_recoit_service_maintien_domicile() {
    $etaid = new ensTableBrioche("typeaidedom", "ordre > 0", "*", "ordre", $this->idsession);
    $this->pdf_groupe_radio("Reoit dj l'aide d'un service de maintien  domicile : ",
                            $this->demandeor->cms, $etaid, "ttypeaidedom", "idad", 3, 40);

    $sicms = new ensTableBrioche("etablissements", "noet = " . $this->demandeor->aidecms, "nomet", 0, $this->idsession);   
    $sicms = $sicms->getPremier("nomet");
	$this->pdf->setY($this->pdf->getY() - $this->row_size - ($this->row_size/5));
    $this->pdf->setX(130);
    $this->pdf->Cell(20, $this->row_size, "lequel", 0, 0, '', 1);
    $this->pdf->Cell(40, $this->row_size, $sicms, 1, 0, '', 1);
    $this->pdf->setY($this->pdf->getY() + ($this->row_size/5));
    $this->pdf->ln();
  }
    
  /**
  * cadre assurances sociales
  */
  function pdf_champ_assurances_sociales() {
    
    $champ_checked = $this->demandeor->asssoc;
    $checked_array = array("AVS"=>false,"AI"=>false,"Aucune"=>false);
    if ($champ_checked != "") $checked_array[$champ_checked] = true;
          
    $this->pdf->Cell(0,$this->row_size,'Assurances sociales : ',0,1);
    $this->pdf->Cell(0,1,'','LTR',1);
    $this->pdf->Cell(3,$this->row_size,'','L');
    $this->pdf_champ_radio("AVS",$checked_array["AVS"],10,'');
    $this->pdf_champ_radio("AI",$checked_array["AI"],10,'');
    $this->pdf_champ_radio("Aucune",$checked_array["Aucune"],20,'');
    $this->pdf_champ_checkbox("PC",$this->demandeor->pc,10);
    $this->pdf_champ_checkbox("API",$this->demandeor->api,10);
    $this->pdf->Cell(0,$this->row_size,'','R',1);
    $this->pdf->Cell(0,1,'','LBR',1);
    $this->pdf->ln();
  }
  
  /**
  * cadre problmes particuliers
  */
  function pdf_champ_problemes_particuliers() {
    $this->pdf->Cell(0,$this->row_size,'Problmes particuliers : ',0,1);
    $this->pdf->Cell(0,1,'','LTR',1);
    $this->pdf->Cell(3,$this->row_size,'','L');
    $this->pdf_champ_checkbox('Anxit, inscurit',$this->demandeor->anx,35);
    $this->pdf_champ_checkbox('Tr. comportement, fugues',$this->demandeor->trcomp,50);
    $this->pdf_champ_checkbox('Chutes',$this->demandeor->chutes,15); 
    $this->pdf_champ_checkbox('Rs. mult. antibiotiques',$this->demandeor->resmult,40); 
    $this->pdf_champ_checkbox('Solitude',$this->demandeor->solitude,20); 
    $this->pdf->Cell(0,$this->row_size,'','R',1);
    $this->pdf->Cell(3,$this->row_size,'','L');
    $this->pdf_champ_checkbox('Dpendances',$this->demandeor->dependance,35); 
    $this->pdf_champ_checkbox('Perfusion',$this->demandeor->perfusion,35); 
    $this->pdf_champ_checkbox('Dom. inadquat',$this->demandeor->dominadequat,30); 
    $this->pdf_champ_checkbox('Absence entourage',$this->demandeor->absenceent,30);       
    $this->pdf->Cell(0,$this->row_size,'','R',1);
    $this->pdf->Cell(3,$this->row_size,'','L');
    $this->pdf_champ_checkbox('Epuisement entour.',$this->demandeor->epuisementent,35); 
    $this->pdf_champ_checkbox('Probl. respiratoire',$this->demandeor->respiratoire,35);
    $this->pdf_champ_checkbox('Refuse CMS',$this->demandeor->refuscms,30);
    $this->pdf_champ_checkbox('Problme de mobilit',$this->demandeor->mobilite,40);   
    $this->pdf->Cell(0,$this->row_size,'','R',1);
    $this->pdf->Cell(3,$this->row_size,'','L');   
    $this->pdf_champ_cadre('Autre',$this->demandeor->autreprobl,20);
    $this->pdf->Cell(0,$this->row_size,'','R',1);
    $this->pdf->Cell(0,1,'','LBR',1); 
  }
  
  /**
  * cadre personne de rfrence dans l'entourage
  */
  function pdf_champ_personne_de_reference_entourage() {
    $this->pdf->Cell(0,1,'',0,1);
    $this->pdf_champ_cadre('Pers. de rfrence entourage',
                           $this->raguillePDF($this->demandeor->refent), 50, 70);
    $this->pdf_champ_cadre('Tl.', $this->raguillePDF($this->demandeor->telrefent), 20, 50, 'R');
    $this->pdf->ln();
  }
  
  /**
  * cadre souhait de l'usager/entourage
  */
  function pdf_champ_souhaits_usager_entourage() {
    $this->pdf->Cell(0, $this->row_size, 'Souhaits de l\'usager et/ou son entourage : ', 0,1);
    $nl = $this->pdf->MultiCell(90, $this->row_size, $this->raguillePDF($this->demandeor->souhaits), 1, '', 1);
    $this->pdf->SetY($this->pdf->GetY()-($this->row_size*($nl+1)));
    return $nl;
  }
  
  /**
  * cadre indications complmentaires
  */
  function pdf_champ_indications_complementaires($nl) {
    $decalage = 100;
    $this->pdf->SetX($this->pdf->GetX()+$decalage);
    $this->pdf->Cell(0,$this->row_size,'Indications complmentaires : ',0,1);
    $this->pdf->SetX($this->pdf->GetX()+$decalage);
    $tnl = $this->pdf->MultiCell(90, $this->row_size,
                                 $this->raguillePDF($this->demandeor->compl), 1, '', 1);
    if ($nl > $tnl) $this->pdf->SetY($this->pdf->GetY()+($this->row_size*($nl-$tnl)));
  }
  
  /**
  * cadre envoi dmst
  */
  function pdf_champ_envoi_DMST() {
    $champ_checked = $this->demandeor->doctrans;
    $checked_array = array(false,false,false);
    if ($champ_checked > 0) $checked_array[$champ_checked-1] = true;
    $this->pdf->Cell(32,$this->row_size,'Dispose d\'un DMST : ');
    $this->pdf_champ_radio('Oui',$checked_array[0],7);
    $this->pdf_champ_radio('Non',$checked_array[1],14);
  }
  
  /**
  * cadre envoi dmt
  */
  function pdf_champ_envoi_DMT() {
    $champ_checked = $this->demandeor->dmttrans;    
    $checked_array = array(false,false,false);
    if ($champ_checked > 0) $checked_array[$champ_checked-1] = true;
    $this->pdf->Cell(30,$this->row_size,'Dispose d\'un DMT :');
    $this->pdf_champ_radio('Oui',$checked_array[0],7);
    $this->pdf_champ_radio('Non',$checked_array[1],14);
  }
  
  /**
  * cadre supplment chambre individuelle
  */
  function pdf_champ_supplement_chambre_individuelle() {
    $champ_checked = $this->demandeor->supplement_ch_indiv;
    $checked_array = array(false,false,false);
    if ($champ_checked > 0) $checked_array[$champ_checked-1] = true;
    $this->pdf->Cell(42,$this->row_size,'Supplment pour ch. indiv. :');
    $this->pdf_champ_radio('Oui',$checked_array[0],7);
    $this->pdf_champ_radio('Non',$checked_array[1],7);
  }
  
  /**
  * cadre demande inter-brio
  */
  function pdf_champ_demande_inter_brio() {
    $interbrios = $this->getDemandeInterBrio();
    $interbrios_str = '';
    $this->pdf->Cell(0,1,'','LTR',1);
    $this->pdf->Cell(3,$this->row_size,'','L');
    $this->pdf->Cell(50,$this->row_size,'Demande transmise aux BRIOs : ');
    $actual_textcolor = $this->pdf->TextColor;
    $actual_fontstyle = $this->pdf->FontStyle;
    $actual_fontsize = $this->pdf->FontSizePt;
    $this->pdf->SetTextColor(0,0,255);
    $this->pdf->SetFont($this->pdf->FontFamily,'I',10);
    if ($interbrios != '')
      foreach ($interbrios as $interbrio) {
        $interbrios_str .= $interbrio['nomet'] . " - ";
      }
    $this->pdf->Cell(0,$this->row_size,$interbrios_str);
    $this->pdf->Cell(0,$this->row_size,'','R',1);
    $this->pdf->Cell(0,1,'','LBR',1);
    $this->pdf->TextColor = $actual_textcolor;
    $this->pdf->SetFont($this->pdf->FontFamily,$actual_fontstyle,$actual_fontsize);
  }
     
  /**
  * cadre date de la demande
  */
  function pdf_champ_date_demande() {
    $this->pdf->Cell(40,$this->row_size,'Date de la demande : ');
    $this->pdf->Cell(30,$this->row_size,$this->demandeor->datedem,1,0,'',1);
    $this->pdf->Cell(40,$this->row_size);
  }
  
  /**
  * cadre demandeur
  */
  function pdf_champ_demandeur() {
    $this->pdf->Cell(25,$this->row_size,'Demandeur : ');
    $this->pdf->Cell(55 ,$this->row_size, $this->raguillePDF($this->demandeor->nomdem), 1, 0, '', 1);
  }
  
  function pdf_entete_dmst() {
    $this->pdf->Cell(30,$this->row_size,"Adress par");
    $this->pdf->Cell(110,$this->row_size,"","B",1);
    $this->pdf->Cell(140,$this->row_size,"",0,1);
    $this->pdf->Cell(30,$this->row_size,"N de tl.");
    $this->pdf->Cell(40,$this->row_size,"","B",0);
    $this->pdf->Cell(30,$this->row_size,"      N de Fax");
    $this->pdf->Cell(40,$this->row_size,"","B",1);
    $this->pdf->Cell(140,$this->row_size,"",0,1);
    $this->pdf->Cell(30,$this->row_size,"");
    $this->pdf->Cell(40,$this->row_size,"","B",0);
    $this->pdf->Cell(30,$this->row_size,"      le");
    $this->pdf->Cell(40,$this->row_size,"","B",1);
    $this->pdf->Cell(140,$this->row_size,"",0,1);
    $this->pdf->SetFont($this->pdf->FontFamily,'B',10);
    $this->pdf->Cell(80,$this->row_size,"Demande d'admission pour un hbergement ?");
    $this->pdf->Cell(30,$this->row_size,"     Si oui : ");
    $this->pdf->SetFont($this->pdf->FontFamily,'',10);
    $this->pdf_champ_checkbox("Long sjour",false,30,"",0.5,0.5);
    $this->pdf_champ_checkbox("Court sjour",false,30,"",0.5,0.5);
    $this->pdf->Cell(0,$this->row_size,"",0,1);
    $this->pdf->SetFont($this->pdf->FontFamily,'',8);
    $this->pdf->Cell(0,$this->row_size,"Les informations contenues dans ce document de transmission sont rdiges uniquement en vue de l'amlioration de la prise en charge du bnficiaire",0,1);
    $this->pdf->Cell(0,$this->row_size,"(intrt prpondrant).",0,1);
    $this->pdf->Cell(0,$this->row_size,"Il est rappel que, conformment aux directives en vigueur  l'Etat de Vaud,  l'OMSV, dans les tablissements de la FHV et de l'AVDEMS, chacun est",0,1);
    $this->pdf->Cell(0,$this->row_size,"soumis au secret de fonction, au secret professionnel ou au devoir de discrtion durant sa fonction et aprs sa cessation. Toute violation peut tre",0,1); 
    $this->pdf->Cell(0,$this->row_size,"sanctionne.",0,1);
    $this->pdf->SetFont($this->pdf->FontFamily,'B',10);
    $this->pdf->Cell(0,$this->row_size,"",0,1);
    $X = $this->pdf->GetX();
    $Y = $this->pdf->GetY();
    $marge = 155;
    $this->pdf->SetXY($marge,10);
    $this->pdf->Cell(0,$this->row_size,"Confidentiel",0,1,"C"); $this->pdf->SetX($marge);
    $this->pdf->SetFont($this->pdf->FontFamily,'',7);
    $this->pdf->Cell(0,$this->small_row_size,"L'intress doit pouvoir lire ce document",0,1); $this->pdf->SetX($marge);
    $this->pdf->Cell(0,$this->small_row_size,"en tout temps.",0,1); $this->pdf->SetX($marge);
    $this->pdf->SetFont($this->pdf->FontFamily,'B',7);
    $this->pdf->Cell(0,$this->small_row_size,"Accord du patient pour la",0,1); $this->pdf->SetX($marge);
    $this->pdf->Cell(0,$this->small_row_size,"transmission de ces informations ",0,1); $this->pdf->SetX($marge);
    $this->pdf->Cell(0,$this->row_size*1.2,"","B",1); $this->pdf->SetX($marge);
    $this->pdf->Cell(0,$this->row_size*0.5,"",0,1); $this->pdf->SetX($marge);
    $this->pdf_champ_checkbox("Oui",true,15,"",0.5,0.5); 
    $this->pdf_champ_checkbox("Non",false,15,"",0.5,0.5); 
    $this->pdf->Cell(0,$this->row_size*1.2,"",0,1); $this->pdf->SetX($marge);
    $this->pdf->SetFont($this->pdf->FontFamily,'',7);
    $this->pdf->Cell(0,$this->small_row_size,"Si non, transmission des donnes",0,1); $this->pdf->SetX($marge);
    $this->pdf->Cell(0,$this->small_row_size,"administratives seulement.",0,1); $this->pdf->SetX($marge);
    $this->pdf->SetXY($X,$Y);
  }
  
  function pdf_donnees_admin() {
    $this->pdf->SetFont($this->text_font,'B',$this->title_size);
    $this->pdf->Cell(0,$this->title_height,"1. Donnes administratives",0,1);
    $this->pdf->SetFont($this->text_font,'',$this->text_size);
    
    $this->pdf->Cell(10,$this->row_size,"Nom","LT",0);
    $this->pdf->Cell(55,$this->row_size,$this->dmst->x_Nom,"T",0);
    $this->pdf->Cell(10,$this->row_size,"Sexe","LT",0,"C");
    $this->pdf->Cell(25,$this->row_size,"Date de","LT",0,"C");
    $this->pdf->Cell(25,$this->row_size,"Lieu de","LT",0,"C");
    $this->pdf->Cell(22,$this->row_size,"Date d'entre","LT",0,"C");
    $this->pdf->Cell(23,$this->row_size,"Date de sortie","LT",0,"C");
    $this->pdf->Cell(20,$this->row_size,"N client","LTR",1,"C");
    
    $this->pdf->Cell(65,$this->small_row_size,"","L",0);
    $this->pdf->Cell(10,$this->small_row_size,"","L",0);
    $this->pdf->Cell(25,$this->small_row_size,"naissance","L",0,"C");
    $this->pdf->Cell(25,$this->small_row_size,"naissance","L",0,"C");
    $this->pdf->Cell(22,$this->small_row_size,"","L",0);
    $this->pdf->Cell(23,$this->small_row_size,"","L",0);
    $this->pdf->Cell(20,$this->small_row_size,"","LR",1);
    
    $this->pdf->Cell(15,$this->row_size,"Prnom","L",0);
    $this->pdf->Cell(50,$this->row_size,$this->dmst->x_Prenom,"",0);
    if ($this->dmst->n_Sexe == 0) $s = "F";
    else $s = "M";
    $this->pdf->Cell(10,$this->row_size,$s,"LB",0,"C");
    $this->pdf->Cell(25,$this->row_size,$this->dmst->d_Naissance,"LB",0,"C");
    $this->pdf->Cell(25,$this->row_size,$this->dmst->x_Lieudenaissance,"LB",0,"C");
    $this->pdf->Cell(22,$this->row_size,$this->dmst->d_Dentree,"LB",0,"C");
    $this->pdf->Cell(23,$this->row_size,$this->dmst->d_Desortie,"LB",0,"C");
    $this->pdf->Cell(20,$this->row_size,$this->dmst->x_Numerodeclient,"LBR",1,"C");
    
    $this->pdf->Cell(15,$this->row_size,"Etat civil","LB",0);
    $this->pdf->Cell(50,$this->row_size,$this->dmst->x_Etatcivil,"B",0);
    $this->pdf->Cell(15,$this->row_size,"Origine","LB",0);
    $this->pdf->Cell(45,$this->row_size,$this->dmst->x_Origine,"B",0);
    $this->pdf->Cell(30,$this->row_size,"Filiation maternelle","LB",0);
    $this->pdf->Cell(35,$this->row_size,$this->dmst->x_Filmat,"BR",1);
    
    $this->pdf->Cell(30,$this->row_size,"Religion/confession","LB",0);
    $this->pdf->Cell(35,$this->row_size,$this->dmst->x_Relconf,"B",0);
    $this->pdf->Cell(20,$this->row_size,"Nationalit","LB",0);
    $this->pdf->Cell(40,$this->row_size,$this->dmst->x_Nation,"B",0);
    $this->pdf->Cell(30,$this->row_size,"Filiation paternelle","LB",0);
    $this->pdf->Cell(35,$this->row_size,$this->dmst->x_Filpat,"BR",1);
    
    $this->pdf->Cell(25,$this->row_size,"Domicile","L",0);
    $this->pdf->Cell(100,$this->row_size,$this->dmst->x_Dom,0,0);
    $this->pdf->Cell(20,$this->row_size,"Profession","L",0);
    $this->pdf->Cell(45,$this->row_size,$this->dmst->x_Profess,"R",1);
    
    $this->pdf->Cell(10,$this->row_size,"Tl.","LB",0);
    $this->pdf->Cell(115,$this->row_size,$this->dmst->t_Domtel,"B",0);
    $this->pdf->Cell(65,$this->row_size,"","LBR",1);
    
    $this->pdf->Cell(95,$this->row_size,"Nom et Prnom du conjoint","L",0);
    $this->pdf->Cell(95,$this->row_size,"Tl. en urgence chez","LR",1);
    
    $this->pdf->Cell(95,$this->row_size,$this->dmst->x_Npconjoint,"LB",0);
    $this->pdf->Cell(95,$this->row_size,$this->dmst->t_Telurg,"LBR",1);
    
    $this->pdf->Cell(25,$this->row_size,"Mdecin traitant","L",0);
    $this->pdf->Cell(70,$this->row_size,$this->dmst->x_Medtrait,0,0);
    $this->pdf->Cell(20,$this->row_size,"Assurance","L",0);
    $this->pdf->Cell(75,$this->row_size,$this->dmst->x_Ass,"R",1);
    
    $this->pdf->Cell(95,$this->row_size,"","LB",0);
    $this->pdf->Cell(20,$this->row_size,"N d'assur","LB",0);
    $this->pdf->Cell(75,$this->row_size,$this->dmst->x_Numass,"BR",1);
    
    $this->pdf->Cell(30,$this->row_size,"Mdecin de l'hpital","L",0);
    $this->pdf->Cell(65,$this->row_size,$this->dmst->x_Medhop,0,0);
    $this->pdf->Cell(95,$this->row_size,"","LR",1);
    
    $this->pdf->Cell(95,$this->row_size,"","LB",0);
    $this->pdf->Cell(15,$this->row_size,"N AVS","LB",0);
    $this->pdf->Cell(80,$this->row_size,$this->dmst->x_Numavs,"BR",1);
    
    $this->pdf->Cell(0,$this->row_size,"",0,1);
  }
  
  function pdf_famille() {
    $this->pdf->SetFont($this->text_font,'B',$this->title_size);
    $this->pdf->Cell(0,$this->title_height,"2. Famille, entourage",0,1);
    $this->pdf->SetFont($this->text_font,'',$this->text_size);
    
    $this->pdf->Cell(190,$this->row_size,"Personne de rfrence : Nom, adresse, tl.","LTR",1);
    $this->pdf->Cell(190,$this->row_size,$this->dmst->x_Persrefnom,"LR",1);
    $this->pdf->Cell(190,$this->row_size,$this->dmst->x_Persrefadr,"LR",1);
    $this->pdf->Cell(190,$this->row_size,$this->dmst->t_Persreftel,"LBR",1);
    $this->pdf->Cell(190,$this->row_size,"Personne(s) vivant avec le patient : Nom, tl.","LTR",1);
    $this->pdf->Cell(190,$this->row_size,$this->dmst->x_Persviv,"LR",1);
    $this->pdf->Cell(190,$this->row_size,$this->dmst->x_Persvivadr,"LR",1);
    $this->pdf->Cell(190,$this->row_size,$this->dmst->t_Persvivtel,"LBR",1);
    $this->pdf->Cell(190,$this->row_size,"Tuteur/curateur : Nom, adresse, tl.","LTR",1);
    $this->pdf->Cell(190,$this->row_size,$this->dmst->x_Cur,"LR",1);
    $this->pdf->Cell(190,$this->row_size,$this->dmst->x_Curadr,"LR",1);
    $this->pdf->Cell(190,$this->row_size,$this->dmst->t_Curtel,"LBR",1);
    
    $this->pdf->Cell(0,$this->row_size,"",0,1);
  }
  
  function pdf_habitat() {
    $this->pdf->SetFont($this->text_font,'B',$this->title_size);
    $this->pdf->Cell(0,$this->title_height,"3. Habitat (description)",0,1);
    $this->pdf->SetFont($this->text_font,'',$this->text_size);     
    $this->pdf->Cell(190,$this->row_size,"Itinraire et accs / Barrires architecturales / Caractristiques du logement :","LTR",1);
    $this->pdf->MultiCell(190,$this->row_size, $this->raguillePDF($this->dmst->a_Iti), "LBR", "", 0);
    $this->pdf->Cell(0,$this->row_size,"",0,1); 
  }
  
  function pdf_contexte() {
    $this->pdf->SetFont($this->text_font,'B',$this->title_size);
    $this->pdf->Cell(0,$this->title_height,"4. Contexte et habitude de vie",0,1);
    $this->pdf->SetFont($this->text_font,'',$this->text_size);      
    $this->pdf->Cell(190,$this->row_size,"Ressources et besoins, vnements et faits marquants, relations socio-familiales significatives :","LTR",1);
    $this->pdf->MultiCell(190,$this->row_size, $this->raguillePDF($this->dmst->a_Resbes), "LBR", "", 0);
    $this->pdf->Cell(0,$this->row_size,"",0,1); 
  }
  
  function pdf_intervenants() {
    $this->pdf->SetFont($this->text_font,'B',$this->title_size);
    $this->pdf->Cell(70,$this->title_height,"5. Intervenants",0,0);
    $this->pdf->SetFont($this->text_font,'',$this->text_size);      
    $this->pdf->Cell(0,$this->title_height,"( domicile ou de rfrence avant le transfert)",0,1);
    
    $this->pdf->Cell(100,$this->row_size,"Nom de l'intervenant et fonction","LTB",0,"C");
    $this->pdf->Cell(30,$this->row_size,"N de tlphone","LTB",0,"C");
    $this->pdf->Cell(60,$this->row_size,"Prcisions",1,1,"C");
    
    foreach ($this->intervenants as $k => $interv) {
        $this->pdf->Cell(100,$this->row_size,$interv->x_int_nom,"LB",0);
        $this->pdf->Cell(30,$this->row_size,$interv->t_int,"LB",0);
        $this->pdf->Cell(60,$this->row_size,$interv->x_int_precision,"LBR",1);    
    }
            
    $this->pdf->Cell(0,$this->row_size,"",0,1); 
  }
  
  function pdf_ligne_autonomie($name, $selected, $ln = 0) {
    $this->pdf->SetFont($this->text_font,'',$this->text_size);
    $selArray = array("","","","","");
    $selArray[$selected] = "X";
    $case = 8;
    $titre = 95-$case*4;
    $this->pdf->Cell($titre,$this->row_size,"   ".$name,1,0);
    $this->pdf->Cell($case,$this->row_size,$selArray[1],1,0,"C");
    $this->pdf->Cell($case,$this->row_size,$selArray[2],1,0,"C");
    $this->pdf->Cell($case,$this->row_size,$selArray[3],1,0,"C");
    $this->pdf->Cell($case,$this->row_size,$selArray[4],1,$ln,"C");
    $this->pdf->SetFont($this->text_font,'B',$this->text_size);
  }
  
  function pdf_autonomie() {
    $this->pdf->SetFont($this->text_font,'B',$this->title_size);
    $this->pdf->Cell(80,$this->title_height,"6. Niveau d'autonomie",0,0);
    $this->pdf->SetFont($this->text_font,'',$this->text_size);
    $this->pdf->Cell(0,$this->title_height,"1. Autonome 2. Surveillance/Stimulation 3. Exige de l'aide 4. Dpendant",0,1);
    $case = 8;
    $titre = 95-$case*4;
    
    $this->pdf->SetFont($this->text_font,'B',$this->text_size);
    $this->pdf->Cell($titre,$this->row_size,"",1,0);
    $this->pdf->Cell($case,$this->row_size,"1",1,0,"C");
    $this->pdf->Cell($case,$this->row_size,"2",1,0,"C");
    $this->pdf->Cell($case,$this->row_size,"3",1,0,"C");
    $this->pdf->Cell($case,$this->row_size,"4",1,0,"C");
    $this->pdf->Cell($titre,$this->row_size,"",1,0);
    $this->pdf->Cell($case,$this->row_size,"1",1,0,"C");
    $this->pdf->Cell($case,$this->row_size,"2",1,0,"C");
    $this->pdf->Cell($case,$this->row_size,"3",1,0,"C");
    $this->pdf->Cell($case,$this->row_size,"4",1,1,"C");
    
    $this->pdf->Cell(95,$this->row_size,"Activits de la vie quotidienne :",1,0);
    $this->pdf->Cell(95,$this->row_size,"Communication :",1,1);
    $this->pdf_ligne_autonomie("Manger - boire",$this->grille->manger,0);
    $this->pdf_ligne_autonomie("Voir",$this->grille->voir,1);
    $this->pdf_ligne_autonomie("Se laver",$this->grille->laver,0);
    $this->pdf_ligne_autonomie("Entendre",$this->grille->entendre,1);
    $this->pdf_ligne_autonomie("S'habiller",$this->grille->habiller,0);
    $this->pdf_ligne_autonomie("Parler",$this->grille->parler,1);
    $this->pdf_ligne_autonomie("Se dshabiller",$this->grille->deshab,0);
    $this->pdf_ligne_autonomie("Utiliser le tlphone",$this->grille->telephone,1);
    $this->pdf_ligne_autonomie("Continence vsicale",$this->grille->contves,0);
    $this->pdf->Cell(95,$this->row_size,"","R",1);
    $this->pdf_ligne_autonomie("Continence anale",$this->grille->contana,0);
    $this->pdf->Cell(95,$this->row_size,"Etat psychique / Facults mentales :","R",1);
    $this->pdf_ligne_autonomie("Utiliser les toilettes",$this->grille->toilet,0);
    $this->pdf_ligne_autonomie("Mmoire",$this->grille->memoire,1);
    $this->pdf->Cell(95,$this->row_size,"","L",0);
    $this->pdf_ligne_autonomie("Orientation (temps, espace)",$this->grille->orientat,1);
    $this->pdf->Cell(95,$this->row_size,"Mobilit","L",0);
    $this->pdf_ligne_autonomie("Jugement / comprhension",$this->grille->jugement,1);
    $this->pdf_ligne_autonomie("Changer de position",$this->grille->changpos,0);
    $this->pdf_ligne_autonomie("Grer son temps libre, s'occuper",$this->grille->soccuper,1);
    $this->pdf_ligne_autonomie("Se dplacer  l'intrieur",$this->grille->deplint,0);
    $this->pdf->Cell(95,$this->row_size,"","R",1);
    $this->pdf_ligne_autonomie("Se dplacer  l'extrieur",$this->grille->deplext,0);
    $this->pdf->Cell(95,$this->row_size,"Tches domestiques :","R",1);
    $this->pdf_ligne_autonomie("Utiliser les moyens de transport",$this->grille->moytransp,0);
    $this->pdf_ligne_autonomie("Entretenir son logement",$this->grille->entrlog,1);
    $this->pdf_ligne_autonomie("Utiliser les moyens auxiliaires",$this->grille->auxil,0);
    $this->pdf_ligne_autonomie("Prparer les repas",$this->grille->preprepas,1);
    $this->pdf_ligne_autonomie("Utiliser les escaliers",$this->grille->escaliers,0);
    $this->pdf_ligne_autonomie("Faire les courses",$this->grille->courses,1);
    $this->pdf->Cell(95,$this->row_size,"","L",0);
    $this->pdf_ligne_autonomie("Faire la lessive - entretenir son linge",$this->grille->lessive,1);
    $this->pdf->Cell(95,$this->row_size,"","L",0);
    $this->pdf_ligne_autonomie("Prendre ses mdicaments",$this->grille->medics,1);
    $this->pdf->Cell(95,$this->row_size,"","L",0);
    $this->pdf_ligne_autonomie("Gestion administrative",$this->grille->gestad,1);
    $this->pdf->Cell(95,$this->row_size,"","LB",0);
    $this->pdf_ligne_autonomie("Grer ses liens sociaux",$this->grille->lienssociaux,1);
    
    $this->pdf->Cell(0,$this->row_size,"",0,1);
    $this->pdf->SetFont($this->text_font,'',$this->text_size);
    
    $this->pdf->Cell(0,$this->row_size,"Transfr avec (cannes, lunettes, prothses, ...) :","LTR",1);
    $this->pdf->Cell(40,$this->row_size,"Transport effectu par :","LB",0);
    $this->pdf->Cell(80,$this->row_size,$this->dmst->x_Transportpar,"B",0);
    $this->pdf->Cell(10,$this->row_size,"le :","B",0);
    $this->pdf->Cell(0,$this->row_size,$this->dmst->d_Transport,"BR",1);
    
    $this->pdf->Cell(0,$this->row_size,"",0,1);
  }
  
  function pdf_bilan() {
    $this->pdf->SetFont($this->text_font,'B',$this->title_size);
    $this->pdf->Cell(70,$this->title_height,"7. Bilan de sant",0,0);
    $this->pdf->SetFont($this->text_font,'',$this->text_size);      
    $this->pdf->Cell(0,$this->title_height,"(habitudes, problmes, actions entreprises, moyens auxiliaires, etc...)",0,1);
        
    $this->pdf->Cell(190,$this->row_size,"Etat gnral / Respiration / Circulation - temprature / Alimentation, hydratation, digestion / Elimination (incontinence, appareillage),","LTR",1);
    $this->pdf->Cell(190,$this->row_size,"sondes et stomies diverses (avec date de la pose) / Mobilisation (coordination, posture, spasticit, etc.) / Handicaps sensoriels et ","LR",1);
    $this->pdf->Cell(190,$this->row_size,"appareillage / Etat de la peau, des ongles et cicatrices / Sommeil et repos / Etat psychique / Autre :","LR",1);
    $this->pdf->MultiCell(190,$this->row_size, $this->raguillePDF($this->dmst->A_Etatgeneral), "LBR", "", 0);
    
    $this->pdf->Cell(0,$this->row_size,"",0,1);
  }
  
  function pdf_prise_en_charge() {
    $this->pdf->SetFont($this->text_font,'B',$this->title_size);
    $this->pdf->Cell(0,$this->title_height,"8. Prise en charge le jour du transfert",0,1);
    $this->pdf->SetFont($this->text_font,'',$this->text_size);  

    $this->pdf->Cell(190,$this->row_size,"Motif du transfert / Objectifs de soins / Projets pour le patient :","LTR",1);
    $this->pdf->MultiCell(190,$this->row_size, $this->raguillePDF($this->dmst->a_Motiftransfert), "LBR", "", 0);
    
    $this->pdf->Cell(190,$this->row_size,"Traitement en cours et soins  effectuer / Moyens et matriel de soins ncessaires / Surveillance :","LR",1);
    $this->pdf->MultiCell(190,$this->row_size, $this->raguillePDF($this->dmst->a_Traitcours), "LBR", "", 0);
    
    $this->pdf->SetFont($this->text_font,'B',$this->text_size);
    $this->pdf->Cell(90,$this->row_size,"Mdicaments (valable le jour du transfert) :","LB",0);
    $this->pdf->Cell(20,$this->row_size,"Matin","B",0,"C");
    $this->pdf->Cell(20,$this->row_size,"Midi","B",0,"C");
    $this->pdf->Cell(20,$this->row_size,"Soir","B",0,"C");
    $this->pdf->Cell(20,$this->row_size,"Nuit","B",0,"C");
    $this->pdf->Cell(20,$this->row_size,"Autres","BR",1,"C");
    $this->pdf->SetFont($this->text_font,'',$this->text_size);  
    
    foreach ($this->medics as $k => $medic) {
        $this->pdf->Cell(90,$this->row_size,$medic->x_Med_Nom,"LB",0);
        $this->pdf->Cell(20,$this->row_size,$medic->b_Med_Matin,"B",0,"C");
        $this->pdf->Cell(20,$this->row_size,$medic->b_Med_Midi,"B",0,"C");
        $this->pdf->Cell(20,$this->row_size,$medic->b_Med_Soir,"B",0,"C");
        $this->pdf->Cell(20,$this->row_size,$medic->b_Med_Nuit,"B",0,"C");
        $this->pdf->Cell(20,$this->row_size,$medic->x_Med_Autres,"BR",1,"C");
    }
       
    $this->pdf->Cell(120,$this->row_size,"Mdicaments ordonnes par le Dr :","LBT",0);
    $this->pdf->Cell(70,$this->row_size,"Tl. :","RBT",1);
    
    $this->pdf->Cell(0,$this->row_size,"",0,1);
  }
  
  function pdf_pied_dmst() {
    $this->pdf->Cell(60,$this->row_size,"Document mdical :");
    $this->pdf_champ_checkbox("en annexe",false,30,"",0.5,0.5);
    $this->pdf_champ_checkbox("suit",false,30,"",0.5,0.5); 
    $this->pdf_champ_checkbox("envoy au Dr",false,30,"",0.5,0.5);   
    $this->pdf->Cell(0,$this->row_size,"",0,1);
    
    $this->pdf->Cell(80,$this->row_size,"Informations recueillies par :");
    $this->pdf->Cell(60,$this->row_size,"Fonction :");
    $this->pdf->Cell(50,$this->row_size,"Timbre :",0,1);
    
    $this->pdf->Cell(80,$this->row_size,"le :");
    $this->pdf->Cell(110,$this->row_size,"Signature :",0,1);
  }
  
  function pdf_tete_dmst($page) {
    $X = $this->pdf->GetX();
    $Y = $this->pdf->GetY();
    $this->pdf->SetXY(10,5);
    $this->pdf->Cell(95,$this->row_size,"Nom et prnom du patient : " . $this->dmst->x_Nom . " " . $this->dmst->x_Prenom);
    $this->pdf->Cell(95,$this->row_size,"Page " . $page,0,0,"R");
    $this->pdf->SetXY($X,$Y);
  }
}  
?>