<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

/**
* Indicateurs IUMSP
* @package formulaires
*/
/**
* Indicateurs IUMSP
* Accs aux fichiers html contenant les rapports priodiques gnrs par les scripts R de l'IUMSP
* @package formulaires
* @author ob cjd jdu
*/
class indicIUMSP extends cadronglet{
  /**
  * l'action accessoire (affichage des liens)
  * @var int
  */  
  var $action2;
  
  /**
  * les variables de configuration
  * @var object briocheIni
  */
  var $ini;
  
  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param int actif l'action principale
  * @param string fondpage la couleur du fond de page
  * @param string sessionid l'identifiant de session
  * @param int action2 cf. variable de classe
  * @param string item le fichier  afficher
  */
  function indicIUMSP($largeur, $grise, $actif, $fondpage, $sessionid, $action2, $item = ""){
    global $fichier;
    $this->action2 = $action2;
    $this->ini = new briocheIni();
    if (! $this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid)) return;
    if (! $this->verifAut($this->ini->autSuppl[2], $this->autorisations)){
      $this->n_erreur = 103; 
      return;
    }
    if ($item){ // affichage du rapport au format HTML
      
      $nomfich = $this->ini->repHtml_r . "/$item";
      $fich = fopen($nomfich, 'r');
      $txt = fread($fich, filesize($nomfich));
      $txt = preg_replace("/<body>/", "<body><CENTER><A HREF=\"$fichier?action=$this->actif&sessionid=$this->idsession\">" .
                          "Retour</A></CENTER>", $txt);
      
      print $txt;
      
      fclose($fich);
    }
    else { // affichage du formulaire menu
      $tabbande = array("Accs aux indicateurs IUMSP", "", "", "", "");
      $this->addOnglet("Indicateurs", $tabbande, "#8b8378", $this->actif, 80, "");
      $this->colmateOnglets();
    
      //Contenu
      $of = new OngForm();
      $of->setTabParam($this->largeur, $this->coulbande, 6);
      $of->setFormParam("donnees", $fichier, "post");
      $c = new TPanel(5, 1);
      $x = new Label("$this->nomplein");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Bouton("Retour", "Retour", "SUBMIT");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      $c = new TPanel(6, 1);
      $x = new Label("Des rapports d'analyses sont gnrs et actualiss  intervalles rguliers pour des priodes d'un mois, " .
                     "d'un trimestre et d'une anne. Il est probable que les rapports les plus rcents n'aient pas encore atteint " .
                     "leur tat dfinitif. Consultez-les  nouveau d'ici quelques semaines.", false, true);
      $c->addChamp($x);               
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("action", $this->actif, "HIDDEN");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      $c = new TPanel(3, 1);
      $x = new Label("Fichiers mensuels", true);
      $tableau = $this->fichiersDispo("mois");
      $c->addChamp($x);
      $texte = $this->getLiens($tableau);
      $x = new Label("<br>".$texte);
      $c->addChamp($x);
      $x = new Label("<br>"."Fichier trimestriels", true);
      $tableau = $this->fichiersDispo("trimestres");
      $c->addChamp($x);
      $texte = $this->getLiens($tableau);
      $x = new Label("<br>".$texte);
      $c->addChamp($x);
      $x = new Label("<br>"."Fichier semestriels", true);
      $tableau = $this->fichiersDispo("semestres");
      $c->addChamp($x);
      $texte = $this->getLiens($tableau);
      $x = new Label("<br>".$texte);
      $c->addChamp($x);
      $x = new Label("<br>"."Fichier annuels", true);
      $tableau = $this->fichiersDispo("annees");
      $c->addChamp($x);
      $texte = $this->getLiens($tableau);
      $x = new Label("<br>".$texte);
      $c->addChamp($x);
      $of->addChamp($c);
      // En cours
      $c = new TPanel(3, 1);
      $x = new Label("Fichier en cours (Attention : rsultats partiels)", true);
      $tableau = $this->fichiersDispo("encours");
      $c->addChamp($x);
      $texte = $this->getLiens($tableau);
      $x = new Label("<br>".$texte);
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne(0.5);
      
      $this->addContenu($of->getContenu());
    }
  }

  /**
  * sur la base d'un tableau de fichers, renvoie la suite des liens html correpondant
  * @param array tableau le tableau des fichiers
  * @return string
  */
  function getLiens($tableau){
    global $fichier;
    $cpt = count($tableau);
    $texte = "";
    $now = mktime(0,0,0,date("m"),date("d"),date("Y"));
    $nom = array("Mois","Trimestre","Semestre","Anne");
    $n = 0;
    for ($i = 0; $i < $cpt; $i++){
      $params = $this->getParams($tableau[$i]);
      if (date("m", $params['fin']) == date("m", $params['fin'] + SEC_PAR_JOUR) && $params['duree'] > 0) { 
          if ($params['duree'] < 32) $n = 0;
          elseif ($params['duree'] < 93) $n = 1;
          elseif ($params['duree'] < 185) $n = 2;
          else $n = 3;
          $texte .= $nom[$n] . " en cours <br>";
      }
      $texte .= "<A HREF = \"$fichier?action=$this->action2&sessionid=$this->idsession&item=$tableau[$i]\">" .
                date("d.m.Y", $params['debut']) . " - " . date("d.m.Y", $params['fin']) . "</A><BR>";
    }
    return $texte;
  }
  
  /**
  * sur la base d'un nom de fichiers, renvoie les paramtres (dbut, fin, dure)
  * @param string nomfich le nom de fichier  analyer
  * @return array tableau associatif ('debut', 'fin', 'duree')
  */
  function getParams($nomfich){
    $ini = &$this->ini;
    $debut = 0;
    $fin = 0;
    $duree = 0;
    
    if (preg_match("/^" .$ini->nomBrio_r . "_([0-9]{4})([0-9]{2})([0-9]{2})_([0-9]{4})([0-9]{2})([0-9]{2})/", $nomfich, $matches)){
      $debut = mktime(0, 0, 0, $matches[2], $matches[3], $matches[1]);
      $fin = mktime(0, 0, 0, $matches[5], $matches[6], $matches[4]);
      $duree = round(($fin - $debut) / SEC_PAR_JOUR) + 1;
    }
    $tab['debut'] = $debut;
    $tab['fin'] = $fin;
    $tab['duree'] = $duree;
    return $tab;
  }
  
  /**
  * renvoie un tableau de fichiers sur la base de leur type
  * @param string type 'mois' | 'trimestres' | 'semestres' | 'annees' | 'encours'
  * @return array le tableau des fichiers du type demand
  */
  function fichiersDispo($type){
    $ini = &$this->ini;
    $repHtml = opendir($ini->repHtml_r);
    //$now = mktime(0, 0, 0, date("m"), date("d") , date("Y"));
    $mois = array();
    $trimestres = array();
    $semestres = array();
    $annees = array();
    $encours = array();
    while(false !== ($nomfich = readdir($repHtml))) {
      $tab = $this->getParams($nomfich);
      $duree = $tab['duree'];
      $fin = $tab['fin'];
      if (date("m", $fin) == date("m", $fin + SEC_PAR_JOUR) && $duree > 0) { // La fin du fichier ne tombe pas sur le dernier jour
                                                                             // du mois => fichier en cours
       	$encours[] = $nomfich;
      } else {
        if ($duree == 0){
        }
        elseif ($duree < 32){
          $mois[] = $nomfich;
        }
        elseif ($duree < 93) {
          $trimestres[] = $nomfich;
        }
        elseif ($duree < 186) {
          $semestres[] = $nomfich;
        }
        elseif ($duree > 364) {
          $annees[] = $nomfich;
        }  
      }
    }
    rsort($mois);
    rsort($trimestres);
    rsort($semestres);
    rsort($annees);
    rsort($encours);
    return $$type;
  }
}
?>
