<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Liste des dossiers en suspens
* @package formulaires
*/
/**
* Liste des dossiers en suspens
* Affiche tous les dossiers non archivs, avec ou sans les notes, sans rpartition
* @package formulaires
* @author ob tnh
*/
class listeDS extends cadronglet{

  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param int actif l'action principale ("Retour")
  * @param string fondpage la couleur du fond de page
  * @param string sessionid l'identifiant de session
  * @param int action_affichage l'action utilise pour afficher le formulaire
  * @param int options 1: afficher notes, 0: masquer notes
  */
  function listeDS($largeur, $grise, $actif, $fondpage, $sessionid, $action_affichage, $options){
    global $fichier;
    if ( !$this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid)) return;
    $join[] = "usagers";
    $join[] = "demandeor";
    $join[] = "typesejour";
    $join[] = "attributionlit";
    $join[] = "typesejour AS typesejour2";
    $join[] = "missions";
    $join[] = "missions AS missions2";
    $join[] = "annoncelit";
    $join[] = "etablissements";
    $join[] = "signetsdossiers";
    $join[] = "signets";
    if ($options == 1) $join[] = "notes";

    $on[] = "dossiers.nous = usagers.nous";
    $on[] = "dossiers.nodoss = demandeor.nodoss";
    $on[] = "demandeor.typesej = typesejour.idts";
    $on[] = "dossiers.nodoss = attributionlit.nodoss";
    $on[] = "attributionlit.typesej = typesejour2.idts";
    $on[] = "demandeor.typepath = missions.nomission";
    $on[] = "attributionlit.mission = missions2.nomission";
    $on[] = "attributionlit.nolit = annoncelit.nolit";
    $on[] = "annoncelit.etabl = etablissements.noet";
    $on[] = "dossiers.nodoss = signetsdossiers.nodoss";
    $on[] = "signetsdossiers.idsignet = signets.id";
    if ($options == 1) $on[] = "dossiers.nodoss = notes.nodossier";
    
    $champs = "dossiers.nodoss, dossiers.suivpar, " .
      "IF(dossiers.sejobs = -1, \" *\", \"\") AS sejobs, " .
      "usagers.nom, usagers.prenom, " .
      "IF(typesejour2.ttypesej != \"\", typesejour2.ttypesej, typesejour.ttypesej) AS ttypesej, " .
      "IF(missions2.txtmission != \"\", missions2.txtmission, missions.txtmission) AS txtmission, " .
      "IF(dossiers.priorite = 0, \"\", dossiers.priorite) AS priorite, " .
      "etablissements.nomet, attributionlit.dateres, attributionlit.dateplac, signets.nomsignet" . 
      ($options == 1 ? ", concat(DATE_FORMAT(notes.date_creation, '%e.%m.%Y'), ' ', IF (notes.auteur IS NULL, '-', notes.auteur), ' ', notes.textnotes) as donneesnotes " : "");
      
    if ($options == 1) $order_notes = ",notes.date_creation"; else $order_notes = "";
    $tabliste = new EnsTableCompact("dossiers", 
                                    "dossiers.dateclo IS NULL and dossiers.nous > 0 " .
                                    "AND (dossiers.statut IS NULL OR dossiers.statut NOT IN (99, 100))", 
                                    $champs, "dossiers.nodoss".$order_notes, $this->idsession, 
                                    $join, $on, false, "nodoss", "<BR>");

    // si l'utilisateur appuie sur le bouton Obtenir une feuille de calcul, action n'est pas un nombre entier
    // sinon il vient de la page principale et on affiche une page html contenant les donnes de la base
    if($action_affichage - floor($action_affichage) > 0.09) {
      $this->effaceEntete();
      $excel = new FeuilleExcel($tabliste, "dossiers_suspens.xls");
      $excel->affiche();
    }
    else {
      $tabbande = array("Dossiers en suspens", "", "", "", "");
      $this->addOnglet("Liste", $tabbande, "#8b8378", $this->actif, 80, "");
      $this->colmateOnglets();

      //Contenu
      $of = new OngForm();
      $of->setTabParam($this->largeur, $this->coulbande, 6);
      $of->setFormParam("donnees", $fichier, "post");


      $c = new TPanel(2, 1);
      $x = new Label("Il y a <B>" . $tabliste->compte() . "</B> dossiers   ---   * : sjours d'observation");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1);
      $textebouton = ($options ? "Masquer notes" : "Afficher notes");
      $valeurbouton = ($options ? 0 : 1);
      $x = new BoutonTexte($textebouton, "$fichier?action=$action_affichage&sessionid=$this->idsession&options=$valeurbouton",
                           $grise, "100%", 1);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(3, 1, "RIGHT", "MIDDLE");
      $x = new Bouton("action", $action_affichage, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("options", $options, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("Obtenir", "Obtenir feuille de calcul", "BUTTON",
		      "document.forms.donnees.action.value=8.1;document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));    
      $x = new Bouton("Retour", "Retour", "SUBMIT",
                      "document.forms.donnees.action.value=" . $this->actif . 
                      ";document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));

      $of->addChamp($c);
      $of->addLigne();
      $commentaire = ($options ? "donneesnotes" : "");
      $c = new TPanelTableau(6, 1, $tabliste, $this->grise, "dossiers", "nodoss", "", "", $commentaire, 500);
      $opt = new optionsBrioche();
      $opt->setOption("FORCE_DOSS", 1);
      $opt->setOption("LARG_FIX", 1);
      $x = new Lien("", false, false, false, "nodoss", "javascript:ouvreBrioche('brioche.php?action=1" .
		    "&sessionid=$this->idsession&item=&options=" . $opt->getChaine() . 
		    "', 830)");
    
      $c->addColChamp("N doss.", $x, false, true);
      $x = new Label("", false, false, false, "sejobs");
      $c->addColChamp("Obs.", $x);
      $x = new Label("", false, false, false, "suivpar");
      $c->addColChamp("Rf.", $x);
      $x = new Label("", false, false, false, "nom");
      $c->addColChamp("Nom", $x);
      $x = new Label("", false, false, false, "prenom");
      $c->addColChamp("Prnom", $x);
      $x = new Label("", false, false, false, "ttypesej");
      $c->addColChamp("Sj.", $x);
      $x = new Label("", false, false, false, "txtmission");
      $c->addColChamp("Mission", $x);
      $x = new Label("", false, false, false, "priorite");
      $c->addColChamp("Pri.", $x);
      $x = new Label("", false, false, false, "nomet");
      $c->addColChamp("Etabl.", $x);
      $x = new Label("", false, false, false, "dateres");
      $c->addColChamp("Rs.", $x);
      $x = new Label("", false, false, false, "dateplac");
      $c->addColChamp("Plac.", $x);
      if ($tabliste->controleChamp("signets.id")){
	      $x = new Label("", false, false, false, "nomsignet");
        $c->addColChamp("Signet", $x);
      }
      $c->addTitres(true);
      $of->addChamp($c);
      $this->addContenu($of->getContenu());
    }

}






}
?>
