<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Liste des prinscriptions par EMS
* @package formulaires
*/
/**
* Liste des prinscriptions par EMS
* Affiche tous les dossiers ayant fait l'objet de prinscription dans les EMS, avec ou sans les notes
* Possibilit d'afficher les prinscriptions d'un seul tablissemen
* @package formulaires
* @author ob tnh
*/
class listeEMS extends cadronglet{

  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param int actif l'action principale ("Retour")
  * @param string fondpage la couleur du fond de page
  * @param string sessionid l'identifiant de session
  * @param int action_affichage l'action utilise pour afficher le formulaire
  * @param int options 1: afficher notes, 0: masquer notes
  * @param array donnees les donnes postes par le formulaire (n d'tablissement)
  */
  function listeEMS($largeur, $grise, $actif, $fondpage, $sessionid, $action_affichage, $options, $donnees){
    global $fichier;
    if ( !$this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid)) return;

    $join[] = "dossiers";
    $join[] = "usagers";
    $join[] = "etablissements";
    $join[] = "demandeor";
    $join[] = "typesejour";
    $join[] = "attributionlit";
    $join[] = "typesejour AS typesejour2";
    $join[] = "signetsdossiers";
    $join[] = "signets";
    if ($options == 1) $join[] = "notes";
    $join[] = "etablissements AS etablissements2";

    $on[] = "choixems.nodoss = dossiers.nodoss";
    $on[] = "dossiers.nous = usagers.nous";
    $on[] = "choixems.noems = etablissements.noet";
    $on[] = "dossiers.nodoss = demandeor.nodoss";
    $on[] = "demandeor.typesej = typesejour.idts";
    $on[] = "dossiers.nodoss = attributionlit.nodoss";
    $on[] = "attributionlit.typesej = typesejour2.idts";
    $on[] = "dossiers.nodoss = signetsdossiers.nodoss";
    $on[] = "signetsdossiers.idsignet = signets.id";
    if ($options == 1) $on[] = "dossiers.nodoss = notes.nodossier";
    $on[] = "demandeor.servplac = etablissements2.noet";
    
    $champs = "etablissements.nomet, dossiers.suivpar, " .
              "IF(! attributionlit.typesej, typesejour.ttypesej , typesejour2.ttypesej) AS ttypesej ," .
              "dossiers.datouv, dossiers.nodoss, IF(dossiers.sejobs = -1, \" *\", \"\") AS sejobs, " .
              "usagers.nous, usagers.nom, usagers.prenom, IF(dossiers.priorite = 0, \"\", " .
              "dossiers.priorite) AS priorite, " .
              "signets.nomsignet, concat(etablissements.groupepriorite, etablissements.nomet) as _tri" .
              ($options == 1 ? ", concat(DATE_FORMAT(notes.date_creation, '%e.%m.%Y'), ' ', IF (notes.auteur IS NULL, '-', notes.auteur), ' ', notes.textnotes) as donneesnotes " : "") .
              ", demandeor.litdepuis AS litdepuis, etablissements2.nomet as serviceplaceur";
    // On se proccupe ici de tous les tablissements disposant de lits C ou de lits D
    // Si l'on dsire que les BRIOs ne s'affichent pas au bas de la liste, il faudra dcocher "lits C" et "lits D"
    // dans leur fiche d'tablissement
    // Si un lit a t attribu, le dossier disparat de toutes les listes d'attente !
    $where = "dossiers.dateclo IS NULL AND dossiers.nous > 0 AND refus = 0 AND refpro = 0 " .
             "AND (etablissements.litsC OR etablissements.litsD) AND attributionlit.nolit IS NULL";
    // si on a choisi un tablissement, alors on restreint la requte  cet tablissement
    if (isset($donnees['noet']) && $donnees['noet'] > 0) {
      $where .= " AND choixems.noems = ".$donnees['noet'];
    }

    if ($options == 1) $order_notes = ",notes.date_creation"; else $order_notes = "";
    $tabliste = new EnsTableCompact("choixems", 
                                    $where, 
                                    $champs, "_tri, etablissements.groupepriorite, if(dossiers.priorite = 0, 10, priorite), " .
                                    "dossiers.nodoss".$order_notes,
                                    $this->idsession, $join, $on, false,
                                    "nodoss", "<BR>", array(0 => 'nomet'));
    
    $join = "etablissements";
    $on = "choixems.noems = etablissements.noet";

    $champs = "etablissements.noet, etablissements.nomet, etablissements.actif";
    $etabl_liste = new ensTableBrioche("choixems", 
				       "etablissements.nomet IS NOT NULL AND (litsC OR litsD)", 
				       $champs, "etablissements.actif, nomet",
				       $this->idsession, $join, $on, true);
    // si l'utilisateur appuie sur le bouton Obtenir une feuille de calcul, action n'est pas un nombre entier
    // sinon il vient de la page principale et on affiche une page html contenant les donnes de la base
    if($action_affichage - floor($action_affichage) > 0.09) {
      $this->effaceEntete();
      $excel = new FeuilleExcel($tabliste, "ems_liste_inscrits.xls");
      $excel->affiche(true);
    }  
    else {
      $tabbande = array("EMS : listes d'inscrits", "", "", "", "");
      $this->addOnglet("Liste", $tabbande, "#8b8378", $this->actif, 80, "");
      $this->colmateOnglets();

      //Contenu
      $of = new OngForm();
      $of->setTabParam($this->largeur, $this->coulbande, 6);
      $of->setFormParam("donnees", $fichier, "post");

      $c = new TPanel(2,1);
      $x = new Label("Il y a <B>" . $tabliste->compte() . "</B> dossiers   ---   * : sjours d'observation");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1);
      $textebouton = ($options ? "Masquer notes" : "Afficher notes");
      $valeurbouton = ($options ? 0 : 1);
      $x = new BoutonTexte($textebouton, "javascript:document.forms.donnees.options.value=$valeurbouton;" .
                           "document.forms.donnees.submit();",
                           $grise, "100%", 1);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(3, 1, "RIGHT", "MIDDLE");
      $x = new Bouton("action", $action_affichage, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("options", $options, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("Obtenir", "Obtenir feuille de calcul", "BUTTON",
		      "document.forms.donnees.action.value=10.1;document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));                
      $x = new Bouton("Retour", "Retour", "SUBMIT",
                      "document.forms.donnees.action.value=".$this->actif.";document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $of->addChamp($c);
      $of->addLigne();

      // liste droulante avec le nom des EMS et autres BRIO
      $c = new TPanel(6);
      $x = new listOptTableEtabl("donnees[noet]", $donnees['noet'], $etabl_liste, $multiple=false, $size=0, 
			    $class="d2", $onchange="javascript:document.forms.donnees.action.value=".$action_affichage.
			    ";document.forms.donnees.submit();", false);
      $x->addDefaut("&lt;Tous&gt;", "");
      $x->addOptionsEtablissements("nomet", "noet");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $commentaire = ($options ? "donneesnotes" : "");
      $c = new TPanelTableau(6, 1, $tabliste, $this->grise, "dossiers", "nodoss", "nomet", "Aucun", $commentaire, 500);
      $opt = new optionsBrioche();
      $opt->setOption("FORCE_DOSS", 1);
      $opt->setOption("LARG_FIX", 1);
      $x = new Lien("", false, false, false, "nodoss", "javascript:ouvreBrioche('brioche.php?action=1" .
		    "&sessionid=$this->idsession&item=&options=" . $opt->getChaine() . 
		    "', 830)");
      $c->addColChamp("N doss.", $x, false, true);
      $x = new Label("", false, false, false, "sejobs");
      $c->addColChamp("Obs.", $x);
      $x = new Label("", false, false, false, "serviceplaceur");
      //Plus besoin de la fonction de callback
      //$c->addColChamp("Serv. Plac.", $x, false, false, "get_nomEtabl", $this);
      $c->addColChamp("Serv. plac.", $x);
      $x = new Label("", false, false, false, "suivpar");
      $c->addColChamp("Rf.", $x);
      $x = new Label("", false, false, false, "nom");
      $c->addColChamp("Nom", $x);
      $x = new Label("", false, false, false, "prenom");
      $c->addColChamp("Prnom", $x);
      $x = new Label("", false, false, false, "nous");
      $c->addColChamp("N us.", $x);
      $x = new Label("", false, false, false, "datouv");
      $c->addColChamp("Ouvert le", $x);
      $x = new Label("", false, false, false, "priorite");
      $c->addColChamp("Pri.", $x);
      $x = new Label("", false, false, false, "ttypesej");
      $c->addColChamp("Sjour", $x);
      $x = new Label("", false, false, false, "litdepuis");
      $c->addColChamp("Dbut souhait", $x);
      if ($tabliste->controleChamp("signets.id")){
	      $x = new Label("", false, false, false, "nomsignet");
	      $c->addColChamp("Signet", $x);
      }
      $c->addTitres(true);
      $of->addChamp($c);
      $this->addContenu($of->getContenu());
    }
  }
}
?>
