<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Liste des sjours d'observation
* @package formulaires
*/
/**
* Liste des sjours d'observation
* Affichage de tous les sjours d'observation pendants, avec ou sans les notes
* @package formulaires
* @author ob tnh
*/
class listeSO extends cadronglet{

 
   /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param int actif l'action principale ("Retour")
  * @param string fondpage la couleur du fond e page
  * @param string sessionid l'identifiant de session
  * @param int action_affichage l'action utilise pour afficher le formulaire
  * @param int options 1: afficher notes, 0: masquer notes
  */
  function listeSO($largeur, $grise, $actif, $fondpage, $sessionid, $action_affichage, $options){
    global $fichier;
    if ( !$this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid)) return;

    $join[] = "usagers";
    $join[] = "demandeor";
    $join[] = "typesejour";
    $join[] = "attributionlit";
    $join[] = "typesejour AS typesejour2";
    $join[] = "annoncelit";
    $join[] = "etablissements";
    $join[] = "signetsdossiers";
    $join[] = "signets";
    if ($options == 1) $join[] = "notes";

    $on[] = "dossiers.nous = usagers.nous";
    $on[] = "dossiers.nodoss = demandeor.nodoss";
    $on[] = "demandeor.typesej = typesejour.idts";
    $on[] = "dossiers.nodoss = attributionlit.nodoss";
    $on[] = "attributionlit.typesej = typesejour2.idts";
    $on[] = "attributionlit.nolit = annoncelit.nolit";
    $on[] = "demandeor.etsejobs = etablissements.noet";
    $on[] = "signetsdossiers.nodoss = dossiers.nodoss";
    $on[] = "signetsdossiers.idsignet = signets.id";
    if ($options == 1) $on[] = "dossiers.nodoss = notes.nodossier";
    
    $champs = "dossiers.nodoss, dossiers.datouv, dossiers.suivpar, usagers.nom, usagers.prenom, usagers.nous, " .
      "IF(etablissements.ger, \"Griatrie\", IF(etablissements.psychoger, \"Psychogr.\", IF(etablissements.psy, " .
      "\"Psychiatrie\", \"\"))) AS mission, " .
      "etablissements.nomet, attributionlit.dateval, signets.nomsignet" . 
      ($options == 1 ? ", concat(DATE_FORMAT(notes.date_creation, '%e.%m.%Y'), ' ', IF (notes.auteur IS NULL, '-', notes.auteur), ' ', notes.textnotes) as donneesnotes " : "");
      
    if ($options == 1) $order_notes = ",notes.date_creation"; else $order_notes = "";
    $tabliste = new EnsTableCompact("dossiers", 
                                    "dossiers.sejobs = -1 and dossiers.dateclo IS NULL and dossiers.nous > 0",
                                    $champs, "dossiers.nodoss".$order_notes,
                                    $this->idsession, $join, $on, false,
                                    "nodoss", "<BR>");


    // si l'utilisateur appuie sur le bouton Obtenir une feuille de calcul, action n'est pas entier
    // sinon il vient de la page principale et on affiche une page html contenant les donnes de la base
    if($action_affichage - floor($action_affichage) > 0.09) {
      $this->effaceEntete();
      $excel = new FeuilleExcel($tabliste, "liste_sejours_observation.xls");
      $excel->affiche();
    }
    else {
     
      $tabbande = array("Sjours d'observation", "", "", "", "");
      $this->addOnglet("Liste", $tabbande, "#8b8378", $this->actif, 80, "");
      $this->colmateOnglets();

      //Contenu
      $of = new OngForm();
      $of->setTabParam($this->largeur, $this->coulbande, 6);
      $of->setFormParam("donnees", $fichier, "post");


      $c = new TPanel(2, 1);
      $x = new Label("Il y a <B>" . $tabliste->compte() . "</B> dossiers");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1);
      $textebouton = ($options ? "Masquer notes" : "Afficher notes");
      $valeurbouton = ($options ? 0 : 1);
      $x = new BoutonTexte($textebouton, "$fichier?action=$action_affichage&sessionid=$this->idsession&options=$valeurbouton",
                           $grise, "100%", 1);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(3, 1, "RIGHT", "MIDDLE");
      $x = new Bouton("action", $action_affichage, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("options", $options, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("Obtenir", "Obtenir feuille de calcul", "BUTTON",
		      "document.forms.donnees.action.value=12.1;document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));                
      $x = new Bouton("Retour", "Retour", "SUBMIT",
                      "document.forms.donnees.action.value=" . $this->actif .
                      ";document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));

      $of->addChamp($c);
      $of->addLigne();
      $commentaire = ($options ? "donneesnotes" : "");
      $c = new TPanelTableau(6, 1, $tabliste, $this->grise, "dossiers", "nodoss", "", "", $commentaire, 500);
      $opt = new optionsBrioche();
      $opt->setOption("FORCE_DOSS", 1);
      $opt->setOption("LARG_FIX", 1);
      $x = new Lien("", false, false, false, "nodoss", "javascript:ouvreBrioche('brioche.php?action=1" .
		    "&sessionid=$this->idsession&item=&options=" . $opt->getChaine() . 
		    "', 830)");
      $c->addColChamp("N doss.", $x, false, true);
      $x = new Label("", false, false, false, "suivpar");
      $c->addColChamp("Rf.", $x);
      $x = new Label("", false, false, false, "nom");
      $c->addColChamp("Nom", $x);
      $x = new Label("", false, false, false, "prenom");
      $c->addColChamp("Prnom", $x);
      $x = new Label("", false, false, false, "nous");
      $c->addColChamp("N us.", $x);
      $x = new Label("", false, false, false, "mission");
      $c->addColChamp("Mission", $x);
      $x = new Label("", false, false, false, "nomet");
      $c->addColChamp("Etabl.", $x);
      $x = new Label("", false, false, false, "datouv");
      $c->addColChamp("Ouverture", $x);
      $x = new Label("", false, false, false, "dateval");
      $c->addColChamp("Evaluation", $x);
      if ($tabliste->controleChamp("signets.id")){
	      $x = new Label("", false, false, false, "nomsignet");
	      $c->addColChamp("Signet", $x);
      }
      $c->addTitres(true);
      $of->addChamp($c);
      $this->addContenu($of->getContenu());
    }

  }




}
?>
