<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Liste des services placeurs
* @package formulaires
*/
/**
* Liste des services placeurs
* Dossiers en suspens, classs par service placeur, avec possibilits de cibler les choix
* @package formulaires
* @author ob tnh cjd jdu
*/
class listeSP extends cadronglet{

  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param int actif l'action principale ("Retour")
  * @param string fondpage la couleur du fond e page
  * @param string sessionid l'identifiant de session
  * @param int action_affichage l'action utilise pour afficher le formulaire
  * @param int options 1: afficher notes, 0: masquer notes
  * @param array donnees le tableau post par le formulaire (no d'tablissement, prise en charge demande)
  */
  function listeSP($largeur, $grise, $actif, $fondpage, $sessionid, $action_affichage, $options, $donnees){
    global $fichier;
    if ( !$this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid)) return;
    $join[] = "usagers";
    $join[] = "demandeor";
    $join[] = "typesejour";
    $join[] = "attributionlit";
    $join[] = "typesejour AS typesejour2";
    $join[] = "etablissements";
    $join[] = "signetsdossiers";
    $join[] = "signets";
    if ($options == 1) $join[] = "notes";

    $on[] = "dossiers.nous = usagers.nous";
    $on[] = "dossiers.nodoss = demandeor.nodoss";
    $on[] = "demandeor.typesej = typesejour.idts";
    $on[] = "dossiers.nodoss = attributionlit.nodoss";
    $on[] = "attributionlit.typesej = typesejour2.idts";
    $on[] = "demandeor.servplac = etablissements.noet";
    $on[] = "signetsdossiers.nodoss = dossiers.nodoss";
    $on[] = "signetsdossiers.idsignet = signets.id";
    if ($options == 1) $on[] = "dossiers.nodoss = notes.nodossier";
    
    $champs = "dossiers.nodoss, IF(dossiers.sejobs = -1, \" *\", \"\") AS sejobs, " .
      "dossiers.suivpar, usagers.nom, usagers.prenom, usagers.nous, dossiers.datouv, " .
      "IF(typesejour2.ttypesej != \"\", typesejour2.ttypesej, typesejour.ttypesej) AS ttypesej, " .
      "IF(dossiers.priorite = 0, 10, dossiers.priorite) AS pri, etablissements.nomet, " .
      "IF(dossiers.priorite = 0, \"\", dossiers.priorite) AS priorite, signets.nomsignet" . 
      ($options == 1 ? ", concat(DATE_FORMAT(notes.date_creation, '%e.%m.%Y'), ' ', IF (notes.auteur IS NULL, '-', notes.auteur), ' ', notes.textnotes) as donneesnotes " : "") .
      ", demandeor.litdepuis AS litdepuis";

    $where = "dossiers.dateclo IS NULL and dossiers.nous > 0 " .
      "AND (dossiers.statut IS NULL OR dossiers.statut NOT IN (99, 100))";
    // si on a choisit un tablissement, alors on restreint la requte  cet tablissement
    
    if (! isset($donnees['noet'])) $donnees['noet'] = 0;
    else {
      $i = 0;
      foreach ($donnees['noet'] as $donnee) {
      	if ($donnee > 0) {
      	  if ($i==0) $where .= " AND (0=1";
          $where .= " OR demandeor.servplac = $donnee";
          $i = 1;
      	}
      }
      if ($i==1) $where .= ")";
    }

    if (!isset ($donnees['ttypesej'])) $donnees['ttypesej'] = 0;
    else {
      $i = 0;
      foreach ($donnees['ttypesej'] as $donnee) {
      	if ($donnee > 0) {
      	  if ($i==0) $where .= " AND (0=1";
      	    $where .= " OR IF(typesejour2.ttypesej != \"\", typesejour2.idts = $donnee , typesejour.idts = $donnee)";
      	    //$where .= " OR typesejour.idts = $donnee";
            //$where .= " OR typesejour2.idts = $donnee";
            $i = 1;
      	}
      }
      if ($i==1) $where .= ")";
    }
       
    if ($options == 1) $order_notes = ",notes.date_creation"; else $order_notes = "";
    $tabliste = new EnsTableCompact("dossiers",
                                    $where, 
                                    $champs, "etablissements.nomet, pri, dossiers.nodoss".$order_notes,
                                    $this->idsession, $join, $on, false,
                                    "nodoss", "<BR>", array(0 => 'nomet'));


    $join = "etablissements";
    $on = "demandeor.servplac = etablissements.noet";

    $champs = "etablissements.noet, etablissements.nomet, etablissements.actif";
    $etabl_liste = new ensTableBrioche("demandeor", 
				       "etablissements.nomet IS NOT NULL", 
				       $champs, "etablissements.actif, nomet",
				       $this->idsession, $join, $on, true);

    $typesej_liste = new ensTableBrioche("typesejour", "1", "idts, ttypesej", "", $this->idsession);

    // si l'utilisateur appuie sur le bouton Obtenir une feuille de calcul, action n'est pas entier
    // sinon il vient de la page principale et on affiche une page html contenant les donnes de la base
    if($action_affichage - floor($action_affichage) > 0.09) {
      $this->effaceEntete();
      $excel = new FeuilleExcel($tabliste, "liste_services_placeurs.xls");
      $excel->affiche();
    }

    else {
      $tabbande = array("Services placeurs", "", "", "", "");
      $this->addOnglet("Liste", $tabbande, "#8b8378", $this->actif, 80, "");
      $this->colmateOnglets();

      //Contenu
      $of = new OngForm();
      $of->setTabParam($this->largeur, $this->coulbande, 6);
      $of->setFormParam("donnees", $fichier, "post");


      $c = new TPanel(2, 1);
      $x = new Label("Il y a <B>" . $tabliste->compte() . "</B> dossiers   ---   * : sjours d'observation");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1);
      $textebouton = ($options ? "Masquer notes" : "Afficher notes");
      $valeurbouton = ($options ? 0 : 1);
      $x = new BoutonTexte($textebouton,
                           "javascript:document.forms.donnees.options.value=$valeurbouton;document.forms.donnees.submit();",
                           $grise, "100%", 1);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(3, 1, "RIGHT", "MIDDLE");
      $x = new Bouton("action", $action_affichage, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("options", $options, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("Obtenir", "Obtenir feuille de calcul", "BUTTON",
		      "document.forms.donnees.action.value=11.1;document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));                
      $x = new Bouton("Retour", "Retour", "SUBMIT",
                      "document.forms.donnees.action.value=" . $this->actif . 
                      ";document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      
      $of->addChamp($c);
      $of->addLigne();

      // liste droulante avec le nom des EMS et autres BRIO
      $c = new TPanel(6);
      $x = new listOptTableEtabl("donnees[noet][]", $donnees['noet'], $etabl_liste, $multiple=true, $size=4, 
			    $class="d2", $onchange="javascript:document.forms.donnees.action.value=".$action_affichage.
			    ";", $labellise=false);
      $x->addDefaut("&lt;Tous&gt;", "");
      $x->addOptionsEtablissements("nomet", "noet");
      $c->addChamp($x);
      $x = new ListOptTable("donnees[ttypesej][]", $donnees['ttypesej'], $typesej_liste, $multiple=true, $size=4, 
			    $class="d2", $onchange="javascript:document.forms.donnees.action.value=".$action_affichage.
			    ";", false);
      $x->addDefaut("&lt;Tous&gt;", "");
      $x->addOptions("ttypesej", "idts");
      $c->addChamp($x);
      $x = new Bouton("","Recherche","SUBMIT","");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();

      $commentaire = ($options ? "donneesnotes" : "");
      $c = new TPanelTableau(6, 1, $tabliste, $this->grise, "dossiers", "nodoss", "nomet", "", $commentaire, 500);
      $opt = new optionsBrioche();
      $opt->setOption("FORCE_DOSS", 1);
      $opt->setOption("LARG_FIX", 1);
      $x = new Lien("", false, false, false, "nodoss", "javascript:ouvreBrioche('brioche.php?action=1" .
		    "&sessionid=$this->idsession&item=&options=" . $opt->getChaine() . 
		    "', 830)");
      $c->addColChamp("N doss.", $x, false, true);
      $x = new Label("", false, false, false, "sejobs");
      $c->addColChamp("Obs.", $x);
      $x = new Label("", false, false, false, "suivpar");
      $c->addColChamp("Rf.", $x);
      $x = new Label("", false, false, false, "nom");
      $c->addColChamp("Nom", $x);
      $x = new Label("", false, false, false, "prenom");
      $c->addColChamp("Prnom", $x);
      $x = new Label("", false, false, false, "nous");
      $c->addColChamp("N us.", $x);
      $x = new Label("", false, false, false, "ttypesej");
      $c->addColChamp("Sjour", $x);
      $x = new Label("", false, false, false, "datouv");
      $c->addColChamp("Ouvert", $x);
      $x = new Label("", false, false, false, "priorite");
      $c->addColChamp("Pri.", $x);
      $x = new Label("", false, false, false, "litdepuis");
      $c->addColChamp("Dbut souhait", $x);
      if ($tabliste->controleChamp("signets.id")){
	      $x = new Label("", false, false, false, "nomsignet");
	      $c->addColChamp("Signet", $x);
      }
      $c->addTitres(true);
      $of->addChamp($c);
      $this->addContenu($of->getContenu());
    }
  }
}
?>
