<?php
// $Id: litCourtSejour.inc,v 1.1.1.1 2010-10-11 22:25:51 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Formulaire pour attribuer un lit de court sjour planning
* @package formulaires
*/
/**
* Formulaire pour attribuer un lit de court sjour planning
* Gre la squence de choix qui s'offrent  l'utilisateur lorsqu'il attribue
* un lit ou change les paramtres d'un sjour
* @package formulaires
* @author ob thn cjd jdu
*/
class litCourtSejour extends cadreSimple {

  /**
  * @param largeur la largeur du formulaire (en pixels ou %)
  * @param string fondpage la couleur de fond de la page
  * @param int action l'action principale
  * @param string sessionid l'identifiant de session
  * @param array donnees les donnes postes par le formulaire (tableau associatif)
  * @param int action2 action accessoire (affichage des proprits du sjour)
  */
  function litCourtSejour($largeur, $fondpage, $action, $sessionid, $donnees=0, $action2, $special = 0){
    global $fCourSej;
    $ini = new briocheIni();
    $autspec[0] = $ini->autSpec[2];
    if (! $this->cadreSimple($largeur, $fondpage, $sessionid, $autspec)) return;
    $tbx = array("controle", "nodoss", "etabl", "chambre", "lit", "depuis",
                 "jusqua", "choixdossier", "titre", "nolit", "urgent", "sortie_confirmee", 
                 "commentaire", "sexe", "horsStats", "datedecision");
    foreach($tbx as $elx){
      if (! isset($donnees[$elx])) $donnees[$elx] = "";
    }
    
    if ($action == 5) {
      $labeliseEMS = true;  
    } 
    else {
      $labeliseEMS = false;  
    }
    
    global $spedoss;
    $extr = new extrVar();
    $extr->extrait("spedoss");
    if ($spedoss == "") $spedoss = $special;
    if ($spedoss > 0) $opener = "opener."; else $opener = "";    
    
    $libre = false;
    $occupe = false;
    $passuite = false;
    $dt = 0;
      
    if ($donnees['controle']){ //les donnes tablissement, chambre, lit, dates ont t fournies
      if ($action == 5) { //Changement de lit en cours de sjour 
        $prev_cs = new ensTableBrioche("calendrier","noev = ".$donnees['titre'],"fin",0,$this->idsession);
        $prev_cs = $prev_cs->getTableau();
        $donnees['jusqua'] = $prev_cs[0]->fin;
        
        if($donnees['depuis'] && $donnees['jusqua']){
          	$deb = connexionBrioche::dateFr2tst($donnees['depuis']);
          	$fin = connexionBrioche::dateFr2tst($donnees['jusqua']);
        }
        
        $from = date("Ymd",$deb);
		$to = date("Ymd",$fin);
		$litexiste = new ensTableBrioche("litscourtsejour",
		"etabl = " . $donnees['etabl'] . " AND chambre = " . $donnees['chambre'] . " AND lit = " . $donnees['lit'] . " AND " .
		"(ISNULL(debut) OR debut <= " . $from . ") AND (ISNULL(fin) OR fin >= " . $to . ")",
		"*",0,$this->idsession);
		
		$litexiste = $litexiste->compte();
    		
	    $occupe = false;
		if ($litexiste == 0) {
			$al = new Alerte("Ce lit n\'est pas disponible sur toute la priode");
			$al->imprime();
	    	$occupe = true;
		}  
        if ($donnees['depuis'] && $donnees['controle'] == 2) {
            
          $deb = connexionBrioche::dateFr2tst($donnees['depuis']);
          $fin = connexionBrioche::dateFr2tst($donnees['jusqua']);
          $moisdeb = date("n", $deb);
          $andeb = date("Y", $deb);

          $data = new ensTableBrioche("calendrier", "actif = 1 AND nodoss=" .
                                      $donnees['nodoss'], "noev, debut, fin, csprec", 0, $this->idsession);
          $count = $data->compteTotal();
          $data = $data->getTableau();
          $ldd = 0;
          $hdf = 0;
          
          foreach ($data as $d) {
            $dd = explode(".", $d->debut);
            $df = explode(".", $d->fin);
            $dd = mktime(0, 0, 0, $dd[1], $dd[0], $dd[2]);
            $df = mktime(0, 0, 0, $df[1], $df[0], $df[2]);
            if ($dd < $ldd || $ldd == 0) $ldd = $dd;
            if ($df > $hdf || $hdf == 0) $hdf = $df;           
          }
          
          $donnees_temp = $donnees;
          $donnees_temp['titre'] = 0;
          $donnees_temp['depuis'] = date("d.m.Y", $ldd);
          $donnees_temp['jusqua'] = date("d.m.Y", $hdf);
                    
          $new_cs = new grilleOccupation($deb, 0, $this->idsession, $fin, $donnees_temp, $autspec);
          
          $dt = $new_cs->attribueLit(0, 0);
          
          if ($dt){
            
            // Modifier le prec_cs du court-sjour suivant s'il existe
            $tabchamps3['csprec'] = $dt;
            $upd_cs3 = new updateTableBrioche("calendrier",$tabchamps3,$donnees['titre'],"csprec",$this->idsession);
            $upd_cs3->update();
                       
            // Mise  jour des dates de la deuxime partie du court-sjour
            $tabchamps2['debut'] = $donnees['depuis'];
            $tabchamps2['csprec'] = $donnees['titre'];
            $upd_cs2 = new updateTableBrioche("calendrier",$tabchamps2,$dt,"noev",$this->idsession);
            $upd_cs2->update();
          
            // Changement de la date de fin de la premire partie du court-sjour
            $tabchamps1['fin'] = $donnees['depuis'];
            $upd_cs1 = new updateTableBrioche("calendrier",$tabchamps1,$donnees['titre'],"noev",$this->idsession);
            $upd_cs1->update();          
                                  
            // Recherche et fusion d'ventuels sjours fragments dans le mme lit
            $new_cs->fusionneFragments();
            $donnees['titre'] = $dt;
            
            print "<SCRIPT LANGUAGE=\"JavaScript\">;window.".$opener."opener.document.donnees.submit();</SCRIPT>";
            $al = new Alerte("Opration effectue !");
            $al->imprime();
            print "<SCRIPT LANGUAGE=\"JavaScript\">window.location=\"$fCourSej?action=$action2&sessionid=$this->idsession&item=" .
                  $donnees['titre'] . "\";</SCRIPT>";
          }
          
          if($dt){
            $attribution = true;
            $occupe = false;
          }
          else {
            $occupe = true;
            $attribution = false;
          }         
           
        }
        
      }
      else {
      // Il ne s'agit pas d'un changement de lit en cours de sjour
		  if($donnees['depuis'] && $donnees['jusqua']){
          	$deb = connexionBrioche::dateFr2tst($donnees['depuis']);
          	$fin = connexionBrioche::dateFr2tst($donnees['jusqua']);
          	if (! $donnees['nodoss']){ //Bloquer un lit -> dossier = -999
            $donnees['nodoss'] = -999;
          }
			
          $from = date("Ymd",$deb);
          $to = date("Ymd",$fin);
          $litexiste = new ensTableBrioche("litscourtsejour",
          "etabl = " . $donnees['etabl'] . " AND chambre = " . $donnees['chambre'] . " AND lit = " . $donnees['lit'] . " AND " .
          "(ISNULL(debut) OR debut <= " . $from . ") AND (ISNULL(fin) OR fin >= " . $to . ")",
          "*",0,$this->idsession);
          $litexiste = $litexiste->compte();
          
          $noev = $donnees['titre'];
        
          $data = new ensTableBrioche("calendrier",
                                      "actif = 1 AND noev != $noev AND nodoss=" . $donnees['nodoss'],
                                      "noev,debut,fin,csprec", 0, $this->idsession);
          $count = $data->compte();
          $data = $data->getTableau();
          $ldd = 0;
          $hdf = 0;
          $data[$count]->noev = 0;
          $data[$count]->debut = $donnees['depuis'];
          $data[$count]->fin = $donnees['jusqua'];
          $data[$count]->csprec = 0;
          foreach ($data as $d) {
            $dd = explode(".",$d->debut);
            $df = explode(".",$d->fin);
            $dd = mktime(0,0,0,$dd[1],$dd[0],$dd[2]);
            $df = mktime(0,0,0,$df[1],$df[0],$df[2]);
            if ($dd < $ldd || $ldd == 0) $ldd = $dd;
            if ($df > $hdf || $hdf == 0) $hdf = $df;           
          }
        
          $donnees_temp_2 = $donnees;
          $donnees_temp_2['depuis'] = date("d.m.Y", $ldd);
          $donnees_temp_2['jusqua'] = date("d.m.Y", $hdf);
                
          $gr = new grilleOccupation($deb, 0, $this->idsession, $fin, $donnees_temp_2, $autspec);
          //Contrle de disponibilit du lit
          $moisdeb = date("n", $deb);
          $andeb = date("Y", $deb);
          if (($fin - $deb)/SEC_PAR_JOUR > 366){
            $al = new Alerte("La dure ne peut excder une anne");
            $al->imprime();
            $occupe = true;
          }
          if ($fin - $deb < 0){
            $al = new Alerte("Dure ngative !");
            $al->imprime();
            
            $occupe = true;
          }
          if ($litexiste == 0) {
          	$al = new Alerte("Ce lit n\'est pas disponible sur toute la priode");
            $al->imprime();
            $occupe = true;
          }
          if ($donnees['controle'] == 2 && $occupe == false){// Donnes compltes => attribution
            //Ecriture dans le calendrier
          
            $dt = $gr->attribueLit($donnees['titre'], $donnees['nolit']);
            if (! $donnees['titre']) {
              $donnees['titre'] = $dt; 
            }
            if ($donnees['titre']){
              if ($donnees['nodoss'] == -999){
                $passuite = true;
              }  
              if ($dt){
                $gr->fusionneFragments();
                print "<SCRIPT LANGUAGE=\"JavaScript\">window.".$opener."opener.document.donnees.submit();</SCRIPT>";
                $al = new Alerte("Opration effectue !");
                $al->imprime();
              
                print "<SCRIPT LANGUAGE=\"JavaScript\">window.location=\"$fCourSej?action=$action2&sessionid=$this->idsession&item=" .
                      $donnees['titre'] . "\";</SCRIPT>";
              
              }
            }
            if($dt){
              $attribution = true;
              $occupe = false;
            }
            else {
              $occupe = true;
              $attribution = false;
            }
          }
          else {
            $libre = $gr->checkDisponibilite($donnees['titre']);
            if (! $libre){
              $occupe = true;
              $attribution = false;
            }
            else {
              $attribution = true;
              $occupe = false;
            }
           
          }  
        
        }
      }   
    }
    //Dessin du formulaire        
    $tf = new TabForm();
    $tf->setTabParam($largeur, 0, 3, 0, $fondpage);
    $tf->setFormParam("donnees", $fCourSej, "post");
    //Action des boutons Bloquer et Attribuer
    $actionBtAttr = "for(i=0;i<document.forms.donnees.elements.length;i++){if(document.forms.donnees.elements[i].name==\"donnees[controle]\")" .
                    "{document.forms.donnees.elements[i].value=\"2\";".$opener."opener.document.getElementById(\"RefreshAlert\").style.display=\"none\";document.forms.donnees.submit()}}";
    if (1){ //BRIO--- EMS pas encore implment
      $etablissements = new EnsTableBrioche("etablissements", "courplan = -1", "noet, nomet", "nomet", $this->idsession);
    }
    else {  //EMS
      $etablissements = new ensTableBrioche("etablautorises", "etablautorises.idut = $this->nout",
                                            "etablissements.noet,  etablissements.nomet", 0, $this->idsession,
                                            "etablissements", "etablautorises.etabl = etablissements.noet",
                                            false, $autspec);
      }
      
    if ($spedoss > 0) {
        $usager = new ensTableBrioche("usagers, dossiers","dossiers.nous = usagers.nous AND dossiers.nodoss = $spedoss","*",0,$this->idsession);
        $usager = $usager->getTableau();
        $usager = $usager[0];
        $usager = "<b>(".$usager->nom." ".$usager->prenom.")</b>";
    } else $usager = "";
      
    $c = new TPanel(6, 1);
    $txt = ($donnees['titre'] ? "Modifier le sjour" : "Attribuer un lit");
    if ($action == 5) $txt = "Changement de lit en cours de sjour";
    $x = new Label("<H3>$txt $usager</H3>");
    $c->addChamp($x);
    
    if ($spedoss > 0) {
        $x = new Bouton("spedoss",$spedoss,"HIDDEN");
        $c->addChamp($x);
    }
       
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TPanel(6, 1);
    $x = new Bouton("donnees[titre]", $donnees['titre'], "HIDDEN");
    $c->addChamp($x);
    $x = new Label("Etablissement&nbsp;:");
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    if ($etablissements->compte() > 1) {
      $x = new ListOptTable("donnees[etabl]", $donnees['etabl'], $etablissements, false, 0,
                            "d2", "document.forms.donnees.submit();", $labeliseEMS);
      $x->addDefaut("---", "");
      $x->addOptions("nomet", "noet");
      $c->addChamp($x);
    }
    else {
      $tablet = $etablissements->getTableau();
      $x = new Label($tablet[0]->nomet);
      $c->addChamp($x);
      $x = new Bouton("donnees[etabl]", $tablet[0]->noet, "HIDDEN");
      $c->addChamp($x);
    }
    $c->addChamp(new Espace(3));
    if ($donnees['etabl']){
      $chparet = new EnsTableBrioche("litscourtsejour", "etabl = " . $donnees['etabl'] , "chambre",
                                     "chambre", $this->idsession, "", "", true, $autspec);
      $chprem = $chparet->getTableau();
      $x = new Label("Ch.&nbsp;:&nbsp;");
      $c->addChamp($x);
      $x = new ListOptTable("donnees[chambre]", $donnees['chambre'], $chparet, false, 0, "d2", "document.forms.donnees.submit();", false);
      //$x->addDefaut("---", "-");
      $x->addOptions("chambre", "chambre");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      if ($donnees['chambre']){
        $litparch = new EnsTableBrioche("litscourtsejour", "etabl = $donnees[etabl] AND chambre = $donnees[chambre]",
                                        "lit", "lit", $this->idsession, 0, 0, false, $autspec);
        if ($litparch->compteTotal() == 0) {
          $litparch = new EnsTableBrioche("litscourtsejour", "etabl = $donnees[etabl] AND chambre = ".$chprem[0]->chambre,
                                            "lit", "lit", $this->idsession, 0, 0, false, $autspec);
        }
        $x = new Label("Lit&nbsp;:&nbsp;");
        $c->addChamp($x);
        $x = new ListOptTable("donnees[lit]", $donnees['lit'], $litparch, false, 0, "d2", "document.forms.donnees.submit();", false);
        //$x->addDefaut("---", "-");
        $x->addOptions("lit", "lit");
        $c->addChamp($x);
        $c->addChamp(new Espace(3));
        
        if ($donnees['lit']){
          $tf->addChamp($c);
          $tf->addLigne();
          
          $sej = new sejourEvenement($donnees['titre'], $this->idsession);
          
          if ($action == 5) { // Chgt en cours de sjour
            $c = new TPanel(6, 1);
            $x = new ChampTexte("donnees[depuis]", $donnees['depuis'], "Changement de lit le : ", 15, 15, false, "text", "d2",
                                "controleDate('donnees[depuis]', '', 365, 365,'','',false,'".$donnees['depuis']."','".$donnees['jusqua']."'); ",
                                "", false, true);
            $c->addChamp($x);
            $c->addChamp(new Espace(3));            
          } 
          else { // pas de chgt en cours de sjour
            $c = new TPanel(6, 1);
            $x = new ChampTexte("donnees[depuis]", $donnees['depuis'], "Sjour du&nbsp;:&nbsp;", 15, 15, false, "text", "d2",
                                "controleDate('donnees[depuis]', '', 365, 365,'donnees[depuis]','donnees[jusqua]')", "",
                                $sej->hasPrecedent(), true);
            $c->addChamp($x);
            $c->addChamp(new Espace(3));
            $x = new ChampTexte("donnees[jusqua]", $donnees['jusqua'], "jusqu'au&nbsp;:&nbsp;", 15, 15, false, "text", "d2",
                                "controleDate('donnees[jusqua]', '', 365, 400,'donnees[depuis]','donnees[jusqua]')",
                                "", $sej->hasSuivant(), true);
            $c->addChamp($x);
            $c->addChamp(new Espace(3));
          }
          
    // choix urgent ou non    
    $x = new ListOpt("donnees[urgent]", $donnees['urgent'], false, 0, "", "", false);
    $x->addOption("Non urgent", 0);
    $x->addOption("Urgent", 1);
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();

    // Date de passage en long sjour
    $c = new TPanel(6, 1);
    $x = new ChampTexte("donnees[datedecision]", $donnees['datedecision'], 
                        "Date dcision (court sjour transform en long sjour selon SASH)&nbsp;:&nbsp;",
                        15, 15, false, "text", "d2",
                        "controleDate('donnees[datedecision]', '', 365, 400, '', '', '', 
                                      document.forms['donnees'].elements['donnees[depuis]'].value,
                                      document.forms['donnees'].elements['donnees[jusqua]'].value)",
                        "", false, true);
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    
    // Sjour hors statistiques
    $c = new TPanel(6, 1);
    $x = new CheckBox("donnees[horsStats]", 1, 
    "Sjour hors statistiques (lit indisponible temporairement, travaux rnovation, etc.)", $donnees['horsStats']);
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    
    // choix sortie confirme ou non  
    $c = new TPanel(3, 1, "LEFT", "", "50%");
    $x = new ListOpt("donnees[sortie_confirmee]", $donnees['sortie_confirmee'], false, 0, "", "", false);
    $x->addOption("Date de sortie non confirme", 0);
    $x->addOption("Date de sortie confirme", 1);
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();        
    
    // commentaire
    $c = new TPanel(6, 1);
    $x = new TextArea("donnees[commentaire]", $this->deguille($donnees['commentaire']),
                      "Commentaire :", 63, 3);
    $c->addChamp($x);

      $x = new Bouton("donnees[controle]", "1", "HIDDEN");
      $c->addChamp($x);
      $tf->addChamp($c);
      $tf->addLigne();
    $c = new TPanel(6, 1);
        }
      }
    }

    // indique si on a affich la liste droulante pour le sexe
    $sexe_affiche = false;

    if (isset($attribution) && $attribution && $spedoss == 0){ //Les conditions ncessaires  l'attribution du lit sont remplies.
      if (! $donnees['choixdossier'] && $donnees['controle'] != 2 && (! $donnees['nodoss'] || $donnees['nodoss'] == -999)){
        $c = new TPanel(6, 1);
        $x = new Bouton("Bloquer", "Bloquer", "BUTTON", $actionBtAttr);
        $c->addChamp($x);
        $c->addChamp(new Espace(2));

  // Choix sexe pour le lit non attribu  un dossier
  $x = new Label("Sexe : ");
        $c->addChamp($x);
  
  $sexe_affiche = true;
  $x = new ListOpt("donnees[sexe]", $donnees['sexe']);
  $x->addOption("---", '');
  $x->addOption("Femme", 'F');
  $x->addOption("Homme", 'M');
  $c->addChamp($x);
        $x = new Label("<BR>(Bloquer un lit sans l'attribuer  un dossier particulier, toutefois prciser le sexe si connu)", false, true);
        $c->addChamp($x);
        $tf->addChamp($c);
        $tf->addLigne();

        $c = new TPanelCadre(6, 1, "", "", "", "Attribuer  : ");
        $x = new GrBoutonRadio("donnees[choixdossier]", $donnees['choixdossier']);
        $x->addRadio("Dossier existant", 1);
        $x->addRadio("Nouveau dossier", 2);
        $c->addChamp($x);
      }
      else {
        $x = new Bouton("donnees[choixdossier]", $donnees['choixdossier'], "HIDDEN");
        $c->addChamp($x);  
      }
    } elseif (isset($attribution) && $attribution && $spedoss > 0) {
        $donnees['nodoss'] = $spedoss;
    }
    
    // si la liste droulante pour le sexe n'a pas t affiche, il faut alors qu'on sauve la valeur dans un champ cach
    if (!$sexe_affiche) {
      $x = new Bouton("donnees[sexe]", $donnees['sexe'], "HIDDEN");
      $c->addChamp($x);
    }

    $champs = "dossiers.nodoss, IF (usagers.inactif = 0, " .
    "CONCAT(usagers.nom, \" \", usagers.prenom, \" (\", dossiers.nodoss, \")\"), " .
    "CONCAT(\"(\", usagers.nom, \" \", usagers.prenom, \" (\", dossiers.nodoss, \"))\")) " .
    "AS libelle";

    $dossier_a_attribuer = false;
    if (!$donnees['nodoss'] || $donnees['nodoss'] == -999) {
      switch($donnees['choixdossier']){
      case 1: //Attribution  un dossier existant (limiter au seul BRIO ?)
        $c = new TLabel("Vous pouvez choisir parmi tous les dossiers en attente dont l'issue n'est pas spcifie ou " .
                        "dont l'issue est un court sjour sans lit pralablement attribu.", false, true);
        $c->setColSpan(6);
        $tf->addChamp($c);
        $tf->addLigne();
        $c = new TPanel(6, 1);
        $where = "dossiers.dateclo IS NULL AND dossiers.nous > 0 AND dossiers.sejobs IS NULL " .
                 "AND (issue.issue = 0 OR (issue.issue IN (2, 5) AND attributionlit.nolit IS NULL))";
        $join[] = "usagers";
        $join[] = "issue";
        $join[] = "attributionlit";
        $on[] = "dossiers.nous = usagers.nous";
        $on[] = "dossiers.nodoss = issue.nodoss";
        $on[] = "dossiers.nodoss = attributionlit.nodoss";
        $tblist = new ensTableBrioche("dossiers", $where, $champs, "usagers.nom, usagers.prenom",
                                      $this->idsession, $join, $on);
        if ($spedoss == 0) $spedoss = $donnees['nodoss'];
        $x = new ListOptTable("donnees[nodoss]", $spedoss, $tblist, false, 0, "d2");
        $x->addDefaut("---", "");
        $x->addOptions("libelle", "nodoss");
        $c->addChamp($x);
        break;
      case 2: //Ouverture d'un nouveau dossier
        $opt = new optionsBrioche();
        $opt->setOption("MODE", 4);
        $opt->setOption("NOUV_US", 1);
        $opt->setOption("NOUV_DOSS", 1);
        $opt->setOption("LARG_FIX", 1);
        $passuite = true;
        $c = new TPanel(1,1);
        $x = new Label("<FONT COLOR=\"red\">Veuillez saisir une demande d'orientation et envoyer...</FONT>");
        $c->addChamp($x);
        $tf->addChamp($c);
        $tf->addLigne();
        $c = new Tpanel(6, 1);
        $x = new Bouton("Saisir", "Saisir", "BUTTON",
                        "ouvreBrioche(\"brioche.php?action=1&sessionid=$this->idsession&item=-999&lcs[typesej]=5&lcs[litdepuis]=" .
                        $donnees['depuis'] . "&options=" . $opt->getChaine() . "\", 830);");
        $c->addChamp($x);
        $x = new Bouton("donnees[nodoss]", $donnees['nodoss'], "HIDDEN");
        $c->addChamp($x);
        $tf->addChamp($c);
        $tf->addLigne();
        break;
      }
    }
    else { //un dossier a dj t attribu
      $tblist = new ensTableBrioche("dossiers", "dossiers.nodoss = $donnees[nodoss]", $champs, 0,
                                    $this->idsession, "usagers", "dossiers.nous = usagers.nous");
      $tbl = $tblist->getTableau();
      $c = new TPanel(6, 1);
      $x = new Label($tbl[0]->libelle);
      $c->addChamp($x);
      $x = new Bouton("donnees[nodoss]", $tbl[0]->nodoss, "HIDDEN");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $tf->addChamp($c);
      $tf->addLigne();
      $dossier_a_attribuer = true;
      $passuite = true;
    }
    if (! $passuite){
      $x = new Bouton ("Suite", "-->", "SUBMIT");
      $c->addChamp($x);
      $tf->addChamp($c);
      $tf->addLigne();
    }
    
    $c = new TPanel(6, 1, "RIGHT");
    // Bouton d'action Attribuer ou Changer    
    if ((($donnees['controle'] != 2  && ! $occupe) || ! $dt) && $dossier_a_attribuer) {
      $txt = ($donnees['titre'] ? "Changer" : "Attribuer");
      $x = new Bouton("Attribuer", $txt, "BUTTON", $actionBtAttr);
      $c->addChamp($x);
      $c->addChamp(new Espace(2));
    }

    // Bouton d'action Recommencer
    if (! $donnees['titre']){
      $x = new Bouton("Recommencer", "Recommencer", "BUTTON",
                      "for(i=0; i<document.forms.donnees.elements.length; i++)" .
                      "{if(document.forms.donnees.elements[i].name.indexOf(\"donnees\") >= 0)" .
                      "{document.forms.donnees.elements[i].value=\"\"}};document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(2));
    }

    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("action", $action, "HIDDEN");
    $c->addChamp($x);    
    $x = new Bouton("Fermer", "Fermer", "BUTTON", "window.close()");
    $c->addChamp($x);
    $tf->addChamp($c);
    $this->addContenu($tf->getContenu());    
  }
}



?>
