<?php
  // $Id: litsBrioche.inc,v 1.1.1.1 2010-10-11 22:25:53 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Tableau des lits
* @package formulaires
*/
/**
* Tableaux des lits
* Accessible depuis le menu principal de brioche ou depuis le dossier, prsentation diffrencie
* selon les utilisations de l'utilisateur. Utilis aussi pour l'attribution des lits (liste des lits attribuables)
* @package formulaires
* @author ob tnh
*/
class litsBrioche extends cadronglet{
  /**
  * les options telles que passes par le formulaire (chane de caractres)
  * @var string
  */
  var $options;

  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param int l'action de l'onglet actif
  * @param string fondpage la couleur de fond de la page
  * @param string sessionid l'identifiant de session
  * @param string options cf. variable de classe
  * @param int item le numro de dossier (lors de l'attribution d'un lit)   
  * @param array donnees un tableau de donnes postes (ne contenant que l'indication de pagination)
  */
  function litsBrioche($largeur, $grise, $actif, $fondpage, $sessionid, $options, $item=0, $donnees = array()){
    global $fdosbrioche;
    global $imagesdir;
    $cles = array('page', 'sejour', 'mission', 'sexe', 'ems');
    foreach ($cles as $cle){
      if (! isset($donnees[$cle])) $donnees[$cle] = "";
    }
    $this->options = $options;
    $opt = new optionsBrioche($this->options);
    $futuropt = new optionsBrioche($this->options);
    $optdossier = new optionsBrioche($this->options);
    $optdossier->setOption("FORCE_DOSS", 1);
    $optdossier->setOption("MODE", 0);
    $ini = new briocheIni();
    $autspec = array();
    
    if ($opt->getOption("CONS_LITS")){
      $autspec[0] = $ini->autSpec[0];
      $autspec[1] = $ini->autSpec[1];
    }
    if ( !$this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid, $autspec)) return; 
    
    // Si l'utilisateur ne dispose pas des droits d'criture dans le dossier Brioche, 
    //il accde en mode consultation seule (=> pas de liens dans
    // les tableaux.
    $interditLiens = false;
    if (! $this->verifAut($ini->autReq, $this->autorisations)){
      $interditLiens = true;      
    }
    $tabbande = array("Liste des lits disponibles", "", "", "", "");
    $act = ($this->actif == 4002 ? 4001 : $this->actif);
    $this->addOnglet("Disponibles", $tabbande, "#8b8378", $act, 80,
                     "$fdosbrioche?action=$act&sessionid=$this->idsession&options=$this->options");
    $tabbande = array("Liste des lits attribus", "", "", "", "");
    if ($this->actif < 4003 && ! $opt->getOption("CONS_LITS")) {
      $this->addOnglet("Attribus", $tabbande, "#8b8378", 4002, 80,
                       "$fdosbrioche?action=4002&sessionid=$this->idsession&options=$this->options");
    }
    $this->colmateOnglets();
    //Contenu
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fdosbrioche, "post");
    $c = new TPanel(4, 1);
    $c->addChamp(new Espace(1));
    $x = new Aide("C0003");
    $c->addChamp($x);        
    $of->addChamp($c);
    $c = new TPanel(2, 2, "RIGHT", "MIDDLE");
    if ($opt->getOption("CONS_LITS")){
      $x = new Bouton("Retour", "Retour", "BUTTON", "changeChamp(\"action\", 1, \"donnees\");document.forms.donnees.submit();");
    }
    else {
      $x = new Bouton("Fermer", "Fermer", "BUTTON", "window.close()");
    }
    $c->addChamp($x);
    $c->addChamp(new Espace(4));
    //     $c->addChamp(new Espace(3));
    $of->addChamp($c);
    $of->addLigne();
    $join[] = "attributionlit";
    $join[] = "etablissements";
    $join[] = "sexelit";
    $join[] = "typesejour";
    $join[] = "missions";
    $on[] = "annoncelit.nolit = attributionlit.nolit";
    $on[] = "annoncelit.etabl = etablissements.noet";
    $on[] = "annoncelit.sexlit = sexelit.idsexe";
    $on[] = "annoncelit.stlit = typesejour.idts";
    $on[] = "annoncelit.mission = missions.nomission";
    switch ($this->actif){
    case 4001: //lits disponibles
      $opt = new optionsBrioche($this->options);
      $masqueres = $opt->getOption("MASQ_RES");
      $lidisp = new EnsTableBrioche("annoncelit", "(attributionlit.dateplac IS NULL OR attributionlit.dateplac > now())" .
                                    ($masqueres ? " AND attributionlit.dateres IS NULL AND attributionlit.dateplac IS NULL" : "")
				    . " AND annoncelit.stlit != " . COURTS_SEJOURS_PLANIFIES
                                    , "annoncelit.*, etablissements.*, sexelit.*, typesejour.*, missions.*, attributionlit.nodoss," .
                                      " attributionlit.dateres, attributionlit.dateplac"
                                    , "annoncelit.nolit desc", $this->idsession,
                                    $join, $on, false, $autspec);
      $opt2 = new optionsBrioche($this->options);
      $opt2->setOption("MASQ_RES",  ! $masqueres);
      $c = new TPanel(2);
      $txt = ($masqueres ? "Afficher" : "Masquer") . " les lits rservs";
      $x = new BoutonTexte($txt, "javascript:window.location='$fdosbrioche?action=4001&sessionid=$this->idsession&options=" .
                        $opt2->getChaine() .
                        "';", $grise, "100%", 1);
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      break;
    case 4002: //lits attribus
      $futuropt->setOption("MASQ_RES", 2);
      
      $lidisp = new EnsTableBrioche("annoncelit", "attributionlit.dateplac <= now() AND attributionlit.dateplac IS NOT NULL", "*", "annoncelit.nolit desc", $this->idsession, $join, $on);
      break;
    case 4003: //lits attribuables
      $dossier = new EnrBrioche($item, $this->idsession);
      $parametres = $dossier->getEnr("attributionlit");
      $usager = $dossier->getEnr("usagers");
      switch ($parametres->typesej){
      case 0:
        $stlit = 0;
        break;
      case 1:
      case 2:
        $stlit = " IN(1,4)";
        break;
      case 3:
        $stlit = " IN(3,4)";
      }
      $where = "attributionlit.idplac IS NULL" .
               " AND (attributionlit.typesej <> 99 OR attributionlit.typesej IS NULL)" .
               "AND annoncelit.sexlit IN" .($usager->sexe == "M" ?  "(1,3)" : "(2,3)") .
               ($parametres->dateplac ? " AND annoncelit.litdepuis <= " . $dossier->getDateAm($parametres->dateplac) : "") .
               ($parametres->mission ? " AND annoncelit.mission = " . $parametres->mission : "") .
               ($stlit ? " AND annoncelit.stlit" . $stlit : "");
      $lidisp = new EnsTableBrioche("annoncelit", "$where", "annoncelit.*, etablissements.*, sexelit.*, typesejour.*, " .
                                    "missions.*, attributionlit.nodoss," .
                                    " attributionlit.dateres, attributionlit.dateplac", 0, $this->idsession, $join, $on);
      break;
    }

    
    
    
    if ($this->actif != 4003) {
      
      // TRI ...
      // Compltion de la clause where en fonction des options
      if ($donnees['ems'] && $donnees['ems'][0]) {
        $lidisp->setWhere($lidisp->where . " AND (0 ");
        foreach ($donnees['ems'] as $cle => $valeur){
          $lidisp->setWhere($lidisp->where . " OR etablissements.noet = $valeur");
        }
        $lidisp->setWhere($lidisp->where . ")");
      }
      if ($donnees['sejour']) {
        $lidisp->setWhere($lidisp->where . " AND (0 ");
        foreach ($donnees['sejour'] as $cle => $valeur){
          $lidisp->setWhere($lidisp->where . " OR stlit = $cle");
        }
        $lidisp->setWhere($lidisp->where . ")");
      }
      if ($donnees['mission']) {
        $lidisp->setWhere($lidisp->where . " AND (0 ");
        foreach ($donnees['mission'] as $cle => $valeur){
          $lidisp->setWhere($lidisp->where . " OR annoncelit.mission = $cle");
        }
        $lidisp->setWhere($lidisp->where . ")");
      }
      if ($donnees['sexe']) {
        $lidisp->setWhere($lidisp->where . " AND (0 ");
        foreach ($donnees['sexe'] as $cle => $valeur){
          $lidisp->setWhere($lidisp->where . " OR annoncelit.sexlit = $cle");
        }
        $lidisp->setWhere($lidisp->where . ")");
      }
      
      
      $c = new TPanelCadre(5, 1, "LEFT", "MIDDLE", "", "N'afficher que&nbsp:");
      // ... par tablissements
      $ecase = new ensTableBrioche("etablissements", "(litsC OR litsD) AND NOT(autbrio)", "noet, nomet, actif",
                                 "actif, groupepriorite, nomet", $this->idsession, "", "", false, $autspec);
      $tecase = $ecase->getTableau();
      $x = new Label("Etablissements :&nbsp;", true, false, true);
      $c->addChamp($x);
      $x = new ListOptTableEtabl("donnees[ems][]", $donnees['ems'], $ecase, true, 5, "d2", "document.forms.donnees.submit();", false, true);
      $x->addDefaut("---", 0);
      $x->addOptionsEtablissements("nomet", "noet");
      $c->addChamp($x);                                 
      // ... par sjour
      $ecase = new ensTableBrioche("typesejour", "ordrelits > 0", "idts, ttypesej", "ordrelits", $this->idsession,
                                   "", "", false, $autspec);
      $tecase = $ecase->getTableau();
      $cpt = count($tecase);
      $x = new Label("Statut lit :&nbsp;", true);
      $c->addChamp($x);
      for ($i = 0; $i < $cpt; $i++) {                             
        $ind = $tecase[$i]->idts;
        if(!isset($donnees['sejour'][$ind])) $donnees['sejour'][$ind] = 0;
        $x = new AutoCase("donnees[sejour][$ind]", $donnees['sejour'][$ind], $tecase[$i]->ttypesej,
                          ($i == ($cpt-1)), "document.forms.donnees.submit();");
        $c->addChamp($x);    
      }
      // ... par mission
      $ecase = new ensTableBrioche("missions", "1", "nomission, txtmission", "nomission", $this->idsession, 
                                   "", "", false, $autspec);
      $tecase = $ecase->getTableau();
      $cpt = count($tecase);
      $x = new Label("Mission :&nbsp;", true);
      $c->addChamp($x);
      for ($i = 0; $i < $cpt; $i++){
        $ind = $tecase[$i]->nomission;
        if (!isset($donnees['mission'][$ind])) $donnees['mission'][$ind] = 0;
        $x = new AutoCase("donnees[mission][$ind]", $donnees['mission'][$ind], $tecase[$i]->txtmission,
                          ($i == ($cpt-1)), "document.forms.donnees.submit();");
        $c->addChamp($x);
      }  
      // ... par sexe
      $ecase = new ensTableBrioche("sexelit", "1", "idsexe, sexe", "idsexe", $this->idsession, 
                                   "", "", false, $autspec);
      $tecase = $ecase->getTableau();
      $cpt = count($tecase);
      $x = new Label("Sexe :&nbsp;", true);
      $c->addChamp($x);
      for ($i = 0; $i < $cpt; $i++){
        $ind = $tecase[$i]->idsexe;
        if (!isset($donnees['sexe'][$ind])) $donnees['sexe'][$ind] = 0;
        $x = new AutoCase("donnees[sexe][$ind]", $donnees['sexe'][$ind], $tecase[$i]->sexe,
                          ($i == ($cpt-1)), "document.forms.donnees.submit();");
        $c->addChamp($x);
      }  
      
      
      $of->addChamp($c);
      $of->addLigne();    
    }    
    
    $pag = new Pagination($lidisp, "lits", "donnees", "donnees[page]", 100, $donnees['page']);
    $c = new TPanel(12, 1);
    $x = new Bouton("donnees[page]", $donnees['page'], "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("action", $this->actif, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("options", $futuropt->getChaine(), "HIDDEN");
    $c->addChamp($x);
    $c->addChamp($pag);
    $of->addChamp($c);
    $of->addLigne();
        
   
        
    $futuropt->setOption("EDITABLE", 0);
    $c = new TPanelTableau(6, 1, $lidisp, $this->grise, "annoncelit", "nolit");
    $x = new Lien("", false, false, false, "nolit", "javascript:ouvreBrioche('brioche.php?action=5001" .
                  "&item=&ditem=$item&sessionid=$this->idsession&options=" . $futuropt->getChaine() ."', 780, 'Lits');",
                   0, $interditLiens);

    $c->addColChamp("N", $x, false, true);
    $x = new Label("", false, false, false, "notrans");
    $c->addColChamp("Rf.", $x);
    $x = new Label("", false, false, false, "litdepuis");
    $c->addColChamp("Depuis", $x);
    $x = new Label("", false, false, false, "nomet");
    $c->addColChamp("Nom Etabl.", $x);
    $x = new Label("", false, false, false, "sexe");
    $c->addColChamp("Sexe", $x);
    $x = new Label("", false, false, false, "chambre");
    $c->addColChamp("Lits/ch.", $x);
    $x = new Label("", false, false, false, "ttypesej");
    $c->addColChamp("Type sj.", $x);
    $x = new Label("", false, false, false, "txtmission");
    $c->addColChamp("Mission", $x);
    if ($this->actif != 4003){
      $x = new Label("", false, false, false, "dateres");
      $c->addColChamp("Rserv", $x);
      $x = new Label("", false, false, false, "dateplac");
      $c->addColChamp("Placement", $x);
      if (! $opt->getOption("CONS_LITS")) {
        $x = new Lien("", false, false, false, "nodoss",
                      "javascript:window.opener.location='$fdosbrioche?action=1&item=&sessionid=$this->idsession&options=" .
                      $optdossier->getChaine() . "';window.close();");
        $c->addColChamp("Doss.", $x, false, true);
      }
    }
    else {
      $x = new Lien("", false, false, false, "nolit",
                    "javascript:window.opener.location='$fdosbrioche?action=125&item=$item&litem=&sessionid=$this->idsession&" .
                    "options=$this->options';window.close();", "images/vu.gif");
      $c->addColChamp("Attribuer", $x, false, true);
    }
    
    $c->addTitres(true);
    $of->addChamp($c);
    
    $of->addLigne(0.5);
    
    $c = new TPanel(6, 1, "RIGHT", "MIDDLE");
    if ($opt->getOption("CONS_LITS")){
      $x = new Bouton("Retour", "Retour", "BUTTON", "changeChamp(\"action\", 1, \"donnees\");document.forms.donnees.submit();");
    }
    else {
      $x = new Bouton("Fermer", "Fermer", "BUTTON", "window.close()");
    }
    $c->addChamp($x);
    $c->addChamp(new Espace(4));
    $of->addChamp($c);   
    
    $of->addLigne(0.5);
    $of->addLigne();
    $this->addContenu($of->getContenu());
  }
}

?>
