<?php
  // $Id: optionsBrioche.inc,v 1.1.1.1 2010-10-11 22:25:43 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Objet permettant de manipuler un jeu d'options
* @package accessoires
*/
/**
* Objet permettant de manipuler un jeu d'options 
* Les options sont stockes sous la forme d'une chane de caractres qui est
* passe par un champ cach de formulaire. Les mthodes de cette classe permettent
* d'accder aux options individuellement en lecture ou en criture
* @package accessoires
* @author ob
*/
class optionsBrioche{
  /**
  * tableau des caractres individuels reprsentant les valeurs des options
  * @var array
  */
  var $tabch;
  
  /**
  * @param string chaine la chane de caractres poste
  */
  function optionsBrioche($chaine=""){
    if(! $chaine) $chaine = "00000000000000000000000000000";
    $chaine = chunk_split($chaine, 1, "\t");
    $this->tabch = explode("\t", $chaine);
  }

  /**
  * @param string attribut un attribut dsignant une option particulire
  * @return string la valeur correspondante (chane comportant un seul caractre)
  */
  function getOption($attribut) {
    $pos = $this->getPos($attribut);
    if($this->tabch[$pos] == "") return 0;
    return $this->tabch[$pos];
  }

  /**
  * @param string attribut le nom de l'attribut  modifier
  * @param string la valeur  appliquer (un seul caractre ! s'il y en a plus, seul le premier est compt...)
  */
  function setOption($attribut, $valeur){
    $pos = $this->getPos($attribut);
    $valeur = substr($valeur, 0, 1);
    $this->tabch[$pos] = $valeur;
    return true;
  }

  /**
  * renvoie la chane complte des options ( poster dans le formulaire)
  * @return string
  */
  function getChaine(){
    $chaine = implode("", $this->tabch);
    return $chaine;
  }

  /**
  * renvoie la position (numro d'ordre) d'un attribut dans la chane d'options
  * @return int
  */
  function getPos($attribut){
    switch ($attribut){
    case "MODE": // 0:dossiers ouverts, 1:dossiers archivs, 2:tous dossiers, 3:filtrer par usager, 4:nouveau dossier,
                 // 5: filtrer par EMS  8: fiche d'usager isols sans possibilit de recherche 
                 // 9: fiche d'usager ou tablissement isole (sans lien avec demande)
      $pos = 0;
      break;
    case "FORCE_DOSS":
      $pos = 1;
      break;
    case "BLOQUE_US": //1:Usager bloqu
      $pos = 2;
      break;
    case "NOUV_US": //ajout usager 1:demande standard, 2:Slection usager 
      $pos = 3;
      break;
    case "SELECTION_US": // 1: Slection du numro d'usager et inscription dans la demande
      $pos = 4;
      break;
    case "NOUV_DOSS": //cration nouveau dossier 1-ordinaire, 2-criture du nom de l'usager slectionn 3-enr nouv. param.
                      
      $pos = 5;
      break;
    case "PASSE": //gestion des passages dans l'onglet dcision
      $pos = 6;
      break;
    case "NOUV_ET": // Nouvel tablissement
      $pos = 7;
      break;
    case "AJ_EMS":
      $pos = 8;
      break;
    case "MASQ_RES": //0-afficher lits rservs 1-masquer lits rservs 2-lits attribus 3-lits attribuables
      $pos = 9;
      break;
    case "ANN_LIT": //0-consultation ann. existante 1-nouvelle annonce 2-dtails d'un lit attribu 3-validation annonce EMS 4-rejet annonce EMS
      $pos = 10;
      break;
    case "ATTR_LIT": //0-pas de date de rs. ou de plac 1-date prsente
      $pos = 11;
      break;
    case "MAINTENANT": //Bouton maintenant de l'onglet issue (1) 
                       //ou actualiser de l'onglet de navigation (2).
      $pos = 12;
      break;
    case "REPRISE_OPARS": //0-Pas de reprise des options "Q"   1-Reprise
      $pos = 13;
      break;
    case "Q1":
      $pos = 14;
      break;
    case "Q2":
      $pos = 15;
      break;
    case "Q3":
      $pos = 16;
      break;
    case "Q4":
      $pos = 17;
      break;
    case "PLAN":
      $pos = 18;
      break;  
    case "CONS_LITS" : //1- Consultation des lits disponibles depuis le menu principal
      $pos = 19;
      break;
    case "VAL_DEM" : //1- Rejet demande d'orientation Internet 2- Acceptation demande orientation avant doublons
                     //3- Enregistrement aprs doublon 
                     //9- Ouverture dossier : Faut-il valider ?
      $pos = 20;
      break;
    case "ENR_SIGNET" : //Enregistrement d'un signet
      $pos = 21;
      break;
    case "SEUL_CS" : // limitation demande  un CS
      $pos = 22;
      break;
    case "LARG_FIX" : //Largeur fixe (pour affichage dossier dans fentres accessoires.
      $pos = 23;
      break;  
    case "EDITABLE" : //Le formulaire doit-il tre ditable (annonce lit, tablissement)
      $pos = 24;
      break;
    case "PRINT_PDF"; //Impression de la demande au format PDF
      $pos = 25;
      break;
    case "ENR_INTERBRIOS";  //Enregistrement d'un BRIO pour la demande d'orientation
      $pos = 26;
      break;
    case "AJ_CTR";  //Ajout d'un CTR
      $pos = 27;
      break;
    case "SEQ_DMST"; // Squence de validation d'un DMST
      $pos = 28;
      break;
    }
    return $pos;
  }
}

?>
