<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Page vierge du dossier Brioche
* @package formulaires
*/
/**
* Page vierge du dossier Brioche
* Contient les champs cachs et les boutons qu'on retrouve dans tous les onglets
* @package formulaires
* @author ob
*/
class pageDossierBrioche {
  /**
  * l'objet dossierBrioche qui contient la page en question
  * @var object dossierBrioche
  */
  var $dbr;
  
  /**
  * la page vierge contenant les champs des pages filles de cet objet
  * @var object PPageVierge
  */
  var $pv;
    
  /**
  * le contenu HTML des champs communs
  * @var string
  */
  var $pied;
  
  /**
  * le contenu HTML des boutons d'entete de page
  * le pied est ncessaire pour que les boutons de tete puissent fonctionner
  * @var string
  */
  var $tete;
  
  /**
  * @param object dossierBrioche cf. variable de classe
  * @param boolean affsauver faut-il afficher le bouton "Sauver" ?
  * @param boolean afffermer faut-il afficher le bouton "Fermer" ?
  * @param int offset nombre  ajouter  l'action (dfaut = 100)
  */
  function pageDossierBrioche(&$dbr, $affsauver = true, $afffermer = true, $offset = 100){
    $this->dbr = &$dbr;
    $this->pied = new TPanel(6, 1, "RIGHT");
    $this->tete = new TPanel(6, 1, "RIGHT");
    $x = new Bouton("action", $this->dbr->actif + $offset, "HIDDEN");
    $this->pied->addChamp($x);
    $x = new Bouton("sessionid", $this->dbr->idsession, "HIDDEN");
    $this->pied->addChamp($x);
    $x = new Bouton("item", $this->dbr->item, "HIDDEN");
    $this->pied->addChamp($x);
    if (! isset($this->dbr->futuroptions)){
      $this->dbr->futuroptions = new optionsBrioche($this->dbr->options->getChaine());
    }
    $x = new Bouton("options", $this->dbr->futuroptions->getChaine(), "HIDDEN");
    $this->pied->addChamp($x);
    if ($this->dbr->options->getOption("MODE") == 5){
      $x = new Bouton("noetabl", $this->dbr->noetabl, "HIDDEN");
      $this->pied->addChamp($x);
    }
    if ($affsauver){
      $x = new Bouton("Envoyer", "Sauver", "submit", "", "bok");
      $this->pied->addChamp($x);
      $this->tete->addChamp($x);
      $this->pied->addChamp(new Espace(2));
      $this->tete->addChamp(new Espace(2));
    }
    // Fermer
    if ($afffermer){
      $x = new Bouton("Fermer", "Fermer", "BUTTON", "if(!qModif())window.close()");
      $this->pied->addChamp($x);
      $this->tete->addChamp($x);
      $this->pied->addChamp(new Espace(4));
      $this->tete->addChamp(new Espace(4));
    }
  }

  /**
  * renvoie le contenu HTML de l'objet. Cette mthode est en gnral
  * invoque par la mthode addChamp() du contenant
  */
  function TGetContenu(){
    return $this->pv->getContenu();
  }
}

?>
