<?php

// $Id: pageDossierBriocheDemande.inc,v 1.1.1.1 2010-10-11 22:25:50 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Page du dossier correspondant  l'onglet "demande"
* @package formulaires
*/
/**
* Page du dossier correspondant  l'onglet "demande"
* Toute demande d'orientation, qu'il s'agisse d'un onglet du dossier ou d'une demande isole
* @package formulaires
* @author ob
*/
class pageDossierBriocheDemande extends pageDossierBrioche {
  

  /**
  * @param object dossierBrioche le dossier qui contient cette page
  */
  function pageDossierBriocheDemande(&$dbr) {
    global $fdosbrioche;
    global $imagesdir;
    $ini = new briocheIni();
    $this->pageDossierBrioche($dbr);
    $this->pv = new PPageVierge();
    $autspec = $this->dbr->autspec;
    // Cas gnral (demande ordinaire et pas nouveau dossier : tous les services placeurs s'affichent)
    $etabl = new ensTableBrioche("etablissements", "servplac = -1", "nomet, noet, actif", "actif, groupepriorite, nomet",
             $this->dbr->idsession, 0, 0, false, $autspec);
    if ($this->dbr->actif == 20) {//Demande SP
      $demandeor = $this->dbr->rs->getTableau($this->dbr->recup);
      if (isset($demandeor[0])){
        $demandeor = $demandeor[0];
      }
    }
    elseif ($this->dbr->actif == 21) { // Validation demande SP
      //$demandeor = $this->dbr->rs->getEnr("avaliderdem");
            
      $demandeor = $this->dbr->rs->getEnr("demandeor");
    }
    else {
      $demandeor = $this->dbr->rs->getEnr("demandeor", $this->dbr->recup);
    }

    if(is_array($this->dbr->lcs)){
      //Ces lignes sont ncessaires pour viter l'affichage de "notices" gnantes
      //Il semble en effet que l'objet $demandeor renvoy par getEnr(), soit un mysql_fetch_object()
      //Soit dtruit si l'on essaie d'crire les champs de $lcs par dessus. Il faut donc passer tous les champs
      //de la table...
      $tabc = $this->dbr->rs->getChamps("demandeor");
      $lcs = $this->dbr->lcs;
      $cpt = count($tabc);
      for ($i = 0; $i < $cpt; $i++){
        $nomchamp = $tabc[$i];  
        $demandeor->$nomchamp = "";
      }
      foreach($lcs as $cle => $valeur){
        $demandeor->$cle = $valeur;
      }
    }
        
    if (in_array($this->dbr->options->getOption("MODE"), array(0, 1, 2 ,3, 5))){
      $c = new TPanel(6, 1, "RIGHT");
      
      // Modification pour la gnration du PDF
      // -------------------------------------------------------------------------------------------
      $url = "impressionPDF.php?item=".$this->dbr->item."&sessionid=".$this->dbr->idsession."&type=demande";
      $js = "window.open(\"$url\");";
      $x = new Bouton("PDF", "Impression...", "BUTTON", $js);
      // --------------------------------------------------------------------------------------------
      
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $this->pv->addChamp($c);
      $this->pv->addLigne(0.5);
      $this->pv->addLigne();
    }
    
    if (!($this->dbr->action == 21 || $this->dbr->action == 121)) {
      $this->pv->addChamp($this->tete);
      $this->pv->addLigne(0.5);
    }
    
    $usagers = $this->dbr->usagers;
    $nomplein = $usagers->nom . " " . $usagers->prenom;
    $monbrio = $etabl->lookup("noet", "idsulid = \"-1\"");
    if ($demandeor->servplac == $monbrio) {
      $c = new TPanel(6);
      $x = new Label("<FONT COLOR=\"red\">Demande interne</FONT>");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne();
    }
    
    $c = new TPanel(3, 1);
    $x = new Bouton("demandeor[nous]", $this->dbr->usagers->nous, "HIDDEN");
    $c->addChamp($x);
    if ($this->dbr->actif != 20){ // Demande ordinaire
      $where = ($this->dbr->options->getOption("NOUV_DOSS") ? "status = 0" : "1");
      $utilis = new ensTableBrioche("utilisateurs",
                                    $where,
                                    "init, if(status = 0, init, concat(\"(\", init, \")\")) as tinit",
                                    "status, init", $this->dbr->idsession,
                                    0, 0, false, $autspec);
      $x = new Label("Dossier ouvert par :&nbsp;");
      $c->addChamp($x);
      $init = $this->dbr->recup['ouvpar']; // On commence par rcuprer les initiales qui pourraient avoir t postes
      $init2 = $this->dbr->recup['suivpar'];
      if (! $init){ // Autrement, on regarde s'il y a dj des initiales enregistres
        $init = $this->dbr->dossiers->ouvpar;
      }
      if (! $init2){
        $init2 = $this->dbr->dossiers->suivpar;
      }
      // S'il n'y a toujours pas d'initiales et qu'on est en mode "Nouveau dossier", on propose celles de l'utilisateur
      if ($this->dbr->options->getOption("NOUV_DOSS")){
        if (! $init) $init = $this->dbr->getInit();
        if (! $init2) $init2 = $this->dbr->getInit();
      }
      
      $x = new ListOptTable("demandeor[ouvpar]", $init, $utilis, false, 0, "d2", "", 
                            $init && ! $this->dbr->options->getOption("NOUV_DOSS"));
      $x->addDefaut("---", "");
      $x->addOptions("tinit", "init");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $c = new TPanel(2, 1);
      $x = new Label ("Suivi par :&nbsp;");
      $c->addChamp($x);
      $x = new ListOptTable("demandeor[suivpar]", $init2, $utilis, false, 0, "d2");
      $x->addDefaut("---", "");
      $x->addOptions("tinit", "init");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $c = new TPanel(1, 1);
      $x = new Aide("C010");
      $c->addChamp($x);
      
      
      //Y a-t-il des signets dfinis dans l'application
      $etsignets = new ensTableBrioche("signets", "1", "*", 0, 
                                       $this->dbr->idsession);
      if ($etsignets->compte()){                                       
        $this->pv->addChamp($c);
        $this->pv->addLigne(0.5);
        $this->pv->addLigne();
        $c = new TPanelCadre(6, 1);
        $x = new Label("Signets :");
        $c->addChamp($x);
        $c->addChamp(new Espace(2));
        $x = new Bouton("...", " ... ", "BUTTON", 
                        "ouvreFenetre(\"brioche.php?action=7001&sessionid=" . 
                        $this->dbr->idsession . "&item=" . $this->dbr->item . 
                        "&options=" . $this->dbr->options->getChaine() . "\", \"Signets\", " .
                        "\"scrollbars=yes,resizable=no,menubar=no,locationbar=no,height=350," .
                        "width=580,screenX=50,screenY=50\")");
        $c->addChamp($x);
        /*
        $etsignets = new ensTableBrioche("signetsdossiers", "nodoss = "
                                         . $this->dbr->item, "*", "0", $this->dbr->idsession,
                                         "signets", "signetsdossiers.idsignet = signets.id");
        */
        $tetsignets = $this->dbr->rs->getSignets();
        $cpt = count($tetsignets);
        for ($i = 0; $i < $cpt; $i++){
          $c->addChamp(new Espace(2));
          $x = new Label("<FONT COLOR=\"blue\">" . $tetsignets[$i] . ($i < $cpt - 1 ? " - " : "") ."</FONT>",
                         true, true);
          $c->addChamp($x);
          
        }                                 
      }  
    }
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    // Champ demande interbrio   
    // ----------------------------------------------------------------
    if ($this->dbr->actif != 20) {
      $c = new TPanelCadre(6, 1);
      $x = new Label("Demande transmise aux BRIOs :");
      $c->addChamp($x);
      $c->addChamp(new Espace(2));
      $x = new Bouton("...", " ... ", "BUTTON", 
                      "ouvreFenetre(\"brioche.php?action=7002&sessionid=" . 
                      $this->dbr->idsession . "&item=" . $this->dbr->item . 
                      "&options=" . $this->dbr->options->getChaine() . "\", \"InterBrios\", " .
                      "\"scrollbars=yes,resizable=no,menubar=no,locationbar=no,height=350," .
                      "width=580,screenX=50,screenY=50\")");
      $c->addChamp($x);
      $teib = $this->dbr->rs->getDemandeInterBrio();
      
      $cpt = count($teib);
      for ($i = 0; $i < $cpt; $i++){
        $c->addChamp(new Espace(2));
        $couleur = COULEUR_PREPARE;
        if ($ini->interbrio){ // Activation des demandes interbrios
          switch($teib[$i]['quittance']){
          case 1:
          case 2:
            $couleur = COULEUR_ENVOYE;
            break;
          case 98:
            $couleur = COULEUR_REJETE;
            break;
          case 99:
            $couleur = COULEUR_ACCEPTE;
            break;    
          }
        }
        
        $x = new Label("<FONT COLOR=\"$couleur\">" . $teib[$i]['nomet'] . ($i < $cpt - 1 ? " - " : "") .
                       "</FONT>",
                       true, true);
        $c->addChamp($x);
      }
      $this->pv->addChamp($c);
      $this->pv->addLigne(0.5);
      $this->pv->addLigne();
    }
    // -----------------------------------------------------------------

    $labellise = false;
    $etablissement = $demandeor->servplac;
    if ($this->dbr->actif == 20){ // Demande SP
      $labellise = true;
      
      $etabl = new ensTableBrioche("etablautorises", "idut = " . $this->dbr->nout . " AND priv = \"ems\" AND " .
                                   "etablissements.actif = -1",
                                   "etablissements.nomet, etablissements.noet, etablissements.actif", 0,
                                   $this->dbr->idsession, "etablissements", "etablautorises.etabl = etablissements.noet",
                                   false, $autspec);
      $et = $etabl->getTableau();
      if (count($et)){
        $etablissement = $et[0]->noet;
      }
    } 
    else { // Demande ordinaire
      if ($this->dbr->options->getOption("NOUV_DOSS") == 1) { // Nouveau dossier
         $etabl = new ensTableBrioche("etablissements", "actif = -1 AND servplac = -1", "nomet, noet, actif",
                                 "actif, groupepriorite, nomet", //Pour un nouveau dossier, on ne retient que les sp actifs.
         $this->dbr->idsession, 0, 0, false, $autspec);  
      }
    }
    // Rcupration de la Cookie pour dterminer le service placeur
    // ----------------------------------------------------------------------------------------------------
    if ($this->dbr->actif != 20 && $etablissement == '' && $ini->cookie_servplac == 1) {
      
      if (isset($_COOKIE['SERV_PLAC'])) $etablissement = $_COOKIE['SERV_PLAC'];
    }
    // ----------------------------------------------------------------------------------------------------
    
    $c = new TPanel(3, 1);
    $x = new Label("Service placeur :&nbsp;");
    $c->addChamp($x);
    $x = new listOptTableEtabl("demandeor[servplac]", $etablissement, $etabl, false, 0, "d2", "", $labellise);
    $x->addDefaut("---", "");
    $x->addOptionsEtablissements("nomet", "noet");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $c = new TPanel(3, 1, "RIGHT", "MIDDLE");
    $x = new ChampTexte("demandeor[medecinautre]", $demandeor->medecinautre, "Prcision :", 35, 50, false, "text", "d2");
    $c->addChamp($x);
    $c->addChamp(new Espace(2));
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanel(4, 1);
    $x = new ChampTexte("demandeor[referent]", $demandeor->referent, "Professionnel rfrent :", 50, 50, false, "text", "d2");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $c = new TPanel(2, 1, "RIGHT", "MIDDLE");
    $x = new ChampTexte("demandeor[telref]", $demandeor->telref, "Tl. :", 15, 50, false, "text", "d2");
    $c->addChamp($x);
    $c->addChamp(new Espace(2));
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $acb = new AutoCheckBox();
    $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "", "Prise en charge dsire :");
    $labellise = false;
    if ($demandeor->typesej == 5) { // Court sjour planifi
    
      $ch = new EnsTableBrioche("attributionlit, annoncelit, etablissements", 
        "annoncelit.etabl = etablissements.noet AND attributionlit.nolit = annoncelit.nolit AND attributionlit.nodoss = " . $this->dbr->item,
        "*", 0, $this->dbr->idsession);
      $infoEMS = $ch->getTableau();
      if (isset($infoEMS[0])) {
        $infoEMS = $infoEMS[0];
        
        $futuroptions = new optionsBrioche($this->dbr->options->getChaine());
        $futuroptions->setOption("ANN_LIT", 2);
        $texte = "(<A HREF=\"javascript:ouvreFenetre('" .
                     $fdosbrioche . "?action=5001&sessionid=" . $this->dbr->idsession .
                     "&item=$infoEMS->nolit&options=" . $futuroptions->getChaine() .
                     "', 'Lits','scrollbars=yes,resizable=no,menubar=no,locationbar=no,height=500," .
                     "width=780,screenX=50,screenY=50')\">" . $infoEMS->nolit . "</A>";
        $texte .= " - ".$infoEMS->nomet.")";
      } else {
        $texte = "";
      }
      
      $labellise = true;
      $x = new Label("<FONT COLOR=\"red\">Court sjour Planning</FONT> $texte");
      $c->addChamp($x);
      $x = new Bouton("demandeor[typesej]", 5, "HIDDEN");
      $c->addChamp($x);
    }
    else {
      if ($this->dbr->actif != 20) { // Pas de test sur les dossiers concommitants en cas de demande SP (=> pas d'aut. pour $us
        $us = new enrUsBrioche($usagers->nous, $this->dbr->idsession);
        
        if ($us->hasOuvert(1) &&  ! $this->dbr->rs->isOuvert(1) && $this->dbr->actif != 21){
          $this->dbr->options->setOption("SEUL_CS", 1);
            
        }
      }
      $where = "";
      if ($this->dbr->options->getOption("SEUL_CS") && $this->dbr->rs->isOuvert()) {  
        $x = new Label("Choix limit : Il y a dj une demande non \"court sjour\" ouverte pour cet usager.",
                         true, false, true);
        $c->addChamp($x);
        if (! $demandeor->typesej) $demandeor->typesej = 3;
        $where = "ordre > 0 AND idts IN (3, 14)";
      }
      else {
        $where = "ordre > 0" ;              // Le type 5, court-sjour planning, n'a pas  apparatre ici
                                            // Il ne peut tre choisi que par le biais de l'interface 
                                            // Planning. Donc il faut mettre "ordre"  0 dans typesejour
      }
      $ets = new ensTableBrioche("typesejour", $where, "*", "ordre", $this->dbr->idsession, 0, 0, false, $autspec);
      //Les choix de la rubrique Prise en charge sont dans la table typesejour
      $retourligne = array(3, 6);
      $x = new GrBoutonRadioTable("demandeor[typesej]", $demandeor->typesej, $ets, "",
                            ($this->dbr->options->getOption("SEUL_CS") ? "" : "donnees"), false, $retourligne);
      $x->addOptions("ttypesej", "idts");
      $c->addChamp($x);
      $acb->addCase($x);
      
      $x = new ChampTexte("demandeor[typesejautre]",$demandeor->typesejautre," : ", 25, 50, false, "TEST", "d2");
      $c->addChamp($x);
    }
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
      
    $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "", "Nature de la prise en charge (si placement ou UAT) :");
    //Les choix de la rubrique Nature prise en charge sont dans la table typepath
    $etp = new ensTableBrioche("typepath", "ordre > 0", "*", "ordre", $this->dbr->idsession, 0, 0, false, $autspec);
    $x = new GrBoutonRadioTable("demandeor[typepath]", $demandeor->typepath, $etp, "",
                                "donnees", false);
    $x->addOptions("ttypepath", "idtp");
    $c->addChamp($x);
    $acb->addCase($x);
    //new CJD
    $x = new ChampTexte("demandeor[autre]", $demandeor->autre, " : ", 25, 50, false, "text", "d2");
    $c->addChamp($x);
    //fin new CJD
  
    //$acb->addCase($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "", "Dbut souhait pour la prise en charge :");
    // Les choix de la rubrique Dbut souhait sont dans la table typedebutpec
    $etp = new ensTableBrioche("typedebutpec", "ordre > 0", "*", "ordre", $this->dbr->idsession,
                               0, 0, false, $autspec);
    $x = new GrBoutonRadioTable("demandeor[debutpec]", $demandeor->debutpec, $etp, "",
                                "donnees", false);
    $x->addOptions("ttypedebutpec", "iddp");
    $c->addChamp($x);
    $acb->addCase($x);
    $x = new ChampTexte("demandeor[litdepuis]", $demandeor->litdepuis, "<BR>Depuis le :", 15, 15,
                        false, "text", "d2", "controleDate('demandeor[litdepuis]', '" .
                        $demandeor->litdepuis . "', 365, 365, 'demandeor[litdepuis]', 'demandeor[litjusqua]')",
                        "", $labellise, true);
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $x = new Label("Pour l'tude IUMSP, il est recommand de cocher aussi l'une des options ci-dessus",
                   false, true, true);
    $c->addChamp($x);
    // ajout de la date Jusqu' pour les courts sjours
    $x = new ChampTexte("demandeor[litjusqua]", $demandeor->litjusqua, "Jusqu'au :", 15, 15,
                        false, "text", "d2", "controleDate('demandeor[litjusqua]', '" .
                        $demandeor->litjusqua . "', 365, 365, 'demandeor[litdepuis]', 'demandeor[litjusqua]')",
                        "", $labellise, true);
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $x = new Label("Pour les courts sjours",
                   false, true, true);
    $c->addChamp($x);

    
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $futopt = new optionsBrioche($this->dbr->options->getChaine());
    $futopt->setOption("SEUL_CS", 0);
    if ($this->dbr->options->getOption("MODE") == 4) {
      $futopt->setOption("BLOQUE_US", 0);
      $futopt->setOption("NOUV_US", 1);
    }
    else {
      $futopt->setOption("BLOQUE_US", 1);
      $futopt->setOption("NOUV_US", 0);
    }
    if ($demandeor->typesej == 5){
      $futopt->setOption("PLAN", 1);
    }
    if ($this->dbr->actif == 20){ // Demande SP : identit usager intgre dans la demande
      $c = new TPanel(6, 1, "LEFT", "MIDDLE");
      $x = new ChampTexte("demandeor[nom]", $demandeor->nom, "Nom :", 25, 50, false, "text", "d2");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new ChampTexte("demandeor[prenom]", $demandeor->prenom, "Prnom :", 25, 50, false, "text", "d2");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new ChampTexte("demandeor[datenaiss]", $demandeor->datenaiss, "N(e) le :", 12, 12, false, "text", "d2",
                          "controleDate('demandeor[datenaiss]', '" . $this->dbr->aujourdhui() . "', '40150', '-3650')");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new Label("Sexe :&nbsp;");
      $c->addChamp($x);
      $x = new ListOpt("demandeor[sexe]", $usagers->sexe, false, 1, "d2");
      $x->addOption("---", "");
      $x->addOption("F", "F");
      $x->addOption("M", "M");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne(0.5);
      $this->pv->addLigne();
      $c = new TPanel(6, 1, "LEFT", "MIDDLE");
      $x = new ChampTexte("demandeor[adresse]", $demandeor->adresse, "Adresse :", 40, 100, false, "text", "d2");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new ChampTexte("demandeor[npa]", $demandeor->npa, "NPA :", 6, 6, false, "text", "d2", "",
                          "controleNPA(" . $this->dbr->action2 .
                          ", '$fdosbrioche', 'demandeor[npa]', 'demandeor[loc]', 'donnees', 1);" );
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new ChampTexte("demandeor[loc]", $demandeor->loc, "Localit :", 25, 50, false, "text", "d2", "", 
                          "controleNPA(" . $this->dbr->action2 .
                          ", '$fdosbrioche', 'demandeor[npa]', 'demandeor[loc]', 'donnees', 2);");
      $c->addChamp($x);
      $this->pv->addChamp($c);
    }
    else {
      $c = new TPanelCadre(5, 1, "LEFT", "MIDDLE", "", "Usager :");
      $x = new Label("Nom :&nbsp;");
      $c->addChamp($x);
      $x = new Label($nomplein, true);
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new Label("Sexe :&nbsp;");
      $c->addChamp($x);
      $x = new Label($usagers->sexe, true);
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new Label("Date de naissance :&nbsp;");
      $c->addChamp($x);
      $x = new Label($usagers->datenaiss, true);
      $c->addChamp($x);
      $c->addLigne();
      $x = new Label("Adresse :&nbsp;");
      $c->addChamp($x);
      $x = new Label($usagers->adresse, true);
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new Label($usagers->npa . " " . $usagers->loc, true);
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $c = new TPanel(1, 1, "CENTER", "MIDDLE");
      $futopt->setOption("BLOQUE_US", 1);
      $futopt->setOption("NOUV_US", 2);
      $x = new Bouton("Dtails usager", "Dtails usager", "BUTTON",
                      "ouvreFenetre(\"brioche.php?action=1001&sessionid=" .
                      $this->dbr->idsession .
                      "&item=" . $usagers->nous .
                      "&options=" .  $futopt->getChaine() .
                      "\", \"usager\"," .
                      " \"scrollbars=yes,resizable=no,menubar=no,locationbar=no,height=500," .
                      "width=800,screenX=50,screenY=50\")");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      
    }
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "",
                         "Situation de l'usager au moment de la demande (provenance) :");
    $tp = new ensTableBrioche("provenance", "ordre > 0", "*", "ordre", $this->dbr->idsession,
                              0, 0, false, $autspec);
    $retourligne = array(2, 6);
    
    // Automatisation de la slection de la situation actuelle lors de la creation d'une demande
    // ----------------------------------------------------------------------------------------------------
    $selected = $demandeor->provenance;
    if ($this->dbr->actif == 20 || $usagers->nous == '') {
      $service_placeur_tab = new ensTableBrioche("etablissements",
                                             "noet = $etablissement", 
                                             "type_hopital", 0,
                                             $this->dbr->idsession, "", "", false, $autspec);
      $service_placeur_type = $service_placeur_tab->getTableau();
      (isset($service_placeur_type[0])) ?
       $service_placeur_type = $service_placeur_type[0]->type_hopital : $service_placeur_type = 0;
      switch ("$service_placeur_type") {
        case 'A':
            $selected = 1;
            break;
          case 'B':
            $selected = 2;
            break;
          default: break;
      }
    }
    // ----------------------------------------------------------------------------
    $x = new GrBoutonRadioTable("demandeor[provenance]", $selected, $tp, "",
                                "donnees", false, $retourligne);
    $x->addOptions("provenance_text", "idprovenance");
    $c->addChamp($x);
    $acb->addCase($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    
    // Nouveau champ - provenance antrieure  la demande
    // -------------------------------------------------------------------------------
    $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "",
                               "Situation de l'usager avant la demande (tape prcdente) :");
    $tp = new ensTableBrioche("provenance", "ordre > 0", "*", "ordre", $this->dbr->idsession, 0, 0,
                              false, $autspec);
    $retourligne = array(2, 6);
    $x = new GrBoutonRadioTable("demandeor[prov_anterieure]", $demandeor->prov_anterieure,
                                $tp, "", "donnees", false, $retourligne);
    $x->addOptions("provenance_text", "idprovenance");
    $c->addChamp($x);
    $acb->addCase($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    // ----------------------------------------------------------------------------
    
    $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "", "Situation sociale :");
    $tsit = new ensTableBrioche("typesitsociale", "ordre > 0", "*", "ordre", $this->dbr->idsession, 0, 0,
                                false, $autspec);
    // Les options de Situation sociale se trouvent dans la table typesitsociale
    $x = new GrBoutonRadioTable("demandeor[sitsoc]", $demandeor->sitsoc, $tsit, "", "donnees", false);
    $x->addOptions("ttypesitsociale", "idss");
    $c->addChamp($x);
    $acb->addCase($x);
    $x = new ChampTexte("demandeor[sitsocautre]",$demandeor->sitsocautre," : ", 25, 50, false, "TEXT", "d2");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "", "Reoit dj l'aide :");
    $x = new AutoCase("demandeor[aidepr]", $demandeor->aidepr, "De proches");
    $acb->addCase($x);
    $c->addChamp($x);
    $x = new AutoCase("demandeor[uat]", $demandeor->uat, "D'une UAT");
    $acb->addCase($x);
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "",
                         "Reoit dj l'aide d'un service de maintien  domicile :");
    $taide = new ensTableBrioche("typeaidedom", "ordre > 0", "*", "ordre", $this->dbr->idsession, 0, 0, 
                                 false, $autspec);
    // Les options d'aide  domicile se trouvent dans la table typeaidedom
    $javascript = "javascript:
                   if (this.value == 1) {
                     document.forms.donnees.elements['demandeor[aidecms]'].value = 0;
                   } else {
                     document.forms.donnees.elements['demandeor[aidecms]'].value = -1;
                   }                     
                   ";
    $x = new GrBoutonRadioTable("demandeor[cms]", $demandeor->cms, $taide, $javascript, "donnees", false);
    $x->addOptions("ttypeaidedom", "idad");
    $c->addChamp($x);
    
    //////////
    $x = new Label("lequel :&nbsp;");
    $c->addChamp($x);
    $tcms = new ensTableBrioche("etablissements", "type_hopital = 'Z'", "nomet, noet,actif", "actif,groupepriorite,nomet", $this->dbr->idsession, 0, 0, false, $autspec);
    $javascript = "javascript:
                   if (this.value != 0) {
                     document.forms.donnees.elements['demandeor[cms]'][2].checked = true;
                   }
                   ";    
    if (! isset($demandeor->aidecms)){
      $aide = -1;
    }
    else {
      $aide = $demandeor->aidecms;
    }
    $x = new listOptTableEtabl("demandeor[aidecms]",$aide,$tcms,false,0,"d2",$javascript,false);
    $x->addDefaut("---", -1);
    $x->addOptionsEtablissements("nomet", "noet");
    $x->addDefaut("CMS hors rseau", -2);
    $x->addDefaut("CMS non spcifi", 0);
    $c->addChamp($x);
    $this->pv->addChamp($c);
    //////////
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    
    $javascript = "if (this.value == 'Aucune') { 
        document.forms.donnees.elements['demandeor[pc]'].checked = false;
        document.forms.donnees.elements['demandeor[api]'].checked = false;
    }
    ";
    $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "", "Assurances sociales :");
    $x = new GrBoutonRadio("demandeor[asssoc]", $demandeor->asssoc, $javascript, 1, false);   
    $x->addRadio("AVS","AVS");
    $x->addRadio("AI","AI");
    $x->addRadio("Aucune","Aucune");
    $acb->addCase($x);
    $c->addChamp($x);
    $javascript = "if (this.value == -1) { 
        if (document.forms.donnees.elements['demandeor[asssoc]'][2].checked) {
            document.forms.donnees.elements['demandeor[asssoc]'][2].checked = false;
        }
    }
    ";
    $x = new AutoCase("demandeor[pc]", $demandeor->pc, "PC", false, $javascript);
    $acb->addCase($x);
    $c->addChamp($x);
    $x = new AutoCase("demandeor[api]", $demandeor->api, "API", false, $javascript);
    $acb->addCase($x);
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    
    $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "", "Problmes particuliers :");
    $x = new AutoCase("demandeor[anx]", $demandeor->anx, "Anxit, inscurit");
    $acb->addCase($x);
    $c->addChamp($x);
    $x = new AutoCase("demandeor[trcomp]", $demandeor->trcomp, "Tr. comportement, fugues");
    $acb->addCase($x);
    $c->addChamp($x);
    $x = new AutoCase("demandeor[chutes]", $demandeor->chutes, "Chutes");
    $acb->addCase($x);
    $c->addChamp($x);
    $x = new AutoCase("demandeor[resmult]", $demandeor->resmult, "Rs. mult. antibiotiques");
    $acb->addCase($x);
    $c->addChamp($x);
    $x = new Autocase("demandeor[solitude]", $demandeor->solitude, "Solitude");
    $acb->addCase($x);
    $c->addChamp($x);
    $x = new Autocase("demandeor[dependance]", $demandeor->dependance, "Toxicodpendances");
    $acb->addCase($x);
    $c->addChamp($x);
    $x = new Label("<BR>");
    $c->addChamp($x);
    $x = new Autocase("demandeor[perfusion]", $demandeor->perfusion, "Perfusion");
    $acb->addCase($x);
    $c->addChamp($x);
    $x = new Autocase("demandeor[dominadequat]", $demandeor->dominadequat, "Dom. inadquat");
    $acb->addCase($x);
    $c->addChamp($x);
    $x = new Autocase("demandeor[absenceent]", $demandeor->absenceent, "Absence entourage");
    $acb->addCase($x);
    $c->addChamp($x);
    $x = new Autocase("demandeor[epuisementent]", $demandeor->epuisementent, "Epuisement entour.");
    $acb->addCase($x);
    $c->addChamp($x);
    $x = new Autocase("demandeor[respiratoire]", $demandeor->respiratoire, "Probl. respiratoire");
    $acb->addCase($x);
    $c->addChamp($x);
    $x = new Autocase("demandeor[refuscms]", $demandeor->refuscms, "Refuse CMS");
    $acb->addCase($x);
    $c->addChamp($x);
    $x = new Autocase("demandeor[mobilite]", $demandeor->mobilite, "Problme de mobilit");
    $acb->addCase($x);
    $c->addChamp($x);
    $x = new Label("<BR>");
    $c->addChamp($x);
    $x = new ChampTexte("demandeor[autreprobl]", $demandeor->autreprobl, "Autre : ", 25, 50, false, "text", "d2");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanel(4);
    $x = new ChampTexte("demandeor[refent]", $demandeor->refent, "Pers. de rfrence entourage :", 50, 100, false, "text", "d2");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $c = new TPanel(2, 1, "RIGHT", "MIDDLE");
    $x = new ChampTexte("demandeor[telrefent]", $demandeor->telrefent, "Tl. :", 15, 50, false, "text", "d2");
    $c->addChamp($x);
    $c->addChamp(new Espace(2));
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanel(6);
    $x = new TextArea("demandeor[souhaits]", $demandeor->souhaits, "Souhaits de l'usager et/ou son entourage:", 100, 2);
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanel(6);
    $x = new TextArea("demandeor[compl]", $demandeor->compl, "Indications complmentaires :", 100, 2);
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "", "Le BRIO dispose d'un DMST :");
    $x = new GrBoutonRadio("demandeor[doctrans]", $demandeor->doctrans, "", "donnees");
    $x->addRadio("Oui", 1);
    $x->addRadio("Non", 2);
    $c->addChamp($x);
    $acb->addCase($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();

    // envoi ou non du DMT, affichable ou non selon la configuration
    if ($ini->dmttrans) {
      $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "", "Le BRIO dispose d'un DMT :");
      $x = new GrBoutonRadio("demandeor[dmttrans]", $demandeor->dmttrans, "", "donnees");
      $x->addRadio("Oui", 1);
      $x->addRadio("Non", 2);
      $c->addChamp($x);
      $acb->addCase($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne(0.5);
      $this->pv->addLigne();
    }

    if ($ini->supplement_ch_indiv) {
      $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "", "Supplment pour ch. individuelle :");
      $x = new GrBoutonRadio("demandeor[supplement_ch_indiv]",
                             $demandeor->supplement_ch_indiv, "", "donnees");
      $x->addRadio("Oui", 1);
      $x->addRadio("Non", 2);
      $c->addChamp($x);
      $acb->addCase($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne(0.5);
      $this->pv->addLigne();
    }

    $c = new TPanel(2, 1);
    $x = new ChampTexte("demandeor[datedem]", $demandeor->datedem, "Date de la demande :", 15, 15, false,
                        "text", "d2", "controleDate('demandeor[datedem]', '', 7, 7, '', '', false)", "", false, true);
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $c = new TPanel(4, 1, "RIGHT", "MIDDLE");
    $x = new ChampTexte("demandeor[nomdem]", $demandeor->nomdem, "Demandeur :", 50, 50, false, "text", "d2");
    $c->addChamp($x);
    $c->addChamp(new Espace(2));
    $c->addChamp($acb);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    if (in_array($this->dbr->options->getOption("MODE"), array(0, 1, 2 ,3, 5))){
      $c = new TPanel(6, 1, "RIGHT");
      
      // Modification pour la gnration du PDF
      // -------------------------------------------------------------------------------------------
      $url = "impressionPDF.php?item=".$this->dbr->item."&sessionid=".$this->dbr->idsession."&type=demande";
      $js = "window.open(\"$url\");";
      $x = new Bouton("PDF", "Impression...", "BUTTON", $js);
      // --------------------------------------------------------------------------------------------
      
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $this->pv->addChamp($c);
      $this->pv->addLigne(0.5);
      $this->pv->addLigne();
    }
    if ($this->dbr->action == 21 || $this->dbr->action == 121){ // Validation demande SP => modifier option
      $c = new TPanel(6, 1, "RIGHT", "MIDDLE");
      $x = new Bouton("action", $this->dbr->actif, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("sessionid", $this->dbr->idsession, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("item", $this->dbr->item, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("ditem", "", "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("options", $this->dbr->options->getChaine(), "HIDDEN");
      $c->addChamp($x);
      if  ($this->dbr->rs->getNbAval() > 1) {
        $x = new Label("Feuilleter &nbsp;:");
        $c->addChamp($x);
        $prec = $this->dbr->rs->getPrecedAval();
        if ($prec >= 0){
          $x = new BoutonImage("Prcdent", "$imagesdir/precedent.gif", 16, 16,
                               "javascript:document.forms.donnees.item.value=-999;" .
                               "document.forms.donnees.ditem.value='$prec';document.forms.donnees.submit();");
          $c->addChamp($x);
        }
        else {
          $x = new BoutonImage("Prcdent", "$imagesdir/precedentinact.gif", 16, 16, "javascript:void(0)");
          $c->addChamp($x);
        }
        $suiv = $this->dbr->rs->getSuivantAval();
        if ($suiv >= 0){
          $x = new BoutonImage("Suivant", "$imagesdir/suivant.gif", 16, 16,
                               "javascript:document.forms.donnees.item.value=-999;" .
                               "document.forms.donnees.ditem.value='$suiv';document.forms.donnees.submit();");
          $c->addChamp($x);
        
        }
        else {
          $x = new BoutonImage("Suivant", "$imagesdir/suivantinactif.gif", 16, 16, "javascript:void(0);");
          $c->addChamp($x);     
        }
        $c->addChamp(new Espace(10));
      }
      $x = new Bouton("Stop", "Interrompre validation", "BUTTON",
                      "window.location=\"$fdosbrioche?action=0&sessionid=" . $this->dbr->idsession .
                      "\";",
                      "ban");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $futopt = new optionsBrioche($this->dbr->options->getChaine());
      $futopt->setOption("VAL_DEM", 1);
      $valeuropt = $futopt->getChaine();
      $js = "document.forms.donnees.options.value=\"$valeuropt\";document.forms.donnees.submit()";
      
      $x = new Bouton("Rejeter", "Rejeter", "BUTTON", $js);
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $futopt->setOption("VAL_DEM", 2);
      $valeuropt = $futopt->getChaine();
      $js = "document.forms.donnees.options.value=\"$valeuropt\";" .
            "document.forms.donnees.submit()";
      $x = new Bouton("Accepter", "Accepter", "BUTTON", $js);
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $this->pv->addChamp($c);
    }
    else {
      $this->pv->addChamp($this->pied);
    }
    $this->pv->addLigne(0.5);
  }

  
}
