<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Page du dossier correspondant  l'onglet "ems"
* @package formulaires
*/
/**
* Page du dossier correspondant  l'onglet "ems"
* Prinscriptions dans les EMS et transmission aux autres BRIOs. Cette dernire rubrique
* est un miroir du champ "Dossier transmis aux BRIOs" de la demande d'orientaton
* @package formulaires
* @author ob
*/
class pageDossierBriocheEMS extends pageDossierBrioche {
  
  /**
  * @param object dossierBrioche le dossier qui contient cette page
  */
  function pageDossierBriocheEMS(&$dbr){
    global $fdosbrioche;
    $this->pageDossierBrioche($dbr);
    //Seuls les tablissements possdant des lits C ou des lits D sont lists : il ne faudrait pas utiliser
    //les groupes d'tablissements dans l'application : ceux-ci ont t dfinis pour les statistiques IUMSP
    //et devraient logiquement rester indpendants des fonctions de BriocheWeb.
    $whereSansRefus = "nodoss = " . $this->dbr->item . " AND refus = 0 AND refpro = 0 AND (litsC OR litsD or autbrio)";
    $whereAvecRefus = "nodoss = " . $this->dbr->item . " AND (litsC OR litsD OR autbrio)";
    // table des choix, refus excepts (pour calculer le choix d'tablissements); 
    $ch = new EnsTableBrioche("choixems", $whereSansRefus, "*", 0, $this->dbr->idsession, "etablissements", "noems = noet");
    $choixems = $ch->getTableau();
    $this->pv = new PPageVierge();
    $this->pv->addChamp($this->tete);
    $this->pv->addLigne();
    $cpt = count($choixems);
    $in = "";
    if (is_array($choixems) && $cpt) {
      $in = "(";
      for ($i = 0; $i < $cpt; $i++){
        $in .=  $choixems[$i]->noems;
        $in .= ($i == $cpt-1 ? ")" : ",");
      }
     
    }
    //table des choix avec les refus (pour affichage)
    
    $Etch = new EnsTableBrioche("choixems", $whereAvecRefus, "*",
                               "nochoix", $this->dbr->idsession, "etablissements",
                               "choixems.noems = etablissements.noet");
    $EMSach = new EnsTableBrioche("etablissements", "(litsc OR litsd) AND NOT autbrio AND actif = -1" .
                                  ($in ? " AND noet NOT IN $in" : ""), "*", "groupepriorite, nomet", $this->dbr->idsession);
    $BRIOach = new EnsTableBrioche("etablissements", "actif = -1 AND autbrio" . ($in ? " AND noet NOT IN $in" : ""),
                                   "*", "groupepriorite, nomet", $this->dbr->idsession);
    $c = new TLabel("EMS :");
    $c->setColspan(3);
    $this->pv->addChamp($c);
    $c = new TLabel("Autres BRIOS :");
    $c->setColspan(2);
    $this->pv->addChamp($c);
    $c = new TPanel(1, 1);
    $x = new Aide("C13");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne();
    $c = new TPanel(3);
    $x = new Bouton("choixems[-1][nd]", $this->dbr->dossiers->nodoss, "HIDDEN");
    $c->addChamp($x);
    $x = new ListOptTable("choixems[-2][noems]", "", $EMSach, false, 0, "d2");
    $x->addDefaut("---", "");
    $x->addOptions("nomet", "noet");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $c = new TPanel(3);
    $x = new ListOptTable("choixems[-3][noems]", "", $BRIOach, false, 0, "d2");
    $x->addDefaut("---", "");
    $x->addOptions("nomet", "noet");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanel(3);
    $c->addChamp(new Espace(5));
    $opt = new optionsBrioche($this->dbr->options->getChaine());
    $opt->setOption("AJ_EMS", 1);
    $x = new Bouton("Ajouter", "Ajouter", "BUTTON", "document.forms.donnees.options.value = \"" . $opt->getChaine() . "\";submit();");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $c = new TPanel(3);
    $c->addChamp(new Espace(5));
    $opt->setOption("AJ_EMS", 2);
    $x = new Bouton("Ajouter", "Ajouter", "BUTTON", "document.forms.donnees.options.value = \"" . $opt->getChaine() . "\";submit();");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanelCadre(6, 1, "", "", "", "Priorit :");
    $x = new GrBoutonRadio("choixems[-1][priorite]", $this->dbr->dossiers->priorite);
    $x->addRadio("1 (haute)", 1);
    $x->addRadio("2 (moyenne)", 2);
    $x->addRadio("3 (basse)", 3);
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $ch->setWhere($whereAvecRefus);
    $choixems = $ch->getTableau();
    if (is_array($choixems) /*&& $cpt*/){
    	      
      $date_js = "";
      for ($i=0;$i<$cpt;$i++) {
      	$date_js .= "controleDate('choixems[".$choixems[$i]->nochoix."][datechoix]'); ";
      }
    	
      $this->pv->addLigne(0.5);
      $this->pv->addLigne();                     
      $c = new TPanelTableau(6, 1, $Etch, $this->dbr->grise, "choixems", "nochoix");        
      $x = new ChampTexte("datechoix", "", "", 13, 13, false, "text", "d2",$date_js,$date_js,false,true);
      $c->addColChamp("Date", $x);
      $x = new Label("", false, false, false, "nomet");
      $c->addColChamp("Nom tabl.", $x);
      $x = new AutoCase("chus", "");
      $c->addColChamp("Choix us.", $x, true);
      $x = new AutoCase("refus", "");
      $c->addColChamp("Refus us.", $x, true);
      $x = new AutoCase("chpro", "");
      $c->addColChamp("Choix pro.", $x, true);
      $x = new AutoCase("refpro", "");
      $c->addColChamp("Refus pro.", $x, true);
      $x = new ChampTexte("motref", "", "", 20, 50, false, "text", "d2");
      $c->addColChamp("Motif refus", $x);
      $x = new Lien("", false, false, false, "nochoix", "$fdosbrioche?action=114&item=" . $this->dbr->item .
                    "&options=" . $this->dbr->options->getChaine() . "&detruit=&sessionid=" . $this->dbr->idsession, "images/croixtr.gif");
      $c->addColChamp("", $x, false, true);
      $x = new Bouton("noems", "", "HIDDEN");
      $c->addColChamp("", $x);
      $c->addTitres(true);
      $this->pv->addChamp($c);
    }
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $this->pv->addChamp($this->pied);
    $this->pv->addLigne(0.5);
  }

}


?>