<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Page du dossier correspondant  l'onglet "grille"
* @package formulaires
*/
/**
* Page du dossier correspondant  l'onglet "grille"
* Grille d'autonomie du DMST,  saisir pour les statistiques IUMSP
* @package formulaires
* @author ob
*/
class pageDossierBriocheGrille extends pageDossierBrioche {
  
  var $dmst;
  var $usager;
  var $grille;
  var $interv;
  var $medics;
  var $acb;
    
  /**
  * @param object dossierBrioche le dossier qui contient cette page
  */
  function pageDossierBriocheGrille(&$dbr) {
      
    global $ini;
      
    $this->pageDossierBrioche($dbr);
    
    $dmst = new ensTableBrioche("dmst","nodoss = ".$this->dbr->item,"*",0,$this->dbr->idsession);
    $dmst = $dmst->getTableau();
    
    if (!isset($dmst[0])) {
        $ndmst = new updateTableBrioche("dmst", array("nodoss" => $this->dbr->item), 0, "iddmst", $this->dbr->idsession);
        if($ndmst->ajouteEnr() != 1) print "PROBLEME AJOUT AUTO DMST";       
        $dmst = new ensTableBrioche("dmst","nodoss = ".$this->dbr->item,"*",0,$this->dbr->idsession);
        $dmst = $dmst->getTableau();
    }    
    $this->dmst = $dmst[0];
    if ($this->dmst->n_Sexe === "0") $this->dmst->n_Sexe = "F";
    if ($this->dmst->n_Sexe === "1") $this->dmst->n_Sexe = "M";
    
    $usager = new ensTableBrioche("usagers","usagers.nous = dossiers.nous","*",0,$this->dbr->idsession,"dossiers","dossiers.nodoss = ".$this->dbr->item);
    $usager = $usager->getTableau();
    $this->usager = $usager[0];
    
    $grille = new ensTableBrioche("grille","nodoss = ".$this->dbr->item,"*",0,$this->dbr->idsession);
    $grille = $grille->getTableau();
    $this->grille = $grille[0];
    
    $interv = new ensTableBrioche("dmstinterv","iddmst = ".$this->dmst->iddmst,"*",0,$this->dbr->idsession);
    $this->interv = $interv->getTableau();
    
    $medics = new ensTableBrioche("dmstmedics","iddmst = ".$this->dmst->iddmst,"*",0,$this->dbr->idsession);
    $this->medics = $medics->getTableau();
        
    $this->pv = new PPageVierge();
    
    // TITRE
    $c = new TPanel(4, 1);
    $x = new Label("<h1 id='top'>DOCUMENT MEDICO-SOCIAL DE TRANSMISSION</h1>");
    $c->addChamp($x);
    $this->pv->addChamp($c);
               
    // Modification pour la gnration du PDF
    // -------------------------------------------------------------------------------------------
    $c = new TPanel(2, 1, "RIGHT");
    $url = "impressionPDF.php?item=".$this->dmst->iddmst."&sessionid=".$this->dbr->idsession."&type=dmst";
    $js = "window.open(\"$url\");";
    $x = new Bouton("PDF", "Impression...", "BUTTON", $js);
    $c->addChamp($x);
    $c->addChamp(new Espace(4));
    $this->pv->addChamp($c);
    $this->pv->addLigne();
    // --------------------------------------------------------------------------------------------
    
    // MODIF
    $info = "";
    if ($this->dmst->source != '') {
        $info .= "Ce DMST provient de \"".$this->dmst->source."\"";
        if ($this->dmst->modifie) {
            $info .= " et a ensuite t modifi par le Brio.";   
        } else {
            $info .= ".";   
        }
    } else {
        //$info .= "Ce DMST provient du Brio.";
        $info .= "";
    }
    
    $c = new TPanel(2, 1);
    $x = new Label($info);
    $c->addChamp($x);
    $this->pv->addChamp($c);
    
    if ($ini->envoiDMSTactif) {    
        // Envoi DMST inter-brios
        $c = new TPanel(3, 1, "RIGHT");
        $brios = outilXML::getOrganisations("brios");
        $label = "Envoi lectronique du DMST  un autre BRIO";
        $html = "$label : <select id='brios' name='brios'>";
        foreach ($brios as $k => $brio) {
            $html .= "<option value='$k'>$brio</option>";   
        }
        $html .= "</select>";
        $x = new Label($html);
        $c->addChamp($x);
        $c->addChamp(new Espace(4));
        $js = "window.location=\"brioche.php?action=108.1&sessionid=".$this->dbr->idsession."&item=".$this->dbr->item.
              "&noetabl=\"+document.getElementById(\"brios\").value;";
        $x = new Bouton("Envoi", "Envoyer", "BUTTON", $js);
        $c->addChamp($x);
        $this->pv->addChamp($c);    
    }
    
    $this->pv->addChamp($this->tete);
    $this->pv->addLigne();

    $c = new TPanel(6, 1);
    $x = new Bouton("anchor",0,"HIDDEN","","","anchor");
    $c->addChamp($x);

    $ex = new extrVar();
    $ex->extrait("anchor");
    global $anchor;
    
    if ($anchor != "0" && $anchor != "") {
        $x = new Label("<script>window.location.hash='#$anchor';</script>");
        $c->addChamp($x);
    }
    $this->pv->addChamp($c);    
    $this->pv->addLigne();
    
    $c = new TPanel(6, 1, "RIGHT");
    $x = new Aide("C012");
    $c->addChamp($x);
    $c->addChamp(new Espace(5));
    $this->pv->addChamp($c);
    $this->pv->addLigne();
    
    $chaps = array("Donnes administratives","Famille, entourage","Habitat (description)",
                   "Contexte et habitudes de vie","Intervenants","Niveau d'autonomie","Bilan de sant",
                   "Prise en charge le jour du transfert");

    foreach ($chaps as $k => $chap) {
        $n = $k + 1;
        if (fmod($k,3) == 0) $c = new TPanel(2, 1);
        $x = new Label("<a href='#chap_$n'>$n. $chap</a>&nbsp;&nbsp;&nbsp;",false,false,true);
        $c->addChamp($x);
        if (fmod($k,3) == 2) $this->pv->addChamp($c);
        elseif ($k == count($chaps)-1) $this->pv->addChamp($c);
    }

    $this->pv->addLigne();
    $this->pv->addLigne();
       
    foreach ($chaps as $k => $chap) {
        $n = $k + 1;
        $c = new TPanel(6, 1);
        $x = new Label("<h2 id='chap_$n'>$n. $chap</h2>");
        $c->addChamp($x);
        $this->pv->addChamp($c);
        $this->pv->addLigne();
        $this->bloc($n);
        $this->pv->addLigne();
        $c = new TPanel(6, 1,"RIGHT");
        $x = new Label("<a href='#top'>haut</a>");
        $c->addChamp($x);
        $c->addChamp(new Espace(10));
        $this->pv->addChamp($c);
        $this->pv->addLigne();
        $this->pv->addLigne();
    }
            
    $c = new TPanel(6, 1);
    if ($anchor != "0" && $anchor != "") {
        $x = new Label("<script>if (navigator.userAgent.indexOf('MSIE') == -1) window.location.hash='#$anchor';</script>");
        $c->addChamp($x);
    }
    $this->pv->addChamp($c);    
    $this->pv->addLigne();
        
    $this->pv->addChamp($this->pied);
    $this->pv->addLigne(0.5);
                
  }
   
  function bloc($chap) {
     
    switch ($chap) {
      
      case 1:      
        $c = new TPanel(6, 1);
        $xNom = new ChampTexte("dmst[x_Nom]",$this->usager->nom,"Nom :","","",false,"TEXT","d2","","",true);
        $xPrenom = new ChampTexte("dmst[x_Prenom]",$this->usager->prenom,"Prnom :","","",false,"TEXT","d2","","",true);
        $xSexe = new ChampTexte("dmst[n_Sexe]",$this->usager->sexe,"Sexe",2,1,true,"TEXT","d2","","",true);
        $xNaiss = new ChampTexte("dmst[d_Naissance]",$this->usager->datenaiss,"Date de<br/>Naissance",10,10,true,"TEXT","d2","","controleDate('dmst[d_Naissance]', '', '', '')",true);
        $xLieu = new ChampTexte("dmst[x_Lieudenaissance]",$this->usager->lieunaiss,"Lieu de<br/>Naissance","","",true,"TEXT","d2","","",true);
        $xEntree = new ChampTexte("dmst[d_Dentree]",$this->dmst->d_Dentree,"Date<br/>d'entre",10,10,true,"TEXT","d2");
        $xSortie = new ChampTexte("dmst[d_Desortie]",$this->dmst->d_Desortie,"Date de<br/>sortie",10,10,true,"TEXT","d2");
        $xClient = new ChampTexte("dmst[x_Numerodeclient]",$this->dmst->x_Numerodeclient,"N&deg; client","","",true,"TEXT","d2");
        $xECivil = new ChampTexte("dmst[x_Etatcivil]",$this->dmst->x_Etatcivil,"Etat Civil :","","",false,"TEXT","d2");
        $xOrig = new ChampTexte("dmst[x_Origine]",$this->usager->origine,"Origine :","","",false,"TEXT","d2","","",true);
        $xFMater = new ChampTexte("dmst[x_Filmat]",$this->usager->filmat,"Filiation maternelle :","","",false,"TEXT","d2","","",true);
        $xRelig = new ChampTexte("dmst[x_Relconf]",$this->dmst->x_Relconf,"Religion/confession :","","",false,"TEXT","d2");
        $xNation = new ChampTexte("dmst[x_Nation]",$this->usager->nationalite,"Nationalit :","","",false,"TEXT","d2","","",true);
        $xFPater = new ChampTexte("dmst[x_Filpat]",$this->usager->filpat,"Filiation paternelle :","","",false,"TEXT","d2","","",true);
        $adresse = $this->usager->adresse." ".$this->usager->npa." ".$this->usager->loc;
        $xDomicile = new TextArea("dmst[x_Dom]",$adresse,"Domicile :",60,5,"virtual",true);
        $xTelDom = new ChampTexte("dmst[t_Domtel]",$this->usager->telephone,"Tl.","","",true,"TEXT","d2","","",true);
        $xProf = new ChampTexte("dmst[x_Profess]",$this->dmst->x_Profess,"Profession","","",true,"TEXT","d2");
        $xConj = new ChampTexte("dmst[x_Npconjoint]",$this->dmst->x_Npconjoint,"Nom et prnom du conjoint :","","",false,"TEXT","d2");
        $xTelUrg = new ChampTexte("dmst[t_Telurg]",$this->dmst->t_Telurg,"Tl. en urgence chez","","",false,"TEXT","d2");
        $xMedTrait = new ChampTexte("dmst[x_Medtrait]",$this->dmst->x_Medtrait,"Mdecin traitant :","","",false,"TEXT","d2");
        $xAssur = new ChampTexte("dmst[x_Ass]",$this->dmst->x_Ass,"Assurance :","","",false,"TEXT","d2");
        $xNumAss = new ChampTexte("dmst[x_Numass]",$this->dmst->x_Numass,"N&deg; d'assur :","","",false,"TEXT","d2");
        $xMedHop = new ChampTexte("dmst[x_Medhop]",$this->dmst->x_Medhop,"Mdecin de l'hpital :","","",false,"TEXT","d2");
        $xAVS = new ChampTexte("dmst[x_Numavs]",$this->usager->avs,"N&deg; AVS :","","",false,"TEXT","d2","","",true);
        
        $html = "<table width=98% style='border:2px black solid;border-left:1px black solid;' cellspacing=0 cellpadding=2>";
        $html .= "<tr><td colspan=3 style='border-left: 1px black solid;'>".$xNom->getContenu()."<br/>".$xPrenom->getContenu()."</td>";
        $html .= "<td style='border-left: 1px black solid;' align=center>".$xSexe->getContenu()."</td>";
        $html .= "<td style='border-left: 1px black solid;' align=center>".$xNaiss->getContenu()."</td>";
        $html .= "<td style='border-left: 1px black solid;' align=center>".$xLieu->getContenu()."</td>";
        $html .= "<td style='border-left: 1px black solid;' align=center>".$xEntree->getContenu()."</td>";
        $html .= "<td style='border-left: 1px black solid;' align=center>".$xSortie->getContenu()."</td>";
        $html .= "<td style='border-left: 1px black solid;' align=center>".$xClient->getContenu()."</td></tr>";
        $html .= "<tr><td colspan=3 style='border-left: 1px black solid;border-top: 1px black solid;'>".$xECivil->getContenu()."</td>";
        $html .= "<td colspan=3 style='border-left: 1px black solid;border-top: 1px black solid;'>".$xOrig->getContenu()."</td>";
        $html .= "<td colspan=3 style='border-left: 1px black solid;border-top: 1px black solid;'>".$xFMater->getContenu()."</td></tr>";
        $html .= "<tr><td colspan=3 style='border-left: 1px black solid;border-top: 1px black solid;'>".$xRelig->getContenu()."</td>";
        $html .= "<td colspan=3 style='border-left: 1px black solid;border-top: 1px black solid;'>".$xNation->getContenu()."</td>";
        $html .= "<td colspan=3 style='border-left: 1px black solid;border-top: 1px black solid;'>".$xFPater->getContenu()."</td></tr>";
        $html .= "<tr><td colspan=3 style='border-left: 1px black solid;border-top: 1px black solid;'>".$xDomicile->getContenu()."</td>";
        $html .= "<td colspan=3 style='border-left: 1px black solid;border-top: 1px black solid;'>".$xTelDom->getContenu()."</td>";
        $html .= "<td colspan=3 style='border-left: 1px black solid;border-top: 1px black solid;'>".$xProf->getContenu()."</td></tr>";
        $html .= "<tr><td colspan=6 style='border-left: 1px black solid;border-top: 1px black solid;'>".$xConj->getContenu()."</td>";
        $html .= "<td colspan=3 style='border-left: 1px black solid;border-top: 1px black solid;'>".$xTelUrg->getContenu()."</td></tr>";        
        $html .= "<tr><td colspan=5 style='border-left: 1px black solid;border-top: 1px black solid;'>".$xMedTrait->getContenu()."</td>";
        $html .= "<td colspan=4 style='border-left: 1px black solid;border-top: 1px black solid;'>".$xAssur->getContenu()."</td></tr>";
        $html .= "<tr><td colspan=5 style='border-left: 1px black solid;'>&nbsp;</td>";
        $html .= "<td colspan=4 style='border-left: 1px black solid;'>".$xNumAss->getContenu()."</td></tr>";
        $html .= "<tr><td colspan=5 style='border-left: 1px black solid;'>".$xMedHop->getContenu()."</td>";
        $html .= "<td colspan=4 style='border-left: 1px black solid;'>".$xAVS->getContenu()."</td></tr>";
        $html .= "</table>";
        $x = new Label($html);
        $c->addChamp($x);
        $this->pv->addChamp($c);
        break;
      case 2:
        $c = new TPanel(6, 1);
        $xPersRef = new ChampTexte("dmst[x_Persrefnom]",$this->dmst->x_Persrefnom,"Presonne de rfrence :","","",false,"TEXT","d2");
        $xPersRefTel = new ChampTexte("dmst[t_Persreftel]",$this->dmst->t_Persreftel,"Tl. :","","",false,"TEXT","d2");
        $xPersRefAdr = new TextArea("dmst[x_Persrefadr]",$this->dmst->x_Persrefadr,"Adresse :",200,5);
        $xPersPat = new ChampTexte("dmst[x_Persviv]",$this->dmst->x_Persviv,"Presonne(s) vivant avec le patient :","","",false,"TEXT","d2");
        $xPersPatTel = new ChampTexte("dmst[t_Persvivtel]",$this->dmst->t_Persvivtel,"Tl. :","","",false,"TEXT","d2");
        $xPersPatAdr = new TextArea("dmst[x_Persvivadr]",$this->dmst->x_Persvivadr,"Adresse :",200,5);
        $xTutcur = new ChampTexte("dmst[x_Cur]",$this->dmst->x_Cur,"Tuteur/curateur :","","",false,"TEXT","d2");
        $xTutcurTel = new ChampTexte("dmst[t_Curtel]",$this->dmst->t_Curtel,"Tl. :","","",false,"TEXT","d2");
        $xTutcurAdr = new TextArea("dmst[x_Curadr]",$this->dmst->x_Curadr,"Adresse :",200,5);
        
        $html = "<table width=98% style='border:2px black solid;' cellspacing=0 cellpadding=2>";
        $html .= "<tr><td>".$xPersRef->getContenu()."</td>";
        $html .= "<td>".$xPersRefTel->getContenu()."</td></tr>";
        $html .= "<tr><td colspan=2>".$xPersRefAdr->getContenu()."</td></tr>";
        $html .= "<tr><td style='border-top: 1px black solid;'>".$xPersPat->getContenu()."</td>";
        $html .= "<td style='border-top: 1px black solid;'>".$xPersPatTel->getContenu()."</td></tr>";
        $html .= "<tr><td colspan=2>".$xPersPatAdr->getContenu()."</td></tr>";
        $html .= "<tr><td style='border-top: 1px black solid;'>".$xTutcur->getContenu()."</td>";
        $html .= "<td style='border-top: 1px black solid;'>".$xTutcurTel->getContenu()."</td></tr>";
        $html .= "<tr><td colspan=2>".$xTutcurAdr->getContenu()."</td></tr>";
        $html .= "</table>";
        $x = new Label($html);
        $c->addChamp($x);
        $this->pv->addChamp($c);
        break;
      case 3:
        $c = new TPanel(6, 1);
        $xItiAcc = new TextArea("dmst[a_Iti]",$this->dmst->a_Iti,"Itinraire et accs / Barrires architecturales / Caractristiques du logement :",200,10);
        
        $html = "<table width=98% style='border:2px black solid;' cellspacing=0 cellpadding=2>";
        $html .= "<tr><td>".$xItiAcc->getContenu()."</td></tr>";
        $html .= "</table>";
        $x = new Label($html);
        $c->addChamp($x);
        $this->pv->addChamp($c);
        break;
      case 4:
        $c = new TPanel(6, 1);
        $xResBes = new TextArea("dmst[a_Resbes]",$this->dmst->a_Resbes,"Ressources et besoins, vnements et faits marquants, relations socio-familiales significatives :",200,10);
        
        $html = "<table width=98% style='border:2px black solid;' cellspacing=0 cellpadding=2>";
        $html .= "<tr><td>".$xResBes->getContenu()."</td></tr>";
        $html .= "</table>";
        $x = new Label($html);
        $c->addChamp($x);
        $this->pv->addChamp($c);
        break;
      case 5:
        $c = new TPanel(6, 1);
        
        $html = "<table width=98% style='border:2px black solid;border-left:1px black solid;' cellspacing=0 cellpadding=2>";
        $html .= "<tr><td colspan=2 style='border-left: 1px black solid;' align=center><b>Nom de l'intervenant et fonction</b></td>";
        $html .= "<td style='border-left: 1px black solid;' align=center><b>Tlphone</b></td>";
        $html .= "<td colspan=2 style='border-left: 1px black solid;' align=center><b>Prcisions</b></td></tr>";
        for ($i=0;$i<count($this->interv)+1;$i++) {
            if (isset($this->interv[$i]->x_int_nom)) $x_int_nom = $this->interv[$i]->x_int_nom; else $x_int_nom = "";
            if (isset($this->interv[$i]->t_int)) $t_int = $this->interv[$i]->t_int; else $t_int = "";
            if (isset($this->interv[$i]->x_int_precision)) $x_int_precision = $this->interv[$i]->x_int_precision; else $x_int_precision = "";
            $xInter = new ChampTexte("dmst[x_int_nom][$i]",$x_int_nom,"",50,"",false,"TEXT","d2");
            $xInterTel = new ChampTexte("dmst[t_int][$i]",$t_int,"","","",false,"TEXT","d2");
            $xInterPrec = new ChampTexte("dmst[x_int_precision][$i]",$x_int_precision,"","","",false,"TEXT","d2");
            $html .= "<tr><td colspan=2 style='border-left: 1px black solid;border-top: 1px black solid;' align=center>".$xInter->getContenu()."</td>";
            $html .= "<td style='border-left: 1px black solid;border-top: 1px black solid;' align=center>".$xInterTel->getContenu()."</td>";
            $html .= "<td style='border-left: 1px black solid;border-top: 1px black solid;' align=center>".$xInterPrec->getContenu()."</td>";
            if (isset($this->interv[$i]->idinterv)) {
                $js = "document.getElementById(\"dmst[x_int_nom][$i]\").value=\"\";".
                      "document.getElementById(\"anchor\").value=\"chap_5\";";
                $x = new Bouton("EffacerInterv", "&mdash;", "submit", $js, "bok");
                $cont = $x->getContenu();
            } else $cont = "&nbsp;";
            $html .= "<td align=right style='border-top: 1px black solid;'>$cont</td></tr>";
        }        
        $js = "document.getElementById(\"anchor\").value=\"chap_5\";";
        $x = new Bouton("Envoyer", "+", "submit", $js, "bok");
        $html .= "<tr><td style='border-top:1px black solid;border-left:1px black solid;' colspan=6 align=right>".$x->getContenu()."</td></tr>";
        $html .= "</table>";
        $x = new Label($html);
        $c->addChamp($x);
        $this->pv->addChamp($c);
        break;
      case 6:
        $grille = $this->grille;
                        
        $c = new TPanel(6, 1);
        $x = new Label("1.Autonome 2.Surveillance/Stimulation 3.Exige de l'aide 4.Dpendant");
        $c->addChamp($x);
        $this->pv->addChamp($c);
        $this->pv->addLigne();
        $fondgris = "fondgris";
        
        $this->acb = new AutoCheckBox();
        
        $html = "<table width=98% cellspacing=0 style='border:1px black solid;' cellpadding=2><tr><td valign='top' width=50% style='border:1px black solid;'>";

        $html .= "<table width=100% cellspacing=0>";
        $html .= "<tr><td style='border-bottom:1px black solid;'>&nbsp;</td>";
        $html .= "<td style='border-bottom:1px black solid;' align=right><b>1</b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>";
        $html .= "<td style='border-bottom:1px black solid;' align=center><b>2</b></td>";
        $html .= "<td style='border-bottom:1px black solid;' align=center><b>3</b></td>";
        $html .= "<td style='border-bottom:1px black solid;' align=center><b>4</b></td></tr>";
                
        $html .= "<tr><td colspan='5'><b>Activits de la vie quotidienne :</b></td></tr>";
        $html .= "<tr>".$this->oneRadio("Manger - boire", "grille[manger]", $grille->manger, $fondgris)."</tr>";
        $html .= "<tr>".$this->oneRadio("Se laver", "grille[laver]", $grille->laver, "")."</tr>";
        $html .= "<tr>".$this->oneRadio("S'habiller", "grille[habiller]", $grille->habiller, $fondgris)."</tr>";
        $html .= "<tr>".$this->oneRadio("Se dshabiller", "grille[deshab]", $grille->deshab, "")."</tr>";
        $html .= "<tr>".$this->oneRadio("Entretenir sa personne", "grille[entpers]", $grille->entpers, $fondgris)."</tr>";
        $html .= "<tr>".$this->oneRadio("Continence vsicale", "grille[contves]", $grille->contves, "")."</tr>";
        $html .= "<tr>".$this->oneRadio("Continence anale", "grille[contana]", $grille->contana, $fondgris)."</tr>";
        $html .= "<tr>".$this->oneRadio("Utiliser les toilettes", "grille[toilet]", $grille->toilet, "")."</tr>";
        
        $html .= "<tr><td colspan='5'><b>Mobilit :</b></td></tr>";
        $html .= "<tr>".$this->oneRadio("Changer de position", "grille[changpos]", $grille->changpos, $fondgris)."</tr>";
        $html .= "<tr>".$this->oneRadio("Se dplacer  l'intrieur", "grille[deplint]", $grille->deplint, "")."</tr>";
        $html .= "<tr>".$this->oneRadio("Se dplacer  l'extrieur", "grille[deplext]", $grille->deplext, $fondgris)."</tr>";
        $html .= "<tr>".$this->oneRadio("Utiliser les moyens de transport", "grille[moytransp]", $grille->moytransp, "")."</tr>";
        $html .= "<tr>".$this->oneRadio("Utiliser les moyens auxiliaire", "grille[auxil]", $grille->auxil, $fondgris)."</tr>";
        $html .= "<tr>".$this->oneRadio("Utiliser les escaliers", "grille[escaliers]", $grille->escaliers, "")."</tr>";
        
        $html .= "</table>";
        
        $html .= "</td><td valign='top' style='border:1px black solid;'>";
        
        $html .= "<table width=100% cellspacing=0>";
        $html .= "<tr><td style='border-bottom:1px black solid;'>&nbsp;</td>";
        $html .= "<td style='border-bottom:1px black solid;' align=right><b>1</b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>";
        $html .= "<td style='border-bottom:1px black solid;' align=center><b>2</b></td>";
        $html .= "<td style='border-bottom:1px black solid;' align=center><b>3</b></td>";
        $html .= "<td style='border-bottom:1px black solid;' align=center><b>4</b></td></tr>";
                
        $html .= "<tr><td colspan='5'><b>Communication :</b></td></tr>";
        $html .= "<tr>".$this->oneRadio("Voir", "grille[voir]", $grille->voir, $fondgris)."</tr>";
        $html .= "<tr>".$this->oneRadio("Entendre", "grille[entendre]", $grille->entendre, "")."</tr>";
        $html .= "<tr>".$this->oneRadio("Parler", "grille[parler]", $grille->parler, $fondgris)."</tr>";
        $html .= "<tr>".$this->oneRadio("Utiliser le tlphone", "grille[telephone]", $grille->telephone, "")."</tr>";
        
        $html .= "<tr><td colspan='5'><b>Etat psychique / Facults mentales :</b></td></tr>";
        $html .= "<tr>".$this->oneRadio("Mmoire", "grille[memoire]", $grille->memoire, $fondgris)."</tr>";
        $html .= "<tr>".$this->oneRadio("Orientation (temps, espace)", "grille[orientat]", $grille->orientat, "")."</tr>";
        $html .= "<tr>".$this->oneRadio("Jugement / comprhension", "grille[jugement]", $grille->jugement, $fondgris)."</tr>";
        $html .= "<tr>".$this->oneRadio("Grer son temps libre, s'occuper", "grille[soccuper]", $grille->soccuper, "")."</tr>";
        
        $html .= "<tr><td colspan='5'><b>Tches domestiques :</b></td></tr>";
        $html .= "<tr>".$this->oneRadio("Entretenir son logement", "grille[entrlog]", $grille->entrlog, $fondgris)."</tr>";
        $html .= "<tr>".$this->oneRadio("Prparer les repas", "grille[preprepas]", $grille->preprepas, "")."</tr>";
        $html .= "<tr>".$this->oneRadio("Faire les courses", "grille[courses]", $grille->courses, $fondgris)."</tr>";
        $html .= "<tr>".$this->oneRadio("Faire la lessive - entretenir le linge", "grille[lessive]", $grille->lessive, "")."</tr>";
        $html .= "<tr>".$this->oneRadio("Prendre ses mdicaments", "grille[medics]", $grille->medics, $fondgris)."</tr>";
        $html .= "<tr>".$this->oneRadio("Gestion administrative", "grille[gestad]", $grille->gestad, "")."</tr>";
        $html .= "<tr>".$this->oneRadio("Grer ses liens sociaux", "grille[lienssociaux]", $grille->lienssociaux, $fondgris)."</tr>";
        
        $html .= "</table>";
        
        $html .= "</td></tr></table>";
        
        $c = new TPanel(6, 1);
        $x = new Label("$html");
        $c->addChamp($x);
        $this->pv->addChamp($c);
        $this->pv->addLigne();
        $this->pv->addLigne();
        
        $c = new TPanel(6, 1);
        $xTransAvec = new ChampTexte("dmst[x_Transfavec]",$this->dmst->x_Transfavec,"Transfr avec (cannes, lunettes, prothses, ...) :","","",false,"TEXT","d2");
        $xTransPar = new ChampTexte("dmst[x_Transportpar]",$this->dmst->x_Transportpar,"Transport effectu par :","","",false,"TEXT","d2");
        $xTransDate = new ChampTexte("dmst[d_Transport]",$this->dmst->d_Transport,"le :",10,10,false,"TEXT","d2","","controleDate('dmst[d_Naissance]', '', '', '')");
                
        $html = "<table width=98% style='border:2px black solid;' cellspacing=0 cellpadding=2>";
        $html .= "<tr><td colspan=2>".$xTransAvec->getContenu()."</td></tr>";
        $html .= "<tr><td>".$xTransPar->getContenu()."</td>";
        $html .= "<td>".$xTransDate->getContenu()."</td></tr>";
        $html .= "</table>";
        $x = new Label($html);
        $c->addChamp($x);
        $c->addChamp($this->acb);
        $this->pv->addChamp($c);
        
        break;
      case 7:
        $c = new TPanel(6, 1);
        $intro = "Etat gnral / Respiration / Circulation - temprature / Alimentation, hydratation, digestion / 
        Elimination (incontinence, appareillage), sondes et stomies diverses (avec date de la pose) / 
        Mobilisation (coordination, posture, spasticit, etc.) / Handicaps sensoriels et appareillage /
        Etat de la peau, des ongles et cicatrices / Sommeil et repos / Etat psychique / Autre :";
        $xEtatGen = new TextArea("dmst[A_Etatgeneral]",$this->dmst->A_Etatgeneral,$intro,200,10);
        
        $html = "<table width=98% style='border:2px black solid;' cellspacing=0 cellpadding=2>";
        $html .= "<tr><td>".$xEtatGen->getContenu()."</td></tr>";
        $html .= "</table>";
        $x = new Label($html);
        $c->addChamp($x);
        $this->pv->addChamp($c);
        break;
      case 8:
        $c = new TPanel(6, 1);
        $intro1 = "Motif du transfert / Objectifs de soins / Projets pour le patient :";
        $intro2 = "Traitements en cours et soins  effectuer / Moyens et matriel de soins ncessaires / Surveillance :";
        $xMotif = new TextArea("dmst[a_Motiftransfert]",$this->dmst->a_Motiftransfert,$intro1,200,10);
        $xTraitCours = new TextArea("dmst[a_Traitcours]",$this->dmst->a_Traitcours,$intro2,200,10);
        $xMedOrd = new ChampTexte("dmst[x_Med_Ord]",$this->dmst->x_Med_Ord,"Mdicaments ordonnes par Dr :","","",false,"TEXT","d2");
        $xTelMTr = new ChampTexte("dmst[t_Med_Tel]",$this->dmst->t_Med_Tel,"Tl :","","",false,"TEXT","d2");
        
        $html = "<table width=98% style='border:2px black solid;' cellspacing=0 cellpadding=2>";
        $html .= "<tr><td colspan=7>".$xMotif->getContenu()."</td></tr>";
        $html .= "<tr><td colspan=7 style='border-top:1px black solid;border-bottom:2px black solid;'>".$xTraitCours->getContenu()."</td></tr>";
        $html .= "<tr><td>Mdicaments (valable le jour du transfert) :</td><td>Matin</td><td>Midi</td><td>Soir</td><td>Nuit</td><td>Autres</td><td>&nbsp;</td></tr>";
        for ($i=0;$i<count($this->medics)+1;$i++) {
            if (isset($this->medics[$i]->x_Med_Nom)) $x_Med_Nom = $this->medics[$i]->x_Med_Nom; else $x_Med_Nom = "";
            if (isset($this->medics[$i]->b_Med_Matin)) $b_Med_Matin = $this->medics[$i]->b_Med_Matin; else $b_Med_Matin = "";
            if (isset($this->medics[$i]->b_Med_Midi)) $b_Med_Midi = $this->medics[$i]->b_Med_Midi; else $b_Med_Midi = "";
            if (isset($this->medics[$i]->b_Med_Soir)) $b_Med_Soir = $this->medics[$i]->b_Med_Soir; else $b_Med_Soir = "";
            if (isset($this->medics[$i]->b_Med_Nuit)) $b_Med_Nuit = $this->medics[$i]->b_Med_Nuit; else $b_Med_Nuit = "";
            if (isset($this->medics[$i]->x_Med_Autres)) $x_Med_Autres = $this->medics[$i]->x_Med_Autres; else $x_Med_Autres = "";
            $xMedics = new ChampTexte("dmst[x_Med_Nom][$i]",$x_Med_Nom,"",50,"",false,"TEXT","d2");
            $xMedMatin = new ChampTexte("dmst[b_Med_Matin][$i]",$b_Med_Matin,"",10,"",false,"TEXT","d2");
            $xMedMidi = new ChampTexte("dmst[b_Med_Midi][$i]",$b_Med_Midi,"",10,"",false,"TEXT","d2");
            $xMedSoir = new ChampTexte("dmst[b_Med_Soir][$i]",$b_Med_Soir,"",10,"",false,"TEXT","d2");
            $xMedNuit = new ChampTexte("dmst[b_Med_Nuit][$i]",$b_Med_Nuit,"",10,"",false,"TEXT","d2");
            $xMedAutres = new ChampTexte("dmst[x_Med_Autres][$i]",$x_Med_Autres,"","","",false,"TEXT","d2");
            $html .= "<tr><td>".$xMedics->getContenu()."</td><td>".$xMedMatin->getContenu()."</td><td>".$xMedMidi->getContenu()."</td>";
            $html .= "<td>".$xMedSoir->getContenu()."</td><td>".$xMedNuit->getContenu()."</td><td>".$xMedAutres->getContenu()."</td>";
            if (isset($this->medics[$i]->idmedic)) {
                $js = "document.getElementById(\"dmst[x_Med_Nom][$i]\").value=\"\";".
                      "document.getElementById(\"anchor\").value=\"chap_8\";";
                $x = new Bouton("EffacerMedics", "&mdash;", "submit", $js, "bok");
                $cont = $x->getContenu();
            } else $cont = "&nbsp;";
            $html .= "<td align=right>$cont</td></tr>";
        }
        $js = "document.getElementById(\"anchor\").value=\"chap_8\";";
        $x = new Bouton("Envoyer", "+", "submit", $js, "bok");
        $html .= "<tr><td colspan=7 align=right>".$x->getContenu()."</td></tr>";
        
        $html .= "<tr><td colspan=3 style='border-top:2px black solid;'>".$xMedOrd->getContenu()."</td>";
        $html .= "<td colspan=4 style='border-top:2px black solid;'>".$xTelMTr->getContenu()."</td></tr>";
        $html .= "</table>";
        $x = new Label($html);
        $c->addChamp($x);
        $this->pv->addChamp($c);
        break;
      default:
        break;
    }        
  }
  
  function oneRadio($label, $nom, $value, $style = "") {
     
    $html = ""; 
    
    $c = new TPanel(1, 1, "", "", "", $style);
    $c->addChamp(new Espace(5));
    $x = new Label($label);
    $c->addChamp($x);
    $html .= $c->TGetContenu();
    
    $c = new TPanel(1, 1, "RIGHT", "", "", $style);
    $x = new GrBoutonRadio($nom, $value, "", "donnees");
    $x->addRadio("", "1");
    $c->addChamp($x);
    $this->acb->addCase($x);
    $html .= $c->TGetContenu();
    
    $c = new Tpanel(1, 1, "RIGHT", "", "", $style);
    $x = new GrBoutonRadio($nom, $value);
    $x->addRadio("", "2");
    $c->addChamp($x);
    $html .= $c->TGetContenu();
    $c = new Tpanel(1, 1, "RIGHT", "", "", $style);
    $x = new GrBoutonRadio($nom, $value);
    $x->addRadio("", "3");
    $c->addChamp($x);
    $html .= $c->TGetContenu();
    $c = new Tpanel(1, 1, "RIGHT", "", "", $style);
    $x = new GrBoutonRadio($nom, $value);
    $x->addRadio("", "4");
    $c->addChamp($x);
    $html .= $c->TGetContenu();
        
    return $html;
    
  }
}