<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Page du dossier correspondant  l'onglet "OPARS"
* @package formulaires
*/
/**
* Page du dossier correspondant  l'onglet "OPARS"
* Arbre dcisionnel informatisant l'outil OPARS de l'IUMSP
* @package formulaires
* @author ob
*/
class pageDossierBriocheOpars extends pageDossierBrioche {
  /**
  * @param object dossierBrioche le dossier qui contient cette page
  */
  function pageDossierBriocheOpars(&$dbr) {
    $this->pageDossierBrioche($dbr);
    $profilopars = $this->dbr->rs->getEnr("profilopars");
    $this->pv = new PPageVierge();
    $c = new TPanel(3, 1);
    $x = new ChampTexte("profilopars[datev]", $profilopars->datev, "Date valuation&nbsp;:", 15, 15, false, "text", "d2", "controleDate('profilopars[datev]', '', '', '')");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $c = new TPanel(2, 1);
    $x = new ChampTexte("profilopars[faitepar]", $profilopars->faitepar, "Faite par&nbsp;:", 20, 30, false, "text", "d2");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $c = new TPanel(1,1);
    $x = new Aide("C011");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $acb = new AutoCheckBox();
    $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "", "Situation sociale&nbsp;:");
    $x = new GrBoutonRadio("profilopars[sitsoc]", $profilopars->sitsoc, "", "donnees");
    $x->addRadio("A&nbsp;: Vit seul sans aide des proches", 1);
    $x->addRadio("B&nbsp;: Vit seul avec aide des proches", 2);
    $x->addRadio("C&nbsp;: Vit en mnage", 3);
    $acb->addCase($x);
    $c->addChamp($x);
    $x = new Bouton("profilopars[profil]", $profilopars->profil, "HIDDEN");
    $c->addChamp($x);
    $c->addChamp($acb);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();

    //Textes des questions
    $t1 = "L'usager est-il indpendant pour se laver&nbsp;?";
    $t2 = "L'usager est-il indpendant pour l'entretien du mnage, la lessive et le repassage&nbsp;?";
    $t3 = "L'usager prpare-t-il ses repas de manire indpendante&nbsp;?";
    $t4 = "L'usager peut-il prendre un taxi et faire ses courses de manire indpendante&nbsp;?";
    $t5 = "Les capacits cognitives de l'usager sont-elles prserves&nbsp;?";
    $t6 = "Se transfrer / s'habiller / manger : pour combien de ces actes l'usager a-t-il besoin d'aide&nbsp;?";
    $oui = "<FONT COLOR=\"green\">Oui</FONT>";
    $non = "<FONT COLOR=\"red\">Non</FONT>";
    $boui = "&nbsp;&nbsp;&nbsp;Oui&nbsp;&nbsp;&nbsp";
    $bnon = "&nbsp;&nbsp;&nbsp;Non&nbsp;&nbsp;&nbsp";
    if ($profilopars->profil) { //Le profil a t dtermin
      if (! $profilopars->sitsoc){
        $al = new Alerte("Prire d\'indiquer la situation sociale !");
        $al->imprime();
      }
      $c = new TPanel(6, 1);
      $x = new Label("Question 1&nbsp;: $t1 ");
      $c->addChamp($x);
      if ($profilopars->profil < 7){ //Q1 oui
        $x = new Label($oui);
        $c->addChamp($x);
        $this->pv->addChamp($c);
        $this->pv->addLigne();
        $c = new TPanel(6, 1);
        $x = new Label("Question 2&nbsp;: $t2 ");
        $c->addChamp($x);
        if ($profilopars->profil == 1) { //Q2 oui -> profil 1
          $x = new Label($oui);
          $c->addChamp($x);
          $this->pv->addChamp($c);
          $this->pv->addLigne();
        }
        else { //Q2 non
          $x = new Label($non);
          $c->addChamp($x);
          $this->pv->addChamp($c);
          $this->pv->addLigne();
          $c = new TPanel(6, 1);
          $x = new Label("Question 3&nbsp;: $t3 ");
          $c->addChamp($x);
          if ($profilopars->profil == 2 || $profilopars->profil == 4 || $profilopars->profil == 6){ //Q3 oui
            $x = new Label($oui);
          }
          else { //Q3 non
            $x = new Label($non);
          }
          $c->addChamp($x);
          $this->pv->addChamp($c);
          $this->pv->addLigne();
          $c = new TPanel(6, 1);
          $x = new Label("Question 4&nbsp;: $t4 ");
          $c->addChamp($x);
          if ($profilopars->profil == 2 || $profilopars->profil == 3){ //Q4 oui -> profil 2
            $x = new Label($oui);
            $c->addChamp($x);
            $this->pv->addChamp($c);
          }
          else {
            $x = new Label($non);
            $c->addChamp($x);
            $this->pv->addChamp($c);
            $this->pv->addLigne();
            $c = new TPanel(6, 1);
            $x = new Label("Question 5&nbsp;: $t5 ");
            $c->addChamp($x);
            if ($profilopars->profil == 4 || $profilopars->profil == 5){ //Q5 oui -> profil 4 ou 5
              $x = new Label($oui);
              $c->addChamp($x);
              $this->pv->addChamp($c);
            }
            elseif ($profilopars->profil == 6 || $profilopars->profil == -6) { //Q5 non -> profil 6 ou -6
              $x = new Label($non);
              $c->addChamp($x);
              $this->pv->addChamp($c);
            }
          }
        }
      }
      else { //Q1 non
        $x = new Label($non);
        $c->addChamp($x);
        $this->pv->addChamp($c);
        $this->pv->addLigne();
        $c = new TPanel(6, 1);
        $x = new Label("Question 2&nbsp;: $t6 ");
        $c->addChamp($x);
        if ($profilopars->profil < 10) { //Q2 0
          $x = new Label("<FONT COLOR=\"ORANGE\">Aucun</FONT>");
          $c->addChamp($x);
          $this->pv->addChamp($c);
          $this->pv->addLigne();
          $c = new TPanel(6, 1);
          $x = new Label("Question 3&nbsp;: $t4 ");
          $c->addChamp($x);
          if ($profilopars->profil == 7) { //Q3 oui -> 7
            $x = new Label($oui);
            $c->addChamp($x);
            $this->pv->addChamp($c);
            $this->pv->addLigne();
          }
          else { //Q3 non
            $x = new Label($non);
            $c->addChamp($x);
            $this->pv->addChamp($c);
            $this->pv->addLigne();
            $c = new TPanel(6, 1);
            $x = new Label("Question 4&nbsp;: $t5 ");
            $c->addChamp($x);
            if ($profilopars->profil == 8) { //Q4 oui -> 8
              $x = new Label($oui);
              $c->addChamp($x);
            }
            else {//Q4 non -> 9
              $x = new Label($non);
              $c->addChamp($x);
            }
            $this->pv->addChamp($c);
            $this->pv->addLigne();
          }
        }
        else { //Q2 1-3
          if ($profilopars->profil == 10 || $profilopars->profil == 11){ //Q2 1
            $x = new Label("<FONT COLOR=\"ORANGE\">1</FONT>");
            $c->addChamp($x);
            $this->pv->addChamp($c);
            $this->pv->addLigne();
          }
          else { //Q2 2-3
            $x = new Label("<FONT COLOR=\"ORANGE\">2-3</FONT>");
            $c->addChamp($x);
            $this->pv->addChamp($c);
            $this->pv->addLigne();
          }
          $c = new TPanel(6, 1);
          $x = new Label("Question 3&nbsp;: $t5 ");
          $c->addChamp($x);
          if ($profilopars->profil == 10 || $profilopars->profil == 12){ //Q3 oui
            $x = new Label($oui);
            $c->addChamp($x);
          }
          else {
            $x = new Label($non);
            $c->addChamp($x);
          }
          $this->pv->addChamp($c);
          $this->pv->addLigne();
        }

      }
      $this->pv->addLigne();
      $profilabs = abs($profilopars->profil);
      $c = new TPanel(6, 1);
      $x = new Label("<B>Profil&nbsp;:<FONT SIZE=\"+2\" COLOR=\"RED\">&nbsp;$profilabs" . $this->abc($profilopars->sitsoc) . "</FONT></B>");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne(0.5);
      $this->pv->addLigne();
      $c = new TPanel(6, 1);
      $x = new Bouton("Recommencer", "Recommencer l'valuation", "BUTTON", "for(i=0;i<document.donnees.elements.length;i++){if(document.donnees.elements[i].name==\"profilopars[profil]\"){document.donnees.elements[i].value=0;break;}}document.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(5));
      $x = new Label("(L'valuation prcdemment enregistre sera perdue)", false, true);
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne(0.5);
      $this->pv->addLigne();
      $lp = new ensTableBrioche("listeprofils", "1", "*", 0, $this->dbr->idsession);
      $det = $lp->lookUp("texte", "noprof = $profilopars->profil");
      $c = new TPanelCadre(6, 1, "LEFT", "MIDDLE", "", "Rsum&nbsp;:");
      $x = new Label($det, false, true);
      $c->addChamp($x);
      $this->pv->addChamp($c);
      if ($profilopars->sitsoc) { //affichage des options de soins
        $this->pv->addLigne();
        $this->pv->addLigne();
        $c = new TPanel(6, 1);
        $x = new Label("Options de soins", true);
        $c->addChamp($x);
        $this->pv->addChamp($c);
        $os = new ensTableBrioche("optionssoin", "profil = $profilabs AND sitsoc = $profilopars->sitsoc",
                                  "*", "loption", $this->dbr->idsession);
        $cos = $os->compte();
        $tos = $os->getTableau();
        $la = new ensTableBrioche("listeaides", "1", "*", 0, $this->dbr->idsession);
        $lis = $la->compte();
        $tis = $la->getTableau();
        $contTable = "<TABLE><TH></TH>";
        for ($i = 1; $i <= $cos; $i++){
          $contTable .= "<TD><B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Option $i&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</B></TD>";
        }
        $contTable .= "<TR><TD>&nbsp;</TD>";
        for ($i = 0; $i < $cos; $i++){
          $contTable .= "<TD>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" . $tos[$i]->lieudevie . "</TD>";
        }
        $contTable .= "</TR>";
        for ($j = 0; $j < $lis; $j++){
          if (! ($j % 2)){
            $color = $this->dbr->grise;
          }
          else {
            $color = "#ffffff";
          }
          $contTable .= "<TR><TD BGCOLOR=\"$color\">" . $tis[$j]->texte ."&nbsp;&nbsp;&nbsp;</TD>";
          for ($i = 0; $i < $cos; $i++){
            $abr = strtolower($tis[$j]->abrev);
            $ligne = $tos[$i];
            if ($tos[$i]->$abr) {
              $contTable .= "<TD ALIGN=\"CENTER\" BGCOLOR=\"$color\">X</TD>";
            }
            else {
              $contTable .= "<TD BGCOLOR=\"$color\">&nbsp;</TD>";
            }
          }
          $contTable .= "</TR>";
        }
        $contTable .= "</TABLE>";
        $this->pv->addLigne(0.5);
        $this->pv->addLigne();
        $c = new TPanel(6, 1);
        $x = new Label ($contTable);
        $c->addChamp($x);
        $this->pv->addChamp($c);
      }
    }
    else {   //Le profil n'a pas t dtermin
      $reponsed = "document.donnees.options.value=\"";
      $reponsef = "\";document.donnees.submit();";
      $options = $this->dbr->options;
      $c = new TPanel(4, 1);
      $x = new Label("Question 1&nbsp;: $t1 ");
      $c->addChamp($x);
      if ($options->getOption("Q1")) { //rponse 1 dj fournie
        if($options->getOption("Q1") == 1){ // rponse 1 oui
          $x = new Label($oui);
          $c->addChamp($x);
          $this->pv->addChamp($c);
          $this->pv->addLigne();
          $c = new TPanel(4, 1);
          $x = new Label("Question 2&nbsp;: $t2 ");
          $c->addChamp($x);
          if ($options->getOption("Q2")) { //rponse 2 dj fournie
            if ($options->getOption("Q2") == 1){ // rponse 2 oui
              // profil 1
            }
            else { //rponse 2 non
              $x = new Label($non);
              $c->addChamp($x);
              $this->pv->addChamp($c);
              $this->pv->addLigne();
              $c = new TPanel(4, 1);
              $x = new Label("Question 3&nbsp;: $t3 ");
              $c->addChamp($x);
              if ($options->getOption("Q3")) { //rponse 3 dj fournie
                if ($options->getOption("Q3") == 1){ // rponse 3 oui
                  $x = new Label($oui);
                  $c->addChamp($x);
                  $this->pv->addChamp($c);
                  $this->pv->addLigne();
                  $c = new TPanel(4, 1);
                  $x = new Label("Question 4&nbsp;: $t4 ");
                  $c->addChamp($x);
                  if ($options->getOption("Q4")) { //rponse 4 dj fournie
                    if ($options->getOption("Q4") == 1){ // rponse 4 oui
                      // profil 2
                    }
                    else { //rponse 4 non
                      $x = new Label($non);
                      $c->addChamp($x);
                      $this->pv->addChamp($c);
                      $this->pv->addLigne();
                      $c = new TPanel(4, 1);
                      $x = new Label("Question 5&nbsp;: $t5 ");
                      $c->addChamp($x);
                      $this->pv->addChamp($c);
                      $c = new TPanel(2, 1);
                      $x = new Bouton("Oui", $boui, "BUTTON", $this->profil(4)); //profil 4
                      $c->addChamp($x);
                      $c->addChamp(new Espace(2));
                      $x = new Bouton("Non", $bnon, "BUTTON", $this->profil(6)); //profil 6
                      $c->addChamp($x);
                      $this->pv->addChamp($c);
                    }
                  }
                  else { //Q4
                    $this->pv->addChamp($c);
                    $c = new TPanel(2, 1);
                    $futopt = $options;
                    $x = new Bouton("Oui", $boui, "BUTTON", $this->profil(2)); //profil 2
                    $c->addChamp($x);
                    $c->addChamp(new Espace(2));
                    $futopt->setOption("REPRISE_OPARS", 1);
                    $futopt->setOption("Q4", 2);
                    $x = new Bouton("Non", $bnon, "BUTTON", $reponsed . $futopt->getChaine() . $reponsef);
                    $c->addChamp($x);
                    $this->pv->addChamp($c);
                  }
                }
                else { //rponse 3 non
                  $x = new Label($non);
                  $c->addChamp($x);
                  $this->pv->addChamp($c);
                  $this->pv->addLigne();
                  $c = new TPanel(4, 1);
                  $x = new Label("Question 4&nbsp;: $t4 ");
                  $c->addChamp($x);
                  if ($options->getOption("Q4")){ //rponse 4 dj fournie
                    if ($options->getOption("Q4") == 1){
                      // profil 3
                    }
                    else {
                      $x = new Label($non);
                      $c->addChamp($x);
                      $this->pv->addChamp($c);
                      $this->pv->addLigne();
                      $c = new TPanel(4, 1);
                      $x = new Label("Question 5&nbsp;: $t5 ");
                      $c->addChamp($x);
                      $this->pv->addChamp($c);
                      $c = new TPanel(2, 1);
                      $x = new Bouton("Oui", $boui, "BUTTON", $this->profil(5)); //profil 5
                      $c->addChamp($x);
                      $c->addChamp(new Espace(2));
                      $x = new Bouton("Non", $bnon, "BUTTON", $this->profil(-6)); //profil -6
                      $c->addChamp($x);
                      $this->pv->addChamp($c);
                    }
                  }
                  else { //Q4
                    $this->pv->addChamp($c);
                    $c = new TPanel(2, 1);
                    $futopt = $options;
                    $x = new Bouton("Oui", $boui, "BUTTON", $this->profil(3)); // profil 3
                    $c->addChamp($x);
                    $c->addChamp(new Espace(2));
                    $futopt->setOption("REPRISE_OPARS", 1);
                    $futopt->setOption("Q4", 2);
                    $x = new Bouton("Non", $bnon, "BUTTON", $reponsed . $futopt->getChaine() . $reponsef);
                    $c->addChamp($x);
                    $this->pv->addChamp($c);
                  }
                }
              }
              else { //Q3
                $this->pv->addChamp($c);
                $c = new TPanel(2, 1);
                $futopt = $options;
                $futopt->setOption("REPRISE_OPARS", 1);
                $futopt->setOption("Q3", 1);
                $x = new Bouton("Oui", $boui, "BUTTON", $reponsed . $futopt->getChaine() . $reponsef);
                $c->addChamp($x);
                $c->addChamp(new Espace(2));
                $futopt->setOption("Q3", 2);
                $x = new Bouton("Non", $bnon, "BUTTON", $reponsed . $futopt->getChaine() . $reponsef);
                $c->addChamp($x);
                $this->pv->addChamp($c);
              }
            }
          }
          else { //Q2
            $this->pv->addChamp($c);
            $c = new TPanel(2, 1);
            $futopt = $options;
            $x = new Bouton("Oui", $boui, "BUTTON", $this->profil(1)); //profil 1
            $c->addChamp($x);
            $c->addChamp(new Espace(2));
            $futopt->setOption("REPRISE_OPARS", 1);
            $futopt->setOption("Q2", 2);
            $x = new Bouton("Non", $bnon, "BUTTON", $reponsed . $futopt->getChaine() . $reponsef);
            $c->addChamp($x);
            $this->pv->addChamp($c);
          }
        }
        else { //rponse 1 non
          $x = new Label($non);
          $c->addChamp($x);
          $this->pv->addChamp($c);
          $this->pv->addLigne();
          $c = new TPanel(4, 1);
          $x = new Label("Question 2&nbsp;: $t6 ");
          $c->addChamp($x);
          if ($options->getOption("Q2")){ // rponse 2 dj fournie
            switch($options->getOption("Q2")){
            case 1:
              $x = new Label("<FONT COLOR=\"ORANGE\">Aucun</FONT>");
              $c->addChamp($x);
              $this->pv->addChamp($c);
              $this->pv->addLigne();
              $c = new TPanel(4, 1);
              $x = new Label("Question 3&nbsp;: $t4 ");
              $c->addChamp($x);
              if ($options->getOption("Q3")){ // rponse 3 dj fournie
                if ($options->getOption("Q3") == 1){
                  //profil 7
                }
                else {
                  $x = new Label($non);
                  $c->addChamp($x);
                  $this->pv->addChamp($c);
                  $this->pv->addLigne();
                  $c = new TPanel(4, 1);
                  $x = new Label("Question 4&nbsp;: $t5 ");
                  $c->addChamp($x);
                  $this->pv->addChamp($c);
                  $c = new TPanel(2, 1);
                  $x = new Bouton("Oui", $boui, "BUTTON", $this->profil(8)); // profil 8
                  $c->addChamp($x);
                  $c->addChamp(new Espace(2));
                  $x = new Bouton("Non", $bnon, "BUTTON", $this->profil(9)); // profil 9
                  $c->addChamp($x);
                  $this->pv->addChamp($c);
                }
              }
              else {
                $this->pv->addChamp($c);
                $c = new TPanel(2, 1);
                $futopt = $options;
                $x = new Bouton("Oui", $boui, "BUTTON", $this->profil(7)); // profil 7
                $c->addChamp($x);
                $c->addChamp(new Espace(2));
                $futopt->setOption("REPRISE_OPARS", 1);
                $futopt->setOption("Q3", 2);
                $x = new Bouton("Non", $bnon, "BUTTON", $reponsed . $futopt->getChaine() . $reponsef);
                $c->addChamp($x);
                $this->pv->addChamp($c);
              }
              break;
            case 2:
              $x = new Label("<FONT COLOR=\"ORANGE\">1</FONT>");
              $c->addChamp($x);
              $this->pv->addChamp($c);
              $this->pv->addLigne();
              $c = new TPanel(4, 1);
              $x = new Label("Question 3&nbsp;: $t5 ");
              $c->addChamp($x);
              $this->pv->addChamp($c);
              $c = new TPanel(2, 1);
              $x = new Bouton("Oui", $boui, "BUTTON", $this->profil(10)); // profil 10
              $c->addChamp($x);
              $c->addChamp(new Espace(2));
              $x = new Bouton("Non", $bnon, "BUTTON", $this->profil(11)); // profil 11
              $c->addChamp($x);
              $this->pv->addChamp($c);
              break;
            case 3:
              $x = new Label("<FONT COLOR=\"ORANGE\">2-3</FONT>");
              $c->addChamp($x);
              $this->pv->addChamp($c);
              $this->pv->addLigne();
              $c = new TPanel(4, 1);
              $x = new Label("Question 4&nbsp;: $t5 ");
              $c->addChamp($x);
              $this->pv->addChamp($c);
              $c = new TPanel(2, 1);
              $x = new Bouton("Oui", $boui, "BUTTON", $this->profil(12)); // profil 12
              $c->addChamp($x);
              $c->addChamp(new Espace(2));
              $x = new Bouton("Non", $bnon, "BUTTON", $this->profil(13)); // profil 13
              $c->addChamp($x);
              $this->pv->addChamp($c);
              break;
            }
          }
          else { //Q2
            $this->pv->addChamp($c);
            $c = new TPanel(2, 1);
            $futopt = $options;
            $futopt->setOption("REPRISE_OPARS", 1);
            $futopt->setOption("Q2", 1);
            $x = new Bouton("0", "Aucun", "BUTTON", $reponsed . $futopt->getChaine() . $reponsef);
            $c->addChamp($x);
            $c->addChamp(new Espace(1));
            $futopt->setOption("Q2", 2);
            $x = new Bouton("1", "&nbsp;1&nbsp;", "BUTTON", $reponsed . $futopt->getChaine() . $reponsef);
            $c->addChamp($x);
            $c->addChamp(new Espace(1));
            $futopt->setOption("Q2", 3);
            $x = new Bouton("2", "2 - 3", "BUTTON", $reponsed . $futopt->getChaine() . $reponsef);
            $c->addChamp($x);
            $this->pv->addChamp($c);
          }
        }

      }
      else { //Q1
        $this->pv->addChamp($c);
        $c = new TPanel(2,1);
        $futopt = $options;
        $futopt->setOption("REPRISE_OPARS", 1);
        $futopt->setOption("Q1", 1);
        $x = new Bouton("Oui", $boui, "BUTTON", $reponsed . $futopt->getChaine() . $reponsef);
        $c->addChamp($x);
        $c->addChamp(new Espace(2));
        $futopt->setOption("Q1", 2);
        $x = new Bouton("Non", $bnon, "BUTTON", $reponsed . $futopt->getChaine() . $reponsef);
        $c->addChamp($x);
        $this->pv->addChamp($c);
      }

    }


    $this->pv->addLigne();
    $this->pv->addLigne();
    $this->pv->addChamp($this->pied);
    $this->pv->addLigne(0.5);
  }

  /**
  * renvoie le texte du javascript qui provoque l'enregistrement d'un profil
  * @param int no le numro du profil
  * @return string
  */
  function profil($no){
    $ch = "for(i=0;i<document.donnees.elements.length;i++){if(document.donnees.elements[i].name==\"profilopars[profil]\")" .
    "{document.donnees.elements[i].value=$no;break;}}document.donnees.submit();";
    return $ch;
  }

  /**
  * renvoie la lettre correspondant  la situation sociale
  * @param int no le numro de la situation sociale
  * @return string
  */
  function abc($no){
    switch($no){
    case 1:
      return "A";
      break;
    case 2:
      return "B";
      break;
    case 3:
      return "C";
      break;
    default:
      return "";
    break;
    }
  }

}