<?php
  // $Id: planning.inc,v 1.1.1.1 2010-10-11 22:25:43 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Planning d'un tablissement
* @package formulaires
*/
/**
* Planning d'un tablissement
* Construction, pour un tablissement et une priode donns, de l'affichage HTML du planning 
* des lits de court sjour
* @package formulaires
* @author ob tnh cjd jdu
*/
class planning extends connexionBrioche{
  /**
  * l'anne du mois central du planning (nombre de 4 chiffres)
  * @var int
  */
  var $annee;
  
  /**
  * le mois central du planning (1 - 12)
  * @var int
  */
  var $mois;
  /**
  * le nombre de jours  inclure avant le mois central (max. 30)
  * @var int
  */
  var $joursavant;
  
  /**
  * le nombre de jours  inclure aprs le mois central (max. 30)
  * @var int
  */
  var $joursapres;
  
  /**
  * le numro de l'tablissement auquel se rapporte le planning
  * @var int
  */
  var $etablissement;
  
  /**
  * le nom de l'tablissement auquel se rapporte la planning
  * @var string
  */
  var $nomet;
  
  /**
  * le nombre de jour du mois central
  * @var int
  */
  var $jourMois;
  
  /**
  * si faux, l'affichage du planning est bloque (probablement pas utile)
  * @var boolean
  */  
  var $impression;
  
  /**
  * le contenu HTML du planning
  * @var string
  */
  var $contenu;
  
  /**
  * le nom du champ de formulaire contenant l'anne
  * @var string
  */
  var $champannee;
  
  /**
  * le nom du champ de formulaire contenant le mois
  * @var string
  */
  var $champmois;
  
  /**
  * l'action principale du formulaire
  * @var int
  */
  var $action;
  
  /**
  * un tableau correspondant au mois prcdant le mois central (0 => annee, 1 => mois)
  * @var array
  */
  var $mp;
  
  /**
  * un tableau correspondant au mois suivant le mois central (0 => annee, 1 => mois)
  * @var array
  */
  var $ms;
  
  /**
  * un objet grilleOccupation correspondant  la priode donne
  * @var object grilleOccupation
  */
  var $grille;
  
  /**
  * action accessoire (accs  la feuille de proprits du sjour)
  * @var int
  */
  var $action2;
  
  /**
  * @param string champannee cf. variable de classe
  * @param int annee cf. variable de classe
  * @param string champmois cf. variable de classe
  * @param int mois cf. variable de classe
  * @param int etablissement cf. variable de classe
  * @param string nomet cf. variable de classe
  * @param int joursavant cf. variable de classe
  * @param int joursapres cf. variable de classe
  * @param string sessionid l'identifiant de session
  * @param int action cf. variable de classe
  * @param object grilleOccupation grille cf. variable de classe
  * @param int action2 cf. variable de classe
  * @param array autspec le tableau des autorisations spcifiques
  */
  function planning($champannee, $annee, $champmois, $mois, $etablissement, $nomet, $joursavant, $joursapres,
                    $sessionid, $action, &$grille, $action2, $autspec=0){
    
    // index pour les cas o des sjours sont accols
    // Les constantes se trouvent dans briochecvs/briocheapp/constantes.inc
    if (! $this->connexionBrioche($sessionid, $autspec)){
      $this->impresion = false;
      return;
    }
    global $fCourSej;
    $this->impression = true;
    $this->champannee = $champannee;
    $this->annee = $annee;
    $this->champmois = $champmois;
    $this->mois = $mois;
    if ($joursavant > 30) $joursavant = 30;
    if ($joursapres > 30) $joursapres = 30;
    $this->joursavant = $joursavant;
    $this->joursapres = $joursapres;
    $this->mp = $this->moisPrecedent($this->annee, $this->mois);
    $this->ms = $this->moisSuivant($this->annee, $this->mois);
    $this->etablissement = $etablissement;
    $this->nomet = $nomet;
    $this->action = $action;
    $this->action2 = $action2;
    $this->grille = $grille;
    $this->jourMois = cal_days_in_month(CAL_GREGORIAN, $mois, $annee);
  }


  /**
  * renvoie un tableau correspondant au mois prcdant celui dfini par les arguments
  * @param int annee l'anne du mois central
  * @param int mois le mois central
  * @return array le mois prcdent
  */
  function moisPrecedent($annee, $mois){
    if ($mois == 1) {
      $mois = 12;
      $annee = $annee - 1;
    }
    else {
      $mois = $mois - 1;
    }
    $tabmois[0] = $annee;
    $tabmois[1] = $mois;
    return $tabmois;
  }

  /**
  * renvoie un tableau correspondant au mois suivant celui dfini par les arguments
  * @param int annee l'anne du mois central
  * @param int mois le mois central
  * @return array le mois suivant
  */
  function moisSuivant($annee, $mois){
    if ($mois == 12) {
      $mois = 1;
      $annee = $annee + 1;
    }
    else {
      $mois = $mois + 1;
    }
    $tabmois[0] = $annee;
    $tabmois[1] = $mois;
    return $tabmois;
  }


  
  /**
  * renvoie le style de la case  afficher dans le calendrier pour un sjour donn
  * @param boolean urgence est-ce un sjour urgent ?
  * @param int nodoss le numro du dossier (ou 999 si bloqu)
  * @param string proprio : pas utilis actuellement
  * @param string sexe le sexe (M | F) de l'usager
  * @param string le style par dfaut
  */ 
  function getSejourCouleur($urgence, $nodoss, $proprio, $sexe, $couleur_defaut) {
    $couleursej = "";
    
    if ($nodoss == -999){  // Lit bloqu
      $nodoss = "";
      
      if ($urgence) {
        if ($sexe == "M") {
          $couleursej = "cs_urgent_bloque_homme";
        }
        elseif ($sexe == "F") {
          $couleursej = "cs_urgent_bloque_femme";
        }
        else {
          $couleursej = "cs_urgent_bloque";
        }
      } 
      else {
        if ($sexe == "M") {
          $couleursej = "cs_non_urgent_bloque_homme";
        }
        elseif ($sexe == "F") {
          $couleursej = "cs_non_urgent_bloque_femme";
        } 
        else {
          $couleursej = "cs_non_urgent_bloque";
        }
      }
    }
    else { //lit attribu
      if ($urgence) {
        if ($sexe == "M") {
          $couleursej = "cs_urgent_homme";
        }
        elseif ($sexe == "F") {
          $couleursej = "cs_urgent_femme";
        }
        else {
          $couleursej = "white";
        }
      }
      else {
        if ($sexe == "M") {
          $couleursej = "cs_non_urgent_homme";
        }
        elseif ($sexe == "F") {
          $couleursej = "cs_non_urgent_femme";
        }
        else {
          $couleursej = "white";
        }
      }
    }
    
    if ($couleursej == "") {
      $couleursej = $couleur_defaut;
    }
    return $couleursej;
  }

  /**
  * renvoie le contenu HTML de l'objet. En gnral, mthode invoque par la mthode addChamp du contenant
  * @return string
  */
  function getContenu(){
    global $fCourSej;
    $depassement = 0;
    if (! $this->impression) return;
    $mp = $this->mp;
    $ms = $this->ms;
    $nbLits = $this->grille->getNbLits($this->etablissement);
    $nbChambres = $this->grille->getNbChambres($this->etablissement);
    $this->contenu =  "<TABLE BORDER=0 CELLSPACING=1 CELLPADDING=0>\n";
    //Premire ligne
    $this->contenu .= "<TR>\n<TD COLSPAN=" . (2 + $this->joursavant) . "><B>$this->nomet</B></TD></TR>" .
                      "<TR>\n<TD COLSPAN=2>&nbsp;</TD><TD COLSPAN=$this->joursavant>" .
                      "<A HREF=\"$fCourSej?action=$this->action" .
                      "&donnees[noet]=$this->etablissement" . // numro de l'tablissement
                      "&$this->champannee=$mp[0]&$this->champmois=$mp[1]" .
                      "&sessionid=$this->idsession\"><B>" .CJour::texteMois($mp[1]) . " $mp[0]</B></A></TD>\n" .
                      "<TD BGCOLOR=\"#f93c08\" ROWSPAN=" . (2 + $nbLits + $nbChambres) .
                      "><IMG SRC=\"null.gif\" WIDTH=\"1\" HEIGHT=\"1\"></TD>\n" .
                      "<TD COLSPAN=$this->jourMois>" . CJour::texteMois($this->mois) . " " . $this->annee .
                      "</TD>\n<TD BGCOLOR=\"#f93c08\" ROWSPAN=" . (2 + $nbLits + $nbChambres) .
                      "><IMG SRC=\"null.gif\" WIDTH=\"1\" HEIGHT=\"1\"></TD>\n" .
                      "<TD COLSPAN=$this->joursapres><A HREF=\"$fCourSej?action=$this->action" .
                      "&donnees[noet]=$this->etablissement" . // numro de l'tablissement
                      "&$this->champannee=$ms[0]&$this->champmois=$ms[1]" .
                      "&sessionid=$this->idsession\"><B>" . CJour::texteMois($ms[1]) . " $ms[0]</B></A></TD>\n</TR><TR>" .
                      "<TD VALIGN=\"Top\">Ch.</TD>\n<TD VALIGN=\"Top\">Lit</TD>\n<TD VALIGN=\"Top\">&nbsp;</TD>\n";
                                            
    for ($i = 1; $i < $this->grille->nbJours; $i++) {
      $jour = &$this->grille->tabCJours[$i];
      $jourMoinsUn = &$this->grille->tabCJours[$i-1];
      if ($jour->isFerie() || $jour->jourSem() == 0){
        $jour->setCouleur("cs_ferie");
      }
      else {
        $jour->setCouleur("cs_vide");
      }
      $this->contenu .= "<TD CLASS=\"$jour->couleur\"><IMG SRC=\"null.gif\" HEIGHT=\"15\" WIDTH=\"2\">" . $jour->jour . "</TD>\n";

    }
    $this->contenu .= "<TD VALIGN=\"Top\">&nbsp;</TD><TD VALIGN=\"Top\" ALIGN=\"Right\">Lit</TD>\n<TD VALIGN=\"Top\" ALIGN=\"Right\">Ch.</TD></TR>\n";
    //Lignes correspondant aux chambres et aux lits
    if ($nbLits) {
      $chambreprec = array();
      foreach($this->grille->getTablits($this->etablissement) as $lit){ //pour chaque lit
        if ($lit[0] != $chambreprec){
          $this->contenu .= "<TR><TD COLSPAN=" . ($this->grille->nbJours + 8) .
                             " BGCOLOR=\"red\"><IMG SRC=\"null.gif\" WIDTH=\"1\" HEIGHT=\"1\"></TD></TR>";
          $chambreprec = $lit[0];
        }
        $this->contenu .= "<TR><TD><B>$lit[0]</B></TD><TD align='center'>$lit[1]</TD><TD>$lit[2]</TD>"; //Ecriture de l'en-tte de ligne

        // signale s'il y a un sjour accol avant le sjour courant
        $occup_precedente = false;
        for($i = 1; $i < $this->grille->nbJours; $i++){ //pour chaque jour
          $case = &$this->grille->tabCJours[$i];
          
          $from = substr($lit[3],6,4) . substr($lit[3],3,2) . substr($lit[3],0,2);
          $to = substr($lit[4],6,4) . substr($lit[4],3,2) . substr($lit[4],0,2);
          $day = $case->annee . $case->mois . $case->jour; 
          
          if ($day < $from && $from != '' || $day > $to && $to != '') $couleur = '1';
          else $couleur = $case->couleur;
          
          $from = ''; $to = ''; $day = '';
          
          //print $case->annee . $case->mois . $case->jour . " - <pre>"; print_r($case); print  "</pre><BR>";
          $occup = false;
          if (isset($case->occupation[$this->etablissement][$lit[0]][$lit[1]][INDEX_PREMIER])){
            $occup = $case->occupation[$this->etablissement][$lit[0]][$lit[1]][INDEX_PREMIER];
          }
          if (! $occup){ //Lit libre
            $this->contenu .= "<TD CLASS=\"$couleur\"></TD>";
          }
          else { //Lit occup
            $item = $case->title[$this->etablissement][$lit[0]][$lit[1]][INDEX_PREMIER];
            $duree = $case->duree[$this->etablissement][$lit[0]][$lit[1]][INDEX_PREMIER];
            $nojour = $case->nojour[$this->etablissement][$lit[0]][$lit[1]][INDEX_PREMIER];
            $duree = $duree - $nojour; //nombre de jours en tenant compte du dbut de la grille
            
            $finSejour = $case->fin[$this->etablissement][$lit[0]][$lit[1]][INDEX_PREMIER];
            
            $depassement = 0;
            if ($duree > ($this->grille->nbJours - $i)){
              $duree = $this->grille->nbJours - $i -1;
              $depassement = 1;
            }
            //nombre de colonnes (en tenant compte des sparateurs de mois)
            $ajout = 0;
            // Si le sjour chevauche une frontire de mois, on ajoute une colonne pour le sparateur
            if ($case->debut[$this->etablissement][$lit[0]][$lit[1]][INDEX_PREMIER] < mktime(0, 0, 0, $this->mois, 1, $this->annee)
                && $case->fin[$this->etablissement][$lit[0]][$lit[1]][INDEX_PREMIER] >= mktime(0, 0, 0, $this->mois, 1, $this->annee)){
              $ajout ++;
              
            }
            //Mme ajout pour la seconde frontire de mois du planning
            if ($case->debut[$this->etablissement][$lit[0]][$lit[1]][INDEX_PREMIER] < mktime(0, 0, 0, $this->ms[1], 1, $this->ms[0])
                && $case->fin[$this->etablissement][$lit[0]][$lit[1]][INDEX_PREMIER] >= 
                mktime(0, 0, 0, $this->ms[1], 1, $this->ms[0])) {
              $ajout ++;
            }
            
            if ($case->jour == 1){ //Premier du mois...
              $case_precedente = &$this->grille->tabCJours[$i - 1];
              // ... et double occupation du dernier jour du mois prcdent
              if (isset($case_precedente->occupation[$this->etablissement][$lit[0]][$lit[1]][INDEX_SECOND])){
                $ajout --; // il n'y a plus de chevauchement puisque la premire case du sjour est dtache du reste
              }
            }
            
            // si le sjour suivant est accoll au sjour courant

            // si il existe un sjour accol alors $case_suivante->occupation contient un tableau avec 2 entres
            $occup_suivante = false;
            if (isset($this->grille->tabCJours[$i + $duree])) {
              $case_suivante = &$this->grille->tabCJours[$i + $duree];
              if ($i + $duree < $this->grille->nbJours - 1) {
                if (isset($case_suivante->occupation[$this->etablissement][$lit[0]][$lit[1]]) 
                    && count($case_suivante->occupation[$this->etablissement][$lit[0]][$lit[1]]) > 1){
                  $occup_suivante = $case_suivante->occupation[$this->etablissement][$lit[0]][$lit[1]][INDEX_SECOND];
                  if ($occup_suivante == $occup && $occup != -999) {
                    $occup_suivante = $case_suivante->occupation[$this->etablissement][$lit[0]][$lit[1]][INDEX_PREMIER];
                    $index_suivant = 0;
                  }
                  else {
                    $index_suivant = 1;
                  }
                }        
              }
            }
            $occup_suivante_texte = "";
            if ($occup_suivante) {
              $nodoss_suivant = $occup_suivante;
              $proprio_suivant = $case_suivante->proprio[$this->etablissement][$lit[0]][$lit[1]][$index_suivant];
              $doss = new ensTableBrioche("dossiers", "nodoss=$nodoss_suivant", "usagers.sexe",
                                          0, $this->idsession, "usagers", "dossiers.nous = usagers.nous",
                                          false, $this->autspec);
              $tdoss = $doss->getTableau();
              $sexe_suivant = "";

              if (count($tdoss)){
                // un dossier a t attribu
                $tabdoss = $tdoss[0];
                $sexe_suivant = $tabdoss->sexe;
              }
              else {
                // aucun dossier attribu -> sjour bloqu
                $sexe_suivant = $case_suivante->getSexe($this->etablissement, $lit[0], $lit[1], $index_suivant);
              }


              $occup_suivante_texte = "<font CLASS='".$this->getSejourCouleur($case_suivante->isUrgent($this->etablissement, 
                                                                              $lit[0], 
                                                                              $lit[1],
                                                                              $index_suivant), 
                                                                              $nodoss_suivant, 
                                                                              $proprio_suivant, 
                                                                              $sexe_suivant, 
                                                                              $case_suivante->couleur)."'>[&nbsp;&nbsp;</font>";
            }
            else {
              $occup_suivante_texte = "<font CLASS='".$case_suivante->couleur."'>&nbsp;&nbsp;&nbsp;</font>";
            }
            $colspan = $duree + $ajout;
            $nodoss = $case->occupation[$this->etablissement][$lit[0]][$lit[1]][INDEX_PREMIER];
            $proprio = $case->proprio[$this->etablissement][$lit[0]][$lit[1]][INDEX_PREMIER];
            //Dfinition des couleurs
            $doss = new ensTableBrioche("dossiers", "nodoss=$nodoss", "usagers.sexe, usagers.nom, usagers.prenom, usagers.nous",
                                        0, $this->idsession, "usagers", "dossiers.nous = usagers.nous",
                                        false, $this->autspec);
            $tdoss = $doss->getTableau();
            $sexe = "";
            $nom = "";
            $prenom = "";
            $nous = "";

            if (count($tdoss)){
              // un dossier a t attribu
              $tabdoss = $tdoss[0];
              $sexe = $tabdoss->sexe;
              $nom = $tabdoss->nom;
              $prenom = $tabdoss->prenom;
              $nous = $tabdoss->nous;
            }
            else {
              // aucun dossier attribu -> sjour bloqu
              $sexe = $case->getSexe($this->etablissement, $lit[0], $lit[1]);        
            }
            
            $cal = new ensTableBrioche("calendrier", "nodoss = $nodoss","debut, noev, horsStats, datedecision, csprec", "csprec ASC", 
                                                 $this->idsession, 0, 0, false, $this->autspec);

            $calTab = array();
            $dateDec = "";
            foreach ($cal->getTableau() as $calt) {
                $calTab[$calt->noev] = $calt;
                if ($dateDec == "" || 
                    strtotime($dateDec) > strtotime($calt->datedecision) && $calt->datedecision != "") {
                        $dateDec = $calt->datedecision;
                    }
            }
            
            if ($dateDec != "" && strtotime($dateDec) < strtotime($calTab[$item]->debut)) 
                $dateDec = date("d.m.Y", strtotime($calTab[$item]->debut) + 86400);

            $hs = $calTab[$item]->horsStats;
            
            if ($hs) $hachure = "style=\"background-image:url('images/hach.gif')\"";
            else $hachure = "";
            
            $couleursej = $this->getSejourCouleur($case->isUrgent($this->etablissement, $lit[0], $lit[1]),
                                                                  $nodoss, $proprio, $sexe, $case->couleur);

            //Texte dans les cases en fonction de la longueur affiche
            $lien = "javascript:ouvreFenetre('$fCourSej?action=$this->action2" .
                    "&sessionid=$this->idsession&item=$item','lits'," .
                    "'dependent=yes,scrollbars=yes,resizable=no,menubar=no,locationbar=no," .
                    "height=350,width=630,screenX=50,screenY=50');";
                    
            $usOptions = new optionsBrioche();
            $usOptions->setOption("MODE", 9);
            $usOptions->setOption("BLOQUE_US", 0);
            $usOptions->setOption("NOUV_US", 1);
            $lienUsager = "javascript:ouvreFenetre('brioche.php?action=1001" .
                     "&sessionid=$this->idsession&item=$nous&options=".$usOptions->getChaine()."', ".
                     "'Usager', 'dependent=yes,scrollbars=yes,resizable=no,menubar=no,locationbar=no,".
                     "height=550,width=850,screenX=50,screenY=50');";

            $title = "";
            
            if ($dateDec != "") {
                $hachvert = "style=\"background-image:url('images/hachvert.gif')\"";
                $dateFin = $this->grille->deb + ($this->grille->nbJours - 1) * 86400;
                if ($finSejour < $dateFin) $dateFin = $finSejour;
                if (strtotime($dateDec) < $this->grille->deb) {
                    $dateDec = date("d.m.Y", $this->grille->deb + 86400 * 2);
                    $hachure = $hachvert;
                }
                if (strtotime($dateDec) > $dateFin) $dureeDec = 0;
                else $dureeDec = round(($dateFin - strtotime($dateDec)) / 86400);
                $colspan = $colspan - $dureeDec;
            }
            
            if (! $nodoss || $nodoss == -999){
              $texte = "<A HREF=\"$lien\">?</A>";
              $commentaire = new ensTableBrioche("calendrier", "noev = $item","commentaire", 0, 
                                                 $this->idsession, 0, 0, false, $this->autspec);
              $commentaire = $commentaire->getPremier('commentaire');
              if ($commentaire != "")
              $title = "TITLE=\"".print_r($commentaire,true)."\"";
            }
            else {
              $title = "TITLE=\"$nodoss - $nom $prenom\"";
              if ($colspan <= 2) {
                $texte = "<A HREF=\"$lien\">*</A>";
              }
              elseif ($colspan <=5) {
                $texte = "<A HREF=\"$lien\">$nodoss</A>";
              }
              elseif ($colspan <=8) {
                $texte = "<A HREF=\"$lien\">$nodoss</A> - <A HREF=\"$lienUsager\">" . substr($nom, 0, ($colspan-2) * 2) . "</A>";
              }
              else {
                $texte = "<A HREF=\"$lien\">$nodoss</A> - <A HREF=\"$lienUsager\">" . substr("$nom $prenom", 0, ($colspan-2) * 3) . "</A>";
              }
            }
            if ($this->change_cs($item,$nodoss,"debut")){
              $texte = CARACTERE_PAUSE_DEBUT_CS . ($colspan > 1 ? " " : "") . $texte;
            }
            
            $this->contenu .= "<TD $hachure COLSPAN=$colspan $title CLASS=\"$couleursej\">$texte";
                
            if ($dateDec != "") {
                if ($dureeDec > 0)
                    $this->contenu .= "</TD><TD $hachvert COLSPAN=$dureeDec $title CLASS=\"$couleursej\">";
            }

            if ($duree > 0) {
              $this->contenu .= "</TD><TD>";
            }
           
            if ($i + $duree < $this->grille->nbJours) {        
              // affiche un ? ou un ] selon le fait qu'une sortie de sjour a t confirme ou pas.
              $caractere_fin_sejour = CARACTERE_NON_CONFIRME;
              if ($case->isSortieConfirmee($this->etablissement, $lit[0], $lit[1])) {
                $caractere_fin_sejour = CARACTERE_CONFIRME;        
              }
              if ($this->change_cs($item,$nodoss,"fin")) $caractere_fin_sejour = CARACTERE_PAUSE_FIN_CS;
              if (isset($depassement) && $depassement == 1) $caractere_fin_sejour = CARACTERE_CONTINUE;  
              $this->contenu .= "<font CLASS=\"$couleursej\">&nbsp;&nbsp;" . $caractere_fin_sejour . 
                                "</font><font CLASS=\"white\">&nbsp;</font>".$occup_suivante_texte."</TD>";
            }
            if ($occup_suivante) {
              $occup_precedente = true;
            } 
            else {
              $occup_precedente = false;
            }
            $i = $i + $duree;
          }
        }
        $this->contenu .= "<TD align='right'>$lit[2]</TD><TD align='center'>$lit[1]</TD><TD align='right'><B>$lit[0]</B></TD>";
        $this->contenu .= "</TR>\n";
      }
    }
    $this->contenu .= "</TABLE>";


    return $this->contenu;
  }
  
  /**
  * renvoie le contenu HTML de la lgende du planning
  * @return string
  */
  function addLegende(){
    // table pour voir un chantillon des couleurs utilises
    $legende = "<TABLE WIDTH='100%' BORDER=0 CELLSPACING=1 CELLPADDING=5>\n";
    $legende .= "<TR><TD>\n";
    $legende .= "<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=2>\n";
    $legende .= "<TR><TD>Urgent : femme</TD><TD CLASS='cs_urgent_femme'>&nbsp; &nbsp;</TD></TR>\n";
    $legende .= "<TR><TD>Urgent : homme</TD><TD CLASS='cs_urgent_homme'>&nbsp; &nbsp;</TD></TR>\n";
    $legende .= "<TR><TD>Urgent : bloqu pour une femme</TD><TD CLASS='cs_urgent_bloque_femme'>&nbsp; &nbsp;</TD></TR>\n";
    $legende .= "<TR><TD>Urgent : bloqu pour un homme</TD><TD CLASS='cs_urgent_bloque_homme'>&nbsp; &nbsp;</TD></TR>\n";
    $legende .= "<TR><TD>Urgent : bloqu</TD><TD CLASS='cs_urgent_bloque'>&nbsp; &nbsp;</TD></TR>\n";
    $legende .= "<TR><TD>Sjour hors statistiques</TD><TD style=\"border:1px black solid;background-image:url('images/hach.gif')\">&nbsp; &nbsp;</TD></TR>\n";
    $legende .= "</TABLE>\n";
    $legende .= "</TD><TD>\n";
    $legende .= "<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=2>\n";
    $legende .= "<TR><TD>Non urgent : femme</TD><TD CLASS='cs_non_urgent_femme'>&nbsp; &nbsp;</TD></TR>\n";    
    $legende .= "<TR><TD>Non urgent : homme</TD><TD CLASS='cs_non_urgent_homme'>&nbsp; &nbsp;</TD></TR>\n";
    $legende .= "<TR><TD>Non urgent : bloqu pour une femme</TD><TD CLASS='cs_non_urgent_bloque_femme'>&nbsp; &nbsp;</TD></TR>\n";
    $legende .= "<TR><TD>Non urgent : bloqu pour un homme</TD><TD CLASS='cs_non_urgent_bloque_homme'>&nbsp; &nbsp;</TD></TR>\n";
    $legende .= "<TR><TD>Non urgent : bloqu</TD><TD CLASS='cs_non_urgent_bloque'>&nbsp; &nbsp;</TD></TR>\n";
    $legende .= "<TR><TD>Court sjour transform en long sjour</TD><TD style=\"border:1px black solid;background-image:url('images/hachvert.gif')\">&nbsp; &nbsp;</TD></TR>\n";
    $legende .= "</TABLE>\n";
    $legende .= "</TD><TD>\n";
    $legende .= "<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=2>\n";
    $legende .= "<TR><TD>Date de sortie confirme</TD><TD> ] </TD></TR>\n";    
    $legende .= "<TR><TD>Date de sortie non confirme</TD><TD> ? </TD></TR>\n";
    $legende .= "<TR><TD>Le court sjour se poursuit</TD><TD> >> </TD></TR>\n";
    $legende .= "<TR><TD>Changement en cours de sjour (fin)</TD><TD> > </TD></TR>\n";
    $legende .= "<TR><TD>Changement en cours de sjour (dbut)</TD><TD> < </TD></TR>\n";
    $legende .= "</TABLE>\n";
    $legende .= "</TD><TD width=25%>\n";
    $legende .= "<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=2>\n";
    $legende .= "<TR><TD><b>Plages de temps blanches :</b></TD></TR>\n";
    $legende .= "<TR><TD><p align=justify>indique les priodes pour lesquelles un lit est indisponible, 
    aucun sjour ne peut y tre attribu (cf. fentre \"Chambres et lits\", dates \"Du:\" et \"Au:\"). 
    Le lit disparat du planning les mois o il n'est pas disponible.</p></TD></TR>\n";
    $legende .= "</TABLE>\n";
    $legende .= "</TD></TR>";
    $legende .= "</TABLE>\n";
    return $legende;
  }  
  
  /**
  * le sjour commence-t-il ou se poursuit-il dans un autre lit ?
  * @param int item le numro de l'vnement correspondant au sjour test
  * @param int nodoss le numro du dossier associ
  * @param string quant ("debut" | "fin")
  * @return boolean
  */
  function change_cs($item, $nodoss, $quand = "fin") {
    if ($quand == 'fin') {  
      $autre_cs = new ensTableBrioche("calendrier", "nodoss = $nodoss AND actif = 1 AND csprec = $item",
                                      "*", 0 , $this->idsession, 0, 0, false, $this->autspec);
      if ($autre_cs->compteTotal() > 0) return true;
    }
    if ($quand == 'debut') {
      $autre_cs = new ensTableBrioche("calendrier", "noev = $item AND actif = 1",
                                      "csprec", 0, $this->idsession, 0, 0, false, $this->autspec);
      $csprec = $autre_cs->getTableau();
      if ($csprec[0]->csprec) return true; 
    }
    return false;
  }

}

?>
