<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Affichage du planning gnral des courts sjours
* @package formulaires
*/
/**
* Affichage du planning gnral des courts sjours
* Formulaire contenant le ou les plannings d'un ou plusieurs tablissements
* @package formulaires
* @author ob tnh cjd jdu
*/
class planningCourSej extends cadreSimple {

  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string fond page la couleur du fond de la page
  * @param string sessionid l'identifiant de session
  * @param string dannee le nom du champ de formulaire indiquant l'anne
  * @param int annee l'anne du mois central
  * @param string dmois le nom du champ de formulaire indiquant le mois central
  * @param int mois le mois central
  * @param int action principale du formulaire
  * @param int joursavant le nombre de jours avant le mois central
  * @param int joursaprs le nombre de jours aprs le mois central
  * @param int action2 action accessoire (passe  l'objet planning)
  */
  function planningCourSej($largeur, $fondpage, $sessionid, $dannee, $annee, $dmois, $mois, $action,
                           $joursavant=15, $joursapres=15, $action2=""){
    global $aujourdhui;
    global $fCourSej;
    global $donnees;

    $ini = new briocheIni();
    $autspec[0] = $ini->autSpec[2];
    if (! $this->cadreSimple($largeur, $fondpage, $sessionid, $autspec)) return;
    $tstJourUn = mktime(0, 0, 0, $mois, 1 - $joursavant, $annee); //Premier jour de la priode
    $jourMois = cal_days_in_month(CAL_GREGORIAN, $mois, $annee); //Nombre de jours du mois central
    $nbJours = $joursavant + $joursapres + $jourMois; //nombre total de jours
    $gri = new grilleOccupation($tstJourUn, $nbJours, $sessionid, 0, 0, $autspec);
    $tf = new TabForm();
    $tf->setTabParam($largeur, 0, 3, 0, $fondpage);
    $tf->setFormParam("donnees", $fCourSej, "post");
    if ($this->verifAut($ini->autReq, $this->autorisations)) {
    // Les collaborateurs BRIOs accdent  la liste des tablissements qui pratiquent le court-sjour planning
      $mode = "brio";
      $tetabl = new ensTableBrioche("etablissements", "courplan = -1", "noet, nomet", 0, $this->idsession);
    }
    else {
    // Les utilsateurs EMS accdent (en lecture) au planning de leur EMS  
      $mode = "ems";
      $tetabl = new ensTableBrioche("etablautorises", "etablautorises.idut = $this->nout AND priv = 'emscs'", 
                                    "etablissements.noet,  etablissements.nomet", 0, $this->idsession,
                                    "etablissements", "etablautorises.etabl = etablissements.noet",
                                    false, $autspec);
    }
    $tabletabl = $tetabl->getTableau();
    $cpt = count($tabletabl);
    $c = new TPanel(5, 1, "LEFT");
    $x = new Label("<H2>Planning des lits de court sjour - $this->nomplein</H2>");
    $c->addChamp($x);
    $tf->addChamp($c);
    $c = new TPanel(1, 1, "RIGHT");
    $x = new Aide("C19");
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $tf->addChamp($c);
    $tf->addLigne();
    
    // Rafrachissement du planning
    if (isset($donnees['noet'])) $noet = $donnees['noet'];
    else $noet = -1;
    $c = new TPanel(1, 0);
    $x = new Label("<script>refreshPlanning('".time()."','".$noet."','".$this->idsession."');</script>");
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TPanel(6, 1, "CENTER");
    $x = new Label("<div id='RefreshAlert' style='height:20px;color:red;font-weight:bold;'></div>");
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    
    // affichage du calendrier pour l'tablissement choisi

    // recherche du nom de l'tablissement
    if (!isset($donnees['noet']) || $donnees['noet'] == "") {
      $donnees['noet'] = $tabletabl[0]->noet;
    }    
    $nomet = "";
    for ($i = 0; $i < $cpt; $i++){
      if ($donnees['noet'] == $tabletabl[$i]->noet) {
        $nomet = $tabletabl[$i]->nomet;
        break;
      }
    }
    if ($mode = 'brio' && $cpt > 1){
      $c = new TPanel(6, 1);
      $x = new ListOptTable("donnees[noet]", $donnees['noet'], $tetabl, $multiple=false, $size=0, 
          $class="", $onchange="javascript:document.donnees.submit();");
      $x->addOptions("nomet", "noet");
      $x->addDefaut("&lt;TOUS&gt;", -1);
      $c->addChamp($x);
      $tf->addChamp($c);
      $tf->addLigne();
    }
    //Tableau des tablissements  afficher
    $afficher = array();
    if ($donnees['noet'] > 0){
      $afficher[0]['noet'] = $donnees['noet'];
      $afficher[0]['nomet'] = $nomet;
    }
    else {
      for ($i = 0; $i < $cpt; $i++){
        $afficher[$i]['noet'] = $tabletabl[$i]->noet;
        $afficher[$i]['nomet'] = $tabletabl[$i]->nomet;
      }
    }
    foreach ($afficher as $aff){
    
      $c = new TPanel(6, 1);
      $pl = new planning($dannee, $annee, $dmois, $mois, $aff['noet'],
                         $aff['nomet'], $joursavant, $joursapres, 
             $this->idsession, $action, $gri, $action2, $autspec);
      $c->addChamp($pl);
      $tf->addChamp($c);
      $tf->addLigne();
    }
    $c = new TPanel(6);
    if (isset($pl)){
      $x = new Label($pl->addLegende());
    }
    else {
      $x = new Label("Aucun tablissement ne pratique le court sjour \"Planning\"");
    }
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TLabel("&nbsp");
    $c->setColspan(6);
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TPanel(2, 1);
    $x = new Label("Sauter vers&nbsp;&nbsp;&nbsp;", true);
    $c->addChamp($x);
    $x = new ListOpt($dmois, $donnees['mois'], false, 0, "d2");
    for ($i = 1; $i < 13; $i++){
      $x->addOption(CJour::texteMois($i), $i);
    }
    $c->addChamp($x);
    $c->addChamp(new Espace(2));
    $x = new ListOpt($dannee, $donnees['annee'], false, 0, "d2");
    for ($i = -5; $i <= 5; $i++){
      $x->addOption($aujourdhui['year'] + $i,  $aujourdhui['year'] + $i);
    }
    $c->addChamp($x);
    $c->addChamp(new Espace(2));
    $x = new Bouton("hop", "Hop !", "BUTTON", "document.donnees.submit();");
    $c->addChamp($x);
    $c->addChamp(new Espace(2));
    $x = new Bouton("Retour", "Mois courant", "BUTTON", "changeChamp(\"donnees[mois]\", \"" .
                    $aujourdhui['mon'] ."\", \"donnees\");" .
                    "changeChamp(\"donnees[annee]\", \"" . $aujourdhui['year'] . "\", \"donnees\");" .
                    "document.forms.donnees.submit();");
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("action", $action, "HIDDEN");
    $c->addChamp($x);
    $tf->addChamp($c);
    
    // Boutons d'actions
    $c = new TPanel(4, 1, "RIGHT", "CENTER");
    $x = new ChampTexte("itemNom","","Nom",10,"",false,"TEXT","d2");
    $c->addChamp($x);
    $c->addChamp(new Espace(2));
    $x = new ChampTexte("itemPrenom","","Prnom",10,"",false,"TEXT","d2");
    $c->addChamp($x);
    $c->addChamp(new Espace(2));
    $js = 'if (document.getElementById("itemNom").value == "" && document.getElementById("itemPrenom").value == "") {';
    $js .= 'alert("Saisissez au moins un caractre");return false;';
    $js .= '} else {';
    $js .= 'ouvreFenetre("'.$fCourSej.'?action=6&sessionid='.$this->idsession.'&option=0&itemNom="';
    $js .= '+document.getElementById("itemNom").value+"&itemPrenom="+document.getElementById("itemPrenom").value,';
    $js .= '"lits","dependent=yes,scrollbars=yes,resizable=no,menubar=no,locationbar=no,height=500,';
    $js .= 'width=700,screenX=50,screenY=50");return false;}';
    $x = new Bouton("Usagers", "Chercher usagers", "SUBMIT", $js);
    $c->addChamp($x);
    $x = new Label("<script>document.donnees.Usagers.focus();</script>");
    $c->addChamp($x);

    $tf->addChamp($c);
    $tf->addLigne();
    
    $c = new TPanel(6, 1, "RIGHT", "CENTER");
    $x = new Bouton("RechDispo","Disponibilits lits","BUTTON","javascript:ouvreFenetre(\"" . $fCourSej .
                    "?action=4&sessionid=$this->idsession\"," .
                    " \"lits\",\"dependent=yes,scrollbars=yes,resizable=no,menubar=no,locationbar=no,height=700," .
                    "width=700,screenX=50,screenY=50\")");
    $c->addChamp($x);
    $c->addChamp(new Espace(2));
    if ($this->verifAut($ini->autReq, $this->autorisations) &&
        ($this->verifAut($ini->autSpec[3], $this->autorisations) || $this->verifAut($ini->autSuppl[0], $this->autorisations))) {
      $x = new Bouton("ChambreEtLits", "Chambres et lits", "BUTTON", "javascript:ouvreFenetre(\"" . $fCourSej .
                      "?action=2&sessionid=$this->idsession\"," .
                      " \"lits\",\"dependent=yes,scrollbars=yes,resizable=no,menubar=no,locationbar=no,height=800," .
                      "width=800,screenX=50,screenY=50\")");
      $c->addChamp($x);
      $c->addChamp(new Espace(2));
    }
    if ($this->verifAut($ini->autReq, $this->autorisations)){
      $x = new Bouton("Attribuer", "Attribuer lit", "BUTTON", "javascript:ouvreFenetre(\"" . $fCourSej .
                      "?action=3&sessionid=$this->idsession&donnees[etabl]=" .
                      $donnees['noet'] . "\", \"lits\"," .
                      " \"dependent=yes,scrollbars=yes,resizable=no,menubar=no,locationbar=no,height=400," .
                      "width=650,screenX=50,screenY=50\")");
      $c->addChamp($x);
      $c->addChamp(new Espace(2));
    }
    $x = new Bouton("Quitter", "Fermer", "BUTTON", "fermeTout();");
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    $this->addContenu($tf->getContenu());
  }

}

?>
 