<?php
// $Id: proprietesSejour.inc,v 1.1.1.1 2010-10-11 22:25:44 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Proprits d'un lit de court sjour "planning"
* @package formulaires
*/
/**
* Proprits d'un lit de court sjour "planning"
* Affichage de la feuille de proprits d'un sjour particulier
* @package formulaires
* @author ob tnh cjd jdu
*/

class proprietesSejour extends cadreSimple {


  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string fondpage la couleur du fond le page
  * @param int action l'action principale du formulaire
  * @param string sessionid l'identifiant de session
  * @param int item numro du sjour (vnement du calendrier)
  * @param int option paramtre supplmentaire (99 pour supprimer un sjour)
  * @param int action2 une action accessoire (changer)
  */
  function proprietesSejour($largeur, $fondpage, $action, $sessionid, $item, $option, $action2){
    global $fCourSej;
    $ini = new briocheIni();
    $autspec[0] = $ini->autSpec[2];
    if (! $this->cadreSimple($largeur, $fondpage, $sessionid, $autspec)) return;
    //Instanciation du sjour
    $se = new sejourEvenement($item, $this->idsession, $autspec);
    $lit = $se->getLit();
    $pers = $se->getDossier();
    $suivi_par = $se->get_suivi_par();
    //Destruction d'un sjour
    if ($option == 99){
      $se->detruitEvenement();  
      $andeb = $this->getDateAm($se->getDebut(), "Y");
      $moisdeb = $this->getDateAm($se->getDebut(), "m");

      // recharge la page du calendrier pour afficher la suppression de l'attribution du lit
      print "<SCRIPT LANGUAGE=\"JavaScript\">;window.opener.document.donnees.submit();</SCRIPT>";
      /*print "<SCRIPT LANGUAGE=\"JavaScript\">window.opener.location=\"$fCourSej?action=1&". 
	          "sessionid=$this->idsession&donnees[annee]=$andeb&donnees[mois]=$moisdeb&donnees[noet]=".$lit[0]."\";</SCRIPT>";
      */
      $al = new Alerte("Opration effectue !");
      $al->imprime();
      print "<SCRIPT LANGUAGE=\"JavaScript\">window.close();</SCRIPT>";   
    }
    // Dessin du formulaire
    $tf = new TabForm();
    $tf->setTabParam($largeur, 0, 3, 0, $fondpage);
    $tf->setFormParam("donnees", $fCourSej, "post");
    $c = new TPanel(6, 1);
    $x = new Label("<H3>Proprits du sjour</H3>", true);
    $c->addChamp($x);
    $tf->addChamp($c);
    
    $tf->addLigne();
    $c = new TPanel(6, 1);
    $x = new Label("<B>Suivi par : </B>" . $suivi_par[1]);
    $c->addChamp($x);
    $tf->addChamp($c);
    
    $tf->addLigne();
    $c = new TPanel(6, 1);
    $x = new Label("<B>Etablissement : </B>" . $lit[3] . "&nbsp;&nbsp;&nbsp;Ch. : " . $lit[1] . 
                   "&nbsp;&nbsp;&nbsp;Lit : " . $lit[2]);
    $c->addChamp($x);
    $x = new Bouton("donnees[etabl]", $lit[0], "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("donnees[chambre]", $lit[1], "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("donnees[lit]", $lit[2], "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("donnees[titre]", $se->getTitre(), "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("donnees[nodoss]", $pers[0], "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("donnees[nolit]", $lit[4], "HIDDEN");
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TPanel(6, 1);
    $opt = new optionsBrioche();
    $opt->setOption("FORCE_DOSS", 1);
    $opt->setOption("LARG_FIX", 1);
    $opt->setOption("BLOQUE_US", 0);
    $opt->setOption("NOUV_US", 1);
    if ($this->verifAut($ini->autReq, $this->autorisations)){
      $x = new Label("<B>Dossier : </B>" . ($pers[0] ? "<A HREF=\"javascript:ouvreBrioche('brioche.php?action=1" .
                     "&sessionid=$this->idsession&item=$pers[0]&options=" . $opt->getChaine() . 
                     "', 830)\">$pers[0]</A> - " : "") . (($pers[1] && isset($pers[2])) ? "<A HREF=\"javascript:ouvreBrioche('brioche.php?action=1001" .
                     "&sessionid=$this->idsession&item=$pers[2]&options=" . $opt->getChaine() . 
                     "', 830)\">$pers[1]</A>" : "$pers[1]"));
    }
    else {
      $x = new Label("<B>Dossier : </B>" . $pers[0] . " - " . $pers[1]);
    }
    $c->addChamp($x);
    
    $tf->addChamp($c);
    $tf->addLigne();    
    $c = new TPanel(3, 1);
    $x = new ChampTexte("donnees[depuis]", $se->getDebut(), "Dbut :", 15, 15, false, "TEXT", "d2", "", "", true);
    $c->addChamp($x);
    $tf->addChamp($c);
    $c = new TPanel(2, 1);
    $x = new ChampTexte("donnees[jusqua]", $se->getFin(), "Fin :", 15, 15, false, "TEXT", "d2", "", "", true);
    $c->addChamp($x);    
    $tf->addChamp($c);

    // urgence du sjour
    $c = new TPanel(1, 1);
    $x = new ListOpt("donnees[urgent]", $se->getUrgence(), false, 0, "", "", true);
    $x->addOption("Non urgent", 0);
    $x->addOption("Urgent", 1);
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();

    // confirmation sortie du sjour
    $c = new TPanel(1, 1);
    $x = new ListOpt("donnees[sortie_confirmee]", $se->getSortieConfirmee(), false, 0, "", "", true);
    $x->addOption("Date de sortie non confirme", 0);
    $x->addOption("Date de sortie confirme", 1);
    $c->addChamp($x);
    $tf->addChamp($c);      
    $tf->addLigne();
    
    // hors statistiques
    $c = new TPanel(3, 1);
    $x = new Bouton("donnees[horsStats]", $se->getHorsStats(), "HIDDEN");
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    
    //date decision
    $c = new TPanel(6, 1);
    if ($se->getDateDecision() != "") {
        $x = new ChampTexte("donnees[datedecision]", $se->getDateDecision(), 
        "Date dcision (court sjour transform en long sjour selon SASH) :", 15, 15, false, "TEXT", "d2", "", "", true);
    } else {
        $x = new Bouton("donnees[datedecision]", "", "HIDDEN");
    }
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();

    // commentaire
    $c = new TPanel(6, 1);
    $x = new TextArea("donnees[commentaire]", $se->getCommentaire(), "Commentaire :", 0, 0, "", true);
    $c->addChamp($x);

    $x = new Bouton("action", $action, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();

    // Sexe
    $c = new TPanel(1, 1);
    $x = new ListOpt("donnees[sexe]", $se->getSexe(), false, 0, "", "", true);
    $x->addOption("", '');
    $x->addOption("<b>Sexe prvu :</b> Femme", 'F');
    $x->addOption("<b>Sexe prvu :</b> Homme", 'M');
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();


    // Boutons d'actions
    $c = new TPanel(6, 1, "RIGHT");   
    // Seuls les collaborateurs BRIOs disposant de droits d'criture sur le dossier Brioche accdent  ces fonctions
    // Changer de lit en cours de sjour
    if ($this->verifAut($ini->autReq, $this->autorisations)){
      $x = new Bouton("ChangementLit", "Changement de lit en cours de sjour", "BUTTON",
                      "javascript:document.forms.donnees.action.value=5;document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(2));
     
      // Changer l'attribution
      $x = new Bouton("Changer", "Changer", "BUTTON",
                      "javascript:document.forms.donnees.action.value=$action2;document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(2));
    

      // Supprimer l'attribution (masqu si le fragment n'est ni au dbut ni  la fin du sjour)
      if( $se->hasPrecedent() + $se->hasSuivant() < 2){
        $x = new Bouton("Supprimer", "Supprimer", "BUTTON", 
		                    "javascript:supprimeCond(\"$fCourSej?action=$action&item=$item" .
                        "&option=99&sessionid=$this->idsession\");");
        $c->addChamp($x);
        $c->addChamp(new Espace(2));
      }
    }
    // Fermer cette fentre
    $x = new Bouton("Fermer", "Fermer", "BUTTON", "window.close();");
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    $this->addContenu($tf->getContenu());
  }

  /**
  * renvoie l'une des composates d'une date
  * @param string dateFr une date au format francophone
  * @param string element ("Y" | "m" | autre)
  * @return int l'an, le mois ou le jour
  */
  function getDateAm($dateFr, $element){
    if ($dateFr == "") return "NULL";
    $tab = explode(".", $dateFr);
    if ($element == "Y") {
      return $tab[2];
    } elseif ($element == "m") {
      return $tab[1];
    } else {
      return $tab[0];
    }
  }
}

?>
