<?php
  // $Id: quitte.inc,v 1.2 2017/07/06 22:19:45 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Dconnexion propre de l'utilisateur
* @package formulaires
*/
/**
* Dconnexion propre de l'utilisateur
* Met fin  la session et renvoie  la page de login
* @package formulaires
* @author ob tnh
*/
class quitte extends cadropt{
  /**
  * l'identifiant de session
  * @var string
  */
  var $idsession;
  
  /**
  * l'action du formulaire
  * @var int
  */
  var $action;
  
  /**
  * le fichier  afficher aprs dconnexion
  * @var string
  */
  var $fichier;
  
  /**
  * paramtre qui dtermine l'action du javascript fermant les fentres : si l'on se trouve dans la "page racine" et 
  * non dans une fentre fille, alors close est dfini comme false car il n'y a plus de fentres  fermer.
  * @var boolean
  */
  var $close;
  
  /**
  * donner la valeur "true" si l'on est dans Herms et "false" dans Brioche. Dtermine le javascript qui sera excut
  * @var boolean
  */
  var $admin;
  
  /**
  * le numro erreur de session
  * @var int
  */
  var $n_erreur = 0;
  
  /**
  * le contenu HTML de l'objet
  * @var string
  */
  var $vitrine;
  
  /**
  * la session utilise
  * @var object Session
  */
  var $session;

  /**
  * @param string no cf. variable de classe idsession
  * @param int act cf. variable de classe action
  * @param string fichier cf. variable de classe fichier
  * @param boolean close cf. variable de classe
  * @param boolean admin cf. variable de classe
  */ 
  function __construct($no, $act, $fichier, $close = false, $admin = false){    
    //$this->cadropt("#009966", 90, true, 2);
    parent::__construct("#009966", 90, true, 2);
    $this->idsession = $no;
    $this->action = $act;
    $this->fichier = $fichier;
    $this->close = $close;
    $this->admin = $admin;
    $this->session = new Session($this->idsession);
    if (!$this->verifSess($this->session)){
      return;
    }
  }
 
  /**
  * vrification de la session utilise
  * @param object Session la session utilise
  * @return boolean la session est-elle OK =
  */ 
  function verifSess($ss){
    if($ss->n_erreur){
      $this->n_erreur = $ss->n_erreur;
      return 0;
    }
    else return 1;
  }
  
  /**
  * construction de l'affichage dans le menu principal de Herms
  */
  function faitVitrine(){
    $form = new TabForm();
    $form->setTabParam();
    $form->setFormParam("quitter", $this->fichier . "?action=". $this->action, "POST");
    $c = new TLabel("Pour des raisons de s&eacute;curit&eacute;, il est prudent de quitter " .
                    "&agrave; la fin de votre travail");
    $c->setColSpan(2);
    $form->addChamp($c);
    $c = new TPanel(1, 1, "right", "", "50%");
    $x = new Label("&nbsp;");
    $c->addChamp($x);
    $x = new Bouton("sessionid", "$this->idsession", "HIDDEN");
    $c->addChamp($x);
    
    // lien pour envoyer l'action : le champ "page_racine" est utilis par la fonction javascript 
    //qui vrifie que toutes les fentres se ferment
    if ($this->close) {
      $x = new Bouton("page_racine", "0", "HIDDEN");
      $c->addChamp($x);
    } else {
      $x = new Bouton("page_racine", "1", "HIDDEN");
      $c->addChamp($x);
    }
    
    
    if ($this->admin) {
      // $x = new Lien("Quitter", true, false, false, "", "javascript:document.forms.quitter.submit();");
      $x = new Bouton("Quitter", "Quitter", "BUTTON", "javascript:document.forms.quitter.submit();");    
    } else {
      $x = new Bouton("Quitter", "Quitter", "BUTTON", "javascript:fermeToutesFenetres();");    
    }
    $c->addChamp($x);
    $x = new Label("&nbsp;");
    $c->addChamp($x);
    $form->addChamp($c);
    $this->vitrine = $this->entete;
    $this->vitrine .= $form->getContenu();
    $this->vitrine .= $this->pied;
  }

  /**
  * quittance aprs avoir quitt (retour au login)
  */
  function faitQuittance(){
    $this->session->ferme();
    parent::__construct("orange", 50);
    $this->vitrine = "<SCRIPT>document.location.replace('index.php');</SCRIPT>";
  }

  /**
  * affichage du contenu HTML de l'objet
  */
  function imprime(){
    if ($this->n_erreur) return;
    print $this->vitrine;
  }
}

?>
