<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Rception d'un DMST
* @package formulaires
*/
/**
* Rception d'un DMST
* Guide le CMS qui envoie un DMST depuis le DI. Lui permet ensuite de complter et corriger le document
* A installer sur le serveur centralis "Mange"
* @package formulaires
* @author ob
*/
class receptionDmst extends cadronglet{
  /**
  * l'identifiant du formulaire (hchage md5 pour raisons de scurit)
  * @var string
  */ 
  var $item;
  
  /**
  * les options passes par le formulaire
  * @var object optionsBrioche
  */
  var $options;
  
  /**
  * les options  passer par le formulaire
  * @var object optionsBrioche
  */
  var $futuroptions;
  
  /**
  * l'objet contenant les donnes dj enregistres dans la table "dmst"
  * @var object
  */
  var $tdmst;
  
  /**
  * le tableau de donnes postes par le formulaire
  * @var array
  */
  var $donnees;
  
  /**
  * le numro de la demande d'orientation associe au dmst
  * @var int
  */
  var $nodemor;
  
  /**
  * action accessoire : rception donnes prliminaires
  * @var int
  */  
  var $action2;
  
  /**
  * action accessoire : grille d'autonomie
  * @var int
  */
  var $action3;
  
  /**
  * action accessoire : contexte
  * @var int
  */
  var $action4;
  
  /**
  * action accessoire : transfert
  * @var int
  */
  var $action5;
  
  /**
  * action accessoire : mdicaments - intervenants
  * @var int
  */
  var $action6;
  
  
  /**
  * action accessoire : quitter
  * @var int
  */
  var $action7;
  
  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param int l'action de l'onglet actif
  * @param string fondpage la couleur de fond de la page
  * @param string sessionid l'identifiant de session
  * @param array donnees le tableau des donnes postes
  * @param int action2 ... action7 cf. variable de classe
  * @param strint autocheckboxes le champ "autocheckboxes" post par le formulaire (gestion des cases  cocher)
  */
  function receptionDmst($largeur, $grise, $actif, $fondpage, $options, $autspec, $action2, $action3, 
                                                $action4, $action5, $action6, $action7, $autocheckboxes){
    global $fichier;
    //if (!$this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid, $autspec)) return;
    $this->action2 = $action2; //action pour la rception (onglet unique)
    $this->action3 = $action3; //action pour le remplissage de la grille
    $this->action4 = $action4; //action pour le contexte
    $this->action5 = $action5; //action pour le transfert
    $this->action6 = $action6; //action pour les mdics
    $this->action7 = $action7; //Quitter
    
    $this->options = new optionsBrioche($options);
    $this->futuroptions = new optionsBrioche($options);
    $sequence = $this->options->getOption("SEQ_DMST");
    $focusExp = false;
    $of = new OngForm();
    
    $of->setFormParam("donnees", $fichier, "post");
    $onglets = array();
    $txtbouton = "Continuer&gt;&gt;&gt;";
    $typebouton = "SUBMIT";
    $actionbouton = "";
    $sauver = false;
    // Squence de vrification
    
    switch ($sequence){
    case 0: // premier affichage aprs la rception du DMST
      
      $this->futuroptions->setOption("SEQ_DMST", 1); 
      $focusExp = true;
      $onglets[] = "reception";
      break;
//    case 1: // Vrification saisie du nom de l'expditeur
//      $tabchamps['nomdem'] = $donnees['exp'];
//      $onglets[] = "reception";
//            
//      $utd = new updateTableBrioche("avaliderdem", $tabchamps, $this->nodemor, "nodemor", $this->idsession,
//                                    "", $this->autspec);
//      if (! $utd->controlePresence("nomdem", "expditeur")) {
//          
//        $this->options->setOption("SEQ_DMST", 0);
//        $this->futuroptions->setOption("SEQ_DMST", 1);
//        break;
//      }
//      else {
//        $this->futuroptions->setOption("SEQ_DMST", 2);
//        $utd->update();
//        
//        $type = $donnees['type'];        
//        if ($type == 2) {
//          unset($onglets[prev($onglets)]);
//        } else {
//          
//          $nvtype = array("C_TypeDoc" => "DMST+");
//          $cht = new updateTableBrioche("dmst",$nvtype,$this->item,"dmd5",$this->idsession,"",$this->autspec);
//          if (! $cht->update()) print "ERROR DMST +";
//            
//          if (! isset($this->donnees['provenance'])) $this->donnees['provenance'] = 4; // Par dfaut, vient du domicile
//          $c = new TPanel(6, 1);
//          $x = new Label("<FONT COLOR=\"red\">Le BRIO vous est reconnaissant de bien vouloir corriger ou de complter " .
//                      "ce qui suit...</FONT>");
//          $c->addChamp($x);
//          $of->addChamp($c);
//          $of->addLigne();
//          break;
//        }
//      }
//      
//    case 2: // Rception-enregistrement d'une demande d'orientation minimale
//      // enregistrement des lments de la demande d'orientation
//      
//      $ut = new updateTableBrioche("avaliderdem", $donnees, $this->recupereNoDem(), "nodemor", $this->idsession, "",
//                                   $this->autspec);
//      $ut->update();
//      $this->futuroptions->setOption("SEQ_DMST", 3);
//      //Basculement sur la grille d'autonomie
//      $onglets[] = "grille";
//      $this->actif = $this->action3;
//      $c = new TPanel(6, 1);
//      $x = new Label("La grille d'autonomie fait partie du DMST et fournit des renseignements trs utiles, " .
//                     "mais elle ne fait pas encore partie du " .
//                     "dossier informatis des CMS. <BR><FONT COLOR=\"red\">Merci de complter celle-ci !</FONT>");
//      $c->addChamp($x);
//      $of->addChamp($c);       
//      
//      break;
//    case 3: // Rception et enregistrement de la grille d'autonomie
//    // pas de break !   
//    case 4: //Accs final  l'ensemble des donnes
//      if($sequence == 3) $this->actif = $this->action4;
//      $this->futuroptions->setOption("SEQ_DMST", 4);
//      $dp = $this->donnees;
//      $c = new TPanel(6, 1);
//      $x = new Label("En utilisant les onglets ci-dessus, vous pouvez, si vous le dsirez, contrler et complter " .
//                     "les donnes transmises. Notez bien que les modifications effectues  ce stade sont transmises " .
//                     "au BRIO mais ne sont <B>pas</B> reportes dans le dossier informatis des CMS. N'oubliez pas de " .
//                     "cliquer ensuite sur [envoyer et quitter l'application].");
//      $c->addChamp($x);
//      $of->addChamp($c);
//      $of->addLigne();
//      if (! isset($dp['orig'])) $dp['orig'] = "";
//      if ($dp['orig'] == "reception"){
//        $ut = new updateTableBrioche("avaliderdem", $dp, $this->recupereNoDem(), "nodemor", $this->idsession, $autocheckboxes, 
//                                     $this->autspec);
//        $ut->update();                             
//      }
//      if ($dp['orig'] == "grille" || $dp['orig'] == "contexte" || $dp['orig'] == "transfert"
//          || $dp['orig'] = "medics"){
//        $ut = new updateTableBrioche("dmst", $dp, $this->item, "dmd5", $this->idsession, $autocheckboxes, 
//                                     $this->autspec);
//        $ut->update();                             
//      }
//      if (isset($dp[-1]) && $dp[-1]['orig'] == "medics"){
//        if ($autocheckboxes){
//          $acbmed = preg_replace("/donnees\[medic\]/", "dmedic", $autocheckboxes);
//        }
//        
//        if (isset($dp['medic']) && is_array($dp['medic'])){
//          foreach($dp['medic'] as $cle => $tabvaleurs){
//            if ($cle > 0){
//              $ut = new updateTableBrioche("dmstmedics", $tabvaleurs, $cle, "idmedic", $this->idsession,
//                                           $acbmed, $this->autspec);
//              $ut->update();                             
//            }
//          }
//          
//        }
//        if (isset($dp['interv']) && is_array($dp['interv'])){
//          foreach($dp['interv'] as $cle => $tabvaleurs){
//            if ($cle > 0) {
//              $ut = new updateTableBrioche("dmstinterv", $tabvaleurs, $cle, "idinterv", $this->idsession,
//                                           "", $this->autspec);
//              $ut->update();                            
//            }
//          }
//        }
//        foreach($dp as $cle => $valeur){
//          if ($cle == -2 && $valeur){ // destruction d'un mdicament
//            $ut = new updateTableBrioche("dmstmedics", "", $valeur, "idmedic", $this->idsession,
//                                         "", $this->autspec);
//            $ut->detruitEnr();
//          }
//          if ($cle == -3 && $valeur){ // destruction d'un intervenant
//            $ut = new updateTableBrioche("dmstinterv", "", $valeur, "idinterv", $this->idsession,
//                                         "", $this->autspec);
//            $ut->detruitEnr();                             
//          }
//        }
//        
//        if ($dp[-20]){ // nouveau mdicament
//          $tabchamps['iddmst'] = $this->recupereNoDmst();
//          $ut = new updateTableBrioche("dmstmedics", $tabchamps, "", "", $this->idsession, "", $this->autspec);
//          $ut->ajouteEnr();
//        }
//        if ($dp[-30]){ // nouvel intervenant
//          $tabchamps['iddmst'] = $this->recupereNoDmst();
//          $ut = new updateTableBrioche("dmstinterv", $tabchamps, "", "", $this->idsession, "", $this->autspec);
//          $ut->ajouteEnr();
//        }
//      
//      }
//      
//      // On va chercher les donnes dans la base et non plus dans les champs posts
//      $this->donnees = 0;
//      $sauver = true;
//      $txtbouton = "Envoyer et quitter l'application";
//      $typebouton = "BUTTON";
//      $actionbouton = "document.forms.donnees.action.value=99;document.forms.donnees.submit();";
//      $onglets[] = "reception";
//      $onglets[] = "grille";
//      $onglets[] = "contexte";
//      $onglets[] = "transfert";
//      $onglets[] = "medics";
//      break;
    }
    
    //Rcupration des donnes dj enregistres
    $sessManege = new sessionManege();
    $DMST = $sessManege->voir("DMST");
    // Dessin des onglets
    if (count($onglets)){
      foreach($onglets as $onglet){
        if ($onglet == "reception" && ($DMST["C_TypeDoc"] == "DMST+" || $sequence == 0)){
          $tabbande = array("Document concernant : ", $DMST["x_Nom"] . " " . $DMST["x_Prenom"],
                            "", "", "Donnes prliminaires");
          $this->addOnglet("Rception", $tabbande, "#8b8378",
                           $this->action2, 80,
                           "javascript:document.forms.donnees.elements['action'].value=" .
                           "$this->action2;document.forms.donnees.submit();");  
        }
//        if ($onglet == "grille"){
//          $tabbande = array("Document concernant : ", $this->tdmst->x_Nom . " " . $this->tdmst->x_Prenom,
//                            "", "", "Grille d'autonomie");
//          $this->addOnglet("Grille", $tabbande, "#122199",
//                           $this->action3, 80,
//                           "javascript:document.forms.donnees.elements['action'].value=" .
//                           "$this->action3;document.forms.donnees.submit();");
//        }
//        if ($onglet == "contexte") {
//          $tabbande = array("Document concernant : ", $this->tdmst->x_Nom . " " . $this->tdmst->x_Prenom,
//                            "", "", "Contexte, tat de sant");
//          $this->addOnglet("Contexte", $tabbande, "#ff31f5",
//                          $this->action4, 80,
//                          "javascript:document.forms.donnees.elements['action'].value=" .
//                          "$this->action4;document.forms.donnees.submit();");
//        }
//        if ($onglet == "transfert") {
//          $tabbande = array("Document concernant : ", $this->tdmst->x_Nom . " " . $this->tdmst->x_Prenom,
//                            "", "", "Jour du transfert");
//          $this->addOnglet("Transfert", $tabbande, "#30ff15",
//                          $this->action5, 80,
//                          "javascript:document.forms.donnees.elements['action'].value=" .
//                          "$this->action5;document.forms.donnees.submit();");
//        }
//        if ($onglet == "medics") {
//          $tabbande = array("Document concernant : ", $this->tdmst->x_Nom . " " . $this->tdmst->x_Prenom,
//                            "", "", "Mdicaments et intervenants");
//          $this->addOnglet("Mdic.", $tabbande, "#30ff15",
//                          $this->action6, 80,
//                          "javascript:document.forms.donnees.elements['action'].value=" .
//                          "$this->action6;document.forms.donnees.submit();");
//        }
        
      }
      $this->colmateOnglets();
    }
      
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    
    // Corps de la page
//    if ($this->actif == $this->action2){ // rception et validation
//      $pdv = new pageDmstValidation($this, $sauver, false, 0);
//      $of->addPage($pdv);
//      if($focusExp) $of->setFocus("donnees[exp]");
//    }
//    elseif ($this->actif == $this->action3){ // grille d'autonomie
//      $pdv = new pageDmstGrille($this, $sauver, false, 0);
//      $of->addPage($pdv);
//    }
//    elseif ($this->actif == $this->action4) { // Contexte
//      
//      $pdv = new pageDmstContexte($this, true, false, 0);
//      $of->addPage($pdv);
//    }
//    elseif ($this->actif == $this->action5) { // Transfert
//      $pdv = new pageDmstTransfert($this, true, false, 0);
//      $of->addPage($pdv);
//    }
//    elseif ($this->actif == $this->action6) { // Mdics
//      $pdv = new pageDmstMedics($this, true, false, 0);
//      $of->addPage($pdv);
//    }
    $of->addLigne();
    $c = new TPanel(6, 1, "RIGHT");
    $x = new Bouton("Continuer", $txtbouton, $typebouton, $actionbouton);
    $c->addChamp($x);
    $c->addChamp(new Espace(2));
    $of->addChamp($c);
    $of->addLigne();
    $this->addContenu($of->getContenu());
   
  }
}

?>
