<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Recherche de disponibilits en courts sjours
* @package formulaires
*/
/**
* Recherche de disponibilits en courts sjours
* Les lits disponibles pour une priode donne. Accs plein pour le BRIO et limit pour les tablissements
* @package formulaires
* @author cjd jdu ob
*/
class rechDispo extends cadreSimple {
	
  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string fondpage la couleur du fond de page
  * @param int action l'action principale
  * @param string sessionid l'identifiant de session
  * @param array donnees les donnes postes par le formulaire (n d'tablissement)
  */
  function rechDispo($largeur, $fondpage, $action, $sessionid, $donnees) {
    global $fCourSej;
    global $imagesdir;
    $ini = new briocheIni();
    $autspec[0] = $ini->autSpec[2];
    if (! $this->cadreSimple($largeur, $fondpage, $sessionid, $autspec)) return;
    $tbx = array("depuis", "jusqua");
    foreach($tbx as $elx){
      if (! isset($donnees[$elx])) $donnees[$elx] = date("d.m.Y");
    }
 
    if ($donnees['depuis'] == '' && $donnees['jusqua'] != '') $donnees['depuis'] = $donnees['jusqua'];
    if ($donnees['jusqua'] == '' && $donnees['depuis'] != '') $donnees['jusqua'] = $donnees['depuis'];
    if ($donnees['jusqua'] == '' && $donnees['depuis'] == '') {
      $donnees['jusqua'] = date("d.m.Y");
      $donnees['depuis'] = date("d.m.Y");
    }
    
    $depuis = explode(".", $donnees['depuis']);
    $depuis_timestamp =  mktime(0, 0, 0, $depuis[1], $depuis[0], $depuis[2]);
    $depuis_time = date("Y-m-d",$depuis_timestamp);
    $jusqua = explode(".", $donnees['jusqua']);
    $jusqua_timestamp =  mktime(0, 0, 0, $jusqua[1], $jusqua[0], $jusqua[2]);
    $jusqua_time = date("Y-m-d",$jusqua_timestamp);
   
    $tf = new TabForm();
    $tf->setTabParam($largeur, 0, 3, 0, $fondpage);
    $tf->setFormParam("donnees", "", "post");
    
    // Titre
    $c = new TPanel(6, 1);
    $txt = "Lits Disponibles - Planning des courts sjours";
    $x = new Label("<H3>$txt</H3>");
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    
    // Date depuis - jusqua
    $c = new TPanel(6, 1);
    $x = new ChampTexte("donnees[depuis]", $donnees['depuis'], "Sjour du&nbsp;:&nbsp;", 15, 15, false, "text", "d2",
                        "controleDate('donnees[depuis]', '', 365, 365,'donnees[depuis]','donnees[jusqua]')", "", false, true);
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $x = new ChampTexte("donnees[jusqua]", $donnees['jusqua'], "jusqu'au&nbsp;:&nbsp;", 15, 15, false, "text", "d2",
                        "controleDate('donnees[jusqua]', '', 365, 400,'donnees[depuis]','donnees[jusqua]')", "", false, true);
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $tf->addChamp($c);
    
    // Recherche
    $c = new TPanel(4, 1, "RIGHT");   
    $x = new Bouton("Recherche", "Recherche", "SUBMIT");   
    $c->addChamp($x);
    $tf->addChamp($c);
    
    $tf->addLigne();
    $tf->addLigne(0.5);

    if ($jusqua_time == $depuis_time) {
        $signe = "<="; 
        $signe2 = ">"; 
    } else {
        $signe = "<";
        $signe2 = ">=";
    }
    
    $limitation = "";
    if (! $this->verifAut($ini->autReq, $this->autorisations)){ 
      //Les utilisateurs EMS n'accdent qu'aux disponibilits de leur propre tablissement
      $tetabl = new ensTableBrioche("etablautorises", "etablautorises.idut = $this->nout AND priv = 'emscs'", 
                                    "etablissements.noet", 0, $this->idsession,
                                    "etablissements", "etablautorises.etabl = etablissements.noet",
                                    false, $autspec);
      $tt = $tetabl->getTableau();
      $limitation = " AND etablissements.noet = " . $tt[0]->noet . " ";
    }                                
    $litsDispo = new ensTableBrioche("etablissements, litscourtsejour",
                                     "IFNULL(calendrier.noev < 0, 0=0) AND " .
                                     "etablissements.noet = litscourtsejour.etabl" .
                                     $limitation,
                                     "etablissements.noet, etablissements.nomet, litscourtsejour.chambre, " .
                                     "litscourtsejour.lit, litscourtsejour.descr, calendrier.debut, calendrier.sexe",
                                     //,calendrier.debut,calendrier.fin,calendrier.actif",
                                     "etablissements.nomet, litscourtsejour.chambre, " .
                                     "litscourtsejour. lit,litscourtsejour.descr",
                                     $this->idsession,
                                     "calendrier",
                                     "litscourtsejour.etabl = calendrier.etablissement " .
                                     "AND litscourtsejour.chambre = calendrier.chambre " .
                                     "AND litscourtsejour.lit = calendrier.lit " .
                                     "AND calendrier.actif = 1 AND calendrier.debut $signe '". 
                                     $jusqua_time . "' AND calendrier.fin > '". $depuis_time . "'",
                                     true, $this->autspec, "");
    //print_r($litsDispo->getSql());
    $dte = explode(".", $donnees['depuis']);  
    $c = new TPanelTableau(12, 1, $litsDispo, "#AAAAAA", "etablissements", "noet");
    $tabInt = $litsDispo->getTableau();
    foreach ($tabInt as $cle => $tab) {
        // Occup ds le
        $prochaineOcc = new ensTableBrioche("calendrier","calendrier.etablissement = " . $tab->noet .
                                                         " AND calendrier.chambre = " . $tab->chambre .
                                                         " AND calendrier.lit = " . $tab->lit .
                                                         " AND calendrier.actif = 1 " .
                                                         " AND calendrier.debut $signe2 '" . $jusqua_time . "'",
                                             "debut", 0, $this->idsession, 0, 0, false, $this->autspec);
        if ($prochaineOcc->getPremier('debut') != '')
            $tabInt[$cle]->debut = date("d.m.Y",strtotime($prochaineOcc->getPremier('debut')));
        else $tabInt[$cle]->debut = '';
        // Sexe
        $voisinSexe = new ensTableBrioche("calendrier","calendrier.etablissement = " . $tab->noet .
                                          " AND calendrier.chambre = " . $tab->chambre . " AND calendrier.lit != " . $tab->lit .
                                          " AND calendrier.actif = 1  AND calendrier.debut $signe '" . $jusqua_time . "'" .
                                          " AND calendrier.fin > '". $depuis_time . "'",
                                          "sexe, nodoss", 0, $this->idsession, 0, 0, false, $this->autspec);
        $sexe = "";
        foreach ($voisinSexe->getTableau() as $sexeTab) {
            if ($sexe == "F/M") break;
            $sexeAtt = "";
            if ($sexeTab->nodoss == -999) $sexeAtt = $sexeTab->sexe;
            else {
                $usagerSexe = new ensTableBrioche("dossiers, usagers","dossiers.nodoss = " . $sexeTab->nodoss .
                              " AND dossiers.nous = usagers.nous", "sexe", 0, $this->idsession, 0, 0, false, $this->autspec);
                $sexeAtt = $usagerSexe->getTableau();
                $sexeAtt = $sexeAtt[0]->sexe;
            }
            if ($sexeAtt != $sexe && $sexe != "") $sexe = "F/M";
            elseif ($sexe == "") $sexe = $sexeAtt;
        }
        $tabInt[$cle]->sexe = $sexe;        
    }
    $c->tableau = $tabInt;
    $x = new BoutonImage("", "$imagesdir/vu.gif", 12, 12, "#", "noet", "", 
                         "window.opener.location='$fCourSej?action=$action" .
                         "&sessionid=$this->idsession" .
                         "&donnees[noet]=&donnees[mois]=" . $dte[1] .
                         "&donnees[annee]=" . $dte[2] . "';");
    $c->addColChamp("", $x, false, true);
    $x = new Label("", false, false, false, "nomet");
    $c->addColChamp("Etablissement", $x);
    $x = new Label("", false, false, false, "chambre");
    $c->addColChamp("Chambre", $x);
    $x = new Label("", false, false, false, "lit");
    $c->addColChamp("Lit", $x);
    $x = new Label("", false, false, false, "descr");
    $c->addColChamp("Description", $x);
    $x = new Label("", false, false, false, "sexe");
    $c->addColChamp("Sexe", $x);
    $x = new Label("", false, false, false, "debut");
    $c->addColChamp("Occup ds le", $x);
    $c->addTitres(true);
    $tf->addChamp($c);
    
    $tf->addLigne();
    $tf->addLigne(0.5);    
    
    // Close
    $c = new TPanel(10, 1, "RIGHT");
    $x = new Bouton("Fermer", "Fermer", "BUTTON", "window.close()");    
    $c->addChamp($x);        	
    
    $tf->addChamp($c);
    $this->addContenu($tf->getContenu());
  }
}

?>