<?php
/**
* Extraction des statistiques IUMSP
* @package donnes
*/
/**
* Extraction des statistiques IUMSP
* Objet invoqu par un script en principe hebdomadaire, et qui excute les scripts R de l'IUMSP
* @package donnes
* @author ob cjd jdu
*/
class scriptIumsp {
  /**
  * le tableau des fichiers  gnrer et analyser
  * @var array
  */
  var $tabdates;
  
  /**
  * Excution des scripts
  */
  function scriptIumsp (){
     $ini = new briocheIni();
    //Destruction des fichiers *.txt prcdemment extraits (pour le cas o une prcdente excution du script aurait t
    //interrompue
    $repext = opendir($ini->repExtraction_r);
    while (false !== ($nomfich = readdir($repext))) {
      if (preg_match("/^" . $ini->nomBrio_r ."/", $nomfich)){
        unlink("$ini->repExtraction_r/$nomfich");
      }
    }
    // Destruction des anciennes statistiques
    $rephtml = opendir($ini->repHtml_r);
    while (false !== ($nomfichhtml = readdir($rephtml))) {
      if (preg_match("/^" . $ini->nomBrio_r ."/", $nomfichhtml)){
        unlink("$ini->repHtml_r/$nomfichhtml");
      }
    }
    
    //Constitution du tableau des priodes  traiter
    $anneeCourante = date("Y");
    $moisCourant = date("m");
    $jourCourant = date("d");
    $dernierMois = ($jourCourant > 15 ? $moisCourant - 1 : $moisCourant - 2);
    $dernierDebutTrimestre = ceil(($moisCourant)/3);
    //Les 6 derniers mois
    $index = 0;
    for ($i = 5; $i  >= 0; $i --){
      $debut = mktime(0, 0, 0, $dernierMois - $i, 1, $anneeCourante);
      $fin = mktime(0, 0, 0, $dernierMois - $i + 1, 0, $anneeCourante);
      $this->remplitTableau($index, $debut, $fin);
      $index ++;
    }
    
    //mois en cours
    $debut = mktime(0, 0, 0, $moisCourant, 1, $anneeCourante);
    $fin = mktime(0, 0, 0, $moisCourant, $jourCourant, $anneeCourante);
    $this->remplitTableau($index, $debut, $fin);
    $index ++;
   
    // Les 4 derniers trimestres
    for ($i = 3; $i >= 0; $i --){
      $moisdeb = (ceil($moisCourant/3) * 3) - 5;
      $debut = mktime(0, 0, 0, $moisdeb - ($i * 3), 1, $anneeCourante);  
      $fin = mktime(0, 0, 0, $moisdeb - ($i * 3) + 3, 0, $anneeCourante);    
      $this->remplitTableau($index, $debut, $fin);
      $index ++;
    } 
    
    //trimestre en cours
    $debut = mktime(0, 0, 0, $moisdeb+3, 1, $anneeCourante);
    $fin = mktime(0, 0, 0, $moisCourant, $jourCourant, $anneeCourante);
    $this->remplitTableau($index, $debut, $fin);
    $index ++;
    
    // Les 2 derniers semestres
    for ($i = 1; $i >= 0; $i --) {
      $moisdeb = (ceil($moisCourant/6) * 6) - 11;
      $debut = mktime(0, 0, 0, $moisdeb - ($i * 6), 1, $anneeCourante);  
      $fin = mktime(0, 0, 0, $moisdeb - ($i * 6) + 6, 0, $anneeCourante);    
      $this->remplitTableau($index, $debut, $fin);
      $index ++;
    }
    
    //semestre en cours
    $debut = mktime(0, 0, 0, $moisdeb+6, 1, $anneeCourante);
    $fin = mktime(0, 0, 0, $moisCourant, $jourCourant, $anneeCourante);
    $this->remplitTableau($index, $debut, $fin);
    $index ++;
    
    // L'anne prcdente en entier
    for ($i = 2; $i >= 0; $i --) {
      $debut = mktime(0, 0, 0, 1, 1, $anneeCourante - 1 - $i);
      $fin = mktime(0, 0, 0, 1, 0, $anneeCourante - $i);
      $this->remplitTableau($index, $debut, $fin);
      $index ++;
    }
    
    //anne en cours
    $debut = mktime(0, 0, 0, 1, 1, $anneeCourante);
    $fin = mktime(0, 0, 0, $moisCourant, $jourCourant, $anneeCourante);
    $this->remplitTableau($index, $debut, $fin);
    $index ++;
    
    //Ouverture d'une session par priode et gnration des tables provisoires
    $cpt = count($this->tabdates);
    for ($i = 0; $i < $cpt; $i++){
      $sess = new Session(0, $ini->utilScripts, $ini->passeScripts, 0, $i);
      $idsession = $sess->idsession;
      $ed = new ensDataIUMSP($this->tabdates[$i]['frdebut'], $this->tabdates[$i]['frfin'], $idsession, $idsession);
      $tp = new TableProv("IUM",  $idsession);
      $tpr = new TableProv("IUMR",  $idsession);
      $contenu = $tp->getCSV("iddemand");
      $contenur = $tpr->getCSV("iddemand");
      $nomf = "$ini->repExtraction_r/" . $ini->nomBrio_r . "_demandes_" . $this->tabdates[$i]['titre'] . ".txt";
      $nomfr = "$ini->repExtraction_r/" . $ini->nomBrio_r . "_refus_" . $this->tabdates[$i]['titre'] . ".txt";
      $fichier = fopen($nomf , "w");
      $fichierr = fopen($nomfr , "w"); 
      fwrite($fichier, $contenu);
      fwrite($fichierr, $contenur);
      fclose($fichier);
      fclose($fichierr);    
      // Excution des routines R
      system("R --save < $ini->rep_r/analyses.R");
      unlink($nomf);
      unlink($nomfr);
      //cd bunlink($nomfr);
      $sess->ferme();
 
    }
    //print_r($this->tabdates);
  }
  
  /**
  * ajout d'un fichier au tableau des fichiers  gnrer et analyser
  * @param int index le numro d'ordre du fichier
  * @param int debut le timstamp unix du dbut du fichier
  * @param int fin le timestamp unix de la fin du fichier
  * le tableau tabdates se voit ajouter un tableau associatif contenant respectivement
  * <pre>
  * tstdebut : le timestamp correspondant au dbut du fichier
  * tstfin : le temestamp correspondant  la fin du fichier
  * titre : la partie centrale du titre du fichier (sans l'extension ni le prfixe _demandes_ ou _refus_)
  * frdebut : la date de dbut au format francophone
  * frfin : la date de dbut au format francophone
  * </pre>
  */
  function remplitTableau($index, $debut, $fin){
    $this->tabdates[$index]['tstdebut'] = $debut;
    $this->tabdates[$index]['tstfin']  = $fin;
    $this->tabdates[$index]['titre'] = date("Ymd", $debut) . "_" . date("Ymd", $fin); 
    $this->tabdates[$index]['frdebut'] = date("d.m.Y", $debut);
    $this->tabdates[$index]['frfin'] = date("d.m.Y", $fin);
  }

}










?>