<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Slection des envois interBRIOs dans la demande d'orientation
* @package formulaires
*/
/**
* Slection des envois interBRIOs dans la demande d'orientation
* Permet de slectionner un ou plusieurs BRIOs auxquels la demande est envoye
* Si soap est en service, possibilit d'envoyer directement une demande lectronique
* Les BRIOs slectionns apparaissent aussi dans l'onglet EMS
* @package formulaires
* @author cjd jdu ob
*/
class selInterBrios extends cadronglet {
  /**
  * le numro du dossier
  * @var int
  */
  var $item;
  
  /**
  * @param string largeur la largeur du formulaire
  * @param string grise la couleur du gris
  * @param int actif l'action principale du formulaire
  * @param string fondpage la couleur du fond de page
  * @param string sessionid l'identifiant de session
  * @param int item cf. variable de classe
  * @param string la chane de caractres reprsentant les options (telle que poste)
  * @param array donnees le tableau des donnees postees
  */
  function selInterBrios($largeur, $grise, $actif, $fondpage, $sessionid, $item, $options, $donnees){
    global $fdosbrioche;
    if ( !$this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid)) return;                   
    $ini = new briocheIni();
    $this->item = $item;
    $this->options = new optionsBrioche($options);
    $cles = array('etablissements', 'mettrajour', 'nochoix');
    foreach($cles as $cle){
      if (! isset($donnees[$cle])) $donnees[$cle] = "";
    }
    if ($donnees['mettrajour'] == 1){//Enregistrement d'un etablissement
      if (! $donnees['etablissements']){
        $al = new Alerte("Spcifiez un BRIO !");
        $al->imprime();
      }
      else {
        $tabchamps['noems'] = $donnees['etablissements'];
        $tabchamps['nodoss'] = $item;
        $tabchamps['datechoix'] = $this->aujourdhui();
        $uts = new updateTableBrioche("choixems", $tabchamps, 0, 0, $this->idsession);
        if (! $uts->ajouteEnr()){
          print "PROBLEME";
        }
        else { //Ecriture etablissement russie
          $this->envoieOpener();
        }
      }  
    }
    elseif ($donnees['mettrajour'] == 2){ //Destruction d'un etablissement
      $etdel = new ensTableBrioche("choixems",
                                   "nochoix = " . $donnees['nochoix'],
                                   "*", 0, $this->idsession);
      $tetdel = $etdel->getTableau();
      if (count($tetdel)){
        if ( ! $etdel->detruitEnr($tetdel[0]->nochoix, "nochoix")) print "PROBLEME";
      }                             
      $this->envoieOpener();
    }
    elseif ($donnees['mettrajour'] == 3) { //Envoi d'une demande interbrio
      $man = new clientManege($this->idsession);
      $man->envoieDemande($donnees['nochoix']);
      $man->getQuittances();
      $this->envoieOpener();
    }
    
    $tabbande = array("Dossier", "", "", "N " . $this->item, "");
    $this->addOnglet("InterBrios", $tabbande, "#8b8378", 7002, 60, "javascript:'void(0)')");
    $this->colmateOnglets();
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 12);
    $of->setFormParam("donnees", $fdosbrioche, "post");
    $c = new TPanel(12, 1);
    $x = new Bouton("donnees[mettrajour]", $donnees['mettrajour'], "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("action", $this->actif, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("options", $options, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("donnees[nochoix]", $donnees['nochoix'], "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("item", $this->item, "HIDDEN");
    $c->addChamp($x);
    $x = new Label("Ajout d'un tablissement", true);
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne();
    // Brios dj slectionns (et  supprimer de la liste droulante).
    $join = array();
    $on = array();
    $join[] = "etablissements";
    $on[] = "choixems.noems = etablissements.noet";
    $join[] = "suivisenvoisib";
    $on[] = "etablissements.adresseib = suivisenvoisib.adressedest";

    $enr = new enrBrioche($this->item, $this->idsession);
    $brios = $enr->getDemandeInterBrio();
    $cptib = count($brios);
    $chaine = "";
    for ($i = 0; $i < $cptib; $i++){
      $chaine .= $brios[$i]['noet'];
      if ($i < ($cptib -1)) {
        $chaine .= ", ";
      }
    }
    if ($chaine) $chaine = " AND noet NOT IN ($chaine)";
    $c = new TPanel(12, 1);
    $tlist = new ensTableBrioche("etablissements", "actif = -1 AND autbrio = -1" .
                                 $chaine, "*",
                                 "nomet", $this->idsession);
    $x = new ListOptTable("donnees[etablissements]", $donnees['etablissements'], $tlist, false, 8);
    $x->addDefaut("---", "");
    $x->addOptions("nomet", "noet");
    $c->addChamp($x);
    $c->addChamp(new Espace(2));
    $x = new Bouton("OK", "OK !", "BUTTON",
                    "javascript:changeChamp(\"donnees[mettrajour]\", 1, \"donnees\");" .
                    "document.donnees.submit();");
                    
    $c->addChamp($x);
    $of->addChamp($c);                
    $of->addLigne(0.5);
    $of->addLigne();
    
    
    $c = new TPanel(12, 1);
    if ($cptib){
      
      $x = new Label("Envoi et suivi des demandes interBRIOs :", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      for ($i = 0; $i < $cptib; $i++){
        $c = new TPanel(3, 1);
        $x = new Label($brios[$i]['nomet']);
        $c->addChamp($x);
        $of->addChamp($c);
        $c = new TPanel(1, 1);
        //print $tintbriodoss[$i]->quittance;
        //if (! $tintbriodoss[$i]->quittance) print "N";
        $x = new Lien("Effacer", false, false, false, "",
                      "javascript:changeChamp('donnees[mettrajour]', 2, 'donnees');" .
                      "changeChamp('donnees[nochoix]', '" . $brios[$i]['nochoix'] . "', 'donnees');" .
                      "document.forms.donnees.submit();", 0, $brios[$i]['quittance']);
        $c->addChamp($x);
        $of->addChamp($c); 
        $c = new TPanel(1, 1, "RIGHT");
        
        $fction = "changeChamp('donnees[mettrajour]', 3, 'donnees');" .
              "changeChamp('donnees[nochoix]', '" . $brios[$i]['nochoix'] .
              "', 'donnees');document.forms.donnees.submit();";
        
        if ($brios[$i]['quittance'] > 1){
          $js = "javascript:if(confirm('Le BRIO destinataire a dj reu cette demande. " .
                "Faut-il rpter l\'envoi ?')){$fction}";
        }
        else {
          $js = "javascript:" . $fction;
        }
        if ($this->options->getOption("NOUV_DOSS")) {
          $js = "javascript:alert('Avant de pouvoir envoyer votre demande interBRIOs, " .
                "vous devez la terminer et la sauver.');";             
        }   
        if ($brios[$i]['adresseib'] && ($this->verifAut($ini->autSuppl[5], $this->autorisations))) {
          $x = new BoutonImage("Transmettre la demande", "images/envoivert.gif", 20, 18,
                               $js);
          $c->addChamp($x);
        }
        switch($brios[$i]['quittance']){
        case 1:
        case 2:  
          $texte = "<FONT COLOR=\"" . COULEUR_ENVOYE . "\">Demande envoye</FONT>";
          break;
        case 98:
          $texte = "<FONT COLOR=\"" . COULEUR_REJETE . "\">Demande rejete par le BRIO destinataire</FONT>";
          break;
        case 99:
          $texte = "<FONT COLOR=\"" . COULEUR_ACCEPTE . "\">Demande valide par le BRIO destinataire</FONT>";
          break;
        default:
          $texte = "<FONT COLOR=\"" . COULEUR_PREPARE . "\">Demande prpare</FONT>";  
        }
        $of->addChamp($c);
        $c = new TPanel(7, 1);
        $x = new Label($texte);
        $c->addChamp($x);
        $of->addChamp($c);
        $of->addLigne();  
      }	  
    }  	                                
    else {
      $x = new Label("Aucun BRIO n'est slectionn pour ce dossier...", false, true);
      $c->addChamp($x);	
      $of->addChamp($c);
      $of->addLigne();
    }	
    $c = new TPanel(12, 1, "RIGHT", "TOP");
    $x = new Bouton("Fermer", "Fermer", "BUTTON", "window.close();");
    $c->addChamp($x);
    $c->addChamp(new Espace(2));
    $of->addChamp($c);
    $of->addLigne();
    $this->addContenu($of->getContenu());
  }                   		
  
  /**
  * gnration du javascript qui provoque un submit de la fentre parente
  */
  function envoieOpener(){
    $opt = new optionsBrioche($this->options->getChaine());
    $opt->setOption("ENR_INTERBRIOS", 1);
    print "<SCRIPT LANGUAGE=\"JavaScript\">" .
          "changeChampOpener('options', '" . 
          $opt->getChaine() . "', 'donnees');" .
          "window.opener.document.forms.donnees.submit();".
          //"window.close();" .
          "</SCRIPT>";
  }	 

}	




?>