<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Session
* @package herms
*/
/**
* Session
* Classe mre de toutes les connexions  la base de donnes d'administration
* Gestion des erreurs de session, du timeout.
* Contient quelques fonctions trs gnrales de conversions de chanes
* @package herms
* @author ob
*/
class Session {
  /**
  * le lien  la base d'administration
  * @var resource
  */
  var $link;
  
  /**
  * le nom d'utilisateur herms-brioche
  * @var int
  */
  var $utilisateur;
  
  /**
  * l'identifiant de session
  * @var string
  */
  var $idsession;
  
  /**
  * l'hte de la base mysql d'administration
  * @var string
  */
  var $hoteMysql;
  
  /**
  * l'utilisateur de la base mysql d'adminstration
  * @var string
  */
  var $utilMysql;
  
  /**
  * le mot de passe pour la connexion  la base d'administration
  * @var string
  */
  var $passeMysql;
  
  /**
  * le nom de la base de donnes d'administration
  * @var string
  */
  var $bdMysql;
  
  /**
  * le mot de passe de l'utilisateur herms-brioche
  * @var string
  */
  var $mdp;
  
  /**
  * l'adresse email de l'utilisateur herms-brioche
  * @var string
  */
  var $email;
  
  /**
  * le nom complet de l'utilisateur herms-brioche
  * @var string
  */
  var $nomplein;
  
  /**
  * le groupe auquel appartient l'utilisateur herms-brioche
  * @var string
  */
  var $groupe;
  
  /**
  * un message pour l'erreur de session
  * @var string
  */
  var $erreur = "";
  
  /**
  * le numro de l'erreur de session
  * @var int
  */
  var $n_erreur = 0;
  
  /**
  * les autorisations dont dispose le groupe auquel appartient l'utilisateur herms-brioche
  * Une chane de caractres, les autorisations spares par des virgules
  * @var string
  */
  var $autorisations = "";
  
  /**
  * le numro de l'utilisateur herms-brioche
  * @var int
  */
  var $nout;
  
  /**
  * la dure du timeout (secondes)
  * @var int
  */
  var $timeout;
  
  /**
  * la largeur de l'cran de l'utilisateur (pixel)
  * @var int
  */
  var $largeurecran;

  /**
  * @param string idsession cf. variable de classe
  * @param string idutilisateur cf. variable de classe utilisateur
  * @param string mdput cf. variable de classe mdp
  * @param int largeurecran cf. variable de classe
  * @param int no valeur pouvant tre ajoute lorsque plusieurs sessions sont ouvertes trs
  * rapidement par le mme utilisateur (dans un script), afin d'viter que plusieurs sessions successives
  * puissent avoir le mme identifiant
  * L'invocation d'une session se fait soit en fournissant l'identifiant idsession (auquel cas le nom d'utilisateur
  * et le mot de passe sont inutiles), soit en fournissant un nom d'utilisateur et un mot de passe
  * (auquel cas une nouvelle session est cre).
  */
  function __construct($idsession=0, $idutilisateur=0, $mdput=0, $largeurecran=0, $no=0){
    $hini = new hermesIni();
    $this->utilisateur = $idutilisateur;
    $this->idsession = $idsession;
    $this->mdp = $mdput;
    $this->timeout = $hini->timeout;
    if (! $this->timeout){
      $this->timeout = 10000; // TNH change
    }
    #connexion  MySql
    $this->bdMysql = $hini->bdMysql;
    $this->hoteMysql = $hini->hoteMysql;
    $this->utilMysql = $hini->utilMysql;
    $this->passeMysql = $hini->passeMysql;
    $this->link = mysqli_connect($this->hoteMysql, $this->utilMysql, $this->passeMysql, $this->bdMysql);
    if (! $this->link){
      #chec de la connexion
      $this->erreur = mysqli_error($this->link);
      $this->n_erreur = 101;
      return;
    }
    
    #Slection bd
    //$resultat = mysql_select_db($this->bdMysql, $this->link);
    //if (! $resultat){
    //  #chec slection bd
    //  $this->erreur = mysql_error();
    //  $this->n_erreur = 102;
    //  return;
    //}
    #Vrification ou cration
    if (! $this->idsession) { #cration session
      $requete = "SELECT utilisateurs.id, utilisateurs.mdput, utilisateurs.emailut, abonnes.nomplein, utilisateurs.groupe " .
                 "FROM utilisateurs LEFT JOIN abonnes ON utilisateurs.id = abonnes.idut WHERE nomut = \"$this->utilisateur\"";
      $result = mysqli_query($this->link, $requete);
      if (! mysqli_num_rows($result)){
        $this->n_erreur = 103;
        $this->erreur = "Echec d'autorisation";
        return;
      }
      $ligneut = mysqli_fetch_row($result);
      $maintenant = time();
      #cration d'un numro de session unique
      $aubol = $this->utilisateur . $maintenant . $no;
      $this->idsession = md5($aubol);
      $requete = "INSERT INTO session SET sessionid = \"$this->idsession\", dernAcc = $maintenant, ";
      $requete .= "mdpstock = \"$ligneut[1]\", idut = $ligneut[0]";

      if ($largeurecran) {
        $requete .= ", largeurecran = $largeurecran";
        $this->largeurecran = $largeurecran;
      }
      $result = mysqli_query($this->link, $requete);
      #contrle du mot de passe
      if (! $this->contrMdp($this->mdp)){
        return;
      }
      #mot de passe OK => quittance = 1
      $requete = "UPDATE session SET quittance = 1 WHERE sessionid = \"$this->idsession\"";
      $result = mysqli_query($this->link, $requete);
    }
    else { #vrification session en cours
      #fermeture des sessions chues (timeout)
      $requete = "UPDATE session SET quittance = 2 WHERE quittance = 1 AND " . time() . " - dernAcc > " . $this->timeout;
      $result = mysqli_query($this->link, $requete);
      #appel de la session
      $requete = "SELECT id, sessionid, dernAcc, mdpstock, mdpfourn, idut, quittance, largeurecran " .
                 "FROM session WHERE sessionid = \"$this->idsession\"";
      $result = mysqli_query($this->link, $requete);
      $ligneut = mysqli_fetch_row($result);
      $this->largeurecran = $ligneut[7];
      if (! $ligneut){
        $this->n_erreur = 104;
        $this->erreur = "Session inexistante";
        return;
      }
      elseif ($ligneut[6] < 0){
        $this->n_erreur = - $ligneut[6];      
        return;
      }
      if ($ligneut[6] != 1){
        $this->n_erreur = 105;
        $this->erreur = "Session chue";
        return;
      }
      #mise  jour du champ dernAcc
      $requete = "UPDATE session SET dernAcc = " . time() . " WHERE sessionid = \"$this->idsession\"";
      $result = mysqli_query($this->link, $requete);
      #recherche donnes utilisateur
      $requete = "SELECT utilisateurs.id, mdput, emailut, nomplein, groupe, nomut FROM utilisateurs " .
                 "LEFT JOIN abonnes ON utilisateurs.id = abonnes.idut " .
                 "LEFT JOIN session ON utilisateurs.id = session.idut " .
                 "WHERE session.sessionid = \"$this->idsession\"";
      $result = mysqli_query($this->link, $requete);
      $ligneut = mysqli_fetch_row($result);
      $this->utilisateur = $ligneut[5];
      $this->nout = $ligneut[0];
    }
    $this->email = $ligneut[2];
    $this->nomplein = $ligneut[3];
    $this->groupe = $ligneut[4];
    //print $this->idsession . " - " . $this->largeurecran . "<BR>";
    #fonctions autorises
    $requete = "SELECT autorisations FROM groupesut WHERE abrgroupe = \"$this->groupe\"";
    $result = mysqli_query($this->link, $requete);

    $ligne = mysqli_fetch_row($result);
    $this->autorisations = $ligne[0];
  }
  
  /**
  * declenche une erreur et l'enregistre dans la base de donnes (quittance ngative portant le numro de l'erreur)
  * @param int no le numro de l'erreur  dclencher
  */
  function declencheErreur($no){
    $requete = "UPDATE session SET quittance = - $no WHERE sessionid = \"$this->idsession\"";
    $result = mysqli_query($this->link, $requete);
  }
  
  /**
  * renvoie l'adresse IP de l'utilisateur
  * @return string
  */
  function getIP(){
    global $_SERVER;
	  return $_SERVER['REMOTE_ADDR'];
  }
  
  /**
  * renvoie le systme d'exploitation de l'utilisateur
  * @return string ("WIN" | "LIN" | "MAC" | "AUT")
  */
  function getOS(){
    global $_SERVER;
	  $nav = $_SERVER['HTTP_USER_AGENT'];
	  if (preg_match("/Windows/i", $nav)) return "WIN";
	  if (preg_match("/Linux/i", $nav))return "LIN";
    if (preg_match("/Macin/i", $nav)) return "MAC"; 
	  return "AUT";
  }
  
  /**
  * modifie l'adresse e-mail de l'utilisateur
  * @param string nAd nouvelle adresse e-mail
  */
  function changeEmail($nAd){
    $requete = "UPDATE utilisateurs SET emailut = \"$nAd\" WHERE nomut = \"$this->utilisateur\"";
    $result = mysqli_query($this->link, $requete);
  }

  /**
  * contrle du mot de passe fourni
  * @param string mdpfourn le mot de passe fourni
  * @return boolean le mot de passe est-il valid ?
  */
  function contrMdp($mdpfourn){


    $requete = "UPDATE session SET mdpfourn = PASSWORD(\"$mdpfourn\") WHERE sessionid = \"$this->idsession\"";
    // Requte transitoire  substituer lors d'une mise  jour vers mysql >= 4.1 (changement algorithme)
    //$requete = "UPDATE session SET mdpfourn = OLD_PASSWORD(\"$mdpfourn\") WHERE sessionid = \"$this->idsession\"";
    //
    //print "<BR> $requete";
    $result = mysqli_query($this->link, $requete);
    
    $requete = "SELECT mdpstock, mdpfourn FROM session WHERE sessionid = \"$this->idsession\"";
    $result = mysqli_query($this->link, $requete);
    $lignemdp = mysqli_fetch_row($result);
    if (($lignemdp[0] != $lignemdp[1]) OR (! $lignemdp[0])){  #mot de passe ne correspond pas ou non dfini=> quittance  9
      $requete = "UPDATE session SET quittance = 9 WHERE sessionid = \"$this->idsession\"";
      $result = mysqli_query($this->link, $requete);
      $this->n_erreur = 103;
      $this->erreur = "Echec d'autorisation";
      return 0;
    }
    else{
      // Requte  activer provisoirement lors du changement d'algorithme : Permet de stocker 
      //  les nouveaux hchages dans le champ mdpnew. Dans un second temps, ces hchages pourront tre
      //  introduits dans le champ mdput par simple requte update. On pourra alors rtablir PASSWORD
      //  l o on avait transitoirement mis OLD_PASSWORD
      $requete = "UPDATE utilisateurs SET mdpnew = PASSWORD(\"$mdpfourn\") WHERE nomut = \"$this->utilisateur\"";
      $result = mysqli_query($this->link, $requete);
      //
      return 1;
    }
  }

  /**
  * changement du mot de passe de l'utilisateur
  * @param string ch le nouveau mot de passe
  */
  function nouvMdp($ch){
    // ATTENTION phase transitoire : un remplacement  effectuer dans sessionCUT.inc, fonction enrcompte
    // Dans la phase transitoire du changement d'algorithme, remplacer partout PASSWORD par OLD_PASSWORD
    $requete = "UPDATE session SET mdpstock = PASSWORD(\"$ch\"), mdpfourn = PASSWORD(\"$ch\") WHERE sessionid = \"$this->idsession\"";
    //$requete = "UPDATE session SET mdpstock = OLD_PASSWORD(\"$ch\"), mdpfourn = OLD_PASSWORD(\"$ch\") WHERE sessionid = \"$this->idsession\"";
    $result = mysqli_query($this->link, $requete);
    $requete = "UPDATE utilisateurs SET mdput = PASSWORD(\"$ch\") WHERE nomut = \"$this->utilisateur\"";
    //$requete = "UPDATE utilisateurs SET mdput = OLD_PASSWORD(\"$ch\") WHERE nomut = \"$this->utilisateur\"";
    $result = mysqli_query($this->link, $requete);
  }


  /**
  * substitue des quivalents  certains caractres qui peuvent poser problme (guillemets)
  * @param string chaine la chane  transformer
  * @return string la chane transforme
  */
  function deguille($chaine){
    $chaine = preg_replace("/\"/","&quot;", $chaine);
    $chaine = preg_replace("/\\\'/", "'", $chaine);
    $chaine = stripslashes($chaine);
    return $chaine;
  }


  /**
  * rtablissement des guillemets pour les PDF
  * @param string chaine la chane  transformer
  * @param string la chane transforme
  */
  function raguillePDF($chaine){
    
    $chaine = preg_replace("/&quot;/", "\"", $chaine);
    $chaine = preg_replace("/\\\'/", "'", $chaine);
    return $chaine;
  }

  /**
  * exclusion des caractres non alpha-numriques des mots de passe
  * @param string chaine la chane  controler
  * @return int 0 s'il y a des caractres non alphanumriques, un nombre entier s'il n'y en a pas
  */
  function contrCaract($chaine){
    return preg_match("/^[a-z,A-Z,0-9]*$/", $chaine);
  }

  /**
  * mise en forme des numros de tlphone (en supprimant les caractres non numriques
  * @param string le numro  mettre en forme
  * @return string le numro mis en forme
  */
  function nettoieTel($tel){
    $tel = preg_replace("/[^0-9]/", " ", $tel);
    return $tel;
  }

  /**
  * fermeture de la session
  */
  function ferme(){
    $requete = "UPDATE session SET quittance = 3 WHERE sessionid = \"$this->idsession\"";
    $result = mysqli_query($this->link, $requete);
  }


  /**
  * fonction statique pour dterminer si une session est active
  * @param string sessionid
  * @return boolean la session correspondante est-elle ouverte ?
  */
  function estActive($sessionid){
    $requete = "SELECT session.quittance from session WHERE sessionid = \"$sessionid\"";
    $result = mysqli_query($this->link, $requete);
    $retour = false;
    while($ligne = mysqli_fetch_row($result)){
      if($ligne[0] == 1) $retour = true;
    }
    return $retour;	
  }	

}
?>
