<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Session pour l'annuaire Herms
* @package herms 
*/
/**
* Session pour l'annuaire Herms
* Gre l'autorisation ncessaire pour accder  l'annuaire herms et
* fournit quelques fonctions d'accs  des listes d'abonns
* @package herms
* @author ob
*/
class sessionAn extends Session {
  /**
  * nombre d'lments du rsultat d'une requte
  * @var int
  */
  var $compte;
  
  /**
  * @param string idsession l'identifiant de session
  * @param string utilisateur le nom d'utilisateur
  * @param string mdp le mot de passe
  */
  function __construct($idsession, $utilisateur, $mdp){
    parent::__construct($idsession, $utilisateur,$mdp);
  }

  /**
  * Liste d'abonns (mdecins ou non)
  * @param int crit le critre 1 pour abonns collectifs, 2 pour autres (0 pour mdecins)
  * @return array
  */
  function getItMeds($crit){
    $items = array();
    switch ($crit) {
    case 1:
      $where = "WHERE med = \"non\" AND nompers IS NULL";
      break;
    case 2:
      $where = "WHERE med = \"non\" AND nompers IS NOT NULL";
      break;
    default:
      $where = "WHERE med = \"oui\"";
      break;
    }
    $requete = ("SELECT prenom, nompers, ville, id, idsvm, nomplein FROM abonnes $where ORDER BY alpha");
    $result = mysqli_query($this->link, $requete);
    while ($lignes = mysqli_fetch_row($result)){
      for ($i = 0; $i < count($lignes); $i++){
        $lignes[$i] = $this->deguille($lignes[$i]);
      }
      $items[] = $lignes;
    }
    
    return $items;

  }
  
  /**
  * renvoi les donnes personnelles d'un abonn
  * @return array
  */
  function recupMed(){
    global $item;
    $requete = ("SELECT nompers, prenom, remarque, rue, npa, ville, tel, fax, email, ameslo, nomplein FROM abonnes WHERE id = $item");
    $result = mysqli_query($this->link, $requete);
    $lignes = mysqli_fetch_array($result);
    return $lignes;
  }
  
  /**
  * ajout ou dition d'un abonn
  * @param int crit critre (cf. fonction getItMed())
  */
  function addMed($crit){
    global $champs, $item;
    for ($i = 0; $i < 11; $i++){
      if (! isset($champs[$i])){
        $champs[$i] = "";
      }
    }
    $champs[6] = $this->nettoieTel($champs[6]);
    $champs[7] = $this->nettoieTel($champs[7]);
    $requete = ($item ? "UPDATE " : "INSERT INTO ") .
               "abonnes SET " .
               ($crit == 1 ? "nomplein = \"$champs[10]\", nompers = NULL, " : "nompers = \"$champs[0]\", prenom = \"$champs[1]\", ") .
               "remarque = \"$champs[2]\", " .
               ($crit == 1 ? "" : "nomplein = \"$champs[1] $champs[0]\", ") .
               ($crit == 1 ? "alpha = \"$champs[0]\", " : "alpha = LCASE(CONCAT(\"$champs[0]\", MID(\"$champs[1]\", 1, 1))), ") .
               "rue = \"$champs[3]\", npa = \"$champs[4]\", ville = \"$champs[5]\", tel = \"$champs[6]\", " .
               "fax = \"$champs[7]\", email = \"$champs[8]\", " .
               ($crit == 0 ? "med = \"oui\", " : "med = \"non\", ") .
               ($crit == 0 ? "ameslo = " . ($champs[9] == "oui" ? "\"oui\", " : "\"non\", ") : "") .
               (($crit == 0 AND $item) ? "idsvm = ABS(idsvm) " : "idsvm = NULL ") .
               ($item ? "WHERE id = $item" : "");
    $result = mysqli_query($this->link, $requete);
  }

  /**
  * Suppression d'un abonn
  * @param int item le numro de l'abonn  supprimer
  */
  function detrMed($item){
    $requete = "DELETE FROM abonnes WHERE id = $item";
    $result = mysqli_query($this->link, $requete);
  }

  /**
  * Liste des membres de la SVM (pour Herms dmt seulement)
  * @param array champs les champs posts dans le formulaire fournissant l'interface d'interrogation
  * @return array
  */
  function getItSVM($offset = 0, $choix = 0, $champs = 0){
    if (! isset($champs[0])) $champs[0] = 0;
    if ($choix){
      if ($champs[1] < 1000){
        $champs[1] = 1000;
      }
      $where = "WHERE membressvm.npa >= $champs[1] ORDER BY membressvm.npa";
    }
    else {
      if ($champs[0] == "*"){
        $champs[0] = "";
      }
      $where = "WHERE membressvm.nom LIKE \"$champs[0]%\" ORDER BY membressvm.nom";
    }
    $requete = ("SELECT COUNT(id) FROM membressvm $where");
    $result = mysqli_query($this->link, $requete);
    $lignes = mysqli_fetch_array($result);
    $this->compte = $lignes[0];
    $requete = "SELECT membressvm.id, membressvm.nom, membressvm.adresse, membressvm.npa, membressvm.ville, " .
               "membressvm.telpro, membressvm.fax, membressvm.email, membressvm.specialite, membressvm.prenom, " .
               "abonnes.idsvm  FROM membressvm  LEFT JOIN abonnes ON membressvm.id = ABS(abonnes.idsvm) " .
               "$where LIMIT " . ($offset*100) . ", 100";
    $result = mysqli_query($this->link, $requete);
    while ($lignes = mysqli_fetch_array($result)){
      for ($i = 0; $i < count($lignes); $i++){
        $lignes[$i] = $this->deguille($lignes[$i]);
      }
      $items[] = $lignes;
    }
    return $items;

  }
  
  /**
  * rcupration des donnes personnelles d'un membre de la SVM (d'aprs son numro)
  * @param int item le numro du mdecin
  * @return array
  */
  function getMedSVM($item){
  #Recherche d'un enregistrement SVM
    $requete = "SELECT nom, prenom, adresse, npa, ville, telpro, fax, email, id, specialite FROM membressvm WHERE id = $item";
    $result = mysqli_query($this->link, $requete);
    $lignes = mysqli_fetch_array($result);
    return $lignes;
  }

  /**
  * renvoie les spcialits  partir d'une liste de numros spars par -
  * @param strint texte les spcialits
  * @return array un lment par spcialit
  */
  function getSpec($texte){
  #Retourne un tableau contenant les textes des spcialits  partir des numros spars par un -
    if (!$texte) return;
    $tabtext = array();
    $tabnum = explode("-", $texte);
    for ($i = 0; $i < count($tabnum); $i++){
      if ($tabnum[$i] > 0){
        $requete = "SELECT libelle FROM codesfmh WHERE id = $tabnum[$i]";
        $result = mysqli_query($this->link, $requete);
        $lignes = mysqli_fetch_array($result);
        $tabtext[] = $lignes[0];
      }
    }
    return $tabtext;
  }

  /**
  * remplissage d'un enregistrement de la table "abonns" avec un enregistrement import de la SVM
  * @param array valeurs le tableau des valeurs
  */
  function remplitAbo($valeurs){
    $requete = "SELECT COUNT(abonnes.id) FROM abonnes WHERE ABS(abonnes.idsvm) = $valeurs[8]";
    $result = mysqli_query($this->link, $requete);
    $lignes = mysqli_fetch_array($result);
    if ($lignes[0]) {
      return;
    }
    $item = - $valeurs[8];
    $nom = ucwords(strtolower($valeurs[0]));
    $alpha = strtolower($valeurs[0]) . strtolower(substr($valeurs[1], 1));
    $ville = ucwords(strtolower($valeurs[4]));
    $spec = $this->getSpec($valeurs[9]);
    if (! $spec) $spec[0] = "";
    $requete = "INSERT INTO abonnes SET idsvm = $item, nompers = \"$nom\", prenom = \"$valeurs[1]\", " .
               "remarque = \"$spec[0]\", nomplein = \"$valeurs[1] $nom\", alpha = \"$alpha\", " .
               "rue = \"$valeurs[2]\", npa = \"$valeurs[3]\", ville =\"$ville\", tel = \"$valeurs[5]\", " .
               "fax = \"$valeurs[6]\", email = \"$valeurs[7]\", med = \"oui\"";
    $result = mysqli_query($this->link, $requete);

  }

  /**
  * Rsolution de certains problmes de guillemets
  * @param string chaine la chane  transformer
  * @return string la chane transforme
  */
  function deguille($chaine){
    #%$chaine = stripslashes($chaine);

   $chaine = preg_replace("/\"/","``", $chaine);
   $chaine = preg_replace("/\\\'/", "'", $chaine);
   $chaine = stripslashes($chaine);
   return $chaine;
  }
}
?>
