<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Session pour les comptes utilisateur
* @package herms
*/
/**
* Session pour les comptes utilisateur
* Gre l'autorisation ncessaire pour grer les comptes utilisateurs
* fournit quelques fonctions d'accs aux donnes correspondantes
* @package herms
* @author ob
*/
class sessionCUt extends Session {
  
  #constructeur SessionCUt(string idsession, string utilisateur, string mot_de_passe)
  /**
  * @param string l'identifiant de session
  * @param string le nom d'utilisateur
  * @param string le mot de passe utilisateur
  */
  function __construct($idsession, $utilisateur, $mdp){
    parent::__construct($idsession, $utilisateur,$mdp);
  }

  /**
  * renvoie la liste des abonns (qu'ils aient ou nom un compte utilisateur)
  * @return array
  */
  function getItAbos(){

               //         0            1              2                 3               4  
    $requete = "SELECT abonnes.id, abonnes.nomplein, abonnes.nompers, abonnes.prenom, abonnes.idut, " .
               //         5                                             6
               "IF(LENGTH(alpha)=0 , nomplein , alpha) AS beta, utilisateurs.nomut FROM abonnes " .
               "LEFT JOIN utilisateurs ON abonnes.idut = utilisateurs.id " .
               "ORDER BY beta";
    $result = mysqli_query($this->link, $requete);
    while ($lignes = mysqli_fetch_row($result)){
      for ($i = 0; $i < count($lignes); $i++){
        $lignes[$i] = $this->deguille($lignes[$i]);
      }
      $items[] = $lignes;
    }
    return $items;
  }

  /**
  * renvoie la liste des comptes utilisateurs pour lesquels il n'existe plus d'entre d'annuaire
  * @return array
  */
  function getAboSuppr(){
    $items = array();
    $requete = "SELECT utilisateurs.id, utilisateurs.nomut FROM utilisateurs " .
               "LEFT JOIN abonnes ON utilisateurs.id = abonnes.idut " .
               "WHERE abonnes.idut IS NULL AND utilisateurs.nomut NOT IN (\"hermesfax\", \"hermesposte\")";
    $result = mysqli_query($this->link, $requete);
    while ($lignes = mysqli_fetch_row($result)){
      for ($i = 0; $i < count($lignes); $i++){
        $lignes[$i] = $this->deguille($lignes[$i]);
      }
      $items[] = $lignes;
    }
    return $items;
  }

  /**
  * renvoie paramtres d'un compte utilisateurs
  * @return array
  */
  function recupCompte(){
    global $item;
                        //   0              1            2             3               4
    $requete = "SELECT abonnes.id, abonnes.nomplein, abonnes.ville, abonnes.med, abonnes.ameslo, " .
                     // 5          6                 7                     8                   9                 10
               "abonnes.idut, abonnes.ameslo, utilisateurs.groupe, utilisateurs.nomut, utilisateurs.fax, utilisateurs.emailut " .
               "FROM abonnes LEFT JOIN utilisateurs " .
               "ON abonnes.idut = utilisateurs.id WHERE abonnes.id = $item";
    $result = mysqli_query($this->link, $requete);
    $lignes = mysqli_fetch_row($result);
    return $lignes;
  }

  /**
  * renvoie un tableau des groupes d'utilisateurs existants
  * @return array
  */
  function recupGroupe(){
    $requete = "SELECT abrgroupe, nomgroupe, autorisations, id FROM groupesut ORDER BY nomgroupe";
    $result = mysqli_query($this->link, $requete);
    while ($lignes = mysqli_fetch_row($result)){
      $groupes[] = $lignes;
    }
    return $groupes;
  }

  /**
  * renvoie un tableau des autorisations existantes
  * @return array
  */
  function recupAut(){
    $requete = "SELECT aut, comm FROM autorisations ORDER BY aut";
    $result = mysqli_query($this->link, $requete);
    while ($lignes = mysqli_fetch_row($result)){
      $auts[] = $lignes;
    }
    return $auts;
  }
  
  /**
  * enregistrement des donnes d'un compte (cration ou modification)
  * @return boolean l'enregistrement s'est-il fait ?
  */
  function enrCompte() {
    global $item, $champs;
    if (! $champs[5]){ //Cration nouveau compte utilisateur
      $prov = substr(md5(time() . $this->idsession), 0, 19);
      $requete = "INSERT INTO utilisateurs SET nomut = \"$prov\""; //Rservation d'un numro de compte
      $result = mysqli_query($this->link, $requete);
      if (! $result) return false;
      $requete = "SELECT id, fax, emailut, pref FROM utilisateurs WHERE nomut = \"$prov\""; //Obtention du numro
      $result = mysqli_query($this->link, $requete);
      $utilisateur = mysqli_fetch_row($result);
      $idut = $utilisateur[0];
      if (! $idut) return false;
      $requete = "UPDATE abonnes SET idut = $idut WHERE id = $item"; //criture du champ idut dans abonns
      $result = mysqli_query($this->link, $requete);
      if (! $result) return false;
      $requete = "SELECT id, fax, email FROM abonnes WHERE id = $item"; //lecture fax et e-mail
      $result = mysqli_query($this->link, $requete);
      $abonne = mysqli_fetch_row($result);
      if (! $result) return false;
      $requete = "UPDATE utilisateurs SET fax = " . ($abonne[1] ? "\"$abonne[1]\", " : "NULL, pref = \"poste\", ") .
                 "emailut = " . ($abonne[2] ? "\"$abonne[2]\" " :  "NULL ") . "WHERE id = $idut";
      $result = mysqli_query($this->link, $requete);
      if (! $result) return false;
    }
    else {
      $idut = $champs[5];
    }
    // enregistrement des donnes entres dans utilisateurs
    // EN PHASE DE TRANSITION, REMPLACER PASSWORD PAR OLD_PASSWORD cf session.inc <---------------------------
    $requete = "UPDATE utilisateurs SET nomut = \"$champs[8]\", groupe = \"$champs[7]\" ".
               ($champs[2] ? ", mdput = PASSWORD(\"$champs[2]\") " : "") .
               ", fax = \"$champs[9]\", emailut = \"$champs[10]\" " .
               "WHERE id = $idut";
    $result = mysqli_query($this->link, $requete);
    if(mysqli_errno($this->link) == 1062){
      print "<SCRIPT LANGUAGE=\"JavaScript\">alert('" . $champs[8] .
            " : ce nom d\'utilisateur existe dj');</SCRIPT>";
      $requete = "UPDATE utilisateurs set nomut = NULL where id = $idut";
      mysqli_query($this->link, $requete);
    }
    if (! $result) return false;
    return true;
  }

  /**
  * suppression d'un compte utilisateurs
  * @param int le numro du compte  supprimer
  * @return boolean la suppression s'est-elle effectue ?
  */
  function detrCompte($item){
    global $orph;
    $ex = new extrVar();
    $ex->extrait("orph");
    if ($orph == 1){  //Il s'agit d'un utilisateur dont le compte abonn a t supprim
      $requete = "DELETE FROM utilisateurs WHERE id = $item";
      $result = mysqli_query($this->link, $requete);
      if (! $result) return false;
      return true;
    }
    else {
      $requete = "SELECT idut FROM abonnes WHERE id = $item";
      $result = mysqli_query($this->link, $requete);
      $lignes = mysqli_fetch_row($result);
      $idut = $lignes[0];
      if (! $idut) return false;
      $requete = "UPDATE abonnes SET idut = NULL WHERE id = $item";
      $result = mysqli_query($this->link, $requete);
      if (!$result) return false;
      $requete = "DELETE FROM utilisateurs WHERE id = $idut";
      $result = mysqli_query($this->link, $requete);
      if (! $result) return false;
      return true;
    }
  }
  
  /**
  * ajout d'une nouvelle autorisation
  * le nom de l'autorisation est fourni par une variable globale
  * @return boolean l'ajout s'est-il fait correctement
  */
  function addAut(){
    global $champs;
    $champs[0] = preg_replace("/[^A-Za-z0-9\_\-]/", "", $champs[0]);
    if (strlen($champs[0]) == 0 ){
      return false;
    }
    $requete = "INSERT INTO autorisations SET aut = \"$champs[0]\", comm = \"$champs[1]\"";
    $result = mysqli_query($this->link, $requete);
    if ($result) {
      $this->majGroupes();
    }
    return $result;
  }

  /**
  * destruction d'une autorisation existante
  * l'identifiant de l'autorisation est fourni par une variable globale
  */
  function detrAut(){
    global $item;
    $requete = "DELETE FROM autorisations WHERE aut = \"$item\"";
    $result = mysqli_query($this->link, $requete);
    $this->majGroupes();
  }
  
  /**
  * mise  jour de la dfinition de champs "autorisations" de la table groupesut en fonction
  * des autorisations existantes
  */
  function majGroupes(){
    $requete = "SELECT aut FROM autorisations";
    $result = mysqli_query($this->link, $requete);
    $defin = "";
    while ($lignes = mysqli_fetch_row($result)){
      $defin .= "'$lignes[0]',";
    }
    $defin = substr($defin, 0, -1);
    $requete = "ALTER TABLE groupesut CHANGE autorisations autorisations SET($defin)";
    $result = mysqli_query($this->link, $requete);
  }
  
  /**
  * renvoie les paramtres d'un compte donn
  * @param int l'identifiant du groupe
  * @return array
  */
  function recupMGroupe($item){
    $requete = "SELECT abrgroupe, nomgroupe FROM groupesut WHERE id = $item";
    $result = mysqli_query($this->link, $requete);
    $lignes = mysqli_fetch_row($result);
    return $lignes;
  }
  
  /**
  * renvoie les autorisations dont dispose un groupe
  * @param int l'identifiant du groupe
  * @return array
  */
  function recupMOpt($item){
    $requete = "SELECT autorisations FROM groupesut WHERE id = $item";
    $result = mysqli_query($this->link, $requete);
    $lignes = mysqli_fetch_row($result);
    $opts = explode(",", $lignes[0]);
    return $opts;
  }

  /**
  * cration - dition d'un groupe
  * les paramtres sont fournis par des variables globales
  * @return boolean la mise  jour s'est-elle effectue ?
  */
  function addGroupe(){
    global $champs, $opts, $item;
    $autorisations = ($opts ? "'" . implode(",", $opts) . "'" : "");
    $requete = ($item ? "UPDATE " : "INSERT INTO ") .
               "groupesut SET abrgroupe = \"$champs[0]\", nomgroupe = \"$champs[1]\", " .
               "autorisations = $autorisations" .
               ($item ? " WHERE id = $item" : "");
    $result = mysqli_query($this->link, $requete);
    return $result;
  }
  
  /**
  * destruction d'un groupe
  * @param int l'identifiant du groupe
  */
  function detrGroupe($item){
    $requete = "DELETE FROM groupesut WHERE id = $item";
    $result = mysqli_query($this->link, $requete);
  }
  
  /**
  * renvoie le groupe auquel appartient un utilisateur
  * @param int l'identifiant de l'utilisateur
  * @return string le groupe en question
  */
  function groupeUt($ut) {
  	
  	if ($ut == '') return '-';
  	
  	$requete = "SELECT groupe FROM utilisateurs WHERE id = $ut";
  	$result = mysqli_query($this->link, $requete);
  	$ret = mysqli_fetch_assoc($result);
  	return $ret['groupe'];
  }
  
}

?>
