<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Session pour l'application BriocheWeb
* @package donnes
*/
/**
* Session pour l'application BriocheWeb
* Gre le contrle des autorisations et tous les accs  la base d'administration
* pour l'application BriocheWeb
* @package donnes
* @author ob
*/
class sessionDBrioche extends Session {
  /**
  * le tableau des autorisations spcifiques ncessaires pour accder  la ressource demande
  * @var array
  */
  var $autspec;

  /**
  * @param string l'identifiant de session
  * @param array autspec cf. variable de classe
  */
  function __construct($idsession, $autspec=0){
    parent::__construct($idsession);
    $ini = new briocheIni();
    $aut = $ini->autReq;
    $this->autspec = $autspec;
    if (!$this->verifSess($aut)){
      $cpt = count($autspec);
      if ($cpt && $this->n_erreur == 1001){
        $retour = false;
        for ($i = 0; $i < $cpt; $i++){
          $this->n_erreur = 0;
          if($this->verifSess($autspec[$i])) {
            $retour = true;
            break;
          }
          else {
            $this->n_erreur = 1001;
          }
        }
        return $retour;
      }
    }
    else {
      return true;
    }
  }  

  /**
  * vrification d'une autorisation. L'utilisateur en dispose-t-il ?
  * @param string l'autorisation  vrifier
  * @param array le tableau des autorisations dont didpose l'utilisateur
  * @return boolean
  */
  function verifAut($aut, $tab){
    //$aut est l'autorisation  vrifier et $tab la liste des autorisations de l'utilisateur
    if ($this->n_erreur) return false;
    $tabaut = explode(",", $tab);
    return in_array($aut, $tabaut);
  }

  /**
  * vrification de la session en fournissant une autorisation
  * @param string l'autorisation  vrifier
  * @return boolean la session est-elle OK ?
  */
  function verifSess($aut){
    if($this->n_erreur){
      return 0;
    }
    if(! $aut){
      $this->n_erreur = 1001;
      return 0;
    }
    if ($this->verifAut($aut, $this->autorisations)){
      return 1;
    }
   
    $this->n_erreur = 1001;
    return 0;
  }

  /**
  * renvoie le tableau des utilisateur ayant l'autorisation de base pour crire dans le dossier (autReq)
  * fonction statique
  * @return array
  */
  function listUtBri(){
    $ini = new briocheIni();
    $aut = $ini->autReq;
    
    $requete = "SELECT utilisateurs.id, utilisateurs.nomut, abonnes.nomplein FROM utilisateurs " .
               "LEFT JOIN abonnes ON utilisateurs.id = abonnes.idut " .
               "LEFT JOIN groupesut ON utilisateurs.groupe = groupesut.abrgroupe WHERE " .
               "FIND_IN_SET(\"$aut\", groupesut.autorisations)";
    $result = mysql_query($requete, $this->link);
    $tbl = array();
    while($ligne = mysql_fetch_array($result)){
      $tbl[] = $ligne; 	
    }
    return $tbl;	           	
  }	
  
  /**
  * fonction statique renvoyant le tableau des autorisation d'un utilisateur quelconque
  * @param int l'identifiant de l'autorisateur en question
  * @return array
  */
  function getAutorisations($id){
    $requete = "SELECT groupesut.autorisations FROM groupesut " .
               "LEFT JOIN utilisateurs ON groupesut.abrgroupe = utilisateurs.groupe " .
               "WHERE utilisateurs.id = $id";
    //print $requete;
    $result = mysql_query($requete, $this->link);
    $ligne = mysql_fetch_row($result);
    $tab = explode(",", $ligne[0]);
    return $tab;
  }
  
  
  /**
  * renvoie la liste des utilisateurs bnficiant de l'autorisation spcifique EMS ou service placeur
  * (autSpec[0], autSpec[1]) fonction statique
  * @return array
  */
  function listeEMS(){
    $ini = new briocheIni();
    $aut = $ini->autSpec[0];
    $aut2 = $ini->autSpec[1];
    $requete = "SELECT utilisateurs.id, utilisateurs.nomut, abonnes.nomplein, " .
               "utilisateurs.groupe FROM utilisateurs " .
               "LEFT JOIN abonnes ON utilisateurs.id = abonnes.idut " .
               "LEFT JOIN groupesut ON utilisateurs.groupe = groupesut.abrgroupe WHERE " .
               "FIND_IN_SET(\"$aut\", groupesut.autorisations) OR " .
               "FIND_IN_SET(\"$aut2\", groupesut.autorisations)";
    $result = mysql_query($requete, $this->link);
    $tabUt = array();
    while($ligne = mysql_fetch_row($result)){
      $tabUt[] = $ligne;
    }           
    return $tabUt;           
    
  }  
  
  /**
  * renvoie la liste des utilisateurs bnficiant de l'autorisation "Courts sjours pour EMS"
  * (autSpec[2]) fonction statique
  * @return array
  */
  function listeEMSCS(){
    $ini = new briocheIni();
    //$gems = $ini->groupeEMSCS;
    $aut = $ini->autSpec[2];
    $requete = "SELECT utilisateurs.id, abonnes.nomplein FROM utilisateurs " .
               "LEFT JOIN abonnes ON utilisateurs.id = abonnes.idut " .
               "LEFT JOIN groupesut ON utilisateurs.groupe  = groupesut.abrgroupe WHERE " .
               "FIND_IN_SET(\"$aut\", groupesut.autorisations)";
    $result = mysql_query($requete, $this->link);
    $tabUt = array();
    while($ligne = mysql_fetch_row($result)){
      $tabUt[] = $ligne;
    }
    return $tabUt;
  }

}

?>
