<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Statistiques pour les courts sjours plannin
* @package formulaires
*/
/**
* Statistique pour les courts sjours planning
* Affichage des statistiques par tablissement pour les courts sjours planning
* Correspond aux renseignements demands par le SASH pour le financement complmentaire
* @package formulaires
* @author ob
*/
class statCourSej extends cadronglet{

  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param int actif l'action principale
  * @param string fondpage la couleur du fond de page
  * @param string sessionid l'identifiant de session
  * @param int action_affichage l'action pour afficher les stats
  * @param mixed options pas utilis pour l'instant
  * @param array donnees le tableau de variables postes par le formulaire
  */
  function statCourSej($largeur, $grise, $actif, $fondpage, $sessionid,
                       $action_affichage, $options, $donnees){
    global $fichier;
    
    $ini = new briocheIni();
    $autspec[0] = $ini->autSpec[2];
    
    if (! $this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid, $autspec)) return;
    
    if (! isset($donnees['noet'])) $donnees['noet'] = "";
    if (! isset($donnees['deb']) || ! $donnees['deb']) $donnees['deb'] = $this->nouvelan();
    if (! isset($donnees['fin']) || ! $donnees['fin']) $donnees['fin'] = $this->aujourdhui();
    $etabl_liste = new ensTableBrioche("etablissements", "courplan = -1", "noet, nomet",
                                       "groupepriorite", $this->idsession, "", "", false, $this->autspec);
    if ($this->verifAut($ini->autReq, $this->autorisations)){
      // liste droulante avec le nom des EMS et autres BRIO
      
      $labellise = false;    
        
      
    }
    else { // Pour EMS : un seul EMS
      $eu = new enrUtilisateur($this->idsession, $this->autspec);
      $ett = $eu->getEtablAttribue("emscs");
      //print_r($ett);
      $donnees['noet'] = $ett->noet;
      $labellise = true;
    }
      
    
    
    $deb = $this->getDateAm($donnees['deb'], true);
    $fin = $this->getDateAm($donnees['fin'], true);    
    $join[] = "dossiers";
    $on[] = "calendrier.nodoss = dossiers.nodoss";
    $join[] = "usagers";
    $on[] = "dossiers.nous = usagers.nous";
    $join[] = "demandeor";
    $on[] = "calendrier.nodoss = demandeor.nodoss";
    $join[] = "etablissements";
    $on[] = "demandeor.servplac = etablissements.noet"; 
    $join[] = "etablissements AS etablissements2";
    $on[] = "calendrier.etablissement = etablissements2.noet";
    $join[] = "issue";
    $on[] = "calendrier.nodoss = issue.nodoss";
    $join[] = "issueoptions";
    $on[] = "issue.issue2 = issueoptions.idissue";
    $join[] = "provenance";
    $on[] = "demandeor.provenance = provenance.idprovenance";
    
    $champs = "etablissements2.nomet as ems, dossiers.nodoss as doss_num, " .
              "CONCAT(usagers.nom, \" \", usagers.prenom) as nomplein, " .
              "CONCAT(usagers.nom, usagers.prenom, usagers.datenaiss, usagers.sexe, dossiers.nodoss) as _nomunique, " .
              "usagers.datenaiss, usagers.sexe, usagers.npa," .
              "etablissements.nomet as serv_placeur, " .
              "provenance.provenance_text, issue_text, MIN(calendrier.datedecision) as datedecision, " .
              "MIN(calendrier.debut) as debut, MAX(calendrier.fin) as fin, calendrier.noev as _noev, " . 
              "SUM((if(calendrier.fin > $fin, TO_DAYS($fin), TO_DAYS(calendrier.fin)) - " .
              "if(calendrier.debut < $deb, TO_DAYS($deb), TO_DAYS(debut)) + " .
              "(if(csprec is not null and debut >= $deb, 0, 1)))) as duree_effective, " .
              "SUM((if(calendrier.fin > $fin, TO_DAYS($fin) ,TO_DAYS(calendrier.fin)) - " .
              "if(calendrier.debut < $deb, TO_DAYS($deb), TO_DAYS(debut)) + " .
              "(if(csprec is not null and debut >= $deb, 0, if(issue.issue2 in (2,3,6,9,10),0,1))))) as duree_hors_jour_transfertc ";
              
    $where = ($donnees['noet'] == -1 ? "" : "calendrier.etablissement = " . $donnees['noet'] . " AND ") .
             "calendrier.actif = 1 AND calendrier.horsStats = 0 " .
             "AND calendrier.nodoss > 0 AND calendrier.fin >= $deb " .
             "AND calendrier.debut <= $fin";
             
    if ($donnees['noet'] == -1) $comp = "";
    else $comp = "etablissement = " . $donnees['noet'] . " AND "; 
    $cptHorsStats = new ensTableBrioche("calendrier","$comp horsStats = 1 AND debut <= $fin AND fin >= $deb",
                                        "SUM((if(fin > $fin, TO_DAYS($fin), TO_DAYS(fin)) - " .
                                        "if(debut < $deb, TO_DAYS($deb), TO_DAYS(debut)) + " .
                                        "(if(csprec is not null and debut >= $deb, 0, 1)))) as duree",
                                        0,$this->idsession);
    $cptHorsStats = $cptHorsStats->getTableau();
    $cptHorsStats = $cptHorsStats[0]->duree;
    if ($cptHorsStats == '') $cptHorsStats = 0;
    
    $tabliste = new EnsTableBrioche("calendrier", 
                                    $where,
                                    $champs, "ems, usagers.nom, usagers.prenom, debut",
                                    $this->idsession, $join, $on, false, $this->autspec, "_nomunique");
    $totaljournees = $tabliste->sommeTab("duree_effective");
    $periode = ($fin - $deb) + 1;
    $tstfin = strtotime($this->getDateAm($donnees['fin'], false));
    $tstdebut = strtotime($this->getDateAm($donnees['deb'], false));
    $duree = round(($tstfin - $tstdebut)/SEC_PAR_JOUR) + 1;
    
    //Nombre de lits concerns (pour calcul taux d'occupation)
    $where = ($donnees['noet'] == -1 ? "horsStats = 0" : "horsStats = 0 AND etabl = " . $donnees['noet']);
    $where .= " AND (ISNULL(debut) OR debut < " . $fin . ") AND (ISNULL(fin) OR fin > " . $deb . ")";
    $elits = new ensTableBrioche("litscourtsejour", $where, "UNIX_TIMESTAMP(fin) as unix_fin, UNIX_TIMESTAMP(debut)as unix_debut", 
                                 0, $this->idsession, "", "", false, $this->autspec);
    $telits = $elits->getTableau();
    $nblits = 0;
    foreach ($telits as $lits) {
      if ($lits->unix_fin == '' || $lits->unix_fin > $tstfin) $lits->unix_fin = $tstfin;
      if ($lits->unix_debut == '' || $lits->unix_debut < $tstdebut) $lits->unix_debut = $tstdebut;
      $nblits += round(($lits->unix_fin - $lits->unix_debut)/SEC_PAR_JOUR) + 1;
    }
    $nblits = $nblits - $cptHorsStats;
    $nblits = number_format($nblits / $duree, 2);
    
    if (($action_affichage - floor($action_affichage)) > 0) { // Feuille de calcul
      $this->effaceEntete();
      $excel = new FeuilleExcel($tabliste, "stats_courts_sejours.xls");
      $excel->affiche(true);
    }
    else {
      $tabbande = array("Courts sjours planning : Liste nominative des sjours et journes ralises", "", "", "", "");
      $this->addOnglet("Rcapitulatif", $tabbande, "#8b8378", $this->actif, 80, "");
      $this->colmateOnglets();

      //Contenu
      $of = new OngForm();
      $of->setTabParam($this->largeur, $this->coulbande, 6);
      $of->setFormParam("donnees", $fichier, "post");
      $c = new TPanel(3, 1);
      $x = new Label("Etablissement : ");
      $c->addChamp($x);
      $x = new listOptTable("donnees[noet]", $donnees['noet'], $etabl_liste, $multiple=false, $size=0, 
                            $class="d2", $onchange="javascript:document.forms.donnees.action.value=" .
                            $action_affichage .
                            ";document.forms.donnees.submit();", $labellise);
      $x->addDefaut("&lt;TOUS&gt;", "-1");
      $x->addOptions("nomet", "noet");
      $c->addChamp($x);
      $of->addChamp($c);   
         
      $c = new TPanel(3, 1, "RIGHT", "MIDDLE");
      $x = new Bouton("action", $action_affichage, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("options", $options, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("Obtenir", "Obtenir feuille de calcul", "BUTTON",
		      "document.forms.donnees.action.value=" . $action_affichage .
          ".1;document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));                
      $x = new Bouton("Retour", "Retour", "BUTTON",
                      "document.forms.donnees.action.value=".$this->actif.";document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      
      // Dates
      $c = new TPanel(5, 1);
      $x = new ChampTexte("donnees[deb]", $donnees['deb'], "Priode du : ", 12, 12, false, "TEXT",  "d2",
                          "controleDate('donnees[deb]', '', '', '', 'donnees[deb]', 'donnees[fin]')", "", false, true);
      $c->addChamp($x);
      $c->addChamp(new Espace(4));
      $x = new ChampTexte("donnees[fin]", $donnees['fin'], "au : ", 12, 12, false, "TEXT",  "d2",
                        "controleDate('donnees[fin]', '', '', '', 'donnees[deb]', 'donnees[fin]')", "", false, true);
      $c->addChamp($x);
      $c->addChamp(new Espace(10));
      $x = new Bouton("OK", "OK", "SUBMIT", "document.forms.donnees.action.value=" . 
                      floor($action_affichage) . ";document.forms.donnees.submit();");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      //$commentaire = ($options ? "textnotes" : "");
      $c = new TPanel(6, 1);
      $x = new Label("Occupation des lits (pour la priode concerne) : <B>" .
                     $totaljournees . " journes / $nblits lits</B>." .
                     " Taux d'occupation&nbsp;: " .
                     round(($totaljournees * 100)/($duree * ($nblits[0] ? $nblits : 1)), 2) . "%"); 
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanelTableau(6, 1, $tabliste, $this->grise, "sejour", "_noev", "ems");
      
      $opt = new optionsBrioche($options);
      $opt->setOption("FORCE_DOSS", 1);
      $x = new Lien("", false, false, false, "doss_num", "javascript:ouvreBrioche('brioche.php?action=1" .
                    "&sessionid=$this->idsession&item=&options=" . $opt->getChaine() . "');");
      $c->addColChamp("Dossier", $x, false, true);
      
      $x = new Label("", false, false, false, "nomplein");
      $c->addColChamp("Nom", $x);
      $x = new Label("", false, false, false, "datenaiss");
      $c->addColChamp("Date de naissance", $x);
      $x = new Label("", false, false, false, "sexe");
      $c->addColChamp("Sexe", $x);
      $x = new Label("", false, false, false, "npa");
      $c->addColChamp("N post.", $x);
      $x = new Label("", false, false, false, "serv_placeur");
      $c->addColChamp("Serv. placeur", $x);
      $x = new Label("", false, false, false, "provenance_text");
      $c->addColChamp("Provenance", $x);
      $x = new Label("", false, false, false, "issue_text");
      $c->addColChamp("Issue", $x);
      $x = new Label("", false, false, false, "debut");
      $c->addColChamp("Dbut", $x);
      $x = new Label("", false, false, false, "datedecision");
      $c->addColChamp("Date dcision", $x);
      $x = new Label("", false, false, false, "fin");
      $c->addColChamp("Fin", $x);
//      $x = new Label("", false, false, false, "chlit");
//      $c->addColChamp("Ch(Lit)", $x);
      $x = new Label("", false, false, false, "duree_effective");
      $c->addColChamp("Dure effective*", $x);
      $x = new Label("", false, false, false, "duree_hors_jour_transfertc");
      $c->addColChamp("Dure hors jour transfert**", $x);
      $c->addTitres(true);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      $c = new TPanel(6, 1);
      $x = new Label("*La dure est calcule en nombre de journes, soit en comptabilisant la date " .
                     "d'entre <b>et</b> la date de " . 
                     "sortie. Les journes qui dbordent de la priode dtermine pour la " .
                     "statistique ne sont pas prises en compte. Lors d'un changement de chambre ".
                     "ou de lit en cours de sjour, le jour du changement n'est pas compt  double. ".
                     "Le nombre de lits peut tre  virgule si un lit n'est disponible que sur " .
                     "une partie de la priode choisie.");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(6, 1);
      $x = new Label("**Un jour est retir pour les sjours ayant t suivis par un transfert, " .
                     "i.e. ceux dont l'issue est \"Hpital A\", \"Hpital B\", \"Placement long sjour\", " .
                     "\"Sjour d'observation\" ou \"Court sjour\".");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $this->addContenu($of->getContenu());
    }
  
  }
}
?>