<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Statistiques pour les courts sjours plannin
* @package formulaires
*/
/**
* Statistique pour les courts sjours planning
* Affichage des statistiques par tablissement pour les courts sjours planning
* Correspond aux renseignements demands par le SASH pour le financement complmentaire
* @package formulaires
* @author jdu, ob
*/

class statCourSejIndic extends cadronglet {

  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param int actif l'action principale
  * @param string fondpage la couleur du fond de page
  * @param string sessionid l'identifiant de session
  * @param int action_affichage l'action pour afficher les stats
  * @param mixed options pas utilis pour l'instant
  * @param array donnees le tableau de variables postes par le formulaire
  */
  function statCourSejIndic($largeur, $grise, $actif, $fondpage, $sessionid,
                       $action_affichage, $options, $donnees) {
                                 
    global $fichier;
    $this->Session($sessionid);
       
    $aujourdhui = getdate();
    
    $ini = new briocheIni();
    $autspec[0] = $ini->autSpec[2];
    
    if (! $this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid, $autspec)) return;
    
    if (! isset($donnees['noet'])) $donnees['noet'][0] = -1;
    if (! isset($donnees['moisdeb']) || ! $donnees['moisdeb']) $donnees['moisdeb'] = 1;
    if (! isset($donnees['moisfin']) || ! $donnees['moisfin']) $donnees['moisfin'] = 12;
    if (! isset($donnees['anneedeb']) || ! $donnees['anneedeb']) $donnees['anneedeb'] = $aujourdhui['year'];
    if (! isset($donnees['anneefin']) || ! $donnees['anneefin']) $donnees['anneefin'] = $aujourdhui['year'];
    $etabl_liste = new ensTableBrioche("etablissements", "courplan = -1", "noet, nomet",
                                       "groupepriorite", $this->idsession, "", "", false, $this->autspec);
    if ($this->verifAut($ini->autReq, $this->autorisations)){
      // liste droulante avec le nom des EMS et autres BRIO
      $labellise = false;    
    }
    else { // Pour EMS : un seul EMS
      $eu = new enrUtilisateur($this->idsession, $this->autspec);
      $ett = $eu->getEtablAttribue("emscs");
      //print_r($ett);
      $donnees['noet'][0] = $ett->noet;
      $labellise = true;
    } 
    
    //Contenu
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fichier, "post");

       
    if (($action_affichage - floor($action_affichage)) > 0) { // Feuille de calcul
      
      header('Content-disposition: inline; filename=csp_export_excel.xls');
      header('Content-type: application/vnd.ms-excel');
      
    } else {

      $tabbande = array("Statistiques des courts sjours planning - Donnes extraites le " . date("d.m.Y") . " par $this->nomplein", "", "", "", "");
      $this->addOnglet("Indicateurs", $tabbande, "#8b8378", $this->actif, 80, "");
      $this->colmateOnglets();

      $c = new TPanel(2, 2);
      $x = new Label("Etablissement : ");
      $c->addChamp($x);
      $x = new listOptTable("donnees[noet][]", $donnees['noet'], $etabl_liste, $multiple=true, $size=0, 
                              $class="d2", "", $labellise);
      $x->addDefaut("&lt;TOUS&gt;", "-1");
      $x->addOptions("nomet", "noet");
      $c->addChamp($x);
      $of->addChamp($c);
      
      $c = new TPanel(4, 1, "RIGHT", "TOP");
      $x = new Bouton("action", $action_affichage, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("options", $options, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("Obtenir", "Obtenir feuille de calcul", "BUTTON",
  	                "document.forms.donnees.action.value=" . $action_affichage .
                      ".1;document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));                
      $x = new Bouton("Retour", "Retour", "SUBMIT", "document.forms.donnees.action.value=".$this->actif.";document.forms.donnees.submit();");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $of->addChamp($c);
      $of->addLigne();
      
      $c = new TPanel(4, 1);
      $x = new Label("Priode du :&nbsp;", true);
      $c->addChamp($x);
      $x = new ListOpt("donnees[moisdeb]", $donnees['moisdeb'], false, 0, "d2");
      $x2 = new ListOpt("donnees[moisfin]", $donnees['moisfin'], false, 0, "d2");
      for ($i = 1; $i < 13; $i++){
        $x->addOption(CJour::texteMois($i), $i);
        $x2->addOption(CJour::texteMois($i), $i);
      }
      $c->addChamp($x);
      $x = new ListOpt("donnees[anneedeb]", $donnees['anneedeb'], false, 0, "d2");
      $x3 = new ListOpt("donnees[anneefin]", $donnees['anneefin'], false, 0, "d2");
      for ($i = -5; $i <= 6; $i++){
        $x->addOption($aujourdhui['year'] + $i,  $aujourdhui['year'] + $i);
        $x3->addOption($aujourdhui['year'] + $i,  $aujourdhui['year'] + $i);
      }
      $c->addChamp(new Espace(2));
      $c->addChamp($x);
      $x = new Label("&nbsp;&nbsp;&nbsp;au :&nbsp;", true);
      $c->addChamp($x);
      $c->addChamp($x2);
      $c->addChamp(new Espace(2));
      $c->addChamp($x3);
      $c->addChamp(new Espace(10));
      $x = new Bouton("OK", "OK", "BUTTON", "document.forms.donnees.action.value=" . 
                      floor($action_affichage) . ";document.forms.donnees.submit();");
      $c->addChamp($x);
      $of->addChamp($c);
      
      $of->addLigne();
      $of->addLigne();
      
    }
    
    $dateDebPeriode = $donnees['anneedeb'] . ($donnees['moisdeb'] < 10 ? "0" : "") . $donnees['moisdeb'] . "01";
    $dateFinPeriode = $donnees['anneefin'] . ($donnees['moisfin'] < 10 ? "0" : "") . $donnees['moisfin'] .
    cal_days_in_month(CAL_GREGORIAN,$donnees['moisfin'],$donnees['anneefin']);
    
    // Construction d'un tableau listant les mois de la priode
    $tstmpDebPeriode = strtotime($dateDebPeriode);
    $tstmpFinPeriode = strtotime($dateFinPeriode);
    $monthArray = array();
    $tstmpEvol = $tstmpDebPeriode;
    while ($tstmpEvol < $tstmpFinPeriode) {
        $date = getdate($tstmpEvol);
    	$monthArray[] = array('mois' => $date['mon'], 'annee' => $date['year']);
    	$date['mon'] += 1;
    	$tstmpEvol = mktime(0,0,0,$date['mon'],1,$date['year']);
    }
        
    // Dossiers concerns par la priode
    $nodossiers = new ensTableBrioche("calendrier","calendrier.actif = 1 AND calendrier.nodoss != -999 AND calendrier.horsStats = 0 AND " .
                                      ($donnees['noet'][0] != -1 ? "etablissement IN (" . implode(",",$donnees['noet']) . ") AND" : "") . " (
                                      (calendrier.debut <= $dateFinPeriode AND calendrier.fin >= $dateDebPeriode))",
                                      "nodoss",0,$sessionid,0,0,true);
    $nodossiers = $nodossiers->getTableau();
    $nodossArray = array();
    foreach ($nodossiers as $nodossier) $nodossArray[] = $nodossier->nodoss;
    
    // Nombre de journes ralises
	$join[] = "dossiers";
    $on[] = "calendrier.nodoss = dossiers.nodoss";
    $join[] = "usagers";
    $on[] = "dossiers.nous = usagers.nous";
    $join[] = "issue";
    $on[] = "dossiers.nodoss = issue.nodoss";
    $join[] = "issueoptions";
    $on[] = "issueoptions.idissue = issue.issue2";
    $join[] = "demandeor";
    $on[] = "dossiers.nodoss = demandeor.nodoss";
    $join[] = "provenance";
    $on[] = "provenance.idprovenance = demandeor.provenance";
    
    $jocc = new ensTableBrioche("calendrier",
                                "calendrier.actif = 1 AND calendrier.nodoss != -999 AND calendrier.horsStats = 0 AND " . 
                                "calendrier.nodoss IN (". implode(",",$nodossArray) .")",
                                "usagers.datenaiss as datenaiss, usagers.sexe as sexe, calendrier.urgent, ".
                                "calendrier.debut, calendrier.fin, calendrier.etablissement, calendrier.chambre, calendrier.lit, 
                                UNIX_TIMESTAMP(calendrier.debut) as unix_debut, UNIX_TIMESTAMP(calendrier.fin) as unix_fin, ".
                                "calendrier.csprec, calendrier.noev, issue_text, issue2, provenance_text",
                                "etablissement,calendrier.chambre,calendrier.lit,calendrier.debut",$sessionid,
                                $join, $on, false, $this->autspec);
                                
    $tjocc = $jocc->getTableau();

    // Nombre de journes possible et nombre de lits disponibles
    $ldisp = new ensTableBrioche("litscourtsejour","horsStats = 0 AND (ISNULL(debut) OR debut < " . $dateFinPeriode . ") AND ".
                                 "(ISNULL(fin) OR fin > " . $dateDebPeriode . ")" .
                                 ($donnees['noet'][0] != -1 ? " AND etabl IN (" . implode(",",$donnees['noet']) . ")" : ""),
                                 "debut, fin, UNIX_TIMESTAMP(debut) as unix_debut, UNIX_TIMESTAMP(fin) as unix_fin",
                                 "etabl,chambre,lit",$sessionid);
    $tldisp = $ldisp->getTableau();
            
    // Fusion des courts sjours avec changement de lit
    $sejours = array();
    foreach ($tjocc as $sejour) {
      $sejours[$sejour->noev] = $sejour; 
    }
    
    $sejourArray = array();
    $cpt = 0;
    
    foreach ($sejours as $sejour) {
      if ($this->verifDernier($sejour->noev,$sessionid)) {
        $sejourArray[$cpt]['fin'] = $sejour->unix_fin;
        $sejourArray[$cpt]['urgent'] = $sejour->urgent;
        $sejourArray[$cpt]['sexe'] = $sejour->sexe;
        $sejourArray[$cpt]['datenaiss'] = $sejour->datenaiss;
        $sejourArray[$cpt]['issue'] = $sejour->issue_text;
        $sejourArray[$cpt]['issue_val'] = $sejour->issue2;
        $sejourArray[$cpt]['provenance'] = $sejour->provenance_text;
        $csprec = $sejour->csprec;
        if ($csprec == '') {
          $sejourArray[$cpt]['debut'] = $sejour->unix_debut;
        } else {
          while (true) {
            if ($sejours[$csprec]->csprec != '') $csprec = $sejours[$csprec]->csprec;
            else {
              $sejourArray[$cpt]['debut'] = $sejours[$csprec]->unix_debut;
              break; 
            }
          }
        }
        $sejourArray[$cpt]['duree'] = date("d.m.Y",$sejourArray[$cpt]['debut']) . ' --> ' . date("d.m.Y",$sejourArray[$cpt]['fin']);
        $cpt++;
      }
    }

    //echo '<pre>'.print_r($sejourArray,true).'</pre>';
    
    // Liste des issues possible
    $issues = new ensTableBrioche("issueoptions","1","issue_text","ordre",$this->idsession,0,0,false,$this->autspec);
    $issues = $issues->getTableau();
    $issuesTab = array("total" => 0);
    foreach ($issues as $issue) $issuesTab[$issue->issue_text] = 0;
    
    // liste des provenances possible
    $listeprovs = new ensTableBrioche("provenance","1","provenance_text","ordre",$this->idsession,0,0,false,$this->autspec);
    $listeprovs = $listeprovs->getTableau();
    $provTab = array("total" => 0);
    foreach ($listeprovs as $listeprov) $provTab[$listeprov->provenance_text] = 0;
    
    // Identifiants des tablissements A, B ou C
    $etablABC = array(2 => 2, 3 => 3, 6 => 6, 9 => 9, 10 => 10);
    
    // Calcul    
    $statsResult = array();
    
    $nbJoursTotal = array('urgent' => 0, 'non urgent' => 0, 'femme' => 0, 'homme' => 0, 'total' => 0);
    $nbLitsDispTotal = array('total' => 0);
    $nbJoursPossTotal = array('total' => 0);
    $nvEntreesTotal = array('urgent' => 0, 'non urgent' => 0, 'femme' => 0, 'homme' => 0, 'total' => 0);
    $provenancesTotal = $provTab;
    $nvSortiesTotal = array('urgent' => 0, 'non urgent' => 0, 'femme' => 0, 'homme' => 0, 'total' => 0);
    $destinationsTotal = $issuesTab;
    $transfersTotal = array('total' => 0);
    $ageEntreeTotal = array('urgent' => 0, 'non urgent' => 0, 'femme' => 0, 'homme' => 0, 'total' => 0);
    $ageEntreeTotalQty = array('urgent' => 0, 'non urgent' => 0, 'femme' => 0, 'homme' => 0, 'total' => 0);
    $ageMoyenTotal = array('urgent' => 0, 'non urgent' => 0, 'femme' => 0, 'homme' => 0, 'total' => 0);
    $ageMoyenTotalQty = array('urgent' => 0, 'non urgent' => 0, 'femme' => 0, 'homme' => 0, 'total' => 0);
    $nbJoursTotalSejTermine = array('urgent' => 0, 'non urgent' => 0, 'femme' => 0, 'homme' => 0, 'total' => 0);
    $cpthsTotal = 0;
    
    foreach ($monthArray as $mois) {
      
      $Deb = $mois['annee'] . ($mois['mois'] < 10 ? "0" : "") . $mois['mois'] . "01";
      $Fin = $mois['annee'] . ($mois['mois'] < 10 ? "0" : "") . $mois['mois'] . cal_days_in_month(CAL_GREGORIAN,$mois['mois'],$mois['annee']);
      $tstmpDeb = strtotime($Deb);
      $tstmpFin = strtotime($Fin);
      
      // Journes hors stats  retirer des journes possible et des lits disponibles
      $cpthsmens = new ensTableBrioche("calendrier","horsStats = 1 AND debut <= $Fin AND fin >= $Deb ".
                                          ($donnees['noet'][0] != -1 ? "AND etablissement IN (" . implode(",",$donnees['noet']) . ")" : ""),
                                          "SUM((if(fin > $Fin, TO_DAYS($Fin), TO_DAYS(fin)) - " .
                                          "if(debut < $Deb, TO_DAYS($Deb), TO_DAYS(debut)) + " .
                                          "(if(csprec is not null and debut >= $Deb, 0, 1)))) as duree",
                                          0,$this->idsession);
      $cpthsmens = $cpthsmens->getTableau();
      $cpthsmens = $cpthsmens[0]->duree;
      if ($cpthsmens == '') $cpthsmens = 0;
      $cpthsTotal += $cpthsmens;
      
      $nbJours = array('urgent' => 0, 'non urgent' => 0, 'femme' => 0, 'homme' => 0, 'total' => 0);
      $nbLitsDisp = array('total' => 0);
      $nbJoursPoss = array('total' => 0);
      $nvEntrees = array('urgent' => 0, 'non urgent' => 0, 'femme' => 0, 'homme' => 0, 'total' => 0);
      $provenances = $provTab;
      $nvSorties = array('urgent' => 0, 'non urgent' => 0, 'femme' => 0, 'homme' => 0, 'total' => 0);
      $destinations = $issuesTab;
      $transfers = array('total' => 0);
      $ageEntree = array('urgent' => 0, 'non urgent' => 0, 'femme' => 0, 'homme' => 0, 'total' => 0);
      $ageEntreeQty = array('urgent' => 0, 'non urgent' => 0, 'femme' => 0, 'homme' => 0, 'total' => 0);
      $ageMoyen = array('urgent' => 0, 'non urgent' => 0, 'femme' => 0, 'homme' => 0, 'total' => 0);
      $ageMoyenQty = array('urgent' => 0, 'non urgent' => 0, 'femme' => 0, 'homme' => 0, 'total' => 0);
      $nbJoursSejTermine = array('urgent' => 0, 'non urgent' => 0, 'femme' => 0, 'homme' => 0, 'total' => 0);
           
      foreach ($sejourArray as $cle => $elmt) {
        
        $val = 0;
        $nouvelle_entree = 0;
        $nouvelle_sortie = 0;
                  
        /*-|-|-*/   
        if ($tstmpDeb > $elmt['debut'] && $tstmpFin < $elmt['fin']) {
          $val = ($tstmpFin - $tstmpDeb) / 86400 + 1;
        }
        /*-|-| */
        if ($tstmpDeb > $elmt['debut'] && $tstmpFin >= $elmt['fin'] && $tstmpDeb <= $elmt['fin']) {
          $nouvelle_sortie++;
          $val = ($elmt['fin'] - $tstmpDeb) / 86400 + 1;
        }
        /* |-|-*/
        if ($tstmpDeb <= $elmt['debut'] && $tstmpFin < $elmt['fin'] && $tstmpFin >= $elmt['debut']) {
          $nouvelle_entree++;
          $val = ($tstmpFin - $elmt['debut']) / 86400 + 1;
        }
        /* |-| */
        if ($tstmpDeb <= $elmt['debut'] && $tstmpFin >= $elmt['fin']) {
          $nouvelle_entree++;
          $nouvelle_sortie++;
          $val = ($elmt['fin'] - $elmt['debut']) / 86400 + 1;
        }

        if ($val > 0) {
          
          if ($mois['mois'] == 3) $val = ceil($val);
          if ($mois['mois'] == 10) $val = floor($val);
          
          $nbJoursTotal['total'] += $val;
          $nbJours['total'] += $val;
          
          $ageTmp = $this->calculAge($elmt['datenaiss'],$tstmpFin);
          $ageMoyenTotal['total'] += $ageTmp;
          $ageMoyen['total'] += $ageTmp;
          if ($ageTmp > 0) $ageMoyenTotalQty['total']++;
          if ($ageTmp > 0) $ageMoyenQty['total']++;
          
          if ($nouvelle_entree == 1) {
            $nvEntreesTotal['total']++; $nvEntrees['total']++; 
            $ageTmp = $this->calculAge($elmt['datenaiss'],$elmt['debut']);
            $ageEntreeTotal['total'] += $ageTmp;
            $ageEntree['total'] += $ageTmp;
            if ($ageTmp > 0) $ageEntreeTotalQty['total']++;
            if ($ageTmp > 0) $ageEntreeQty['total']++;
            if ($elmt['provenance'] != "") {
                $provenances['total']++; $provenancesTotal['total']++;
                $provenancesTotal[$elmt['provenance']]++;
                $provenances[$elmt['provenance']]++;
            }
          }
          if ($nouvelle_sortie == 1) { 
            $nvSortiesTotal['total']++; $nvSorties['total']++; 
            $nbJoursTotalSejTermine['total'] += ($elmt['fin'] - $elmt['debut']) / 86400 + 1;
            $nbJoursSejTermine['total'] += ($elmt['fin'] - $elmt['debut']) / 86400 + 1;
            if ($elmt['issue'] != "") {
                $destinations['total']++; $destinationsTotal['total']++;
                $destinationsTotal[$elmt['issue']]++;
                $destinations[$elmt['issue']]++;
            }
            if (in_array($elmt['issue_val'],$etablABC)) {
                $transfersTotal['total']++;   
                $transfers['total']++;
            }
          }
          if ($elmt['sexe'] == 'F') { 
            $nbJours['femme'] += $val; $nbJoursTotal['femme'] += $val; 
            $ageTmp = $this->calculAge($elmt['datenaiss'],$tstmpFin);
            $ageMoyenTotal['femme'] += $ageTmp;
            $ageMoyen['femme'] += $ageTmp;
            if ($ageTmp > 0) $ageMoyenTotalQty['femme']++;
            if ($ageTmp > 0) $ageMoyenQty['femme']++;
            if ($nouvelle_entree == 1) { 
              $nvEntreesTotal['femme']++; $nvEntrees['femme']++; 
              $ageTmp = $this->calculAge($elmt['datenaiss'],$elmt['debut']);
              $ageEntreeTotal['femme'] += $ageTmp;
              $ageEntree['femme'] += $ageTmp;
              if ($ageTmp > 0) $ageEntreeTotalQty['femme']++;
              if ($ageTmp > 0) $ageEntreeQty['femme']++;
            }
            if ($nouvelle_sortie == 1) { 
              $nvSortiesTotal['femme']++; $nvSorties['femme']++; 
              $nbJoursTotalSejTermine['femme'] += ($elmt['fin'] - $elmt['debut']) / 86400 + 1;
              $nbJoursSejTermine['femme'] += ($elmt['fin'] - $elmt['debut']) / 86400 + 1;
            }
          }
          if ($elmt['sexe'] == 'M') { 
            $nbJours['homme'] += $val; $nbJoursTotal['homme'] += $val; 
            $ageTmp = $this->calculAge($elmt['datenaiss'],$tstmpFin);
            $ageMoyenTotal['homme'] += $ageTmp;
            $ageMoyen['homme'] += $ageTmp;
            if ($ageTmp > 0) $ageMoyenTotalQty['homme']++;
            if ($ageTmp > 0) $ageMoyenQty['homme']++;
            if ($nouvelle_entree == 1) { 
              $nvEntreesTotal['homme']++; $nvEntrees['homme']++; 
              $ageTmp = $this->calculAge($elmt['datenaiss'],$elmt['debut']);
              $ageEntreeTotal['homme'] += $ageTmp;
              $ageEntree['homme'] += $ageTmp;
              if ($ageTmp > 0) $ageEntreeTotalQty['homme']++;
              if ($ageTmp > 0) $ageEntreeQty['homme']++;
            }
            if ($nouvelle_sortie == 1) { 
              $nvSortiesTotal['homme']++; $nvSorties['homme']++; 
              $nbJoursTotalSejTermine['homme'] += ($elmt['fin'] - $elmt['debut']) / 86400 + 1;
              $nbJoursSejTermine['homme'] += ($elmt['fin'] - $elmt['debut']) / 86400 + 1;
            }
          }
          if ($elmt['urgent'] == 1) { 
            $nbJours['urgent'] += $val; $nbJoursTotal['urgent'] += $val; 
            $ageTmp = $this->calculAge($elmt['datenaiss'],$tstmpFin);
            $ageMoyenTotal['urgent'] += $ageTmp;
            $ageMoyen['urgent'] += $ageTmp;
            if ($ageTmp > 0) $ageMoyenTotalQty['urgent']++;
            if ($ageTmp > 0) $ageMoyenQty['urgent']++;
            if ($nouvelle_entree == 1) { 
              $nvEntreesTotal['urgent']++; $nvEntrees['urgent']++; 
              $ageTmp = $this->calculAge($elmt['datenaiss'],$elmt['debut']);
              $ageEntreeTotal['urgent'] += $ageTmp;
              $ageEntree['urgent'] += $ageTmp;
              if ($ageTmp > 0) $ageEntreeTotalQty['urgent']++;
              if ($ageTmp > 0) $ageEntreeQty['urgent']++;
            }
            if ($nouvelle_sortie == 1) { 
              $nvSortiesTotal['urgent']++; $nvSorties['urgent']++; 
              $nbJoursTotalSejTermine['urgent'] += ($elmt['fin'] - $elmt['debut']) / 86400 + 1;
              $nbJoursSejTermine['urgent'] += ($elmt['fin'] - $elmt['debut']) / 86400 + 1;
            }
          }
          if ($elmt['urgent'] == 0) { 
            $nbJours['non urgent'] += $val; $nbJoursTotal['non urgent'] += $val; 
            $ageTmp = $this->calculAge($elmt['datenaiss'],$tstmpFin);
            $ageMoyenTotal['non urgent'] += $ageTmp;
            $ageMoyen['non urgent'] += $ageTmp;
            if ($ageTmp > 0) $ageMoyenTotalQty['non urgent']++;
            if ($ageTmp > 0) $ageMoyenQty['non urgent']++;
            if ($nouvelle_entree == 1) { 
              $nvEntreesTotal['non urgent']++; $nvEntrees['non urgent']++; 
              $ageTmp = $this->calculAge($elmt['datenaiss'],$elmt['debut']);
              $ageEntreeTotal['non urgent'] += $ageTmp;
              $ageEntree['non urgent'] += $ageTmp;
              if ($ageTmp > 0) $ageEntreeTotalQty['non urgent']++;
              if ($ageTmp > 0) $ageEntreeQty['non urgent']++;
            }
            if ($nouvelle_sortie == 1) { 
              $nvSortiesTotal['non urgent']++; $nvSorties['non urgent']++; 
              $nbJoursTotalSejTermine['non urgent'] += ($elmt['fin'] - $elmt['debut']) / 86400 + 1;
              $nbJoursSejTermine['non urgent'] += ($elmt['fin'] - $elmt['debut']) / 86400 + 1;
            }
          }
        }
      }
      
      foreach ($tldisp as $cle => $elmt) {
        
        $val = 0;
        $inc = 0;
        
        /*-|-|-*/   
        if (($tstmpDeb > $elmt->unix_debut || $elmt->unix_debut == '') && ($tstmpFin < $elmt->unix_fin || $elmt->unix_fin == '')) {
          $val = ($tstmpFin - $tstmpDeb) / 86400 + 1;
        }
        /*-|-| */
        if (($tstmpDeb > $elmt->unix_debut || $elmt->unix_debut == '') && $tstmpFin >= $elmt->unix_fin && $tstmpDeb < $elmt->unix_fin && $elmt->unix_fin != '') {
          $val = ($elmt->unix_fin - $tstmpDeb) / 86400 + 1;
        }
        /* |-|-*/
        if ($tstmpDeb <= $elmt->unix_debut && ($tstmpFin < $elmt->unix_fin || $elmt->unix_fin == '') && $tstmpFin > $elmt->unix_debut && $elmt->unix_debut != '') {
          $val = ($tstmpFin - $elmt->unix_debut) / 86400 + 1;
        }
        /* |-| */
        if ($tstmpDeb <= $elmt->unix_debut && $elmt->unix_debut != '' && $tstmpFin >= $elmt->unix_fin && $elmt->unix_fin != '') {
          $val = ($elmt->unix_fin - $elmt->unix_debut) / 86400 + 1;
        } 
        
        if ($val > 0) {
          if ($mois['mois'] == 3) $val = ceil($val);
          if ($mois['mois'] == 10) $val = floor($val);
          
          $nbJoursPossTotal['total'] += $val;
          $nbJoursPoss['total'] += $val;
        }
      }
      
      $nbJoursPoss['total'] = $nbJoursPoss['total'] - $cpthsmens;
      
      $nbLitsDisp['total'] = number_format($nbJoursPoss['total'] / cal_days_in_month(CAL_GREGORIAN,$mois['mois'],$mois['annee']),2);
      $nbLitsDispTotal['total'] += $nbLitsDisp['total'];
      
      if ($ageEntreeQty['total'] == 0) $ageEntreeQty['total'] = 1;
      if ($ageEntreeQty['urgent'] == 0) $ageEntreeQty['urgent'] = 1;
      if ($ageEntreeQty['non urgent'] == 0) $ageEntreeQty['non urgent'] = 1;
      if ($ageEntreeQty['femme'] == 0) $ageEntreeQty['femme'] = 1;
      if ($ageEntreeQty['homme'] == 0) $ageEntreeQty['homme'] = 1;
      if ($ageMoyenQty['total'] == 0) $ageMoyenQty['total'] = 1;
      if ($ageMoyenQty['urgent'] == 0) $ageMoyenQty['urgent'] = 1;
      if ($ageMoyenQty['non urgent'] == 0) $ageMoyenQty['non urgent'] = 1;
      if ($ageMoyenQty['femme'] == 0) $ageMoyenQty['femme'] = 1;
      if ($ageMoyenQty['homme'] == 0) $ageMoyenQty['homme'] = 1;
            
      $statsResult['nbjours'][$mois['mois'] . "." . $mois['annee']] = $nbJours;
      $statsResult['journeesposs'][$mois['mois'] . "." . $mois['annee']] = $nbJoursPoss;
      $statsResult['litsdisp'][$mois['mois'] . "." . $mois['annee']] = $nbLitsDisp;
      
      if ($nbJoursPoss['total'] == 0) $nbJoursPoss['total'] = 1;
            
      $statsResult['txoccup'][$mois['mois'] . "." . $mois['annee']]['total'] = number_format($nbJours['total'] / $nbJoursPoss['total'] * 100,2,null,"") . "%";
      $statsResult['txoccup'][$mois['mois'] . "." . $mois['annee']]['urgent (sur 100%)'] = ($nbJours['total'] == 0) ? "0.00%" : number_format($nbJours['urgent'] / $nbJours['total'] * 100,2,null,"") . "%";
      $statsResult['txoccup'][$mois['mois'] . "." . $mois['annee']]['non urgent (sur 100%)'] = ($nbJours['total'] == 0) ? "0.00%" : number_format($nbJours['non urgent'] / $nbJours['total'] * 100,2,null,"") . "%";
      $statsResult['nventrees'][$mois['mois'] . "." . $mois['annee']] = $nvEntrees;
      $statsResult['provenances'][$mois['mois'] . "." . $mois['annee']] = $provenances;
      $statsResult['nvsorties'][$mois['mois'] . "." . $mois['annee']] = $nvSorties;
      $statsResult['destinations'][$mois['mois'] . "." . $mois['annee']] = $destinations;
      $statsResult['transfers'][$mois['mois'] . "." . $mois['annee']] = $transfers;
      
      if ($nvSorties['total'] == 0) $nvSorties['total'] = 1;
      if ($nvSorties['urgent'] == 0) $nvSorties['urgent'] = 1;
      if ($nvSorties['non urgent'] == 0) $nvSorties['non urgent'] = 1;
      if ($nvSorties['femme'] == 0) $nvSorties['femme'] = 1;
      if ($nvSorties['homme'] == 0) $nvSorties['homme'] = 1;
      
      $statsResult['dureemoy'][$mois['mois'] . "." . $mois['annee']]['total'] = number_format($nbJoursSejTermine['total'] / $nvSorties['total'],2,null,"");
      $statsResult['dureemoy'][$mois['mois'] . "." . $mois['annee']]['urgent'] = number_format($nbJoursSejTermine['urgent'] / $nvSorties['urgent'],2,null,"");
      $statsResult['dureemoy'][$mois['mois'] . "." . $mois['annee']]['non urgent'] = number_format($nbJoursSejTermine['non urgent'] / $nvSorties['non urgent'],2,null,"");
      $statsResult['dureemoy'][$mois['mois'] . "." . $mois['annee']]['femme'] = number_format($nbJoursSejTermine['femme'] / $nvSorties['femme'],2,null,"");
      $statsResult['dureemoy'][$mois['mois'] . "." . $mois['annee']]['homme'] = number_format($nbJoursSejTermine['homme'] / $nvSorties['homme'],2,null,"");
      $statsResult['ageentree'][$mois['mois'] . "." . $mois['annee']]['total'] = number_format($ageEntree['total'] / $ageEntreeQty['total'],2,null,"");
      $statsResult['ageentree'][$mois['mois'] . "." . $mois['annee']]['urgent'] = number_format($ageEntree['urgent'] / $ageEntreeQty['urgent'],2,null,"");
      $statsResult['ageentree'][$mois['mois'] . "." . $mois['annee']]['non urgent'] = number_format($ageEntree['non urgent'] / $ageEntreeQty['non urgent'],2,null,"");
      $statsResult['ageentree'][$mois['mois'] . "." . $mois['annee']]['femme'] = number_format($ageEntree['femme'] / $ageEntreeQty['femme'],2,null,"");
      $statsResult['ageentree'][$mois['mois'] . "." . $mois['annee']]['homme'] = number_format($ageEntree['homme'] / $ageEntreeQty['homme'],2,null,"");
      $statsResult['agemoyen'][$mois['mois'] . "." . $mois['annee']]['total'] = number_format($ageMoyen['total'] / $ageMoyenQty['total'],2,null,"");
      $statsResult['agemoyen'][$mois['mois'] . "." . $mois['annee']]['urgent'] = number_format($ageMoyen['urgent'] / $ageMoyenQty['urgent'],2,null,"");
      $statsResult['agemoyen'][$mois['mois'] . "." . $mois['annee']]['non urgent'] = number_format($ageMoyen['non urgent'] / $ageMoyenQty['non urgent'],2,null,"");
      $statsResult['agemoyen'][$mois['mois'] . "." . $mois['annee']]['femme'] = number_format($ageMoyen['femme'] / $ageMoyenQty['femme'],2,null,"");
      $statsResult['agemoyen'][$mois['mois'] . "." . $mois['annee']]['homme'] = number_format($ageMoyen['homme'] / $ageMoyenQty['homme'],2,null,"");
    }
    
    if ($ageEntreeTotalQty['total'] == 0) $ageEntreeTotalQty['total'] = 1;
    if ($ageEntreeTotalQty['urgent'] == 0) $ageEntreeTotalQty['urgent'] = 1;
    if ($ageEntreeTotalQty['non urgent'] == 0) $ageEntreeTotalQty['non urgent'] = 1;
    if ($ageEntreeTotalQty['femme'] == 0) $ageEntreeTotalQty['femme'] = 1;
    if ($ageEntreeTotalQty['homme'] == 0) $ageEntreeTotalQty['homme'] = 1;
    if ($ageMoyenTotalQty['total'] == 0) $ageMoyenTotalQty['total'] = 1;
    if ($ageMoyenTotalQty['urgent'] == 0) $ageMoyenTotalQty['urgent'] = 1;
    if ($ageMoyenTotalQty['non urgent'] == 0) $ageMoyenTotalQty['non urgent'] = 1;
    if ($ageMoyenTotalQty['femme'] == 0) $ageMoyenTotalQty['femme'] = 1;
    if ($ageMoyenTotalQty['homme'] == 0) $ageMoyenTotalQty['homme'] = 1;
        
    if ($nbJoursPossTotal['total'] == 0) $nbJoursPossTotal['total'] = 1;
    $nbJoursPossTotal['total'] = $nbJoursPossTotal['total'] - $cpthsTotal;
               
    $statsResult['nbjours']['total']['total'] = number_format($nbJoursTotal['total'],0,null,"");
    $statsResult['nbjours']['total']['urgent'] = number_format($nbJoursTotal['urgent'],0,null,"");
    $statsResult['nbjours']['total']['non urgent'] = number_format($nbJoursTotal['non urgent'],0,null,"");
    $statsResult['nbjours']['total']['femme'] = number_format($nbJoursTotal['femme'],0,null,"");
    $statsResult['nbjours']['total']['homme'] = number_format($nbJoursTotal['homme'],0,null,"");
    $statsResult['nbjours']['titre'] = "Nombre de journes ralises";
    $statsResult['journeesposs']['total']['total'] = number_format($nbJoursPossTotal['total'],0,null,"");
    $statsResult['journeesposs']['titre'] = "Nombre de journes possibles";
    $statsResult['litsdisp']['total']['total'] = "&nbsp;";
    $statsResult['litsdisp']['titre'] = "Nombre de lits disponibles";    
    $statsResult['txoccup']['total']['total'] = "&nbsp;";
    $statsResult['txoccup']['total']['urgent (sur 100%)'] = "&nbsp;";
    $statsResult['txoccup']['total']['non urgent (sur 100%)'] = "&nbsp;";
    $statsResult['txoccup']['titre'] = "Taux d'occupation des lits";
    $statsResult['nventrees']['total'] = $nvEntreesTotal;
    $statsResult['nventrees']['titre'] = "Nouvelles entres pendant la priode";
    $statsResult['provenances']['total'] = $provenancesTotal;
    $statsResult['provenances']['titre'] = "Provenance des entres";
    $statsResult['nvsorties']['total'] = $nvSortiesTotal;
    $statsResult['nvsorties']['titre'] = "Nouvelles sorties pendant la priode";
    $statsResult['destinations']['total'] = $destinationsTotal;
    $statsResult['destinations']['titre'] = "Destination des sorties";
    $statsResult['destinations']['nl'] = false;
    $statsResult['transfers']['total'] = $transfersTotal;
    $statsResult['transfers']['titre'] = "Sous-total des transferts vers tablissements A, B ou C";
    $statsResult['dureemoy']['total']['total'] = "&nbsp;";
    $statsResult['dureemoy']['total']['urgent'] = "&nbsp;";
    $statsResult['dureemoy']['total']['non urgent'] = "&nbsp;";
    $statsResult['dureemoy']['total']['femme'] = "&nbsp;";
    $statsResult['dureemoy']['total']['homme'] = "&nbsp;";
    $statsResult['dureemoy']['titre'] = "Dure moyenne des sjours (achevs sur la priode) en jours";
    $statsResult['ageentree']['total']['total'] = "&nbsp;";
    $statsResult['ageentree']['total']['urgent'] = "&nbsp;";
    $statsResult['ageentree']['total']['non urgent'] = "&nbsp;";
    $statsResult['ageentree']['total']['femme'] = "&nbsp;";
    $statsResult['ageentree']['total']['homme'] = "&nbsp;";
    $statsResult['ageentree']['titre'] = "Age moyen des usagers au moment de l'entre";
    $statsResult['agemoyen']['total']['total'] = "&nbsp;";
    $statsResult['agemoyen']['total']['urgent'] = "&nbsp;";
    $statsResult['agemoyen']['total']['non urgent'] = "&nbsp;";
    $statsResult['agemoyen']['total']['femme'] = "&nbsp;";
    $statsResult['agemoyen']['total']['homme'] = "&nbsp;";
    $statsResult['agemoyen']['titre'] = "Age moyen des usagers pendant le sjour";

    if ($nvSortiesTotal['total'] == 0) $nvSortiesTotal['total'] = 1;
    if ($nvSortiesTotal['urgent'] == 0) $nvSortiesTotal['urgent'] = 1;
    if ($nvSortiesTotal['non urgent'] == 0) $nvSortiesTotal['non urgent'] = 1;
    if ($nvSortiesTotal['femme'] == 0) $nvSortiesTotal['femme'] = 1;
    if ($nvSortiesTotal['homme'] == 0) $nvSortiesTotal['homme'] = 1;
    if ($nbJoursTotal['total'] == 0) $nbJoursTotal['total'] = 1;
    if ($provenancesTotal['total'] == 0) $provenancesTotal['total'] = 1;
    if ($destinationsTotal['total'] == 0) $destinationsTotal['total'] = 1;
    
    $statsResult['nbjours']['moy']['total'] = number_format($nbJoursTotal['total'] / count($monthArray),2,null,"");
    $statsResult['nbjours']['moy']['urgent'] = number_format($nbJoursTotal['urgent'] / count($monthArray),2,null,"");
    $statsResult['nbjours']['moy']['non urgent'] = number_format($nbJoursTotal['non urgent'] / count($monthArray),2,null,"");
    $statsResult['nbjours']['moy']['femme'] = number_format($nbJoursTotal['femme'] / count($monthArray),2,null,"");
    $statsResult['nbjours']['moy']['homme'] = number_format($nbJoursTotal['homme'] / count($monthArray),2,null,"");
    $statsResult['journeesposs']['moy']['total'] = number_format($nbJoursPossTotal['total'] / count($monthArray),2,null,"");
    $statsResult['litsdisp']['moy']['total'] = number_format($nbLitsDispTotal['total'] / count($monthArray),2,null,"");
    $statsResult['txoccup']['moy']['total'] = number_format($nbJoursTotal['total'] / $nbJoursPossTotal['total'] * 100,2,null,"") . "%";
    $statsResult['txoccup']['moy']['urgent (sur 100%)'] = number_format($nbJoursTotal['urgent'] / $nbJoursTotal['total'] * 100,2,null,"") . "%";
    $statsResult['txoccup']['moy']['non urgent (sur 100%)'] = number_format($nbJoursTotal['non urgent'] / $nbJoursTotal['total'] * 100,2,null,"") . "%";
    $statsResult['nventrees']['moy']['total'] = number_format($nvEntreesTotal['total'] / count($monthArray),2,null,"");
    $statsResult['nventrees']['moy']['urgent'] = number_format($nvEntreesTotal['urgent'] / count($monthArray),2,null,"");
    $statsResult['nventrees']['moy']['non urgent'] = number_format($nvEntreesTotal['non urgent'] / count($monthArray),2,null,"");
    $statsResult['nventrees']['moy']['femme'] = number_format($nvEntreesTotal['femme'] / count($monthArray),2,null,"");
    $statsResult['nventrees']['moy']['homme'] = number_format($nvEntreesTotal['homme'] / count($monthArray),2,null,"");
    $statsResult['provenances']['moy'] = $provTab;
    foreach ($statsResult['provenances']['moy'] as $moyCle =>$moy)
        $statsResult['provenances']['moy'][$moyCle] = number_format($provenancesTotal[$moyCle] / $provenancesTotal['total'] * 100,2,null,"") . "%";
    $statsResult['nvsorties']['moy']['total'] = number_format($nvSortiesTotal['total'] / count($monthArray),2,null,"");
    $statsResult['nvsorties']['moy']['urgent'] = number_format($nvSortiesTotal['urgent'] / count($monthArray),2,null,"");
    $statsResult['nvsorties']['moy']['non urgent'] = number_format($nvSortiesTotal['non urgent'] / count($monthArray),2,null,"");
    $statsResult['nvsorties']['moy']['femme'] = number_format($nvSortiesTotal['femme'] / count($monthArray),2,null,"");
    $statsResult['nvsorties']['moy']['homme'] = number_format($nvSortiesTotal['homme'] / count($monthArray),2,null,"");
    $statsResult['destinations']['moy'] = $issuesTab;
    foreach ($statsResult['destinations']['moy'] as $moyCle =>$moy)
        $statsResult['destinations']['moy'][$moyCle] = number_format($destinationsTotal[$moyCle] / $destinationsTotal['total'] * 100,2,null,"") . "%";
    $statsResult['transfers']['moy']['total'] = number_format($transfersTotal['total'] / $destinationsTotal['total'] * 100,2,null,"") . "%";
    $statsResult['dureemoy']['moy']['total'] = number_format($nbJoursTotalSejTermine['total'] / $nvSortiesTotal['total'],2,null,"");
    $statsResult['dureemoy']['moy']['urgent'] = number_format($nbJoursTotalSejTermine['urgent'] / $nvSortiesTotal['urgent'],2,null,"");
    $statsResult['dureemoy']['moy']['non urgent'] = number_format($nbJoursTotalSejTermine['non urgent'] / $nvSortiesTotal['non urgent'],2,null,"");
    $statsResult['dureemoy']['moy']['femme'] = number_format($nbJoursTotalSejTermine['femme'] / $nvSortiesTotal['femme'],2,null,"");
    $statsResult['dureemoy']['moy']['homme'] = number_format($nbJoursTotalSejTermine['homme'] / $nvSortiesTotal['homme'],2,null,"");
    $statsResult['ageentree']['moy']['total'] = number_format($ageEntreeTotal['total'] / $ageEntreeTotalQty['total'],2,null,"");
    $statsResult['ageentree']['moy']['urgent'] = number_format($ageEntreeTotal['urgent'] / $ageEntreeTotalQty['urgent'],2,null,"");
    $statsResult['ageentree']['moy']['non urgent'] = number_format($ageEntreeTotal['non urgent'] / $ageEntreeTotalQty['non urgent'],2,null,"");
    $statsResult['ageentree']['moy']['femme'] = number_format($ageEntreeTotal['femme'] / $ageEntreeTotalQty['femme'],2,null,"");
    $statsResult['ageentree']['moy']['homme'] = number_format($ageEntreeTotal['homme'] / $ageEntreeTotalQty['homme'],2,null,"");
    $statsResult['agemoyen']['moy']['total'] = number_format($ageMoyenTotal['total'] / $ageMoyenTotalQty['total'],2,null,"");
    $statsResult['agemoyen']['moy']['urgent'] = number_format($ageMoyenTotal['urgent'] / $ageMoyenTotalQty['urgent'],2,null,"");
    $statsResult['agemoyen']['moy']['non urgent'] = number_format($ageMoyenTotal['non urgent'] / $ageMoyenTotalQty['non urgent'],2,null,"");
    $statsResult['agemoyen']['moy']['femme'] = number_format($ageMoyenTotal['femme'] / $ageMoyenTotalQty['femme'],2,null,"");
    $statsResult['agemoyen']['moy']['homme'] = number_format($ageMoyenTotal['homme'] / $ageMoyenTotalQty['homme'],2,null,"");
       
    $aide = array();
    $aide["Nombre de journes ralises"] = "nombre de lits occups par jour cumuls sur la priode choisie. Le jour de dbut 
    et le jour de fin sont compts chacun comme un jour entier, sauf dans le cas d'un changement de lit en cours de sjour. 
    Dans ce dernier cas, la journe n'est compte qu'une seule fois.";
    $aide["Nombre de journes possibles"] = "nombre de lits disponibles (occups ou non) par jour, cumuls sur la priode choisie. 
    Si un lit n'est potentiellement disponible que X jours pour un mois, le nombre de journes possibles sera de X pour ce lit.";
    $aide["Nombre de lits disponibles"] = "nombre de lits disponibles (occups ou non) sur la priode choisie. 
    Si un lit n'est potentiellement disponible que X jours dans un mois de N jours, ce lit ne sera disponible qu' 100*(X/N) %.";
    $aide["Taux d'occupation des lits"] = "nombre de journes ralises au total, urgent et non urgent divis 
    par le nombre de journes possibles au total.";
    $aide["Nouvelles entres pendant la priode"] = "nombre de personnes commenant un sjour pendant la priode choisie.";
    $aide["Provenance des entres"] = "provenances des usagers par type de services placeurs lors de l'entre en court sjour.";
    $aide["Nouvelles sorties pendant la priode"] = "nombre de personnes terminant un sjour pendant la priode choisie.";
    $aide["Destination des issues"] = "destinations des usagers par types d'institutions aprs le court sjour";
    $aide["Dure moyenne des sjours (achevs sur la priode) en jours"] = "dure moyenne des sjours se terminant pendant la priode choisie.";
    $aide["Age moyen des usagers au moment de l'entre"] = "ge moyen des usagers au moment o le sjour commence. Le calcul est le suivant : (date de dbut de sjour 
    - date de naissance) / 365.25 .";
    $aide["Age moyen des usagers pendant le sjour"] = "ge moyen des usagers en cours de sjour pour la priode choisie.";
    
    // Output
    if (($action_affichage - floor($action_affichage)) > 0) { // Feuille de calcul
      $x = new StatsTableau($statsResult,$monthArray,$aide);
      $enteteExcel['titre'] = "Statistiques des courts sjours planning";
      $enteteExcel['contenu'][] = "&nbsp;";
      $enteteExcel['contenu'][] = "Donnes extraites le " . date("d.m.Y") . " par $this->nomplein";
      $enteteExcel['contenu'][] = "&nbsp;";
      
      foreach ($etabl_liste->getTableau() as $etabl) {
        if ($donnees['noet'][0] > 0) {
          if (in_array($etabl->noet,$donnees['noet'])) $contenuEtabl[] = $etabl->nomet;
        } else $contenuEtabl[] = $etabl->nomet;
      }
      $enteteExcel['contenu'][] = "Etablissement(s) : " . implode(', ',$contenuEtabl);
      $enteteExcel['contenu'][] = "Priode du " . date("d.m.Y",$tstmpDebPeriode) . " au " . date("d.m.Y",$tstmpFinPeriode);
      $enteteExcel['contenu'][] = "&nbsp;";
      $x->excelHeader($enteteExcel);
      print($x->GetContenu());
      
    } else {

      $c = new TPanel(6, 1, "LEFT","","","border-width=0px;");
      $x = new StatsTableau($statsResult,$monthArray,$aide);   
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();    
      $this->addContenu($of->getContenu());
    }
    
  }
  
  function calculAge($dateNaiss,$reference) {
    
    if ($dateNaiss == '') return 0;
    
    $aujourdhui = getdate($reference);
    
    $age = $aujourdhui['year'] - substr($dateNaiss,6,4);       
    $epsilon = mktime(0,0,0,$aujourdhui['mon'],$aujourdhui['mday'],$aujourdhui['year']) 
             - mktime(0,0,0,substr($dateNaiss,3,2),substr($dateNaiss,0,2),$aujourdhui['year']);
    $age += $epsilon / (86400 * 365.25);
    
    return $age;
  }
  
  function verifDernier($noev,$sessionid) {
    $cal = new ensTableBrioche("calendrier","actif = 1 AND nodoss != -999 AND csprec = $noev AND horsStats = 0", "*", 0, $sessionid);
    if ($cal->compteTotal()) return false; else return true;
  }
  
}
?>