<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Statistiques pour EMS
* @package formulaires
*/
/**
* Statistique pour EMS
* Affichage des statistiques par EMS, pour un seul EMS si l'utilisateur EMS et pour les 
* EMS  choix si c'est un collaborateur du BRIO qui se connecte
* @package formulaires
* @author ob tnh
*/
class statEMS extends cadronglet{
  /**
  * action qui ramne au menu prcdent
  * @var int
  */
  var $precedente_action;
  
  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param int actif l'action principale
  * @param string fondpage la couleur du fond de page
  * @param string sessionid l'identifiant de session
  * @param array donnees le tableau de variables postes par le formulaire
  * @param int precedente_action cf. variable de classe
  * @param int options 1: afficher notes, 0: masquer notes
  */
  function statEMS($largeur, $grise, $actif, $fondpage, $sessionid, $donnees, $precedente_action = 1){
    global $fichier;
    // si on ne donne pas l'action prcdente, alors on ramne l'utilisateur vers le menu principal
    // pour lequel action = 1 justement
    if ($precedente_action == "") {
      $precedente_action = 1;
    }
    $this->precedente_action = $precedente_action;

    $ini = new briocheIni();
    $autspec[0] = $ini->autSpec[0];
    if (! isset($donnees)){
      $donnees['fin'] = "";
      $donnees['deb'] = "";
      $donnees['etab'] = "";
    }
    
    if (! $this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid, $autspec)) return;
    $tabbande = array("Pour EMS", "", "", "", "");
    $this->addOnglet("Statistiques", $tabbande, "#8b8378", $this->actif, 80, "");
    $this->colmateOnglets();
    if (! $donnees['deb']) $donnees['deb'] = $this->nouvelan();
    if (! $donnees['fin']) $donnees['fin'] = $this->aujourdhui();

    //Contenu
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fichier, "post");
    $c = new Tpanel(6);
    $x = new Label("$this->nomplein");
    $c->addChamp($x);
    if (! $this->verifAut($ini->autReq, $this->autorisations)) { //EMS
      $ese = new ensStatEMS($donnees['deb'], $donnees['fin'], $this->idsession, "", $autspec);
      $donnees['etab'] = "ems";
      $nomems = $ese->nomems;
      $x = new Label(" - $nomems", true);
      $c->addChamp($x);
    }
    else  { //Collaborateurs BRIO
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      $c = new TPanel(6);
      $x = new Label("Etablissement : ");
      $c->addChamp($x);
      $tablems = new ensTableBrioche("etablissements", 
                 "(litsc = -1 OR litsd = -1) AND autbrio = 0", "noet, nomet, actif",
                 "actif, groupepriorite, nomet", $this->idsession);
      $x = new listoptTableEtabl("donnees[etab]", $donnees['etab'], $tablems, false, 0, "d2");
      $x->addDefaut("&lt;TOUS&gt;", "-1");
      $x->addOptionsEtablissements("nomet", "noet");
      $c->addChamp($x);
      if ($donnees['etab']){
        $ese = new ensStatEMS($donnees['deb'], $donnees['fin'], $this->idsession,
                              $donnees['etab'], array());
        $nomems = $ese->nomems;
      }
    }

    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    $c = new TPanel(5, 1);
    $x = new ChampTexte("donnees[deb]", $donnees['deb'], "Priode du : ", 12, 12, false, "TEXT",  "d2",
                        "controleDate('donnees[deb]', '', '', '', 'donnees[deb]', 'donnees[fin]')", "", false, true);
    $c->addChamp($x);
    $c->addChamp(new Espace(4));
    $x = new ChampTexte("donnees[fin]", $donnees['fin'], "au : ", 12, 12, false, "TEXT",  "d2",
                        "controleDate('donnees[fin]', '', '', '', 'donnees[deb]', 'donnees[fin]')", "", false, true);
    $c->addChamp($x);
    $c->addChamp(new Espace(10));
    $x = new Bouton("OK", "OK", "SUBMIT");
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $x = new Bouton("Retour", "Retour", "BUTTON",
                    "document.forms.donnees.action.value=".$this->precedente_action.";" . 
                    "document.forms.donnees.submit();");
    $c->addChamp($x);
    $of->addChamp($c);
    $c = new TPanel(1, 1, "RIGHT");
    $x = new Aide("C0005");
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("action", $this->actif, "HIDDEN");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    if (! $donnees['etab']){

    }
    else {
      $c = new TPanel(6);
      $x = new Label("<FONT COLOR=\"red\">Les chiffres en rouge permettent une comparaison avec l'activit" .
                     " globale du BRIO sur la mme priode</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $x = new Label("Nombre de lits annoncs au BRIO par l'tablissement : ", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(2, 1, "RIGHT");
      $x = new Label("$ese->nbann");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbann, $ese->nbannBrio, 2, "0") .
                     " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont lits de long sjour : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbannLong", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbannLong, $ese->nbannLongBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont lits de court sjour (sans planning) : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbannCourt", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbannCourt, $ese->nbannCourtBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont lits polyvalents : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbannPoly", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbannPoly, $ese->nbannPolyBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();

      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont courts sjours \"planning\" : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbannPlan", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbannPlan, $ese->nbannPlanBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();

      
      
      $c = new TPanel(3);
      $x = new Label("Nombre de lits attribus : ", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(2, 1, "RIGHT");
      $x = new Label("$ese->nbattr");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbattr, $ese->nbattrBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont longs sjours : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbattrLong", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbattrLong, $ese->nbattrLongBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont sjours d'observation : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbattrObs", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbattrObs, $ese->nbattrObsBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont courts sjours (sans planning) : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbattrCourt", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbattrCourt, $ese->nbattrCourtBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont courts sjours \"planning\" : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbattrPlan", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbattrPlan, $ese->nbattrPlanBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      
      $c = new TPanel(3);
      $x = new Label("Nombre d'annonces de lit retires : ", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(2, 1, "RIGHT");
      $x = new Label("$ese->nbRetr");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbRetr, $ese->nbRetrBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      
      $c = new TPanel(4);
      $x = new Label("Dlai moyen disponibilit - attribution (longs sjours, y compris sj. observation) : ", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->delai j.");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("<i>Dans la moiti des cas, dlai infrieur ou gal  : </i>", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(2, 1, "RIGHT");
      $x = new Label("$ese->percent j.");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      
      
      $c = new TPanel(4);
      $x = new Label("Dlai moyen disponibilit - attribution (courts sjours, planning except) : ", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->delaiCourt j.");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      
      
      
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("<I>Dans la moiti des cas, dlai infrieur ou gal  : </I>", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(2, 1, "RIGHT");
      $x = new Label("$ese->percentCourt j.");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(6, 1);
      $x = new Label("<FONT COLOR=\"red\">Durant cette priode, un quart des lits de long sjour " .
                     "annoncs au BRIO ont t attribus dans les $ese->percent25BrioNonCourt jours, une moiti dans les " .
                     "$ese->percent50BrioNonCourt jours, trois quarts dans les $ese->percent75BrioNonCourt " .
                     "jours .</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $x = new Label("Moyenne d'ge des usagers au moment de l'attribution :", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(2, 1, "RIGHT");
      $x = new Label($ese->moyenneDage);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new Tpanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">$ese->moyenneDageBrio</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $x = new Label("Rapport femmes/hommes :", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(2, 1, "RIGHT");
      $x = new Label(($ese->nbHommes ? round($ese->nbFemmes / $ese->nbHommes, 2) : "infini"));
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new Tpanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . ($ese->nbHommesBrio ? round($ese->nbFemmesBrio / $ese->nbHommesBrio, 2) : "infini") . "</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TSautForm("stats", "stats.php", "post");
      $of->addChamp($c);
      $c = new TPanel(6, 1);
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("action", "1", "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("donnees[deb]", $donnees['deb'], "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("donnees[fin]", $donnees['fin'], "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("donnees[etab]", $donnees['etab'], "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("Envoyer", "Obtenir une feuille de calcul", "SUBMIT");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
    }
    $this->addContenu($of->getContenu());
  }


}
?>
