<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Statistiques pour services placeurs
* @package formulaires
*/
/**
* Statistiques pour service placeurs
* Permet aux services placeurs d'accder  leurs statistiques, et au BRIO d'accder aux statistiques
* de tous les services placeurs
* @package formulaires
* @author ob tnh
*/
class statSP extends cadronglet{
  /**
  * l'action qui ramne au menu
  * @var int
  */
  var $precedente_action;

  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param int actif l'action principale
  * @param string fondpage la couleur du fond de page
  * @param string sessionid l'identifiant de session
  * @param array donnees le tableau de variables postes par le formulaire
  * @param int precedente_action l'action qui ramne au menu
  */
  function statSP($largeur, $grise, $actif, $fondpage, $sessionid, $donnees, $precedente_action){
    global $fichier;
    // si on ne donne pas l'action prcdente, alors on ramne l'utilisateur vers le menu principal
    // pour lequel action = 1 justement
    if ($precedente_action == "") {
      $precedente_action = 1;
    }
    $this->precedente_action = $precedente_action;

    $ini = new briocheIni();
    $autspec[0] = $ini->autSpec[1];
    if (! isset($donnees)){
      $donnees['fin'] = "";
      $donnees['deb'] = "";
      $donnees['etab'] = "";
    }
    if (! $this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid, $autspec)) return;
    $tabbande = array("Pour services placeurs", "", "", "", "");
    $this->addOnglet("Statistiques", $tabbande, "#8b8378", $this->actif, 80, "");
    $this->colmateOnglets();
    if (! $donnees['deb']) $donnees['deb'] = $this->nouvelan();
    if (! $donnees['fin']) $donnees['fin'] = $this->aujourdhui();

    //Contenu
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fichier, "post");
    $c = new Tpanel(6);
    $x = new Label("$this->nomplein");
    $c->addChamp($x);
    if (! $this->verifAut($ini->autReq, $this->autorisations)) { //EMS
      $ese = new ensStatSP($donnees['deb'], $donnees['fin'], $this->idsession, "", $autspec);
      $donnees['etab'] = "ems";
      $nomems = $ese->nomems;
      $x = new Label(" - $nomems", true);
      $c->addChamp($x);
    }
    else  { //Collaborateurs BRIO
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      $c = new TPanel(6);
      $x = new Label("Etablissement : ");
      $c->addChamp($x);
      $tablems = new ensTableBrioche("etablissements", "servplac = -1", "noet, nomet, actif",
                 "actif, groupepriorite, nomet", $this->idsession);
      $x = new listoptTableEtabl("donnees[etab]", $donnees['etab'], $tablems, false, 0, "d2");
      $x->addDefaut("&lt;TOUS&gt;", "-1");
      $x->addOptionsEtablissements("nomet", "noet");
      $c->addChamp($x);
      if ($donnees['etab']){
        $ese = new ensStatSP($donnees['deb'], $donnees['fin'], $this->idsession, $donnees['etab'], array());
        $nomems = $ese->nomems;
      }
    }

    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    $c = new TPanel(5, 1);
    $x = new ChampTexte("donnees[deb]", $donnees['deb'], "Priode du : ", 12, 12, false, "TEXT",  "d2",
                        "controleDate('donnees[deb]', '', '')", "", false, true);
    $c->addChamp($x);
    $c->addChamp(new Espace(4));
    $x = new ChampTexte("donnees[fin]", $donnees['fin'], "au : ", 12, 12, false, "TEXT",  "d2",
                        "controleDate('donnees[fin]', '', '')", "", false, true);
    $c->addChamp($x);
    $c->addChamp(new Espace(10));
    $x = new Bouton("OK", "OK", "SUBMIT");
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $x = new Bouton("Retour", "Retour", "BUTTON",
                    "document.forms.donnees.action.value=".$this->precedente_action.";document.forms.donnees.submit();");
    $c->addChamp($x);
    $of->addChamp($c);
    $c = new TPanel(1, 1, "RIGHT");
    $x = new Aide("C0008");
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("action", $this->actif, "HIDDEN");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    if (! $donnees['etab']){

    }
    else {
      $c = new TPanel(6);
      $x = new Label("<FONT COLOR=\"red\">Les chiffres en rouge permettent une comparaison avec l'activit globale du BRIO sur la mme priode</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $x = new Label("Nombre de demandes faites au BRIO : ", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(2, 1, "RIGHT");
      $x = new Label("$ese->nbdem");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbdem, $ese->nbdemBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont demandes de long sjour : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbdemLong", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbdemLong, $ese->nbdemLongBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont demandes de sjours d'observation : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbdemObs", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbdemObs, $ese->nbdemObsBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont demandes de courts sjours : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbdemCour", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbdemCour, $ese->nbdemCourBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont autres demandes : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbdemAut", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbdemAut, $ese->nbdemAutBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $x = new Label("Nombre de lits C attribus au sein du rseau : ", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(2, 1, "RIGHT");
      $x = new Label("$ese->nbattr");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbattr, $ese->nbattrBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont longs sjours : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbattrLong", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbattrLong, $ese->nbattrLongBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont sjours d'observation : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbattrObs", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbattrObs, $ese->nbattrObsBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont courts sjours : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbattrCour", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbattrCour, $ese->nbattrCourBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $x = new Label("Nombre de lits C attribus hors du rseau : ", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(2, 1, "RIGHT");
      $x = new Label("$ese->nbattrHors");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbattrHors, $ese->nbattrHorsBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont longs sjours : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbattrLongHors", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbattrLongHors, $ese->nbattrLongHorsBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont sjours d'observation : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbattrObsHors", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbattrObsHors, $ese->nbattrObsHorsBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $c->addChamp(new Espace(3));
      $x = new Label("dont courts sjours : ", true, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "RIGHT");
      $x = new Label("$ese->nbattrCourHors", false, true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . $this->pourcent($ese->nbattrCourHors, $ese->nbattrCourHorsBrio, 2, "0") . " %</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $x = new Label("Dlai moyen d'aboutissement des demandes : ", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(2, 1, "RIGHT");
      $x = new Label("$ese->delai j.");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $x = new Label("Dans la moiti des cas, dlai infrieur ou gal  : ", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(2, 1, "RIGHT");
      $x = new Label("$ese->percent j.");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(6, 1);
      $x = new Label("<FONT COLOR=\"red\">Durant cette priode, un quart des demandes " .
                     "au BRIO ont abouti dans les $ese->percent25Brio jours, une moiti dans les " .
                     "$ese->percent50Brio jours, trois quarts dans les $ese->percent75Brio " .
                     "jours .</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $x = new Label("Moyenne d'ge des usagers au moment de la demande :", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(2, 1, "RIGHT");
      $x = new Label($ese->moyenneDage);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new Tpanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">$ese->moyenneDageBrio</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanel(3);
      $x = new Label("Rapport femmes/hommes :", true);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(2, 1, "RIGHT");
      $x = new Label(($ese->nbHommes ? round($ese->nbFemmes / $ese->nbHommes, 2) : "infini"));
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new Tpanel(1, 1, "CENTER");
      $x = new Label("<FONT COLOR=\"red\">" . ($ese->nbHommesBrio ? round($ese->nbFemmesBrio / $ese->nbHommesBrio, 2) : "infini") . "</FONT>");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TSautForm("stats", "stats.php", "post");
      $of->addChamp($c);
      $c = new TPanel(6, 1);
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("action", "3", "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("donnees[deb]", $donnees['deb'], "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("donnees[fin]", $donnees['fin'], "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("donnees[etab]", $donnees['etab'], "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("Envoyer", "Obtenir une feuille de calcul", "SUBMIT");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
    }
    $this->addContenu($of->getContenu());
  }


}
?>
