<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Suivi des demandes pour service placeur
* @package formulaires
*/
/**
* Suivi des demandes pour service placeur
* Permet aux services placeurs de suivre les demandes en cours, et de lister les demandes
* abouties
* @package formulaires
* @author ob
*/
class suivDemSP extends cadronglet{
  /**
  * l'action accessoire permettant d'accder au profil des usagers
  * @var int
  */
  var $action2;
  
  /**
  * l'action accessoire pour l'onglet "Demandes en cours" 
  * @var int
  */
  var $action3;
  
  /**
  * l'action accessoire pour l'onglet "Demandes abouties"
  * @var int
  */
  var $action4;
  
  /**
  * l'action accessoire pour revenir au menu
  * @var int
  */
  var $action5;
  
  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param int actif l'action principale
  * @param string fondpage la couleur du fond de page
  * @param string sessionid l'identifiant de session
  * @param array donnees le tableau de variables postes par le formulaire
  * @param int action2 ... action5 cf. variables de classe
  */
  function suivDemSP($largeur, $grise, $actif, $fondpage, $sessionid, $donnees,
                       $action2, $action3, $action4, $action5){
    global $fichier;
    
    $ini = new briocheIni();
    $autspec[0] = $ini->autSpec[1];
    if ( !$this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid, $autspec)) return;
    
    $this->action2 = $action2;
    $this->action3 = $action3;
    $this->action4 = $action4;
    $this->action5 = $action5;
    if (! isset($donnees)){
      $donnees['fin'] = "";
      $donnees['debut'] = "";
    }
    $tabbande = array("Suivi des demandes", "", "", "", "");
    $this->addOnglet("En cours", $tabbande, "#8b8378", $this->action3, 80,
                     "$fichier?action=$this->action3&sessionid=$this->idsession");
    $tabbande = array("Suivi des demandes", "", "", "", "");
    $this->addOnglet("Abouties", $tabbande, "#990099", $this->action4, 80, 
                     "$fichier?action=$this->action4&sessionid=$this->idsession");
    $this->colmateOnglets();

    //Contenu commun
    $ut = new enrUtilisateur($this->idsession, $autspec);
    $etabl = $ut->getEtablAttribue("ems");
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fichier, "post");
    
    $c = new TPanel(6, 1);
    $x = new Label("<P CLASS=\"soustitre\">Utilisateur : $this->nomplein - Etablissement : " .
                   $etabl->nomet . "</P>");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne();
    $c = new TPanel(5, 1, "RIGHT", "MIDDLE");
    $x = new Bouton("action", $this->actif, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("Retour", "Retour", "BUTTON", 
                    "javascript:document.forms.donnees.action.value=" .
                    $this->action5 . ";document.forms.donnees.submit();");
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $of->addChamp($c);
    $c = new TPanel(1, 1, "RIGHT");
    $x = new Aide("C0007");
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $of->addChamp($c);
    $of->addLigne();
    
    //Contenu spcifique aux onglets
    if ($this->actif == $this->action3){ // Demandes en cours
      $join[] = "choixems";
      $join[] = "usagers";
      $join[] = "demandeor";
      $join[] = "typesejour";
      $join[] = "attributionlit";
      $join[] = "typesejour AS typesejour2";
      $join[] = "utilisateurs";
      $join[] = "profilopars";
      $join[] = "issue";
      $join[] = "annoncelit";
      $join[] = "etablissements";

      $on[] = "choixems.nodoss = dossiers.nodoss";
      $on[] = "dossiers.nous = usagers.nous";
      $on[] = "dossiers.nodoss = demandeor.nodoss";
      $on[] = "demandeor.typesej = typesejour.idts";
      $on[] = "dossiers.nodoss = attributionlit.nodoss";
      $on[] = "attributionlit.typesej = typesejour2.idts";
      $on[] = "dossiers.suivpar = utilisateurs.init";
      $on[] = "dossiers.nodoss = profilopars.nodoss";
      $on[] = "dossiers.nodoss = issue.nodoss";
      $on[] = "attributionlit.nolit = annoncelit.nolit";
      $on[] = "annoncelit.etabl = etablissements.noet";
      
      $champs = "utilisateurs.nomut, IF(dossiers.priorite = 0, 10, dossiers.priorite) AS pri, " .
                "IF(typesejour2.ttypesej = \"\", typesejour.ttypesej , typesejour2.ttypesej) AS ttypesej ," .
                "dossiers.nodoss, IF(profilopars.profil, ABS(profilopars.profil), \"\") AS profil, " .
                "usagers.nom, usagers.prenom, " .
                "IF(dossiers.priorite = 0, \"\", dossiers.priorite) AS priorite, " .
                "count(choixems.nochoix) AS preinscr, " .
                "IF(attributionlit.dateplac IS NULL, issue.dateissue, attributionlit.dateplac) AS dateplac, " .
                "etablissements.nomet";


      $tabliste = new EnsTableBrioche("dossiers",
                                      "dossiers.dateclo IS NULL and dossiers.nous > 0 " .
                                      "AND (dossiers.statut IS NULL OR dossiers.statut NOT IN (99, 100)) " .
                                      "AND demandeor.servplac = " .
                                      $etabl->noet,
                                      $champs, "pri",
                                      $this->idsession, $join, $on, false,
                                      $autspec, "dossiers.nodoss");

      $cpt = $tabliste->compte();
      $c = new TPanel(6, 1);
      $x = new Label("Il y a <B>" . $cpt . "</B> dossiers...");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanelTableau(6, 1, $tabliste, $this->grise, "dossiers", "nodoss");
      $x = new Label("", false, false, false, "nodoss");
      $c->addColChamp("N doss.", $x, false, true);
 
      $x = new Label("", false, false, false, "nom");
      $c->addColChamp("Nom", $x);
      $x = new Label("", false, false, false, "prenom");
      $c->addColChamp("Prnom", $x);
      $x = new Label("", false, false, false, "priorite");
      $c->addColChamp("Pri.", $x);
      $x = new Lien("", false, false, false, "profil",
                    "javascript:ff=ouvreFenetre('$fichier?action=$action2&sessionid=$this->idsession&donnees[profil]=', 'profil'," .
                    " 'width=250,height=350');");
      $c->addColChamp("OPARS", $x, false, true);
      $x = new Label("", false, false, false, "ttypesej");
      $c->addColChamp("Sjour", $x);
      $x = new Label("", false, false, false, "preinscr");
      $c->addColChamp("Inscr.", $x);
      $x = new Label("", false, false, false, "dateplac");
      $c->addColChamp("Date iss.", $x);
      $x = new Label("", false, false, false, "nomet");
      $c->addColChamp("EMS", $x);
      $x = new Label("", false, false, false, "nomut");
      $c->addColChamp("Rf. Brio", $x);
    
      $c->addTitres(true);
      $of->addChamp($c);
      $of->addLigne();
    }  
    elseif($this->actif == $this->action4){//Placements raliss
      $c = new TPanel(6, 1);
      if (! $donnees['debut']) $donnees['debut'] = $this->nouvelan();
      if (! $donnees['fin']) $donnees['fin'] = $this->aujourdhui();
      $x = new ChampTexte("donnees[debut]", $donnees['debut'], "Priode du : ",
                          15, 15, false, "TEXT", "d2",
                          "controleDate('donnees[debut]', '', '', '')");
      $c->addChamp($x);
      $c->addChamp(new Espace(3));
      $x = new ChampTexte("donnees[fin]", $donnees['fin'], "au :",
                          15, 15, false, "TEXT", "d2",
                          "controleDate('donnees[fin]', '', '', '')");
      $c->addChamp($x);                    
      $c->addChamp(new Espace(3));
      $x = new Bouton("OK !", "OK", "SUBMIT");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $of->addLigne(0.5);
      
      $join[] = "attributionlit";
      $join[] = "annoncelit";
      $join[] = "usagers";
      $join[] = "typesejour";
      $join[] = "demandeor";
      $join[] = "issue";
      $join[] = "etablissements";
      $join[] = "issueoptions";
      
      $on[] = "dossiers.nodoss = attributionlit.nodoss";
      $on[] = "attributionlit.nolit = annoncelit.nolit";
      $on[] = "dossiers.nous = usagers.nous";
      $on[] = "attributionlit.typesej = typesejour.idts";
      $on[] = "dossiers.nodoss = demandeor.nodoss";
      $on[] = "dossiers.nodoss = issue.nodoss";
      $on[] = "annoncelit.etabl = etablissements.noet";
      $on[] = "issue.issue = issueoptions.idissue";
      $where = "demandeor.servplac = " . $etabl->noet . 
               " AND dossiers.nodoss IS NOT NULL " .
               "AND (dossiers.statut IS NULL OR dossiers.statut NOT IN (99, 100)) " .
               "AND issue.dateissue BETWEEN " .
               $this->getDateAm($donnees['debut']) . " AND " .
               $this->getDateAm($donnees['fin']);
      $champs = "dossiers.nodoss, usagers.nom, usagers.prenom, issue.dateissue, " .
                "usagers.datenaiss, issue.issue, issueoptions.issue_text, etablissements.nomet"; 
      $tabliste = new ensTableBrioche("dossiers",
                                      $where,
                                      $champs, "issue.dateissue", 
                                      $this->idsession, $join, $on, false, $autspec);
      $c = new TPanel(6, 1);
      $x = new Label("Il y a <B>" . $tabliste->compte() . "</B> dossiers...");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
      $c = new TPanelTableau(6, 1, $tabliste, $this->grise, "dossiers", "nodoss");
      $x = new Label("", false, false, false, "nodoss");
      $c->addColChamp("N doss.", $x);
      $x = new Label("", false, false, false, "nom");
      $c->addColChamp("Nom", $x);
      $x = new Label("", false, false, false, "prenom");
      $c->addColChamp("Prnom", $x);
      $x = new Label("", false, false, false, "datenaiss");
      $c->addColChamp("N(e) le", $x);
      $x = new Label("", false, false, false, "dateissue");
      $c->addColChamp("Date iss.", $x);
      $x = new Label("", false, false, false, "issue_text");
      //$c->addColChamp("Issue", $x, false, false, "textIssue", $this);
      $c->addColChamp("Issue", $x);
      $x = new Label("", false, false, false, "nomet");
      $c->addColChamp("EMS", $x);
      $c->addTitres(true);
      $of->addChamp($c);
      $of->addLigne();
    }	
    $this->addContenu($of->getContenu());
  }
}

?>
