<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Tableau de bord "lits et demandes"
* @package formulaires
*/
/**
* Tableau de bord "lits et demandes"
* Affiche des graphiques renseignant sur l'volution des lits disponibles et des demandes en attente
* @package formulaires
* @author ob
*/
class tabBordLit extends cadronglet {

  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param int actif l'action principale
  * @param string fondpage la couleur du fond de page
  * @param string sessionid l'identifiant de session
  * @param int action_retour l'action utilise pour revenir au menu
  * @param int donnees : les donnes permettant de paramtrer l'affichage
  */
  function tabBordLit($largeur, $grise, $actif, $fondpage, $sessionid, $action_retour, $donnees, $regions = false){
    global $fichier;
    if (! $this->cadronglet($largeur, $grise, $actif, $fondpage, $sessionid)) return;
    if (! isset($donnees['datefin'])) $donnees['datefin'] = $this->aujourdhui();
    if (! isset($donnees['echelle'])) $donnees['echelle'] = "sem";
    if (! isset($donnees['nb'])) $donnees['nb'] = 30;
    
    
    $champsmoinsun = array('lls', 'dls', 'tls', 'nls', 'NORD', 'CENTRE', 'OUEST', 'EST');
    $champszero = array('lsp', 'lcs', 'dcs', 'dct', 'ddo', 'dau', 'tcs', 'tct', 'tdo', 'tau', 'ncs', 'nct', 'ndo', 'nau');
    
    foreach ($champsmoinsun as $champ){
      if (! isset($donnees[$champ])) $donnees[$champ] = array('c' => -1, 'v' => -1);
    }
    foreach ($champszero as $champ){
      if (! isset($donnees[$champ])) $donnees[$champ] = array('c' => 0, 'v' => 0);
    }
    $somme = 1;
    if ($regions){
      // Si aucune rgion n'est coche, elles le sont toutes...
      $somme = ($donnees['NORD']['v'] + $donnees['CENTRE']['v'] + $donnees['OUEST']['v'] + $donnees['EST']['v']);
      if(! $somme){
        $donnees['NORD']['c'] = -1;
        $donnees['NORD']['v'] = -1;
        $donnees['CENTRE']['c'] = -1;
        $donnees['CENTRE']['v'] = -1;
        $donnees['EST']['c'] = -1;
        $donnees['EST']['v'] = -1;
        $donnees['OUEST']['c'] = -1;
        $donnees['OUEST']['v'] = -1;
        $somme = -4;
      }
      $somme = - $somme;
    }
    $tabbande = array("Lits et demandes", "", "", "", "");
    $this->addOnglet("Tableau de bord", $tabbande, "#8b8378", $this->actif, 100, "");
    $this->colmateOnglets();
    
    //Contenu
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fichier, "post");
        
    $c = new TPanel(4, 1);
    $x = new ChampTexte("donnees[datefin]", $donnees['datefin'], "Date butoir&nbsp;:", 12, 12, false, "TEXT",  "d2",
                        "controleDate('donnees[datefin]', '', '')", "", false, true);
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $x = new Label("Echelle&nbsp;:");
    $c->addChamp($x);
    $x = new ListOpt("donnees[echelle]", $donnees['echelle'], false, $size=0, "d2");
    $x->addOption("Jour", "jour");
    $x->addOption("Semaine", "sem");
    $x->addOption("Mois", "mois");
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    
    
    $x = new ChampTexte("donnees[nb]", $donnees['nb'], "Nb de points&nbsp;:", 6, 3, false, "TEXT", "d2");
    $c->addChamp($x);
    
    $of->addChamp($c);
    $c = new TPanel(2, 1, "RIGHT", "MIDDLE");
    
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("action", $this->actif, "HIDDEN");
    $c->addChamp($x);
    
    $x = new Bouton("OK", "OK", "SUBMIT");
    $c->addChamp($x);
    $c->addChamp(new Espace(3));    
    $x = new Bouton("Retour", "Retour", "BUTTON",
                    "document.forms.donnees.action.value=" . $action_retour . 
                    ";document.forms.donnees.submit();");
    $c->addChamp($x);
    $c->addChamp(new Espace(3));
    $of->addChamp($c);
    
    if ($regions){
      $of->addLigne();
      $c = new TPanelCadre(4, 1);
      $x = new Commutateur("donnees[OUEST]", $donnees['OUEST'], "Ouest", "donnees", false);
      $c->addChamp($x);
      $x = new Commutateur("donnees[CENTRE]", $donnees['CENTRE'], "Centre", "donnees", false);
      $c->addChamp($x);
      $x = new Commutateur("donnees[NORD]", $donnees['NORD'], "Nord", "donnees", false);
      $c->addChamp($x);
      $x = new Commutateur("donnees[EST]", $donnees['EST'], "Est", "donnees", false);
      $c->addChamp($x);
      
      $of->addChamp($c);
    }
    
    
    $of->addLigne(0.5);
    $of->addLigne();
    $c = new TPanel(4, 1);
    $x = new Label("Pour chaque jour est dtermin le nombre de lits C inoccups (
                   l'exception des courts-sjours planning, mais en comptant les lits rservs).
                   Le cas chant, ce nombre est moyenn sur la semaine ou le mois.");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne();
    //Lits disponibles
    $c = new TPanel(4,1);
    
    $chaineparam = "&ls=" . abs($donnees['lls']['v']) .
                   "&sp=" . abs($donnees['lsp']['v']).
                   "&cs=" . abs($donnees['lcs']['v']);
    if($regions){
      
      $chaineplus = "&regions=$somme" .
                      "&NORD=" . abs($donnees['NORD']['v']) .
                      "&CENTRE=" . abs($donnees['CENTRE']['v']) .
                      "&OUEST=" . abs($donnees['OUEST']['v']) .
                      "&EST=" . abs($donnees['EST']['v']);
      $chaineparam .= $chaineplus;
    }  
    $chaineparam .= "\">";
    $x = new Label("<img src=\"graphique.php?sessionid=$this->idsession&type=lits&nb=" .
                   $donnees['nb'] . "&echelle=" . $donnees['echelle']. "&datefin=" . 
                   $this->getDateAm($donnees['datefin'], false) . $chaineparam);
                   
    $c->addChamp($x);
    $of->addChamp($c);
    
    $c = new TPanel(2, 1, "LEFT", "TOP");
    $x = new Label("Type de lits&nbsp;:", true, false, true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[lls]", $donnees['lls'], "Longs sjours", "donnees", "donnees", true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[lsp]", $donnees['lsp'], "Lits polyvalents", "donnees", "donnees", true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[lcs]", $donnees['lcs'], "Courts sjours", "donnees", "donnees", true);
    $c->addChamp($x);
    $of->addChamp($c);
    
    $of->addLigne(0.5);
    $of->addLigne();
    
    //Demandes en attente (dlai dpass)
    
    $c = new TPanel(4, 1);
    $x = new Label("Pour chaque jour est dtermin le nombre de demandes encore
                   ouvertes (pas de date d'issue ou date d'issue dans le futur) pour
                   lesquelles le dlai de prise en charge (Dbut souhait pour
                   la prise en charge) est dpass. Le cas chant, ce nombre est
                   moyenn sur la semaine ou le mois.Les demandes de courts
                   sjours planning sont exclues");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne();
    $c = new TPanel(4, 1);
    $chaineparam = "&ls=" . abs($donnees['dls']['v']) .
                   "&cs=" . abs($donnees['dcs']['v']).
                   "&ct=" . abs($donnees['dct']['v']).
                   "&do=" . abs($donnees['ddo']['v']).
                   "&au=" . abs($donnees['dau']['v']);
    if ($regions) $chaineparam .= $chaineplus;
    $chaineparam .= "\">";
    $x = new Label("<img src=\"graphique.php?sessionid=$this->idsession&type=demtypsej&nb=" .
                   $donnees['nb'] . "&echelle=" . $donnees['echelle']. "&datefin=" . 
                   $this->getDateAm($donnees['datefin'], false) . $chaineparam
                   
                   );
    $c->addChamp($x);
    $of->addChamp($c);
    
    $c = new TPanel(2, 1, "LEFT", "TOP");
    $x = new Label("Prise en charge demande&nbsp;:", true, false, true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[dls]", $donnees['dls'], "Longs sjours", "donnees", "donnees", true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[dcs]", $donnees['dcs'], "Courts sjours", "donnees", "donnees", true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[dct]", $donnees['dct'], "CTR", "donnees", "donnees", true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[ddo]", $donnees['ddo'], "Domicile", "donnees", "donnees", true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[dau]", $donnees['dau'], "Autre", "donnees", "donnees", true);
    $c->addChamp($x);
    
    $of->addChamp($c);
    
    $of->addLigne(0.5);
    $of->addLigne();
    
    // Nouvelles demandes
    $c = new TPanel(4, 1);
    $x = new Label("Pour chaque jour est dtermin le nombre de nouvelles demandes parvenues au BRIO.
                   Le cas chant, ce nombre est moyenn sur la semaine ou le mois.");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne();
    $c = new TPanel(4, 1);
    $chaineparam = "&ls=" . abs($donnees['nls']['v']) .
                   "&cs=" . abs($donnees['ncs']['v']).
                   "&ct=" . abs($donnees['nct']['v']).
                   "&do=" . abs($donnees['ndo']['v']).
                   "&au=" . abs($donnees['nau']['v']);
    if ($regions) $chaineparam .= $chaineplus;
    $chaineparam .= "\">";
    $x = new Label("<img src=\"graphique.php?sessionid=$this->idsession&type=demtypsejnv&nb=" .
                   $donnees['nb'] . "&echelle=" . $donnees['echelle']. "&datefin=" . 
                   $this->getDateAm($donnees['datefin'], false) . $chaineparam
                   
                   );
    $c->addChamp($x);
    $of->addChamp($c);
    
    $c = new TPanel(2, 1, "LEFT", "TOP");
    $x = new Label("Prise en charge demande&nbsp;:", true, false, true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[nls]", $donnees['nls'], "Longs sjours", "donnees", "donnees", true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[ncs]", $donnees['ncs'], "Courts sjours", "donnees", "donnees", true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[nct]", $donnees['nct'], "CTR", "donnees", "donnees", true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[ndo]", $donnees['ndo'], "Domicile", "donnees", "donnees", true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[nau]", $donnees['nau'], "Autre", "donnees", "donnees", true);
    $c->addChamp($x);
    
    $of->addChamp($c);
    
    
    $of->addLigne(0.5);
    $of->addLigne();
    
    // Demandes en suspens
    
    $c = new TPanel(4, 1);
    $x = new Label("Pour chaque jour est dtermin le nombre de demandes en cours (date de la demande
                   dans le pass et pas de date d'issue ou date d'issue dans le futur). Le cas chant, ce
                   nombre est moyenn sur la semaine ou le mois");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne();
    $c = new TPanel(4, 1);
    $chaineparam = "&ls=" . abs($donnees['tls']['v']) .
                   "&cs=" . abs($donnees['tcs']['v']).
                   "&ct=" . abs($donnees['tct']['v']).
                   "&do=" . abs($donnees['tdo']['v']).
                   "&au=" . abs($donnees['tau']['v']);
    if ($regions) $chaineparam .= $chaineplus;
    $chaineparam .= "\">";
    $x = new Label("<img src=\"graphique.php?sessionid=$this->idsession&type=demtypsejtt&nb=" .
                   $donnees['nb'] . "&echelle=" . $donnees['echelle']. "&datefin=" . 
                   $this->getDateAm($donnees['datefin'], false) . $chaineparam
                   );
    $c->addChamp($x);
    $of->addChamp($c);
    
    $c = new TPanel(2, 1, "LEFT", "TOP");
    $x = new Label("Prise en charge demande&nbsp;:", true, false, true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[tls]", $donnees['tls'], "Longs sjours", "donnees", "donnees", true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[tcs]", $donnees['tcs'], "Courts sjours", "donnees", "donnees", true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[tct]", $donnees['tct'], "CTR", "donnees", "donnees", true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[tdo]", $donnees['tdo'], "Domicile", "donnees", "donnees", true);
    $c->addChamp($x);
    $x = new Commutateur("donnees[tau]", $donnees['tau'], "Autre", "donnees", "donnees", true);
    $c->addChamp($x);
    
    $of->addChamp($c);
    
    $of->addLigne();
    
    $this->addContenu($of->getContenu());

  }


}
?>
