<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Crations de tables d'historiques
* @package accessoires
*/
/**
* Cration de tables d'historiques
* Permettent d'obtenir des courbes sur les disponibilits, les demandes en attente en fonction du temps
* @package accessoires
* @author ob
*/
class tablesHist extends connexionBrioche { 
  /**
  * Le nom de la table
  * @var string
  */
  var $nom;
  
  /**
  * @param string l'identifiant de la session
  */
  function tablesHist($idsession){
    if (! $this->connexionBrioche($idsession)) return false;
  }
  
  /**
  * Cration d'une table
  * @param string le nom de la table (un _ sera ajout devant)
  */
  function creeTable($nom, $regions = false){
    $this->nom = $nom;  
    $tp = new tableProv("", $this->idsession, $nom);
    $yaunan = time() - (365 * SEC_PAR_JOUR);
    
    // Structure table
    switch ($nom){
    case "lits":
      $debut = strtotime($this->getDateAm($this->getPremierJour("annoncelit", "litdepuis"), false));
      if (! $tp->exists()){
        $yaunan = $debut;
        $tp->setChamp("longsej", "int", "", "", true, '0');
        $tp->setChamp("courtsej", "int", "", "", true, '0');
        $tp->setChamp("polyvsej", "int", "", "", true, '0');
        if ($regions){
          $tp->setChamp("region", "char", 6, "", true);
        }
      }
      break;
    case "demtypsej":
      $debut = strtotime($this->getDateAm($this->getPremierJour("demandeor", "litdepuis"), false));
      if (! $tp->exists()){
        $yaunan = $debut;
        $tp->setChamp("longsej", "int", "", "", true, '0');
        $tp->setChamp("ctr", "int", "", "", true, '0');
        $tp->setChamp("domicile", "int", "", "", true, '0');
        $tp->setChamp("courtsej", "int", "", "", true, '0');
        $tp->setChamp("autres", "int", "", "", true, '0');
        $tp->setChamp("longsejtt", "int", "", "", true, '0');
        $tp->setChamp("ctrtt", "int", "", "", true, '0');
        $tp->setChamp("domicilett", "int", "", "", true, '0');
        $tp->setChamp("courtsejtt", "int", "", "", true, '0');
        $tp->setChamp("autrestt", "int", "", "", true, '0');
        $tp->setChamp("longsejnv", "int", "", "", true, '0');
        $tp->setChamp("ctrnv", "int", "", "", true, '0');
        $tp->setChamp("domicilenv", "int", "", "", true, '0');
        $tp->setChamp("courtsejnv", "int", "", "", true, '0');
        $tp->setChamp("autresnv", "int", "", "", true, '0');
        if ($regions){
          $tp->setChamp("region", "char", 6, "", true);
        }  
      }
      
      break;
    
    }
    $tp->setChamp("jour", "date");
    $tp->setChamp("id", "int", "", "", true, "", true, true);
    $tp->setChamp("tst", "timestamp", "", "", true, "NULL");
    $creeentier = false;
    if (! $tp->exists()){
      $tp->create();
      $creeentier = true;
    }  
    // Donnes
    // Remplissage des tables pour chaque jour depuis 1 an ou, si la base est plus jeune, pour toutes les dates
    if (($debut < $yaunan) && ! $creeentier) $premj = $yaunan; else $premj = $debut;
    $nb = round((mktime() - $premj) / SEC_PAR_JOUR);
    for ($i = 0; $i < $nb; $i++){
      print "-$i-";
      
      $madate = mktime(0, 0, 0, date('m', $premj), date('d', $premj) + $i, date('y', $premj));
      $madatefr = date("d.m.y", $madate);
      $madateam = $this->getDateAm($madatefr, true);
      print ".$madateam.";
      
      switch ($nom) {
      case "lits":
        
        $treg = array(false);
        if($regions){
          $treg = $this->getRegions();
        }
        $wherereg = "";
        foreach($treg as $reg) {
          
          if ($reg){
            $wherereg = "AND annoncelit.region = \"$reg->region\"";
          }
          
          $et = new ensTableBrioche("annoncelit",
                                     "stlit IN (1, 2, 3, 4, 14) AND litdepuis <= " . $madateam . 
                                     " AND (dateplac > " . $madateam . " OR dateplac IS NULL) $wherereg" ,
                                     "stlit, count(annoncelit.nolit) as nombre ",
                                     "stlit",
                                     $this->idsession,
                                     "attributionlit",
                                     "annoncelit.nolit = attributionlit.nolit",
                                     false, 0,
                                     "stlit");
          $tet = $et->getTableau();
          $cpt = count($tet);
          $tabchamps = array();
          if ($regions) $tabchamps['region'] = $reg->region;
          for ($j = 0; $j < $cpt; $j++){
            $status = $tet[$j]->stlit;
            if ($status == 1 || $status == 2){
              $tabchamps['longsej'] = $tet[$j]->nombre;                            
            }
            elseif ($status == 3 || $status == 14){
              $tabchamps['courtsej'] = $tet[$j]->nombre;
            }
            elseif ($status == 4) {
              $tabchamps['polyvsej'] = $tet[$j]->nombre;
            }
          }                            
          $tabchamps['jour'] = $madatefr;
          $ut = new updateTableBrioche("_lits", $tabchamps, $this->getDateAm($madatefr, false), 'jour', $this->idsession); 
          $etl = new ensTableBrioche("_lits",
                                     "jour = $madateam" . ($regions ? " AND region = \"$reg->region\"" : ""),
                                     "id", 0, $this->idsession);
          //print $etl->getSQL();
          $nbre = $etl->compte();
          if ($nbre) $etl->detruitEnsemble();
          $ut->ajouteEnr();
        
        } //fin foreach 
        
        break;
      
      case "demtypsej":
        $treg = array(false);
        if($regions){
          $treg = $this->getRegions();
        }
        $wherereg = "";
        foreach($treg as $reg){
          if ($reg){
            $wherereg = "AND demandeor.region = \"$reg->region\"";
          }
          $groupe = "IF(typesej IN(1, 2), 'lon', " .
                    "IF(typesej = 7, 'ctr', " .
                    "IF(typesej IN(8, 9, 10, 11), 'dom', " .
                    "IF(typesej IN(3, 14, 5), 'cour', 'aut'))))";
          $debpec = "IF(litdepuis, litdepuis, " .
                    "IF(debutpec = 1, datedem + INTERVAL 2 DAY, " .
                    "IF(debutpec = 2, datedem + INTERVAL 6 DAY, " .
                    "datedem + INTERVAL 30 DAY)))"; 
          //Demandes en attente (dlai dpass)
          $et = new ensTableBrioche("demandeor",
                                    "typesej <> 5 AND (litdepuis IS NOT NULL OR debutpec IN(1, 2, 3)) AND " .
                                    "IF(litdepuis, litdepuis <= $madateam, " .
                                    "IF(debutpec = 1, datedem + INTERVAL 2 DAY <= $madateam, " .
                                    "IF(debutpec = 2, datedem + INTERVAL 6 DAY <= $madateam, " .
                                    "datedem + INTERVAL 30 DAY <= $madateam)))" .
                                    //"$debpec <= $madateam" .
                                    " AND (dateissue > " . $madateam . " OR dateissue IS NULL) $wherereg",
                                    $groupe .  "AS typ, " . 
                                    "count(demandeor.nodoss) AS nombre ",
                                    //"sum(to_days($madateam) - to_days($debpec)) AS duree",
                                    0, $this->idsession,
                                    "issue",
                                    "demandeor.nodoss = issue.nodoss",
                                    false, 0,
                                    $groupe);
          $tet = $et->getTableau();
        
          //Toutes demandes en cours
          $ettt = new ensTableBrioche("demandeor",
                                      "datedem <= $madateam " .
                                      "AND (dateissue > " . $madateam . " OR dateissue IS NULL) $wherereg",
                                      $groupe . "AS typ, " .
                                      "count(demandeor.nodoss) AS nombre ",
                                      0, $this->idsession,
                                      "issue",
                                      "demandeor.nodoss = issue.nodoss",
                                      false, 0,
                                      $groupe);
         
          $tettt = $ettt->getTableau();
        
          //Nouvelles demandes
          $etnv = new ensTableBrioche("demandeor",
                                      "datedem = $madateam $wherereg",
                                      $groupe . "AS typ, " .
                                      "count(demandeor.nodoss) AS nombre ", 
                                      0, $this->idsession,
                                      "issue",
                                      "demandeor.nodoss = issue.nodoss",
                                      false, 0,
                                      $groupe);
          $tetnv = $etnv->getTableau();
          //print $etnv->getSQL() . "\n\n";
          $cpt = count($tet);
          $tabchamps = array();
          if ($regions) $tabchamps['region'] = "$reg->region";
          
          for ($j = 0; $j < $cpt; $j++){
          
            $typ = $tet[$j]->typ;
            if ($typ == 'lon'){
              $tabchamps['longsej'] = $tet[$j]->nombre;
            }
            elseif ($typ == 'ctr'){
              $tabchamps['ctr'] = $tet[$j]->nombre;
            }
            elseif ($typ == 'dom'){
              $tabchamps['domicile'] = $tet[$j]->nombre;
            }
            elseif ($typ == 'cour'){
              $tabchamps['courtsej'] = $tet[$j]->nombre;
            }
            elseif ($typ == 'aut'){
              $tabchamps['autres'] = $tet[$j]->nombre;
            }
          }
          $cpt = count($tettt);
          for ($j = 0; $j < $cpt; $j++){
            $typ = $tettt[$j]->typ;
            if ($typ == 'lon'){
              $tabchamps['longsejtt'] = $tettt[$j]->nombre;
            }
            elseif ($typ == 'ctr'){
              $tabchamps['ctrtt'] = $tettt[$j]->nombre;
            }
            elseif ($typ == 'dom'){
              $tabchamps['domicilett'] = $tettt[$j]->nombre;
            }
            elseif ($typ == 'cour'){
              $tabchamps['courtsejtt'] = $tettt[$j]->nombre;
            }
            elseif ($typ == 'aut'){
              $tabchamps['autrestt'] = $tettt[$j]->nombre;
            }
          }
          $cpt = count($tetnv);
          for ($j = 0; $j < $cpt; $j++){
            $typ = $tetnv[$j]->typ;
            if ($typ == 'lon'){
              $tabchamps['longsejnv'] = $tetnv[$j]->nombre;
            }
            elseif ($typ == 'ctr'){
              $tabchamps['ctrnv'] = $tetnv[$j]->nombre;
            }
            elseif ($typ == 'dom'){
              $tabchamps['domicilenv'] = $tetnv[$j]->nombre;
            }
            elseif ($typ == 'cour'){
              $tabchamps['courtsejnv'] = $tetnv[$j]->nombre;
            }
            elseif ($typ == 'aut'){
              $tabchamps['autresnv'] = $tetnv[$j]->nombre;
            }
          }
          $tabchamps['jour'] = $madatefr;
          $ut = new updateTableBrioche("_demtypsej", $tabchamps, $this->getDateAm($madatefr, false), 'jour', $this->idsession);
          $etl = new ensTableBrioche("_demtypsej",
                                     "jour = $madateam" . ($regions ? " AND region = \"$reg->region\"" : ""),
                                     "id", 0, $this->idsession);
          $nbre = $etl->compte();
          if ($nbre) $etl->detruitEnsemble();
          $ut->ajouteEnr();
          
        
        } //fin foreach
        break;
      } // fin switch
    
    }
   
    
  
  }
  
  /**
  * Retourne la plus ancienne date correspondant  un champ donn d'une table donne
  * @param string le nom de la table
  * @param string le nom du champ
  * @return string la premire date de la table en question
  */
  function getPremierJour($table, $champ){
    $et = new ensTableBrioche($table, 
                              $champ . " IS NOT NULL",
                              $champ, $champ, $this->idsession, 0, 0, false, 0, "", 1);
    $tet = $et->getTableau();
    return $tet[0]->$champ; 
  }
  
  /**
  * Retourne les sries de donnes ncessaires au traage des graphiques
  * @param string le type de graphique
  * @param string la date butoir
  * @param int le nombre de points  tracer
  * @param string l'chelle employe (jour, sem, mois)
  * @return array les sries de donnes
  */
  function getSeries($type, $datefin, $nb = 30, $echelle = "jour", $regions = 0, $tabreg = null) {
    if (! $datefin){
        $datefin = date("y-m-d");
    }
    $prod = 1;
    $wherereg = "";
    if ($regions) {
      $prod = $regions;
      $wherereg = " AND (";
      foreach($tabreg as $mareg){
        $wherereg .= "region = \"$mareg\" OR ";
      }
      $wherereg .= " 0)";
    }
    
    switch($type){
    case  "lits":
      if ($echelle == "jour"){
        $et = new ensTableBrioche("_lits", "jour <= \"$datefin\"" . $wherereg,
                                  "jour, sum(longsej) as longsej, sum(courtsej) as courtsej, sum(polyvsej) as polyvsej ",
                                  "jour DESC", $this->idsession,
                                  0, 0, false, 0, "jour", $nb );
        }     
      elseif ($echelle == "sem"){
        $et = new ensTableBrioche("_lits", "jour <= \"$datefin\"" . $wherereg,
                                  "date_format(jour, \"%y - s. %u\") as jour, avg(longsej)*$prod as longsej, " .
                                  "avg(courtsej)*$prod as courtsej, avg(polyvsej)*$prod as polyvsej ",
                                  "date_format(jour, \"%y - %u\") DESC", $this->idsession,
                                  0, 0, false, 0, "date_format(jour, \"%y - %u\")", $nb); 
        
      }
      elseif ($echelle == "mois"){
        $et = new ensTableBrioche("_lits", "jour <= \"$datefin\"",
                                  "date_format(jour, \"%m %y\") as jour, avg(longsej)*$prod as longsej, " .
                                  "avg(courtsej)*$prod as courtsej, avg(polyvsej)*$prod as polyvsej",
                                  "date_format(jour, \"%y - %m\") DESC", $this->idsession,
                                  0, 0, false, 0, "date_format(jour, \"%y - %m\")", $nb); 
         
        
      }
      $tet = $et->getTableau();
      $cpt = count($tet);
      for ($i = $cpt - 1; $i >= 0; $i--){
        $xdata[] = $tet[$i]->jour;  
        $ydata[] = $tet[$i]->longsej;
        $y2data[] = $tet[$i]->polyvsej;
        $y3data[] = $tet[$i]->courtsej;
        $y4data[] = $tet[$i]->longduree;
        $y5data[] = $tet[$i]->courtduree;
        $y6data[] = $tet[$i]->polyvduree;
      }
      $retour['x'] = $this->metEnFormeX($xdata, $echelle, $nb);
      $retour['y'] = $ydata;
      $retour['y2'] = $y2data;
      $retour['y3'] = $y3data;
      $retour['y4'] = $y4data;
      $retour['y5'] = $y5data;
      $retour['y6'] = $y6data;
      
      break;
    case "demtypsej":
    case "demtypsejtt":
    case "demtypsejnv": 
      
      if ($echelle == "jour"){
        if ($type == "demtypsej"){
          
          $et = new ensTableBrioche("_demtypsej", "jour <= \"$datefin\"" . $wherereg,
                                    "jour, sum(longsej) as longsej, sum(courtsej) as courtsej, sum(ctr) as ctr, " .
                                    "sum(domicile) as domicile, sum(autres) as autres",
                                    "jour DESC", $this->idsession,
                                    0, 0, false, 0, "jour", $nb );
        }     
        elseif ($type == "demtypsejtt") {
          $et = new ensTableBrioche("_demtypsej", "jour <= \"$datefin\"" . $wherereg,
                                    "jour, sum(longsejtt) as longsej, sum(courtsejtt) as courtsej, sum(ctrtt) as ctr, " .
                                    "sum(domicilett) as domicile, sum(autrestt) as autres",
                                    "jour DESC", $this->idsession,
                                    0, 0, false, 0, "jour", $nb );  
        }
        elseif ($type == "demtypsejnv"){
          $et = new ensTableBrioche("_demtypsej", "jour <= \"$datefin\"" .$wherereg,
                                    "jour, sum(longsejnv) as longsej, sum(courtsejnv) as courtsej, sum(ctrnv) as ctr, " .
                                    "sum(domicilenv) as domicile, sum(autresnv) as autres",
                                    "jour DESC", $this->idsession,
                                    0, 0, false, 0, "jour", $nb ); 
        }
      }  
      elseif ($echelle == "sem"){
          if  ($type == "demtypsej"){
          
          $et = new ensTableBrioche("_demtypsej", "jour <= \"$datefin\"" .$wherereg,
                                    "date_format(jour, \"%y - s. %u\") as jour, avg(longsej)*$prod as longsej, " .
                                    "avg(courtsej)*$prod as courtsej, avg(ctr)*$prod as ctr, " .
                                    "avg(domicile)*$prod as domicile, avg(autres)*$prod as autres",
                                    "date_format(jour, \"%Y - %u\") DESC", $this->idsession,
                                    0, 0, false, 0, "date_format(jour, \"%y - %u\")", $nb);
        }
        elseif ($type == "demtypsejtt"){
          $et = new ensTableBrioche("_demtypsej", "jour <= \"$datefin\"" . $wherereg,
                                    "date_format(jour, \"%y - s. %u\") as jour, avg(longsejtt)*$prod as longsej, " .
                                    "avg(courtsejtt)*$prod as courtsej, avg(ctrtt)*$prod as ctr, " .
                                    "avg(domicilett)*$prod as domicile, avg(autrestt)*$prod as autres",
                                    "date_format(jour, \"%Y - %u\") DESC", $this->idsession,
                                    0, 0, false, 0, "date_format(jour, \"%y - %u\")", $nb);
        
        }
        elseif ($type == "demtypsejnv"){
          $et = new ensTableBrioche("_demtypsej", "jour <= \"$datefin\"" . $wherereg,
                                    "date_format(jour, \"%y - s. %u\") as jour, avg(longsejnv)*$prod as longsej, " .
                                    "avg(courtsejnv)*$prod as courtsej, avg(ctrnv)*$prod as ctr, " .
                                    "avg(domicilenv)*$prod as domicile, avg(autresnv)*$prod as autres",
                                    "date_format(jour, \"%Y - %u\") DESC", $this->idsession,
                                    0, 0, false, 0, "date_format(jour, \"%y - %u\")", $nb);
          
        }
      }
      elseif ($echelle == "mois"){
        if ($type == "demtypsej"){
          $et = new ensTableBrioche("_demtypsej", "jour <= \"$datefin\"" . $wherereg,
                                    "date_format(jour, \"%m %y\") as jour, avg(longsej)*$prod as longsej, " .
                                    "avg(courtsej)*$prod as courtsej, avg(ctr)*$prod as ctr, " .
                                    "avg(domicile)*$prod as domicile, avg(autres)*$prod as autres",
                                    "date_format(jour, \"%Y - %m\") DESC", $this->idsession,
                                    0, 0, false, 0, "date_format(jour, \"%y - %m\")", $nb);   
        }
        elseif ($type == "demtypsejtt"){
          $et = new ensTableBrioche("_demtypsej", "jour <= \"$datefin\"" . $wherereg,
                                    "date_format(jour, \"%m %y\") as jour, avg(longsejtt)*$prod as longsej, " .
                                    "avg(courtsejtt)*$prod as courtsej, avg(ctrtt)*$prod as ctr, " .
                                    "avg(domicilett)*$prod as domicile, avg(autrestt)*$prod as autres",
                                    "date_format(jour, \"%Y - %m\") DESC", $this->idsession,
                                    0, 0, false, 0, "date_format(jour, \"%y - %m\")", $nb);   
        }
        elseif ($type == "demtypsejnv"){
          $et = new ensTableBrioche("_demtypsej", "jour <= \"$datefin\"" . $wherereg,
                                    "date_format(jour, \"%m %y\") as jour, avg(longsejnv)*$prod as longsej, " .
                                    "avg(courtsejnv)*$prod as courtsej, avg(ctrnv)*$prod as ctr, " .
                                    "avg(domicilenv)*$prod as domicile, avg(autresnv)*$prod as autres",
                                    "date_format(jour, \"%Y - %m\") DESC", $this->idsession,
                                    0, 0, false, 0, "date_format(jour, \"%y - %m\")", $nb);   
        }
      }
      $tet = $et->getTableau();
      $cpt = count($tet);
      //print $et->getSQL();
      for ($i = $cpt - 1; $i >= 0; $i--){
        $xdata[] = $tet[$i]->jour;
        $ydata[] = $tet[$i]->longsej;
        $y2data[] = $tet[$i]->courtsej;
        $y3data[] = $tet[$i]->ctr;
        $y4data[] = $tet[$i]->domicile;
        $y5data[] = $tet[$i]->autres;
      }
      $retour['x'] = $this->metEnFormeX($xdata, $echelle, $nb);
      $retour['y'] = $ydata;
      $retour['y2'] = $y2data;
      $retour['y3'] = $y3data;
      $retour['y4'] = $y4data;
      $retour['y5'] = $y5data;
      break;
    }
    return $retour;
  }

  /**
  * Met en forme les tiquettes de l'abcisse en fonction de l'chelle et du nombre de points
  * @param array les donnes  mettre en forme
  * @param string l'chelle utilise
  * @param int le nombre de points
  * @return array les donnes mises en forme
  */
  function metEnFormeX($data, $echelle, $nb){
    $cpt = count($data);
    if ($echelle == "mois"){
      
      for ($i = 0; $i < $cpt; $i ++){
        $data[$i] = CJour::abrevMois(substr($data[$i], 0, 2)) . " " . substr($data[$i], 2);
      }
    }
     
    $rapport = round($nb/20);
    for ($i = 0; $i < $cpt; $i++){
      if ($i % $rapport) $data[$i] = "";
    }
     
    return $data;
  }
  /**
  * Obtient un tableau des rgions (pour les bases agrges)
  *
  */
  function getRegions(){
    $et = new ensTableBrioche("dossiers", 1, "region", 0, $this->idsession, 0, 0, true);
    $tet = $et->getTableau();
    return $tet; 
  }
}
?>