<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Textes de messages prdfinis
* @package accessoires
*/
/**
* Textes de messages prdfins
* @package accessoires
* @author ob
*/
class textesMessages extends connexionBrioche{
  /**
  * accs aux variables de configuration
  * @var object briocheIni
  */
  var $ini;
  
  /**
  * le type du message
  * @var string
  */
  var $type;
  
  /**
  * un tableau de paramtres  inclure dans le message
  * @var array
  */
  var $params;
  
  /**
  * le destinataire
  * @var string
  */
  var $to;

  
  /**
  * @param string type cf. variable de classe
  * @param array params cf. variable de classe
  * @param string to cf. variable de classe
  * @param string sessionid l'identifiant de session
  * @param array autspec le tableau des autorisations spcifiques
  */
  function textesMessages($type, $params, $to, $sessionid, $autspec=0){
    if (! $this->connexionBrioche($sessionid, $autspec)) return;
    $this->ini = new briocheIni();
    $this->type = $type;
    $this->params = $params;
    $this->to = $to;  
  }
  
  /**
  * renvoie le texte du message
  * @return string
  */
  function getTexte(){
    switch($this->type){
    case 1: //Confirmation annonce lit  EMS
      $texte = "Bonjour,\r\n\r\nLe BRIO " . $this->ini->nomBrio . " a bien reu votre annonce de lit. " .
      "Elle sera traite dans dlais les plus brefs.\r\n\r\n" .
      "Pour mmoire :\r\n\r\n".
      "NUMERO DE REFERENCE : " . $this->params[0] . "\r\n" .
      "ANNONCEUR : " . $this->params[1] . "\r\n" .
      "DATE DE L'ENVOI : " . $this->aujourdhui() . "\r\n" .
      "LIT LIBRE DEPUIS : " . $this->params[2] . "\r\n" .
      "TYPE DE SEJOUR : " . $this->typesejour($this->params[3]) . "\r\n" .
      "SEXE : " . $this->sexelit($this->params[4]) . "\r\n" .
      "NB. LITS DANS LA CHAMBRE : " . $this->params[5] . ($this->params[5] == 3 ? " ET PLUS" : "") . "\r\n" .
      "INDICATIONS COMPLEMENTAIRES : " . $this->params[6] . "\r\n";
      break;
    case 2: //Avertissement au BRIO lors d'une annonce par WEB
      $texte = "Bonjour,\r\n\r\nUne annonce de lit vient d'tre transmise par Internet. Vous pourrez la " .
      "valider la prochaine fois que vous vous connecterez  Brioche.\r\n\r\n" .
      "Pour mmoire :\r\n\r\n".
      "NUMERO DE REFERENCE : " . $this->params[0] . "\r\n" .
      "ANNONCEUR : " . $this->params[1] . "\r\n" .
      "ETABLISSEMENT : " . $this->params[7] . "\r\n" .
      "DATE DE L'ENVOI : " . $this->aujourdhui() . "\r\n" .
      "LIT LIBRE DEPUIS : " . $this->params[2] . "\r\n" .
      "TYPE DE SEJOUR : " . $this->typesejour($this->params[3]) . "\r\n" .
      "SEXE : " . $this->sexelit($this->params[4]) . "\r\n" .
      "NB. LITS DANS LA CHAMBRE : " . $this->params[5] . ($this->params[5] == 3 ? " ET PLUS" : "") . "\r\n" .
      "INDICATIONS COMPLEMENTAIRES : " . $this->params[6] . "\r\n";
      break;
    case 3: //Confirmation demande d'orientation
      $texte = "Bonjour, \r\n\r\nLe BRIO " . $this->ini->nomBrio . " a bien reu votre demande d'orientation. " .
      "Elle sera traite dans les dlais les plus brefs. \r\n\r\n" .
      "Pour mmoire :\r\n\r\n" .
      "NUMERO DE REFERENCE : " . $this->params[0] . "\r\n" .
      "Vous pouvez consulter le dtail des donnes transmises en vous connectant  Brioche.";
      break;
    case 4: //Avertissement au BRIO lors d'une demande par WEB
      $texte = "Bonjour, \r\n\r\nUne demande d'orientation vient d'tre transmise par Internet: Vous pourrez la " .
      "valider la prochaine fois que vous vous connecterez  Brioche.\r\n\r\n" .
      "NUMERO DE REFERENCE : " . $this->params[0] . "\r\n" .
      "SERVICE PLACEUR : " . $this->params[1] . "\r\n" .
      "DEMANDE FAITE PAR : " . $this->params[2] . "\r\n";
      break;
    case 5: // Avertissement  l'administrateur au cas o deux dossiers sont ouverts pour un usager
      $texte = "Bonjour, \r\n\r\nUn contrle fait apparatre que plusieurs dossiers sont simultanment ouverts pour " .
      "le ou les usagers suivants :\r\n\r\n" . $this->params[0] .
      "\r\n\r\nBRIO concern : " . $this->params[1] . "\r\n";
      break;
    }
    return $texte;
  }
  
  /**
  * renvoie le type du sjour  partir de l'identifiant
  * @param int type l'identifiant
  * @return string
  */
  function typesejour($type){
    $requete = "SELECT ttypesej FROM typesejour WHERE idts = $type";
    $result = mysql_query($requete);
    if (! $result) return "";
    $ligne = mysql_fetch_row($result); 
    return $ligne[0];    
  }
  
   
  /**
  * renvoie le texte du lit  partir de l'identifiant
  * @param int type l'identifiant
  * @return strint
  */
  function sexelit($type){
    $requete = "SELECT sexe FROM sexelit WHERE idsexe = $type";
    $result = mysql_query($requete);
    if (! $result) return "";
    $ligne = mysql_fetch_row($result);
    return $ligne[0];
  }
  
  /**
  * renvoie le texte du sujet du message en fonction du type
  * @return string
  */
  function getSujet() {
    switch($this->type){
    case 1:
    case 2:  
      $sujet = "Annonce de lit " . $this->params[0];
      break;
    case 3:
    case 4:  
      $sujet = "Demande d'orientation " . $this->params[0];
    break;    
    case 5:
      $sujet = "DOSSIERS MULTIPLES POUR UN USAGER - " . $this->params[1];
    }
    return $sujet;
  }
  
  /**
  * renvoie le champ from du message en fonction du type
  * @return string
  */
  function getFrom(){
    switch($this->type){
    case 1:
    case 2:  
    case 3:
    case 4:
    case 5:  
      $from = "From: " . $this->ini->adresseBrio;
      break;
    }
    return $from;
  }
  
  /**
  * envoi du message
  * @return boolean l'envoi s'est-il bien pass ?
  */
  function envoie(){
    return mail($this->to, $this->getSujet(), $this->getTexte(), $this->getFrom());
  }
}
?>
