<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Ensemble permettant de mettre  jour une table
* @package donnes
*/
/**
* Ensemble permettant de mettre  jour une table
* Mise  jour d'un enregistrement, ajout d'un enregistrement (lorsqu'il n'est pas ncessaire
* de disposer de son identifiant), destruction d'un enregistrement)
* @package donnes
* @author ob thn
*/
class updateTableBrioche extends connexionBrioche {
  /**
  * le nom de la table
  * @var string
  */
  var $nomtable;
  
  /**
  * le tableau associatif dont les cls sont les noms des champs  mettre  jour et le contenu les valeurs
  * correspondantes
  * @var array
  */
  var $tabchamps;
  
  /**
  * un identifiant unique pour l'enregistrement
  * (il est aussi possible de passer un tableau de valeurs)
  * @var mixed 
  */
  var $item;
  
  /**
  * le champ correspondant  l'identifiant fourni
  * @var string
  */
  var $primaire;
  
  /**
  * une variable "autocheckboxes" poste par un formulaire contenant des cases  cocher ou des boutons radio
  * @var string
  */
  var $autocheckboxes;
  
  /**
  * le nombre d'enregistrement affects (en principe 1 si les paramtres sont corrects)
  * @var int
  */
  var $affected;
  
  /**
  * le texte de la requte update
  * @var string
  */
  var $sql;

  /**
  * la clause where
  * @var string
  */
  var $where;
  
  /**
  * @param string nomtable cf. variable de classe
  * @param array tabchamps cf. variable de classe
  * @param mixed item cf. variable de classe
  * @param string primaire cf. variable de classe
  * @param string sessionid l'identifiant de session
  * @param string autocheckboxes cf. variable de classes
  * @param array autspec le tableau des autorisations spcifiques
  */
  function __construct($nomtable, $tabchamps, $item=0, $primaire=0, $sessionid,
                              $autocheckboxes = "", $autspec=0){
    if (! parent::__construct($sessionid, $autspec)) return;
    $this->nomtable = $nomtable;
    $this->tabchamps = $tabchamps;
    $this->item = $item;
    $this->primaire = $primaire;
    $this->autocheckboxes = $autocheckboxes;
    $this->setWhere();
  }

  /**
  * dfinition de la clause where
  * Si scalaire, on a simplement $this->primaire = $this->item
  * Si tableau, les valeurs du tableau constituent une fonction IN()
  * Si tableau[-1] = true, les valeurs des index >= 0 constituent une fonction NOT IN()
  * Tableau[-2] peut contenir une clause AND
  */
  function setWhere(){
    if (! is_array($this->item)){
      $this->where = "$this->primaire = \"$this->item\"";
    }
    else {
      $not = false;
      $and = false;
      $chaine = "";
      foreach($this->item as $index => $valeur){
        if ($index == -1){
          if ($valeur) $not = true;
        }
        elseif($index == -2){
          $and = $valeur;
        }
        else {
          $chaine .= "$valeur, ";
        }
      }
      
      $chaine = substr($chaine, 0, - 2);
      $chaine = "$this->primaire " . ($not ? "NOT " : "") . "IN($chaine) " . ($and ? " AND $and" : "");
      $this->where = $chaine;
    }
  }
  
  /**
  * dfinition du tableau des champs  modifier
  * @param array tabchamps le tableau
  */
  function setTabChamps($tabchamps){
    $this->tabchamps = $tabchamps;
  }

  /**
  * dfinition du nom de la table
  * @param string nomtable le nom de la table
  */
  function setTable($nomtable) {
    $this->nomtable = $nomtable;
  }

  /**
  * dfinition du champ de l'identifiant unique
  * @param string nomchamp le nom du champ
  */
  function setPrimaire($nomchamp){
    $this->primaire = $nomchamp;
    $this->setWhere();
  }
  
  /**
  * dfinition de l'identifiant unique
  * @param mixed item l'identifiant
  */
  function setItem($item) {
    $this->item = $item;
    $this->setWhere();
  }
  
  /**
  * excution de la mise  jour
  * @return int le nombre d'enregistrements affects
  */
  function update(){
    //Rcupration des noms et types de champs de la table
    if ($this->n_erreur) return;
    if ($this->autocheckboxes != ""){
      $tabcb = explode(";", substr($this->autocheckboxes, 0, -1));  //liste des checkboxes
      $nbt = count($tabcb);
    }
    else {
      $nbt = 0;
    }
    $types = $this->getTypes();
    //print_r($types);
    $tailles =  $this->getTailles();
    //Rdaction de la requte de mise  jour
    
    $requete = "UPDATE $this->nomtable SET tst = NOW(), ";
    if (! is_array($this->tabchamps)) return true; //rien  mettre  jour, donc on arrte ici sans gnrer d'erreur
    while(list($cle, $valeur) = each($this->tabchamps)){
      if ($this->checkChamp($cle)){
        $requete .= "$cle = " . $this->metEnFormeUpd($cle, $valeur, $types, $tailles) . ", ";
      }
    }

    if ($nbt) {
      for ($i = 0; $i < $nbt; $i++){  //checkboxes qui sont  0
        $nn = explode("[", $tabcb[$i]);
        $nn = substr($nn[1], 0, -1);
        if(! isset($this->tabchamps[$nn])){
          $requete .= $nn . " = 0, ";
        }
      }
    }

    $requete = substr(trim($requete), 0, -1);
    $requete .= " WHERE $this->where";
    //print "RU :" . $requete . "<BR>";
    $this->sql = $requete;
    $result = mysqli_query($this->linkBrioche, $requete);
    //print mysqli_error($this->linkBrioche);
    //$this->affected = mysqli_affected_rows($this->linkBrioche);
    return $result;
    
  }

  /**
  * ce champ existe-t-il dans la table ?
  * @param string nom le nom de champ  contrler
  * @return boolean
  */
  function checkChamp($nom){
    $rep = false;
    $requete = "SELECT * FROM $this->nomtable LIMIT 1";
    //print $requete;
    $result = mysqli_query($this->linkBrioche, $requete);
    //$nb = mysqli_num_fields($result);
    while ($fld = mysqli_fetch_field($result)){
      if ($fld->name == $nom){
        $rep = true;
        break;
      }
    }
    return $rep;
  }

  /**
  * renvoie le tableau des tailles des champs
  * @return array
  */
  function getTailles() {
    $requete = "SELECT * FROM $this->nomtable LIMIT 1";
    $result = mysqli_query($this->linkBrioche, $requete);
    //$nb = mysql_num_fields($result);
    while ($fld = mysqli_fetch_field($result)){
      $tailles[$fld->name] = $fld->length;
    }
    return $tailles;
  }

  /**
  * renvoie le tableau des types des champs
  * @return array
  */
  function getTypes(){
    $requete = "SELECT * FROM $this->nomtable LIMIT 1";
    $result = mysqli_query($this->linkBrioche, $requete);
    //print $requete;
    //$nb = mysql_num_fields($result);
    while ($fld = mysqli_fetch_field($result)){
      $types[$fld->name] = $fld->type;
    }
    return $types;
  }

  /**
  * ajout d'un enregistrement (si l'on dsire connatre l'identifiant du nouvel enregistrement,
  * il faut utiliser les mthodes de ensTableBrioche
  * @return boolean l'ajout s'est-il bien pass ?
  */
  function ajouteEnr(){
    if ($this->n_erreur) return false;
    $types = $this->getTypes();
    $tailles = $this->getTailles();
    $requete = "INSERT INTO $this->nomtable SET tst = NOW(), ";
    reset($this->tabchamps);
    //print_r($this->tabchamps);
    while(list($cle, $valeur) = each($this->tabchamps)){
      if($this->checkChamp($cle)){
        $requete .= "$cle = " . $this->metEnFormeUpd($cle, $valeur, $types, $tailles) . ", ";
      }
    }
    $requete = substr(trim($requete), 0, -1);
    //print "RR : $requete<BR>\n";
    $result = mysqli_query($this->linkBrioche, $requete);
    //echo mysqli_error($this->linkBrioche);
    return $result;
  }

  /**
  * mise  jour ponctuelle d'un champ
  * @param string champ le nom du champ
  * @param mixed valeur la valeur  crire
  * @param string where la clause where pour la mise  jour
  * @param boolean numerique le champ  mettre  jour est-il numrique ?
  */
  function updateSpec($champ, $valeur, $where, $numerique=true){
    $requete = "UPDATE $this->nomtable SET $champ = " . ($numerique ? "$valeur" : "\"$valeur\"") .
               " WHERE $where";
    //print $requete;
    $result = mysqli_query($this->linkBrioche, $requete);
    return $result;
  }

  /**
  * destruction d'un enregistremsnt
  * @return boolean l'enregistrement a-t-il t dtruit ?
  */
  function detruitEnr(){
    $requete = "DELETE FROM $this->nomtable WHERE  $this->where";
    //print $requete;
    $result = mysqli_query($this->linkBrioche, $requete);
    return $result;
  }
  
  /**
  * verrouillage de la table
  * @param string type 'r'|'w' 
  * @return boolean le verrouillage s'est-il bien pass ?
  */
  function lock($type){
    $tab = array('r', 'w');
    if (! in_array($type, $tab)) return false;
    $requete = "LOCK TABLE $this->nomtable " . ($type == 'r' ? "READ" : "WRITE");
    $result = mysqli_query($this->linkBrioche, $requete);
    return $result;
  }
  
  /**
  * dverrouillage des tables
  * @return boolean le dverrouillage s'est-il bien pass ?
  */
  function unlock(){
    $requete = "UNLOCK TABLES";
    $result = mysqli_query($this->linkBrioche, $requete);
    return $result;
  }
  
  /**
  * destruction de tous les enregistrements
  * @return boolean la destruction s'est-elle produite ?
  */
  function detruitTout(){
    $requete = "DELETE FROM $this->nomtable";
    $result = mysqli_query($this->linkBrioche, $requete);
    return $result;
  }
  
  /**
  * contrle qu'un champ a t post
  * @param string champ le nom du champ
  * @param string libelle le libell  afficher dans le message d'alerte
  */
  function controlePresence($champ, $libelle=0){
    if(isset($this->tabchamps[$champ]) && ($this->tabchamps[$champ]
       || $this->tabchamps[$champ] == "0")){
      return true;
    }
    else {
      if ($libelle){
        $al = new Alerte("Le champ \"$libelle\" est obligatoire !");
        $al->imprime();
      }
      return false;
    }
  }

  /**
  * modification d'une valeur de $this->tabchamps
  * @param string cle le nom de la cl
  * @param mixed val la valeur
  */
  function changeVal($cle, $val){
    $this->tabchamps[$cle] = $val;
  }
}


?>
