#!/usr/bin/php
<?php
// $Id: fichierIni.php,v 1.4 2017/12/04 20:42:02 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Crations de fichiers ini
* @package accessoires
*/
/**
* Cration de fichiers ini
* Gnration de fichiers ini en lisant si ncessaires d'anciens fichier et en en reprenant les options
* dj paramtres. Trs utile pour ne pas avoir  reparamtrer compltement les applications lors de mises 
*  jour tout en introduisant les nouveaux paramtres dans les fichiers ini
* Le fichier s'excute en ligne de commande
* <pre>
* Usage: php fichierIni.php [-i fichier_entre] -o fichier_sortie -t {b,h,c,m}
* option -t (type):
* b : fichier ini de BriocheWeb (en principe briocheIni.inc)
* h : fichier ini de Herms (en principe hermesIni.inc)
* c : fichier ini de radix (en principe briocheIni.inc)
* m : fichier ini de mange (en principe briocheIni.inc)
* t : fichier ini des services de radix (en principe briocheIni.inc)
* </pre>
* @package accessoires
* @author ob
*/
class fichierIni {
  /**
  * nom du fichier lu
  * @var string
  */
  var $input;
  
  /**
  * nom du fichier crit
  * @var string
  */
  var $output;
  
  /**
  * type (cf. doc de la classe)
  * @var string
  */
  var $type;
  
  /**
  * tableau associant le nom des paramtres  leur valeur
  * @var array
  */
  var $valeurs;
  
  /**
  * tableau associant le nom des paramtres  un commentaire explicatif qui sera insr dans le fichier ini
  * @var array
  */
  var $comments;
  
  /**
  * @param string output cf. variable de classe
  * @param string input cf. variable de classe
  * @param string type cf. variable de classe
  */
  function fichierIni ($output, $input, $type){
    $this->input = $input;
    $this->output = $output;	
    $this->type = $type;
   
    //Constitution d'une matrice par dfaut
    switch($this->type){
    case "b": //briocheIni.inc
      $valeurs['phpDir'] = '';
      $comments['phpDir'] = 'Le rpertoire principal de l\'application';
      $valeurs['classDir'] = '$this->phpDir/classes';
      $comments['classDir'] = 'Le rpertoire contenant les classes de Brioche';
      $valeurs['outilsDir'] = '$this->phpDir/outils';
      $comments['outilsDir'] = 'Le rpertoire contenant les outils graphiques';
      $valeurs['imagesDir'] = 'images';
      $comments['imagesDir'] = 'Le sous-rpertoire web contenant les images';
      $valeurs['fondAccueil'] = '#F4AF0C';
      $comments['fondAccueil'] = 'La couleur de fond de la page d\'accueil de Brioche';
      $valeurs['tstorig'] = '19700102000000';
      $comments['tstorig'] = 'Le tst des enregistrements  dtruire automatiquement';
      $valeurs['briocheHote'] = 'localhost'; 
      $comments['briocheHote'] = 'L\'adresse du serveur mySQL';
      $valeurs['briocheUser'] = 'brio';
      $comments['briocheUser'] = 'Un nom d\'utilisateur avec droits d\'criture sur la bd de Brioche. Doit tre diffrent de celui de la base d\'administration';
      $valeurs['briochePw'] = 'brio';
      $comments['briochePw'] = 'Le mot de passe correspondant  briocheUser';
      $valeurs['briocheBd'] = 'dbrio';
      $comments['briocheBd'] = 'La base de donnes principale de brioche';
      $valeurs['autReq'] = 'cBrio';
      $comments['autReq'] = 'L\'autorisation ncessaire pour accder aux dossiers en criture';
      $valeurs['autSpec[0]'] = 'annLit';
      $comments['autSpec[0]'] = 'L\'autorisation suffisant pour annoncer des lits';
      $valeurs['autSpec[1]'] = 'demOr';
      $comments['autSpec[1]'] = 'L\'autorisation suffisant pour faire des demandes d\'orientation';
      $valeurs['autSpec[2]'] = 'EMSCourSej';
      $comments['autSpec[2]'] = 'L\'autorisation suffisant pour les CS planifis (EMS)';
      $valeurs['autSpec[3]'] = 'gestAnnLit';
      $comments['autSpec[3]'] = 'L\'autorisation suffisant pour diter des annonces de lits';
      $valeurs['autSpec[4]'] = 'gestEtabl';
      $comments['autSpec[4]'] = 'L\'autorisation suffisant pour diter des tablissements';
      $valeurs['autSpec[5]'] = 'gestUsager';
      $comments['autSpec[5]'] = 'L\'autorisation suffisant pour diter des usagers';
      $valeurs['autSuppl[0]'] = 'briocheAdm';
      $comments['autSuppl[0]'] = 'L\'autorisation supplmentaire pour administration';
      $valeurs['autSuppl[1]'] = 'cSej';
      $comments['autSuppl[1]'] = 'L\'autorisation supplmentaire pour courts sjours planifis';
      $valeurs['autSuppl[2]'] = 'statsR';
      $comments['autSuppl[2]'] = 'L\'autorisation supplmentaire pour accder aux statistiques R';
      $valeurs['autSuppl[3]'] = 'statsIUMSP';
      $comments['autSuppl[3]'] = 'L\'autorisation supplmentaire pour pouvoir extraire des fichiers de donnes brutes';
      $valeurs['autSuppl[4]'] = 'recIB';
      $comments['autSuppl[4]'] = 'L\'autorisation supplmentaire pour pouvoir recevoir des demandes interBRIOs';
      $valeurs['autSuppl[5]'] = 'envIB';
      $comments['autSuppl[5]'] = 'L\'autorisation supplmentaire pour pouvoir envoyer des demandes interBRIOs';
      $valeurs['autSuppl[6]'] = 'tabBord';
      $comments['autSuppl[6]'] = 'L\'autorisation supplmentaire pour accder aux tableaux de bord';
      $valeurs['passSulid'] = 0;
      $comments['passSulid'] = 'Activation de la passerelle SuLiD';
      $valeurs['sulidURL'] = 'https://pompaples.polenord.ch/sulid/lib/versSulid.php3';
      $comments['sulidURL'] = 'L\'URL de la passerelle SuLiD';
      $valeurs['sulidUtil'] = '';
      $comments['sulidUtil'] = 'Un nom d\'utilisateur valide pour l\'application SuLiD';
      $valeurs['sulidMdp'] = '';
      $comments['sulidMdp'] = 'Le mot de passe correspondant';
      $valeurs['sulidReseau'] = '';
      $comments['sulidReseau'] = 'Un nom d\'utilisateur valide pour la passerelle SuLiD';
      $valeurs['sulidReseauMdp'] = '';
      $comments['sulidReseauMdp'] = 'Le mot de passe correspondant';
      $valeurs['copNotes'] = 1;
      $comments['copNotes'] = 'Copie des notes dans les dossiers ouverts automatiquement';
      $valeurs['copEMS'] = 1;
      $comments['copEMS'] = 'Copie des prchoix d\'EMS dans les dossiers ouverts automatiquement';
      $valeurs['groupeEMSCS'] = 'EMSCS';
      $comments['groupeEMSCS'] = 'Groupe utilisateurs EMS pour gestion courts sjours';
      $valeurs['groupeCBRIO'] = 'CBRIO';
      $comments['groupeCBRIO'] = 'Groupe utilisateurs "Collaborateurs BRIO"';
      $valeurs['groupeDEVBRI'] = 'DEVBRI';
      $comments['groupeDEVBRI'] = 'Groupe exprimental pour dveloppement';
      $valeurs['groupeRESPBRI'] = 'RESPBRI';
      $comments['groupeRESPBRI'] = 'Groupe utilisateurs "Responsable BRIO"';
      $valeurs['groupeEMS'] = 'EMS';
      $comments['groupeEMS'] = 'Groupe utilisateurs "EMS"';
      $valeurs['groupeSERVP'] = 'SERVP';
      $comments['groupeSERVP'] = 'Groupe utilisateurs "Service placeur"';
      $valeurs['groupeTOUT'] = 'TOUT';
      $comments['groupeTOUT'] = 'Groupe disposant de tous les privilges';
      $valeurs['repSauvegarde'] = '';
      $comments['repSauvegarde'] = 'Rpertoire pour les sauvegardes quotidiennes';
      $valeurs['nomBrio'] = 'ESSAI';
      $comments['nomBrio'] = 'Le nom du BRIO';
      $valeurs['adresseBrio'] = '';
      $comments['adresseBrio'] = 'L\'adresse e-mail du BRIO';
      $valeurs['adresseAdministrateur'] = '';
      $comments['adresseAdministrateur'] = 'L\'adresse e-mail de l\'administrateur';
      $valeurs['planningEmails'] = '';
      $comments['planningEmails'] = 'Spares par un point-virgule, les adresses des destinataires du document pdf rsumant le planning des courts-sjours.';
      $valeurs['typeMailer'] = 'smtp';
      $comments['typeMailer'] = 'Le type de serveur pour envoi par phpmailer : smtp | sendmail';
      $valeurs['hoteMailer'] = 'localhost';
      $comments['hoteMailer'] = 'Si smtp, l\'hote correspondant';
      $valeurs['debogage'] = 0;
      $comments['debogage'] = 'Mode dbogage : 0 pour exploitation, 1 pour tests';
      $valeurs['aideHote'] = '$this->briocheHote';
      $comments['aideHote'] = 'L\'adresse du serveur MySQL contenant la base d\'aide';
      $valeurs['aideUser'] = '$this->briocheUser';
      $comments['aideUser'] = 'Un utilisateur MySQL accdant  la base d\'aide';
      $valeurs['aidePw'] = '$this->briochePw';
      $comments['aidePw'] = 'Le mot de passe correspondant';
      $valeurs['aideBd'] = 'aidebrioche';
      $comments['aideBd'] = 'Le nom de la base d\'aide';
      $valeurs['utilScripts'] = 'cbrio';
      $comments['utilScripts'] = 'Utilisateur Brioche excutant les scripts de maintenance. Doit disposer d\'une autorisation lui permettant d\'ouvrir une session';
      $valeurs['passeScripts'] = 'cbrio';
      $comments['passeScripts'] = 'Le mot de passe correspondant';
      $valeurs['dmttrans'] = true;
      $comments['dmttrans'] = 'true affiche les radios dans Demande Brioche pour l\'info sur l\'envoi du DMT, false masque cette partie';
      $valeurs['supplement_ch_indiv'] = true;
      $comments['supplement_ch_indiv'] = 'true affiche les radios dans Demande Brioche pour l\'info sur le supplment pour la chambre individuelle';
      $valeurs['cookie_servplac'] = 1;
      $comments['cookie_servplac'] = 'true active, dans la demande d\'orientation, la mmorisation du service placeur par cookie';
      $valeurs['cookie_expiration'] = 1;
      $comments['cookie_expiration'] = 'Le nombre de jours au terme desquels le cookie expirera';
      $valeurs['avs'] = true;
      $comments['avs'] = 'true donne la possibilit d\'enregistrer le numro AVS de l\'usager, false masque ce champ ditable';
      $valeurs['deconnPartout'] = 1;
      $comments['deconnPartout'] = 'Affichage d\'une bote de dconnexion  toutes les pages';
      $valeurs['rep_r'] = "";
      $comments['rep_r'] = 'Le rpertoire des routines R';
      $valeurs['nomBrio_r'] = "";
      $comments['nomBrio_r'] = 'Le nom du BRIO utilise par les routines R';
      $valeurs['repExtraction_r'] = "";
      $comments['repExtraction_r'] = 'Le rpertoire pour l\'extraction des donnes brutes';
      $valeurs['repHtml_r'] = "";
      $comments['repHtml_r'] = 'Le rpertoire contenant les rapports statistiques au format html'; 
      $valeurs['version'] = '3.9';
      $comments['version'] = 'La version de BriocheWeb';
      $valeurs['instance'] = 'production';
      $comments['instance'] = 'Le type d\'instance correspondant  ce fichier de conf : production, test ou developpement';
      $valeurs['maxExcel'] = '2000';
      $comments['maxExcel'] = 'Le nombre maximum de lignes pour les feuilles de calculs';
      $valeurs['interbrio'] = 0;
      $comments['interbrio'] = 'Faut-il activer les fonctions interBRIOs ?';
      $valeurs['adresseInterBrio'] = '';
      $comments['adresseInterBrio'] = 'Mon adresse interBRIO (publique), utilise par tous';
      $valeurs['manegeURL'] = 'https://pompaples.polenord.ch/manege/manege.php';
      $comments['manegeURL'] = 'L\'URL du serveur SOAP manege';
      $valeurs['manegeUtil'] = '';
      $comments['manegeUtil'] = 'Le nom d\'utilisateur pour se connecter au serveur manege';
      $valeurs['manegePw'] = '';
      $comments['manegePw'] = 'Le mot de passe pour se connecter au serveur manege';
      $valeurs['manegeReleverAuLogin'] = 1;
      $comments['manegeReleverAuLogin'] = 'Faut-il relever les demandes interBRIOs au Login (mettre  zro si latence trop grande)';
      $valeurs['manegeReleverChaqueHeure'] = 0;
      $comments['manegeReleverChaqueHeure'] = 'Faut-il que l\'autoscript "heure" relve les demandes interBRIOs (mettre  1 si manegeReleverAuLogin a t mis  0';
      $valeurs['connectionActiveMQ'] = "";
      $comments['connectionActiveMQ'] = 'Adresse de connection  ActiveMQ - Mange 2.0';
      $valeurs['nomBrioActiveMQ'] = "";
      $comments['nomBrioActiveMQ'] = 'Le nom du BRIO pour activeMQ - Mange 2.0';
      $valeurs['connectionLDAP'] = "";
      $comments['connectionLDAP'] = 'Adresse de connection  LDAP';
      $valeurs['portLDAP'] = 389;
      $comments['portLDAP'] = 'Le numro de port pour se connecter  LDAP';
      $valeurs['batchLog'] = "";
      $comments['batchLog'] = 'Fichier de log du batch de rception des DMST';
      $valeurs['delaiDossiersInactifs'] = 'array("HAUTE" => 30, "MOYENNE" => 90, "BASSE" => 180)';
      $comments['delaiDossiersInactifs'] = 'Dlai utilis dans l\'affichage des dossiers en souffrance (en jours)';
      $valeurs['envoiDMSTactif'] = 0;
      $comments['envoiDMSTactif'] = 'activer la fonctionalit d\'envoi des DMST';
      break;
    case "h";  //hermesIni.inc
      $valeurs['bdMysql'] = 'adminbrio';
      $comments['bdMysql'] = 'Base de donnes Herms utilise par l\'application pour ses sessions';
      $valeurs['hoteMysql'] = 'localhost';
      $comments['hoteMysql'] = 'l\'adresse du serveur MySQL';
      $valeurs['utilMysql'] = 'adminbrio';
      $comments['utilMysql'] = 'Un utilisateur MySQL autoris';
      $valeurs['passeMysql'] = 'adminbrio';
      $comments['passeMysql'] = 'Le mot de passe correspondant';
      $valeurs['phpDir'] = '';
      $comments['phpDir'] = 'Le rpertoire principal de l\'application';
      $valeurs['classDir'] = '$this->phpDir/classes';
      $comments['classDir'] = 'Le rpertoire contenant les classes de Brioche';
      $valeurs['outilsDir'] = '$this->phpDir/outils';
      $comments['outilsDir'] = 'Le rpertoire contenant les outils graphiques';
      $valeurs['repSauvegarde'] = '';
      $comments['repSauvegarde'] = 'Rpertoire pour les sauvegardes quotidiennes';
      $valeurs['bdSauveSession'] = 'sauvesession';
      $comments['bdSauveSession'] = 'La base de donnes o sont sauves les sessions chues';
      $valeurs['hoteTechnique'] = 'localhost';
      $comments['hoteTechnique'] = 'L\'adresse du serveur MySQL contenant la base SauveSession';
      $valeurs['utilTechnique'] = 'technique';
      $comments['utilTechnique'] = 'Un utilisateur MySQL autoris';
      $valeurs['passeTechnique'] = 'technique';
      $comments['passeTechnique'] = 'Le mot de passe correspondant';
      $valeurs['repSauveSauveSession'] = '';
      $comments['repSauveSauveSession'] = 'Rpertoire dans lequel se fait la sauvegarde quodidienne de la base SauveSession';
      $valeurs['timeout'] = 1000;
      $comments['timeout'] = 'Le timeout de l\'application';
      $valeurs['deconnPartout'] = 1;
      $comments['deconnPartout'] = 'Affichage d\'une bote de dconnexion  toutes les pages';
      $valeurs['nomHermes'] = '';
      $comments['nomHermes'] = 'Un nom qui dcrit l\'instance d\'Herms dfinie pour ce fichier';
      $valeurs['instance'] = 'production';
      $comments['instance'] = 'Le type d\'instance : developpement, test ou production';
      $valeurs['version'] = '3.9';
      $comments['version'] = 'La version d\'Herms';
      break;
    case "c": //briocheIni.inc pour cabinet (radix)
      $valeurs['phpDir'] = '';
      $comments['phpDir'] = 'Le rpertoire principal de l\'application';
      $valeurs['classDir'] = '$this->phpDir/classes';
      $comments['classDir'] = 'Le rpertoire contenant les classes de Brioche';
      $valeurs['outilsDir'] = '$this->phpDir/outils';
      $comments['outilsDir'] = 'Le rpertoire contenant les outils graphiques';
      $valeurs['cabDir'] = '';
      $comments['cabDir'] = 'Le rpertoire contenant les fichiers "radix"';
      $valeurs['fichDir'] = '';
      $comments['fichDir'] = 'Le rpertoire contenant les fichiers tlchargs (attention aux droits d\'criture)';
      $valeurs['imagesDir'] = 'images';
      $comments['imagesDir'] = 'Le sous-rpertoire web contenant les images';
      $valeurs['fpdfDir'] = '$this->classDir/fpdf';
      $comments['fpdfDir'] = 'Le sous-rpertoire de la bibliothque pdf';
      $valeurs['tstorig'] = '19700102000000';
      $comments['tstorig'] = 'Le tst des enregistrements  dtruire automatiquement';
      $valeurs['briocheHote'] = 'localhost'; 
      $comments['briocheHote'] = 'L\'adresse du serveur mySQL';
      $valeurs['briocheUser'] = 'cabinet';
      $comments['briocheUser'] = 'Un nom d\'utilisateur avec droits d\'criture sur la bd de Brioche. Doit tre diffrent de celui de la base d\'administration';
      $valeurs['briochePw'] = 'cabinet';
      $comments['briochePw'] = 'Le mot de passe correspondant  briocheUser';
      $valeurs['briocheBd'] = 'cabinet';
      $comments['briocheBd'] = 'La base de donnes principale de brioche';
      $valeurs['tarmedHote'] = 'localhost';
      $comments['tarmedHote'] = 'Le serveur mySQL pour la base tarmed';
      $valeurs['tarmedUser'] = 'tarmed';
      $comments['tarmedUser'] = 'L\'utilisateur pour la base tarmed (doit tre diffrent de l\'utilisateur de la base principale de Brioche.';
      $valeurs['tarmedPw'] = 'tarmed';
      $comments['tarmedPw'] = 'Le mot de passe correspondant';
      $valeurs['tarmedBd'] = 'tarmed';
      $comments['tarmedBd'] = 'La base tarmed';
      $valeurs['autReq'] = 'cabDosEcr';
      $comments['autReq'] = 'L\'autorisation ncessaire pour accder aux dossiers en criture';
      $valeurs['autSpec[0]'] = '';
      $comments['autSpec[0]'] = '';
      $valeurs['autSuppl[0]'] = 'gfact';
      $comments['autSuppl[0]'] = 'L\'autorisation ncessaire pour accder au rcapitulatif des factures';
      $valeurs['autSuppl[1]'] = 'compta';
      $comments['autSuppl[1]'] = 'L\'autorisation ncessaire pour accder aux comptes courants et  la compta';
      $valeurs['repSauvegarde'] = '';
      $comments['repSauvegarde'] = 'Rpertoire pour les sauvegardes quotidiennes';
      $valeurs['nomBrio'] = 'ESSAI';
      $comments['nomBrio'] = 'Le nom du Serveur';
      $valeurs['adresseBrio'] = '';
      $comments['adresseBrio'] = 'L\'adresse e-mail de l\'utilisateur principal';
      $valeurs['adresseAdministrateur'] = '';
      $comments['adresseAdministrateur'] = 'L\'adresse e-mail de l\'administrateur';
      $valeurs['debogage'] = 0;
      $comments['debogage'] = 'Mode dbogage : 0 pour exploitation, 1 pour tests';
      $valeurs['longPage'] = 100;
      $comments['longPage'] = 'Nombre d\'enregistrement par pages (lors d\'affichage de listes)';
      $valeurs['typeDefaut'] = 8;
      $comments['typeDefaut'] = 'Le type de facture par dfaut, pour les nouveaux patients';
      $valeurs['aideHote'] = '$this->briocheHote';
      $comments['aideHote'] = 'L\'adresse du serveur MySQL contenant la base d\'aide';
      $valeurs['aideUser'] = '$this->briocheUser';
      $comments['aideUser'] = 'Un utilisateur MySQL accdant  la base d\'aide';
      $valeurs['aidePw'] = '$this->briochePw';
      $comments['aidePw'] = 'Le mot de passe correspondant';
      $valeurs['aideBd'] = 'aideradix';
      $comments['aideBd'] = 'Le nom de la base d\'aide';
      $valeurs['utilScripts'] = 'cbrio';
      $comments['utilScripts'] = 'Utilisateur Brioche excutant les scripts de maintenance. Doit disposer d\'une autorisation lui permettant d\'ouvrir une session';
      $valeurs['passeScripts'] = 'cbrio';
      $comments['passeScripts'] = 'Le mot de passe correspondant';
      $valeurs['tolerance'] = 1;
      $comments['tolerance'] = 'Diffrence tolre entre le montant d\'une facture et la somme encaisse';
      $valeurs['urlServices'] = 'http://radix.tarmed.info/services';
      $comments['urlServices'] = 'L\'URL pour les services radix (p. ex. la mise  jour du Tarmed)';
      $valeurs['mdpHachage'] = 'abcdef';
      $comments['mdpHachage'] = 'Chane utilise pour les hchages d\'anonymisation (CDC)';
      $valeurs['cdc_result_email'] = '';
      $comments['cdc_result_email'] = 'Adresse pour les e-mails du cdc';
      $valeurs['canton'] = 'VD';
      $comments['canton'] = 'Canton d\'mission des factures';
      $valeurs['xmlfactDir'] = '/var/spool/xmlradix';
      $comments['xmlfactDir'] = 'Rpertoire spool pour les factures xml';
      $valeurs['cdcAnonymise'] = 1;
      $comments['cdcAnonymise'] = 'Faut-il anonymiser les donnes transmises au CDC';
      $valeurs['cdcTest'] = 0;
      $comments['cdcTest'] = 'Compte test pour le cdc ?';
      $valeurs['cdcUrl'] = 'https://212.109.85.197//servlet/cdc.webserver.CDC_XmlUpload';
      $comments['cdcUrl'] = 'L\'URL du CDC';
      $valeurs['briochePayeDir'] = '$this->cabDir/briochepaye';
      $comments['briochePayeDir'] = 'Le rpertoire des fichiers "briochepaye"';
      $valeurs['urlClearing'] = 'http://www.sic.ch/tkicch_extern/download/bcbankenstamm.zip';
      $comments['urlClearing'] = 'L\'URL du fichier des N de clearing bancaires';
      $valeurs['idDTA'] = 'ABC';
      $comments['idDTA'] = 'Chaine personnelle  utiliser pour les fichiers DTA';
      $valeurs['deltaDTA'] = '0';
      $comments['deltaDTA'] = 'Nombre  ajouter  "id" de "ep_archives" pour le tien et le texte de "comptes"';
      $valeurs['raisonSoc'] = 'Dr...';
      $comments['raisonSoc'] = 'Raison sociale pour fichiers DTA';
      $valeurs['cpteTransit'] = 1010;
      $comments['cpteTransit'] = 'Un numro de compte transitoire pour le remboursement de factures';
      $valeurs['cpteResultat'] = 8000;
      $comments['cpteResultat'] = 'Un numro de compte pour l\'criture des rsultats lors du bouclement';
      $valeurs['cptePrive'] = 2102;
      $comments['cptePrive'] =  'Un numro de compte pour le capital (compte priv)';
      $valeurs['cpteDecouvert'] = 1500;
      $comments['cpteDecouvert'] = 'Un numro de compte pour le dcouvert';
      $valeurs['cpteBilan'] = 8100;
      $comments['cpteBilan'] = 'Un numro de compte pour le bilan';
      $valeurs['cpteSolde'] = 8101;
      $comments['cpteSolde'] = 'Un numro de compte pour les soldes (dbut d\'un nouvel exercice)';
      $valeurs['supplAuto'] = 1;
      $comments['supplAuto'] = 'Calcul automatique des supplments de la liste des analyses';
      $valeurs['medFam'] = 1;
      $comments['medFam'] = 'Ajout de la prestation de mdecine de famille  la consultation';
      $valeurs['scanServ'] = 'serveur.ici:143/notls';
      $comments['scanServ'] = 'Serveur imap pour bv scanns (cf. fonction php imap_open())';
      $valeurs['scanBal'] = 'INBOX';
      $comments['scanBal'] = 'Bote  lettres de rception, en principe INBOX (doit exister sur le serveur)';
      $valeurs['scanArch'] = "ARCH";
      $comments['scanArch'] = 'Bote  lettres d\'archivage (doit exister sur le serveur : sous-dossier)';
      $valeurs['scanUser'] = 'bvr';
      $comments['scanUser'] = 'Utilisateur mail (doit exister)';
      $valeurs['scanMdp'] = 'bla';
      $comments['scanMdp'] = 'Mot de passe de scanUser';
      $valeurs['version'] = '0.98';
      $comments['version'] = 'La version de radiX';
      break;
    case 'm': //briocheIni pour Manege (serveur SOAP);
      $valeurs['phpDir'] = '';
      $comments['phpDir'] = 'Le rpertoire principal de l\'application';
      $valeurs['classDir'] = '$this->phpDir/classes';
      $comments['classDir'] = 'Le rpertoire contenant les classes de Brioche';
      $valeurs['outilsDir'] = '$this->phpDir/outils';
      $comments['outilsDir'] = 'Le rpertoire contenant les outils graphiques';
      $valeurs['tstorig'] = '19700102000000';
      $comments['tstorig'] = 'Le tst des enregistrements  dtruire automatiquement';
      $valeurs['briocheHote'] = 'localhost';
      $comments['briocheHote'] = 'L\'adresse du serveur MySQL';
      $valeurs['briocheUser'] = 'manege';
      $comments['briocheUser'] = 'Un nom d\'utilisateur avec droits d\'criture sur la bd de Mange';
      $valeurs['briochePw'] = 'manege';
      $comments['briochePw'] = 'Le mot de passe correspondant';
      $valeurs['briocheBd'] = 'manege';
      $comments['briocheBd'] = 'La base de donnes de Mange';
      $valeurs['autReq'] = 'manege';
      $comments['autReq'] = 'L\'autorisation ncessaire pour fonctionner comme client Mange';
      $valeurs['autSpec[0]'] = 'postDmst';
      $comments['autSpec[0]'] = 'L\'autorisation suffisant pour poster des DMST';
      $valeurs['debogage'] = 0;
      $comments['debogage'] = 'Mode dbogage : 0 pour exploitation, 1 pour tests';
      $valeurs['utilDmst'] = 'pdmst';
      $comments['utilDmst'] = 'L\'utilisateur qui se connecte pour envoyer un DMST';
      $valeurs['mdpDmst'] = 'pdmst';
      $comments['mdpDmst'] = 'Le mot de passe correspondant';
      $valeurs['repSauvegarde'] = '';
      $comments['repSauvegarde'] = 'Le rpertoire de sauvegarde pour la base Mange';
      $valeurs['nomBrio'] = '';
      $comments['nomBrio'] = 'Le nom du serveur';
      $valeurs['adresseBrio'] = '';
      $comments['adresseBrio'] = 'L\'adresse pour les messages standard du serveur';
      $valeurs['adresseAdministrateur'] = '';
      $comments['adresseAdministrateur'] = 'L\'adresse de l\'administrateur';
      $valeurs['version'] = '3.7.2';
      $comments['version'] = 'La version';
      $valeurs['instance'] = 'production';
      $comments['instance'] = 'Le type d\'instance (production, test ou developpement)';
      break;
    case 't': //briocheIni pour les services de radix (mise  jour tarmed)
      $valeurs['phpDir'] = '';
      $comments['phpDir'] = 'Le rpertoire principal de l\'application';
      $valeurs['classDir'] = '$this->phpDir/classes';
      $comments['classDir'] = 'Le rpertoire contenant les classes de Brioche';
      $valeurs['outilsDir'] = '$this->phpDir/outils';
      $comments['outilsDir'] = 'Le rpertoire contenant les outils graphiques';
      $valeurs['cabDir'] = '';
      $comments['cabDir'] = 'Le rpertoire contenant les fichiers "radix"';
      $valeurs['tstorig'] = '19700102000000';
      $comments['tstorig'] = 'Le tst des enregistrements  dtruire automatiquement';
      $valeurs['briocheHote'] = 'localhost';
      $comments['briocheHote'] = 'L\'adresse du serveur MySQL';
      $valeurs['briocheUser'] = 'servradix';
      $comments['briocheUser'] = 'Un nom d\'utilisateur avec droits d\'criture sur la bd de service';
      $valeurs['briochePw'] = 'servradix';
      $comments['briochePw'] = 'Le mot de passe correspondant';
      $valeurs['briocheBd'] = 'tarmedserveur';
      $comments['briocheBd'] = 'La base de donnes de service';
       $valeurs['tarmedHote'] = 'localhost';
      $comments['tarmedHote'] = 'Le serveur mySQL pour la base tarmed';
      $valeurs['tarmedUser'] = 'tarmed';
      $comments['tarmedUser'] = 'L\'utilisateur pour la base tarmed (doit tre diffrent de l\'utilisateur de la base principale de Brioche.';
      $valeurs['tarmedPw'] = 'tarmed';
      $comments['tarmedPw'] = 'Le mot de passe corresondant';
      $valeurs['tarmedBd'] = '$this->briocheBd';
      $comments['tarmedBd'] = 'La base tarmed';
      $valeurs['autReq'] = 'servradix';
      $comments['autReq'] = 'L\'autorisation ncessaire pour fonctionner comme serveur';
      $valeurs['servicesUt'] = '';
      $comments['servicesUt'] = 'Un utilisateur herms disposant de l\'autorisation autReq';
      $valeurs['servicesMdp'] = '';
      $comments['servicesMdp'] = 'Le mot de passe correspondant';
      $valeurs['utilScripts'] = '$this->servicesUt';
      $comments['utilScript'] = 'L\'utilisateur excutant le script d\'importation tarmed';
      $valeurs['passeScripts'] = '$this->servicesMdp';
      $comments['passeScript'] = 'Le mot de passe correspondant';
      $valeurs['adresseBrio'] = '';
      $comments['adresseBrio'] = 'L\'adresse pour les messages standard du serveur';
      $valeurs['adresseAdministrateur'] = '';
      $comments['adresseAdministrateur'] = 'L\'adresse de l\'administrateur';
      $valeurs['version'] = '0.91';
      $comments['version'] = 'La version';
      $valeurs['instance'] = 'production';
      $comments['instance'] = 'Le type d\'instance (production, test ou developpement)';
      break;
    case "an":
      $valeurs['agregHost'] = 'pompaples.polenord.ch';
      $comments['agregHost'] = 'Machine o l\'agrgation se fait';
      $valeurs['agregUser'] = ''; 
      $comments['agregUser'] = 'Utilisateur sous lequel se logue scp pour accder  la machine d\'agrgation';
      $valeurs['agregPort'] = '9923';
      $comments['agregPort'] = 'Port ssh';
      $valeurs['agregDestPath'] = '';
      $comments['agregDestPath'] = 'Rpertoire sur la machine d\'agrgation o dposer le dump de la base normalise. Droit d\'criture pour agregUser ncessaire';
      $valeurs['localBRIOS'] = 'array("VEVEY","POMPAPLES", "PAYERNE", "AIGLE", "YVERDON")';
      $comments['localBRIOS'] = 'Liste des brios locaux  la machine d\'utilisation. Uniquelment utile pour utiliser cp au lieu de scp';
      $valeurs['destDir'] = '/tmp/briodump';
      $comments['destDir'] = 'Rpertoire o mettre les dumps de la bases de donnees: droit d\'criture ncessaire'.
      $valeurs['normalisePHPpath'] = '';
      $comments['normalisePHPpath'] = 'Rpertoire o se trouve le fichier de normalisation (normalise.php)';
      $valeurs['logFile'] = '';
      $comments['logFile'] = 'O se trouve le fichier de log: droit d\'criture ncessaire';
      $valeurs['dbuser'] = '';
      $comments['dbuser'] = 'Utilisateur pour la bd o se trouvent les bases brio et les bases de travail';
      $valeurs['dbpwd'] = '';
      $comments['dbpwd'] = 'mot de passe pour la bd';
      $valeurs['dbhost'] = 'localhost';
      $comments['dbhost'] = 'machine hote de la bd';	
      $valeurs['briochesInis'] = 'array("/chemin1/briocheIni.inc", "/chemin2/briocheIni.inc")';
      $comments['briochesInis'] = "Tableau des chemins complets des fichiers briocheIni.inc des instances  normaliser en local";
      break;
    case "ac":
      $valeurs['agregbase'] = "agregationBRIO";
      $comments['agregbase'] = "Nom de la base de donnes, qui doit exister AVANT le lancement du script";
      $valeurs['jumellebase'] = "agregationBIS";
      $comments['jumellebase'] = "Nom de la base jumelle, pour brancher brioche";
      $valeurs['hote'] = "localhost";
      $comments['hote'] = "Machine qui hberge la base";
      $valeurs['user'] = "nom";
      $comments['user'] = "Utilisiteur ayant les droits sur cette base et les bases de travail";
      $valeurs['pwd'] = "mdp";
      $comments['pwd'] = "Mot de passe pour user";
      $valeurs['prefixDB'] = "norm";
      $comments['prefixDB'] = "Prfixe des bases de travail";
      $valeurs['expectedNumDB'] = 7;
      $comments['expectedNumDB'] = "Nombre de BRIOs attendus au total";
      $valeurs['depotPath'] = "/chemin/vers/depot";
      $comments['depotPath'] = "Rpertoire o se trouvent les fichiers .sql des bases normalises"; 
      $valeurs['consolidatePHPpath'] = "/chemin/vers/executables/consolidation";
      $comments['consolidatePHPpath'] = "Rpertoire du script de consolidation";
      $valeurs['logfile'] = '$this->consolidatePHPpath/brioche-agregation.log';
      $comments['logfile'] = "O mettre le fichier de log";
      $valeurs['normalisePath'] = "/vers/normalisation";
      $comments['normalisePath'] = "Rpertoire des scripts de normalisation";
      $valeurs['brios[1][\'nom\']'] = "POMPAPLES";
      $comments['brios[1][\'nom\']'] = "Tableau des BRIOS, avec nom, offset et rgion";
      $valeurs['brios[1][\'offset\']'] = 0;
      $valeurs['brios[1][\'region\']'] = "NORD";
      $valeurs['brios[2][\'nom\']'] = "PAYERNE";
      $valeurs['brios[2][\'offset\']'] = 5000000;
      $valeurs['brios[2][\'region\']'] = "NORD";
      $valeurs['brios[3][\'nom\']'] = "YVERDON";
      $valeurs['brios[3][\'offset\']'] = 10000000;
      $valeurs['brios[3][\'region\']'] = "NORD";
      $valeurs['brios[4][\'nom\']'] = "VEVEY";
      $valeurs['brios[4][\'offset\']'] = 15000000;
      $valeurs['brios[4][\'region\']'] = "EST";
      $valeurs['brios[5][\'nom\']']= "AIGLE";
      $valeurs['brios[5][\'offset\']'] = 20000000;
      $valeurs['brios[5][\'region\']'] = "EST";
      $valeurs['brios[6][\'nom\']'] = "ROLLE";
      $valeurs['brios[6][\'offset\']'] = 25000000;
      $valeurs['brios[6][\'region\']'] = "OUEST";
      $valeurs['brios[7][\'nom\']'] = "LAUSANNE";
      $valeurs['brios[7][\'offset\']'] = 30000000;
      $valeurs['brios[7][\'region\']'] = "CENTRE";
      break;
    }	
    $this->valeurs = $valeurs;
    $this->comments = $comments;
    //Lecture du fichier input
    if ($this->input){
      $matrInput = $this->litInput();
      foreach($matrInput as $pari => $vali){
        $this->valeurs[$pari] = $vali;
      }
    }
    //print_r($matr->input);
    // Ecriture d'un fichier
    if (file_exists($this->output)){
      rename($this->output, $this->output . ".sauv");
    }
    $classes = array('b' => 'briocheIni',
                     'h' => 'hermesIni',
                     'm' => 'briocheIni',
                     't' => 'briocheIni',
                     'c' => 'briocheIni',
                     'an' => 'normalisationTechIni',
                     'ac' => 'agregationIni'
                     );
    $nomClasse = $classes[$this->type];
    $nfich = fopen($this->output, "w");
    $titres = array ('b' => "Brioche",
                     'h' => "Herms",
                     'm' => "Mange",
                     't' => "Services radix",
                     'c' => "radix",
                     'an' => "Brioche - agrgation",
                     'ac' => "Brioche - agrgation"
                     );
    fwrite($nfich, "<?php\n".
                   "## Ce programme est un logiciel libre soumis aux termes de la\n" .
                   "## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)\n".
                   "/////////////////////////////\n");
    fwrite($nfich, "//\n// Classe d'initialisation de " . 
                   $titres[$this->type] .
                   " - Contient les paramres de configuration.\n");
    fwrite($nfich, "// Gnration automatique par le script fichierIni.php.\n");
    fwrite($nfich, "//\n//////////////////////////////\n\n");
    fwrite($nfich, "class $nomClasse {\n");
    $tabcles = array();
    foreach($this->valeurs as $param => $val){
      //suppression ventuelle des [] pour pour dclaration de var;
      $impr = true;
      if(preg_match("/([^\[\]]*)\[[^\]]*\]/", $param, $matches)){
        $param = $matches[1];
        
        $cpt = count($tabcles);
        //print "CPT $cpt";
        for ($i = 0; $i < $cpt; $i++){
          if ($param == $tabcles[$i]){
            $impr = false;
          }
        }	
        $tabcles[] = $param;
      }	
      if ($impr){
        fwrite($nfich, '  var $' . $param . ";\n");
      }
    }	
    fwrite($nfich, "\n\n  function __construct() {\n");
    fwrite($nfich, "  // Les rpertoires sont  indiquer sans / final.\n");
    $i = 0;
    foreach($this->valeurs as $param => $val){
      $guill = "\"";
      if (preg_match("/^array/", $val)) $guill = "";
      fwrite($nfich, '    $this->' . $param . " = " . $guill . $val . $guill . ";     //" . $comments[$param] . "\n");
      $i++;
    }	
    fwrite($nfich, "  }\n");
    fwrite($nfich, "}\n");
    fwrite($nfich, "?>\n");
    fclose($nfich);
    print "$i entres crites...\n";
  }
  
  function litInput(){
    $ficIn = fopen($this->input, "r");	
    $i = 0;
    while (! feof($ficIn)){
      $ligne = fgets($ficIn);
      if (preg_match('/^[ \t]*\$this->([^= ]*)[ ]*=[ ]*["]{0,1}([^";]*)["]{0,1}[ ]*;/',
                    $ligne, $matches)){
        $param = $matches[1];
        $val = $matches[2];
        if ($param != 'version'){ // La variable version doit tre mise  jour et non conserve
          $matrIn[$param] = $val;
          $i++;
        }
      }	
      if (preg_match('/^[ \t]*\$this->([^= ]*)[ ]*=[ ]*(array[ ]*\([^)]*\))[ ]*;/',
                    $ligne, $matches) ){
        $param = $matches[1];
        $val = $matches[2];
        $matrIn[$param] = $val;
        $i++;
      }              
    }
    print "$i entres lues...\n";
    return $matrIn;	
  }



}


/**
* Bloc principal : analyse des paramtres passs en ligne de commande et instanciation de la classe
*/
$cpt = count($argv);
$usage = "Usage: php fichierIni.php [-i fichier_entre] -o fichier_sortie -t {b,h,c,m, an, ac}\n"; 
for($i = 1; $i < $cpt; $i++){
  if($argv[$i] == "-i"){
    if ($i+1 < $cpt && $argv[$i+1]){
      $params['i'] = $argv[$i+1];
    }
    else die ($usage);	
  }
  if ($argv[$i] == "-o"){
    if($i+1 < $cpt && $argv[$i+1]){
      $params['o'] = $argv[$i+1];
    }	 	
  }
  if ($argv[$i] == "-t"){
    if ($i+1 < $cpt && $argv[$i+1]){
      $params['t'] = $argv[$i+1];
    }
  }	
}

if ((! isset($params['t'])) || ($params['t'] != "b" && $params['t'] != "h" &&
   $params['t'] != "c" && $params['t'] != "m" && $params['t'] != "t" && $params['t'] != "an" 
   && $params['t'] != "ac")){
  print "Il faut indiquer le type de fichier : -t b pour briocheIni, -t h pour hermesIni, -t c pour radix, " .
        "-t t pour les services radix, -t an pour l'agrgation brioche (normalisation), " .
        "- t ac pour l'agrgation (consolidation).\n";
  die ($usage);
}	

if (isset($params['i'])){
  if (! file_exists($params['i'])){
    print "Le fichier entre spcifi n'existe pas.\n";
    die ($usage);
  }
  elseif(is_dir($params['i'])){
    print $params['i'] . " est un rpertoire.\n";
    die ($usage);
  }	
}  
else {
  $params['i'] = "";		
}

if (! isset ($params['o'])){
  print "Il faut indiquer le nom du fichier de sortie.\n";
  die ($usage);
}
else {
  if (file_exists($params['o'])){
    if (is_dir($params['o'])){
      print $params['o'] . " est un rpertoire.\n";
      die ($usage);
    }	
    print "Faut-il remplacer le fichier " . $params['o'] . " existant ? [o, N]\n";
    //ob_flush();
    $rep = fread(STDIN, 1);
    if (! ($rep == "o" || $rep == "O")){
      die ("Abandon...\n");	 
    }
  }	
}

$fini = new fichierIni($params['o'], $params['i'], $params['t']);

