<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Case  cocher lie  l'objet AutoCheckBox
* @package outils
*
*/
/**
* Case  cocher lie  l'objet AutoCheckBox
*
* Cette case peut tre utilise dans un formulaire fond sur une base de donnes. En l'ajoutant  un
* objet AutoCheckBox, on fait en sorte que la valeur -1 soit poste si la case est coche, et que la
* valeur 0 soit poste si la case n'est pas coche. Une telle correspondance n'est pas directement possible avec
* le champ HTML <INPUT TYPE ="checkbox"> car la valeur n'est poste que si la case est coche.
* Pratiquement, le champ AutoCase doit tre ajout  un contenant graphique de type TPanel et  un contenant "donnes"
* de type autocheckbox.
* <pre>
* Exemple :
* $formulaire = new OngForm();
* $acb = new AutoCheckBox();
* $c = new TPanel(1, 1);
* $x = new AutoCase("monnom", $mavaleur, "Case :");
* $c->addChamp($x);
* $acb->addCase($x);
* $c->addChamp($acb);
* $formulaire->addChamp($c);
* </pre>
* @author ob
* @package outils
*/
class AutoCase {
  /**
  * Le nom de la case
  * @var string
  */
  var $nom;
  /**
  * La valeur de la case (-1 pour coch et 0 pour non coch, ou une variable pouvant prendre l'une ou l'autre de ces valeurs)
  * @var int
  */
  var $valeur;
  /**
  * L'tiquette
  * @var string
  */
  var $label;
  /**
  * Faut-il un retour  la ligne aprs l'tiquette ?
  * @var boolean
  */
  var $br;
  /**
  * Le code javascript excut sur modification
  * @var string
  */
  var $onchange;

  /**
  * Indique s'il faut dsactiver ou non le champ
  * @var boolean
  */
  var $labellise;

  /**
  * @param string nom cf. variable de classe
  * @param int valeur cf. variable de classe
  * @param string label cf. variable de classe
  * @param boolean br cf. variable de classe
  * @param string onchange cf. variable de classe
  * @param boolean labellise cf. variable de classe
  */
  function __construct($nom, $valeur, $label = "",  $br=false, $onchange=0, $labellise = false){
    $this->nom = $nom;
    $this->valeur = $valeur;
    $this->label = $label;
    $this->br = $br;
    $this->onchange = $onchange;
    $this->labellise = $labellise;
  }

  /**
  * Renvoie le nom du champ
  * @access public
  * @return string le nom du champ
  */
  function getNom(){
    return $this->nom;
  }

  /**
  * Passe le contenu au contenant
  * En principe, est invoque par la mthode addChamp() du contenant
  * @access public
  * @return string le contenu du champ
  */
  function getContenu() {
    if (!$this->labellise) {
      $contenu = "<INPUT TYPE=\"checkbox\" NAME=\"$this->nom\" VALUE=\"-1\"" .
                 ($this->valeur == -1 ? " CHECKED" : "") .
                 ($this->onchange ? " OnChange=\"$this->onchange\"" : "") .
                 " onClick=\"this.blur()\";> $this->label&nbsp;&nbsp;&nbsp;" . ($this->br ? "<BR>" : "");
                 // Le onClick est rendu ncessaire par le fait que IExplorer ne gnre l'vnement onChange que
                 // lorsque le contrle perd le focus.        
    } else {
      $contenu = "<INPUT TYPE=\"hidden\" NAME=\"$this->nom\"  VALUE=\"".$this->valeur."\">" .
                 ($this->valeur == -1 ? "[<b>x</b>]&nbsp;" : "[&nbsp;]&nbsp;") .
                 $this->label . "&nbsp;&nbsp;&nbsp;" . ($this->br ? "<BR>" : "");
    }
    return $contenu;
  }
}
?>
