<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Bouton
* @package outils
*/
/**
* Bouton
*
* Affiche un bouton (ou un champ cach de formulaire).
* Doit tre inclus dans un contenant comme TPanel ou TPanelCadre
* <pre>
* Exemple :
* $c = new TPanel(1, 1);
* $x = new Bouton("Beau bouton", "Bravo !", "BUTTON", "alert(\"Bravo !\")");
* $c->addChamp($x);
* </pre>
* @author ob
* @package outils
*/

class Bouton {
  /**
  * Le nom du bouton
  * @var string
  */
  var $nom;

  /**
  * La valeur attriube au bouton dans le code HTML
  * @var mixed
  */
  var $valeur;

  /**
  * Le type du bouton (attribut HTML "TYPE")
  *
  * SUBMIT | RESET | BUTTON | HIDDEN
  * @var string
  */
  var $type;

  /**
  * Les instructions javascript excutes lors du clic sur BUTTON
  *
  * Attention : Utiliser des guillemets doubles chapps !
  * @var string
  */
  var $onClick;
  
  /**
  * La classe (style - CSS)
  * @var string
  */
  var $class;
  
  /**
  * L'ID du bouton
  * @var string
  */
  var $id;

  /**
  * @param string nom cf. variable de classe
  * @param mixed valeur cf. variable de classe
  * @param string type cf. variable de clase
  * @param string onclick cf. variable de classe
  * @param string class cf. variable de classe
  */
  function __construct($nom, $valeur, $type, $onClick = "", $class = "", $id = ""){
    $this->nom = $nom;
    $this->id = $id;
    $this->valeur = $valeur;
    $this->type = $type;
    $this->onClick = $onClick;
    $this->class = $class;

    if ($class == "") {
      if (preg_match("/button/i", $type) || preg_match("/submit/i", $type) || preg_match("/reset/i", $type)) {
        $this->class = "brioche_button";
      }
    }

   }

  /**
  * Passe le contenu au contenant
  * En principe, est invoque par la mthode addChamp() du contenant
  * @access public
  * @return string le contenu du champ
  */
  function getContenu() {
    $contenu = "\n<INPUT TYPE=\"$this->type\" NAME=\"$this->nom\" VALUE=\"$this->valeur\"" .
    ($this->onClick ? " onClick='$this->onClick'" : "") . 
    ($this->id ? " id='$this->id'" : "") . 
    ($this->class ? " CLASS=\"$this->class\"" : "") . ">\n";
    return $contenu;
  }
}
?>
