<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Bouton image
* @package outils
*/
/**
* Bouton image
*
* Affiche une image associe  un lien hypertexte. L'image devrait figurer un bouton
* Doit tre inclus dans un contenant comme TPanel ou TPanelCadre
* <pre>
* Exemple :
* $c = new TPanel(1, 1);
* $x = new BoutonImage("Appuyez", "images/vu.gif", 23, 23, "javascript:alert('bonjour !')");
* $c->addChamp($x);
* </pre>
* @author ob
* @package outils
*/
class BoutonImage{
  /**
  * Le contenu de la balise <ALT>
  * @var string
  */
  var $alt;
  /**
  * La source de l'image
  * @var string
  */
  var $src;
  /**
  * La largeur en pixels
  * @var int
  */
  var $largeur;
  /**
  * La hauteur en pixels
  * @var int
  */
  var $hauteur;
  /**
  * Le lien associ
  * @var string
  */
  var $lien;
  /**
  * Le nom du champ
  * @var string
  */
  var $nom;
  /**
  * La fentre cible
  *
  */
  var $target;
  /**
  * La proprit OnClick du lien
  *
  */
  var $onclick;
  /**
  * @param string alt cf. variable de classe
  * @param string src cf. variable de classe
  * @param string largeur cf. variable de classe
  * @param string hauteur cf. variable de classe
  * @param string lien cf. variable de classe
  * @param string nom cf. variable de classe
  * @param string target cf. variable de classe
  * @param string onclick cf. variable de classe
  */
  function __construct($alt, $src, $largeur, $hauteur, $lien, $nom="", $target="", $onclick=""){
    $this->alt = $alt;
    $this->src = $src;
    $this->largeur = $largeur;
    $this->hauteur = $hauteur;
    $this->lien = $lien;
    $this->nom = $nom;
    $this->target = $target;
    $this->onclick = $onclick;
  }

  /**
  * Passe le contenu au contenant
  * En principe, est invoque par la mthode addChamp() du contenant
  * @access public
  * @return string le contenu du champ
  */
  function getContenu(){
    $contenu = "\n<A HREF=\"$this->lien\" " . ($this->onclick ? "OnClick=\"$this->onclick\" " : "") .
              ($this->target ? "TARGET=\"$this->target\"" : "") .
               "><IMG ALT=\"$this->alt\" BORDER=0 WIDTH=\"$this->largeur\" " .
               "HEIGHT=\"$this->hauteur\" SRC=\"$this->src\"></A>\n";
    return $contenu;
  }
}

?>
