<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Bouton texte
* @package outils
*/
/**
* Bouton texte
*
* Affiche un bouton constitu d'une table dont la couleur de fond est paramtrable, avec un lien.
* Peut tre utilis en groupe de boutons contenus dans un objet GrTBoutonTexte
* ou dans un contenant de type TPanel.
* <pre>
* Exemple :
* $c = new TPanel(1, 1);
* $x = new BoutonTexte("Appuyez", "javascript:alert('bonjour !')", "red", 68, 23);
* $c->addChamp($x);
* </pre>
* @author ob
* @package outils
*/
class BoutonTexte {
  /**
  * L'tiquette
  * @var string
  */
  var $label;
  /**
  * Le lien hypertexte
  * @var string
  */
  var $lien;
  /**
  * La couleur de fond
  * @var string
  */
  var $couleur;
  /**
  * La largeur en pixels
  * @var int
  */
  var $largeur;
  /**
  * La hauteur en pixels
  * @var int
  */
  var $hauteur;
  /**
  * La valeur associe (lorsqu'utilis dans un groupe GrTBoutonTexte
  * @var mixed
  */
  var $valeur;

  /**
  * @param string label cf. variable de classe
  * @param string lien cf. variable de classe
  * @param string couleur cf. variable de classe
  * @param int largeur cf. variable de classe
  * @param int hauteur cf. variable de classe
  * @param mixed valeur cf. variable de classe
  */
  function __construct($label, $lien, $couleur, $largeur, $hauteur, $valeur=0){
    $this->label = $label;
    $this->lien = $lien;
    $this->couleur = $couleur;
    $this->largeur = $largeur;
    $this->hauteur = $hauteur;
    $this->valeur = $valeur;
  }

  /**
  * Passe le contenu au contenant
  * En principe, est invoque par la mthode addChamp() du contenant
  * @access public
  * @return string le contenu du champ
  */
  function getContenu(){
    $entete = "\n<TABLE WIDTH=\"$this->largeur\" HEIGHT=\"$this->hauteur\" BORDER=0 CELLPADDING=0 " .
              "CELLSPACING=0 BGCOLOR=\"$this->couleur\"><TR><TD ALIGN=\"CENTER\" VALIGN=\"CENTER\">";
    $pied = "</TD><TD WIDTH=1 BGCOLOR=\"#808080\"><IMG WIDTH=1 HEIGHT=1 ALT=\"\"></TD>".
            "<TD WIDTH=1 BGCOLOR=\"#ffffff\"><IMG WIDTH=1 HEIGHT=1 ALT=\"\"></TD></TR></TABLE>\n";
    if ($this->lien) {
      $TContenu = "<A HREF=\"$this->lien\">$this->label</A>";
    }
    else {
      $TContenu = $this->label;
    }
    return $entete . $TContenu . $pied;
  }
}

?>
