<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Champ date
* @package obsolte
*/
/**
* Champ date
*
* Affiche une table contenant trois champs texte pour le jour, le mois et l'anne d'une date
* Doit tre inclus dans un contenant comme TPanel ou TPanelCadre
* Obsolte : on prfrera n'utiliser qu'un champ texte pour les dates
* <pre>
* Exemple :
* $c = new TPanel(1, 1);
* $x = new ChampDate(1, 4, 1929, "jour", "mois", "annee");
* $c->addChamp($x);
* </pre>
* @author ob
* @package obsolte
*/
class ChampDate {
  /**
  * Le quantime
  * @var string
  */
  var $jour;
  /**
  * Le numro du mois (1-12)
  * @var int
  */
  var $mois;
  /**
  * L'anne (2 ou 4 chiffres)
  * @var int
  */
  var $annee;
  /**
  * Le nom du champ "jour"
  * @var string
  */
  var $chjour;
  /**
  * Le nom du champ "mois"
  * @var string
  */
  var $chmois;
  /**
  * Le nom du champ "anne"
  * @var string
  */
  var $channee;
  /**
  * Le timestamp de la date reprsente
  * @var int
  */
  var $montime;
  /**
  * Un tableau correspondant  la date reprsente (fonction php getdate())
  * @var array
  */
  var $madate;
  /**
  * @param string chjour cf. variable de classe
  * @param string chmois cf. variable de classe
  * @param string channee cf. variable de classe
  * @param int jour cf. variable de classe
  * @param int mois cf. variable de classe
  * @param int annee cf. variable de classe
  */
  function __construct($chjour, $chmois, $channee, $jour = "", $mois = "", $annee = ""){
    $this->jour = $jour;
    $this->mois = $mois;
    $this->annee = $annee;
    $this->chjour = $chjour;
    $this->chmois = $chmois;
    $this->channee = $channee;
  }

  /**
  * Controle de la date entre par le biais des trois champs
  * @return boolean true si date valable, false si date non valable
  * @access public
  */
  function controleDate(){
    if ($this->annee > 0 AND $this->mois > 0 AND $this->jour > 0) {
      if (strlen($this->annnee) < 4 AND $this->annee < 30){
        $this->annee += 2000;
      }
      if (!checkdate($this->mois, $this->jour, $this->annee)){
        return false;
      }
      else{
        $md = mktime(0,0,0,$this->mois, $this->jour, $this->annee);
        $this->montime = $md;
        $this->madate = getdate($md);
        return true;
      }
    }
    else {
      return false;
    }
  }

  /**
  * Retourne le timestamp de la date reprsente
  * @return int
  * @access public
  */
  function getMonTime(){
    if ($this->controleDate()){
      return $this->montime;
    }
    else {
      return "";
    }
  }

  /**
  * Retourne le tableau figurant la date reprsente (fonction getdate())
  * @return array
  * @access public
  */
  function getMaDate(){
    if ($this->controleDate()){
      return $this->madate;
    }
    else {
      return "";
    }
  }

  /**
  * Retourne la date reprsente sous la forme d'une chane aaaa-mm-jj utilisable dans une requte SQL
  * @return string
  * @access public
  */
  function getMysqlDate(){
    $md = $this->getMaDate();
    return $md['year']."-".$md['mon']."-".$md['mday'];
  }

  /**
  * Passe le contenu au contenant
  * En principe, est invoque par la mthode addChamp() du contenant
  * @access public
  * @return string le contenu du champ
  */
  function getContenu() {
    $entete = "";
    $pied = "";
    $contenu = "<TABLE BORDER = 0><TR><TD>jour</TD><TD>mois</TD><TD>ann&eacute;e</TD></TR>".
               "<TR><TD><INPUT TYPE=\"text\" NAME=\"$this->chjour\" VALUE=\"$this->jour\" SIZE=3 MAXLENGTH=2></TD>".
               "<TD><INPUT TYPE=\"text\" NAME=\"$this->chmois\" VALUE=\"$this->mois\" SIZE=3 MAXLENGTH=2></TD>".
               "<TD><INPUT TYPE=\"text\" NAME=\"$this->channee\" VALUE=\"$this->annee\" SIZE=5 MAXLENGTH=4></TD></TR></TABLE>";
    $contenu = $entete . $contenu . $pied;
    return $contenu;
  }
}
?>
