<?php
  // $Id: ChampTexte.inc,v 1.3 2017/12/04 20:42:02 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Champ texte
* @package outils
*/
/**
* Champ texte
*
* Affiche un champ texte
* Doit tre inclus dans un contenant comme TPanel ou TPanelCadre
* <pre>
* Exemple :
* $c = new TPanel(1, 1);
* $x = new ChampTexte("Rubrique", "?", "Votre nom: ", 12, 12, false, "text");
* $c->addChamp($x);
* </pre>
* @author ob
* @package outils
*/
class ChampTexte{
  /**
  * Le nom du champ
  * @var string
  */
  var $nom;
  /**
  * La valeur du champ
  * @var mixed
  */
  var $valeur;
  /**
  * La taille du champ (en nombre de caractres)
  * @var int
  */
  var $size;
  /**
  * La taille maximale du champ
  * @var int
  */
  var $maxlength;
  /**
  * Le label du champ
  * @var int
  */
  var $label;
  /**
  * Retour  la ligne : true s'il faut un retour  la ligne entre le label et le champ
  * @var boolean
  */
  var $br;
  /**
  * L'attribut "Type" de la balise INPUT (par dfaut "TEXT")
  * @var string
  */
  var $type;
  /**
  * L'attribut "Class" de la balise INPUT (style)
  * @var string
  */
  var $classe;
  /**
  * Javascript de l'vnement onBlur
  * @var string
  */
  var $onblur;
  /** Javascript de l'vnement onChange
  * @var string
  */
  var $onchange;
  /**
  * Labellisation : si true, le champ texte est transform en un label simple avec la valeur dans un champ cach
  * @var boolean
  */
  var $labellise;
  /**
  * ajouter un calendrier permettant la slection d'une date
  * @var boolean
  */
  var $calendrier;
  /**
  * ajouter un id
  * @var string
  */
  var $id;
  /**
  * @param string nom cf. variable de classe
  * @param mixed valeur cf. variable de classe
  * @param string label cf. variable de classe
  * @param int size cf. variable de classe
  * @param int maxlength cf. variable de classe
  * @param boolean br cf. variable de classe
  * @param string type cf. variable de classe
  * @param string class cf.variable de classe
  * @param string onblur cf. variable de classe
  * @param string onchange cf. variable de classe
  * @param string labellise cf. variable de classe
  * @param string calendrier cf. variable de classe
  * @param string id cf. variable de classe
  */
  function __construct($nom, $valeur, $label = "", $size, $maxlength, $br = false, $type = "TEXT", $classe = "",
                      $onblur= "", $onchange = "", $labellise = false, $calendrier = false){
    $this->nom = $nom;
    $this->valeur = $valeur;
    $this->size = $size;
    $this->maxlength = $maxlength;
    $this->label = $label;
    $this->br = $br;
    $this->type = $type;
    $this->classe = $classe;
    $this->onblur = $onblur;
    $this->onchange = $onchange;
    $this->labellise = $labellise;
    $this->calendrier = $calendrier;
  }

  /**
  * Passe le contenu au contenant
  * En principe, est invoque par la mthode addChamp() du contenant
  * @access public
  * @return string le contenu du champ
  */
  function getContenu() {
    $contenu = "";

    if ($this->label) {
      $bold_deb = "";
      $bold_fin = "";
      if ($this->labellise) {
        $bold_deb = "<B>";
        $bold_fin = "</B>";
      }
      $contenu = $bold_deb . $this->label . $bold_fin . "&nbsp;" .($this->br ? "<BR>" : "");
    }

    if (! $this->labellise) {
      $contenu .= "<INPUT ID=\"$this->nom\" TYPE=\"$this->type\" " . ($this->classe ? "CLASS=\"$this->classe\" " : "") .
                  ($this->onblur ? "OnBlur=\"$this->onblur\" " : "") . ($this->onchange ? "OnChange=\"$this->onchange\" " : "") .
                  "NAME=\"$this->nom\" VALUE=\"$this->valeur\" SIZE=\"$this->size\" MAXLENGTH=\"$this->maxlength\">\n";
      if ($this->calendrier) {
        require_once('Calendrier.inc');
        $contenu .= "<img align='absmiddle' style='cursor:pointer;' src=\"images/calendrier.gif\" onclick=\"pickDate(document.getElementById('$this->nom'), '', '', 'day_month_year', '.', 'true', 
                    'Jan.,Fv.,Mars,Avr.,Mai,Juin,Juil.,Aot,Sept.,Oct.,Nov.,Dc', 
                    'D,L,M,M,J,V,S', 'Aujourd\'hui', '');\"></img>";
      }
    }
    else {
      $contenu .= "$this->valeur <INPUT NAME=\"$this->nom\" VALUE=\"$this->valeur\" TYPE=\"HIDDEN\">\n";
    }
    return $contenu;
  }
}
?>
