<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Case  cocher
* @package outils
*/
/**
* Case  cocher
*
* Affiche une case  cocher
* Doit tre inclus dans un contenant comme TPanel ou TPanelCadre
* <pre>
* Exemple :
* $c = new TPanel(1, 1);
* $x = new Checkbox("case", 1);
* $c->addChamp($x);
* </pre>
* @author ob
* @package outils
*/
class CheckBox {
  /**
  * Nom du champ
  * @var string
  */
  var $name;
  /**
  * Valeur du champ (renvoye si la case est coche)
  * @var mixed
  */
  var $value;
  /**
  * Etiquette du champ
  * @var string
  */
  var $label;
  /**
  * La case est-elle coche ?
  * Le test n'est pas inclus dans l'objet
  * @var boolean
  */
  var $checked;
  /**
  * Faut-il un retour  la ligne entre l'tiquette et la case ?
  * @var boolean
  */
  var $br;
  /**
  * Les instructions javascript excutes sur changement.
  * @var string
  */
  var $onchange;
  /**
  * La position du label par rapport au checkbox.
  * @var string
  */
  var $positionLabel;

  /**
  * @param string name cf. variable de classe
  * @param mixed value cf. variable de classe
  * @param string label cf. variable de classe
  * @param boolean checked cf. variable de classe
  * @param boolean br cf. variable de classe
  * @param string onchange cf. variable de classe
  */
  function __construct($name, $value, $label = "", $checked = false, $br = false, $onchange="", $positionLabel = "apres"){
    $this->name = $name;
    $this->value = $value;
    $this->label = $label;
    $this->checked = $checked;
    $this->br = $br;
    $this->onchange = $onchange;
    $this->positionLabel = $positionLabel;
  }

  /**
  * Passe le contenu au contenant
  * En principe, est invoque par la mthode addChamp() du contenant
  * @access public
  * @return string le contenu du champ
  */
  function getContenu() {
    $contenu = 
    ($this->positionLabel == "avant" ? $this->label . "&nbsp;&nbsp;&nbsp;" : "") .
    "<INPUT TYPE=\"checkbox\" NAME=\"$this->name\" VALUE=\"$this->value\"" .
    ($this->checked ? " CHECKED" : "") .
    ($this->onchange ? " OnChange=\"$this->onchange\"" : "") . ">" .
    ($this->positionLabel == "apres" ? $this->label . "&nbsp;&nbsp;&nbsp;" : "") .
    ($this->br ? "<BR>" : "");
    return $contenu;
  }
}
?>
