<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Groupe de boutons texte
* @package outils
*/

/**
* Groupe de boutons texte
*
* Cet objet peut contenir plusieurs boutons texte. Ceux-ci sont mutuellement exclusifs si la valeur de
* $actif correspond  celle d'un des boutons contenus
* Tient lieu de contenant pour les boutons individuels (joue le mme rle que, par exemple, TPanel)
* <pre>
* Exemple :
* $c = new GrTBoutonTexte($actif, 6, 123, 22, "red", "white", 3);
* $c->addBouton("Et d'un", "http://par.ici", 1);
* $c->addBouton("Et de deux", "http://par.la", 2);
* $c->addBouton("Et de trois", "http://par.la.bas", 3);
* </pre>
* @author ob
* @package outils
*/
class GrTBoutonTexte {
  /**
  * Valeur dterminant le bouton actif
  * @var mixed
  */
  var $actif;
  /**
  * Le "colspan" du groupe dans la table qui le contient
  * @var int
  */
  var $colspan;
  /**
  * La largeur en pixels du groupe
  * @var int
  */
  var $largeur;
  /**
  * La hauteur en pixels du groupe
  * @var int
  */
  var $hauteur;
  /**
  * La couleur du bouton actif
  * @var string
  */
  var $couleuract;
  /**
  * La couleur des boutons inactifs (et donc activables)
  * @var string
  */
  var $couleurinact;
  /**
  * Le nombre total des boutons contenus (ncessaire pour calculer leur largeur);
  * @var int
  */
  var $nombre;
  /**
  * Le code html correspondant au groupe
  * @var string
  * @access private
  */
  var $contenu;

  /**
  * @param mixed actif cf. variable de classe
  * @param int colspan cf. variable de classe
  * @param int largeur cf. variable de classe
  * @param int hauteur cf. variable de classe
  * @param string couleuract cf. variable de classe
  * @param string couleurinact cf. variable de classe
  * @param int nombre cf. variable de classe
  */
  function __construct($actif, $colspan, $largeur, $hauteur, $couleuract, $couleurinact, $nombre) {
    $this->actif = $actif;
    $this->colspan = $colspan;
    $this->largeur = $largeur;
    $this->hauteur = $hauteur;
    $this->couleuract = $couleuract;
    $this->couleurinact = $couleurinact;
    $this->nombre = $nombre;
  }

  /**
  * Ajout d'un objet BoutonTexte au groupe
  * @param string label le label du bouton
  * @param string lien le lien hypertexte sous-jacent au bouton
  * @param mixed valeur la valeur associe au bouton,  mettre en rapport avec la variable de classe $actif
  */
  function addBouton($label, $lien, $valeur){
    if ($valeur == $this->actif) {
      $couleur = $this->couleuract;
      $lien = 0;
    }
    else {
      $couleur = $this->couleurinact;
    }
    $bt = new BoutonTexte($label, $lien, $couleur, intval($this->largeur/$this->nombre), $this->hauteur, $valeur);
    $this->contenu .= "<TD>" . $bt->getContenu() . "</TD>";
  }

  /**
  * Passe le contenu au contenant
  * En principe, est invoque par la mthode addChamp() du contenant
  * @access public
  * @return string le contenu du champ
  */
  function TGetContenu(){
    $entete = "<TD COLSPAN=$this->colspan><TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0><TR>";
    $pied = "</TR></TABLE>";
    return $entete . $this->contenu . $pied;
  }
}
?>
