<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Label
* @package outils
*/

/**
* Label
*
* Etiquette de texte simple
* Doit tre inclus dans un contenant comme TPanel ou TPanelCadre
* <pre>
* Exemple :
* $c = new TPanel(1, 1);
* $x = new Label("Bonjour !");
* $c->addChamp($x);
* </pre>
* @author ob
* @package outils
*/
class Label {
  /**
  * Le nom du champ
  * @var string
  */
  var $nom;
  /**
  * Le texte affich
  * @var sgring
  */
  var $valeur;
  /**
  * Le texte doit-il s'afficher en gras ?
  * @var boolean
  */
  var $gras;
  /**
  * Le texte doit-il s'afficher en italique ?
  * @var boolean
  */
  var $ital;
  /**
  * Faut-il un retour  la ligne aprs le label ?
  * @var boolean
  */
  var $br;
  /**
  * Couleur texte
  */
  var $couleur;
  /**
  * Style
  */
  var $classe;

  /**
  * @param string nom cf. variable de classe
  * @param string valeur cf. variable de classe
  * @param boolean gras cf. varlable de classe
  * @param boolean ital cf. variable de classe
  * @param boolean br cf. variable de classe
  * @param string couleur cf. variable de classe
  * @param string classe cf. variable de classe
  */
  function __construct($valeur, $gras = false, $ital = false, $br = false, $nom="", $couleur="", $classe=""){
    $this->nom = $nom;
    $this->valeur = $valeur;
    $this->gras = $gras;
    $this->ital = $ital;
    $this->br = $br;
    $this->couleur = $couleur;
    $this->classe = $classe;
  }
  /**
  * Passe le contenu au contenant
  * En principe, est invoque par la mthode addChamp() du contenant
  * @access public
  * @return string le contenu du champ
  */
  function getContenu() {
    $entete = "";
    $pied = "";
    if ($this->gras){
      $entete .= "<B>";
      $pied .= "</B>";
    }
    if ($this->ital){
      $entete .= "<I>";
      $pied .= "</I>";
    }
    if ($this->couleur){
      $entete .= "<FONT COLOR =\"$this->couleur\">";
      $pied .= "</FONT>";
    }
    if ($this->classe){
      $entete = "<P CLASS=\"$this->classe\">" . $entete;
    }
    if ($this->br){
      $pied .= "<BR>";
    }

    $contenu = $entete . $this->valeur . $pied;
    return $contenu;
  }
}
?>
