<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Image avec lien
* @package outils
*/
/**
* Label pouvant afficher une image avec lien
*
* Hrite de l'objet label, en ajoutant la possibilit d'ajouter une image et un lien
* <pre>
* Exemple :
* $c = new TPanel(1, 1);
* $x = Lien ("Cliquez", false, false, false, "", "http://par.ici", "http://par.ici/image.gif");
* $c->addChamp($x);
* </pre>
* @author ob
* @package outils*/
class Lien extends Label {
  /**
  * Le lien
  * @var string
  */
  var $link;
  /**
  * L'URL de l'image
  * @var string
  */
  var $image;
  /**
  * Faut-il transformer le lien en un simple label ?
  * @var boolean
  */
  var $labellise;
  /**
  * Evnement onClick
  * @var string
  */
  var $onClick;
  
  /**
  * @param mixed valeur le texte du label (s'affiche en "ALT" s'il y a une image)
  * @param boolean gras Le texte du label doit-il tre gras ?
  * @param boolean ital Le texte du label doit-il tre en italique ?
  * @param boolean br Faut-il un retour  la ligne aprs le label ?
  * @param string nom Le nom de l'objet
  * @param string link cf. variable de classe
  * @param string image cf. variable de classe
  * @param boolean labellise cf. variable de classe
  * @param string onClick cf. variable de classe 
  */
  function __construct($valeur, $gras = false, $ital = false, $br = false, $nom="", $link, $image=0, $labellise=false, $onClick=0){
    parent::__construct($valeur, $gras, $ital, $br, $nom);
    $this->link = $link;
    $this->image = $image;
    $this->labellise = $labellise;
    $this->onClick = $onClick;
  }

  /**
  * Passe le contenu au contenant
  * En principe, est invoque par la mthode addChamp() du contenant
  * @access public
  * @return string le contenu du champ
  */
  function getContenu() {
    $entete = "";
    $pied = "";

    $gras_deb = "";
    $gras_fin = "";
    if ($this->gras){
      $gras_deb = "<B>";
      $gras_fin = "</B>";
    }

    $ital_deb = "";
    $ital_fin = "";
    if ($this->ital){
      $ital_deb = "<I>";
      $ital_fin = "</I>";
    }
    if ($this->br){
      $pied .= "<BR>";
    }
    $contenu = $entete;
    if (! $this->labellise){
      $contenu .= "<A";
      if ($this->link) $contenu .= " HREF=\"" . $this->link . "\"";
      if ($this->onClick) $contenu .= " onClick =\"$this->onClick\" onmouseover=\"this.style.cursor='pointer'\"";
      $contenu .= ">";
    }  
      
    $contenu .= ($this->image ? "" : $ital_deb . $gras_deb . $this->valeur . $gras_fin . $ital_fin) .
                ($this->image ? "<IMG ALT=\"$this->valeur\" SRC=\"$this->image\" BORDER=0>" : "") .
                "</A>" . $pied;

    return $contenu;
  }
}
?>
