<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Liste d'options
* @package outils
*/

/**
* Liste d'options
*
* Affiche une liste d'options
* Doit tre inclus dans un contenant comme TPanel ou TPanelCadre
* <pre>
* Exemple :
* $c = new TPanel(1, 1);
* $x = new ListOpt("Liste", 2, false, 0);
* $x->addOption("Premire", 1);
* $x->addOption("Seconde", 2);
* $c->addChamp($x);
* </pre>
* @author ob
* @package outils
*/
class ListOpt {
  /**
  * Le nom du champ
  * @var string
  */
  var $nom;
  /**
  * Autoriser slection multiple ?
  * @var boolean
  */
  var $multiple;
  /**
  * Nombre d'options affiches
  * @var int
  */
  var $size;
  /**
  * Les items de la liste
  * @var string
  * @access private
  */
  var $items;
  /**
  * L'item ou les items slectionns
  * @var array (ou int)
  */
  var $selected;
  /**
  * La valeur de l'item slectionn
  * @var int
  */
  var $class;
  /**
  * Code javascript sur changement
  * @var string
  */
  var $onchange;
  /**
  * Faut-il transformer la liste en un simple label ?
  * @var boolean
  */
  var $labellise;
  /**
  * Ajout d'un retour  la ligne si ncessaire
  * @var boolean
  */
  var $br;
  /**
  * En cas de labellisation : la partie du label correspondant au nom du champ
  * @var string
  * @access private
  */
  var $labelNom;
  /**
  * En cas de labellisation : la partie du label correspondant  la valeur du champ
  * @var string
  * @access private
  */
  var $labelVal;
  /**
  * Definit l'ID (HTML)du champ
  * @var string
  */
  var $id;
  
  /**
  * @param string nom cf. variable de classe
  * @param array selected cf. variable de classe (int si une seule valeur)
  * @param boolean multiple cf. variable de classe
  * @param int size cf. variable de classe
  * @param string class cf. variable de classe
  * @param string onchange cf. variable de classe
  * @param boolean labellise cf. variable de classe
  * @param boolean id cf. variable de classe
  */
  function __construct($nom, $selected=0, $multiple=false, $size=0, $class="", $onchange="", $labellise=false, $br = false, $id = ""){
    $this->nom = $nom;
    $this->multiple = $multiple;
    $this->size = $size;
    $this->selected = $selected;
    $this->valeur = $selected; //Ncessaire pour les TPanelTables
    $this->class = $class;
    $this->onchange = $onchange;
    $this->labellise = $labellise;
    $this->br = $br;
    $this->id = $id;
  }

  /**
  * Ajout d'une option  la liste
  * @param string name le texte de l'option
  * @param mixed value la valeur associe
  * @access public
  */
  function addOption($nom, $valeur){
    $this->items .= "<OPTION VALUE=\"$valeur\"";
    if (! is_array($this->selected)){
      $tableau[0] = $this->selected;
    }
    else {
      $tableau = $this->selected;
    }
    for ($i = 0; $i < count($tableau); $i++){
      if ($valeur == $tableau[$i]){
        $this->items.= " SELECTED";
        $this->labelNom = $nom;
        $this->labelVal = $valeur;
      }
    }
    $this->items .= ">$nom</OPTION>";
  }
  
  /**
  * Passe le contenu au contenant
  * En principe, est invoque par la mthode addChamp() du contenant
  * @access public
  * @return string le contenu du champ
  */
  function getContenu(){
    if (! $this->labellise) {
      $contenu = "<SELECT " . (($this->id != "") ? "ID=$this->id" : "") .
                 ($this->class ? " CLASS=\"$this->class\" " : "") . "NAME=\"$this->nom\"" .
                 ($this->multiple ? " MULTIPLE " : "") .
                 ($this->size ? " SIZE=$this->size" : "") .
                 ($this->onchange ? " OnChange=\"$this->onchange\"" : "") . ">" . $this->items . "</SELECT>\n";
    }
    else {
      $contenu= "$this->labelNom <INPUT NAME=\"$this->nom\" VALUE=\"$this->labelVal\" TYPE=\"HIDDEN\">";
    }
    $contenu .= ($this->br ? "\n<BR>" : "");
    return $contenu;
  }
}

?>
