<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Liste d'options lie  une table
* @package outils
*/
/**
* Liste d'options lie  une table
*
* Etend l'objet ListOpt afin de lui permettre d'afficher des options tires d'une table de base de donnes
* <pre>
* Exemple :
* $c = new TPanel(1, 1);
* $et = new ensTableBrioche("usagers", "critere = 1", "nom, numero", "nom", $noSession);
* $x = new ListOptTable("maliste", 0, $et);
* $x->addDefaut("---", "");
* $x->addOptions("nom", "numero");
* $c->addChamp($x);
* </pre>
* @author ob
* @package outils
*/
class ListOptTable extends ListOpt {
  /**
  * L'objet table contenant les options
  * @var object ensTableBrioche
  */
  var $table;
  /**
  * Le tableau d'objets "enregistrement" extrait de l'objet ensTableBrioche
  * @var array
  * @access private
  */
  var $tab;
  /**
  * La valeur du champ (correspondant  l'item slectionn=
  * @var int
  */
  var $valeur;
  /**
  * @param string nom le nom du champ
  * @param mixed valeur la valeur de l'option active
  * @param object cf. variable de classe
  * @param boolean multiple autoriser les slections multiples ?
  * @param int size le nombre d'options affiches
  * @param string class une indication de style
  * @param string onchange le code javascript excut sur changement
  * @param boolean labellise transforme la liste en un simple label
  * @param string id cf. variable de classe
  */
  function __construct($nom, $valeur, &$table, $multiple=false,
                        $size=0, $class="", $onchange="",
                        $labellise=false, $br = false, $id = ""){
    $this->table = $table;
    $this->valeur = $valeur;
    parent::__construct($nom, $this->valeur, $multiple, $size, $class, $onchange, $labellise, $br, $id);
    $this->tab = $table->getTableau();
    
  }

  /**
  * Ajoute une valeur "nulle" par dfaut, non contenue dans la table
  * @param string nom la valeur affiche
  * @param string val la valeur renvoye
  */
  function addDefaut($nom, $val){
    $this->addOption($nom, $val);
  }

  /**
  * Ajoute les options de la table
  * @param nom le champ de la table qui est affich
  * @param val le champ de la table qui est renvoy
  */
  function addOptions($nom, $val){
    $nb = count($this->tab);
    for ($i=0; $i<$nb; $i++){
      $this->addOption($this->tab[$i]->$nom, $this->tab[$i]->$val);
    }
  }
  
  
}

?>
