<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* ListeOptTable automatique simplifie adapte  TPanelTable
* @package outils
*/
/**
* listeOptTable automatique simplifie adapte  TPanelTable
* Permet d'intgrer une liste d'options  un tableau : la fonction getContenu renvoie
* directement les options et le dfaut, sans qu'il soit ncessaire d'invoquer les mthodes
* addOptions() et addDefaut().
* <pre>
* Exemple :
* $et = new ensTableBrioche("table", "1", "*", 0, $idsession);
* $c = new TPanelTableau(6, 1, $et, "#efefef", "donnees", $champ);
* $etl = new ensTableBrioche("tableliste", "1", "nom, valeur", 0, $idsession);
* $x = new ListOptTableAuto("monnom", "", $etl, true, "nom", "valeur", "d2");
* $c->addColChamp("Col. test", $x);
* </pre>
* @author ob
* @package outils
*/
class ListOptTableAuto extends ListOptTable {
  
  /**
  * Faut-il ajouter une option par dfaut, qui sera alors ---, 0 ?
  * @var boolean
  */
  var $defaut;
  
  /**
  * Le champ de la table contenant les options qui sera utilis comme nom (donc affich dans le formulaire)
  * @var string
  */
  var $chnom;
  
  /**
  * Le champ de la table contenant les options qui sera utilis comme valeur (donc renvoy par le formulaire)
  * @var string
  */
  var $chvaleur;
  
  /**
  * @param string nom cf. variable de classe
  * @param string valeur cf. variable de classe
  * @param string table cf. variable de classe
  * @param boolean defaut cf. variable de classe
  * @param string chnom cf. variable de classe
  * @param string chvaleur cf. variable de classe
  * @param string class cf. variable de classe
  */
  function __construct($nom, $valeur, $table, $defaut, $chnom, $chvaleur, $class){
    parent::__construct($nom, $valeur, $table, false, 0, $class);
    $this->defaut = $defaut;
    $this->chnom = $chnom;
    $this->chvaleur = $chvaleur;
  }

  /**
  * Ajoute les options de la table
  * @param string nom le champ affich
  * @param string val le champ renvoy
  * @access private
  */
  function addOptions($nom, $valeur){
    $this->selected = $this->valeur;
    return parent::addOptions($nom, $valeur);
  }
  
  /**
  * Ajoute les valeurs par dfaut non contenues dans la table
  * @param string nom le dfaut affich
  * @param string val le dfaut renvoy
  * @access private
  */
  function addDefaut($nom, $valeur){
    if (! $this->valeur) $this->valeur = 0;
    $this->selected = $this->valeur;
    return parent::addDefaut($nom, $valeur);
  }
  
  /**
  * Ajoute les options, les dfauts et passe le contenu au contenant
  * @return string le contenu HTML
  */
  function getContenu(){
    if ($this->defaut){
      $this->addDefaut("---", 0);
    }
    $this->addOptions($this->chnom, $this->chvaleur);
    return parent::getContenu() . "\n";
  }



}





?>
