<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Pagination
* @package outils
*/
/**
* Pagination
* 
* Gre la pagination pour les listes susceptibles de contenir beaucoup d'enregistrements
* Doit tre inclus dans un contenant comme TPanel ou TPanelCadre
* Exemple :
* $c = new TPanel(1, 1);
* $x = new Pagination($table, "nom_de_l'item__compter", "nom_formulaire", "nom_champ_page", "taille_page", numro_page);
* $c->addChamp($x);
* 
* Le champ "nom_champ_page" doit exister dans le formulaire "nom_formulaire", en principe sous forme de champ HIDDEN
* L'objet $table peut tre un ensTableBrioche ou un objet fils (ensTableCompact).
* 
* @author ob
* @package outils
*/


class Pagination {
  /**
  * La table retournant les enregistrements  afficher
  * @var object ensTableBrioche
  */
  var $table;
  /**
  * Le contenu graphique renvoy par Pagination
  * @var string
  */
  var $contenu;
  /**
  * Le nombre total d'enregistrements
  * @var int
  */
  var $total;  

  /**
  * @param object table cf. variable de classe
  * @param string nomitem Le nom d'item  afficher (par exemple "dossiers" ou "lits" 
  * @param string nomform Le nom du formulaire contenant le champ "page"
  * @param string nomchamp Le nom du champ "page"
  * @param int taillepage Le nombre d'enregistrements par page
  * @param int nopage Le numro de la page  afficher
  */
  function __construct(&$table, $nomitem, $nomform, $nomchamp, $taillepage, $nopage){
    $this->table = &$table;
    $this->total = $this->table->compteTotal();
    if (! $nopage) $nopage = 1;
    if ($this->total <= $taillepage){ // Pas besoin de pagination 
      $this->contenu = "<B>$this->total $nomitem au total</B>";
    }
    else { // Pagination
      $debut = ($nopage - 1)* $taillepage + 1;
      $fin = ($nopage) * $taillepage;
      if ($fin > $this->total) $fin = $this->total;
      $nbpages = ceil($this->total / $taillepage);
      $offset = $debut - 1; 
      $pagesuiv = $nopage + 1;
      $pageprec = $nopage - 1;
      $this->table->setLimit($taillepage);
      $this->table->setOffset($offset);
      $this->contenu = "<B>Affichage des $nomitem $debut  $fin sur un total de $this->total</B><BR>";
      $this->contenu .= ($nopage <= 1 ? "Page prcdente" :
                       "<A HREF=\"javascript:changeChamp('$nomchamp', '" . $pageprec .
                       "', '$nomform');document.forms.$nomform.submit();\">Page prcdente</A>") . " | ";
      for ($i = 1; $i <= $nbpages; $i++){
        $this->contenu .= ($nopage == $i ? $i : "<A HREF=\"javascript:changeChamp('$nomchamp', " .
                          "'$i', '$nomform');document.forms.$nomform.submit();\">$i</A>") . " | ";
      }
      $this->contenu .= ($nopage >= $nbpages ? "Page suivante" : 
                       "<A HREF=\"javascript:changeChamp('$nomchamp', '" . $pagesuiv .
                       "', '$nomform');document.forms.$nomform.submit();\">Page suivante</A>");
    }
  }

  /**
  * Renvoi du contenu du champ "Pagination"
  * @access public
  */
  function getContenu(){
    $entete = "";
    $pied = "";
    $contenu = $this->contenu;
    return $entete . $contenu . $pied;
  }
}

?>
