<?php
  // $Id: Radio.inc,v 1.2 2017/07/06 22:23:38 ob Exp $
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Bouton radio
* @package outils
*/
/**
* Bouton radio
* Bouton radio unique, utilis avant tout par la mthode addRadio de la classe GrBoutonRadio
* @author ob
* @package outils
*/
class Radio {
  /**
  * le nom du bouton
  * @var string
  */
  var $name;
  
  /**
  * la valeur du bouton
  * @var string
  */ 
  var $value;
  
  /**
  * le label affich en regard du bouton
  * @var string
  */
  var $label;
  
  /**
  * le bouton est-il slectionn ?
  * @var string
  */
  var $checked;
  
  /**
  * le contenu html de l'objet
  * @var string
  */
  var $contenu = "";
  
  /**
  * Y a-t-il un retour  la ligne aprs le bouton ?
  * @var boolean
  */
  var $br;
  
  /**
  * fonction javaScript onChange associe
  * @var string
  */
  var $onchange;
  
  /** 
  * faut-il transformer le bouton en label (lecture seule) ?
  * @var boolean
  */
  var $labellise;
  
  /**
  * @param string name cf. variable de classe
  * @param string value cf. variable de classe
  * @param string label cf. variable de classe
  * @param boolean checked cf. variable de classe
  * @param boolean br cf. variable de classe
  * @param string onchange cf. variable de classe
  * @param boolean labellise cf. variable de classe
  */
  function __construct($name, $value, $label = "", $checked = false, 
                 $br = false, $onchange = "", $labellise){

    $this->name = $name;
    $this->value = $value;
    $this->label = $label;
    $this->checked = $checked;
    $this->br = $br;
    $this->onchange = $onchange;
    $this->labellise = $labellise;

  }

  /**
  * Passe le contenu au contenant
  * En principe, est invoque par la mthode addRadio() du GroupeBoutonRadio
  * @return string le contenu du champ
  */
  function getContenu() {
    if (!$this->labellise) {
      $contenu = "<INPUT TYPE=\"radio\" NAME=\"$this->name\" VALUE=\"$this->value\"" .
                 ($this->checked ? " CHECKED" : "") .
                 ($this->onchange ? " OnChange=\"$this->onchange\"" : "") .
                 " onClick=\"this.blur()\"> $this->label&nbsp;&nbsp;&nbsp;" .
                 ($this->br ? "<BR>" : "") . "\n";
                 // Le onClick est rendu ncessaire par le fait que IExplorer
                 //ne gnre l'vnement onChange que
                 // lorsque le contrle perd le focus.
    } 
    else {
      $contenu = "";
      if ($this->checked) {
        $contenu .= "<INPUT TYPE=\"hidden\" NAME=\"$this->name\"  VALUE=\"".$this->value."\">";
      }
      $contenu .=  ($this->checked ? "(<b>x</b>)&nbsp;" : "(&nbsp;)&nbsp;") .
      $this->label . "&nbsp;&nbsp;&nbsp;" . ($this->br ? "<BR>" : "");
    }
    return $contenu;
  }
}
?>
