<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Tableau bidimensionnel construit sur la base des donnes d'un array (statistiques)
* @package outils
*/
/**
* Tableau bidimensionnel construit sur la base des donnes d'un array
* Spcifique  l'affichage des rsultats statistiques
* @package outils
* @author jdu
*/
class StatsTableau {
  
  /**
  * tableau contenant les donnes
  * @var array
  */
  var $statResult;
  
  /**
  * tableau contenant les mois de la priode choisie
  * @var array
  */
  var $periode;
  
  /**
  * Donnes qui doivent apparatre dans l'intitul du fichier excel
  * @var string
  */
  var $enteteExcel;
  
  /**
  * Textes d'aides dcrivant les statistiques
  * @var array
  */
  var $aide;
    
  /**
  * @param int colspan cf. variable de classe
  * @param int rowspan cf. variable de classe
  * @param object table cf. variable de classe
  * @param string couleur cf. variable de classe
  * @param string nom cf. variable de classe
  * @param string primaire cf. variable de classe
  * @param string nomgroupe cf. variable de classe
  * @param string defautnomgroupe cf. variable de classe
  * @param string commentaire cf. variable de classe
  * @param string taillemaxcom cf. variable de classe
  */
  function __construct($statResult,$periode,$aide){
    
    $this->statResult = $statResult;
    $this->periode = $periode;
    $this->aide = $aide;
    $this->enteteExcel = "";
  } 
  
  function excelHeader($enteteExcel) {
    
    $nbCol = count($this->periode) + 4;
    
    $contenu = "";
    $contenu .= "<tr><td colspan=$nbCol><b>" . $enteteExcel['titre'] . "</b></td></tr>";
    foreach ($enteteExcel['contenu'] as $ligne) {
      $contenu .= "<tr>";
      $contenu .= "<td colspan=$nbCol>$ligne</td>";
      $contenu .= "</tr>";
    }
    
    $this->enteteExcel = $contenu;
  }
  
  /**
  * passe le contenu au contenant
  * @return string le texte contenu
  */
  function GetContenu(){
    
    $aujourdhui = getdate();
    $ligneDroite = "style='border-right-width:1px;border-right-style:solid;border-right-color:black;'";
    
    $totalBKB = '#aaffff';
    $moyBKG = 'pink';
    
    $contenu = "<table cellspacing=0 align='center' border=0>";
          
    if ($this->enteteExcel != "") $contenu .= $this->enteteExcel;
    
    $contenu .= "<tr><td colspan=4 align='right' $ligneDroite><b>Pour la priode slectionne</b>&nbsp;</td>";
    
    $ligneVide = "<tr><td>&nbsp;</td><td>&nbsp;</td><td width=50 $ligneDroite bgcolor=$totalBKB>&nbsp;</td><td width=50 $ligneDroite bgcolor=$moyBKG>&nbsp;</td>";
    $ligneVide2 = "<tr><td>&nbsp;</td><td>&nbsp;</td><td $ligneDroite align=center bgcolor=$totalBKB>Total</td><td $ligneDroite bgcolor=$moyBKG align=center>Moyenne mensuelle</td>";    
    foreach ($this->periode as $mois) {
      if ($aujourdhui['year'] == $mois['annee'] && $aujourdhui['mon'] == $mois['mois']) $bgcolor = "#FFFF99";
      elseif ($aujourdhui['year'] == $mois['annee'] && $aujourdhui['mon'] < $mois['mois'] || $aujourdhui['year'] < $mois['annee']) $bgcolor = "#FFCC00";
      else $bgcolor = "#ffffff";
      $contenu .= "<td align='right' bgcolor='$bgcolor'><b>".$mois['mois'].".".$mois['annee']."&nbsp;</b></td>";
      
      $ligneVide .= "<td bgcolor='$bgcolor'>&nbsp;</td>";
      $ligneVide2 .= "<td bgcolor='$bgcolor'>&nbsp;</td>";
    }
    $ligneVide .= "</tr>";
    $ligneVide2 .= "</tr>";
    $contenu .= "</tr>";
    
    $contenu .= $ligneVide2;
    
    $contenu .= $ligneVide;
    
    foreach ($this->statResult as $cle => $ligne) {
      
      $contenu .= "<tr>";
      $contenu .= "<td><b>" . $ligne['titre'] . "</b></td><td>&nbsp;</td>";
      $contenu .= "<td align='right' $ligneDroite bgcolor=$totalBKB style='padding-right:5px;'><b>" . $ligne['total']['total'] . "</b></td>";
      $contenu .= "<td align='right' $ligneDroite bgcolor=$moyBKG style='padding-right:5px;'><b>" . $ligne['moy']['total'] . "</b></td>";
      
      $sscontenu = array();
      foreach ($this->periode as $mois) {
        foreach ($ligne[$mois['mois'].".".$mois['annee']] as $cle => $elmt) {
          if ($aujourdhui['year'] == $mois['annee'] && $aujourdhui['mon'] == $mois['mois']) $bgcolor = "#FFFF99";
          elseif ($aujourdhui['year'] == $mois['annee'] && $aujourdhui['mon'] < $mois['mois'] || $aujourdhui['year'] < $mois['annee']) $bgcolor = "#FFCC00";
          else $bgcolor = "#ffffff";
          if ($cle == 'total') {
            $contenu .= "<td align='right' bgcolor='$bgcolor' style='padding-right:5px;'><b>$elmt</b></td>";
          } else {
            if (!isset($sscontenu[$cle])) $sscontenu[$cle] = "";
            $sscontenu[$cle] .= "<td align='right' bgcolor='$bgcolor' style='padding-right:5px;'>$elmt</td>";
          }
        }
      }
      
      $contenu .= "</tr>";
      
      if (count($sscontenu) > 0) {
        foreach ($sscontenu as $cle => $elmt) {
          $contenu .= "<tr>";
          $contenu .= "<td style='padding-left:15px;'>" . $cle . "</td><td>&nbsp;</td>";
          $contenu .= "<td align='right' $ligneDroite bgcolor=$totalBKB style='padding-right:5px;'>" . $ligne['total'][$cle] . "</td>";
          $contenu .= "<td align='right' $ligneDroite bgcolor=$moyBKG style='padding-right:5px;'>" . $ligne['moy'][$cle] . "</td>";
          $contenu .= $elmt;
          $contenu .= "</tr>";
        }
      }
      
      if (!isset($ligne['nl'])) $nl = true;
      else $nl = $ligne['nl'];
      if ($nl) $contenu .= $ligneVide; 
    }
    
    $contenu .= "</table><br/>"; 
    
    if (count($this->aide) > 0) {
      $contenu .= "<table cellspacing=0 align='left' border=0>"; 
      $contenu .= "<tr><td colspan='2'><b><u>Aide sur les statistiques :</u></b><br/><br/></td></tr>";
      foreach ($this->aide as $key => $value)	{
      	$contenu .= "<tr><td style='padding-left:20px;' valign='top'><b>$key :</b></td>";
      	$contenu .= "<td valign='top'>$value</td></tr>";
      }
      $contenu .= "</table>"; 
    }
    
    //$contenu .= "<pre>".print_r($this->statResult,true)."</pre>";
    
        
    return $contenu;
  }
}


?>
