<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Champ texte dans une cellule de table
* @package outils
*/
/**
* Champ texte dans une cellule de table
* Raccourci faisant d'un champ texte un contenant de premier niveau
* et permettant de l'insrer directement dans un objet de type OngForm
* (contenant de second niveau) sans passer par un TPanel (contenant de premier niveau)
* <pre>
* Exemple :
* $c = new TchampTexte("montexte", "montiquette", 12, 12);
* quivaut 
* $c = new TPanel(1, 1);
* $x = new ChampTexte("montexte", "montiquette", 12, 12);
* $c->addChamp($x);
* </pre>
* @package outils
* @author ob
*/
class TChampTexte extends ChampTexte {
  /**
  * le nombre de colonne que l'objet enjambe
  * @var int
  */
  var $colspan = "";

  /**
  * @param string name le nom du champt
  * @param string value la valeur (contenu) du champ
  * @param string label l'tiquette du champ
  * @param int size la taille du champ (nb. caractres)
  * @param int maxlength le nombre maximal de caractres admis
  * @param boolean br : faut-il un retour  la ligne aprs le champ ?
  * @param string text attribut "TYPE" du champ HTML "INPUT" (par dfaut "text")
  * @param string class l'attribut HTML "CLASS" (pour l'usage des css)
  * @param string onblur du code javaScript correspondant  la proprit onBlur du champ HTML
  * @param string onchange du code javaScript correspondant  la proprit onChange du champ HTML 
  */
  function __construct($name, $value, $label, $size, $maxlenth, $br=false, $type="text", $class="", $onblur="", $onchange=""){
    parent::__construct($name, $value, $label, $size, $maxlenth, $br, $type, $class, $onblur, $onchange);
  }

  /**
  * rgle le nombre de colonnes qu'enjambe l'objet
  * @param int colspan cf. variable de classe
  */
  function setColSpan($colspan){
    $this->colspan = $colspan;
  }

  /**
  * passe le contenu au contenant (le plus souvent par le biais de sa mthode addChamp())
  * @return string le texte contenu
  */
  function TGetContenu(){
    $TContenu = "<TD " . ($this->colspan ? "COLSPAN=\"$this->colspan\">" : ">");
    $TContenu .= $this->getContenu();
    $TContenu .= "</TD>\n";
    return $TContenu;
  }


}

?>
