<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Champ texte
* @package outils
*/
/**
* Champ texte
*
* Affiche un champ texte avec le label et le champ dans 2 cellules diffrentes.
* Doit tre inclus dans un contenant comme TPanel ou TPanelCadre
* Exemple :
* $c = new TPanel(1, 1);
* $x = new TChampTexteCellule("Rubrique", "?", "Votre nom: ", 12, 12, false, "text");
* $c->addChamp($x);
* @author ob
* @package outils
*/
class TChampTexteCellule extends ChampTexte {
  var $colspan;

  /**
  * @param string nom cf. variable de classe
  * @param mixed valeur cf. variable de classe
  * @param string label cf. variable de classe
  * @param int size cf. variable de classe
  * @param int maxlength cf. variable de classe
  * @param boolean br cf. variable de classe
  * @param string type cf. variable de classe
  * @param string class cf.variable de classe
  * @param string onblur cf. variable de classe
  * @param string onchange cf. variable de classe
  * @param string labellise cf. variable de classe
  */
  function __construct($nom, $valeur, $label = "", $size, $maxlength, $br = false, $type = "TEXT", $classe = "",
			     $onblur= "", $onchange = "", $labellise = false, $colspan = 1, $calendrier = false){
    parent::__construct($nom, $valeur, $label, $size, $maxlength, $br, $type, $classe,
                      $onblur, $onchange, $labellise, $calendrier);
    $this->colspan = $colspan;
    
  }

  /**
  * Passe le contenu au contenant
  * En principe, est invoque par la mthode addChamp() du contenant
  * @access public
  * @return string le contenu du champ
  */
  function TGetContenu() {
    $contenu = "";
    if ($this->label) {
      $contenu = "<TD>$this->label</TD>" . ($this->br ? "<BR>" : "");
    }
    if (! $this->labellise) {
      $contenu .= "<TD COLSPAN=\"".$this->colspan."\"><INPUT TYPE=\"$this->type\" " . ($this->classe ? "CLASS=\"$this->classe\" " : "") .
                  ($this->onblur ? "OnBlur=\"$this->onblur\" " : "") . ($this->onchange ? "OnChange=\"$this->onchange\" " : "") .
                  "NAME=\"$this->nom\" VALUE=\"$this->valeur\" SIZE=\"$this->size\" MAXLENGTH=\"$this->maxlength\">";
      if ($this->calendrier) {
        require_once('Calendrier.inc');
        $contenu .= "&nbsp;<img align='absmiddle' style='cursor:pointer;' src=\"images/calendrier.gif\" onclick=\"pickDate(document.getElementById('$this->nom'), '', '', 'day_month_year', '.', 'true', 
                    'Jan.,Fv.,Mars,Avr.,Mai,Juin,Juil.,Aot,Sept.,Oct.,Nov.,Dc', 
                    'D,L,M,M,J,V,S', 'Aujourd\'hui', '');\"></img>";
      }
      $contenu .= "</TD>\n";
    }
    else {
      $contenu .= "<TD COLSPAN=\"".$this->colspan."\">$this->valeur <INPUT NAME=\"$this->nom\" VALUE=\"$this->valeur\" TYPE=\"HIDDEN\"></TD>\n";
    }
    return $contenu;
  }
}
?>
