<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Label dans une cellule de table
* @package outils
*/
/**
* Label dans une cellule de table
* Raccourci faisant d'un Label un contenant de premier niveau
* et permettant de l'insrer directement dans un objet de type OngForm
* (contenant de second niveau) sans passer par un TPanel (contenant de premier niveau)
* <pre>
* Exemple :
* $c = new TLabel("bonjour");
* quivaut 
* $c = new TPanel(1, 1);
* $x = new Label("bonjour");
* $c->addChamp($x);
* </pre>
* @package outils
* @author ob
*/
class TLabel extends Label {
  /**
  * le nombre de colonnes que l'objet enjambe
  * @var int
  */
  var $colspan = "";
  
  /**
  * l'alignement horizontal dans la cellule ("LEFT", "CENTER" ou "RIGHT")
  * @var string
  */
  var $align = "LEFT";
  
  /**
  * le nombre de lignes que l'objet enjambe
  * @var int
  */
  var $rowspan = "";
  
  
  /**
  * @param string value la valeur affiche
  * @param boolean gras faut-il l'afficher en caractres gras ?
  * @param boolean ital faut-il l'afficher en italique ?
  * @param boolean br faut-il un retour  la ligne aprs ?
  */
  function __construct($value, $gras = false, $ital = false, $br = false){
    parent::__construct($value, $gras, $ital, $br);
  }

  /**
  * dfinit l'alignement horizontal
  * @param string al cf. variable de classe align
  */
  function setAlign($al){
    $this->align = $al;
  }

  /**
  * dfinit le nombre de colonnes enjambes
  * @param int colspan cf. valeur de classe
  */
  function setColSpan($colspan){
    $this->colspan = $colspan;
  }

  /**
  * dfinit le nombre de lignes enjambes
  * @param int colspan cf. valeur de classe
  */
  function setRowspan($rowspan){
    $this->rowspan = $rowspan;
  }

  /**
  * passe le contenu au contenant (le plus souvent par le biais de sa mthode addChamp())
  * @return string le texte contenu
  */
  function TGetContenu(){
    $TContenu = "<TD " . ($this->align ? "ALIGN=\"$this->align\" " : "") .
               ($this->colspan ? "COLSPAN=\"$this->colspan\" " : "") .
               ($this->rowspan ? "ROWSPAN=\"$this->rowspan\" " : "") . ">";
    $TContenu .= $this->getContenu();
    $TContenu .= "</TD>\n";
    return $TContenu;
  }


}

?>
