<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Panneau  insrer dans une table et contenant un champ de formulaire
* @package outils
*/
/**
* Panneau  insrer dans une table et contenant un champ de formulaire
* Il s'agit du contenant de premier niveau, rglant avant tout la hauteur (en lignes),
* la largeur (en colonnes) et l'alignement du champ  l'intrieur du panneau.
* Un TPanel peut contenir un nombre indtermin de champs, qui lui sont ajouts par la mthode
* addchamp, qui va elle-mme invoquer la mthode getContenu de chaque champ contenu
* <pre>
* Exemple :
* of = new OngForm();
* $c = new TPanel(1, 1);
* $x = new Label("Bonjour");
* $c->addChamp($x);
* $c->addChamp(new Espace(2));
* $x = new Label("Au revoir");
* $c->addChamp($x);
* $of->addChamp($c);
* </pre>
* @package outils
* @author ob
*/
class TPanel {
  /**
  * le nombre de colonnes enjambes
  * @var int
  */
  var $colspan;
  
  /**
  * le nombre de lignes enjambes
  * @var int
  */
  var $rowspan;
  
  /**
  * l'alignement horizontal ("LEFT", "CENTER", "RIGHT")
  * @var string
  */
  var $align;
  
  /**
  * l'alignement vertical ("TOP", "MIDDLE", "BOTTOM")
  * @var string
  */
  var $valign;
  
  /**
  * la largeur en pixels (si on a des raisons de vouloir la prciser)
  * @var int
  */
  var $width;
  
  /**
  * le contenu HTML de l'objet
  * @var string
  * @access private
  */
  var $corps = "";
  
  /**
  * le style (class CSS)
  * @var string
  */
  var $style;
  
  /**
  * @param int colspan cf. variable de classe
  * @param int rowspan cf. variable de classe
  * @param string align cf. variable de classe
  * @param string valign cf. variable de classe
  * @param int width cf. variable de classe
  * @param string style cf. variable de classe
  * @return boolean
  */
  function __construct($colspan=1, $rowspan=1, $align="LEFT", $valign="", $width="", $style=""){
    $this->colspan = $colspan;
    $this->rowspan = $rowspan;
    $this->align = $align;
    $this->valign = $valign;
    $this->width = $width;
    $this->style = $style;
    return true;
  }

  /**
  * ajout d'un champ contenu (n'importe quel objet dont la mthode getContenu() renvoie du texte.
  * @param object champ le champ  passer 
  */
  function addChamp(&$champ){       //passage par rfrence pas admis avec new Espace dans anciennes versions de php
                                    // l'essai le 20.3.06, toutes les instances semblant tourner sous php4
    $this->corps .= $champ->getContenu();
  }

  /**
  * passe le contenu au contenant (le plus souvent par le biais de sa mthode addChamp())
  * @return string le texte contenu
  */
  function TGetContenu(){
    $entete = "<TD" . ($this->style ? " CLASS=\"$this->style\" " : "") . 
    " COLSPAN=\"$this->colspan\" ROWSPAN=\"$this->rowspan\"" .
    ($this->align ? " ALIGN=\"$this->align\"" : "") . ($this->valign ? " VALIGN=\"$this->valign\"" : "") .
    ($this->width ? " WIDTH=\"$this->width\"" : "") . ">";
    $pied = "</TD>";
    $TContenu = $entete . $this->corps . $pied;
    return $TContenu;
  }


}

?>
