<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* TPanel contenant un bulletin de versement avec rfrence
* @package outils
*/
/**
* TPanel contenant un bulletin de versement avec rfrence
* A utiliser dans un module de paiements lectronique comme celui de radiX
* S'insre comme n'importe quel TPanel dans un contenant de second niveau
* @package outils
* @author ob
*/
class TPanelBVR extends TPanel {
   /**
  * le Bulletin doit-il s'afficher en lecture seule (champs non modifiables) ?
  * @var boolean
  */
  var $labellise;
  
  /**
  * le nom du formulaire tel que dfini dans le contenant de second niveau
  * @var string
  */ 
  var $nomform;
  
  /**
  * les donnes correspondant au paiement sont encapsules dans un objet enrBriochePaye
  * @var object enrBriochePaye
  */
  var $enr;
  
  /**
  * le numro d'action qui correspond  l'ouverture des dtails (boutons [...])
  * @var int
  */
  var $action4;
  
  /**
  * un objet "options" pass par le formulaire contenant le bulletin
  * @var object
  */
  var $options;
  
  /**
  * l'identifiant de session ( transmettre lors d'ouverture de fentres accessoires)
  * @var string
  */
  var $idsession;
  
  /**
  * le tableau contenant les valeurs postes par le formulaire
  * @var array
  */
  var $donnees;
  
  
  /**
  * @param int colspan le nb. de colonnes enjambes
  * @param int rowspan le nb. de lignes enjambes
  * @param boolean labellise cf. variable de classe
  * @param array donnees cf. variable de classe
  * @param string nomform cf. variable de classe
  * @param int action4 cf. variable de classe
  * @param object options cf. variable de classe
  * @param string idsession cf. variable de classe
  * @param int item l'identifiant du payement ( transmettre  enrBriochePaye)
  */
  function __construct($colspan=1, $rowspan=1, $labellise=0, $donnees, $nomform,
                     $action4, &$options, $idsession, $item){
    if (! parent::__construct($colspan, $rowspan, "RIGHT", "BOTTOM", 750, "")) return;
    $this->labellise = $labellise;
    $this->nomform = $nomform;
    $this->action4 = $action4;
    $this->options = &$options;
    $this->idsession = $idsession;
    $this->enr = new enrBriochePaye($item, $this->idsession);
    $this->donnees = $this->enr->getEnr("ep_archives", $donnees); 
    
  }

  
  /**
  * passe le contenu au contenant (le plus souvent par le biais de sa mthode addChamp())
  * @return string le texte contenu
  */
  function TGetContenu(){
    global $fdosbrioche;
    global $fichierpay;
    $nomform = $this->nomform;
    $donnees = $this->donnees;
    $item = "";
    if (! is_object($donnees)) {
      $donnees = (object) array("id" => "", "comptedest" => "", "priadr" => "", "prinpa" => "",
                                "priville" => "", "secadr" => "", "secnpa" => "", "secville" => "",
                                "numref" => "", "montant" => "");
    }
    
    $compte = new ChampTexte($nomform . '[comptedest]', $donnees->comptedest,
                             "", 20, 20, false, "TEXT", "d2",
                             "", "", $this->labellise);
    $priadr = new ChampTexte($nomform . '[priadr]', $donnees->priadr, "", 40, 40,
                             false, "TEXT", "d2", 
                             "ecritCookie('priadr', document.forms." . $nomform . ".elements['" .
                             $nomform . "[priadr]'].value);", "",
                             $this->labellise); 
    $prinpa = new ChampTexte($nomform . '[prinpa]', $donnees->prinpa, "", 6, 4, false,
                             "TEXT", "d2", "",
                             "controleNPA(6101, '$fdosbrioche', " .
                             "'" . $nomform . "[prinpa]', '" . $nomform . "[priville]', '$nomform', 1);",
                             $this->labellise);
    $priville = new ChampTexte($nomform . '[priville]', $donnees->priville, "",
                               20, 20, false, "TEXT", "d2", "",
                               "controleNPA(6101, '$fdosbrioche', " .
                               "'" . $nomform . "[prinpa]', '" . $nomform . "[priville]', '$nomform', 2);",
                               $this->labellise);
    $secadr = new ChampTexte($nomform . '[secadr]', $donnees->secadr, "", 40, 40, false, "TEXT",
                             "d2",
                             "ecritCookie('secadr', document.forms." . $nomform . ".elements['" .
                             $nomform . "[secadr]'].value);", "", $this->labellise);
    $secnpa = new ChampTexte($nomform . '[secnpa]', $donnees->secnpa, "", 6, 4, false, "TEXT",
                             "d2", "", "controleNPA(6101, '$fdosbrioche', " .
                             "'" . $nomform . "[secnpa]', '" . $nomform . "[secville]', '$nomform', 1);",
                             $this->labellise);
    $secville = new ChampTexte($nomform . '[secville]', $donnees->secville, "",
                               20, 20, false, "TEXT", "d2", "", "controleNPA(6101, '$fdosbrioche', " .
                             "'" . $nomform . "[secnpa]', '" . $nomform . "[secville]', '$nomform', 2);",
                             $this->labellise);
    $numref = new ChampTexte($nomform . '[numref]', $this->enr->espaceNoRef($donnees->numref), "", 
                               32, 32, false, "TEXT", "d2", "", "", $this->labellise);
    $montant = new ChampTexte($nomform . '[montant]', $donnees->montant, "",
                               12, 12, false, "TEXT", "d2", "", "", $this->labellise);
    $entete = "<TD" . 
    " COLSPAN=\"$this->colspan\" ROWSPAN=\"$this->rowspan\">";
    $this->corps .= "<table bgcolor=\"#ffcc99\" border=\"0\" cellpadding=\"0\" \n" .
                    "cellspacing=\"0\" width=\"95%\"><tr>\n" .
                    "<td rowspan=\"11\" bgcolor=\"#000000\"><img src=\"null.gif\" height=\"1\" width=\"1\"></td>\n" .
                    "<td colspan=\"8\" bgcolor=\"#000000\"><img src=\"null.gif\" height=\"1\" width=\"1\"></td>\n" .
                    "<td rowspan=\"11\" bgcolor=\"#000000\"><img src=\"null.gif\" height=\"1\" width=\"1\"></td>\n" .
                    "</tr>" .
                    "<tr>" .
                    "<td colspan=\"8\">" .
                    "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">\n" .
                    "<tbody><tr>\n" .
                    "<td align=\"center\">Einzahlung Giro Post</td>\n" .
                    "<td align=\"center\">Versement Virement Poste</td>\n" .
                    "<td align=\"center\">Versamento Girata Posta</td>\n" .
                    "</tr>" .
                    "</table></td></tr> " . 
                    "<tr>" .
                    "<td colspan=\"8\" bgcolor=\"#000000\"><img src=\"null.gif\" height=\"1\" width=\"1\"></td>" .
                    "</tr>" .
                    "<tr>" .
                    "<td width=\"1%\">&nbsp;</td>" .  
                    "<td colspan=\"2\" width=\"50%\">" .
                    "Versement pour" .
                    "</td>" .
                    "<td width=\"1\"></td>" .
                    "<td rowspan=\"2\" bgcolor=\"#000000\" width=\"1\"><img src=\"null.gif\" height=\"1\"" .
                    " width=\"1\"></td>" .
                    "<td rowspan=\"2\" width=\"33%\"><pre>Pas de communication !              </pre></td>" .
                    "<td rowspan=\"2\" bgcolor=\"#000000\" width=\"1\"><img src=\"null.gif\" height=\"1\"" .
                    " width=\"1\"></td>" .
                    "<td rowspan=\"2\" width=\"17%\">" .
                    "<img src=\"images/stampBlue.gif\" alt=\"Timbre\" align=\"middle\">" .
                    "</td>" .
                    "</tr>" .
                    "<tr>" .
                    "<td>&nbsp</td>" .  
                    "<td colspan=\"2\"><table border=\"0\" cellpadding=\"0\" width=\"100%\">" .
                    "<tbody><tr><td>&nbsp;</td>" .
                    "</tr>" .
                    "<tr><td>\n";
    $this->addChamp($priadr);
    $this->corps .= "</td></tr><tr><td>\n";
    $this->addChamp($prinpa);                       
    $x = new Espace(1);
    $this->addChamp($x);
    $this->addChamp($priville);
    if (! $this->labellise){
      $futopt = new optionsBriochePaye($this->options->getChaine());
      $futopt->setOption("TYPE_DETAIL", 1);
      $x = new Espace(2);
      $this->addChamp($x);
      $x = new Bouton("...", "...", "BUTTON",
                      "ouvreFenetre(\"$fichierpay?action=$this->action4&item=$item&" .
                      "sessionid=$this->idsession&cookie=priadr&options=" .
                      $futopt->getChaine() . "\"," .
                      "\"detail\", \"scrollbars=no,resizable=no,menubar=no,locationbar=no,height=380," .
                      "width=650,screenX=150,screenY=100\");");
      $this->addChamp($x);
    }
    $this->corps .= "</td>" .
                    "</tr>" .
                    "<tr><td>&nbsp;</td>" .
                    "</tr>" .
                    "<tr><td>&nbsp;</td>" .
                    "</tr>" .
                    "</tbody></table>" .
                    "</td>" .
                    "<td>&nbsp;</td>" .
                    "</tr>" .
                    "<tr>" .
                    "<td colspan=\"4\"><img src=\"null.gif\" height=\"1\" width=\"1\"></td>" .
                    "<td colspan=\"4\" bgcolor=\"#000000\"><img src=\"null.gif\" height=\"1\" width=\"1\"></td>" .
                    "</tr>" .
                    "<tr>" .
                    "<td>&nbsp;</td>" .  
                    "<td colspan=\"2\">" .
                    "En faveur de" .
                    "</td>" .
                    "<td>&nbsp;</td>" .
                    "<td rowspan=\"5\" bgcolor=\"#000000\"><img src=\"null.gif\" height=\"1\" width=\"1\"></td>" .
                    "<td colspan=\"3\">" .
                    "&nbsp;" .
                    "</td>" .
                    "</tr>" .
                    "<tr>" .
                    "<td>&nbsp;</td>" .
                    "<td colspan=\"2\"><table border=\"0\" cellpadding=\"0\" width=\"100%\">" .
                    "<tbody><tr><td>&nbsp;</td>" .
                    "</tr>" .
                    "<tr><td>" ;
    $this->addChamp($secadr);
    $this->corps .= "</td></tr><tr><td>";
    $this->addChamp($secnpa);
    $x = new Espace(1);
    $this->addChamp($x);
    $this->addChamp($secville);
    if (! $this->labellise){
      $futopt = new optionsBriochePaye($this->options->getChaine());
      $futopt->setOption("TYPE_DETAIL", 2);
      $x = new Espace(2);
      $this->addChamp($x);
      $x = new Bouton("...", "...", "BUTTON",
                      "ouvreFenetre(\"$fichierpay?action=$this->action4&item=$item&sessionid=$this->idsession" .
                      "&cookie=secadr&options=" .
                      $futopt->getChaine() . "\"," .
                      "\"detail\", \"scrollbars=no,resizable=no,menubar=no,locationbar=no,height=300," .
                      "width=650,screenX=150,screenY=100\")");
      $this->addChamp($x);
    }
    $this->corps .= " </td>" .
                    "</tr>" .
                    "<tr><td>&nbsp;</td>" .
                    "</tr>" .
                    "<tr><td>&nbsp;</td>" .
                    "</tr>" .
                    "</tbody></table>" .
                    "</td>" .
                    "<td>&nbsp;</td>" .
                    "<td colspan=\"3\">" .
                    "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"90%\">" .
                    "<tbody><tr>" .
                    "<td>" .
                    "&nbsp;N de rfrence" .
                    "</td>" .
                    "</tr>" .
                    "<tr>" .
                    "<td>" .
                    "&nbsp;<nobr>";
    $this->addChamp($numref);                                    
    $this->corps .= "</nobr></td>" .
                    "</tr>" .
                    "</tbody></table>" .
                    "</td>" .
                    "</tr>" .
                    "<tr>" .
                    "<td width=\"1%\"><img src=\"null.gif\" border=\"0\" width=\"5\"></td>" .  
                    "<td>" .
                    "Compte" .
                    "</td>" .
                    "<td align=\"right\">";
    $this->addChamp($compte);
    $this->corps .= "</td>" .
                    "<td width=\"50%\">&nbsp;</td>" .
                    "<td colspan=\"3\">" .
                    "&nbsp;" .
                    "</td>" .
                    "</tr>" .
                    "<tr>" .
                    "<td width=\"1%\"><img src=\"null.gif\" border=\"0\" width=\"5\"></td>" .  
                    "<td>" .
                    "Montant" .
                    "</td>" .
                    "<td align=\"right\" valign=\"top\">" .
                    "&nbsp;&nbsp;CHF&nbsp;" ;
    $this->addChamp($montant);                
    $this->corps .= "</td>" .
                    "<td width=\"50%\">&nbsp;</td>" .
                    "<td colspan=\"3\">" .
                    "<nobr>&nbsp;Vers par:&nbsp;<b>BriochePaye           </b>" .
                    "</nobr></td>" .
                    "</tr>" .
                    "<tr>" .
                    "<td colspan=\"8\" bgcolor=\"#000000\"><img src=\"null.gif\" height=\"1\" width=\"1\"></td>" .
                    "</tr>" .
                    "</tbody>" .
                    "</table>";

    $pied = "</TD>";
    $TContenu = $entete . $this->corps . $pied;
    return $TContenu;
  }


}

?>
