<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Tableau bidimensionnel construit sur la base des donnes d'une table
* @package outils
*/
/**
* Tableau bidimensionnel construit sur la base des donnes d'une table
* Permet d'afficher, sur des lignes et des colonnes, un nombre illimit
* de valeurs extraites d'une table ou d'une jointure (objet ensTableBrioche)
* <pre>
* Exemple :
* $et = new ensTableBrioche("table", "1", "*", 0, $idsession);
* $of = new OngForm();
* $c = new TPanelTableau(6, 3, $et, "#efefef", "nomtable", "cleprimaire");
* $x = new Label("", false, false, false, "champ_a_afficher");
* $c->addColChamp("Titre", $x);
* $of->addChamp($c);
* </pre>
* @package outils
* @author ob
*/
class TPanelTableau {
  /**
  * un tableau des titres des colonnes
  * @var array
  */
  var $cols;
  
  /**
  * le tableau renvoy par la fonction getTableau() de l'argument table
  * @var array
  */
  var $tableau;
  
  /**
  * la couleur d'une ligne sur deux (pour amliorer la lisibilit horizontale)
  * @var string
  */
  var $couleur;
  
  /**
  * le nom global du tableau, celui qui servira  nommer le tableau des variables si
  * des champs renvoyant une valeur (p. ex. checkbox) sont intgrs au tableau. En principe
  * on choisira le mme nom que celui du tableau de valeurs des champs du formulaire.
  * @var string
  */
  var $nom;
  
  /**
  * le nombre de colonnes enjambes
  * @var int
  */
  var $colspan;
  
  /**
  * le nombre de lignes enjambes
  * @var int
  */
  var $rowspan;
  
  /**
  * le champ du tableau de donnes (ensTableBrioche) qui est utilis comm identifiant unique
  * des enregistrements
  * @var string
  */
  var $primaire;
  
  /**
  * un tableau de valeurs boolennes correspondant aux colonnes du tableau, true si le champ en question est
  * une case  cocher, false autrement
  * @var array
  */
  var $autocb;
  
  /**
  * la ligne de la table HTML contenant les titre des colonnes
  * @var string
  */
  var $titre;
  
  /**
  * un tableau de valeurs boolennes correspondant aux colonnes du tableau, true si la caractristique
  * "sterling" est  utiliser dans la colonne correspondante. Dans ce cas, le caractre  figurant dans un
  * des arguments passs  l'objet constituant la colonne est remplac par l'identifiant de l'enregistrement
  * (la valeur du champ dsign par la variable $primaire)
  * @var array
  */
  var $sterling;
  
  /**
  * un objet de type AutoCheckBox, portant le nom correspondant  variable $nom et rglant l'criture dans la base de
  * donnes des valeurs correspondant  une case coche ou non
  * @var object AutoCheckBox
  */
  var $acb;
  
  /**
  * si l'on dsire que le tableau comporte des subdivisions horizontales (groupes), on indiquera dans ce champ
  * le nom du champ du tableau de donnes (ensTableBrioche) dont la valeur s'affichera comme libell de groupe.
  * Il faudra de plus s'arranger pour que la clause "order" de l'objet ensTabBrioche groupe les enregistrements
  * de manire compatible : pratiquement, les valeurs du premier champ de la clause order doivent correspondre
  * de manire biunivoque  celles du champ $nomgroupe
  * @var string
  */
  var $nomgroupe;
  
  /**
  * l'objet ensTableBrioche gnrant le tableau de donnes  mettre en forme
  * @var object ensTableBrioche
  */
  var $table;
  
  /**
  * dans le cas o l'on dfinit des groupes, le libell du groupe pour lequel, ventuellement, le champ
  * $nomgroupe n'a pas de valeur
  * @var string
  */
  var $defautnomgroupe;
  
  /**
  * un tableau comportant s'il y a lieu, pour chaque colonne du tableau, le nom d'une fonction "callback"
  *  appliquer, pour chaque ligne,  la valeur de la colonne correspondate. A utiliser lorsque l'affichage requis
  * est trop complexe pour tre gnr par une requte SQL.
  * @var array
  */
  var $fonction;
  
  /**
  * un tableau comportant s'il y a lieu, pour chaque colonne du tableau, une rfrence  l'objet contenant
  * la fonction callback dsigne dans le tableau $fonction
  * @var array
  */
  var $objet;
  
  /**
  * un tableau comportant, pour chaque colonne du tableau, l'alignement ("LEFT", "RIGHT", "CENTER")
  * @var array
  */
  var $align;
  
  /**
  * un tableau comportant s'il y a lieu, pour chaque colonne du tableau, une valeur  passer en argument supplmentaire
  *  la fonction callback
  * @var array
  */ 
  var $argsup;
  
  /**
  * un champ du tableau de donnes (ensTableBrioche)  insrer sur toute la largeur du tableau en-dessous de la ligne correspondante
  * @var string 
  */
  var $commentaire;
  
  /**
  * la taille maximale au-del de laquelle la chane de carractres correspondant au commentaire doit tre tronque
  * @var int
  */
  var $taillemaxcom;
  
  /**
  * la couleur d'une ligne sur deux (pour amliorer la lisibilit horizontale)
  * Il s'agit ici de l'autre ligne (pas la mme que $couleur)
  * @var string
  */
  var $couleuraltern;
  
  /**
  * la couleur de la ligne des titres
  * @var string
  */
  var $couleurtitre;
  
  /**
  * @param int colspan cf. variable de classe
  * @param int rowspan cf. variable de classe
  * @param object table cf. variable de classe
  * @param string couleur cf. variable de classe
  * @param string nom cf. variable de classe
  * @param string primaire cf. variable de classe
  * @param string nomgroupe cf. variable de classe
  * @param string defautnomgroupe cf. variable de classe
  * @param string commentaire cf. variable de classe
  * @param string taillemaxcom cf. variable de classe
  */
  function __construct($colspan, $rowspan, $table, $couleur="#ffffff", $nom="", $primaire="",
                         $nomgroupe="", $defautnomgroupe="", $commentaire="", $taillemaxcom=0, 
                         $couleuraltern="#fff7eb", $couleurtitre="#ffffff"){
    $this->table = $table;
    $this->tableau = $table->getTableau();
    $this->couleur = $couleur;
    $this->couleuraltern = $couleuraltern;
    $this->couleurtitre = $couleurtitre;
    $this->nom = $nom;
    $this->colspan = $colspan;
    $this->rowspan = $rowspan;
    $this->primaire = $primaire;
    $this->acb = new AutoCheckbox($this->nom);
    $this->nomgroupe = $nomgroupe;
    $this->defautnomgroupe = $defautnomgroupe;
    $this->commentaire = $commentaire;
    $this->taillemaxcom = $taillemaxcom;
  }

  /**
  * ajout d'une colonne au tableau, sous la forme d'un objet graphique (p. ex. Label, 
  * Lien, ChampTexte etc.)
  * @param string col le titre de la colonne
  * @param object outil l'objet graphique
  * @param boolean autocb s'agit-il d'un objet  ajouter  l'objet AutoCheckBox ?
  * @param boolean sterling faut-il remplacer  par la valeur de l'identifiant d'enregistrement ($primaire)
  * @param object objet si fonction callback, l'objet qui la contient (par ex. $this)
  * @param string aligne l'alignement du texte dans la colonne
  * @param string argsup un ventuel argument supplmentaire pour la fonction callback
  */
  function addColChamp($col, &$outil, $autocb=false, $sterling=false, $fonction=false,
                       $objet=false, $align="LEFT", $argsup = 0){
    $this->cols[] = $col;
    $this->outils[] = $outil;
     //Le champ, dont la valeur contient, s'il y a lieu la valeur  et dont le nom peut contenir
     //un argument supplmentaire
    $this->autocb[] = $autocb;
    $this->sterling[] = $sterling;
    $this->fonction[] = $fonction;
    $this->objet[] = $objet;
    $this->align[] = $align;
    $this->argsup[] = $argsup;
  }

  /**
  * ajout de la ligne de titres
  * @param boolean gras doivent-ils s'afficher en gras ?
  */
  function addTitres($gras=false){
    $cpt = count($this->cols);
    $titre = "<TR>";
    for ($i = 0; $i < $cpt; $i++){
      $titre .= "<TD bgColor='".$this->couleurtitre."'>" . ($gras ? "<B>" . $this->cols[$i] . "</B>" : $this->cols[$i]) . "</TD>";
    }
    $titre .= "</TR>";
    $this->titre = $titre;
  }

  /**
  * mise en forme du texte des commentaires
  * @param string texte le texte  mettre en forme
  */
  function metEnForme($texte){
    $ln = strlen($texte);
    if ($ln > $this->taillemaxcom){ // commentaire trop grand donc on tronque
    $texte = "[...] " . substr($texte, - $this->taillemaxcom);
    }
    $texte = preg_replace("/\n/", "<BR>", $texte);  
    return "<I>$texte</I>";
  }
  
  /**
  * passe le contenu au contenant (le plus souvent par le biais de sa mthode addChamp())
  * @return string le texte contenu
  */
  function TGetContenu(){
    // echo "<pre>";print_r($this->tableau);
    $acb = &$this->acb;
    $contenu = "<TD" . ($this->colspan ? " COLSPAN=$this->colspan" : "") .
               ($this->rowspan ? " ROWSPAN=$this->rowspan" : "") . "><TABLE WIDTH=\"99%\" BORDER=0 CELLPADDING=1>";
    $cpt = count($this->tableau);
    if (! is_array($this->tableau)) $cpt = 0;
    $pr = $this->primaire;
    $ccol = count($this->cols);
    if ($this->titre){
      $contenu .= $this->titre;
    }
    for ($j = 0; $j < $ccol; $j++){
      $nomprov[$j] = $this->outils[$j]->nom;
      if ($this->autocb[$j]){
        $acb->addCase($this->outils[$j]);
      }
    }
    if ($this->nomgroupe){ //Dfinition d'un groupe
      $champgroupe = explode(",", $this->table->order);
      $champgroupe = trim($champgroupe[0]);
      $champgroupe = explode(".", $champgroupe);
      $champgroupe = trim($champgroupe[count($champgroupe) - 1]);
      $precedent = "x65egslezfhsalkjlkrt";
    }
    for ($i = 0; $i < $cpt; $i++){
      if ($this->nomgroupe){ //ajout des sous-titres
        $actuel = $this->tableau[$i]->$champgroupe;
        if ($actuel != $precedent){
          $ng = $this->nomgroupe;
          $texte = $this->tableau[$i]->$ng;
          if (! $texte) $texte = $this->defautnomgroupe;
          $contenu .= "<TR><TD COLSPAN=" . $ccol ."><B>$texte</B></TD></TR>";
        }
        $precedent = $actuel;
      }
      $contenu .= "<TR>";
      for ($j = 0; $j < $ccol; $j++){
        $npr = $nomprov[$j];
        $ddd = $this->tableau[$i]->$npr;
        if($this->outils[$j]->nom){
          $this->outils[$j]->nom = $this->nom . "[" . $this->tableau[$i]->$pr . "]" . "[" . $nomprov[$j] . "]";
        }
        $this->outils[$j]->valeur = $ddd;
        $zzz = $this->outils[$j]->getContenu();
        if ($this->sterling[$j]){
          $zzz = preg_replace("//", $ddd, $zzz);
        }
        if ($this->fonction[$j]){
          if ($this->objet[$j]){
            $obj = $this->objet[$j];
            $fct = $this->fonction[$j];
            $nomarg = $this->argsup[$j];
            if ($nomarg){
              $xxx = $this->tableau[$i]->$nomarg;
              $zzz = $obj->$fct($zzz, $xxx);
            }
            else {
              $zzz = $obj->$fct($zzz);
            }
          }
          else {
            if ($nomarg){
              $xxx = $this->tableau[$i]->nomarg;
              $zzz = $obj->$fct($zzz, $xxx);
            }
            else{
              $zzz = $this->fonction[$j]($zzz);
            }
          }
        }
        $contenu .= "<TD ALIGN=" . $this->align[$j] . ($i % 2 == 0 ? " BGCOLOR=\"$this->couleur\"" : "  BGCOLOR=\"$this->couleuraltern\"") .
                    ">" . $zzz . "</TD>\n";
      }
      $contenu .= "</TR>\n";
      if ($this->commentaire){
        $champ = $this->commentaire;
        $contenu .= "<TR><TD colspan=$ccol"  . ($i % 2 == 0 ? " BGCOLOR=\"$this->couleur\"" : " BGCOLOR=\"$this->couleuraltern\"") . ">" .
                    $this->metEnForme($this->tableau[$i]->$champ) . "</TR>";
      }
    }
    if (array_sum($this->autocb)) $contenu .= $acb->getContenu(); //pas de champ autocheckboxes si aucun champ n'en a besoin
    $contenu .= "</TABLE></TD>";
    return $contenu;
  }
}


?>
