<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Aire de texte dans une cellule de table
* @package outils
*/
/**
* Aire de texte dans une cellule de table
* 
* Raccourci faisant d'un TextArea un contenant de premier niveau
* et permettant de l'insrer directement dans un objet de type OngForm
* (contenant de second niveau) sans passer par un TPanel (contenant de premier niveau)
* <pre>
* Exemple :
* $c = new TTextarea("Mazone", "bonjour");
* quivaut 
* $c = new TPanel(1, 1);
* $x = new TextArea("Mazone, "bonjour");
* $c->addChamp($x);
* </pre>
* @package outils
* @author ob
*/
class TTextArea extends TextArea {
  /**
  * le nombre de cellules enjambes
  * @var int
  */
  var $colspan = "";

  /**
  * @param string name le nom de la zone
  * @param string value le texte affich
  * @param string label l'tiquette de la zone
  * @param int cols le nombre de colonnes de texte
  * @param int lignes le nombre de lignes de texte
  * @param int wrap la valeur de l'attribut HTML "WRAP"
  */
  function __construct($name, $value, $label = "", $cols = "10", $lignes = "10", $wrap = "virtual"){
    parent::__construct($name, $value, $label, $cols, $lignes, $wrap);
  }
  
  /**
  * dfinition du nombre de colonnes enjambes
  * @param int colspam cf. variable de classe
  */
  function setColSpan($colspan){
    $this->colspan = $colspan;
  }

  /**
  * passe le contenu au contenant (le plus souvent par le biais de sa mthode addChamp())
  * @return string le texte contenu
  */
  function TGetContenu(){
    $TContenu = "<TD " . ($this->colspan ? "COLSPAN=\"$this->colspan\">" : ">");
    $TContenu .= $this->getContenu();
    $TContenu .= "</TD>\n";
    return $TContenu;
  }

}

?>
