<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Conjonction d'un formulaire et d'une table
* @package outils
*/
/**
* Conjonction d'un formulaire et d'une table
* Contenant de second niveau, analogue  OngForm, utile lorsque, graphiquement, on dsire un
* habillage graphique simple, sans onglet. Pour le reste s'instancie comme OngForm
*
* @package outils
* @author ob
*/

class TabForm {
  /**
  * la largeur (en pixels ou en %)
  * @var string
  */
  var $tWidth;
  
  /**
  * l'paisseur de la bordure (en pixels)
  * @var int
  */
  var $tBorder;
  
  /**
  * le "padding" de la table HTML
  * @var int
  */
  var $tPadding;
  
  /**
  * le "spacing" de la table HTML
  * @var int
  */
  var $tSpacing;
  
  /**
  * la couleur de fond
  * @var string
  */
  var $bgcolor;
  
  /**
  * le nom du formulaire
  * @var string
  */
  var $fName;
  
  /**
  * l'action associe au formulaire
  * @var string
  */
  var $fAction;
  
  /**
  * la mthode HTTP du formulaire (GET ou POST)
  * @var string
  */
  var $fMethod;
  
  /**
  * le type d'encodage des champs du formulaire dans la requte HTTP
  * @var string
  */
  var $fenctype;
  
  /**
  * la partie principale du contenu (texte HTML) de l'objet
  * @var string
  */
  var $corps;
  
  /**
  * faut-il centrer la table ?
  * @var boolean
  */
  var $centrer;
  
  /**
  * couleur de la bordure
  * @var string
  */
  var $borderColor;
  
  /**
  * champ du formulaire qui doit recevoir le focus au moment de l'affichage
  * @var string
  */
  var $focus;

  /**
  * Constructeur
  */
  function __construct(){
  }

  /**
  * Dfinition des paramtres de la table HTML
  * @param int width cf. variable de classe tWidth
  * @param int border cf. variable de classe tBorder
  * @param int padding cf. variable de classe tPadding
  * @param int spacing cf. variable de classe tSpacing
  * @param string bgcolor cf. variable de classe
  * @param boolean centrer cf. variable de classe
  * @param string borderColor cf. variable de classe
  */
  function setTabParam($width = "100%", $border = "0", $padding = "3", $spacing = "0", $bgcolor="#EEFFEE",
                       $centrer = false, $borderColor = 0){
    $this->tWidth = $width;
    $this->tBorder = $border;
    $this->tSpacing = $spacing;
    $this->tPadding = $padding;
    $this->bgcolor = $bgcolor;
    $this->centrer = $centrer;
    $this->borderColor = $borderColor;
  }

  /**
  * Dfinition des paramtres du formulaire
  * @param string name cf. variable fName
  * @param string action cf. variable fAction
  * @param string method cf. variable fMethod
  * @param string enctype cf. variable fenctype
  */
  function setFormParam($name = "", $action = "", $method = "", $enctype = ""){
    $this->fName = $name;
    $this->fAction = $action;
    $this->fMethod = $method;
    $this->fenctype = $enctype;
  }
  
  /**
  * Donne le focus au champ pass en paramtre
  * @param string champ le champ qui doit recevoir le focus
  */
  function setFocus($champ){
    $this->focus = $champ;
  }
  
  /**
  * Ajoute un champ au contenant, c'est--dire un contenant de premier niveau (p. ex TPanel)
  * @param object champ le champ ajout
  */
  function addChamp(&$champ){
    $this->corps .= $champ->TGetContenu();
  }

  /**
  * Ajout d'un retour  la ligne dans la table => les objets suivants s'affichent en-dessous
  */
  function addLigne(){
    $this->corps .= "</TR>\n<TR>";
  }

  /**
  * Renvoie le contenu, par exemple en le passant au cadronglet qui contient le tout
  * @return string
  */
  function getContenu(){
    $entete = ($this->centrer ? "<CENTER>" : "").
    //"<TABLE WIDTH=\"$this->tWidth\" BORDER=\"$this->tBorder\" BGCOLOR=\"$this->bgcolor\" " .
    "<TABLE WIDTH=\"$this->tWidth\" STYLE=\"border-width: $this->tBorder; border-style: solid; " .
    "border-color: $this->borderColor;\" " .
    "BGCOLOR=\"$this->bgcolor\" " .
    "CELLPADDING=\"$this->tPadding\" CELLSPACING=\"$this->tSpacing\">\n" .
    ($this->fenctype ? " ENCTYPE=\"$this->fenctype\"" : "") .
    "<FORM NAME=\"$this->fName\" METHOD=\"$this->fMethod\" ACTION=\"$this->fAction\"" . ">\n" .
    "<TR>";
    $pied = "</TR></FORM>\n</TABLE>" . ($this->centrer ? "</CENTER>" : "") . "\n";
    if ($this->focus){
      $pied .= "<SCRIPT LANGUAGE=\"JavaScript\">document.forms.$this->fName.$this->focus.focus();</SCRIPT>";
    }
    return $entete . $this->corps . $pied;
  }
  
  /**
  * Affiche directement le contenu (si on ne veut pas le passer  un autre objet
  */
  function imprime(){
    print $this->getContenu();
  }
}
