<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Aire de texte
* @package outils
*/
/**
* Aire de texte
* affiche une aire de texte (champ HTML "TextArea") dans un contenant de premier niveau (TPanel)
* <pre>
* Exemple :
* $c = new TPanel(1, 1);
* $x = new TextArea("nom", "contenu");
* $c->addChamp($x);
* </pre>
* @package outils
* @author ob
*/
class TextArea {
  /**
  * le nom de la zone
  * @var string
  */
  var $name;
  
  /**
  * le contenu (texte affich)
  * @var string
  */
  var $value;
  
  /**
  * le nombre de colonnes affiches par la zone (HTML COLS)
  * @var int
  */
  var $cols;
  
  /**
  * le nombre de lignes affiches par la zone (HTML ROWS)
  * @var int
  */
  var $lignes;
  
  /**
  * la valeur de l'attribut HTML "WRAP"
  * @var string
  */
  var $wrap;
  
  /**
  * l'tiquette de la zone texte
  * @var string
  */
  var $label;
  
  /**
  * faut-il afficher la zone en lecture seule (non ditable) ?
  * @var boolean
  */
  var $labellise;


  /**
  * @param string name cf. variable de classe
  * @param string value cf. variable de classe
  * @param string label cf. variable de classe
  * @param int cols cf. variable de classe
  * @param int lignes cf. variable de classe
  * @param string wrap cf. variable de classe
  * @param boolean labellise cf. variable de classe
  */
  function __construct($name, $value, $label = "", $cols="10", $lignes="10", $wrap="virtual", $labellise = false){
    $this->name = $name;
    $this->value = $value;
    $this->cols = $cols;
    $this->lignes = $lignes;
    $this->wrap = $wrap;
    $this->label = $label;
    $this->labellise = $labellise;
  }

  /**
  * Passe le contenu au contenant
  * En principe, est invoque par la mthode addChamp() du contenant
  * @access public
  * @return string le contenu du champ
  */
  function getContenu() {
    $contenu = "";
    
    if ($this->label) {
      $bold_deb = "";
      $bold_fin = "";
      if ($this->labellise) {
        $bold_deb = "<B>";
        $bold_fin = "</B>";
      }
      $contenu = $bold_deb . $this->label . $bold_fin . "<BR>";
    }
    if (! $this->labellise) {
      $contenu .= "<TEXTAREA NAME=\"$this->name\" COLS=\"$this->cols\" ROWS=\"$this->lignes\" WRAP=\"$this->wrap\">" .
                  stripslashes($this->value) . "</TEXTAREA>";    
    } else {
      $contenu .= "$this->value <INPUT NAME=\"$this->name\" VALUE=\"" . addslashes($this->value) .
                  "\" TYPE=\"HIDDEN\">\n";
    }
    
    return $contenu;
  }


}
?>
