<?php

class outilXML {

    var $xml;
    var $dom;
    var $sessionid;
    
    function __construct($xml = "", $sessionid = "") {
        
        $this->xml = $xml;
        $this->dom = new DOMDocument("1.0", "UTF-8");
        $this->sessionid = $sessionid;
        if ($xml != "") $this->dom->loadXML($this->xml);
    }
        
    function getRecursive($path, $name, $origin = null) {
        
        if (is_null($origin)) $origin = $this->dom;
        
        if (count($path) > 0) {
            
            $next = array_shift($path);
            $content = $origin->getElementsByTagName($next)->item(0);
            return $this->getRecursive($path,$name,$content);
            
        } else {

            $origin = $origin->getElementsByTagName($name)->item(0);
            if ($origin != "") {
                if ($origin->hasChildNodes()) {
                    $content = mysql_escape_string(utf8_decode($origin->firstChild->nodeValue));
                    return $content;
                } else return "";
            } else return "";
        }
    }
    
    function getDemande($nodoss = 0) {
     
        $DEMANDE = array();

        $DEMANDE["servplac"] = ""; // TBD
        $DEMANDE["medecinautre"] = "";
        $DEMANDE["referent"] = "";
        $DEMANDE["telref"] = "";
        $DEMANDE["litdepuis"] = $this->getRecursive(array("DemandeOrientation","PriseEnCharge"),"DateDes");
        $DEMANDE["litjusqua"] = $this->getRecursive(array("DemandeOrientation","PriseEnCharge"),"DateFin");
        $DEMANDE["debutpec"] = $this->getRecursive(array("DemandeOrientation","PriseEnCharge"),"Urgence");
        $idactivemq = $this->getRecursive(array("DemandeOrientation","PriseEnCharge"),"Type");
        if ($idactivemq == "") $DEMANDE["typesej"] = 0;
        else {
            $tsejID = new ensTableBrioche("typesejour","idactivemq = '$idactivemq'","idts",0,$this->sessionid);    
            $tsejID = $tsejID->getPremier("idts");
            $DEMANDE["typesej"] = $tsejID;
            if ($idactivemq == "Autre") $DEMANDE["typesejautre"] = $this->getRecursive(array("DemandeOrientation","PriseEnCharge"),"AutreType");
        }
        $idactivemq = $this->getRecursive(array("DemandeOrientation","PriseEnCharge"),"Nature");
        if ($idactivemq == "") $DEMANDE["typepath"] = 0;
        else {
            $tpathID = new ensTableBrioche("typepath","idactivemq = '$idactivemq'","idtp",0,$this->sessionid);    
            $tpathID = $tpathID->getPremier("idtp");
            $DEMANDE["typepath"] = $tpathID;
        }
        $DEMANDE["autre"] = $this->getRecursive(array("DemandeOrientation","PriseEnCharge"),"AutreNature");
        $DEMANDE["nodoss"] = $nodoss;
        $idactivemq = $this->getRecursive(array("DemandeOrientation"),"Provenance");
        if ($idactivemq == "") $DEMANDE["provenance"] = 0;
        else {
            $provID = new ensTableBrioche("provenance","idactivemq = '$idactivemq'","idprovenance",0,$this->sessionid);    
            $provID = $provID->getPremier("idprovenance");
            $DEMANDE["provenance"] = $provID;
        }
        $DEMANDE["prov_anterieure"] = "";
        $idactivemq = $this->getRecursive(array("DemandeOrientation"),"SituationSociale");
        if ($idactivemq == "") $DEMANDE["sitsoc"] = 0;
        else {
            $ssid = new ensTableBrioche("typesitsociale","idactivemq = '$idactivemq'","idss",0,$this->sessionid);    
            $ssid = $ssid->getPremier("idss");
            $DEMANDE["sitsoc"] = $ssid;
            if ($idactivemq == "Autre") $DEMANDE["sitsocautre"] = $this->getRecursive(array("DemandeOrientation"),"AutreSituationSociale");
        }
        $DEMANDE["aidepr"] = 0; // TBD
        $idactivemq = $this->getRecursive(array("DemandeOrientation"),"AideRecue");
        if ($idactivemq == "") $DEMANDE["cms"] = 0;
        else {
            $idad = new ensTableBrioche("typeaidedom","idactivemq = '$idactivemq'","idad",0,$this->sessionid);    
            $idad = $idad->getPremier("idad");
            $DEMANDE["cms"] = $idad;
        }
        if ($DEMANDE["cms"] == 1) $DEMANDE["aidecms"] = 0;
        else $DEMANDE["aidecms"] = -1;
        $DEMANDE["uat"] = 0; // TBD
        $DEMANDE["litvirt"] = 0;
        $DEMANDE["refent"] = $this->getRecursive(array("DemandeOrientation","PersonneDeReference"),"Nom");
        $DEMANDE["telrefent"] = $this->getRecursive(array("DemandeOrientation","PersonneDeReference"),"NoTelephone");
        $DEMANDE["souhaits"] = $this->getRecursive(array("DemandeOrientation"),"Souhaits");
        $DEMANDE["compl"] = $this->getRecursive(array("DemandeOrientation"),"Commentaire");
        $DEMANDE["doctrans"] = 0;
        $DEMANDE["dmttrans"] = 0;
        $supp = $this->getRecursive(array("DemandeOrientation"),"SupplementChambreIndividuelle");
        if ($supp == 0) $supp = 2;
        $DEMANDE["supplement_ch_indiv"] = $supp;
        $DEMANDE["datedem"] = date("d.m.Y");
        $DEMANDE["etsejobs"] = "";
        $DEMANDE["nomdem"] = "";
        $DEMANDE["asssoc"] = $this->getRecursive(array("DemandeOrientation","AssuranceSociales"),"Type");
        $DEMANDE["pc"] = -1*$this->getRecursive(array("DemandeOrientation","AssuranceSociales"),"PC");
        $DEMANDE["api"] = -1*$this->getRecursive(array("DemandeOrientation","AssuranceSociales"),"API");
        $DEMANDE["anx"] = -1*$this->getRecursive(array("DemandeOrientation","ProblemesParticuliers"),"AnxieteInsecurite");
        $DEMANDE["trcomp"] = -1*$this->getRecursive(array("DemandeOrientation","ProblemesParticuliers"),"TroublesComportementFugues");
        $DEMANDE["resmult"] = -1*$this->getRecursive(array("DemandeOrientation","ProblemesParticuliers"),"ResistanceMultiplesAntibiotiques");
        $DEMANDE["chutes"] = -1*$this->getRecursive(array("DemandeOrientation","ProblemesParticuliers"),"Chutes");
        $DEMANDE["solitude"] = -1*$this->getRecursive(array("DemandeOrientation","ProblemesParticuliers"),"Solitude");
        $DEMANDE["dependance"] = -1*$this->getRecursive(array("DemandeOrientation","ProblemesParticuliers"),"Toxicodependances");
        $DEMANDE["perfusion"] = -1*$this->getRecursive(array("DemandeOrientation","ProblemesParticuliers"),"Perfusion");
        $DEMANDE["dominadequat"] = -1*$this->getRecursive(array("DemandeOrientation","ProblemesParticuliers"),"DomicileInadequat");
        $DEMANDE["absenceent"] = -1*$this->getRecursive(array("DemandeOrientation","ProblemesParticuliers"),"AbsenceEntourage");
        $DEMANDE["epuisementent"] = -1*$this->getRecursive(array("DemandeOrientation","ProblemesParticuliers"),"EpuisementEntourage");
        $DEMANDE["respiratoire"] = -1*$this->getRecursive(array("DemandeOrientation","ProblemesParticuliers"),"ProblemeRespiratoire");
        $DEMANDE["refuscms"] = -1*$this->getRecursive(array("DemandeOrientation","ProblemesParticuliers"),"RefusCMS");
        $DEMANDE["mobilite"] = -1*$this->getRecursive(array("DemandeOrientation","ProblemesParticuliers"),"Mobilite");
        $DEMANDE["autreprobl"] = $this->getRecursive(array("DemandeOrientation","ProblemesParticuliers"),"AutreProbleme");
        $DEMANDE["notrans"] = "";
        $DEMANDE["brioorigine"] = "";
        $DEMANDE["nomanege"] = "";
        
        return $DEMANDE;
    }
    
    function getDMST($nodoss = 0) {
        
        $DMST = array();
        $DMST["dmd5"] = md5(time());
        $DMST["nodoss"] = $nodoss;
        
        $DMST["C_Org_Nom"] = ""; // TBD
        $DMST["C_Org_Id"] = ""; // TBD
        $DMST["C_TypeDoc"] = "DMST";
        $DMST["x_Nom"] = $this->getRecursive(array("Patient"),"Nom");
        $DMST["x_Prenom"] = $this->getRecursive(array("Patient"),"Prenom");
        $DMST["C_Patient_Id"] = 0; // TBD
        $DMST["d_Naissance"] = $this->transformDate($this->getRecursive(array("Patient"),"DateDeNaissance"));
        $DMST["A_Etatgeneral"] = $this->getRecursive(array("DMST"),"BilanDeSante");
        $DMST["a_Iti"] = $this->getRecursive(array("DMST"),"Habitat");
        $DMST["a_Motiftransfert"] = $this->getRecursive(array("DMST","PriseEnChargeLorsTransfert"),"Motif");
        $DMST["a_Resbes"] = $this->getRecursive(array("DMST"),"ContexteHabitudesDeVie");
        $DMST["a_Traitcours"] = $this->getRecursive(array("DMST","PriseEnChargeLorsTransfert"),"TraitementsEnCours");
        $DMST["b_Dm_Enannexe"] = 0; // TBD
        $DMST["b_Dm_Env_Dr"] = 0; // TBD
        $DMST["b_Dm_Suit"] = 0; // TBD
        $DMST["d_Dentree"] = $this->transformDate($this->getRecursive(array("DMST","DonneesAdministratives"),"DateEntree"));
        $DMST["d_Desortie"] = $this->transformDate($this->getRecursive(array("DMST","DonneesAdministratives"),"DateSortie"));
        $DMST["d_Transport"] = $this->transformDate($this->getRecursive(array("DMST","PriseEnChargeLorsTransfert"),"Date"));
        $DMST["n_Accordpatient"] = $this->getRecursive(array("DMST","Transmission"),"DocumentTransmissible");
        $DMST["n_Dapourheb"] = 0; // TBD
        if ($this->getRecursive(array("Patient"),"Sexe") == "M") $sexe = 1;
        else $sexe = 0;
        $DMST["n_Sexe"] = $sexe;
        $DMST["n_Transfavec"] = $this->getRecursive(array("DMST","PriseEnChargeLorsTransfert"),"Accessoires");
        $DMST["t_Curtel"] = $this->getRecursive(array("Patient","FamilleEntourage","TuteurCurateur"),"NoTelephone");
        $DMST["t_Domtel"] = $this->getRecursive(array("Patient"),"NoTelephone");
        $DMST["t_Med_Tel"] = $this->getRecursive(array("DMST","DonneesAdministratives","MedecinTraitant"),"NoTelephone");
        $DMST["t_Persreftel"] = $this->getRecursive(array("DMST","FamilleEntourage","PersonneDeReference"),"NoTelephone");
        $DMST["t_Persvivtel"] = $this->getRecursive(array("DMST","FamilleEntourage","PersonneVivantAvec"),"NoTelephone");
        $DMST["t_Telurg"] = $this->getRecursive(array("DMST","DonneesAdministratives"),"NoTelephoneUrgence");
        $DMST["x_Ass"] = $this->getRecursive(array("DMST","DonneesAdministratives","Assurance"),"Nom");
        $DMST["x_Cur"] = $this->getRecursive(array("Patient","FamilleEntourage","TuteurCurateur"),"Nom");
        $DMST["x_Curadr"] = $this->getRecursive(array("Patient","FamilleEntourage","TuteurCurateur"),"Commentaire");
        $DMST["x_Dm_Env_Dr"] = ""; // TBD
        $DMST["x_Dom"] = $this->getRecursive(array("Patient","Adresse"),"RueEtNumero");
        $DMST["x_DomNoPostal"] = $this->getRecursive(array("Patient","Adresse"),"NoPostal");
        $DMST["x_DomLocalite"] = $this->getRecursive(array("Patient","Adresse"),"Localite");
        $DMST["x_Etatcivil"] = $this->getRecursive(array("DMST","DonneesAdministratives"),"EtatCivil");
        $DMST["x_Filmat"] = $this->getRecursive(array("DMST","DonneesAdministratives"),"FiliationMaternelle");
        $DMST["x_Filpat"] = $this->getRecursive(array("DMST","DonneesAdministratives"),"FiliationPaternelle");
        $DMST["x_Lieudenaissance"] = $this->getRecursive(array("DMST","DonneesAdministratives"),"LieuDeNaissance");
        $DMST["x_Medhop"] = $this->getRecursive(array("DMST","DonneesAdministratives","MedecinHopital"),"Nom");
        $DMST["x_Med_Ord"] = $this->getRecursive(array("DMST","Medicaments","MedecinPrescripteur"),"Nom");
        $DMST["x_Medtrait"] = $this->getRecursive(array("DMST","DonneesAdministratives","MedecinTraitant"),"Nom");
        $DMST["x_Nation"] = $this->getRecursive(array("DMST","DonneesAdministratives"),"Nationalite");
        $DMST["x_Npconjoint"] = $this->getRecursive(array("DMST","DonneesAdministratives"),"Conjoint");
        $DMST["x_Numass"] = $this->getRecursive(array("DMST","DonneesAdministratives","Assurance"),"NoAssure");
        $DMST["x_Numavs"] = $this->getRecursive(array("Patient"),"NoAVS");
        $DMST["x_Numerodeclient"] = $this->getRecursive(array("Patient"),"NoClientCMS");
        $DMST["x_Origine"] = $this->getRecursive(array("DMST","DonneesAdministratives"),"Origine");
        $DMST["x_Nation"] = $this->getRecursive(array("DMST","DonneesAdministratives"),"Nationalite");
        $DMST["x_Persrefadr"] = $this->getRecursive(array("DMST","FamilleEntourage","PersonneDeReference"),"Commentaire");
        $DMST["x_Persrefnom"] = $this->getRecursive(array("DMST","FamilleEntourage","PersonneDeReference"),"Nom");
        $DMST["x_Persviv"] = $this->getRecursive(array("DMST","FamilleEntourage","PersonneVivantAvec"),"Nom");
        $DMST["x_Persvivadr"] = $this->getRecursive(array("DMST","FamilleEntourage","PersonneVivantAvec"),"Commentaire");
        $DMST["x_Profess"] = $this->getRecursive(array("DMST","DonneesAdministratives"),"Profession");
        $DMST["x_Relconf"] = $this->getRecursive(array("DMST","DonneesAdministratives"),"Confession");
        $DMST["x_Transfavec"] = ""; // TBD
        $DMST["x_Transportpar"] = $this->getRecursive(array("DMST","PriseEnChargeLorsTransfert","EffectuePar"),"Nom");
        
        return $DMST;
    }
    
    function getMedicaments($iddmst = 0) {
        
        $MEDICS = array();
        
        $medicaments = $this->dom->getElementsByTagName("Medicament");
        foreach ($medicaments as $k => $medicament) {
            $MEDICS[$k]["iddmst"] = $iddmst;
            $MEDICS[$k]["x_Med_Nom"] = $this->getRecursive(array(),"Nom",$medicament);
            $prise = $medicament->getElementsByTagName("Prise")->item(0);
            
            $MEDICS[$k]["b_Med_Matin"] = $this->getRecursive(array(),"Matin",$prise);
            $MEDICS[$k]["b_Med_Midi"] = $this->getRecursive(array(),"Midi",$prise);
            $MEDICS[$k]["b_Med_Soir"] = $this->getRecursive(array(),"Soir",$prise);
            $MEDICS[$k]["b_Med_Nuit"] = $this->getRecursive(array(),"Nuit",$prise);
            $MEDICS[$k]["x_Med_Autres"] = $this->getRecursive(array(),"Autres",$prise);
        }
        
        return $MEDICS;
    }
    
    function getIntervenants($iddmst = 0) {
        
        $INTERVS = array();
        
        $intervenants = $this->dom->getElementsByTagName("Intervenants");
        foreach ($intervenants as $k => $intervenant) {
            if ($this->getRecursive(array(),"Nom",$intervenant) == "") continue;
            $INTERVS[$k]["iddmst"] = $iddmst;
            $INTERVS[$k]["x_int_nom"] = $this->getRecursive(array(),"Nom",$intervenant);
            $INTERVS[$k]["t_int"] = $this->getRecursive(array(),"NoTelephone",$intervenant);
            $INTERVS[$k]["x_int_precision"] = $this->getRecursive(array(),"Commentaire",$intervenant);
        }
        
        return $INTERVS;
    }
    
    function getGrille($nododss = 0) {
        
        $GRILLE = array();
        $GRILLE["nodoss"] = $nododss;
        
        $GRILLE["manger"] = $this->getRecursive(array("DMST","NiveauAutonomie","ActivitesQuotidiennes"),"MangerBoire");
        $GRILLE["laver"] = $this->getRecursive(array("DMST","NiveauAutonomie","ActivitesQuotidiennes"),"SeLaver");
        $GRILLE["habiller"] = $this->getRecursive(array("DMST","NiveauAutonomie","ActivitesQuotidiennes"),"Habiller");
        $GRILLE["deshab"] = $this->getRecursive(array("DMST","NiveauAutonomie","ActivitesQuotidiennes"),"Deshabiller");
        $GRILLE["entpers"] = $this->getRecursive(array("DMST","NiveauAutonomie","ActivitesQuotidiennes"),"EntretenirSaPersonne");
        $GRILLE["contves"] = $this->getRecursive(array("DMST","NiveauAutonomie","ActivitesQuotidiennes"),"ContinenceVesicale");
        $GRILLE["contana"] = $this->getRecursive(array("DMST","NiveauAutonomie","ActivitesQuotidiennes"),"ContinenceAnale");
        $GRILLE["toilet"] = $this->getRecursive(array("DMST","NiveauAutonomie","ActivitesQuotidiennes"),"UtiliserToilettes");
        
        $GRILLE["changpos"] = $this->getRecursive(array("DMST","NiveauAutonomie","Mobilite"),"ChangerPosition");
        $GRILLE["deplint"] = $this->getRecursive(array("DMST","NiveauAutonomie","Mobilite"),"DeplacerInterieur");
        $GRILLE["deplext"] = $this->getRecursive(array("DMST","NiveauAutonomie","Mobilite"),"DeplacerExterieur");
        $GRILLE["moytransp"] = $this->getRecursive(array("DMST","NiveauAutonomie","Mobilite"),"UtiliserMoyensTransport");
        $GRILLE["auxil"] = $this->getRecursive(array("DMST","NiveauAutonomie","Mobilite"),"UtiliserMoyensAuxiliaires");
        $GRILLE["escaliers"] = $this->getRecursive(array("DMST","NiveauAutonomie","Mobilite"),"UtiliserEscaliers");
        
        $GRILLE["voir"] = $this->getRecursive(array("DMST","NiveauAutonomie","Communication"),"Voir");
        $GRILLE["entendre"] = $this->getRecursive(array("DMST","NiveauAutonomie","Communication"),"Entendre");
        $GRILLE["parler"] = $this->getRecursive(array("DMST","NiveauAutonomie","Communication"),"Parler");
        $GRILLE["telephone"] = $this->getRecursive(array("DMST","NiveauAutonomie","Communication"),"UtiliserTelephone");
        
        $GRILLE["memoire"] = $this->getRecursive(array("DMST","NiveauAutonomie","EtatPsychiqueFacultesMentales"),"Memoire");
        $GRILLE["orientat"] = $this->getRecursive(array("DMST","NiveauAutonomie","EtatPsychiqueFacultesMentales"),"Orientation");
        $GRILLE["jugement"] = $this->getRecursive(array("DMST","NiveauAutonomie","EtatPsychiqueFacultesMentales"),"JugementComprehension");
        $GRILLE["soccuper"] = $this->getRecursive(array("DMST","NiveauAutonomie","EtatPsychiqueFacultesMentales"),"GererTempsLibre");
        
        $GRILLE["entrlog"] = $this->getRecursive(array("DMST","NiveauAutonomie","TachesDomestiques"),"EntretenirLogement");
        $GRILLE["courses"] = $this->getRecursive(array("DMST","NiveauAutonomie","TachesDomestiques"),"FaireCourses");
        $GRILLE["preprepas"] = $this->getRecursive(array("DMST","NiveauAutonomie","TachesDomestiques"),"PreparerRepas");
        $GRILLE["lessive"] = $this->getRecursive(array("DMST","NiveauAutonomie","TachesDomestiques"),"FaireLessive");
        $GRILLE["medics"] = $this->getRecursive(array("DMST","NiveauAutonomie","TachesDomestiques"),"PrendreMedicaments");
        $GRILLE["gestad"] = $this->getRecursive(array("DMST","NiveauAutonomie","TachesDomestiques"),"GestionAdministrative");
        $GRILLE["lienssociaux"] = $this->getRecursive(array("DMST","NiveauAutonomie","TachesDomestiques"),"GererLiensSociaux");
        
        return $GRILLE;
    }
    
    function transformDate($dateXML) {
     
        if ($dateXML == "") return "";
        $dateDB = explode("-",$dateXML);
        $dateDB = $dateDB[2].".".$dateDB[1].".".$dateDB[0];
        return $dateDB;
    }
            
    function dmstDataToXML($usager, $dmst, $medics, $intervs, $grille, $source, $dest) {
                                            
        // ROOT
        $xmlArray = array();
        $xmlArray["Message"]["attributes"]["version"] = "1.0";
        // SOURCE
        $xmlArray["Message"]["Source"]["Organisation"]["value"] = $source;
        $xmlArray["Message"]["Source"]["Personne"]["value"] = "";
        $xmlArray["Message"]["Source"]["NoTelephone"]["value"] = "";
        $xmlArray["Message"]["Source"]["AdresseEMail"]["value"] = "";
        // DESTINATION
        $xmlArray["Message"]["Destination"]["Organisation"]["value"] = $dest;
        $xmlArray["Message"]["Destination"]["Personne"]["value"] = "";
        $xmlArray["Message"]["Destination"]["NoTelephone"]["value"] = "";
        $xmlArray["Message"]["Destination"]["AdresseEMail"]["value"] = "";
        // TIMESTAMP
        $xmlArray["Message"]["Timestamp"]["value"] = date("Y-m-d\TH:i:s.0\Z");
        // PATIENT
        $xmlArray["Message"]["Patient"]["Sexe"]["value"] = $usager->sexe;
        $xmlArray["Message"]["Patient"]["Nom"]["value"] = $usager->nom;
        $xmlArray["Message"]["Patient"]["Prenom"]["value"] = $usager->prenom;
        $dNaissance = substr($usager->datenaiss,6,4).'-'.substr($usager->datenaiss,3,2).'-'.substr($usager->datenaiss,0,2);
        $xmlArray["Message"]["Patient"]["DateDeNaissance"]["value"] = $dNaissance;
        $xmlArray["Message"]["Patient"]["Adresse"]["RueEtNumero"]["value"] = $usager->adresse;
        $xmlArray["Message"]["Patient"]["Adresse"]["NoPostal"]["value"] = $usager->npa;
        $xmlArray["Message"]["Patient"]["Adresse"]["Localite"]["value"] = $usager->loc;
        $xmlArray["Message"]["Patient"]["NoTelephone"]["value"] = $usager->telephone;
        if ($usager->avs != "")
            $xmlArray["Message"]["Patient"]["NoAVS"]["value"] = $usager->avs;
        else
            $xmlArray["Message"]["Patient"]["NoAVS"]["value"] = "000.00.000.000";
        if ($dmst->x_Numerodeclient != "")
            $xmlArray["Message"]["Patient"]["NoClientCMS"]["value"] = $dmst->x_Numerodeclient;
            
        // CONTENU
        // DMST
        $xmlArray["Message"]["Contenu"]["DMST"]["Transmission"]["DocumentTransmissible"]["value"] = $dmst->n_Accordpatient;
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["LieuDeNaissance"]["value"] = $dmst->x_Lieudenaissance;
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["EtatCivil"]["value"] = "Autre";
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["AutreEtatCivil"]["value"] = $dmst->x_Etatcivil;
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["Confession"]["value"] = $dmst->x_Relconf;
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["Origine"]["value"] = $dmst->x_Origine;
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["Nationalite"]["value"] = $dmst->x_Nation;
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["FiliationMaternelle"]["value"] = $dmst->x_Filmat;
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["FiliationPaternelle"]["value"] = $dmst->x_Filpat;
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["Profession"]["value"] = $dmst->x_Profess;
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["Conjoint"]["value"] = $dmst->x_Npconjoint;
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["NoTelephoneUrgence"]["value"] = $dmst->t_Telurg;
        if ($dmst->d_Dentree != "") {
            $dateEntree = explode(".",$dmst->d_Dentree);
            $dateEntree = $dateEntree[2].'-'.$dateEntree[1].'-'.$dateEntree[0];
            $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["DateEntree"]["value"] = $dateEntree;
        }
        if ($dmst->d_Desortie != "") {
            $dateSortie = explode(".",$dmst->d_Desortie);
            $dateSortie = $dateSortie[2].'-'.$dateSortie[1].'-'.$dateSortie[0];
            $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["DateSortie"]["value"] = $dateSortie;
        }
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["MedecinTraitant"]["Nom"]["value"] = $dmst->x_Medtrait;
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["MedecinHopital"]["Nom"]["value"] = $dmst->x_Medhop;
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["Assurance"]["Nom"]["value"] = $dmst->x_Ass;
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["Assurance"]["NoAssure"]["value"] = $dmst->x_Numass;
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["PersonneDeReference"]["Nom"]["value"] = $dmst->x_Persrefnom;
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["PersonneDeReference"]["NoTelephone"]["value"] = $dmst->t_Persreftel;
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["PersonneDeReference"]["Commentaire"]["value"] = $dmst->x_Persrefadr;
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["PersonneVivantAvec"]["Nom"]["value"] = $dmst->x_Persviv;
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["PersonneVivantAvec"]["NoTelephone"]["value"] = $dmst->t_Persvivtel;
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["PersonneVivantAvec"]["Commentaire"]["value"] = $dmst->x_Persvivadr;
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["TuteurCurateur"]["Nom"]["value"] = $dmst->x_Cur;
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["TuteurCurateur"]["NoTelephone"]["value"] = $dmst->t_Curtel;
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["TuteurCurateur"]["Commentaire"]["value"] = $dmst->x_Curadr;
        $xmlArray["Message"]["Contenu"]["DMST"]["Habitat"]["value"] = $dmst->a_Iti;
        $xmlArray["Message"]["Contenu"]["DMST"]["ContexteHabitudesDeVie"]["value"] = $dmst->a_Resbes;
        $xmlArray["Message"]["Contenu"]["DMST"]["Intervenants"]["multiple"] = true;
        if (is_array($intervs)) {
            $cpt = 0;
            foreach ($intervs as $k => $interv) {
                $xmlArray["Message"]["Contenu"]["DMST"]["Intervenants"][$cpt]["Intervenant"]["Nom"]["value"] = $interv->x_int_nom;
                $xmlArray["Message"]["Contenu"]["DMST"]["Intervenants"][$cpt]["Intervenant"]["NoTelephone"]["value"] = $interv->t_int;
                $xmlArray["Message"]["Contenu"]["DMST"]["Intervenants"][$cpt]["Intervenant"]["Commentaire"]["value"] = $interv->x_int_precision;
                $cpt++;
            }
        }
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["ActivitesQuotidiennes"]["MangerBoire"]["value"] = $grille->manger;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["ActivitesQuotidiennes"]["SeLaver"]["value"] = $grille->laver;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["ActivitesQuotidiennes"]["Habiller"]["value"] = $grille->habiller;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["ActivitesQuotidiennes"]["Deshabiller"]["value"] = $grille->deshab;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["ActivitesQuotidiennes"]["EntretenirSaPersonne"]["value"] = $grille->entpers;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["ActivitesQuotidiennes"]["ContinenceVesicale"]["value"] = $grille->contves;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["ActivitesQuotidiennes"]["ContinenceAnale"]["value"] = $grille->contana;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["ActivitesQuotidiennes"]["UtiliserToilettes"]["value"] = $grille->toilet;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Mobilite"]["ChangerPosition"]["value"] = $grille->changpos;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Mobilite"]["DeplacerExterieur"]["value"] = $grille->deplext;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Mobilite"]["DeplacerInterieur"]["value"] = $grille->deplint;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Mobilite"]["UtiliserMoyensTransport"]["value"] = $grille->moytransp;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Mobilite"]["UtiliserMoyensAuxiliaires"]["value"] = $grille->auxil;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Mobilite"]["UtiliserEscaliers"]["value"] = $grille->escaliers;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Communication"]["Voir"]["value"] = $grille->voir;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Communication"]["Entendre"]["value"] = $grille->entendre;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Communication"]["Parler"]["value"] = $grille->parler;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Communication"]["UtiliserTelephone"]["value"] = $grille->telephone;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["EtatPsychiqueFacultesMentales"]["Memoire"]["value"] = $grille->memoire;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["EtatPsychiqueFacultesMentales"]["Orientation"]["value"] = $grille->orientat;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["EtatPsychiqueFacultesMentales"]["JugementComprehension"]["value"] = $grille->jugement;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["EtatPsychiqueFacultesMentales"]["GererTempsLibre"]["value"] = $grille->soccuper;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["TachesDomestiques"]["EntretenirLogement"]["value"] = $grille->entrlog;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["TachesDomestiques"]["PreparerRepas"]["value"] = $grille->preprepas;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["TachesDomestiques"]["FaireCourses"]["value"] = $grille->courses;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["TachesDomestiques"]["FaireLessive"]["value"] = $grille->lessive;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["TachesDomestiques"]["PrendreMedicaments"]["value"] = $grille->medics;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["TachesDomestiques"]["GestionAdministrative"]["value"] = $grille->gestad;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["TachesDomestiques"]["GererLiensSociaux"]["value"] = $grille->lienssociaux;
        $xmlArray["Message"]["Contenu"]["DMST"]["BilanDeSante"]["value"] = $dmst->A_Etatgeneral;
        if ($dmst->d_Transport != "") {
            $dateTransport = explode(".",$dmst->d_Transport);
            $dateTransport = $dateTransport[2].'-'.$dateTransport[1].'-'.$dateTransport[0];
            $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["DateTransfert"]["value"] = $dateTransport;
        }
        $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Motif"]["value"] = $dmst->a_Motiftransfert;
        $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["TraitementsEnCours"]["value"] = $dmst->a_Traitcours;
        $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"]["multiple"] = true;
        if (is_array($medics)) {
            $cpt = 0;
            foreach ($medics as $k => $medics) {
                $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"][$cpt]["Medicament"]["Nom"]["value"] = $medics->x_Med_Nom;
                $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"][$cpt]["Medicament"]["Prise"]["Matin"]["value"] = $medics->b_Med_Matin;
                $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"][$cpt]["Medicament"]["Prise"]["Midi"]["value"] = $medics->b_Med_Midi;
                $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"][$cpt]["Medicament"]["Prise"]["Soir"]["value"] = $medics->b_Med_Soir;
                $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"][$cpt]["Medicament"]["Prise"]["Nuit"]["value"] = $medics->b_Med_Nuit;
                $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"][$cpt]["Medicament"]["Prise"]["Autres"]["value"] = $medics->x_Med_Autres;
                $cpt++;
            }
        }
        $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"][$cpt]["MedecinPrescripteur"]["Nom"]["value"] = $dmst->x_Med_Ord;
        $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"][$cpt]["MedecinPrescripteur"]["NoTelephone"]["value"] = $dmst->t_Med_Tel;
        $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Accessoires"]["value"] = $dmst->n_Transfavec;
        $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["EffectuePar"]["Nom"]["value"] = $dmst->x_Transportpar;
                
        $this->XMLgenerator($xmlArray, $this->dom, $this->dom);
                    
        libxml_use_internal_errors(true);        
        if (!@$this->dom->schemaValidate("Manege.xsd")) {
            $errors = libxml_get_errors();   
            $error = "<div style='padding:10px;background-color:white;border:2px solid red;'>";
            foreach ($errors as $err) {
                $error .= "<b style='color:red'>".$err->message . "</b></br>";
            }
            $error .= "</div><br/>";
            echo $error;
            return false;
        }
        
        $xml = $this->dom->saveXML();       
        return $xml;
    }
    
    function XMLgenerator($xmlArray, $parent, $dom) {
        
        if (count($xmlArray) == 0) return;
        
        foreach ($xmlArray as $key => $xmlElmnt) {
            
            if (isset($xmlElmnt["value"])) {
                $trans = array("<"=>"&lt;",">"=>"&gt;","&"=>"&amp;");
                $xmlElmnt["value"] = strtr($xmlElmnt["value"],$trans);
                $elemnt = $dom->createElement($key, utf8_encode($xmlElmnt["value"]));
                unset($xmlElmnt["value"]);
            } else {
                $elemnt = $dom->createElement($key);
            }
                    
            if (isset($xmlElmnt["attributes"])) {
                foreach ($xmlElmnt["attributes"] as $attKey => $attValue) {
                    $trans = array("<"=>"&lt;",">"=>"&gt;","&"=>"&amp;");
                    $attValue = strtr($attValue,$trans);
                    $elemnt->setAttribute($attKey, utf8_encode($attValue));
                }
                unset($xmlElmnt["attributes"]);
            }
            
            $elemnt = $parent->appendChild($elemnt);
            
            if (isset($xmlElmnt["multiple"]) && $xmlElmnt["multiple"]) {
                unset($xmlElmnt["multiple"]);
                foreach ($xmlElmnt as $xmlSubElment) {
                    $this->XMLgenerator($xmlSubElment, $elemnt, $dom);
                }
            } else {
                $this->XMLgenerator($xmlElmnt, $elemnt, $dom);
            }
        }   
    }

    function stompSend($xml, $queue) {
  
        global $ini;
        
        $c = @new StompConnection($ini->connectionActiveMQ);
        $result = @$c->connect();
        if ($result == null || $result->command != 'CONNECTED') {
            trigger_error("Client not connected", E_USER_ERROR);
        }
        
        @$c->send("/queue/$queue", $xml, array("persistent" => "true"));
        @$c->disconnect();
    }
    
    function getOrganisations($type) {
     
        global $ini;
        if ($ini->connectionLDAP == "") return array();
        $organisations = array();
        
        $conn = explode(".",$ini->connectionLDAP);
        $connString = "";
        foreach ($conn as $elmnt) {
            $connString .= ",dc=".$elmnt;
        }        
                
        $link = ldap_connect($ini->connectionLDAP, $ini->portLDAP);
        
        ldap_set_option($link, LDAP_OPT_PROTOCOL_VERSION, 3);
        
        $bind = ldap_bind($link, "cn=admin".$connString, "password1");
        $result = ldap_search($link, "o=$type,cn=admin".$connString, "ou=*");
        $result = ldap_get_entries($link, $result);

        foreach ($result as $key => $res) {
         
            if (isset($res["ou"])) $organisations[$res["ou"][0]] = $res["ou"][0];   
        }
        
        return $organisations;
    }
}

?>