-- Patch bd grant le passage de la version 3_6  la version 3_7
-- mysql dbrio < patch_global_v3_6-v3_7.sql

-- Remplacement de la mention quivoque "Court sjour planifi" par
-- Court sjour planning dans la table typesejour.

UPDATE typesejour SET ttypesej = "Court sjour planning" WHERE idts = 5;
UPDATE typesejour SET ordre = 0 WHERE idts = 5;

DROP TABLE IF EXISTS `typepath`;
CREATE TABLE `typepath` (
  `idtp` smallint(6) NOT NULL default '0',
  `ttypepath` char(25) default NULL,
  `tst` timestamp NOT NULL,
  `ordre` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`idtp`)
) ENGINE=MyISAM;

LOCK TABLES `typepath` WRITE;
INSERT INTO `typepath` VALUES (4,'Autre','2006-02-13 12:23:46',4),(3,'Psychiatrie','2006-02-13 12:23:46',3),(2,'Griatrie','2006-02-13 12:23:46',2),(1,'Psychogriatrie','2006-02-13 12:23:46',1);
UNLOCK TABLES;

DROP TABLE IF EXISTS `typedebutpec`;
CREATE TABLE `typedebutpec` (
  `iddp` smallint(6) NOT NULL default '0',
  `ttypedebutpec` char(50) default NULL,
  `tst` timestamp NOT NULL,
  `ordre` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`iddp`)
) ENGINE=MyISAM;
LOCK TABLES `typedebutpec` WRITE;
INSERT INTO `typedebutpec` VALUES (4,'Dans plus d\'un mois','2006-02-13 19:05:14',4),(3,'Dans 1 semaine  1 mois max.','2006-02-13 19:05:14',3),(2,'Ds maintenant mais sans urgence (3  6 jours)','2006-02-13 19:05:14',2),(1,'Le plus vite possible (0  2 jours)','2006-02-13 19:05:14',1);
#UNLOCK TABLES;

--'
DROP TABLE IF EXISTS `typesitsociale`;
CREATE TABLE `typesitsociale` (
  `idss` smallint(6) NOT NULL default '0',
  `ttypesitsociale` char(50) default NULL,
  `tst` timestamp NOT NULL,
  `ordre` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`idss`)
) ENGINE=MyISAM;
LOCK TABLES `typesitsociale` WRITE;
INSERT INTO `typesitsociale` VALUES (5,'Autre','2006-02-13 21:06:32',5),(4,'Plac en institution de soins','2006-02-13 21:06:32',4),(3,'Hberg par un proche','2006-02-13 21:06:32',3),(2,'En mnage','2006-02-13 21:06:32',2),(1,'Vit seul','2006-02-13 21:06:32',1);
UNLOCK TABLES;

DROP TABLE IF EXISTS `typeaidedom`;
CREATE TABLE `typeaidedom` (
  `idad` smallint(6) NOT NULL default '0',
  `ttypeaidedom` char(50) default NULL,
  `tst` timestamp NOT NULL,
  `ordre` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`idad`)
) ENGINE=MyISAM;

LOCK TABLES `typeaidedom` WRITE;
INSERT INTO `typeaidedom` VALUES (3,'Aucune aide','2006-02-13 21:45:50',3),(2,'Autre prestataire','2006-02-13 21:45:50',2),(1,'CMS','2006-02-13 21:45:50',1);
UNLOCK TABLES;




-- Reprise des donnes de interbriodossiers et insertion dans choixems
INSERT INTO choixems (nodoss, noems, datechoix) SELECT nodoss, idinterbrios, tst FROM interbriosdossiers; 
-- Puis destruction de interbriodossiers
DROP TABLE IF EXISTS interbriosdossiers;



-- Cration d'une liste d'adresses interbrios pour la transmission lectronique des demandes
-- Sera actualises par le script de maintenance quotidienne.

CREATE TABLE adressesinterbrio (

  adresse CHAR(20),
  libelle CHAR(50),
  tst TIMESTAMP,
  PRIMARY KEY (adresse)
) ENGINE=MyISAM;

ALTER TABLE etablissements add adresseib CHAR(20);
UPDATE etablissements set type_hopital = 0 where type_hopital is null;
ALTER TABLE etablissements change type_hopital type_hopital char(1) not null default '0';

--Adaptation des tables demandeor, avaliderdem et usagers aux demandes interbrio lectroniques
alter table demandeor change autre autre char(50);
alter table avaliderdem change autre autre char(50) after typepath;
alter table avaliderdem add avs char(14) after sexe;
alter table usagers change nom nom char(50);
alter table usagers change prenom prenom char(50);
alter table usagers change adresse adresse char(100);
alter table usagers change loc loc char(25);
alter table usagers change dmd5 dmd5 char(32);
alter table usagers change avs avs char(14);
alter table avaliderdem add nodoss int default 0;

-- Table permettant le suivi des demandes interbrios lectroniques
CREATE TABLE suivisenvoisib (
  id int not null auto_increment primary key,
  nochoix int,
  adressedest char(20),
  quittance smallint not null default 0,
  dmd5 char(32),
  tst timestamp

) ENGINE=MyISAM;


alter table avaliderdem add brioorigine char(20);
alter table demandeor add brioorigine char(20);  
alter table avaliderdem add nomanege int;
alter table demandeor add nomanege int;



alter table etablissements add unique (adresseIB);

alter table quittances add idsession char(32);


-- Adaptation de certaines valeurs de la table etablissements de manire  restaurer l'indpendance
-- du "groupe d'tablissement" (rserv aux stats IUMSP) vis  vis des fonctions de l'application

update etablissements set type_hopital = "Z" where groupet = 1;
update etablissements set autbrio = 0, litsc = -1 where groupet in (3, 4, 5) and litsc = 0 and litsd = 0;

-- Mon brio n'est pas un autre BRIO !
update etablissements set autbrio = 0 where idsulid = "-1";



alter table issueoptions add ordre int;
update issueoptions set ordre = 1 where idissue = 1;
update issueoptions set ordre = 2 where idissue = 4;
update issueoptions set ordre = 3 where idissue = 5;
update issueoptions set ordre = 4 where idissue = 2;
update issueoptions set ordre = 5 where idissue = 6;
update issueoptions set ordre = 6 where idissue = 3;
update issueoptions set ordre = 7 where idissue = 9;
update issueoptions set ordre = 8 where idissue = 10;
update issueoptions set ordre = 9 where idissue = 7;
update issueoptions set ordre = 10 where idissue = 8;
update issueoptions set ordre = 0 where idissue = 11;


update typesejour set ordre = -5 where idts = 5;

alter table typesejour add ordrelits smallint default 0;
update typesejour set ordrelits = 1 where idts = 1;
update typesejour set ordrelits = 0 where idts = 2;
update typesejour set ordrelits = 3 where idts = 3;
update typesejour set ordrelits = 4 where idts = 4;





update issue set noet = NULL where noet = 0;
update issue set type_court_sejour = NULL where type_court_sejour = 0;

----------------------------- 4 tests sur machaut jusqu'ici

----------------------- Serveurs demo 1 et 2 Pompaples  jour jusqu'ici --------------------
------------------------ Tous BRIOs  jour jusqu'ici

UPDATE version set valeur = 3 where cle = "versionG";
UPDATE version set valeur = 7 where cle = "versionP";