drop table if exists dmst;

create table dmst (
  iddmst int auto_increment not null primary key,
  tst timestamp,
  dmd5 varchar(32),
  C_Org_Nom varchar(10),
  C_Org_Id varchar(10),
  C_TypeDoc varchar(10),
  x_Nom varchar(50),
  x_Prenom varchar(50),
  C_Patient_Id varchar(10),
  d_Naissance date,
  A_Etatgeneral text,
  a_Iti text,
  a_Motiftransfert text,
  a_Resbes text,
  a_Traitcours text,
  b_Dm_Enannexe tinyint(4) default 0 not null,
  b_Dm_Env_Dr tinyint(4) default 0 not null,
  b_Dm_Suit tinyint(4) default 0 not null,
  d_Dentree date,
  d_Desortie date,
  d_Transport date,
  n_Accordpatient smallint default 0 not null,
  n_Dapourheb smallint default 0 not null,
  n_Sexe smallint default 0,
  n_Transfavec smallint default 0,
  contana smallint default 0,
  changpos smallint default 0,
  contves smallint default 0,
  deshab smallint default 0,
  deplext smallint default 0,
  deplint smallint default 0,
  entendre smallint default 0,
  entpers smallint default 0,
  entrlog smallint default 0,
  courses smallint default 0,
  lessive smallint default 0,
  gestad smallint default 0,
  lienssociaux smallint default 0,
  soccuper smallint default 0,
  habiller smallint default 0,
  jugement smallint default 0,
  manger smallint default 0,
  memoire smallint default 0,
  orientat smallint default 0,
  preprepas smallint default 0,
  medics smallint default 0,
  laver smallint default 0,
  escaliers smallint default 0,
  auxil smallint default 0,
  telephone smallint default 0,
  toilet smallint default 0,
  moytransp smallint default 0,
  voir smallint default 0,
  parler smallint default 0,
  t_Curtel varchar(50),
  t_Domtel varchar(50),
  t_Med_Tel varchar(50),
  t_Persreftel varchar(50),
  t_Persvivtel varchar(50),
  t_Telurg varchar(50),
  x_Ass varchar(50),
  x_Cur varchar(50),
  x_Curadr varchar(50),
  x_Dm_Env_Dr varchar(50),
  x_Dom varchar(50),
  x_Etatcivil varchar(50),
  x_Filmat varchar(50),
  x_Filpat varchar(50), 
  x_Lieudenaissance varchar(50),
  x_Medenv varchar(50),
  x_Medhop varchar(50),
  x_Med_Ord varchar(50),
  x_Medtrait varchar(50),
  x_Nation varchar(50),
  x_Npconjoint varchar(50),
  x_Numass varchar(50),
  x_Numavs varchar(50),
  x_Numerodeclient varchar(50),
  x_Origine varchar(50),
  x_Persrefadr varchar(50),
  x_Persrefnom varchar(50),
  x_Persviv varchar(50),
  x_Persvivadr varchar(50),
  x_Profess varchar(50),
  x_Relconf varchar(50),
  x_Sectcaisse varchar(50),
  x_Transfavec varchar(50),
  x_Transportpar varchar(50)
  
  
 
);

drop table if exists dmstmedics;

create table dmstmedics (
  idmedic int auto_increment not null primary key,
  tst timestamp,
  iddmst int,
  x_Med_Nom varchar(50),
  b_Med_Matin tinyint(4) default 0 not null,
  b_Med_Midi tinyint(4) default 0 not null,
  b_Med_Soir tinyint(4) default 0 not null,
  b_Med_Nuit tinyint(4) default 0 not null,
  x_Med_Autres varchar(50)
);

drop table if exists dmstinterv;

create table dmstinterv (
  idinterv int auto_increment not null primary key,
  tst timestamp,
  iddmst int,
  x_int_nom varchar(50),
  t_int varchar(50),
  x_int_precision varchar(50)
);

drop table if exists dmstcms;

create table dmstcms (
  id int auto_increment not null primary key,
  tst timestamp,
  nocms int,
  nomcms varchar(50),
  briopref smallint
);

insert into dmstcms set nocms = 1, nomcms = "OMSV", briopref = 1;
insert into dmstcms set nocms = 10, nomcms = "CMS La Sallaz", briopref = 2;


drop table if exists dmstdemande;
create table dmstdemande(
  id int auto_increment not null primary key,
  tst timestamp,
  iddmst int,
  nodemor int
  
);


DROP TABLE IF EXISTS `typesejour`;
CREATE TABLE `typesejour` (
  `idts` smallint(6) NOT NULL default '0',
  `ttypesej` char(25) default NULL,
  `tst` timestamp,
  `ordre` smallint(6) NOT NULL default '0',
  `ordrelits` smallint(6) default '0',
  PRIMARY KEY  (`idts`)
) ENGINE=MyISAM;

INSERT INTO `typesejour` VALUES (1,'Long sj. (C)','2006-03-30 20:51:07',1,1),(2,'Sj. d\'observation (C)','2006-03-30 21:43:22',2,0),(3,'Court sj. non urgent (C)','2006-03-30 20:51:07',3,3),(4,'Polyvalent','2006-03-30 20:51:42',0,4),(5,'Court sjour planning','2006-03-30 17:57:15',-5,0),(6,'Et. non mdicalis (D)','2005-01-07 21:56:32',6,0),(7,'CTR (B)','2005-01-07 21:56:34',7,0),(8,'Domicile','2005-01-07 21:56:37',8,0),(9,'Domicile + UAT','2005-01-07 21:56:40',9,0),(10,'Logement adapt','2005-01-07 21:56:44',10,0),(11,'Appart. protg','2005-01-07 21:56:46',11,0),(12,'Tt. opt. ouvertes','2005-01-07 21:56:49',12,0),(13,'Or. dj arrte','2005-01-07 21:56:51',13,0),(14,'Court sj. urgent (C)','2005-01-07 21:56:57',4,0);

--'

DROP TABLE IF EXISTS `typepath`;
CREATE TABLE `typepath` (
  `idtp` smallint(6) NOT NULL default '0',
  `ttypepath` char(25) default NULL,
  `tst` timestamp,
  `ordre` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`idtp`)
) ENGINE=MyISAM;

LOCK TABLES `typepath` WRITE;
INSERT INTO `typepath` VALUES (4,'Autre','2006-02-13 11:23:46',4),(3,'Psychiatrie','2006-02-13 11:23:46',3),(2,'Griatrie','2006-02-13 11:23:46',2),(1,'Psychogriatrie','2006-02-13 11:23:46',1);
UNLOCK TABLES;

DROP TABLE IF EXISTS `typedebutpec`;
CREATE TABLE `typedebutpec` (
  `iddp` smallint(6) NOT NULL default '0',
  `ttypedebutpec` char(50) default NULL,
  `tst` timestamp,
  `ordre` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`iddp`)
) ENGINE=MyISAM;

LOCK TABLES `typedebutpec` WRITE;
INSERT INTO `typedebutpec` VALUES (4,'Dans plus d\'un mois','2006-02-13 18:05:14',4),(3,'Dans 1 semaine  1 mois max.','2006-02-13 18:05:14',3),(2,'Ds maintenant mais sans urgence (3  6 jours)','2006-02-13 18:05:14',2),(1,'Le plus vite possible (0  2 jours)','2006-02-13 18:05:14',1);
UNLOCK TABLES;

--'
DROP TABLE IF EXISTS `typesitsociale`;
CREATE TABLE `typesitsociale` (
  `idss` smallint(6) NOT NULL default '0',
  `ttypesitsociale` char(50) default NULL,
  `tst` timestamp,
  `ordre` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`idss`)
) ENGINE=MyISAM;


LOCK TABLES `typesitsociale` WRITE;
INSERT INTO `typesitsociale` VALUES (5,'Autre','2006-02-13 20:06:32',5),(4,'Plac en institution de soins','2006-02-13 20:06:32',4),(3,'Hberg par un proche','2006-02-13 20:06:32',3),(2,'En mnage','2006-02-13 20:06:32',2),(1,'Vit seul','2006-02-13 20:06:32',1);
UNLOCK TABLES;

DROP TABLE IF EXISTS `provenance`;
CREATE TABLE `provenance` (
  `idprovenance` smallint(6) NOT NULL default '0',
  `ordre` smallint(6) NOT NULL default '0',
  `provenance_text` char(25) default NULL,
  `tst` timestamp,
  PRIMARY KEY  (`idprovenance`)
) ENGINE=MyISAM;

LOCK TABLES `provenance` WRITE;
INSERT INTO `provenance` VALUES (1,1,'Hpital (A)','2005-01-01 19:20:16'),(2,2,'CTR (B)','2005-01-01 19:20:16'),(8,3,'Lit A ou B reclass','2005-01-01 19:22:53'),(3,4,'Long sjour (C)','2005-01-01 19:23:03'),(5,5,'Long sjour provisoire','2005-01-01 19:24:13'),(6,6,'Sjour d\'observation','2005-01-01 19:20:16'),(7,7,'Court sjour (C)','2005-01-01 19:20:16'),(9,8,'Etabl. non mdicalis','2005-01-01 19:24:17'),(4,9,'Domicile','2005-01-01 19:23:48');
UNLOCK TABLES;

--'
-- n_Dapourheb transformer en radio (avec autre)
-- Etat civil : convertirCREATE TABLE adressesinterbrio (

