<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Sauvegarde quotidienne
* Script utilisant l'utilitaire mysqldump pour sauvegarder une base de donnes
* La sauvegarde se fait par rotation quotidienne sur une semaine. Un fichier hebdomadaire
* est ensuite conserv sur une rotation de 8 semaines. Finalement, un fichier mensuel est
* conserv indfiniment
* L'utilisateur unix excutant le script doit avoir un fichier .my.cnf permettant d'invoquer
* mysqldump sans les paramtres -h -u et -p
* Se script s'excute par inclusion dans un autoscriptsJour. Les variables $bd (base de donnes
*  sauver) et et $rep (rpertoire de sauvegarde) doivent tre dfinies dans le code avant l'inclusion
* @package accessoires
* @author ob
*/ 
$joursem = 1; //jour de la semaine o se fait la sauvegarde hebd
$jourdhui = date("w"); // le jour de la semaine o nous sommes
$nomfich = "$rep/$bd$jourdhui.bd";
$nomfichgz = "$nomfich" . ".gz";
print $nomfich . "\n";
if (! $rep){
  print "Sauvegarde non spcifie dans le fichier ini\n";
}
elseif ($rep && file_exists($rep) && is_dir($rep) && is_writeable($rep)){
  // Le rpertoire de sauvegarde est indiqu dans le fichier briocheIni.inc, il existe et est inscriptible
  clearstatcache();
  if ($joursem == $jourdhui){//Nous sommes le jour de la semaine o se fait la sauvegarde
    print "Sauvegarde hebdomadaire\n";
    if (file_exists($nomfichgz)) {
      //print time() ." - " . filemtime($nomfichgz) . " = " . (time()-filemtime($nomfichgz)) . "\n";
      $dt = getdate(time());
      $dtf = getdate(filemtime($nomfichgz));
      if ( (time() - filemtime($nomfichgz)) > (5*24*3600) ){ //vieux d'au moins 5 jours
        $fichhebd = "$rep/$bd" . "HEBD";
        print "Cascade";
        for ($i = 8; $i >= 0; $i--) {
          if (file_exists($fichhebd . ($i + 1) . ".bd.gz")) {
            unlink($fichhebd . ($i + 1) . ".bd.gz");
          }
          if (file_exists("$fichhebd$i.bd.gz")) {
            copy("$fichhebd$i.bd.gz", $fichhebd . ($i + 1) . ".bd.gz");
            print ".";
          }
        }
        print "\n";
	copy ($nomfichgz, $fichhebd . "0.bd.gz");
      }
    }
  }
  //sauvegarde de la base !!! Il doit exister un fichier .my.cnf pour l'utilisateur excutant le script
  exec("mysqldump --add-drop-table $bd > \"$nomfich\"");
  //Nous sommes le premier du mois ==> fichier mensuel
  if (date("j") == 1){
    print "Sauvegarde mensuelle\n";
    copy("$nomfich", "$rep/$bd" . "MENS" . date("ym") . ".bd");
  }
  //Cration d'un fichier gzip
  /* Remplacement des appels systmes par des fonctions php (meilleure portabilit)
  exec("gzip -f $nomfich");
  exec("md5sum $nomfichgz > $rep/md5.txt");
  */
  $chaine = file_get_contents($nomfich);
  $zp = gzopen($nomfichgz, "w9");
  gzwrite($zp, $chaine);
  gzclose($zp);
  if (file_exists($nomfich)) unlink($nomfich);
  $chaine = file_get_contents($nomfichgz);
  $md5 = md5($chaine);
  $fl = fopen("$rep/md5.txt", "w");
  fwrite($fl, "$md5  $nomfichgz\n");
  fclose($fl);
  print "Fin de la sauvegarde quotidienne\n";
}
else {
  print "Le rpertoire $rep est inaccessible : sauvegarde impossible\n";
}

?>
