-- MySQL dump 10.10
--
-- Host: machaut.ici    Database: sulid
-- ------------------------------------------------------
-- Server version	5.0.30-Debian_1-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `chambres`
--

DROP TABLE IF EXISTS `chambres`;
CREATE TABLE `chambres` (
  `id` smallint(5) NOT NULL default '0',
  `nom` varchar(50) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `deSulid`
--

DROP TABLE IF EXISTS `deSulid`;
CREATE TABLE `deSulid` (
  `nosulid` int(11) default NULL,
  `brio` enum('AROVAL','ARCOS','RESCO','RENOVA','CHABLAIS','BROYE','ASCOR','ARSOL','ARC','AUCUN') default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `districts`
--

DROP TABLE IF EXISTS `districts`;
CREATE TABLE `districts` (
  `id` smallint(5) NOT NULL default '0',
  `nom` varchar(50) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `etablissements`
--

DROP TABLE IF EXISTS `etablissements`;
CREATE TABLE `etablissements` (
  `id` varchar(5) NOT NULL default '',
  `nom` varchar(50) NOT NULL default '',
  `localite` varchar(50) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `journalBrioche`
--

DROP TABLE IF EXISTS `journalBrioche`;
CREATE TABLE `journalBrioche` (
  `noEcr` int(10) unsigned NOT NULL auto_increment,
  `typEcr` tinyint(5) unsigned default NULL,
  `noSulid` int(10) unsigned default NULL,
  `noBrioche` int(10) unsigned default NULL,
  `datHeure` datetime default NULL,
  `Etabl` char(5) default NULL,
  `DesLe` date default NULL,
  `reserve` tinyint(3) unsigned default NULL,
  `Mission` tinyint(3) unsigned default NULL,
  `Sejour` tinyint(3) unsigned default NULL,
  `Chambre` tinyint(3) unsigned default NULL,
  `Lit` tinyint(3) unsigned default NULL,
  `brio` enum('AROVAL','ARCOS','RESCO','RENOVA','SBROYE','ASCOR','ARSOL','CHABLAIS','ARC','AUCUN') default NULL,
  `quittance` tinyint(4) unsigned default NULL,
  PRIMARY KEY  (`noEcr`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `lits`
--

DROP TABLE IF EXISTS `lits`;
CREATE TABLE `lits` (
  `id` smallint(5) NOT NULL default '0',
  `nom` varchar(50) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `mdpSulid`
--

DROP TABLE IF EXISTS `mdpSulid`;
CREATE TABLE `mdpSulid` (
  `id` tinyint(4) NOT NULL auto_increment,
  `util` char(10) default NULL,
  `mdp` char(10) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

--
-- Table structure for table `missions`
--

DROP TABLE IF EXISTS `missions`;
CREATE TABLE `missions` (
  `id` smallint(5) NOT NULL default '0',
  `nom` varchar(50) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `refsulid`
--

DROP TABLE IF EXISTS `refsulid`;
CREATE TABLE `refsulid` (
  `noBrioche` int(11) NOT NULL default '0',
  `noSulid` int(11) default NULL,
  `etabl` char(5) default NULL,
  `desLe` date default NULL,
  `reserve` int(11) default NULL,
  `mission` int(11) default NULL,
  `sejour` int(11) default NULL,
  `chambre` int(11) default NULL,
  `lit` int(11) default NULL,
  `operation` int(11) default NULL,
  `brio` enum('AROVAL','ARCOS','RESCO','RENOVA','CHABLAIS','BROYE','ASCOR','ARSOL','ARC','AUCUN') NOT NULL default 'AROVAL',
  UNIQUE KEY `id` (`brio`,`noBrioche`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `sejours`
--

DROP TABLE IF EXISTS `sejours`;
CREATE TABLE `sejours` (
  `id` smallint(5) NOT NULL default '0',
  `nom` varchar(50) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `verrou`
--

DROP TABLE IF EXISTS `verrou`;
CREATE TABLE `verrou` (
  `Nom` char(10) NOT NULL default '',
  `temps` bigint(20) default NULL,
  PRIMARY KEY  (`Nom`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `verssulid`
--

DROP TABLE IF EXISTS `verssulid`;
CREATE TABLE `verssulid` (
  `noBrioche` int(11) NOT NULL default '0',
  `etabl` char(5) default NULL,
  `desLe` date default NULL,
  `reserve` int(11) default NULL,
  `mission` smallint(6) default NULL,
  `sejour` smallint(6) default NULL,
  `chambre` smallint(6) default NULL,
  `lit` smallint(6) default NULL,
  `brio` enum('AROVAL','ARCOS','RESCO','RENOVA','CHABLAIS','BROYE','ASCOR','ARSOL','ARC','AUCUN') NOT NULL default 'AROVAL',
  UNIQUE KEY `id` (`brio`,`noBrioche`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2007-01-08 19:43:28
