<?php

require_once("../lib/lib.class.php");

class gui {
  
  var $lib;
    
  function gui() {
    
    $this->lib = new lib();
  }

  function select() {
   
    $method = lib::getParam('method');
    switch ($method) {
      case 'showInfo':
        return $this->showInfo();
      break;
      case 'showSearch':
        return $this->showSearch();
      break;
      default:
      break; 
    }
  }
  
  function showInfo() {
   
    $where = array();
    $order = array();

    $orderdir = $this->lib->getParam('orderdir');
    if ($orderdir == -1 || $orderdir == 'DESC') $orderdir = 'ASC';
    else $orderdir = 'DESC';
    
    $orderby = $this->lib->getParam('orderby');
    if ($orderby != -1) $order[] = $orderby;
    else $order[] = 'desLe';
       
    $desle = $this->lib->getParam('desle');
    $desle = substr($desle,6,4) . substr($desle,3,2) . substr($desle,0,2);
    if ($desle != -1 && $desle != '') $where[] = "desLe >= '$desle'";
    
    $reserv = $this->lib->getParam('reserv');
    if ($reserv != -1) $where[] = "reserve = $reserv";
    
    $brios = $this->lib->getWhere('brios','brio');
    if ($brios != '0') $where[] = $brios;
    
    $etabls = $this->lib->getWhere('etablissements','etabl');
    if ($etabls != '0') $where[] = $etabls;
    
    $missions = $this->lib->getWhere('missions','mission');
    if ($missions != '0') $where[] = $missions;
    
    $sejours = $this->lib->getWhere('sejours','sejour');
    if ($sejours != '0') $where[] = $sejours;
    
    $chambres = $this->lib->getWhere('chambres','chambre');
    if ($chambres != '0') $where[] = $chambres;
    
    $lits = $this->lib->getWhere('lits','lit');
    if ($lits != '0') $where[] = $lits;
    
    $info = $this->lib->getInfo($where,$order,$orderdir);
    	          
    $html = "<input name='orderdir' type='hidden' value=$orderdir></input>";    
    $html .= "<input name='orderby' type='hidden' value=-1></input>";
    
    $html .= "<table class=searchResults>";
    
    if (count($info) == 0) $html .= "<tr><td colspan=8 align=center><font size=4><b>Aucun lit disponible</b></font></td></tr>";
    else {
      
      if (count($info) == 1) 
        $html .= "<tr><td colspan=8 align=center><font size=4><b>Un seul lit disponible</b></font><br/>
      	       		Cliquer sur une colonne pour trier les lits selon cette colonne</td></tr>";
      else
        $html .= "<tr><td colspan=8 align=center><font size=4><b>Lits disponibles (".count($info).")</b></font><br/>
      	       		Cliquer sur une colonne pour trier les lits selon cette colonne</td></tr>";
      
      $html .= "<tr class=titleBar>";
      $html .= "<td><input type=button class=button value='Brio' onclick=\"document.main_form.orderby.value='brio';document.getElementById('searchButton').click();\"></input></td>";
      $html .= "<td><input type=button class=button value='R&eacute;serv&eacute;' onclick=\"document.main_form.orderby.value='reserve';document.getElementById('searchButton').click();\"></input></td>";
      $html .= "<td><input type=button class=button value='Disponible d&egrave;s le' onclick=\"document.main_form.orderby.value='desLe';document.getElementById('searchButton').click();\"></input></td>";
      $html .= "<td><input type=button class=button value='Etablissement' onclick=\"document.main_form.orderby.value='etabl';document.getElementById('searchButton').click();\"></input></td>";
      $html .= "<td><input type=button class=button value='Mission' onclick=\"document.main_form.orderby.value='mission';document.getElementById('searchButton').click();\"></input></td>";
      $html .= "<td><input type=button class=button value='Chambre' onclick=\"document.main_form.orderby.value='chambre';document.getElementById('searchButton').click();\"></input></td>";
      $html .= "<td width=50><input type=button class=button value='Lit' onclick=\"document.main_form.orderby.value='lit';document.getElementById('searchButton').click();\"></input></td>";
      $html .= "<td><input type=button class=button value='S&eacute;jour' onclick=\"document.main_form.orderby.value='sejour';document.getElementById('searchButton').click();\"></input></td>";
      $html .= "</tr>";
      
      $reservarray = array('Non','Oui');
      $line = 0;
      $leftPad = "style='padding-left:10px;'";
      foreach ($info as $element) {
        $altern = fmod($line,2);
        $line++;
        $html .= "<tr class='altern_$altern'>";
        $html .= "<td align=center>".$this->lib->getText('nom','mdpSulid','util',"'".$element['brio']."'")."</td>";
        $html .= "<td align=center>".$reservarray[$element['reserve']]."</td>";
        $html .= "<td align=center>".date("d.m.Y",strtotime($element['desLe']))."</td>";
        $html .= "<td $leftPad align=left>".$this->lib->getText('nom','etablissements','id',$element['etabl'])."</td>";
        $html .= "<td $leftPad align=left>".$this->lib->getText('nom','missions','id',$element['mission'])."</td>";
        $html .= "<td $leftPad align=left>".$this->lib->getText('nom','chambres','id',$element['chambre'])."</td>";
        $html .= "<td align=center>".$this->lib->getText('nom','lits','id',$element['lit'])."</td>";
        $html .= "<td align=center>".$this->lib->getText('nom','sejours','id',$element['sejour'])."</td>";
        $html .= "</tr>";
      }
    }
    
    $html .= "</table>";
    
    return $html;
  } 
  
  function showSearch() {
   
    $html = "<table cellpadding=2 width=100% cellspacing=0><tr>";
    
    $html .= "<td colspan=6>Lits disponibles d&egrave;s le (<i>jj.mm.yyyy</i>) : ".$this->dateInput('search_date','')."</td>";
    
    $html .= "</tr><tr>";
                   
    $html .= "<td class='title'>Brio :</td>";
    $html .= "<td class='title'>Etablissements :</td>";
    $html .= "<td class='title'>Mission :</td>";
    $html .= "<td class='title'>Type de chambre :</td>";
    $html .= "<td class='title'>Type de lit :</td>";
    $html .= "<td class='title'>Type de s&eacute;jour :</td>";
    
    $html .= "</tr><tr>";
    
    $brios = $this->lib->getSearchData('util','nom','mdpSulid');
    $etabls = $this->lib->getSearchData('id','nom','etablissements');
    $missions = $this->lib->getSearchData('id','nom','missions');
    $chambres = $this->lib->getSearchData('id','nom','chambres');
    $lits = $this->lib->getSearchData('id','nom','lits');
    $sejours = $this->lib->getSearchData('id','nom','sejours');
    
    $html .= "<td>".$this->selectInput('brio',$brios,100,array('0'))."</td>";
    $html .= "<td>".$this->selectInput('etablissement',$etabls,250,array('0'))."</td>";
    $html .= "<td>".$this->selectInput('mission',$missions,250,array('0'))."</td>";
    $html .= "<td>".$this->selectInput('chambre',$chambres,180,array('0'))."</td>";
    $html .= "<td>".$this->selectInput('lit',$lits,100,array('0'))."</td>";
    $html .= "<td>".$this->selectInput('sejour',$sejours,120,array('0'))."</td>";
    
    $html .= "</tr><tr>";
    
    $values = array(-1 => "Tous", 1 => "R&eacute;serv&eacute;s", 0 => "Non-r&eacute;serv&eacute;s");
    $html .= "<td colspan=6 class='title'>R&eacute;serv&eacute;s : </td></tr>";
    $html .= "<tr><td colspan=6>".$this->radioInput('search_reserv',$values, -1)."</td>";
    $html .= "</tr></table>";
    
    $search = "+ '&desle=' + document.main_form.search_date.value";
    $search .= "+ '&reserv=' + document.main_form.search_reserv.value";    
    $search .= $this->lib->createSearchString('brios','brio',$brios);
    $search .= $this->lib->createSearchString('etablissements','etablissement',$etabls);
    $search .= $this->lib->createSearchString('missions','mission',$missions);
    $search .= $this->lib->createSearchString('chambres','chambre',$chambres);
    $search .= $this->lib->createSearchString('lits','lit',$lits);
    $search .= $this->lib->createSearchString('sejours','sejour',$sejours);
    
    $search .= " + '&orderdir=' + document.main_form.orderdir.value";
    $search .= " + '&orderby=' + document.main_form.orderby.value";
            
    $html .= "<div style='visibility: hidden;'><input id='searchButton' type='button' onclick=\"stdFunction('gui.class','info','method=showInfo'$search);\"></input></div>";
    
    return $html;
  }

  function selectInput($name, $options, $width = 100,$checked = array()) {
    
    $html = "<select multiple style='width:".$width."px;' size=8 class=inputs name=$name onchange=\"document.getElementById('searchButton').click();\">";
    if (in_array(0,$checked)) $sel = 'selected'; else $sel = '';
    foreach ($options as $key => $val) {
      if (in_array($key,$checked)) $sel = 'selected'; else $sel = '';
      $html .= "<option title='$val' $sel value=$key>$val</option>";
    }
    $html .= "</select>";
    return $html;    
  }
   
  function dateInput($name, $value) {
   
    $html = "<input class=inputs name=$name type=text value=\"$value\" ";
    $html .= "onkeypress=\"if (window.event.keyCode == 13) {if (checkDate(this.value,document.main_form.$name)) document.getElementById('searchButton').click(); return false;}\" ";
    $html .= "onchange=\"if (checkDate(this.value,document.main_form.$name)) document.getElementById('searchButton').click();\"></input>";
    $html .= "&nbsp;&nbsp;&nbsp;<img src='../img/cal.gif' onmouseover=\"this.style.cursor='pointer'\" onclick=\"window.open('calendar_popup.php','calendar','width=280,height=200');\"/>";
    $html .= "&nbsp;&nbsp;&nbsp;<img src='../img/croixtr.gif' onmouseover=\"this.style.cursor='pointer'\" onclick=\"document.main_form.$name.value='';document.getElementById('searchButton').click();\"/>";
            
    return $html;   
  }
  
  function radioInput($name, $values, $selected) {
   
    $html = "";
    $selectedKey = 0;
    foreach ($values as $key => $value) {
      if ($key == $selected) {
          $select = "checked";
          $selectedKey = $key;
      } else $select = "";
      $html .= "<input $select name=".$name."_radios type=radio value=\"$key\" ";
      $html .= "onclick=\"document.main_form.$name.value=this.value;document.getElementById('searchButton').click();\">$value</input>";
    }
    $html .= "<input name=$name type=hidden value='$selectedKey'></hidden>";
            
    return $html;   
  }
}

$gui = new gui();
echo $gui->select();

?>