<?php

class dmstManager {
    
    function dmstManager() {
    }
    
    function startSDO() {
        
        session_start();
        
        $POSTData = requireManager::getFullPost();
        if (isset($POSTData["E1"])) {
            session_destroy();
            session_start();
        }
    }
    
    function getDMSTFromPost() {
        
        $POSTData = requireManager::getFullPost();
        
        $DMST = array();
        $fields = array();
        $cpt = array();
        $cpt["MEDICS"] = 0;
        $cpt["INTERV"] = 0;
        
        if (!isset($POSTData["E1"])) {
            $msg = "Aucune donne n'a t reue ! Veuillez fermer votre navigateur et recommencer.";
            requireManager::addError($msg,"ERROR");
            return null;
        }
                        
        foreach($POSTData as $key => $data) {
        
            if (strstr($key,"D1")) $type = "MEDICS";
            elseif (strstr($key,"D2")) $type = "INTERV";
            else $type = "DMST";
            
            if ($key == "E1" || $key == "E1_D1" || $key == "E1_D2") {
                $fields[$key] = explode(";", $data);
            } elseif ($key == "E1_L1" || preg_match("/^E1_L1_D1/", $key) || preg_match("/^E1_L1_D2/", $key)) {
                $content = explode(";", $data);
                foreach ($fields[substr(str_replace("_L1","",$key),0,5)] as $k => $field) {
                    if ($field == "") continue;
                    if ($type == "DMST")
                        $DMST[$type][$field] = $this->convert($content[$k],$field);
                    else {
                        $DMST[$type][$cpt[$type]][$field] = $this->convert($content[$k],$field);
                    }
                }
                if ($type != "DMST") $cpt[$type]++;
            }
        }
        
        return $DMST;
    }
    
    function convert($string, $field){
        
        // Conversion valeurs des champs checkbox
        if (preg_match("/^b_/", $field)){
            $string = ($string == "O" ? -1 : 0);
        }
        // Conversion valeurs slections
        if ($field == "n_Accordpatient"){
            if ($string == "") $string = -1;
            $string ++;
        }  
        
        return $string;
    }
    
    function convertToXML($fullDMST) {
        
        $dom = new DOMDocument("1.0","UTF-8");
                            
        // ROOT
        $xmlArray = array();
        $xmlArray["Message"]["attributes"]["version"] = "1.0";
        // SOURCE
        $xmlArray["Message"]["Source"]["Organisation"]["value"] = $fullDMST["ENTETE"]->orgSource;
        $xmlArray["Message"]["Source"]["Personne"]["value"] = $fullDMST["ENTETE"]->nomSource;
        $xmlArray["Message"]["Source"]["NoTelephone"]["value"] = $fullDMST["ENTETE"]->telSource;
        $xmlArray["Message"]["Source"]["AdresseEMail"]["value"] = "";
        // DESTINATION
        $xmlArray["Message"]["Destination"]["Organisation"]["value"] = $fullDMST["ENTETE"]->orgDestination;
        $xmlArray["Message"]["Destination"]["Personne"]["value"] = $fullDMST["ENTETE"]->nomDestination;
        $xmlArray["Message"]["Destination"]["NoTelephone"]["value"] = "";
        $xmlArray["Message"]["Destination"]["AdresseEMail"]["value"] = "";
        // TIMESTAMP
        $xmlArray["Message"]["Timestamp"]["value"] = date("Y-m-d\TH:i:s.0\Z");
        // COMMENTAIRE
        $xmlArray["Message"]["Commentaire"]["value"] = $fullDMST["ENTETE"]->comments;
        // PATIENT
        if ($fullDMST["DMST"]["n_Sexe"] == 1) $sexe = "M";
        else $sexe = "F";
        $xmlArray["Message"]["Patient"]["Sexe"]["value"] = $sexe;
        $xmlArray["Message"]["Patient"]["Nom"]["value"] = $fullDMST["DMST"]["x_Nom"];
        $xmlArray["Message"]["Patient"]["Prenom"]["value"] = $fullDMST["DMST"]["x_Prenom"];
        $dNaissance = substr($fullDMST["DMST"]["d_Naissance"],6,4).'-'.substr($fullDMST["DMST"]["d_Naissance"],3,2).'-'.substr($fullDMST["DMST"]["d_Naissance"],0,2);
        $xmlArray["Message"]["Patient"]["DateDeNaissance"]["value"] = $dNaissance;
        $fulladr = $fullDMST["DMST"]["x_Dom"];
        if (preg_match("/[0-9]{4}/",$fulladr,$cdp)) {
            $codepostal = trim($cdp[0]);
            $splitadr = preg_split("/[0-9]{4}/",$fulladr);
            $localite = trim($splitadr[1]);
            $adresse = trim($splitadr[0]);
        } else {
            $codepostal = "";   
            $localite = "";
            $adresse = $fulladr;
        }        
        $xmlArray["Message"]["Patient"]["Adresse"]["RueEtNumero"]["value"] = $adresse;
        if ($localite != "")
            $xmlArray["Message"]["Patient"]["Adresse"]["NoPostal"]["value"] = $codepostal;
        $xmlArray["Message"]["Patient"]["Adresse"]["Localite"]["value"] = $localite;
        $xmlArray["Message"]["Patient"]["NoTelephone"]["value"] = $fullDMST["DMST"]["t_Domtel"];
        if ($fullDMST["DMST"]["x_Numavs"] != "")
            $xmlArray["Message"]["Patient"]["NoAVS"]["value"] = $fullDMST["DMST"]["x_Numavs"];
        else
            $xmlArray["Message"]["Patient"]["NoAVS"]["value"] = "000.00.000.000";
        if ($fullDMST["DMST"]["x_Numerodeclient"] != "")
            $xmlArray["Message"]["Patient"]["NoClientCMS"]["value"] = $fullDMST["DMST"]["x_Numerodeclient"];
            
        // CONTENU
        // DEMANDE
        if ($fullDMST["ENTETE"]->typeDoc == "DMST+") {        
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["PriseEnCharge"]["Type"]["value"] = $fullDMST["DEMANDE"]->typePriseEnCharge;
            if ($fullDMST["DEMANDE"]->typePriseEnCharge == "Autre") 
                $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["PriseEnCharge"]["AutreType"]["value"] = $fullDMST["DEMANDE"]->typePriseEnChargeAutre;
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["PriseEnCharge"]["Nature"]["value"] = $fullDMST["DEMANDE"]->naturePriseEnCharge;
            if ($fullDMST["DEMANDE"]->naturePriseEnCharge == "Autre") 
                $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["PriseEnCharge"]["AutreNature"]["value"] = $fullDMST["DEMANDE"]->naturePriseEnChargeAutre;
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["PriseEnCharge"]["Urgence"]["value"] = $fullDMST["DEMANDE"]->urgences;
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["PriseEnCharge"]["DateDes"]["value"] = $fullDMST["DEMANDE"]->dateDes;
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["PriseEnCharge"]["DateFin"]["value"] = $fullDMST["DEMANDE"]->dateFin;
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["Provenance"]["value"] = $fullDMST["DEMANDE"]->situationProvenance;
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["SituationSociale"]["value"] = $fullDMST["DEMANDE"]->situationSociale;
            if ($fullDMST["DEMANDE"]->situationSociale == "Autre") 
                $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["AutreSituationSociale"]["value"] = $fullDMST["DEMANDE"]->situationSocialeAutre;
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["AideRecue"]["value"] = $fullDMST["DEMANDE"]->aideServiceDomicile;
            $problemesParticuliers = dmstManager::getProblemesParticuliers();
            foreach ($problemesParticuliers as $key => $probPart) {
                if ($fullDMST["DEMANDE"]->$key == 1) $value = 1;
                else $value = 0;
                $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["ProblemesParticuliers"][$key]["value"] = $value;
            }   
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["ProblemesParticuliers"]["AutreProbleme"]["value"] = $fullDMST["DEMANDE"]->AutreProbleme;        
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["PersonneDeReference"]["Nom"]["value"] = $fullDMST["DEMANDE"]->persReference;
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["PersonneDeReference"]["NoTelephone"]["value"] = $fullDMST["DEMANDE"]->persReferenceTel;
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["AssuranceSociales"]["Type"]["value"] = $fullDMST["DEMANDE"]->assuranceSocialesType;
            if ($fullDMST["DEMANDE"]->assuranceSocialesPC == "") $fullDMST["DEMANDE"]->assuranceSocialesPC = 0;
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["AssuranceSociales"]["PC"]["value"] = $fullDMST["DEMANDE"]->assuranceSocialesPC;
            if ($fullDMST["DEMANDE"]->assuranceSocialesAPI == "") $fullDMST["DEMANDE"]->assuranceSocialesAPI = 0;
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["AssuranceSociales"]["API"]["value"] = $fullDMST["DEMANDE"]->assuranceSocialesAPI;
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["SupplementChambreIndividuelle"]["Desire"]["value"] = $fullDMST["DEMANDE"]->suppChambreIndivDesire;
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["Souhaits"]["value"] = $fullDMST["DEMANDE"]->souhaitsUsager;
            $xmlArray["Message"]["Contenu"]["DemandeOrientation"]["Commentaire"]["value"] = $fullDMST["DEMANDE"]->indicationsCompl;            
        }
        // DMST
        $xmlArray["Message"]["Contenu"]["DMST"]["Transmission"]["DocumentTransmissible"]["value"] = $fullDMST["DMST"]["n_Accordpatient"];
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["LieuDeNaissance"]["value"] = $fullDMST["DMST"]["x_Lieudenaissance"];
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["EtatCivil"]["value"] = "Autre";
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["AutreEtatCivil"]["value"] = $fullDMST["DMST"]["x_Etatcivil"];
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["Confession"]["value"] = $fullDMST["DMST"]["x_Relconf"];
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["Origine"]["value"] = $fullDMST["DMST"]["x_Origine"];
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["Nationalite"]["value"] = $fullDMST["DMST"]["x_Nation"];
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["FiliationMaternelle"]["value"] = $fullDMST["DMST"]["x_Filmat"];
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["FiliationPaternelle"]["value"] = $fullDMST["DMST"]["x_Filpat"];
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["Profession"]["value"] = $fullDMST["DMST"]["x_Profess"];
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["Conjoint"]["value"] = $fullDMST["DMST"]["x_Npconjoint"];
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["NoTelephoneUrgence"]["value"] = $fullDMST["DMST"]["t_Telurg"];
        if ($fullDMST["DMST"]["d_Dentree"] != "") {
            $dateEntree = explode(".",$fullDMST["DMST"]["d_Dentree"]);
            $dateEntree = $dateEntree[2].'-'.$dateEntree[1].'-'.$dateEntree[0];
            $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["DateEntree"]["value"] = $dateEntree;
        }
        if ($fullDMST["DMST"]["d_Desortie"] != "") {
            $dateSortie = explode(".",$fullDMST["DMST"]["d_Desortie"]);
            $dateSortie = $dateSortie[2].'-'.$dateSortie[1].'-'.$dateSortie[0];
            $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["DateSortie"]["value"] = $dateSortie;
        }
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["MedecinTraitant"]["Nom"]["value"] = $fullDMST["DMST"]["x_Medtrait"];
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["MedecinHopital"]["Nom"]["value"] = $fullDMST["DMST"]["x_Medhop"];
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["Assurance"]["Nom"]["value"] = $fullDMST["DMST"]["x_Ass"];
        $xmlArray["Message"]["Contenu"]["DMST"]["DonneesAdministratives"]["Assurance"]["NoAssure"]["value"] = $fullDMST["DMST"]["x_Numass"];
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["PersonneDeReference"]["Nom"]["value"] = $fullDMST["DMST"]["x_Persrefnom"];
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["PersonneDeReference"]["NoTelephone"]["value"] = $fullDMST["DMST"]["t_Persreftel"];
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["PersonneDeReference"]["Commentaire"]["value"] = $fullDMST["DMST"]["x_Persrefadr"];
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["PersonneVivantAvec"]["Nom"]["value"] = $fullDMST["DMST"]["x_Persviv"];
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["PersonneVivantAvec"]["NoTelephone"]["value"] = $fullDMST["DMST"]["t_Persvivtel"];
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["PersonneVivantAvec"]["Commentaire"]["value"] = $fullDMST["DMST"]["x_Persvivadr"];
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["TuteurCurateur"]["Nom"]["value"] = $fullDMST["DMST"]["x_Cur"];
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["TuteurCurateur"]["NoTelephone"]["value"] = $fullDMST["DMST"]["t_Curtel"];
        $xmlArray["Message"]["Contenu"]["DMST"]["FamilleEntourage"]["TuteurCurateur"]["Commentaire"]["value"] = $fullDMST["DMST"]["x_Curadr"];
        $xmlArray["Message"]["Contenu"]["DMST"]["Habitat"]["value"] = $fullDMST["DMST"]["a_Iti"];
        $xmlArray["Message"]["Contenu"]["DMST"]["ContexteHabitudesDeVie"]["value"] = $fullDMST["DMST"]["a_Resbes"];
        if (is_array($fullDMST["INTERV"])) {
            $cpt = 0;
            foreach ($fullDMST["INTERV"] as $k => $interv) {
                $xmlArray["Message"]["Contenu"]["DMST"]["Intervenants"]["multiple"] = true;
                $xmlArray["Message"]["Contenu"]["DMST"]["Intervenants"][$cpt]["Intervenant"]["Nom"]["value"] = $interv["x_int_nom"];
                $xmlArray["Message"]["Contenu"]["DMST"]["Intervenants"][$cpt]["Intervenant"]["NoTelephone"]["value"] = $interv["t_int"];
                $xmlArray["Message"]["Contenu"]["DMST"]["Intervenants"][$cpt]["Intervenant"]["Commentaire"]["value"] = $interv["x_int_precision"];
                $cpt++;
            }
        }
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["ActivitesQuotidiennes"]["MangerBoire"]["value"] = $fullDMST["GRILLE"]->manger;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["ActivitesQuotidiennes"]["SeLaver"]["value"] = $fullDMST["GRILLE"]->laver;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["ActivitesQuotidiennes"]["Habiller"]["value"] = $fullDMST["GRILLE"]->habiller;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["ActivitesQuotidiennes"]["Deshabiller"]["value"] = $fullDMST["GRILLE"]->deshabiller;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["ActivitesQuotidiennes"]["EntretenirSaPersonne"]["value"] = $fullDMST["GRILLE"]->entPersonne;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["ActivitesQuotidiennes"]["ContinenceVesicale"]["value"] = $fullDMST["GRILLE"]->contVes;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["ActivitesQuotidiennes"]["ContinenceAnale"]["value"] = $fullDMST["GRILLE"]->contAna;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["ActivitesQuotidiennes"]["UtiliserToilettes"]["value"] = $fullDMST["GRILLE"]->toilettes;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Mobilite"]["ChangerPosition"]["value"] = $fullDMST["GRILLE"]->position;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Mobilite"]["DeplacerExterieur"]["value"] = $fullDMST["GRILLE"]->depExterieur;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Mobilite"]["DeplacerInterieur"]["value"] = $fullDMST["GRILLE"]->depInterieur;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Mobilite"]["UtiliserMoyensTransport"]["value"] = $fullDMST["GRILLE"]->transport;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Mobilite"]["UtiliserMoyensAuxiliaires"]["value"] = $fullDMST["GRILLE"]->auxiliaires;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Mobilite"]["UtiliserEscaliers"]["value"] = $fullDMST["GRILLE"]->escaliers;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Communication"]["Voir"]["value"] = $fullDMST["GRILLE"]->voir;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Communication"]["Entendre"]["value"] = $fullDMST["GRILLE"]->entendre;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Communication"]["Parler"]["value"] = $fullDMST["GRILLE"]->parler;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["Communication"]["UtiliserTelephone"]["value"] = $fullDMST["GRILLE"]->telephone;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["EtatPsychiqueFacultesMentales"]["Memoire"]["value"] = $fullDMST["GRILLE"]->memoire;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["EtatPsychiqueFacultesMentales"]["Orientation"]["value"] = $fullDMST["GRILLE"]->orientation;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["EtatPsychiqueFacultesMentales"]["JugementComprehension"]["value"] = $fullDMST["GRILLE"]->jugement;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["EtatPsychiqueFacultesMentales"]["GererTempsLibre"]["value"] = $fullDMST["GRILLE"]->tempsLibre;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["TachesDomestiques"]["EntretenirLogement"]["value"] = $fullDMST["GRILLE"]->entLogement;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["TachesDomestiques"]["PreparerRepas"]["value"] = $fullDMST["GRILLE"]->prepRepas;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["TachesDomestiques"]["FaireCourses"]["value"] = $fullDMST["GRILLE"]->courses;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["TachesDomestiques"]["FaireLessive"]["value"] = $fullDMST["GRILLE"]->lessive;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["TachesDomestiques"]["PrendreMedicaments"]["value"] = $fullDMST["GRILLE"]->medics;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["TachesDomestiques"]["GestionAdministrative"]["value"] = $fullDMST["GRILLE"]->gestAdmin;
        $xmlArray["Message"]["Contenu"]["DMST"]["NiveauAutonomie"]["TachesDomestiques"]["GererLiensSociaux"]["value"] = $fullDMST["GRILLE"]->liensSociaux;
        $xmlArray["Message"]["Contenu"]["DMST"]["BilanDeSante"]["value"] = $fullDMST["DMST"]["A_Etatgeneral"];
        if ($fullDMST["DMST"]["d_Transport"] != "") {
            $dateTransport = explode(".",$fullDMST["DMST"]["d_Transport"]);
            $dateTransport = $dateTransport[2].'-'.$dateTransport[1].'-'.$dateTransport[0];
            $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["DateTransfert"]["value"] = $dateTransport;
        }
        $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Motif"]["value"] = $fullDMST["DMST"]["a_Motiftransfert"];
        $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["TraitementsEnCours"]["value"] = $fullDMST["DMST"]["a_Traitcours"];
        $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"]["multiple"] = true;
        if (is_array($fullDMST["MEDICS"])) {
            $cpt = 0;
            foreach ($fullDMST["MEDICS"] as $k => $medics) {
                $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"][$cpt]["Medicament"]["Nom"]["value"] = $medics["x_Med_Nom"];
                if ($medics["b_Med_Matin"] == 0) $medics["b_Med_Matin"] = ""; else $medics["b_Med_Matin"] = "X";
                if ($medics["b_Med_Midi"] == 0) $medics["b_Med_Midi"] = ""; else $medics["b_Med_Midi"] = "X";
                if ($medics["b_Med_Soir"] == 0) $medics["b_Med_Soir"] = ""; else $medics["b_Med_Soir"] = "X";
                if ($medics["b_Med_Nuit"] == 0) $medics["b_Med_Nuit"] = ""; else $medics["b_Med_Nuit"] = "X";
                $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"][$cpt]["Medicament"]["Prise"]["Matin"]["value"] = $medics["b_Med_Matin"];
                $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"][$cpt]["Medicament"]["Prise"]["Midi"]["value"] = $medics["b_Med_Midi"];
                $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"][$cpt]["Medicament"]["Prise"]["Soir"]["value"] = $medics["b_Med_Soir"];
                $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"][$cpt]["Medicament"]["Prise"]["Nuit"]["value"] = $medics["b_Med_Nuit"];
                $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"][$cpt]["Medicament"]["Prise"]["Autres"]["value"] = $medics["x_Med_Autres"];
                $cpt++;
            }
        }
        $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"][$cpt]["MedecinPrescripteur"]["Nom"]["value"] = $fullDMST["DMST"]["x_Med_Ord"];
        $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Medicaments"][$cpt]["MedecinPrescripteur"]["NoTelephone"]["value"] = $fullDMST["DMST"]["t_Med_Tel"];
        $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["Accessoires"]["value"] = $fullDMST["DMST"]["n_Transfavec"];   
        $xmlArray["Message"]["Contenu"]["DMST"]["PriseEnChargeLorsTransfert"]["EffectuePar"]["Nom"]["value"] = $fullDMST["DMST"]["x_Transportpar"];
                
        $this->XMLgenerator($xmlArray, $dom, $dom);
                    
        @$dom->schemaValidate("Manege.xsd");
        $xml = $dom->saveXML();
       
        return $xml;
    }
    
    function XMLgenerator($xmlArray, $parent, $dom) {
        
        if (count($xmlArray) == 0) return;
        
        foreach ($xmlArray as $key => $xmlElmnt) {
            
            if (isset($xmlElmnt["value"])) {
                $trans = array("<"=>"&lt;",">"=>"&gt;","&"=>"&amp;");
                $xmlElmnt["value"] = strtr($xmlElmnt["value"],$trans);
                $elemnt = $dom->createElement($key, utf8_encode($xmlElmnt["value"]));
                unset($xmlElmnt["value"]);
            } else {
                $elemnt = $dom->createElement($key);
            }
                    
            if (isset($xmlElmnt["attributes"])) {
                foreach ($xmlElmnt["attributes"] as $attKey => $attValue) {
                    $trans = array("<"=>"&lt;",">"=>"&gt;","&"=>"&amp;");
                    $attValue = strtr($attValue,$trans);
                    $elemnt->setAttribute($attKey, utf8_encode($attValue));
                }
                unset($xmlElmnt["attributes"]);
            }
            
            $elemnt = $parent->appendChild($elemnt);
            
            if (isset($xmlElmnt["multiple"]) && $xmlElmnt["multiple"]) {
                unset($xmlElmnt["multiple"]);
                foreach ($xmlElmnt as $xmlSubElment) {
                    $this->XMLgenerator($xmlSubElment, $elemnt, $dom);
                }
            } else {
                $this->XMLgenerator($xmlElmnt, $elemnt, $dom);
            }
        }   
    }
    
    function stompSend($xml, $queue) {
  
        require_once(LIBS_DIR."Stomp.php");
        $c = @new StompConnection(STOMP_LINK);
        $result = @$c->connect();
        if ($result == null || $result->command != 'CONNECTED') {
            trigger_error("Client not connected", E_USER_ERROR);
        }
        
        @$c->send("/queue/$queue", $xml, array("persistent" => "true"));
        @$c->disconnect();
    }
    
    function getTypePriseEnCharge() {

        $array = array();
        $array["LongSejour"] = "Long Sjour";
        $array["SejourObservation"] = "Sjour d'observation";
        $array["CourtSejourUrgent"] = "Court sjour urgent";
        $array["CourtSejourNonUrgent"] = "Court sjour non urgent";
        $array["EtablissementNonMedicalise"] = "Etablissement non mdicalis";
        $array["CTR"] = "CTR";
        $array["Domicile"] = "Domicile";
        $array["DomicileEtUAT"] = "Domicile et UAT";
        $array["LogementAdapte"] = "Logement adapt";
        $array["AppartementProtege"] = "Appartement protg";
        $array["Autre"] = "Autre";
        return $array;
    }
    
    function getNaturePriseEncharge() {
        
        $array = array();
        $array["Psychogeriatrie"] = "Psychogriatrie";
        $array["Geriatrie"] = "Griatrie";
        $array["Psychiatrie"] = "Psychiatrie";
        $array["Autre"] = "Autre";
        return $array;
    }
    
    function getUrgences() {
     
        $array = array();
        $array[1] = "Le plus vite possible (0  2 jours)";
        $array[2] = "Ds maintenant mais sans urgence (3  6 jours)";
        $array[3] = "Dans 1 semaine  1 mois max.";
        $array[4] = "Dans plus d'un mois";
        return $array;                              
    }
    
    function getSituationProvenance() {
        
        $array = array();
        $array["Hopital"] = "Hpital";
        $array["CTR"] = "CTR";
        $array["Lit_A_ou_B_reclasse"] = "Lit A ou B reclass";
        $array["LongSejour"] = "Long sjour";
        $array["LongSejourProvisoire"] = "Long sjour provisoire";
        $array["SejourObservation"] = "Sjour d'observation";
        $array["CourtSejour"] = "Court sjour";
        $array["EtablissementNonMedicalise"] = "Etablissement non mdicalis";
        $array["Domicile"] = "Domicile";
        return $array;
    }
    
    function getSituationSociale() {
     
        $array = array();
        $array["Seul"] = "Seul";
        $array["EnMenage"] = "En mnage";
        $array["ChezProche"] = "Chez un proche";
        $array["LongSejour"] = "Long sjour";
        $array["Autre"] = "Autre";
        return $array;
    }    
    
    function getAideServiceDomicile() {
     
        $array = array();
        $array["CMS"] = "CMS";
        $array["Aucune"] = "Aucune aide";
        $array["AutrePrestataire"] = "Autre prestataire";
        return $array;
    }
    
    function getProblemesParticuliers() {
        
        $array = array();
        $array["AnxieteInsecurite"] = "Anxit, inscurit";
        $array["TroublesComportementFugues"] = "Tr. comportement, fugues";
        $array["Chutes"] = "Chutes";
        $array["ResistanceMultiplesAntibiotiques"] = "Rs. mult. antibiotiques";
        $array["Solitude"] = "Solitude";
        $array["Toxicodependances"] = "Toxicodpendances";
        $array["Perfusion"] = "Perfusion";
        $array["DomicileInadequat"] = "Dom. inadquat";
        $array["AbsenceEntourage"] = "Absence entourage";
        $array["EpuisementEntourage"] = "Epuisement entour.";
        $array["ProblemeRespiratoire"] = "Probl. respiratoire";
        $array["RefusCMS"] = "Refuse CMS";
        $array["Mobilite"] = "Problme de mobilit";
        return $array;
    }
    
    function getOrganisations($type) {
     
        $organisations = array();
        $link = ldap_connect(LDAP_HOST, LDAP_PORT) or die("Impossible de se connecter  " . LDAP_HOST);
        $bind = ldap_bind($link);
        $conn = explode(".",LDAP_HOST);
        $connString = "";
        foreach ($conn as $elmnt) {
            $connString .= ",dc=".$elmnt;
        }
        $result = ldap_search($link,"o=$type,cn=admin".$connString,"ou=*");
        $result = ldap_get_entries($link, $result);
                        
        foreach ($result as $key => $res) {
         
            if (isset($res["ou"])) $organisations[$res["ou"][0]] = $res["ou"][0];   
        }
        
        return $organisations;
    }
}
?>