<?php

class mainView {

    var $selectedTab;
    var $dmst;
    var $entete;
    var $grille;
    var $demande;
    
    function mainView() {
        
        $this->selectedTab = "ENTETE";
        $this->dmst = null;
        $this->entete = null;
        $this->grille = null;
        $this->demande = null;
    }        
    
    function process() {
        
        $this->selectedTab = requireManager::getSession("selectedTab");
        
        $this->dmst = requireManager::getSession("DMST");
        if (is_null(requireManager::getSession("SENT"))) {
            if (is_null($this->dmst)) {
                $dmstManager = new dmstManager();
                $this->dmst = $dmstManager->getDMSTFromPost();
                if (!is_null($this->dmst))
                    requireManager::setSession("DMST",$this->dmst);
            }
            $this->entete = requireManager::getSession("ENTETE");
            if (is_null($this->entete)) {
                $this->entete = new enteteObject();
            }
            $this->grille = requireManager::getSession("GRILLE");
            if (is_null($this->grille)) {
                $this->grille = new grilleObject();   
            }
            $this->demande = requireManager::getSession("DEMANDE");
            if (is_null($this->demande)) {
                $this->demande = new demandeObject();   
            }
        }
    }    
    
    function display() {
     
        $html = "";
        $html .= "<div class='mainDiv'><br/>";
        
        switch ($this->selectedTab) {
            case "ENTETE":
                $html .= $this->displayEntete();
                break;
            case "DEMANDE":
                $html .= $this->displayDemande();
                break;
            case "GRILLE":
                $html .= $this->displayGrille();
                break;
            case "DMST":
                $html .= $this->displayDMST();
                break;
            case "ENVOYER":
                $html .= $this->displayEnvoyer();
                break;
            default: break;
        }
        
        $html .= "</div>";
        
        return $html;   
    }
    
    function displayEntete() {
        
        $html = "";
        
        $sources = dmstManager::getOrganisations("cms");
        $dests = dmstManager::getOrganisations("brios");
        
        $checked = array("DMST" => "", "DMST+" => "");
        $checked[$this->entete->typeDoc] = "checked";
        
        $html .= "<table cellspacing=0 cellpadding=3 align='center' class='tableBlock'>";
        $html .= "<tr><td colspan='2' class='blocHeader'>Type d'envoi</td></tr>";
        $html .= "<tr><td><input ".$checked["DMST+"]." name='typeDoc' type='radio' value='DMST+'></td>";
        $html .= "<td>Demande d'orientation associe  un DMST</td></tr>";
        $html .= "<tr><td><input ".$checked["DMST"]." name='typeDoc' type='radio' value='DMST'></td>";
        $html .= "<td>DMST seul</td></tr>";
        $html .= "</table>";
        $html .= "<br/>";
                
        $html .= "<table cellspacing=0 cellpadding=3 align='center' class='tableBlock'>";
        $html .= "<tr><td colspan='2' class='blocHeader'>Emetteur</td></tr>";
        $html .= "<tr><td>Nom</td>";
        $html .= "<td><input name='sourceNom' type='text' value=\"".$this->entete->nomSource."\"></input></td></tr>";
        $html .= "<tr><td>Organisation</td>";
        $html .= "<td><select name='sourceOrg'>";
        foreach ($sources as $key => $source) {
            if ($this->entete->orgSource == $key) $selected = "selected";
            else $selected = "";
            $html .= "<option value='$key' $selected>$source</option>";   
        }
        $html .= "</select></td></tr>";
        $html .= "<tr><td>Tlphone</td>";
        $html .= "<td><input name='sourceTel' type='text' value=\"".$this->entete->telSource."\"></input></td></tr>";
        $html .= "</table>";
        $html .= "<br/>";
        
        $html .= "<table cellspacing=0 cellpadding=3 align='center' class='tableBlock'>";
        $html .= "<tr><td colspan='2' class='blocHeader'>Destinataire</td></tr>";
        $html .= "<tr><td>Nom</td>";
        $html .= "<td><input name='destNom' type='text' value=\"".$this->entete->nomDestination."\"></input></td></tr>";
        $html .= "<tr><td>Organisation</td>";
        $html .= "<td><select name='destOrg'>";
        foreach ($dests as $key => $dest) {
            if ($this->entete->orgDestination == $key) $selected = "selected";
            else $selected = "";
            $html .= "<option value='$key' $selected>$dest</option>";   
        }
        $html .= "</select></td></tr>";
        $html .= "</table>";
        $html .= "<br/>";
        
        $html .= "<table cellspacing=0 cellpadding=3 align='center' class='tableBlock'>";
        $html .= "<tr><td class='blocHeader'>Commentaires</td></tr>";
        $html .= "<tr><td><textarea class='tarea' name='commentaires' cols=85 rows=5>".$this->entete->comments."</textarea></td></tr>";
        $html .= "</table>";
        
        return $html;        
    }
    
    function displayDemande() {
        
        $html = "";
                        
        $html .= "<table cellspacing=0 cellpadding=3 align='center' class='tableBlock'>";
        $html .= "<tr><td colspan='2' class='blocHeader'>";
        $html .= "Demande d'orientation";
        $html .= "</td></tr>";
        
        $typesPEC = dmstManager::getTypePriseEnCharge();
        $html .= "<tr style='background-color:#EEEEEE;'><td style='width:250px;'>Prise en charge dsire</td>";
        $html .= "<td><select id='typePriseEnCharge' name='typePriseEnCharge' onchange=\"enableText('typePriseEnCharge','typePriseEnChargeAutre','Autre');\">";
        foreach ($typesPEC as $key => $option) {
            if ($this->demande->typePriseEnCharge == $key) $selected = "selected";
            else $selected = "";
            $html .= "<option $selected value='$key'>$option</option>";   
        }
        $html .= "</select>";
        $html .= "&nbsp;&nbsp;&nbsp;<a id='typePriseEnChargeAutre'>prciser : ";
        $html .= "<input name='typePriseEnChargeAutre' type='text' value=\"".$this->demande->typePriseEnChargeAutre."\"></input></a></td></tr>";
        
        $naturesPEC = dmstManager::getNaturePriseEncharge();
        $html .= "<tr><td>Nature</td>";
        $html .= "<td><select id='naturePriseEnCharge' name='naturePriseEnCharge' onchange=\"enableText('naturePriseEnCharge','naturePriseEnChargeAutre','Autre');\">";
        foreach ($naturesPEC as $key => $option) {
            if ($this->demande->naturePriseEnCharge == $key) $selected = "selected";
            else $selected = "";
            $html .= "<option $selected value='$key'>$option</option>";   
        }
        $html .= "</select>";
        $html .= "&nbsp;&nbsp;&nbsp;<a id='naturePriseEnChargeAutre'>prciser : ";
        $html .= "<input name='naturePriseEnChargeAutre' type='text' value=\"".$this->demande->naturePriseEnChargeAutre."\"></input></a></td></tr>";
        
        $urgences = dmstManager::getUrgences();
        $html .= "<tr style='background-color:#EEEEEE;'><td>Urgence</td>";
        $html .= "<td><select name='urgences'>";
        foreach ($urgences as $key => $option) {
            if ($this->demande->urgences == $key) $selected = "selected";
            else $selected = "";
            $html .= "<option $selected value='$key'>$option</option>"; 
        }
        $html .= "</select></td></tr>";
        
        require_once(LIBS_DIR."Calendrier.inc");
        $calendrier = "<img align='absmiddle' style='cursor:pointer;' src=\"".IMG_URL."calendrier.gif\" onclick=\"pickDate(document.getElementById('dateDes'), '', '', 'day_month_year', '.', 'true', 
                    'Jan.,Fv.,Mars,Avr.,Mai,Juin,Juil.,Aot,Sept.,Oct.,Nov.,Dc', 
                    'D,L,M,M,J,V,S', 'Aujourd\'hui', '');\"></img>";
        $controleDate = "controleDate('dateDes','".$this->demande->dateDes."',365,365,'dateDes','dateFin');";
        $html .= "<tr><td>Depuis le</td>";
        $html .= "<td><input id='dateDes' style='width:200px;' onblur=\"$controleDate\" name='dateDes' type='text' value=\"".$this->demande->dateDes."\">";
        $html .= "</input>&nbsp;$calendrier</td></tr>";

        $calendrier = "<img align='absmiddle' style='cursor:pointer;' src=\"".IMG_URL."calendrier.gif\" onclick=\"pickDate(document.getElementById('dateFin'), '', '', 'day_month_year', '.', 'true', 
                    'Jan.,Fv.,Mars,Avr.,Mai,Juin,Juil.,Aot,Sept.,Oct.,Nov.,Dc', 
                    'D,L,M,M,J,V,S', 'Aujourd\'hui', '');\"></img>";       
        $controleDate = "controleDate('dateFin','".$this->demande->dateFin."',365,365,'dateDes','dateFin')";
        $html .= "<tr style='background-color:#EEEEEE;'><td>Jusqu'au</td>";
        $html .= "<td><input id='dateFin' style='width:200px;' onblur=\"$controleDate\" name='dateFin' type='text' value=\"".$this->demande->dateFin."\">";
        $html .= "</input>&nbsp;$calendrier</td></tr>";

        $situationProvenance = dmstManager::getSituationProvenance();
        $html .= "<tr><td nowrap>Situation de l'usager <br/>au moment de la demande (provenance)</td>";
        $html .= "<td><select name='situationProvenance'>";
        foreach ($situationProvenance as $key => $option) {
            if ($this->demande->situationProvenance == $key) $selected = "selected";
            else $selected = "";
            $html .= "<option $selected value='$key'>$option</option>";   
        }
        $html .= "</select></td></tr>";
               
        $situationSociale = dmstManager::getSituationSociale();
        $html .= "<tr style='background-color:#EEEEEE;'><td>Situation sociale</td>";
        $html .= "<td><select id='situationSociale' name='situationSociale' onchange=\"enableText('situationSociale','situationSocialeAutre','Autre');\">";
        foreach ($situationSociale as $key => $option) {
            if ($this->demande->situationSociale == $key) $selected = "selected";
            else $selected = "";
            $html .= "<option $selected value='$key'>$option</option>";   
        }
        $html .= "</select>";
        $html .= "&nbsp;&nbsp;&nbsp;<a id='situationSocialeAutre'>prciser : ";
        $html .= "<input name='situationSocialeAutre' type='text' value=\"".$this->demande->situationSocialeAutre."\"></input></a></td></tr>";
        
        $aideServiceDomicile = dmstManager::getAideServiceDomicile();
        $html .= "<tr><td>Reoit dj l'aide d'un service <br/>de maintien  domicile</td>";
        $html .= "<td><select id='aideServiceDomicile' name='aideServiceDomicile'>";
        foreach ($aideServiceDomicile as $key => $option) {
            if ($this->demande->aideServiceDomicile == $key) $selected = "selected";
            else $selected = "";
            $html .= "<option $selected value='$key'>$option</option>";   
        }
        $html .= "</select></td></tr>";
        
        $assSocSel = array("AVS" => "", "AI" => "", "Aucune" => "");
        $keySocSel = array("AVS" => 0, "AI" => 1, "Aucune" => 2);
        if ($this->demande->assuranceSocialesType != "") {
            $assSocSel[$this->demande->assuranceSocialesType] = "checked";
            if ($this->demande->assuranceSocialesType == "Aucune") $selText = 0;
            else $selText = $this->demande->assuranceSocialesType;
            $selKey = $keySocSel[$this->demande->assuranceSocialesType];
        } else {
            $assSocSel["Aucune"] = "checked";
            $selKey = 2;
            $selText = 0;
        }
        
        $checkedPC = "";
        $checkedAPI = "";
        if ($this->demande->assuranceSocialesPC == 1) $checkedPC = "checked";
        if ($this->demande->assuranceSocialesAPI == 1) $checkedAPI = "checked";
        
        $html .= "<tr style='background-color:#EEEEEE;'><td>Assurances Sociales</td>";
        $html .= "<td>";
        $html .= "<input ".$assSocSel["AVS"]." type='radio' name='assuranceSocialesType' id='assuranceSocialesType' value='AVS' ";
        $html .= "onclick=\"enableRadioText(document.forms[0].assuranceSocialesType,2,'assuranceSocialesPCAPI');\"></input>AVS";
        $html .= "&nbsp;&nbsp;&nbsp;<input ".$assSocSel["AI"]." type='radio' name='assuranceSocialesType' id='assuranceSocialesType' value='AI' ";
        $html .= "onclick=\"enableRadioText(document.forms[0].assuranceSocialesType,2,'assuranceSocialesPCAPI');\"></input>AI";
        $html .= "&nbsp;&nbsp;&nbsp;<input ".$assSocSel["Aucune"]." type='radio' name='assuranceSocialesType' id='assuranceSocialesType' value='Aucune' ";
        $html .= "onclick=\"enableRadioText(document.forms[0].assuranceSocialesType,2,'assuranceSocialesPCAPI');\"></input>Aucune";
        $html .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a id='assuranceSocialesPCAPI'>";
        $html .= "<input type='checkbox' $checkedPC value='1' name='assuranceSocialesPC'></input>PC";
        $html .= "&nbsp;&nbsp;&nbsp;<input $checkedAPI type='checkbox' value='1' name='assuranceSocialesAPI'></input>API";
        $html .= "</a>";
        $html .= "</td></tr>";
                
        $html .= "<tr><td colspan='2'>Problmes particuliers</td></tr>";
        $html .= "<tr><td colspan='2'>";
        $problemesParticuliers = dmstManager::getProblemesParticuliers();
        $cpt = 0;
        foreach ($problemesParticuliers as $key => $checkbox) {
            if (fmod($cpt,4) == 4) $float = "";
            else $float = "float:left;";
            if ($this->demande->$key == 1) $checked = "checked";
            else $checked = "";
            $cpt++;
            $html .= "<div style='width:210px;$float'>";
            $html .= "<input type='checkbox' name='$key' value=1 $checked></input>$checkbox";
            $html .= "</div>";
        }                
        $html .= "&nbsp;&nbsp;&nbsp;Autre&nbsp;:&nbsp;<input name='AutreProbleme' type='text' value=\"".$this->demande->AutreProbleme."\"></input></td></tr>";
        
        $html .= "<tr style='background-color:#EEEEEE;'><td colspan='2'>Pers. de rfrence entourage&nbsp;&nbsp;&nbsp;";
        $html .= "<input name='persReference' type='text' value=\"".$this->demande->persReference."\">";
        
        $html .= "&nbsp;&nbsp;&nbsp;Tlphone&nbsp;&nbsp;&nbsp;";
        $html .= "<input name='persReferenceTel' type='text' value=\"".$this->demande->persReferenceTel."\"></input></td></tr>";
        
        $checked = array("","");
        if ($this->demande->suppChambreIndivDesire == "")
            $checked[0] = "checked";
        else 
            $checked[$this->demande->suppChambreIndivDesire] = "checked";
        $html .= "<tr><td>Supplment pour ch. individuelle</td>";
        $html .= "<td><input ".$checked[1]." name='suppChambreIndivDesire' type='radio' value='1'></input>Oui&nbsp;&nbsp;&nbsp;";
        $html .= "<input ".$checked[0]." name='suppChambreIndivDesire' type='radio' value='0'></input>Non</tr>";
        
        $html .= "<tr style='background-color:#EEEEEE;'><td>Souhaits de l'usager et/ou son entourage</td>";
        $html .= "<td><textarea class='tarea' name='souhaitsUsager' rows='3' cols='50'>".$this->demande->souhaitsUsager."</textarea></td></tr>";
        
        $html .= "<tr><td>Indications complmentaires</td>";
        $html .= "<td><textarea class='tarea' name='indicationsCompl' rows='3' cols='50'>".$this->demande->indicationsCompl."</textarea></td></tr>";
                
        $html .= "</table>";
        
        $html .= "<script>";
        $html .= "enableText('typePriseEnCharge','typePriseEnChargeAutre','Autre');";
        $html .= "enableText('naturePriseEnCharge','naturePriseEnChargeAutre','Autre');";
        $html .= "enableText('situationSociale','situationSocialeAutre','Autre');";
        $html .= "enableRadioText(document.forms[0].assuranceSocialesType,2,'assuranceSocialesPCAPI');";
        $html .= "</script>";
        
        return $html;   
    }
    
    function displayGrille() {
        
        $html = "";
        
        $html .= "<table cellspacing=0 cellpadding=3 align='center' class='tableBlock'>";
        $html .= "<tr><td colspan='12' class='blocHeader'>";
        $html .= "Niveau d'autonomie&nbsp;&nbsp;&nbsp; <font style='font-weight:normal;'>0.Inconnu&nbsp; 1.Autonome&nbsp; 2.Surveillance/Stimulation&nbsp; 3.Exige de l'aide&nbsp; 4.Dpendant";
        $html .= "</font></td></tr>";
        $html .= "<tr style='background-color:#EEEEEE;'><td>&nbsp;</td><td align='center'>0</td><td align='center'>1</td><td align='center'>2</td><td align='center'>3</td><td align='center'>4</td>";
        $html .= "<td>&nbsp;</td><td align='center'>0</td><td align='center'>1</td><td align='center'>2</td><td align='center'>3</td><td align='center'>4</td></tr>";
        
        $html .= "<tr class='grilleTitles'><td colspan='6'><b>Activits de la vie quotidienne</b></td>";
        $html .= "<td colspan='6'><b>Communication</b></td></tr>";
        
        $html .= "<tr class='altLine1'>".$this->radioLine("Manger - Boire", "manger", $this->grille->manger);
        $html .= $this->radioLine("Voir", "voir", $this->grille->voir)."</tr>";
        
        $html .= "<tr class='altLine2'>".$this->radioLine("Se laver", "laver", $this->grille->laver);
        $html .= $this->radioLine("Entendre", "entendre", $this->grille->entendre)."</tr>";
        
        $html .= "<tr class='altLine1'>".$this->radioLine("S'habiller", "habiller", $this->grille->habiller);
        $html .= $this->radioLine("Parler", "parler", $this->grille->parler)."</tr>";
        
        $html .= "<tr class='altLine2'>".$this->radioLine("Se dshabiller", "deshabiller", $this->grille->deshabiller);
        $html .= $this->radioLine("Utiliser le tlphone", "telephone", $this->grille->telephone)."</tr>";
        
        $html .= "<tr class='altLine1'>".$this->radioLine("Entretenir sa personne", "entpersonne", $this->grille->entPersonne);
        $html .= "<td colspan='6' class='grilleTitles'><b>Etat psychique / Facults mentales</b></td></tr>";
        
        $html .= "<tr class='altLine2'>".$this->radioLine("Continence vsicale", "contves", $this->grille->contVes);
        $html .= $this->radioLine("Mmoire", "memoire", $this->grille->memoire)."</tr>";
        
        $html .= "<tr class='altLine1'>".$this->radioLine("Continence anale", "contana", $this->grille->contAna);
        $html .= $this->radioLine("Orientation (temps, espace)", "orientation", $this->grille->orientation)."</tr>";
        
        $html .= "<tr class='altLine2'>".$this->radioLine("Utiliser les toilettes", "toilettes", $this->grille->toilettes);
        $html .= $this->radioLine("Jugement / comprhension", "jugement", $this->grille->jugement)."</tr>";
        
        $html .= "<tr class='altLine1'><td colspan='6'>&nbsp;</td>";
        $html .= $this->radioLine("Grer son temps libre, s'occuper", "tempslibre", $this->grille->tempsLibre)."</tr>";
        
        $html .= "<tr class='grilleTitles'><td colspan='6'><b>Mobilit</b></td>";
        $html .= "<td colspan='6'><b>Tches domestiques</b></td></tr>";

        $html .= "<tr class='altLine1'>".$this->radioLine("Changer de position", "position", $this->grille->position);
        $html .= $this->radioLine("Entretenir son logement", "entlogement", $this->grille->entLogement)."</tr>";

        $html .= "<tr class='altLine2'>".$this->radioLine("Se dplacer  l'intrieur", "depinterieur", $this->grille->depInterieur);
        $html .= $this->radioLine("Prparer les repas", "preprepas", $this->grille->prepRepas)."</tr>";
        
        $html .= "<tr class='altLine1'>".$this->radioLine("Se dplacer  l'extrieur", "depexterieur", $this->grille->depExterieur);
        $html .= $this->radioLine("Faire les courses", "courses", $this->grille->courses)."</tr>";

        $html .= "<tr class='altLine2'>".$this->radioLine("Utiliser les moyens de transport", "transport", $this->grille->transport);
        $html .= $this->radioLine("Faire la lessive - entretenir le linge", "lessive", $this->grille->lessive)."</tr>";

        $html .= "<tr class='altLine1'>".$this->radioLine("Utiliser les moyens auxiliaires", "auxiliaires", $this->grille->auxiliaires);
        $html .= $this->radioLine("Prendre ses mdicaments", "medics", $this->grille->medics)."</tr>";
        
        $html .= "<tr class='altLine2'>".$this->radioLine("Utiliser les escaliers", "escaliers", $this->grille->escaliers);
        $html .= $this->radioLine("Gestion administrative", "gestadmin", $this->grille->gestAdmin)."</tr>";
        
        $html .= "<tr class='altLine1'><td colspan='6'>&nbsp;</td>";
        $html .= $this->radioLine("Grer ses liens sociaux", "lienssociaux", $this->grille->liensSociaux)."</tr>";

        $html .= "</table>";
        
        return $html;
    }
    
    function radioLine($name, $id, $selected) {
        
        $html = "";
        
        $checked = array("","","","","");
        $bgColor = array("","","","","");
        if ($selected == "") $selected = 0;
        $checked[$selected] = "checked";
        $bgColor[$selected] = "style='background-color:#CC3300;'";
        
        $html .= "<td>$name</td>";
        
        for ($i=0;$i<5;$i++) {
            $html .= "<td id='td_".$id."_".$i."' ".$bgColor[$i]."><input ".$checked[$i]." type='radio' name='$id' value='$i' ";
            $html .= "onclick=\"updateRadioBackground('td_".$id."',$i);\"></input></td>";
        }
                
        return $html;
    }
    
    function displayDMST() {
     
        $html = "";
        
        $DMST = $this->dmst["DMST"];
        if (isset($this->dmst["INTERV"])) $INTERV = $this->dmst["INTERV"];
        else $INTERV = array();
        if (isset($this->dmst["MEDICS"])) $MEDICS = $this->dmst["MEDICS"];
        else $MEDICS = array();
        
        $html .= "<table cellspacing=0 cellpadding=3 align='center' class='tableBlock'>";
        $html .= "<tr><td colspan='9' class='blocHeader'>";
        $html .= "<b>1. Donnes administratives</b></td></tr>";
        $html .= "<tr><td colspan='3' style='border-right:1px black solid;'><a class='libellesDMST'>Nom : </a>";
        $html .= "<a class='contenuDMST'>".$DMST["x_Nom"]."</a></td>";
        $html .= "<td align='center' style='border-right:1px black solid;' class='libellesDMST'>Sexe</td>";
        $html .= "<td align='center' style='border-right:1px black solid;' class='libellesDMST'>Date de <br/>Naissance</td>";
        $html .= "<td align='center' style='border-right:1px black solid;' class='libellesDMST'>Lieu de <br/>Naissance</td>";
        $html .= "<td align='center' style='border-right:1px black solid;' class='libellesDMST'>Date <br/>d'entre</td>";
        $html .= "<td align='center' style='border-right:1px black solid;' class='libellesDMST'>Date de <br/>sortie</td>";
        $html .= "<td align='center' class='libellesDMST'>N&deg; client</td>";
        $html .= "</tr>";
        $html .= "<tr><td colspan='3' style='border-right:1px black solid;'><a class='libellesDMST'>Prnom : </a>";
        $html .= "<a class='contenuDMST'>".$DMST["x_Prenom"]."</a></td>";
        $sexe = "";
        if ($DMST["n_Sexe"] == 1) $sexe = "M"; elseif ($DMST["n_Sexe"] == 0) $sexe = "F";
        $html .= "<td align='center' style='border-right:1px black solid;' class='contenuDMST'>".$sexe."&nbsp;</td>";
        $html .= "<td align='center' style='border-right:1px black solid;' class='contenuDMST'>".$DMST["d_Naissance"]."&nbsp;</td>";
        $html .= "<td align='center' style='border-right:1px black solid;' class='contenuDMST'>".$DMST["x_Lieudenaissance"]."&nbsp;</td>";
        $html .= "<td align='center' style='border-right:1px black solid;' class='contenuDMST'>".$DMST["d_Dentree"]."&nbsp;</td>";
        $html .= "<td align='center' style='border-right:1px black solid;' class='contenuDMST'>".$DMST["d_Desortie"]."&nbsp;</td>";
        $html .= "<td align='center' class='contenuDMST'>".$DMST["x_Numerodeclient"]."</td>";
        $html .= "</tr>";
        
        $html .= "<tr><td colspan='3' style='border-right:1px black solid;border-top:1px black solid;'>";
        $html .= "<a class='libellesDMST'>Etat civil : </a><a class='contenuDMST'>".$DMST["x_Etatcivil"]."</a></td>";
        $html .= "<td colspan='3' style='border-right:1px black solid;border-top:1px black solid;'>";
        $html .= "<a class='libellesDMST'>Origine : </a><a class='contenuDMST'>".$DMST["x_Origine"]."</a></td>";
        $html .= "<td colspan='3' style='border-top:1px black solid;'>";
        $html .= "<a class='libellesDMST'>Filiation maternelle : </a><a class='contenuDMST'>".$DMST["x_Filmat"]."</a></td></tr>";
        
        $html .= "<tr><td colspan='3' style='border-right:1px black solid;border-top:1px black solid;'>";
        $html .= "<a class='libellesDMST'>Religion/confession : </a><a class='contenuDMST'>".$DMST["x_Relconf"]."</a></td>";
        $html .= "<td colspan='3' style='border-right:1px black solid;border-top:1px black solid;'>";
        $html .= "<a class='libellesDMST'>Nationalit : </a><a class='contenuDMST'>".$DMST["x_Nation"]."</a></td>";
        $html .= "<td colspan='3' style='border-top:1px black solid;'>";
        $html .= "<a class='libellesDMST'>Filiation paternelle : </a><a class='contenuDMST'>".$DMST["x_Filpat"]."</a></td></tr>";
        
        $html .= "<tr><td colspan='3' style='border-top:1px black solid;'>";
        $html .= "<a class='libellesDMST'>Domicile : </a><a class='contenuDMST'><br/>".$DMST["x_Dom"]."</a></td>";
        $html .= "<td colspan='3' style='border-right:1px black solid;border-top:1px black solid;'>";
        $html .= "<a class='libellesDMST'>Tl. </a><a class='contenuDMST'>".$DMST["t_Domtel"]."</a></td>";
        $html .= "<td colspan='3' style='border-top:1px black solid;'>";
        $html .= "<a class='libellesDMST'>Profession </a><a class='contenuDMST'>".$DMST["x_Profess"]."</a></td></tr>";
        
        $html .= "<tr><td colspan='6' style='border-top:1px black solid;border-right:1px black solid;'>";
        $html .= "<a class='libellesDMST'>Nom et prnom du conjoint : </a><a class='contenuDMST'>".$DMST["x_Npconjoint"]."</a></td>";
        $html .= "<td colspan='3' style='border-top:1px black solid;'>";
        $html .= "<a class='libellesDMST'>Tl en urgence chez </a><a class='contenuDMST'>".$DMST["t_Telurg"]."</a></td></tr>";
        
        $html .= "<tr><td colspan='5' style='border-top:1px black solid;border-right:1px black solid;'>";
        $html .= "<a class='libellesDMST'>Mdecin traitant : </a><a class='contenuDMST'>".$DMST["x_Medtrait"]."</a></td>";
        $html .= "<td colspan='4' style='border-top:1px black solid;'>";
        $html .= "<a class='libellesDMST'>Assurance : </a><a class='contenuDMST'>".$DMST["x_Ass"]."</a></td></tr>";
        
        $html .= "<tr><td colspan='5' style='border-right:1px black solid;'>";
        $html .= "&nbsp;</td>";
        $html .= "<td colspan='4'>";
        $html .= "<a class='libellesDMST'>N&deg; d'assur : </a><a class='contenuDMST'>".$DMST["x_Numass"]."</a></td></tr>";
        
        $html .= "<tr><td colspan='5' style='border-right:1px black solid;'>";
        $html .= "<a class='libellesDMST'>Mdecin de l'hpital : </a><a class='contenuDMST'>".$DMST["x_Medhop"]."</a></td>";
        $html .= "<td colspan='4'>";
        $html .= "<a class='libellesDMST'>N&deg; AVS : </a><a class='contenuDMST'>".$DMST["x_Numavs"]."</a></td></tr>";
                        
        $html .= "</table>";
                
        $html .= "<br/>";
        
        $html .= "<table cellspacing=0 cellpadding=3 align='center' class='tableBlock'>";
        $html .= "<tr><td colspan='2' class='blocHeader'>";
        $html .= "<b>2. Famille, entourage</b></td></tr>";
        $html .= "<tr><td><a class='libellesDMST'>Personne de rfrence : </a><a class='contenuDMST'>".$DMST["x_Persrefnom"]."</a></td>";
        $html .= "<td><a class='libellesDMST'>Tl : </a><a class='contenuDMST'>".$DMST["t_Persreftel"]."</a></td></tr>";
        $html .= "<tr><td colspan='2' style='border-bottom:1px black solid;'>";
        $html .= "<a class='libellesDMST'>Adresse : </a><a class='contenuDMST'>".$DMST["x_Persrefadr"]."</a></td></tr>";
        $html .= "<tr><td><a class='libellesDMST'>Personne(s) vivant avec le patient : </a><a class='contenuDMST'>".$DMST["x_Persviv"]."</a></td>";
        $html .= "<td><a class='libellesDMST'>Tl : </a><a class='contenuDMST'>".$DMST["t_Persvivtel"]."</a></td></tr>";
        $html .= "<tr><td colspan='2' style='border-bottom:1px black solid;'>";
        $html .= "<a class='libellesDMST'>Adresse : </a><a class='contenuDMST'>".$DMST["x_Persvivadr"]."</a></td></tr>";
        $html .= "<tr><td><a class='libellesDMST'>Tuteur/curateur : </a><a class='contenuDMST'>".$DMST["x_Cur"]."</a></td>";
        $html .= "<td><a class='libellesDMST'>Tl : </a><a class='contenuDMST'>".$DMST["t_Curtel"]."</a></td></tr>";
        $html .= "<tr><td colspan='2'><a class='libellesDMST'>Adresse : </a><a class='contenuDMST'>".$DMST["x_Curadr"]."</a></td></tr>";
        $html .= "</table>";
        
        $html .= "<br/>";
        
        $html .= "<table cellspacing=0 cellpadding=3 align='center' class='tableBlock'>";
        $html .= "<tr><td class='blocHeader'>";
        $html .= "<b>3. Habitat (description)</b></td></tr>";
        $html .= "<tr><td class='libellesDMST'>Itinraire et accs / Barrires architecturales / Caractristiques du logement :<br/></td></tr>";
        $html .= "<tr><td class='contenuDMST'>".$DMST["a_Iti"]."</td></tr>";
        $html .= "</table>";
        
        $html .= "<br/>";
        
        $html .= "<table cellspacing=0 cellpadding=3 align='center' class='tableBlock'>";
        $html .= "<tr><td class='blocHeader'>";
        $html .= "<b>4. Contexte et habitudes de vie</b></td></tr>";
        $html .= "<tr><td class='libellesDMST'>Ressources et besoins, vnements et faits marquants, relations socio-familiales significatives :<br/></td></tr>";
        $html .= "<tr><td class='contenuDMST'>".$DMST["a_Resbes"]."</td></tr>";
        $html .= "</table>";
        
        $html .= "<br/>";
        
        $html .= "<table cellspacing=0 cellpadding=3 align='center' class='tableBlock'>";
        $html .= "<tr><td colspan='3' class='blocHeader'>";
        $html .= "<b>5. Intervenants</b> ( domicile ou de rfrence avant le transfert)</td></tr>";
        $html .= "<tr class='libellesDMST'><td align='center' style='border-right:1px black solid;border-bottom:1px black solid;'>Nom de l'intervenant et fonction</td>";
        $html .= "<td align='center' style='border-right:1px black solid;border-bottom:1px black solid;'>N&deg; de tlphone</td>";
        $html .= "<td align='center' style='border-bottom:1px black solid;'>Prcisions</td></tr>";
        foreach ($INTERV as $key => $INT) {
            $html .= "<tr class='contenuDMST'><td style='border-top:1px black solid;border-right:1px black solid;'>"; 
            $html .= $INT["x_int_nom"]."</td>";
            $html .= "<td style='border-top:1px black solid;border-right:1px black solid;'>";
            $html .= $INT["t_int"]."</td>";
            $html .= "<td style='border-top:1px black solid;'>";
            $html .= $INT["x_int_precision"]."</td>";
            $html .= "</tr>";  
        }
        $html .= "</table>";
        
        $html .= "<br/>";
                        
        $html .= "<table cellspacing=0 cellpadding=3 align='center' class='tableBlock'>";
        $html .= "<tr><td colspan='4' class='blocHeader'>";
        $html .= "<b>6. Niveau d'autonomie</b></td></tr>";
        $html .= "<tr><td class='libellesDMST' colspan='4'>Voir onglet \"Grille\"</td></tr>";
        $html .= "<tr><td class='libellesDMST' colspan='1'>Transfr avec (cannes, lunettes, prothses, ...) :</td>";
        $html .= "<td class='contenuDMST' colspan='3'>".$DMST["x_Transfavec"]."&nbsp;</td></tr>";
        $html .= "<tr><td class='libellesDMST'>Transport effectu par : </td>";
        $html .= "<td class='contenuDMST'>".$DMST["x_Transportpar"]."&nbsp;</td>";
        $html .= "<td class='libellesDMST'>le : </td>";
        $html .= "<td class='contenuDMST'>".$DMST["d_Transport"]."&nbsp;</td></tr>";
        $html .= "</table>";
        
        $html .= "<br/>";
        
        $html .= "<table cellspacing=0 cellpadding=3 align='center' class='tableBlock'>";
        $html .= "<tr><td class='blocHeader'>";
        $html .= "<b>7. Bilan de sant</b> (habitudes, problmes, actions entreprises, moyens auxiliaires, etc...)</td></tr>";
        $html .= "<tr><td class='libellesDMST'>Etat gnral / Respiration / Circulation - temprature / Alimentation, hydratation, digestion / ";
        $html .= "Elimination (incontinence, appareillage), sondes et stomies diverses (avec date de la pose) / ";
        $html .= "Mobilisation (coordination, posture, spasticit, etc.) / Handicaps sensoriels et appareillage / ";
        $html .= "Etat de la peau, des ongles et cicatrices / Sommeil et repos / Etat psychique / Autre : <br/></td></tr>";
        $html .= "<tr><td class='contenuDMST'>".$DMST["A_Etatgeneral"]."</td></tr>";
        $html .= "</table>";
        
        $html .= "<br/>";
        
        $html .= "<table cellspacing=0 cellpadding=3 align='center' class='tableBlock'>";
        $html .= "<tr><td colspan='6' class='blocHeader'>";
        $html .= "<b>8. Prise en charge le jour du transfert</b></td></tr>";
        $html .= "<tr><td colspan='6' class='libellesDMST'>Motif du transfert / Objectifs de soins / Projets pour le patient :<br/></td></tr>";
        $html .= "<tr><td colspan='6' class='contenuDMST' style='border-bottom:1px black solid;'>".$DMST["a_Motiftransfert"]."</td></tr>";
        $html .= "<tr><td colspan='6' class='libellesDMST'>Traitement en cours et soins  effectuer / Moyens et matriel de soins ncessaires / Surveillance :<br/></td></tr>";
        $html .= "<tr><td colspan='6' class='contenuDMST' style='border-bottom:1px black solid;'>".$DMST["a_Traitcours"]."</td></tr>";
        $html .= "<tr class='libellesDMST'><td style='border-top:1px black solid;border-bottom:1px black solid;'>Mdicaments (valable le jour du transfert) :</td>";
        $html .= "<td align='center' style='border-top:1px black solid;border-bottom:1px black solid;'>Matin</td>";
        $html .= "<td align='center' style='border-top:1px black solid;border-bottom:1px black solid;'>Midi</td>";
        $html .= "<td align='center' style='border-top:1px black solid;border-bottom:1px black solid;'>Soir</td>";
        $html .= "<td align='center' style='border-top:1px black solid;border-bottom:1px black solid;'>Nuit</td>";
        $html .= "<td align='center' style='border-top:1px black solid;border-bottom:1px black solid;'>Autres</td></tr>";
        foreach ($MEDICS as $key => $MED) {
            if (fmod($key,2) == 0) $style = "background-color:#EEEEEE;";
            else $style = "";
            if ($MED["b_Med_Matin"] < 0) $b_Med_Matin = "X"; else $b_Med_Matin = "";
            if ($MED["b_Med_Midi"] < 0) $b_Med_Midi = "X"; else $b_Med_Midi = "";
            if ($MED["b_Med_Soir"] < 0) $b_Med_Soir = "X"; else $b_Med_Soir = "";
            if ($MED["b_Med_Nuit"] < 0) $b_Med_Nuit = "X"; else $b_Med_Nuit = "";
            $html .= "<tr class='contenuDMST' style='$style'><td>".$MED["x_Med_Nom"]."</td>";
            $html .= "<td align='center'>".$b_Med_Matin."</td>";
            $html .= "<td align='center'>".$b_Med_Midi."</td>";
            $html .= "<td align='center'>".$b_Med_Soir."</td>";
            $html .= "<td align='center'>".$b_Med_Nuit."</td>";
            $html .= "<td align='center'>".$MED["x_Med_Autres"]."</td></tr>";
        }
        $html .= "<tr><td style='border-top:1px black solid;' colspan='3'><a class='libellesDMST'>Mdicaments ordonns par Dr : </a>";
        $html .= "<a class='contenuDMST'>".$DMST["x_Med_Ord"]."</a></td>";
        $html .= "<td style='border-top:1px black solid;' colspan='3'><a class='libellesDMST'>Tl. : </a>";
        $html .= "<a class='contenuDMST'>".$DMST["t_Med_Tel"]."</a></td></tr>";
        $html .= "</table>";
        
        //$html .= "<textarea name='dmst' cols=85 rows=25>".print_r($this->dmst,true)."</textarea>";
        
        return $html;           
    }
    
    function displayEnvoyer() {
        
        $html = "";
        
        $html .= "<center>";
        $html .= "<br/><br/><br/><br/><br/>";
        if (!is_null(requireManager::getSession("SENT")) && requireManager::getSession("SENT") == "OK") {
            
            $html .= "<p style='width=70%'>Merci d'avoir envoy votre document. Vous pouvez maintenant
                      fermer cette fentre.</p>";
            $html .= "<br/><br/>";
            $html .= "<input type='button' value='Fermer' onclick=\"window.close();\"></input>";
        } elseif (!is_null(requireManager::getSession("SENT")) && requireManager::getSession("SENT") == "KO") {
            
            $html .= "<p style='width=70%'>L'envoi du document a t annul. Vous pouvez maintenant
                      fermer cette fentre.</p>";
            $html .= "<br/><br/>";
            $html .= "<input type='button' value='Fermer' onclick=\"window.close();\"></input>";
        } else {
                
            $html .= "<p style='width=70%'>Si les donnes saisies, ainsi que les donnes provenant du CMS sont correctes, 
                     vous pouvez cliquer sur le bouton <Envoyer> ci-dessous afin de faire suivre le document
                     au brio dsir.</p>";
            $html .= "<br/><br/>";
            $html .= "<input type='button' value='Annuler' onclick=\"Submit('cancel')\"></input>";
            $html .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
            $html .= "<input type='button' value='Envoyer' onclick=\"Submit('sendDMST');\"></input>";
        }
        $html .= "</center>";
        
        return $html;   
    }
}

?>