<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Server SOAP "mange" fournissant des mthodes invocables  distance. Mange est le serveur
* centralis sur lequel se connectent les diffrentes instances de briocheWeb pour changer
* des communications interBRIOs
* Repose sur la bibliothque nusoap
* @package manege
* @author ob
*/
/**
*/
//
require('entete.phtml');
//
$ini = new briocheIni();
require("$ini->classDir/session.inc");
require("$ini->classDir/erreurB.inc");
require("$ini->classDir/sessionDBrioche.inc");
require("$ini->classDir/connexionBrioche.inc");
require("$ini->classDir/ensTableBrioche.inc");
require("$ini->classDir/updateTableBrioche.inc");
require_once("$ini->classDir/nusoap/lib/nusoap.php"); 


$server = new soap_server;
$server->register('getSession');
$server->register('getAdressesInterBrio');
$server->register('envoieDemande');
$server->register('getQuittances');
$server->register('getDemandes');
$server->register('setQuittance');
$server->service(file_get_contents("php://input"));

/**
* renvoie au client distant son adresse interBRIOs propre sur la base du numro de session
* obtenu lorsqu'il s'est identifi
* @param string idsession le numro de session sur le serveur
* @return string
*/
function getAdresseIB($idsession){
  $et = new ensTableBrioche("adressesinterbrio", "1", "*", 0, $idsession);
  $adresse = $et->lookUp("adresse", "utilisateur = \"$et->utilisateur\"");
  return $adresse;
}

/**
* attribue un numro de session sur le serveur Mange  une instance de briocheWeb. Des paramtres 
* de login sont attribus  chaque instance de briocheWeb qui les stocke dans son briocheIni.inc
* (paramtres manegeUtil et manegePw). Les instances clientes autorises sont enregistres comme
* utilisateurs Herms auprs du serveur sur lequel s'appuye le serveur Mange qui doivent
* disposer de l'autorisation mentionne sous autReq dans le fichier briocheIni du serveur Mange. 
* @param string usr le nom d'utilisateur
* @param string pwd le mot de passe
* @return string idsession le numro de session "mange"
*/
function getSession($usr, $pwd){
  $sess = new Session(0, $usr, $pwd);
  if ($sess->n_erreur){
    return new soap_fault('Client', '', "Impossible d'obtenir une session : erreur $sess->n_erreur", '');
  }
  return $sess->idsession;
}

/**
* renvoie le tableau de toutes les adresses interBRIOs agres et des libells associs
* @param string idsession un numro de session en cours
* @return array
*/
function getAdressesInterBrio($idsession){
  $et = new ensTableBrioche("adressesinterbrio", "1", "adresse, libelle", "adresse",
                            $idsession);
  $tet = $et->getTableau();
  return $tet;
}

/**
* vrification qu'une adresse interBRIOs existe
* @param string destination l'adresse  vrifier
* @param string idsession un numro de session en cours
* @return boolean l'adresse existe-t-elle ?
*/
function verifieAdresse($destination, $idsession){
  $et = new ensTableBrioche("adressesinterbrio", "adresse = \"$destination\"", "adresse", 0, $idsession);
  return $et->compte(); 
}

// Rcupration des demandes en attente par un BRIO
function getDemandes($idsession){
  $adresse = getAdresseIB($idsession);
  $edem = new ensTableBrioche("avaliderdem",
                              "envoisinterbrio.quittance = 1 and envoisinterbrio.adressedest = \"$adresse\"",
                              "avaliderdem.*, envoisinterbrio.quittance",
                              0,
                              $idsession,
                              "envoisinterbrio",
                              "avaliderdem.nodemor = envoisinterbrio.nodemor");
  return $edem->getTableau();
}

/**
* enregistrement d'une demande envoye par l'instance cliente de briocheWeb
* @param string idsession un numro de session en cours
* @param array le tableau associatif des variables constituant la demande
* @return boolean l'enregistrement s'est-il bien pass ?
*/
function envoieDemande($idsession, $tab, $destination){
  $tabchamps = $tab;
  unset($tabchamps['nodemor']); // Le numro (technique) de la demande est rattribu incrmentiellement par Mange
  unset($tabchamps['tst']); // Le champ tst de l'enregistrement original n'a pas  tre transmis
  unset($tabchamps['dmd5']);
  if ($tabchamps['cms'] == 1) $tabchamps['aidecms'] = -2;
  $tabchamps['brioorigine'] = getAdresseIB($idsession); //Rcupration de l'adresse interBRIO de l'metteur
  if ($tabchamps['typesej'] == 5) $tabchamps['typesej'] = 3; // Transmis, une demande de sjour planning devient une simple
  if (! verifieAdresse($destination, $idsession)) return 0; // demande de court-sjour.
  $et = new ensTableBrioche("avaliderdem",
                            "nodoss = " . $tabchamps['nodoss'] . " AND brioorigine = \"" . $tabchamps['brioorigine'] . "\"",
                            "nodemor", 0, $idsession);
  if ($et->compte()){
    $tet = $et->getTableau();
    $nd = $tet[0]->nodemor;
  }
  else {
    
    $nd = $et->creeNouveau("nodemor");
  }
  $ut = new updateTableBrioche("avaliderdem", $tabchamps, $nd, "nodemor", $idsession);
  if($ut->update()){
    //La demande transmise a pu tre enregistre => enregistrement de l'adresse du bnficiaire
    $env = new ensTableBrioche("envoisinterbrio", "nodemor = $nd and adressedest = \"$destination\"", "id", 0, $idsession);
    if ($env->compte()){
      $tenv = $env->getTableau();
      $nid = $tenv[0]->id; 
    } 
    else {
      $nid = $env->creeNouveau("id");
    }
    $tabchamps = array();
    $tabchamps['adressedest'] = $destination;
    $tabchamps['nodemor'] = $nd;
    $tabchamps['quittance'] = 1;
    $utenv = new updateTableBrioche("envoisinterbrio", $tabchamps, $nid, "id", $idsession);
    if (! $utenv->update()) return false;
    return $nd;
  }
  else return 0;
}

/**
* fournit  l'instance briocheWeb cliente les quittances correspondant aux envois interBRIOs
* envoys qui n'ont pas encore t enregistres comme "valides" ou "rejetes"
* @param string idsession un numro de session en cours
* @param array tabquit, un tableau dont chaque index contient un tableau associatif dont
* la cl ['nodoss'] correspond au numro du dossier dans le BRIO d'origine et ['adressedest']
* l'adresse interBRIOs du BRIO destinataire
* @return array le mme tableau, avec pour chaque index une cl ['quittance'] en plus.
*/
function getQuittances($idsession, $tabquitt){
  $cpt = count($tabquitt);
  $et = new ensTableBrioche("envoisinterbrio", "1", "quittance, adressedest", 0, $idsession,
                            "avaliderdem", "envoisinterbrio.nodemor = avaliderdem.nodemor"); 
  $rep = array();
  for ($i = 0; $i < $cpt; $i++){
    $where = "brioorigine = \"" . getAdresseIB($idsession) .
             "\" AND avaliderdem.nodoss = " . $tabquitt[$i]['nodoss'] . " AND adressedest = \"" .
             $tabquitt[$i]['adressedest'] . "\"";
    $et->setWhere($where);
    $tet = $et->getTableau();
    $rep[$i]['nodoss'] = $tabquitt[$i]['nodoss'];
    $rep[$i]['adressedest'] = $tet[0]->adressedest;
    $rep[$i]['quittance'] = $tet[0]->quittance;                         
  }
  return $rep;
}

/**
* mise  jour de la quittance lorsque le BRIO destinataire prend connaissance de la demande 
* interBRIOs
* @param string idsession l'identifiant d'une session en cours
* @param int nodemor l'identifiant de la demande transmise
* @param int valeur  donner  la quittance (en principe 98 pour rejet, 99 pour accept)
* @param int le numro de dossier auprs du BRIO destinataire
* @param int le numro d'usager auprs du BRIO destinataire
* @return boolean la mise  jour de la quittance s'est-elle bien passe ?
*/
function setQuittance($idsession, $nodemor, $valeur, $nodoss = 0, $nous = 0){
  $adresse = getAdresseIB($idsession);
  $where = "nodemor = $nodemor AND adressedest = \"$adresse\"";
  $ut = new updateTableBrioche("envoisinterbrio", "", "", "", $idsession);
  if ($nodoss) $ut->updateSpec("nodoss", $nodoss, $where);
  if ($nous) $ut->updateSpec("nous", $nous, $where);
  return $ut->updateSpec("quittance", $valeur, $where);
}


?> 