<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:fn="http://www.w3.org/2005/xpath-functions" xmlns:xdt="http://www.w3.org/2005/xpath-datatypes">
	<xsl:output method="html" version="1.0" encoding="UTF-8" indent="yes"/>
	<xsl:template match="Message">
		<html>
			<head>
				<title>Message Manège</title>
				<link rel="stylesheet" type="text/css" href="../manege/manege.css"/>
			</head>
			<body>
				<h1>Message Manège</h1>
				<xsl:apply-templates/>
			</body>
		</html>
	</xsl:template>
	<xsl:template match="Timestamp">
		<h2>Date et heure</h2>
		<table>
			<tr>
				<td class="label">Date et heure</td>
				<td class="value">
					<xsl:value-of select="."/>
				</td>
			</tr>
		</table>
	</xsl:template>
	<xsl:template match="Commentaire">
		<h2>Commentaire</h2>
		<table>
			<tr>
				<td class="label">Commentaire</td>
				<td class="value">
					<xsl:value-of select="."/>
				</td>
			</tr>
		</table>
	</xsl:template>
    
	<xsl:template match="Source|Destination">
		<h2>
			<xsl:value-of select="name(current())"/>
		</h2>
		<table>
			<tr>
				<td class="label">Organisation</td>
				<td class="value">
					<xsl:value-of select="Organisation"/>
				</td>
			</tr>
			<tr>
				<td class="label">Personne</td>
				<td class="value">
					<xsl:value-of select="Personne"/>
				</td>
			</tr>
			<tr>
				<td class="label">No de téléphone</td>
				<td class="value">
					<xsl:value-of select="NoTelephone"/>
				</td>
			</tr>
			<tr>
				<td class="label">Adresse e-mail</td>
				<td class="value">
					<xsl:value-of select="AdresseEMail"/>
				</td>
			</tr>
		</table>
	</xsl:template>
	<xsl:template match="Patient">
		<h2>Patient</h2>
		<table>
			<tr>
				<td class="label">Sexe</td>
				<td class="value">
					<xsl:value-of select="Sexe"/>
				</td>
			</tr>
			<tr>
				<td class="label">Nom</td>
				<td class="value">
					<xsl:value-of select="Nom"/>
				</td>
			</tr>
			<tr>
				<td class="label">Prénom</td>
				<td class="value">
					<xsl:value-of select="Prenom"/>
				</td>
			</tr>
			<tr>
				<td class="label">Date de naissance</td>
				<td class="value">
					<xsl:value-of select="DateDeNaissance"/>
				</td>
			</tr>
			<tr>
				<td class="label">Adresse</td>
				<td class="value">
					<xsl:value-of select="Adresse/RueEtNumero"/>
					<xsl:text>, </xsl:text>
					<xsl:value-of select="Adresse/NoPostal"/>
					<xsl:text> </xsl:text>
					<xsl:value-of select="Adresse/Localite"/>
				</td>
			</tr>
			<tr>
				<td class="label">No de téléphone</td>
				<td class="value">
					<xsl:value-of select="NoTelephone"/>
				</td>
			</tr>
			<tr>
				<td class="label">No AVS</td>
				<td class="value">
					<xsl:value-of select="NoAVS"/>
				</td>
			</tr>
			<tr>
				<td class="label">NNSS</td>
				<td class="value">
					<xsl:value-of select="NNSS"/>
				</td>
			</tr>
			<tr>
				<td class="label">Num. de client</td>
				<td class="value">
					<xsl:value-of select="NoClientCMS"/>
				</td>
			</tr>
			<tr>
				<td class="label">Commentaire</td>
				<td class="value">
					<xsl:value-of select="Commentaire"/>
				</td>
			</tr>
		</table>
	</xsl:template>
	<xsl:template match="DemandeOrientation">
		<h1>Demande d'orientation</h1>
		<table>
			<tr>
				<td class="label">PriseEnCharge/Type</td>
				<td class="value">
					<xsl:value-of select="PriseEnCharge/Type"/>
				</td>
			</tr>
			<tr>
				<td class="label">PriseEnCharge/AutreType</td>
				<td class="value">
					<xsl:value-of select="PriseEnCharge/AutreType"/>
				</td>
			</tr>
			<tr>
				<td class="label">PriseEnCharge/Nature</td>
				<td class="value">
					<xsl:value-of select="PriseEnCharge/Nature"/>
				</td>
			</tr>
			<tr>
				<td class="label">PriseEnCharge/AutreNature</td>
				<td class="value">
					<xsl:value-of select="PriseEnCharge/AutreNature"/>
				</td>
			</tr>
			<tr>
				<td class="label">PriseEnCharge/SoldeJourneesCourtSejour</td>
				<td class="value">
					<xsl:value-of select="PriseEnCharge/SoldeJourneesCourtSejour"/>
				</td>
			</tr>
			<tr>
				<td class="label">PriseEnCharge/Urgence</td>
				<td class="value">
					<xsl:value-of select="PriseEnCharge/Urgence"/>
				</td>
			</tr>
			<tr>
				<td class="label">PriseEnCharge/DateDes</td>
				<td class="value">
					<xsl:value-of select="PriseEnCharge/DateDes"/>
				</td>
			</tr>
			<tr>
				<td class="label">PriseEnCharge/DateFin</td>
				<td class="value">
					<xsl:value-of select="PriseEnCharge/DateFin"/>
				</td>
			</tr>
			<tr>
				<td class="label">Provenance</td>
				<td class="value">
					<xsl:value-of select="Provenance"/>
				</td>
			</tr>
			<tr>
				<td class="label">SituationSociale</td>
				<td class="value">
					<xsl:value-of select="SituationSociale"/>
				</td>
			</tr>
			<tr>
				<td class="label">AutreSituationSociale</td>
				<td class="value">
					<xsl:value-of select="AutreSituationSociale"/>
				</td>
			</tr>
			<tr>
				<td class="label">AideRecue</td>
				<td class="value">
					<xsl:value-of select="AideRecue"/>
				</td>
			</tr>
			<tr>
				<td class="label">CMSAide</td>
				<td class="value">
					<xsl:value-of select="CMSAide"/>
				</td>
			</tr>
			<tr>
				<td class="label">PersonneDeReference/Nom</td>
				<td class="value">
					<xsl:value-of select="PersonneDeReference/Nom"/>
				</td>
			</tr>
			<tr>
				<td class="label">PersonneDeReference/NoTelephone</td>
				<td class="value">
					<xsl:value-of select="PersonneDeReference/NoTelephone"/>
				</td>
			</tr>
			<tr>
				<td class="label">AssuranceSociales/Type</td>
				<td class="value">
					<xsl:value-of select="AssuranceSociales/Type"/>
				</td>
			</tr>
			<tr>
				<td class="label">AssuranceSociales/PC</td>
				<td class="value">
					<xsl:value-of select="AssuranceSociales/PC"/>
				</td>
			</tr>
			<tr>
				<td class="label">AssuranceSociales/API</td>
				<td class="value">
					<xsl:value-of select="AssuranceSociales/API"/>
				</td>
			</tr>
			<tr>
				<td class="label">SupplementChambreIndividuelle/Desire</td>
				<td class="value">
					<xsl:value-of select="SupplementChambreIndividuelle/Desire"/>
				</td>
			</tr>
			<tr>
				<td class="label">SupplementChambreIndividuelle/MontantJournalierMaximum</td>
				<td class="value">
					<xsl:value-of select="SupplementChambreIndividuelle/MontantJournalierMaximum"/>
				</td>
			</tr>
			<tr>
				<td class="label">Souhaits</td>
				<td class="value">
					<xsl:value-of select="Souhaits"/>
				</td>
			</tr>
			<tr>
				<td class="label">Commentaire</td>
				<td class="value">
					<xsl:value-of select="Commentaire"/>
				</td>
			</tr>
		</table>
		<xsl:apply-templates select="ProblemesParticuliers"/>
	</xsl:template>
	<xsl:template match="ProblemesParticuliers">
		<h2>Problemes particuliers</h2>
		<table>
			<tr>
				<td class="label">AnxieteInsecurite</td>
				<td class="value">
					<xsl:value-of select="	AnxieteInsecurite"/>
				</td>
			</tr>
			<tr>
				<td class="label">TroublesComportementFugues</td>
				<td class="value">
					<xsl:value-of select="	TroublesComportementFugues"/>
				</td>
			</tr>
			<tr>
				<td class="label">Chutes</td>
				<td class="value">
					<xsl:value-of select="	Chutes"/>
				</td>
			</tr>
			<tr>
				<td class="label">ResistanceMultiplesAntibiotiques</td>
				<td class="value">
					<xsl:value-of select="	ResistanceMultiplesAntibiotiques"/>
				</td>
			</tr>
			<tr>
				<td class="label">Solitude</td>
				<td class="value">
					<xsl:value-of select="	Solitude"/>
				</td>
			</tr>
			<tr>
				<td class="label">Toxicodependances</td>
				<td class="value">
					<xsl:value-of select="	Toxicodependances"/>
				</td>
			</tr>
			<tr>
				<td class="label">Perfusion</td>
				<td class="value">
					<xsl:value-of select="	Perfusion"/>
				</td>
			</tr>
			<tr>
				<td class="label">DomicileInadequat</td>
				<td class="value">
					<xsl:value-of select="	DomicileInadequat"/>
				</td>
			</tr>
			<tr>
				<td class="label">AbsenceEntourage</td>
				<td class="value">
					<xsl:value-of select="	AbsenceEntourage"/>
				</td>
			</tr>
			<tr>
				<td class="label">EpuisementEntourage</td>
				<td class="value">
					<xsl:value-of select="	EpuisementEntourage"/>
				</td>
			</tr>
			<tr>
				<td class="label">ProblemeRespiratoire</td>
				<td class="value">
					<xsl:value-of select="	ProblemeRespiratoire"/>
				</td>
			</tr>
			<tr>
				<td class="label">RefusCMS</td>
				<td class="value">
					<xsl:value-of select="	RefusCMS"/>
				</td>
			</tr>
			<tr>
				<td class="label">Mobilite</td>
				<td class="value">
					<xsl:value-of select="	Mobilite"/>
				</td>
			</tr>
			<tr>
				<td class="label">AutreProbleme</td>
				<td class="value">
					<xsl:value-of select="	AutreProbleme"/>
				</td>
			</tr>
		</table>
	</xsl:template>
	<xsl:template match="DMST">
		<h1>Document Médico-Social de Transmission</h1>
		<xsl:apply-templates/>
	</xsl:template>	
	<xsl:template match="Transmission">
		<h2>Transmission</h2>
		<table>
			<tr>
				<td class="label">DocumentTransmissible</td>
				<td class="value">
					<xsl:value-of select="DocumentTransmissible"/>
				</td>
			</tr>
			<tr>
				<td class="label">Commentaire</td>
				<td class="value">
					<xsl:value-of select="Commentaire"/>
				</td>
			</tr>
		</table>
	</xsl:template>
	<xsl:template match="DonneesAdministratives">
		<h2>DonneesAdministratives</h2>
		<table>
			<tr>
				<td class="label">LieuDeNaissance</td>
				<td class="value">
					<xsl:value-of select="	LieuDeNaissance"/>
				</td>
			</tr>
			<tr>
				<td class="label">EtatCivil</td>
				<td class="value">
					<xsl:value-of select="	EtatCivil"/>
				</td>
			</tr>
			<tr>
				<td class="label">Confession</td>
				<td class="value">
					<xsl:value-of select="	Confession"/>
				</td>
			</tr>
			<tr>
				<td class="label">Origine</td>
				<td class="value">
					<xsl:value-of select="	Origine"/>
				</td>
			</tr>
			<tr>
				<td class="label">Nationalité</td>
				<td class="value">
					<xsl:value-of select="	Nationalite"/>
				</td>
			</tr>
			<tr>
				<td class="label">FiliationMaternelle</td>
				<td class="value">
					<xsl:value-of select="	FiliationMaternelle"/>
				</td>
			</tr>
			<tr>
				<td class="label">FiliationPaternelle</td>
				<td class="value">
					<xsl:value-of select="	FiliationPaternelle"/>
				</td>
			</tr>
			<tr>
				<td class="label">Profession</td>
				<td class="value">
					<xsl:value-of select="	Profession"/>
				</td>
			</tr>
			<tr>
				<td class="label">Conjoint</td>
				<td class="value">
					<xsl:value-of select="	Conjoint"/>
				</td>
			</tr>
			<tr>
				<td class="label">NoTelephoneUrgence</td>
				<td class="value">
					<xsl:value-of select="	NoTelephoneUrgence"/>
				</td>
			</tr>
			<tr>
				<td class="label">DateEntree</td>
				<td class="value">
					<xsl:value-of select="DateEntree"/>
				</td>
			</tr>
			<tr>
				<td class="label">DateSortie</td>
				<td class="value">
					<xsl:value-of select="DateSortie"/>
				</td>
			</tr>
			<tr>
				<td class="label">MedecinTraitant</td>
				<td class="value">
					<xsl:apply-templates select="MedecinTraitant"/>
				</td>
			</tr>
			<tr>
				<td class="label">MedecinHopital</td>
				<td class="value">
					<xsl:apply-templates select="MedecinHopital"/>
				</td>
			</tr>
			<tr>
				<td class="label">Assurance</td>
				<td class="value">
					<xsl:value-of select="Assurance/Nom"/>
				</td>
			</tr>
			<tr>
				<td class="label">No assuré</td>
				<td class="value">
					<xsl:value-of select="Assurance/NoAssure"/>
				</td>
			</tr>
		</table>
	</xsl:template>
	<xsl:template match="FamilleEntourage">
		<h2>FamilleEntourage</h2>
		<table>
			<tr>
				<td class="label">PersonneDeReference</td>
				<td class="value">
					<xsl:apply-templates select="PersonneDeReference"/>
				</td>
			</tr>
			<tr>
				<td class="label">PersonneVivantAvec</td>
				<td class="value">
					<xsl:apply-templates select="PersonneVivantAvec"/>
				</td>
			</tr>
			<tr>
				<td class="label">TuteurCurateur</td>
				<td class="value">
					<xsl:apply-templates select="TuteurCurateur"/>
				</td>
			</tr>
		</table>
	</xsl:template>
	<xsl:template match="Habitat">
		<h2>Habitat</h2>
		<table>
			<tr>
				<td class="label">Habitat</td>
				<td class="value">
					<xsl:value-of select="."/>
				</td>
			</tr>
		</table>
	</xsl:template>
	<xsl:template match="ContexteHabitudesDeVie">
		<h2>ContexteHabitudesDeVie</h2>
		<table>
			<tr>
				<td class="label">ContexteHabitudesDeVie</td>
				<td class="value">
					<xsl:value-of select="."/>
				</td>
			</tr>
		</table>
	</xsl:template>
	<xsl:template match="Intervenants">
		<h2>Intervenants</h2>
		<table>
			<tr>
				<td class="label">Intervenants</td>
				<td class="value">
					<xsl:apply-templates/>
				</td>
			</tr>
		</table>
	</xsl:template>
	<xsl:template match="MedecinTraitant|MedecinHopital|MedecinEnvoyeur|PersonneDeReference|PersonneVivantAvec|TuteurCurateur|Intervenant|MedecinPrescripteur|EffectuePar">
		<xsl:value-of select="Nom"/>
		<xsl:text>, </xsl:text>
		<xsl:value-of select="NoTelephone"/>
		<xsl:text>, </xsl:text>
		<xsl:value-of select="Commentaire"/>
		<br/>
	</xsl:template>
	<xsl:template match="NiveauAutonomie">
		<h2>Niveau d'autonomie</h2>
		<table>
			<tbody>
				<xsl:for-each select="*">
					<tr>
						<th class="h3"><xsl:value-of select="name(.)"/></th>
					</tr>
					<xsl:for-each select="*">
						<tr>
						  <td class="label"><xsl:value-of select="name(.)"/></td>
						  <td class="value"><xsl:value-of select="text()"/></td>
						</tr>
					</xsl:for-each>
				</xsl:for-each>
			</tbody>
		</table>
	</xsl:template>
	<xsl:template match="BilanDeSante">
		<h2>BilanDeSante</h2>
		<table>
			<tr>
				<td class="label">BilanDeSante</td>
				<td class="value">
					<xsl:value-of select="."/>
				</td>
			</tr>
		</table>
	</xsl:template>
	<xsl:template match="PriseEnChargeLorsTransfert">
		<h2>PriseEnChargeLorsTransfert</h2>
		<table>
			<tr>
				<td class="label">DateTransfert</td>
				<td class="value">
					<xsl:value-of select="DateTransfert"/>
				</td>
			</tr>
			<tr>
				<td class="label">Motif</td>
				<td class="value">
					<xsl:value-of select="Motif"/>
				</td>
			</tr>
			<tr>
				<td class="label">TraitementsEnCours</td>
				<td class="value">
					<xsl:value-of select="TraitementsEnCours"/>
				</td>
			</tr>
			<tr>
				<td class="label">Medicaments</td>
				<td class="value">
					<xsl:apply-templates select="Medicaments"/>
				</td>
			</tr>
			<tr>
				<td class="label">Accessoires</td>
				<td class="value">
					<xsl:value-of select="Accessoires"/>
				</td>
			</tr>
			<tr>
				<td class="label">EffectuePar</td>
				<td class="value">
					<xsl:apply-templates select="EffectuePar"/>
				</td>
			</tr>
		</table>
	</xsl:template>
	<xsl:template match="Medicament">
		<xsl:value-of select="Nom"/>
		<xsl:text>:  </xsl:text>
		<xsl:if test="string-length(Prise/Matin)">
			Matin: <xsl:value-of select="Prise/Matin"/>
		</xsl:if>
		<xsl:if test="string-length(Prise/Midi)">
			Midi: <xsl:value-of select="Prise/Midi"/>
		</xsl:if>
		<xsl:if test="string-length(Prise/Soir)">
			Soir: <xsl:value-of select="Prise/Soir"/>
		</xsl:if>
		<xsl:if test="string-length(Prise/Nuit)">
			Nuit: <xsl:value-of select="Prise/Nuit"/>
		</xsl:if>
		<xsl:if test="string-length(Prise/Autres)>0">
			Autres: <xsl:value-of select="Prise/Autres"/>
		</xsl:if>
		<br/>
	</xsl:template>
</xsl:stylesheet>
