<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
define("SEC_PAR_JOUR", 86400);
/**
* Objet "Jour", utilisable dans une grille
*
* L'objet jour peut tre utilis comme proprit d'un objet grilleOccupation.
* Il contient un certain nombre de proprits ayant trait d'une part aux particularits du calendrier
* (par exemple jours fris),
* $premierJour = new CJour(date("Y", $deb), date("m", $deb), date("d", $deb));
* if $premierJour->isFerie();
* print "C'est un jour fri !";
* @author ob
*
*/
class CJourCab {
  /**
  * l'anne (4 chiffres)
  * @var int
  */
  var $annee;
  /**
  * le mois (1-12)
  * @var int
  */
  var $mois;
  /**
  * le quantieme (1-31)
  * @var int
  */
  var $jour;
  /**
  * le timestamp correspondant au jour reprsent
  * @var int
  */
  var $tst;
  /**
  * la couleur de fond (lorsque reprsent dans un planning
  * @var string
  */

  function __construct($annee, $mois, $jour){
    $this->tst = mktime(0, 0, 0, $mois, $jour, $annee);
    $this->annee = date("Y", $this->tst);
    $this->mois = date("m", $this->tst);
    $this->jour = date("d", $this->tst);
  }

  /**
  * Le jour de la semaine correspondant au jour reprsent (0 pour dimanche)
  * @access public
  * @return int
  */
  function jourSem(){
    $madate = getdate(mktime(0, 0, 0, $this->mois, $this->jour, $this->annee));
    return $madate['wday'];
  }
  

  /**
  * Le jour est-il fri ?
  * @access public
  * @return boolean
  */
  function isFerie(){
    $ferie = false;
    if ($this->mois == 1 && ($this->jour == 1 || $this->jour == 2)) $ferie = true; //Nouvel-an et 2 janv.
    $paques = easter_date($this->annee);
    if ($this->tst == $paques) $ferie = true; //Paques
    if ($this->tst == strtotime(date("Y-m-d", $paques + SEC_PAR_JOUR))) $ferie = true; //Lundi de Paques;
    if ($this->tst == strtotime(date("Y-m-d", $paques + SEC_PAR_JOUR * 39))) $ferie = true; //Ascension
    if ($this->tst == strtotime(date("Y-m-d", $paques + SEC_PAR_JOUR * 50))) $ferie = true; //Lundi de pentecte
    if ($this->tst == strtotime(date("Y-m-d", $paques - SEC_PAR_JOUR * 2))) $ferie = true; //Lundi de pentecte
    if ($this->mois == 8 && $this->jour == 1) $ferie = true; //1er Aot
    if ($this->mois == 9) {
      for ($i = 1; $i < 8; $i++) {
        $md = date_create($this->annee . "-09-" . $i);
        if (date_format($md, "D") == "Sun"){
          $dimanche = $i;
          break;
        }
      }
      $dimanche = $dimanche + 14;
      if ($this->jour == $dimanche + 1) $ferie = true;
    }
    if ($this->mois == 12 && ($this->jour == 25 || $this->jour == 26)) $ferie = true;
    return $ferie;
  }
  /**
  * Renvoie le nom du mois correspondant au jour reprsent (texte)
  * @access public
  * @return boolean
  */
  function monMois(){
    return $this->texteMois($this->mois);
  }

  /**
  * Ajoute $n jours au jour d'aujourd'hui
  * @access public
  * @return boolean
  */
  function ajouteJours($nb){
    self::__construct($this->annee, $this->mois, ($this->jour + $nb));
  }

  /**
  * Renvoie le nom du mois  partir de son numro de 1 - 12
  * @param int mois le numro du mois
  * @access public
  * @static
  * @return string
  */
  function texteMois($mois){
    switch ($mois){
    case 1:
      return "janvier";
      break;
    case 2:
      return "fvrier";
      break;
    case 3:
      return "mars";
      break;
    case 4:
      return "avril";
      break;
    case 5:
      return "mai";
      break;
    case 6:
      return "juin";
      break;
    case 7:
      return "juillet";
      break;
    case 8:
      return "aot";
      break;
    case 9:
      return "septembre";
      break;
    case 10:
      return "octobre";
      break;
    case 11:
      return "novembre";
      break;
    case 12:
      return "dcembre";
      break;
    default:
      return false;
    }
  }
}


?>
