<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
///////////////////////////////////////////
//
//  Ajout de prestations isoles
//
//////////////////////////////////////////

class ajoutPrestations extends cadronglet{
  var $idsession;
  var $options;
  var $action;
  var $ifact;
  var $tarif;

  #Constructeur
  function __construct($largeur, $grise, $actif, $fondpage, $sessionid, $itfact,
                            $options = 0, $donnees){
    global $fdosbrioche;
    global $imagesdir;
    if (! parent::__construct($largeur, $grise, $actif, $fondpage, $sessionid)) return; //appel du constsructeur de l'objet parent (avec vrif)
    $this->action = $actif;
    $this->options = new optionsBriocheCab($options);
    $this->itfact = $itfact;
    $this->tarif = $this->options->getOption("TARIF");
    $mode = 0;
    //print "T: $this->tarif <br>";
    if (! isset($donnees['position'])) $donnees['position'] = 0;
    $mafact = new ensDetailFacture($this->itfact, $this->idsession);
    $monpat = new ensFacturePat($mafact->nopat, $this->idsession);
    if ($donnees['position']){ //Ajout de la prestation
      $ut = new updateTableBrioche("prestations", $donnees, "", "", $this->idsession);
      $suite = true;
      if (! $ut->controlePresence("nombre", "Nombre")) $suite = false;
      if (! $ut->controlePresence("dateprest", "dateprest")) $suite = false;
      if ($suite){
        $datheure = $mafact->getDateHeure($donnees['dateprest'], "");
        
        if (! $mafact->addPrestation($donnees['nombre'], $donnees['position'],
           $datheure, $this->tarif)){
           $al = new Alerte("Un problme est survenu lors de l\'enregistrement");
           $al->imprime();
        }
        else {
          $donnees['position'] = 0;
          $donnees['nombre'] = 1;
          $ff = new fermeFenetre(1, 0);
        }
        
      }
    }
    if (! isset($donnees['nombre'])) $donnees['nombre'] = 1;
    if (! isset($donnees['dateprest'])) $donnees['dateprest'] = $this->getDateFr(ensDetailFacture::getCookieDate());
    if (! ($donnees['dateprest'])) $donnees['dateprest'] = $this->aujourdhui();
    $classe = $monpat->getClasse($donnees['dateprest']);
    switch ($this->tarif){ // pour ajax
    case 5: //tarmed
      $mode = 2;
      break;
    case 6: //tarmed nouveau
      $mode = 50 + $classe;
      break;
    case 4: //Liste analyses
      $mode = 3;
      break;
    case 9: //presations sur mesure   
      $mode = 4;
      break;
    }
    
    $tabbande = array("", "", "", "", "");
    $this->addOnglet("Ajout prestation", $tabbande, "#8b8378", $this->action, 120, "");
    $this->colmateOnglets();
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fdosbrioche, "post");
    if ($this->tarif == 5 || $this->tarif == 6) $gauche = 2;
    else $gauche = 4;
    $droite = 6 - $gauche;
    $gri = 0;
    if ($this->tarif == 5 || $this->tarif == 6) $gri = $this->tarif;
    $of->addLigne(0.5);
    if ($this->tarif < 9){ // Tarmed ou liste des analyses;
      
      $monTarif = "tarif = $this->tarif ";
      // Patch tarif 50 SUVA
      if ($this->tarif == 4) $monTarif = "tarif IN(4, 50, 51) ";
      //
      
      $tab = new ensTableBrioche("tarif", "$monTarif and masquer = 0 and classe IN (0,$classe" . ($classe == 1 ? ",3" : "") .")",
                               "position, " .
                               "CONCAT(
                                 IF (tarif <> 51,
                                   CONCAT(
                                     LEFT(LPAD(position, 6, \"0\"),$gauche), \".\", RIGHT(LPAD(position, 6, \"0\"),$droite)
                                   ),
                                   CONCAT(
                                     MID(position, 3, 4),
                                     \".\",
                                     MID(position, 7, 2)
                                   )
                                 ),
                                 \" -  \", texte
                               ) AS tprest",
                               "tarif,position", $this->idsession);
      $c = new GrTBoutonTexte($this->tarif, 6, 100, 12, "#aaaaaa", "#efefef", 2);
      $futopt = new optionsBriocheCab($this->options->getChaine());
      
      $futopt->setOption("TARIF", $mafact->getTarmed());
      $c->addBouton("Tarmed",
                    "javascript:dd=document.forms.donnees.elements['donnees[dateprest]'].value;" .
                    "window.location='$fdosbrioche?action=$this->action&sessionid=$this->idsession" .
                    "&itfact=$this->itfact&options=" . $futopt->getChaine() . 
                    "&donnees[dateprest]=' + dd;",
                    $gri);
      $futopt->setOption("TARIF", 4);
      $c->addBouton("Labo", 
                    "javascript:dd=document.forms.donnees.elements['donnees[dateprest]'].value;" .
                    "window.location='$fdosbrioche?action=$this->action&sessionid=$this->idsession" .
                    "&itfact=$this->itfact&options=" . $futopt->getChaine() . 
                    "&donnees[dateprest]=' + dd;",
                    4);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
    }
    else { // prestations sur mesure
      $tab = new ensTableBrioche("prestsurmes", "1",
                                 "concat(codepers, \" - \", libelle, \" (Fr. \", prix, \")\") AS tprest, idprest AS position",
                                 "codepers, libelle", $this->idsession); 
    }
    $c = new TPanel(6);
    $x = new ChampTexte("donnees[dateprest]", $donnees['dateprest'], "Date : ", 12, 15, false,
                        "TEXT", "d2", "controleDate('donnees[dateprest]', '" .
                        $this->aujourdhui() . "', '250', '30')" );
    $c->addChamp($x);
    $x = new Espace(3);
    $c->addChamp($x);
    $x = new ChampTexte("donnees[nombre]", $donnees['nombre'], "Nombre : ", 3, 2, false,
                        "TEXT", "d2");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    $c = new TPanel(5);
    $x = new ListOptTable("donnees[position]", $donnees['position'], $tab, false, 0, "d2", "", false, false, "donnees[position]");
    $x->addDefaut("Choix de la position", 0);
    $x->addOptions("tprest", "position");
    $c->addChamp($x);
    $of->addChamp($c);
    $c = new TPanel(1);
    $x = new BoutonImage("Slectionner", "$imagesdir/vu.gif", 18, 16,
                         "javascript:document.forms.donnees.submit()");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne();
    $of->addLigne(0.5);
    $c = new TPanel(6);
    $x = new Label("Recherche de position :");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    $c = new TPanel(5);
    $x = new ChampTexte("donnees[textpos]", "", "", 46, 64, false, "text", "d2");
    $c->addChamp($x);
    $of->addChamp($c);
    $c = new TPanel(1);
    $x = new BoutonImage("bouton_select", "$imagesdir/vu.gif", 18, 16,
                         "javascript:actionBouton()");
    $c->addChamp($x);
    $x = new Bouton("noind", "", "HIDDEN", "", "", "noind");
    $c->addChamp($x);
    $x = new Label("<script type=\"text/javascript\">
          window.onload = function(){initAutoComplete(document.forms.donnees,
          document.getElementById('donnees[textpos]'),document.getElementById('bouton_select'),document.getElementById('noind'),$mode,\"\", \"\", \"$this->idsession\", \"\");};
        </script>");
    $c->addChamp($x); 
    $of->setFocus("donnees[textpos]");
    $of->addChamp($c);
    $of->addLigne();
    $of->addLigne(0.5);
    $c = new TPanel(6, 1, "RIGHT");
    $x = new Espace(2);
    $c->addChamp($x);
    $x = new Bouton("itfact", $this->itfact, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x =new Bouton("options", $this->options->getChaine(), "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("action", $this->action, "HIDDEN");
    $c->addChamp($x);
    $of->addChamp($c);
    $this->addContenu($of->getContenu());
    $tf = new TabForm();
    $tf->setTabParam(300, 0, 3, 0, "#2784be");
    $c = new TPanel(3);
    $x = new Espace(1);
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TPanel(3, 1, "RIGHT");
    $x = new Bouton("Fermer", "Fermer", "BUTTON", "window.close()");
    $c->addChamp($x);
    $tf->addChamp($c);
    $this->addContenu($tf->getContenu());
  }









}


?>
