<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
//////////////
//
//  Ce script de rcuperer dans la table sic_clearing de la bd cabinet
//  la dernire version du fichier des n de clearing.
//  Puis la table ep_clearing, utilise par BriochePaye, est mise  jour.
//
/////////////


require("briocheIni.inc");      //utilise les fichiers de config. qui se trouvent dans le rpertoire    courant
require("hermesIni.inc");

$ini = new briocheIni();

require("$ini->classDir/session.inc");
require("$ini->classDir/sessionDBrioche.inc");
require("$ini->classDir/connexionBrioche.inc");

$sess = new Session(0, $ini->utilScripts, $ini->passeScripts);
$idsession = $sess->idsession;

if (! $idsession) die ("Impossible d'obtenir une session");
$con = new connexionBrioche($idsession);
$linkBrioche = $con->linkBrioche;
//Rcupration du fichier sur le web
$nomfich = $ini->urlClearing;
$cont = file_get_contents($nomfich);
$long = strlen($cont);
if ($long < 100000) {
  print "Fichier clearing trop petit... Abandon.\n";
  return;
}
//Ecriture du fichier dans le rpertoire de tlchargement
$fprov = fopen("$ini->fichDir/clearing.zip", 'w');
fwrite($fprov, $cont);
fclose($fprov);
//Lecture de l'archive zip tlcharge
$zip = zip_open("$ini->fichDir/clearing.zip");

if (! $zip) {
  print "Impossible d'ouvrir le fichier .zip... Abandon.\n";
  return;
}

$fzip = zip_read($zip);
zip_entry_open($zip, $fzip, 'r');
$cvs = zip_entry_read($fzip, zip_entry_filesize($fzip));
$cvs = preg_replace("/\"/", "\\\"", $cvs);
zip_entry_close($fzip);
zip_close($zip);
$cvstab = explode("\r\n", $cvs);
$cpt = count($cvstab);
//Destrution des enregistrements de la table sic_clearing
$req = "delete from sic_clearing";
$result = mysqli_query($linkBrioche, $req);
//Ecriture des lignes du fichier extrait dans sic_clearing
for ($i = 0; $i < $cpt; $i++) {
  $ligne = $cvstab[$i];
  if (strlen($ligne) == 298){ 
    $groupe = trim(substr($ligne, 0, 2));
    $noclearing = trim(substr($ligne, 2, 5));
    $idsuc = trim(substr($ligne, 7, 4));
    $nouvclearing = trim(substr($ligne, 11, 5));
    if (! $nouvclearing) $nouvclearing = "0";
    $nosic = trim(substr($ligne, 16, 6));
    $siege = trim(substr($ligne, 22, 5));
    $genrecb = trim(substr($ligne, 27, 1));
    $valable = trim(substr($ligne, 28, 8));
    $sic = trim(substr($ligne, 36, 1));
    $eurosic = trim(substr($ligne, 37, 1));
    $langue = trim(substr($ligne, 38, 1));
    $nomabr = trim(substr($ligne, 39, 15));
    $banque = trim(substr($ligne, 54, 60));
    $domicile = trim(substr($ligne, 114, 35));
    $adresse = trim(substr($ligne, 149, 35));
    $npa = trim(substr($ligne, 184, 10));
    $ville = trim(substr($ligne, 194, 35));
    $tel = trim(substr($ligne, 229, 18));
    $fax = trim(substr($ligne, 247, 18));
    $indicatif = trim(substr($ligne, 265, 5));
    $pays = trim(substr($ligne, 270, 2));
    $ccp = trim(substr($ligne, 272, 12));
    $swift = trim(substr($ligne, 284, 14));
    $req = "INSERT INTO sic_clearing SET groupe = $groupe, noclearing = $noclearing, " .
           "idsuc = $idsuc, nouvclearing = $nouvclearing, nosic = $nosic, siege = $siege, " .
           "genrecb = $genrecb, valable = \"$valable\", sic = $sic, eurosic = $eurosic, " .
           "langue = $langue, nomabr = \"$nomabr\", banque = \"$banque\", " .
           "domicile = \"$domicile\", adresse = \"$adresse\", npa = \"$npa\", " .
           "ville = \"$ville\", tel = \"$tel\", fax = \"$fax\", " .
           "indicatif = \"$indicatif\", pays = \"$pays\", ccp = \"$ccp\", " .
           "swift = \"$swift\", controle = ($noclearing * 10000 + $idsuc)";
    $result = mysqli_query($linkBrioche, $req);
    if (mysqli_error($linkBrioche)) print $i . " - " .
      $req . " : " . mysqli_error($linkBrioche) . "\n";       
  }
}

//Dtection d'ventuels nouveaux enregistrements dans sic_clearing et copie dans ep_clearing
$req = "select sic_clearing.* from sic_clearing left join ep_clearing " .
       "on sic_clearing.controle = ep_clearing.controle " .
       "where ep_clearing.noclearing is null";
$result = mysqli_query($linkBrioche, $req);
$i = 0;
while ($ligne = mysqli_fetch_array($result)){
  copie($ligne['controle'], 1);
  $i++;
}
print "$i enregistrements ont t ajouts\n";

//Dtection d'ventuels enregistrements supprims dans sic_clearing et masquage dans ep_clearing 
$req = "select ep_clearing.controle from ep_clearing left join sic_clearing " .
       "on ep_clearing.controle = sic_clearing.controle " .
       "where sic_clearing.noclearing is null and ep_clearing.masquer = 0";
$result = mysqli_query($linkBrioche, $req);
$i = 0;
while ($ligne = mysqli_fetch_array($result)){
  $req2 = "update ep_clearing set masquer = -1 where controle = " . 
          $ligne['controle'];
  $result2 = mysqli_query($linkBrioche, $req2);      
  $i++;
}
print "$i enregistrements ont t masqus\n";

//Mise  jour des enregistrement communs
$req = "select ep_clearing.controle from ep_clearing where masquer = 0";
$result = mysqli_query($linkBrioche, $req);
while ($ligne = mysqli_fetch_array($result)){
  copie($ligne['controle'], 0);
  if (mysqli_error($linkBrioche)) print mysqli_error($linkBrioche) . "\n";
}

function copie ($controle, $insert) {
  global $linkBrioche;
  $requete = "select * from sic_clearing where controle = $controle";
  $result = mysqli_query($linkBrioche, $requete);
  $ligne = mysqli_fetch_object($result);
  $requete = ($insert ? "INSERT INTO " : "UPDATE ") . "ep_clearing SET " .
              "groupe = $ligne->groupe, noclearing = $ligne->noclearing, " .
              "idsuc = $ligne->idsuc, nouvclearing = " . 
              ($ligne->nouvclearing ? $ligne->nouvclearing : "0") . 
              ", nosic = $ligne->nosic, siege = $ligne->siege, " .
              "genrecb = $ligne->genrecb, valable = \"$ligne->valable\", " .
              "sic = $ligne->sic, eurosic = $ligne->eurosic, " .
              "langue = $ligne->langue, nomabr = \"$ligne->nomabr\", " .
              "banque = \"$ligne->banque\", " .
              "domicile = \"$ligne->domicile\", adresse = \"$ligne->adresse\", " .
              "npa = \"$ligne->npa\", " .
              "ville = \"$ligne->ville\", tel = \"$ligne->tel\", fax = \"$ligne->fax\", " .
              "indicatif = \"$ligne->indicatif\", pays = \"$ligne->pays\", " .
              "ccp = \"$ligne->ccp\", " .
              "swift = \"$ligne->swift\"" .
              ($insert ? ", controle = ($ligne->noclearing * 10000 + $ligne->idsuc)" :
               " where controle = $controle");
  //print $requete;
  return $result = mysqli_query($linkBrioche, $requete);

}

?>
