<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

////////
//
// Encapsule les donnes d'un dossier BriochePaye
//
////////

class enrBriochePaye extends connexionBrioche {
  var $item;
  #Constructeur
  function __construct($item, $sessionid){
    if (! parent::__construct($sessionid)) return;
    $this->item = $item;
  }


  #Rcupration des enregistrements par table en fonction du numro de dossier
  function getEnr($table, $recup=0){
    if ($this->n_erreur) return;
    $ini = new briocheIni();
    if ($recup){
      $ligne = $this->faitRecup($recup, $table);
    }
    else {
      if ($table == "ep_archives"){
        $requete = "SELECT * FROM ep_archives WHERE id = $this->item AND tst > \"" . $ini->tstorig . "\"";
      }
      elseif ($table == "ep_destpri"){
        $requete = "SELECT ep_destpri.* FROM ep_archives LEFT JOIN ep_destpri ON ep_archives.comptedest = " .
                   "ep_destpri.nocompte WHERE ep_archives.id = $this->item AND " .
                   "ep_archives.tst > \"" . $ini->tstorig . "\"";
      }
      //elseif ($table == "prestations") $cle = "noprest";
      
      
      $result = mysqli_query($this->linkBrioche, $requete);
      if (! $result) return false;
      $ligne = mysqli_fetch_object($result);
      //Conversion des champs date
      if ($ligne){
        while ($flds = mysqli_fetch_field($result)){
          $fn = $flds->name;
          if ($flds->type == 10){ // date (10)
            $ligne->$fn = $this->getDateFr($ligne->$fn);
          }
          $ligne->$fn = $this->metEnFormeSel($ligne->$fn);
        }
      }
    }
    return $ligne;
  }
  
  //Dcalage de la date de paiement en cas de jour fri
  function controleDatePay($date, $alerte){
    $tabdate = explode(".", $date);
    $cj = new CJourCab($tabdate[2], $tabdate[1], $tabdate[0]);
    $chgt = 0;
    while ($cj->isFerie() || $cj->jourSem() == 0 || $cj->jourSem() == 6){
      $chgt = 1;
      $cj->ajouteJours(1);
    }
    if ($chgt) {
      $al = new Alerte($alerte);
      $al->imprime();
    }
    return "$cj->jour.$cj->mois.$cj->annee";
  }
  
  #Maj des tables secondaires en fonction des donnes de ep_archives
  function majTable($nomtable){
    $enr = $this->getEnr("ep_archives");
    switch ($nomtable){
    case "ep_destpri":
      $ens = new ensTableBrioche("ep_destpri", "nocompte = \"$enr->comptedest\"", "*", 0, $this->idsession);
      $tens = $ens->getTableau();
      $id = 0;
      if (count($tens)){
        $id = $tens[0]->id;
      }
      $tabchamps['nocompte'] = $enr->comptedest;
      $tabchamps['adresse'] = $enr->priadr;
      $tabchamps['npa'] = $enr->prinpa;
      $tabchamps['ville'] = $enr->priville;
      $ut = new updateTableBrioche($nomtable, $tabchamps, $id, "id", $this->idsession);
      if ($id){
        $ut->update();
      }
      else {
        $ut->ajouteEnr();
      }  
      break;
    case "ep_destsec":
      if ($enr->secadr){
        $ens = new ensTableBrioche("ep_destsec", 
                                   "CONCAT(nocompte, adresse, npa) = \"$enr->comptedest$enr->secadr$enr->secnpa\"",
                                   "*", 0, $this->idsession);
        $tens = $ens->getTableau();
        $id = 0;
        if (count($tens)){
          $id = $tens[0]->id;
        }                           
        $tabchamps['nocompte'] = $enr->comptedest;
        $tabchamps['adresse'] = $enr->secadr;
        $tabchamps['npa'] = $enr->secnpa;
        $tabchamps['ville'] = $enr->secville;
        $ut = new updateTableBrioche($nomtable, $tabchamps, $id, "id", $this->idsession);
        if ($id){
          $ut->update();
        }
        else {
          $ut->ajouteEnr();
        }
      }
      break;    
    case "ep_ccp":
      $ens = new ensTableBrioche("ep_ccp", "nocompte = \"$enr->comptedest\"", "*", 0, $this->idsession);
      $tens = $ens->getTableau();
      $id = 0;
      if (count($tens)){
        $id = $tens[0]->id;
      }
      $tabchamps['nocompte'] = $enr->comptedest;
      $tabchamps['adresse'] = $enr->priadr;
      $tabchamps['npa'] = $enr->prinpa;
      $tabchamps['ville'] = $enr->priville;
      $tabchamps['clearing'] = $enr->clearingbanque;
      $ut = new updateTableBrioche($nomtable, $tabchamps, $id, "id", $this->idsession);
      if ($id){
        $ut->update();
      }
      else {
        $ut->ajouteEnr();
      }  
      break;
    case "ep_cptbanques":
    case "ep_cptbanquesB":  
      if ($enr->secadr){
        if ($nomtable == "ep_cptbanques"){
          $where = "CONCAT(ccpbanque, nocompte) = \"$enr->comptedest$enr->cptbanque\"";
        }
        elseif ($nomtable == "ep_cptbanquesB"){
          $where = "CONCAT(clearing, nocompte) = \"$enr->clearingbanque$enr->cptbanque\"";
        }
        $ens = new ensTableBrioche("ep_cptbanques", 
                                   $where,
                                   "*", 0, $this->idsession);
        
        $tens = $ens->getTableau();
        $id = 0;
        if (count($tens)){
          $id = $tens[0]->id;
        }                           
        $tabchamps['nocompte'] = $enr->cptbanque;
        $tabchamps['clearing'] = $enr->clearingbanque;
        $tabchamps['adresse'] = $enr->secadr;
        $tabchamps['npa'] = $enr->secnpa;
        $tabchamps['ville'] = $enr->secville;
        $tabchamps['ccpbanque'] = $enr->comptedest;
        $ut = new updateTableBrioche("ep_cptbanques", $tabchamps, $id, "id", $this->idsession);
        if ($id){
          $ut->update();
        }
        else {
          $ut->ajouteEnr();
        }
      }
      break;  
    }
  }
  
  #Cration d'un nouvel enregistrement
  function creeNouveau($table, $fact=""){
    if ($this->n_erreur) return;
    $dg = md5(time() . $this->idsession . $fact);
    $requete = "INSERT INTO $table SET dmd5 = \"$dg\", tst = 0";
    $result = mysqli_query($this->linkBrioche, $requete);
    if ($table == "ep_archives") $cle = "id";
    $requete = "SELECT $cle FROM $table WHERE dmd5 = \"$dg\"";
    $result = mysqli_query($this->linkBrioche, $requete);
    $lignes = mysqli_fetch_row($result);
    $nd = $lignes[0];
    return $nd;
  }

  //Dfinit le type de bulletin
  function setType($lettre){
    $requete = "UPDATE ep_archives SET typepay = \"$lettre\", tst = tst WHERE id = $this->item";
    return $result = mysqli_query($this->linkBrioche, $requete);
  }
  
  //Renvoie le type de bulletin
  function getType($mode){
    $requete = "SELECT typepay FROM ep_archives where id = $this->item";
    $result = mysqli_query($this->linkBrioche, $requete);
    $ligne = mysqli_fetch_row($result);
    $lettre = $ligne[0];
    switch ($mode) {
    case 1:
      if ($lettre == 'B') return 'BVR';
      elseif ($lettre == 'G' || $lettre == 'R'){
        return 'BV rose';
      }
      elseif ($lettre == 'K'){
        return 'B. bancaire';
      }
      break;
    } 
  }
  
  //Contrle N compte
  function controleNoCCP($num, $alerte){
    if (preg_match("/^[0-9]{5}$/", $num)){ //5 positions BVR
      $base = substr($num, 0, 4);
      $contr = substr($num, 4, 1);
      $contr2 = $this->getNoControle($base);
      if ($contr != $contr2){
        $al = new Alerte($alerte);
        $al->imprime();
        return false;
      }
      return $num; 
    }
    elseif (preg_match("/^01-\d{4,6}-\d$/", $num)){ //9 positions BVR
      $tabl = explode("-", $num);
      $chaine = $tabl[0] . str_pad($tabl[1], 6, "0", STR_PAD_LEFT);
      $chaine2 = $tabl[0] . "-" . str_pad($tabl[1], 6, "0", STR_PAD_LEFT);
      $contr = $tabl[2];
      $contr2 = $this->getNoControle($chaine);
      if ($contr != $contr2){
        $al = new Alerte($alerte);
        $al->imprime();
        return false;
      }
      return "$chaine2-$contr";
    }
    elseif (preg_match("/^\d{2}-\d{1,6}\-\d$/", $num)){
      $tabl = explode("-", $num);
      $chaine = $tabl[0] . str_pad($tabl[1], 6, "0", STR_PAD_LEFT);
      $chaine2 =  $tabl[0] . "-" . str_pad($tabl[1], 6, "0", STR_PAD_LEFT);
      $contr = $tabl[2];
      $contr2 = $this->getNoControle($chaine);
      if ($contr != $contr2){
        $al = new Alerte($alerte);
        $al->imprime();
        return false;
      }
      return "$chaine2-$contr";
    }
    else{
      $al = new Alerte($alerte);
      $al->imprime();
      return false; 
    }
  }
 
 
 
 //Test modulo 10 rcursif
 //Numro de contrle BVR
  function getNoControle($noatraiter){
    $report = 0;
    $cpt = strlen($noatraiter);
    for($i = 0; $i < $cpt; $i++){

      $report = substr($this->lignereport($report), substr($noatraiter, $i, 1), 1);
      //print "<BR>I : $i - CH : " . substr($noatraiter, $i, 1) . " - R : $report<BR>";
    }
    return (10 - $report) % 10;
  }

  //Ligne de report pour calcul BVR
  function ligneReport($report){
    $etalon = ('09468271350946827135');
    $lignereport = substr($etalon, $report, 10);
    return $lignereport;
  }
 
  //Contrle et formate le montant
  function controleMontant($montant, $alerte){
    $montant = preg_replace("/,/", ".", $montant);
    if (! preg_match("/\./", $montant)) $montant .= '.00';
    if (! preg_match("/^\d{1,6}\.\d{2}$/", $montant)){
      $al = new Alerte($alerte);
      $al->imprime();
      return false;
    }
    return $montant;
  }
  
  function espaceNoRef($numref){
    $numref = preg_replace("/[^0-9]/", "", $numref);
    if (strlen($numref) == 15){
      $ret = substr($numref, 0, 5) . " " . substr($numref, 5, 5) . " " . substr($numref, 10, 5);
      return $ret;
    }
    elseif (strlen($numref) == 16){
      $ret = substr($numref, 0, 1) . " " . substr($numref, 1, 5) . " " . substr($numref, 6, 5) . " " .
             substr($numref, 11, 5);
      return $ret;
    }
    elseif (strlen($numref) == 27){
      $ret = substr($numref, 0, 2) . " " . substr($numref, 2, 5) . " " .substr($numref, 7, 5) . " " .
             substr($numref, 12, 5) . " " . substr($numref, 17, 5) . " " . substr($numref, 22, 5);
      return $ret;
    }
    else return false;
  }
  
  //Contrle et formate les numros de rfrence
  function controleNoRef($numref, $nocompte, $alerte){
    $numref = preg_replace("/[^0-9]/", "", $numref);
    if (strlen($numref) == 15 && strlen($nocompte) == 5) { //5 positions
      return $numref;  
    }  
    elseif (strlen($nocompte) == 11 && (strlen($numref) == 16 || strlen($numref) == 27)){
      $base = substr($numref, 0, -1);
      $contr = substr($numref, -1);
      $contr2 = $this->getNoControle($base);
      if ($contr == $contr2){
        return $numref;
      }
    }
    $al = new Alerte($alerte);
    $al->imprime();
    return false;
  } 
/*
  #Dtruit le dossier courant
  function detruit(){
    if ($this->n_erreur) return;
    $requete = "DELETE FROM dossiers WHERE dossiers.nodoss = $this->item";
    $result = mysql_query($requete);
    return $result;
  }
  */
}

?>
