<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

//////////////////////////////////////////////////////////////////
//
//  Cration fichier dta et passage d'criture  partir nouveaux paiements
//
////////////////////////////////////////////////////////////////

class genDTA extends connexionBrioche {
  var $ea;
  var $contenu;
  var $total;

  function __construct($sessionid){
    if (! parent::__construct($sessionid)) return false;
    $this->ea = new ensTableBrioche("ep_archives", "quittance = 0 AND TO_DAYS(datepay) - TO_DAYS(NOW()) < 60", "*", 0, $this->idsession);
    $this->total  = $this->ea->somme("montant"); 
    $this->contenu = "";
  }

  function getNbEnr(){
    return $this->ea->compte();
  }
  
  //Production du fichier xml
  function imprimeXml(){
    $ini = new BriocheIni();
    $tabEnr = $this->ea->getTableau();
    $source = new ensTableBrioche("ep_comptessource", "1", "*", 0, $this->idsession);
    $nbEnr = count($tabEnr);
    $xml = new xmlDoc('<?xml version="1.0" encoding="UTF-8"?>', "");
    $Document = new xmlElement("Document");
    $Document->addAttribut("xmlns", 'http://www.six-interbank-clearing.com/de/pain.001.001.03.ch.02.xsd');
    $Document->addAttribut("xmlns:xsi", 'http://www.w3.org/2001/XMLSchema-instance');
    $Document->addAttribut("xsi:schemaLocation", 'http://www.six-interbank-clearing.com/de/pain.001.001.03.ch.02.xsd  pain.001.001.03.ch.02.xsd');
    $CstmrCdtTrfInitn = new xmlElement("CstmrCdtTrfInitn");
    $GrpHdr = new xmlElement("GrpHdr");
    $MsgId = new xmlElement("MsgId");
    $MsgId->addTexte("M-" . md5("OB" . microtime())); 
    $CreDtTm = new xmlElement("CreDtTm");
    //$CreDtTm->addTexte(date("Y-m-d\TG:i:s"));
    $CreDtTm->addTexte(date("c"));
    $NbOfTxs = new xmlElement("NbOfTxs");
    $NbOfTxs->addTexte($nbEnr);
    $CtrlSum = new xmlElement("CtrlSum");
    $CtrlSum->addTexte($this->total);
    $InitgPty = new xmlElement("InitgPty");
    $Nm = new xmlElement("Nm");
    $Nm->addTexte(utf8_encode($ini->raisonSoc));
    $InitgPty->addElement($Nm);
    $CtctDtls = new xmlElement("CtctDtls");
    $Nm = new xmlElement("Nm"); 
    $Nm->addTexte("Radix (BriochePaye)");
    $Othr = new xmlElement("Othr");
    $Othr->addTexte($ini->version);
    $CtctDtls->addElement($Nm);
    $CtctDtls->addElement($Othr);
    $InitgPty->addElement($CtctDtls);
    $GrpHdr->addElement($MsgId);
    $GrpHdr->addElement($CreDtTm);
    $GrpHdr->addElement($NbOfTxs);
    $GrpHdr->addElement($CtrlSum);
    $GrpHdr->addElement($InitgPty);
    $CstmrCdtTrfInitn->addElement($GrpHdr);
    foreach($tabEnr as $ind => $enr){
      //print_r($enr);
      switch($enr->typepay){
        case 'B':
        $typepay = 'B';
        $proprietary = "CH01";
        break;
        case 'K':
        $typepay = 'K';
        $proprietary = "CH03";
        break;
        case 'R':
        if (! $enr->cptbanque){
          $typepay = 'R';
          $proprietary = "CH02";
        }
        else {
          $typepay = 'K';
          $proprietary = "CH03";
        }
        break;
      }
      
      $nobic = $source->lookUp("BIC", "nocompte = \"" . $enr->comptesource . "\"");
      $PmtInf = new xmlElement("PmtInf");
      $PmtInfId = new xmlElement("PmtInfId");
      $PmtInfId->addTexte("P-" . sprintf("%04d", ($ind+1)));
      $PmtMtd = new xmlElement("PmtMtd");
      $PmtMtd->addTexte("TRF");
      $BtchBookg = new xmlElement("BtchBookg");
      $BtchBookg->addTexte("true");
      $ReqdExctnDt = new xmlElement("ReqdExctnDt");
      $ReqdExctnDt->addTexte($this->getDateAm($enr->datepay, false));
      $Dbtr = new xmlElement("Dbtr");
      $Nm = new xmlElement("Nm");
      $Nm->addTexte(utf8_encode($ini->raisonSoc));
      $Dbtr->addElement($Nm);
      $DbtrAcct = new xmlElement("DbtrAcct");
      $Id = new xmlElement("Id");
      $IBAN = new xmlElement("IBAN");
      $IBAN->addTexte(preg_replace("/\s/", "", $enr->comptesource));
      $Id->addElement($IBAN);
      $DbtrAcct->addElement($Id);
      $DbtrAgt = new xmlElement("DbtrAgt");
      $FinInstnId = new xmlElement("FinInstnId");
      $BIC = new xmlElement("BIC");
      $BIC->addTexte($nobic);
      $FinInstnId->addElement($BIC);
      $DbtrAgt->addElement($FinInstnId);
      $CdtTrfTxInf = new xmlElement("CdtTrfTxInf");
      $PmtId = new xmlElement("PmtId");
      $InstrId = new xmlElement("InstrId");
      $InstrId->addTexte("I-" . sprintf("%04d", ($ind+1)));
      $EndToEndId = new xmlElement("EndToEndId");
      $EndToEndId->addTexte("E-" . sprintf("%04d", ($ind+1)));
      $PmtId->addElement($InstrId);
      $PmtId->addElement($EndToEndId);
      $PmtTpInf = new xmlElement("PmtTpInf");
      $LclInstrm = new xmlElement("LclInstrm");
      $Prtry = new xmlElement("Prtry");
      $Prtry->addTexte($proprietary);
      $LclInstrm->addElement($Prtry);
      $PmtTpInf->addElement($LclInstrm);
      $Amt = new xmlElement("Amt");
      $InstdAmt = new xmlElement("InstdAmt");
      $InstdAmt->addAttribut("Ccy", "CHF");
      $InstdAmt->addTexte($enr->montant);
      $Amt->addElement($InstdAmt);
      $CdtTrfTxInf->addElement($PmtId);
      $CdtTrfTxInf->addElement($PmtTpInf);
      $CdtTrfTxInf->addElement($Amt);
      if ($typepay == 'B'){
        $cptd = self::oteZeros($enr->comptedest);
        $nref = (strlen($enr->numref) == 16 ? "00000000000" . $enr->numref : $enr->numref);
        $CdtrAcct = new xmlElement("CdtrAcct");
        $Id = new xmlElement("Id");
        $Othr = new xmlElement("Othr");
        $Idid = new xmlElement("Id");
        $Idid->addTexte($cptd);
        $Othr->addElement($Idid);
        $Id->addElement($Othr);
        $CdtrAcct->addElement($Id);
        $CdtTrfTxInf->addElement($CdtrAcct);
        $RmtInf = new xmlElement("RmtInf");
        $Strd = new xmlElement("Strd");
        $CdtrRefInf = new xmlElement("CdtrRefInf");
        $Ref = new xmlElement("Ref");
        $Ref->addTexte($nref);
        $CdtrRefInf->addElement($Ref);
        $Strd->addElement($CdtrRefInf);
        $RmtInf->addElement($Strd);
        $CdtTrfTxInf->addElement($RmtInf);
      }
      elseif ($typepay == 'K'){
        $CdtrAgt = new xmlElement("CdtrAgt");
        $FinInstnId = new xmlElement("FinInstnId");
        if ($enr->clearingbanque){
          $ClrSysMmbId = new xmlElement("ClrSysMmbId");
          $ClrSysId = new xmlElement("ClrSysId");
          $Cd = new xmlElement("Cd");
          $Cd->addTexte("CHBCC");
          $ClrSysId->addElement($Cd);
          $MmbId = new xmlElement("MmbId");
          $MmbId->addTexte($enr->clearingbanque);
          $ClrSysMmbId->addElement($ClrSysId);
          $ClrSysMmbId->addElement($MmbId);
          $FinInstnId->addElement($ClrSysMmbId);
        }
        if ($enr->comptedest){
          $Othr = new xmlElement("Othr");
          $Id = new xmlElement("Id");
          $Id->addTexte(self::oteZeros($enr->comptedest));
          $Othr->addElement($Id);
          $FinInstnId->addElement($Othr);
        }
        $CdtrAgt->addElement($FinInstnId);
        $CdtTrfTxInf->addElement($CdtrAgt);
        $Cdtr = new xmlElement("Cdtr");
        $Nm = new xmlElement("Nm");
        $Nm->addTexte(utf8_encode($enr->secadr));
        $Cdtr->addElement($Nm);
        $PstlAdr = new xmlElement("PstlAdr");
        $PstCd = new xmlElement("PstCd");
        $PstCd->addTexte($enr->secnpa);
        $PstlAdr->addElement($PstCd);
        $TwnNm = new xmlElement("TwnNm");
        $TwnNm->addtexte(utf8_encode($enr->secville));
        $PstlAdr->addElement($TwnNm);
        $Cdtr->addElement($PstlAdr);
        $CdtrAcct = new xmlElement("CdtrAcct");
        $Id = new xmlElement("Id");
        $IBAN = new xmlElement("IBAN");
        $IBAN->addTexte(preg_replace("/\s/", "", $enr->cptbanque));
        $Id->addElement($IBAN);
        $CdtrAcct->addElement($Id);
        $RmtInf = new xmlElement("RmtInf");
        $Ustrd = new xmlElement("Ustrd");
        $Ustrd->addTexte(utf8_encode($enr->communication ? $enr->communication : "---"));
        $RmtInf->addElement($Ustrd);
        $CdtTrfTxInf->addElement($Cdtr);
        $CdtTrfTxInf->addElement($CdtrAcct);
        $CdtTrfTxInf->addElement($RmtInf);
      }
      elseif ($typepay == 'R'){
        $cptd = self::oteZeros($enr->comptedest);
        $Cdtr = new xmlElement("Cdtr");
        $Nm = new xmlElement("Nm");
        $Nm->addTexte(utf8_encode($enr->priadr));
        $Cdtr->addElement($Nm);
        $PstlAdr = new xmlElement("PstlAdr");
        $PstCd = new xmlElement("PstCd");
        $PstCd->addTexte($enr->prinpa);        
        $PstlAdr->addElement($PstCd);
        $TwnNm = new xmlElement("TwnNm");
        $TwnNm->addTexte(utf8_encode($enr->priville));
        $PstlAdr->addElement($TwnNm);
        $Cdtr->addElement($PstlAdr);
        $CdtTrfTxInf->addElement($Cdtr);
        $CdtrAcct = new xmlElement("CdtrAcct");
        $Id = new xmlElement("Id");
        $Othr = new xmlElement("Othr");
        $Idid = new xmlElement("Id");
        $Idid->addTexte($cptd);
        $Othr->addElement($Idid);
        $Id->addElement($Othr);
        $CdtrAcct->addElement($Id);
        $CdtTrfTxInf->addElement($CdtrAcct);
        $RmtInf = new xmlElement("RmtInf");
        $Ustrd = new xmlElement("Ustrd");
        $Ustrd->addTexte(utf8_encode($enr->communication ? $enr->communication : "---"));
        $RmtInf->addElement($Ustrd);
        $CdtTrfTxInf->addElement($RmtInf);
      }
      $PmtInf->addElement($PmtInfId);
      $PmtInf->addElement($PmtMtd);
      $PmtInf->addElement($BtchBookg);
      $PmtInf->addElement($ReqdExctnDt);
      $PmtInf->addElement($Dbtr);
      $PmtInf->addElement($DbtrAcct);
      $PmtInf->addElement($DbtrAgt);
      $PmtInf->addElement($CdtTrfTxInf);
      
      
      $CstmrCdtTrfInitn->addElement($PmtInf);
      $tabchamps['quittance'] = 1;
      $tabchamps['datarchiv'] = $this->aujourdhui();
      $ut = new updateTableBrioche("ep_archives", $tabchamps, $enr->id, "id", $this->idsession);
      $ut->update();
    }
    $Document->addElement($CstmrCdtTrfInitn);
    $xml->addElement($Document);
    
    print $xml->getContenu();
    return true;
  }
  
  static function oteZeros($nocompte){
    $tabcptd = explode("-", $nocompte);
    $cptd = $tabcptd[0] . "-" . preg_replace("/^0*/", "", $tabcptd[1]) . "-" . $tabcptd[2];
    return $cptd;
  }
  
  //Production des donnes du fichier DTA
  function imprime(){
    $tea = $this->ea->getTableau();
    $cpt = count($tea);
    for ($i = 0; $i < $cpt; $i++){
      $this->creeEnr($tea[$i], $i);
    }
    $this->creeTotal($i);
    print $this->contenu;
  }

  function creeEnr($ligne, $seq){
    $ecs = new ensTableBrioche("ep_comptessource", "nocompte = \"$ligne->comptesource\"", "*", 0, $this->idsession);
    $tecs = $ecs->getTableau();
    $clea = $tecs[0]->noclearing;
    $ini = new BriocheIni();
    # 01
    $this->contenu .= '01';
    $this->contenu .= $this->formateDate($ligne->datepay);
    if ($ligne->typepay == 'K' || ($ligne->typepay == 'R' && $ligne->cptbanque)){ // Interbancaire => n clearing
      $this->contenu .= $this->pade($ligne->clearingbanque, 12);
    }
    else {
      $this->contenu .= $this->pade("", 12);
    }
    $this->contenu .= "00000";
    $this->contenu .= $this->formateDate($this->aujourdhui());
    $this->contenu .= $this->pade($clea, 7);
    $this->contenu .= $this->pade($ini->idDTA, 5);
    $this->contenu .= str_pad($seq + 1, 5, "0", STR_PAD_LEFT);
    if ($ligne->typepay == 'B'){
      $this->contenu .= "826";
    }
    else {
      $this->contenu .= "827";
    }
    $this->contenu .= "00";
    $this->contenu .= $ini->idDTA;
    $this->contenu .= str_pad($ligne->id, 11, "0", STR_PAD_LEFT);
    $this->contenu .= $this->pade($ligne->comptesource, 24);
    $this->contenu .= $this->pade("", 6) . "CHF";
    $this->contenu .= $this->formateMontant($ligne->montant);
    $this->contenu .= $this->pade("", 14);
    # 02
    $this->contenu .= "02";
    $this->contenu .= $this->pade($tecs[0]->adresse1, 20);
    $this->contenu .= $this->pade($tecs[0]->adresse2, 20);
    $this->contenu .= $this->pade("", 20);
    $this->contenu .= $this->pade($tecs[0]->npa . " " . $tecs[0]->ville, 20);
    $this->contenu .= $this->pade("", 46);
    # 03
    $this->contenu .= "03";
    $this->contenu .= "/C/";
    if ($ligne->typepay == 'B'){ //BVR
      $this->contenu .= $this->formateCCP($ligne->comptedest);
      $tadr = $this->formateAdresse($ligne->priadr, 20);
      $this->contenu .= $tadr[0];
      $this->contenu .= $tadr[1];
      $this->contenu .= $tadr[2];
      $this->contenu .= $this->pade($ligne->prinpa, 4) . " " . $this->pade($ligne->priville, 15);
      $this->contenu .= $this->formateNoR($ligne->numref);
      $this->contenu .= $this->pade("", 7);
    }
    elseif ($ligne->typepay == 'K' || ($ligne->typepay == 'R' && $ligne->cptbanque)){ //Virement bancaire
      $this->contenu .= $this->pade($ligne->cptbanque, 27);
      $adr = $this->formateAdresse($ligne->secadr, 24);
      $this->contenu .= $adr[0];
      $this->contenu .= $adr[1];
      $this->contenu .= $adr[2];
      $this->contenu .= $this->pade($ligne->secnpa, 4) . " " . $this->pade($ligne->priville, 19);
    }
    elseif ($ligne->typepay == 'R' && (! $ligne->cptbanque)){ // Virement postal pur
      $this->contenu .= $this->pade($ligne->comptedest, 27);
      $adr = $this->formateAdresse($ligne->priadr, 24);
      $this->contenu .= $adr[0];
      $this->contenu .= $adr[1];
      $this->contenu .= $adr[2];
      $this->contenu .= $this->pade($ligne->prinpa, 4) . " " . $this->pade($ligne->priville, 19);
    }
    if ($ligne->communication) {
      $this->contenu .= "04";
      $this->contenu .= $this->pade($ligne->communication, 28);
      $this->contenu .= $this->pade("", 98);
    }
    $tabchamps['quittance'] = 1;
    $tabchamps['datarchiv'] = $this->aujourdhui();
    $ut = new updateTableBrioche("ep_archives", $tabchamps, $ligne->id, "id", $this->idsession);
    $ut->update();
    
  }

  // Enregistrement total du fichier DTA
  function creeTotal($seq){
    $ini = new briocheIni();
    $this->contenu .= "01";
    $this->contenu .= "000000";
    $this->contenu .= $this->pade("", 12);
    $this->contenu .= "00000";
    $this->contenu .= $this->formateDate($this->aujourdhui());
    $this->contenu .= $this->pade("", 7);
    $this->contenu .= $this->pade($ini->idDTA, 5);
    $this->contenu .= str_pad(($seq + 1), 5, "0", STR_PAD_LEFT);
    $this->contenu .= "890";
    $this->contenu .= $this->formateTotal($this->total);
    $this->contenu .= $this->pade("", 66);
  }

  //Passage des critures comptables
  function compta(){
    $ini = new briocheIni();
    $ep = new ensTableBrioche("ep_archives", "quittance = 1",
                              "*, IF(secadr is not null, secadr, priadr) as destinataire", "datepay", $this->idsession);
    $tep = $ep->getTableau();
    $cpt = count($tep);
    for ($i = 0; $i < $cpt; $i++){
      $ecpt = new ensTableBrioche("ep_comptessource", "nocompte = \"" . $tep[$i]->comptesource . "\"",
                                  "*", 0, $this->idsession);
      $tecpt = $ecpt->getTableau();

      $tabchamps['datop'] = $tep[$i]->datepay;
      $tabchamps['typedecriture'] = 2;
      $tabchamps['cred'] = $tecpt[0]->compta;
      $tabchamps['mtant'] = $tep[$i]->montant;
      $tabchamps['de_pour'] = $tep[$i]->destinataire;
      $lien = $ini->deltaDTA + $tep[$i]->id;
      $tabchamps['lien'] = $lien;
      $tabchamps['texte'] = $lien;
      $ut = new updateTableBrioche("comptes", $tabchamps, "", "", $this->idsession);
      $ut->ajouteEnr();

      $tabchamps = array();
      $tabchamps['quittance'] = 2;
      $ut = new updateTableBrioche("ep_archives", $tabchamps, $tep[$i]->id, "id", $this->idsession);
      $ut->update();
    }
  }

  //Formate un n de ccp
  function formateCCP($no){
    $no = preg_replace("/-/", "", $no);
    $no = str_pad($no, 9, "0", STR_PAD_LEFT);
    return $no;
  }

  //Formate le montant total
  function formateTotal($tot){
    $tot = $tot . "0";
    $tot = preg_replace("/\./", ",", $tot);
    $tot = str_pad($tot, 11, "0", STR_PAD_LEFT);
    return $tot;
  }

  //Formate n de rfrence pour DTA
  function formateNoR($nr){
    if (strlen($nr) == 15){
      return $this->pade($nr, 27);
    }
    elseif (strlen($nr) == 16){
      return str_pad($nr, 27, "0", STR_PAD_LEFT);
    }
    else return $nr;
  }

  //Formate les adresses
  function formateAdresse($chaine, $long){
    $blancs = $this->pade("", $long);
    $tablret = array($blancs, $blancs, $blancs);
    $chaine = wordwrap($chaine, $long, "\n");
    $tablexpl = explode("\n", $chaine);
    $cpt = (count($tablexpl) > 3 ? 3 : count($tablexpl));
    for ($i = 0; $i < $cpt; $i++){
      $tablret[$i] = $this->pade($tablexpl[$i], $long);
    }
    return $tablret;
  }

  //Formate les dates
  function formateDate($date){
    $tab = explode(".", $date);
    return substr($tab[2], 2, 2) . $tab[1] . $tab[0];
  }
  //Ajoute espaces
  function pade($chaine, $nb){
    if (strlen($chaine) > $nb){
      $chaine = substr($chaine, 0, $nb);
    }
    return str_pad($chaine, $nb, " ");
  }

  function formateMontant($mtant){
    $mtant = preg_replace("/\./", ",", $mtant);
    $mtant = $this->pade($mtant, 12);
    return $mtant;
  }
}

?>
