<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
//////////////////////////////////////////////////////////////
//
//  Lecture fichier BVR
//
//////////////////////////////////////////////////////////////

class releveCourrier extends connexionBrioche {
  var $tabEnr;
  
  function __construct($idsession){
    if (! parent::__construct($idsession)) return;
    if(isset($fichierbvr)){
      $this->fichbvr = $fichbvr;
    }
  }

  function traiteBal(){
    $ini = new BriocheIni();
    $serveur = $ini->scanServ;
    $balrec = $ini->scanBal;
    $balarch = $ini->scanArch;
    $user = $ini->scanUser;
    $mdp = $ini->scanMdp;
    $mbox = imap_open("{" . $serveur . "}" . $balrec, $user, $mdp);
    $mc = imap_check($mbox);
    $headers = array();
    if ($mc->Nmsgs){
      $headers = imap_fetch_overview($mbox, "1:$mc->Nmsgs");
    }
    $this->tabEnr = array();
    foreach($headers as $header){
      if ($header->seen == 0){ //message non lu
        if (preg_match("/SmartID/", $header->subject)){
          $struct = imap_fetchstructure($mbox, (int) $header->msgno);
          $parts = $struct->parts ?? array();
          foreach($parts as $idp => $part){
            if ($part->subtype == "XML"){
              $texte = imap_fetchbody($mbox, (int) $header->msgno, $idp+1);
              $texte = base64_decode($texte);
              $dom = new DOMDocument('1.0');
              try {
               $fichierxml = new SimpleXMLElement($texte);
              } catch (Exception $e) {
                die ($e->getMessage());
              }
              $dom->loadXML($fichierxml->asXML());
              $paiements = $dom->getElementsByTagName('PmtInf');
              $this->tabEnr = array();
              foreach($paiements as $paiement){
                $refs = $paiement->getElementsByTagName('Ref');
                $lignesdef = array();
                $CdtrAgts = $paiement->getElementsByTagName('CdtrAgt');
                foreach($CdtrAgts as $CdtrAgt){
                  $MmbIds = $CdtrAgt->getElementsByTagName('MmbId');
                  foreach($MmbIds as $MmbId){
                    $clearing = $MmbId->nodeValue;
                    $lignesdef['clearingbanque'] = (int) $clearing;
                  }
                }
                $montants = $paiement->getElementsByTagName('InstdAmt');
                foreach($montants as $montant){
                  $lignesdef['montant'] = $montant->nodeValue;
                }
                $CdtrAccts = $paiement->getElementsByTagName('CdtrAcct');
                foreach ($CdtrAccts as $CdtrAcct){
                  $Othrs = $CdtrAcct->getElementsByTagName('Othr');
                  foreach ($Othrs as $Othr){
                    $ids = $Othr->getElementsByTagName('Id');
                    foreach ($ids as $id){
                      $cpte = $id->nodeValue;
                      if (isset($lignesdef['clearingbanque'])){
                        $lignesdef['cptbanque'] = self::getIban($lignesdef['clearingbanque'], $cpte);
                      }
                      else {
                        $tabcpte = explode('-', $cpte);
                        $tabcpte[1] = sprintf("%06d", $tabcpte[1]);
                        $cpte = implode("-", $tabcpte);
                        $lignesdef['comptedest'] = $cpte;
                      }
                    }
                  }
                  
                }
                
                if (count($refs)){ //BRV
                  $lignesdef['typepay'] = 'B';
                  foreach ($refs as $ref){
                    $lignesdef['numref'] = $ref->nodeValue;
                  }
                }
                else { // Bulletin rose avec ou sans compte
                  if (isset($lignesdef['clearingbanque'])){
                    $lignesdef['typepay'] = 'K';
                }
                else {
                    $lignesdef['typepay'] = 'R';
                  }
                }
                $this->tabEnr[] = $lignesdef;
              }
              
            }
          }
          //print_r($this->tabEnr);
          //Fin du traitement du message
          imap_mail_move($mbox, (string) $header->msgno, "$balrec.$balarch");
        }
        /*
        if ($header->subject == "ibiScan"){
          //Traitement du message
          $struct = imap_fetchstructure($mbox, (int) $header->msgno);
          $txt = imap_fetchbody($mbox, (int) $header->msgno, 1);
          $txt = quoted_printable_decode($txt);
          $txt = trim(utf8_decode($txt));
          $txt = preg_replace("/\n/", "", $txt);
          $txt = preg_replace("/\r/", "", $txt);
          $txt = preg_replace("/:/", ": ", $txt);
          $txt = preg_replace("/+/", "\n", $txt);
          $txt = preg_replace("/:\n/", ": ", $txt);
          $txt = preg_replace("/=+/", "===", $txt);
          $enrs = explode("===", $txt);
          foreach($enrs as $enr){
            $lignes = explode("\n", trim($enr));
            $lignesdef = array();
            foreach ($lignes as $champ){
              //$matches = array(0 => "", 1 => "", 2 => "");
              preg_match("/(.*):\s(.*)/", $champ, $matches);
              if (! isset($matches[1])) $matches[1] = "";
              if (! isset($matches[2])) $matches[2] = "";
              if(trim($matches[2]) == "- - - -") $matches[2] = "";
              if($matches[2] && $matches[1] == "Montant") $lignesdef['montant'] = preg_replace("/ CHF/", "", $matches[2]);
              if($matches[2] && $matches[1] == "Compte"){
                $lignesdef['comptedest'] = trim($matches[2]);
                $cpte = explode("-", $matches[2]);
                if (count($cpte) == 3){
                  $cpte[1] = sprintf("%06d", $cpte[1]);
               }
                $lignesdef['comptedest'] = trim($cpte[0]) . "-" . trim($cpte[1]) . "-" . trim($cpte[2]);
              }
              if($matches[2] && $matches[1] == "No de rfrence") $lignesdef['numref'] = preg_replace("/\s/", "", $matches[2]);
              if($matches[2] && $matches[1] == "IBAN"){
                $lignesdef['cptbanque'] = $matches[2];
                $ibanreduit = preg_replace("/\s/", "", $matches[2]);
                $lignesdef['clearingbanque'] = (integer) substr($ibanreduit, 4, 5);
              }
              $lignesdef['typepay'] = "R";
              if (isset($lignesdef['numref'])) $lignesdef['typepay'] = "B";
              if (isset($lignesdef['clearingbanque'])) $lignesdef['typepay'] = "K"; 
              
            }
            $this->tabEnr[] = $lignesdef;
            
          }
          //print_r($this->tabEnr);
          //Fin du traitement du message
          imap_mail_move($mbox, (string) $header->msgno, "$balrec.$balarch");
        }
        else {
          // Destrutcion message non ibiScan
          imap_delete($mbox, $header->msgno);
        }
      */
      }
      else {
        //Archivage d'un ventuel message dj lu
        imap_mail_move($mbox, (string) $header->msgno, "$balrec.$balarch");
      }
    }
    
    
    imap_expunge($mbox);
    imap_close($mbox);
    $this->enregistreLignes();
  }
  
  static function getIban($clearing, $nocpte){
    // D'aprs http://www.swissiban.com/fr.htm
    $clearing = sprintf("%05d", $clearing);
    $nocpte = preg_replace("/^0*/", "", $nocpte);
    $nocpte = substr($nocpte, 0, -1);
    $nocpte = sprintf("%012d", $nocpte);
    $iban = $clearing . $nocpte;
    $tabIban = str_split($iban);
    $chaineNum = "";
    foreach ($tabIban as $lettre){
      if (! is_numeric($lettre)){
        $lettre = strtoupper($lettre);
        $lettre = (ord($lettre)-55);
      }
      $chaineNum .= $lettre;
      
    }
    $chaineNum .= "121700";
    $controle = 98 - bcmod($chaineNum, "97");
    $iban = "CH" . sprintf("%02d", $controle) . $iban;
    $iban = preg_replace("/(.{4})(.{4})(.{4})(.{4})(.{4})(.)/", "$1 $2 $3 $4 $5 $6", $iban);
    return $iban;
  }
  
  function enregistreLignes(){ // Enregistrement des donnes scannes dans des ordres de Paiement
    $fact = 0;
    foreach ($this->tabEnr as $ligne){
      if ($ligne['typepay'] == "B"){ //BVR
         // recherche destinataire primaire
        $et = new ensTableBrioche("ep_destpri", "nocompte=\"" . $ligne['comptedest'] . "\"", "*", "id DESC", $this->idsession);
        $ett = $et->getTableau();
        //print $et->getSQL() . "<br>";
        //print mysqli_error($this->linkBrioche);
        //print_r($ett);
        //print "--->" . count($ett) . "<---";
        if (count($ett)){
          $ligne['priadr'] = $ett[0]->adresse;
          $ligne['prinpa'] = $ett[0]->npa;
          $ligne['priville'] = $ett[0]->ville;
        }
        $partic = substr($ligne['numref'], 0, 6);
        // recherche destinataire secondaire
        $et = new ensTableBrioche("ep_archives",
                                  "comptedest=\"" . $ligne['comptedest'] . "\" AND numref LIKE \"" . $partic . "%\"",
                                  "*", "id DESC", $this->idsession, 0, 0, 0, 0, 0, "1");
        $ett = $et->getTableau();
        if (count($ett)){
          if ($ett[0]->secadr) $ligne['secadr'] = $ett[0]->secadr;
          if ($ett[0]->secnpa) $ligne['secnpa'] = $ett[0]->secnpa;
          if ($ett[0]->secville) $ligne['secville'] = $ett[0]->secville;
        }
      }
      elseif ($ligne['typepay'] == "R"){ // BV rose
        $et = new ensTableBrioche("ep_ccp", "nocompte=\"" . $ligne['comptedest'] . "\"", "*", "id DESC", $this->idsession);
        $ett = $et->getTableau();
        if (count($ett)){
          $ligne['priadr'] = $ett[0]->adresse;
          $ligne['prinpa'] = $ett[0]->npa;
          $ligne['priville'] = $ett[0]->ville;
        }
      }
      elseif ($ligne['typepay'] == "K") {  //transfert bancaire
        //Banque
        $et = new ensTableBrioche("ep_clearing", "noclearing=\"" . $ligne['clearingbanque'] . "\"", "*", 0, $this->idsession);
        $ett = $et->getTableau();
        if (count($ett)){
          $ligne['priadr'] = $ett[0]->banque;
          $ligne['prinpa'] = $ett[0]->npa;
          $ligne['priville'] = $ett[0]->ville;
        }
        // Destinataire secondaire
        if (isset($ligne['cptbanque'])){
          $et = new ensTableBrioche("ep_cptbanques", "nocompte=\"" . $ligne['cptbanque'] . "\"", "*", "id DESC", $this->idsession);
          $ett = $et->getTableau();
          if (count($ett)){
            $ligne['secadr'] = $ett[0]->adresse;
            $ligne['secnpa'] = $ett[0]->npa;
            $ligne['secville'] = $ett[0]->ville;
          }
        }
      }
      
      $ligne['quittance'] = -1;
      $enrp = new enrBriochePaye(0, $this->idsession);
      $fact ++;
      $item = $enrp->creeNouveau("ep_archives", $fact);
      $ut = new updateTableBrioche("ep_archives", $ligne, $item, "id", $this->idsession);
      $ut->update();
      //print_r($ligne);
      //print "<BR>---<BR>";
    }
  
  }
  
}














?>
