<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
//////////////////////////////////////////////////////////////
//
//  Lecture fichier BVR
//
//////////////////////////////////////////////////////////////

class bvr extends connexionBrioche{
  var $fichbvr;  
  var $nomfich;
  var $nbenr;
  var $erreurs;
  var $erreurtraitement;
  var $futname;
  
  function __construct($fichbvr, $idsession){
    if (! parent::__construct($idsession)) return;
    $this->fichbvr = $fichbvr;
  }

  function litFichier(){
    $nomfich = $this->fichbvr['name'];
    $this->nomfich = $nomfich;
    if (! $nomfich){
      $al = new Alerte("Il faut indiquer un fichier !");
      $al->imprime();
      return false;
    }
    $chaine = file_get_contents($this->fichbvr['tmp_name']);
    $futname = md5($chaine) . ".txt";
    $this->futname = $futname;
    $ini = new briocheIni();
    if (file_exists("$ini->fichDir/$futname")){
      $al = new Alerte("Ce fichier a dj t tlcharg !");
      $al->imprime();
      return false;  
    }
    if (! move_uploaded_file($this->fichbvr['tmp_name'], "$ini->fichDir/$futname")){
      $al = new Alerte("Problme lors du tlchargement du fichier !");
      $al->imprime();
    }
    //Le fichier a t tlcharg correctement
    $tabtxt = file("$ini->fichDir/$futname");
    $bvrdata = new updateTableBrioche("entreesbvr", "", "", "", $this->idsession);
    $bvrtota = new updateTableBrioche("totauxbvr", "", "", "", $this->idsession);
    $cpt = count($tabtxt);
    if  ($cpt == 1){ // Pas de retour de chariot dans le fichier de la banque (p. ex. Crdit Suisse)
     $tabtxt[0] = preg_replace("/\s+/", "", trim($tabtxt[0]));
     $tabtxt = explode("", $tabtxt[0]);
     $cpt = count($tabtxt);
    }
    
    $this->erreurs = 0;
    $this->nbenr = 0;
    for ($i = 0; $i < $cpt; $i++){
      $ligne = $tabtxt[$i];
      if (substr($ligne, 0, 1) == 9){ //Ligne total
        $tabchamps['genretransaction'] = substr($ligne, 0, 3);
        $tabchamps['montant'] = substr($ligne, 39, 12);
        $tabchamps['nbtransactions'] = substr($ligne, 51, 12);
        $tabchamps['datedisquette'] = substr($ligne, 63, 6);
        $tabchamps['taxes'] = substr($ligne, 69, 9);
        $bvrtota->setTabChamps($tabchamps);
        $bvrtota->ajouteEnr(); 
      }
      else { //ligne entre
        $tabchamps['genretransaction'] = substr($ligne, 0, 3);
        $tabchamps['numeroref'] = substr($ligne, 12, 27);
        $tabchamps['montant'] = substr($ligne, 39, 10);
        $tabchamps['dated'] = substr($ligne, 59, 6);
        $tabchamps['datet'] = substr($ligne, 65, 6);
        $tabchamps['datei'] = substr($ligne, 71, 6);
        $tabchamps['microfilm'] = substr($ligne, 77, 9);
        $tabchamps['rejet'] = substr($ligne, 86, 1);
        if ($tabchamps['rejet']) $this->erreurs ++;
        $tabchamps['reserve'] = substr($ligne, 87, 9);
        $tabchamps['taxe'] = substr($ligne, 96, 4);
        $bvrdata->setTabChamps($tabchamps);
        $bvrdata->ajouteEnr();
        $this->nbenr ++;
      }
    }  
    return true;
  
  }
  
  function traiteDonnees(){
    $ed = new ensTableBrioche("entreesbvr", "quittance is null", "*", 0, $this->idsession);
    $ted = $ed->getTableau();
    $cpt = count($ted);
    $this->erreurtraitement = 0;
    $ueb = new updateTableBrioche("entreesbvr", "", "", "numeroref", $this->idsession);
    for ($i = 0; $i < $cpt; $i++){
      $ligne = $ted[$i];
      $ok = true;
      if (substr($ligne->numeroref, 13, 1) == 0){ //prefixe bvr court
        $nofact = substr($ligne->numeroref, 6, 7) + 0;
        $nopat = substr($ligne->numeroref, 13, 13) + 0;
        //Contrle correspondance patient-facture
        $ep = new ensFacturePat($nopat, $this->idsession);
        if (! $ep->verifNofact($nofact)){
          $this->erreurtraitement ++;
          $tabchamps['quittance'] = 2;
          $ok = false;
        }
      }  
      else{ //prefixe bvr long (ex. raiffeisen)
        $nofact = substr($ligne->numeroref, 14, 7);
        $hachage = substr($ligne->numeroref, 21, 5);
        $edf = new ensDetailFacture($nofact, $this->idsession);
        $ok = $edf->controleHachage($hachage);
        if (!$ok){
          $this->erreurtraitement ++;
          $tabchamps['quittance'] = 2;
        }
      }  
        
      if($ok){ //Patient et facture correspondent
        $montant = $ligne->montant/100;
        $datop = $this->date62DateFr($ligne->datet);
        $edf = new ensDetailFacture($nofact, $this->idsession);
        if($edf->acquitte($montant, 0, 1, $datop)){
          $tabchamps['quittance'] = 9;
        }
        else {
          $this->erreurtraitement ++;
          $tabchamps['quittance'] = 3;
        }
      }
      $ueb->setTabchamps($tabchamps);
      $ueb->setItem($ligne->numeroref);
      $ueb->update();
    }
  }
}















?>
