<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

////////////////////////////////////////////
//
//  Calcul chiffre d'affaires du labo (comparaison nouveau 2009 / ancien)
//
////////////////////////////////////////////
class  calculCALabo extends connexionBrioche {
  var $tabMois;
  function __construct($sessionid) {
    if (! parent::__construct($sessionid)) return;
  }
  
  function calcule(){
    $debut = date_create("2009-07-01");
    $ancienPoint = 0.9;
    $maintenant = date_create();
    //tableau des mois
    $tabMois = array();
    $dateTrans = $debut;
    $dateFin = new DateTime();
    $i = 0;
    $conversion = array (
      102000 => 800600,
      102001 => 800600,
      102100 => 800700,
      102300 => 800850,
      102301 => 800850,
      102700 => 801200,
      102701 => 801200,
      104701 => 803700,
      109300 => 805800,
      109301 => 805800,
      120700 => 812600,
      120701 => 812600,
      122300 => 814900,
      123000 => 815800,
      123001 => 815800,
      124500 => 813700,
      124501 => 813700,
      124900 => 838400,
      124901 => 838400,
      126000 => 817900,
      126001 => 817900,
      126600 => 840300,
      130400 => 826900,
      134100 => 824900,
      134101 => 824900,
      135600 => 825900,
      135601 => 825900,
      136300 => 826500,
      136301 => 826500,
      137100 => 826900,
      137201 => 826900,
      139601 => 827500,
      140600 => 828400,
      140601 => 828400,
      141000 => 828800,
      141001 => 828800,
      147900 => 834300,
      147901 => 834300,
      150900 => 838700,
      150901 => 838700,
      157400 => 843800,
      158300 => 844300,
      158301 => 844300,
      159200 => 803700,
      160100 => 846200,
      163400 => 849200,
      163401 => 849200,
      166400 => 851700,
      166401 => 851700,
      166600 => 851900,
      166601 => 851900,
      170000 => 854800,
      170001 => 854800,
      173100 => 857200,
      173101 => 857200,
      173401 => 857411,
      173500 => 857411,
      173800 => 857800,
      173801 => 857800,
      173900 => 857900,
      174000 => 858000,
      174001 => 858000,
      333000 => 930900,
      346900 => 955972,
      346901 => 955972
    );
    while ($dateTrans < $maintenant){
      $dateFin->setDate(date_format($dateTrans, "Y"), date_format($dateTrans, "n") + 1, 0);
      $tabMois[$i]['an'] = date_format($dateTrans, "Y");
      $tabMois[$i]['mois'] = date_format($dateTrans, "n");
      $tabMois[$i]['anFin'] = date_format($dateFin, "Y");
      $tabMois[$i]['moisFin'] = date_format($dateFin, "n");
      $tabMois[$i]['jourFin'] = date_format($dateFin, "d");
      $i++;
      $dateTrans->setDate(date_format($dateTrans, "Y"), date_format($dateTrans, "n") + 1, 1);
      
    }
    $j = 0;
    $cpt = count($tabMois);
    for($i = 0; $i < $cpt; $i++) { // Chaque mois
      $mois = $tabMois[$i];
      $wheredate = "(dateprest BETWEEN \"" . $mois['an'] . "-" . $mois['mois'] . "-1\" AND \"" . $mois['anFin'] . "-" .
                   $mois['moisFin'] . "-" . $mois['jourFin']. "\")";
      $where = "$wheredate AND tarif = 4 AND position < 399999";
      $seances = new ensTableBrioche("prestations", "$where", "TO_DAYS(dateprest), nofact", 0, $this->idsession, 0, 0, true);
      $nbseances = $seances->compte();
      $seances->setWhere("$wheredate AND tarif = 5 AND position = 140 AND autom=1");
      $nbpresence = $nbseances - $seances->compte();
      $tabMois[$i]['nbSeances'] = $nbseances;
      $tabMois[$i]['nbPresence'] = $nbpresence;
      $prestations = new ensTableBrioche("prestations", $where, "*", 0, $this->idsession);
      $tabPrests = $prestations->getTableau();
      $totalPrestNouv = 0;
      $totalPrestAnc = 0;
      foreach($tabPrests as $ligne){
        $totalPrestNouv += $ligne->ttligne;
        $ancpos = $conversion[$ligne->position];
        $nombre = $ligne->nombre;
        $points = $this->interrogeTarif($ancpos);
        $ttlAnc = $nombre * 0.9 * $points;
        $totalPrestAnc += $ttlAnc;
      }
      $tabMois[$i]['totPrestNouv'] = $totalPrestNouv;
      $tabMois[$i]['totPrestAnc'] = $totalPrestAnc;
      
      
      // Prestations automatiques
      $prestations->setWhere("$wheredate AND autom = 1");
      $tabPrests = $prestations->getTableau();
      $totalPrestAuto = 0;
      foreach($tabPrests as $ligne){
        $totalPrestAuto += $ligne->ttligne;
      }
      $tabMois[$i]['totPrestAuto'] = $totalPrestAuto;
      $tabMois[$i]['totNouv'] = $tabMois[$i]['totPrestNouv'] + $tabMois[$i]['totPrestAuto'];
      $tabMois[$i]['difference'] = round($tabMois[$i]['totNouv'] - $tabMois[$i]['totPrestAnc'], 2);
    }
    
    
    $this->tabMois = $tabMois;
  }

  function interrogeTarif($position){
    $et = new ensTableBrioche("tarif", "tarif = 4 AND position = $position", "points", 0, $this->idsession);
    $tet = $et->getTableau();
    return $tet[0]->points;
  }
  
  function rapportHtml(){
    $ini = new briocheIni();
    $chaine = "<HTML><HEAD></HEAD><BODY>";
    $chaine .= "<TABLE BORDER=1>";
    $chaine .= "<TR><TH>An</TH><TH>Mois</TH><TH>Nb. sances</TH><TH>Prs./Abs.</TH><TH>Fr. analyses</TH><TH>Fr. suppl.</TH><TH>Total</TH><TH>Simul. ancien tarif</TH><TH>Diff.</TH></TR>";
    foreach($this->tabMois as $ligne){
      $chaine .= "<TR><TD>" . $ligne['an'] . "</TD><TD>" . $ligne['mois'] . "</TD><TD>" . $ligne['nbSeances'] . "</TD><TD>" . $ligne['nbPresence'] .
                 "/" . ($ligne['nbSeances'] - $ligne['nbPresence']) . "</TD><TD>" . $ligne['totPrestNouv'] . "</TD><TD>" .
                 $ligne['totPrestAuto'] . "</TD><TD>" . $ligne['totNouv'] . "</TD><TD>" . $ligne['totPrestAnc'] . "</TD><TD>" .
                 $ligne['difference'] . "</TD></TR>";
    }
    $chaine .= "</TABLE>";
    $chaine .="</BODY></HTML>";
    
    $nomfich = "R" . $this->idsession . ".html";
    $pf = fopen("$ini->fichDir/$nomfich", "w");
    fwrite($pf, $chaine);
    fclose($pf);
    
    $mailer = new PHPMailer();
    $mailer->From = "admin@virga.org";
    $mailer->FromName = "radiX";  
    $mailer->Subject = "Rapport laboratoire";
    $mailer->Body = "Un nouveau rapport laboratoire est sorti...";
    $mailer->AddAddress($ini->adresseBrio);
    $mailer->AddAttachment("$ini->fichDir/$nomfich", 'rapport.html', 'base64', 'text/html');
    //print $chaine;
    $mailer->Send();
    
    unlink("$ini->fichDir/$nomfich");
  }
  
}
?>
