<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

////////////////////////////////////////////
//
//  Comptes courants
//
////////////////////////////////////////////

class comptesCourants extends cadronglet{
  var $action;
  var $action0;
  var $action1;
  var $action2;
  var $options;
  

  #Constructeur
  function __construct($largeur, $grise, $actif, $fondpage, $sessionid, $donnees,
                           $action0, $action1, $action2,
                           $options, $item){
    global $fichier;
    global $imagesdir;
    global $fdossbrioche; 
    $ini = new briocheIni();
    if (! isset($donnees)){
      $donnees['fin'] = "";
      $donnees['compte'] = "";
      $donnees['item'] = "";
    }
    if (! isset($donnees['page'])) $donnees['page'] = 0;
    if (! parent::__construct($largeur, $grise, $actif, $fondpage, $sessionid)) return;
    $this->options = new optionsBriocheCab($options);
    //Lecture relev UBS
    if(isset($_FILES['fichubs']) && $_FILES['fichubs']['name']){
      $fichubs = $_FILES['fichubs'];
      $fubs = new releve($fichubs, $donnees['compte'], $this->idsession);
      $fubs->litFichier();
    }
    
    //Destruction d'une opration
    if ($this->options->getOption("DETR_OP") == 1){
      $this->options->setOption("DETR_OP", 0);
      $ut = new updateTableBrioche("comptes", "", $item, "noop", $this->idsession);
      $ut->detruitEnr();
    }
    $this->action = $actif;
    $this->action0 = $action0;
    $this->action1 = $action1;
    $this->action2 = $action2;
    $tabbande = array("Consulatation des comptes courants", "", "", "", "");
    $this->addOnglet("Comptes", $tabbande, "#8b8378", $this->action, 80, "");
    $this->colmateOnglets();
    if (! $donnees['fin']) $donnees['fin'] = $this->aujourdhui();
    $join = "typesecriture";
    $on = "comptes.typedecriture = typesecriture.notype";
    $where = "(deb = " . $donnees['compte'] . " OR cred = " . $donnees['compte'] .
             ") AND datop <= " . $this->getDateAm($donnees['fin']); 
    $red = $this->options->getOption("RED_CPT");
    if (! $red){
      $etgen = new ensTableBrioche("comptes", $where,
                                   "comptes.*, typesecriture.typeecr, IF(deb = " . $donnees['compte'] . 
                                   ", mtant, \"\") as debit, " .
                                   "IF(cred = " . $donnees['compte'] . ", mtant, \"\") as credit",
                                   "datop DESC, noop DESC", $this->idsession, $join, $on);
    }
    else {
      $etgen = new ensTableBrioche("comptes", $where,
                                   "datop, typeecr, sum(if(deb=" . $donnees['compte'] .
                                   ", mtant, null)) as debit, " .
                                   "sum(if(cred=" . $donnees['compte'] . ", mtant, null)) as credit, " .
                                   "\"\" as texte," .
                                   " \"\" as de_pour", 
                                   "datop desc, typedecriture", $this->idsession, $join, $on,
                                   false, 0, "datop, typedecriture");
    }
    $solde = $etgen->somme("IF(deb = " . $donnees['compte'] . ", mtant, \"\")") -
             $etgen->somme("IF(cred = " . $donnees['compte'] . ", mtant, \"\")");
    $solde = sprintf("%01.2f", $solde);
    //Contenu
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fichier, "post", "multipart/form-data");
    $of->addLigne(0.5);
    $c = new TPanel(2);
    $x = new Label("Compte :&nbsp;");
    $c->addChamp($x);
    $etcpt = new ensTableBrioche("listecomptes", "courant = -1",
                                 "*",
                                 "nomcompte", $this->idsession);
    $x = new ListOptTable("donnees[compte]", $donnees['compte'], $etcpt, false, 0, "d2",
                          "changeChamp('donnees[page]', 0, 'donnees' );" .
                          "document.forms.donnees.submit()");
    $x->addDefaut("---", 0);
    $x->addOptions("nomcompte", "nocompte");
    $c->addChamp($x);
    $of->addChamp($c);
    $c = new TPanel(3);
    $x = new ChampTexte("donnees[fin]", $donnees['fin'], "Date : ", 12, 12, false, "TEXT",  "d2",
                        "controleDate('donnees[fin]', '', '');document.forms.donnees.submit()");
    $c->addChamp($x);
    $x = new Espace(5);
    $c->addChamp($x);
    $x = new Bouton("OK", "OK", "BUTTON",
                    "changeChamp(\"donnees[page]\", 0, \"donnees\");document.forms.donnees.submit();",
                    "bok");
    $c->addChamp($x);
    $x = new Espace(4);
    $c->addChamp($x);
    $x = new Label("Solde : Fr.&nbsp;&nbsp;", false, false, false);
    $c->addChamp($x);
    $x = new Label($solde, true);
    $c->addChamp($x);
    $of->addChamp($c);
    $c = new TPanel(1, 1, "RIGHT");
    $x = new Bouton("Retour", "Retour", "BUTTON",
                    "document.forms.donnees.action.value=$this->action0;document.forms.donnees.submit();");
    $c->addChamp($x);
    $x = new Espace(3);
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("action", $this->action, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("options", $this->options->getChaine(), "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("item", $this->options->getChaine(), "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("scroll", 0, "HIDDEN");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    
    $c = new GrTBoutonTexte($red, 2, 140, 20, "#999999", "#efefef", 2);
    $futopt = new optionsBriocheCab($this->options->getChaine());
    $futopt->setOption("RED_CPT", 0);
    $c->addBouton("Dvelopper",
                  "javascript:document.forms.donnees.options.value='" . $futopt->getChaine() .
                  "';document.forms.donnees.submit()", 0);
    $futopt = new optionsBriocheCab($this->options->getChaine());
    $futopt->setOption("RED_CPT", 1);
    $c->addBouton("Rduire", "javascript:document.forms.donnees.options.value='" . $futopt->getChaine() .
                  "';document.forms.donnees.submit()", 1);
    
    $of->addChamp($c);
    if ($donnees['compte']){
      $c = new TPanel(1);
      $x = new Bouton("Ajouter", "Ajouter", "BUTTON", "ouvreFenetre(\"$fdossbrioche?action=$this->action2" .
             "&item=" . $donnees['compte'] . "&sessionid=$this->idsession\", \"ajout\", " .
             "\"scrollbars=no,resizable=no,menubar=no,locationbar=no,height=300," .
             "width=500,screenX=150,screenY=100\")");
      $c->addChamp($x);
      $of->addChamp($c);
      $noubs = $etcpt->lookUp("noubs", "nocompte = " . $donnees['compte']);
      if ($noubs){
        $c = new TPanel(3, 1, "RIGHT");
        $x = new Label("Fichier relev UBS :", true);
        $c->addChamp($x);
        
        $x = new Bouton("fichubs", "fichubs", "FILE");
        $c->addChamp($x);
        $x = new Espace(3);
        $c->addChamp($x);
        $of->addChamp($c);
      }
    }
    $c = new TPanel(4, 1, "RIGHT");
    $x = new Aide("C008");
    $c->addChamp($x);
    $x = new Espace(3);
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    if ($this->options->getOption("RED_CPT") == 0) { // Pas de pagination si rduction
      $c = new TPanel(6, 1);
      $x = new Pagination($etgen, "oprations", "donnees", "donnees[page]",
                        $ini->longPage, $donnees['page']);
      $c->addChamp($x);
      $x = new Bouton("donnees[page]", $donnees['page'], "HIDDEN");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
    }
    $c = new TPanelTableau(6, 6, $etgen, "#efefef", "", ($red ? "datop" : "noop"));
    if ($red){
      $x = new Label("", false, false, false, "datop");
      $c->addColChamp("Date", $x);
    }
    else {
      $x = new Label("", false, false, false, "noop");
      $c->addColChamp("Date", $x, false, true, "getLienDate", $this, "LEFT", "datop");
    }
    $x = new Label("", false, false, false, "debit");
    $c->addColChamp("Dbit", $x, false, false, "", "", "RIGHT");
    $x = new Label("", false, false, false, "credit", "red");
    $c->addColChamp("Crdit", $x, false, false, "", "", "RIGHT");
    $x = new Label("", false, false, false, "typeecr");
    $c->addColChamp("Type", $x);
    $x = new Label("", false, false, false, "texte");
    $c->addColChamp("Texte / Rf.", $x);
    $x = new Label("", false, false, false, "de_pour");
    $c->addColChamp("De / pour", $x);
    if (! $red){
      $futopt = new optionsBriocheCab($this->options->getChaine());
      $futopt->setOption("DETR_OP", 1);
      $x = new BoutonImage("", "$imagesdir/croix.gif", 12, 12,
                           "javascript:supprimeCond('javascript:document.forms.donnees.options.value=\'" .
                           $futopt->getChaine() ."\';document.forms.donnees.item.value=;" .
                           "document.forms.donnees.scroll.value=document.body.scrollTop;" .
                           "document.forms.donnees.submit();', '');", "noop");
      $c->addColChamp("", $x, false, true);
    }
    $c->addTitres(true);
    $of->addChamp($c);




    $this->addContenu($of->getContenu());
  }

  function getLienDate($noop, $datop){
    global $fdossbrioche;
    return "<A HREF=\"javascript:ouvreFenetre('$fdossbrioche?action=$this->action1" .
           "&item=$noop&sessionid=$this->idsession', 'ajout', " .
           "'scrollbars=no,resizable=no,menubar=no,locationbar=no,height=150," .
           "width=300,screenX=150,screenY=100');\">$datop</A>";
  }
}
?>
