<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
////////////////////////////////////////////////
//
// Page de garde du dossier BriocheCab
//
//////////////////////////////////////////////////

class dossierBriocheCab extends cadronglet {

   var $nav;
   var $item;
   var $options;
   var $futuroptions;
   var $recup;
   var $rs;
   var $nomplein;
   var $itfact;
   var $itprest;
   var $typeprest;
  #Constructeur
  function __construct($largeur, $grise, $actif, $fondpage, $sessionid,
                             $item = 0, $options = 0, $recup = 0, $itfact = 0,
                             $itprest = 0, $upd = 0, $typeprest = 0){
    global $fdosbrioche;
    global $imagesdir;
    global $noetabl;
    $this->options = new optionsBriocheCab($options);
    //$ini = new briocheIni();
    if ( ! parent::__construct($largeur, $grise, $actif, $fondpage, $sessionid)) return;
    //Vrification que l'affichage des popups est autoris
    if ($this->options->getOption("V_POPUP")) {
      $this->options->setOption("V_POPUP", 0);
      print  "<SCRIPT LANGUAGE=\"JavaScript\">" .
             "testPopup();" .
             "postTestPopup();" .
             "</SCRIPT>";
    }
    if ($this->options->getOption("NOUV_DOSS") == 1){
      $enr = new enrBriocheCab(0, $this->idsession);
      $item = $enr->creeNouveau("patients");
      $this->options->setOption("NOUV_DOSS", 2);
    }
    
   
    $this->recup = $recup;
    $this->action = $actif;
    $this->itfact = $itfact;
    $this->itprest = $itprest;
    $this->typeprest = $typeprest;
    $this->upd = $upd;
    $this->options->setOption("ACT_DOSS", $this->action);
    // Connexion aux donnes
    $this->nav = new ensNavBriocheCab($this->idsession); //Outil de navigation
    if ($item == -9999){ //Recherche par facture
      $etd = new ensTableBrioche("factures", 1, "*", 0, $this->idsession);
      $item = $etd->lookUp("nopat", "nofact = $this->itfact");
    }
    $this->item = ($item ? $item : $this->nav->getSuivant(0));
    if ((! $this->nav->checkItem($this->item)) && (!$this->options->getOption("NOUV_DOSS"))){
      $al = new Alerte("Le patient N " . $this->item . " n\'existe pas...");
      $al->imprime();
      $this->item = $this->nav->getPrecedent($this->item);
    }
    $this->rs = new enrBriocheCab($this->item, $this->idsession);
    $patient = $this->rs->getEnr("patients");
    $this->nomplein = $patient->nomp . " " . $patient->prenom ;
    $this->futuroptions = new optionsBriocheCab($this->options->getChaine());
    $this->futuroptions->setOption("CH_AD", 0);
    $this->futuroptions->setOption("CH_ST_FACT", 0);
    $this->futuroptions->setOption("CH_MED", 0);
    $this->futuroptions->setOption("SUP_PREST", 0);
    $this->futuroptions->setOption("REC_FACT", 0);
    $this->futuroptions->setOption("CH_BOUCL_FACT", 0);
    // Dessin des onglets
    $tabbande = array("Patient courant :", $this->item, $this->nomplein, "", "");
    $tabbande[0] = "Fiche patient - Dossier ";
    $this->addOnglet("Patient", $tabbande, "#e119c1", 1, 60,
                     "javascript:lienCond('$fdosbrioche?action=1&sessionid=$this->idsession&item=$this->item&options=" .
                     $this->futuroptions->getChaine() . "')");
    if ($this->options->getOption("NOUV_DOSS") == 0) {
      $tabbande[0] = "Relations - Dossier ";
      $this->addOnglet("Relations", $tabbande, "#00e1ff", 2, 60,
                        "javascript:lienCond('$fdosbrioche?action=2&sessionid=$this->idsession&item=$this->item&options=" .
                         $this->futuroptions->getChaine() . "')");
      $tabbande[0] = "Factures - Dossier ";
      $this->addOnglet("Factures", $tabbande, "#122199", 3, 60,
                       "javascript:lienCond('$fdosbrioche?action=3&sessionid=$this->idsession&item=$this->item&options=" .
                       $this->futuroptions->getChaine() . "')");
      
    }
    $this->colmateOnglets();
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("navigation", $fdosbrioche, "post");

    //Navigation

    if ($this->options->getOption("NOUV_DOSS") == 0){
      $premier = $this->nav->getSuivant(0);
      $suivant = $this->nav->getSuivant($this->item);
      $precedent = $this->nav->getPrecedent($this->item);
      $dernier = $this->nav->getPrecedent(0);
      $c = new TPanel(3,1);
      $x = new Label($this->nav->getNbDoss() . " patients au total", false, true);
      $c->addChamp($x);
      $x = new Espace(2);
      $c->addChamp($x);
      /*$futuroptions = new optionsBriocheCab($this->options->getChaine());
      $futuroptions->setOption("REC_FACT", 0);
      $futuroptions->setOption("SUP_PREST", 0);
      $futuroptions->setOption("CH_AD", 0);
      $futuroptions->setOption("CH_ST_FACT", 0);
      $futuroptions->setOption("CH_BOUCL_FACT", 0);
      */
      $x = new Bouton("...", "...", "BUTTON",
                      "if(!qModif()) ouvreFenetre(\"$fdosbrioche?action=2000&sessionid=" .
                      "$this->idsession&options=" . $this->futuroptions->getChaine() .
                      "&item=-999\", \"Recherche\", " .
                      "\"scrollbars=no,resizable=no,menubar=no,locationbar=no,height=400," .
                      "width=450,screenX=150,screenY=100\")");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(3, 1, "RIGHT", "MIDDLE");
      $x = new BoutonImage("Premier", "$imagesdir/premier.gif", 16, 16,
                           "javascript:lienCond('$fdosbrioche?action=$this->action&sessionid=$this->idsession" .
                           "&item=$premier&options=" . $this->futuroptions->getChaine() . "')");
      $c->addChamp($x);
      $x = new BoutonImage("Prcdent", "$imagesdir/precedent.gif", 16, 16,
                           "javascript:lienCond('$fdosbrioche?action=$this->action&sessionid=$this->idsession" .
                           "&item=$precedent&options=" . $this->futuroptions->getChaine() . "')");
      $c->addChamp($x);
      $x = new ChampTexte("item", "$this->item", "", 5, 6, false, "text", "d2");
      $c->addChamp($x);
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("options", $this->futuroptions->getChaine(), "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("action", $this->actif, "HIDDEN");
      $c->addChamp($x);
      $x = new BoutonImage("OK", "$imagesdir/vu.gif", 18, 16, "javascript:envoieCondNav()");
      $c->addChamp($x);
      $this->futuroptions->setOption("FORCE_DOSS", 0);
      $x = new BoutonImage("Suivant", "$imagesdir/suivant.gif", 16, 16,
                           "javascript:lienCond('$fdosbrioche?action=$this->action&sessionid=$this->idsession" .
                           "&item=$suivant&options=" . $this->futuroptions->getChaine() . "')");
      $c->addChamp($x);
      $x = new BoutonImage("Dernier", "$imagesdir/dernier.gif", 16, 16,
                           "javascript:lienCond('$fdosbrioche?action=$this->action&sessionid=$this->idsession" .
                           "&item=$dernier&options=" . $this->futuroptions->getChaine() . "')");
      $c->addChamp($x);
      $of->addChamp($c);

      $coulb = "green";

      $of->addLigneVierge();
      $c = new TBandeCouleur(6, 3, $coulb);
      $of->addChamp($c);

    }

    $this->addContenu($of->getContenu());
    //ajout du contenu spcifique
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fdosbrioche, "post");
    $of->addLigne();

    switch ($this->actif){

    //Les contenus des onglets volumineux se trouvent dans les enfants de pageDossierBrioche;
    //Onglet demande d'orientation
    case 1:
      $page = new pageDossierBriocheCabPatient($this);
      $of->addPage($page);
      break;
    //onglet Relations
    case 2:
      $page = new pageDossierBriocheCabRel($this);
      $of->addPage($page);
      break;
    //Onglet factures
    case 3:
      $page = new pageDossierBriocheCabFact($this);
      $of->addPage($page);
      break;
   
    }
    $this->addContenu($of->getContenu());
    $tf = new TabForm();
    $tf->setTabParam(760, 0, 3, 0, "#2784be");
    $c = new TLabel("&nbsp");
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TPanel(1, 1);
    //$x = new Label("<IMG SRC=\"images/brioche100.gif\" WIDTH=100 HEIGHT=26>");
    //$c->addChamp($x);
    $tf->addChamp($c);
    $c = new TPanel(1, 1, "RIGHT", "CENTER");
    $x = new Bouton("Quitter", "Fermer", "BUTTON", "fermeTout();");
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TLabel("&nbsp;");
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TLabel("&nbsp;");
    $tf->addChamp($c);
    $this->addContenu($tf->getContenu());
  }
}

?>
