<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

////////////////////////////////////////////
//
// Donnes utiles  la gestion de la comptabilit
//
///////////////////////////////////////////////

class ensCompta extends connexionBrioche {

  function __construct($sessionid){
    global $fichier;
    if (! parent::__construct($sessionid)) return;
  }

  // Obtention de la liste des exercices comptables, avec divers paramtres
  function getExercices(){
    $req = "SHOW TABLES";
    $result = mysqli_query($this->linkBrioche, $req);
    $tabdates = array();
    while ($ligne = mysqli_fetch_row($result)){
      if (preg_match("/^c(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})$/", $ligne[0],
          $matches)){
        $an1 = ($matches[1] > 94 ? $matches[1] + 1900 : $matches[1] + 2000);
        $an2 = ($matches[4] > 94 ? $matches[4] + 1900 : $matches[4] + 2000);
        $mois1 = $matches[2];
        $jour1 = $matches[3];
        $mois2 = $matches[5];
        $jour2 = $matches[6];
        $chaine = $an1 . $mois1 . $jour1 . $an2 . $mois2 . $jour2;
        $tabdates[$chaine]['date1'] = mktime(0, 0, 0, $mois1, $jour1, $an1);
        $tabdates[$chaine]['date2'] = mktime(0, 0, 0, $mois2, $jour2, $an2);
        $tabdates[$chaine]['table'] = $matches[0];
        $tabdates[$chaine]['affichage'] = date("j.n.y", $tabdates[$chaine]['date1']) . " - " .
                                          date("j.n.y", $tabdates[$chaine]['date2']) ;
        
      }
      
    }
    krsort($tabdates);
    return $tabdates;
  }

  // Soldes par ligne pour un ensTable
  function getSoldes($table, $cle, $debit, $credit){
    $tab = $table->getTableau();
    $cpt = count($tab);
    $solde = 0;
    $tabret = array();
    for ($i = 0; $i < $cpt; $i ++){
      $solde = sprintf("%0.2f", round($solde + (float) $tab[$i]->$debit - (float) $tab[$i]->$credit, 2));
      $noop = $tab[$i]->$cle;
      $tabret[$noop] = $solde;
    }
    $tabret['-1'] = $solde;
    return $tabret;
  }

  function getDebutExercice(){
    $et = new EnsTableBrioche("comptes", "deb > 100 and cred > 100 and datop is not null", "datop", "datop", $this->idsession, "", "", false, 0, 0, 1);
    $tab = $et->getTableau();
    return $tab[0]->datop;
  }

  //Cration d'une table destine  recueillir les enregistrements d'un exercice
  function bouclement($debut, $fin){
    // Cration d'une table pour l'exercice  partir du schma de "comptes"
    $nomtable = "c" . date("ymd", $this->dateFr2tst($debut)) . date("ymd", $this->dateFr2tst($fin));
    $sql = "show create table comptes";
    $result = mysqli_query($this->linkBrioche, $sql);
    $ligne = mysqli_fetch_row($result);
    $requetecr = "DROP TABLE IF EXISTS `$nomtable`";
    $result = mysqli_query($this->linkBrioche, $requetecr);
    $requetecr = preg_replace("/CREATE TABLE `comptes`/i", "CREATE TABLE `$nomtable`", $ligne[1]);
    $result = mysqli_query($this->linkBrioche, $requetecr);
    if (! $result) return false;
    // Copie des enregistrements correspondant  l'exercice.
    $requete = "INSERT INTO `$nomtable` SELECT * FROM comptes WHERE datop BETWEEN " . $this->getDateAm($debut) .
               " AND " . $this->getDateAm($fin) . " AND (deb > 100 AND cred > 100)";
    $result = mysqli_query($this->linkBrioche, $requete);
    if (! $result) return false;           
    
    //Liste des comptes pour rsultats (recettes et dpenses)
    $elc = new ensTableBrioche("listecomptes", "nocompte between 3000 and 4999",
                               "nocompte, nomcompte", "nocompte", $this->idsession);
    $tabcomptes = $elc->getTableau();
    
    // Ecriture rsultats
    $cpt = count ($tabcomptes);
    $ut = new updateTableBrioche($nomtable, 0, 0, 0, $this->idsession);  
    $etcred = new ensTableBrioche($nomtable,"" , "mtant", 0, $this->idsession);
    $etdeb = new ensTableBrioche($nomtable, "", "mtant", 0, $this->idsession);
    $tabchamps = array();
    $tabchamps['datop'] = $fin;
    $tabchamps['typedecriture'] = 11;
    $tabchamps['texte_ref'] = "Rsultat";
    $tabchamps['texte'] = "Rsultat";
    $ini = new briocheIni();
    for ($i = 0; $i < $cpt; $i++){
       $nocompte = $tabcomptes[$i]->nocompte;
       //Sommes crdits et dbits
       $etcred->setWhere("cred = $nocompte");
       $totcred = $etcred->somme("mtant");
       $etdeb->setWhere("deb = $nocompte");
       $totdeb = $etdeb->somme("mtant");
       $balance = round($totdeb - $totcred, 2);
       $tabchamps['mtant'] = abs($balance);
       $tabchamps['deb'] = ($balance > 0 ? $ini->cpteResultat : $nocompte);
       $tabchamps['cred'] = ($balance > 0 ? $nocompte : $ini->cpteResultat);
       $ut->setTabChamps($tabchamps);
       if (! $ut->ajouteEnr()) return false;
    }
    // Rsultat
    $etcred->setWhere("cred = " . $ini->cpteResultat);
    $totcred = $etcred->somme("mtant");
    $etdeb->setWhere("deb = " . $ini->cpteResultat);
    $totdeb = $etdeb->somme("mtant");
    $balance = round($totdeb - $totcred, 2);
    $tabchammps = array();
    $tabchamps['datop'] = $fin;
    $tabchamps['typedecriture'] = 11;
    $tabchamps['texte_ref'] = "Rsultat de l'exercice";
    $tabchamps['texte'] = "Rsultat de l'exercicie";
    $tabchamps['mtant'] = abs($balance);
    $tabchamps['deb'] = ($balance > 0 ? $ini->cptePrive : $ini->cpteResultat);
    $tabchamps['cred'] =($balance > 0 ? $ini->cpteResultat : $ini->cptePrive);
    $ut->setTabChamps($tabchamps);
    if (! $ut->ajouteEnr()) return false;
    
    //Compensation pertes et compte priv en cas de dcouvert
    $etcred->setWhere("cred = " . $ini->cptePrive);
    $totcred = $etcred->somme("mtant");
    $etdeb->setWhere("deb = " . $ini->cptePrive);
    $totdeb = $etdeb->somme("mtant");
    $balance = round($totdeb - $totcred, 2);
    if ($balance > 0) {
      $tabchamps = array();
      $tabchamps['datop'] = $fin;
      $tabchamps['typedecriture'] = 11;
      $tabchamps['texte_ref'] = "Compensation";
      $tabchamps['texte'] = "Compensation";
      $tabchamps['mtant'] = $balance;
      $tabchamps['deb'] = $ini->cpteDecouvert;
      $tabchamps['cred'] = $ini->cptePrive;
      $ut->setTabChamps($tabchamps);
      if (! $ut->ajouteEnr()) return false;
    }
    
    // Liste des champs pour compte bilan
    $elc = new ensTableBrioche("listecomptes", "nocompte between 1000 and 2999", "nocompte, nomcompte",
                               "nocompte", $this->idsession);
    $tabcomptes = $elc->getTableau();
    // Ecriture bilan
    $cpt = count ($tabcomptes);
    $ut = new updateTableBrioche($nomtable, 0, 0, 0, $this->idsession);  
    $etcred = new ensTableBrioche($nomtable,"" , "mtant", 0, $this->idsession);
    $etdeb = new ensTableBrioche($nomtable, "", "mtant", 0, $this->idsession);
    $tabchamps = array();
    $tabchamps['datop'] = $fin;
    $tabchamps['typedecriture'] = 11;
    $tabchamps['texte_ref'] = "Bilan";
    $tabchamps['texte'] = "Bilan";
    for ($i = 0; $i < $cpt; $i++){
       $nocompte = $tabcomptes[$i]->nocompte;
       //Sommes crdits et dbits
       $etcred->setWhere("cred = $nocompte");
       $totcred = $etcred->somme("mtant");
       $etdeb->setWhere("deb = $nocompte");
       $totdeb = $etdeb->somme("mtant");
       $balance = round($totdeb - $totcred, 2);
       $tabchamps['mtant'] = abs($balance);
       $tabchamps['deb'] = ($balance > 0 ? $ini->cpteBilan : $nocompte);
       $tabchamps['cred'] = ($balance > 0 ? $nocompte : $ini->cpteBilan);
       $ut->setTabChamps($tabchamps);
       if (! $ut->ajouteEnr()) return false;
    }
    // Remplissage champ criture
    $et = new ensTableBrioche($nomtable, "1", "noop", "datop, noop", $this->idsession);
    $tet = $et->getTableau();
    $cpt = count($tet);
    $ut->setPrimaire("noop");
    $tabchamps = array();
    for ($i = 0; $i < $cpt; $i++){
      $tabchamps['ecriture'] = $i + 1;
      $item = $tet[$i]->noop;
      $ut->setTabChamps($tabchamps);
      $ut->setItem($item);
      $ut->update();
    }
    
    // Report des soldes dans les comptes d'actif et de passif
    $et = new ensTableBrioche($nomtable, "deb = $ini->cpteBilan or cred = $ini->cpteBilan",
                              "deb, cred, mtant", 0, $this->idsession);   
    $tet = $et->getTableau();
    $cpt = count($tet);
    $dd = $this->dateFr2tst($fin);
    $datenouv = date("d.m.Y", mktime(0, 0, 0, date("m", $dd), date("d", $dd) + 1, date("Y", $dd)));
    $ut = new updateTableBrioche("comptes", $tabchamps, "", "", $this->idsession);
    $tabchamps = array();
    $tabchamps['datop'] = $datenouv;
    $tabchamps['typedecriture'] = 10;
    $tabchamps['texte'] = "Solde";
    for ($i = 0; $i < $cpt; $i++){
      $tabchamps['mtant'] = $tet[$i]->mtant;
      $tabchamps['deb'] = ($tet[$i]->deb == $ini->cpteBilan ? $tet[$i]->cred : $ini->cpteSolde);
      $tabchamps['cred'] = ($tet[$i]->deb == $ini->cpteBilan ? $ini->cpteSolde : $tet[$i]->deb);
      $ut->setTabChamps($tabchamps);
      if (! $ut->ajouteEnr()) return false;  
    }
    
    // Report d'un ventuel dcouvert dans le compte priv.
    $etcred = new ensTableBrioche("comptes","" , "mtant", 0, $this->idsession);
    $etdeb = new ensTableBrioche("comptes", "", "mtant", 0, $this->idsession);
    $etcred->setWhere("cred = " . $ini->cpteDecouvert);
    $totcred = $etcred->somme("mtant");
    $etdeb->setWhere("deb = " . $ini->cpteDecouvert);
    $totdeb = $etdeb->somme("mtant");
    $balance = round($totdeb - $totcred, 2);
    if ($balance <> 0){
      $tabchamps = $array();
      $tabchamps['datop'] = $datenouv;
      $tabchamps['typedecriture'] = 10;
      $tabchamps['texte'] = "Solde";
      $tabchamps['deb'] = $ini->cptePrive;
      $tabchamps['cred'] = $ini->cpteDecouvert;
      $tabchamps['mtant'] = $balance;
      $ut->setTabChamps($tabchamps);
      $ut->ajouteEnr();
    }
    
    // Destruction des enregistrements de l'exercice boucl.
    $req = "DELETE FROM comptes WHERE datop between " . $this->getDateAm($debut) . " AND " . $this->getDateAm($fin) .
           " AND (deb > 100 AND cred > 100)";
    $result = mysqli_query($this->linkBrioche, $req);       
    
    return true;
  }
  
  

}

?>
