<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

////////////////////////////////////////////
//
//  Dtail d'une facture
//
//////////////////////////////////////////

class ensDetailFacture extends connexionBrioche {

  var $nofact;
  var $debut;
  var $fin;
  var $quittance;
  var $status;
  var $coulstat;
  var $typeprest;
  var $ttypeprest;
  var $datefact;
  var $daterap;
  var $et;
  var $ret;
  var $nummed;
  var $nommed;
  var $cpthonoraires;
  var $cptbvr;
  var $nopat;
  var $noad;
  var $montant;
  var $bouclement;
  var $medecin;
  var $tiersxml;
  var $tpr;
  var $cdcnofact;
  var $cdcpasswd;
  var $payant;
  var $loi;
  var $tarif;

  function __construct($nofact, $idsession){
    if (! parent::__construct($idsession)) return;
    $ini = new briocheIni();
    $this->tolerance = $ini->tolerance;
    $this->nofact = $nofact;
    $join[] = "typeprest";
    $join[] = "statutsfact";
    $join[] = "medecins";
    $join[] = "patients";
    $on[] = "factures.typeprest = typeprest.id";
    $on[] = "factures.quittance = statutsfact.id";
    $on[] = "factures.medecin = medecins.id";
    $on[] = "factures.nopat = patients.nopat";
    $etf = new ensTableBrioche("factures",
                              "nofact = $this->nofact",
                              "factures.*, statutsfact.txt as status, " .
                              "statutsfact.couleur as coulstat, ".
                              "typeprest.txt as ttypeprest, typeprest.id as tpr, medecins.txt as nommed, " .
                              "medecins.cpthonoraires, medecins.cptbvr, " .
                              "typeprest.tiersxml, typeprest.payant, typeprest.loi, patients.nomal, patients.noac",
                              0, $this->idsession, $join, $on);
    $ett = $etf->getTableau();

    $this->typeprest = $ett[0]->typeprest;
    $this->ttypeprest = $ett[0]->ttypeprest;
    $this->debut = $ett[0]->debut;
    $this->fin = $ett[0]->fin;
    $this->quittance = $ett[0]->quittance;
    $this->status = ($ett[0]->quittance < 0 ? "Ouverte" : $ett[0]->status);
    $this->coulstat = ($ett[0]->quittance < 0 ? "Blue" : $ett[0]->coulstat);
    $this->datefact = $ett[0]->datefact;
    $this->daterap = $ett[0]->daterap;
    $this->montant = $ett[0]->montant;
    $this->nommed = $ett[0]->nommed;
    $this->nummed = $ett[0]->medecin;
    $this->cpthonoraires = $ett[0]->cpthonoraires;
    $this->cptbvr = $ett[0]->cptbvr;
    $this->noad = $ett[0]->noad;
    $this->nopat = $ett[0]->nopat;
    $this->bouclement = $ett[0]->bouclement;
    $this->tiersxml = $ett[0]->tiersxml;
    $this->payant = $ett[0]->payant;
    $this->loi = $ett[0]->loi;
    $this->noass = '';
    if ($this->loi == 'LAA') $this->noass = $ett[0]->noac;
    if ($this->loi == 'LAMAL') $this->noass = $ett[0]->nomal; 
    $this->tpr = $ett[0]->tpr;
    $this->cdcnofact = $ett[0]->cdcid;
    $this->cdcquittance = $ett[0]->cdcquittance;
    $this->et = new ensTableBrioche("prestations",
                                    "nofact = $this->nofact AND tarif != 999",
                                    "*, concat(LPAD(HOUR(dateprest), 2, '0'), ':', " .
                                    "LPAD(MINUTE(dateprest), 2, '0'), ':', " .
                                    "LPAD(SECOND(dateprest), 2, '0')) as heureprest",
                                    "DATE(dateprest), tarif DESC, position + deltatri",
                                     $this->idsession);
    //print $this->et->getSql();                                 
    $this->ret = new ensTableBrioche("prestations",
                                     "nofact = $this->nofact AND tarif = 999",
                                     "*", "noprest", $this->idsession,
                                     "textefactures", "prestations.noprest = textefactures.noligne");
    $emed = new ensTableBrioche("medecins", "id = $this->nummed", "*", 0, $this->idsession);
    $temed = $emed->getTableau();
    $this->medecin = $temed[0];
    
  }

  function getAdresseFact(){
    $ef = new ensFacturePat($this->nopat, $this->idsession);
    $a = array("", "", "", "");
    if ($this->noad == -1) {
        $a[0] = "$ef->politesse $ef->prenNom";
        $a[1] = $ef->adresse;
        $a[2] = $ef->nopost;
        $a[3] = $ef->ville;
    }

    else {
      switch ($this->noad){
      case -2:
      case -4:
        $notiers = $ef->asmal;
        break;
      case -3:
        $notiers = $ef->asacci;
      break;
      default:
        $notiers = $this->noad;
      }
      if ($notiers) {
        $at = new adresseTiers($notiers, $this->idsession);
        $a[0] = $at->tiers->nomp;
        $a[1] = $at->tiers->adresse;
        $a[2] = $at->tiers->nopost;
        $a[3] = $at->tiers->ville;
      }
    }
    return $a;
  }

  function getAdresseAsmal(){
    $ef = new ensFacturePat($this->nopat, $this->idsession);
    $notiers = $ef->asmal;
    $at = new adresseTiers($notiers, $this->idsession);
    $a[0] = $at->tiers->nomp;
    $a[1] = $at->tiers->adresse;
    $a[2] = $at->tiers->nopost;
    $a[3] = $at->tiers->ville;
    return $a;
  }
  
  function getLignes($limit = 0, $offset = 0){
   if ($limit || $offset){
      if (! $limit) $limit = $this->compteLignes();
      $et = new ensTableBrioche($this->et->table, $this->et->where, $this->et->champs,
                                $this->et->order, $this->idsession, $this->et->join,
                                $this->et->on, false, 0, "", $limit, $offset);
   }
    else {
      $et = $this->et;
    }
    //print $et->getSql() . "<BR>";
    return $et;
  }

  function compteLignes(){
    return $this->et->compte();
  }

  function getRemarques(){
    return $this->ret;
  }

  function getTexteRemarques(){
    $tab = $this->ret->getTableau();
    $txt = "";
    $cpt = count($tab);
    for ($i = 0; $i < $cpt; $i++){
      $txt .= $tab[$i]->texte . " - ";
    }
    return $txt;
  }

  //Code tarif (pour xml et formulaire unifi
  function getCodeTarif($tarif){
    switch ($tarif){
    case 5:
    case 6:
      return '001';
      break;
    case 4:
      // Le code labo a chang au 1.7.2009
      if (strtotime($this->getDateAm($this->datefact, 0)) < strtotime("2009-07-01")){
        return '316';
      }
      else {
        return '317';
      }
      break;
    case 50:
      return '050';
      break;
    case 51:
      return '003';
      break;
    default:
      return '999';
      break;
    }
  }

  //Total intermdiaire
  function getTotalInter($nblignes){
    $et = new ensTableBrioche($this->et->table, $this->et->where, "ttligne",
                              $this->et->order, $this->idsession, $this->et->join,
                              $this->et->on, false, 0, "", $nblignes);
    $tet = $et->getTableau();
    $somme = 0;
    for ($i = 0; $i < count($tet); $i++){
      $somme += $tet[$i]->ttligne;
    }  
    return $somme;
  }
  
  //Montant prestations tarmed
  function getMontantTarmed(){
    $et = new ensTableBrioche("prestations", "nofact = $this->nofact AND tarif = 5",
                              "SUM(ttligne) AS mtant", 0, $this->idsession);
    $tet = $et->getTableau();
    return (float) $tet[0]->mtant;
  }

  //Pts mdicaux
  function getSommePtsMed(){
    $et = new ensTableBrioche("prestations", "nofact = $this->nofact AND tarif = 5",
                              "SUM(pm * nombre) AS pm", 0, $this->idsession);
    $tet = $et->getTableau();
    return (float) $tet[0]->pm;
  }

  //Fr mdicaux
  function getSommeFrMed(){
    $et = new ensTableBrioche("prestations", "nofact = $this->nofact AND tarif = 5",
                              "SUM(pm * vpm * nombre) AS fm", 0, $this->idsession);
    $tet = $et->getTableau();
    return (float) $tet[0]->fm;
  }

  //Pts techniques
  function getSommePtsTec(){
    $et = new ensTableBrioche("prestations", "nofact = $this->nofact AND tarif = 5",
                              "SUM(pt * nombre) AS pt", 0, $this->idsession);
    $tet = $et->getTableau();
    return (float) $tet[0]->pt;
  }

  //Fr techniques
  function getSommeFrTec(){
    $et = new ensTableBrioche("prestations", "nofact = $this->nofact AND tarif = 5",
                              "SUM(pt * vpt * nombre) AS ft", 0, $this->idsession);
    $tet = $et->getTableau();
    return (float) $tet[0]->ft;
  }

  function getMontantLabo(){
    $et = new ensTableBrioche("prestations", "nofact = $this->nofact AND tarif = 4",
                              "SUM(ttligne) AS mtant", 0, $this->idsession);
    $tet = $et->getTableau();
    return (float) $tet[0]->mtant;
  }

  function getMontantAutre(){
    $et = new ensTableBrioche("prestations", "nofact = $this->nofact AND tarif NOT IN (4, 5)",
                              "SUM(ttligne) AS mtant", 0, $this->idsession);
    $tet = $et->getTableau();
    return (float) $tet[0]->mtant;
  }

  function getMontantFrC(){
    $mt = $this->montant;
    $tabm = explode(".", $mt);
    return $tabm;
  }
  
  // Statut tarmed de la facture ? 0 = non et obsolte, 1 = non et actuelle, 2 = oui et actuelle
  function getTarmed() {
    $efg = new ensFacture($this->idsession);
    $tarmed = $efg->getTarmed($this->typeprest);
    return $tarmed;
  }
  
  function getMontantPaye(){
    $etc = new ensTableBrioche("factures", "nofact = $this->nofact", "paye", 0, $this->idsession);
    $tetc = $etc->getTableau();
    $tot = $tetc[0]->paye;
    return $tot;
  }
  
  function getMontantAPayer(){
    return $this->montant - $this->getMontantPaye();
  }
  
  //Compare un montant donn avec le montant  payer
  function compareMontant($mnt){
    $somme = $this->getMontantAPayer();
    $diff = $mnt - $somme;
    if (abs($diff) > $this->tolerance){
       if ($diff > 0) return 1;
       else return -1;
    }
    else return 0;
  }

  // Recalcule montant et dates dbut et fin de la facture
  function recalcule($dateprest=""){
    //$this->convertit($this->typeprest);
    $this->calcMajor();
    $this->plusDeSoins($dateprest);
    $ini = new briocheIni();
    if ($ini->supplAuto) {
      $this->calculSuppLabo();
    }
    $tab = $this->et->getTableau();
    $cpt = count($tab);
    $total = 0;
    for ($i = 0; $i < $cpt; $i++){
      $total += $tab[$i]->ttligne;
    }
    if (! count($tab)){
      $tab[0] = (object) array("dateprest" => "");
      $cpt = 1;
    }
    $total = $this->arrondit($total);
    $debut = $tab[0]->dateprest;
    $fin = $tab[$cpt-1]->dateprest;
    $tabchamps['montant'] = $total;
    $tabchamps['debut'] = $debut;
    $tabchamps['fin'] = $fin;
    $ut = new updateTableBrioche("factures", $tabchamps, $this->nofact, "nofact", $this->idsession);
    if (! $ut->update()) print "PROBLEME";
    self::__construct($this->nofact, $this->idsession);
    
  }
  
  //recalcule aprs autoconversion
  function recalculeplus(){
    $this->convertit($this->typeprest);
  }
  
  
  // Depuis tarmed 1.09, substitue des prestations + en cas de dpassement des quoatas
  function plusDeSoins($dateprest=""){
    // pt examen
    if (! $dateprest) return; 
    if ($this->getTarmed() == 5) return;
    $enf = new ensFacturePat($this->nopat, $this->idsession);
    $quota = $enf->getQuota(415, $dateprest, $this->typeprest, $this->medecin->id, false, 0);
    if ($quota < 6) $this->remplacePrest(415, 417);
    $quota = $enf->getQuota(510, $dateprest, $this->typeprest, $this->medecin->id, false, 0);
    if ($quota < 6) $this->remplacePrest(510, 516);
    $quota = $enf->getQuota(610, $dateprest, $this->typeprest, $this->medecin->id, false, 0);
    if ($quota < 6) $this->remplacePrest(610, 616);
    $quota = $enf->getQuota(50, $dateprest, $this->typeprest, $this->medecin->id, false, 0);
    if ($quota < 6) $this->remplacePrest(50, 56);
    $quota = $enf->getQuota(141, $dateprest, $this->typeprest, $this->medecin->id, false, 0);
    for ($i = 1 ; $i < 7 ; $i++){
      if ($quota < 31) $this->remplacePrest((140 + $i), (160 + $i));
    }
  }
  
  //Calcul des supplments pour labo
  function calculSuppLabo() {
    $anfact = floor($this->nofact/100000);
    if ($anfact >= 15 && $anfact < 95){ // On ne touche plus aux factures d'avant 2015
      //Construction du tableau des jours Labo
      $etDatLab = new ensTableBrioche("prestations", "nofact = $this->nofact and tarif = 4 and position < 399999",
                                      "TO_DAYS(dateprest) AS jour, dateprest", "TO_DAYS(dateprest)", $this->idsession, 0, 0, true);
      //Dates des consultations
      $etDatCons = new ensTableBrioche("prestations", "nofact = $this->nofact and tarif = " . $this->getTarmed() . " and position IN (10, 60, 380430)",
                                     "TO_DAYS(dateprest) AS jour", "TO_DAYS(dateprest)", $this->idsession, 0, 0, true);
      $tabDatLab = $etDatLab->getTableau();
      $tabDatCons = $etDatCons->getTableau();
      $datesCons = array();
      foreach ($tabDatCons as $ligne){
        $datesCons[] = $ligne->jour;
      }
      foreach ($tabDatLab as $dateLab) {
        $where = "nofact = $this->nofact and tarif = 4 and position < 399999 AND TO_DAYS(dateprest) = $dateLab->jour";
        $etPrest = new ensTableBrioche("prestations", $where, "position, nombre", 0, $this->idsession, "tarif");
        $tabPrest = $etPrest->getTableau();
        $etLaboJour = new ensTableBrioche("prestations", "TO_DAYS(dateprest) = $dateLab->jour", "noprest, position", 0,
                                          $this->idsession);
        $chimie = 0;
        $autre = 0;
        $wheregen = "tarif = 4 AND TO_DAYS(dateprest) = $dateLab->jour AND nofact = $this->nofact";    
        foreach ($tabPrest as $prest) {
          $etTar = new ensTableBrioche("tarif", "tarif = 4 and position = $prest->position", "ch", 0, $this->idsession);
          $tabTar = $etTar->getTableau();
          $type = $tabTar[0]->ch;
          $nb = $prest->nombre;
          //exclusion des prestations en .01
          if ($prest->position % 10 == 0){
            if ($type == "C"){
              $chimie = $chimie + $nb;
            }
            else {
              $autre = $autre + $nb;
            } 
          }
        }
        $nbAnalyses = $chimie + $autre;
      
        if ($this->existeSuppLabo()) { //les supplments sont activs
          
          $total = ($chimie * 2 + $autre);
          if ($total > 20) {
            if ($total % 2 == 1){
              if ($autre > 0) $autre --;
            }
          }
          $total = ($chimie * 2 + $autre);
         
          while ($total > 20){
            if ($chimie > 0){
              $chimie --;
            }
            else {
              break;
            }  
            $total = ($chimie * 2 + $autre);
          }
          while ($total > 20){
            $autre --;
          }
           
          //Taxe de prsence supprime en 2015
          //$noTaxePres = $etLaboJour->lookUp("noprest", "$wheregen AND position = 470700");
          //$this->addPrestation(1, 470700, $this->getDateheure($dateLab->dateprest), 4, false, $noTaxePres, true);
          $noSupplC = $etLaboJour->lookUp("noprest", "$wheregen AND position = 470710");
          $this->addPrestation($chimie, 470710, $this->getDateheure($dateLab->dateprest), 4, false, $noSupplC, true);
          $noSupplA = $etLaboJour->lookUp("noprest", "$wheregen AND position = 470720");
          $this->addPrestation($autre, 470720, $this->getDateheure($dateLab->dateprest), 4, false, $noSupplA, true);
        }
      
        if (in_array($dateLab->jour, $datesCons)) {
          //Il y a une consultation le jour du labo
          //Destruction des ventuelles prestations en l'absence automatiques
          $where = "nofact = $this->nofact and tarif = 5 and position in (140, 380430) and autom = 1 and TO_DAYS(dateprest) = $dateLab->jour";
          $etDel = new ensTableBrioche("prestations", $where, "*", 0, $this->idsession);
          //print "<BR>Destruction 1 --- " . $etDel->compte();
          $etDel->detruitEnsemble();
          //Ajout des supplments automatiques
        
        }
        else {
          //Il n'y a pas de consultation le jour du labo
          //Destruction des ventuels supplments automatiques -- supprim en 2015
          //$where = "nofact = $this->nofact and tarif = 4 and position IN (470700, 470710, 470720) and autom = 1 and TO_DAYS(dateprest) = $dateLab->jour";
          //$etDel = new ensTableBrioche("prestations", $where, "*", 0, $this->idsession);
          //print "<BR>DESTRUCTION2 --- " . $etDel->compte();
          //$etDel->detruitEnsemble();
          //Ajout des prestations en absence automatiques
          //$tarif = $this->getTarmed();
          //if ($tarif == 5) {
          //  $noPrestAbs = $etLaboJour->lookUp("noprest", "tarif = 5 AND TO_DAYS(dateprest) = $dateLab->jour AND position in(140, 380430) AND autom = 1");
          //  $this->addPrestation(1, 140, $this->getDateheure($dateLab->dateprest), 5, false, $noPrestAbs, true);
          //}
        }
        // Ajout des supplments de transition
        if ($this->existeSupplTrans()){
          $noTransition = $etLaboJour->lookUp("noprest", "$wheregen AND position = 470800");
          $this->addPrestation($nbAnalyses, 470800, $this->getDateheure($dateLab->dateprest), 4, false, $noTransition, true); 
        }
      }
    
    
      // Tous les jours o il y a des prestations
      $etDat = new ensTableBrioche("prestations", "nofact = $this->nofact",
                                         "TO_DAYS(dateprest) AS jour", 0, $this->idsession, 0, 0, true);
      $tabDat = $etDat->getTableau();
      $tabDatePrest = array();
      foreach($tabDat as $dateprest){
        $tabDatePrest[] = $dateprest->jour;
      }
      // Les jours o il y a du labo
      $etDat->setWhere("nofact = $this->nofact AND tarif = 4 AND position < 399999");
      $tabDat = $etDat->getTableau();
      $tabDateLabo = array();
      foreach($tabDat as $dateprest){
        $tabDateLabo[] = $dateprest->jour;
      }
      // Jours avec prestations mais sans labo
      foreach($tabDatePrest as $dateprest){
        if (! in_array($dateprest, $tabDateLabo)){
          $etDel = new ensTableBrioche("prestations",
                                       "autom = 1 AND nofact = $this->nofact AND TO_DAYS(dateprest) = $dateprest " .
                                       "AND ((tarif = 5 and position = 140) OR (tarif = 4 AND position IN (470700, 470710, 470720, 470800)))",
                                       "*", 0, $this->idsession);
          //PRINT "<BR>Destruction3 --- " . $etDel->compte();
          $etDel->detruitEnsemble();                             
        }
      }
    }
  }
  
  //Les supplments sont-ils dans la base ?
  function  existeSuppLabo(){
    $et = new ensTableBrioche("tarif", "tarif = 4 and (position = 470710 OR position = 470720) and masquer = 0",
                              "position", 0, $this->idsession);
    if ($et->compte()==2) return true;
    return false;
  }
  //Le supplment de transition est-il dans la base ?
  function existeSupplTrans(){
    $et = new ensTableBrioche("tarif", "tarif = 4 and position = 470800 and masquer = 0", "position", 0, $this->idsession);
    if ($et->compte()) return true;
    return false;
  }
  
    
  //Dfinit la quittance du cdc
  function setCdcQuittance($quit, $cdcnofact = 0){
      if ($cdcnofact){
        $tabcdc['cdcid'] = $cdcnofact;
      }
      $tabcdc['cdcquittance'] = $quit;
      $ucdc = new updateTableBrioche("factures", $tabcdc, $this->nofact, "nofact",
                                     $this->idsession);
      $ucdc->update();
  }

  //Prpare pour l'impression des factures ou des rappels et cre v. les fichiers xml
  function prepare($impgroupe = false){
    //Factures
    $ini = new briocheIni();
    if ($this->quittance == 1) {
      $tabchamps['quittance'] = 2;
      if (! $this->datefact) $tabchamps['datefact'] = $this->aujourdhui();
    }
    // Toute impression provoque l'envoi au CDC
    //if ($this->cdcquittance == 0){ //xml pas encore envoy => quittance  1 pour que la facture soit rcupre
    $this->setCdcQuittance(1, $this->cdcnofact);
    //}
    //Rappels
    if ($this->quittance >= 2 && $this->quittance < 6 && $impgroupe){
      $tabchamps['quittance'] = $this->quittance + 1;
      $tabchamps['daterap'] = $this->aujourdhui();
    }
    if (isset($tabchamps)){
      $ut = new updateTableBrioche("factures", $tabchamps, $this->nofact,
                                   "nofact", $this->idsession);
      $ut->update();
    }
    self::__construct($this->nofact, $this->idsession);
  }
  //Change le mdecin (par rotation)
  function changeMed(){
    if (! $this->isOuvert()) return false;
    $emed = new ensTableBrioche("medecins", "id > $this->nummed", "id", "id",
                                $this->idsession, 0, 0, false, 0, "", 1);
    if (! $emed->compte()) {
      $emed->setWhere(1);                            
    }
    $temed = $emed->getTableau();
    $nomed = $temed[0]->id;
    /*
    if ($this->nummed == 1) $this->nummed = 2;
    elseif ($this->nummed == 2) $this->nummed = 1;
    */
    $tabchamps['medecin'] = $nomed;
    $ut = new updateTableBrioche("factures", $tabchamps, $this->nofact, "nofact", $this->idsession);
    if (! $ut->update()) print "PROBLEME";
    self::__construct($this->nofact, $this->idsession);
    
  }
  // Change squence bouclement
  function changeBoucl($mode){
    $tabchamps['bouclement'] = $mode;
    if ($mode == 9){//Rotation
      $tabchamps['bouclement'] = "IF(bouclement = 3, 1, bouclement + 1)"; 
    }
    $ut = new updateTableBrioche("factures", $tabchamps, $this->nofact, "nofact", $this->idsession);
    if (! $ut->update()) print "PROBLEME";
    self::__construct($this->nofact, $this->idsession);
  }
  //Boucle la facture
  function boucle(){
    
    if (! $this->isOuvert()) return false;
    if ($this->quittance == 0) {
      $tabchamps['quittance'] = 1;
    }
    else {
      $tabchamps['quittance'] = - $this->quittance;
    }
    $ut = new updateTableBrioche("factures", $tabchamps, $this->nofact, "nofact", $this->idsession);
    if (! $ut->update()) print "PROBLEME";
    self::__construct($this->nofact, $this->idsession);
    
  }

  //Rouvre la facture (tout repart  0)
  function rouvre(){
    if (! $this->isRouvrable()) return false;
    $tabchamps['quittance'] = 0;
    $tabchamps['datefact'] = "";
    $tabchamps['daterap'] = "";
    $ut = new updateTableBrioche("factures", $tabchamps, $this->nofact, "nofact", $this->idsession);
    if (! $ut->update()) print "PROBLEME";
    self::__construct($this->nofact, $this->idsession);
    $this->supOp();
  }

  function entrOuvre(){
    if (! $this->isEntrouvrable()) return;
    $tabchamps['quittance'] = - $this->quittance;
    $ut = new updateTableBrioche("factures", $tabchamps, $this->nofact, "nofact", $this->idsession);
    if (! $ut->update()) print "PROBLEME";
    self::__construct($this->nofact, $this->idsession);
    $this->supOp();
  }

  //Change la quittance
  function setQuittance($num){
    $tabchamps['quittance'] = $num;
    $utf = new updateTableBrioche("factures", $tabchamps, $this->nofact, "nofact", $this->idsession);
    return $utf->update();
  }
  //Convertit (d'un type  un autre)
  function convertit($typeprest){
    $efg = new ensFacture($this->idsession);
    if (! $this->isOuvert() || $this->getTarmed() != $efg->getTarmed($typeprest)) return;
    //Chgt type facture dans la table factures
    $tabchamps['typeprest'] = $typeprest;
    $ut = new updateTableBrioche("factures", $tabchamps, $this->nofact, "nofact", $this->idsession);
    if ($ut->update()){ // Changement de la valeur du point 
      self::__construct($this->nofact, $this->idsession);
      $lig = $this->et->getTableau();
      $cpt = count ($lig);
      for ($i = 0; $i < $cpt; $i++){
        if ($lig[$i]->tarif == 5 || $lig[$i]->tarif == 6){ //tarmed
          $dateheure = $this->getDateAm($lig[$i]->dateprest, false);
          //print $lig[$i]->position . "<br>";
          $vpt = $this->getVal("pt", $dateheure);
          $vpm = $this->getVal("pm", $dateheure);
          $fpt = $this->getFacteur("fpt", $dateheure);
          $fpm = $this->getFacteur("fpm", $dateheure);
          $tabchamps['vpm'] = $vpm;
          $tabchamps['vpt'] = $vpt;
          $tabchamps['fpm'] = $fpm;
          $tabchamps['fpt'] = $fpt;
          $totalligne = ($this->arronditCt($fpm * $lig[$i]->pm * $vpm) + $this->arronditCt($fpt * $lig[$i]->pt * $vpt)) * $lig[$i]->nombre;
          $tabchamps['ttligne'] = $totalligne;
          $utp = new updateTableBrioche("prestations", $tabchamps, $lig[$i]->noprest, "noprest", $this->idsession);
          $utp->update();
        }
      }
      
    }
    self::__construct($this->nofact, $this->idsession);
    $this->recalcule();
  }
  
    
  //Rembourse un montant donn  une facture et crdite compte tlgiro du montant correspondant
  function rembourse($mnt, $datop){
    if ($this->isOuvert()) return false;
    //Mise  jour table facture
    $quitt = 99;
    if ($this->compareMontant(-$mnt) == -1) $quitt = 98;
    elseif ($this->compareMontant(-$mnt) == 1) $quitt = 100;
    $this->setQuittance($quitt);
    //Ecriture comptable
    $ini = new briocheIni();
    $ep = new ensFacturePat($this->nopat, $this->idsession);
    $tabchamps['deb'] = $this->cpthonoraires;
    $tabchamps['cred'] = $ini->cpteTransit;
    $tabchamps['mtant'] = $mnt;
    $tabchamps['datop'] = $datop;
    $tabchamps['typedecriture'] = 6;
    $tabchamps['texte'] = "Remboursement " . $ep->getNoAbr($this->nofact);
    $tabchamps['de_pour'] = $ep->nomplein;
    $tabchamps['lien'] = $this->nofact;
    $utc = new updateTableBrioche("comptes", $tabchamps, 0, 0, $this->idsession);
    if (! $utc->ajouteEnr()) return false;
    // Ecriture champ paye
    $tabmontant['paye'] = "paye - $mnt";
    $utm = new updateTableBrioche("factures", $tabmontant, $this->nofact, "nofact", $this->idsession);
    return $utm->update();
  }
  
  //Acquitte la facture d'un montant donn
  function acquitte($mnt, $compte, $typecr = 1, $datop){
    if ($this->isOuvert()) return false;
    if ($compte == 0) { // Acquittement automatique bvr
      $compte = $this->cptbvr;
    }
    //Mise  jour table factures
    $quitt = 99;
    if ($this->compareMontant($mnt) == -1) $quitt = 98;
    elseif ($this->compareMontant($mnt) == 1) $quitt = 100;
    $this->setQuittance($quitt);
    //Ecriture comptable
    $ep = new ensFacturePat($this->nopat, $this->idsession);
    $tabchamps['deb'] = $compte;
    $tabchamps['cred'] = $this->cpthonoraires;
    $tabchamps['mtant'] = $mnt;
    $tabchamps['datop'] = $datop;
    $tabchamps['typedecriture'] = $typecr;
    $tabchamps['texte'] = $ep->getNoAbr($this->nofact);
    $tabchamps['lien'] = $this->nofact;
    $tabchamps['de_pour'] = $ep->nomplein;
    $utc = new updateTableBrioche("comptes", $tabchamps, 0, 0, $this->idsession);
    if (! $utc->ajouteEnr()) return false;
    //Ecriture champ paye
    $tabmontant['paye'] = "paye + $mnt";
    $utm = new updateTableBrioche("factures", $tabmontant, $this->nofact, "nofact", $this->idsession);
    return $utm->update(); 
  }

  //Dtruit opration comptable de bouclement lors de rouverture
  function supOp(){
    $et = new ensTableBrioche("comptes",
                              "lien = $this->nofact AND typedecriture = 0", "*", 0,
                              $this->idsession);
    $et->detruitEnsemble();
  }
  //Supprime une prestation
  function supPrest($noprest){
    return $this->et->detruitEnr("noprest", $noprest);
  }

  
  // Renvoie le libell correspondant  une prestation
  function getLibelle($noprest, $complet = false){
    $pos = $this->et->lookUp("position", "noprest = $noprest");
    $tarif = $this->et->lookUp("tarif", "noprest = $noprest");
    if ($tarif == 99){
      $etf = new ensTableBrioche("textefactures", "noligne = $noprest", "texte", 0,
      $this->idsession);
      $tetf = $etf->getTableau();
      return $tetf[0]->texte;
    }
    $etr = new ensTableBrioche("tarif", "tarif = $tarif AND position = $pos",
                               (($tarif == 5 || $tarif == 6) && $complet ? "textecompl as texte" : "texte"), 0,
                                $this->idsession);
    $tetr = $etr->getTableau();
    if (! count($tetr)) return "";
    $retour = $tetr[0]->texte;
    return $retour;
  }



  //Formatage pm et pt
  function supprZero($nb){
    if ($nb == 0) return "";
    return $nb;
  }

  function isRappel(){
    if ($this->quittance > 2 && $this->quittance < 6) return $this->quittance - 2;
    return false;
  }

  // La facture est-elle ditable ??
  function isEditable(){
    if ($this->typeprest < 7) return false;
    return true;
  }
  // La facture est-elle ouverte et ditable ??
  function isOuvert() {
    if (! $this->isEditable()) return false;
    if ($this->quittance > 0) return false;
    return true;
  }

  // La facture est-elle rouvrable ?
  function isRouvrable() {
    if (! $this->isEditable()) return false;
    if ($this->isOuvert()) return false;
    if ($this->quittance < 90) return true;
    return false;
  }

  // La facture est-elle imprimable ?
  function isImprimable() {
    return (! $this->isOuvert());
  }

  
  
  // La facture est-elle entrouvrable
  function isEntrOuvrable() {
    if ($this->isRouvrable() && $this->quittance > 1) return true;
    return false;
  }
  // Modification de l'adresse de facturation
  function setAdFact($noad){
    $tabchamps['noad'] = $noad;
    $ut = new updateTableBrioche("factures", $tabchamps, $this->nofact, "nofact", $this->idsession);
    $ut->update();
  }

  // Renvoie une datheure formate pour addPrestation
  function getDateheure($date, $heure = ""){
    if ($heure == "") $heure = "11:59";
    $tabheure = explode(":", $heure);
    $tabdate = explode(".", $date);
    $datheure = date("Y-m-d H:i", mktime($tabheure[0], $tabheure[1], 0,
                     $tabdate[1], $tabdate[0], $tabdate[2]));
    return $datheure;
  }
  
  // Arrondit le total de la facture  5 c.
  function arrondit($mtant){
    return round($mtant*20)/20;
  }

  
  // Arrondi au centime (exigence TARMED cf. message Steinhauslin avril 2005)
  function arronditCt($somme){
    
    $arrondi = round($somme, 2);
    //print "somme $somme - $arrondi";
    return $arrondi;
  }
  
  // Ajout d'un cookie retenant la date de la dernire prestation pour 5 minutes
  function setCookieDate($date){
    return setcookie("DateDerPrest", $date, time() + (5 * 60));
  }
  
  // Rcupration du cookie date
  static function getCookieDate(){
    if (! isset($_COOKIE['DateDerPrest'])) return;
    return $_COOKIE['DateDerPrest'];
  }
  
  // Remplacement d'une prestation par une autre dans cette facture
  function remplacePrest($de, $vers){
    $tabchamps['position'] = $vers;
    $where = "nofact = " . $this->nofact;
    $ut = new updateTableBrioche("prestations", $tabchamps, $de, "position", $this->idsession);
    $ut->setWhere($where);
    return $ut->update();
    
  }
  
  // Ajout d'une prestation
  function addPrestation($nb, $position, $dateheure, $tarif, $recalcule = true, $aModifier = 0, $autom = 0){
    
    if ((! $this->isEditable()) || (! $this->isOuvert())) return;
    $fact = $this->getFacteur("fpm", $dateheure);
    $tabchamps['dateprest'] =  $dateheure;
    if ($tarif == 9){ // prestation sur mesure
      $this->addSurMes($nb, $position, $dateheure);
    }
    else {
      //  Patch SUVA
      $montarif = "tarif = $tarif ";
      if ($tarif == 4) {
        $montarif = "tarif IN (4,50,51) ";
      
      }
      //
      $mtar = new ensTableBrioche("tarif", "position = $position AND $montarif",
                                  "*", 0, $this->idsession);
      $tmtar = $mtar->getTableau();
      $lignetar = $tmtar[0];
      
      $tabchamps['nofact'] = $this->nofact;
      
      $tabchamps['position'] = $position;
      $tabchamps['nombre'] = $nb;
      $tabchamps['tarif'] = $lignetar->tarif;
      
      
      $tabchamps['pm'] = $lignetar->pm;
      $tabchamps['pt'] = $lignetar->pt;
      $tabchamps['autom'] = $autom;
      if ($tarif == 5 || $tarif == 6){
        //print strtotime($dateheure) . "/" . strtotime("2014-10-01");
        if ($tarif == 5 && strtotime($dateheure) >= strtotime("2014-10-01")){ // correction mdecine de famille 2014
          //print ".........";
          if (in_array($this->getChapitre($position), array(4,5,8,15,17,19,21,24,31,32,35,37,39))){
            $tabchamps['pt'] = round($tabchamps['pt']*91.5/100, 2); // rduction linaire
          }
        }
        
        $tabchamps['vpm'] = $this->getVal("pm", $dateheure);
        $tabchamps['vpt'] = $this->getVal("pt", $dateheure);
        $tabchamps['fpm'] = $this->getFacteur("fpm", $dateheure);
        $tabchamps['fpt'] = $this->getFacteur("fpt", $dateheure);
        $tabchamps['valpoint'] = $this->getVal("pm", $dateheure);
        $tabchamps['deltatri'] = $lignetar->deltatri;
      }
      else { // labo
        $tabchamps['fpm'] = 1;
        $tabchamps['fpt'] = 1;
        $tabchamps['vpm'] = 0;
        $tabchamps['vpt'] = $this->getVal("pl", $dateheure);
        // SUVA : VALEUR DU POINT PROPHYLAXIE -  dcommenter si diffrente de 4
        //if ($lignetar->tarif == 50){
        //  $tabchamps['vpt'] = .92;
        //}
        $tabchamps['valpoint'] = $this->getVal("pl", $dateheure);
      }
      
      $tabchamps['points'] = $lignetar->pm + $lignetar->pt;
      $tabchamps['ttligne'] = $nb * (($this->arronditCt($tabchamps['fpm'] * $tabchamps['pm'] * $tabchamps['vpm'])) +
                              $this->arronditCt($tabchamps['fpt'] * $tabchamps['pt'] * $tabchamps['vpt']));
      
      $ut = new updateTableBrioche("prestations", $tabchamps, $aModifier, "noprest", $this->idsession);
      if ($aModifier) {
        if ($nb) {
          if (! $ut->update()){
            print "PROBLEME UPDATE";
            return false;
          }
        }
        else {
          if (! $ut->detruitEnr()) {
            print "PROBLEME DESTRUCTION";
            return false;
          }
        }
      }
      else {
        if ($nb){
          if (! $ut->ajouteEnr()){
            print "PROBLEME";
            return false;
          }
        }
      } 
    }
    if (! $autom) $this->setCookieDate($tabchamps['dateprest']);
    //print "y<br>";
    //print $dateheure . "<br>";
    if($recalcule) $this->recalcule($tabchamps['dateprest']);
    //print "z<br>";
    return true;
  }

  //Ajoute une prestation sur mesure
  function addSurMes($nb, $position, $datheure){
    $enr = new enrBriocheCab($this->nofact, $this->idsession);
    $nopr = $enr->creeNouveau("prestations");
    $et = new ensTableBrioche("prestsurmes", "idprest = $position", "*", 0, $this->idsession);
    $tet = $et->getTableau();
    $tet = $tet[0];
    $tabchamps['dateprest'] = $datheure;
    $tabchamps['ttligne'] = $tet->prix * $nb;
    $tabchamps['nombre'] = $nb;
    $tabchamps['tarif'] = 99;
    $tabchamps['points'] = $tet->prix;
    $tabchamps['valpoint'] = 1;
    $tabchamps['pt'] = $tet->prix;
    $tabchamps['vpt'] = 1;
    $tabchamps['nofact'] = $this->nofact;
    $utp = new updateTableBrioche("prestations", $tabchamps, $nopr, "noprest", $this->idsession);
    if ($utp->update()){
      $tabchamps = array();
      $tabchamps['texte'] = $tet->libelle;
      $tabchamps['noligne'] = $nopr;
      $utt = new updateTableBrioche("textefactures", $tabchamps, "", "", $this->idsession);
      if ($utt->ajouteEnr()){
        return true;
      }
      else return false;
    }
    else return false;
  }
  
  //Ajoute prestation libre ou remarque
  function addLibRem($type, $texte, $dateprest = "", $montant = ""){
    $enr = new enrBriocheCab($this->nofact, $this->idsession);
    $nopr = $enr->creeNouveau("prestations");
    if ($dateprest){
      $tabchamps['dateprest'] = $this->getDateHeure($dateprest, "");
      $this->setCookieDate($tabchamps['dateprest']);
    }
    if ($montant){
      $tabchamps['ttligne'] = $montant;
      $tabchamps['nombre'] = 1;
      $tabchamps['tarif'] = 99;
      $tabchamps['points'] = $montant;
      $tabchamps['valpoint'] = 1;
      $tabchamps['pt'] = $montant;
      $tabchamps['vpt'] = 1;
    }
    else {
      $tabchamps['tarif'] = 999;
    }
    $tabchamps['nofact'] = $this->nofact;
    $utf = new updateTableBrioche("prestations", $tabchamps, $nopr, "noprest", $this->idsession);
    if ($utf->update()) {
      $tabchamps = array();
      $tabchamps['texte'] = $texte;
      $tabchamps['noligne'] = $nopr;
      $utt = new updateTableBrioche("textefactures", $tabchamps, "", "", $this->idsession);
      if($utt->ajouteEnr()){
        $this->recalcule();
        return true;
      }
      else return false;
    }
    else return false;
  }

  //Majore les prestations en cas d'urgence
  function majorUrg($dateheure, $grprest = 1){
    $tu = $this->getTypeUrg($dateheure, $grprest);
    switch($tu){
    case "A":
      $this->addPrestation(1, 2510, $dateheure, 5);
      break;
    case "B":
      $this->addPrestation(1, 2520, $dateheure, 5);
      $this->addPrestation(1, 2530, $dateheure, 5);
      break;
    case "C":
      $this->addPrestation(1, 2540, $dateheure, 5);
      $this->addPrestation(1, 2550, $dateheure, 5);
      break;
    case "D":
      $this->addPrestation(1, 2560, $dateheure, 5);
      $this->addPrestation(1, 2570, $dateheure, 5);
      break;
    case "E":
      $this->addPrestation(1, 2580, $dateheure, 5);
      $this->addPrestation(1, 2590, $dateheure, 5);
      break;
    }
    //Calcul des ventuelles majorations;
    $this->calcMajor();
  }

  function calcMajor(){
    $ensm = new ensTableBrioche("prestations",
                                "position IN (2530, 2550, 2570, 2590) " .
                                "AND nofact = $this->nofact",
                                "*", 0, $this->idsession);
    $tensm = $ensm->getTableau();
    $cpt = count($tensm);
    $maj[2530] = .25;
    $maj[2550] = .50;
    $maj[2570] = .25;
    $maj[2590] = .50;
    for($i = 0; $i < $cpt; $i++){
      if ($tensm[$i]->position <= 2550){ //cons. ou visite.
        $eprest = new ensTableBrioche("prestations",
                                      "position NOT IN (2510, 2520, 2530, 2540, 2550, 2560, 2570, " .
                                      "2580, 2590, 110, 120, 130) " .
                                      "AND nofact = $this->nofact AND TO_DAYS(dateprest) = " .
                                      "TO_DAYS(" . $this->getDateAm($tensm[$i]->dateprest) .")",
                                      "SUM(pm * nombre) AS sompt", 0, $this->idsession);

      }
      else { //Tl.
        $eprest = new ensTableBrioche("prestations",
                                      "position IN (110, 120, 130) " .
                                      "AND nofact = $this->nofact AND TO_DAYS(dateprest) = " .
                                      "TO_DAYS(" . $this->getDateAm($tensm[$i]->dateprest) .")",
                                      "SUM(pm) AS sompt", 0, $this->idsession);
      }
      $teprest = $eprest->getTableau();
      $majoration = $maj[$tensm[$i]->position] * $teprest[0]->sompt;
      $tabchamps['pm'] = $majoration;
      $tabchamps['nombre'] = 1;
      $tabchamps['ttligne'] = $this->getVal("pm", $this->getDateAm($tensm[$i]->dateprest, 0)) * $majoration;
      $ut = new updateTableBrioche("prestations", $tabchamps, $tensm[$i]->noprest, "noprest",
                                   $this->idsession);
      if (! $ut->update()) print "PROBLEME";
    }

  }

  //Renvoie le type d'urgence
  function getTypeUrg($dateheure, $grprest){
    $tst = strtotime($dateheure);
    $cj = new CJourCab(date("Y", $tst), date("m", $tst), date("d", $tst));
    $heure = date("H", $tst);
    $jsem = date("w", $tst);
    if ($heure > 21 || $heure < 7){
      if($grprest == 3) return "E";
      else return "C";
    }
    if ($heure > 18 && $heure <= 21){
      if($grprest == 3) return "D";
      else return "B";
    }
    if ($heure > 11 && $jsem == 6){
      if($grprest == 3) return "D";
      else return "B";
    }
    if ($cj->isFerie() || $jsem == 0){
      if($grprest == 3) return "D";
      else return "B";
    }
    if ($grprest == 3) return false;
    else return "A";
  }

  // Renvoie la valeur du facteur appliqu, par mdecin et par type de prestation
  // Utiliser "fpm", "fpt"
  function getFacteur($point, $dateheure){
    $etp = new ensTableBrioche("factpmptdate",
                               "facteur = \"" . $point . "\" and typeprest = $this->typeprest and medecin = " . $this->medecin->id . " and date <= \"$dateheure\"",
                               "valeur", "date DESC", $this->idsession);
    $tetp = $etp->getTableau();
    $valeur = $tetp[0]->valeur;
    //print "<--- $valeur --->";
    return $valeur;
  }
  
  // Renvoie la valeur du point, mdical, technique ou labo pour une certaine date
  // Utiliser "pm", "pt", "pl"
  function getVal($point, $dateheure){
    //Dtermination du groupe
    $efp = new ensFacturePat($this->nopat, $this->idsession);
    if ($this->loi == "LAMAL"){
      $groupe = $efp->getGroupe();
    }
    else {
      $groupe = 0;
    }
    //print $groupe . "<br>";
    $etp = new ensTableBrioche("valpointdate",
                               "point = \"$point\" AND typeprest = $this->typeprest " .
                               "AND date <= \"$dateheure\""  . ($groupe ? " AND groupass = $groupe": ""),
                               "montant", "date DESC, montant DESC", $this->idsession);
    //print $etp->getSql() . "<br>";
    $tetp = $etp->getTableau();
    $valeur = $tetp[0]->montant;
    //print "<" . strtotime($dateheure) . ">" . "/" . strtotime("2014-10-01") . "/";
    
    return $valeur;
  }

  // Renvoie le chapitre du tarmed
  function getChapitre($position){
    $chap = floor($position/10000);
    return $chap;
  }
  //Une position donne est-elle prslectionne ?
  //function estSelPos($no){
  //  $et = new ensTableBrioche("tarif", "position = $no AND tarif = 5", "position", 0, $this->idsession);
  //  return $et->compte();
  //}
  
  //Formatage de la position en fonction du tarif
  function formatePos($noprest){
    $pos = $this->et->lookUp("position", "noprest = $noprest");
    $tarif = $this->et->lookUp("tarif", "noprest = $noprest");
    return ensFacture::formatePos($pos, $tarif);
  }

  //Colonne Code rf. du formulaire unifi
  function getCodeRef($tarif, $position){
    if ($tarif != 5) return "";
    $et = new ensTableBrioche("tarif", "tarif = $tarif AND position = $position",
                              "codref", 0, $this->idsession);
    $tet = $et->getTableau();
    $retour = $tet[0]->codref;
    if (! $retour) return "";
    //return sprintf("%02d.%04d", $retour/10000, ($retour/10000 - floor($retour/10000))*10000);
    return $retour . "";
  }
  //Le code en question gnre-t-il une nouvelle sance ?
  function nouvSeance($tarif, $position){
    if($tarif != 5) return 0;
    $et = new ensTableBrioche("tarif", "tarif = 5 AND position = $position",
                              "nouvseance", 0, $this->idsession);
    $tet = $et->getTableau();
    return $tet[0]->nouvseance;

  }
  //Numro de contrle BVR
  function getNoControle($noatraiter){
    $report = 0;
    $cpt = strlen($noatraiter);
    for($i = 0; $i < $cpt; $i++){

      $report = substr($this->lignereport($report), substr($noatraiter, $i, 1), 1);
      //print "<BR>I : $i - CH : " . substr($noatraiter, $i, 1) . " - R : $report<BR>";
    }
    return (10 - $report) % 10;
  }

  //Ligne de report pour calcul BVR
  function ligneReport($report){
    $etalon = ('09468271350946827135');
    $lignereport = substr($etalon, $report, 10);
    return $lignereport;
  }

  function getMonNumRef(){
    $emed = new ensTableBrioche("medecins", "id = $this->nummed", "*", 0, $this->idsession);
    $temed = $emed->getTableau();
    //montant
    $med = $temed[0];
    $chaine = '01' . sprintf("%010s", $this->montant * 100);
    $chaine .= $this->getNoControle($chaine);
    $tab[0] = $chaine;
    //num rf
    if(strlen($med->prefbvr) <= 6){
      $chaine = sprintf("%0-6s", $med->prefbvr) . sprintf("%07s", $this->nofact);
      $chaine .= '0000' . sprintf("%09s", $this->nopat);
      $chaine .= $this->getNoControle($chaine);
    }
    else { //prfixe bvr long (par exemple Raiffeisen)
      $chaine = sprintf("%0-13s", $med->prefbvr) . "1" . sprintf("%07s", $this->nofact);
      $chaine .= $this->hacheNoPat();
      $chaine .= $this->getNoControle($chaine);
    }
    //print "<pre>a" . $chaine . "b</pre>";
    $tab[1] = $chaine;
    //ccp
    $tab[2] = $med->ccpbvr;
    return $tab;

  }

  function hacheNoPat(){
    return sprintf("%05.5s", hexdec(substr(md5($this->nopat), 0, 5)));
  }
  
  function controleHachage($hachage){
    $h2 = $this->hacheNoPat();
    if ($h2 == $hachage) return true;
    return false;
  }
  
  function getPatient($type){ //$type 1 => anonymisation
    $ini = new briocheIni();
    $epat = new ensTableBrioche("patients", "nopat = $this->nopat", "*", 0, $this->idsession);
    $tepat = $epat->getTableau();
    $tab = $tepat[0];
    $dn = $this->getDateAm($tab->daten, 0);

    $tab->daten = $dn . "T00:00:00";

    if ($type == 1){ //Anonymisation

      $tab->daten = substr($dn, 0, 4) . "-07-01T00:00:00";
      $tab->nomp = substr(md5($tab->nomp . $ini->mdpHachage),0, 10);
      $tab->prenom = "Anonymus";
      $tab->nopost = 1000;
      $tab->ville = "Lausanne";
    }

    return $tab;
  }
  //Facture au format xml
  function getXml($type, $test = 0){
    $ini = new briocheIni();
    $monean = ($test ? '789456456' : $this->medecin->ean);
    $doc = new xmlDoc('<?xml version="1.0" encoding="UTF-8" standalone="no"?>', 'invoice');
    $request = new xmlElement('request');
    $request->addAttribut('xmlns:xsi', 'http://www.w3.org/2001/XMLSchema-instance');
    $request->addAttribut('xmlns:invoice', 'http://www.xmlData.ch/xmlInvoice/XSD');
    $request->addAttribut('xsi:schemaLocation' ,
                          'http://www.xmldata.ch/xmlInvoice/XSD/MDInvoiceRequest_400.xsd http://svmed.ch');
    $request->addAttribut('role', 'production');
    //Header
    $header = new xmlElement('header');
    $sender = new xmlElement('sender');
    $sender->addAttribut('ean_party', $monean);
    $header->addElement($sender);
    $intermediate = new xmlElement('intermediate');
    $intermediate->addAttribut('ean_party', '2000000000000');
    $header->addElement($intermediate);
    $recipient = new xmlElement('recipient');
    ////ICI EAN DE L'ASSUREUR EN CAS DE TIERS-PAYANT
    $recipient->addAttribut('ean_party', 'unknown');
    $header->addElement($recipient);
    $request->addElement($header);
    //Prologue
    $prolog = new xmlElement('prolog');
    $package = new xmlElement('package');
    $package->addTexte('Radix');
    $package->addAttribut('version', '100');
    $prolog->addElement($package);
    $generator = new xmlElement('generator');
    $software = new xmlElement('software');
    $software->addTexte('Moulinez vous-m&#234;me votre XML !');
    $software->addAttribut('version', '100');
    $generator->addElement($software);
    $prolog->addElement($generator);
    $request->addElement($prolog);
    //Facture
    $invoice = new xmlElement('invoice');
    $tst = $this->dateFrToTst($this->datefact);
    $invoice->addAttribut('invoice_timestamp', $tst);
    $id = ($type == 0 ? $this->nofact : md5($this->nofact . $ini->mdpHachage));
    $this->cdcnofact = $id;
    $invoice->addAttribut('invoice_id', $id);
    $invoice->addAttribut('invoice_date', ($type == 0 ? $this->getDateAm($this->datefact, 0) :
                          $this->today()) . "T00:00:00");
    $nbrem = $this->ret->compte();
    if ($nbrem){
      $remark = new xmlElement('remark');
      $remark->addTexte($doc->xmlentities($this->getTexteRemarques()));
      $invoice->addElement($remark);
    }
    $balance = new xmlElement('balance');
    $balance->addAttribut('currency', 'CHF');
    $balance->addAttribut('amount', $this->montant);
    $balance->addAttribut('amount_due', $this->montant);
    $balance->addAttribut('amount_tarmed', $this->getMontantTarmed());
    $balance->addAttribut('unit_tarmed.mt', $this->arronditCt($this->getSommePtsMed()));
    $balance->addAttribut('amount_tarmed.mt', $this->arronditCt($this->getSommeFrMed()));
    $balance->addAttribut('unit_tarmed.tt', $this->arronditCt($this->getSommePtsTec()));
    $balance->addAttribut('amount_tarmed.tt', $this->arronditCt($this->getSommeFrTec()));
    $balance->addAttribut('amount_unclassified', $this->arronditCt($this->getMontantAutre()));
    $balance->addAttribut('amount_lab', $this->getMontantLabo());
    $balance->addAttribut('amount_obligations', $this->getMontantTarmed() + $this->getMontantLabo() +
                          $this->getMontantAutre());
    $vat = new xmlElement('vat');
    $vat->addAttribut('vat', '0');
    $vatrate = new xmlElement('vat_rate');
    $vatrate->addAttribut('vat_rate', '0');
    $vatrate->addAttribut('amount', '0');
    $vatrate->addAttribut('vat', '0');
    $vat->addElement($vatrate);
    $balance->addElement($vat);
    $invoice->addElement($balance);
    $esr = new xmlElement('esr9');
    $nr = $this->getMonNumRef();
    $esr->addAttribut('participant_number', ($type == 0 ? $this->medecin->ccp : "01-1000-0"));
    $esr->addAttribut('type', '16or27');
    $esr->addAttribut('reference_number', ($type == 0 ? sprintf("%s %s %s %s %s %s", substr($nr[1], 0, 2),
                       substr($nr[1], 2, 5), substr($nr[1], 7, 5),
                       substr($nr[1], 12, 5), substr($nr[1], 17, 5), substr($nr[1], 22, 5)) :
                       "00 00000 00000 00000 00000 00000"));
    $cl = ($type == 0 ?  "$nr[0]&gt;$nr[1]+ $nr[2]&gt;" :
                          "0100000000000&gt;000000000000000000000000000+ 000000000&gt;" );
    $esr->addAttribut('coding_line', $cl);
    $bank = new xmlElement('bank');
    $cmpn = new xmlElement('company');
    $cnn  = new xmlElement('companyname');
    $cnn->addTexte($doc->xmlentities($this->medecin->banque));
    $cmpn->addElement($cnn);
    $pst = new xmlElement('postal');
    $zz = new xmlElement('zip');
    $zz->addAttribut('countrycode', 'CH');
    $zz->addTexte(substr($this->medecin->lieubanque, 0, 4));
    $pst->addElement($zz);
    $ct = new xmlElement('city');
    $ct->addTexte($doc->xmlentities((substr($this->medecin->lieubanque, 5))));
    $pst->addElement($ct);
    $cmpn->addElement($pst);
    $bank->addElement($cmpn);
    $esr->addElement($bank);
    $invoice->addElement($esr);
    if ($this->tiersxml != 2) {
      $tiers = new xmlElement('tiers_garant');
      //if ($type == 0){
        //Le token serait  ajouter ici
        //$demand = new xmlElement('demand');
        //$tc_demand_id = new Attribut('tc_demand_id', '');
        //$demand->addAttribut($tc_demand_id);
        //$token = preg_replace("/^01/", "22", $cl); 
        //$tc_token = new Attribut('tc_token', $token);
        //$demand->addAttribut(
        //$tiers->addElement($demand);
      //}
    }
    else {
      $tiers = new xmlElement('tiers_payant');
      $tiers->addAttribut('invoice_modification', 'false');
      $tiers->addAttribut('purpose', 'invoice');

    }
    //Fournisseur
    $biller = new xmlElement('biller');
    $biller->addAttribut('ean_party', $monean);
    $biller->addAttribut('zsr', $this->medecin->concordat);
    $person = new xmlElement('person');
    $familyname = new xmlElement('familyname');
    $familyname->addTexte($doc->xmlentities($this->medecin->nommed));
    $person->addElement($familyname);
    $givenname = new xmlElement('givenname');
    $givenname->addTexte($doc->xmlentities($this->medecin->prenommed));
    $person->addElement($givenname);
    $postal = new xmlElement('postal');
    $zip = new xmlElement('zip');
    $zip->addTexte($this->medecin->npa);
    $postal->addElement($zip);
    $city = new xmlElement('city');
    $city->addTexte($doc->xmlentities($this->medecin->ville));
    $postal->addElement($city);
    $person->addElement($postal);
    $biller->addElement($person);
    $provider = new xmlElement('provider');
    $provider->addAttribut('ean_party', $monean);
    $provider->addAttribut('zsr', $this->medecin->concordat);
    $provider->addAttribut('cdc_login', $this->medecin->cdclogin);
    $provider->addAttribut('cdc_passwd', $this->medecin->cdcpasswd);
    $provider->addAttribut('cdc_result_email', $ini->cdc_result_email);
    $provider->addAttribut('cdc_force', 'false');
    $provider->addElement($person);

    //Patient
    $monpat = $this->getPatient($type);
    $patient = new xmlElement('patient');
    $patient->addAttribut('gender', ($monpat->sexe == 1 ? 'female' : 'male'));
    $patient->addAttribut('birthdate', $monpat->daten);
    //$patient->addAttribut('cdc_uniqueid', '');
    //$patient->addAttribut('cdc_freeid', '224z556');
    $p_person = new xmlElement('person');
    $p_familyname = new xmlElement('familyname');
    $p_familyname->addTexte($doc->xmlentities($monpat->nomp));
    $p_person->addElement($p_familyname);
    $p_givenname = new xmlElement('givenname');
    $p_givenname->addTexte($doc->xmlentities($monpat->prenom));
    $p_person->addElement($p_givenname);
    $p_postal = new xmlElement('postal');
    $p_zip = new xmlElement('zip');
    $p_zip->addTexte($monpat->nopost);
    $p_postal->addElement($p_zip);
    $p_city = new xmlElement('city');
    $p_city->addTexte($doc->xmlentities($monpat->ville));
    $p_postal->addElement($p_city);
    $p_person->addElement($p_postal);
    $patient->addElement($p_person);
    //$cdc_lamal = new xmlElement('cdc_lamal');
    //$cdc_lamal->addAttribut('cdc_ct_num', '12345');
    //$cdc_lamal->addTexte('supra');
    //$patient->addElement($cdc_lamal);
    $guarantor = new xmlElement('guarantor');
    $guarantor->addElement($p_person);
    $tiers->addElement($biller);
    $tiers->addElement($provider);
    if ($this->tiersxml == 2) {//tiers payant
      $assurance = new xmlElement('insurance');
      $assurance->addAttribut('ean_party', '2000000000000');
      $tiers->addElement($assurance);
    }
    $tiers->addElement($patient);
    $tiers->addElement($guarantor);
    $invoice->addElement($tiers);
    //Traitement
    $detail = new xmlElement('detail');
    $detail->addAttribut('date_begin', $this->getDateAm($this->debut, 0) . "T00:00:00");
    $detail->addAttribut('date_end', $this->getDateAm($this->fin, 0) . "T00:00:00");
    $detail->addAttribut('canton', $ini->canton);
    $detail->addAttribut('service_locality', 'practice');
    $diagnosis = new xmlElement('diagnosis');
    $diagnosis->addAttribut('type', 'freetext');
    $diagnosis->addTexte('U'); //Pour l'instant...
    $detail->addElement($diagnosis);
    switch($this->tpr){
    case 1://LAMAL
    case 5:
    case 6:
    case 8:
    case 9:
    case 12:
    case 13:
      $vg = new xmlElement('kvg');
      if ($this->tpr == 5 || $this->tpr == 12){
        $vg->addAttribut('reason', 'accident');
      }
      else {
        $vg->addAttribut('reason', 'disease');
      }
      break;
    case 2: //LAA
    case 7:
      $vg = new xmlElement('uvg');
      $vg->addAttribut('reason', 'accident');
      break;
    case 11: //AMF
      $vg = new xmlElement('mvg');
      $vg->addAttribut('reason', 'disease');
      break;
    case 10: //AI
      $vg = new xmlElement('ivg');
      $vg->addAttribut('reason', 'disease');
      $vg->addAttribut('case_id', '00000000000000');
      $vg->addAttribut('ssn', '10000000000');
      $vg->addAttribut('nif', '0000000');
      break;
    default : //LCA
      $vg = new xmlElement('vvg');
      $vg->addAttribut('reason', 'disease');
      break;
    }

    $detail->addElement($vg);
    $services = new xmlElement('services');
    $prest = $this->et->getTableau();
    $cpt = count($prest);
    $seance = 1;
    $dateprec = 0;
    $radiol = 0;
    for ($i = 0; $i < $cpt; $i++){
      $heure = 'T' . ($prest[$i]->heureprest == '11:59:00' ? '00:00:00' : $prest[$i]->heureprest);
      $datheure = $this->getDateAm($prest[$i]->dateprest, 0) . $heure;
      switch ($prest[$i]->tarif){
      case 5:
        $tr = new ensTableBrioche("tarif", "position = " . $prest[$i]->position . " AND tarif = 5", "*", 0,
                                  $this->idsession);
        $ttr = $tr->getTableau();
        if ($prest[$i]->position > 300000){
          $radiol ++;
        }
        if ($ttr[0]->nouvseance || $radiol == 1){
          $seance ++;
        }
        if ($dateprec != $prest[$i]->dateprest){
          $seance = 1;
          $radiol = ($radiol == 1 ? 1 : 0);
        }
        //print "-$seance-"; 
        //print "\n";
        $record_tarmed = new xmlElement('record_tarmed');
        $record_tarmed->addAttribut('record_id', $i+1);
        $record_tarmed->addAttribut('number', $seance);
        $record_tarmed->addAttribut('treatment', 'ambulatory');
        $record_tarmed->addAttribut('tariff_type', $this->getCodeTarif(5));
        $record_tarmed->addAttribut('code', $this->formatePos($prest[$i]->noprest));
        if ($this->getCodeRef(5, $prest[$i]->position))        {
          $record_tarmed->addAttribut('ref_code', $this->getCodeRef(5, $prest[$i]->position));
        }
        $record_tarmed->addAttribut('quantity', $prest[$i]->nombre);

        $record_tarmed->addAttribut('date_begin', $datheure);
        $record_tarmed->addAttribut('ean_provider', $monean);
        $record_tarmed->addAttribut('ean_responsible', $monean);
        $record_tarmed->addAttribut('billing_role', 'both');
        $record_tarmed->addAttribut('medical_role', 'self_employed');
        $record_tarmed->addAttribut('body_location', 'none');
        $record_tarmed->addAttribut('unit.mt', $prest[$i]->pm);
        $record_tarmed->addAttribut('unit_factor.mt', $prest[$i]->vpm);
        $record_tarmed->addAttribut('scale_factor.mt', '1');
        $record_tarmed->addAttribut('external_factor.mt', '1');
        $record_tarmed->addAttribut('amount.mt', $prest[$i]->pm * $prest[$i]->vpm * $prest[$i]->nombre);
        $record_tarmed->addAttribut('unit.tt', $prest[$i]->pt);
        $record_tarmed->addAttribut('unit_factor.tt', $prest[$i]->vpt);
        $record_tarmed->addAttribut('scale_factor.tt', '1');
        $record_tarmed->addAttribut('external_factor.tt', '1');
        $record_tarmed->addAttribut('amount.tt', $prest[$i]->pt * $prest[$i]->vpt * $prest[$i]->nombre);
        $record_tarmed->addAttribut('amount', $prest[$i]->ttligne);
        $record_tarmed->addAttribut('vat_rate', '0');
        $record_tarmed->addAttribut('validate', 'true');
        $record_tarmed->addAttribut('obligation', 'true');
        $record_tarmed->addTexte($doc->xmlentities($this->getLibelle($prest[$i]->noprest, true)));
        $services->addElement($record_tarmed);
        $dateprec = $prest[$i]->dateprest;
        break;
      case 99:
        $record_unclassified = new xmlElement('record_unclassified');
        $record_unclassified->addAttribut('record_id', $i+1);
        $record_unclassified->addAttribut('number', $seance);
        $record_unclassified->addAttribut('tariff_type', $this->getCodeTarif(99));
        $record_unclassified->addAttribut('code', '-');
        $record_unclassified->addAttribut('quantity', '1');
        $record_unclassified->addAttribut('date_begin', $datheure);
        $record_unclassified->addAttribut('unit', $prest[$i]->points);
        $record_unclassified->addAttribut('unit_factor', $prest[$i]->valpoint);
        $record_unclassified->addAttribut('external_factor', '1');
        $record_unclassified->addAttribut('amount', $prest[$i]->ttligne);
        $record_unclassified->addAttribut('vat_rate', '0');
        $record_unclassified->addAttribut('validate', 'false');
        $record_unclassified->addAttribut('obligation', 'true');
        $record_unclassified->addTexte($doc->xmlentities($this->getLibelle($prest[$i]->noprest)));
        $services->addElement($record_unclassified);
        break;
      case 4:
        $record_lab = new xmlElement('record_lab');
        $record_lab->addAttribut('record_id', $i+1);
        $record_lab->addAttribut('number', $seance);
        $record_lab->addAttribut('tariff_type', $this->getCodeTarif(4));
        $record_lab->addAttribut('code', $this->formatePos($prest[$i]->noprest));
        $record_lab->addAttribut('quantity', $prest[$i]->nombre);
        $record_lab->addAttribut('date_begin', $datheure);
        $record_lab->addAttribut('unit', $prest[$i]->points);
        $record_lab->addAttribut('unit_factor', $prest[$i]->valpoint);
        $record_lab->addAttribut('external_factor', '1');
        $record_lab->addAttribut('amount', $prest[$i]->ttligne);
        $record_lab->addAttribut('vat_rate', '0');
        $record_lab->addAttribut('validate', 'true');
        $record_lab->addAttribut('obligation', 'true');

        $record_lab->addTexte($doc->xmlentities($this->getLibelle($prest[$i]->noprest)));
        $services->addElement($record_lab);
        break;
      }
    }
    $detail->addElement($services);
    $invoice->addElement($detail);
    $request->addElement($invoice);
    $doc->addElement($request);
    return $doc->getContenu();
  }
}



?>
