<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

///////////////////////////////////////////
//
//  Ensemble de toutes les factures
//
///////////////////////////////////////////

class ensFacture extends connexionBrioche{
   

  function __construct($sessionid){
    if(! parent::__construct($sessionid)) return;
    return true;
  }


  //Numro de la prochaine facture
  function prochainNum(){
    $efact = new ensTableBrioche("factures", "nofact is not null", "cofact", 0,
                                 $this->idsession);
    $derco = $efact->getDernier("cofact");
    $dernum = $efact->lookUp("nofact", "cofact = $derco");
    $anfact = floor($dernum/100000);
    if ($anfact != date("y")){
      $proch = date("y")*100000 + 1;
    }
    else {
      $proch = ++$dernum;
    }
    return $proch;
  }



  // Renvoie le numro abrg
  static function getNoAbr($nofact){
    $anfact = floor($nofact/100000);
    $numero = $nofact - ($anfact*100000);
    return sprintf("%02d-%d", $anfact, $numero);
  }
  function getNoPlein($an, $no){
    return ($an * 100000) + $no;
  }

  //Un numro de facture existe-t-il ?
  function existeNofact($nofact){
    $et = new ensTableBrioche("factures", "nofact = $nofact", "nofact", 0, $this->idsession);
    return $et->compte();
  }

  // Retourne un tableau avec le dbut et la fin du trimestre de $date
  function getTrimestre($date) {
    if (preg_match("/-/", $date)){
      $dateam = $date;
    }
    else {
      $dateam = $this->getDateAm($date, false);
    }
    $notrim = floor((date("n", strtotime($dateam))+2)/3);
    $trimestre['deb'] = date("Y-m-d", mktime(0, 0, 0, (($notrim-1)*3) + 1,
                             1, date("Y", strtotime($dateam))));
    $trimestre['fin'] = date("Y-m-d", mktime(0, 0, 0, (($notrim)*3) + 1,
                             0, date("Y", strtotime($dateam))));
    return $trimestre;
  }
  
  // Formate une position en fonction du tarif (Fonction statique)
  static function formatePos($pos, $tarif){
    switch ($tarif){
    case 1: //NMT
    case 2: //NMT technique
    case 3: //Ancien tarif LAA
      return sprintf("%04d", $pos);
      break;
    case 4: //Liste des analyses
    case 50: //SUVA prophylaxie
      return sprintf("%4.2f", $pos/100);
      break;
    case 51: // Dpistage clon
      return preg_replace("/^([0-9]{2})([0-9]{4})([0-9]{2})/", "$1.$2.$3.", $pos);
      break;
    case 5: //tarmed
    case 6:
      return sprintf("%02d.%04d", $pos/10000, (($pos + .1)/10000 - floor($pos/10000))*10000 );
    default; //Prestation non code
      return "---";
      break;
    }
  }
  
  // Renvoie un objet table contenant les types de factures avec ou sans enregistrements
  // masqus
  function getTypePrest($ycmasque = 0){
    $tp = new ensTableBrioche("typeprest", ($ycmasque ? "1" : "masquer = 0"),
      "*", "id", $this->idsession);
    return $tp;  
  }
  
  //Retourne le statut Tarmed
  function getTarmed($typeprest){
    $tp = new ensTableBrioche("typeprest", "id = $typeprest", "tarmed", 0, $this->idsession);
    $ttp = $tp->getTableau();
    return $ttp[0]->tarmed; 
  }
  
  
  //Retourne le numro de rfrence BVR
  function getNumRef($nofact){
    $edf = new ensDetailFacture($nofact, $this->idsession);
    return $edf->getMonNumRef();
  } 
  
  function getNumRefMtant($nofact){
    $tab = $this->getNumRef($nofact);
    return $tab[0];
  }
  // Renvoie la position correspondant  la tranche $tranche pour le groupe (cons/visite/tl./abs) et le tarif
  function getTranche($tranche, $groupe, $tarif=5, $classe=1){
    //print "CL: $classe<br>GR: $groupe<br>";
    switch ($groupe){
    case 1:
      if ($tranche == 1) return 10; // valable pour toutes les classes
      if ($tranche == 2){
        //print "t2<br>";
        if ($tarif == 5) return 20;
        if ($tarif == 6){
          if ($classe == 1) return 20; else return 25;
        }
      }
      if ($tranche == 3) return 30;
      break;
    case 2:
      if ($tranche == 1) return 60;
      if ($tranche == 2){
        if ($tarif == 5) return 70;
        if ($tarif == 6) {
          if ($classe == 1) return 70; else return 75;
        }
      }
      if ($tranche == 3) return 80;
      break;
    case 3:
      if ($tranche == 1) return 110;
      if ($tranche == 2){
        if ($tarif == 5) return 120;
        if ($tarif == 6){
          if ($classe == 1) return 120; elseif($classe == 2) return 125; else return 126;
        }
      }
      if ($tranche == 3) return 130;
    case 4:
      return 140;
      break;
    }
  }


}





?>
