<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

///////////////////////////////////////////
//
//  Ensemble des factures par patient
//
///////////////////////////////////////////

class ensFacturePat extends ensFacture{
  var $nopat;
  var $noad;
  var $daten;
  var $medecin;
  var $asmal;
  var $asacci;
  var $nomplein;
  var $nomp;
  var $prenom;
  var $prenNom;
  var $politesse;
  var $adresse;
  var $nopost;
  var $ville;
  var $sexe;
  var $existe;
  var $typedefaut;
  function __construct($nopat, $sessionid){
    if(! parent::__construct($sessionid)) return;
    $this->nopat = $nopat;
    $enp = new ensTableBrioche("patients", "nopat = $this->nopat", "*", 0, $this->idsession);
    $tenp = $enp->getTableau();
    $this->existe = 0;
    if (count($tenp)){
      $this->existe = 1;
      $this->noad = $tenp[0]->factures;
      $this->daten = $tenp[0]->daten;
      $this->medecin = $tenp[0]->medecin;
      $this->asmal = $tenp[0]->asmal;
      $this->asacci = $tenp[0]->asacci;
      $this->nomplein = $tenp[0]->nomp . " " . $tenp[0]->prenom;
      $this->adresse = $tenp[0]->adresse;
      $this->nopost = $tenp[0]->nopost;
      $this->ville = $tenp[0]->ville;
      $this->prenNom = $tenp[0]->prenom . " " . $tenp[0]->nomp;
      $this->politesse = ($tenp[0]->sexe == 1 ? "Madame" : "Monsieur");
      if ($this->getAge() < 18) $this->politesse = "Aux parents de";
      $this->nomp = $tenp[0]->nomp;
      $this->prenom = $tenp[0]->prenom;
      $this->sexe = ($tenp[0]->sexe == 1 ? "F" : "M");
      $this->sexenum = $tenp[0]->sexe;
      $this->typedefaut = $tenp[0]->typedefaut;
      $this->nomal = $tenp[0]->nomal;
      $this->noac =$tenp[0]->noac;
    }
  }

  function getTabFact(){
    $join[] = "medecins";
    $join[] = "typeprest";
    $join[] = "statutsfact";
    $on[] = "factures.medecin = medecins.id";
    $on[] = "factures.typeprest = typeprest.id";
    $on[] = "factures.quittance = statutsfact.id";
    $ef = new ensTableBrioche("factures", "nopat = $this->nopat",
                              "factures.*, " .
                              "medecins.abr, typeprest.abr as typabr,  " .
                              "IF(quittance < 0, \"Ouverte\", statutsfact.txt) AS stat",
                              "cofact DESC",
                              $this->idsession, $join, $on);
    $this->table = $ef;
    return $ef;
  }

  //La facture en question appartient-elle  ce patient ?
  function verifNofact($nofact){
    $et = new ensTableBrioche("factures", "nopat = $this->nopat AND nofact = $nofact", "nofact",
                              0, $this->idsession);
    return $et->compte();                          
  }
  
  //Y a-t-il un contentieux pour ce patient ?
  function getContentieux(){
    $et = new ensTableBrioche("factures",
                              "nopat = $this->nopat AND quittance IN (3, 4, 5, 6, 98)",
                              "nofact", 0, $this->idsession);
    $cpt = $et->compte();
    return $cpt;
  }

  //Nombre de factures pour ce patient
  function compte(){
    return $this->table->compte();
  }

  //Renvoie le type par dfaut pour ce patient
  function getTypeDefaut(){
    return $this->typedefaut;
  }
   
  //Renvoie le numro de la facture ouverte de "type" et, au besoin, en ouvre une nouvelle
  function getNoFact($type, $medecin, $forcer){
    $enf = new ensTableBrioche("factures",
                               "nopat = $this->nopat AND quittance <= 0 AND typeprest = $type " .
                               "AND medecin = $medecin",
                               "*", "nofact DESC", $this->idsession);
    $enft = $enf->getTableau();
    if(count($enft) && (! $forcer)){ // Il y a une facture du bon type ouverte;
      return $enft[0]->nofact;
    }
    else { //cration d'une nouvelle facture
      return $this->creeFact($type, $medecin);
    }
  }
  //Renvoie le numro d'assurance maladie ou,  dfaut, -2
  function getAsmal(){
    if ($this->asmal) return $this->asmal;
    return -2;
  }
  //Renvoie le numro d'assurance accient ou,  dfaut, -3
  function getAsacci(){
    if ($this->asacci) return $this->asacci;
    return -3;
  }
  
  function getNomAsmal(){
    $et = new ensTableBrioche("tiers", "1", "*", 0, $this->idsession);
    $nom = $et->lookUp("nomp", "notier = " . $this->asmal);
    return $nom;
  }
  
  function getGroupe(){
    if ($this->asmal){
      $egr = new ensTableBrioche("tiers", "notier = $this->asmal", "*", 0, $this->idsession);
      $tegr = $egr->getTableau();
      if (! count($tegr)){
         $al = new Alerte("Aucune assurance maladie n'a t enregistre pour ce patient !");
         $al->imprime();
         return 1;
      }
      
      $groupe = $tegr[0]->groupe;
      $egg = new ensTableBrioche("groupesass", "1", "*", 0, $this->idsession);
      $groupe = $egg->lookUp("id", "abr = \"$groupe\"");
      $groupe = $groupe + 0;
      $retour = $groupe;
    }
    else {
      $retour = 0;
    }
    return $retour;
  }
  
  //Cre, pour ce patient, une nouvelle facture d'un type donn
  function creeFact($type, $medecin){
    $ok = false;
    $etc = new ensTableBrioche("typeprest", "id = $type", "*", 0, $this->idsession);
    $tet = $etc->getTableau();
    $adressefact = $tet[0]->adressefact;
    while(! $ok){
      $nofact = $this->prochainNum();
      $tabchamps['nofact'] = $nofact;
      $tabchamps['quittance'] = 0;
      // Dtermination de l'adresse de facturation en fonction du paramtre
      // adressefact de la table typeprest
      if ($adressefact == 0) {
        $tabchamps['noad'] = $this->noad; 
      }
      elseif ($adressefact == 2){
        $tabchamps['noad'] = -2;
      }
      elseif ($adressefact == 3){
        $tabchamps['noad'] = -3;  
      }
      else {
        $tt = new ensTableBrioche("tiers", "typetier = $adressefact", "notier", 0,
                                  $this->idsession);
        $ttt = $tt->getTableau();
        $adr = $ttt[0]->notier;                          
        $tabchamps['noad'] = $adr;
      }
      $tabchamps['nopat'] = $this->nopat;
      $tabchamps['typeprest'] = $type;
      $tabchamps['medecin'] = $medecin;
      $tabchamps['bouclement'] = 1;
      $up = new updateTableBrioche("factures", $tabchamps, 0, 0, $this->idsession);
      $ok = $up->ajouteEnr();
    }
    return $nofact;
  }

  // Age
  function getAge(){
    return floor((strtotime($this->today()) - strtotime($this->getDateAm($this->daten, false))) /
     (60 * 60 * 24 * 365.25));
  }
  
  // Classe d'ge (1 = >6 <75 ; 2 = <6 >75)
  function getClasse($date){
     $age = floor((strtotime($this->getDateAm($date, false)) - strtotime($this->getDateAm($this->daten, false))) /
     (60 * 60 * 24 * 365.25));
     if ($age < 6 || $age > 74) return 2; else return 1;
  }
  
  // S'agit-il d'un enfant de moins de 6 ans ?
  function isEnfant($dateprest){
    if((strtotime($this->getDateAm($dateprest, false)) -
       strtotime($this->getDateAm($this->daten, false)))/(60 * 60 * 24 * 365.25) < 6) return true;
    return false;
  }

  function getMix($abs) { //Simulation des prestations en l'absence
    $nb1 = $this->getLoterie();
    $nb2 = $this->getLoterie();
    if ($abs == 1) {
      return array($nb1 + $nb2);
    }
    else {
      //print "$nb1 - $nb2";
      return array($nb1, $nb2);
    }
  }
  
  function getLoterie(){
    $nb = random_int(0, 99);
    if ($nb < 20) {
      return 1;
    }
    elseif ($nb < 50) {
      return 2;
    }
    else {
      return 3;
    }
  }
  
  // Renvoie le quota pour une prestation donne  une date donnes
  function getQuota($position, $date, $type, $medecin, $alerte, $ajout = 1){
    switch($position){
    case 410: //pt examen (2* par trimestre) tarif 5
      $trimestre = $this->getTrimestre($date);
      $between = " \"" . $trimestre['deb'] . "\" AND \"" . $trimestre['fin'] . "\" ";
      $max = 2;
      $message = "Petit examen : quota de 2 par trimestre dpass";
      break;
    case 415: //(y. c. 416 et 417
      $trimestre = $this->getTrimestre($date);
      $between = " \"" . $trimestre['deb'] . "\" AND \"" . $trimestre['fin'] . "\" ";
      $max = 12;
      $position = "415,416,417";
      $message = "Petit examen : quota de 12 par trimestre dpass";    
      break;
    case 420: //gd examen (2* par trimestre) 5
      $trimestre = $this->getTrimestre($date);
      $between = " \"". $trimestre['deb'] . "\" AND \"" . $trimestre['fin'] . "\" ";
      $max = 2;
      $message = "Grand examen : quota de 2 par trimestre dpass";
      break;
    case 510: // cons. spc.
      $trimestre = $this->getTrimestre($date);
      $between = " \"". $trimestre['deb'] . "\" AND \"" . $trimestre['fin'] . "\" ";
      if ($this->getTarmed($type) == 5) $max = 6; else $max = 12;
      if ($this->getTarmed($type) == 6) $position = "510,515,516";
      $message = "Cons. spcifique : quota de $max par trimestre dpass";
      break;
    case 610: // Instruction
      $trimestre = $this->getTrimestre($date);
      $between = " \"". $trimestre['deb'] . "\" AND \"" . $trimestre['fin'] . "\" ";
      if ($this->getTarmed($type) == 5) $max = 6; else $max = 12;
      if ($this->getTarmed($type) == 6) $position = "610,615,616";
      $message = "Instruction patient : quota de $max par trimestre dpass";
      break;
    case 50: // Information
      $trimestre = $this->getTrimestre($date);
      $between = " \"". $trimestre['deb'] . "\" AND \"" . $trimestre['fin'] . "\" ";
      if ($this->getTarmed($type) == 5) $max = 6; else $max = 12;
      if ($this->getTarmed($type) == 6) $position = "50,55,56";
      $message = "Entretien d\'information : quota de $max par trimestre dpass";
      break;
    case 140:
      $trimestre = $this->getTrimestre($date);
      $between = " \"". $trimestre['deb'] . "\" AND \"" . $trimestre['fin'] . "\" ";
      $max = 12;
      $message = "Prestations en l\'absence : quota de 12 par trimestre dpass";
      break;
    case 141:
      $trimestre = $this->getTrimestre($date);
      $between = " \"". $trimestre['deb'] . "\" AND \"" . $trimestre['fin'] . "\" ";
      $max = 60;
      $position = "131,132,133,134,135,136,137,138,141,142,143,144,145,146,147,148,161,162,163,164,165,166,167,168";
      $message = "Prestations en l\'absence : quota de 60 par trimestre dpass";
      break;
    }
    $join = "factures";
    $on = "prestations.nofact = factures.nofact";
    $epr = new ensTableBrioche("prestations",
                               "position IN ($position) AND factures.nopat = $this->nopat " .
                               "AND dateprest BETWEEN $between AND typeprest = $type " .
                               "AND factures.medecin = $medecin",
                               "SUM(nombre) AS somme", 0, $this->idsession, $join, $on);
    $eprt = $epr->getTableau();
    $reste = $max - (float) $eprt[0]->somme - $ajout;
    if ($reste < 1 && $alerte){
      $al = new Alerte($message);
      $al->imprime();
    }
    return $reste;
  }
  
  // Liste des doublons potentiels avec ce patient
  function listeDoublons(){
    $dbl = new ensTableBrioche("patients", 
                               "nopat != $this->nopat AND prenom LIKE \"" . substr($this->prenom, 0, 3) .
                               "%\" AND sexe = \"" .
                               $this->sexenum . "\" AND daten = " .
                               $this->getDateAm($this->daten), "nopat", "nopat", $this->idsession);
    $tdbl = $dbl->getTableau();
    $cpt = count($tdbl);
    if (! $cpt){
      return -999;                           
    }
    else {
      $chaine = "";
      for ($i = 0; $i < $cpt; $i++){
        $chaine .= $tdbl[$i]->nopat . ", ";
      }
      return substr($chaine, 0, -2);
    }
  }  

  //existe-t-il bien un patient avec ce numro
  function existe($alerte = false){
    $cpt = $this->existe;
    if ($alerte && (! $cpt)){
      $al = new Alerte("L\'usager $this->item n\'existe pas !");
      $al->imprime();
    }
    return $cpt;
  }
    
  //Fusion de ce patient avec un autre
  function fusionne(&$uss, $alerte = false){
    //Vrification que les deux numros correspondent  des dossiers
    if (! $this->existe(true)) return false;
    if (! $uss->existe(true)) return false;
    $ut = new updateTableBrioche("factures", "", "", "", $this->idsession);
    if (! $ut->updateSpec("nopat", $this->nopat, "nopat = $uss->nopat", true)) return false;
    $ut = new updateTableBrioche("patients", "", $uss->nopat, "nopat", $this->idsession);
    return ($ut->detruitEnr());
  }
}





?>
