<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

////////////////////////////////////////////////////////////
//
//  Ensemble de donnes ncessaires  la gestion des factures
//
///////////////////////////////////////////////////////////

class ensGestFact extends connexionBrioche {
  
  var $ef;
  var $er;
  var $tp;
  var $rtp;

  function __construct($idsession){
    if (! parent::__construct($idsession)) return;
    //Factures tiers garant (sortir tiers payant aprs ralisation formulaire)
    $this->ef = new ensTableBrioche("factures", "quittance = 1 AND bouclement <> 3",
                                    "nofact, medecin", 0, $this->idsession);
    $this->er = new ensTableBrioche("factures", 
                                    "(bouclement <> 3) AND ((quittance = 2 AND " . 
                                    "TO_DAYS(NOW())- TO_DAYS(datefact) > 60) OR " .
                                    "(quittance BETWEEN 3 AND 5 AND " .
                                    "TO_DAYS(NOW())- TO_DAYS(daterap) > 40))",
                                    "nofact, medecin, quittance", 0, $this->idsession);
    $this->tp = new tableProv("FI", $this->idsession);
    $this->rtp = new tableProv("RI", $this->idsession);
    $this->tp->nettoie();
  }
  
  //Cration table provisoire pour lister factures  imprimer;
  function prepareTP(){
    //print "PREPARATION";
    $this->tp->setChamp("tst", "timestamp");
    $this->tp->setChamp("nofact", "INT");
    $this->tp->setChamp("medecin", "SMALLINT");
    $this->tp->create();
    $tef = $this->ef->getTableau();
    $cpt = count($tef);
    $ut = new updateTableBrioche($this->tp->getNom(), "", "", "", $this->idsession);
    for ($i = 0; $i < $cpt; $i++){
      $tabchamps['nofact'] = $tef[$i]->nofact;
      $tabchamps['medecin'] = $tef[$i]->medecin;
      $ut->setTabChamps($tabchamps);
      $ut->ajouteEnr();
    }
    $this->rtp->setChamp("tst", "timestamp");
    $this->rtp->setChamp("nofact", "INT");
    $this->rtp->setChamp("medecin", "SMALLINT");
    $this->rtp->setChamp("quittance", "SMALLINT");
    $this->rtp->create();
    $ter = $this->er->getTableau();
    $cpt = count($ter);
    $utr = new updateTableBrioche($this->rtp->getNom(), "", "", "", $this->idsession);
    for ($i = 0; $i < $cpt; $i++){
      $tabchamps['nofact'] = $ter[$i]->nofact;
      $tabchamps['medecin'] = $ter[$i]->medecin;
      $tabchamps['quittance'] = $ter[$i]->quittance;
      $utr->setTabChamps($tabchamps);
      $utr->ajouteEnr();
    }     
  }
  
  //Nombre de factures  imprimer
  function getNfi(){
    return $this->ef->compte();
  }
  
  //Nombre de rappels  imprimer
  function getNri(){
    return $this->er->compte();
  }
  
  //tableau des factures  imprimer sur bvr 
  function getTfi(){
    $et = new ensTableBrioche($this->tp->getNom(), "1", "*", "medecin, nofact", $this->idsession);
    //print $et->getSql();
    return $et->getTableau();
  }
  
  //tableau des formules unifies
  function getTji(){
    return $this->getTfi();
  }
  
   
  //tablau des rappels  imprimer
  function getTri(){
    $et = new ensTableBrioche($this->rtp->getNom(), "1", "*", "medecin, quittance, nofact",
                              $this->idsession);
    return $et->getTableau();
  }
  //Boucle toutes les factures ouvertes  une date donne
  function boucleDate($dateb){
    $etb = new ensTableBrioche("factures", "debut < " . $this->getDateAm($dateb, 1) .
                               " and quittance = 0", "nofact", "nofact", $this->idsession);
    $tetb = $etb->getTableau();
    $cpt = count($tetb);
    for ($i = 0; $i < $cpt; $i++) {
      $det = new ensDetailFacture($tetb[$i]->nofact, $this->idsession);
      $det->boucle();  
    }
    return $cpt;   
  }
  
  // Complte, pour tous les types de prestations et tous les groupes d'assureurs, les lignes initiales de valpoint
  function majValPoints(){
    $ettyp = new ensTableBrioche("typeprest", "masquer = 0", "*", 0, $this->idsession);
    $tettyp = $ettyp->getTableau();
    $etgr = new ensTableBrioche("groupesass", "1", "*", 0, $this->idsession);
    $tetgrm = $etgr->getTableau();
    // Remplacement de chaque enregistrements LAMAL par un enregistrement par groupe d'assureurs
    $evpd = new ensTableBrioche("valpointdate", "1", "*", 0, $this->idsession);
    $evpdch = new ensTableBrioche("valpointdate", "1", "*", 0, $this->idsession);
    $tevpd = $evpd->getTableau();
    $ut = new updateTableBrioche("valpointdate", "", 0, "id", $this->idsession);
    foreach ($tevpd as $ligne){
      $tabchamps = array();
      $tt = $ligne->typeprest;
      $tabchamps['typeprest'] = $tt;
      $tabchamps['date'] = $ligne->date;
      $tabchamps['point'] = $ligne->point;
      $tabchamps['montant'] = $ligne->montant;
      $loi = $ettyp->lookUp("loi", "id = " . $tt);
      if ($loi == "LAMAL"){
        if ($ligne->groupass == 0){
          for ($i = 1; $i <= 3; $i++){
            $tabchamps['groupass'] = $i;
            $evpdch->setWhere("date =\"" . $ligne->date . "\" AND point = \"" . $ligne->point .
                              "\" AND typeprest = " . $ligne->typeprest . " AND groupass = " . $i);
            $tevpdch = $evpdch->getTableau();
            $cpt = count($tevpdch);
            if (!$cpt) {
              $ut->setTabChamps($tabchamps);
              $ut->ajouteEnr();
            }
          }
          $evpd->detruitEnr($ligne->id, "id");
        }
      }
    }
    // Ajout des champs initiaux (1.1.2003)
    $tabchamps = array();
    foreach ($tettyp as $typ){
      if($typ->loi != "LAMAL"){
        $obj = new stdClass();
        $obj->id = 0;
        $tetgr = array($obj);
      }
      else {
        $tetgr = $tetgrm;
      }
      foreach ($tetgr as $gr){
        $points = array("pm", "pt", "pl");
        foreach ($points as $point) {
          $etprov = new ensTableBrioche("valpointdate",
                                        "typeprest = " . $typ->id . " AND groupass = " . $gr->id . " AND point = \"" . $point . "\" AND date = \"2003-01-01\"",
                                        "*", 0, $this->idsession);
          $tetprov = $etprov->getTableau();
          $cpt = count($tetprov);
          if (! $cpt){
            $tabchamps['date'] = "1.1.2003";
            $tabchamps['typeprest'] = $typ->id;
            $tabchamps['point'] = $point;
            $tabchamps['montant'] = 1;
            $tabchamps['groupass'] = $gr->id;
            $ut->setTabChamps($tabchamps);
            $ut->ajouteEnr();
          }
        
        }
      }
    }
  }
  
  // Complte, pour tous les mdecins et tous les types de prestations, les lignes initiales de factpmptdate
  function majFacteurs(){
    $ettyp = new ensTableBrioche("typeprest", "masquer = 0", "*", 0, $this->idsession);
    $tettyp = $ettyp->getTableau();
    
    $etmed = new ensTableBrioche("medecins", "1", "*", 0, $this->idsession);
    $tetmed = $etmed->getTableau();
    $tabchamps = array();
    $ut = new updateTableBrioche("factpmptdate", $tabchamps, 0, "id", $this->idsession);
    foreach ($tetmed as $med){
      foreach ($tettyp as $typ) {
        $facts = array("fpm", "fpt");
          foreach ($facts as $fact){
            $etprov = new ensTableBrioche("factpmptdate",
                                          "medecin = " . $med->id . " AND facteur = \"" . $fact . "\" AND typeprest = " .
                                          $typ->id . " AND date = \"2003-01-01\"",
                                          "*", 0, $this->idsession);
            $tetprov = $etprov->getTableau();
            $cpt = count($tetprov);
            if (! $cpt) {
             $tabchamps['date'] = "1.1.2003";
             $tabchamps['medecin'] = $med->id;
             $tabchamps['facteur'] = $fact;
             $tabchamps['valeur'] = 1;
             $tabchamps['typeprest'] = $typ->id;
             $ut->setTabChamps($tabchamps);
             $ut->ajouteEnr();
            }
          }
        }
      }
    }
  }














?>
