<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

///////////////////////////////////////////
//
//  Formulaire facturation
//
//////////////////////////////////////////

class formFact extends cadronglet{
  var $idsession;
  var $options;
  var $action;
  var $item;
  var $nofact;

  #Constructeur
  function __construct($largeur, $grise, $actif, $fondpage, $sessionid, $item, $options = 0, $donnees){
    
    global $fdosbrioche;
    global $imagesdir;
     //appel du constructeur de l'objet parent (avec vrif)
    if (! parent::__construct($largeur, $grise, $actif, $fondpage, $sessionid)) return;
    $this->action = $actif;
    $this->options = new optionsBriocheCab($options);
    $this->item = $item;
    $ini = new BriocheIni();
    $enf = new ensFacturePat($this->item, $this->idsession);
    $efg = new ensFacture($this->idsession);
    $ef = $enf->getTabFact();
    $tef = $ef->getTableau();
    if (! isset($donnees['medecin'])) $donnees['medecin'] = $enf->medecin;
    if (! isset($donnees['forcer'])) $donnees['forcer'] = 0;
    if (! isset($donnees['typefact'])){
      //Si le type de facture n'est pas dtermin, c'est le type par dfaut qui est choisi
      $donnees['typefact'] = $enf->getTypeDefaut();
    }
    if (! isset($donnees['grprest'])) $donnees['grprest'] = 1;
    if (! isset($donnees['urg'])) $donnees['urg'] = 0;
    if (! isset($donnees['dateprest'])) $donnees['dateprest'] = $this->getDateFr(ensDetailFacture::getCookieDate());
    if (! ($donnees['dateprest'])) $donnees['dateprest'] = $this->aujourdhui();
    if (! isset($donnees['heureprest'])) $donnees['heureprest'] = "";
    if (! isset($donnees['duree'])) $donnees['duree'] = "";
    if (! isset($donnees['tduree'])) $donnees['tduree'] = "";
    if (! isset($donnees['ptex'])) $donnees['ptex'] = 0;
    if (! isset($donnees['gdex'])) $donnees['gdex'] = 0;
    if (! isset($donnees['psy'])) $donnees['psy'] = "";
    if (! isset($donnees['spec'])) $donnees['spec'] = "";
    if (! isset($donnees['info'])) $donnees['info'] = "";
    if (! isset($donnees['instr'])) $donnees['instr'] = "";
    if (! isset($donnees['rapport'])) $donnees['rapport'] = 0;
    if (! isset($donnees['depl'])) $donnees['depl'] = "";
    if (! isset($donnees['derangement'])) $donnees['derangement'] = 0;
    if (! isset($donnees['abs'])) $donnees['abs'] = 0;
    //$supplVisite = 0;
    
    $tabbande = array("", "", "", "", "");
    $this->addOnglet("Facturation", $tabbande, "#FF8833", 1000, 60,
                     "");
    $this->colmateOnglets();

    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", "$fdosbrioche?action=$this->action", "post");
    $acb = new AutoCheckBox();
    $futopt = new optionsBriocheCab($this->options->getChaine());
    $em = new ensTableBrioche("medecins", "1", "*", 0, $this->idsession);
    //Premier passage
    if ($this->options->getOption("FORM_FACT") == 0){
      $futopt->setOption("FORM_FACT", 1);
      $c = new TPanelCadre(4, 1, "", "", "", "Mdecin");
      $tem = $em->getTableau();
      $cpt = count($tem);
      $labellise = ($cpt <= 1 ? 1 : 0);
      $x = new GrBoutonRadio("donnees[medecin]", $donnees['medecin'], "", 0, $labellise);
      for ($i = 0; $i < $cpt; $i++){
        $x->addRadio($tem[$i]->txt, $tem[$i]->id);
      }
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanelCadre(2, 1, "", "", "", "&nbsp;");
      $x = new Espace(3);
      $c->addChamp($x);
      $x = new AutoCase("donnees[forcer]", $donnees['forcer'], "Forcer nouvelle facture", true);
      $c->addChamp($x);
      $acb->addCase($x);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      $c = new TPanelCadre(6, 1, "", "", "", "Type de facture");
      $tetype = $efg->getTypePrest(0);
      $tetype->compteTotal();
      $cpt = $tetype->compteTotal();
      $x = new GrBoutonRadioTable("donnees[typefact]", $donnees['typefact'], $tetype);
      $x->addOptions("abr", "id");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      $c = new TPanelCadre(4, 1, "", "", "", "Groupe de prestations");
      $x = new GrBoutonRadio("donnees[grprest]", $donnees['grprest']);
      $x->addRadio($this->getGrPrest(1), 1);
      $x->addRadio($this->getGrPrest(2), 2);
      $x->addRadio($this->getGrPrest(3), 3);
      $x->addRadio($this->getGrPrest(4), 4);
      $x->addRadio($this->getGrPrest(5), 99);
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanelCadre(2, 1, "", "", "", "&nbsp;");
      $x = new AutoCase("donnees[urg]", $donnees['urg'], "Urgence", true);
      $acb->addCase($x);
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
    }
    //Ds le deuxime passage
    elseif ($this->options->getOption("FORM_FACT") >= 1){
      if ($this->options->getOption("FORM_FACT") == 1){//Deuxime passage seulement
        
        $futopt->setOption("FORM_FACT", 2);
        $donnees['nofact'] = $enf->getNoFact($donnees['typefact'], $donnees['medecin'],
                                        $donnees['forcer']);
        $actdoss = $this->options->getOption("ACT_DOSS");
        $optprinc = new optionsBriocheCab($this->options->getChaine());
        $optprinc->setOption("FORM_FACT", 0);
        //Affichage de la facture par la page principale
        print "<SCRIPT LANGUAGE=\"JavaScript\">" .
              "window.opener.document.location='$fdosbrioche?action=$actdoss&sessionid=" .
              "$this->idsession&item=$this->item&itfact=" . $donnees['nofact'] .
              "&options=" . $optprinc->getChaine() ."'" .
              "</SCRIPT>";
        if ($donnees['grprest'] == 99) { //Autre -> fermeture
          $ff = new fermeFenetre(false, true);
        }
      }
      $mafact = new ensDetailFacture($donnees['nofact'], $this->idsession);
      $tarif = $mafact->getTarmed();
      $monpat = new ensFacturePat($mafact->nopat, $this->idsession);
      $classe = $monpat->getClasse($donnees['dateprest']);
      if ($this->options->getOption("FORM_FACT") == 2){
        // contrle compltion
        $tabchamps = $donnees;
        $suite = 1;
        $up = new updateTableBrioche("prestations", $tabchamps, 0, 0, $this->idsession);
        if (! $up->controlePresence("dateprest", "Date")) $suite = 0;
        if ((!$up->controlePresence("duree")) && (!$up->controlePresence("tduree"))){
          $suite = 0;
          $al = new Alerte("Vous devez indiquer la dure");
          $al->imprime();
        }
        if ($donnees['urg']) {
          if (! $up->controlePresence("heureprest", "Heure")) $suite = 0;
        }
        if ($donnees['grprest'] == 2){
          if (! $up->controlePresence("depl", "Dplacement")) $suite = 0;
        }
        if ($donnees['grprest'] == 4 && $tarif == 6){
          if (! $donnees['abs']){
            $suite = 0;
            $al = new Alerte("Vous devez choisir une prestation");
            $al->imprime();
          }
        }
        if ($donnees['ptex'] && $donnees['gdex']){
          $al = new Alerte("Impossible de facturer deux examens");
          $al->imprime();
        }
        if ($suite){
          //Calcul comblements
          $dureefact = ($donnees['tduree'] ? $dureefact = ceil(($donnees['tduree'])/5) :
                        $dureefact = $donnees['duree']); // nombre de tranches de 5 min. de la facture
          $dureecombl = 0; // nombre de tranche combles
          $reste = $dureefact - $dureecombl - 4; // Reste  combler
          //print "Dure : $dureefact / Combl : $dureecombl / Reste  combler : $reste <br>";
          if ($donnees['grprest'] == 4){ //Prestations en absence
            if ($tarif == 5){
            $tabprest[0]['nb'] = $dureefact;
            $tabprest[0]['pos'] = $enf->getTranche(1, 4);
            $quota = $enf->getQuota(140, $donnees['dateprest'], $donnees['typefact'],
                                    $donnees['medecin'], true, $dureefact);
            }
            elseif ($tarif == 6) {
              $dizaine = ($classe == 1 ? 140 : 130);
              $tabmix = $enf->getMix($donnees['abs']);
              //print "<br>D:$dureefact";
              $cpt = count($tabmix);
              for ($i = 0; $i < $cpt; $i++){
                $popo = ($i == 0 ? $dizaine + 1 : $dizaine + $donnees['abs']);
                $tabprest[$i]['nb'] = $tabmix[$i] * $dureefact;
                $tabprest[$i]['pos'] = $popo;
              }
              $quota = $enf->getQuota(141, $donnees['dateprest'], $donnees['typefact'],
                                      $donnees['medecin'], true, 0);
            }
          }
          else { // consult-visites
            // Premire tranche
            $i = 0;
            $tabprest[$i]['nb'] = 1;
            $tabprest[$i]['pos'] = $enf->getTranche(1, $donnees['grprest'], $tarif, $classe);
            $i++;
            if ($donnees['grprest'] == 1 && $ini->medFam && strtotime($donnees['dateprest']) > strtotime("2014-09-30")){ // consultation et md. famille
              $tabprest[$i]['nb'] = 1;
              $tabprest[$i]['pos'] = 15;
              $i++;
            }
     
            if ($donnees['ptex']){
              if ($tarif == 5){
                $quota = $enf->getQuota(410, $donnees['dateprest'], $donnees['typefact'],
                                        $donnees['medecin'], true);
                $dureecombl += 3;
                $reste -= 3;
                $tabprest[$i]['nb'] = 1;
                $tabprest[$i]['pos'] = 410;
                $i++;
              }
              else { // tarif 6
                $quota = $enf->getQuota(415, $donnees['dateprest'], $donnees['typefact'],
                                        $donnees['medecin'], false, 0);
                $nb = ($reste > 3 ? 3 : $reste);
                $nb = ($nb > $quota ? $quota : $nb);
                $dureecombl += $nb;
                $reste -= $nb;
                if ($nb > 0) {
                  $tabprest[$i]['nb'] = $nb;
                  $tabprest[$i]['pos'] = ($classe == 1 ? 415 : 416);
                  $i++;
                }
              }
            }
            //print "Dure : $dureefact / Combl : $dureecombl / Reste  combler : $reste <br>";
            if ($donnees['gdex']){
              $quota = $enf->getQuota(420, $donnees['dateprest'], $donnees['typefact'],
                                      $donnees['medecin'], true, 0);
              $nb = 1;
              $dureecombl += 5;
              $reste  -= 5;
              $tabprest[$i]['nb'] = 1;
              $tabprest[$i]['pos'] = 420;
              $i++;
            }
            $nb = 0;
            //print "Dure : $dureefact / Combl : $dureecombl / Reste  combler : $reste <br>";
            
            if ($reste > 0){ //comblement
              $tot = 0;
              if($donnees['psy']) { // Consult. psycho-sociale
                $nb = ($reste > 12 ? 12 : $reste);
                $tot += $nb;
                $reste -= $nb;
                $tabprest[$i]['nb'] = $nb;
                $tabprest[$i]['pos'] = 520;
                $i++;
              }
              if($donnees['spec'] && $reste > 0){ // consult spcifique
                $nb = $reste;
                $quota = $enf->getQuota(510, $donnees['dateprest'], $donnees['typefact'],
                                       $donnees['medecin'], true, 0);
                $nb = ($nb > $quota ? $quota : $nb);
                $nb = ($nb > 3 ? 3 : $nb);
                $tot += $nb;
                $reste -= $nb;
                if ($nb > 0) {
                  $tabprest[$i]['nb'] = $nb;
                  $tabprest[$i]['pos'] = ($classe == 1 || $tarif == 5 ? 510 : 515);
                  $i++;
                }
              }
              if($donnees['instr'] && $reste > 0){ // Instruction patient
                $nb = $reste;
                $quota = $enf->getQuota(610, $donnees['dateprest'], $donnees['typefact'],
                                       $donnees['medecin'], true, 0);
                $nb = ($nb > $quota ? $quota : $nb);
                $nb = ($nb > 3 ? 3 : $nb);
                $tot += $nb;
                $reste-= $nb;
                
                if ($nb > 0) {
                  $tabprest[$i]['nb'] = $nb;
                  $tabprest[$i]['pos'] = ($classe == 1 || $tarif == 5 ? 610 : 615);
                  $i++;
                }
              }
              if($donnees['info'] && $reste > 0){ // Information patient
                $nb = $reste;
                $quota = $enf->getQuota(50, $donnees['dateprest'], $donnees['typefact'],
                                       $donnees['medecin'], true, 0);
                $nb = ($nb > $quota ? $quota : $nb);
                $tot += $nb;
                $reste -= $nb;
                if ($nb > 0) {
                  $tabprest[$i]['nb'] = $nb;
                  $tabprest[$i]['pos'] = 50;
                  $i++;
                }
              }
            }
            //Tranches 2 et 3
            if ($donnees['grprest'] == 3) { // tl.
              $reste = $dureefact - 2;
              $nb = ($reste > 4 ? 4 : $reste);
              $reste -= $nb;
              if ($nb > 0){
                $tabprest[$i]['nb'] = $nb;
                if ($nb > 2) $classe = 3;
                $tabprest[$i]['pos'] = $enf->getTranche(2, $donnees['grprest'], $tarif, $classe);
                $i++;
              }  
            }
            else {
              if ($dureefact > 2){
                //print "DF : $dureefact";
                $tabprest[$i]['nb'] = ($dureefact == 3 ? 1 : 2);
                $tabprest[$i]['pos'] = $enf->getTranche(2, $donnees['grprest'], $tarif, $classe);
                $i++;
              }
            }
            if ($dureefact > 1){
              $tabprest[$i]['nb'] = 1;
              $tabprest[$i]['pos'] = $enf->getTranche(3, $donnees['grprest']);
              $i++;
            } 
            if ($reste > 0) {
              $al = new Alerte("Comblement impossible : veuillez ajouter une option ou " .
                              "diminuer la dure...");
              $al->imprime();
              $suite = false;
            }
          }
        }
        if ($suite){ // Ecriture des prestations;
          //$mafact = new ensDetailFacture($donnees['nofact'], $this->idsession);
          
          $cpt = count($tabprest);
          $datheure = $mafact->getDateHeure($donnees['dateprest'], $donnees['heureprest']);
          for ($j = 0; $j < $cpt; $j++){
            $mafact->addPrestation($tabprest[$j]['nb'], $tabprest[$j]['pos'], $datheure, $tarif);
          }
          if ($donnees['grprest'] == 2){//Visite
            $nbprest = ceil($donnees['depl']/5);
            $mafact->addPrestation($nbprest, 95, $datheure, $tarif);
          }
          if ($donnees['grprest'] == 1 && $enf->isEnfant($donnees['dateprest'])){ // Consultation enfant
            $mafact->addPrestation(1, 40, $datheure, $tarif);
          }
          if ($donnees['urg']){ //Urgence ventuelle
            //print $donnees['grprest'];
            //print $datheure;
            $mafact->majorUrg($datheure, $donnees['grprest']);
          }
          if ($donnees['derangement']){
            if ($donnees['derangement'] == 1){
              $mafact->addPrestation(1, 2505, $datheure, $tarif); // vis. ou cons. pressante
            }
           
          }
          
          print "<SCRIPT LANGUAGE=\"JavaScript\">" .
                "window.opener.document.location.reload();" .
                "window.close();" .
                "</SCRIPT>";
         
        }
      }

      $nommed = $em->lookUp("txt", "id = " . $donnees['medecin']);
      $etype = new ensTableBrioche("typeprest", "1", "*", 0, $this->idsession);
      $nomtypfact = $etype->lookup("abr", "id = " . $donnees['typefact']);
      $c = new TPanelCadre(6, 1);
      $x = new Label("$nommed - $nomtypfact - " .
                     $this->getGrPrest($donnees['grprest']), true);
      $c->addChamp($x);
      $x = new Bouton("donnees[medecin]", $donnees['medecin'], "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("donnees[typefact]", $donnees['typefact'], "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("donnees[grprest]", $donnees['grprest'], "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("donnees[urg]", $donnees['urg'], "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("donnees[forcer]", $donnees['forcer'], "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("donnees[nofact]", $donnees['nofact'], "HIDDEN");
      $c->addChamp($x);

      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      $c = new TPanel(6, 1);
      $x = new ChampTexte("donnees[dateprest]", $donnees['dateprest'], "Date : ", 15, 15, false,
                          "TEXT", "d2", "controleDate('donnees[dateprest]', '" .
                          $this->aujourdhui() . "', '720', '30')");
      $c->addChamp($x);
      if ($donnees['urg']){
        $x = new Espace(3);
        $c->addChamp($x);
        $x = new ChampTexte("donnees[heureprest]", $donnees['heureprest'], "Heure : ", 12, 12, false,
                            "TEXT", "d2", "controleHeure('donnees[heureprest]')");
        $c->addChamp($x);
      }
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      if ($donnees['grprest'] == 2){ //Visite
        $c = new TPanelCadre(6, 1, "", "", "", "Dplacement :");
        $x = new ChampTexte("donnees[depl]", $donnees['depl'], "Dure (min) : ", 4, 3, false,
                            "TEXT", "d2");
        $c->addChamp($x);
        $x = new Espace(3);
        $c->addChamp($x);
        $x = new Label("Non compris dans le temps de visite", false, true);
        $c->addChamp($x);
        $of->addChamp($c);
        $of->addLigne(0.5);
        $of->addLigne();
      }
      if ($tarif == 6 && $donnees['grprest'] == 4) { // Nouvelles prestations en absence
        $c = new TPanelCadre(6, 1, "", "", "", "Prestation en l'absence  : ");
        $x = new GrBoutonRadio("donnees[abs]", $donnees['abs'], "", "donnees");
        $x->addRadio("Ordonnance", 6);
        $x->addRadio("Dossier", 1);
        $x->addRadio("Proches", 3);
        $x->addRadio("Tiers", 2);
        $x->addRadio("Soignants", 4);
        $x->addRadio("Dlgation", 5);
        $c->addChamp($x);
        $of->addChamp($c);
        $of->addLigne(0.5);
        $of->addLigne();
      }
      $c = new TPanelCadre(6, 1, "", "", "", "Dure totale (minutes) : ");
      $x = new GrBoutonRadio("donnees[duree]", $donnees['duree'], "", "donnees");
      $x->addRadio("5-", 1);
      $x->addRadio("5+", 2);
      $x->addRadio("10+", 3);
      $x->addRadio("15+", 4);
      $x->addRadio("<FONT COLOR=\"red\">20+</FONT>", 5);
      $x->addRadio("<FONT COLOR=\"red\">25+</FONT>", 6);
      if ($donnees['grprest'] != 3){ // Tl. limit  25+
        $x->addRadio("<FONT COLOR=\"red\">30+</FONT>", 7);
      }
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      if ($donnees['grprest'] != 3) {
        $x = new ChampTexte("donnees[tduree]", $donnees['tduree'], "", 4, 3, false,
                           "TEXT", "d2");
        $c->addChamp($x);
      }
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      if ($donnees['grprest'] == 1 || $donnees['grprest'] == 2){
        $c = new TPanelCadre(6, 1, "", "", "", "Combler avec : ");
        $x = new AutoCase("donnees[ptex]", $donnees['ptex'], "Pt examen", ($tarif == 6 ? true : false));
        $c->addChamp($x);
        $acb->addCase($x);
        if ($tarif == 5){ // Pas de grand examen pour tarif 6
          $x = new Espace(5);
          $c->addChamp($x);
          $x = new AutoCase("donnees[gdex]", $donnees['gdex'], "Gd examen (25 min.)", true);
          $c->addChamp($x);
          $acb->addCase($x);
        }
        $x = new AutoCase("donnees[psy]", $donnees['psy'], "Cons. psycho-sociale");
        $c->addChamp($x);
        $acb->addCase($x);
        $x = new Espace(5);
        $c->addChamp($x);
        $x = new AutoCase("donnees[spec]", $donnees['spec'], "Cons. spcifique", true);
        $c->addChamp($x);
        $acb->addCase($x);
        $x = new AutoCase("donnees[instr]", $donnees['instr'], "Instruction patient");
        $c->addChamp($x);
        $acb->addCase($x);
        $x = new Espace(5);
        $c->addChamp($x);
        $x = new AutoCase("donnees[info]", $donnees['info'], "Information patient", true);
        $c->addChamp($x);
        $acb->addCase($x);
        $of->addChamp($c);
        if (! $donnees['urg']){
          $of->addLigne(0.2);
          $of->addLigne();
          $c = new TPanelCadre(6, 1, "", "", "", "Drangement : ");
          $x = new GrBoutonRadio("donnees[derangement]", $donnees['derangement'], "", "donnees");
          $x->addRadio(($donnees['grprest'] == 1 ? "Consultation " : "Visite") ." pressante", 1);
          $c->addChamp($x);
          $of->addChamp($c);
        }
        
        $of->addLigne(0.5);
        $of->addLigne();
      }
    }
    $c = new TPanel(6, 1, "RIGHT");
    $x = new Bouton("Continuer", "Continuer", "SUBMIT");
    $c->addChamp($x);
    $x = new Espace(3);
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("item", $this->item, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("options", $futopt->getChaine(), "HIDDEN");
    $c->addChamp($x);
    $c->addChamp($acb);
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    $this->addContenu($of->getContenu());
    $tf = new TabForm();
    $tf->setTabParam(500, 0, 3, 0, "#2784be");
    $c = new TPanel(3);
    $x = new Espace(1);
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TPanel(3, 1, "RIGHT");
    $x = new Bouton("Fermer", "Fermer", "BUTTON", "window.close()");
    $c->addChamp($x);
    $tf->addChamp($c);
    $this->addContenu($tf->getContenu());
  }

  function getGrPrest($num){
    switch($num){
    case 1:
      return "Consult.";
      break;
    case 2:
      return "Visite";
      break;
    case 3:
      return "Tl.";
      break;
    case 4:
      return "P. en abs.";
      break;
    default:
      return "Autre";
      break;
    }

  }


  //Une position donne est-elle prslectionne ?
  function estSelPos($no){
    $et = new ensTableBrioche("tarif", "position = $no AND tarif = $tarif", "position", 0, $this->idsession);
    return $et->compte();
  }




}


?>
