<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
///////////////////////////////////////////
//
//  Ajout / importation de prestations au tarif
//
//////////////////////////////////////////

class importPrestations extends cadronglet{
  var $montarif;
  
  #Constructeur
  function __construct($largeur, $grise, $actif, $fondpage, $sessionid,
                            $options, $donnees){
    global $fichier;
    global $imagesdir;
    if (! parent::__construct($largeur, $grise, $actif, $fondpage, $sessionid)) return; //appel du constsructeur de l'objet parent (avec vrif)
    
    $options = new optionsBriocheCab($options);
    $this->montarif = $options->getOption("TARIF");
    //Reception des donnes postes
    $ferme = false;
    $chiffre = preg_replace("/[^0-9]/", "", $donnees['position']);
    if (isset($donnees)){
      if (! $donnees['position']) {
        $al = new Alerte("Il faut indiquer une position !");
        $al->imprime();
      }
      elseif (! $donnees['texte']){
        $al = new Alerte("Il faut indiquer un libell / rsum");
        $al->imprime();
      }
      elseif ($this->montarif == 4 && ! $donnees['ch']){ //Nouvelles prestations liste analyses
        print $chiffre;
        $al = new Alerte("Il faut indiquer la nature de la prestation (chimie, hmatologie ou microbiologie)");
        $al->imprime();
      }
      else {
        
        $et = new ensTableBrioche("tarif", "position = " . $chiffre  . " AND tarif = $this->montarif",
                                  "id", 0, $this->idsession);
        print $et->getSql();
        $tet = $et->getTableau();
        $id = 0;
        if (isset($tet[0])) $id = $tet[0]->id; // La prestation  importer est dj dans la table tarif
        if ($this->montarif == 5 || $this->montarif == 6){
          $epostar = new ensTableTarmed("tarmedRef", "position = " . $donnees['position'], "*", 0, $this->idsession);
          $tepostar = $epostar->getTableau();
          $tepostar = $tepostar[0];
          $tabchamps = array();
          $tabchamps['tarif'] = $this->montarif;
          $tabchamps['position'] = $chiffre;
          $tabchamps['texte'] = $donnees['texte'];
          $tabchamps['points'] = $tepostar->pm + $tepostar->pt;
          $tabchamps['pm'] = $tepostar->pm;
          $tabchamps['pt'] = $tepostar->pt;
          $tabchamps['textecompl'] = $tepostar->texte;
          $tabchamps['nouvseance'] = $tepostar->nouvseance;
          $tabchamps['codref'] = $tepostar->codref;
          $tabchamps['deltatri'] = $tepostar->deltatri;
          $tabchamps['masquer'] = 0;
          $ut = new updateTableBrioche("tarif", $tabchamps, $id, "id", $this->idsession);
          if ($id) $ut->update(); else $ut->ajouteEnr();  
          $ferme = true;
        }
        elseif ($this->montarif == 4) {
          if ((! $donnees['points']) ||(! is_numeric($donnees['points']))) {
            $al = new Alerte("Il faut spcifier le nombre de points !");
            $al->imprime();
          }
          elseif ((! is_numeric($chiffre)) || $chiffre > 999999){
            $al = new Alerte("Code position : format non reconnu ! Veuillez entrer un nombre de un  six chiffres " .
                             "ou une expression du type 0000.00");
            $al->imprime();                 
          }
          else {
            $tabchamps = array();
            $tabchamps['tarif'] = 4;
            $tabchamps['position'] = $chiffre;
            $tabchamps['texte'] = $donnees['texte'];
            $tabchamps['points'] = $donnees['points'];
            $tabchamps['pm'] = 0;
            $tabchamps['pt'] = $donnees['points'];
            $tabchamps['ch'] = $donnees['ch'];
            $tabchamps['nouvseance'] = 0;
            $tabchamp['codref'] = 0;
            $tabchamps['deltatri'] = 0;
            $tabchamps['masquer'] = 0;
            $ut = new updateTableBrioche("tarif", $tabchamps, $id, "id", $this->idsession);
            if ($id) $ut->update(); else $ut->ajouteEnr();
            $ferme = true;
                
          }
        }
      }
      
    }
    if ($ferme){
      print "<SCRIPT LANGUAGE=\"JavaScript\">" .
            "window.opener.document.forms.donnees.elements['donnees[maj]'].value=0;" .
            "</SCRIPT>";
      $ff = new fermeFenetre(2, true);
    }
      
    $tabbande = array("Import ou ajout", "", "nouvelles prestations", "", "");
    $this->addOnglet("Import", $tabbande, "#8b8378", $this->actif, 120, "");
    $this->colmateOnglets();
    
    
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fichier, "post");
    
    
    if ($this->montarif == 5 || $this->montarif == 6) $gauche = 2;
    else $gauche = 4;
    $droite = 6 - $gauche;
    
    $of->addLigne(0.5);
    
    if ($this->montarif == 5 || $this->montarif == 6){ // Tarmed ancien ou nouveau 
      $etarm = new ensTableTarmed("tarmedRef", "masquer = " . ($this->montarif == 5 ? 5 : 0) , "LNR, position, " .
                                  "concat(LNR, \" \", left(texte, 100), if(char_length(texte) > 100, " .
                                  "\"...\", \"\")) as texte, resume",
                                  "position", $this->idsession);  
      $c = new TPanel(6);
      $x = new Label("Slectionnez dans la liste une prestation tarmed  ajouter  vos prestations usuelles et " .
                   "rdigez un rsum (max. 50 caractres) qui s'imprimera sur vos factures...");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      $c = new TPanel(6);
      $x = new ListOptTable("donnees[position]", $donnees['position'], $etarm, false, 0, "d2");
      $x->addDefaut("Choix de la position", 0);
      $x->addOptions("texte", "position");
      $c->addChamp($x);
      $x = new Espace(2);
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      $c = new TPanel(6);
      $x = new Label("Rsum :");
      $c->addChamp($x);
    }
    else { // Liste des analyses
      $c = new TPanel(6);
      $x = new Label("Indiquez le code position, le nombre de points et le libell d'une prestation de la liste des analyses...");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      $c = new TPanel(6);
      $x = new ChampTexte("donnees[position]", $donnees['position'], "Code position (0000.00) :", 10, 7, false, "TEXT", "d2");
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      $x = new ChampTexte("donnees[points]", $donnees['points'], "Nb. points : ", 10, 10, false, "TEXT", "d2");
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      $x = new Label("Chimie/Hmato./Micro.");
      $c->addChamp($x);
      $x = new ListOpt("donnees[ch]", $donnees['ch'], false);
      $x->addOption("---", "");
      $x->addOption("C", "C");
      $x->addOption("H", "H");
      $x->addOption("M", "M");
      $c->addChamp($x);
      
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      $c = new TPanel(6);
      $x = new Label("Libell :");
      $c->addChamp($x);    
    }
    $x = new Espace(2);
    $c->addChamp($x);
    $x = new ChampTexte("donnees[texte]", $donnees['texte'], "", 50, 50, false, "TEXT", "d2");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    $c = new TPanel(6, 1, "RIGHT");
    $x = new Bouton("OK", "OK", "SUBMIT", "", "bok");
    $c->addChamp($x);
    $x = new Espace(3);
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne();
    $c = new TPanel(6, 1, "RIGHT");
    $x = new Espace(2);
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x =new Bouton("options", $options->getChaine(), "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("action", $this->actif, "HIDDEN");
    $c->addChamp($x);
    $of->addChamp($c);
    $this->addContenu($of->getContenu());
    $tf = new TabForm();
    $tf->setTabParam(800, 0, 3, 0, "#d5ddff");
    $c = new TPanel(3);
    $x = new Espace(1);
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TPanel(3, 1, "RIGHT");
    $x = new Bouton("Fermer", "Fermer", "BUTTON", "window.close()");
    $c->addChamp($x);
    $tf->addChamp($c);
    $this->addContenu($tf->getContenu());
  }









}


?>
