<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
//////////////
//
//  Ce script permet l'importation de la base access tarmed
//  Le placer (ou le lier) dans le rpertoire contenant briocheIni.inc
//  Le fichier access doit se trouver dans $ini->cabDir;
//
/////////////

/// MODE D'EMPLOI : majTarmed.txt
/// REQUIERT QUE mdbtools SOIT INSTALLE SUR LE SYSTEME
/// L'utilisateur excutant le script doit pouvoir utilier mysql en ligne de commande sans
/// fournir de mot de passe (fichier .my.cnf)
/// Il y a un problme d'arrondi pour quelques prestations extrmement onreuses de 
/// neurochirurgie, mais cela ne devrait pas porter  consquence.

require("briocheIni.inc");      //utilise les fichiers de config. qui se trouvent dans le rpertoire    courant
require("hermesIni.inc");

$ini = new briocheIni();

require("$ini->classDir/session.inc");
require("$ini->classDir/sessionDBrioche.inc");
require("$ini->classDir/connexionBrioche.inc");

$sess = new Session(0, $ini->utilScripts, $ini->passeScripts);

$idsession = $sess->idsession;

if (! $idsession) die ("Impossible d'obtenir une session");
$con = new connexionBrioche($idsession);

$linkTarmed = mysqli_connect($ini->tarmedHote, $ini->tarmedUser, $ini->tarmedPw, $ini->tarmedBd);
//mysql_select_db($ini->tarmedBd, $linkTarmed);

//Destruction des trois tables

$req = "DROP TABLE IF EXISTS LEISTUNG";
$result = mysqli_query($linkTarmed, $req);
$req = "DROP TABLE IF EXISTS LEISTUNG_TEXT";
$result = mysqli_query($linkTarmed, $req);
$req = "DROP TABLE IF EXISTS VERSION";
$result = mysqli_query($linkTarmed, $req);

//Rcupration du schma de la table LEISTUNG
exec("mdb-schema $ini->cabDir/TARMED_Database.mdb -T LEISTUNG mysql | mysql $ini->tarmedBd");
//Rcupration du schma de la table LEISTUNG_TEXT
exec("mdb-schema $ini->cabDir/TARMED_Database.mdb -T LEISTUNG_TEXT mysql " .
     "| mysql $ini->tarmedBd");
//Schema table version
exec("mdb-schema $ini->cabDir/TARMED_Database.mdb -T VERSION mysql | mysql " . "$ini->tarmedBd");

//Exportation des donnes de LEISTUNG
exec("mdb-export -D \"%Y-%m-%d\" -H $ini->cabDir/TARMED_Database.mdb  " .
     "LEISTUNG > /tmp/prov1.txt");
//Rcupration des donnes exportes
exec("mysql  $ini->tarmedBd -e \"LOAD DATA LOCAL INFILE '/tmp/prov1.txt' REPLACE INTO TABLE LEISTUNG FIELDS TERMINATED BY ',' OPTIONALLY ENCLOSED BY '\\\"';\"");

//Exportation des donnes de LEISTUNG_TEXT
exec("mdb-export -D \"%Y-%m-%d\" -H $ini->cabDir/TARMED_Database.mdb " .
     "LEISTUNG_TEXT > /tmp/prov2.txt");
//Recodage en iso latin1

$prov2 = file("/tmp/prov2.txt");
$prov3 = array();
foreach($prov2 as $lignprov){
  $lignprov = utf8_decode($lignprov);
  $prov3[] = $lignprov;
}
$chaineprov = implode("\n", $prov3);
file_put_contents("/tmp/prov2.txt", $chaineprov);

//Rcupration des donnes exportes
exec("mysql $ini->tarmedBd -e \"LOAD DATA LOCAL INFILE '/tmp/prov2.txt' REPLACE INTO TABLE LEISTUNG_TEXT FIELDS TERMINATED BY ',' OPTIONALLY ENCLOSED BY '\\\"';\"");

//Exportation des donnes de VERSION
exec("mdb-export -D \"%Y-%m-%d\" -H $ini->cabDir/TARMED_Database.mdb " .
     "VERSION > /tmp/prov3.txt");
//Rcupration export
//$req = 'LOAD DATA LOCAL INFILE \'/tmp/prov3.txt\' REPLACE INTO TABLE VERSION ' .
//       'FIELDS TERMINATED BY "," OPTIONALLY ENCLOSED BY\'"\'';
//$result = mysqli_query($linkTarmed, $req);            
exec("mysql $ini->tarmedBd -e \"LOAD DATA LOCAL INFILE '/tmp/prov3.txt' REPLACE INTO TABLE VERSION FIELDS TERMINATED BY ',' OPTIONALLY ENCLOSED BY '\\\"';\"");


//Ajout champ tst  table VERSION
$req = "ALTER TABLE VERSION ADD tst TIMESTAMP";
$result = mysqli_query($linkTarmed, $req);
$req = "UPDATE VERSION SET tst = NOW()";
$result = mysqli_query($linkTarmed, $req);


//Rcupration de la date d'entre en vigueur de la dernire version
$req = "SELECT GUELTIG_VON FROM VERSION WHERE IN_PRODUKTION = \"ja\"";
$result = mysqli_query($linkTarmed, $req);
$ligne = mysqli_fetch_row($result);
$datedeb = $ligne[0];


//Suppression des enregistrements obsoltes
$req = "DELETE FROM LEISTUNG WHERE GUELTIG_BIS < \"$datedeb\"";
$result = mysqli_query($linkTarmed, $req);

//Indexage
$req = "alter table LEISTUNG add Index LNR (LNR)";
$result = mysqli_query($linkTarmed, $req);
$req = "alter table LEISTUNG_TEXT add Index LNR (LNR)";
$result = mysqli_query($linkTarmed, $req);
$req = "alter table LEISTUNG_TEXT add Index BEZ_255 (BEZ_255)";
$result = mysqli_query($linkTarmed, $req);


//Etablissement rapport
$rapport = fopen("rapport.txt", "w");
$contenu = "Rapport modification tarmed - " . date("Y-m-d");
$contenu .= "\n----------------------------------------\n";
//Prestations supprimes
$req = "select tarmedRef.LNR, tarmedRef.texte from tarmedRef left join LEISTUNG on tarmedRef.LNR = LEISTUNG.LNR WHERE LEISTUNG.LNR IS NULL and tarmedRef.masquer = 0";
$result = mysqli_query($linkTarmed, $req);
$contenu .= "Prestations supprimes : \n";
$chaine = "";
$amasquer = "";
while($ligne = mysqli_fetch_array($result)){
  $chaine .= $ligne['LNR'] . " : " . $ligne['texte'] . "\n";
  $amasquer .= "\"" . $ligne['LNR'] . "\",";
}
$amasquer = substr($amasquer, 0, -1);
$contenu .= $chaine;
//Prestations ajoutes
$req = "select LEISTUNG.LNR, LEISTUNG.TP_AL, LEISTUNG.TP_TL, " .
       "LEISTUNG_TEXT.BEZ_255 as TEXTE " .
       "from LEISTUNG left join tarmedRef " .
       "on LEISTUNG.LNR = tarmedRef.LNR " .
       "LEFT JOIN LEISTUNG_TEXT ON LEISTUNG.LNR = LEISTUNG_TEXT.LNR " .
       "WHERE tarmedRef.LNR IS NULL AND LEISTUNG_TEXT.SPRACHE = 'F'";
$result = mysqli_query($linkTarmed, $req);
$contenu .= "Prestations ajoutes : \n";
$chaine = "";
$cpt = 0;
$aajouter = array();
$amodifierpm = array();
$amodifierpt = array();
while($ligne = mysqli_fetch_array($result)){
  $chaine .= $ligne['LNR'] . " : " . $ligne['TEXTE'] . "\n";
  $aajouter[$cpt]['LNR'] = $ligne['LNR'];
  $aajouter[$cpt]['TP_AL'] = $ligne['TP_AL'];
  $aajouter[$cpt]['TP_TL'] = $ligne['TP_TL'];
  $cpt++;
}
$contenu .= $chaine;       
//Prestations dont le pm a t modifi
$req = "select tarmedRef.LNR, tarmedRef.texte, tarmedRef.pm, " .
       "LEISTUNG.TP_AL from tarmedRef left join LEISTUNG on " .
       "tarmedRef.LNR = LEISTUNG.LNR WHERE tarmedRef.pm <> LEISTUNG.TP_AL";
$result = mysqli_query($linkTarmed, $req);

$contenu .= "Modification pm : \n";
$chaine = "";
$cpt = 0;
while($ligne = mysqli_fetch_array($result)){
  $chaine .= $ligne['LNR'] . " - " . $ligne['texte'] . " : " . $ligne['pm'] . " --> " .
             $ligne['TP_AL'] . "\n";
  $amodifierpm[$cpt]['LNR'] = $ligne['LNR'];
  $amodifierpm[$cpt]['TP_AL'] = $ligne['TP_AL'];
  $cpt++;
}

$contenu .= $chaine;   

//Prestations dont le pt a t modifi
$req = "select tarmedRef.LNR, tarmedRef.texte, tarmedRef.pt, " .
       "LEISTUNG.TP_TL from tarmedRef left join LEISTUNG on " .
       "tarmedRef.LNR = LEISTUNG.LNR WHERE tarmedRef.pt <> LEISTUNG.TP_TL";
$result = mysqli_query($linkTarmed, $req);

$contenu .= "Modification pt : \n";
$chaine = "";
$cpt = 0;
while($ligne = mysqli_fetch_array($result)){
  $chaine .= $ligne['LNR'] . " - " . $ligne['texte'] . " : " . $ligne['pt'] . " --> " .
             $ligne['TP_TL'] . "\n";
  $amodifierpt[$cpt]['LNR'] = $ligne['LNR'];
  $amodifierpt[$cpt]['TP_TL'] = $ligne['TP_TL'];
  $cpt++;
}
$contenu .= $chaine;   

// Seulement s'il n'y a pas de coexistence de plusieurs versions
//Masquer les enregistrements supprims
//if ($amasquer){
//  $req = "update tarmedRef set masquer = -1 where LNR IN($amasquer)";
//  $result = mysqli_query($linkTarmed, $req);
//}
//

// Cas du passage de 1.08b - 1.09 (priode de transition avec 2 tarifs)
// On met un code 5  toutes les prestations de l'ancien tarif;

$req = "UPDATE tarmedRef set masquer = 5 where masquer = 0";
$result = mysqli_query($linkTarmed, $req);

// Seulement s'il n'y a pas coexistence
//Ajouter les nouveaux enregistrements
//$cpt = count($aajouter);
//for ($i = 0; $i < $cpt; $i++){
//  $req = "insert into tarmedRef set chap = " . substr($aajouter[$i]['LNR'], 0, 2) .
//         ", code = " . substr($aajouter[$i]['LNR'], -4) .
//         ", pm = " . $aajouter[$i]['TP_AL'] .
//         ", pt = " . $aajouter[$i]['TP_TL'] .
//         ", position = " . preg_replace("/\./", "", $aajouter[$i]['LNR']) .
//         ", LNR = \"" . $aajouter[$i]['LNR'] . "\"";
//  $result = mysqli_query($linkTarmed, $req);       
//}
////Rcriture des textes
//$req = "select LNR, BEZ_255 from LEISTUNG_TEXT where SPRACHE = 'F' " .
//       "and GUELTIG_BIS > now()";
//$result = mysqli_query($linkTarmed, $req);
//while ($ligne = mysqli_fetch_array($result)){
//  $req2 = "UPDATE tarmedRef set texte = \"" . $ligne['BEZ_255'] .
//          "\" where LNR = \"" . $ligne['LNR'] . "\"";
//  $result2 = mysqli_query($linkTarmed, $req2);       
//}

////Modification des pm
//$cpt = count ($amodifierpm);
//for ($i = 0; $i < $cpt; $i++){
//  $req2 = "update tarmedRef set pm = " . $amodifierpm[$i]['TP_AL']  . 
//         " where LNR = \"" . $amodifierpm[$i]['LNR'] . "\"";
//  $result2 = mysqli_query($linkTarmed, $req2);        
//}

////Modification des pt
//$cpt = count ($amodifierpt);
//for ($i = 0; $i < $cpt; $i++){
//  $req2 = "update tarmedRef set pt = " . $amodifierpt[$i]['TP_TL'] .
//          " where LNR = \"" . $amodifierpt[$i]['LNR'] . "\"";
//  $result2 = mysqli_query($linkTarmed, $req2);        
//}

// S'il y a coexistence, ajout de toutes les prestations du nouveau tarif
$req = "ALTER TABLE tarmedRef DROP INDEX IF EXISTS LNR";
$result = mysqli_query($linkTarmed, $req);

$req = "ALTER TABLE tarmedRef ADD INDEX IF NOT EXISTS LNR (LNR)";
$result = mysqli_query($linkTarmed, $req);

$req = "ALTER TABLE tarmedRef DROP INDEX IF EXISTS prest";
$result = mysqli_query($linkTarmed, $req);
$req = "ALTER TABLE tarmedRef ADD UNIQUE IF NOT EXISTS prest (chap, code, masquer)";
$result = mysqli_query($linkTarmed, $req);
$req = "SELECT LEISTUNG.* " .
       "from LEISTUNG ";  

$result = mysqli_query($linkTarmed, $req);

while ($ligne = mysqli_fetch_array($result)){
  $req2 = "INSERT INTO tarmedRef SET chap = " . substr($ligne['LNR'], 0, 2) .
          ", code = " . substr($ligne['LNR'], -4) .
          ", pm = " . $ligne['TP_AL'] .
          ", pt = " . $ligne['TP_TL'] .
          ", position = " . preg_replace("/\./", "", $ligne['LNR']) .
          ", LNR = \"" . $ligne['LNR'] . "\"" .
          ", masquer = 0";
  $result2 = mysqli_query($linkTarmed, $req2);
  $req3 = "SELECT BEZ_255 FROM LEISTUNG_TEXT WHERE SPRACHE=\"F\" AND LNR = \"" . $ligne['LNR'] . "\"";
  $result3 = mysqli_query($linkTarmed, $req3);
  $lig3 = mysqli_fetch_row($result3);
  
  $req4 = "UPDATE tarmedRef SET texte = \"" . $lig3[0] . "\" WHERE LNR = \"" . $ligne['LNR'] . "\" AND masquer = 0";
  $result4 = mysqli_query($linkTarmed, $req4);
  
  print mysqli_error($linkTarmed);
}
// Dsactivation position 65 (1.08)
$req = "update tarmedRef SET masquer = -1 where position = 65 and masquer = 5";
$result = mysqli_query($linkTarmed, $req);


//Remplissage du champ codref pour les prestations marques ("Z")
$req = "SELECT id, tarmedRef.LNR " .
       "FROM tarmedRef LEFT JOIN LEISTUNG ON tarmedRef.LNR = LEISTUNG.LNR " .
       "WHERE LEISTUNG.LEISTUNG_TYP = \"Z\" AND masquer = 0 " .
       "ORDER BY LNR";
$result = mysqli_query($linkTarmed, $req);
while ($ligne = mysqli_fetch_row($result)){
  $req2 = "SELECT LNR FROM LEISTUNG WHERE LEISTUNG_TYP = \"H\" AND LNR < \"$ligne[1]\" ORDER BY LNR DESC LIMIT 1";
  $result2 = mysqli_query($linkTarmed, $req2);
  $ligne2 = mysqli_fetch_row($result2);
  $req3 = "UPDATE tarmedRef SET codref = \"$ligne2[0]\" WHERE id = $ligne[0]";
  $result3 = mysqli_query($linkTarmed, $req3);
}        

// Rsums pour tarmed 1.09
$comm = array(
  array('pos' => 10, 'res' => "Consultation, premire priode", 'gr' => 0),
  array('pos' => 15, 'res' => "Prestation de mdecine de famille", 'gr' => 0),
  array('pos' => 20, 'res' => "Consultation, priode supplmentaire", 'gr' => 1),
  array('pos' => 25, 'res' => "Consultation, priode supplmentaire (<>)", 'gr' => 2),
  array('pos' => 26, 'res' => "Consultation, priode supplmentaire (+)", 'gr' => 3),
  array('pos' => 30 , 'res' => "Consultation, dernire priode", 'gr' => 0),
  array('pos' => 40 , 'res' => "Enfant de moins de 6 ans", 'gr' => 0),
  array('pos' => 50 , 'res' => "Entretien d'information", 'gr' => 1),
  array('pos' => 55 , 'res' => "Entretien d'information (<>)", 'gr' => 2),
  array('pos' => 56, 'res' => "Entretien d'information (+)", 'gr' => 3),
  array('pos' => 60, 'res' => "Visite, premire priode", 'gr' => 0),
  array('pos' => 70, 'res' => "Visite, priode supplmentaire", 'gr' => 1),
  array('pos' => 75, 'res' => "Visite, priode supplmentaire (<>)", 'gr' => 2),
  array('pos' => 76, 'res' => "Visite, priode supplmentaire (+)", 'gr' => 3),
  array('pos' => 80, 'res' => "Visite, dernire priode", 'gr' => 0),
  array('pos' => 95, 'res' => "Dplacement", 'gr' => 0),
  array('pos' => 100, 'res' => "Transport du patient", 'gr' => 0),
  array('pos' => 110, 'res' => "Consultation tlphonique, premire priode", 'gr' => 0),
  array('pos' => 120, 'res' => "Consult. tlphonique, priode supplmentaire", 'gr' => 1),
  array('pos' => 125, 'res' => "Consult. tlphonique, priode supplmentaire (<>)", 'gr' => 2),
  array('pos' => 126, 'res' => "Consult. tlphonique, priode supplmentaire (+)", 'gr' => 3),
  array('pos' => 130, 'res' => "Consult. tlphonique, dernire priode", 'gr' => 0),
  array('pos' => 131, 'res' => "tude de dossier (<>)", 'gr' => 2),
  array('pos' => 132, 'res' => "Entretien avec tiers (<>)", 'gr' => 2),
  array('pos' => 133, 'res' => "Renseignement proches (<>)", 'gr' => 2),
  array('pos' => 134, 'res' => "Discussion avec soignants (<>)", 'gr' => 2),
  array('pos' => 135, 'res' => "Envoi chez spcialiste (<>)", 'gr' => 2),
  array('pos' => 136, 'res' => "Ordonnance (<>)", 'gr' => 2),
  array('pos' => 137, 'res' => "", 'gr' => 2),
  array('pos' => 138, 'res' => "", 'gr' => 2),
  array('pos' => 141, 'res' => "tude de dossier", 'gr' => 1),
  array('pos' => 142, 'res' => "Entretien avec tiers", 'gr' => 1),
  array('pos' => 143, 'res' => "Renseignement proches", 'gr' => 1),
  array('pos' => 144, 'res' => "Discussion avec soignants", 'gr' => 1),
  array('pos' => 145, 'res' => "Envoi chez spcialiste", 'gr' => 1),
  array('pos' => 146, 'res' => "Ordonnance", 'gr' => 1),
  array('pos' => 147, 'res' => "", 'gr' => 0),
  array('pos' => 148, 'res' => "", 'gr' => 0),
  array('pos' => 150, 'res' => "Administration de mdicaments", 'gr' => 0),
  array('pos' => 155, 'res' => "Substitution opiacs", 'gr' => 0),
  array('pos' => 160, 'res' => "Collecte d'urine (toxicologie)", 'gr' => 0),
  array('pos' => 161, 'res' => "tude de dossier (+)", 'gr' => 3),
  array('pos' => 162, 'res' => "Entretien avec tiers (+)", 'gr' => 3),
  array('pos' => 163, 'res' => "Renseignement proches (+)", 'gr' => 3),
  array('pos' => 164, 'res' => "Discussion avec soignants (+)", 'gr' => 3),
  array('pos' => 165, 'res' => "Envoi chez spcialiste (+)", 'gr' => 3),
  array('pos' => 166, 'res' => "Ordonnance (+)", 'gr' => 3),
  array('pos' => 167, 'res' => "", 'gr' => 3),
  array('pos' => 168, 'res' => "", 'gr' => 3),
  array('pos' => 415, 'res' => "Petit examen", 'gr' => 1),
  array('pos' => 416, 'res' => "Petit examen (<>)", 'gr' => 2),
  array('pos' => 417, 'res' => "Petit examen (+)", 'gr' => 3),
  array('pos' => 425, 'res' => "Examen complet", 'gr' => 0),
  array('pos' => 435, 'res' => "", 'gr' => 1),
  array('pos' => 436, 'res' => "", 'gr' => 2),
  array('pos' => 437, 'res' => "", 'gr' => 3),
  array('pos' => 490, 'res' => "Bilan cognitif", 'gr' => 0),
  array('pos' => 510, 'res' => "Consultation spcifique", 'gr' => 1),
  array('pos' => 515, 'res' => "Consultation spcifique (<>)", 'gr' => 2),
  array('pos' => 516, 'res' => "Consultation spcifique (+)", 'gr' => 3),
  array('pos' => 520, 'res' => "Consultation psychosociale", 'gr' => 0),
  array('pos' => 530, 'res' => "Consultation gntique", 'gr' => 1),
  array('pos' => 535, 'res' => "Consultation gntique (<>)", 'gr' => 2),
  array('pos' => 536, 'res' => "Consultation gntique (+)", 'gr' => 3),
  array('pos' => 610, 'res' => "Instruction du patient", 'gr' => 1),
  array('pos' => 615, 'res' => "Instruction du patient (<>)", 'gr' => 2),
  array('pos' => 616, 'res' => "Instruction du patient (+)", 'gr' => 3),
  array('pos' => 715, 'res' => "Prise de sang veineux", 'gr' => 0),
  array('pos' => 716, 'res' => "Prise de sang capillaire", 'gr' => 0),
  array('pos' => 750, 'res' => "Injection par pers. non mdical", 'gr' => 0),
  array('pos' => 850, 'res' => "Pose voie veineuse", 'gr' => 0),
  array('pos' => 1160, 'res' => "Anesthsie par application", 'gr' => 0),
  array('pos' => 1170, 'res' => "Cryoanesthsie", 'gr' => 0),
  array('pos' => 1180, 'res' => "Anesthsie locale (visage, cou, mains)", 'gr' => 0),
  array('pos' => 1190, 'res' => "Anesthsie locale (autres loc.)", 'gr' => 0),
  array('pos' => 1240, 'res' => "Anesthsie en bague, 1er doigt", 'gr' => 0),
  array('pos' => 1250, 'res' => "Anesthsie en bague, doigt suivant", 'gr' => 0),
  array('pos' => 1310, 'res' => "Dsensibilisation", 'gr' => 0),
  array('pos' => 1345, 'res' => "Nettoyage ou chgt pansement par personnel", 'gr' => 0),
  array('pos' => 1370, 'res' => "Suivi et surveillance au cabinet (15 min.)", 'gr' => 0),
  array('pos' => 1390, 'res' => "Examen d'un cadavre", 'gr' => 0),
  array('pos' => 1400, 'res' => "Examen mdico-lgal", 'gr' => 0),
  array('pos' => 2206, 'res' => "Rapport sur formulaire (5 min.)", 'gr' => 0),
  array('pos' => 2215, 'res' => "Formulaire traumatisme cervical", 'gr' => 0),
  array('pos' => 2285, 'res' => "Rapport, premire page", 'gr' => 0),
  array('pos' => 2295, 'res' => "Rapport, page suivante", 'gr' => 0),
  array('pos' => 2505, 'res' => "Visite ou consultation pressante", 'gr' => 0),
  array('pos' => 2510, 'res' => "Forfait urgence A", 'gr' => 0),
  array('pos' => 2520, 'res' => "Forfait urgence B", 'gr' => 0),
  array('pos' => 2530, 'res' => "Majoration urgence B", 'gr' => 0),
  array('pos' => 2540, 'res' => "Forfait urgence C", 'gr' => 0),
  array('pos' => 2550, 'res' => "Majoration urgence C", 'gr' => 0),
  array('pos' => 2560, 'res' => "Forfait urgence D", 'gr' => 0),
  array('pos' => 2570, 'res' => "Majoration urgence D", 'gr' => 0),
  array('pos' => 2580, 'res' => "Forfait urgence E", 'gr' => 0),
  array('pos' => 2590, 'res' => "Majoration urgence E", 'gr' => 0),
  array('pos' => 40520, 'res' => "Incision/drainage abcs superf.", 'gr' => 0),
  array('pos' => 40540, 'res' => "Excision cutane, visage, cou, main", 'gr' => 0),
  array('pos' => 40580, 'res' => "Excision cutane, autres localisations", 'gr' => 0),
  array('pos' => 41010, 'res' => "Traitement de plaie (visage, cou, mains)", 'gr' => 0),
  array('pos' => 41030, 'res' => "Traitement de plaie (autres localisations)", 'gr' => 0),
  array('pos' => 170010, 'res' => "lectrocardiogramme", 'gr' => 0),
  array('pos' => 190170, 'res' => "Test respiratoire (helicobacter)", 'gr' => 0),
);




$req = "ALTER TABLE tarmedRef ADD classe TINYINT NOT NULL DEFAULT 0";
$result = mysqli_query($linkTarmed, $req);
print mysqli_error($linkTarmed);

foreach ($comm as $ligne){
  $req2 = "UPDATE tarmedRef SET resume = \"" . $ligne['res'] .
          "\", classe = " . $ligne['gr'] . " where position = " . $ligne['pos'] .
          " and masquer = 0";
  $result2 = mysqli_query($linkTarmed, $req2);
  print mysqli_error($linkTarmed);
}

$req = "UPDATE tarmedRef SET resume = NULL WHERE resume = \"\"";
$result = mysqli_query($linkTarmed, $req);

$req = "UPDATE tarmedRef SET deltatri = -170, nouvseance = 1 where position in(131,132,133,134,135,136,137,138," .
                                                              "141,142,143,144,145,146,147,148," .
                                                              "161,162,163,164,165,166,167,168" .
                                                              ") and masquer = 0";
$result = mysqli_query($linkTarmed, $req);

$req = "UPDATE tarmedRef SET deltatri = 85 where position = 50";
$result = mysqli_query($linkTarmed, $req);

// Nouvelle sance pour nouveau tarif;
$req = "SELECT * FROM tarmedRef where nouvseance = 1 and masquer = 5";
$result = mysqli_query($linkTarmed, $req);
while ($ligne = mysqli_fetch_array($result)){
  $req2 = "UPDATE tarmedRef SET nouvseance = 1 where masquer = 0 and position = " . $ligne['position'];
  $result2 = mysqli_query($linkTarmed, $req2);
  
}


fwrite($rapport, $contenu);
fclose($rapport);


exec("mysqldump --add-drop-table " . $ini->tarmedBd . " > " . $ini->cabDir .
     "/tarmed.sql");      


?>
