<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

////////////////////////////////////////////
//
//  Journal compta
//
////////////////////////////////////////////

class jourCompta extends cadronglet{
  var $action0;
  var $action1;
  var $action2;
  var $action3;
  var $action4;
  var $donnees;
  var $options;
  #Constructeur
  function __construct($largeur, $grise, $actif, $fondpage, $sessionid, $action0, $action1, $action2, $action3, 
                      $action4, $donnees, $options, $item){
    global $fichier;
    global $imagesdir;
    global $fdossbrioche;
    $ini = new BriocheIni();
    if (! parent::__construct($largeur, $grise, $actif, $fondpage, $sessionid)) return;
    $this->action0 = $action0;
    $this->action1 = $action1;
    $this->action2 = $action2;
    $this->action3 = $action3;
    $this->action4 = $action4;
    $this->donnees = $donnees;
    $courant = true;
    $exercice = "Courant";
    $ec = new ensCompta($this->idsession);
    $listex = $ec->getExercices();
    $tablec = "comptes";
    $champ = "noop";
    
    if (! isset($donnees['page'])) $donnees['page'] = "";
    if (! isset($donnees['date'])) $donnees['date'] = "";
    if (! isset($donnees['dates'])) $donnees['dates'] = "";
    // Ce n'est pas l'exercice courant
    if ($donnees['dates']){
      $courant = false;
      $dates = $donnees['dates'];
      $exercice = $listex[$dates]['affichage'];
      $tablec = $listex[$dates]['table'];
      $champ = "ecriture";
    }
    $this->options = new optionsBriocheCab($options);
    $tabbande = array("Journal", "", "", "", "");
    $this->addOnglet("Comptabilit", $tabbande, "#8b8378", $this->action1, 80,
                     "javascript:lienCond('$fichier?action=$this->action1&sessionid=$this->idsession');");
    if ($courant){
      $this->addOnglet("Incomplets", $tabbande, "#455667", $this->action2, 80, 
                       "$fichier?action=$this->action2&sessionid=$this->idsession");
      $this->addOnglet("Accessoires", $tabbande, "#12aaaa", $this->action3, 80, 
                       "$fichier?action=$this->action3&sessionid=$this->idsession");
    }
    $this->colmateOnglets();
    
    //Destruction d'un enregistrement
    if ($this->options->getOption("DETR_OP") && $courant){
      $this->options->setOption("DETR_OP", 0);
      $ut = new updateTableBrioche("comptes", 0, $item, "noop", $this->idsession);
      $ut->detruitEnr();
    }
    
    //Ecriture des donnes (enr. incomplets)
    if ($this->options->getOption("ENR_COMPTA") && $courant){
      $this->options->setOption("ENR_COMPTA", 0);
      if (is_array($donnees) && count($donnees)){
        foreach($donnees as $cle => $valeur){
          if (isset($valeur['cred']) && isset($valeur['deb'])) {
            $tabchamps['cred'] = ($valeur['cred'] ? $valeur['cred'] : "NULL");
            $tabchamps['deb'] = ($valeur['deb'] ? $valeur['deb'] : "NULL");
            $ut = new updateTableBrioche("comptes", $tabchamps, $cle, "noop", $this->idsession);
            $ut->update();
          }
        }
      }
    }
    
    //Contenu
    
    switch ($this->actif){
    case  $this->action1:  
      $where = "deb > 100 and cred > 100";
      break;
    case $this->action2:  // Enregistrements incomplets
      $where = "(deb is null or cred is null) and typedecriture <> 0";
      break;    
    case $this->action3:
      $where = "deb < 100 or cred < 100";
      break;
    }
    $join[] = "listecomptes";
    $on[] = "$tablec.cred = listecomptes.nocompte";
    $join[] = "listecomptes as listecomptes1";
    $on[] = "$tablec.deb = listecomptes1.nocompte";
    $et = new ensTableBrioche($tablec, $where,
                              "$champ, datop, deb, cred, mtant, de_pour, texte, " .
                              "listecomptes.nomcompte as nomcred, listecomptes1.nomcompte as nomdeb",
                              "datop DESC, $champ DESC", $this->idsession, $join, $on);
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fichier, "post");
    $of->addLigne(0.5);
    $c = new TPanel(2, 1);
    $x = New Label("Exercice : $exercice", true);
    $c->addChamp($x);
    $of->addChamp($c);
    $c = new TPanel(4, 1, "RIGHT");
    $x = new Bouton("Ajouter", "Ajouter", "BUTTON",
                    "javascript:lienCond(\"". 
                    "javascript:ouvreFenetre(\\\"$fdossbrioche?action=$this->action4" .
                    "&sessionid=$this->idsession&item=-999\\\", " .
                    "\\\"ajout\\\", \\\"scrollbars=no,resizable=no,menubar=no,locationbar=no,height=300," .
                    "width=500,screenX=150,screenY=100\\\")" .
                    "\")");
    $c->addChamp($x);
    $x = new Espace(2);
    $c->addChamp($x);
    if ($this->actif == $this->action2){
      $futopt = new optionsBriocheCab($this->options->getChaine());
      $futopt->setOption("ENR_COMPTA", 1);
      $x = new Bouton("OK", "OK", "BUTTON", "changeChamp(\"options\", \"" .
                      $futopt->getChaine() . "\", \"donnees\");" .
                      "document.forms.donnees.submit();", "bok");
      $c->addChamp($x);
      $x = new Espace(2);
      $c->addChamp($x);
      $x = new Bouton("Annuler", "Annuler", "RESET", "", "ban");
      $c->addChamp($x);
      $x = new Espace(2);
      $c->addChamp($x);
    }
    $x = new Bouton("Retour", "Retour", "BUTTON", "if(!qModif()){changeChamp(\"action\"," .
                    "\"$this->action0\", \"donnees\");document.forms.donnees.submit()}");
    $c->addChamp($x);
    $x = new Espace(2);
    $c->addChamp($x);
    $x = new Aide("C012");
    $c->addChamp($x);
    
    $x = new Espace(3);
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("action", $this->actif, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("options", $this->options->getChaine(), "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("item", $item, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("donnees[dates]", $donnees['dates'], "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("donnees[page]", $donnees['page'], "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("scroll", 0, "HIDDEN");
    $c->addChamp($x);
    $of->addChamp($c);

    
    $of->addLigne();
    $c = new TPanel(6, 1);
    //$x = new Label($et->compte() . " oprations affiches...", true);
    $x = new Pagination($et, "oprations", "donnees", "donnees[page]",
                        $ini->longPage, $donnees['page']);
    $c->addChamp($x);
    $of->addChamp($c);
        $of->addLigne(0.5);
    $of->addLigne();
    $c = new TPanelTableau(6, 1, $et, "#efefef", "donnees", $champ);
    if ($courant){
      $x = new BoutonImage("", "$imagesdir/vu.gif", 12, 12, 
                           "javascript:lienCond('" . 
                           "javascript:ouvreFenetre(\'$fdossbrioche?action=$this->action4" .
                           "&sessionid=$this->idsession&item=\', \'ajout\', " .
                           "\'scrollbars=no,resizable=no,menubar=no,locationbar=no,height=300," .
                           "width=500,screenX=150,screenY=100\');');",
                           $champ);
      $c->addColChamp("", $x, false, true);                     
    }
    $x = new Label("", false, false, false, $champ);
    $c->addColChamp("N", $x);
    $x = new Label("", false, false, false, "datop");
    $c->addColChamp("Date", $x);
    if ($this->actif == $this->action2){
      $el = new EnsTableBrioche("listecomptes", "1", "nomcompte, nocompte", "nomcompte", $this->idsession);
      $x = new ListOptTableAuto("cred", "", $el, true, "nomcompte", "nocompte", "d2");
      $c->addColChamp("Cpte crdit", $x);
      $x = new ListOptTableAuto("deb", "", $el, true, "nomcompte", "nocompte", "d2");
      $c->addColChamp("Cpte dbit", $x);
    }
    else {
      $x = new Label("", false, false, false, "nomcred");
      $c->addColChamp("Cpte crdit", $x);
      $x = new Label("", false, false, false, "nomdeb");
      $c->addColChamp("Cpte dbit", $x);
    }
    $x = new Label("", false, false, false, "texte");
    $c->addColChamp("Texte / Rf.", $x);
    $x = new Label("", false, false, false, "de_pour");
    $c->addColChamp("De / pour", $x);
    $x = new  Label("", false, false, false, "mtant");
    $c->addColChamp("Montant", $x, false, false, "", "", "RIGHT");
    $futopt = new optionsBriocheCab($this->options->getChaine());
    $futopt->setOption("DETR_OP", 1);
    if ($courant){
      $x = new BoutonImage("", "$imagesdir/croix.gif", 12, 12,
                           "javascript:supprimeCond('javascript:if(!qModif()){" .
                           "document.forms.donnees.item.value=;" .
                           "document.forms.donnees.options.value=\'" . $futopt->getChaine() . "\';" .
                           "document.forms.donnees.scroll.value=document.body.scrollTop;" .
                           "document.forms.donnees.submit();}', '')", $champ);
      $c->addColChamp("", $x, false, true);
    }
    $c->addTitres(true);
    $of->addChamp($c);
    
    $of->addLigne();
    $this->addContenu($of->getContenu());
  }






}
?>
