<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

//////////////////////////////////////////////////////
//
//  Page "Factures"
//
////////////////////////////////////////////////////////

class pageDossierBriocheCabFact extends pageDossierBriocheCab {
  var $pv;

  #Constructeur
  function __construct(&$dbr) {
    global $imagesdir;
    global $fdosbrioche;
    parent::__construct($dbr);
    $efg = new ensFacture($this->dbr->idsession);
    $ef = new ensFacturePat($this->dbr->item, $this->dbr->idsession);
    $tabfact = $ef->getTabFact();
    $emed = new ensTableBrioche("medecins", 1, "*", 0, $this->dbr->idsession);
    $nbmed = $emed->compte();
    // Dessin de l'interface
    $this->pv = new PPageVierge();
    $c = new TPanel(5, 1);
    $x = new Label($this->dbr->nomplein . " - ", true);
    $c->addChamp($x);
    $x = new Label($ef->compte() . " facture" . ($ef->compte() > 1 ? "s" : "") . "...");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    if ($this->dbr->itfact){
      $mafact = new ensDetailFacture($this->dbr->itfact, $this->dbr->idsession);
      //Faut-il imprimer la facture ?
      if ($this->dbr->options->getOption("CH_ST_FACT") == 2){
        $this->dbr->options->setOption("CH_ST_FACT", 0);
        //$mafact->recalcule();
        //$mafact->prepare();
        print "<SCRIPT LANGUAGE=\"JavaScript\">" .
              "ouvreFenetre('fichepatient.php?itfact=" . $this->dbr->itfact .
              "&item=" . $this->dbr->item . "&sessionid=" . $this->dbr->idsession .
              "&mode=fg', 'Imprimer', 'scrollbars=no,resizable=yes,menubar=no,locationbar=no," .
              "height=200,width=800,screenX=150,screenY=100');" .
              "ouvreAutreFenetre('fichepatient.php?itfact=" . $this->dbr->itfact .
              "&item=" .$this->dbr->item ."&sessionid=" . $this->dbr->idsession . 
              "&mode=fj','Justificatifs'," .
              "'scrollbars=no,resizable=yes,menubar=no,locationbar=no,height=200," .
              "width=800,screenX=150,screenY=100');" .
              "</SCRIPT>";
      }
      //Faut-il boucler la facture ?
      if ($this->dbr->options->getOption("CH_ST_FACT") == 1){
        $mafact->boucle();
        $this->dbr->options->setOption("CH_ST_FACT", 0);
      }
      //Faut-il entrouvrir la facture ?
      if ($this->dbr->options->getOption("CH_ST_FACT") == 7){
        $mafact->entrOuvre();
        $this->dbr->options->setOption("CH_ST_FACT", 0);
      }
      //Faut-il rouvrir la facture ?
      if ($this->dbr->options->getOption("CH_ST_FACT") == 8){
        $mafact->rouvre();
        $this->dbr->options->setOption("CH_ST_FACT", 0);
      }
      //Faut-il changer le mdecin ?
      if ($this->dbr->options->getOption("CH_MED")){
        $mafact->changeMed();
        //$mafact = new ensDetailFacture($this->dbr->itfact, $this->dbr->idsession);
        $this->dbr->options->setOption("CH_MED", 0);
      }
      // Faut-il changer le bouclement
      if ($this->dbr->options->getOption("CH_BOUCL_FACT")){
        $mafact->changeBoucl($this->dbr->options->getOption("CH_BOUCL_FACT"));
      }
      //Faut-il dtruire une prestation ?
      if ($this->dbr->options->getOption("SUP_PREST")){
        $mafact->supPrest($this->dbr->itprest);
        $this->dbr->options->setOption("SUP_PREST", 0);
      }
      //Faut-il recalculer la facture ?
      if ($this->dbr->options->getOption("REC_FACT")){
        $mafact->recalculeplus();
        $this->dbr->options->setOption("REC_FACT", 0);
      }
      //Faut-il convertir la facture ?
      if ($this->dbr->typeprest){
        $mafact->convertit($this->dbr->typeprest);
      }
      
      if ($mafact->isImprimable()){
        $c = new TPanel(1, 1);
        $futopt = new optionsBriocheCab($this->dbr->options->getChaine());
        $futopt->setOption("CH_ST_FACT", 2);
        $x = new BoutonImage("Imprimer", "images/imprim.gif", 32, 32,
                             "$fdosbrioche?action=" . $this->dbr->action . "&sessionid=" .
                             $this->dbr->idsession . "&item=" . $this->dbr->item . "&itfact=" .
                             $this->dbr->itfact . "&options=" . $futopt->getChaine(),
                             "", "", "Imprimer facture");
        $c->addChamp($x);
        $this->pv->addChamp($c);
      }
    }
    $this->pv->addLigne();
    $c = new TPanel(1, 1);
    $x = new Bouton("Facturer", "Facturer", "BUTTON",
                    "ouvreFenetre(\"$fdosbrioche?action=1000&sessionid=" .
                    $this->dbr->idsession . "&options=" . $this->dbr->options->getChaine() .
                    "&item=" . $this->dbr->item . "\", \"Facturer\", " .
                      "\"scrollbars=no,resizable=no,menubar=no,locationbar=no,height=450," .
                      "width=780,screenX=150,screenY=100\")");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    if (! $this->dbr->itfact){ // Pas de numro de facture, donc affichage de la liste
      $c = new TPanel(5, 1, "RIGHT");
      $x = new Aide("C006");
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne();
      $c = new TPanelTableau(6, 1, $tabfact, "#efefef", "factures", "nofact");
      $x = new BoutonImage("", "$imagesdir/vu.gif", 12, 12,
                         "$fdosbrioche?action=" . $this->dbr->action . "&sessionid=" .
                         $this->dbr->idsession . "&item=" . $this->dbr->item . "&itfact=" .
                         "&options=" . $this->dbr->options->getChaine(),
                         "nofact");
      $c->addColChamp("", $x, false, true);
      $x = new Label("", false, false, false, "nofact");
      $c->addColChamp("N", $x, false, false, "getNoAbr", $ef);
      $x = new Label("", false, false, false, "typabr");
      $c->addColChamp("Type", $x);
      $x = new Label("", false, false, false, "abr");
      $c->addColChamp("Md.", $x);
      $x = new Label("", false, false, false, "debut");
      $c->addColChamp("Dbut", $x);
      $x = new Label("", false, false, false, "fin");
      $c->addColChamp("Fin", $x);
      $x = new Label("", false, false, false, "stat");
      $c->addColChamp("Status", $x);
      $x = new Label("", false, false, false, "montant");
      $c->addColChamp("Montant", $x);
      $c->addTitres(true);
      $this->pv->addChamp($c);
    }
    else { // Affichage du dtail d'une facture
      $c = new TPanel(2, 1);
      if ($mafact->isOuvert()){ // Facture ouverte => bouton prestations isoles
        $futopt = new optionsBriocheCab($this->dbr->options->getChaine());
        $futopt->setOption("TARIF", $mafact->getTarmed());
        $x = new Label("Ajout de : ", true, false);
        $c->addChamp($x);
        $x = new BoutonTexte("Prestations isoles", "javascript:ouvreFenetre('$fdosbrioche?action=1500&sessionid=" .
                        $this->dbr->idsession . "&options=" . $futopt->getChaine() .
                        "&itfact=" . $this->dbr->itfact . "', 'Facturer', " .
                        "'scrollbars=no,resizable=no,menubar=no,locationbar=no,height=620," .
                        "width=600,screenX=150,screenY=100')", "#efefef", 150, 15);
        $c->addChamp($x);
        $futopt->setOption("TARIF", 9);
        $x = new BoutonTexte("Prestations sur mesure", "javascript:ouvreFenetre('$fdosbrioche?action=1500&sessionid=" .
                        $this->dbr->idsession . "&options=" . $futopt->getChaine() .
                        "&itfact=" . $this->dbr->itfact . "&itprest=l', 'Facturer', " .
                        "'scrollbars=no,resizable=no,menubar=no,locationbar=no,height=620," .
                        "width=600,screenX=150,screenY=100')", "#f9f9f9", 150, 15);
        $c->addChamp($x);
        $x = new BoutonTexte("Prestations libres", "javascript:ouvreFenetre('$fdosbrioche?action=1700&sessionid=" .
                        $this->dbr->idsession . "&options=" . $futopt->getChaine() .
                        "&itfact=" . $this->dbr->itfact . "&itprest=l', 'Facturer', " .
                        "'scrollbars=no,resizable=no,menubar=no,locationbar=no,height=250," .
                        "width=600,screenX=150,screenY=100')", "#efefef", 150, 15);
        $c->addChamp($x);
        $x = new BoutonTexte("Remarques", "javascript:ouvreFenetre('$fdosbrioche?action=1700&sessionid=" .
                        $this->dbr->idsession . "&options=" . $futopt->getChaine() .
                        "&itfact=" . $this->dbr->itfact . "&itprest=r', 'Facturer', " .
                        "'scrollbars=no,resizable=no,menubar=no,locationbar=no,height=250," .
                        "width=600,screenX=150,screenY=100')", "#f9f9f9", 150, 15);
        $c->addChamp($x);

        
      }
      else {
        $x = new Espace(1);
        $c->addChamp($x);
      }
      $this->pv->addChamp($c);
      $chopt  = $this->dbr->options->getChaine();
      $c = new TPanel(1, 1);
      $x = new BoutonTexte("Retour  la liste",
                           "$fdosbrioche?action=" . $this->dbr->action . "&sessionid=" .
                           $this->dbr->idsession . "&item=" . $this->dbr->item .
                           "&options=" . $chopt, "#c6ffc7", 100, 15);
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $c = new TPanel(2, 1, "RIGHT");
      $x = new Aide("C007");
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      $this->pv->addChamp($c);
      
      $this->pv->addLigne(1.5);
      $meslignes = $mafact->getLignes();
      $mesremarques = $mafact->getRemarques();
      $c = new TPanel (4, 1);
      $x = new Label("Facture N " . $ef->getNoAbr($this->dbr->itfact), true);
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      $x = new Label(" - Du : " . $mafact->debut . "  Au : " . $mafact->fin);
      $c->addChamp($x);
      $x = new Label(" - Status : <FONT COLOR=\"" . $mafact->coulstat . "\">"
                     . $mafact->status . "</FONT>");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      // Changement du status de la facture
      $c = new GrTBoutonTexte("", 2, 300, 15, "", "#efefef", 3);
      $futopt = new optionsBriocheCab($this->dbr->options->getChaine());
      if ($mafact->isOuvert()){
        $futopt->setOption("CH_ST_FACT", 1);
        $c->addBouton("Boucler",
                      "$fdosbrioche?action=" . $this->dbr->action . "&sessionid=" .
                      $this->dbr->idsession . "&item=" . $this->dbr->item . "&itfact=" .
                      $this->dbr->itfact . "&options=" . $futopt->getChaine(),
                      1);
      }
      if ($mafact->isRouvrable()){
        $futopt->setOption("CH_ST_FACT", 8);
        $c->addBouton("Rouvrir",
                      "$fdosbrioche?action=" . $this->dbr->action . "&sessionid=" .
                      $this->dbr->idsession . "&item=" . $this->dbr->item . "&itfact=" .
                      $this->dbr->itfact . "&options=" . $futopt->getChaine(),
                      1);
      }
      if ($mafact->isEntrOuvrable()){
        $futopt->setOption("CH_ST_FACT", 7);
        $c->addBouton("Entrouvrir", "$fdosbrioche?action=" . $this->dbr->action . "&sessionid=" .
                      $this->dbr->idsession . "&item=" . $this->dbr->item . "&itfact=" .
                      $this->dbr->itfact . "&options=" . $futopt->getChaine(),
                      1);
      }
      $this->pv->addChamp($c);
      $this->pv->addLigne();
      $c = new TPanel(2, 1);
      $x = new Label("Type : <I><B>" . $mafact->ttypeprest . "</B></I>");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $tp = $efg->getTypePrest(0);
      $ttp = $tp->getTableau();
      $cttp = count($ttp);
      //Conversion de la facture
      if ($mafact->isOuvert()){
        $c = new TPanel(1, 1, "RIGHT");
        $x = new Label ("Convertir :&nbsp;&nbsp;");
        $c->addChamp($x);
        $this->pv->addChamp($c);
        $c = new GrTBoutonTexte($mafact->typeprest, 3, 300, 18, "#aaaaaa", "#efefef", $cttp);
        for ($i = 0; $i < $cttp; $i++){
          if ($mafact->getTarmed() == $ttp[$i]->tarmed){
            $c->addBouton($ttp[$i]->abr,
                          "$fdosbrioche?action=" . $this->dbr->action . "&sessionid=" .
                          $this->dbr->idsession . "&item=" . $this->dbr->item . "&itfact=" .
                          $this->dbr->itfact . "&options=" . $this->dbr->options->getChaine() .
                          "&typeprest=" . $ttp[$i]->id,
                          $ttp[$i]->id);
          }
        }
        $this->pv->addChamp($c);
      }
      $this->pv->addLigne();
      $c = new TPanel(4, 1);
      $x = new Label("Date de la facture : ", true);
      $c->addChamp($x);
      $x = new Label($mafact->datefact);
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      $x = new Label("Date du dernier rappel : ", true);
      $c->addChamp($x);
      $x = new Label($mafact->daterap);
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $futopt = new optionsBriocheCab($this->dbr->options->getChaine());
      $c = new GrTBoutonTexte($mafact->bouclement, 2, 180, 12, "#aaaaaa", "#efefef", 3);
      $futopt->setOption("CH_BOUCL_FACT", 1);
      $c->addBouton("2 mois", 
                    "$fdosbrioche?action=" . $this->dbr->action . "&sessionid=" .
                    $this->dbr->idsession . "&item=" . $this->dbr->item . "&itfact=" .
                    $this->dbr->itfact . "&options=" . $futopt->getChaine(),
                    1);
      $futopt->setOption("CH_BOUCL_FACT", 2);
      $c->addBouton("10 jours",
                    "$fdosbrioche?action=" . $this->dbr->action . "&sessionid=" .
                    $this->dbr->idsession . "&item=" . $this->dbr->item . "&itfact=" .
                    $this->dbr->itfact . "&options=" . $futopt->getChaine(),
                    2);
      $futopt->setOption("CH_BOUCL_FACT", 3);
      $c->addBouton("bloque", "$fdosbrioche?action=" . $this->dbr->action . "&sessionid=" .
                    $this->dbr->idsession . "&item=" . $this->dbr->item . "&itfact=" .
                    $this->dbr->itfact . "&options=" . $futopt->getChaine(),
                    3); 
      $this->pv->addChamp($c);
      $this->pv->addLigne();
      $c = new TPanel(2, 1, "RIGHT", "MIDDLE");
      $x = new Label("Mdecin : ", true);
      $c->addChamp($x);
      $x = new Espace(2);
      $c->addChamp($x);
      $x = new Label($mafact->nommed);
      $c->addChamp($x);
      $x = new Espace(4);
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $c = new TPanel(2, 1, "LEFT", "MIDDLE");
      if ($mafact->isOuvert() && $nbmed > 1){
        $futopt = new optionsBriocheCab($this->dbr->options->getChaine());
        $futopt->setOption("CH_MED", 1);
        $x = new BoutonTexte("Changer",
                             "$fdosbrioche?action=" . $this->dbr->action . "&sessionid=" .
                             $this->dbr->idsession . "&item=" . $this->dbr->item .
                             "&itfact=" . $this->dbr->itfact . "&options=" .
                             $futopt->getChaine(), "#efefef", 100, 15);
        $c->addChamp($x);
      }
      $this->pv->addChamp($c);
      // Adresse de facturation
      $a = $mafact->getAdresseFact();
      $c = new TPanel(1, 1);
      $x = new Label($a[0], false, false, true);
      $c->addChamp($x);
      $x = new Label($a[1], false, false, true);
      $c->addChamp($x);
      $x = new Label("$a[2]  <B>$a[3]</B>", false, false, true);
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $c = new TPanel(1,1);
      $x = new Bouton("...", "...", "BUTTON",
                      "ouvreFenetre(\"$fdosbrioche?action=3000&sessionid=" .
                      $this->dbr->idsession . "&options=" . $this->dbr->options->getChaine() .
                      "&item=" . $mafact->noad . "&itfact=". $this->dbr->itfact ."\", \"Adresse\", " .
                      "\"scrollbars=no,resizable=no,menubar=no,locationbar=no,height=250," .
                      "width=450,screenX=150,screenY=100\")");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne(2);
      $cpt = $mesremarques->compte();
      if ($cpt){
        $c = new TPanelTableau(6, 1, $mesremarques, "#efefef", "prestations", "noprest");
        if ($mafact->isOuvert()){ // Bouton suppression prestation
          $futopt = new optionsBriocheCab($this->dbr->options->getChaine());
          $futopt->setOption("SUP_PREST", 1);
          $futopt->setOption("REC_FACT", 1);
          $x = new BoutonImage("", "$imagesdir/croix.gif", 12, 12,
                               "javascript:supprimeCond('$fdosbrioche?action=" . $this->dbr->action . "&sessionid=" .
                               $this->dbr->idsession . "&item=" . $this->dbr->item .
                               "&itfact=" . $this->dbr->itfact . "&itprest=&options=" .
                               $futopt->getChaine() . "')",
                               "noprest");
          $c->addColChamp("", $x, false, true);
        }
        $x = new Label("", false, false, false, "texte");
        $c->addColChamp("", $x);
        $this->pv->addChamp($c);
        $this->pv->addLigne(0.5);
        $this->pv->addLigne();
      }

      $futopt = new optionsBriocheCab($this->dbr->options->getChaine());
      $futopt->setOption("REC_FACT", 1);
      $c = new TPanel(4, 1, "RIGHT");
      if($mafact->isOuvert()){

        $x = new BoutonTexte("Recalculer", "$fdosbrioche?action=" . $this->dbr->action . "&sessionid=" .
                             $this->dbr->idsession . "&item=" . $this->dbr->item .
                             "&itfact=" . $this->dbr->itfact . "&options=" .
                             $futopt->getChaine(), "#efefef", 80, 15);
        $c->addChamp($x);


      }
      $this->pv->addChamp($c);
      $c = new TPanel(2, 1);
      $x = new Espace(5);
      $c->addChamp($x);
      $x = new Label("Montant total : ", true);
      $c->addChamp($x);
      $x = new Espace(2);
      $c->addChamp($x);
      $x = new Label($mafact->montant);
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne(0.5);
      $this->pv->addLigne();
      $c = new TPanelTableau(6, 1, $meslignes, "#efefef", "prestations", "noprest");
      if ($mafact->isOuvert()){ // Bouton suppression prestation
        $futopt = new optionsBriocheCab($this->dbr->options->getChaine());
        $futopt->setOption("SUP_PREST", 1);
        $futopt->setOption("REC_FACT", 1);
        $x = new BoutonImage("", "$imagesdir/croix.gif", 12, 12,
                         "javascript:supprimeCond('$fdosbrioche?action=" . $this->dbr->action . "&sessionid=" .
                         $this->dbr->idsession . "&item=" . $this->dbr->item .
                         "&itfact=" . $this->dbr->itfact . "&itprest=&options=" .
                         $futopt->getChaine() . "')",
                         "noprest");
        $c->addColChamp("", $x, false, true);
      }
      $x = new Label("", false, false, false, "dateprest");
      $c->addColChamp("Date", $x);
      $x = new Label("", false, false, false, "nombre");
      $c->addColChamp("Nb.", $x);
      $x = new Label("", false, false, false, "noprest");
      $c->addColChamp("Pos.", $x, false, false, "formatePos", $mafact);
      $x = new Label("", false, false, false, "noprest");
      $c->addColChamp("Libell", $x, false, false, "getLibelle", $mafact);
      $x = new Label("", false, false, false, "pm");
      $c->addColChamp("pm", $x, false, false, "supprZero", $mafact, "RIGHT");
      $x = new Label("", false, false, false, "fpm");
      $c->addColChamp("fpm", $x, false, false, "supprZero", $mafact, "RIGHT");
      $x = new Label("", false, false, false, "vpm");
      $c->addColChamp("vm", $x, false, false, "supprZero", $mafact, "RIGHT");
      $x = new Label("", false, false, false, "pt");
      $c->addColChamp("pt", $x, false, false, "supprZero", $mafact, "RIGHT");
      $x = new Label("", false, false, false, "fpt");
      $c->addColChamp("fpt", $x, false, false, "supprZero", $mafact, "RIGHT");
      $x = new Label("", false, false, false, "vpt");
      $c->addColChamp("vt", $x, false, false, "supprZero", $mafact, "RIGHT");
      $x = new Label("", false, false, false, "ttligne");
      $c->addColChamp("Mont.", $x, false, false, "supprZero", $mafact, "RIGHT");
      $c->addTitres(true);

      $this->pv->addChamp($c);
    }
    $this->pv->addLigne();
    $this->pv->addLigne();
    $this->pv->addChamp($this->pied);
    $this->pv->addLigne(0.5);
  }

  function TGetContenu(){
    return $this->pv->getContenu();
  }



}
