<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

//////////////////////////////////////////////////////
//
//  Page "Fiche patient"
//
////////////////////////////////////////////////////////

class pageDossierBriocheCabPatient extends pageDossierBriocheCab {
  var $pv;

  #Constructeur
  function __construct(&$dbr) {
    global $fdosbrioche;
    parent::__construct($dbr);
    $this->pv = new PPageVierge();
    $patients = $this->dbr->rs->getEnr("patients", $this->dbr->recup);
    $nomplein = $patients->nomp . " " . $patients->prenom;
    $acb = new AutoCheckbox();
    if (! $this->dbr->options->getOption("NOUV_DOSS")){
      $futopt = new optionsBriocheCab($this->dbr->options->getChaine());
      $futopt->setOption("NOUV_DOSS", 1);
      $c = new TPanel(5, 1);
      $x = new BoutonImage("Nouveau patient", "images/nouveau.gif", 32, 32,
                           "javascript:if(! qModif()) {document.forms.donnees.options.value='" .
                           $futopt->getChaine() .
                           "';document.forms.donnees.action.value=" .
                           ($this->dbr->actif) . ";document.forms.donnees.submit();}",
                           "", "", "Crer nouveau patient");
      $c->addChamp($x);
      $x = new BoutonImage("Fiche", "images/impdoss.gif", 32, 32,
                           "javascript:lienCond('fichepatient.php?item=" . $this->dbr->item .
                           "&sessionid=" . $this->dbr->idsession . "&mode=d');",
                           "", "", "Imprimer fiche patient");
      $c->addChamp($x);
      $x = new BoutonImage("Etiquettes", "images/impetiq.gif", 32, 32,
                           "javascript:if(!qModif()) ouvreFenetre('$fdosbrioche?action=500&sessionid=" .
                           $this->dbr->idsession . "&item=" . $this->dbr->item . "', 'Recherche', " .
                           "'scrollbars=no,resizable=no,menubar=no,locationbar=no,height=200," .
                           "width=450,screenX=150,screenY=100')",
                           "", "", "Imprimer tiquettes");
      $c->addChamp($x);

      $this->pv->addChamp($c);
      $c = new TPanel (1, 1, "RIGHT");
      $x = new Aide("C003");
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      
    }
    else {
      $c = new TPanel (6, 1, "RIGHT");
      $x = new Aide("C004");
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
    }
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanelCadre(6, 1, "", "", "", "Mdecin traitant :");
    $em = new ensTableBrioche("medecins", "1", "*", "0", $this->dbr->idsession);
    $emt = $em->getTableau();
    $cpt = count($emt);
    $labellise = ($cpt <= 1 ? 1 : 0);
    $med = $patients->medecin;
    if ($med == 0 && $cpt == 1){ // Un seul mdecin dans la base
       $med = $emt[0]->id;
    } 
    $x = new GrBoutonRadio("patients[medecin]", $med, "",
         "donnees", $labellise);
    for ($i = 0; $i < $cpt; $i++){
      $x->addRadio($emt[$i]->txt, $emt[$i]->id);
    }
    $c->addChamp($x);
    $acb->addCase($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanel(2, 1);
    $x = new ChampTexte("patients[nomp]", $patients->nomp, "Nom : ", 25, 25, false,
                        "TEXT", "d2" );
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $c = new TPanel(2, 1);
    $x = new ChampTexte("patients[nomc]", $patients->nomc, "Alliance : ", 25, 25, false,
                        "TEXT", "d2" );
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $c = new TPanel(2, 1);
    $x = new ChampTexte("patients[prenom]", $patients->prenom, "Prnom : ", 25, 25, false,
                        "TEXT", "d2" );
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new Tpanel(2, 1);
    $x = new ChampTexte("patients[daten]", $patients->daten, "Date de naissance : ", 15, 15, false,
                        "TEXT", "d2", "controleDate('patients[daten]', '"
                        . $this->dbr->aujourdhui() . "', '40000', '0')");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $c = new TPanel(2, 1);
    $x = new Label("Sexe : ");
    $c->addChamp($x);
    $x = new Espace(1);
    $c->addChamp($x);
    $x = new ListOpt("patients[sexe]", $patients->sexe, false, 0, "d2");
    $x->addOption("---", 0);
    $x->addOption("F", 1);
    $x->addOption("M", 2);
    $c->addChamp($x);
    $x = new Espace(2);
    $c->addChamp($x);
    $x = new Label("Etat civil : ");
    $c->addChamp($x);
    $x = new Espace(1);
    $c->addChamp($x);
    $ec = new ensTableBrioche("etatcivil", "1", "*", "id", $this->dbr->idsession);
    $x = new ListOptTable("patients[etatcivil]", $patients->etatcivil, $ec, false, 0, "d2");
    $x->addDefaut("---", 0);
    $x->addOptions("txt", "id");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $c = new TPanel(2, 1);
    $x = new ChampTexte("patients[profession]", $patients->profession, "Profession : ", 20, 40, false,
                        "TEXT", "d2");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanel(6, 1);
    $x = new ChampTexte("patients[adresse]", $patients->adresse, "Adresse :", 50, 120, false,
                        "TEXT", "d2");
    $c->addChamp($x);
    $x = new Espace(2);
    $c->addChamp($x);
    $x = new ChampTexte("patients[telpri]", $patients->telpri, "Tl. :", 16, 20, false,
                        "TEXT", "d2");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new Tpanel(6, 1);
    $x = new ChampTexte("patients[nopost]", $patients->nopost, "NPA :", 5, 4, false,
                        "TEXT", "d2", "",
                        "controleNPA(6101, '$fdosbrioche', " .
                        "'patients[nopost]', 'patients[ville]', 'donnees', 1);");
    $c->addChamp($x);
    $x = new Espace(2);
    $c->addChamp($x);
    $x = new ChampTexte("patients[ville]", $patients->ville, "Localit :", 25, 30, false,
                        "TEXT", "d2", "",
                        "controleNPA(6101, '$fdosbrioche', " .
                        "'patients[nopost]', 'patients[ville]', 'donnees', 2);");
    $c->addChamp($x);
    $c->addChamp($acb);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanel(6, 1);
    $ef = new ensFacturePat($this->dbr->item, $this->dbr->idsession);
    $x = new Label("Adresse tiers-garant : ", true);
    $c->addChamp($x);
    $x = new Espace(2);
    $c->addChamp($x);
    switch($ef->noad){
    case -1:
      $txt = "Patient";
      break;
    case -2:
      $txt = "Caisse-maladie";
      break;
    case -3:
      $txt = "Assurance-accident";
      break;
    case -4:
      $txt = "Caisse-maladie (EMS)";
      break;
    case 0:
      $txt = "";
      break;
    default:
      $mtiers = new adresseTiers($ef->noad, $this->dbr->idsession);
      $txt = $mtiers->tiers->nomp . ", " . $mtiers->tiers->ville;
    }
    $x = new Label($txt);
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();

    $ct = $ef->getContentieux();
    if ($ct){
      $c = new TPanel(6, 1);
      $x = new Label("<FONT COLOR=\"red\">Il y a " . $ct .
                     " facture" . ($ct > 1 ? "s" : "") . " en souffrance !!! </FONT>", true);
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne(0.5);
      $this->pv->addLigne();
    }

    $this->pv->addChamp($this->pied);
    $this->pv->addLigne(0.5);

  }

  function TGetContenu(){
    return $this->pv->getContenu();
  }

}
