<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

//////////////////////////////////////////////////////
//
//  Page "Relations"
//
////////////////////////////////////////////////////////

class pageDossierBriocheCabRel extends pageDossierBriocheCab {
  var $pv;

  #Constructeur
  function __construct(&$dbr) {
    global $fdosbrioche;
    parent::__construct($dbr);
    $recup = $this->dbr->recup;
    if ($this->dbr->upd){ // enregistrement employeur et N d'assur
      $cnpa = new checkNPA(200, "#efefef", 6101, "#2784be", 3, $this->dbr->idsession, $recup['empl']['nopost'],
                           $recup['empl']['ville']);
      $cnpa->affiche();
      
      
      
      $tabcass = $recup['ass'];
      
      $utp = new updateTableBrioche("patients", $tabcass, $this->dbr->item, "nopat", $this->dbr->idsession);
      $utp->update();	
      $patients = $this->dbr->rs->getEnr("patients");
      $monempl = $patients->employeur;
      $long = 0;
      foreach ($recup['empl'] as $valeur){
        $long += strlen($valeur);
      }
      $tabchamps = $recup['empl'];
      $tabchamps['typetier'] = 1;
      $ut = new updateTableBrioche("tiers", $tabchamps, $monempl, "notier", $this->dbr->idsession);
      $ert = new enrBriocheCab($this->dbr->item, $this->dbr->idsession);
      if ($long){ // Les champs employeurs sont remplis
        if (! $monempl){
          $nouv = $ert->creeNouveau("tiers");
          $ut->setItem($nouv);
          $tchampspat['employeur'] = $nouv;
          $utp->setTabChamps($tchampspat);
          $utp->update();
        }
        $ut->update();
      }
      else{
        if ($monempl){
          $ut->detruitEnr();
          $tchampspat['employeur'] = "NULL";
          $utp->setTabChamps($tchampspat);
          $utp->update();
        }
      }
    }
    
    if ($this->dbr->options->getOption("CH_AD") == 1){ // Changement adresse facturation
      $tabchamps['factures'] = $this->dbr->itfact;
      $ut = new updateTableBrioche("patients", $tabchamps, $this->dbr->item, "nopat", $this->dbr->idsession);
      if ($this->dbr->itfact < 0 && $this->dbr->itfact > -10){
        $ut->update();
      }
    }
    if ($this->dbr->options->getOption("CH_AD") == 2){ // Enregistrement autre adresse de facturation
      $cnpa = new checkNPA(200, "#efefef", 6101, "#2784be", 3, $this->dbr->idsession, $recup['fact']['nopost'],
                           $recup['fact']['ville']);
      $cnpa->affiche();
      $this->dbr->options->setOption("CH_AD", 0);
      $this->addPied();

      $ent = new enrBriocheCab(0, $this->dbr->idsession);
      $notiers = $ent->creeNouveau("tiers");
      $tabchamps = $recup['fact'];
      $tabchamps['typetier'] = 3;
      $ut = new updateTableBrioche("tiers", $tabchamps, $notiers, "notier", $this->dbr->idsession);
      if (! $ut->update()){
        print "PROBLEME";
      }
      else {
        $tabchamps = array();
        $tabchamps['factures'] = $notiers;
        $ut = new updateTableBrioche("patients", $tabchamps, $this->dbr->item, "nopat", $this->dbr->idsession);
        if (! $ut->update()) print "PROBLEME2";
      }
    }
    
    $patients = $this->dbr->rs->getEnr("patients");
    $this->pv = new PPageVierge();

    
    $futopt = new optionsBriocheCab($this->dbr->options->getChaine());
    $futopt->setOption("CH_AD", 1);
        
    $efg = new ensFacture($this->dbr->idsession);
    $tp = $efg->getTypePrest(0);
    $c = new TPanelCadre(5, 1, "", "", "", "Type de facture par dfaut&nbsp;:");    
    $x = new GrBoutonRadioTable("patients[typedefaut]", $patients->typedefaut, $tp);
    $x->addOptions("abr", "id");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $c = new TPanel(1, 3, "RIGHT");
    $x = new Aide("C005");
    $c->addChamp($x);
    $x = new Espace(3);
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    
    $c = new TPanel(6, 1);
    $x = new Label("Adresse de facturation (tiers-garant)&nbsp;:");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne();
    $boutactif = ($this->dbr->itfact == -99 ? -99 : $patients->factures);
    $c = new GrTboutonTexte($boutactif, 5, 300, 15, "#aaaaaa", "#efefef", 5);

    $c->addBouton("Patient", "javascript:lienCond('$fdosbrioche?action=" . $this->dbr->action .
                  "&itfact=-1&item=" . $this->dbr->item .
                  "&sessionid=" . $this->dbr->idsession .
                  "&options=" . $futopt->getChaine() . "');", -1);
    /*
    $c->addBouton("Ass. mal", "javascript:lienCond('$fdosbrioche?action=" . $this->dbr->action .
                  "&itfact=-2&item=" . $this->dbr->item .
                  "&sessionid=" . $this->dbr->idsession .
                  "&options=" . $futopt->getChaine() . "');", -2);
    $c->addBouton("Ass. acc.", "javascript:lienCond('$fdosbrioche?action=" . $this->dbr->action . "&itfact=-3&item=" .
                  $this->dbr->item .
                  "&sessionid=" . $this->dbr->idsession .
                  "&options=" . $futopt->getChaine() . "');", -3);
    $c->addBouton("EMS", "javascript:lienCond('$fdosbrioche?action=" . $this->dbr->action . "&itfact=-4&item=" .
                  $this->dbr->item .
                  "&sessionid=" . $this->dbr->idsession .
                  "&options=" . $futopt->getChaine() . "');", -4);
    */
    $c->addBouton("Autre", "javascript:lienCond('$fdosbrioche?action=" . $this->dbr->action . "&itfact=-99&item=" .
                  $this->dbr->item .
                  "&sessionid=" . $this->dbr->idsession .
                  "&options=" . $futopt->getChaine() . "');", ($patients->factures > 0 ? $patients->factures : -99));
    $this->pv->addChamp($c);
    
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    if ($patients->factures > 0){
      $ensf = new ensTableBrioche("tiers", "notier = $patients->factures", "*", 0, $this->dbr->idsession);
      $tensf = $ensf->getTableau();
      $c = new TPanel(6, 1);
      $x = new Label($tensf[0]->nomp, false, false, true);
      $c->addChamp($x);
      $x = new Label($tensf[0]->adresse, false, false, true);
      $c->addChamp($x);
      $x = new Label($tensf[0]->nopost . " " . $tensf[0]->ville);
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne(0.5);
      $this->pv->addLigne();
    }
    if ($this->dbr->itfact == -99){  // Ajout d'une adresse de facturation
      $this->dbr->options->setOption("CH_AD", 2);
      $this->addPied(); // On rpte l'ajout du pied pour modifier option
      $c = new TPanel(6, 1);
      $x = new ChampTexte("tiers[fact][nomp]", "", "", 29, 50, false, "TEXT", "d2");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne();
      $c = new TPanel(6, 1);
      $x = new ChampTexte("tiers[fact][adresse]", "", "", 29, 120, false, "TEXT", "d2");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne();
      $c = new TPanel(6, 1);
      $x = new ChampTexte("tiers[fact][nopost]", "", "", 5, 4, false, "TEXT", "d2", "",
                          "controleNPA(6101, '$fdosbrioche', " .
                          "'tiers[fact][nopost]', 'tiers[fact][ville]', 'donnees', 1);");
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      $x = new ChampTexte("tiers[fact][ville]", "", "", 20, 50, false, "TEXT", "d2", "", 
                          "controleNPA(6101, '$fdosbrioche', " .
                          "'tiers[fact][nopost]', 'tiers[fact][ville]', 'donnees', 2);");
      $c->addChamp($x);
      $this->pv->addChamp($c);
    }
    else { // employeur et assurances
      if (! isset($tiers['empl'])){
        if(! $patients->employeur){
          $tiers['empl'] = new stdClass();
          $tiers['empl']->nomp = "";
          $tiers['empl']->adresse = "";
          $tiers['empl']->nopost = "";
          $tiers['empl']->ville = "";
          $tiers['empl']->tel = "";
        }
        else{
          $emp = new enrBriocheCab($patients->employeur, $this->dbr->idsession);
          $tiers['empl'] = $emp->getEnr("tiers");
        }
      }
      $c = new TPanel(6, 1);
      $x = new Label("Employeur :", false, false, true);
      $c->addChamp($x);
      $x = new ChampTexte("tiers[empl][nomp]", $tiers['empl']->nomp, "", 29, 50, false, "TEXT", "d2");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne();
      $c = new TPanel(6, 1);
      $x = new ChampTexte("tiers[empl][adresse]", $tiers['empl']->adresse, "", 29, 120, false, "TEXT", "d2");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne();
      $c = new TPanel(6, 1);
      $x = new ChampTexte("tiers[empl][nopost]", $tiers['empl']->nopost, "", 5, 4, false, "TEXT", "d2", "",
                          "controleNPA(6101, '$fdosbrioche', " .
                          "'tiers[empl][nopost]', 'tiers[empl][ville]', 'donnees', 1);");
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      $x = new ChampTexte("tiers[empl][ville]", $tiers['empl']->ville, "", 20, 50, false, "TEXT", "d2", "",
                          "controleNPA(6101, '$fdosbrioche', " .
                          "'tiers[empl][nopost]', 'tiers[empl][ville]', 'donnees', 2);");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne();
      $c = new TPanel(6, 1);
      $x = new ChampTexte("tiers[empl][tel]", $tiers['empl']->tel, "Tl. :", 25, 50, false, "TEXT", "d2");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne(0.5);
      $this->pv->addLigne();
      $am = $patients->asmal;
      $eam = new enrBriocheCab($am, $this->dbr->idsession);
      $asmal = $eam->getEnr("tiers");
      $c = new TPanel(2, 1);
      
      $x = new Label((! ($asmal->ofsp ?? 0) ? "<span style=\"color:red\">" : "<span>") . "Assurance maladie :</span>", true, false, true);
      $c->addChamp($x);
      $x = new Label($asmal->nomp ?? "", false, false, true);
      $c->addChamp($x);
      $x = new Label($asmal->adresse ?? "", false, false, true);
      $c->addChamp($x);
      $x = new Label(($asmal->nopost ?? "") . " " . ($asmal->ville ?? ""), false, false, true);
      $c->addChamp($x);
      $x = new Label($asmal->tel ?? "", false, false, true);
      $c->addChamp($x);
      $x = new ChampTexte("tiers[ass][nomal]", $patients->nomal ?? "", "N", 25, 50, false,
                          "TEXT", "d2");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $c = new TPanel(1, 1, "LEFT", "TOP");
      $x = new Bouton("...", "...", "BUTTON", "if(!qModif()) ouvreFenetre(\"$fdosbrioche?action=2100&sessionid=" .
                      $this->dbr->idsession . "&options=" . $this->dbr->options->getChaine() .
                      "&item=" . $this->dbr->item . "&itfact=$am&itprest=m\", \"Recherche\", " .
                      "\"scrollbars=no,resizable=no,menubar=no,locationbar=no,height=300," .
                      "width=550,screenX=150,screenY=100\")");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $c = new TPanel(2, 1, "LEFT", "TOP");
      $x = new Label("Assurance accidents :", true, false, true);
      $c->addChamp($x);
      $aa = $patients->asacci;
      $eaa = new enrBriocheCab($aa, $this->dbr->idsession);
      $asacci = $eaa->getEnr("tiers");
      $x = new Label($asacci->nomp ?? "", false, false, true);
      $c->addChamp($x);
      $x = new Label($asacci->adresse ?? "", false, false, true);
      $c->addChamp($x);
      $x = new Label(($asacci->nopost ?? "") . " " . ($asacci->ville ?? ""), false, false, true);
      $c->addChamp($x);
      $x = new Label($asacci->tel ?? "", false, false, true);
      $c->addChamp($x);
      $x = new ChampTexte("tiers[ass][noac]", $patients->noac, "N", 25, 50, false,
                          "TEXT", "d2");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $c = new TPanel(1, 1, "LEFT", "TOP");
      $x = new Bouton("...", "...", "BUTTON", "if(!qModif()) ouvreFenetre(\"$fdosbrioche?action=2100&sessionid=" .
                      $this->dbr->idsession . "&options=" . $this->dbr->options->getChaine() .
                      "&item=" . $this->dbr->item . "&itfact=$aa&itprest=a\", \"Recherche\", " .
                      "\"scrollbars=no,resizable=no,menubar=no,locationbar=no,height=300," .
                      "width=550,screenX=150,screenY=100\")");
      $c->addChamp($x);
      $this->pv->addChamp($c);


    }
    $this->pv->addLigne();
    $this->pv->addLigne();
    $this->pv->addChamp($this->pied);
    $this->pv->addLigne(0.5);
  }

  function TGetContenu(){
    return $this->pv->getContenu();
  }



}
