<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

/////////////////////////////////////////////////////////////
//
//  Facture pdf
//
/////////////////////////////////////////////////////////////

class pdfFact extends connexionBrioche {

  //var $idsession;
  var $ms;
  var $il;
  var $pdf;
  var $mg;
  var $xadresse;
  var $hp;
  var $htot;
  var $hu;
  var $hc;
  var $tc;
  var $G;
  var $P;
  var $M;
  var $tabpri;
  var $medecin;
  var $col1;
  var $col2;
  var $col3;
  var $col4;
  var $col5;
  var $col6;
  var $col7;
  var $col8;
  var $col9;
  var $col0;
  var $col11;
  var $col12;
  var $col13;
  var $col14;
  var $col15;
  var $col16;
  var $col17;
  var $col18;
  var $mafact;
    

  function __construct(&$pdf, $idsession){
    if (! parent::__construct($idsession)) return;
    
    $this->pdf = &$pdf;
    $this->ms = 10; // Marge suprieure
    $this->mg = 10; // Marge de gauche
    $this->il = 3.5;  // Interligne
    $this->xadresse = 110; //Abcisse de l'adresse
    $this->hp = 95; //Haut des prestations
    $this->htot = 184; //Ligne total
    $this->hu = 198; //Ligne UBS
    $this->hc = 276; //Ligne codage
    $this->tc = 203; //Ligne codage
    $this->pasMtant = 5; // Espace entre deux chiffres du montant imprim
    $mg = $this->mg;
    $this->col1 = $mg;
    $this->col2 = $mg + 18;
    $this->col3 = $mg + 26;
    $this->col4 = $mg + 42;
    $this->col5 = $mg + 59;
    $this->col6 = $mg + 63;
    $this->col7 = $mg + 72;
    $this->col8 = $mg + 84;
    $this->col9 = $mg + 98;
    $this->col10 = $mg + 105;
    $this->col11 = $mg + 116;
    $this->col12 = $mg + 125;
    $this->col13 = $mg + 133;
    $this->col14 = $mg + 145;
    $this->col15 = $mg + 149;
    $this->col16 = $mg + 153;
    $this->col17 = $mg + 157;
    $this->col18 = $mg + 170;
    $pdf->SetLineWidth(0.1);
    $pdf->SetMargins($this->mg, $this->ms);
    $pdf->AddFont('Gothic', '', 'gothic.php');
    $pdf->AddFont('Gothic', 'B', 'gothicb.php');
    $pdf->AddFont('Ocrb', '', 'OCRB.php');
    $pdf->SetAutoPageBreak(false);
    $this->tabpri = 40;
    
  }

  //Lettre rappel
  function addLettre($itfact){
    $mafact = new ensDetailFacture($itfact, $this->idsession);
    $pdf = &$this->pdf;
    $mg = $this->mg;
    $xadresse = $this->xadresse;
    $enp = new enrBriocheCab($mafact->nopat, $this->idsession);
    $enr = $enp->getEnr("patients");
    $nummed = $mafact->nummed;
    $adresse = $mafact->getAdresseFact();
    $ensFact = new ensFacturePat($mafact->nopat, $this->idsession);
    $emed = new ensTableBrioche("medecins", "id = $nummed", "*", 0, $this->idsession);
    $temed = $emed->getTableau();
    $medecin = $temed[0];
    //print $mafact->nofact . " : " . $mafact->tiersxml . "<BR>"; 
    if ($mafact->tiersxml == 2){
      $this->addJust($itfact); //En cas de tiers payant, formulaire Facture TP
    }
    else {
      $pdf->SetMargins($this->mg, $this->ms, 20);
      $pdf->AddPage();
      $pdf->SetFont('Gothic', 'B', 9);
      $pdf->SetXY($mg, 10);
      $pdf->Cell(50, $this->il, 'Docteur ' . $medecin->txt);
      $pdf->SetFont('Gothic', '', 9);
      $pdf->SetXY($mg, $this->ligne(1));
      $pdf->Cell(50, $this->il, $medecin->titre);
      $pdf->SetXY($mg, $this->ligne(2));
      $pdf->Cell(50, $this->il, $medecin->adresse);
      $pdf->SetXY($mg, $this->ligne(3));
      $pdf->Cell(8, $this->il, $medecin->npa);
      $pdf->SetFont('Gothic', 'B', 9);
      $pdf->Cell(42, $this->il, $medecin->ville);
      $pdf->SetFont('Gothic', '', 9);
      $pdf->SetXY($mg, $this->ligne(4.5));
      $pdf->Cell(50, $this->il, $medecin->tel);
      $pdf->SetXY($mg, $this->ligne(5.5));
      $pdf->Cell(50, $this->il, $medecin->email);
      $pdf->SetFont('Arial', '', 10);
      $pdf->SetXY($mg, $this->ligne(30));
      $pdf->Cell(100, $this->il, 'Concerne : Facture N ' . ensFacturePat::getNoAbr($mafact->nofact) .
                 ' du ' . $mafact->datefact);
      $pdf->SetXY($xadresse, $this->ms);
      $pdf->Cell(50, $this->il, $medecin->ville . ', le ' . $mafact->aujourdhui());
      $pdf->SetXY($xadresse, 55);
      $pdf->Cell(60, $this->il, $adresse[0]);
      $pdf->SetXY($xadresse, 55 + 1.5 * $this->il);
      $pdf->Cell(60, $this->il, $adresse[1]);
      $pdf->SetXY($xadresse, 55 + 3 * $this->il);
      $pdf->Cell(10, $this->il, $adresse[2]);
      $pdf->SetFont('Arial', 'B', 10);
      $pdf->Cell(50, $this->il, $adresse[3]);
      $pdf->SetFont('Arial', '', 10);
      $pdf->SetXY($mg, $this->ligne(35));
      $pdf->Cell(50, $this->il, "Madame, Monsieur");
      $pdf->SetXY($mg, $this->ligne(40));
      $norap = $mafact->isRappel();
      switch($norap){
      default:
        $txt = "En contrlant mes comptes, je m'aperois que la facture ci-jointe est reste impaye  ce " .
             "jour. Je vous rappelle que, selon la pratique gnralement en vigueur dans le canton de Vaud, " .
             "il vous appartient de rgler vous-mme vos frais mdicaux ambulatoires et de vous les faire " .
             "rembourser ensuite par votre caisse-maladie.\n\n" .
             "Afin de rendre possible son remboursement par votre assurance, j'ai tabli ma facture " .
             "conformment aux conventions en vigueur, ce qui implique l'usage d'un certain nombre de codes. " .
             "Si son contenu vous semble obscur, je suis bien entendu  votre disposition pour vous apporter " .
             "les claircissements ncessaires.\n\n" .
             "Au cas o votre rglement et le rappel  ci-joint se seraient croiss, je vous prie de " .
             "considrer ce dernier comme nul. Dans le cas contraire, je vous serais reconnaissant de bien " .
             "vouloir procder au paiements dans les meilleurs dlais.\n\n" .
             "Veuillez agrer, Madame, Monsieur, mes salutations les meilleures.";
        break;
      case 2:
        $txt = "En contrlant mes comptes, je m'aperois que, malgr deux rappels conscutifs, la facture " .
             "ci-jointe n'a toujours pas t rgle. Une dernire fois, je vous rappelle que c'est  vous " .
             "qu'il appartient de payer vos frais mdicaux ambulatoires, votre assurance se chargeant ensuite " .
             "de vous les rembourser.\n\n" .
             "Si, pour une raison imprieuse, vous aviez besoin d'un dlai supplmentaire, je vous prie de " .
             "bien vouloir prendre contact avec moi afin que nous puissions le ngocier. Dans le cas " .
             "contraire, je vous prie de procder au paiement dans les dix jours. Pass ce dlai et sans " .
             "nouvelles de votre part, je me verrai dans l'obligation d'engager des poursuites.\n\n" .
             "Veuillez agrer, Madame, Monsieurs, mes salutations les meilleures.";
        break;
      }
      $pdf->Write($this->il * 1.5, $txt);
      $pdf->SetXY($xadresse, $this->ligne(70));
      $pdf->Cell(50, $this->il, $medecin->txt);
    }
  }

  //Contenu formulaire unifi
  function addJust($itfact){
    //print "ONYVA $itfact <BR>";
    $mafact = new ensDetailFacture($itfact, $this->idsession);
    $mafact->recalcule();
    $monpat = new ensFacturePat($mafact->nopat, $this->idsession);
    $emed = new ensTableBrioche("medecins", "id = $mafact->nummed", "*", 0, $this->idsession);
    $temed = $emed->getTableau();
    $this->medecin = $temed[0];
    $adresse = $mafact->getAdresseFact();
    if ($mafact->tpr == 16){
      $adresse = $mafact->getAdresseAsmal();
    }
    $xadresse = $this->xadresse;
    $texteLoi = $mafact->loi;
    $ini = new briocheIni();
    $G = 16; //Grande taille
    $this->G = $G;
    $P = 6;  //Petite taille
    $this->P = $P;
    $M = 9; //Taille moyenne
    $mg = $this->mg;
    $tabP = 17;
    $this->ms = 10;
    $ms = $this->ms;
    $this->M = $M;
    $pdf = &$this->pdf;
    $lignedebprest = 32;
    $pdf->AddPage();
    // Dbut de l'criture
    $this->enteteJust($mg, 0, 180, 18, $mafact, 1); // En-tte commun  toutes les pages
    $pdf->Line($mg, 25, $mg, 108);
    $pdf->SetFont('Arial', 'B', $P);
    $pdf->setXY($mg + 1, $this->ligne(8));
    $pdf->Cell(50, 1, 'Patient');
    $pdf->SetFont('Arial', '', $P);
    $pdf->SetXY($mg + $tabP, $this->ligne(8));
    $pdf->Cell(50, 1, 'Nom');
    $pdf->SetXY($mg + $tabP, $this->ligne(9));
    $pdf->Cell(50, 1, 'Prnom');
    $pdf->SetXY($mg + $tabP, $this->ligne(10));
    $pdf->Cell(50, 1, 'Rue');
    $pdf->SetXY($mg + $tabP, $this->ligne(11));
    $pdf->Cell(50, 1, 'NPA');
    $pdf->SetXY($mg + $tabP, $this->ligne(12));
    $pdf->Cell(50, 1, 'Localit');
    $pdf->SetXY($mg + $tabP, $this->ligne(13));
    $pdf->Cell(50, 1, 'Date de naissance');
    $pdf->SetXY($mg + $tabP, $this->ligne(14));
    $pdf->Cell(50, 1, 'Sexe');
    $pdf->SetXY($mg + $tabP, $this->ligne(15));
    $pdf->Cell(50, 1, 'Date cas');
    $pdf->SetXY($mg + $tabP, $this->ligne(16));
    $pdf->Cell(50, 1, 'N cas/dcision');
    $pdf->SetXY($mg + $tabP, $this->ligne(17));
    $pdf->Cell(50, 1, 'N AVS');
    $pdf->SetXY($mg + $tabP, $this->ligne(18));
    $pdf->Cell(50, 1, 'N Assur');
    $pdf->SetXY($mg + $tabP, $this->ligne(19));
    $pdf->Cell(50, 1, 'N/Nom entreprise');
    $pdf->SetXY($mg + $tabP, $this->ligne(20));
    $pdf->Cell(50, 1, 'Canton');
    $pdf->SetXY($mg + $tabP, $this->ligne(21));
    $pdf->Cell(50, 1, 'Copie de facture');
    $pdf->SetXY($mg + $tabP, $this->ligne(22));
    $pdf->Cell(50, 1, 'Type de remb.');
    $pdf->SetXY($mg + $tabP, $this->ligne(23));
    $pdf->Cell(50, 1, 'Loi');
    $pdf->SetXY($mg + $tabP, $this->ligne(24));
    $pdf->Cell(50, 1, 'Motif traitement');
    $pdf->SetXY($mg + $tabP, $this->ligne(25));
    $pdf->Cell(50, 1, 'Traitement');
    $pdf->SetXY($mg + $tabP, $this->ligne(26));
    $pdf->Cell(50, 1, 'Lieu fourn. prest.');
    $pdf->SetXY($mg + 110, $this->ligne(8));
    $pdf->Cell(50, 1, 'N EAN');
    $pdf->SetXY($mg + 110, $this->ligne(25));
    $pdf->Cell(50, 1, 'N Facture');
    $pdf->SetXY($mg + 110, $this->ligne(26));
    $pdf->Cell(50, 1, 'Date facture/rappel');
    $pdf->Carre($mg + $this->tabpri, $this->ligne(8));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(9));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(10));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(11));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(12));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(13));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(14));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(15));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(16));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(17));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(18));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(19));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(20));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(21));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(22));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(23));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(24));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(25));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(26));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(27));
    $pdf->Carre($mg + $this->tabpri, $this->ligne(28));
    $pdf->Carre($mg + 20, $this->ligne(28));
    $pdf->Carre($mg + 70, $this->ligne(28));
    $pdf->Carre($mg + 20, $this->ligne(29));
    $pdf->Carre($mg + 130, $this->ligne(8));
    $pdf->Carre($mg + 130, $this->ligne(25));
    $pdf->Carre($mg + 130, $this->ligne(26));
    $pdf->SetFont('Arial', '', $M);
    $pdf->SetXY($mg + $this->tabpri + 2, $this->ligne(8));
    $pdf->Cell(50, 1, $monpat->nomp);
    $pdf->SetXY($mg + $this->tabpri + 2, $this->ligne(9));
    $pdf->Cell(50, 1, $monpat->prenom);
    $pdf->SetXY($mg + $this->tabpri + 2, $this->ligne(10));
    $pdf->Cell(50, 1, $monpat->adresse);
    $pdf->SetXY($mg + $this->tabpri + 2, $this->ligne(11));
    $pdf->Cell(50, 1, $monpat->nopost);
    $pdf->SetXY($mg + $this->tabpri + 2, $this->ligne(12));
    $pdf->Cell(50, 1, $monpat->ville);
    $pdf->SetXY($mg + $this->tabpri + 2, $this->ligne(13));
    $pdf->Cell(50, 1, $monpat->daten);
    $pdf->SetXY($mg + $this->tabpri + 2, $this->ligne(14));
    $pdf->Cell(50, 1, $monpat->sexe);
    if ($this->medecin->imprnoass || $mafact->tpr == 16){
      $pdf->SetXY($mg + $this->tabpri + 2, $this->ligne(18));
      $pdf->Cell(50, 1, $mafact->noass);
    }
    $pdf->SetXY($mg + $this->tabpri + 2, $this->ligne(20));
    $pdf->Cell(50, 1, $ini->canton);
    $pdf->SetXY($mg + $this->tabpri + 2, $this->ligne(21));
    $pdf->Cell(50, 1, 'Non');
    $pdf->SetXY($mg + $this->tabpri + 2, $this->ligne(22));
    $pdf->Cell(50, 1, $mafact->payant);
    $pdf->SetXY($mg + $this->tabpri + 2, $this->ligne(23));
    $pdf->Cell(50, 1, $texteLoi);
    $pdf->SetXY($mg + $this->tabpri + 2, $this->ligne(24));
    $pdf->Cell(50, 1, ($mafact->tpr == 7 || $mafact->tpr == 12 ? 'Accident' : ($mafact->tpr == 16 ? 'Prvention': 'Maladie')));
    $pdf->SetXY($mg + $this->tabpri + 2, $this->ligne(25));
    $pdf->Cell(50, 1, $mafact->debut . ' - ' . $mafact->fin);
    $pdf->SetXY($mg + $this->tabpri + 2, $this->ligne(26));
    $pdf->Cell(50, 1, 'Cabinet mdical');
    $pdf->SetXY($mg + $xadresse, $this->ligne(14));
    $pdf->Cell(50, 1, $adresse[0]);
    $pdf->SetXY($mg + $xadresse, $this->ligne(15));
    $pdf->Cell(50, 1, $adresse[1]);
    $pdf->SetXY($mg + $xadresse, $this->ligne(16));
    $pdf->Cell(50, 1, $adresse[2] . ' ' . $adresse[3]);
    $pdf->SetXY($mg + $xadresse, $this->ligne(17));
    $pdf->SetXY($mg + 132, $this->ligne(25));
    $pdf->Cell(50, 1, $mafact->nofact);
    $pdf->SetXY($mg + 132, $this->ligne(26));
    $pdf->Cell(50, 1, $mafact->datefact . '/' . $mafact->daterap);
    $pdf->SetXY($mg + 22, $this->ligne(28));
    $pdf->Cell(50, 1, 'Texte libre');
    $pdf->SetXY($mg + 42, $this->ligne(28));
    $pdf->Cell(50, 1, 'U');
    $pdf->SetXY($mg + 22, $this->ligne(29));
    $pdf->Cell(50, 1, '1/' . $this->medecin->ean);
    $pdf->SetFont('Arial', 'B', $P);
    $pdf->SetXY($mg + 1, $this->ligne(27));
    $pdf->Cell(50, 1, 'Mandataire');
    $pdf->SetXY($mg + 1, $this->ligne(28));
    $pdf->Cell(50, 1, 'Diagnostic');
    $pdf->SetXY($mg + 1, $this->ligne(29));
    $pdf->Cell(50, 1, 'Liste EAN');
    $pdf->SetXY($mg + 1, $this->ligne(30));
    $pdf->Cell(50, 1, 'Commentaire');
    $pdf->Rect($mg, $this->ligne(26.6), 180, $this->il);
    $pdf->Rect($mg, $this->ligne(27.6), 180, $this->il);
    $pdf->Rect($mg, $this->ligne(28.6), 180, $this->il);
    $pdf->Rect($mg, $this->ligne(29.6), 180, $this->il);
    $pdf->SetFont('Arial', '', $P);
    $pdf->SetXY($mg + $tabP, $this->ligne(27));
    $pdf->Cell(50, 1, 'N EAN/N RCC');
    $pdf->SetXY($mg + $tabP, $this->ligne(30));
    $pdf->Cell(50, 1, $mafact->getTexteRemarques());
    //Prestations
    $this->titreCol(31, $pdf);
    
    $lignespage1 = 17;
    $tli = $mafact->getLignes($lignespage1);
    $li = $tli->getTableau();
    $cpt = $tli->compte();
    $seance = 1;
    $dateprec = 0;
    $radiol = 0;
    $result = $this->egrene($cpt, $lignedebprest, $pdf, $mafact, $li, $seance, $dateprec, $radiol);
    if ($mafact->compteLignes() > $lignespage1){
      $lir = $result['lir'] + 3;
      $pdf->Carre($this->col1 - 2, $this->ligne($lir));
      $pdf->SetFont('Arial', 'B', $P);
      $pdf->SetXY($this->col1, $this->ligne($lir));
      $pdf->Cell(50, 1, 'Total intermdiaire');
      $pdf->SetFont('Arial', 'B', $M);
      $pdf->SetXY($this->col18, $this->ligne($lir));
      $pdf->Cell(10, 1, $mafact->getTotalInter($lignespage1), 0, 0, 'R');
      $rtab = $mafact->getMonNumRef();
      $pdf->SetFont('Ocrb', '', 12);
      $pdf->SetXY($this->col4, $this->ligne(78));
      $pdf->Cell(100, $this->il, "$rtab[0]>$rtab[1]+ $rtab[2]>");
      $pdf->AddPage(); //Seconde page
      $this->enteteJust($mg, 0, 180, 18, $mafact, 2); // En-tte commun  toutes les pages
      $pdf->Rect($mg, $this->ligne(2.5) + 18, 180, $this->il);
      $pdf->SetFont('Arial', 'B', $P);
      $pdf->SetXY($mg + 1, $this->ligne(8));
      $pdf->Cell(50, 1, 'Patient');
      $pdf->SetFont('Arial', '', $P);
      $pdf->SetXY($mg + 25, $this->ligne(8));
      $pdf->Cell(50, 1, $monpat->nomp . ' ' . $monpat->prenom . ', ' . $monpat->daten);
      $this->titreCol(9, $pdf);
      $tli = $mafact->getLignes($mafact->compteLignes(), $lignespage1);
      $li = $tli->getTableau();
      $cpt = $tli->compte();
      $lignedebprest = 10;
      $result = $this->egrene($cpt, $lignedebprest, $pdf, $mafact, $li, $result['seance'], $result['dateprec'],
                              $result['radiol']);
      $this->totaux(68, $pdf, $mafact);
    }   
    else { //Totaux
      $this->totaux(68, $pdf, $mafact);
    }
    $rtab = $mafact->getMonNumRef();
    $pdf->SetFont('Ocrb', '', 12);
    $pdf->SetXY($this->col4, $this->ligne(78));
    $pdf->Cell(100, $this->il, "$rtab[0]>$rtab[1]+ $rtab[2]>");

  }

  function titreCol($ligne, &$pdf){
    $pdf->SetXY($this->col1, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'Date');
    $pdf->SetXY($this->col2, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'Tarif');
    $pdf->SetXY($this->col3, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'Code');
    $pdf->SetXY($this->col4, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'Code rf.');
    $pdf->SetXY($this->col5, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'S');
    $pdf->SetXY($this->col6, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'C');
    $pdf->SetXY($this->col7, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'Quantit');
    $pdf->SetXY($this->col8, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'PtPM/Prix');
    $pdf->SetXY($this->col9, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'fPM');
    $pdf->SetXY($this->col10, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'VPtPM');
    $pdf->SetXY($this->col11, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'PtPT');
    $pdf->SetXY($this->col12, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'fPT');
    $pdf->SetXY($this->col13, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'VPtPT');
    $pdf->SetXY($this->col14, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'E');
    $pdf->SetXY($this->col15, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'R');
    $pdf->SetXY($this->col16, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'P');
    $pdf->SetXY($this->col17, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'T');
    $pdf->SetXY($this->col18, $this->ligne($ligne));
    $pdf->Cell(50, 1, 'Montant');
  }
  //Totaux gnraux de la facture
  function totaux($ligdeb, &$pdf, &$mafact){
    $pdf->SetFont('Arial', '', $this->P);
    $pdf->SetXY($this->col2, $this->ligne($ligdeb));
    $pdf->Cell(50, 1, 'Tarmed PM');
    $pdf->SetXY($this->col2, $this->ligne($ligdeb + 1));
    $pdf->Cell(50, 1, 'Tarmed PT');
    $pdf->SetXY($this->col5, $this->ligne($ligdeb));
    $pdf->Cell(50, 1, 'Physio');
    $pdf->SetXY($this->col5, $this->ligne($ligdeb + 1));
    $pdf->Cell(50, 1, 'Labo');
    $pdf->SetXY($this->col9, $this->ligne($ligdeb));
    $pdf->Cell(50, 1, 'LIMA');
    $pdf->SetXY($this->col9, $this->ligne($ligdeb + 1));
    $pdf->Cell(50, 1, 'Mdic.');
    $pdf->SetXY($this->col13, $this->ligne($ligdeb));
    $pdf->Cell(50, 1, 'Autres');
    $pdf->SetXY($this->col13, $this->ligne($ligdeb + 1));
    $pdf->Cell(50, 1, 'Cantonal');
    $pdf->SetFont('Arial', '', $this->M);
    $pdf->SetXY($this->col3, $this->ligne($ligdeb));
    $pdf->Cell(18, 1, sprintf('%01.2f', $mafact->getSommeFrMed()), 0, 0, 'R');
    $pdf->SetXY($this->col4, $this->ligne($ligdeb));
    $pdf->Cell(16, 1, '(' . sprintf('%01.2f', $mafact->getSommePtsMed()) . ')', 0, 0, 'R'); 
    $pdf->SetXY($this->col3, $this->ligne($ligdeb + 1));
    $pdf->Cell(18, 1, sprintf('%01.2f', $mafact->getSommeFrTec()), 0, 0, 'R');
    $pdf->SetXY($this->col4, $this->ligne($ligdeb + 1));
    $pdf->Cell(16, 1, '(' . sprintf('%01.2f', $mafact->getSommePtsTec()) . ')', 0, 0, 'R'); 
    $pdf->SetXY($this->col7, $this->ligne($ligdeb));
    $pdf->Cell(15, 1, '0.00', 0, 0, 'R');
    $pdf->SetXY($this->col7, $this->ligne($ligdeb + 1));
    $pdf->Cell(15, 1, sprintf('%01.2f', $mafact->getMontantLabo()), 0, 0, 'R');
    $pdf->SetXY($this->col11, $this->ligne($ligdeb));
    $pdf->Cell(10, 1, '0.00', 0, 0, 'R');
    $pdf->SetXY($this->col11, $this->ligne($ligdeb + 1));
    $pdf->Cell(10, 1, '0.00', 0, 0, 'R');
    $pdf->SetXY($this->col17, $this->ligne($ligdeb));
    $pdf->Cell(10, 1, sprintf('%01.2f', $mafact->getMontantAutre()), 0, 0, 'R');
    $pdf->SetXY($this->col17, $this->ligne($ligdeb + 1));
    $pdf->Cell(10, 1, '0.00', 0, 0, 'R');
    
    $pdf->SetXY($this->col1, $this->ligne($ligdeb + 7));
    $pdf->Cell(5, 1, '0', 0, 0, 'R');
    $pdf->SetXY($this->col2, $this->ligne($ligdeb + 7));
    $pdf->Cell(5, 1, '0', 0, 0, 'R');
    $pdf->SetXY($this->col3, $this->ligne($ligdeb + 7));
    $pdf->Cell(10, 1, sprintf('%01.2f', $mafact->montant), 0, 0, 'R');
    $pdf->SetXY($this->col4, $this->ligne($ligdeb + 7));
    $pdf->Cell(8, 1, '0.00', 0, 0, 'R');
    
    
    $pdf->Carre($this->col1 - 2, $this->ligne($ligdeb + 3));
    $pdf->Carre($this->col1 - 2, $this->ligne($ligdeb + 5));
    $pdf->Carre($this->col1 - 2, $this->ligne($ligdeb + 7));
    $pdf->SetFont('Arial', 'B', $this->P);
    $pdf->SetXY($this->col1, $this->ligne($ligdeb + 3));
    $pdf->Cell(50, 1, 'Montant total');
    $pdf->SetXY($this->col3, $this->ligne($ligdeb + 3));
    $pdf->Cell(50, 1, 'CHF');
    $pdf->SetXY($this->col5, $this->ligne($ligdeb + 3));
    $pdf->Cell(50, 1, 'dont pr. obl.');
    $pdf->SetXY($this->col9, $this->ligne($ligdeb + 3));
    $pdf->Cell(50, 1, 'Acompte');
    $pdf->SetXY($this->col13, $this->ligne($ligdeb + 3));
    $pdf->Cell(50, 1, 'Montant d');
    $pdf->SetXY($this->col1, $this->ligne($ligdeb + 5));
    $pdf->Cell(50, 1, 'N TVA');
    $pdf->SetXY($this->col1, $this->ligne($ligdeb + 6));
    $pdf->Cell(50, 1, 'Code');
    $pdf->SetXY($this->col2, $this->ligne($ligdeb + 6));
    $pdf->Cell(50, 1, 'Taux');
    $pdf->SetXY($this->col3, $this->ligne($ligdeb + 6));
    $pdf->Cell(50, 1, 'Montant');
    $pdf->SetXY($this->col4, $this->ligne($ligdeb + 6));
    $pdf->Cell(50, 1, 'TVA');
    $pdf->SetXY($this->col1, $this->ligne($ligdeb + 8.5));
    $pdf->Cell(50, 1, 'Total');
    
    
    $pdf->SetFont('Arial', 'B', $this->M);
    $pdf->SetXY($this->col3, $this->ligne($ligdeb + 3));
    $pdf->Cell(25, 1, sprintf('%01.2f', $mafact->montant), 0, 0, 'R');
    $pdf->SetXY($this->col6, $this->ligne($ligdeb + 3));
    $pdf->Cell(25, 1, sprintf('%01.2f', $mafact->montant), 0, 0, 'R');
    $pdf->SetXY($this->col11, $this->ligne($ligdeb + 3));
    $pdf->Cell(10, 1, '0.00', 0, 0, 'R');
    $pdf->SetXY($this->col18, $this->ligne($ligdeb + 3));
    $pdf->Cell(10, 1, sprintf('%01.2f', $mafact->montant), 0, 0, 'R');
    $pdf->SetXY($this->col3, $this->ligne($ligdeb + 8.5));
    $pdf->Cell(10, 1, sprintf('%01.2f', $mafact->montant), 0, 0, 'R');
    $pdf->SetXY($this->col4, $this->ligne($ligdeb + 8.5));
    $pdf->Cell(8, 1, '0.00', 0, 0, 'R');
    
  }
  //Egrenage des prestations d'une page
  function egrene($cpt, $lignedebut, &$pdf, &$mafact, $li, $seance, $dateprec, $radiol){
    $mg = $this->mg;
    $P = $this->P;
    $M = $this->M;
    for ($i = 0; $i < $cpt; $i++){
      $lir = $lignedebut + (2 * $i);
      $pdf->SetXY($this->col3, $this->ligne($lir));
      $pdf->SetFont('Arial', 'B', $P);
      $pdf->Cell(50, 1, substr($mafact->getLibelle($li[$i]->noprest, true),0 ,150));
      $pdf->Carre($this->col1 - 2, $this->ligne($lir + 1));
      $pdf->SetXY($this->col1, $this->ligne($lir + 1));
      $pdf->SetFont('Arial', '', $M);
      $pdf->Cell(50, 1, $li[$i]->dateprest);
      $pdf->SetXY($this->col2, $this->ligne($lir + 1));
      $pdf->Cell(50, 1, $mafact->getCodeTarif($li[$i]->tarif));
      $pdf->SetXY($this->col3, $this->ligne($lir + 1));
      $pdf->Cell(50, 1, $mafact->formatePos($li[$i]->noprest));
      $pdf->SetXY($this->col4, $this->ligne($lir + 1));
      $pdf->Cell(50, 1, $mafact->getCodeRef($li[$i]->tarif, $li[$i]->position));
      if ($li[$i]->position > 300000 && $li[$i]->tarif == 5){
        $radiol ++;
      } 
      if ($mafact->nouvseance($li[$i]->tarif, $li[$i]->position)
          || $radiol == 1){
        $seance ++;
      }
      if ($li[$i]->dateprest != $dateprec){
        $seance = 1;
        $radiol = ($radiol == 1 ? 1 : 0);
      }
      $pdf->SetXY($this->col5, $this->ligne($lir + 1));
      $pdf->Cell(50, 1, $seance);
      //pas de ct pour l'instant
      $pdf->SetXY($this->col7, $this->ligne($lir + 1));
      $pdf->Cell(10, 1, $li[$i]->nombre, 0, 0, 'R');
      $pdf->SetXY($this->col8, $this->ligne($lir + 1));
      $pdf->Cell(10, 1, ($li[$i]->tarif == 99 ?
                 $li[$i]->pt :
                 ($li[$i]->pm == 0 ? "" : $li[$i]->pm)), 0, 0, 'R');
      $pdf->SetXY($this->col9, $this->ligne($lir + 1));
      $pdf->Cell(5.5, 1, sprintf('%01.2f', $li[$i]->fpm), 0, 0, 'R');
      $pdf->SetXY($this->col10, $this->ligne($lir + 1));
      $pdf->Cell(8, 1, ($li[$i]->tarif == 99 ?
                 $li[$i]->vpt :
                 ($li[$i]->vpm == 0 ? "" : $li[$i]->vpm)), 0, 0, 'R');
      $pdf->SetXY($this->col11, $this->ligne($lir + 1));
      $pdf->Cell(8, 1, ($li[$i]->tarif == 99 ?
                 "" :
                 ($li[$i]->pt == 0 ? "" : $li[$i]->pt)), 0, 0, 'R');
      $dateprec = $li[$i]->dateprest;
      $pdf->SetXY($this->col12, $this->ligne($lir + 1));
      $pdf->Cell(7, 1, sprintf('%01.2f', $li[$i]->fpt), 0, 0, 'R');
      $pdf->SetXY($this->col10, $this->ligne($lir + 1));
      $pdf->SetXY($this->col13, $this->ligne($lir + 1));
      $pdf->Cell(8, 1, ($li[$i]->tarif == 99 ?
                 "" :
                 ($li[$i]->vpt == 0 ? "" : $li[$i]->vpt)), 0, 0, 'R');
      $pdf->SetXY($this->col14, $this->ligne($lir + 1));
      $pdf->Cell(50, 1, '1');
      $pdf->SetXY($this->col15, $this->ligne($lir + 1));
      $pdf->Cell(50, 1, '1');
      $pdf->SetXY($this->col16, $this->ligne($lir + 1));
      $pdf->Cell(50, 1, '1');
      $pdf->SetXY($this->col17, $this->ligne($lir + 1));
      $pdf->Cell(50, 1, '0');
      $pdf->SetXY($this->col18, $this->ligne($lir + 1));
      $pdf->Cell(10, 1, $li[$i]->ttligne, 0, 0, 'R');
      $dateprec = $li[$i]->dateprest;
    }  
    $retour['lir'] = $lir;
    $retour['seance'] = $seance;
    $retour['radiol'] = $radiol;
    $retour['dateprec'] = $dateprec;
    return $retour;
  }
  
  //Entete formulaire unifi
  function enteteJust($x, $y, $w, $h, &$mafact, $page){
    $P = $this->P;
    $M = $this->M;
    $G = $this->G;
    $mg = $this->mg;
    $il = $this->il;
    $ms = $this->ms;
    $medecin = $this->medecin;
    $pdf = &$this->pdf;
    $pdf->SetFont('Arial', 'B', $G);
    $pdf->SetXY($mg, $this->ligne(1));
    $pdf->Cell(50, 1, ($mafact->tiersxml == 2 ? 'Facture TP' : 'Justificatif de remboursement'));
    if ($mafact->isRappel() && $mafact->tiersxml == 2){
      $pdf->SetXY($mg + 85, $this->ligne(1));
      $pdf->Cell(50, 1, $mafact->isRappel() . "e rappel");
    }
    $pdf->SetFont('Arial', '', $P);
    $pdf->SetXY($mg + 140, $y + $this->ligne(1));
    $pdf->Cell(10, 1, 'Version');
    $pdf->carre($mg + 150, $y + $this->ligne(1));
    $pdf->SetFont('Arial', '', $M);
    $pdf->SetXY($mg + 155, $y + $this->ligne(1));
    $pdf->Cell(50, 1, ' 4.0');
    $pdf->SetFont('Arial', 'B', $G);
    $pdf->SetXY($mg + 175, $y + $this->ligne(1));
    $pdf->Cell(10, 1, 'M');
    $pdf->Rect($x, $y + $this->ligne(2.5), $w, $h);
    $pdf->SetXY($x + 1, $y + $this->ligne(3));
    $pdf->SetFont('Arial', "B", $P);
    $pdf->Cell(50, 1, 'Document');
    $pdf->SetXY($x + 160, $y + $this->ligne(3));
    $pdf->Cell(20, 1, 'Page');
    $pdf->SetXY($x + 1, $y + $this->ligne(4));
    $pdf->Cell(50, 1, 'Auteur facture');
    $pdf->SetXY($x + 1, $y + $this->ligne(6));
    $pdf->Cell(50, 1, 'Four. de prestations');
    $pdf->Carre($x + 25, $y + $this->ligne(3));
    $pdf->SetFont('Arial', '', $M);
    $pdf->SetXY($x + 27, $y + $this->ligne(3));
    $pdf->Cell(50, 1, $mafact->nofact . ' ' . $mafact->datefact . ' 00:00:00');
    $pdf->carre($x + 167, $y + $this->ligne(3));
    $pdf->SetFont('Arial', '', $M);
    $pdf->SetXY($x + 169, $y + $this->ligne(3));
    $pdf->Cell(20, 1, $page);
    $pdf->SetFont('Arial', '', $P);
    $pdf->SetXY($x + 25, $y + $this->ligne(4));
    $pdf->Cell(20, 1, 'N EAN');
    $pdf->SetXY($x + 25, $y + $this->ligne(5));
    $pdf->Cell(20, 1, 'N RCC');
    $pdf->SetXY($x + 25, $y + $this->ligne(6));
    $pdf->Cell(20, 1, 'N EAN');
    $pdf->SetXY($x + 25, $y + $this->ligne(7));
    $pdf->Cell(20, 1, 'N RCC');
    $pdf->SetXY($x + 70, $y + $this->ligne(4));
    $pdf->Cell(20, 1, 'Dr ' . $mafact->nommed);
    $pdf->SetXY($x + 70, $y + $this->ligne(5));
    $pdf->Cell(20, 1, 'Tl. ' . $medecin->tel);
    $pdf->SetXY($x + 70, $y + $this->ligne(6));
    $pdf->Cell(20, 1, 'Dr ' . $mafact->nommed);
    $pdf->SetXY($x + 70, $y + $this->ligne(7));
    $pdf->Cell(20, 1, 'Tl. ' . $medecin->tel);
    $pdf->SetXY($x + 105, $y + $this->ligne(4));
    $pdf->Cell(20, 1, $medecin->adresse);
    $pdf->SetXY($x + 100, $y + $this->ligne(5));
    $pdf->Cell(20, 1, 'Fax ');
    $pdf->SetXY($x + 105, $y + $this->ligne(6));
    $pdf->Cell(20, 1, $medecin->adresse);
    $pdf->SetXY($x + 100, $y + $this->ligne(7));
    $pdf->Cell(20, 1, 'Fax ');
    $pdf->SetXY($x + 140, $y + $this->Ligne(4));
    $pdf->Cell(20, 1, $medecin->npa . " " . $medecin->ville);
    $pdf->SetXY($x + 135, $y + $this->ligne(5));
    $pdf->Cell(20, 1, 'Courriel : ' . $medecin->email);
    $pdf->SetXY($x + 140, $y + $this->ligne(6));
    $pdf->Cell(20, 1, $medecin->npa . " " . $medecin->ville);
    $pdf->SetXY($x + 135, $y + $this->ligne(7));
    $pdf->Cell(20, 1, 'Courriel : ' . $medecin->email);
    $pdf->carre($x + $this->tabpri, $y + $this->ligne(4));
    $pdf->carre($x + $this->tabpri, $y + $this->ligne(5));
    $pdf->carre($x + $this->tabpri, $y + $this->ligne(6));
    $pdf->carre($x + $this->tabpri, $y + $this->ligne(7));
    $pdf->SetFont('Arial', '', $M);
    $pdf->SetXY($x + $this->tabpri + 2, $y + $this->ligne(4));
    $pdf->Cell(20, 1, $medecin->ean);
    $pdf->SetXY($x + $this->tabpri + 2, $y + $this->ligne(5));
    $pdf->Cell(20, 1, $medecin->concordat);
    $pdf->SetXY($x + $this->tabpri + 2, $y + $this->ligne(6));
    $pdf->Cell(20, 1, $medecin->ean);
    $pdf->SetXY($x + $this->tabpri + 2, $y + $this->ligne(7));
    $pdf->Cell(20, 1, $medecin->concordat);


  }

  //Contenu facture
  function addFact($itfact, $impgroupe = false){
    $mafact = new ensDetailFacture($itfact, $this->idsession);
    $mafact->recalcule();
    $mafact->prepare($impgroupe);
    $enp = new enrBriocheCab($mafact->nopat, $this->idsession);
    $enr = $enp->getEnr("patients");
    $nummed = $mafact->nummed;
    $ensFact = new ensFacturePat($mafact->nopat, $this->idsession);
    $emed = new ensTableBrioche("medecins", "id = $nummed", "*", 0, $this->idsession);
    $temed = $emed->getTableau();
    $medecin = $temed[0];
    $ecas = new ensTableBrioche("typeprest", "id = $mafact->typeprest", "*", 0, $this->idsession);
    $tecas = $ecas->getTableau();
    $cas = $tecas[0];
    
    $adresse = $mafact->getAdresseFact();

    $pdf = &$this->pdf;
    $mg = $this->mg;
    $xadresse = $this->xadresse;
    $hp = $this->hp;
    $htot = $this->htot;
    $hu = $this->hu;
    $hc = $this->hc;
    $tc = $this->tc;
    $pdf->AddPage();
    $pdf->SetFont('Gothic', 'B', 9);
    $pdf->SetXY($mg, 10);
    $pdf->Cell(50, $this->il, 'Docteur ' . $medecin->txt);
    $pdf->SetFont('Gothic', '', 9);
    $pdf->SetXY($mg, $this->ligne(1));
    $pdf->Cell(50, $this->il, $medecin->titre);
    $pdf->SetXY($mg, $this->ligne(2));
    $pdf->Cell(50, $this->il, $medecin->adresse);
    $pdf->SetXY($mg, $this->ligne(3));
    $pdf->Cell(8, $this->il, $medecin->npa);
    $pdf->SetFont('Gothic', 'B', 9);
    $pdf->Cell(42, $this->il, $medecin->ville);
    $pdf->SetFont('Gothic', '', 9);
    $pdf->SetXY($mg, $this->ligne(4.5));
    $pdf->Cell(50, $this->il, $medecin->tel);
    $pdf->SetXY($mg, $this->ligne(5.5));
    $pdf->Cell(50, $this->il, $medecin->email);
    $pdf->SetFont('Arial', '', 8);
    $pdf->SetXY($mg, $this->ligne(7));
    $pdf->Cell(10, $this->il, 'EAN : ' . $medecin->ean . ' - RCC : ' . $medecin->concordat .
               ($medecin->nif ? ' - NIF : ' . $medecin->nif : ''));
    $pdf->SetXY($mg, $this->ligne(8.5));
    $pdf->Cell(100, $this->il, 'Facture N ' . ensFacturePat::getNoAbr($mafact->nofact) .
               ' du ' . $mafact->datefact);
    $pdf->SetXY($mg, $this->ligne(9.5));
    $pdf->Cell(100, $this->il, 'Soins  : ' . $ensFact->nomplein .', n(e) le ' . $ensFact->daten);
    $pdf->SetXY($mg, $this->ligne(10.5));
    $pdf->Cell(100, $this->il, $enr->adresse . " - " . $enr->nopost . " " . $enr->ville);
    $pdf->SetXY($mg, $this->ligne(11.5));
    $pdf->Cell(100, $this->il, 'Code diag. : U' . ($medecin->imprnoass ? ' - N assur : ' . $mafact->noass : ''));
    $pdf->SetXY($mg, $this->ligne(12.5));
    $pdf->Cell(100, $this->il, $cas->loi . ' - ' . $cas->txt . ' - ' . $cas->payant);
    $pdf->Rect($mg -1 , $this->ligne(8.1), 82, $this->il * 5.4);
    if ($mafact->isRappel()){
      switch ($mafact->isRappel()){
      case 1:
        $texterap = "RAPPEL";
        break;
      case 2:
        $texterap = "DEUXIEME RAPPEL";
        break;
      case 3:
        $texterap = "TROISIEME RAPPEL";
        break;
      }
      $pdf->SetFont('Arial', 'B', 20);
      $pdf->SetXY($mg + 100, $this->ligne(3));
      $pdf->Cell(100, $this->il, $texterap);

    }
    $pdf->SetFont('Arial', 'I', 10);
    $pdf->SetXY($mg, $this->ligne(15));
    $pdf->SetRightMargin(120);
    $pdf->Write(3, $mafact->getTexteRemarques());
    $pdf->SetRightMargin(10);
    
    $pdf->SetFont('Arial', '', 10);
    $pdf->SetXY($xadresse, $this->ms);
    $pdf->Cell(50, $this->il, $medecin->ville . ', le ' . $mafact->aujourdhui());
    $pdf->SetXY($xadresse, 55);
    $pdf->Cell(60, $this->il, $adresse[0]);
    $pdf->SetXY($xadresse, 55 + 1.5 * $this->il);
    $pdf->Cell(60, $this->il, $adresse[1]);
    $pdf->SetXY($xadresse, 55 + 3 * $this->il);
    $pdf->Cell(10, $this->il, $adresse[2]);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->Cell(50, $this->il, $adresse[3]);
    $pdf->SetFont('Arial', '', 10);
    $pdf->SetXY($mg + 5, 85);
    $pdf->Write(4, 'Le docteur ' . $medecin->txt . ' vous prsente ses compliments ' .
                "et vous adresse sa note d'honoraires pour ses prestations du " .
                $mafact->debut . ($mafact->fin == $mafact->debut ? '' : " au $mafact->fin") . '.');

    $tab[0] = $mg;
    $tab[1] = $mg + 16;
    $tab[2] = $mg + 24;
    $tab[3] = $mg + 38;
    $tab[4] = $mg + 122;
    $tab[5] = $mg + 130;
    $tab[6] = $mg + 138;
    $tab[7] = $mg + 146;
    $tab[8] = $mg + 154;
    $tab[9] = $mg + 162;
    $tab[10] = $mg + 170;

    $pdf->SetFont('Arial', 'B', 8);
    $pdf->SetXY($tab[0], $hp);
    $pdf->Cell(10, $this->il, 'Date');
    $pdf->SetXY($tab[1], $hp);
    $pdf->Cell(8, $this->il, 'Nb.', 0, 0, 'R');
    $pdf->SetXY($tab[2], $hp);
    $pdf->Cell(10, $this->il, 'Pos.');
    $pdf->SetXY($tab[3], $hp);
    $pdf->Cell(10, $this->il, 'Libell');
    $pdf->SetXY($tab[4], $hp);
    $pdf->Cell(10, $this->il, 'pm', 0, 0, 'R');
    $pdf->SetXY($tab[5], $hp);
    $pdf->Cell(10, $this->il, 'fpm', 0, 0, 'R');
    $pdf->SetXY($tab[6], $hp);
    $pdf->Cell(10, $this->il, 'vm', 0, 0, 'R');
    $pdf->SetXY($tab[7], $hp);
    $pdf->Cell(10, $this->il, 'pt', 0, 0, 'R');
    $pdf->SetXY($tab[8], $hp);
    $pdf->Cell(10, $this->il, 'fpt', 0, 0, 'R');
    $pdf->SetXY($tab[9], $hp);
    $pdf->Cell(10, $this->il, 'vt', 0, 0, 'R');
    $pdf->SetXY($tab[10], $hp);
    $pdf->Cell(20, $this->il, 'Montant', 0, 0, 'R');
    $tl = $mafact->getLignes(24);
    $lig = $tl->getTableau();
    $cpt = $tl->compte();
    $pdf->setFont('Arial', '', 8);
    for ($i = 0; $i < $cpt; $i++){
      $forPo = $mafact->formatePos($lig[$i]->noprest);
      $tarif = $mafact->et->lookUp("tarif", "noprest = " . $lig[$i]->noprest);
      if ($tarif == 51){
        $forPo = substr($forPo, 3, 7);
      }
      $pdf->SetXY($tab[0], $hp + $this->il * ($i + 1));
      $pdf->Cell(10, $this->il, $lig[$i]->dateprest);
      $pdf->SetXY($tab[1], $hp + $this->il * ($i + 1));
      $pdf->Cell(8, $this->il, $lig[$i]->nombre, 0, 0, 'R');
      $pdf->SetXY($tab[2], $hp + $this->il * ($i + 1));
      $pdf->Cell(10, $this->il, $forPo);
      $pdf->SetXY($tab[3], $hp + $this->il * ($i + 1));
      $pdf->Cell(10, $this->il, $this->getLibelle($lig[$i]->noprest, $mafact));
      $pdf->SetXY($tab[4], $hp + $this->il * ($i + 1));
      $pdf->Cell(10, $this->il, $mafact->supprZero($lig[$i]->pm), 0, 0, 'R');
      $pdf->SetXY($tab[5], $hp + $this->il * ($i + 1));
      $pdf->Cell(10, $this->il, $mafact->supprZero($lig[$i]->fpm), 0, 0, 'R');
      $pdf->SetXY($tab[6], $hp + $this->il * ($i + 1));
      $pdf->Cell(10, $this->il, $mafact->supprZero($lig[$i]->vpm), 0, 0, 'R');
      $pdf->SetXY($tab[7], $hp + $this->il * ($i + 1));
      $pdf->Cell(10, $this->il, $mafact->supprZero($lig[$i]->pt), 0, 0, 'R');
      $pdf->SetXY($tab[8], $hp + $this->il * ($i + 1));
      $pdf->Cell(10, $this->il, $mafact->supprZero($lig[$i]->fpt), 0, 0, 'R');
      $pdf->SetXY($tab[9], $hp + $this->il * ($i + 1));
      $pdf->Cell(10, $this->il, $mafact->supprZero($lig[$i]->vpt), 0, 0, 'R');
      $pdf->SetXY($tab[10], $hp + $this->il * ($i + 1));
      $pdf->Cell(20, $this->il, $lig[$i]->ttligne, 0, 0, 'R');

    }
    $mtab[0] = $mg;
    $mtab[1] = 55;
    $mtab[2] = 95;
    $mtab[3] = 135;
    $mtab[4] = 130;

    $pdf->SetFont('Arial', 'B', 10);
    $pdf->SetXY($mtab[0], $htot);
    $pdf->Cell(10, $this->il, 'Montant tarmed : ' . $mafact->getMontantTarmed());
    $pdf->SetXY($mtab[1], $htot);
    $pdf->Cell(10, $this->il, 'Montant labo : ' . $mafact->getMontantLabo());
    $pdf->SetXY($mtab[2], $htot);
    $pdf->Cell(10, $this->il, 'Autre : ' . $mafact->getMontantAutre());
    $pdf->SetXY($mtab[3], $htot);
    $pdf->Cell(65, $this->il, 'Total : ' . $mafact->montant, 0, 0, 'R');
    $utab[0] = 10;
    $utab[1] = 70;
    $mt = $mafact->getMontantFrC();
    if ($medecin->ccp != "non"){
      for ($i = 0; $i < 2; $i++){
        if ($medecin->imprbanque){
          $pdf->SetFont('Arial', 'B', 10);
          $pdf->SetXY($utab[$i], $hu);
          $pdf->Cell(10, $this->il, $medecin->banque);
        }
        $pdf->SetFont('Arial', '', 10);
        $pdf->SetXY($utab[$i], $hu + 2 * $this->il);
        $pdf->Cell(10, $this->il, $medecin->lieubanque);
        $pdf->SetXY($utab[$i], $hu + 15);
        $pdf->Cell(10, $this->il, 'Dr ' . $medecin->txt);
        $pdf->SetXY($utab[$i], $hu + 15 + 1.2 * $this->il);
        $pdf->Cell(10, $this->il, $medecin->adresse);
        $pdf->SetXY($utab[$i], $hu + 15 + 2.4 * $this->il);
        $pdf->Cell(10, $this->il, $medecin->npa . ' ' . $medecin->ville);
        $pdf->SetXY($utab[$i] + 18, $hu + 35);
        $pdf->Cell(10, $this->il, $medecin->ccp);
        $pdf->SetFont('Arial', 'B', 10);
        $cpt0 = strlen($mt[0]);
        for ($j = $cpt0 - 1; $j >= 0; $j--){
          $pdf->SetXY($utab[$i] + 0 - ($j * $this->pasMtant), $hu + 43);
          $pdf->Cell(20, $this->il, substr($mt[0], (- $j - 1), 1), 0, 0, 'R');
        }
        $cpt1 = strlen($mt[1]);
        for ($j = $cpt1 - 1 ; $j >= 0; $j--){
          $pdf->SetXY($utab[$i] + 34 - ($j * $this->pasMtant), $hu + 43);
          $pdf->Cell(10, $this->il, substr($mt[1], (- $j -1), 1), 0, 0, 'R');
        }
      }
      $rtab = $mafact->getMonNumRef();
      $ch = $rtab[1];
      $fch = sprintf("%s %s %s %s %s %s", substr($ch, 0, 2), substr($ch, 2, 5), substr($ch, 7, 5),
                     substr($ch, 12, 5), substr($ch, 17, 5), substr($ch, 22, 5));
      $pdf->SetFont('Arial', '', 10);
      $pdf->SetXY($utab[0] + 117 , $hu + 26);
      $pdf->Cell(10, $this->il, $fch);
      $pdf->SetFont('Arial', '', 8);
      $pdf->SetXY($utab[0] ,$hu + 52);
      $pdf->Cell(10, $this->il, $fch);
      $pdf->SetFont('Ocrb', '', 12);
      $pdf->SetXY($tc - 100, $hc);
      $pdf->Cell(100, $this->il, "$rtab[0]>$rtab[1]+ $rtab[2]>", 0, 0, 'R');
      $pdf->Line($utab[0], $hu + 58, $utab[0] + 45, $hu + 58);
      $pdf->Line($utab[0], $hu + 66, $utab[0] + 45, $hu + 66);
      $pdf->Line($utab[0], $hu + 74, $utab[0] + 45, $hu + 74);

      $pdf->line($utab[0] + 117, $hu + 45, $utab[0] + 117 + 75, $hu + 45);
      $pdf->line($utab[0] + 117, $hu + 53, $utab[0] + 117 + 75, $hu + 53);
      $pdf->line($utab[0] + 117, $hu + 61, $utab[0] + 117 + 75, $hu + 61);
    }
    //Page 2
    if($mafact->compteLignes() > 24){
      $pdf->SetXY($mtab[4], $htot);
      $pdf->SetFont('Arial', '', '10');
      $pdf->Cell(50, $this->il, 'Suite p. 2 >>>');
      $tl = $mafact->getLignes($mafact->compteLignes(), 24);
      $lig = $tl->getTableau();
      $cpt = count($lig);
      $hp = 20;
      $pdf->addPage();
      $pdf->SetFont('Arial', '', 10);
      $pdf->SetXY($tab[0], 15);
      $pdf->Cell(100, $this->il, 'Dr ' . $medecin->txt . ' - Facture ' .
                 ensFacturePat::getNoAbr($mafact->nofact) . ' - ' . ' p. 2');
      $pdf->SetFont('Arial', 'B', 8);
      $pdf->SetXY($tab[0], $hp);
      $pdf->Cell(10, $this->il, 'Date');
      $pdf->SetXY($tab[1], $hp);
      $pdf->Cell(8, $this->il, 'Nb.', 0, 0, 'R');
      $pdf->Cell(10, $this->il, 'Pos.');
      $pdf->SetXY($tab[3], $hp);
      $pdf->Cell(10, $this->il, 'Libell');
      $pdf->SetXY($tab[4], $hp);
      $pdf->Cell(10, $this->il, 'pm', 0, 0, 'R');
      $pdf->SetXY($tab[5], $hp);
      $pdf->Cell(10, $this->il, 'vm', 0, 0, 'R');
      $pdf->SetXY($tab[6], $hp);
      $pdf->Cell(10, $this->il, 'pt', 0, 0, 'R');
      $pdf->SetXY($tab[7], $hp);
      $pdf->Cell(10, $this->il, 'vt', 0, 0, 'R');
      $pdf->SetXY($tab[8], $hp);
      $pdf->Cell(20, $this->il, 'Montant', 0, 0, 'R');
      $pdf->SetFont('Arial', '', 8);
      for ($i = 0; $i < $cpt; $i++){
        $pdf->SetXY($tab[0], $hp + $this->il * ($i + 1));
        $pdf->Cell(10, $this->il, $lig[$i]->dateprest);
        $pdf->SetXY($tab[1], $hp + $this->il * ($i + 1));
        $pdf->Cell(8, $this->il, $lig[$i]->nombre, 0, 0, 'R');
        $pdf->SetXY($tab[2], $hp + $this->il * ($i + 1));
        $pdf->Cell(10, $this->il, $mafact->formatePos($lig[$i]->noprest));
        $pdf->SetXY($tab[3], $hp + $this->il * ($i + 1));
        $pdf->Cell(10, $this->il, $this->getLibelle($lig[$i]->noprest, $mafact));
        $pdf->SetXY($tab[4], $hp + $this->il * ($i + 1));
        $pdf->Cell(10, $this->il, $mafact->supprZero($lig[$i]->pm), 0, 0, 'R');
        $pdf->SetXY($tab[5], $hp + $this->il * ($i + 1));
        $pdf->Cell(10, $this->il, $mafact->supprZero($lig[$i]->vpm), 0, 0, 'R');
        $pdf->SetXY($tab[6], $hp + $this->il * ($i + 1));
        $pdf->Cell(10, $this->il, $mafact->supprZero($lig[$i]->pt), 0, 0, 'R');
        $pdf->SetXY($tab[7], $hp + $this->il * ($i + 1));
        $pdf->Cell(10, $this->il, $mafact->supprZero($lig[$i]->vpt), 0, 0, 'R');
        $pdf->SetXY($tab[8], $hp + $this->il * ($i + 1));
        $pdf->Cell(20, $this->il, $lig[$i]->ttligne, 0, 0, 'R');
      }
      $pdf->SetFont('Arial', 'B', 10);
      $pdf->SetXY($mtab[0], $htot);
      if ($medecin->ccp != "non"){
        $pdf->Cell(100, $this->il, "Totaux, cf. p. 1 - Pour votre rglement, merci d'utiliser le bulletin annex  la premire page.");

        for ($i = 0; $i < 2; $i++){
          $pdf->SetXY($utab[$i] + 12, $hu + 43);
          $pdf->Cell(20, $this->il, "XXXXXX", 0, 0, 'R');
          $pdf->SetXY($utab[$i] + 37, $hu + 43);
          $pdf->Cell(10, $this->il, "XXXX", 0, 0, 'R');
        }
      }
    }

  }

  function getLibelle($prest, $mafact){
    $ttt = $mafact->getLibelle($prest);
    $ttt = preg_replace("/&lt;/", "<", $ttt);
    $ttt = preg_replace("/&gt;/", ">", $ttt);
    return $ttt;
  }

  function ligne($no){
    return $this->ms + ($this->il * $no);
  }





}


?>
