alter table tarif add IF NOT EXISTS classe tinyint not null default 0;
-- facteur différencié pour médecins
DROP TABLE IF EXISTS `factpmptdate`;
CREATE TABLE `factpmptdate` (
  `date` date NOT NULL DEFAULT '0000-00-00',
  `medecin` tinyint NOT NULL DEFAULT '0', 
  `facteur` enum('fpm','fpt') NOT NULL DEFAULT 'fpm',
  `valeur` float NOT NULL DEFAULT '0',
  `typeprest` tinyint(4) NOT NULL DEFAULT '0',
  `tst` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`),
  UNIQUE dfmt (`date`, `facteur`, `medecin`, `typeprest`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

ALTER TABLE tiers ADD IF NOT EXISTS ofsp  SMALLINT DEFAULT NULL;
ALTER TABLE tiers ADD CONSTRAINT ofsp UNIQUE (ofsp);



ALTER TABLE tiers ADD IF NOT EXISTS groupe VARCHAR(5) DEFAULT NULL;
ALTER TABLE tiers DROP IF EXISTS estAa;
ALTER TABLE tiers DROP IF EXISTS estAm;

ALTER TABLE prestations ADD IF NOT EXISTS fpm FLOAT NOT NULL DEFAULT 0 AFTER vpt;
ALTER TABLE prestations ADD IF NOT EXISTS fpt FLOAT NOT NULL DEFAULT 0 AFTER fpm;
UPDATE prestations SET fpm = 1 WHERE fpm = 0;
UPDATE prestations SET fpt = 1 WHERE fpt = 0;

DROP TABLE IF EXISTS `groupesass`;
CREATE TABLE `groupesass` (
  `abr` VARCHAR(5) NOT NULL,
  `texte` VARCHAR(25) DEFAULT NULL,
  `tst` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
INSERT INTO `groupesass` VALUES
('TS', 'Tarifsuisse','2017-11-23 10:42:19', ''),
('HSK', 'Communauté HSK', '2017-11-23 10:42:19', ''),
('CSS', 'Groupe CSS', '2017-11-23 10:42:19', '');
--
ALTER TABLE `valpointdate` ADD IF NOT EXISTS groupass TINYINT NOT NULL DEFAULT 0 AFTER typeprest;
DELETE FROM `valpointdate` WHERE date < "2003-01-01";

-- Assurances
LOCK TABLES `tiers` WRITE;
/*!40000 ALTER TABLE `tiers` DISABLE KEYS */;
DELETE FROM `tiers` WHERE ofsp IS NOT NULL;
INSERT INTO `tiers` VALUES ('2017-11-23 10:42:19',6758,NULL,'Vivacare',NULL,NULL,'Weltpoststrasse 19',3000,'Berne',NULL,0,NULL,0,1570,'TS'),('2017-11-23 10:42:19',6753,NULL,'Sumiswalder KK',NULL,NULL,'Spitalstrasse 47',3454,'Sumiswald',NULL,0,NULL,0,194,'TS'),('2017-11-23 10:42:19',6754,NULL,'Supra',NULL,NULL,'rue des Cèdres 5',1919,'Martigny',NULL,0,NULL,0,62,'TS'),('2017-11-23 10:42:19',6755,NULL,'Swica',NULL,NULL,'Römerstrasse 38',8401,'Winterthur',NULL,0,NULL,0,1384,'TS'),('2017-11-23 10:42:19',6756,NULL,'Visana',NULL,NULL,'Weltpoststrasse 19',3000,'Berne',NULL,0,NULL,0,1555,'TS'),('2017-11-23 10:42:19',6757,NULL,'Vita surselva',NULL,NULL,'Bahnofstrasse 33',7130,'Ilanz',NULL,0,NULL,0,966,'TS'),('2017-11-23 10:42:19',6751,NULL,'SLKK',NULL,NULL,'Hofwiesenstrasse 370',8050,'Zurich',NULL,0,NULL,0,923,'TS'),('2017-11-23 10:42:19',6752,NULL,'Sodalis',NULL,NULL,'Balfrinstrasse 15',3930,'Viège',NULL,0,NULL,0,941,'TS'),('2017-11-23 10:42:19',6742,NULL,'ÖKK',NULL,NULL,'Bahnhofstrasse 13',7302,'Landquart',NULL,0,NULL,0,455,'TS'),('2017-11-23 10:42:19',6743,NULL,'Philos',NULL,NULL,'rue des Cèdres 5',1919,'Martigny',NULL,0,NULL,0,1535,'TS'),('2017-11-23 10:42:19',6744,NULL,'Progrès',NULL,NULL,'Postfach',8081,'Zurich',NULL,0,NULL,0,994,'HSK'),('2017-11-23 10:42:19',6745,NULL,'Provita',NULL,NULL,'Römerstrasse 38',8401,'Winterthur',NULL,0,NULL,0,182,'TS'),('2017-11-23 10:42:19',6746,NULL,'Rhenusana',NULL,NULL,'Heinrich-Wild-strasse 210',9435,'Heerbrugg',NULL,0,NULL,0,1401,'TS'),('2017-11-23 10:42:19',6747,NULL,'Sana24',NULL,NULL,'Weltpoststrasse 19',3000,'Berne',NULL,0,NULL,0,1568,'TS'),('2017-11-23 10:42:19',6748,NULL,'Sanagate',NULL,NULL,'Tribschenstrasse 21',6002,'Lucerne',NULL,0,NULL,0,1577,'CSS'),('2017-11-23 10:42:19',6749,NULL,'Sanavals',NULL,NULL,'Valléstrasse 146E',7132,'Vals',NULL,0,NULL,0,901,'TS'),('2017-11-23 10:42:19',6750,NULL,'Sanitas',NULL,NULL,'Jägerstrasse 3',8021,'Zurich',NULL,0,NULL,0,1509,'HSK'),('2017-11-23 10:42:19',6717,NULL,'CSS',NULL,NULL,'Tribschenstrasse 21',6002,'Lucerne',NULL,0,NULL,0,8,'CSS'),('2017-11-23 10:42:19',6718,NULL,'Easy Sana',NULL,NULL,'Rue des Cèdres 5',1919,'Martigny',NULL,0,NULL,0,774,'TS'),('2017-11-23 10:42:19',6719,NULL,'EGK',NULL,NULL,'Brislachstrasse 2',4242,'Laufon',NULL,0,NULL,0,881,'TS'),('2017-11-23 10:42:19',6720,NULL,'Galenos',NULL,NULL,'Militärstrasse 36',8021,'Zurich',NULL,0,NULL,0,1386,'TS'),('2017-11-23 10:42:19',6721,NULL,'Gen. Glarner KV',NULL,NULL,'Semftalstrasse 33',8762,'Schwanden',NULL,0,NULL,0,780,'TS'),('2017-11-23 10:42:19',6722,NULL,'Helsana',NULL,NULL,'Postfach',8081,'Zurich',NULL,0,NULL,0,1562,'HSK'),('2017-11-23 10:42:19',6723,NULL,'Indivo / Helsana',NULL,NULL,'Postfach',8081,'Zurich',NULL,0,NULL,0,1573,'HSK'),('2017-11-23 10:42:19',6724,NULL,'Intras',NULL,NULL,'Tribschenstrasse 21',6002,'Lucerne',NULL,0,NULL,0,1529,'CSS'),('2017-11-23 10:42:19',6725,NULL,'KK Birchmeier',NULL,NULL,'Hauptstrasse 22',5444,'Künten',NULL,0,NULL,0,1322,'TS'),('2017-11-23 10:42:19',6726,NULL,'KK Einsiedeln',NULL,NULL,'Hauptsrasse 61',8840,'Einsiedeln',NULL,0,NULL,0,134,'TS'),('2017-11-23 10:42:19',6727,NULL,'KK Ingenbohl',NULL,NULL,'Posfach 57',8840,'Einsiedeln',NULL,0,NULL,0,1142,'TS'),('2017-11-23 10:42:19',6728,NULL,'KK Luzerner Hinterland',NULL,NULL,'Luzernstrasse 19',6144,'Zell',NULL,0,NULL,0,360,'TS'),('2017-11-23 10:42:19',6729,NULL,'KK Steffisburg',NULL,NULL,'Unterdorfstrasse 37',3612,'Steffisburg',NULL,0,NULL,0,246,'TS'),('2017-11-23 10:42:19',6730,NULL,'KK Stoffel',NULL,NULL,'Bahnhofstrasse 63',8887,'Mels',NULL,0,NULL,0,1331,'TS'),('2017-11-23 10:42:19',6731,NULL,'KK Simplon',NULL,NULL,'',3907,'Simplon-Dorf',NULL,0,NULL,0,1362,'TS'),('2017-11-23 10:42:19',6732,NULL,'KK Turbenthal',NULL,NULL,'Tösstalstrasse 147',8488,'Turbenthal',NULL,0,NULL,0,1147,'TS'),('2017-11-23 10:42:19',6733,NULL,'KKV',NULL,NULL,'Wierastrasse',3932,'Visperterminen',NULL,0,NULL,0,1040,'TS'),('2017-11-23 10:42:19',6734,NULL,'KK Wädenswil',NULL,NULL,'Schönenbergstrasse 28',8820,'Wädenswil',NULL,0,NULL,0,1318,'TS'),('2017-11-23 10:42:19',6735,NULL,'Klug',NULL,NULL,'Gubelstrasse 22',6300,'Zug',NULL,0,NULL,0,829,'TS'),('2017-11-23 10:42:19',6736,NULL,'KMU KV',NULL,NULL,'Bachtelstrasse 5',8400,'Winterthur',NULL,0,NULL,0,1328,'TS'),('2017-11-23 10:42:19',6737,NULL,'Kolping',NULL,NULL,'Wallisellenstrasse 5',8600,'Dübendorf',NULL,0,NULL,0,762,'TS'),('2017-11-23 10:42:19',6738,NULL,'CPT/KPT',NULL,NULL,'Wankdorfallee 3',3001,'Berne',NULL,0,NULL,0,376,'HSK'),('2017-11-23 10:42:19',6739,NULL,'KVF',NULL,NULL,'Bahnhofstrasse 13',7302,'Landquart',NULL,0,NULL,0,558,'TS'),('2017-11-23 10:42:19',6740,NULL,'Moove Sympany',NULL,NULL,'Peter Merian-Weg 4',4002,'Bâle',NULL,0,NULL,0,57,'TS'),('2017-11-23 10:42:19',6741,NULL,'Mutuel',NULL,NULL,'rue des Cèdres 5',1919,'Martigny',NULL,0,NULL,0,1479,'TS'),('2017-11-23 10:42:19',6706,NULL,'Agrisano',NULL,NULL,'Laurstrasse 10',5200,'Brugg',NULL,0,NULL,0,1560,'TS'),('2017-11-23 10:42:19',6707,NULL,'AMB',NULL,NULL,'route de Verbier 13',1934,'Le Châble',NULL,0,NULL,0,1507,'TS'),('2017-11-23 10:42:19',6708,NULL,'Aquilana',NULL,NULL,'Bruggerstrasse 46',5401,'Baden',NULL,0,NULL,0,32,'TS'),('2017-11-23 10:42:19',6709,NULL,'Arcosana',NULL,NULL,'Tribschenstrasse 21',6005,'Lucerne',NULL,0,NULL,0,1569,'CSS'),('2017-11-23 10:42:19',6710,NULL,'Assura',NULL,NULL,'Av. C.-F. Ramuz 70',1009,'Pully',NULL,0,NULL,0,1542,'TS'),('2017-11-23 10:42:19',6711,NULL,'Atupri',NULL,NULL,'Ziegelstrasse 29',3000,'Berne',NULL,0,NULL,0,312,'TS'),('2017-11-23 10:42:19',6712,NULL,'Avenir',NULL,NULL,'rue des Cèdres 5',1919,'Martigny',NULL,0,NULL,0,343,'TS'),('2017-11-23 10:42:19',6713,NULL,'Caisse Vallée d\'Entremont',NULL,NULL,'Place centrale',1937,'Orsières',NULL,0,NULL,0,1113,'TS'),('2017-11-23 10:42:19',6714,NULL,'Cassa da malsauns Lumneziana',NULL,NULL,'Postfach 41',7144,'Vella',NULL,0,NULL,0,820,'TS'),('2017-11-23 10:42:19',6715,NULL,'Compact',NULL,NULL,'Jägerstrasse 3',8021,'Zurich',NULL,0,NULL,0,1575,'HSK'),('2017-11-23 10:42:19',6716,NULL,'Concordia',NULL,NULL,'Bundesplatz 15',6002,'Lucerne',NULL,0,NULL,0,290,'TS'),('2017-11-23 10:42:19',6759,NULL,'Vivao Sympany',NULL,NULL,'Peter Merian-Weg 4',4002,'Bâle',NULL,0,NULL,0,509,'TS');
/*!40000 ALTER TABLE `tiers` ENABLE KEYS */;
UNLOCK TABLES;


ALTER TABLE `valpointdate` ADD CONSTRAINT multi UNIQUE (date, point, typeprest, groupass);
--
update version set valeur = 0 where cle = "versionG";
update version set valeur = 98 where cle = "versionP";
