<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Formulaire pour paramtrer les prestations sur mesure
* @package radix
*/
/**
* Formulaire pour pramtrer les prestaionts sur mesure
* Permet de dfinir un certain nombre de prestations hors tarif (vaccins, etc.)
* @package radix
* @author ob
*/
class prestSurMes extends cadronglet {
    
  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param string fondpage la couleur du fond de la page
  * @param string sessionid l'identifiant de session
  * @param string donnees les donnees postes par le formulaire
  * @param int action_retour l'action pour revenir au menu
  */
  function __construct($largeur, $grise, $actif, $fondpage, $sessionid, $donnees, $action_retour){
    global $fichier;
    if (! parent::__construct($largeur, $grise, $actif, $fondpage, $sessionid)) return;
    $ut = new updateTableBrioche("prestsurmes", array(), "", "idprest", $this->idsession);
    if (is_array($donnees['prest'])){
      foreach($donnees['prest'] as $cle => $valeur) {
        if ($cle > 0){
           $ut->setTabChamps($valeur);
           $ut->setItem($cle);
           $ut->update();
        }
      }
    }
    if ($donnees[-2]) {
      $ut->setItem($donnees[-2]);
      $ut->detruitEnr();
    }
    if ($donnees[-20]) {
      $ut->ajouteEnr();
    }
    $tabbande = array("Prestations sur mesure", "", "", "", "");
      $this->addOnglet("Choix", $tabbande, "#154cff", $this->actif, 80, "");
      $this->colmateOnglets();
    
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fichier, "post");
    $c = new TPanel(6, 1);
    $x = new Label("Enregistrez ici des prestations que vous dlivrez souvent, mais qui ne sont rpertories " .
                   "ni dans la liste des analyses ni dans le tarmed, par exemple des mdicaments ou des vaccins. " .
                   "Cliquez sur <B>OK</B> pour sauver vos modifications !");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne();
    $c = new TPanel(1, 1);
    $x = new Bouton("Ajouter", "Ajouter", "BUTTON",
                    "document.forms.donnees.elements[\"donnees[-20]\"].value=1;document.forms.donnees.submit();");
    $c->addChamp($x);
    $of->addChamp($c);
    $c = new TPanel(5, 1, "RIGHT");
    $x = new Bouton("OK", "OK", "SUBMIT", "", "bok");
    $c->addChamp($x);
    $x = new Espace(2);
    $c->addChamp($x);
    $x = new Bouton("Retour", "Retour", "Button",
                    "document.forms.donnees.action.value=$action_retour;document.forms.donnees.submit();");
    $c->addChamp($x);
    $x = new Espace(3);
    $c->addChamp($x);
    $x = new Bouton("action", $this->actif, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("donnees[-2]", 0, "HIDDEN"); // pour suppression d'une prestation
    $c->addChamp($x);
    $x = new Bouton("donnees[-20]", 0, "HIDDEN"); // pour ajout prestation
    $c->addChamp($x);                               
    $of->addChamp($c);
    $of->addLigne();
    
    
    $etm = new ensTableBrioche("prestsurmes", "1", "*", "codepers, libelle",
                               $this->idsession);
    
    $c = new TPanelTableau(4, 1, $etm, $this->grise, "donnees[prest]", "idprest");        
    $x = new ChampTexte("codepers", "", "", 10, 10, false, "text", "d2");
    $c->addColChamp("Code personnel (libre)", $x);
    $x = new ChampTexte("libelle", "", "", 50, 50, false, "text", "d2");
    $c->addColChamp("Libell", $x);
    $x = new ChampTexte("prix", "", "", 10, 10, false, "text", "d2");
    $c->addColChamp("Prix", $x);
    $x = new Lien("", false, false, false, "idprest",
                  "javascript:document.forms.donnees.elements['donnees[-2]'].value=;" .
                  "document.forms.donnees.submit();", "images/croixtr.gif");
    $c->addColChamp("", $x, false, true);
   
    $c->addTitres(true); 
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    
    
    $this->addContenu($of->getContenu());
  }

}


?>
