<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Formulaire pour paramtrer les prestations sur mesure
* @package radix
*/
/**
* Formulaire pour pramtrer les prestaionts sur mesure
* Permet de dfinir un certain nombre de prestations hors tarif (vaccins, etc.)
* @package radix
* @author ob
*/
class prestTarmedLA extends cadronglet {
  var $montarif; 
  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param string fondpage la couleur du fond de la page
  * @param string sessionid l'identifiant de session
  * @param string donnees les donnees postes par le formulaire
  * @param int action_retour l'action pour revenir au menu
  */
  function __construct($largeur, $grise, $actif, $fondpage, $sessionid, $donnees, $options,
                         $action_retour, $action2){
    global $fichier;
    if (! parent::__construct($largeur, $grise, $actif, $fondpage, $sessionid)) return;
    if (! $options){
      $options = new optionsBriocheCab();
      $options->setOption("TARIF", 6); // par dfaut, Tarmed nouveau
    }
    else $options = new optionsBriocheCab($options);
    $this->montarif = $options->getOption("TARIF");
    //traitement des donnes
    
    //Accs  tarif avec conversion masquer=>actif
    $etm = new ensTableBrioche("tarif", "tarif = $this->montarif", 
                               "*, if(masquer < 0, 0, -1) AS actif", "position",
                               $this->idsession);
    //Rception des donnes postes et criture dans la table
    //print_r($donnees);
    if (is_array($donnees['prest'])){
      foreach ($donnees['prest'] as $cle => $valeur){
        $tabval[] = $cle;
      }  
    }
    if ($donnees['maj']){ // Lors de l'ajout/importation d'une prestation, pas de mise  jour
      $tabval[-2] = "tarif = $this->montarif";
      $tabchamps['masquer'] = 0;
      $ut = new updateTableBrioche("tarif", $tabchamps, $tabval, "id", $this->idsession);
      $ut->update(); 
      $tabval[-1] = true;
      $tabchamps['masquer'] = ("IF(masquer = -1, -1, -2) ");
      $ut->setTabChamps($tabchamps);
      $ut->setItem($tabval);
      $ut->update();
    }
    $tabbande = array("Prestations tarmed et liste des analyses", "", "", "", "");
    $this->addOnglet("Choix", $tabbande, "#ff4917", $this->actif, 80, "");
    $this->colmateOnglets();
    
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fichier, "post");
    $c = new TPanel(6, 1);
    $x = new Label("Vous pouvez ici importer, activer, dsactiver les prestations tarmed en fonction " .
                   "de votre pratique et de vos besoins. Vous pouvez aussi saisir celles des prestations " . 
                   "de la liste des analyses que vous utilisez.");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne();
    // Bouton tarmed <-> LA
    $c = new TPanel(1, 1);
    $x = new Label("Slection du tarif&nbsp;:", true);
    $c->addChamp($x);
    $of->addChamp($c);
    $c = new GrTBoutonTexte($this->montarif, 8, 220, 12, "#aaaaaa", "#efefef", 2);
    $futopt = new optionsBriocheCab($options->getChaine());
    $futopt->setOption("TARIF", 5);
    $c->addBouton("Tarmed ancien",
                  "$fichier?action=$this->actif&sessionid=$this->idsession&options=" . 
                  $futopt->getChaine(),
                  5);
    $futopt->setOption("TARIF", 6);
    $c->addBouton("Tarmed nouveau",
                  "$fichier?action=$this->actif&sessionid=$this->idsession&options=" . 
                  $futopt->getChaine(),
                  6);
    
    $futopt->setOption("TARIF", 4);
    $c->addBouton("L. analyses", 
                  "$fichier?action=$this->actif&sessionid=$this->idsession&options=" . 
                  $futopt->getChaine(),
                  4);
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    
    $c = new TPanel(5, 1);
    $x = new Bouton("Ajouter", ($this->montarif == 4 ? "Ajouter" : "Importer") . " nouvelle prestation", "BUTTON",
                    "ouvreFenetre(\"$fichier?action=$action2&sessionid=" .
                    $this->idsession . "&options=" . $options->getChaine() . "\", \"Facturer\", " .
                    "\"scrollbars=no,resizable=no,menubar=no,locationbar=no,height=450," .
                    "width=850,screenX=150,screenY=100\")");
    $c->addChamp($x); 
    
    $of->addChamp($c);
    $c = new TPanel(5, 1, "RIGHT");
    //$x = new Bouton("OK", "OK", "SUBMIT", "", "bok");
    //$c->addChamp($x);
    //$c->addChamp(new Espace(2));
    $x = new Bouton("Retour", "Retour", "Button",
                    "document.forms.donnees.action.value=$action_retour;document.forms.donnees.submit();");
    $c->addChamp($x);
    $x = new Espace(3); 
    $c->addChamp($x);
    $x = new Bouton("action", $this->actif, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("options", $options->getChaine(), "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("donnees[maj]", 1, "HIDDEN"); // pour mettre  jour les prestations
    $c->addChamp($x);
    $x = new Bouton("scroll", 0, "HIDDEN");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne();
       
    $c = new TPanelTableau(6, 1, $etm, $this->grise, "donnees[prest]", "id");        
    $x = new Label("", false, false, false, "position");
    $c->addColChamp("Position", $x, false, false, "formatePos", $this, "LEFT", "masquer");
    $x = new Label("", false, false, false, "texte");
    $c->addColChamp("Rsum", $x, false, false, "griseInactifs" , $this, "LEFT", "masquer");
    $x = new Label("", false, false, false, "pm");
    $c->addColChamp("pm", $x, false, false, "griseInactifs", $this, "RIGHT", "masquer");
    $x = new Label("", false, false, false, "pt");
    $c->addColChamp("pt", $x, false, false, "griseInactifs", $this, "RIGHT", "masquer");
    
    if ($this->montarif == 4){ //Liste des analyses
      $x = new Label("", false, false, false, "ch");
      $c->addColChamp("C/H", $x, false, false, "griseInactifs", $this, "LEFT", "masquer");
    }
    
    $x = new Autocase("actif", "", "", false,
                      "document.forms.donnees.scroll.value=document.body.scrollTop;" .
                      "document.forms.donnees.submit();");
    $c->addColChamp("Actif", $x, true, false, "griseCase", $this, "", "masquer");
   
    
   
    $c->addTitres(true); 
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    
    
    $this->addContenu($of->getContenu());
  }

  // Fonction de callback
  function formatePos($position, $masquer){
    $position = ensFacture::formatePos($position, $this->montarif);
    return $this->griseInactifs($position, $masquer);
  }

  function griseInactifs($arg, $masquer){
    if ($masquer < 0) {
      if ($masquer == -1) $couleur = "#FFADAD";
      elseif ($masquer == -2) $couleur = "#999999";
      return "<FONT COLOR=\"$couleur\">$arg</FONT>";
    }
    else return $arg;
  }

  function griseCase($contenu, $masquer){
    if ($masquer == -1) return $this->griseInactifs("&nbsp;[&nbsp;&nbsp;&nbsp;]&nbsp;", -1);
    return $contenu;
  }
}


?>
