<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

///////////////////////////////////////////
//
//  Remboursement d'une facture
//
//////////////////////////////////////////

class rembourseFact extends cadronglet{
  var $idsession;
  var $options;
  var $action;

  #Constructeur
  function __construct($largeur, $grise, $actif, $fondpage, $sessionid,
                        $options, $donnees){
    global $fdosbrioche;
    global $imagesdir;
    //appel du constsructeur de l'objet parent (avec vrif)
    if (! parent::__construct($largeur, $grise, $actif, $fondpage, $sessionid)) return;
   
    $this->action = $actif;
    $this->options = new optionsBriocheCab($options);
    $tabbande = array("", "", "", "", "");
    $this->addOnglet("Rembourser", $tabbande, "#8b8378", $this->action, 60, "");
    $this->colmateOnglets();
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fdosbrioche, "post");
    $complet = true;
    $rembourse = false;
    $confirme = false;
    switch($this->options->getOption("REM_FACT")){//Premier passage
    case 0;
      $afficheform = true;

    }
    if ($this->options->getOption("REM_FACT") >= 1){//Second passage
      if ($this->options->getOption("REM_FACT") == 2){
        $rembourse = true;
      }
      $ut = new updateTableBrioche("Factures", $donnees, "", "", $this->idsession);
      if (! $ut->controlePresence("anfact", "Anne de la facture")) $complet = false;
      if (! $ut->controlePresence("numero", "Numro de la facture")) $complet = false;
      if (! $ut->controlePresence("montant", "Montant")) $complet = false;
      if ($complet){ // tous les champs sont remplis
        $ef = new ensFacture($this->idsession);
        $nofact = $ef->getNoPlein($donnees['anfact'], $donnees['numero']);
        if (! $ef->existeNofact($nofact)){ //La facture n'existe pas
          $al = new Alerte("La facture " . $donnees['anfact'] . " - " . $donnees['numero'] .
                           " n\'existe pas");
          $al->imprime();
        }
        else { //La facture existe
          $edf = new ensDetailFacture($nofact, $this->idsession);
          if ($this->options->getOption("REM_FACT") == 1) $confirme = true;
        }
      }
      
    }

    if(! $donnees['datop']) $donnees['datop'] = $this->aujourdhui();
    if(! isset($donnees['anfact'])) $donnees['anfact'] = "";
    if(! isset($donnees['numero'])) $donnees['numero'] = "";
    if(! isset($donnees['montant'])) $donnees['montant'] = "";
    if(! isset($donnees['compte'])) $donnees['compte'] = "";
    $of->setFocus("donnees[anfact]");
    $c = new TPanel(3);
    $x = new Label("Numro de la facture :&nbsp;");
    $c->addChamp($x);
    $of->addChamp($c);
    $c = new TPanel(3);
    $x = new ChampTexte("donnees[anfact]", $donnees['anfact'], "", 2, 2, false, "text", "d2");
    $c->addChamp($x);
    $x = new Label("-");
    $c->addChamp($x);
    $x = new ChampTexte("donnees[numero]", $donnees['numero'], "", 6, 5, false, "text", "d2");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne(1.2);
    $c = new TPanel(6);
    $x = new ChampTexte("donnees[datop]", $donnees['datop'], 
                        "Date de l'criture : ", 15, 15, false, "text", "d2",
                        "controleDate('donnees[datop]', '" .
                        $this->aujourdhui() . "', '300', '10')");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne(1.2);
    $c = new TPanel(3);
    $x = new Label("Montant :&nbsp;");
    $c->addChamp($x);
    $of->addChamp($c);
    $c = new TPanel(3);
    $x = new ChampTexte("donnees[montant]", $donnees['montant'], "", 10, 10, false, "text", "d2");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne(1.2);
    $c = new TPanel(6, 1);
    $ini = new briocheIni();
    $cptes = new ensTableBrioche("listecomptes", 1, "*", 0, $this->idsession);
    $nomcpte = $cptes->lookUp("nomcompte", "nocompte = $ini->cpteTransit");
    $x = new Label("Le montant rembours sera port au compte '" .
                   $nomcpte . "', d'o il faudra " .
                   "encore effectuer le versement rel...");
    $c->addChamp($x);               
    $of->addChamp($c);
    $of->addLigne();
    $c = new TPanel(6, 1, "RIGHT");
    $x = new Bouton("OK", "OK", "SUBMIT", "", "bok");
    $c->addChamp($x);
    $x = new Espace(2);
    $c->addChamp($x);
    $futopt = new optionsBriocheCab($this->options->getChaine());
    $futopt->setOption("REM_FACT", 1);
    $x =new Bouton("options", $futopt->getChaine(), "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("Annuler", "Annuler", "BUTTON", "window.close()", "ban");
    $c->addChamp($x);
    $x = new Espace(2);
    $c->addChamp($x);
    $of->addChamp($c);
    if ($rembourse){
      if ($edf->rembourse($donnees['montant'], $donnees['datop'])){
        $al = new Alerte("Opration effectue !");
        
      }
      else {
        $al = new Alerte("Le remboursement n\'est pas possible. Vrifiez que la facture a t boucle...");
      }
      $al->imprime();
      $ff = new fermeFenetre(false);
    }

    $of->addLigne();
    $c = new TPanel(6, 1, "RIGHT");
    $x = new Espace(2);
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);

    $x = new Bouton("action", $this->action, "HIDDEN");
    $c->addChamp($x);
    $of->addChamp($c);



    $this->addContenu($of->getContenu());
    if ($confirme){
      $edf = new ensDetailFacture($nofact, $this->idsession);
      $apayer = $edf->getMontantAPayer();
      $futopt = new optionsBriocheCab($this->options->getChaine());
      $futopt->setOption("REM_FACT", 2);
      $cf = new Confirm("Vous vous apprtez  rembourser la somme de Fr " .
                        $donnees['montant'] .  ". Dsirez-vous continuer ?",
                        "changeChamp('options', '" . $futopt->getChaine() .
                        "', 'donnees');document.forms.donnees.submit();", "");
      $this->addContenu($cf->getContenu());
    }
  }


}


?>
