<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)
/**
* Formulaire pour paramtrer les valeurs de points
* @package radix
*/
/**
* Formulaire pour pramtrer les valeurs de points
* Historique de toutes les valeurs pour tous les types de prestations
* @package radix
* @author ob
*/
class valPoints extends cadronglet {
    
  /**
  * @param string largeur la largeur du formulaire (pixels ou %)
  * @param string grise la couleur du gris
  * @param string fondpage la couleur du fond de la page
  * @param string sessionid l'identifiant de session
  * @param string donnees les donnees postes par le formulaire
  * @param int action_retour l'action pour revenir au menu
  */
  function __construct($largeur, $grise, $actif, $fondpage, $sessionid, $donnees, $action_retour){
    global $fichier;
    if (! parent::__construct($largeur, $grise, $actif, $fondpage, $sessionid)) return;
    if (! isset($donnees['dataj'])) $donnees['dataj'] = "";
    if (! isset($donnees['typeprest'])) $donnees['typeprest'] = "";
    if (! isset($donnees['groupas'])) $donnees['groupas'] = "";
    $donnees['groupas'] = (float) $donnees['groupas'] + 0;
    if (! isset($donnees[-2])) $donnees[-2] = 0;
    if (! isset($donnees['pmaj'])) $donnees['pmaj'] = "";
    if (! isset($donnees['ptaj'])) $donnees['ptaj'] = "";
    if (! isset($donnees['plaj'])) $donnees['plaj'] = "";
    // Ajout des lignes manquantes
    $egf = new ensGestFact($this->idsession);
    $egf->majValPoints();
    
    // Destruction d'une ligne
    if ($donnees[-2] && $donnees[-3]){
      $etsuppr = new ensTableBrioche("valpointdate", "date = " . $this->getDateAm($donnees[-2]) . " AND typeprest = "
                                     . $donnees[-3] . " AND groupass = " . $donnees[-4], 
                                     "*", 0, $this->idsession);
      $etsuppr->detruitEnsemble();
    }
    $etdate = new ensTableBrioche("valpointdate", 1, "montant", "date DESC", 
                                      $this->idsession, "", "", false, "", "", 1);
    
    
    $ut = new updateTableBrioche("valpointdate", array(), "", "", $this->idsession);
    
    // Ajout nouvelle valeur
    if ($donnees['dataj']){
      $tpt = array("m", "t", "l");
      $where = $this->whereDate($donnees['dataj'], $donnees['typeprest'], 
      $donnees['groupas']);
      //print $where;
      foreach($tpt as $point){
        if ($donnees['p' . $point . 'aj']){
          $wherep = " AND point = \"p$point\"";   
          $etdate->setWhere($where . $wherep);
          $tetdate = $etdate->getTableau();
          if (! count($tetdate)){
            $montant = 0;
          }
          else {
            $tetdate = $tetdate[0];
            $montant = $tetdate->montant;
          }
          //print $etdate->getSQL();
          if ($montant != $donnees['p' . $point . 'aj']){
            $tabchamps['date'] = $donnees['dataj'];
            $tabchamps['point'] = "p$point";
            $tabchamps['montant'] = $donnees['p' . $point . 'aj'];
            $tabchamps['typeprest'] = $donnees['typeprest'];
            $tabchamps['groupass'] = $donnees['groupas'];
            $ut->setTabChamps($tabchamps);
            $ut->ajouteEnr();
          }
        }
        $donnees['p' . $point . 'aj'] = "";
      }
      $donnees['dataj'] = "";
    }
    
    
    $tabbande = array("Valeurs des points", "par type de prestation", "", "", "");
      $this->addOnglet("Journal", $tabbande, "#154cff", $this->actif, 80, "");
      $this->colmateOnglets();
    
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fichier, "post");
    $c = new TPanel(6, 1);
    $x = new Label("Introduisez ici les nouvelles valeurs de points pour chacun des types dfinis. " .
                   "Cliquez sur <B>OK</B> pour valider les nouvelles entres !");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne();
    $c = new TPanel(6, 1, "RIGHT");
    
    $x = new Bouton("Retour", "Retour", "Button",
                    "document.forms.donnees.action.value=$action_retour;document.forms.donnees.submit();");
    $c->addChamp($x);
    $x = new Espace(3);
    $c->addChamp($x);
    $x = new Bouton("action", $this->actif, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("donnees[-2]", 0, "HIDDEN"); //date  supprimer
    $c->addChamp($x);
    $x = new Bouton("donnees[-3]", 0, "HIDDEN"); //type de prestation  supprimer
    $c->addChamp($x);
    $x = new Bouton("donnees[-4]", 0, "HIDDEN"); //groupe d'assureurs  supprimer
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
        
    
    $etm = new ensTableBrioche("typeprest", "masquer = 0", "*", 0, $this->idsession);
    $c = new TPanel(6, 1);
    $x = new Label ("Choisissez le type : ");
    $c->addChamp($x);
    $x = new Espace(2);
    $c->addChamp($x);
    $x = new ListOptTable("donnees[typeprest]", $donnees['typeprest'], $etm, false, 0, "d2", "document.forms.donnees.submit();");
    $x->addDefaut("---", "");
    $x->addOptions("txt", "id");
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    
    
    
    // Le type a t choisi
    if($donnees['typeprest']){
      $etp = new ensTableBrioche("typeprest", "1", "*", 0, $this->idsession);
      $loi = $etp->lookUp("loi", "id=" . $donnees['typeprest']);
      if ($loi == "LAMAL"){
        $etg = new ensTableBrioche("groupesass", "1", "*", 0, $this->idsession);
        $tetg = $etg->getTableau();
        $c = new TPanel(6, 1);
        $x = new Label ("Choisissez le groupe d'assureurs : ");
        $c->addChamp($x);
        $x = new Espace(2);
        $c->addChamp($x);
        $x = new ListOptTable("donnees[groupas]", $donnees['groupas'], $etg, false, 0, "d2", "document.forms.donnees.submit();");
        $x->addDefaut("---", "");
        $x->addOptions("texte", "id");
        $c->addChamp($x);
        $of->addChamp($c);
        $of->addLigne(0.5);
        $of->addLigne();      
      }
      else {
        $donnees['groupas'] = 0;
      }
      if($donnees['groupas'] || $loi != "LAMAL"){
        $etd = new ensTableBrioche("valpointdate",
                                   "typeprest = " . $donnees['typeprest'] . " AND groupass = " . $donnees['groupas'],
                                   "date", "date DESC", $this->idsession, "", "", true);
        $tetd = $etd->getTableau();
        $cpt = count($tetd);
        $c = new TPanel(6, 1);
        $x = new Label("<B>Ajout de nouvelles valeurs</B> (en francs, p. ex. 0.96)&nbsp;:", false);
        $c->addChamp($x);
        $of->addChamp($c);
        $of->addLigne();
        $c = new TPanel(6, 1);
        $x = new ChampTexte("donnees[dataj]", $donnees['dataj'], "Date entre en vigueur&nbsp;:", 15, 15, false, "TEXT", "d2",
                          "controleDate('donnees[dataj]', '', '', '');"); 
        $c->addChamp($x);
        $x = new Espace(5);
        $c->addChamp($x);
        $x = new ChampTexte("donnees[pmaj]", $donnees['pmaj'], "Pt mdical&nbsp;:", 4, 6, false, "TEXT", "d2");
        $c->addChamp($x); 
        $x = new Espace(3);
        $c->addChamp($x);
        $x = new ChampTexte("donnees[ptaj]", $donnees['ptaj'], "Pt technique&nbsp;:", 4, 6, false, "TEXT", "d2");
        $c->addChamp($x); 
        $x = new Espace(3);
        $c->addChamp($x);
        $x = new ChampTexte("donnees[plaj]", $donnees['plaj'], "Pt labo&nbsp;:", 4, 6, false, "TEXT", "d2");
        $c->addChamp($x); 
        $x = new Espace(3);
        $c->addChamp($x);
        $x = new Bouton("OK", "OK", "SUBMIT", "", "bok");
        $c->addChamp($x);
        $of->addChamp($c);
        $of->addLigne(0.5);
        $of->addLigne();
        $c = new TPanel(6, 1);
        $x = new Label("Historique", true, true);
        $c->addChamp($x);
        $of->addChamp($c);
        $of->addLigne();
        if ($cpt){ // Il y a dj des enregistrements;
          $c = new TLabel("Date entr. vigueur", true);
          $of->addChamp($c);
          $c = new TLabel("Pt mdical", true);
          $of->addChamp($c);
          $c = new TLabel("Pt technique", true);
          $of->addChamp($c);
          $c = new TLabel("Pt labo", true);
          $of->addChamp($c);
        
          $of->addLigne();
        }
        else {
          $c = new TPanel(6, 1);
          $x = new Label("La facturation dans ce type ne fonctionnera pas ! Vous devriez ajouter au moins une valeur pour chaque point !", true, true);
          $c->addChamp($x);
          $of->addChamp($c);
          $of->addLigne();
        }
        $tabpoints = array("pm", "pt", "pl");
        for ($i = 0; $i < $cpt; $i++){
          $madate = $tetd[$i]->date;
          foreach ($tabpoints as $typept){
            $where = $this->whereDate($madate, $donnees['typeprest'], $donnees['groupas']);
            $wherep = $where . " AND point = \"$typept\"";
            $etdate->setWhere($wherep);
            $tetdate = $etdate->getTableau();
            $tetdate = $tetdate[0];
            $$typept = $tetdate->montant;
          }
               
          $c = new TPanel(1, 1);
          $x = new Label($madate, false, false, false, "", "",
                        ($this->isPair($i) ? "listepair" : "listeimpair"));
          $c->addChamp($x);
          $of->addChamp($c);
          $c = new TPanel(1, 1);
          $x = new Label($pm, false, false, false, "", "",
                        ($this->isPair($i) ? "listepair" : "listeimpair"));
          $c->addChamp($x);
          $of->addChamp($c);
          $c = new TPanel(1, 1);
          $x = new Label($pt, false, false, false, "", "",
                        ($this->isPair($i) ? "listepair" : "listeimpair"));
          $c->addChamp($x);
          $of->addChamp($c);
          $c = new TPanel(1, 1);
          $x = new Label($pl, false, false, false, "", "",
                        ($this->isPair($i) ? "listepair" : "listeimpair"));
          $c->addChamp($x);
          $of->addChamp($c);
          if ($i < $cpt -1){
            $c = new TPanel(1, 1);
            $x = new BoutonImage("Suppr.", "images/croixtr.gif", 16, 16, 
                                 "javascript:document.forms.donnees.elements['donnees[-2]'].value='$madate';" .
                                 "document.forms.donnees.elements['donnees[dataj]'].value='';" .
                                 "document.forms.donnees.elements['donnees[-3]'].value='" . $donnees['typeprest'] .
                                 "';document.forms.donnees.elements['donnees[-4]'].value='" . $donnees['groupas'] . "';document.forms.donnees.submit();");
            $c->addChamp($x);
            $of->addChamp($c); 
        
            $of->addLigne();
          }
        }
      }
    
      $of->addLigne(0.5);
      $of->addLigne();
    
    }  
    $this->addContenu($of->getContenu());
  }

  function whereDate($madate, $montype, $mongroupe){
    $mongroupe = $mongroupe + 0;
    return "date <= " . $this->getDateAm($madate) . " and typeprest = " . $montype . " and groupass = $mongroupe ";
  }
  
  function isPair($nb){
    if ($nb/2 == round($nb/2)) return false;
    else return true;
  }

}




?>
