<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

///////////////////////////////////////////////////////////////
//
// Envoi des factures xml au cdc
//
////////////////////////////////////////////////////////////////

class envoiXml extends connexionBrioche {

  function __construct($idsession, $nofact = 0){
    if (! parent::__construct($idsession)) return;
    $ini = new briocheIni();
    if (! $ini->xmlfactDir) {
      print "Pas de rpertoire pour les factures xml... Abandon.\n";
      return;
    }
    if ($nofact){ // envoi isol
      $etb = new ensTableBrioche("factures", "nofact = $nofact", "nofact", 0, $idsession);
    }
    else {
      $etb = new ensTableBrioche("factures", "cdcquittance = 1", "nofact", 0, $idsession);
    }
    $tetb = $etb->getTableau();
    $cpt = count($tetb);
    for ($i = 0; $i < $cpt; $i++){
      $det = new ensDetailFacture($tetb[$i]->nofact, $idsession);
      $xml = $det->getXml($ini->cdcAnonymise, $ini->cdcTest);
      //print $det->cdcnofact;
      $fichier = fopen("$ini->xmlfactDir/$det->cdcnofact.xml", "w");
      fwrite($fichier, $xml);
      fclose($fichier);
      if (! $nofact){ // En cas d'envoi par bloc
        $det->setCdcQuittance(2, $det->cdcnofact);
      }
    }

    //Envoi des fichiers du rpertoire spool
    
    if (! $nofact){
      $dh = opendir($ini->xmlfactDir);
      $url = $ini->cdcUrl;
      while($fichier = readdir($dh)){
        //print $fichier;
        $chemin = "$ini->xmlfactDir/$fichier";
        if (is_file($chemin)){
        //print $fichier;
          $nofact = $this->retrouveNofact($fichier);
          $resultat = $this->envoie($chemin, $url, $nofact);
          print_r($resultat);
          
          $ed = new ensDetailFacture($nofact, $this->idsession);
          if($this->parseResult($resultat)){
            $quit = 99;
          }
          else {
            $quit = 98;
          }
                
          $ed->setCdcQuittance($quit);
          unlink($chemin);
        }
      }
      closedir($dh);
    }
  }

  
  //Rcupration du n de facture  partir du nomf de fichier
  function retrouveNofact($fichier){
    $tab = explode('.', $fichier);
    $hach = $tab[0];
    $etf = new ensTableBrioche("factures", "cdcid = \"$hach\"", "nofact", 0, $this->idsession);
    $tetf = $etf->getTableau();
    return $tetf[0]->nofact;
  }
  
  //Rcupration du mdecin de la facture
  function retrouveMedecin($nofact){
    $ens = new ensDetailFacture($nofact, $this->idsession);
    return $ens->medecin; 
  }
  
  //Postage du fichier
  function envoie($fich, $url, $nofact){
    $ch = curl_init($url);
    $medecin = $this->retrouveMedecin($nofact);
    curl_setopt($ch, CURLOPT_VERBOSE, 19);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_POSTFIELDS, array('file1' => "@$fich"));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_SSLCERT, $medecin->certif);
    curl_setopt($ch, CURLOPT_SSLCERTPASSWD, $medecin->cdcpasswd);
    $resultat = curl_exec($ch);
    curl_close($ch);
    $resultat = explode("<br>", $resultat);
    return $resultat;  
  }
  
  //Analyse du rsultat de la transmission
  function parseResult($resultat){
    $cpt = count($resultat);
    $ok = 0;
    for ($i = 0; $i < $cpt; $i ++){
      if (preg_match("/Facture accepte/i", $resultat[$i])){
        $ok = 1;
      }
    }
    if (! $ok){
      for ($i = 0; $i < $cpt; $i++){
        print $resultat[$i] . "\n";
      }
    }
    return $ok;
  }
}

?>
