<?php
## Ce programme est un logiciel libre soumis aux termes de la
## licence GNU-GPL (http://www.gnu.org/copyleft/gpl.txt)

function decb($tableau){
    return dechex($tableau[1]);
}

require("entete.phtml");
$ini = new briocheIni();
require("$ini->fpdfDir/fpdf.php");
require("$ini->fpdfDir/fpdfCorr.php");
require("$ini->classDir/session.inc");
require("$ini->classDir/sessionDBrioche.inc");
require("$ini->classDir/connexionBrioche.inc");
require("$ini->cabDir/enrBriocheCab.inc");
require("$ini->cabDir/adresseTiers.inc");
require("$ini->classDir/ensTableBrioche.inc");
require("$ini->cabDir/ensFacture.inc");
require("$ini->cabDir/ensFacturePat.inc");
require("$ini->classDir/updateTableBrioche.inc");
require("$ini->cabDir/ensDetailFacture.inc");
require("$ini->classDir/extrVar.inc");
require("$ini->outilsDir/Alerte.inc");
require("$ini->classDir/fermeFenetre.inc");
require("$ini->cabDir/pdfFact.inc");
require("$ini->cabDir/ensGestFact.inc");
require("$ini->classDir/tableProv.inc");
require("$ini->classDir/erreurB.inc");
define('FPDF_FONTPATH', "$ini->fpdfDir/font/");
$ex = new extrVar();
$ex->extrait("item");
$ex->extrait("itfact");
$ex->extrait("sessionid");
$ex->extrait("mode");
$ex->extrait("ligne");


$enp = new enrBriocheCab($item, $sessionid);
$enr = $enp->getEnr("patients");
$ip = $enp->getIP();
$os = $enp->getOS();
$impr = new ensTableBrioche("imprimantes", "ip = \"$ip\" AND os = \"$os\"",
                            "*", 0, $sessionid);
$timpr = $impr->getTableau();
if (count($timpr)){
  $fact = $timpr[0]->fact;
  $bordx = $timpr[0]->bordx;
  $bordy = $timpr[0]->bordy;
  $police = $timpr[0]->police;
  $delta = $timpr[0]->delta;
  $pente = $timpr[0]->pente;
}
else{
  $fact = 1;
  $bordx = 0;
  $bordy = 0;
  $police = 0;
  $delta = 0;
  $pente = 1;

}


switch ($mode) {
case "d": // Page de garde du dossier
  $enm = new ensTableBrioche("medecins", 1, "*", 0, $sessionid);
  $enec = new ensTableBrioche("etatcivil", 1, "*", 0, $sessionid);
  $enet = new ensTableBrioche("tiers", 1, "*", 0, $sessionid);
  $med = $enm->lookUp("txt", "id = $enr->medecin");
  $ec = ($enr->etatcivil ? $enec->lookUp("txt", "id = $enr->etatcivil") : "");
  $eam = ($enr->asmal ? $enet->lookUp("nomp", "notier = $enr->asmal") : "");
  $eac = ($enr->asacci ? $enet->lookUp("nomp", "notier = $enr->asacci") : "");
  $pdf=new FPDFCorr($bordx, $bordy, $fact, $police, $delta, $pente);
  $pdf->SetLineWidth(0.1);
  $pdf->AddPage();
  $pdf->SetFont('Arial','',12);
  $pdf->SetY(29);
  $pdf->SetX(27);
  $pdf->Cell(32, 10,'N de patient :');
  $pdf->SetFont('Arial', 'B', 12);
  $pdf->Cell(25, 10, $enr->nopat);
  $pdf->setX(85);
  $pdf->SetFont('Arial', '', 12);
  $pdf->Cell(36, 10, 'Mdecin traitant : ');
  $pdf->SetFont('Arial', 'B', 12);
  $pdf->Cell (60, 10, "Dr $med");
  $pdf->Rect(27, 40, 140, 15);
  $pdf->SetXY(30, 40);
  $pdf->SetFont('Arial', 'B', 20);
  $pdf->Cell(150, 15, $enr->nomp . " " . $enr->prenom);
  $pdf->SetXY(27, 65);
  $pdf->SetFont('Arial', '', 12);
  $pdf->Cell(80, 10, $enr->adresse);
  $pdf->SetXY(27, 73);
  $pdf->Cell(20, 10, $enr->nopost);
  $pdf->SetX(42);
  $pdf->SetFont('Arial', 'B', 12);
  $pdf->Cell(60, 10, $enr->ville);
  $pdf->SetXY(27, 81);
  $pdf->SetFont('Arial', '', 12);
  $pdf->Cell(15, 10, 'Tl. :');
  $pdf->SetX(39);
  $pdf->Cell(35, 10, $enr->telpri);
  $pdf->SetXY(27, 88);
  $pdf->Cell(40, 10, 'Date de naissance :');
  $pdf->Cell(30, 10, $enr->daten);
  $pdf->Cell(22, 10, 'Etat civil :');
  $pdf->Cell(40, 10, $ec);
  $pdf->Line(27, 100, 167, 100);
  $pdf->SetXY(27, 105);
  $pdf->Cell(45, 10, 'Caisse-maladie :');
  $pdf->Cell(60, 10, $eam);
  $pdf->SetXY(27, 113);
  $pdf->Cell(45, 10, 'Assurance accidents :');
  $pdf->Cell(60, 10, $eac);
  $pdf->Line(27, 125, 167, 125);
  $pdf->SetXY(27, 130);
  $pdf->Cell(25, 10, 'Profession :');
  $pdf->Cell(60, 10, $enr->profession);
  $pdf->Output();
  break;
case "e": // Etiquettes
  if ($ligne < 1 || $ligne > 16){
    $al = new Alerte("Il faut indiquer un numro de ligne entre 1 et 16");
    $al->imprime();
    $fe = new fermeFenetre();
  }
  $ligne1 = substr("$enr->nomp $enr->prenom", 0, 26);
  $ligne2 = substr("$enr->adresse", 0, 26);
  $ligne3 = substr("$enr->nopost", 0, 26);
  $ligne4 = substr("$enr->ville", 0, 26);
  $ligne5 = substr("$enr->daten - N $enr->nopat", 0, 26);
  $margesup = 5.5;
  $margegau = 6;
  $padv = 0;
  $padh = 2;
  $hligne = 3;
  $lcol = 34;
  $intercol = 2.9;
  $offvert = ($ligne-1) * 17.55 ;//16.93;
  $pdf = new FPDFCorr($bordx, $bordy, $fact, $police, $delta, $pente);
  //$pdf->SetMargins(0, 0, 0);
  $pdf->SetAutoPageBreak(false, 0);
  $pdf->AddPage();
  $pdf->SetFont('Arial', '', 8);
  //$pdf->Rect(13, 13.5, 30, 10);
  //print "---$bordx $bordy $fact ---<BR>";
  for ($ncol = 0; $ncol < 5; $ncol++){
    $xx = $margegau + $padh + $ncol * ($lcol + $padh + $intercol);
    //print "$ncol : $xx <BR>";
    $yy = $margesup + $padv + $offvert;
    //print "$yy<BR>";
    //$pdf->Rect($xx, $yy, 30, 10);
    $pdf->SetXY($xx, $yy);
    $pdf->Cell($lcol, $hligne, $ligne1);
    $yy = $margesup + $padv + $hligne + $offvert;
    $pdf->SetXY($xx, $yy);
    $pdf->Cell($lcol, $hligne, $ligne2);
    $yy = $margesup + $padv + 2 * $hligne + $offvert;
    $pdf->SetXY($xx, $yy);
    $pdf->Cell($lcol, $hligne, $ligne3);
    $yy = $margesup + $padv + 3 * $hligne + $offvert;
    $pdf->SetXY($xx, $yy);
    $pdf->Cell($lcol, $hligne, $ligne4);
    $yy = $margesup + $padv + 4 * $hligne + $offvert;
    $pdf->SetXY($xx, $yy);
    $pdf->Cell($lcol, $hligne, $ligne5);
  }
  $pdf->Output();
  break;
case "fg": // facture bvr + impressions groupes
case "fj": // formulaire unifi

  $pdf = new FPDFCorr($bordx, $bordy, $fact, $police, $delta, $pente);
  $mpf = new pdfFact($pdf, $sessionid);
  $ensemble = new ensGestFact($sessionid);
  switch ($itfact){
  case -9:
    $tab = $ensemble->getTji();
    $cpt = count($tab);
    for ($i = 0; $i < $cpt; $i++){
      $mpf->addJust($tab[$i]->nofact);
    }
    break;
  case -10: // Impression groupe factures
    $tab = $ensemble->getTfi();
    $cpt = count($tab);
    //print $cpt;
    for($i = 0; $i < $cpt; $i++){
       //print $tab[$i]->nofact;
       $mpf->addFact($tab[$i]->nofact);
       //print "OK <BR>";
    }
    break;
  case -11:
    $tab = $ensemble->getTri();
    $cpt = count($tab);
    for($i = 0; $i < $cpt; $i++){
      $mpf->addFact($tab[$i]->nofact, true);
    }
    break;
  case -12: //lettres rappel
    $tab = $ensemble->getTri();
    $cpt = count($tab);
    for($i = 0; $i < $cpt; $i++){
      $mpf->addLettre($tab[$i]->nofact);
    }
    break;
  default:
    if ($mode == "fg"){ 
      $mpf->addFact($itfact);
    }
    elseif ($mode == "fj"){
      $mpf->addJust($itfact);
    }
    break;

  }

  $pdf->Output();

  break;
}

?>