<?php

class auteursBriocheBibl extends cadronglet {

   var $nav;
   var $item;
   var $options;
   var $futuroptions;
   var $rs;
   var $itempere;
   var $actionpere;
   
  #Constructeur
  function __construct($largeur, $grise, $actif, $fondpage, $sessionid,
                             $item = 0, $options = 0, $itempere, $actionpere){
    global $fichier;
    global $imagesdir;
    $this->options = new optionsBriocheBiBl($options);
    if ( ! parent::__construct($largeur, $grise, $actif, $fondpage, $sessionid)) return;
    $this->itempere = $itempere;
    $this->action = $actif;
    $this->actionpere = $actionpere;
    // Connexion aux donnes
    $this->nav = new ensNavBriocheBibl($this->idsession, "bibl_auteurs", "noitem"); //Outil de navigation
    $this->item = ($item ? $item : $this->nav->getSuivant(0));
    if (! $this->nav->checkItem($this->item)){
      $al = new Alerte("La fiche N " . $this->item . " n\'existe pas...");
      $al->imprime();
      $this->item = $this->nav->getPrecedent($this->item);
    }
    $this->rs = new enrAuteurBriocheBibl($this->item, $this->idsession);
    $bibl_auteur = $this->rs->getEnr("bibl_auteurs");
    
    
    //Ajout d'un auteur
    if ($this->options->getOption("AJOUT_AUTEUR")){
      if (! $this->rs->ajoutAuteur($this->itempere)){
        $al = new Alerte("Ajout impossible... Doublon ?");
        $al->imprime();
      }
      $ff = new fermeFenetre(2, true); 
    }
    
    // Destruction d'une fiche auteur
    if ($this->options->getOption("SUPPR_ENR")){
      $this->options->setOption("SUPPR_ENR", 0);
      if (! $this->rs->detruit()){
        $al = new Alerte("Impossible de supprimer !");
        $al->imprime();
      }
      else {
        $this->item = $this->nav->getPrecedent($this->item);
        $this->rs = new enrAuteurBriocheBibl($this->item, $this->idsession);
        $bibl_auteur = $this->rs->getEnr("bibl_auteurs");
      }
      //$ff = new fermeFenetre(0, true);
    }
    
    //Nouvel auteur
    if ($this->options->getOption("NOUVEAU")){
      $this->options->setOption("NOUVEAU", 0);
      $this->item = $this->rs->creeNouveau();
      $this->rs = new enrAuteurBriocheBibl($this->item, $this->idsession);
      $bibl_auteur = $this->rs->getEnr("bibl_auteurs");
    }
    else {
      if (! $bibl_auteur->tri){
        $this->rs->setTri($this->rs->genereTri($bibl_auteur->nom, $bibl_auteur->prenom));
        $this->rs = new enrAuteurBriocheBibl($this->item, $this->idsession);
        $bibl_auteur = $this->rs->getEnr("bibl_auteurs");
      }
    }
    $this->futuroptions = new optionsBriocheBibl($this->options->getChaine());
    // Dessin des onglets
    $nomplein = (isset($bibl_auteur->prenom) ? $bibl_auteur->prenom . " " : "") . (isset($bibl_auteur->nom) ? $bibl_auteur->nom : "");
    $tabbande = array("Auteur courant :", $this->item, $nomplein, "", "");
    $tabbande[0] = "Auteur ";
    $this->addOnglet("Auteurs", $tabbande, "#FFD918", 1001, 60,
                     "javascript:lienCond('$fichier?action=1&sessionid=$this->idsession&item=$this->item&options=" .
                     $this->futuroptions->getChaine() . "')");
    $this->colmateOnglets();
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("navigation", $fichier, "post");
    
    //Navigation
    
    if ($this->options->getOption("NAVIGATION") == 1){
      $premier = $this->nav->getSuivant(0);
      $suivant = $this->nav->getSuivant($this->item);
      $precedent = $this->nav->getPrecedent($this->item);
      $dernier = $this->nav->getPrecedent(0);
      $c = new TPanel(3,1);
      $x = new Label($this->nav->getNbDoss() . " fiches au total", false, true);
      $c->addChamp($x);
      $x = new Espace(2);
      $c->addChamp($x);
      /*
      $x = new Bouton("...", "...", "BUTTON",
                      "if(!qModif()) ouvreFenetre(\"$fichier?action=2000&sessionid=" .
                      "$this->idsession&options=" . $this->futuroptions->getChaine() .
                      "&item=-999\", \"Recherche\", " .
                      "\"scrollbars=no,resizable=no,menubar=no,locationbar=no,height=200," .
                      "width=450,screenX=150,screenY=100\")");
      $c->addChamp($x);
      */
      $of->addChamp($c);
      $c = new TPanel(3, 1, "RIGHT", "MIDDLE");
      $x = new BoutonImage("Premier", "$imagesdir/premier.gif", 16, 16,
                           "javascript:lienCond('$fichier?action=$this->action&sessionid=$this->idsession" .
                           "&item=$premier&options=" . $this->futuroptions->getChaine() . "')");
      $c->addChamp($x);
      $x = new BoutonImage("Prcdent", "$imagesdir/precedent.gif", 16, 16,
                           "javascript:lienCond('$fichier?action=$this->action&sessionid=$this->idsession" .
                           "&item=$precedent&options=" . $this->futuroptions->getChaine() . "')");
      $c->addChamp($x);
      $x = new ChampTexte("item", "$this->item", "", 5, 6, false, "text", "d2");
      $c->addChamp($x);
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("options", $this->futuroptions->getChaine(), "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("action", $this->actif, "HIDDEN");
      $c->addChamp($x);
      $x = new BoutonImage("OK", "$imagesdir/vu.gif", 18, 16, "javascript:envoieCondNav()");
      $c->addChamp($x);
      $this->futuroptions->setOption("FORCE_DOSS", 0);
      $x = new BoutonImage("Suivant", "$imagesdir/suivant.gif", 16, 16,
                           "javascript:lienCond('$fichier?action=$this->action&sessionid=$this->idsession" .
                           "&item=$suivant&options=" . $this->futuroptions->getChaine() . "')");
      $c->addChamp($x);
      $x = new BoutonImage("Dernier", "$imagesdir/dernier.gif", 16, 16,
                           "javascript:lienCond('$fichier?action=$this->action&sessionid=$this->idsession" .
                           "&item=$dernier&options=" . $this->futuroptions->getChaine() . "')");
      $c->addChamp($x);
      $of->addChamp($c);

      $coulb = "green";

      $of->addLigneVierge();
      $c = new TBandeCouleur(6, 3, $coulb);
      $of->addChamp($c);

    }

    $this->addContenu($of->getContenu());
    //ajout du contenu spcifique
    $editable = $this->options->getOption("EDITABLE");
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fichier, "post");
    $of->addLigne();
    if ($editable){
      $c = new TPanel(6, 1);
      $x = new ChampTexte("bibl_auteur[nom]", isset($bibl_auteur->nom) ? $bibl_auteur->nom : "", "Nom : ", 50, 100, true, "TEXT", "d2");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      $c = new TPanel(6, 1);
      $x = new ChampTexte("bibl_auteur[prenom]", isset($bibl_auteur->prenom) ? $bibl_auteur->prenom : "", "Prnom : ", 50, 100, true, "TEXT", "d2");
      $c->addChamp($x);
      $x = new Bouton("item", $this->item , "HIDDEN");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      
    }
    else {
      $c = new TPanel(6, 1);
      $eta = new ensTableBrioche("bibl_auteurs", "1", "CONCAT(nom, \" \", if(prenom is not null, prenom, \"\")) " .
                                 "AS nomplein, noitem", "tri", $this->idsession);
      $x = new ListOptTable("item", $this->item, $eta, false, 0, "d2", "document.forms.donnees.submit();");
      $x->addDefaut("---", 0);
      $x->addOptions("nomplein", "noitem");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
    }
    $c = new TPanel(6, 1);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("action", ($editable ? ($this->action + 100) : $this->action), "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("options", $this->options->getChaine(), "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("itempere", "$this->itempere", "HIDDEN");
    $c->addChamp($x);
    $x = new ChampTexte("bibl_auteur[tri]", isset($bibl_auteur->tri) ? $bibl_auteur->tri : "", "Tri : ", 50, 100, true, "TEXT", "d2", "", "", ! $editable);
    $c->addChamp($x);
    $of->addChamp($c);
    $of->addLigne(0.5);
    $of->addLigne();
    $notices = true;
    if ($editable) {
      $futopt = new optionsBriocheBibl($this->options->getChaine());
      $futopt->setOption("EDITABLE", 0);
      $futopt->setOption("NAVIGATION", 1);
      $c = new TPanel(6, 1, "RIGHT");
      $x = new Bouton("OK", "OK", "BUTTON", "changeChamp(\"options\",\"" .
                      $futopt->getChaine() . "\",\"donnees\");document.forms.donnees.submit();", "bok");
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      $x = new Bouton("Abandonner", "Abandonner", "BUTTON", "document.forms.donnees.reset();" .
                      "changeChamp(\"options\",\"" . $futopt->getChaine() . 
                      "\",\"donnees\");document.forms.donnees.submit();", "ban");
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne();
    }  
    else {  
      $c = new TPanel(6, 1, "RIGHT");
      
      $futopt = new optionsBriocheBibl($this->options->getChaine());
      $futopt->setOption("NAVIGATION", 0);
      $futopt->setOption("EDITABLE", 1);
      $futopt->setOption("NOUVEAU", 1);
      if (! $this->rs->getNbNotices()){
        $notices = false;
        $fo = new optionsBriocheBibl($this->options->getChaine());
        $fo->setOption("SUPPR_ENR", 1);
        $x = new Bouton("Supprimer", "Supprimer", "BUTTON",
                        "supprimeCond(\"$fichier?action=" . $this->action .
                        "&sessionid=$this->idsession&item=$this->item&options=" .
                        $fo->getChaine() . "\",\"\",\"Voulez-vous vraiment supprimer cette fiche ?\");");
        $c->addChamp($x);
        $x = new Espace(3);
        $c->addChamp($x);
      }
      $x = new Bouton("Nouveau", "Nouveau", "BUTTON", "document.location=\"$fichier?action=" . $this->action . 
                      "&sessionid=$this->idsession&item=$this->item&itempere=$this->itempere&options=" .
                      $futopt->getChaine() . "\"");
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      $futopt->setOption("NOUVEAU", 0);
      $x = new Bouton("Editer", "Editer", "BUTTON", "document.location=\"$fichier?action=" . $this->action . 
                      "&sessionid=$this->idsession&item=$this->item&itempere=$this->itempere&options=" .
                      $futopt->getChaine() . "\"");
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      if ($this->options->getOption("SELECTION")){
        $futopt = new optionsBriocheBibl($this->options->getChaine());
        $futopt->setOption("AJOUT_AUTEUR", 1);
        $x = new Bouton("Slectionner", "Slectionner", "BUTTON", "changeChamp(\"options\", \"" .
        $futopt->getChaine() . "\", \"donnees\");document.forms.donnees.submit();");
        $c->addChamp($x);
        $x = new Espace(3);
        $c->addChamp($x);
      }
      
      $of->addChamp($c);
      $of->addLigne();
    }
    if ($notices && $this->options->getOption("NAVIGATION")) {
      $join = "bibl_items";
      $on = "bibl_aut_items.noitem = bibl_items.noitem";
      $etauteurs = new ensTableBrioche("bibl_aut_items", "bibl_aut_items.noauteur = $this->item",
                                       "bibl_items.titre, bibl_items.noitem", 0, $this->idsession, $join, $on);
      $c = new TPanel(6, 1);
      $x = new Label ($this->rs->getNbNotices() . " notice" . ($this->rs->getNbNotices() > 1 ? "s" : "") . " pour cet auteur");
      $c->addChamp($x);
      $of->addChamp($c);
      $of->addLigne(0.5);
      $of->addLigne();
      $c = new TPanelTableau(6, 1, $etauteurs, "#efefef", "bibl_items", "noitem");
      $opo = new optionsBriocheBibl();
      $opo->setOption("NAVIGATION", 1);
      $fo = new optionsBriocheBibl($this->options->getChaine());
      $fo->setOption("SELECTION", 0);
      $x = new Lien("", false, false, false, "noitem", "#", 0, false, 
                    "window.opener.document.location='$fichier?action=$this->actionpere&sessionid=$this->idsession" .
                    "&item=&options=" . $opo->getChaine() ."';changeChamp('options','" . 
                    $fo->getChaine() . "','donnees');document.forms.donnees.submit()");
      $c->addColChamp("noitem", $x, false, true);
      $x = new Label("", false, false, false, "titre");
      $c->addColChamp("titre", $x);
      $of->addChamp($c); 
    }
    
    $this->addContenu($of->getContenu());
    $tf = new TabForm();
    $tf->setTabParam(360, 0, 3, 0, "#D5DDFF");
    $c = new TLabel("&nbsp");
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TPanel(1, 1, "RIGHT", "CENTER");
    $x = new Bouton("Quitter", "Fermer", "BUTTON", "fermeTout();");
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TLabel("&nbsp;");
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TLabel("&nbsp;");
    $tf->addChamp($c);
    
    $this->addContenu($tf->getContenu());
  }
}

?>
