<?php

class dossierBriocheBibl extends cadronglet {

   var $nav;
   var $item;
   var $options;
   var $futuroptions;
   var $recup;
   var $rs;
   var $nomplein;
   var $action_retour;
   var $action2;
   var $action3;
   var $action4;
   var $action5;
   var $itemfils;
  #Constructeur
  function __construct($largeur, $grise, $actif, $fondpage, $sessionid,
                             $item = 0, $options = 0, $recup = 0, $action_retour = 0,
                             $action2, $action3, $action4, $action5, $itemfils = 0){
    global $fichier;
    global $imagesdir;
    $this->action_retour = $action_retour;
    $this->options = new optionsBriocheBiBl($options);
    $this->action2 = $action2;
    $this->action3 = $action3;
    $this->action4 = $action4;
    $this->action5 = $action5;
    $this->itemfils = $itemfils;
    if ( ! parent::__construct($largeur, $grise, $actif, $fondpage, $sessionid)) return;
    
   
    $this->recup = $recup;
    $this->action = $actif;
   
    // Connexion aux donnes
    $this->nav = new ensNavBriocheBibl($this->idsession, "bibl_items", "noitem"); //Outil de navigation
    $this->item = ($item ? $item : $this->nav->getSuivant(0));
    if (! $this->nav->checkItem($this->item)){
      $al = new Alerte("La notice N " . $this->item . " n\'existe pas...");
      $al->imprime();
      $this->item = $this->nav->getPrecedent($this->item);
    }
    $this->rs = new enrBriocheBibl($this->item, $this->idsession);
    $bibl_item = $this->rs->getEnr("bibl_items");
    
    //Suppression de la fiche
    if ($this->options->getOption("SUPPR_ENR")){
      $this->options->setOption("SUPPR_ENR", 0);
      $this->rs->detruitEnr();
      $this->item = $this->nav->getPrecedent($this->item);
      $this->rs = new enrBriocheBibl($this->item, $this->idsession);
      $bibl_item = $this->rs->getEnr("bibl_items");
    }
    
    //Nouvelle fiche
    if ($this->options->getOption("NOUV_ITEM")){
      $this->options->setOption("NOUV_ITEM", 0);
      
      $this->item = $this->rs->creeNouveau();
      $this->rs = new enrBriocheBibl($this->item, $this->idsession);
      $bibl_item = $this->rs->getEnr("bibl_items");
    }
   
    
    //Suppression d'un auteur pour cette notice
    if ($this->options->getOption("DESTR_AUT")){
      $this->options->setOption("DESTR_AUT", 0);
      $this->rs->supprimeAuteur($this->itemfils);
    }
    // Suppression de l'diteur pour cette notice
    if ($this->options->getOption("DESTR_ED")){
      $this->options->setOption("DESTR_ED", 0);
      $this->rs->supprimeEditeur(0);
      $bibl_item = $this->rs->getEnr("bibl_items", $this->recup);
    }
    // Suppression du reprinteur pour cette notice
    if ($this->options->getOption("DESTR_REPR")){
      $this->options->setOption("DESTR_REPR", 0);
      $this->rs->supprimeEditeur(1);
      $bibl_item = $this->rs->getEnr("bibl_items", $this->recup);
    }
    
    // Suppression du journal pour cette notice
    if ($this->options->getOption("DESTR_JOURN")){
      $this->options->setOption("DESTR_JOURN", 0);
      $this->rs->supprimeJournal();
      $bibl_item = $this->rs->getEnr("bibl_items", $this->recup);
    }
    
    $this->futuroptions = new optionsBriocheBibl($this->options->getChaine());
    
    $titabr = substr($bibl_item->titre, 0, 45) . (strlen($bibl_item->titre)> 45 ? "..." : "");
    $tabbande = array("Notice courante :", $this->item, $titabr, "", "");
    $tabbande[0] = "Notice ";
    $this->addOnglet("Notices", $tabbande, "#e119c1", 11, 60,
                     "javascript:lienCond('$fichier?action=1&sessionid=$this->idsession&item=$this->item&options=" .
                     $this->futuroptions->getChaine() . "')");
    
    $this->colmateOnglets();
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("navigation", $fichier, "post");
  
    //Navigation
    
    if ($this->options->getOption("NAVIGATION") == 1){
      $premier = $this->nav->getSuivant(0);
      $suivant = $this->nav->getSuivant($this->item);
      $precedent = $this->nav->getPrecedent($this->item);
      $dernier = $this->nav->getPrecedent(0);
      $c = new TPanel(3,1);
      $x = new Label($this->nav->getNbDoss() . " notices au total", false, true);
      $c->addChamp($x);
      $x = new Espace(2);
      $c->addChamp($x);
      
      $x = new Bouton("...", "...", "BUTTON",
                      "if(!qModif()) ouvreFenetre(\"$fichier?action=2000&sessionid=" .
                      "$this->idsession&options=" . $this->futuroptions->getChaine() .
                      "&item=-999\", \"Recherche\", " .
                      "\"scrollbars=no,resizable=no,menubar=no,locationbar=no,height=400," .
                      "width=450,screenX=150,screenY=100\")");
      $c->addChamp($x);
      $of->addChamp($c);
      $c = new TPanel(3, 1, "RIGHT", "MIDDLE");
      $x = new BoutonImage("Premier", "$imagesdir/premier.gif", 16, 16,
                           "javascript:lienCond('$fichier?action=$this->action&sessionid=$this->idsession" .
                           "&item=$premier&options=" . $this->futuroptions->getChaine() . "')");
      $c->addChamp($x);
      $x = new BoutonImage("Prcdent", "$imagesdir/precedent.gif", 16, 16,
                           "javascript:lienCond('$fichier?action=$this->action&sessionid=$this->idsession" .
                           "&item=$precedent&options=" . $this->futuroptions->getChaine() . "')");
      $c->addChamp($x);
      $x = new ChampTexte("item", "$this->item", "", 5, 6, false, "text", "d2");
      $c->addChamp($x);
      $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("options", $this->futuroptions->getChaine(), "HIDDEN");
      $c->addChamp($x);
      $x = new Bouton("action", $this->actif, "HIDDEN");
      $c->addChamp($x);
      $x = new BoutonImage("OK", "$imagesdir/vu.gif", 18, 16, "javascript:envoieCondNav()");
      $c->addChamp($x);
      //$this->futuroptions->setOption("FORCE_DOSS", 0);
      $x = new BoutonImage("Suivant", "$imagesdir/suivant.gif", 16, 16,
                           "javascript:lienCond('$fichier?action=$this->action&sessionid=$this->idsession" .
                           "&item=$suivant&options=" . $this->futuroptions->getChaine() . "')");
      $c->addChamp($x);
      $x = new BoutonImage("Dernier", "$imagesdir/dernier.gif", 16, 16,
                           "javascript:lienCond('$fichier?action=$this->action&sessionid=$this->idsession" .
                           "&item=$dernier&options=" . $this->futuroptions->getChaine() . "')");
      $c->addChamp($x);
      $of->addChamp($c);

      $coulb = "green";

      $of->addLigneVierge();
      $c = new TBandeCouleur(6, 3, $coulb);
      $of->addChamp($c);

    }

    $this->addContenu($of->getContenu());
    //ajout du contenu spcifique
    $of = new OngForm();
    $of->setTabParam($this->largeur, $this->coulbande, 6);
    $of->setFormParam("donnees", $fichier, "post");
    $of->addLigne();

    switch ($this->actif){

    //Les contenus des onglets volumineux se trouvent dans les enfants de pageDossierBrioche;
    //Onglet Notice
    case 11:
      $page = new pageDossierBriocheBiblNotice($this);
      $of->addPage($page);
      break;
    /*
    //onglet Relations
    case 2:
      $page = new pageDossierBriocheCabRel($this);
      $of->addPage($page);
      break;
    //Onglet factures
    case 3:
      $page = new pageDossierBriocheCabFact($this);
      $of->addPage($page);
      break;
    */
    }
    
    
    
    $this->addContenu($of->getContenu());
    $tf = new TabForm();
    $tf->setTabParam(760, 0, 3, 0, "#D5DDFF");
    $of->setFormParam("fermeture", $fichier, "post");
    $c = new TLabel("&nbsp");
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TPanel(1, 1);
    //$x = new Label("<IMG SRC=\"images/brioche100.gif\" WIDTH=100 HEIGHT=26>");
    //$c->addChamp($x);
    $tf->addChamp($c);
    $c = new TPanel(1, 1, "RIGHT", "CENTER");
    $x = new Bouton("action", $this->action_retour, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("sessionid", $this->idsession, "HIDDEN");
    $c->addChamp($x);
    $x = new Bouton("Retour", "Retour", "SUBMIT");
    $c->addChamp($x);
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TLabel("&nbsp;");
    $tf->addChamp($c);
    $tf->addLigne();
    $c = new TLabel("&nbsp;");
    $tf->addChamp($c);
    
    $this->addContenu($tf->getContenu());
  }
}

?>
