<?php

////////
//
// Encapsule les donnes d'un dossier BriocheBibl
//
////////

class enrBriocheBibl extends connexionBrioche {
  var $item;
  #Constructeur
  function __construct($item, $sessionid){
    if (! parent::__construct($sessionid)) return;
    $this->item = $item;
  }


  #Rcupration des enregistrements par table en fonction du numro de dossier
  function getEnr($table, $recup=0){
    if ($this->n_erreur) return;
    if ($recup){
      $ligne = $this->faitRecup($recup, $table);
    }
    else {
      if ($table == "bibl_items") $cle = "noitem";
      //elseif ($table == "tiers") $cle = "notier";
      //elseif ($table == "prestations") $cle = "noprest";
      //elseif ($table == "comptes") $cle = "noop";
      $ini = new briocheIni();
      $requete = "SELECT * FROM $table WHERE $cle = $this->item AND tst > \"" . $ini->tstorig . "\"";
      $result = mysqli_query($this->linkBrioche, $requete);
      if (! $result) return false;
      $ligne = mysqli_fetch_object($result);
      //Conversion des champs date
      if ($ligne){
        //for ($i = 0; $i < mysqli_num_fields($result); $i++){
        while ($flds = mysqli_fetch_field($result)){
        //$flds = mysqli_fetch_field($result, $i);
          $fn = $flds->name;
          if ($flds->type == 10){
            $ligne->$fn = $this->getDateFr($ligne->$fn);
          }
          
          $ligne->$fn = $this->metEnFormeSel($ligne->$fn);
        }
      }
    }
    return $ligne;
  }

  //Type de notice
  function getTypeNotice(){
    $ini = new briocheIni();
    $requete = "SELECT article FROM bibl_items WHERE noitem = $this->item AND tst > \"" . $ini->tstorig . "\"";
    $result = mysqli_query($this->linkBrioche, $requete);
    $ligne = mysqli_fetch_row($result);
    switch ($ligne[0]){
    case 0;
      return "livre";
      break;
    case 1:
      return "article de journal";
      break;
    case 2:
      return "article de recueil";
      break;
    case 3:
      return "recueil d'articles";
      break;      
    }
  }
  
  //Nombre d'auteurs
  function compteAuteurs(){
    $ini = new briocheIni();
    $requete = "SELECT COUNT(*) from bibl_aut_items WHERE noitem = $this->item AND tst > \"" . $ini->tstorig . "\"";
    $result = mysqli_query($this->linkBrioche, $requete);
    $ligne = mysqli_fetch_row($result);
    return $ligne[0];
  }
  
  //Auteur
  function getAuteurs(){
    $ini = new briocheIni();
    $join = "bibl_auteurs";
    $on = "bibl_aut_items.noauteur = bibl_auteurs.noitem";
    $et = new ensTableBrioche("bibl_aut_items", "bibl_aut_items.noitem = $this->item", "*", "bibl_aut_items.noitem",
                              $this->idsession, $join, $on);
    return $et->getTableau();
  }
  
  //Editeur
  function getEditeur($type = 0) {
    $ini = new briocheIni();
    $join = "bibl_edits";
    
    $on = "bibl_items.editeur = bibl_edits.id";
    if ($type == 1){
      $on = "bibl_items.reprint = bibl_edits.id";
    }
    $et = new ensTableBrioche("bibl_items", "bibl_items.noitem = $this->item", "*", 0, $this->idsession, $join, $on);
    $tab = $et->getTableau();
    return (count($tab) ? $tab[0] : 0);
  } 
  
  //Journal
  function getJournal(){
    $ini = new briocheIni();
    $join = "bibl_journs";
    $on = "bibl_items.journal = bibl_journs.id";
    $et = new ensTableBrioche("bibl_items", "bibl_items.noitem = $this->item", "*", 0, $this->idsession, $join, $on);
    $tab = $et->getTableau();
    return $tab[0];
  }
  // Suppression d'un auteur de cette notice
  function supprimeAuteur($noauteur){
    $requete = "DELETE FROM bibl_aut_items WHERE noauteur = $noauteur AND noitem = $this->item";
    $result = mysqli_query($this->linkBrioche, $requete);
  }
  
  //Suppression de l'diteur - 0 - ou du reprinteur - 1 - de cette notice
  function supprimeEditeur($type){
    if ($type == 0) $champ = "editeur";
    elseif ($type == 1) $champ = "reprint";
    $tabchamps[$champ] = "NULL";
    $ut = new updateTableBrioche("bibl_items", $tabchamps, $this->item, "noitem", $this->idsession);
    return $ut->update();
  }
  
  //Suppression du journal de cette notice
  function supprimeJournal(){
    $tabchamps['journal'] = "NULL";
    $ut = new updateTableBrioche("bibl_items", $tabchamps, $this->item, "noitem", $this->idsession);
    return $ut->update();
  }
  
  #Cration d'un nouveau dossier avec toutes les tables, annexes et renvoi de son numro
  function creeNouveau(){
    if ($this->n_erreur) return;
    $dg = md5(time() . $this->idsession);
    $requete = "INSERT INTO bibl_items SET dmd5 = \"$dg\", tst = 0";
    $result = mysqli_query($this->linkBrioche, $requete);
    $requete = "SELECT noitem FROM bibl_items WHERE dmd5 = \"$dg\"";
    $result = mysqli_query($this->linkBrioche, $requete);
    $lignes = mysqli_fetch_row($result);
    $nd = $lignes[0];
    //table notes
    //$requete = "INSERT INTO notes SET nodossier = $nd";
    //$result = mysql_query($requete);
    return $nd;
  }

  //Enregistre le tri
  function setTri($tri){
    $tabchamps['tri'] = $tri;
    $ut = new updateTableBrioche("bibl_items", $tabchamps, $this->item, "noitem", $this->idsession);
    return $ut->update();
  }
  
  //Gnre et enregistre une href
  function setHref(){
    if (! $this->compteAuteurs()) return "";
    $auteurs = $this->getAuteurs();
    $auteur = $auteurs[0];
    $chaine = substr($auteur->nom, 0, 4) . strtolower(substr($auteur->prenom, 0, 1));
    $i = 1;
    do {
      $et = new ensTableBrioche("bibl_items", "href = \"$chaine\"", "noitem", 0, $this->idsession);
      $cpt = $et->compte();
      if ($cpt) {
        $chaine = preg_replace("/[0-9]*$/", "", $chaine);
        $chaine .= $i;
        $i++;
      }
    } while($cpt);
    $tabchamps['href'] = $chaine;
    $ut = new updateTableBrioche("bibl_items", $tabchamps, $this->item, "noitem", $this->idsession);
    return $ut->update();
  }


  #Dtruit la fiche courante
  function detruitEnr(){
    if ($this->n_erreur) return;
    $requete = "DELETE FROM bibl_items WHERE noitem = $this->item";
    $result = mysqli_query($this->linkBrioche, $requete);
    return $result;
  }
  
}

?>
