<?php

//////////////////////////////////////////////////////
//
//  Page "Notice bibliographique"
//
////////////////////////////////////////////////////////

class pageDossierBriocheBiblNotice extends pageDossierBriocheBibl {
  var $pv;

  #Constructeur
  function __construct(&$dbr) {
    global $fichier;
    $ini = new briocheIni();
    $imagedir = $ini->imagesDir;
    
    parent::__construct($dbr);
    $this->pv = new PPageVierge();
    $options = new optionsBriocheBibl($this->dbr->options->getChaine());
    $bibl_item = $this->dbr->rs->getEnr("bibl_items", $this->dbr->recup);
    $auteurs = $this->dbr->rs->getAuteurs();
    $nbaut = $this->dbr->rs->compteAuteurs();
    if (! $bibl_item->tri && $nbaut){ // Compltion ventuelle du tri
      $this->dbr->rs->setTri(enrAuteurBriocheBibl::genereTri($auteurs[0]->nom, $auteurs[0]->prenom));
      $bibl_item = $this->dbr->rs->getEnr("bibl_items", $this->dbr->recup);
    }
    if (! $bibl_item->href && $nbaut){ // Compltion ventuelle de la marque href
      $this->dbr->rs->setHref();
      $bibl_item = $this->dbr->rs->getEnr("bibl_items", $this->dbr->recup);
    }
    $acb = new AutoCheckbox();
    
    $c = new TPanel(2, 1);
    $x = new Label("Type de notice : ", true);
    $c->addChamp($x);
    $x = new Label($this->dbr->rs->getTypeNotice());
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $c = new GrTBoutonTexte($bibl_item->article, 4, 300, 15, "#adae91", "#efefef", 4);
    $c->addBouton("Livre", "javascript:changeChamp('bibl_item[article]','0','donnees');document.forms.donnees.submit();", 0);
    $c->addBouton("Art. journal",
                  "javascript:changeChamp('bibl_item[article]','1','donnees');document.forms.donnees.submit();", 1);
    $c->addBouton("Art. recueil",
                  "javascript:changeChamp('bibl_item[article]','2','donnees');document.forms.donnees.submit();", 2);
    $c->addBouton("Recueil",
                  "javascript:changeChamp('bibl_item[article]','3','donnees');document.forms.donnees.submit();", 3);
    
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanel(6, 1, "RIGHT");
    $x = new Label("Groupe : ", true);
    $c->addChamp($x);
    $etg = new ensTableBrioche("bibl_groupes", "1", "*", 0, $this->dbr->idsession);
    $x = new ListOptTable("bibl_item[groupe]", $bibl_item->groupe, $etg, false, 0, "d2");
    $x->addDefaut("---", 0);
    $x->addOptions("groupe", "nogroupe");
    $c->addChamp($x);
    $x = new Espace(5);
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanel(1, 1);
    $x = new Label("Auteur(s) : ");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $futopt = new optionsBriocheBibl();
    $futopt->setOption("NAVIGATION", 1);
    $futopt->setOption("SELECTION", 1);
    $c = new TPanel(1, 1);
    $x = new Bouton("itemfils", 0, "HIDDEN");
    $c->addChamp($x);
    $x = new BoutonImage("Ajouter", "$imagedir/plus.gif", 18, 16,
                         "javascript:ouvreFenetre('$fichier?action=" . $this->dbr->action2 . "&sessionid=" .
                         $this->dbr->idsession . "&options=" . $futopt->getChaine() . "&itempere=" .$this->dbr->item .
                         "', 'Auteurs'," .
                         "'scrollbars=no,resizable=no,menubar=no,locationbar=no,height=500,width=450,screenX=150,screenY=100')");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $c = new TPanel(4, 1, "RIGHT");
    $x = new ChampTexte("bibl_item[tri]", $bibl_item->tri, "Tri : ", 20, 25, false, "TEXT", "d2");
    $c->addChamp($x);
    $x = new Espace(3);
    $c->addChamp($x);
    $x = new ChampTexte("bibl_item[href]", $bibl_item->href, "Marque href : ", 7, 7, false, "TEXT", "d2");
    $c->addChamp($x);
    $x = new Espace(5);
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne();
    for ($i = 0; $i < $nbaut; $i++){
      $c = new TPanel(1, 1);
      $x = new Label("&nbsp;");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $c = new TPanel(2, 1);
      $x = new Label(($auteurs[$i]->prenom ? $auteurs[$i]->prenom . " " : "") . $auteurs[$i]->nom);
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $futopt = new optionsBriocheBibl($options->getChaine());
      $futopt->setOption("DESTR_AUT", 1);
      $c = new TPanel(1, 1);
      $x = new BoutonImage("Supprimer", "$imagedir/croixtr.gif", 18, 16, 
                           "javascript:changeChamp('options','" . $futopt->getChaine().
                           "','donnees');changeChamp('itemfils','" . $auteurs[$i]->noitem .
                           "','donnees');document.forms.donnees.submit();");
      $c->addChamp($x);
      
      $this->pv->addChamp($c);
      $this->pv->addLigne();
    }
    $c = new TPanel(1, 1);
    $x = new Label("Titre : ");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $c = new TPanel(5, 1);
    $x = new ChampTexte("bibl_item[titre]", $bibl_item->titre, "", 90, 250, false, "TEXT", "d2");
    $c->addChamp($x);
    $x = new Bouton("bibl_item[article]", ($bibl_item->article ? $bibl_item->article : "0"), "HIDDEN");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne();
    
    switch ($bibl_item->article){
    case 0: //livre
    case 3: //Recueil
      $editeur = $this->dbr->rs->getEditeur();
      $reprinteur = $this->dbr->rs->getEditeur(1);
      $c = new TPanel(1, 1);
      $x = new Label("Editeur : ");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $c = new TPanel(2, 1);
      $x = new Label($editeur->nomed . " - " . $editeur->lieued);
      $c->addChamp($x);
      $x = new Bouton("bibl_item[editeur]", $bibl_item->editeur, "HIDDEN");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $c = new TPanel(1, 1);
      // Il y a un diteur
      if ($bibl_item->editeur){
        $futopt = new optionsBriocheBibl($options->getChaine());
        $futopt->setOption("DESTR_ED", 1);
        $x = new BoutonImage("Supprimer", "$imagedir/croixtr.gif", 18, 16,
                             "javascript:changeChamp('options','" . $futopt->getChaine().
                             "','donnees');document.forms.donnees.submit();");
        $c->addChamp($x); 
      }
        
      else {
        $futopt = new optionsBriocheBibl();
        $futopt->setOption("NAVIGATION", 1);
        $futopt->setOption("SELECTION", 1);
        $x = new BoutonImage("Ajouter", "$imagedir/plus.gif", 18, 16,
                             "javascript:ouvreFenetre('$fichier?action=" . $this->dbr->action3 . "&sessionid=" .
                             $this->dbr->idsession . "&options=" . $futopt->getChaine() . "&itempere=" .$this->dbr->item .
                             "', 'Editeurs'," .
                             "'scrollbars=no,resizable=no,menubar=no,locationbar=no,height=500,width=450,screenX=150,screenY=100')"); 
        $c->addChamp($x);
      }
      $this->pv->addChamp($c);
      $c = new TPanel(2, 1, "RIGHT");
      $x = new ChampTexte("bibl_item[annee]", $bibl_item->annee, "Date d'dition : ", 6, 10, false, "TEXT", "d2");
      $c->addChamp($x);
      $x = new Espace(5);
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne();
      $c = new TPanel(6, 1);
      $x = New ChampTexte("bibl_item[remarque]", $bibl_item->remarque, "Remarque : ", 110, 255, true, "TEXT", "d2");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne(0.5);
      $this->pv->addLigne();
      $c = new TPanel(1, 1);
      $x = new Label("Rimpression : ");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $c = new TPanel(2, 1);
      $x = new Label($reprinteur->nomed . " - " . $reprinteur->lieued);
      $c->addChamp($x);
      $x = new Bouton("bibl_item[reprint]", $bibl_item->reprint, "HIDDEN");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $c = New TPanel(1, 1);
      // Il y a un reprinteur
      if ($bibl_item->reprint){
        $futopt = new optionsBriocheBibl($options->getChaine());
        $futopt->setOption("DESTR_REPR", 1);
        $x = new BoutonImage("Supprimer", "$imagedir/croixtr.gif", 18, 16,
                             "javascript:changeChamp('options','" . $futopt->getChaine().
                             "','donnees');document.forms.donnees.submit();");
        $c->addChamp($x); 
      }
        
      else {
        $futopt = new optionsBriocheBibl();
        $futopt->setOption("NAVIGATION", 1);
        $futopt->setOption("SELECTION", 1);
        $x = new BoutonImage("Ajouter", "$imagedir/plus.gif", 18, 16,
                             "javascript:ouvreFenetre('$fichier?action=" . $this->dbr->action4 . "&sessionid=" .
                             $this->dbr->idsession . "&options=" . $futopt->getChaine() . "&itempere=" .$this->dbr->item .
                             "', 'Editeurs'," .
                             "'scrollbars=no,resizable=no,menubar=no,locationbar=no,height=500,width=450,screenX=150,screenY=100')"); 
        $c->addChamp($x);
      }
      
      $this->pv->addChamp($c);
      $c = new Tpanel(2, 1, "RIGHT");
      $x = new ChampTexte("bibl_item[anneer]", $bibl_item->anneer, "Date de rimpression : ", 6, 4, false, "TEXT", "d2");
      $c->addChamp($x);
      $x = new Espace(5);
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne();
      break;
    case 1: //article de journal
      $this->pv->addLigne(0.5);
      $c = new TPanel(2, 1, "LEFT", "TOP");
      $x = new Label ("Journal : ");
      $c->addChamp($x);
      $x = new Espace(15);
      $c->addChamp($x);
      $journal = $this->dbr->rs->getJournal();
      $x = new Label($journal->nomjo);
      $c->addChamp($x);
      $x = new Bouton("bibl_item[journal]", $bibl_item->journal, "HIDDEN");
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      if ($bibl_item->journal){ // Il y a un journal
        $futopt = new optionsBriocheBibl($options->getChaine());
        $futopt->setOption("DESTR_JOURN", 1);
        $x = new BoutonImage("Supprimer", "$imagedir/croixtr.gif", 18, 16,
                             "javascript:changeChamp('options','" . $futopt->getChaine().
                             "','donnees');document.forms.donnees.submit();");
        $c->addChamp($x); 
      }
      else {
        $futopt = new optionsBriocheBibl();
        $futopt->setOption("NAVIGATION", 1);
        $futopt->setOption("SELECTION", 1);
        $x = new BoutonImage("Ajouter", "$imagedir/plus.gif", 18, 16,
                             "javascript:ouvreFenetre('$fichier?action=" . $this->dbr->action5 . "&sessionid=" .
                             $this->dbr->idsession . "&options=" . $futopt->getChaine() . "&itempere=" .$this->dbr->item .
                             "', 'Journaux'," .
                             "'scrollbars=no,resizable=no,menubar=no,locationbar=no,height=500,width=600,screenX=150,screenY=100')"); 
        $c->addChamp($x);
      }
      $this->pv->addChamp($c);
      $c = new TPanel(4, 1, "RIGHT");
      $x = new ChampTexte("bibl_item[tome]", $bibl_item->tome, "Tome : ", 5, 20, false, "TEXT", "d2");
      $c->addChamp($x);
      $x = new Espace(2);
      $c->addChamp($x);
      $x = new ChampTexte("bibl_item[volume]", $bibl_item->volume, "Volume : ", 5, 20, false, "TEXT", "d2");
      $c->addChamp($x);
      $x = new Espace(2);
      $c->addChamp($x);
      $x = new ChampTexte("bibl_item[annee]", $bibl_item->annee, "Annee : ", 5, 10, false, "TEXT", "d2");
      $c->addChamp($x);
      $x = new Espace(2);
      $c->addChamp($x);
      $x = new ChampTexte("bibl_item[pp]", $bibl_item->pp, "Pages : ", 10, 30, false, "TEXT", "d2");
      $c->addChamp($x);
      $x = new Espace(3);
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne();
      $c = new TPanel(6, 1);
      $x = New ChampTexte("bibl_item[remarque]", $bibl_item->remarque, "Remarque : ", 110, 255, true, "TEXT", "d2");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne();
      break;
    case 2: //article de recueil
      $this->pv->addLigne(0.5);
      $c = new TPanel(1, 1);
      $x = new Label("Recueil : ");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $etr = new ensTableBrioche("bibl_items", "bibl_items.article = \"3\"", "left(titre, 75) as titre, noitem", "titre", $this->dbr->idsession);
      $c = new TPanel(4, 1);
      $x = new ListOptTable("bibl_item[recueil]", $bibl_item->recueil, $etr, false, 0, "d2");
      $x->addDefaut("---", 0);
      $x->addOptions("titre", "noitem");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $c = new TPanel(2, 1);
      $x = new ChampTexte("bibl_item[pp]", $bibl_item->pp, "Pages : ", 10, 30, false, "TEXT", "d2");
      $c->addChamp($x);
      $this->pv->addChamp($c); 
      $this->pv->addLigne();
      $c = new TPanel(6, 1);
      $x = New ChampTexte("bibl_item[remarque]", $bibl_item->remarque, "Remarque : ", 110, 255, true, "TEXT", "d2");
      $c->addChamp($x);
      $this->pv->addChamp($c);
      $this->pv->addLigne();
      break;
    }
    $c = new TPanel(6, 1);
    $x = New ChampTexte("bibl_item[motscl]", $bibl_item->motscl, "Mots-cls : ", 110, 255, true, "TEXT", "d2");
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();    
    $c = new TPanel(6, 1);
    $x = New TextArea("bibl_item[commentaire]", $bibl_item->commentaire, "Commentaire : ", 100, 6);
    $c->addChamp($x);
    
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $c = new TPanel(4, 1);
    $x = new AutoCase("bibl_item[cvf]", $bibl_item->cvf, "Chantez-vous franais");
    $c->addChamp($x);
    $acb->addCase($x);
    $x = new Espace(3);
    $c->addChamp($x);
    $x = new AutoCase("bibl_item[pron]", $bibl_item->pron, "prononciation.org");
    $c->addChamp($x);
    $acb->addCase($x);
    $x = new AutoCase("bibl_item[mign]", $bibl_item->mign, "Mignonne...");
    $c->addChamp($x);
    $acb->addCase($x);
    $c->addChamp($acb);
    $this->pv->addChamp($c);
    $futopt = new optionsBriocheBibl($this->dbr->options->getChaine());
    $futopt->setOption("SUPPR_ENR", 1);
    $c = new TPanel(2, 1, "RIGHT");
    $x = new Bouton("Supprimer", "Supprimer", "BUTTON",
                    "supprimeCond(\"$fichier?action=" . $this->dbr->action .
                    "&sessionid=" . $this->dbr->idsession . "&item=" . $this->dbr->item . "&options=" .
                        $futopt->getChaine() . "\",\"\",\"Voulez-vous vraiment supprimer cette fiche ?\");");
    $c->addChamp($x);
    $futopt = new optionsBriocheBibl($this->dbr->options->getChaine());
    $futopt->setOption("NOUV_ITEM", 1);
    $x = new Espace(2);
    $c->addChamp($x);
    $x = new Bouton("Nouveau", "Nouveau", "BUTTON",
                    "if(!qModif()){changeChamp(\"options\",\"" . $futopt->getChaine().
                    "\",\"donnees\");document.forms.donnees.submit()}");
    $c->addChamp($x);
    $x = new Espace(5);
    $c->addChamp($x);
    $this->pv->addChamp($c);
    $this->pv->addLigne(0.5);
    $this->pv->addLigne();
    $this->pv->addChamp($this->pied);
    $this->pv->addLigne(0.5);
    
  }

  function TGetContenu(){
    return $this->pv->getContenu();
  }

}
